

DROP TABLE IF EXISTS config CASCADE;
create table config
        (id SERIAL,
	 help_url_prefix VARCHAR(250),
	version VARCHAR(20),		 
	cust_id VARCHAR(250),
	cust_key varchar(250),
	cust_email VARCHAR(250));

INSERT INTO config(help_url_prefix, version) VALUES ('labsolns.com/software/', '0.2.0');

-- added for artanis
DROP TABLE IF EXISTS person CASCADE;
create table person
        (id SERIAL PRIMARY KEY,
	lnuser varchar(250),
	passwd varchar(250),
	salt varchar(250),
	email VARCHAR(250),
	usergroup VARCHAR(250));

-- password is 'welcome' for both
insert into person (lnuser, passwd, salt, email, usergroup)
        VALUES ('ln_admin','1d52114553ae31b3','a39b69e5fd79854b', 'info@labsolns.com', 'admin'),
               ('ln_user','ca6468f6ff4a82e6','e999f4c34635f943', '','user'),
	       ('demo','97f8647f1067346d','55ecb01c50cb1ae1', '','user');



DROP TABLE IF EXISTS sessions CASCADE;
DROP SEQUENCE IF EXISTS  sessions_id_seq CASCADE;
DROP INDEX IF EXISTS sessions_pkey CASCADE;
CREATE TABLE sessions
(        
        sid varchar(32) PRIMARY KEY,
        data text,
        expires varchar(29),
        valid varchar(5),
        client varchar(39));

INSERT INTO sessions (sid, expires) VALUES ('9999999999', 'Sat, 31 Oct 2020 13:41:27 GMT' );


DROP TABLE IF EXISTS sess_person CASCADE;
CREATE TABLE sess_person
(        
        sid varchar(32) PRIMARY KEY,
        person_id INTEGER,
        prjid INTEGER,
        FOREIGN KEY (person_id) REFERENCES person(ID));

INSERT INTO sess_person (sid, person_id, prjid) VALUES ('9999999999', 1, 1);



-- ===================================================================================================================
-- ===================================================================================================================
-- ===================================================================================================================

DROP TABLE IF EXISTS project CASCADE;
DROP SEQUENCE IF EXISTS  project_id_seq CASCADE;
DROP INDEX IF EXISTS project_pkey CASCADE;
CREATE TABLE project
(id SERIAL PRIMARY KEY,
        project_sys_name VARCHAR(30),
        descr VARCHAR(250),
	project_name VARCHAR(250),
        sessions_id VARCHAR(32),
	updated TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,
        FOREIGN KEY (sessions_id) REFERENCES sessions(sid));

CREATE INDEX ON project(sessions_id);

------------------------------------------------
DROP TABLE IF EXISTS plate_format CASCADE;
DROP TABLE IF EXISTS plate_type CASCADE;

CREATE TABLE plate_type
(id SERIAL PRIMARY KEY,
	plate_type_name VARCHAR(30));

INSERT INTO plate_type (plate_type_name) VALUES ('assay');
INSERT INTO plate_type (plate_type_name) VALUES ('rearray');
INSERT INTO plate_type (plate_type_name) VALUES ('master');
INSERT INTO plate_type (plate_type_name) VALUES ('daughter');
INSERT INTO plate_type (plate_type_name) VALUES ('archive');
INSERT INTO plate_type (plate_type_name) VALUES ('replicate');


CREATE TABLE plate_format (id INTEGER PRIMARY KEY,
	format VARCHAR(6), rownum INTEGER, colnum INTEGER);

INSERT INTO plate_format (id, format, rownum, colnum) VALUES ( 96, '96', 8, 12);
INSERT INTO plate_format (id, format, rownum, colnum) VALUES (384, '384',16, 24);
INSERT INTO plate_format (id, format, rownum, colnum) VALUES (1536, '1536', 32, 48);


----------------------------


DROP TABLE IF EXISTS plate_layout_name CASCADE;

CREATE TABLE plate_layout_name (
		id SERIAL PRIMARY KEY,
		sys_name VARCHAR(30),
                name VARCHAR(250),
                descr VARCHAR(250),
                plate_format_id INTEGER,
		replicates INTEGER,
		targets INTEGER,
		use_edge INTEGER,
		num_controls INTEGER,
		unknown_n INTEGER,
		control_loc VARCHAR(30),
		source_dest VARCHAR(30),
		FOREIGN KEY (plate_format_id) REFERENCES plate_format(id));

CREATE INDEX ON plate_layout_name(plate_format_id);
	
-- 96 well plate 4 controls
INSERT INTO plate_layout_name (sys_name, name, descr, plate_format_id, replicates, targets, use_edge, num_controls, unknown_n, control_loc, source_dest) VALUES
  ('LYT-1','4 controls col 12', '1S1T', 96,1,1,1,4,92,'E12-H12','source')
, ('LYT-2','4 controls cols 23,24', '1S4T', 384, 1,4,1,4,368,'I23-P24','dest')
, ('LYT-3','4 controls cols 23,24', '2S2T', 384, 2,2,1,4,368,'I23-P24','dest')
, ('LYT-4','4 controls cols 23,24', '2S4T', 384, 2,4,1,4,368,'I23-P24','dest')
, ('LYT-5','4 controls cols 23,24', '4S1T', 384, 4,1,1,4,368,'I23-P24','dest')
, ('LYT-6','4 controls cols 23,24', '4S2T', 384, 4,2,1,4,368,'I23-P24','dest')

-- 96 well plate 8 controls

, ('LYT-7','8 controls col 12', '1S1T', 96, 1,1,1,8,88,'A12-H12','source')
, ('LYT-8','8 controls cols 23,24', '1S4T', 384, 1,4,1,8,352,'A23-P24','dest')
, ('LYT-9','8 controls cols 23,24', '2S2T', 384, 2,2,1,8,352,'A23-P24','dest')
, ('LYT-10','8 controls cols 23,24', '2S4T', 384, 2,4,1,8,352,'A23-P24','dest')
, ('LYT-11','8 controls cols 23,24', '4S1T', 384, 4,1,1,8,352,'A23-P24','dest')
, ('LYT-12','8 controls cols 23,24', '4S2T', 384, 4,2,1,8,352,'A23-P24','dest')

-- 384 well plate 8 controls

, ('LYT-13','8 controls col 24', '1S1T', 384, 1,1,1,8,376,'I24-P24','source')
, ('LYT-14','8 controls cols 47,48', '1S4T', 1536, 1,4,1,8,1504,'Q47-AF48','dest')
, ('LYT-15','8 controls cols 47,48', '2S2T', 1536, 2,2,1,8,1504,'Q47-AF48','dest')
, ('LYT-16','8 controls cols 47,48', '2S4T', 1536, 2,4,1,8,1504,'Q47-AF48','dest')
, ('LYT-17','8 controls cols 47,48', '4S1T', 1536, 4,1,1,8,1504,'Q47-AF48','dest')
, ('LYT-18','8 controls cols 47,48', '4S2T', 1536, 4,2,1,8,1504,'Q47-AF48','dest')

-- 384 well plate 16 controls

, ('LYT-19','16 controls col 24', '1S1T', 384, 1,1,1,16,368,'A24-P24','source')
, ('LYT-20','16 controls cols 47,48', '1S4T', 1536, 1,4,1,16,1472,'A47-AF48','dest')
, ('LYT-21','16 controls cols 47,48', '2S2T', 1536, 2,2,1,16,1472,'A47-AF48','dest')
, ('LYT-22','16 controls cols 47,48', '2S4T', 1536, 2,4,1,16,1472,'A47-AF48','dest')
, ('LYT-23','16 controls cols 47,48', '4S1T', 1536, 4,1,1,16,1472,'A47-AF48','dest')
, ('LYT-24','16 controls cols 47,48', '4S2T', 1536, 4,2,1,16,1472,'A47-AF48','dest')

-- 384 well plate 7 controls no edge

, ('LYT-25','7 controls col 23', '1S1T', 384, 1,1,0,7,301,'I23-O23','source')
, ('LYT-26','7 controls cols 46,47', '1S4T', 1536, 1,4,0,7,1204,'Q46-AE47','dest')
, ('LYT-27','7 controls cols 46,47', '2S2T', 1536, 2,2,0,7,1204,'Q46-AE47','dest')
, ('LYT-28','7 controls cols 46,47', '2S4T', 1536, 2,4,0,7,1204,'Q46-AE47','dest')
, ('LYT-29','7 controls cols 46,47', '4S1T', 1536, 4,1,0,7,1204,'Q46-AE47','dest')
, ('LYT-30','7 controls cols 46,47', '4S2T', 1536, 4,2,0,7,1204,'Q46-AE47','dest')

-- 384 well plate 14 controls no edge

, ('LYT-31','14 controls col 23', '1S1T', 384, 1,1,0,14,294,'B23-O23','source')
, ('LYT-32','14 controls cols 46,47', '1S4T', 1536, 1,4,0,14,1176,'B46-AE47','dest')
, ('LYT-33','14 controls cols 46,47', '2S2T', 1536, 2,2,0,14,1176,'B46-AE47','dest')
, ('LYT-34','14 controls cols 46,47', '2S4T', 1536, 2,4,0,14,1176,'B46-AE47','dest')
, ('LYT-35','14 controls cols 46,47', '4S1T', 1536, 4,1,0,14,1176,'B46-AE47','dest')
, ('LYT-36','14 controls cols 46,47', '4S2T', 1536, 4,2,0,14,1176,'B46-AE47','dest')

--1536 as source
, ('LYT-37','8 controls cols 47,48', '1S1T', 1536, 1,1,1,8,1504,'Q47-AF48','source')
, ('LYT-38','16 controls cols 47,48', '1S1T', 1536, 1,1,1,16,1472,'A47-AF48','source')
, ('LYT-39','7 controls cols 46,47', '1S1T', 1536, 1,1,0,7,1204,'Q46-AE47','source')
, ('LYT-40','14 controls cols 46,47', '1S1T', 1536, 1,1,0,14,1176,'B46-AE47','source')
, ('LYT-41','all blanks', 'not reformattable', 1536, 1,1,0,0,0,'none','dest')
, ('LYT-42','all blanks', 'not reformattable', 1536, 1,1,0,0,0,'none','dest')
, ('LYT-43','all blanks', 'not reformattable', 1536, 1,1,0,0,0,'none','dest')
, ('LYT-44','all blanks', 'not reformattable', 1536, 1,1,0,0,0,'none','dest');




DROP TABLE IF EXISTS layout_source_dest CASCADE;

CREATE TABLE layout_source_dest (
                src INTEGER NOT NULL,
                dest INTEGER NOT NULL);


INSERT INTO layout_source_dest( src, dest ) VALUES (1,2),(1,3),(1,4),(1,5),(1,6),(7,8),(7,9),(7,10),(7,11),(7,12),(13,14),(13,15),(13,16),(13,17),(13,18),(19,20),(19,21),(19,22),(19,23),(19,24),(25,26),(25,27),(25,28),(25,29),(25,30),(31,32),(31,33),(31,34),(31,35),(31,36),(37,41),(38,42),(39,43),(40,44);

DROP TABLE IF EXISTS target CASCADE;
DROP SEQUENCE IF EXISTS target_id_seq;

CREATE TABLE target
(id SERIAL PRIMARY KEY,
        target_sys_name VARCHAR(30),
	project_id INTEGER,
        target_name VARCHAR(30),
        descr VARCHAR(250),
	accs_id VARCHAR(30),
	FOREIGN KEY (project_id) REFERENCES project(ID));

INSERT INTO target (target_sys_name,  target_name, descr ) VALUES
('TRG-1', 'Target1', 'Generic Target 1'),
(  'TRG-2', 'Target2', 'Generic Target 2'),
(  'TRG-3', 'Target3', 'Generic Target 3'),
(  'TRG-4', 'Target4', 'Generic Target 4');

DROP TABLE IF EXISTS target_layout_name CASCADE;
DROP SEQUENCE IF EXISTS target_layout_name_id_seq;
 CREATE TABLE  target_layout_name
                           (id SERIAL PRIMARY KEY,
                            project_id INTEGER,
                            target_layout_name_sys_name varchar(30),
                            target_layout_name_name VARCHAR(30),
                            target_layout_name_desc VARCHAR(250),
                            reps INTEGER,
                            FOREIGN KEY (project_id) REFERENCES project(ID));
 

INSERT INTO target_layout_name ( target_layout_name_sys_name, target_layout_name_name, target_layout_name_desc, reps) VALUES
('TLY-1','DefaultSinglicates', 'Generic default target layout for singlicates', 1 ),
('TLY-2','DefaultDuplicates', 'Generic default target layout for duplicates', 2 ),
('TLY-3','DefaultQuadruplicates', 'Generic default target layout for quadruplicates', 4 );


DROP TABLE IF EXISTS target_layout CASCADE;
CREATE TABLE target_layout
                           (target_layout_name_id INTEGER,
                            target_id INTEGER,
                            quad INTEGER,
                            FOREIGN KEY (target_id) REFERENCES target(id),
                            FOREIGN KEY (target_layout_name_id) REFERENCES target_layout_name(id));
		           
 CREATE INDEX ON target_layout(target_layout_name_id);		           

INSERT INTO target_layout (target_layout_name_id, target_id, quad ) VALUES
(1,1,1),(1,2,2),(1,3,3),(1,4,4),
(2,1,1),(2,2,2),(2,1,3),(2,2,4),
(3,1,1),(3,1,2),(3,1,3),(3,1,4);

-----------------------------
DROP TABLE IF EXISTS plate_set CASCADE;
DROP SEQUENCE IF EXISTS plate_set_id_seq;

CREATE TABLE plate_set
(id SERIAL PRIMARY KEY,
	plate_set_name VARCHAR(250),
        descr VARCHAR(250),
        plate_set_sys_name VARCHAR(30),
        num_plates INTEGER,
        plate_format_id INTEGER,
        plate_type_id INTEGER,
        project_id INTEGER,
	plate_layout_name_id INTEGER,
        sessions_id VARCHAR(32),
	target_layout_name_id INTEGER,
	updated TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,
        FOREIGN KEY (plate_type_id) REFERENCES plate_type(id),
        FOREIGN KEY (plate_format_id) REFERENCES plate_format(id),
        FOREIGN KEY (project_id) REFERENCES project(ID) ON DELETE cascade,
        FOREIGN KEY (sessions_id) REFERENCES sessions(sid) ON DELETE cascade,
	FOREIGN KEY (plate_layout_name_id) REFERENCES plate_layout_name(id),
	FOREIGN KEY (target_layout_name_id) REFERENCES target_layout_name(id));


CREATE INDEX ON plate_set(plate_format_id);
CREATE INDEX ON plate_set(plate_type_id);
CREATE INDEX ON plate_set(project_id);
CREATE INDEX ON plate_set(sessions_id);
CREATE INDEX ON plate_set(plate_layout_name_id);
CREATE INDEX ON plate_set(target_layout_name_id);



----------------------------
DROP TABLE IF EXISTS plate CASCADE;
DROP TABLE IF EXISTS well CASCADE;
DROP TABLE IF EXISTS sample CASCADE;

CREATE TABLE plate (id SERIAL PRIMARY KEY,
barcode VARCHAR(250),
		plate_sys_name VARCHAR(30),
        	plate_type_id INTEGER,
		plate_format_id INTEGER,
		plate_layout_name_id INTEGER,
	        updated TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,
                FOREIGN KEY (plate_type_id) REFERENCES plate_type(id),
		FOREIGN KEY (plate_format_id) REFERENCES plate_format(id), 
		FOREIGN KEY (plate_layout_name_id) REFERENCES plate_layout_name(id));

CREATE INDEX ON plate(plate_type_id);
CREATE INDEX ON plate(plate_format_id);
CREATE INDEX ON plate(barcode);

----------------------------------------------------------------------------
DROP TABLE IF EXISTS plate_plate_set CASCADE;

CREATE TABLE plate_plate_set (
        	plate_set_id INTEGER,
        	plate_id INTEGER,
		plate_order INTEGER,
                FOREIGN KEY (plate_set_id) REFERENCES plate_set(id) ON DELETE cascade,
                FOREIGN KEY (plate_id) REFERENCES plate(id) ON DELETE cascade);

CREATE INDEX ON plate_plate_set(plate_set_id);
CREATE INDEX ON plate_plate_set(plate_id);
 
----------------------------------------------------------------------------

CREATE TABLE sample (id SERIAL PRIMARY KEY,
		sample_sys_name VARCHAR(30),
		project_id INTEGER,
                accs_id VARCHAR(30),
		FOREIGN KEY (project_id) REFERENCES project(id)  ON DELETE cascade);

CREATE INDEX ON sample(project_id);


DROP TABLE IF EXISTS well CASCADE;
CREATE TABLE well (id SERIAL PRIMARY KEY,
  		by_col integer,
		plate_id INTEGER,
		FOREIGN KEY (plate_id) REFERENCES plate(id)  ON DELETE cascade);

CREATE INDEX ON well(plate_id);

----------------------------------------------------------------------------
DROP TABLE IF EXISTS well_sample CASCADE;

CREATE TABLE well_sample (
        	well_id INTEGER,
        	sample_id INTEGER,
                FOREIGN KEY (well_id) REFERENCES well(id)  ON DELETE cascade,
                FOREIGN KEY (sample_id) REFERENCES sample(id) ON DELETE cascade);

CREATE INDEX ON well_sample(well_id);
CREATE INDEX ON well_sample(sample_id);



----------------------------
DROP TABLE IF EXISTS assay_type CASCADE;
CREATE TABLE assay_type (id SERIAL PRIMARY KEY,
	assay_type_name VARCHAR(250));

INSERT INTO assay_type (assay_type_name) VALUES ('ELISA');
INSERT INTO assay_type (assay_type_name) VALUES ('Octet');
INSERT INTO assay_type (assay_type_name) VALUES ('SNP');
INSERT INTO assay_type (assay_type_name) VALUES ('HCS');
INSERT INTO assay_type (assay_type_name) VALUES ('HTRF');
INSERT INTO assay_type (assay_type_name) VALUES ('FACS');		


DROP TABLE IF EXISTS assay_run CASCADE;

CREATE TABLE assay_run (id serial PRIMARY KEY,
               assay_run_sys_name VARCHAR(30),
	       assay_run_name VARCHAR(250),
               descr VARCHAR(250),
		assay_type_id INTEGER,
                plate_set_id INTEGER,
		plate_layout_name_id INTEGER,
        sessions_id VARCHAR(32),
                updated  TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,
               FOREIGN KEY (plate_set_id) REFERENCES plate_set(id),
               FOREIGN KEY (plate_layout_name_id) REFERENCES plate_layout_name(id),
               FOREIGN KEY (sessions_id) REFERENCES sessions(sid),
		FOREIGN KEY (assay_type_id) REFERENCES assay_type(id));

CREATE INDEX ON assay_run(assay_type_id);
CREATE INDEX ON assay_run(plate_set_id);
CREATE INDEX ON assay_run(plate_layout_name_id);
CREATE INDEX ON assay_run(sessions_id);


DROP TABLE IF EXISTS assay_result CASCADE;

CREATE TABLE assay_result (
		assay_run_id INTEGER,
		plate_order INTEGER,
		well INTEGER,
                response REAL,
                bkgrnd_sub REAL,
		norm REAL,        -- max unknown signal set to 1
		norm_pos REAL,    --positive control set to 1
		p_enhance REAL,   --% enhancement; Kelley 2004
	    updated  TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,	
		FOREIGN KEY (assay_run_id) REFERENCES assay_run(id)  ON DELETE cascade);
		

CREATE INDEX ON assay_result(assay_run_id);
CREATE INDEX ON assay_result(plate_order);
CREATE INDEX ON assay_result(well);

DROP TABLE IF EXISTS assay_result_pre CASCADE;

    CREATE TABLE assay_result_pre
                          (assay_run_id INTEGER,
                           plate_order INTEGER,
                           well INTEGER,
                          response REAL,
			   updated  TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,		
                          FOREIGN KEY (assay_run_id) REFERENCES assay_run(id));
                         


----------------------------
DROP TABLE IF EXISTS hit_list CASCADE;

CREATE TABLE hit_list
(id SERIAL PRIMARY KEY,
 hitlist_sys_name VARCHAR(30),
 hitlist_name VARCHAR(250),
        descr VARCHAR(250),
	n INTEGER,
        sessions_id VARCHAR(32),
	updated TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,
 assay_run_id INTEGER,
 FOREIGN KEY (sessions_id) REFERENCES sessions(sid)  ON DELETE CASCADE,
 FOREIGN KEY (assay_run_id) REFERENCES assay_run(id)  ON DELETE cascade);

CREATE INDEX ON hit_list(assay_run_id);
CREATE INDEX ON hit_list(sessions_id);


DROP TABLE IF EXISTS hit_sample CASCADE;
CREATE TABLE hit_sample
(
 hitlist_id INTEGER,
  sample_id INTEGER,
 FOREIGN KEY (hitlist_id) REFERENCES hit_list(id)  ON DELETE cascade,
 FOREIGN KEY (sample_id) REFERENCES sample(id)  ON DELETE cascade);

CREATE INDEX ON hit_sample(hitlist_id);
CREATE INDEX ON hit_sample(sample_id);

----------------------------


DROP TABLE IF EXISTS well_type CASCADE;
CREATE TABLE well_type (
		id SERIAL PRIMARY KEY,
                name VARCHAR(30));
    
INSERT INTO well_type (name) VALUES ('unknown');
INSERT INTO well_type (name) VALUES ('positive');
INSERT INTO well_type (name) VALUES ('negative');
INSERT INTO well_type (name) VALUES ('blank');
INSERT INTO well_type (name) VALUES ('edge');


DROP TABLE IF EXISTS plate_layout CASCADE;

CREATE TABLE plate_layout (
		plate_layout_name_id INTEGER,
                well_by_col INTEGER,
                well_type_id INTEGER,
		replicates integer,
		target integer,
		FOREIGN KEY (plate_layout_name_id) REFERENCES plate_layout_name(id),
                FOREIGN KEY (well_type_id) REFERENCES well_type(id));

CREATE INDEX ON plate_layout(plate_layout_name_id);
CREATE INDEX ON plate_layout(well_type_id);
CREATE INDEX ON plate_layout(well_by_col);

----------------------------
--for import only

DROP TABLE IF EXISTS import_plate_layout CASCADE;

CREATE TABLE import_plate_layout (
		plate_layout_name_id INTEGER,
                well_by_col INTEGER,
                well_type_id INTEGER,
		replicates integer,
		target INTEGER);


-----------------------------------
DROP TABLE IF EXISTS temp_accs_id CASCADE;
CREATE TABLE temp_accs_id(plate_order INTEGER,
			by_col Integer, 
                           accs_id VARCHAR(30));

CREATE INDEX ON temp_accs_id(plate_order);
CREATE INDEX ON temp_accs_id(by_col);

-----------------------------------
DROP TABLE IF EXISTS temp_barcode_id CASCADE;
CREATE TABLE temp_barcode_id(plate_order INTEGER, 
                           barcode_id VARCHAR(30));

CREATE INDEX ON temp_barcode_id(plate_order);


-----------------------------------
DROP TABLE IF EXISTS rearray_pairs CASCADE;
CREATE TABLE rearray_pairs(
		id SERIAL PRIMARY KEY,
                src INTEGER,
			dest Integer);

CREATE INDEX ON rearray_pairs(src);
CREATE INDEX ON rearray_pairs(dest);


-----------------------------------

DROP TABLE IF EXISTS worklists CASCADE;
CREATE TABLE worklists(
		rearray_pairs_id INTEGER,
		sample_id INTEGER,
                source_plate VARCHAR(10),
		source_well integer,
		dest_plate VARCHAR(10),
		dest_well integer,
		FOREIGN KEY (rearray_pairs_id) REFERENCES rearray_pairs(id)  ON DELETE cascade,
		FOREIGN KEY (sample_id) REFERENCES sample(id));

DROP TABLE IF EXISTS well_numbers CASCADE;
CREATE TABLE well_numbers(plate_format INTEGER,
			well_name VARCHAR(5), 
                           row VARCHAR(2),
			   row_num INTEGER,
                           col VARCHAR(2),
			   total_col_count INTEGER,
                           by_row INTEGER,
                           by_col INTEGER,
                           quad INTEGER,
			   parent_well integer);

--CREATE TRIGGER calculate_by_row_number
--before INSERT ON well_numbers
--FOR EACH row EXECUTE PROCEDURE calc_by_row_num_func();
CREATE INDEX ON well_numbers(by_col);

DROP TABLE IF EXISTS assay_run_stats CASCADE;
-- stats across all plates of normalized data
CREATE TABLE assay_run_stats
(assay_run_id INTEGER,
response_type INTEGER,
max_response DECIMAL,
min_response DECIMAL,
mean_bkgrnd DECIMAL,
std_dev_bkgrnd DECIMAL,
mean_pos DECIMAL,
stdev_pos DECIMAL,
mean_neg_3_sd DECIMAL,
mean_neg_2_sd DECIMAL,
mean_pos_3_sd DECIMAL,
mean_pos_2_sd DECIMAL,
	updated TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT current_timestamp,
        FOREIGN KEY (assay_run_id) REFERENCES assay_run(id));

CREATE INDEX ON assay_run_stats(assay_run_id);


INSERT INTO plate_layout (plate_layout_name_id, well_by_col, well_type_id, replicates, target) VALUES (1, 1, 1, 1, 1),(1, 2, 1, 1, 1),(1, 3, 1, 1, 1),(1, 4, 1, 1, 1),(1, 5, 1, 1, 1),(1, 6, 1, 1, 1),(1, 7, 1, 1, 1),(1, 8, 1, 1, 1),(1, 9, 1, 1, 1),(1, 10, 1, 1, 1),(1, 11, 1, 1, 1),(1, 12, 1, 1, 1),(1, 13, 1, 1, 1),(1, 14, 1, 1, 1),(1, 15, 1, 1, 1),(1, 16, 1, 1, 1),(1, 17, 1, 1, 1),(1, 18, 1, 1, 1),(1, 19, 1, 1, 1),(1, 20, 1, 1, 1),(1, 21, 1, 1, 1),(1, 22, 1, 1, 1),(1, 23, 1, 1, 1),(1, 24, 1, 1, 1),(1, 25, 1, 1, 1),(1, 26, 1, 1, 1),(1, 27, 1, 1, 1),(1, 28, 1, 1, 1),(1, 29, 1, 1, 1),(1, 30, 1, 1, 1),(1, 31, 1, 1, 1),(1, 32, 1, 1, 1),(1, 33, 1, 1, 1),(1, 34, 1, 1, 1),(1, 35, 1, 1, 1),(1, 36, 1, 1, 1),(1, 37, 1, 1, 1),(1, 38, 1, 1, 1),(1, 39, 1, 1, 1),(1, 40, 1, 1, 1),(1, 41, 1, 1, 1),(1, 42, 1, 1, 1),(1, 43, 1, 1, 1),(1, 44, 1, 1, 1),(1, 45, 1, 1, 1),(1, 46, 1, 1, 1),(1, 47, 1, 1, 1),(1, 48, 1, 1, 1),(1, 49, 1, 1, 1),(1, 50, 1, 1, 1),(1, 51, 1, 1, 1),(1, 52, 1, 1, 1),(1, 53, 1, 1, 1),(1, 54, 1, 1, 1),(1, 55, 1, 1, 1),(1, 56, 1, 1, 1),(1, 57, 1, 1, 1),(1, 58, 1, 1, 1),(1, 59, 1, 1, 1),(1, 60, 1, 1, 1),(1, 61, 1, 1, 1),(1, 62, 1, 1, 1),(1, 63, 1, 1, 1),(1, 64, 1, 1, 1),(1, 65, 1, 1, 1),(1, 66, 1, 1, 1),(1, 67, 1, 1, 1),(1, 68, 1, 1, 1),(1, 69, 1, 1, 1),(1, 70, 1, 1, 1),(1, 71, 1, 1, 1),(1, 72, 1, 1, 1),(1, 73, 1, 1, 1),(1, 74, 1, 1, 1),(1, 75, 1, 1, 1),(1, 76, 1, 1, 1),(1, 77, 1, 1, 1),(1, 78, 1, 1, 1),(1, 79, 1, 1, 1),(1, 80, 1, 1, 1),(1, 81, 1, 1, 1),(1, 82, 1, 1, 1),(1, 83, 1, 1, 1),(1, 84, 1, 1, 1),(1, 85, 1, 1, 1),(1, 86, 1, 1, 1),(1, 87, 1, 1, 1),(1, 88, 1, 1, 1),(1, 89, 1, 1, 1),(1, 90, 1, 1, 1),(1, 91, 1, 1, 1),(1, 92, 1, 1, 1),(1, 93, 2, 1, 1),(1, 94, 2, 1, 1),(1, 95, 3, 1, 1),(1, 96, 4, 1, 1),(2, 1, 1, 1, 1),(2, 2, 1, 3, 1),(2, 3, 1, 1, 1),(2, 4, 1, 3, 1),(2, 5, 1, 1, 1),(2, 6, 1, 3, 1),(2, 7, 1, 1, 1),(2, 8, 1, 3, 1),(2, 9, 1, 1, 1),(2, 10, 1, 3, 1),(2, 11, 1, 1, 1),(2, 12, 1, 3, 1),(2, 13, 1, 1, 1),(2, 14, 1, 3, 1),(2, 15, 1, 1, 1),(2, 16, 1, 3, 1),(2, 17, 1, 2, 1),(2, 18, 1, 4, 1),(2, 19, 1, 2, 1),(2, 20, 1, 4, 1),(2, 21, 1, 2, 1),(2, 22, 1, 4, 1),(2, 23, 1, 2, 1),(2, 24, 1, 4, 1),(2, 25, 1, 2, 1),(2, 26, 1, 4, 1),(2, 27, 1, 2, 1),(2, 28, 1, 4, 1),(2, 29, 1, 2, 1),(2, 30, 1, 4, 1),(2, 31, 1, 2, 1),(2, 32, 1, 4, 1),(2, 33, 1, 1, 1),(2, 34, 1, 3, 1),(2, 35, 1, 1, 1),(2, 36, 1, 3, 1),(2, 37, 1, 1, 1),(2, 38, 1, 3, 1),(2, 39, 1, 1, 1),(2, 40, 1, 3, 1),(2, 41, 1, 1, 1),(2, 42, 1, 3, 1),(2, 43, 1, 1, 1),(2, 44, 1, 3, 1),(2, 45, 1, 1, 1),(2, 46, 1, 3, 1),(2, 47, 1, 1, 1),(2, 48, 1, 3, 1),(2, 49, 1, 2, 1),(2, 50, 1, 4, 1),(2, 51, 1, 2, 1),(2, 52, 1, 4, 1),(2, 53, 1, 2, 1),(2, 54, 1, 4, 1),(2, 55, 1, 2, 1),(2, 56, 1, 4, 1),(2, 57, 1, 2, 1),(2, 58, 1, 4, 1),(2, 59, 1, 2, 1),(2, 60, 1, 4, 1),(2, 61, 1, 2, 1),(2, 62, 1, 4, 1),(2, 63, 1, 2, 1),(2, 64, 1, 4, 1),(2, 65, 1, 1, 1),(2, 66, 1, 3, 1),(2, 67, 1, 1, 1),(2, 68, 1, 3, 1),(2, 69, 1, 1, 1),(2, 70, 1, 3, 1),(2, 71, 1, 1, 1),(2, 72, 1, 3, 1),(2, 73, 1, 1, 1),(2, 74, 1, 3, 1),(2, 75, 1, 1, 1),(2, 76, 1, 3, 1),(2, 77, 1, 1, 1),(2, 78, 1, 3, 1),(2, 79, 1, 1, 1),(2, 80, 1, 3, 1),(2, 81, 1, 2, 1),(2, 82, 1, 4, 1),(2, 83, 1, 2, 1),(2, 84, 1, 4, 1),(2, 85, 1, 2, 1),(2, 86, 1, 4, 1),(2, 87, 1, 2, 1),(2, 88, 1, 4, 1),(2, 89, 1, 2, 1),(2, 90, 1, 4, 1),(2, 91, 1, 2, 1),(2, 92, 1, 4, 1),(2, 93, 1, 2, 1),(2, 94, 1, 4, 1),(2, 95, 1, 2, 1),(2, 96, 1, 4, 1),(2, 97, 1, 1, 1),(2, 98, 1, 3, 1),(2, 99, 1, 1, 1),(2, 100, 1, 3, 1),(2, 101, 1, 1, 1),(2, 102, 1, 3, 1),(2, 103, 1, 1, 1),(2, 104, 1, 3, 1),(2, 105, 1, 1, 1),(2, 106, 1, 3, 1),(2, 107, 1, 1, 1),(2, 108, 1, 3, 1),(2, 109, 1, 1, 1),(2, 110, 1, 3, 1),(2, 111, 1, 1, 1),(2, 112, 1, 3, 1),(2, 113, 1, 2, 1),(2, 114, 1, 4, 1),(2, 115, 1, 2, 1),(2, 116, 1, 4, 1),(2, 117, 1, 2, 1),(2, 118, 1, 4, 1),(2, 119, 1, 2, 1),(2, 120, 1, 4, 1),(2, 121, 1, 2, 1),(2, 122, 1, 4, 1),(2, 123, 1, 2, 1),(2, 124, 1, 4, 1),(2, 125, 1, 2, 1),(2, 126, 1, 4, 1),(2, 127, 1, 2, 1),(2, 128, 1, 4, 1),(2, 129, 1, 1, 1),(2, 130, 1, 3, 1),(2, 131, 1, 1, 1),(2, 132, 1, 3, 1),(2, 133, 1, 1, 1),(2, 134, 1, 3, 1),(2, 135, 1, 1, 1),(2, 136, 1, 3, 1),(2, 137, 1, 1, 1),(2, 138, 1, 3, 1),(2, 139, 1, 1, 1),(2, 140, 1, 3, 1),(2, 141, 1, 1, 1),(2, 142, 1, 3, 1),(2, 143, 1, 1, 1),(2, 144, 1, 3, 1),(2, 145, 1, 2, 1),(2, 146, 1, 4, 1),(2, 147, 1, 2, 1),(2, 148, 1, 4, 1),(2, 149, 1, 2, 1),(2, 150, 1, 4, 1),(2, 151, 1, 2, 1),(2, 152, 1, 4, 1),(2, 153, 1, 2, 1),(2, 154, 1, 4, 1),(2, 155, 1, 2, 1),(2, 156, 1, 4, 1),(2, 157, 1, 2, 1),(2, 158, 1, 4, 1),(2, 159, 1, 2, 1),(2, 160, 1, 4, 1),(2, 161, 1, 1, 1),(2, 162, 1, 3, 1),(2, 163, 1, 1, 1),(2, 164, 1, 3, 1),(2, 165, 1, 1, 1),(2, 166, 1, 3, 1),(2, 167, 1, 1, 1),(2, 168, 1, 3, 1),(2, 169, 1, 1, 1),(2, 170, 1, 3, 1),(2, 171, 1, 1, 1),(2, 172, 1, 3, 1),(2, 173, 1, 1, 1),(2, 174, 1, 3, 1),(2, 175, 1, 1, 1),(2, 176, 1, 3, 1),(2, 177, 1, 2, 1),(2, 178, 1, 4, 1),(2, 179, 1, 2, 1),(2, 180, 1, 4, 1),(2, 181, 1, 2, 1),(2, 182, 1, 4, 1),(2, 183, 1, 2, 1),(2, 184, 1, 4, 1),(2, 185, 1, 2, 1),(2, 186, 1, 4, 1),(2, 187, 1, 2, 1),(2, 188, 1, 4, 1),(2, 189, 1, 2, 1),(2, 190, 1, 4, 1),(2, 191, 1, 2, 1),(2, 192, 1, 4, 1),(2, 193, 1, 1, 1),(2, 194, 1, 3, 1),(2, 195, 1, 1, 1),(2, 196, 1, 3, 1),(2, 197, 1, 1, 1),(2, 198, 1, 3, 1),(2, 199, 1, 1, 1),(2, 200, 1, 3, 1),(2, 201, 1, 1, 1),(2, 202, 1, 3, 1),(2, 203, 1, 1, 1),(2, 204, 1, 3, 1),(2, 205, 1, 1, 1),(2, 206, 1, 3, 1),(2, 207, 1, 1, 1),(2, 208, 1, 3, 1),(2, 209, 1, 2, 1),(2, 210, 1, 4, 1),(2, 211, 1, 2, 1),(2, 212, 1, 4, 1),(2, 213, 1, 2, 1),(2, 214, 1, 4, 1),(2, 215, 1, 2, 1),(2, 216, 1, 4, 1),(2, 217, 1, 2, 1),(2, 218, 1, 4, 1),(2, 219, 1, 2, 1),(2, 220, 1, 4, 1),(2, 221, 1, 2, 1),(2, 222, 1, 4, 1),(2, 223, 1, 2, 1),(2, 224, 1, 4, 1),(2, 225, 1, 1, 1),(2, 226, 1, 3, 1),(2, 227, 1, 1, 1),(2, 228, 1, 3, 1),(2, 229, 1, 1, 1),(2, 230, 1, 3, 1),(2, 231, 1, 1, 1),(2, 232, 1, 3, 1),(2, 233, 1, 1, 1),(2, 234, 1, 3, 1),(2, 235, 1, 1, 1),(2, 236, 1, 3, 1),(2, 237, 1, 1, 1),(2, 238, 1, 3, 1),(2, 239, 1, 1, 1),(2, 240, 1, 3, 1),(2, 241, 1, 2, 1),(2, 242, 1, 4, 1),(2, 243, 1, 2, 1),(2, 244, 1, 4, 1),(2, 245, 1, 2, 1),(2, 246, 1, 4, 1),(2, 247, 1, 2, 1),(2, 248, 1, 4, 1),(2, 249, 1, 2, 1),(2, 250, 1, 4, 1),(2, 251, 1, 2, 1),(2, 252, 1, 4, 1),(2, 253, 1, 2, 1),(2, 254, 1, 4, 1),(2, 255, 1, 2, 1),(2, 256, 1, 4, 1),(2, 257, 1, 1, 1),(2, 258, 1, 3, 1),(2, 259, 1, 1, 1),(2, 260, 1, 3, 1),(2, 261, 1, 1, 1),(2, 262, 1, 3, 1),(2, 263, 1, 1, 1),(2, 264, 1, 3, 1),(2, 265, 1, 1, 1),(2, 266, 1, 3, 1),(2, 267, 1, 1, 1),(2, 268, 1, 3, 1),(2, 269, 1, 1, 1),(2, 270, 1, 3, 1),(2, 271, 1, 1, 1),(2, 272, 1, 3, 1),(2, 273, 1, 2, 1),(2, 274, 1, 4, 1),(2, 275, 1, 2, 1),(2, 276, 1, 4, 1),(2, 277, 1, 2, 1),(2, 278, 1, 4, 1),(2, 279, 1, 2, 1),(2, 280, 1, 4, 1),(2, 281, 1, 2, 1),(2, 282, 1, 4, 1),(2, 283, 1, 2, 1),(2, 284, 1, 4, 1),(2, 285, 1, 2, 1),(2, 286, 1, 4, 1),(2, 287, 1, 2, 1),(2, 288, 1, 4, 1),(2, 289, 1, 1, 1),(2, 290, 1, 3, 1),(2, 291, 1, 1, 1),(2, 292, 1, 3, 1),(2, 293, 1, 1, 1),(2, 294, 1, 3, 1),(2, 295, 1, 1, 1),(2, 296, 1, 3, 1),(2, 297, 1, 1, 1),(2, 298, 1, 3, 1),(2, 299, 1, 1, 1),(2, 300, 1, 3, 1),(2, 301, 1, 1, 1),(2, 302, 1, 3, 1),(2, 303, 1, 1, 1),(2, 304, 1, 3, 1),(2, 305, 1, 2, 1),(2, 306, 1, 4, 1),(2, 307, 1, 2, 1),(2, 308, 1, 4, 1),(2, 309, 1, 2, 1),(2, 310, 1, 4, 1),(2, 311, 1, 2, 1),(2, 312, 1, 4, 1),(2, 313, 1, 2, 1),(2, 314, 1, 4, 1),(2, 315, 1, 2, 1),(2, 316, 1, 4, 1),(2, 317, 1, 2, 1),(2, 318, 1, 4, 1),(2, 319, 1, 2, 1),(2, 320, 1, 4, 1),(2, 321, 1, 1, 1),(2, 322, 1, 3, 1),(2, 323, 1, 1, 1),(2, 324, 1, 3, 1),(2, 325, 1, 1, 1),(2, 326, 1, 3, 1),(2, 327, 1, 1, 1),(2, 328, 1, 3, 1),(2, 329, 1, 1, 1),(2, 330, 1, 3, 1),(2, 331, 1, 1, 1),(2, 332, 1, 3, 1),(2, 333, 1, 1, 1),(2, 334, 1, 3, 1),(2, 335, 1, 1, 1),(2, 336, 1, 3, 1),(2, 337, 1, 2, 1),(2, 338, 1, 4, 1),(2, 339, 1, 2, 1),(2, 340, 1, 4, 1),(2, 341, 1, 2, 1),(2, 342, 1, 4, 1),(2, 343, 1, 2, 1),(2, 344, 1, 4, 1),(2, 345, 1, 2, 1),(2, 346, 1, 4, 1),(2, 347, 1, 2, 1),(2, 348, 1, 4, 1),(2, 349, 1, 2, 1),(2, 350, 1, 4, 1),(2, 351, 1, 2, 1),(2, 352, 1, 4, 1),(2, 353, 1, 1, 1),(2, 354, 1, 3, 1),(2, 355, 1, 1, 1),(2, 356, 1, 3, 1),(2, 357, 1, 1, 1),(2, 358, 1, 3, 1),(2, 359, 1, 1, 1),(2, 360, 1, 3, 1),(2, 361, 2, 1, 1),(2, 362, 2, 3, 1),(2, 363, 2, 1, 1),(2, 364, 2, 3, 1),(2, 365, 3, 1, 1),(2, 366, 3, 3, 1),(2, 367, 4, 1, 1),(2, 368, 4, 3, 1),(2, 369, 1, 2, 1),(2, 370, 1, 4, 1),(2, 371, 1, 2, 1),(2, 372, 1, 4, 1),(2, 373, 1, 2, 1),(2, 374, 1, 4, 1),(2, 375, 1, 2, 1),(2, 376, 1, 4, 1),(2, 377, 2, 2, 1),(2, 378, 2, 4, 1),(2, 379, 2, 2, 1),(2, 380, 2, 4, 1),(2, 381, 3, 2, 1),(2, 382, 3, 4, 1),(2, 383, 4, 2, 1),(2, 384, 4, 4, 1),(3, 1, 1, 1, 1),(3, 2, 1, 2, 1),(3, 3, 1, 1, 1),(3, 4, 1, 2, 1),(3, 5, 1, 1, 1),(3, 6, 1, 2, 1),(3, 7, 1, 1, 1),(3, 8, 1, 2, 1),(3, 9, 1, 1, 1),(3, 10, 1, 2, 1),(3, 11, 1, 1, 1),(3, 12, 1, 2, 1),(3, 13, 1, 1, 1),(3, 14, 1, 2, 1),(3, 15, 1, 1, 1),(3, 16, 1, 2, 1),(3, 17, 1, 1, 2),(3, 18, 1, 2, 2),(3, 19, 1, 1, 2),(3, 20, 1, 2, 2),(3, 21, 1, 1, 2),(3, 22, 1, 2, 2),(3, 23, 1, 1, 2),(3, 24, 1, 2, 2),(3, 25, 1, 1, 2),(3, 26, 1, 2, 2),(3, 27, 1, 1, 2),(3, 28, 1, 2, 2),(3, 29, 1, 1, 2),(3, 30, 1, 2, 2),(3, 31, 1, 1, 2),(3, 32, 1, 2, 2),(3, 33, 1, 1, 1),(3, 34, 1, 2, 1),(3, 35, 1, 1, 1),(3, 36, 1, 2, 1),(3, 37, 1, 1, 1),(3, 38, 1, 2, 1),(3, 39, 1, 1, 1),(3, 40, 1, 2, 1),(3, 41, 1, 1, 1),(3, 42, 1, 2, 1),(3, 43, 1, 1, 1),(3, 44, 1, 2, 1),(3, 45, 1, 1, 1),(3, 46, 1, 2, 1),(3, 47, 1, 1, 1),(3, 48, 1, 2, 1),(3, 49, 1, 1, 2),(3, 50, 1, 2, 2),(3, 51, 1, 1, 2),(3, 52, 1, 2, 2),(3, 53, 1, 1, 2),(3, 54, 1, 2, 2),(3, 55, 1, 1, 2),(3, 56, 1, 2, 2),(3, 57, 1, 1, 2),(3, 58, 1, 2, 2),(3, 59, 1, 1, 2),(3, 60, 1, 2, 2),(3, 61, 1, 1, 2),(3, 62, 1, 2, 2),(3, 63, 1, 1, 2),(3, 64, 1, 2, 2),(3, 65, 1, 1, 1),(3, 66, 1, 2, 1),(3, 67, 1, 1, 1),(3, 68, 1, 2, 1),(3, 69, 1, 1, 1),(3, 70, 1, 2, 1),(3, 71, 1, 1, 1),(3, 72, 1, 2, 1),(3, 73, 1, 1, 1),(3, 74, 1, 2, 1),(3, 75, 1, 1, 1),(3, 76, 1, 2, 1),(3, 77, 1, 1, 1),(3, 78, 1, 2, 1),(3, 79, 1, 1, 1),(3, 80, 1, 2, 1),(3, 81, 1, 1, 2),(3, 82, 1, 2, 2),(3, 83, 1, 1, 2),(3, 84, 1, 2, 2),(3, 85, 1, 1, 2),(3, 86, 1, 2, 2),(3, 87, 1, 1, 2),(3, 88, 1, 2, 2),(3, 89, 1, 1, 2),(3, 90, 1, 2, 2),(3, 91, 1, 1, 2),(3, 92, 1, 2, 2),(3, 93, 1, 1, 2),(3, 94, 1, 2, 2),(3, 95, 1, 1, 2),(3, 96, 1, 2, 2),(3, 97, 1, 1, 1),(3, 98, 1, 2, 1),(3, 99, 1, 1, 1),(3, 100, 1, 2, 1),(3, 101, 1, 1, 1),(3, 102, 1, 2, 1),(3, 103, 1, 1, 1),(3, 104, 1, 2, 1),(3, 105, 1, 1, 1),(3, 106, 1, 2, 1),(3, 107, 1, 1, 1),(3, 108, 1, 2, 1),(3, 109, 1, 1, 1),(3, 110, 1, 2, 1),(3, 111, 1, 1, 1),(3, 112, 1, 2, 1),(3, 113, 1, 1, 2),(3, 114, 1, 2, 2),(3, 115, 1, 1, 2),(3, 116, 1, 2, 2),(3, 117, 1, 1, 2),(3, 118, 1, 2, 2),(3, 119, 1, 1, 2),(3, 120, 1, 2, 2),(3, 121, 1, 1, 2),(3, 122, 1, 2, 2),(3, 123, 1, 1, 2),(3, 124, 1, 2, 2),(3, 125, 1, 1, 2),(3, 126, 1, 2, 2),(3, 127, 1, 1, 2),(3, 128, 1, 2, 2),(3, 129, 1, 1, 1),(3, 130, 1, 2, 1),(3, 131, 1, 1, 1),(3, 132, 1, 2, 1),(3, 133, 1, 1, 1),(3, 134, 1, 2, 1),(3, 135, 1, 1, 1),(3, 136, 1, 2, 1),(3, 137, 1, 1, 1),(3, 138, 1, 2, 1),(3, 139, 1, 1, 1),(3, 140, 1, 2, 1),(3, 141, 1, 1, 1),(3, 142, 1, 2, 1),(3, 143, 1, 1, 1),(3, 144, 1, 2, 1),(3, 145, 1, 1, 2),(3, 146, 1, 2, 2),(3, 147, 1, 1, 2),(3, 148, 1, 2, 2),(3, 149, 1, 1, 2),(3, 150, 1, 2, 2),(3, 151, 1, 1, 2),(3, 152, 1, 2, 2),(3, 153, 1, 1, 2),(3, 154, 1, 2, 2),(3, 155, 1, 1, 2),(3, 156, 1, 2, 2),(3, 157, 1, 1, 2),(3, 158, 1, 2, 2),(3, 159, 1, 1, 2),(3, 160, 1, 2, 2),(3, 161, 1, 1, 1),(3, 162, 1, 2, 1),(3, 163, 1, 1, 1),(3, 164, 1, 2, 1),(3, 165, 1, 1, 1),(3, 166, 1, 2, 1),(3, 167, 1, 1, 1),(3, 168, 1, 2, 1),(3, 169, 1, 1, 1),(3, 170, 1, 2, 1),(3, 171, 1, 1, 1),(3, 172, 1, 2, 1),(3, 173, 1, 1, 1),(3, 174, 1, 2, 1),(3, 175, 1, 1, 1),(3, 176, 1, 2, 1),(3, 177, 1, 1, 2),(3, 178, 1, 2, 2),(3, 179, 1, 1, 2),(3, 180, 1, 2, 2),(3, 181, 1, 1, 2),(3, 182, 1, 2, 2),(3, 183, 1, 1, 2),(3, 184, 1, 2, 2),(3, 185, 1, 1, 2),(3, 186, 1, 2, 2),(3, 187, 1, 1, 2),(3, 188, 1, 2, 2),(3, 189, 1, 1, 2),(3, 190, 1, 2, 2),(3, 191, 1, 1, 2),(3, 192, 1, 2, 2),(3, 193, 1, 1, 1),(3, 194, 1, 2, 1),(3, 195, 1, 1, 1),(3, 196, 1, 2, 1),(3, 197, 1, 1, 1),(3, 198, 1, 2, 1),(3, 199, 1, 1, 1),(3, 200, 1, 2, 1),(3, 201, 1, 1, 1),(3, 202, 1, 2, 1),(3, 203, 1, 1, 1),(3, 204, 1, 2, 1),(3, 205, 1, 1, 1),(3, 206, 1, 2, 1),(3, 207, 1, 1, 1),(3, 208, 1, 2, 1),(3, 209, 1, 1, 2),(3, 210, 1, 2, 2),(3, 211, 1, 1, 2),(3, 212, 1, 2, 2),(3, 213, 1, 1, 2),(3, 214, 1, 2, 2),(3, 215, 1, 1, 2),(3, 216, 1, 2, 2),(3, 217, 1, 1, 2),(3, 218, 1, 2, 2),(3, 219, 1, 1, 2),(3, 220, 1, 2, 2),(3, 221, 1, 1, 2),(3, 222, 1, 2, 2),(3, 223, 1, 1, 2),(3, 224, 1, 2, 2),(3, 225, 1, 1, 1),(3, 226, 1, 2, 1),(3, 227, 1, 1, 1),(3, 228, 1, 2, 1),(3, 229, 1, 1, 1),(3, 230, 1, 2, 1),(3, 231, 1, 1, 1),(3, 232, 1, 2, 1),(3, 233, 1, 1, 1),(3, 234, 1, 2, 1),(3, 235, 1, 1, 1),(3, 236, 1, 2, 1),(3, 237, 1, 1, 1),(3, 238, 1, 2, 1),(3, 239, 1, 1, 1),(3, 240, 1, 2, 1),(3, 241, 1, 1, 2),(3, 242, 1, 2, 2),(3, 243, 1, 1, 2),(3, 244, 1, 2, 2),(3, 245, 1, 1, 2),(3, 246, 1, 2, 2),(3, 247, 1, 1, 2),(3, 248, 1, 2, 2),(3, 249, 1, 1, 2),(3, 250, 1, 2, 2),(3, 251, 1, 1, 2),(3, 252, 1, 2, 2),(3, 253, 1, 1, 2),(3, 254, 1, 2, 2),(3, 255, 1, 1, 2),(3, 256, 1, 2, 2),(3, 257, 1, 1, 1),(3, 258, 1, 2, 1),(3, 259, 1, 1, 1),(3, 260, 1, 2, 1),(3, 261, 1, 1, 1),(3, 262, 1, 2, 1),(3, 263, 1, 1, 1),(3, 264, 1, 2, 1),(3, 265, 1, 1, 1),(3, 266, 1, 2, 1),(3, 267, 1, 1, 1),(3, 268, 1, 2, 1),(3, 269, 1, 1, 1),(3, 270, 1, 2, 1),(3, 271, 1, 1, 1),(3, 272, 1, 2, 1),(3, 273, 1, 1, 2),(3, 274, 1, 2, 2),(3, 275, 1, 1, 2),(3, 276, 1, 2, 2),(3, 277, 1, 1, 2),(3, 278, 1, 2, 2),(3, 279, 1, 1, 2),(3, 280, 1, 2, 2),(3, 281, 1, 1, 2),(3, 282, 1, 2, 2),(3, 283, 1, 1, 2),(3, 284, 1, 2, 2),(3, 285, 1, 1, 2),(3, 286, 1, 2, 2),(3, 287, 1, 1, 2),(3, 288, 1, 2, 2),(3, 289, 1, 1, 1),(3, 290, 1, 2, 1),(3, 291, 1, 1, 1),(3, 292, 1, 2, 1),(3, 293, 1, 1, 1),(3, 294, 1, 2, 1),(3, 295, 1, 1, 1),(3, 296, 1, 2, 1),(3, 297, 1, 1, 1),(3, 298, 1, 2, 1),(3, 299, 1, 1, 1),(3, 300, 1, 2, 1),(3, 301, 1, 1, 1),(3, 302, 1, 2, 1),(3, 303, 1, 1, 1),(3, 304, 1, 2, 1),(3, 305, 1, 1, 2),(3, 306, 1, 2, 2),(3, 307, 1, 1, 2),(3, 308, 1, 2, 2),(3, 309, 1, 1, 2),(3, 310, 1, 2, 2),(3, 311, 1, 1, 2),(3, 312, 1, 2, 2),(3, 313, 1, 1, 2),(3, 314, 1, 2, 2),(3, 315, 1, 1, 2),(3, 316, 1, 2, 2),(3, 317, 1, 1, 2),(3, 318, 1, 2, 2),(3, 319, 1, 1, 2),(3, 320, 1, 2, 2),(3, 321, 1, 1, 1),(3, 322, 1, 2, 1),(3, 323, 1, 1, 1),(3, 324, 1, 2, 1),(3, 325, 1, 1, 1),(3, 326, 1, 2, 1),(3, 327, 1, 1, 1),(3, 328, 1, 2, 1),(3, 329, 1, 1, 1),(3, 330, 1, 2, 1),(3, 331, 1, 1, 1),(3, 332, 1, 2, 1),(3, 333, 1, 1, 1),(3, 334, 1, 2, 1),(3, 335, 1, 1, 1),(3, 336, 1, 2, 1),(3, 337, 1, 1, 2),(3, 338, 1, 2, 2),(3, 339, 1, 1, 2),(3, 340, 1, 2, 2),(3, 341, 1, 1, 2),(3, 342, 1, 2, 2),(3, 343, 1, 1, 2),(3, 344, 1, 2, 2),(3, 345, 1, 1, 2),(3, 346, 1, 2, 2),(3, 347, 1, 1, 2),(3, 348, 1, 2, 2),(3, 349, 1, 1, 2),(3, 350, 1, 2, 2),(3, 351, 1, 1, 2),(3, 352, 1, 2, 2),(3, 353, 1, 1, 1),(3, 354, 1, 2, 1),(3, 355, 1, 1, 1),(3, 356, 1, 2, 1),(3, 357, 1, 1, 1),(3, 358, 1, 2, 1),(3, 359, 1, 1, 1),(3, 360, 1, 2, 1),(3, 361, 2, 1, 1),(3, 362, 2, 2, 1),(3, 363, 2, 1, 1),(3, 364, 2, 2, 1),(3, 365, 3, 1, 1),(3, 366, 3, 2, 1),(3, 367, 4, 1, 1),(3, 368, 4, 2, 1),(3, 369, 1, 1, 2),(3, 370, 1, 2, 2),(3, 371, 1, 1, 2),(3, 372, 1, 2, 2),(3, 373, 1, 1, 2),(3, 374, 1, 2, 2),(3, 375, 1, 1, 2),(3, 376, 1, 2, 2),(3, 377, 2, 1, 2),(3, 378, 2, 2, 2),(3, 379, 2, 1, 2),(3, 380, 2, 2, 2),(3, 381, 3, 1, 2),(3, 382, 3, 2, 2),(3, 383, 4, 1, 2),(3, 384, 4, 2, 2),(4, 1, 1, 1, 1),(4, 2, 1, 2, 1),(4, 3, 1, 1, 1),(4, 4, 1, 2, 1),(4, 5, 1, 1, 1),(4, 6, 1, 2, 1),(4, 7, 1, 1, 1),(4, 8, 1, 2, 1),(4, 9, 1, 1, 1),(4, 10, 1, 2, 1),(4, 11, 1, 1, 1),(4, 12, 1, 2, 1),(4, 13, 1, 1, 1),(4, 14, 1, 2, 1),(4, 15, 1, 1, 1),(4, 16, 1, 2, 1),(4, 17, 1, 1, 1),(4, 18, 1, 2, 1),(4, 19, 1, 1, 1),(4, 20, 1, 2, 1),(4, 21, 1, 1, 1),(4, 22, 1, 2, 1),(4, 23, 1, 1, 1),(4, 24, 1, 2, 1),(4, 25, 1, 1, 1),(4, 26, 1, 2, 1),(4, 27, 1, 1, 1),(4, 28, 1, 2, 1),(4, 29, 1, 1, 1),(4, 30, 1, 2, 1),(4, 31, 1, 1, 1),(4, 32, 1, 2, 1),(4, 33, 1, 1, 1),(4, 34, 1, 2, 1),(4, 35, 1, 1, 1),(4, 36, 1, 2, 1),(4, 37, 1, 1, 1),(4, 38, 1, 2, 1),(4, 39, 1, 1, 1),(4, 40, 1, 2, 1),(4, 41, 1, 1, 1),(4, 42, 1, 2, 1),(4, 43, 1, 1, 1),(4, 44, 1, 2, 1),(4, 45, 1, 1, 1),(4, 46, 1, 2, 1),(4, 47, 1, 1, 1),(4, 48, 1, 2, 1),(4, 49, 1, 1, 1),(4, 50, 1, 2, 1),(4, 51, 1, 1, 1),(4, 52, 1, 2, 1),(4, 53, 1, 1, 1),(4, 54, 1, 2, 1),(4, 55, 1, 1, 1),(4, 56, 1, 2, 1),(4, 57, 1, 1, 1),(4, 58, 1, 2, 1),(4, 59, 1, 1, 1),(4, 60, 1, 2, 1),(4, 61, 1, 1, 1),(4, 62, 1, 2, 1),(4, 63, 1, 1, 1),(4, 64, 1, 2, 1),(4, 65, 1, 1, 1),(4, 66, 1, 2, 1),(4, 67, 1, 1, 1),(4, 68, 1, 2, 1),(4, 69, 1, 1, 1),(4, 70, 1, 2, 1),(4, 71, 1, 1, 1),(4, 72, 1, 2, 1),(4, 73, 1, 1, 1),(4, 74, 1, 2, 1),(4, 75, 1, 1, 1),(4, 76, 1, 2, 1),(4, 77, 1, 1, 1),(4, 78, 1, 2, 1),(4, 79, 1, 1, 1),(4, 80, 1, 2, 1),(4, 81, 1, 1, 1),(4, 82, 1, 2, 1),(4, 83, 1, 1, 1),(4, 84, 1, 2, 1),(4, 85, 1, 1, 1),(4, 86, 1, 2, 1),(4, 87, 1, 1, 1),(4, 88, 1, 2, 1),(4, 89, 1, 1, 1),(4, 90, 1, 2, 1),(4, 91, 1, 1, 1),(4, 92, 1, 2, 1),(4, 93, 1, 1, 1),(4, 94, 1, 2, 1),(4, 95, 1, 1, 1),(4, 96, 1, 2, 1),(4, 97, 1, 1, 1),(4, 98, 1, 2, 1),(4, 99, 1, 1, 1),(4, 100, 1, 2, 1),(4, 101, 1, 1, 1),(4, 102, 1, 2, 1),(4, 103, 1, 1, 1),(4, 104, 1, 2, 1),(4, 105, 1, 1, 1),(4, 106, 1, 2, 1),(4, 107, 1, 1, 1),(4, 108, 1, 2, 1),(4, 109, 1, 1, 1),(4, 110, 1, 2, 1),(4, 111, 1, 1, 1),(4, 112, 1, 2, 1),(4, 113, 1, 1, 1),(4, 114, 1, 2, 1),(4, 115, 1, 1, 1),(4, 116, 1, 2, 1),(4, 117, 1, 1, 1),(4, 118, 1, 2, 1),(4, 119, 1, 1, 1),(4, 120, 1, 2, 1),(4, 121, 1, 1, 1),(4, 122, 1, 2, 1),(4, 123, 1, 1, 1),(4, 124, 1, 2, 1),(4, 125, 1, 1, 1),(4, 126, 1, 2, 1),(4, 127, 1, 1, 1),(4, 128, 1, 2, 1),(4, 129, 1, 1, 1),(4, 130, 1, 2, 1),(4, 131, 1, 1, 1),(4, 132, 1, 2, 1),(4, 133, 1, 1, 1),(4, 134, 1, 2, 1),(4, 135, 1, 1, 1),(4, 136, 1, 2, 1),(4, 137, 1, 1, 1),(4, 138, 1, 2, 1),(4, 139, 1, 1, 1),(4, 140, 1, 2, 1),(4, 141, 1, 1, 1),(4, 142, 1, 2, 1),(4, 143, 1, 1, 1),(4, 144, 1, 2, 1),(4, 145, 1, 1, 1),(4, 146, 1, 2, 1),(4, 147, 1, 1, 1),(4, 148, 1, 2, 1),(4, 149, 1, 1, 1),(4, 150, 1, 2, 1),(4, 151, 1, 1, 1),(4, 152, 1, 2, 1),(4, 153, 1, 1, 1),(4, 154, 1, 2, 1),(4, 155, 1, 1, 1),(4, 156, 1, 2, 1),(4, 157, 1, 1, 1),(4, 158, 1, 2, 1),(4, 159, 1, 1, 1),(4, 160, 1, 2, 1),(4, 161, 1, 1, 1),(4, 162, 1, 2, 1),(4, 163, 1, 1, 1),(4, 164, 1, 2, 1),(4, 165, 1, 1, 1),(4, 166, 1, 2, 1),(4, 167, 1, 1, 1),(4, 168, 1, 2, 1),(4, 169, 1, 1, 1),(4, 170, 1, 2, 1),(4, 171, 1, 1, 1),(4, 172, 1, 2, 1),(4, 173, 1, 1, 1),(4, 174, 1, 2, 1),(4, 175, 1, 1, 1),(4, 176, 1, 2, 1),(4, 177, 1, 1, 1),(4, 178, 1, 2, 1),(4, 179, 1, 1, 1),(4, 180, 1, 2, 1),(4, 181, 1, 1, 1),(4, 182, 1, 2, 1),(4, 183, 1, 1, 1),(4, 184, 1, 2, 1),(4, 185, 1, 1, 1),(4, 186, 1, 2, 1),(4, 187, 1, 1, 1),(4, 188, 1, 2, 1),(4, 189, 1, 1, 1),(4, 190, 1, 2, 1),(4, 191, 1, 1, 1),(4, 192, 1, 2, 1),(4, 193, 1, 1, 1),(4, 194, 1, 2, 1),(4, 195, 1, 1, 1),(4, 196, 1, 2, 1),(4, 197, 1, 1, 1),(4, 198, 1, 2, 1),(4, 199, 1, 1, 1),(4, 200, 1, 2, 1),(4, 201, 1, 1, 1),(4, 202, 1, 2, 1),(4, 203, 1, 1, 1),(4, 204, 1, 2, 1),(4, 205, 1, 1, 1),(4, 206, 1, 2, 1),(4, 207, 1, 1, 1),(4, 208, 1, 2, 1),(4, 209, 1, 1, 1),(4, 210, 1, 2, 1),(4, 211, 1, 1, 1),(4, 212, 1, 2, 1),(4, 213, 1, 1, 1),(4, 214, 1, 2, 1),(4, 215, 1, 1, 1),(4, 216, 1, 2, 1),(4, 217, 1, 1, 1),(4, 218, 1, 2, 1),(4, 219, 1, 1, 1),(4, 220, 1, 2, 1),(4, 221, 1, 1, 1),(4, 222, 1, 2, 1),(4, 223, 1, 1, 1),(4, 224, 1, 2, 1),(4, 225, 1, 1, 1),(4, 226, 1, 2, 1),(4, 227, 1, 1, 1),(4, 228, 1, 2, 1),(4, 229, 1, 1, 1),(4, 230, 1, 2, 1),(4, 231, 1, 1, 1),(4, 232, 1, 2, 1),(4, 233, 1, 1, 1),(4, 234, 1, 2, 1),(4, 235, 1, 1, 1),(4, 236, 1, 2, 1),(4, 237, 1, 1, 1),(4, 238, 1, 2, 1),(4, 239, 1, 1, 1),(4, 240, 1, 2, 1),(4, 241, 1, 1, 1),(4, 242, 1, 2, 1),(4, 243, 1, 1, 1),(4, 244, 1, 2, 1),(4, 245, 1, 1, 1),(4, 246, 1, 2, 1),(4, 247, 1, 1, 1),(4, 248, 1, 2, 1),(4, 249, 1, 1, 1),(4, 250, 1, 2, 1),(4, 251, 1, 1, 1),(4, 252, 1, 2, 1),(4, 253, 1, 1, 1),(4, 254, 1, 2, 1),(4, 255, 1, 1, 1),(4, 256, 1, 2, 1),(4, 257, 1, 1, 1),(4, 258, 1, 2, 1),(4, 259, 1, 1, 1),(4, 260, 1, 2, 1),(4, 261, 1, 1, 1),(4, 262, 1, 2, 1),(4, 263, 1, 1, 1),(4, 264, 1, 2, 1),(4, 265, 1, 1, 1),(4, 266, 1, 2, 1),(4, 267, 1, 1, 1),(4, 268, 1, 2, 1),(4, 269, 1, 1, 1),(4, 270, 1, 2, 1),(4, 271, 1, 1, 1),(4, 272, 1, 2, 1),(4, 273, 1, 1, 1),(4, 274, 1, 2, 1),(4, 275, 1, 1, 1),(4, 276, 1, 2, 1),(4, 277, 1, 1, 1),(4, 278, 1, 2, 1),(4, 279, 1, 1, 1),(4, 280, 1, 2, 1),(4, 281, 1, 1, 1),(4, 282, 1, 2, 1),(4, 283, 1, 1, 1),(4, 284, 1, 2, 1),(4, 285, 1, 1, 1),(4, 286, 1, 2, 1),(4, 287, 1, 1, 1),(4, 288, 1, 2, 1),(4, 289, 1, 1, 1),(4, 290, 1, 2, 1),(4, 291, 1, 1, 1),(4, 292, 1, 2, 1),(4, 293, 1, 1, 1),(4, 294, 1, 2, 1),(4, 295, 1, 1, 1),(4, 296, 1, 2, 1),(4, 297, 1, 1, 1),(4, 298, 1, 2, 1),(4, 299, 1, 1, 1),(4, 300, 1, 2, 1),(4, 301, 1, 1, 1),(4, 302, 1, 2, 1),(4, 303, 1, 1, 1),(4, 304, 1, 2, 1),(4, 305, 1, 1, 1),(4, 306, 1, 2, 1),(4, 307, 1, 1, 1),(4, 308, 1, 2, 1),(4, 309, 1, 1, 1),(4, 310, 1, 2, 1),(4, 311, 1, 1, 1),(4, 312, 1, 2, 1),(4, 313, 1, 1, 1),(4, 314, 1, 2, 1),(4, 315, 1, 1, 1),(4, 316, 1, 2, 1),(4, 317, 1, 1, 1),(4, 318, 1, 2, 1),(4, 319, 1, 1, 1),(4, 320, 1, 2, 1),(4, 321, 1, 1, 1),(4, 322, 1, 2, 1),(4, 323, 1, 1, 1),(4, 324, 1, 2, 1),(4, 325, 1, 1, 1),(4, 326, 1, 2, 1),(4, 327, 1, 1, 1),(4, 328, 1, 2, 1),(4, 329, 1, 1, 1),(4, 330, 1, 2, 1),(4, 331, 1, 1, 1),(4, 332, 1, 2, 1),(4, 333, 1, 1, 1),(4, 334, 1, 2, 1),(4, 335, 1, 1, 1),(4, 336, 1, 2, 1),(4, 337, 1, 1, 1),(4, 338, 1, 2, 1),(4, 339, 1, 1, 1),(4, 340, 1, 2, 1),(4, 341, 1, 1, 1),(4, 342, 1, 2, 1),(4, 343, 1, 1, 1),(4, 344, 1, 2, 1),(4, 345, 1, 1, 1),(4, 346, 1, 2, 1),(4, 347, 1, 1, 1),(4, 348, 1, 2, 1),(4, 349, 1, 1, 1),(4, 350, 1, 2, 1),(4, 351, 1, 1, 1),(4, 352, 1, 2, 1),(4, 353, 1, 1, 1),(4, 354, 1, 2, 1),(4, 355, 1, 1, 1),(4, 356, 1, 2, 1),(4, 357, 1, 1, 1),(4, 358, 1, 2, 1),(4, 359, 1, 1, 1),(4, 360, 1, 2, 1),(4, 361, 2, 1, 1),(4, 362, 2, 2, 1),(4, 363, 2, 1, 1),(4, 364, 2, 2, 1),(4, 365, 3, 1, 1),(4, 366, 3, 2, 1),(4, 367, 4, 1, 1),(4, 368, 4, 2, 1),(4, 369, 1, 1, 1),(4, 370, 1, 2, 1),(4, 371, 1, 1, 1),(4, 372, 1, 2, 1),(4, 373, 1, 1, 1),(4, 374, 1, 2, 1),(4, 375, 1, 1, 1),(4, 376, 1, 2, 1),(4, 377, 2, 1, 1),(4, 378, 2, 2, 1),(4, 379, 2, 1, 1),(4, 380, 2, 2, 1),(4, 381, 3, 1, 1),(4, 382, 3, 2, 1),(4, 383, 4, 1, 1),(4, 384, 4, 2, 1),(5, 1, 1, 1, 1),(5, 2, 1, 1, 2),(5, 3, 1, 1, 1),(5, 4, 1, 1, 2),(5, 5, 1, 1, 1),(5, 6, 1, 1, 2),(5, 7, 1, 1, 1),(5, 8, 1, 1, 2),(5, 9, 1, 1, 1),(5, 10, 1, 1, 2),(5, 11, 1, 1, 1),(5, 12, 1, 1, 2),(5, 13, 1, 1, 1),(5, 14, 1, 1, 2),(5, 15, 1, 1, 1),(5, 16, 1, 1, 2),(5, 17, 1, 1, 3),(5, 18, 1, 1, 4),(5, 19, 1, 1, 3),(5, 20, 1, 1, 4),(5, 21, 1, 1, 3),(5, 22, 1, 1, 4),(5, 23, 1, 1, 3),(5, 24, 1, 1, 4),(5, 25, 1, 1, 3),(5, 26, 1, 1, 4),(5, 27, 1, 1, 3),(5, 28, 1, 1, 4),(5, 29, 1, 1, 3),(5, 30, 1, 1, 4),(5, 31, 1, 1, 3),(5, 32, 1, 1, 4),(5, 33, 1, 1, 1),(5, 34, 1, 1, 2),(5, 35, 1, 1, 1),(5, 36, 1, 1, 2),(5, 37, 1, 1, 1),(5, 38, 1, 1, 2),(5, 39, 1, 1, 1),(5, 40, 1, 1, 2),(5, 41, 1, 1, 1),(5, 42, 1, 1, 2),(5, 43, 1, 1, 1),(5, 44, 1, 1, 2),(5, 45, 1, 1, 1),(5, 46, 1, 1, 2),(5, 47, 1, 1, 1),(5, 48, 1, 1, 2),(5, 49, 1, 1, 3),(5, 50, 1, 1, 4),(5, 51, 1, 1, 3),(5, 52, 1, 1, 4),(5, 53, 1, 1, 3),(5, 54, 1, 1, 4),(5, 55, 1, 1, 3),(5, 56, 1, 1, 4),(5, 57, 1, 1, 3),(5, 58, 1, 1, 4),(5, 59, 1, 1, 3),(5, 60, 1, 1, 4),(5, 61, 1, 1, 3),(5, 62, 1, 1, 4),(5, 63, 1, 1, 3),(5, 64, 1, 1, 4),(5, 65, 1, 1, 1),(5, 66, 1, 1, 2),(5, 67, 1, 1, 1),(5, 68, 1, 1, 2),(5, 69, 1, 1, 1),(5, 70, 1, 1, 2),(5, 71, 1, 1, 1),(5, 72, 1, 1, 2),(5, 73, 1, 1, 1),(5, 74, 1, 1, 2),(5, 75, 1, 1, 1),(5, 76, 1, 1, 2),(5, 77, 1, 1, 1),(5, 78, 1, 1, 2),(5, 79, 1, 1, 1),(5, 80, 1, 1, 2),(5, 81, 1, 1, 3),(5, 82, 1, 1, 4),(5, 83, 1, 1, 3),(5, 84, 1, 1, 4),(5, 85, 1, 1, 3),(5, 86, 1, 1, 4),(5, 87, 1, 1, 3),(5, 88, 1, 1, 4),(5, 89, 1, 1, 3),(5, 90, 1, 1, 4),(5, 91, 1, 1, 3),(5, 92, 1, 1, 4),(5, 93, 1, 1, 3),(5, 94, 1, 1, 4),(5, 95, 1, 1, 3),(5, 96, 1, 1, 4),(5, 97, 1, 1, 1),(5, 98, 1, 1, 2),(5, 99, 1, 1, 1),(5, 100, 1, 1, 2),(5, 101, 1, 1, 1),(5, 102, 1, 1, 2),(5, 103, 1, 1, 1),(5, 104, 1, 1, 2),(5, 105, 1, 1, 1),(5, 106, 1, 1, 2),(5, 107, 1, 1, 1),(5, 108, 1, 1, 2),(5, 109, 1, 1, 1),(5, 110, 1, 1, 2),(5, 111, 1, 1, 1),(5, 112, 1, 1, 2),(5, 113, 1, 1, 3),(5, 114, 1, 1, 4),(5, 115, 1, 1, 3),(5, 116, 1, 1, 4),(5, 117, 1, 1, 3),(5, 118, 1, 1, 4),(5, 119, 1, 1, 3),(5, 120, 1, 1, 4),(5, 121, 1, 1, 3),(5, 122, 1, 1, 4),(5, 123, 1, 1, 3),(5, 124, 1, 1, 4),(5, 125, 1, 1, 3),(5, 126, 1, 1, 4),(5, 127, 1, 1, 3),(5, 128, 1, 1, 4),(5, 129, 1, 1, 1),(5, 130, 1, 1, 2),(5, 131, 1, 1, 1),(5, 132, 1, 1, 2),(5, 133, 1, 1, 1),(5, 134, 1, 1, 2),(5, 135, 1, 1, 1),(5, 136, 1, 1, 2),(5, 137, 1, 1, 1),(5, 138, 1, 1, 2),(5, 139, 1, 1, 1),(5, 140, 1, 1, 2),(5, 141, 1, 1, 1),(5, 142, 1, 1, 2),(5, 143, 1, 1, 1),(5, 144, 1, 1, 2),(5, 145, 1, 1, 3),(5, 146, 1, 1, 4),(5, 147, 1, 1, 3),(5, 148, 1, 1, 4),(5, 149, 1, 1, 3),(5, 150, 1, 1, 4),(5, 151, 1, 1, 3),(5, 152, 1, 1, 4),(5, 153, 1, 1, 3),(5, 154, 1, 1, 4),(5, 155, 1, 1, 3),(5, 156, 1, 1, 4),(5, 157, 1, 1, 3),(5, 158, 1, 1, 4),(5, 159, 1, 1, 3),(5, 160, 1, 1, 4),(5, 161, 1, 1, 1),(5, 162, 1, 1, 2),(5, 163, 1, 1, 1),(5, 164, 1, 1, 2),(5, 165, 1, 1, 1),(5, 166, 1, 1, 2),(5, 167, 1, 1, 1),(5, 168, 1, 1, 2),(5, 169, 1, 1, 1),(5, 170, 1, 1, 2),(5, 171, 1, 1, 1),(5, 172, 1, 1, 2),(5, 173, 1, 1, 1),(5, 174, 1, 1, 2),(5, 175, 1, 1, 1),(5, 176, 1, 1, 2),(5, 177, 1, 1, 3),(5, 178, 1, 1, 4),(5, 179, 1, 1, 3),(5, 180, 1, 1, 4),(5, 181, 1, 1, 3),(5, 182, 1, 1, 4),(5, 183, 1, 1, 3),(5, 184, 1, 1, 4),(5, 185, 1, 1, 3),(5, 186, 1, 1, 4),(5, 187, 1, 1, 3),(5, 188, 1, 1, 4),(5, 189, 1, 1, 3),(5, 190, 1, 1, 4),(5, 191, 1, 1, 3),(5, 192, 1, 1, 4),(5, 193, 1, 1, 1),(5, 194, 1, 1, 2),(5, 195, 1, 1, 1),(5, 196, 1, 1, 2),(5, 197, 1, 1, 1),(5, 198, 1, 1, 2),(5, 199, 1, 1, 1),(5, 200, 1, 1, 2),(5, 201, 1, 1, 1),(5, 202, 1, 1, 2),(5, 203, 1, 1, 1),(5, 204, 1, 1, 2),(5, 205, 1, 1, 1),(5, 206, 1, 1, 2),(5, 207, 1, 1, 1),(5, 208, 1, 1, 2),(5, 209, 1, 1, 3),(5, 210, 1, 1, 4),(5, 211, 1, 1, 3),(5, 212, 1, 1, 4),(5, 213, 1, 1, 3),(5, 214, 1, 1, 4),(5, 215, 1, 1, 3),(5, 216, 1, 1, 4),(5, 217, 1, 1, 3),(5, 218, 1, 1, 4),(5, 219, 1, 1, 3),(5, 220, 1, 1, 4),(5, 221, 1, 1, 3),(5, 222, 1, 1, 4),(5, 223, 1, 1, 3),(5, 224, 1, 1, 4),(5, 225, 1, 1, 1),(5, 226, 1, 1, 2),(5, 227, 1, 1, 1),(5, 228, 1, 1, 2),(5, 229, 1, 1, 1),(5, 230, 1, 1, 2),(5, 231, 1, 1, 1),(5, 232, 1, 1, 2),(5, 233, 1, 1, 1),(5, 234, 1, 1, 2),(5, 235, 1, 1, 1),(5, 236, 1, 1, 2),(5, 237, 1, 1, 1),(5, 238, 1, 1, 2),(5, 239, 1, 1, 1),(5, 240, 1, 1, 2),(5, 241, 1, 1, 3),(5, 242, 1, 1, 4),(5, 243, 1, 1, 3),(5, 244, 1, 1, 4),(5, 245, 1, 1, 3),(5, 246, 1, 1, 4),(5, 247, 1, 1, 3),(5, 248, 1, 1, 4),(5, 249, 1, 1, 3),(5, 250, 1, 1, 4),(5, 251, 1, 1, 3),(5, 252, 1, 1, 4),(5, 253, 1, 1, 3),(5, 254, 1, 1, 4),(5, 255, 1, 1, 3),(5, 256, 1, 1, 4),(5, 257, 1, 1, 1),(5, 258, 1, 1, 2),(5, 259, 1, 1, 1),(5, 260, 1, 1, 2),(5, 261, 1, 1, 1),(5, 262, 1, 1, 2),(5, 263, 1, 1, 1),(5, 264, 1, 1, 2),(5, 265, 1, 1, 1),(5, 266, 1, 1, 2),(5, 267, 1, 1, 1),(5, 268, 1, 1, 2),(5, 269, 1, 1, 1),(5, 270, 1, 1, 2),(5, 271, 1, 1, 1),(5, 272, 1, 1, 2),(5, 273, 1, 1, 3),(5, 274, 1, 1, 4),(5, 275, 1, 1, 3),(5, 276, 1, 1, 4),(5, 277, 1, 1, 3),(5, 278, 1, 1, 4),(5, 279, 1, 1, 3),(5, 280, 1, 1, 4),(5, 281, 1, 1, 3),(5, 282, 1, 1, 4),(5, 283, 1, 1, 3),(5, 284, 1, 1, 4),(5, 285, 1, 1, 3),(5, 286, 1, 1, 4),(5, 287, 1, 1, 3),(5, 288, 1, 1, 4),(5, 289, 1, 1, 1),(5, 290, 1, 1, 2),(5, 291, 1, 1, 1),(5, 292, 1, 1, 2),(5, 293, 1, 1, 1),(5, 294, 1, 1, 2),(5, 295, 1, 1, 1),(5, 296, 1, 1, 2),(5, 297, 1, 1, 1),(5, 298, 1, 1, 2),(5, 299, 1, 1, 1),(5, 300, 1, 1, 2),(5, 301, 1, 1, 1),(5, 302, 1, 1, 2),(5, 303, 1, 1, 1),(5, 304, 1, 1, 2),(5, 305, 1, 1, 3),(5, 306, 1, 1, 4),(5, 307, 1, 1, 3),(5, 308, 1, 1, 4),(5, 309, 1, 1, 3),(5, 310, 1, 1, 4),(5, 311, 1, 1, 3),(5, 312, 1, 1, 4),(5, 313, 1, 1, 3),(5, 314, 1, 1, 4),(5, 315, 1, 1, 3),(5, 316, 1, 1, 4),(5, 317, 1, 1, 3),(5, 318, 1, 1, 4),(5, 319, 1, 1, 3),(5, 320, 1, 1, 4),(5, 321, 1, 1, 1),(5, 322, 1, 1, 2),(5, 323, 1, 1, 1),(5, 324, 1, 1, 2),(5, 325, 1, 1, 1),(5, 326, 1, 1, 2),(5, 327, 1, 1, 1),(5, 328, 1, 1, 2),(5, 329, 1, 1, 1),(5, 330, 1, 1, 2),(5, 331, 1, 1, 1),(5, 332, 1, 1, 2),(5, 333, 1, 1, 1),(5, 334, 1, 1, 2),(5, 335, 1, 1, 1),(5, 336, 1, 1, 2),(5, 337, 1, 1, 3),(5, 338, 1, 1, 4),(5, 339, 1, 1, 3),(5, 340, 1, 1, 4),(5, 341, 1, 1, 3),(5, 342, 1, 1, 4),(5, 343, 1, 1, 3),(5, 344, 1, 1, 4),(5, 345, 1, 1, 3),(5, 346, 1, 1, 4),(5, 347, 1, 1, 3),(5, 348, 1, 1, 4),(5, 349, 1, 1, 3),(5, 350, 1, 1, 4),(5, 351, 1, 1, 3),(5, 352, 1, 1, 4),(5, 353, 1, 1, 1),(5, 354, 1, 1, 2),(5, 355, 1, 1, 1),(5, 356, 1, 1, 2),(5, 357, 1, 1, 1),(5, 358, 1, 1, 2),(5, 359, 1, 1, 1),(5, 360, 1, 1, 2),(5, 361, 2, 1, 1),(5, 362, 2, 1, 2),(5, 363, 2, 1, 1),(5, 364, 2, 1, 2),(5, 365, 3, 1, 1),(5, 366, 3, 1, 2),(5, 367, 4, 1, 1),(5, 368, 4, 1, 2),(5, 369, 1, 1, 3),(5, 370, 1, 1, 4),(5, 371, 1, 1, 3),(5, 372, 1, 1, 4),(5, 373, 1, 1, 3),(5, 374, 1, 1, 4),(5, 375, 1, 1, 3),(5, 376, 1, 1, 4),(5, 377, 2, 1, 3),(5, 378, 2, 1, 4),(5, 379, 2, 1, 3),(5, 380, 2, 1, 4),(5, 381, 3, 1, 3),(5, 382, 3, 1, 4),(5, 383, 4, 1, 3),(5, 384, 4, 1, 4),(6, 1, 1, 1, 1),(6, 2, 1, 1, 1),(6, 3, 1, 1, 1),(6, 4, 1, 1, 1),(6, 5, 1, 1, 1),(6, 6, 1, 1, 1),(6, 7, 1, 1, 1),(6, 8, 1, 1, 1),(6, 9, 1, 1, 1),(6, 10, 1, 1, 1),(6, 11, 1, 1, 1),(6, 12, 1, 1, 1),(6, 13, 1, 1, 1),(6, 14, 1, 1, 1),(6, 15, 1, 1, 1),(6, 16, 1, 1, 1),(6, 17, 1, 1, 2),(6, 18, 1, 1, 2),(6, 19, 1, 1, 2),(6, 20, 1, 1, 2),(6, 21, 1, 1, 2),(6, 22, 1, 1, 2),(6, 23, 1, 1, 2),(6, 24, 1, 1, 2),(6, 25, 1, 1, 2),(6, 26, 1, 1, 2),(6, 27, 1, 1, 2),(6, 28, 1, 1, 2),(6, 29, 1, 1, 2),(6, 30, 1, 1, 2),(6, 31, 1, 1, 2),(6, 32, 1, 1, 2),(6, 33, 1, 1, 1),(6, 34, 1, 1, 1),(6, 35, 1, 1, 1),(6, 36, 1, 1, 1),(6, 37, 1, 1, 1),(6, 38, 1, 1, 1),(6, 39, 1, 1, 1),(6, 40, 1, 1, 1),(6, 41, 1, 1, 1),(6, 42, 1, 1, 1),(6, 43, 1, 1, 1),(6, 44, 1, 1, 1),(6, 45, 1, 1, 1),(6, 46, 1, 1, 1),(6, 47, 1, 1, 1),(6, 48, 1, 1, 1),(6, 49, 1, 1, 2),(6, 50, 1, 1, 2),(6, 51, 1, 1, 2),(6, 52, 1, 1, 2),(6, 53, 1, 1, 2),(6, 54, 1, 1, 2),(6, 55, 1, 1, 2),(6, 56, 1, 1, 2),(6, 57, 1, 1, 2),(6, 58, 1, 1, 2),(6, 59, 1, 1, 2),(6, 60, 1, 1, 2),(6, 61, 1, 1, 2),(6, 62, 1, 1, 2),(6, 63, 1, 1, 2),(6, 64, 1, 1, 2),(6, 65, 1, 1, 1),(6, 66, 1, 1, 1),(6, 67, 1, 1, 1),(6, 68, 1, 1, 1),(6, 69, 1, 1, 1),(6, 70, 1, 1, 1),(6, 71, 1, 1, 1),(6, 72, 1, 1, 1),(6, 73, 1, 1, 1),(6, 74, 1, 1, 1),(6, 75, 1, 1, 1),(6, 76, 1, 1, 1),(6, 77, 1, 1, 1),(6, 78, 1, 1, 1),(6, 79, 1, 1, 1),(6, 80, 1, 1, 1),(6, 81, 1, 1, 2),(6, 82, 1, 1, 2),(6, 83, 1, 1, 2),(6, 84, 1, 1, 2),(6, 85, 1, 1, 2),(6, 86, 1, 1, 2),(6, 87, 1, 1, 2),(6, 88, 1, 1, 2),(6, 89, 1, 1, 2),(6, 90, 1, 1, 2),(6, 91, 1, 1, 2),(6, 92, 1, 1, 2),(6, 93, 1, 1, 2),(6, 94, 1, 1, 2),(6, 95, 1, 1, 2),(6, 96, 1, 1, 2),(6, 97, 1, 1, 1),(6, 98, 1, 1, 1),(6, 99, 1, 1, 1),(6, 100, 1, 1, 1),(6, 101, 1, 1, 1),(6, 102, 1, 1, 1),(6, 103, 1, 1, 1),(6, 104, 1, 1, 1),(6, 105, 1, 1, 1),(6, 106, 1, 1, 1),(6, 107, 1, 1, 1),(6, 108, 1, 1, 1),(6, 109, 1, 1, 1),(6, 110, 1, 1, 1),(6, 111, 1, 1, 1),(6, 112, 1, 1, 1),(6, 113, 1, 1, 2),(6, 114, 1, 1, 2),(6, 115, 1, 1, 2),(6, 116, 1, 1, 2),(6, 117, 1, 1, 2),(6, 118, 1, 1, 2),(6, 119, 1, 1, 2),(6, 120, 1, 1, 2),(6, 121, 1, 1, 2),(6, 122, 1, 1, 2),(6, 123, 1, 1, 2),(6, 124, 1, 1, 2),(6, 125, 1, 1, 2),(6, 126, 1, 1, 2),(6, 127, 1, 1, 2),(6, 128, 1, 1, 2),(6, 129, 1, 1, 1),(6, 130, 1, 1, 1),(6, 131, 1, 1, 1),(6, 132, 1, 1, 1),(6, 133, 1, 1, 1),(6, 134, 1, 1, 1),(6, 135, 1, 1, 1),(6, 136, 1, 1, 1),(6, 137, 1, 1, 1),(6, 138, 1, 1, 1),(6, 139, 1, 1, 1),(6, 140, 1, 1, 1),(6, 141, 1, 1, 1),(6, 142, 1, 1, 1),(6, 143, 1, 1, 1),(6, 144, 1, 1, 1),(6, 145, 1, 1, 2),(6, 146, 1, 1, 2),(6, 147, 1, 1, 2),(6, 148, 1, 1, 2),(6, 149, 1, 1, 2),(6, 150, 1, 1, 2),(6, 151, 1, 1, 2),(6, 152, 1, 1, 2),(6, 153, 1, 1, 2),(6, 154, 1, 1, 2),(6, 155, 1, 1, 2),(6, 156, 1, 1, 2),(6, 157, 1, 1, 2),(6, 158, 1, 1, 2),(6, 159, 1, 1, 2),(6, 160, 1, 1, 2),(6, 161, 1, 1, 1),(6, 162, 1, 1, 1),(6, 163, 1, 1, 1),(6, 164, 1, 1, 1),(6, 165, 1, 1, 1),(6, 166, 1, 1, 1),(6, 167, 1, 1, 1),(6, 168, 1, 1, 1),(6, 169, 1, 1, 1),(6, 170, 1, 1, 1),(6, 171, 1, 1, 1),(6, 172, 1, 1, 1),(6, 173, 1, 1, 1),(6, 174, 1, 1, 1),(6, 175, 1, 1, 1),(6, 176, 1, 1, 1),(6, 177, 1, 1, 2),(6, 178, 1, 1, 2),(6, 179, 1, 1, 2),(6, 180, 1, 1, 2),(6, 181, 1, 1, 2),(6, 182, 1, 1, 2),(6, 183, 1, 1, 2),(6, 184, 1, 1, 2),(6, 185, 1, 1, 2),(6, 186, 1, 1, 2),(6, 187, 1, 1, 2),(6, 188, 1, 1, 2),(6, 189, 1, 1, 2),(6, 190, 1, 1, 2),(6, 191, 1, 1, 2),(6, 192, 1, 1, 2),(6, 193, 1, 1, 1),(6, 194, 1, 1, 1),(6, 195, 1, 1, 1),(6, 196, 1, 1, 1),(6, 197, 1, 1, 1),(6, 198, 1, 1, 1),(6, 199, 1, 1, 1),(6, 200, 1, 1, 1),(6, 201, 1, 1, 1),(6, 202, 1, 1, 1),(6, 203, 1, 1, 1),(6, 204, 1, 1, 1),(6, 205, 1, 1, 1),(6, 206, 1, 1, 1),(6, 207, 1, 1, 1),(6, 208, 1, 1, 1),(6, 209, 1, 1, 2),(6, 210, 1, 1, 2),(6, 211, 1, 1, 2),(6, 212, 1, 1, 2),(6, 213, 1, 1, 2),(6, 214, 1, 1, 2),(6, 215, 1, 1, 2),(6, 216, 1, 1, 2),(6, 217, 1, 1, 2),(6, 218, 1, 1, 2),(6, 219, 1, 1, 2),(6, 220, 1, 1, 2),(6, 221, 1, 1, 2),(6, 222, 1, 1, 2),(6, 223, 1, 1, 2),(6, 224, 1, 1, 2),(6, 225, 1, 1, 1),(6, 226, 1, 1, 1),(6, 227, 1, 1, 1),(6, 228, 1, 1, 1),(6, 229, 1, 1, 1),(6, 230, 1, 1, 1),(6, 231, 1, 1, 1),(6, 232, 1, 1, 1),(6, 233, 1, 1, 1),(6, 234, 1, 1, 1),(6, 235, 1, 1, 1),(6, 236, 1, 1, 1),(6, 237, 1, 1, 1),(6, 238, 1, 1, 1),(6, 239, 1, 1, 1),(6, 240, 1, 1, 1),(6, 241, 1, 1, 2),(6, 242, 1, 1, 2),(6, 243, 1, 1, 2),(6, 244, 1, 1, 2),(6, 245, 1, 1, 2),(6, 246, 1, 1, 2),(6, 247, 1, 1, 2),(6, 248, 1, 1, 2),(6, 249, 1, 1, 2),(6, 250, 1, 1, 2),(6, 251, 1, 1, 2),(6, 252, 1, 1, 2),(6, 253, 1, 1, 2),(6, 254, 1, 1, 2),(6, 255, 1, 1, 2),(6, 256, 1, 1, 2),(6, 257, 1, 1, 1),(6, 258, 1, 1, 1),(6, 259, 1, 1, 1),(6, 260, 1, 1, 1),(6, 261, 1, 1, 1),(6, 262, 1, 1, 1),(6, 263, 1, 1, 1),(6, 264, 1, 1, 1),(6, 265, 1, 1, 1),(6, 266, 1, 1, 1),(6, 267, 1, 1, 1),(6, 268, 1, 1, 1),(6, 269, 1, 1, 1),(6, 270, 1, 1, 1),(6, 271, 1, 1, 1),(6, 272, 1, 1, 1),(6, 273, 1, 1, 2),(6, 274, 1, 1, 2),(6, 275, 1, 1, 2),(6, 276, 1, 1, 2),(6, 277, 1, 1, 2),(6, 278, 1, 1, 2),(6, 279, 1, 1, 2),(6, 280, 1, 1, 2),(6, 281, 1, 1, 2),(6, 282, 1, 1, 2),(6, 283, 1, 1, 2),(6, 284, 1, 1, 2),(6, 285, 1, 1, 2),(6, 286, 1, 1, 2),(6, 287, 1, 1, 2),(6, 288, 1, 1, 2),(6, 289, 1, 1, 1),(6, 290, 1, 1, 1),(6, 291, 1, 1, 1),(6, 292, 1, 1, 1),(6, 293, 1, 1, 1),(6, 294, 1, 1, 1),(6, 295, 1, 1, 1),(6, 296, 1, 1, 1),(6, 297, 1, 1, 1),(6, 298, 1, 1, 1),(6, 299, 1, 1, 1),(6, 300, 1, 1, 1),(6, 301, 1, 1, 1),(6, 302, 1, 1, 1),(6, 303, 1, 1, 1),(6, 304, 1, 1, 1),(6, 305, 1, 1, 2),(6, 306, 1, 1, 2),(6, 307, 1, 1, 2),(6, 308, 1, 1, 2),(6, 309, 1, 1, 2),(6, 310, 1, 1, 2),(6, 311, 1, 1, 2),(6, 312, 1, 1, 2),(6, 313, 1, 1, 2),(6, 314, 1, 1, 2),(6, 315, 1, 1, 2),(6, 316, 1, 1, 2),(6, 317, 1, 1, 2),(6, 318, 1, 1, 2),(6, 319, 1, 1, 2),(6, 320, 1, 1, 2),(6, 321, 1, 1, 1),(6, 322, 1, 1, 1),(6, 323, 1, 1, 1),(6, 324, 1, 1, 1),(6, 325, 1, 1, 1),(6, 326, 1, 1, 1),(6, 327, 1, 1, 1),(6, 328, 1, 1, 1),(6, 329, 1, 1, 1),(6, 330, 1, 1, 1),(6, 331, 1, 1, 1),(6, 332, 1, 1, 1),(6, 333, 1, 1, 1),(6, 334, 1, 1, 1),(6, 335, 1, 1, 1),(6, 336, 1, 1, 1),(6, 337, 1, 1, 2),(6, 338, 1, 1, 2),(6, 339, 1, 1, 2),(6, 340, 1, 1, 2),(6, 341, 1, 1, 2),(6, 342, 1, 1, 2),(6, 343, 1, 1, 2),(6, 344, 1, 1, 2),(6, 345, 1, 1, 2),(6, 346, 1, 1, 2),(6, 347, 1, 1, 2),(6, 348, 1, 1, 2),(6, 349, 1, 1, 2),(6, 350, 1, 1, 2),(6, 351, 1, 1, 2),(6, 352, 1, 1, 2),(6, 353, 1, 1, 1),(6, 354, 1, 1, 1),(6, 355, 1, 1, 1),(6, 356, 1, 1, 1),(6, 357, 1, 1, 1),(6, 358, 1, 1, 1),(6, 359, 1, 1, 1),(6, 360, 1, 1, 1),(6, 361, 2, 1, 1),(6, 362, 2, 1, 1),(6, 363, 2, 1, 1),(6, 364, 2, 1, 1),(6, 365, 3, 1, 1),(6, 366, 3, 1, 1),(6, 367, 4, 1, 1),(6, 368, 4, 1, 1),(6, 369, 1, 1, 2),(6, 370, 1, 1, 2),(6, 371, 1, 1, 2),(6, 372, 1, 1, 2),(6, 373, 1, 1, 2),(6, 374, 1, 1, 2),(6, 375, 1, 1, 2),(6, 376, 1, 1, 2),(6, 377, 2, 1, 2),(6, 378, 2, 1, 2),(6, 379, 2, 1, 2),(6, 380, 2, 1, 2),(6, 381, 3, 1, 2),(6, 382, 3, 1, 2),(6, 383, 4, 1, 2),(6, 384, 4, 1, 2),(7, 1, 1, 1, 1),(7, 2, 1, 1, 1),(7, 3, 1, 1, 1),(7, 4, 1, 1, 1),(7, 5, 1, 1, 1),(7, 6, 1, 1, 1),(7, 7, 1, 1, 1),(7, 8, 1, 1, 1),(7, 9, 1, 1, 1),(7, 10, 1, 1, 1),(7, 11, 1, 1, 1),(7, 12, 1, 1, 1),(7, 13, 1, 1, 1),(7, 14, 1, 1, 1),(7, 15, 1, 1, 1),(7, 16, 1, 1, 1),(7, 17, 1, 1, 1),(7, 18, 1, 1, 1),(7, 19, 1, 1, 1),(7, 20, 1, 1, 1),(7, 21, 1, 1, 1),(7, 22, 1, 1, 1),(7, 23, 1, 1, 1),(7, 24, 1, 1, 1),(7, 25, 1, 1, 1),(7, 26, 1, 1, 1),(7, 27, 1, 1, 1),(7, 28, 1, 1, 1),(7, 29, 1, 1, 1),(7, 30, 1, 1, 1),(7, 31, 1, 1, 1),(7, 32, 1, 1, 1),(7, 33, 1, 1, 1),(7, 34, 1, 1, 1),(7, 35, 1, 1, 1),(7, 36, 1, 1, 1),(7, 37, 1, 1, 1),(7, 38, 1, 1, 1),(7, 39, 1, 1, 1),(7, 40, 1, 1, 1),(7, 41, 1, 1, 1),(7, 42, 1, 1, 1),(7, 43, 1, 1, 1),(7, 44, 1, 1, 1),(7, 45, 1, 1, 1),(7, 46, 1, 1, 1),(7, 47, 1, 1, 1),(7, 48, 1, 1, 1),(7, 49, 1, 1, 1),(7, 50, 1, 1, 1),(7, 51, 1, 1, 1),(7, 52, 1, 1, 1),(7, 53, 1, 1, 1),(7, 54, 1, 1, 1),(7, 55, 1, 1, 1),(7, 56, 1, 1, 1),(7, 57, 1, 1, 1),(7, 58, 1, 1, 1),(7, 59, 1, 1, 1),(7, 60, 1, 1, 1),(7, 61, 1, 1, 1),(7, 62, 1, 1, 1),(7, 63, 1, 1, 1),(7, 64, 1, 1, 1),(7, 65, 1, 1, 1),(7, 66, 1, 1, 1),(7, 67, 1, 1, 1),(7, 68, 1, 1, 1),(7, 69, 1, 1, 1),(7, 70, 1, 1, 1),(7, 71, 1, 1, 1),(7, 72, 1, 1, 1),(7, 73, 1, 1, 1),(7, 74, 1, 1, 1),(7, 75, 1, 1, 1),(7, 76, 1, 1, 1),(7, 77, 1, 1, 1),(7, 78, 1, 1, 1),(7, 79, 1, 1, 1),(7, 80, 1, 1, 1),(7, 81, 1, 1, 1),(7, 82, 1, 1, 1),(7, 83, 1, 1, 1),(7, 84, 1, 1, 1),(7, 85, 1, 1, 1),(7, 86, 1, 1, 1),(7, 87, 1, 1, 1),(7, 88, 1, 1, 1),(7, 89, 2, 1, 1),(7, 90, 2, 1, 1),(7, 91, 2, 1, 1),(7, 92, 2, 1, 1),(7, 93, 3, 1, 1),(7, 94, 3, 1, 1),(7, 95, 4, 1, 1),(7, 96, 4, 1, 1),(8, 1, 1, 1, 1),(8, 2, 1, 3, 1),(8, 3, 1, 1, 1),(8, 4, 1, 3, 1),(8, 5, 1, 1, 1),(8, 6, 1, 3, 1),(8, 7, 1, 1, 1),(8, 8, 1, 3, 1),(8, 9, 1, 1, 1),(8, 10, 1, 3, 1),(8, 11, 1, 1, 1),(8, 12, 1, 3, 1),(8, 13, 1, 1, 1),(8, 14, 1, 3, 1),(8, 15, 1, 1, 1),(8, 16, 1, 3, 1),(8, 17, 1, 2, 1),(8, 18, 1, 4, 1),(8, 19, 1, 2, 1),(8, 20, 1, 4, 1),(8, 21, 1, 2, 1),(8, 22, 1, 4, 1),(8, 23, 1, 2, 1),(8, 24, 1, 4, 1),(8, 25, 1, 2, 1),(8, 26, 1, 4, 1),(8, 27, 1, 2, 1),(8, 28, 1, 4, 1),(8, 29, 1, 2, 1),(8, 30, 1, 4, 1),(8, 31, 1, 2, 1),(8, 32, 1, 4, 1),(8, 33, 1, 1, 1),(8, 34, 1, 3, 1),(8, 35, 1, 1, 1),(8, 36, 1, 3, 1),(8, 37, 1, 1, 1),(8, 38, 1, 3, 1),(8, 39, 1, 1, 1),(8, 40, 1, 3, 1),(8, 41, 1, 1, 1),(8, 42, 1, 3, 1),(8, 43, 1, 1, 1),(8, 44, 1, 3, 1),(8, 45, 1, 1, 1),(8, 46, 1, 3, 1),(8, 47, 1, 1, 1),(8, 48, 1, 3, 1),(8, 49, 1, 2, 1),(8, 50, 1, 4, 1),(8, 51, 1, 2, 1),(8, 52, 1, 4, 1),(8, 53, 1, 2, 1),(8, 54, 1, 4, 1),(8, 55, 1, 2, 1),(8, 56, 1, 4, 1),(8, 57, 1, 2, 1),(8, 58, 1, 4, 1),(8, 59, 1, 2, 1),(8, 60, 1, 4, 1),(8, 61, 1, 2, 1),(8, 62, 1, 4, 1),(8, 63, 1, 2, 1),(8, 64, 1, 4, 1),(8, 65, 1, 1, 1),(8, 66, 1, 3, 1),(8, 67, 1, 1, 1),(8, 68, 1, 3, 1),(8, 69, 1, 1, 1),(8, 70, 1, 3, 1),(8, 71, 1, 1, 1),(8, 72, 1, 3, 1),(8, 73, 1, 1, 1),(8, 74, 1, 3, 1),(8, 75, 1, 1, 1),(8, 76, 1, 3, 1),(8, 77, 1, 1, 1),(8, 78, 1, 3, 1),(8, 79, 1, 1, 1),(8, 80, 1, 3, 1),(8, 81, 1, 2, 1),(8, 82, 1, 4, 1),(8, 83, 1, 2, 1),(8, 84, 1, 4, 1),(8, 85, 1, 2, 1),(8, 86, 1, 4, 1),(8, 87, 1, 2, 1),(8, 88, 1, 4, 1),(8, 89, 1, 2, 1),(8, 90, 1, 4, 1),(8, 91, 1, 2, 1),(8, 92, 1, 4, 1),(8, 93, 1, 2, 1),(8, 94, 1, 4, 1),(8, 95, 1, 2, 1),(8, 96, 1, 4, 1),(8, 97, 1, 1, 1),(8, 98, 1, 3, 1),(8, 99, 1, 1, 1),(8, 100, 1, 3, 1),(8, 101, 1, 1, 1),(8, 102, 1, 3, 1),(8, 103, 1, 1, 1),(8, 104, 1, 3, 1),(8, 105, 1, 1, 1),(8, 106, 1, 3, 1),(8, 107, 1, 1, 1),(8, 108, 1, 3, 1),(8, 109, 1, 1, 1),(8, 110, 1, 3, 1),(8, 111, 1, 1, 1),(8, 112, 1, 3, 1),(8, 113, 1, 2, 1),(8, 114, 1, 4, 1),(8, 115, 1, 2, 1),(8, 116, 1, 4, 1),(8, 117, 1, 2, 1),(8, 118, 1, 4, 1),(8, 119, 1, 2, 1),(8, 120, 1, 4, 1),(8, 121, 1, 2, 1),(8, 122, 1, 4, 1),(8, 123, 1, 2, 1),(8, 124, 1, 4, 1),(8, 125, 1, 2, 1),(8, 126, 1, 4, 1),(8, 127, 1, 2, 1),(8, 128, 1, 4, 1),(8, 129, 1, 1, 1),(8, 130, 1, 3, 1),(8, 131, 1, 1, 1),(8, 132, 1, 3, 1),(8, 133, 1, 1, 1),(8, 134, 1, 3, 1),(8, 135, 1, 1, 1),(8, 136, 1, 3, 1),(8, 137, 1, 1, 1),(8, 138, 1, 3, 1),(8, 139, 1, 1, 1),(8, 140, 1, 3, 1),(8, 141, 1, 1, 1),(8, 142, 1, 3, 1),(8, 143, 1, 1, 1),(8, 144, 1, 3, 1),(8, 145, 1, 2, 1),(8, 146, 1, 4, 1),(8, 147, 1, 2, 1),(8, 148, 1, 4, 1),(8, 149, 1, 2, 1),(8, 150, 1, 4, 1),(8, 151, 1, 2, 1),(8, 152, 1, 4, 1),(8, 153, 1, 2, 1),(8, 154, 1, 4, 1),(8, 155, 1, 2, 1),(8, 156, 1, 4, 1),(8, 157, 1, 2, 1),(8, 158, 1, 4, 1),(8, 159, 1, 2, 1),(8, 160, 1, 4, 1),(8, 161, 1, 1, 1),(8, 162, 1, 3, 1),(8, 163, 1, 1, 1),(8, 164, 1, 3, 1),(8, 165, 1, 1, 1),(8, 166, 1, 3, 1),(8, 167, 1, 1, 1),(8, 168, 1, 3, 1),(8, 169, 1, 1, 1),(8, 170, 1, 3, 1),(8, 171, 1, 1, 1),(8, 172, 1, 3, 1),(8, 173, 1, 1, 1),(8, 174, 1, 3, 1),(8, 175, 1, 1, 1),(8, 176, 1, 3, 1),(8, 177, 1, 2, 1),(8, 178, 1, 4, 1),(8, 179, 1, 2, 1),(8, 180, 1, 4, 1),(8, 181, 1, 2, 1),(8, 182, 1, 4, 1),(8, 183, 1, 2, 1),(8, 184, 1, 4, 1),(8, 185, 1, 2, 1),(8, 186, 1, 4, 1),(8, 187, 1, 2, 1),(8, 188, 1, 4, 1),(8, 189, 1, 2, 1),(8, 190, 1, 4, 1),(8, 191, 1, 2, 1),(8, 192, 1, 4, 1),(8, 193, 1, 1, 1),(8, 194, 1, 3, 1),(8, 195, 1, 1, 1),(8, 196, 1, 3, 1),(8, 197, 1, 1, 1),(8, 198, 1, 3, 1),(8, 199, 1, 1, 1),(8, 200, 1, 3, 1),(8, 201, 1, 1, 1),(8, 202, 1, 3, 1),(8, 203, 1, 1, 1),(8, 204, 1, 3, 1),(8, 205, 1, 1, 1),(8, 206, 1, 3, 1),(8, 207, 1, 1, 1),(8, 208, 1, 3, 1),(8, 209, 1, 2, 1),(8, 210, 1, 4, 1),(8, 211, 1, 2, 1),(8, 212, 1, 4, 1),(8, 213, 1, 2, 1),(8, 214, 1, 4, 1),(8, 215, 1, 2, 1),(8, 216, 1, 4, 1),(8, 217, 1, 2, 1),(8, 218, 1, 4, 1),(8, 219, 1, 2, 1),(8, 220, 1, 4, 1),(8, 221, 1, 2, 1),(8, 222, 1, 4, 1),(8, 223, 1, 2, 1),(8, 224, 1, 4, 1),(8, 225, 1, 1, 1),(8, 226, 1, 3, 1),(8, 227, 1, 1, 1),(8, 228, 1, 3, 1),(8, 229, 1, 1, 1),(8, 230, 1, 3, 1),(8, 231, 1, 1, 1),(8, 232, 1, 3, 1),(8, 233, 1, 1, 1),(8, 234, 1, 3, 1),(8, 235, 1, 1, 1),(8, 236, 1, 3, 1),(8, 237, 1, 1, 1),(8, 238, 1, 3, 1),(8, 239, 1, 1, 1),(8, 240, 1, 3, 1),(8, 241, 1, 2, 1),(8, 242, 1, 4, 1),(8, 243, 1, 2, 1),(8, 244, 1, 4, 1),(8, 245, 1, 2, 1),(8, 246, 1, 4, 1),(8, 247, 1, 2, 1),(8, 248, 1, 4, 1),(8, 249, 1, 2, 1),(8, 250, 1, 4, 1),(8, 251, 1, 2, 1),(8, 252, 1, 4, 1),(8, 253, 1, 2, 1),(8, 254, 1, 4, 1),(8, 255, 1, 2, 1),(8, 256, 1, 4, 1),(8, 257, 1, 1, 1),(8, 258, 1, 3, 1),(8, 259, 1, 1, 1),(8, 260, 1, 3, 1),(8, 261, 1, 1, 1),(8, 262, 1, 3, 1),(8, 263, 1, 1, 1),(8, 264, 1, 3, 1),(8, 265, 1, 1, 1),(8, 266, 1, 3, 1),(8, 267, 1, 1, 1),(8, 268, 1, 3, 1),(8, 269, 1, 1, 1),(8, 270, 1, 3, 1),(8, 271, 1, 1, 1),(8, 272, 1, 3, 1),(8, 273, 1, 2, 1),(8, 274, 1, 4, 1),(8, 275, 1, 2, 1),(8, 276, 1, 4, 1),(8, 277, 1, 2, 1),(8, 278, 1, 4, 1),(8, 279, 1, 2, 1),(8, 280, 1, 4, 1),(8, 281, 1, 2, 1),(8, 282, 1, 4, 1),(8, 283, 1, 2, 1),(8, 284, 1, 4, 1),(8, 285, 1, 2, 1),(8, 286, 1, 4, 1),(8, 287, 1, 2, 1),(8, 288, 1, 4, 1),(8, 289, 1, 1, 1),(8, 290, 1, 3, 1),(8, 291, 1, 1, 1),(8, 292, 1, 3, 1),(8, 293, 1, 1, 1),(8, 294, 1, 3, 1),(8, 295, 1, 1, 1),(8, 296, 1, 3, 1),(8, 297, 1, 1, 1),(8, 298, 1, 3, 1),(8, 299, 1, 1, 1),(8, 300, 1, 3, 1),(8, 301, 1, 1, 1),(8, 302, 1, 3, 1),(8, 303, 1, 1, 1),(8, 304, 1, 3, 1),(8, 305, 1, 2, 1),(8, 306, 1, 4, 1),(8, 307, 1, 2, 1),(8, 308, 1, 4, 1),(8, 309, 1, 2, 1),(8, 310, 1, 4, 1),(8, 311, 1, 2, 1),(8, 312, 1, 4, 1),(8, 313, 1, 2, 1),(8, 314, 1, 4, 1),(8, 315, 1, 2, 1),(8, 316, 1, 4, 1),(8, 317, 1, 2, 1),(8, 318, 1, 4, 1),(8, 319, 1, 2, 1),(8, 320, 1, 4, 1),(8, 321, 1, 1, 1),(8, 322, 1, 3, 1),(8, 323, 1, 1, 1),(8, 324, 1, 3, 1),(8, 325, 1, 1, 1),(8, 326, 1, 3, 1),(8, 327, 1, 1, 1),(8, 328, 1, 3, 1),(8, 329, 1, 1, 1),(8, 330, 1, 3, 1),(8, 331, 1, 1, 1),(8, 332, 1, 3, 1),(8, 333, 1, 1, 1),(8, 334, 1, 3, 1),(8, 335, 1, 1, 1),(8, 336, 1, 3, 1),(8, 337, 1, 2, 1),(8, 338, 1, 4, 1),(8, 339, 1, 2, 1),(8, 340, 1, 4, 1),(8, 341, 1, 2, 1),(8, 342, 1, 4, 1),(8, 343, 1, 2, 1),(8, 344, 1, 4, 1),(8, 345, 1, 2, 1),(8, 346, 1, 4, 1),(8, 347, 1, 2, 1),(8, 348, 1, 4, 1),(8, 349, 1, 2, 1),(8, 350, 1, 4, 1),(8, 351, 1, 2, 1),(8, 352, 1, 4, 1),(8, 353, 2, 1, 1),(8, 354, 2, 3, 1),(8, 355, 2, 1, 1),(8, 356, 2, 3, 1),(8, 357, 2, 1, 1),(8, 358, 2, 3, 1),(8, 359, 2, 1, 1),(8, 360, 2, 3, 1),(8, 361, 3, 1, 1),(8, 362, 3, 3, 1),(8, 363, 3, 1, 1),(8, 364, 3, 3, 1),(8, 365, 4, 1, 1),(8, 366, 4, 3, 1),(8, 367, 4, 1, 1),(8, 368, 4, 3, 1),(8, 369, 2, 2, 1),(8, 370, 2, 4, 1),(8, 371, 2, 2, 1),(8, 372, 2, 4, 1),(8, 373, 2, 2, 1),(8, 374, 2, 4, 1),(8, 375, 2, 2, 1),(8, 376, 2, 4, 1),(8, 377, 3, 2, 1),(8, 378, 3, 4, 1),(8, 379, 3, 2, 1),(8, 380, 3, 4, 1),(8, 381, 4, 2, 1),(8, 382, 4, 4, 1),(8, 383, 4, 2, 1),(8, 384, 4, 4, 1),(9, 1, 1, 1, 1),(9, 2, 1, 2, 1),(9, 3, 1, 1, 1),(9, 4, 1, 2, 1),(9, 5, 1, 1, 1),(9, 6, 1, 2, 1),(9, 7, 1, 1, 1),(9, 8, 1, 2, 1),(9, 9, 1, 1, 1),(9, 10, 1, 2, 1),(9, 11, 1, 1, 1),(9, 12, 1, 2, 1),(9, 13, 1, 1, 1),(9, 14, 1, 2, 1),(9, 15, 1, 1, 1),(9, 16, 1, 2, 1),(9, 17, 1, 1, 2),(9, 18, 1, 2, 2),(9, 19, 1, 1, 2),(9, 20, 1, 2, 2),(9, 21, 1, 1, 2),(9, 22, 1, 2, 2),(9, 23, 1, 1, 2),(9, 24, 1, 2, 2),(9, 25, 1, 1, 2),(9, 26, 1, 2, 2),(9, 27, 1, 1, 2),(9, 28, 1, 2, 2),(9, 29, 1, 1, 2),(9, 30, 1, 2, 2),(9, 31, 1, 1, 2),(9, 32, 1, 2, 2),(9, 33, 1, 1, 1),(9, 34, 1, 2, 1),(9, 35, 1, 1, 1),(9, 36, 1, 2, 1),(9, 37, 1, 1, 1),(9, 38, 1, 2, 1),(9, 39, 1, 1, 1),(9, 40, 1, 2, 1),(9, 41, 1, 1, 1),(9, 42, 1, 2, 1),(9, 43, 1, 1, 1),(9, 44, 1, 2, 1),(9, 45, 1, 1, 1),(9, 46, 1, 2, 1),(9, 47, 1, 1, 1),(9, 48, 1, 2, 1),(9, 49, 1, 1, 2),(9, 50, 1, 2, 2),(9, 51, 1, 1, 2),(9, 52, 1, 2, 2),(9, 53, 1, 1, 2),(9, 54, 1, 2, 2),(9, 55, 1, 1, 2),(9, 56, 1, 2, 2),(9, 57, 1, 1, 2),(9, 58, 1, 2, 2),(9, 59, 1, 1, 2),(9, 60, 1, 2, 2),(9, 61, 1, 1, 2),(9, 62, 1, 2, 2),(9, 63, 1, 1, 2),(9, 64, 1, 2, 2),(9, 65, 1, 1, 1),(9, 66, 1, 2, 1),(9, 67, 1, 1, 1),(9, 68, 1, 2, 1),(9, 69, 1, 1, 1),(9, 70, 1, 2, 1),(9, 71, 1, 1, 1),(9, 72, 1, 2, 1),(9, 73, 1, 1, 1),(9, 74, 1, 2, 1),(9, 75, 1, 1, 1),(9, 76, 1, 2, 1),(9, 77, 1, 1, 1),(9, 78, 1, 2, 1),(9, 79, 1, 1, 1),(9, 80, 1, 2, 1),(9, 81, 1, 1, 2),(9, 82, 1, 2, 2),(9, 83, 1, 1, 2),(9, 84, 1, 2, 2),(9, 85, 1, 1, 2),(9, 86, 1, 2, 2),(9, 87, 1, 1, 2),(9, 88, 1, 2, 2),(9, 89, 1, 1, 2),(9, 90, 1, 2, 2),(9, 91, 1, 1, 2),(9, 92, 1, 2, 2),(9, 93, 1, 1, 2),(9, 94, 1, 2, 2),(9, 95, 1, 1, 2),(9, 96, 1, 2, 2),(9, 97, 1, 1, 1),(9, 98, 1, 2, 1),(9, 99, 1, 1, 1),(9, 100, 1, 2, 1),(9, 101, 1, 1, 1),(9, 102, 1, 2, 1),(9, 103, 1, 1, 1),(9, 104, 1, 2, 1),(9, 105, 1, 1, 1),(9, 106, 1, 2, 1),(9, 107, 1, 1, 1),(9, 108, 1, 2, 1),(9, 109, 1, 1, 1),(9, 110, 1, 2, 1),(9, 111, 1, 1, 1),(9, 112, 1, 2, 1),(9, 113, 1, 1, 2),(9, 114, 1, 2, 2),(9, 115, 1, 1, 2),(9, 116, 1, 2, 2),(9, 117, 1, 1, 2),(9, 118, 1, 2, 2),(9, 119, 1, 1, 2),(9, 120, 1, 2, 2),(9, 121, 1, 1, 2),(9, 122, 1, 2, 2),(9, 123, 1, 1, 2),(9, 124, 1, 2, 2),(9, 125, 1, 1, 2),(9, 126, 1, 2, 2),(9, 127, 1, 1, 2),(9, 128, 1, 2, 2),(9, 129, 1, 1, 1),(9, 130, 1, 2, 1),(9, 131, 1, 1, 1),(9, 132, 1, 2, 1),(9, 133, 1, 1, 1),(9, 134, 1, 2, 1),(9, 135, 1, 1, 1),(9, 136, 1, 2, 1),(9, 137, 1, 1, 1),(9, 138, 1, 2, 1),(9, 139, 1, 1, 1),(9, 140, 1, 2, 1),(9, 141, 1, 1, 1),(9, 142, 1, 2, 1),(9, 143, 1, 1, 1),(9, 144, 1, 2, 1),(9, 145, 1, 1, 2),(9, 146, 1, 2, 2),(9, 147, 1, 1, 2),(9, 148, 1, 2, 2),(9, 149, 1, 1, 2),(9, 150, 1, 2, 2),(9, 151, 1, 1, 2),(9, 152, 1, 2, 2),(9, 153, 1, 1, 2),(9, 154, 1, 2, 2),(9, 155, 1, 1, 2),(9, 156, 1, 2, 2),(9, 157, 1, 1, 2),(9, 158, 1, 2, 2),(9, 159, 1, 1, 2),(9, 160, 1, 2, 2),(9, 161, 1, 1, 1),(9, 162, 1, 2, 1),(9, 163, 1, 1, 1),(9, 164, 1, 2, 1),(9, 165, 1, 1, 1),(9, 166, 1, 2, 1),(9, 167, 1, 1, 1),(9, 168, 1, 2, 1),(9, 169, 1, 1, 1),(9, 170, 1, 2, 1),(9, 171, 1, 1, 1),(9, 172, 1, 2, 1),(9, 173, 1, 1, 1),(9, 174, 1, 2, 1),(9, 175, 1, 1, 1),(9, 176, 1, 2, 1),(9, 177, 1, 1, 2),(9, 178, 1, 2, 2),(9, 179, 1, 1, 2),(9, 180, 1, 2, 2),(9, 181, 1, 1, 2),(9, 182, 1, 2, 2),(9, 183, 1, 1, 2),(9, 184, 1, 2, 2),(9, 185, 1, 1, 2),(9, 186, 1, 2, 2),(9, 187, 1, 1, 2),(9, 188, 1, 2, 2),(9, 189, 1, 1, 2),(9, 190, 1, 2, 2),(9, 191, 1, 1, 2),(9, 192, 1, 2, 2),(9, 193, 1, 1, 1),(9, 194, 1, 2, 1),(9, 195, 1, 1, 1),(9, 196, 1, 2, 1),(9, 197, 1, 1, 1),(9, 198, 1, 2, 1),(9, 199, 1, 1, 1),(9, 200, 1, 2, 1),(9, 201, 1, 1, 1),(9, 202, 1, 2, 1),(9, 203, 1, 1, 1),(9, 204, 1, 2, 1),(9, 205, 1, 1, 1),(9, 206, 1, 2, 1),(9, 207, 1, 1, 1),(9, 208, 1, 2, 1),(9, 209, 1, 1, 2),(9, 210, 1, 2, 2),(9, 211, 1, 1, 2),(9, 212, 1, 2, 2),(9, 213, 1, 1, 2),(9, 214, 1, 2, 2),(9, 215, 1, 1, 2),(9, 216, 1, 2, 2),(9, 217, 1, 1, 2),(9, 218, 1, 2, 2),(9, 219, 1, 1, 2),(9, 220, 1, 2, 2),(9, 221, 1, 1, 2),(9, 222, 1, 2, 2),(9, 223, 1, 1, 2),(9, 224, 1, 2, 2),(9, 225, 1, 1, 1),(9, 226, 1, 2, 1),(9, 227, 1, 1, 1),(9, 228, 1, 2, 1),(9, 229, 1, 1, 1),(9, 230, 1, 2, 1),(9, 231, 1, 1, 1),(9, 232, 1, 2, 1),(9, 233, 1, 1, 1),(9, 234, 1, 2, 1),(9, 235, 1, 1, 1),(9, 236, 1, 2, 1),(9, 237, 1, 1, 1),(9, 238, 1, 2, 1),(9, 239, 1, 1, 1),(9, 240, 1, 2, 1),(9, 241, 1, 1, 2),(9, 242, 1, 2, 2),(9, 243, 1, 1, 2),(9, 244, 1, 2, 2),(9, 245, 1, 1, 2),(9, 246, 1, 2, 2),(9, 247, 1, 1, 2),(9, 248, 1, 2, 2),(9, 249, 1, 1, 2),(9, 250, 1, 2, 2),(9, 251, 1, 1, 2),(9, 252, 1, 2, 2),(9, 253, 1, 1, 2),(9, 254, 1, 2, 2),(9, 255, 1, 1, 2),(9, 256, 1, 2, 2),(9, 257, 1, 1, 1),(9, 258, 1, 2, 1),(9, 259, 1, 1, 1),(9, 260, 1, 2, 1),(9, 261, 1, 1, 1),(9, 262, 1, 2, 1),(9, 263, 1, 1, 1),(9, 264, 1, 2, 1),(9, 265, 1, 1, 1),(9, 266, 1, 2, 1),(9, 267, 1, 1, 1),(9, 268, 1, 2, 1),(9, 269, 1, 1, 1),(9, 270, 1, 2, 1),(9, 271, 1, 1, 1),(9, 272, 1, 2, 1),(9, 273, 1, 1, 2),(9, 274, 1, 2, 2),(9, 275, 1, 1, 2),(9, 276, 1, 2, 2),(9, 277, 1, 1, 2),(9, 278, 1, 2, 2),(9, 279, 1, 1, 2),(9, 280, 1, 2, 2),(9, 281, 1, 1, 2),(9, 282, 1, 2, 2),(9, 283, 1, 1, 2),(9, 284, 1, 2, 2),(9, 285, 1, 1, 2),(9, 286, 1, 2, 2),(9, 287, 1, 1, 2),(9, 288, 1, 2, 2),(9, 289, 1, 1, 1),(9, 290, 1, 2, 1),(9, 291, 1, 1, 1),(9, 292, 1, 2, 1),(9, 293, 1, 1, 1),(9, 294, 1, 2, 1),(9, 295, 1, 1, 1),(9, 296, 1, 2, 1),(9, 297, 1, 1, 1),(9, 298, 1, 2, 1),(9, 299, 1, 1, 1),(9, 300, 1, 2, 1),(9, 301, 1, 1, 1),(9, 302, 1, 2, 1),(9, 303, 1, 1, 1),(9, 304, 1, 2, 1),(9, 305, 1, 1, 2),(9, 306, 1, 2, 2),(9, 307, 1, 1, 2),(9, 308, 1, 2, 2),(9, 309, 1, 1, 2),(9, 310, 1, 2, 2),(9, 311, 1, 1, 2),(9, 312, 1, 2, 2),(9, 313, 1, 1, 2),(9, 314, 1, 2, 2),(9, 315, 1, 1, 2),(9, 316, 1, 2, 2),(9, 317, 1, 1, 2),(9, 318, 1, 2, 2),(9, 319, 1, 1, 2),(9, 320, 1, 2, 2),(9, 321, 1, 1, 1),(9, 322, 1, 2, 1),(9, 323, 1, 1, 1),(9, 324, 1, 2, 1),(9, 325, 1, 1, 1),(9, 326, 1, 2, 1),(9, 327, 1, 1, 1),(9, 328, 1, 2, 1),(9, 329, 1, 1, 1),(9, 330, 1, 2, 1),(9, 331, 1, 1, 1),(9, 332, 1, 2, 1),(9, 333, 1, 1, 1),(9, 334, 1, 2, 1),(9, 335, 1, 1, 1),(9, 336, 1, 2, 1),(9, 337, 1, 1, 2),(9, 338, 1, 2, 2),(9, 339, 1, 1, 2),(9, 340, 1, 2, 2),(9, 341, 1, 1, 2),(9, 342, 1, 2, 2),(9, 343, 1, 1, 2),(9, 344, 1, 2, 2),(9, 345, 1, 1, 2),(9, 346, 1, 2, 2),(9, 347, 1, 1, 2),(9, 348, 1, 2, 2),(9, 349, 1, 1, 2),(9, 350, 1, 2, 2),(9, 351, 1, 1, 2),(9, 352, 1, 2, 2),(9, 353, 2, 1, 1),(9, 354, 2, 2, 1),(9, 355, 2, 1, 1),(9, 356, 2, 2, 1),(9, 357, 2, 1, 1),(9, 358, 2, 2, 1),(9, 359, 2, 1, 1),(9, 360, 2, 2, 1),(9, 361, 3, 1, 1),(9, 362, 3, 2, 1),(9, 363, 3, 1, 1),(9, 364, 3, 2, 1),(9, 365, 4, 1, 1),(9, 366, 4, 2, 1),(9, 367, 4, 1, 1),(9, 368, 4, 2, 1),(9, 369, 2, 1, 2),(9, 370, 2, 2, 2),(9, 371, 2, 1, 2),(9, 372, 2, 2, 2),(9, 373, 2, 1, 2),(9, 374, 2, 2, 2),(9, 375, 2, 1, 2),(9, 376, 2, 2, 2),(9, 377, 3, 1, 2),(9, 378, 3, 2, 2),(9, 379, 3, 1, 2),(9, 380, 3, 2, 2),(9, 381, 4, 1, 2),(9, 382, 4, 2, 2),(9, 383, 4, 1, 2),(9, 384, 4, 2, 2),(10, 1, 1, 1, 1),(10, 2, 1, 2, 1),(10, 3, 1, 1, 1),(10, 4, 1, 2, 1),(10, 5, 1, 1, 1),(10, 6, 1, 2, 1),(10, 7, 1, 1, 1),(10, 8, 1, 2, 1),(10, 9, 1, 1, 1),(10, 10, 1, 2, 1),(10, 11, 1, 1, 1),(10, 12, 1, 2, 1),(10, 13, 1, 1, 1),(10, 14, 1, 2, 1),(10, 15, 1, 1, 1),(10, 16, 1, 2, 1),(10, 17, 1, 1, 1),(10, 18, 1, 2, 1),(10, 19, 1, 1, 1),(10, 20, 1, 2, 1),(10, 21, 1, 1, 1),(10, 22, 1, 2, 1),(10, 23, 1, 1, 1),(10, 24, 1, 2, 1),(10, 25, 1, 1, 1),(10, 26, 1, 2, 1),(10, 27, 1, 1, 1),(10, 28, 1, 2, 1),(10, 29, 1, 1, 1),(10, 30, 1, 2, 1),(10, 31, 1, 1, 1),(10, 32, 1, 2, 1),(10, 33, 1, 1, 1),(10, 34, 1, 2, 1),(10, 35, 1, 1, 1),(10, 36, 1, 2, 1),(10, 37, 1, 1, 1),(10, 38, 1, 2, 1),(10, 39, 1, 1, 1),(10, 40, 1, 2, 1),(10, 41, 1, 1, 1),(10, 42, 1, 2, 1),(10, 43, 1, 1, 1),(10, 44, 1, 2, 1),(10, 45, 1, 1, 1),(10, 46, 1, 2, 1),(10, 47, 1, 1, 1),(10, 48, 1, 2, 1),(10, 49, 1, 1, 1),(10, 50, 1, 2, 1),(10, 51, 1, 1, 1),(10, 52, 1, 2, 1),(10, 53, 1, 1, 1),(10, 54, 1, 2, 1),(10, 55, 1, 1, 1),(10, 56, 1, 2, 1),(10, 57, 1, 1, 1),(10, 58, 1, 2, 1),(10, 59, 1, 1, 1),(10, 60, 1, 2, 1),(10, 61, 1, 1, 1),(10, 62, 1, 2, 1),(10, 63, 1, 1, 1),(10, 64, 1, 2, 1),(10, 65, 1, 1, 1),(10, 66, 1, 2, 1),(10, 67, 1, 1, 1),(10, 68, 1, 2, 1),(10, 69, 1, 1, 1),(10, 70, 1, 2, 1),(10, 71, 1, 1, 1),(10, 72, 1, 2, 1),(10, 73, 1, 1, 1),(10, 74, 1, 2, 1),(10, 75, 1, 1, 1),(10, 76, 1, 2, 1),(10, 77, 1, 1, 1),(10, 78, 1, 2, 1),(10, 79, 1, 1, 1),(10, 80, 1, 2, 1),(10, 81, 1, 1, 1),(10, 82, 1, 2, 1),(10, 83, 1, 1, 1),(10, 84, 1, 2, 1),(10, 85, 1, 1, 1),(10, 86, 1, 2, 1),(10, 87, 1, 1, 1),(10, 88, 1, 2, 1),(10, 89, 1, 1, 1),(10, 90, 1, 2, 1),(10, 91, 1, 1, 1),(10, 92, 1, 2, 1),(10, 93, 1, 1, 1),(10, 94, 1, 2, 1),(10, 95, 1, 1, 1),(10, 96, 1, 2, 1),(10, 97, 1, 1, 1),(10, 98, 1, 2, 1),(10, 99, 1, 1, 1),(10, 100, 1, 2, 1),(10, 101, 1, 1, 1),(10, 102, 1, 2, 1),(10, 103, 1, 1, 1),(10, 104, 1, 2, 1),(10, 105, 1, 1, 1),(10, 106, 1, 2, 1),(10, 107, 1, 1, 1),(10, 108, 1, 2, 1),(10, 109, 1, 1, 1),(10, 110, 1, 2, 1),(10, 111, 1, 1, 1),(10, 112, 1, 2, 1),(10, 113, 1, 1, 1),(10, 114, 1, 2, 1),(10, 115, 1, 1, 1),(10, 116, 1, 2, 1),(10, 117, 1, 1, 1),(10, 118, 1, 2, 1),(10, 119, 1, 1, 1),(10, 120, 1, 2, 1),(10, 121, 1, 1, 1),(10, 122, 1, 2, 1),(10, 123, 1, 1, 1),(10, 124, 1, 2, 1),(10, 125, 1, 1, 1),(10, 126, 1, 2, 1),(10, 127, 1, 1, 1),(10, 128, 1, 2, 1),(10, 129, 1, 1, 1),(10, 130, 1, 2, 1),(10, 131, 1, 1, 1),(10, 132, 1, 2, 1),(10, 133, 1, 1, 1),(10, 134, 1, 2, 1),(10, 135, 1, 1, 1),(10, 136, 1, 2, 1),(10, 137, 1, 1, 1),(10, 138, 1, 2, 1),(10, 139, 1, 1, 1),(10, 140, 1, 2, 1),(10, 141, 1, 1, 1),(10, 142, 1, 2, 1),(10, 143, 1, 1, 1),(10, 144, 1, 2, 1),(10, 145, 1, 1, 1),(10, 146, 1, 2, 1),(10, 147, 1, 1, 1),(10, 148, 1, 2, 1),(10, 149, 1, 1, 1),(10, 150, 1, 2, 1),(10, 151, 1, 1, 1),(10, 152, 1, 2, 1),(10, 153, 1, 1, 1),(10, 154, 1, 2, 1),(10, 155, 1, 1, 1),(10, 156, 1, 2, 1),(10, 157, 1, 1, 1),(10, 158, 1, 2, 1),(10, 159, 1, 1, 1),(10, 160, 1, 2, 1),(10, 161, 1, 1, 1),(10, 162, 1, 2, 1),(10, 163, 1, 1, 1),(10, 164, 1, 2, 1),(10, 165, 1, 1, 1),(10, 166, 1, 2, 1),(10, 167, 1, 1, 1),(10, 168, 1, 2, 1),(10, 169, 1, 1, 1),(10, 170, 1, 2, 1),(10, 171, 1, 1, 1),(10, 172, 1, 2, 1),(10, 173, 1, 1, 1),(10, 174, 1, 2, 1),(10, 175, 1, 1, 1),(10, 176, 1, 2, 1),(10, 177, 1, 1, 1),(10, 178, 1, 2, 1),(10, 179, 1, 1, 1),(10, 180, 1, 2, 1),(10, 181, 1, 1, 1),(10, 182, 1, 2, 1),(10, 183, 1, 1, 1),(10, 184, 1, 2, 1),(10, 185, 1, 1, 1),(10, 186, 1, 2, 1),(10, 187, 1, 1, 1),(10, 188, 1, 2, 1),(10, 189, 1, 1, 1),(10, 190, 1, 2, 1),(10, 191, 1, 1, 1),(10, 192, 1, 2, 1),(10, 193, 1, 1, 1),(10, 194, 1, 2, 1),(10, 195, 1, 1, 1),(10, 196, 1, 2, 1),(10, 197, 1, 1, 1),(10, 198, 1, 2, 1),(10, 199, 1, 1, 1),(10, 200, 1, 2, 1),(10, 201, 1, 1, 1),(10, 202, 1, 2, 1),(10, 203, 1, 1, 1),(10, 204, 1, 2, 1),(10, 205, 1, 1, 1),(10, 206, 1, 2, 1),(10, 207, 1, 1, 1),(10, 208, 1, 2, 1),(10, 209, 1, 1, 1),(10, 210, 1, 2, 1),(10, 211, 1, 1, 1),(10, 212, 1, 2, 1),(10, 213, 1, 1, 1),(10, 214, 1, 2, 1),(10, 215, 1, 1, 1),(10, 216, 1, 2, 1),(10, 217, 1, 1, 1),(10, 218, 1, 2, 1),(10, 219, 1, 1, 1),(10, 220, 1, 2, 1),(10, 221, 1, 1, 1),(10, 222, 1, 2, 1),(10, 223, 1, 1, 1),(10, 224, 1, 2, 1),(10, 225, 1, 1, 1),(10, 226, 1, 2, 1),(10, 227, 1, 1, 1),(10, 228, 1, 2, 1),(10, 229, 1, 1, 1),(10, 230, 1, 2, 1),(10, 231, 1, 1, 1),(10, 232, 1, 2, 1),(10, 233, 1, 1, 1),(10, 234, 1, 2, 1),(10, 235, 1, 1, 1),(10, 236, 1, 2, 1),(10, 237, 1, 1, 1),(10, 238, 1, 2, 1),(10, 239, 1, 1, 1),(10, 240, 1, 2, 1),(10, 241, 1, 1, 1),(10, 242, 1, 2, 1),(10, 243, 1, 1, 1),(10, 244, 1, 2, 1),(10, 245, 1, 1, 1),(10, 246, 1, 2, 1),(10, 247, 1, 1, 1),(10, 248, 1, 2, 1),(10, 249, 1, 1, 1),(10, 250, 1, 2, 1),(10, 251, 1, 1, 1),(10, 252, 1, 2, 1),(10, 253, 1, 1, 1),(10, 254, 1, 2, 1),(10, 255, 1, 1, 1),(10, 256, 1, 2, 1),(10, 257, 1, 1, 1),(10, 258, 1, 2, 1),(10, 259, 1, 1, 1),(10, 260, 1, 2, 1),(10, 261, 1, 1, 1),(10, 262, 1, 2, 1),(10, 263, 1, 1, 1),(10, 264, 1, 2, 1),(10, 265, 1, 1, 1),(10, 266, 1, 2, 1),(10, 267, 1, 1, 1),(10, 268, 1, 2, 1),(10, 269, 1, 1, 1),(10, 270, 1, 2, 1),(10, 271, 1, 1, 1),(10, 272, 1, 2, 1),(10, 273, 1, 1, 1),(10, 274, 1, 2, 1),(10, 275, 1, 1, 1),(10, 276, 1, 2, 1),(10, 277, 1, 1, 1),(10, 278, 1, 2, 1),(10, 279, 1, 1, 1),(10, 280, 1, 2, 1),(10, 281, 1, 1, 1),(10, 282, 1, 2, 1),(10, 283, 1, 1, 1),(10, 284, 1, 2, 1),(10, 285, 1, 1, 1),(10, 286, 1, 2, 1),(10, 287, 1, 1, 1),(10, 288, 1, 2, 1),(10, 289, 1, 1, 1),(10, 290, 1, 2, 1),(10, 291, 1, 1, 1),(10, 292, 1, 2, 1),(10, 293, 1, 1, 1),(10, 294, 1, 2, 1),(10, 295, 1, 1, 1),(10, 296, 1, 2, 1),(10, 297, 1, 1, 1),(10, 298, 1, 2, 1),(10, 299, 1, 1, 1),(10, 300, 1, 2, 1),(10, 301, 1, 1, 1),(10, 302, 1, 2, 1),(10, 303, 1, 1, 1),(10, 304, 1, 2, 1),(10, 305, 1, 1, 1),(10, 306, 1, 2, 1),(10, 307, 1, 1, 1),(10, 308, 1, 2, 1),(10, 309, 1, 1, 1),(10, 310, 1, 2, 1),(10, 311, 1, 1, 1),(10, 312, 1, 2, 1),(10, 313, 1, 1, 1),(10, 314, 1, 2, 1),(10, 315, 1, 1, 1),(10, 316, 1, 2, 1),(10, 317, 1, 1, 1),(10, 318, 1, 2, 1),(10, 319, 1, 1, 1),(10, 320, 1, 2, 1),(10, 321, 1, 1, 1),(10, 322, 1, 2, 1),(10, 323, 1, 1, 1),(10, 324, 1, 2, 1),(10, 325, 1, 1, 1),(10, 326, 1, 2, 1),(10, 327, 1, 1, 1),(10, 328, 1, 2, 1),(10, 329, 1, 1, 1),(10, 330, 1, 2, 1),(10, 331, 1, 1, 1),(10, 332, 1, 2, 1),(10, 333, 1, 1, 1),(10, 334, 1, 2, 1),(10, 335, 1, 1, 1),(10, 336, 1, 2, 1),(10, 337, 1, 1, 1),(10, 338, 1, 2, 1),(10, 339, 1, 1, 1),(10, 340, 1, 2, 1),(10, 341, 1, 1, 1),(10, 342, 1, 2, 1),(10, 343, 1, 1, 1),(10, 344, 1, 2, 1),(10, 345, 1, 1, 1),(10, 346, 1, 2, 1),(10, 347, 1, 1, 1),(10, 348, 1, 2, 1),(10, 349, 1, 1, 1),(10, 350, 1, 2, 1),(10, 351, 1, 1, 1),(10, 352, 1, 2, 1),(10, 353, 2, 1, 1),(10, 354, 2, 2, 1),(10, 355, 2, 1, 1),(10, 356, 2, 2, 1),(10, 357, 2, 1, 1),(10, 358, 2, 2, 1),(10, 359, 2, 1, 1),(10, 360, 2, 2, 1),(10, 361, 3, 1, 1),(10, 362, 3, 2, 1),(10, 363, 3, 1, 1),(10, 364, 3, 2, 1),(10, 365, 4, 1, 1),(10, 366, 4, 2, 1),(10, 367, 4, 1, 1),(10, 368, 4, 2, 1),(10, 369, 2, 1, 1),(10, 370, 2, 2, 1),(10, 371, 2, 1, 1),(10, 372, 2, 2, 1),(10, 373, 2, 1, 1),(10, 374, 2, 2, 1),(10, 375, 2, 1, 1),(10, 376, 2, 2, 1),(10, 377, 3, 1, 1),(10, 378, 3, 2, 1),(10, 379, 3, 1, 1),(10, 380, 3, 2, 1),(10, 381, 4, 1, 1),(10, 382, 4, 2, 1),(10, 383, 4, 1, 1),(10, 384, 4, 2, 1),(11, 1, 1, 1, 1),(11, 2, 1, 1, 2),(11, 3, 1, 1, 1),(11, 4, 1, 1, 2),(11, 5, 1, 1, 1),(11, 6, 1, 1, 2),(11, 7, 1, 1, 1),(11, 8, 1, 1, 2),(11, 9, 1, 1, 1),(11, 10, 1, 1, 2),(11, 11, 1, 1, 1),(11, 12, 1, 1, 2),(11, 13, 1, 1, 1),(11, 14, 1, 1, 2),(11, 15, 1, 1, 1),(11, 16, 1, 1, 2),(11, 17, 1, 1, 3),(11, 18, 1, 1, 4),(11, 19, 1, 1, 3),(11, 20, 1, 1, 4),(11, 21, 1, 1, 3),(11, 22, 1, 1, 4),(11, 23, 1, 1, 3),(11, 24, 1, 1, 4),(11, 25, 1, 1, 3),(11, 26, 1, 1, 4),(11, 27, 1, 1, 3),(11, 28, 1, 1, 4),(11, 29, 1, 1, 3),(11, 30, 1, 1, 4),(11, 31, 1, 1, 3),(11, 32, 1, 1, 4),(11, 33, 1, 1, 1),(11, 34, 1, 1, 2),(11, 35, 1, 1, 1),(11, 36, 1, 1, 2),(11, 37, 1, 1, 1),(11, 38, 1, 1, 2),(11, 39, 1, 1, 1),(11, 40, 1, 1, 2),(11, 41, 1, 1, 1),(11, 42, 1, 1, 2),(11, 43, 1, 1, 1),(11, 44, 1, 1, 2),(11, 45, 1, 1, 1),(11, 46, 1, 1, 2),(11, 47, 1, 1, 1),(11, 48, 1, 1, 2),(11, 49, 1, 1, 3),(11, 50, 1, 1, 4),(11, 51, 1, 1, 3),(11, 52, 1, 1, 4),(11, 53, 1, 1, 3),(11, 54, 1, 1, 4),(11, 55, 1, 1, 3),(11, 56, 1, 1, 4),(11, 57, 1, 1, 3),(11, 58, 1, 1, 4),(11, 59, 1, 1, 3),(11, 60, 1, 1, 4),(11, 61, 1, 1, 3),(11, 62, 1, 1, 4),(11, 63, 1, 1, 3),(11, 64, 1, 1, 4),(11, 65, 1, 1, 1),(11, 66, 1, 1, 2),(11, 67, 1, 1, 1),(11, 68, 1, 1, 2),(11, 69, 1, 1, 1),(11, 70, 1, 1, 2),(11, 71, 1, 1, 1),(11, 72, 1, 1, 2),(11, 73, 1, 1, 1),(11, 74, 1, 1, 2),(11, 75, 1, 1, 1),(11, 76, 1, 1, 2),(11, 77, 1, 1, 1),(11, 78, 1, 1, 2),(11, 79, 1, 1, 1),(11, 80, 1, 1, 2),(11, 81, 1, 1, 3),(11, 82, 1, 1, 4),(11, 83, 1, 1, 3),(11, 84, 1, 1, 4),(11, 85, 1, 1, 3),(11, 86, 1, 1, 4),(11, 87, 1, 1, 3),(11, 88, 1, 1, 4),(11, 89, 1, 1, 3),(11, 90, 1, 1, 4),(11, 91, 1, 1, 3),(11, 92, 1, 1, 4),(11, 93, 1, 1, 3),(11, 94, 1, 1, 4),(11, 95, 1, 1, 3),(11, 96, 1, 1, 4),(11, 97, 1, 1, 1),(11, 98, 1, 1, 2),(11, 99, 1, 1, 1),(11, 100, 1, 1, 2),(11, 101, 1, 1, 1),(11, 102, 1, 1, 2),(11, 103, 1, 1, 1),(11, 104, 1, 1, 2),(11, 105, 1, 1, 1),(11, 106, 1, 1, 2),(11, 107, 1, 1, 1),(11, 108, 1, 1, 2),(11, 109, 1, 1, 1),(11, 110, 1, 1, 2),(11, 111, 1, 1, 1),(11, 112, 1, 1, 2),(11, 113, 1, 1, 3),(11, 114, 1, 1, 4),(11, 115, 1, 1, 3),(11, 116, 1, 1, 4),(11, 117, 1, 1, 3),(11, 118, 1, 1, 4),(11, 119, 1, 1, 3),(11, 120, 1, 1, 4),(11, 121, 1, 1, 3),(11, 122, 1, 1, 4),(11, 123, 1, 1, 3),(11, 124, 1, 1, 4),(11, 125, 1, 1, 3),(11, 126, 1, 1, 4),(11, 127, 1, 1, 3),(11, 128, 1, 1, 4),(11, 129, 1, 1, 1),(11, 130, 1, 1, 2),(11, 131, 1, 1, 1),(11, 132, 1, 1, 2),(11, 133, 1, 1, 1),(11, 134, 1, 1, 2),(11, 135, 1, 1, 1),(11, 136, 1, 1, 2),(11, 137, 1, 1, 1),(11, 138, 1, 1, 2),(11, 139, 1, 1, 1),(11, 140, 1, 1, 2),(11, 141, 1, 1, 1),(11, 142, 1, 1, 2),(11, 143, 1, 1, 1),(11, 144, 1, 1, 2),(11, 145, 1, 1, 3),(11, 146, 1, 1, 4),(11, 147, 1, 1, 3),(11, 148, 1, 1, 4),(11, 149, 1, 1, 3),(11, 150, 1, 1, 4),(11, 151, 1, 1, 3),(11, 152, 1, 1, 4),(11, 153, 1, 1, 3),(11, 154, 1, 1, 4),(11, 155, 1, 1, 3),(11, 156, 1, 1, 4),(11, 157, 1, 1, 3),(11, 158, 1, 1, 4),(11, 159, 1, 1, 3),(11, 160, 1, 1, 4),(11, 161, 1, 1, 1),(11, 162, 1, 1, 2),(11, 163, 1, 1, 1),(11, 164, 1, 1, 2),(11, 165, 1, 1, 1),(11, 166, 1, 1, 2),(11, 167, 1, 1, 1),(11, 168, 1, 1, 2),(11, 169, 1, 1, 1),(11, 170, 1, 1, 2),(11, 171, 1, 1, 1),(11, 172, 1, 1, 2),(11, 173, 1, 1, 1),(11, 174, 1, 1, 2),(11, 175, 1, 1, 1),(11, 176, 1, 1, 2),(11, 177, 1, 1, 3),(11, 178, 1, 1, 4),(11, 179, 1, 1, 3),(11, 180, 1, 1, 4),(11, 181, 1, 1, 3),(11, 182, 1, 1, 4),(11, 183, 1, 1, 3),(11, 184, 1, 1, 4),(11, 185, 1, 1, 3),(11, 186, 1, 1, 4),(11, 187, 1, 1, 3),(11, 188, 1, 1, 4),(11, 189, 1, 1, 3),(11, 190, 1, 1, 4),(11, 191, 1, 1, 3),(11, 192, 1, 1, 4),(11, 193, 1, 1, 1),(11, 194, 1, 1, 2),(11, 195, 1, 1, 1),(11, 196, 1, 1, 2),(11, 197, 1, 1, 1),(11, 198, 1, 1, 2),(11, 199, 1, 1, 1),(11, 200, 1, 1, 2),(11, 201, 1, 1, 1),(11, 202, 1, 1, 2),(11, 203, 1, 1, 1),(11, 204, 1, 1, 2),(11, 205, 1, 1, 1),(11, 206, 1, 1, 2),(11, 207, 1, 1, 1),(11, 208, 1, 1, 2),(11, 209, 1, 1, 3),(11, 210, 1, 1, 4),(11, 211, 1, 1, 3),(11, 212, 1, 1, 4),(11, 213, 1, 1, 3),(11, 214, 1, 1, 4),(11, 215, 1, 1, 3),(11, 216, 1, 1, 4),(11, 217, 1, 1, 3),(11, 218, 1, 1, 4),(11, 219, 1, 1, 3),(11, 220, 1, 1, 4),(11, 221, 1, 1, 3),(11, 222, 1, 1, 4),(11, 223, 1, 1, 3),(11, 224, 1, 1, 4),(11, 225, 1, 1, 1),(11, 226, 1, 1, 2),(11, 227, 1, 1, 1),(11, 228, 1, 1, 2),(11, 229, 1, 1, 1),(11, 230, 1, 1, 2),(11, 231, 1, 1, 1),(11, 232, 1, 1, 2),(11, 233, 1, 1, 1),(11, 234, 1, 1, 2),(11, 235, 1, 1, 1),(11, 236, 1, 1, 2),(11, 237, 1, 1, 1),(11, 238, 1, 1, 2),(11, 239, 1, 1, 1),(11, 240, 1, 1, 2),(11, 241, 1, 1, 3),(11, 242, 1, 1, 4),(11, 243, 1, 1, 3),(11, 244, 1, 1, 4),(11, 245, 1, 1, 3),(11, 246, 1, 1, 4),(11, 247, 1, 1, 3),(11, 248, 1, 1, 4),(11, 249, 1, 1, 3),(11, 250, 1, 1, 4),(11, 251, 1, 1, 3),(11, 252, 1, 1, 4),(11, 253, 1, 1, 3),(11, 254, 1, 1, 4),(11, 255, 1, 1, 3),(11, 256, 1, 1, 4),(11, 257, 1, 1, 1),(11, 258, 1, 1, 2),(11, 259, 1, 1, 1),(11, 260, 1, 1, 2),(11, 261, 1, 1, 1),(11, 262, 1, 1, 2),(11, 263, 1, 1, 1),(11, 264, 1, 1, 2),(11, 265, 1, 1, 1),(11, 266, 1, 1, 2),(11, 267, 1, 1, 1),(11, 268, 1, 1, 2),(11, 269, 1, 1, 1),(11, 270, 1, 1, 2),(11, 271, 1, 1, 1),(11, 272, 1, 1, 2),(11, 273, 1, 1, 3),(11, 274, 1, 1, 4),(11, 275, 1, 1, 3),(11, 276, 1, 1, 4),(11, 277, 1, 1, 3),(11, 278, 1, 1, 4),(11, 279, 1, 1, 3),(11, 280, 1, 1, 4),(11, 281, 1, 1, 3),(11, 282, 1, 1, 4),(11, 283, 1, 1, 3),(11, 284, 1, 1, 4),(11, 285, 1, 1, 3),(11, 286, 1, 1, 4),(11, 287, 1, 1, 3),(11, 288, 1, 1, 4),(11, 289, 1, 1, 1),(11, 290, 1, 1, 2),(11, 291, 1, 1, 1),(11, 292, 1, 1, 2),(11, 293, 1, 1, 1),(11, 294, 1, 1, 2),(11, 295, 1, 1, 1),(11, 296, 1, 1, 2),(11, 297, 1, 1, 1),(11, 298, 1, 1, 2),(11, 299, 1, 1, 1),(11, 300, 1, 1, 2),(11, 301, 1, 1, 1),(11, 302, 1, 1, 2),(11, 303, 1, 1, 1),(11, 304, 1, 1, 2),(11, 305, 1, 1, 3),(11, 306, 1, 1, 4),(11, 307, 1, 1, 3),(11, 308, 1, 1, 4),(11, 309, 1, 1, 3),(11, 310, 1, 1, 4),(11, 311, 1, 1, 3),(11, 312, 1, 1, 4),(11, 313, 1, 1, 3),(11, 314, 1, 1, 4),(11, 315, 1, 1, 3),(11, 316, 1, 1, 4),(11, 317, 1, 1, 3),(11, 318, 1, 1, 4),(11, 319, 1, 1, 3),(11, 320, 1, 1, 4),(11, 321, 1, 1, 1),(11, 322, 1, 1, 2),(11, 323, 1, 1, 1),(11, 324, 1, 1, 2),(11, 325, 1, 1, 1),(11, 326, 1, 1, 2),(11, 327, 1, 1, 1),(11, 328, 1, 1, 2),(11, 329, 1, 1, 1),(11, 330, 1, 1, 2),(11, 331, 1, 1, 1),(11, 332, 1, 1, 2),(11, 333, 1, 1, 1),(11, 334, 1, 1, 2),(11, 335, 1, 1, 1),(11, 336, 1, 1, 2),(11, 337, 1, 1, 3),(11, 338, 1, 1, 4),(11, 339, 1, 1, 3),(11, 340, 1, 1, 4),(11, 341, 1, 1, 3),(11, 342, 1, 1, 4),(11, 343, 1, 1, 3),(11, 344, 1, 1, 4),(11, 345, 1, 1, 3),(11, 346, 1, 1, 4),(11, 347, 1, 1, 3),(11, 348, 1, 1, 4),(11, 349, 1, 1, 3),(11, 350, 1, 1, 4),(11, 351, 1, 1, 3),(11, 352, 1, 1, 4),(11, 353, 2, 1, 1),(11, 354, 2, 1, 2),(11, 355, 2, 1, 1),(11, 356, 2, 1, 2),(11, 357, 2, 1, 1),(11, 358, 2, 1, 2),(11, 359, 2, 1, 1),(11, 360, 2, 1, 2),(11, 361, 3, 1, 1),(11, 362, 3, 1, 2),(11, 363, 3, 1, 1),(11, 364, 3, 1, 2),(11, 365, 4, 1, 1),(11, 366, 4, 1, 2),(11, 367, 4, 1, 1),(11, 368, 4, 1, 2),(11, 369, 2, 1, 3),(11, 370, 2, 1, 4),(11, 371, 2, 1, 3),(11, 372, 2, 1, 4),(11, 373, 2, 1, 3),(11, 374, 2, 1, 4),(11, 375, 2, 1, 3),(11, 376, 2, 1, 4),(11, 377, 3, 1, 3),(11, 378, 3, 1, 4),(11, 379, 3, 1, 3),(11, 380, 3, 1, 4),(11, 381, 4, 1, 3),(11, 382, 4, 1, 4),(11, 383, 4, 1, 3),(11, 384, 4, 1, 4),(12, 1, 1, 1, 1),(12, 2, 1, 1, 1),(12, 3, 1, 1, 1),(12, 4, 1, 1, 1),(12, 5, 1, 1, 1),(12, 6, 1, 1, 1),(12, 7, 1, 1, 1),(12, 8, 1, 1, 1),(12, 9, 1, 1, 1),(12, 10, 1, 1, 1),(12, 11, 1, 1, 1),(12, 12, 1, 1, 1),(12, 13, 1, 1, 1),(12, 14, 1, 1, 1),(12, 15, 1, 1, 1),(12, 16, 1, 1, 1),(12, 17, 1, 1, 2),(12, 18, 1, 1, 2),(12, 19, 1, 1, 2),(12, 20, 1, 1, 2),(12, 21, 1, 1, 2),(12, 22, 1, 1, 2),(12, 23, 1, 1, 2),(12, 24, 1, 1, 2),(12, 25, 1, 1, 2),(12, 26, 1, 1, 2),(12, 27, 1, 1, 2),(12, 28, 1, 1, 2),(12, 29, 1, 1, 2),(12, 30, 1, 1, 2),(12, 31, 1, 1, 2),(12, 32, 1, 1, 2),(12, 33, 1, 1, 1),(12, 34, 1, 1, 1),(12, 35, 1, 1, 1),(12, 36, 1, 1, 1),(12, 37, 1, 1, 1),(12, 38, 1, 1, 1),(12, 39, 1, 1, 1),(12, 40, 1, 1, 1),(12, 41, 1, 1, 1),(12, 42, 1, 1, 1),(12, 43, 1, 1, 1),(12, 44, 1, 1, 1),(12, 45, 1, 1, 1),(12, 46, 1, 1, 1),(12, 47, 1, 1, 1),(12, 48, 1, 1, 1),(12, 49, 1, 1, 2),(12, 50, 1, 1, 2),(12, 51, 1, 1, 2),(12, 52, 1, 1, 2),(12, 53, 1, 1, 2),(12, 54, 1, 1, 2),(12, 55, 1, 1, 2),(12, 56, 1, 1, 2),(12, 57, 1, 1, 2),(12, 58, 1, 1, 2),(12, 59, 1, 1, 2),(12, 60, 1, 1, 2),(12, 61, 1, 1, 2),(12, 62, 1, 1, 2),(12, 63, 1, 1, 2),(12, 64, 1, 1, 2),(12, 65, 1, 1, 1),(12, 66, 1, 1, 1),(12, 67, 1, 1, 1),(12, 68, 1, 1, 1),(12, 69, 1, 1, 1),(12, 70, 1, 1, 1),(12, 71, 1, 1, 1),(12, 72, 1, 1, 1),(12, 73, 1, 1, 1),(12, 74, 1, 1, 1),(12, 75, 1, 1, 1),(12, 76, 1, 1, 1),(12, 77, 1, 1, 1),(12, 78, 1, 1, 1),(12, 79, 1, 1, 1),(12, 80, 1, 1, 1),(12, 81, 1, 1, 2),(12, 82, 1, 1, 2),(12, 83, 1, 1, 2),(12, 84, 1, 1, 2),(12, 85, 1, 1, 2),(12, 86, 1, 1, 2),(12, 87, 1, 1, 2),(12, 88, 1, 1, 2),(12, 89, 1, 1, 2),(12, 90, 1, 1, 2),(12, 91, 1, 1, 2),(12, 92, 1, 1, 2),(12, 93, 1, 1, 2),(12, 94, 1, 1, 2),(12, 95, 1, 1, 2),(12, 96, 1, 1, 2),(12, 97, 1, 1, 1),(12, 98, 1, 1, 1),(12, 99, 1, 1, 1),(12, 100, 1, 1, 1),(12, 101, 1, 1, 1),(12, 102, 1, 1, 1),(12, 103, 1, 1, 1),(12, 104, 1, 1, 1),(12, 105, 1, 1, 1),(12, 106, 1, 1, 1),(12, 107, 1, 1, 1),(12, 108, 1, 1, 1),(12, 109, 1, 1, 1),(12, 110, 1, 1, 1),(12, 111, 1, 1, 1),(12, 112, 1, 1, 1),(12, 113, 1, 1, 2),(12, 114, 1, 1, 2),(12, 115, 1, 1, 2),(12, 116, 1, 1, 2),(12, 117, 1, 1, 2),(12, 118, 1, 1, 2),(12, 119, 1, 1, 2),(12, 120, 1, 1, 2),(12, 121, 1, 1, 2),(12, 122, 1, 1, 2),(12, 123, 1, 1, 2),(12, 124, 1, 1, 2),(12, 125, 1, 1, 2),(12, 126, 1, 1, 2),(12, 127, 1, 1, 2),(12, 128, 1, 1, 2),(12, 129, 1, 1, 1),(12, 130, 1, 1, 1),(12, 131, 1, 1, 1),(12, 132, 1, 1, 1),(12, 133, 1, 1, 1),(12, 134, 1, 1, 1),(12, 135, 1, 1, 1),(12, 136, 1, 1, 1),(12, 137, 1, 1, 1),(12, 138, 1, 1, 1),(12, 139, 1, 1, 1),(12, 140, 1, 1, 1),(12, 141, 1, 1, 1),(12, 142, 1, 1, 1),(12, 143, 1, 1, 1),(12, 144, 1, 1, 1),(12, 145, 1, 1, 2),(12, 146, 1, 1, 2),(12, 147, 1, 1, 2),(12, 148, 1, 1, 2),(12, 149, 1, 1, 2),(12, 150, 1, 1, 2),(12, 151, 1, 1, 2),(12, 152, 1, 1, 2),(12, 153, 1, 1, 2),(12, 154, 1, 1, 2),(12, 155, 1, 1, 2),(12, 156, 1, 1, 2),(12, 157, 1, 1, 2),(12, 158, 1, 1, 2),(12, 159, 1, 1, 2),(12, 160, 1, 1, 2),(12, 161, 1, 1, 1),(12, 162, 1, 1, 1),(12, 163, 1, 1, 1),(12, 164, 1, 1, 1),(12, 165, 1, 1, 1),(12, 166, 1, 1, 1),(12, 167, 1, 1, 1),(12, 168, 1, 1, 1),(12, 169, 1, 1, 1),(12, 170, 1, 1, 1),(12, 171, 1, 1, 1),(12, 172, 1, 1, 1),(12, 173, 1, 1, 1),(12, 174, 1, 1, 1),(12, 175, 1, 1, 1),(12, 176, 1, 1, 1),(12, 177, 1, 1, 2),(12, 178, 1, 1, 2),(12, 179, 1, 1, 2),(12, 180, 1, 1, 2),(12, 181, 1, 1, 2),(12, 182, 1, 1, 2),(12, 183, 1, 1, 2),(12, 184, 1, 1, 2),(12, 185, 1, 1, 2),(12, 186, 1, 1, 2),(12, 187, 1, 1, 2),(12, 188, 1, 1, 2),(12, 189, 1, 1, 2),(12, 190, 1, 1, 2),(12, 191, 1, 1, 2),(12, 192, 1, 1, 2),(12, 193, 1, 1, 1),(12, 194, 1, 1, 1),(12, 195, 1, 1, 1),(12, 196, 1, 1, 1),(12, 197, 1, 1, 1),(12, 198, 1, 1, 1),(12, 199, 1, 1, 1),(12, 200, 1, 1, 1),(12, 201, 1, 1, 1),(12, 202, 1, 1, 1),(12, 203, 1, 1, 1),(12, 204, 1, 1, 1),(12, 205, 1, 1, 1),(12, 206, 1, 1, 1),(12, 207, 1, 1, 1),(12, 208, 1, 1, 1),(12, 209, 1, 1, 2),(12, 210, 1, 1, 2),(12, 211, 1, 1, 2),(12, 212, 1, 1, 2),(12, 213, 1, 1, 2),(12, 214, 1, 1, 2),(12, 215, 1, 1, 2),(12, 216, 1, 1, 2),(12, 217, 1, 1, 2),(12, 218, 1, 1, 2),(12, 219, 1, 1, 2),(12, 220, 1, 1, 2),(12, 221, 1, 1, 2),(12, 222, 1, 1, 2),(12, 223, 1, 1, 2),(12, 224, 1, 1, 2),(12, 225, 1, 1, 1),(12, 226, 1, 1, 1),(12, 227, 1, 1, 1),(12, 228, 1, 1, 1),(12, 229, 1, 1, 1),(12, 230, 1, 1, 1),(12, 231, 1, 1, 1),(12, 232, 1, 1, 1),(12, 233, 1, 1, 1),(12, 234, 1, 1, 1),(12, 235, 1, 1, 1),(12, 236, 1, 1, 1),(12, 237, 1, 1, 1),(12, 238, 1, 1, 1),(12, 239, 1, 1, 1),(12, 240, 1, 1, 1),(12, 241, 1, 1, 2),(12, 242, 1, 1, 2),(12, 243, 1, 1, 2),(12, 244, 1, 1, 2),(12, 245, 1, 1, 2),(12, 246, 1, 1, 2),(12, 247, 1, 1, 2),(12, 248, 1, 1, 2),(12, 249, 1, 1, 2),(12, 250, 1, 1, 2),(12, 251, 1, 1, 2),(12, 252, 1, 1, 2),(12, 253, 1, 1, 2),(12, 254, 1, 1, 2),(12, 255, 1, 1, 2),(12, 256, 1, 1, 2),(12, 257, 1, 1, 1),(12, 258, 1, 1, 1),(12, 259, 1, 1, 1),(12, 260, 1, 1, 1),(12, 261, 1, 1, 1),(12, 262, 1, 1, 1),(12, 263, 1, 1, 1),(12, 264, 1, 1, 1),(12, 265, 1, 1, 1),(12, 266, 1, 1, 1),(12, 267, 1, 1, 1),(12, 268, 1, 1, 1),(12, 269, 1, 1, 1),(12, 270, 1, 1, 1),(12, 271, 1, 1, 1),(12, 272, 1, 1, 1),(12, 273, 1, 1, 2),(12, 274, 1, 1, 2),(12, 275, 1, 1, 2),(12, 276, 1, 1, 2),(12, 277, 1, 1, 2),(12, 278, 1, 1, 2),(12, 279, 1, 1, 2),(12, 280, 1, 1, 2),(12, 281, 1, 1, 2),(12, 282, 1, 1, 2),(12, 283, 1, 1, 2),(12, 284, 1, 1, 2),(12, 285, 1, 1, 2),(12, 286, 1, 1, 2),(12, 287, 1, 1, 2),(12, 288, 1, 1, 2),(12, 289, 1, 1, 1),(12, 290, 1, 1, 1),(12, 291, 1, 1, 1),(12, 292, 1, 1, 1),(12, 293, 1, 1, 1),(12, 294, 1, 1, 1),(12, 295, 1, 1, 1),(12, 296, 1, 1, 1),(12, 297, 1, 1, 1),(12, 298, 1, 1, 1),(12, 299, 1, 1, 1),(12, 300, 1, 1, 1),(12, 301, 1, 1, 1),(12, 302, 1, 1, 1),(12, 303, 1, 1, 1),(12, 304, 1, 1, 1),(12, 305, 1, 1, 2),(12, 306, 1, 1, 2),(12, 307, 1, 1, 2),(12, 308, 1, 1, 2),(12, 309, 1, 1, 2),(12, 310, 1, 1, 2),(12, 311, 1, 1, 2),(12, 312, 1, 1, 2),(12, 313, 1, 1, 2),(12, 314, 1, 1, 2),(12, 315, 1, 1, 2),(12, 316, 1, 1, 2),(12, 317, 1, 1, 2),(12, 318, 1, 1, 2),(12, 319, 1, 1, 2),(12, 320, 1, 1, 2),(12, 321, 1, 1, 1),(12, 322, 1, 1, 1),(12, 323, 1, 1, 1),(12, 324, 1, 1, 1),(12, 325, 1, 1, 1),(12, 326, 1, 1, 1),(12, 327, 1, 1, 1),(12, 328, 1, 1, 1),(12, 329, 1, 1, 1),(12, 330, 1, 1, 1),(12, 331, 1, 1, 1),(12, 332, 1, 1, 1),(12, 333, 1, 1, 1),(12, 334, 1, 1, 1),(12, 335, 1, 1, 1),(12, 336, 1, 1, 1),(12, 337, 1, 1, 2),(12, 338, 1, 1, 2),(12, 339, 1, 1, 2),(12, 340, 1, 1, 2),(12, 341, 1, 1, 2),(12, 342, 1, 1, 2),(12, 343, 1, 1, 2),(12, 344, 1, 1, 2),(12, 345, 1, 1, 2),(12, 346, 1, 1, 2),(12, 347, 1, 1, 2),(12, 348, 1, 1, 2),(12, 349, 1, 1, 2),(12, 350, 1, 1, 2),(12, 351, 1, 1, 2),(12, 352, 1, 1, 2),(12, 353, 2, 1, 1),(12, 354, 2, 1, 1),(12, 355, 2, 1, 1),(12, 356, 2, 1, 1),(12, 357, 2, 1, 1),(12, 358, 2, 1, 1),(12, 359, 2, 1, 1),(12, 360, 2, 1, 1),(12, 361, 3, 1, 1),(12, 362, 3, 1, 1),(12, 363, 3, 1, 1),(12, 364, 3, 1, 1),(12, 365, 4, 1, 1),(12, 366, 4, 1, 1),(12, 367, 4, 1, 1),(12, 368, 4, 1, 1),(12, 369, 2, 1, 2),(12, 370, 2, 1, 2),(12, 371, 2, 1, 2),(12, 372, 2, 1, 2),(12, 373, 2, 1, 2),(12, 374, 2, 1, 2),(12, 375, 2, 1, 2),(12, 376, 2, 1, 2),(12, 377, 3, 1, 2),(12, 378, 3, 1, 2),(12, 379, 3, 1, 2),(12, 380, 3, 1, 2),(12, 381, 4, 1, 2),(12, 382, 4, 1, 2),(12, 383, 4, 1, 2),(12, 384, 4, 1, 2),(13, 1, 1, 1, 1),(13, 2, 1, 1, 1),(13, 3, 1, 1, 1),(13, 4, 1, 1, 1),(13, 5, 1, 1, 1),(13, 6, 1, 1, 1),(13, 7, 1, 1, 1),(13, 8, 1, 1, 1),(13, 9, 1, 1, 1),(13, 10, 1, 1, 1),(13, 11, 1, 1, 1),(13, 12, 1, 1, 1),(13, 13, 1, 1, 1),(13, 14, 1, 1, 1),(13, 15, 1, 1, 1),(13, 16, 1, 1, 1),(13, 17, 1, 1, 1),(13, 18, 1, 1, 1),(13, 19, 1, 1, 1),(13, 20, 1, 1, 1),(13, 21, 1, 1, 1),(13, 22, 1, 1, 1),(13, 23, 1, 1, 1),(13, 24, 1, 1, 1),(13, 25, 1, 1, 1),(13, 26, 1, 1, 1),(13, 27, 1, 1, 1),(13, 28, 1, 1, 1),(13, 29, 1, 1, 1),(13, 30, 1, 1, 1),(13, 31, 1, 1, 1),(13, 32, 1, 1, 1),(13, 33, 1, 1, 1),(13, 34, 1, 1, 1),(13, 35, 1, 1, 1),(13, 36, 1, 1, 1),(13, 37, 1, 1, 1),(13, 38, 1, 1, 1),(13, 39, 1, 1, 1),(13, 40, 1, 1, 1),(13, 41, 1, 1, 1),(13, 42, 1, 1, 1),(13, 43, 1, 1, 1),(13, 44, 1, 1, 1),(13, 45, 1, 1, 1),(13, 46, 1, 1, 1),(13, 47, 1, 1, 1),(13, 48, 1, 1, 1),(13, 49, 1, 1, 1),(13, 50, 1, 1, 1),(13, 51, 1, 1, 1),(13, 52, 1, 1, 1),(13, 53, 1, 1, 1),(13, 54, 1, 1, 1),(13, 55, 1, 1, 1),(13, 56, 1, 1, 1),(13, 57, 1, 1, 1),(13, 58, 1, 1, 1),(13, 59, 1, 1, 1),(13, 60, 1, 1, 1),(13, 61, 1, 1, 1),(13, 62, 1, 1, 1),(13, 63, 1, 1, 1),(13, 64, 1, 1, 1),(13, 65, 1, 1, 1),(13, 66, 1, 1, 1),(13, 67, 1, 1, 1),(13, 68, 1, 1, 1),(13, 69, 1, 1, 1),(13, 70, 1, 1, 1),(13, 71, 1, 1, 1),(13, 72, 1, 1, 1),(13, 73, 1, 1, 1),(13, 74, 1, 1, 1),(13, 75, 1, 1, 1),(13, 76, 1, 1, 1),(13, 77, 1, 1, 1),(13, 78, 1, 1, 1),(13, 79, 1, 1, 1),(13, 80, 1, 1, 1),(13, 81, 1, 1, 1),(13, 82, 1, 1, 1),(13, 83, 1, 1, 1),(13, 84, 1, 1, 1),(13, 85, 1, 1, 1),(13, 86, 1, 1, 1),(13, 87, 1, 1, 1),(13, 88, 1, 1, 1),(13, 89, 1, 1, 1),(13, 90, 1, 1, 1),(13, 91, 1, 1, 1),(13, 92, 1, 1, 1),(13, 93, 1, 1, 1),(13, 94, 1, 1, 1),(13, 95, 1, 1, 1),(13, 96, 1, 1, 1),(13, 97, 1, 1, 1),(13, 98, 1, 1, 1),(13, 99, 1, 1, 1),(13, 100, 1, 1, 1),(13, 101, 1, 1, 1),(13, 102, 1, 1, 1),(13, 103, 1, 1, 1),(13, 104, 1, 1, 1),(13, 105, 1, 1, 1),(13, 106, 1, 1, 1),(13, 107, 1, 1, 1),(13, 108, 1, 1, 1),(13, 109, 1, 1, 1),(13, 110, 1, 1, 1),(13, 111, 1, 1, 1),(13, 112, 1, 1, 1),(13, 113, 1, 1, 1),(13, 114, 1, 1, 1),(13, 115, 1, 1, 1),(13, 116, 1, 1, 1),(13, 117, 1, 1, 1),(13, 118, 1, 1, 1),(13, 119, 1, 1, 1),(13, 120, 1, 1, 1),(13, 121, 1, 1, 1),(13, 122, 1, 1, 1),(13, 123, 1, 1, 1),(13, 124, 1, 1, 1),(13, 125, 1, 1, 1),(13, 126, 1, 1, 1),(13, 127, 1, 1, 1),(13, 128, 1, 1, 1),(13, 129, 1, 1, 1),(13, 130, 1, 1, 1),(13, 131, 1, 1, 1),(13, 132, 1, 1, 1),(13, 133, 1, 1, 1),(13, 134, 1, 1, 1),(13, 135, 1, 1, 1),(13, 136, 1, 1, 1),(13, 137, 1, 1, 1),(13, 138, 1, 1, 1),(13, 139, 1, 1, 1),(13, 140, 1, 1, 1),(13, 141, 1, 1, 1),(13, 142, 1, 1, 1),(13, 143, 1, 1, 1),(13, 144, 1, 1, 1),(13, 145, 1, 1, 1),(13, 146, 1, 1, 1),(13, 147, 1, 1, 1),(13, 148, 1, 1, 1),(13, 149, 1, 1, 1),(13, 150, 1, 1, 1),(13, 151, 1, 1, 1),(13, 152, 1, 1, 1),(13, 153, 1, 1, 1),(13, 154, 1, 1, 1),(13, 155, 1, 1, 1),(13, 156, 1, 1, 1),(13, 157, 1, 1, 1),(13, 158, 1, 1, 1),(13, 159, 1, 1, 1),(13, 160, 1, 1, 1),(13, 161, 1, 1, 1),(13, 162, 1, 1, 1),(13, 163, 1, 1, 1),(13, 164, 1, 1, 1),(13, 165, 1, 1, 1),(13, 166, 1, 1, 1),(13, 167, 1, 1, 1),(13, 168, 1, 1, 1),(13, 169, 1, 1, 1),(13, 170, 1, 1, 1),(13, 171, 1, 1, 1),(13, 172, 1, 1, 1),(13, 173, 1, 1, 1),(13, 174, 1, 1, 1),(13, 175, 1, 1, 1),(13, 176, 1, 1, 1),(13, 177, 1, 1, 1),(13, 178, 1, 1, 1),(13, 179, 1, 1, 1),(13, 180, 1, 1, 1),(13, 181, 1, 1, 1),(13, 182, 1, 1, 1),(13, 183, 1, 1, 1),(13, 184, 1, 1, 1),(13, 185, 1, 1, 1),(13, 186, 1, 1, 1),(13, 187, 1, 1, 1),(13, 188, 1, 1, 1),(13, 189, 1, 1, 1),(13, 190, 1, 1, 1),(13, 191, 1, 1, 1),(13, 192, 1, 1, 1),(13, 193, 1, 1, 1),(13, 194, 1, 1, 1),(13, 195, 1, 1, 1),(13, 196, 1, 1, 1),(13, 197, 1, 1, 1),(13, 198, 1, 1, 1),(13, 199, 1, 1, 1),(13, 200, 1, 1, 1),(13, 201, 1, 1, 1),(13, 202, 1, 1, 1),(13, 203, 1, 1, 1),(13, 204, 1, 1, 1),(13, 205, 1, 1, 1),(13, 206, 1, 1, 1),(13, 207, 1, 1, 1),(13, 208, 1, 1, 1),(13, 209, 1, 1, 1),(13, 210, 1, 1, 1),(13, 211, 1, 1, 1),(13, 212, 1, 1, 1),(13, 213, 1, 1, 1),(13, 214, 1, 1, 1),(13, 215, 1, 1, 1),(13, 216, 1, 1, 1),(13, 217, 1, 1, 1),(13, 218, 1, 1, 1),(13, 219, 1, 1, 1),(13, 220, 1, 1, 1),(13, 221, 1, 1, 1),(13, 222, 1, 1, 1),(13, 223, 1, 1, 1),(13, 224, 1, 1, 1),(13, 225, 1, 1, 1),(13, 226, 1, 1, 1),(13, 227, 1, 1, 1),(13, 228, 1, 1, 1),(13, 229, 1, 1, 1),(13, 230, 1, 1, 1),(13, 231, 1, 1, 1),(13, 232, 1, 1, 1),(13, 233, 1, 1, 1),(13, 234, 1, 1, 1),(13, 235, 1, 1, 1),(13, 236, 1, 1, 1),(13, 237, 1, 1, 1),(13, 238, 1, 1, 1),(13, 239, 1, 1, 1),(13, 240, 1, 1, 1),(13, 241, 1, 1, 1),(13, 242, 1, 1, 1),(13, 243, 1, 1, 1),(13, 244, 1, 1, 1),(13, 245, 1, 1, 1),(13, 246, 1, 1, 1),(13, 247, 1, 1, 1),(13, 248, 1, 1, 1),(13, 249, 1, 1, 1),(13, 250, 1, 1, 1),(13, 251, 1, 1, 1),(13, 252, 1, 1, 1),(13, 253, 1, 1, 1),(13, 254, 1, 1, 1),(13, 255, 1, 1, 1),(13, 256, 1, 1, 1),(13, 257, 1, 1, 1),(13, 258, 1, 1, 1),(13, 259, 1, 1, 1),(13, 260, 1, 1, 1),(13, 261, 1, 1, 1),(13, 262, 1, 1, 1),(13, 263, 1, 1, 1),(13, 264, 1, 1, 1),(13, 265, 1, 1, 1),(13, 266, 1, 1, 1),(13, 267, 1, 1, 1),(13, 268, 1, 1, 1),(13, 269, 1, 1, 1),(13, 270, 1, 1, 1),(13, 271, 1, 1, 1),(13, 272, 1, 1, 1),(13, 273, 1, 1, 1),(13, 274, 1, 1, 1),(13, 275, 1, 1, 1),(13, 276, 1, 1, 1),(13, 277, 1, 1, 1),(13, 278, 1, 1, 1),(13, 279, 1, 1, 1),(13, 280, 1, 1, 1),(13, 281, 1, 1, 1),(13, 282, 1, 1, 1),(13, 283, 1, 1, 1),(13, 284, 1, 1, 1),(13, 285, 1, 1, 1),(13, 286, 1, 1, 1),(13, 287, 1, 1, 1),(13, 288, 1, 1, 1),(13, 289, 1, 1, 1),(13, 290, 1, 1, 1),(13, 291, 1, 1, 1),(13, 292, 1, 1, 1),(13, 293, 1, 1, 1),(13, 294, 1, 1, 1),(13, 295, 1, 1, 1),(13, 296, 1, 1, 1),(13, 297, 1, 1, 1),(13, 298, 1, 1, 1),(13, 299, 1, 1, 1),(13, 300, 1, 1, 1),(13, 301, 1, 1, 1),(13, 302, 1, 1, 1),(13, 303, 1, 1, 1),(13, 304, 1, 1, 1),(13, 305, 1, 1, 1),(13, 306, 1, 1, 1),(13, 307, 1, 1, 1),(13, 308, 1, 1, 1),(13, 309, 1, 1, 1),(13, 310, 1, 1, 1),(13, 311, 1, 1, 1),(13, 312, 1, 1, 1),(13, 313, 1, 1, 1),(13, 314, 1, 1, 1),(13, 315, 1, 1, 1),(13, 316, 1, 1, 1),(13, 317, 1, 1, 1),(13, 318, 1, 1, 1),(13, 319, 1, 1, 1),(13, 320, 1, 1, 1),(13, 321, 1, 1, 1),(13, 322, 1, 1, 1),(13, 323, 1, 1, 1),(13, 324, 1, 1, 1),(13, 325, 1, 1, 1),(13, 326, 1, 1, 1),(13, 327, 1, 1, 1),(13, 328, 1, 1, 1),(13, 329, 1, 1, 1),(13, 330, 1, 1, 1),(13, 331, 1, 1, 1),(13, 332, 1, 1, 1),(13, 333, 1, 1, 1),(13, 334, 1, 1, 1),(13, 335, 1, 1, 1),(13, 336, 1, 1, 1),(13, 337, 1, 1, 1),(13, 338, 1, 1, 1),(13, 339, 1, 1, 1),(13, 340, 1, 1, 1),(13, 341, 1, 1, 1),(13, 342, 1, 1, 1),(13, 343, 1, 1, 1),(13, 344, 1, 1, 1),(13, 345, 1, 1, 1),(13, 346, 1, 1, 1),(13, 347, 1, 1, 1),(13, 348, 1, 1, 1),(13, 349, 1, 1, 1),(13, 350, 1, 1, 1),(13, 351, 1, 1, 1),(13, 352, 1, 1, 1),(13, 353, 1, 1, 1),(13, 354, 1, 1, 1),(13, 355, 1, 1, 1),(13, 356, 1, 1, 1),(13, 357, 1, 1, 1),(13, 358, 1, 1, 1),(13, 359, 1, 1, 1),(13, 360, 1, 1, 1),(13, 361, 1, 1, 1),(13, 362, 1, 1, 1),(13, 363, 1, 1, 1),(13, 364, 1, 1, 1),(13, 365, 1, 1, 1),(13, 366, 1, 1, 1),(13, 367, 1, 1, 1),(13, 368, 1, 1, 1),(13, 369, 1, 1, 1),(13, 370, 1, 1, 1),(13, 371, 1, 1, 1),(13, 372, 1, 1, 1),(13, 373, 1, 1, 1),(13, 374, 1, 1, 1),(13, 375, 1, 1, 1),(13, 376, 1, 1, 1),(13, 377, 2, 1, 1),(13, 378, 2, 1, 1),(13, 379, 2, 1, 1),(13, 380, 2, 1, 1),(13, 381, 3, 1, 1),(13, 382, 3, 1, 1),(13, 383, 4, 1, 1),(13, 384, 4, 1, 1),(14, 1, 1, 1, 1),(14, 2, 1, 3, 1),(14, 3, 1, 1, 1),(14, 4, 1, 3, 1),(14, 5, 1, 1, 1),(14, 6, 1, 3, 1),(14, 7, 1, 1, 1),(14, 8, 1, 3, 1),(14, 9, 1, 1, 1),(14, 10, 1, 3, 1),(14, 11, 1, 1, 1),(14, 12, 1, 3, 1),(14, 13, 1, 1, 1),(14, 14, 1, 3, 1),(14, 15, 1, 1, 1),(14, 16, 1, 3, 1),(14, 17, 1, 1, 1),(14, 18, 1, 3, 1),(14, 19, 1, 1, 1),(14, 20, 1, 3, 1),(14, 21, 1, 1, 1),(14, 22, 1, 3, 1),(14, 23, 1, 1, 1),(14, 24, 1, 3, 1),(14, 25, 1, 1, 1),(14, 26, 1, 3, 1),(14, 27, 1, 1, 1),(14, 28, 1, 3, 1),(14, 29, 1, 1, 1),(14, 30, 1, 3, 1),(14, 31, 1, 1, 1),(14, 32, 1, 3, 1),(14, 33, 1, 2, 1),(14, 34, 1, 4, 1),(14, 35, 1, 2, 1),(14, 36, 1, 4, 1),(14, 37, 1, 2, 1),(14, 38, 1, 4, 1),(14, 39, 1, 2, 1),(14, 40, 1, 4, 1),(14, 41, 1, 2, 1),(14, 42, 1, 4, 1),(14, 43, 1, 2, 1),(14, 44, 1, 4, 1),(14, 45, 1, 2, 1),(14, 46, 1, 4, 1),(14, 47, 1, 2, 1),(14, 48, 1, 4, 1),(14, 49, 1, 2, 1),(14, 50, 1, 4, 1),(14, 51, 1, 2, 1),(14, 52, 1, 4, 1),(14, 53, 1, 2, 1),(14, 54, 1, 4, 1),(14, 55, 1, 2, 1),(14, 56, 1, 4, 1),(14, 57, 1, 2, 1),(14, 58, 1, 4, 1),(14, 59, 1, 2, 1),(14, 60, 1, 4, 1),(14, 61, 1, 2, 1),(14, 62, 1, 4, 1),(14, 63, 1, 2, 1),(14, 64, 1, 4, 1),(14, 65, 1, 1, 1),(14, 66, 1, 3, 1),(14, 67, 1, 1, 1),(14, 68, 1, 3, 1),(14, 69, 1, 1, 1),(14, 70, 1, 3, 1),(14, 71, 1, 1, 1),(14, 72, 1, 3, 1),(14, 73, 1, 1, 1),(14, 74, 1, 3, 1),(14, 75, 1, 1, 1),(14, 76, 1, 3, 1),(14, 77, 1, 1, 1),(14, 78, 1, 3, 1),(14, 79, 1, 1, 1),(14, 80, 1, 3, 1),(14, 81, 1, 1, 1),(14, 82, 1, 3, 1),(14, 83, 1, 1, 1),(14, 84, 1, 3, 1),(14, 85, 1, 1, 1),(14, 86, 1, 3, 1),(14, 87, 1, 1, 1),(14, 88, 1, 3, 1),(14, 89, 1, 1, 1),(14, 90, 1, 3, 1),(14, 91, 1, 1, 1),(14, 92, 1, 3, 1),(14, 93, 1, 1, 1),(14, 94, 1, 3, 1),(14, 95, 1, 1, 1),(14, 96, 1, 3, 1),(14, 97, 1, 2, 1),(14, 98, 1, 4, 1),(14, 99, 1, 2, 1),(14, 100, 1, 4, 1),(14, 101, 1, 2, 1),(14, 102, 1, 4, 1),(14, 103, 1, 2, 1),(14, 104, 1, 4, 1),(14, 105, 1, 2, 1),(14, 106, 1, 4, 1),(14, 107, 1, 2, 1),(14, 108, 1, 4, 1),(14, 109, 1, 2, 1),(14, 110, 1, 4, 1),(14, 111, 1, 2, 1),(14, 112, 1, 4, 1),(14, 113, 1, 2, 1),(14, 114, 1, 4, 1),(14, 115, 1, 2, 1),(14, 116, 1, 4, 1),(14, 117, 1, 2, 1),(14, 118, 1, 4, 1),(14, 119, 1, 2, 1),(14, 120, 1, 4, 1),(14, 121, 1, 2, 1),(14, 122, 1, 4, 1),(14, 123, 1, 2, 1),(14, 124, 1, 4, 1),(14, 125, 1, 2, 1),(14, 126, 1, 4, 1),(14, 127, 1, 2, 1),(14, 128, 1, 4, 1),(14, 129, 1, 1, 1),(14, 130, 1, 3, 1),(14, 131, 1, 1, 1),(14, 132, 1, 3, 1),(14, 133, 1, 1, 1),(14, 134, 1, 3, 1),(14, 135, 1, 1, 1),(14, 136, 1, 3, 1),(14, 137, 1, 1, 1),(14, 138, 1, 3, 1),(14, 139, 1, 1, 1),(14, 140, 1, 3, 1),(14, 141, 1, 1, 1),(14, 142, 1, 3, 1),(14, 143, 1, 1, 1),(14, 144, 1, 3, 1),(14, 145, 1, 1, 1),(14, 146, 1, 3, 1),(14, 147, 1, 1, 1),(14, 148, 1, 3, 1),(14, 149, 1, 1, 1),(14, 150, 1, 3, 1),(14, 151, 1, 1, 1),(14, 152, 1, 3, 1),(14, 153, 1, 1, 1),(14, 154, 1, 3, 1),(14, 155, 1, 1, 1),(14, 156, 1, 3, 1),(14, 157, 1, 1, 1),(14, 158, 1, 3, 1),(14, 159, 1, 1, 1),(14, 160, 1, 3, 1),(14, 161, 1, 2, 1),(14, 162, 1, 4, 1),(14, 163, 1, 2, 1),(14, 164, 1, 4, 1),(14, 165, 1, 2, 1),(14, 166, 1, 4, 1),(14, 167, 1, 2, 1),(14, 168, 1, 4, 1),(14, 169, 1, 2, 1),(14, 170, 1, 4, 1),(14, 171, 1, 2, 1),(14, 172, 1, 4, 1),(14, 173, 1, 2, 1),(14, 174, 1, 4, 1),(14, 175, 1, 2, 1),(14, 176, 1, 4, 1),(14, 177, 1, 2, 1),(14, 178, 1, 4, 1),(14, 179, 1, 2, 1),(14, 180, 1, 4, 1),(14, 181, 1, 2, 1),(14, 182, 1, 4, 1),(14, 183, 1, 2, 1),(14, 184, 1, 4, 1),(14, 185, 1, 2, 1),(14, 186, 1, 4, 1),(14, 187, 1, 2, 1),(14, 188, 1, 4, 1),(14, 189, 1, 2, 1),(14, 190, 1, 4, 1),(14, 191, 1, 2, 1),(14, 192, 1, 4, 1),(14, 193, 1, 1, 1),(14, 194, 1, 3, 1),(14, 195, 1, 1, 1),(14, 196, 1, 3, 1),(14, 197, 1, 1, 1),(14, 198, 1, 3, 1),(14, 199, 1, 1, 1),(14, 200, 1, 3, 1),(14, 201, 1, 1, 1),(14, 202, 1, 3, 1),(14, 203, 1, 1, 1),(14, 204, 1, 3, 1),(14, 205, 1, 1, 1),(14, 206, 1, 3, 1),(14, 207, 1, 1, 1),(14, 208, 1, 3, 1),(14, 209, 1, 1, 1),(14, 210, 1, 3, 1),(14, 211, 1, 1, 1),(14, 212, 1, 3, 1),(14, 213, 1, 1, 1),(14, 214, 1, 3, 1),(14, 215, 1, 1, 1),(14, 216, 1, 3, 1),(14, 217, 1, 1, 1),(14, 218, 1, 3, 1),(14, 219, 1, 1, 1),(14, 220, 1, 3, 1),(14, 221, 1, 1, 1),(14, 222, 1, 3, 1),(14, 223, 1, 1, 1),(14, 224, 1, 3, 1),(14, 225, 1, 2, 1),(14, 226, 1, 4, 1),(14, 227, 1, 2, 1),(14, 228, 1, 4, 1),(14, 229, 1, 2, 1),(14, 230, 1, 4, 1),(14, 231, 1, 2, 1),(14, 232, 1, 4, 1),(14, 233, 1, 2, 1),(14, 234, 1, 4, 1),(14, 235, 1, 2, 1),(14, 236, 1, 4, 1),(14, 237, 1, 2, 1),(14, 238, 1, 4, 1),(14, 239, 1, 2, 1),(14, 240, 1, 4, 1),(14, 241, 1, 2, 1),(14, 242, 1, 4, 1),(14, 243, 1, 2, 1),(14, 244, 1, 4, 1),(14, 245, 1, 2, 1),(14, 246, 1, 4, 1),(14, 247, 1, 2, 1),(14, 248, 1, 4, 1),(14, 249, 1, 2, 1),(14, 250, 1, 4, 1),(14, 251, 1, 2, 1),(14, 252, 1, 4, 1),(14, 253, 1, 2, 1),(14, 254, 1, 4, 1),(14, 255, 1, 2, 1),(14, 256, 1, 4, 1),(14, 257, 1, 1, 1),(14, 258, 1, 3, 1),(14, 259, 1, 1, 1),(14, 260, 1, 3, 1),(14, 261, 1, 1, 1),(14, 262, 1, 3, 1),(14, 263, 1, 1, 1),(14, 264, 1, 3, 1),(14, 265, 1, 1, 1),(14, 266, 1, 3, 1),(14, 267, 1, 1, 1),(14, 268, 1, 3, 1),(14, 269, 1, 1, 1),(14, 270, 1, 3, 1),(14, 271, 1, 1, 1),(14, 272, 1, 3, 1),(14, 273, 1, 1, 1),(14, 274, 1, 3, 1),(14, 275, 1, 1, 1),(14, 276, 1, 3, 1),(14, 277, 1, 1, 1),(14, 278, 1, 3, 1),(14, 279, 1, 1, 1),(14, 280, 1, 3, 1),(14, 281, 1, 1, 1),(14, 282, 1, 3, 1),(14, 283, 1, 1, 1),(14, 284, 1, 3, 1),(14, 285, 1, 1, 1),(14, 286, 1, 3, 1),(14, 287, 1, 1, 1),(14, 288, 1, 3, 1),(14, 289, 1, 2, 1),(14, 290, 1, 4, 1),(14, 291, 1, 2, 1),(14, 292, 1, 4, 1),(14, 293, 1, 2, 1),(14, 294, 1, 4, 1),(14, 295, 1, 2, 1),(14, 296, 1, 4, 1),(14, 297, 1, 2, 1),(14, 298, 1, 4, 1),(14, 299, 1, 2, 1),(14, 300, 1, 4, 1),(14, 301, 1, 2, 1),(14, 302, 1, 4, 1),(14, 303, 1, 2, 1),(14, 304, 1, 4, 1),(14, 305, 1, 2, 1),(14, 306, 1, 4, 1),(14, 307, 1, 2, 1),(14, 308, 1, 4, 1),(14, 309, 1, 2, 1),(14, 310, 1, 4, 1),(14, 311, 1, 2, 1),(14, 312, 1, 4, 1),(14, 313, 1, 2, 1),(14, 314, 1, 4, 1),(14, 315, 1, 2, 1),(14, 316, 1, 4, 1),(14, 317, 1, 2, 1),(14, 318, 1, 4, 1),(14, 319, 1, 2, 1),(14, 320, 1, 4, 1),(14, 321, 1, 1, 1),(14, 322, 1, 3, 1),(14, 323, 1, 1, 1),(14, 324, 1, 3, 1),(14, 325, 1, 1, 1),(14, 326, 1, 3, 1),(14, 327, 1, 1, 1),(14, 328, 1, 3, 1),(14, 329, 1, 1, 1),(14, 330, 1, 3, 1),(14, 331, 1, 1, 1),(14, 332, 1, 3, 1),(14, 333, 1, 1, 1),(14, 334, 1, 3, 1),(14, 335, 1, 1, 1),(14, 336, 1, 3, 1),(14, 337, 1, 1, 1),(14, 338, 1, 3, 1),(14, 339, 1, 1, 1),(14, 340, 1, 3, 1),(14, 341, 1, 1, 1),(14, 342, 1, 3, 1),(14, 343, 1, 1, 1),(14, 344, 1, 3, 1),(14, 345, 1, 1, 1),(14, 346, 1, 3, 1),(14, 347, 1, 1, 1),(14, 348, 1, 3, 1),(14, 349, 1, 1, 1),(14, 350, 1, 3, 1),(14, 351, 1, 1, 1),(14, 352, 1, 3, 1),(14, 353, 1, 2, 1),(14, 354, 1, 4, 1),(14, 355, 1, 2, 1),(14, 356, 1, 4, 1),(14, 357, 1, 2, 1),(14, 358, 1, 4, 1),(14, 359, 1, 2, 1),(14, 360, 1, 4, 1),(14, 361, 1, 2, 1),(14, 362, 1, 4, 1),(14, 363, 1, 2, 1),(14, 364, 1, 4, 1),(14, 365, 1, 2, 1),(14, 366, 1, 4, 1),(14, 367, 1, 2, 1),(14, 368, 1, 4, 1),(14, 369, 1, 2, 1),(14, 370, 1, 4, 1),(14, 371, 1, 2, 1),(14, 372, 1, 4, 1),(14, 373, 1, 2, 1),(14, 374, 1, 4, 1),(14, 375, 1, 2, 1),(14, 376, 1, 4, 1),(14, 377, 1, 2, 1),(14, 378, 1, 4, 1),(14, 379, 1, 2, 1),(14, 380, 1, 4, 1),(14, 381, 1, 2, 1),(14, 382, 1, 4, 1),(14, 383, 1, 2, 1),(14, 384, 1, 4, 1),(14, 385, 1, 1, 1),(14, 386, 1, 3, 1),(14, 387, 1, 1, 1),(14, 388, 1, 3, 1),(14, 389, 1, 1, 1),(14, 390, 1, 3, 1),(14, 391, 1, 1, 1),(14, 392, 1, 3, 1),(14, 393, 1, 1, 1),(14, 394, 1, 3, 1),(14, 395, 1, 1, 1),(14, 396, 1, 3, 1),(14, 397, 1, 1, 1),(14, 398, 1, 3, 1),(14, 399, 1, 1, 1),(14, 400, 1, 3, 1),(14, 401, 1, 1, 1),(14, 402, 1, 3, 1),(14, 403, 1, 1, 1),(14, 404, 1, 3, 1),(14, 405, 1, 1, 1),(14, 406, 1, 3, 1),(14, 407, 1, 1, 1),(14, 408, 1, 3, 1),(14, 409, 1, 1, 1),(14, 410, 1, 3, 1),(14, 411, 1, 1, 1),(14, 412, 1, 3, 1),(14, 413, 1, 1, 1),(14, 414, 1, 3, 1),(14, 415, 1, 1, 1),(14, 416, 1, 3, 1),(14, 417, 1, 2, 1),(14, 418, 1, 4, 1),(14, 419, 1, 2, 1),(14, 420, 1, 4, 1),(14, 421, 1, 2, 1),(14, 422, 1, 4, 1),(14, 423, 1, 2, 1),(14, 424, 1, 4, 1),(14, 425, 1, 2, 1),(14, 426, 1, 4, 1),(14, 427, 1, 2, 1),(14, 428, 1, 4, 1),(14, 429, 1, 2, 1),(14, 430, 1, 4, 1),(14, 431, 1, 2, 1),(14, 432, 1, 4, 1),(14, 433, 1, 2, 1),(14, 434, 1, 4, 1),(14, 435, 1, 2, 1),(14, 436, 1, 4, 1),(14, 437, 1, 2, 1),(14, 438, 1, 4, 1),(14, 439, 1, 2, 1),(14, 440, 1, 4, 1),(14, 441, 1, 2, 1),(14, 442, 1, 4, 1),(14, 443, 1, 2, 1),(14, 444, 1, 4, 1),(14, 445, 1, 2, 1),(14, 446, 1, 4, 1),(14, 447, 1, 2, 1),(14, 448, 1, 4, 1),(14, 449, 1, 1, 1),(14, 450, 1, 3, 1),(14, 451, 1, 1, 1),(14, 452, 1, 3, 1),(14, 453, 1, 1, 1),(14, 454, 1, 3, 1),(14, 455, 1, 1, 1),(14, 456, 1, 3, 1),(14, 457, 1, 1, 1),(14, 458, 1, 3, 1),(14, 459, 1, 1, 1),(14, 460, 1, 3, 1),(14, 461, 1, 1, 1),(14, 462, 1, 3, 1),(14, 463, 1, 1, 1),(14, 464, 1, 3, 1),(14, 465, 1, 1, 1),(14, 466, 1, 3, 1),(14, 467, 1, 1, 1),(14, 468, 1, 3, 1),(14, 469, 1, 1, 1),(14, 470, 1, 3, 1),(14, 471, 1, 1, 1),(14, 472, 1, 3, 1),(14, 473, 1, 1, 1),(14, 474, 1, 3, 1),(14, 475, 1, 1, 1),(14, 476, 1, 3, 1),(14, 477, 1, 1, 1),(14, 478, 1, 3, 1),(14, 479, 1, 1, 1),(14, 480, 1, 3, 1),(14, 481, 1, 2, 1),(14, 482, 1, 4, 1),(14, 483, 1, 2, 1),(14, 484, 1, 4, 1),(14, 485, 1, 2, 1),(14, 486, 1, 4, 1),(14, 487, 1, 2, 1),(14, 488, 1, 4, 1),(14, 489, 1, 2, 1),(14, 490, 1, 4, 1),(14, 491, 1, 2, 1),(14, 492, 1, 4, 1),(14, 493, 1, 2, 1),(14, 494, 1, 4, 1),(14, 495, 1, 2, 1),(14, 496, 1, 4, 1),(14, 497, 1, 2, 1),(14, 498, 1, 4, 1),(14, 499, 1, 2, 1),(14, 500, 1, 4, 1),(14, 501, 1, 2, 1),(14, 502, 1, 4, 1),(14, 503, 1, 2, 1),(14, 504, 1, 4, 1),(14, 505, 1, 2, 1),(14, 506, 1, 4, 1),(14, 507, 1, 2, 1),(14, 508, 1, 4, 1),(14, 509, 1, 2, 1),(14, 510, 1, 4, 1),(14, 511, 1, 2, 1),(14, 512, 1, 4, 1),(14, 513, 1, 1, 1),(14, 514, 1, 3, 1),(14, 515, 1, 1, 1),(14, 516, 1, 3, 1),(14, 517, 1, 1, 1),(14, 518, 1, 3, 1),(14, 519, 1, 1, 1),(14, 520, 1, 3, 1),(14, 521, 1, 1, 1),(14, 522, 1, 3, 1),(14, 523, 1, 1, 1),(14, 524, 1, 3, 1),(14, 525, 1, 1, 1),(14, 526, 1, 3, 1),(14, 527, 1, 1, 1),(14, 528, 1, 3, 1),(14, 529, 1, 1, 1),(14, 530, 1, 3, 1),(14, 531, 1, 1, 1),(14, 532, 1, 3, 1),(14, 533, 1, 1, 1),(14, 534, 1, 3, 1),(14, 535, 1, 1, 1),(14, 536, 1, 3, 1),(14, 537, 1, 1, 1),(14, 538, 1, 3, 1),(14, 539, 1, 1, 1),(14, 540, 1, 3, 1),(14, 541, 1, 1, 1),(14, 542, 1, 3, 1),(14, 543, 1, 1, 1),(14, 544, 1, 3, 1),(14, 545, 1, 2, 1),(14, 546, 1, 4, 1),(14, 547, 1, 2, 1),(14, 548, 1, 4, 1),(14, 549, 1, 2, 1),(14, 550, 1, 4, 1),(14, 551, 1, 2, 1),(14, 552, 1, 4, 1),(14, 553, 1, 2, 1),(14, 554, 1, 4, 1),(14, 555, 1, 2, 1),(14, 556, 1, 4, 1),(14, 557, 1, 2, 1),(14, 558, 1, 4, 1),(14, 559, 1, 2, 1),(14, 560, 1, 4, 1),(14, 561, 1, 2, 1),(14, 562, 1, 4, 1),(14, 563, 1, 2, 1),(14, 564, 1, 4, 1),(14, 565, 1, 2, 1),(14, 566, 1, 4, 1),(14, 567, 1, 2, 1),(14, 568, 1, 4, 1),(14, 569, 1, 2, 1),(14, 570, 1, 4, 1),(14, 571, 1, 2, 1),(14, 572, 1, 4, 1),(14, 573, 1, 2, 1),(14, 574, 1, 4, 1),(14, 575, 1, 2, 1),(14, 576, 1, 4, 1),(14, 577, 1, 1, 1),(14, 578, 1, 3, 1),(14, 579, 1, 1, 1),(14, 580, 1, 3, 1),(14, 581, 1, 1, 1),(14, 582, 1, 3, 1),(14, 583, 1, 1, 1),(14, 584, 1, 3, 1),(14, 585, 1, 1, 1),(14, 586, 1, 3, 1),(14, 587, 1, 1, 1),(14, 588, 1, 3, 1),(14, 589, 1, 1, 1),(14, 590, 1, 3, 1),(14, 591, 1, 1, 1),(14, 592, 1, 3, 1),(14, 593, 1, 1, 1),(14, 594, 1, 3, 1),(14, 595, 1, 1, 1),(14, 596, 1, 3, 1),(14, 597, 1, 1, 1),(14, 598, 1, 3, 1),(14, 599, 1, 1, 1),(14, 600, 1, 3, 1),(14, 601, 1, 1, 1),(14, 602, 1, 3, 1),(14, 603, 1, 1, 1),(14, 604, 1, 3, 1),(14, 605, 1, 1, 1),(14, 606, 1, 3, 1),(14, 607, 1, 1, 1),(14, 608, 1, 3, 1),(14, 609, 1, 2, 1),(14, 610, 1, 4, 1),(14, 611, 1, 2, 1),(14, 612, 1, 4, 1),(14, 613, 1, 2, 1),(14, 614, 1, 4, 1),(14, 615, 1, 2, 1),(14, 616, 1, 4, 1),(14, 617, 1, 2, 1),(14, 618, 1, 4, 1),(14, 619, 1, 2, 1),(14, 620, 1, 4, 1),(14, 621, 1, 2, 1),(14, 622, 1, 4, 1),(14, 623, 1, 2, 1),(14, 624, 1, 4, 1),(14, 625, 1, 2, 1),(14, 626, 1, 4, 1),(14, 627, 1, 2, 1),(14, 628, 1, 4, 1),(14, 629, 1, 2, 1),(14, 630, 1, 4, 1),(14, 631, 1, 2, 1),(14, 632, 1, 4, 1),(14, 633, 1, 2, 1),(14, 634, 1, 4, 1),(14, 635, 1, 2, 1),(14, 636, 1, 4, 1),(14, 637, 1, 2, 1),(14, 638, 1, 4, 1),(14, 639, 1, 2, 1),(14, 640, 1, 4, 1),(14, 641, 1, 1, 1),(14, 642, 1, 3, 1),(14, 643, 1, 1, 1),(14, 644, 1, 3, 1),(14, 645, 1, 1, 1),(14, 646, 1, 3, 1),(14, 647, 1, 1, 1),(14, 648, 1, 3, 1),(14, 649, 1, 1, 1),(14, 650, 1, 3, 1),(14, 651, 1, 1, 1),(14, 652, 1, 3, 1),(14, 653, 1, 1, 1),(14, 654, 1, 3, 1),(14, 655, 1, 1, 1),(14, 656, 1, 3, 1),(14, 657, 1, 1, 1),(14, 658, 1, 3, 1),(14, 659, 1, 1, 1),(14, 660, 1, 3, 1),(14, 661, 1, 1, 1),(14, 662, 1, 3, 1),(14, 663, 1, 1, 1),(14, 664, 1, 3, 1),(14, 665, 1, 1, 1),(14, 666, 1, 3, 1),(14, 667, 1, 1, 1),(14, 668, 1, 3, 1),(14, 669, 1, 1, 1),(14, 670, 1, 3, 1),(14, 671, 1, 1, 1),(14, 672, 1, 3, 1),(14, 673, 1, 2, 1),(14, 674, 1, 4, 1),(14, 675, 1, 2, 1),(14, 676, 1, 4, 1),(14, 677, 1, 2, 1),(14, 678, 1, 4, 1),(14, 679, 1, 2, 1),(14, 680, 1, 4, 1),(14, 681, 1, 2, 1),(14, 682, 1, 4, 1),(14, 683, 1, 2, 1),(14, 684, 1, 4, 1),(14, 685, 1, 2, 1),(14, 686, 1, 4, 1),(14, 687, 1, 2, 1),(14, 688, 1, 4, 1),(14, 689, 1, 2, 1),(14, 690, 1, 4, 1),(14, 691, 1, 2, 1),(14, 692, 1, 4, 1),(14, 693, 1, 2, 1),(14, 694, 1, 4, 1),(14, 695, 1, 2, 1),(14, 696, 1, 4, 1),(14, 697, 1, 2, 1),(14, 698, 1, 4, 1),(14, 699, 1, 2, 1),(14, 700, 1, 4, 1),(14, 701, 1, 2, 1),(14, 702, 1, 4, 1),(14, 703, 1, 2, 1),(14, 704, 1, 4, 1),(14, 705, 1, 1, 1),(14, 706, 1, 3, 1),(14, 707, 1, 1, 1),(14, 708, 1, 3, 1),(14, 709, 1, 1, 1),(14, 710, 1, 3, 1),(14, 711, 1, 1, 1),(14, 712, 1, 3, 1),(14, 713, 1, 1, 1),(14, 714, 1, 3, 1),(14, 715, 1, 1, 1),(14, 716, 1, 3, 1),(14, 717, 1, 1, 1),(14, 718, 1, 3, 1),(14, 719, 1, 1, 1),(14, 720, 1, 3, 1),(14, 721, 1, 1, 1),(14, 722, 1, 3, 1),(14, 723, 1, 1, 1),(14, 724, 1, 3, 1),(14, 725, 1, 1, 1),(14, 726, 1, 3, 1),(14, 727, 1, 1, 1),(14, 728, 1, 3, 1),(14, 729, 1, 1, 1),(14, 730, 1, 3, 1),(14, 731, 1, 1, 1),(14, 732, 1, 3, 1),(14, 733, 1, 1, 1),(14, 734, 1, 3, 1),(14, 735, 1, 1, 1),(14, 736, 1, 3, 1),(14, 737, 1, 2, 1),(14, 738, 1, 4, 1),(14, 739, 1, 2, 1),(14, 740, 1, 4, 1),(14, 741, 1, 2, 1),(14, 742, 1, 4, 1),(14, 743, 1, 2, 1),(14, 744, 1, 4, 1),(14, 745, 1, 2, 1),(14, 746, 1, 4, 1),(14, 747, 1, 2, 1),(14, 748, 1, 4, 1),(14, 749, 1, 2, 1),(14, 750, 1, 4, 1),(14, 751, 1, 2, 1),(14, 752, 1, 4, 1),(14, 753, 1, 2, 1),(14, 754, 1, 4, 1),(14, 755, 1, 2, 1),(14, 756, 1, 4, 1),(14, 757, 1, 2, 1),(14, 758, 1, 4, 1),(14, 759, 1, 2, 1),(14, 760, 1, 4, 1),(14, 761, 1, 2, 1),(14, 762, 1, 4, 1),(14, 763, 1, 2, 1),(14, 764, 1, 4, 1),(14, 765, 1, 2, 1),(14, 766, 1, 4, 1),(14, 767, 1, 2, 1),(14, 768, 1, 4, 1),(14, 769, 1, 1, 1),(14, 770, 1, 3, 1),(14, 771, 1, 1, 1),(14, 772, 1, 3, 1),(14, 773, 1, 1, 1),(14, 774, 1, 3, 1),(14, 775, 1, 1, 1),(14, 776, 1, 3, 1),(14, 777, 1, 1, 1),(14, 778, 1, 3, 1),(14, 779, 1, 1, 1),(14, 780, 1, 3, 1),(14, 781, 1, 1, 1),(14, 782, 1, 3, 1),(14, 783, 1, 1, 1),(14, 784, 1, 3, 1),(14, 785, 1, 1, 1),(14, 786, 1, 3, 1),(14, 787, 1, 1, 1),(14, 788, 1, 3, 1),(14, 789, 1, 1, 1),(14, 790, 1, 3, 1),(14, 791, 1, 1, 1),(14, 792, 1, 3, 1),(14, 793, 1, 1, 1),(14, 794, 1, 3, 1),(14, 795, 1, 1, 1),(14, 796, 1, 3, 1),(14, 797, 1, 1, 1),(14, 798, 1, 3, 1),(14, 799, 1, 1, 1),(14, 800, 1, 3, 1),(14, 801, 1, 2, 1),(14, 802, 1, 4, 1),(14, 803, 1, 2, 1),(14, 804, 1, 4, 1),(14, 805, 1, 2, 1),(14, 806, 1, 4, 1),(14, 807, 1, 2, 1),(14, 808, 1, 4, 1),(14, 809, 1, 2, 1),(14, 810, 1, 4, 1),(14, 811, 1, 2, 1),(14, 812, 1, 4, 1),(14, 813, 1, 2, 1),(14, 814, 1, 4, 1),(14, 815, 1, 2, 1),(14, 816, 1, 4, 1),(14, 817, 1, 2, 1),(14, 818, 1, 4, 1),(14, 819, 1, 2, 1),(14, 820, 1, 4, 1),(14, 821, 1, 2, 1),(14, 822, 1, 4, 1),(14, 823, 1, 2, 1),(14, 824, 1, 4, 1),(14, 825, 1, 2, 1),(14, 826, 1, 4, 1),(14, 827, 1, 2, 1),(14, 828, 1, 4, 1),(14, 829, 1, 2, 1),(14, 830, 1, 4, 1),(14, 831, 1, 2, 1),(14, 832, 1, 4, 1),(14, 833, 1, 1, 1),(14, 834, 1, 3, 1),(14, 835, 1, 1, 1),(14, 836, 1, 3, 1),(14, 837, 1, 1, 1),(14, 838, 1, 3, 1),(14, 839, 1, 1, 1),(14, 840, 1, 3, 1),(14, 841, 1, 1, 1),(14, 842, 1, 3, 1),(14, 843, 1, 1, 1),(14, 844, 1, 3, 1),(14, 845, 1, 1, 1),(14, 846, 1, 3, 1),(14, 847, 1, 1, 1),(14, 848, 1, 3, 1),(14, 849, 1, 1, 1),(14, 850, 1, 3, 1),(14, 851, 1, 1, 1),(14, 852, 1, 3, 1),(14, 853, 1, 1, 1),(14, 854, 1, 3, 1),(14, 855, 1, 1, 1),(14, 856, 1, 3, 1),(14, 857, 1, 1, 1),(14, 858, 1, 3, 1),(14, 859, 1, 1, 1),(14, 860, 1, 3, 1),(14, 861, 1, 1, 1),(14, 862, 1, 3, 1),(14, 863, 1, 1, 1),(14, 864, 1, 3, 1),(14, 865, 1, 2, 1),(14, 866, 1, 4, 1),(14, 867, 1, 2, 1),(14, 868, 1, 4, 1),(14, 869, 1, 2, 1),(14, 870, 1, 4, 1),(14, 871, 1, 2, 1),(14, 872, 1, 4, 1),(14, 873, 1, 2, 1),(14, 874, 1, 4, 1),(14, 875, 1, 2, 1),(14, 876, 1, 4, 1),(14, 877, 1, 2, 1),(14, 878, 1, 4, 1),(14, 879, 1, 2, 1),(14, 880, 1, 4, 1),(14, 881, 1, 2, 1),(14, 882, 1, 4, 1),(14, 883, 1, 2, 1),(14, 884, 1, 4, 1),(14, 885, 1, 2, 1),(14, 886, 1, 4, 1),(14, 887, 1, 2, 1),(14, 888, 1, 4, 1),(14, 889, 1, 2, 1),(14, 890, 1, 4, 1),(14, 891, 1, 2, 1),(14, 892, 1, 4, 1),(14, 893, 1, 2, 1),(14, 894, 1, 4, 1),(14, 895, 1, 2, 1),(14, 896, 1, 4, 1),(14, 897, 1, 1, 1),(14, 898, 1, 3, 1),(14, 899, 1, 1, 1),(14, 900, 1, 3, 1),(14, 901, 1, 1, 1),(14, 902, 1, 3, 1),(14, 903, 1, 1, 1),(14, 904, 1, 3, 1),(14, 905, 1, 1, 1),(14, 906, 1, 3, 1),(14, 907, 1, 1, 1),(14, 908, 1, 3, 1),(14, 909, 1, 1, 1),(14, 910, 1, 3, 1),(14, 911, 1, 1, 1),(14, 912, 1, 3, 1),(14, 913, 1, 1, 1),(14, 914, 1, 3, 1),(14, 915, 1, 1, 1),(14, 916, 1, 3, 1),(14, 917, 1, 1, 1),(14, 918, 1, 3, 1),(14, 919, 1, 1, 1),(14, 920, 1, 3, 1),(14, 921, 1, 1, 1),(14, 922, 1, 3, 1),(14, 923, 1, 1, 1),(14, 924, 1, 3, 1),(14, 925, 1, 1, 1),(14, 926, 1, 3, 1),(14, 927, 1, 1, 1),(14, 928, 1, 3, 1),(14, 929, 1, 2, 1),(14, 930, 1, 4, 1),(14, 931, 1, 2, 1),(14, 932, 1, 4, 1),(14, 933, 1, 2, 1),(14, 934, 1, 4, 1),(14, 935, 1, 2, 1),(14, 936, 1, 4, 1),(14, 937, 1, 2, 1),(14, 938, 1, 4, 1),(14, 939, 1, 2, 1),(14, 940, 1, 4, 1),(14, 941, 1, 2, 1),(14, 942, 1, 4, 1),(14, 943, 1, 2, 1),(14, 944, 1, 4, 1),(14, 945, 1, 2, 1),(14, 946, 1, 4, 1),(14, 947, 1, 2, 1),(14, 948, 1, 4, 1),(14, 949, 1, 2, 1),(14, 950, 1, 4, 1),(14, 951, 1, 2, 1),(14, 952, 1, 4, 1),(14, 953, 1, 2, 1),(14, 954, 1, 4, 1),(14, 955, 1, 2, 1),(14, 956, 1, 4, 1),(14, 957, 1, 2, 1),(14, 958, 1, 4, 1),(14, 959, 1, 2, 1),(14, 960, 1, 4, 1),(14, 961, 1, 1, 1),(14, 962, 1, 3, 1),(14, 963, 1, 1, 1),(14, 964, 1, 3, 1),(14, 965, 1, 1, 1),(14, 966, 1, 3, 1),(14, 967, 1, 1, 1),(14, 968, 1, 3, 1),(14, 969, 1, 1, 1),(14, 970, 1, 3, 1),(14, 971, 1, 1, 1),(14, 972, 1, 3, 1),(14, 973, 1, 1, 1),(14, 974, 1, 3, 1),(14, 975, 1, 1, 1),(14, 976, 1, 3, 1),(14, 977, 1, 1, 1),(14, 978, 1, 3, 1),(14, 979, 1, 1, 1),(14, 980, 1, 3, 1),(14, 981, 1, 1, 1),(14, 982, 1, 3, 1),(14, 983, 1, 1, 1),(14, 984, 1, 3, 1),(14, 985, 1, 1, 1),(14, 986, 1, 3, 1),(14, 987, 1, 1, 1),(14, 988, 1, 3, 1),(14, 989, 1, 1, 1),(14, 990, 1, 3, 1),(14, 991, 1, 1, 1),(14, 992, 1, 3, 1),(14, 993, 1, 2, 1),(14, 994, 1, 4, 1),(14, 995, 1, 2, 1),(14, 996, 1, 4, 1),(14, 997, 1, 2, 1),(14, 998, 1, 4, 1),(14, 999, 1, 2, 1),(14, 1000, 1, 4, 1),(14, 1001, 1, 2, 1),(14, 1002, 1, 4, 1),(14, 1003, 1, 2, 1),(14, 1004, 1, 4, 1),(14, 1005, 1, 2, 1),(14, 1006, 1, 4, 1),(14, 1007, 1, 2, 1),(14, 1008, 1, 4, 1),(14, 1009, 1, 2, 1),(14, 1010, 1, 4, 1),(14, 1011, 1, 2, 1),(14, 1012, 1, 4, 1),(14, 1013, 1, 2, 1),(14, 1014, 1, 4, 1),(14, 1015, 1, 2, 1),(14, 1016, 1, 4, 1),(14, 1017, 1, 2, 1),(14, 1018, 1, 4, 1),(14, 1019, 1, 2, 1),(14, 1020, 1, 4, 1),(14, 1021, 1, 2, 1),(14, 1022, 1, 4, 1),(14, 1023, 1, 2, 1),(14, 1024, 1, 4, 1),(14, 1025, 1, 1, 1),(14, 1026, 1, 3, 1),(14, 1027, 1, 1, 1),(14, 1028, 1, 3, 1),(14, 1029, 1, 1, 1),(14, 1030, 1, 3, 1),(14, 1031, 1, 1, 1),(14, 1032, 1, 3, 1),(14, 1033, 1, 1, 1),(14, 1034, 1, 3, 1),(14, 1035, 1, 1, 1),(14, 1036, 1, 3, 1),(14, 1037, 1, 1, 1),(14, 1038, 1, 3, 1),(14, 1039, 1, 1, 1),(14, 1040, 1, 3, 1),(14, 1041, 1, 1, 1),(14, 1042, 1, 3, 1),(14, 1043, 1, 1, 1),(14, 1044, 1, 3, 1),(14, 1045, 1, 1, 1),(14, 1046, 1, 3, 1),(14, 1047, 1, 1, 1),(14, 1048, 1, 3, 1),(14, 1049, 1, 1, 1),(14, 1050, 1, 3, 1),(14, 1051, 1, 1, 1),(14, 1052, 1, 3, 1),(14, 1053, 1, 1, 1),(14, 1054, 1, 3, 1),(14, 1055, 1, 1, 1),(14, 1056, 1, 3, 1),(14, 1057, 1, 2, 1),(14, 1058, 1, 4, 1),(14, 1059, 1, 2, 1),(14, 1060, 1, 4, 1),(14, 1061, 1, 2, 1),(14, 1062, 1, 4, 1),(14, 1063, 1, 2, 1),(14, 1064, 1, 4, 1),(14, 1065, 1, 2, 1),(14, 1066, 1, 4, 1),(14, 1067, 1, 2, 1),(14, 1068, 1, 4, 1),(14, 1069, 1, 2, 1),(14, 1070, 1, 4, 1),(14, 1071, 1, 2, 1),(14, 1072, 1, 4, 1),(14, 1073, 1, 2, 1),(14, 1074, 1, 4, 1),(14, 1075, 1, 2, 1),(14, 1076, 1, 4, 1),(14, 1077, 1, 2, 1),(14, 1078, 1, 4, 1),(14, 1079, 1, 2, 1),(14, 1080, 1, 4, 1),(14, 1081, 1, 2, 1),(14, 1082, 1, 4, 1),(14, 1083, 1, 2, 1),(14, 1084, 1, 4, 1),(14, 1085, 1, 2, 1),(14, 1086, 1, 4, 1),(14, 1087, 1, 2, 1),(14, 1088, 1, 4, 1),(14, 1089, 1, 1, 1),(14, 1090, 1, 3, 1),(14, 1091, 1, 1, 1),(14, 1092, 1, 3, 1),(14, 1093, 1, 1, 1),(14, 1094, 1, 3, 1),(14, 1095, 1, 1, 1),(14, 1096, 1, 3, 1),(14, 1097, 1, 1, 1),(14, 1098, 1, 3, 1),(14, 1099, 1, 1, 1),(14, 1100, 1, 3, 1),(14, 1101, 1, 1, 1),(14, 1102, 1, 3, 1),(14, 1103, 1, 1, 1),(14, 1104, 1, 3, 1),(14, 1105, 1, 1, 1),(14, 1106, 1, 3, 1),(14, 1107, 1, 1, 1),(14, 1108, 1, 3, 1),(14, 1109, 1, 1, 1),(14, 1110, 1, 3, 1),(14, 1111, 1, 1, 1),(14, 1112, 1, 3, 1),(14, 1113, 1, 1, 1),(14, 1114, 1, 3, 1),(14, 1115, 1, 1, 1),(14, 1116, 1, 3, 1),(14, 1117, 1, 1, 1),(14, 1118, 1, 3, 1),(14, 1119, 1, 1, 1),(14, 1120, 1, 3, 1),(14, 1121, 1, 2, 1),(14, 1122, 1, 4, 1),(14, 1123, 1, 2, 1),(14, 1124, 1, 4, 1),(14, 1125, 1, 2, 1),(14, 1126, 1, 4, 1),(14, 1127, 1, 2, 1),(14, 1128, 1, 4, 1),(14, 1129, 1, 2, 1),(14, 1130, 1, 4, 1),(14, 1131, 1, 2, 1),(14, 1132, 1, 4, 1),(14, 1133, 1, 2, 1),(14, 1134, 1, 4, 1),(14, 1135, 1, 2, 1),(14, 1136, 1, 4, 1),(14, 1137, 1, 2, 1),(14, 1138, 1, 4, 1),(14, 1139, 1, 2, 1),(14, 1140, 1, 4, 1),(14, 1141, 1, 2, 1),(14, 1142, 1, 4, 1),(14, 1143, 1, 2, 1),(14, 1144, 1, 4, 1),(14, 1145, 1, 2, 1),(14, 1146, 1, 4, 1),(14, 1147, 1, 2, 1),(14, 1148, 1, 4, 1),(14, 1149, 1, 2, 1),(14, 1150, 1, 4, 1),(14, 1151, 1, 2, 1),(14, 1152, 1, 4, 1),(14, 1153, 1, 1, 1),(14, 1154, 1, 3, 1),(14, 1155, 1, 1, 1),(14, 1156, 1, 3, 1),(14, 1157, 1, 1, 1),(14, 1158, 1, 3, 1),(14, 1159, 1, 1, 1),(14, 1160, 1, 3, 1),(14, 1161, 1, 1, 1),(14, 1162, 1, 3, 1),(14, 1163, 1, 1, 1),(14, 1164, 1, 3, 1),(14, 1165, 1, 1, 1),(14, 1166, 1, 3, 1),(14, 1167, 1, 1, 1),(14, 1168, 1, 3, 1),(14, 1169, 1, 1, 1),(14, 1170, 1, 3, 1),(14, 1171, 1, 1, 1),(14, 1172, 1, 3, 1),(14, 1173, 1, 1, 1),(14, 1174, 1, 3, 1),(14, 1175, 1, 1, 1),(14, 1176, 1, 3, 1),(14, 1177, 1, 1, 1),(14, 1178, 1, 3, 1),(14, 1179, 1, 1, 1),(14, 1180, 1, 3, 1),(14, 1181, 1, 1, 1),(14, 1182, 1, 3, 1),(14, 1183, 1, 1, 1),(14, 1184, 1, 3, 1),(14, 1185, 1, 2, 1),(14, 1186, 1, 4, 1),(14, 1187, 1, 2, 1),(14, 1188, 1, 4, 1),(14, 1189, 1, 2, 1),(14, 1190, 1, 4, 1),(14, 1191, 1, 2, 1),(14, 1192, 1, 4, 1),(14, 1193, 1, 2, 1),(14, 1194, 1, 4, 1),(14, 1195, 1, 2, 1),(14, 1196, 1, 4, 1),(14, 1197, 1, 2, 1),(14, 1198, 1, 4, 1),(14, 1199, 1, 2, 1),(14, 1200, 1, 4, 1),(14, 1201, 1, 2, 1),(14, 1202, 1, 4, 1),(14, 1203, 1, 2, 1),(14, 1204, 1, 4, 1),(14, 1205, 1, 2, 1),(14, 1206, 1, 4, 1),(14, 1207, 1, 2, 1),(14, 1208, 1, 4, 1),(14, 1209, 1, 2, 1),(14, 1210, 1, 4, 1),(14, 1211, 1, 2, 1),(14, 1212, 1, 4, 1),(14, 1213, 1, 2, 1),(14, 1214, 1, 4, 1),(14, 1215, 1, 2, 1),(14, 1216, 1, 4, 1),(14, 1217, 1, 1, 1),(14, 1218, 1, 3, 1),(14, 1219, 1, 1, 1),(14, 1220, 1, 3, 1),(14, 1221, 1, 1, 1),(14, 1222, 1, 3, 1),(14, 1223, 1, 1, 1),(14, 1224, 1, 3, 1),(14, 1225, 1, 1, 1),(14, 1226, 1, 3, 1),(14, 1227, 1, 1, 1),(14, 1228, 1, 3, 1),(14, 1229, 1, 1, 1),(14, 1230, 1, 3, 1),(14, 1231, 1, 1, 1),(14, 1232, 1, 3, 1),(14, 1233, 1, 1, 1),(14, 1234, 1, 3, 1),(14, 1235, 1, 1, 1),(14, 1236, 1, 3, 1),(14, 1237, 1, 1, 1),(14, 1238, 1, 3, 1),(14, 1239, 1, 1, 1),(14, 1240, 1, 3, 1),(14, 1241, 1, 1, 1),(14, 1242, 1, 3, 1),(14, 1243, 1, 1, 1),(14, 1244, 1, 3, 1),(14, 1245, 1, 1, 1),(14, 1246, 1, 3, 1),(14, 1247, 1, 1, 1),(14, 1248, 1, 3, 1),(14, 1249, 1, 2, 1),(14, 1250, 1, 4, 1),(14, 1251, 1, 2, 1),(14, 1252, 1, 4, 1),(14, 1253, 1, 2, 1),(14, 1254, 1, 4, 1),(14, 1255, 1, 2, 1),(14, 1256, 1, 4, 1),(14, 1257, 1, 2, 1),(14, 1258, 1, 4, 1),(14, 1259, 1, 2, 1),(14, 1260, 1, 4, 1),(14, 1261, 1, 2, 1),(14, 1262, 1, 4, 1),(14, 1263, 1, 2, 1),(14, 1264, 1, 4, 1),(14, 1265, 1, 2, 1),(14, 1266, 1, 4, 1),(14, 1267, 1, 2, 1),(14, 1268, 1, 4, 1),(14, 1269, 1, 2, 1),(14, 1270, 1, 4, 1),(14, 1271, 1, 2, 1),(14, 1272, 1, 4, 1),(14, 1273, 1, 2, 1),(14, 1274, 1, 4, 1),(14, 1275, 1, 2, 1),(14, 1276, 1, 4, 1),(14, 1277, 1, 2, 1),(14, 1278, 1, 4, 1),(14, 1279, 1, 2, 1),(14, 1280, 1, 4, 1),(14, 1281, 1, 1, 1),(14, 1282, 1, 3, 1),(14, 1283, 1, 1, 1),(14, 1284, 1, 3, 1),(14, 1285, 1, 1, 1),(14, 1286, 1, 3, 1),(14, 1287, 1, 1, 1),(14, 1288, 1, 3, 1),(14, 1289, 1, 1, 1),(14, 1290, 1, 3, 1),(14, 1291, 1, 1, 1),(14, 1292, 1, 3, 1),(14, 1293, 1, 1, 1),(14, 1294, 1, 3, 1),(14, 1295, 1, 1, 1),(14, 1296, 1, 3, 1),(14, 1297, 1, 1, 1),(14, 1298, 1, 3, 1),(14, 1299, 1, 1, 1),(14, 1300, 1, 3, 1),(14, 1301, 1, 1, 1),(14, 1302, 1, 3, 1),(14, 1303, 1, 1, 1),(14, 1304, 1, 3, 1),(14, 1305, 1, 1, 1),(14, 1306, 1, 3, 1),(14, 1307, 1, 1, 1),(14, 1308, 1, 3, 1),(14, 1309, 1, 1, 1),(14, 1310, 1, 3, 1),(14, 1311, 1, 1, 1),(14, 1312, 1, 3, 1),(14, 1313, 1, 2, 1),(14, 1314, 1, 4, 1),(14, 1315, 1, 2, 1),(14, 1316, 1, 4, 1),(14, 1317, 1, 2, 1),(14, 1318, 1, 4, 1),(14, 1319, 1, 2, 1),(14, 1320, 1, 4, 1),(14, 1321, 1, 2, 1),(14, 1322, 1, 4, 1),(14, 1323, 1, 2, 1),(14, 1324, 1, 4, 1),(14, 1325, 1, 2, 1),(14, 1326, 1, 4, 1),(14, 1327, 1, 2, 1),(14, 1328, 1, 4, 1),(14, 1329, 1, 2, 1),(14, 1330, 1, 4, 1),(14, 1331, 1, 2, 1),(14, 1332, 1, 4, 1),(14, 1333, 1, 2, 1),(14, 1334, 1, 4, 1),(14, 1335, 1, 2, 1),(14, 1336, 1, 4, 1),(14, 1337, 1, 2, 1),(14, 1338, 1, 4, 1),(14, 1339, 1, 2, 1),(14, 1340, 1, 4, 1),(14, 1341, 1, 2, 1),(14, 1342, 1, 4, 1),(14, 1343, 1, 2, 1),(14, 1344, 1, 4, 1),(14, 1345, 1, 1, 1),(14, 1346, 1, 3, 1),(14, 1347, 1, 1, 1),(14, 1348, 1, 3, 1),(14, 1349, 1, 1, 1),(14, 1350, 1, 3, 1),(14, 1351, 1, 1, 1),(14, 1352, 1, 3, 1),(14, 1353, 1, 1, 1),(14, 1354, 1, 3, 1),(14, 1355, 1, 1, 1),(14, 1356, 1, 3, 1),(14, 1357, 1, 1, 1),(14, 1358, 1, 3, 1),(14, 1359, 1, 1, 1),(14, 1360, 1, 3, 1),(14, 1361, 1, 1, 1),(14, 1362, 1, 3, 1),(14, 1363, 1, 1, 1),(14, 1364, 1, 3, 1),(14, 1365, 1, 1, 1),(14, 1366, 1, 3, 1),(14, 1367, 1, 1, 1),(14, 1368, 1, 3, 1),(14, 1369, 1, 1, 1),(14, 1370, 1, 3, 1),(14, 1371, 1, 1, 1),(14, 1372, 1, 3, 1),(14, 1373, 1, 1, 1),(14, 1374, 1, 3, 1),(14, 1375, 1, 1, 1),(14, 1376, 1, 3, 1),(14, 1377, 1, 2, 1),(14, 1378, 1, 4, 1),(14, 1379, 1, 2, 1),(14, 1380, 1, 4, 1),(14, 1381, 1, 2, 1),(14, 1382, 1, 4, 1),(14, 1383, 1, 2, 1),(14, 1384, 1, 4, 1),(14, 1385, 1, 2, 1),(14, 1386, 1, 4, 1),(14, 1387, 1, 2, 1),(14, 1388, 1, 4, 1),(14, 1389, 1, 2, 1),(14, 1390, 1, 4, 1),(14, 1391, 1, 2, 1),(14, 1392, 1, 4, 1),(14, 1393, 1, 2, 1),(14, 1394, 1, 4, 1),(14, 1395, 1, 2, 1),(14, 1396, 1, 4, 1),(14, 1397, 1, 2, 1),(14, 1398, 1, 4, 1),(14, 1399, 1, 2, 1),(14, 1400, 1, 4, 1),(14, 1401, 1, 2, 1),(14, 1402, 1, 4, 1),(14, 1403, 1, 2, 1),(14, 1404, 1, 4, 1),(14, 1405, 1, 2, 1),(14, 1406, 1, 4, 1),(14, 1407, 1, 2, 1),(14, 1408, 1, 4, 1),(14, 1409, 1, 1, 1),(14, 1410, 1, 3, 1),(14, 1411, 1, 1, 1),(14, 1412, 1, 3, 1),(14, 1413, 1, 1, 1),(14, 1414, 1, 3, 1),(14, 1415, 1, 1, 1),(14, 1416, 1, 3, 1),(14, 1417, 1, 1, 1),(14, 1418, 1, 3, 1),(14, 1419, 1, 1, 1),(14, 1420, 1, 3, 1),(14, 1421, 1, 1, 1),(14, 1422, 1, 3, 1),(14, 1423, 1, 1, 1),(14, 1424, 1, 3, 1),(14, 1425, 1, 1, 1),(14, 1426, 1, 3, 1),(14, 1427, 1, 1, 1),(14, 1428, 1, 3, 1),(14, 1429, 1, 1, 1),(14, 1430, 1, 3, 1),(14, 1431, 1, 1, 1),(14, 1432, 1, 3, 1),(14, 1433, 1, 1, 1),(14, 1434, 1, 3, 1),(14, 1435, 1, 1, 1),(14, 1436, 1, 3, 1),(14, 1437, 1, 1, 1),(14, 1438, 1, 3, 1),(14, 1439, 1, 1, 1),(14, 1440, 1, 3, 1),(14, 1441, 1, 2, 1),(14, 1442, 1, 4, 1),(14, 1443, 1, 2, 1),(14, 1444, 1, 4, 1),(14, 1445, 1, 2, 1),(14, 1446, 1, 4, 1),(14, 1447, 1, 2, 1),(14, 1448, 1, 4, 1),(14, 1449, 1, 2, 1),(14, 1450, 1, 4, 1),(14, 1451, 1, 2, 1),(14, 1452, 1, 4, 1),(14, 1453, 1, 2, 1),(14, 1454, 1, 4, 1),(14, 1455, 1, 2, 1),(14, 1456, 1, 4, 1),(14, 1457, 1, 2, 1),(14, 1458, 1, 4, 1),(14, 1459, 1, 2, 1),(14, 1460, 1, 4, 1),(14, 1461, 1, 2, 1),(14, 1462, 1, 4, 1),(14, 1463, 1, 2, 1),(14, 1464, 1, 4, 1),(14, 1465, 1, 2, 1),(14, 1466, 1, 4, 1),(14, 1467, 1, 2, 1),(14, 1468, 1, 4, 1),(14, 1469, 1, 2, 1),(14, 1470, 1, 4, 1),(14, 1471, 1, 2, 1),(14, 1472, 1, 4, 1),(14, 1473, 1, 1, 1),(14, 1474, 1, 3, 1),(14, 1475, 1, 1, 1),(14, 1476, 1, 3, 1),(14, 1477, 1, 1, 1),(14, 1478, 1, 3, 1),(14, 1479, 1, 1, 1),(14, 1480, 1, 3, 1),(14, 1481, 1, 1, 1),(14, 1482, 1, 3, 1),(14, 1483, 1, 1, 1),(14, 1484, 1, 3, 1),(14, 1485, 1, 1, 1),(14, 1486, 1, 3, 1),(14, 1487, 1, 1, 1),(14, 1488, 1, 3, 1),(14, 1489, 2, 1, 1),(14, 1490, 2, 3, 1),(14, 1491, 2, 1, 1),(14, 1492, 2, 3, 1),(14, 1493, 2, 1, 1),(14, 1494, 2, 3, 1),(14, 1495, 2, 1, 1),(14, 1496, 2, 3, 1),(14, 1497, 3, 1, 1),(14, 1498, 3, 3, 1),(14, 1499, 3, 1, 1),(14, 1500, 3, 3, 1),(14, 1501, 4, 1, 1),(14, 1502, 4, 3, 1),(14, 1503, 4, 1, 1),(14, 1504, 4, 3, 1),(14, 1505, 1, 2, 1),(14, 1506, 1, 4, 1),(14, 1507, 1, 2, 1),(14, 1508, 1, 4, 1),(14, 1509, 1, 2, 1),(14, 1510, 1, 4, 1),(14, 1511, 1, 2, 1),(14, 1512, 1, 4, 1),(14, 1513, 1, 2, 1),(14, 1514, 1, 4, 1),(14, 1515, 1, 2, 1),(14, 1516, 1, 4, 1),(14, 1517, 1, 2, 1),(14, 1518, 1, 4, 1),(14, 1519, 1, 2, 1),(14, 1520, 1, 4, 1),(14, 1521, 2, 2, 1),(14, 1522, 2, 4, 1),(14, 1523, 2, 2, 1),(14, 1524, 2, 4, 1),(14, 1525, 2, 2, 1),(14, 1526, 2, 4, 1),(14, 1527, 2, 2, 1),(14, 1528, 2, 4, 1),(14, 1529, 3, 2, 1),(14, 1530, 3, 4, 1),(14, 1531, 3, 2, 1),(14, 1532, 3, 4, 1),(14, 1533, 4, 2, 1),(14, 1534, 4, 4, 1),(14, 1535, 4, 2, 1),(14, 1536, 4, 4, 1),(15, 1, 1, 1, 1),(15, 2, 1, 2, 1),(15, 3, 1, 1, 1),(15, 4, 1, 2, 1),(15, 5, 1, 1, 1),(15, 6, 1, 2, 1),(15, 7, 1, 1, 1),(15, 8, 1, 2, 1),(15, 9, 1, 1, 1),(15, 10, 1, 2, 1),(15, 11, 1, 1, 1),(15, 12, 1, 2, 1),(15, 13, 1, 1, 1),(15, 14, 1, 2, 1),(15, 15, 1, 1, 1),(15, 16, 1, 2, 1),(15, 17, 1, 1, 1),(15, 18, 1, 2, 1),(15, 19, 1, 1, 1),(15, 20, 1, 2, 1),(15, 21, 1, 1, 1),(15, 22, 1, 2, 1),(15, 23, 1, 1, 1),(15, 24, 1, 2, 1),(15, 25, 1, 1, 1),(15, 26, 1, 2, 1),(15, 27, 1, 1, 1),(15, 28, 1, 2, 1),(15, 29, 1, 1, 1),(15, 30, 1, 2, 1),(15, 31, 1, 1, 1),(15, 32, 1, 2, 1),(15, 33, 1, 1, 2),(15, 34, 1, 2, 2),(15, 35, 1, 1, 2),(15, 36, 1, 2, 2),(15, 37, 1, 1, 2),(15, 38, 1, 2, 2),(15, 39, 1, 1, 2),(15, 40, 1, 2, 2),(15, 41, 1, 1, 2),(15, 42, 1, 2, 2),(15, 43, 1, 1, 2),(15, 44, 1, 2, 2),(15, 45, 1, 1, 2),(15, 46, 1, 2, 2),(15, 47, 1, 1, 2),(15, 48, 1, 2, 2),(15, 49, 1, 1, 2),(15, 50, 1, 2, 2),(15, 51, 1, 1, 2),(15, 52, 1, 2, 2),(15, 53, 1, 1, 2),(15, 54, 1, 2, 2),(15, 55, 1, 1, 2),(15, 56, 1, 2, 2),(15, 57, 1, 1, 2),(15, 58, 1, 2, 2),(15, 59, 1, 1, 2),(15, 60, 1, 2, 2),(15, 61, 1, 1, 2),(15, 62, 1, 2, 2),(15, 63, 1, 1, 2),(15, 64, 1, 2, 2),(15, 65, 1, 1, 1),(15, 66, 1, 2, 1),(15, 67, 1, 1, 1),(15, 68, 1, 2, 1),(15, 69, 1, 1, 1),(15, 70, 1, 2, 1),(15, 71, 1, 1, 1),(15, 72, 1, 2, 1),(15, 73, 1, 1, 1),(15, 74, 1, 2, 1),(15, 75, 1, 1, 1),(15, 76, 1, 2, 1),(15, 77, 1, 1, 1),(15, 78, 1, 2, 1),(15, 79, 1, 1, 1),(15, 80, 1, 2, 1),(15, 81, 1, 1, 1),(15, 82, 1, 2, 1),(15, 83, 1, 1, 1),(15, 84, 1, 2, 1),(15, 85, 1, 1, 1),(15, 86, 1, 2, 1),(15, 87, 1, 1, 1),(15, 88, 1, 2, 1),(15, 89, 1, 1, 1),(15, 90, 1, 2, 1),(15, 91, 1, 1, 1),(15, 92, 1, 2, 1),(15, 93, 1, 1, 1),(15, 94, 1, 2, 1),(15, 95, 1, 1, 1),(15, 96, 1, 2, 1),(15, 97, 1, 1, 2),(15, 98, 1, 2, 2),(15, 99, 1, 1, 2),(15, 100, 1, 2, 2),(15, 101, 1, 1, 2),(15, 102, 1, 2, 2),(15, 103, 1, 1, 2),(15, 104, 1, 2, 2),(15, 105, 1, 1, 2),(15, 106, 1, 2, 2),(15, 107, 1, 1, 2),(15, 108, 1, 2, 2),(15, 109, 1, 1, 2),(15, 110, 1, 2, 2),(15, 111, 1, 1, 2),(15, 112, 1, 2, 2),(15, 113, 1, 1, 2),(15, 114, 1, 2, 2),(15, 115, 1, 1, 2),(15, 116, 1, 2, 2),(15, 117, 1, 1, 2),(15, 118, 1, 2, 2),(15, 119, 1, 1, 2),(15, 120, 1, 2, 2),(15, 121, 1, 1, 2),(15, 122, 1, 2, 2),(15, 123, 1, 1, 2),(15, 124, 1, 2, 2),(15, 125, 1, 1, 2),(15, 126, 1, 2, 2),(15, 127, 1, 1, 2),(15, 128, 1, 2, 2),(15, 129, 1, 1, 1),(15, 130, 1, 2, 1),(15, 131, 1, 1, 1),(15, 132, 1, 2, 1),(15, 133, 1, 1, 1),(15, 134, 1, 2, 1),(15, 135, 1, 1, 1),(15, 136, 1, 2, 1),(15, 137, 1, 1, 1),(15, 138, 1, 2, 1),(15, 139, 1, 1, 1),(15, 140, 1, 2, 1),(15, 141, 1, 1, 1),(15, 142, 1, 2, 1),(15, 143, 1, 1, 1),(15, 144, 1, 2, 1),(15, 145, 1, 1, 1),(15, 146, 1, 2, 1),(15, 147, 1, 1, 1),(15, 148, 1, 2, 1),(15, 149, 1, 1, 1),(15, 150, 1, 2, 1),(15, 151, 1, 1, 1),(15, 152, 1, 2, 1),(15, 153, 1, 1, 1),(15, 154, 1, 2, 1),(15, 155, 1, 1, 1),(15, 156, 1, 2, 1),(15, 157, 1, 1, 1),(15, 158, 1, 2, 1),(15, 159, 1, 1, 1),(15, 160, 1, 2, 1),(15, 161, 1, 1, 2),(15, 162, 1, 2, 2),(15, 163, 1, 1, 2),(15, 164, 1, 2, 2),(15, 165, 1, 1, 2),(15, 166, 1, 2, 2),(15, 167, 1, 1, 2),(15, 168, 1, 2, 2),(15, 169, 1, 1, 2),(15, 170, 1, 2, 2),(15, 171, 1, 1, 2),(15, 172, 1, 2, 2),(15, 173, 1, 1, 2),(15, 174, 1, 2, 2),(15, 175, 1, 1, 2),(15, 176, 1, 2, 2),(15, 177, 1, 1, 2),(15, 178, 1, 2, 2),(15, 179, 1, 1, 2),(15, 180, 1, 2, 2),(15, 181, 1, 1, 2),(15, 182, 1, 2, 2),(15, 183, 1, 1, 2),(15, 184, 1, 2, 2),(15, 185, 1, 1, 2),(15, 186, 1, 2, 2),(15, 187, 1, 1, 2),(15, 188, 1, 2, 2),(15, 189, 1, 1, 2),(15, 190, 1, 2, 2),(15, 191, 1, 1, 2),(15, 192, 1, 2, 2),(15, 193, 1, 1, 1),(15, 194, 1, 2, 1),(15, 195, 1, 1, 1),(15, 196, 1, 2, 1),(15, 197, 1, 1, 1),(15, 198, 1, 2, 1),(15, 199, 1, 1, 1),(15, 200, 1, 2, 1),(15, 201, 1, 1, 1),(15, 202, 1, 2, 1),(15, 203, 1, 1, 1),(15, 204, 1, 2, 1),(15, 205, 1, 1, 1),(15, 206, 1, 2, 1),(15, 207, 1, 1, 1),(15, 208, 1, 2, 1),(15, 209, 1, 1, 1),(15, 210, 1, 2, 1),(15, 211, 1, 1, 1),(15, 212, 1, 2, 1),(15, 213, 1, 1, 1),(15, 214, 1, 2, 1),(15, 215, 1, 1, 1),(15, 216, 1, 2, 1),(15, 217, 1, 1, 1),(15, 218, 1, 2, 1),(15, 219, 1, 1, 1),(15, 220, 1, 2, 1),(15, 221, 1, 1, 1),(15, 222, 1, 2, 1),(15, 223, 1, 1, 1),(15, 224, 1, 2, 1),(15, 225, 1, 1, 2),(15, 226, 1, 2, 2),(15, 227, 1, 1, 2),(15, 228, 1, 2, 2),(15, 229, 1, 1, 2),(15, 230, 1, 2, 2),(15, 231, 1, 1, 2),(15, 232, 1, 2, 2),(15, 233, 1, 1, 2),(15, 234, 1, 2, 2),(15, 235, 1, 1, 2),(15, 236, 1, 2, 2),(15, 237, 1, 1, 2),(15, 238, 1, 2, 2),(15, 239, 1, 1, 2),(15, 240, 1, 2, 2),(15, 241, 1, 1, 2),(15, 242, 1, 2, 2),(15, 243, 1, 1, 2),(15, 244, 1, 2, 2),(15, 245, 1, 1, 2),(15, 246, 1, 2, 2),(15, 247, 1, 1, 2),(15, 248, 1, 2, 2),(15, 249, 1, 1, 2),(15, 250, 1, 2, 2),(15, 251, 1, 1, 2),(15, 252, 1, 2, 2),(15, 253, 1, 1, 2),(15, 254, 1, 2, 2),(15, 255, 1, 1, 2),(15, 256, 1, 2, 2),(15, 257, 1, 1, 1),(15, 258, 1, 2, 1),(15, 259, 1, 1, 1),(15, 260, 1, 2, 1),(15, 261, 1, 1, 1),(15, 262, 1, 2, 1),(15, 263, 1, 1, 1),(15, 264, 1, 2, 1),(15, 265, 1, 1, 1),(15, 266, 1, 2, 1),(15, 267, 1, 1, 1),(15, 268, 1, 2, 1),(15, 269, 1, 1, 1),(15, 270, 1, 2, 1),(15, 271, 1, 1, 1),(15, 272, 1, 2, 1),(15, 273, 1, 1, 1),(15, 274, 1, 2, 1),(15, 275, 1, 1, 1),(15, 276, 1, 2, 1),(15, 277, 1, 1, 1),(15, 278, 1, 2, 1),(15, 279, 1, 1, 1),(15, 280, 1, 2, 1),(15, 281, 1, 1, 1),(15, 282, 1, 2, 1),(15, 283, 1, 1, 1),(15, 284, 1, 2, 1),(15, 285, 1, 1, 1),(15, 286, 1, 2, 1),(15, 287, 1, 1, 1),(15, 288, 1, 2, 1),(15, 289, 1, 1, 2),(15, 290, 1, 2, 2),(15, 291, 1, 1, 2),(15, 292, 1, 2, 2),(15, 293, 1, 1, 2),(15, 294, 1, 2, 2),(15, 295, 1, 1, 2),(15, 296, 1, 2, 2),(15, 297, 1, 1, 2),(15, 298, 1, 2, 2),(15, 299, 1, 1, 2),(15, 300, 1, 2, 2),(15, 301, 1, 1, 2),(15, 302, 1, 2, 2),(15, 303, 1, 1, 2),(15, 304, 1, 2, 2),(15, 305, 1, 1, 2),(15, 306, 1, 2, 2),(15, 307, 1, 1, 2),(15, 308, 1, 2, 2),(15, 309, 1, 1, 2),(15, 310, 1, 2, 2),(15, 311, 1, 1, 2),(15, 312, 1, 2, 2),(15, 313, 1, 1, 2),(15, 314, 1, 2, 2),(15, 315, 1, 1, 2),(15, 316, 1, 2, 2),(15, 317, 1, 1, 2),(15, 318, 1, 2, 2),(15, 319, 1, 1, 2),(15, 320, 1, 2, 2),(15, 321, 1, 1, 1),(15, 322, 1, 2, 1),(15, 323, 1, 1, 1),(15, 324, 1, 2, 1),(15, 325, 1, 1, 1),(15, 326, 1, 2, 1),(15, 327, 1, 1, 1),(15, 328, 1, 2, 1),(15, 329, 1, 1, 1),(15, 330, 1, 2, 1),(15, 331, 1, 1, 1),(15, 332, 1, 2, 1),(15, 333, 1, 1, 1),(15, 334, 1, 2, 1),(15, 335, 1, 1, 1),(15, 336, 1, 2, 1),(15, 337, 1, 1, 1),(15, 338, 1, 2, 1),(15, 339, 1, 1, 1),(15, 340, 1, 2, 1),(15, 341, 1, 1, 1),(15, 342, 1, 2, 1),(15, 343, 1, 1, 1),(15, 344, 1, 2, 1),(15, 345, 1, 1, 1),(15, 346, 1, 2, 1),(15, 347, 1, 1, 1),(15, 348, 1, 2, 1),(15, 349, 1, 1, 1),(15, 350, 1, 2, 1),(15, 351, 1, 1, 1),(15, 352, 1, 2, 1),(15, 353, 1, 1, 2),(15, 354, 1, 2, 2),(15, 355, 1, 1, 2),(15, 356, 1, 2, 2),(15, 357, 1, 1, 2),(15, 358, 1, 2, 2),(15, 359, 1, 1, 2),(15, 360, 1, 2, 2),(15, 361, 1, 1, 2),(15, 362, 1, 2, 2),(15, 363, 1, 1, 2),(15, 364, 1, 2, 2),(15, 365, 1, 1, 2),(15, 366, 1, 2, 2),(15, 367, 1, 1, 2),(15, 368, 1, 2, 2),(15, 369, 1, 1, 2),(15, 370, 1, 2, 2),(15, 371, 1, 1, 2),(15, 372, 1, 2, 2),(15, 373, 1, 1, 2),(15, 374, 1, 2, 2),(15, 375, 1, 1, 2),(15, 376, 1, 2, 2),(15, 377, 1, 1, 2),(15, 378, 1, 2, 2),(15, 379, 1, 1, 2),(15, 380, 1, 2, 2),(15, 381, 1, 1, 2),(15, 382, 1, 2, 2),(15, 383, 1, 1, 2),(15, 384, 1, 2, 2),(15, 385, 1, 1, 1),(15, 386, 1, 2, 1),(15, 387, 1, 1, 1),(15, 388, 1, 2, 1),(15, 389, 1, 1, 1),(15, 390, 1, 2, 1),(15, 391, 1, 1, 1),(15, 392, 1, 2, 1),(15, 393, 1, 1, 1),(15, 394, 1, 2, 1),(15, 395, 1, 1, 1),(15, 396, 1, 2, 1),(15, 397, 1, 1, 1),(15, 398, 1, 2, 1),(15, 399, 1, 1, 1),(15, 400, 1, 2, 1),(15, 401, 1, 1, 1),(15, 402, 1, 2, 1),(15, 403, 1, 1, 1),(15, 404, 1, 2, 1),(15, 405, 1, 1, 1),(15, 406, 1, 2, 1),(15, 407, 1, 1, 1),(15, 408, 1, 2, 1),(15, 409, 1, 1, 1),(15, 410, 1, 2, 1),(15, 411, 1, 1, 1),(15, 412, 1, 2, 1),(15, 413, 1, 1, 1),(15, 414, 1, 2, 1),(15, 415, 1, 1, 1),(15, 416, 1, 2, 1),(15, 417, 1, 1, 2),(15, 418, 1, 2, 2),(15, 419, 1, 1, 2),(15, 420, 1, 2, 2),(15, 421, 1, 1, 2),(15, 422, 1, 2, 2),(15, 423, 1, 1, 2),(15, 424, 1, 2, 2),(15, 425, 1, 1, 2),(15, 426, 1, 2, 2),(15, 427, 1, 1, 2),(15, 428, 1, 2, 2),(15, 429, 1, 1, 2),(15, 430, 1, 2, 2),(15, 431, 1, 1, 2),(15, 432, 1, 2, 2),(15, 433, 1, 1, 2),(15, 434, 1, 2, 2),(15, 435, 1, 1, 2),(15, 436, 1, 2, 2),(15, 437, 1, 1, 2),(15, 438, 1, 2, 2),(15, 439, 1, 1, 2),(15, 440, 1, 2, 2),(15, 441, 1, 1, 2),(15, 442, 1, 2, 2),(15, 443, 1, 1, 2),(15, 444, 1, 2, 2),(15, 445, 1, 1, 2),(15, 446, 1, 2, 2),(15, 447, 1, 1, 2),(15, 448, 1, 2, 2),(15, 449, 1, 1, 1),(15, 450, 1, 2, 1),(15, 451, 1, 1, 1),(15, 452, 1, 2, 1),(15, 453, 1, 1, 1),(15, 454, 1, 2, 1),(15, 455, 1, 1, 1),(15, 456, 1, 2, 1),(15, 457, 1, 1, 1),(15, 458, 1, 2, 1),(15, 459, 1, 1, 1),(15, 460, 1, 2, 1),(15, 461, 1, 1, 1),(15, 462, 1, 2, 1),(15, 463, 1, 1, 1),(15, 464, 1, 2, 1),(15, 465, 1, 1, 1),(15, 466, 1, 2, 1),(15, 467, 1, 1, 1),(15, 468, 1, 2, 1),(15, 469, 1, 1, 1),(15, 470, 1, 2, 1),(15, 471, 1, 1, 1),(15, 472, 1, 2, 1),(15, 473, 1, 1, 1),(15, 474, 1, 2, 1),(15, 475, 1, 1, 1),(15, 476, 1, 2, 1),(15, 477, 1, 1, 1),(15, 478, 1, 2, 1),(15, 479, 1, 1, 1),(15, 480, 1, 2, 1),(15, 481, 1, 1, 2),(15, 482, 1, 2, 2),(15, 483, 1, 1, 2),(15, 484, 1, 2, 2),(15, 485, 1, 1, 2),(15, 486, 1, 2, 2),(15, 487, 1, 1, 2),(15, 488, 1, 2, 2),(15, 489, 1, 1, 2),(15, 490, 1, 2, 2),(15, 491, 1, 1, 2),(15, 492, 1, 2, 2),(15, 493, 1, 1, 2),(15, 494, 1, 2, 2),(15, 495, 1, 1, 2),(15, 496, 1, 2, 2),(15, 497, 1, 1, 2),(15, 498, 1, 2, 2),(15, 499, 1, 1, 2),(15, 500, 1, 2, 2),(15, 501, 1, 1, 2),(15, 502, 1, 2, 2),(15, 503, 1, 1, 2),(15, 504, 1, 2, 2),(15, 505, 1, 1, 2),(15, 506, 1, 2, 2),(15, 507, 1, 1, 2),(15, 508, 1, 2, 2),(15, 509, 1, 1, 2),(15, 510, 1, 2, 2),(15, 511, 1, 1, 2),(15, 512, 1, 2, 2),(15, 513, 1, 1, 1),(15, 514, 1, 2, 1),(15, 515, 1, 1, 1),(15, 516, 1, 2, 1),(15, 517, 1, 1, 1),(15, 518, 1, 2, 1),(15, 519, 1, 1, 1),(15, 520, 1, 2, 1),(15, 521, 1, 1, 1),(15, 522, 1, 2, 1),(15, 523, 1, 1, 1),(15, 524, 1, 2, 1),(15, 525, 1, 1, 1),(15, 526, 1, 2, 1),(15, 527, 1, 1, 1),(15, 528, 1, 2, 1),(15, 529, 1, 1, 1),(15, 530, 1, 2, 1),(15, 531, 1, 1, 1),(15, 532, 1, 2, 1),(15, 533, 1, 1, 1),(15, 534, 1, 2, 1),(15, 535, 1, 1, 1),(15, 536, 1, 2, 1),(15, 537, 1, 1, 1),(15, 538, 1, 2, 1),(15, 539, 1, 1, 1),(15, 540, 1, 2, 1),(15, 541, 1, 1, 1),(15, 542, 1, 2, 1),(15, 543, 1, 1, 1),(15, 544, 1, 2, 1),(15, 545, 1, 1, 2),(15, 546, 1, 2, 2),(15, 547, 1, 1, 2),(15, 548, 1, 2, 2),(15, 549, 1, 1, 2),(15, 550, 1, 2, 2),(15, 551, 1, 1, 2),(15, 552, 1, 2, 2),(15, 553, 1, 1, 2),(15, 554, 1, 2, 2),(15, 555, 1, 1, 2),(15, 556, 1, 2, 2),(15, 557, 1, 1, 2),(15, 558, 1, 2, 2),(15, 559, 1, 1, 2),(15, 560, 1, 2, 2),(15, 561, 1, 1, 2),(15, 562, 1, 2, 2),(15, 563, 1, 1, 2),(15, 564, 1, 2, 2),(15, 565, 1, 1, 2),(15, 566, 1, 2, 2),(15, 567, 1, 1, 2),(15, 568, 1, 2, 2),(15, 569, 1, 1, 2),(15, 570, 1, 2, 2),(15, 571, 1, 1, 2),(15, 572, 1, 2, 2),(15, 573, 1, 1, 2),(15, 574, 1, 2, 2),(15, 575, 1, 1, 2),(15, 576, 1, 2, 2),(15, 577, 1, 1, 1),(15, 578, 1, 2, 1),(15, 579, 1, 1, 1),(15, 580, 1, 2, 1),(15, 581, 1, 1, 1),(15, 582, 1, 2, 1),(15, 583, 1, 1, 1),(15, 584, 1, 2, 1),(15, 585, 1, 1, 1),(15, 586, 1, 2, 1),(15, 587, 1, 1, 1),(15, 588, 1, 2, 1),(15, 589, 1, 1, 1),(15, 590, 1, 2, 1),(15, 591, 1, 1, 1),(15, 592, 1, 2, 1),(15, 593, 1, 1, 1),(15, 594, 1, 2, 1),(15, 595, 1, 1, 1),(15, 596, 1, 2, 1),(15, 597, 1, 1, 1),(15, 598, 1, 2, 1),(15, 599, 1, 1, 1),(15, 600, 1, 2, 1),(15, 601, 1, 1, 1),(15, 602, 1, 2, 1),(15, 603, 1, 1, 1),(15, 604, 1, 2, 1),(15, 605, 1, 1, 1),(15, 606, 1, 2, 1),(15, 607, 1, 1, 1),(15, 608, 1, 2, 1),(15, 609, 1, 1, 2),(15, 610, 1, 2, 2),(15, 611, 1, 1, 2),(15, 612, 1, 2, 2),(15, 613, 1, 1, 2),(15, 614, 1, 2, 2),(15, 615, 1, 1, 2),(15, 616, 1, 2, 2),(15, 617, 1, 1, 2),(15, 618, 1, 2, 2),(15, 619, 1, 1, 2),(15, 620, 1, 2, 2),(15, 621, 1, 1, 2),(15, 622, 1, 2, 2),(15, 623, 1, 1, 2),(15, 624, 1, 2, 2),(15, 625, 1, 1, 2),(15, 626, 1, 2, 2),(15, 627, 1, 1, 2),(15, 628, 1, 2, 2),(15, 629, 1, 1, 2),(15, 630, 1, 2, 2),(15, 631, 1, 1, 2),(15, 632, 1, 2, 2),(15, 633, 1, 1, 2),(15, 634, 1, 2, 2),(15, 635, 1, 1, 2),(15, 636, 1, 2, 2),(15, 637, 1, 1, 2),(15, 638, 1, 2, 2),(15, 639, 1, 1, 2),(15, 640, 1, 2, 2),(15, 641, 1, 1, 1),(15, 642, 1, 2, 1),(15, 643, 1, 1, 1),(15, 644, 1, 2, 1),(15, 645, 1, 1, 1),(15, 646, 1, 2, 1),(15, 647, 1, 1, 1),(15, 648, 1, 2, 1),(15, 649, 1, 1, 1),(15, 650, 1, 2, 1),(15, 651, 1, 1, 1),(15, 652, 1, 2, 1),(15, 653, 1, 1, 1),(15, 654, 1, 2, 1),(15, 655, 1, 1, 1),(15, 656, 1, 2, 1),(15, 657, 1, 1, 1),(15, 658, 1, 2, 1),(15, 659, 1, 1, 1),(15, 660, 1, 2, 1),(15, 661, 1, 1, 1),(15, 662, 1, 2, 1),(15, 663, 1, 1, 1),(15, 664, 1, 2, 1),(15, 665, 1, 1, 1),(15, 666, 1, 2, 1),(15, 667, 1, 1, 1),(15, 668, 1, 2, 1),(15, 669, 1, 1, 1),(15, 670, 1, 2, 1),(15, 671, 1, 1, 1),(15, 672, 1, 2, 1),(15, 673, 1, 1, 2),(15, 674, 1, 2, 2),(15, 675, 1, 1, 2),(15, 676, 1, 2, 2),(15, 677, 1, 1, 2),(15, 678, 1, 2, 2),(15, 679, 1, 1, 2),(15, 680, 1, 2, 2),(15, 681, 1, 1, 2),(15, 682, 1, 2, 2),(15, 683, 1, 1, 2),(15, 684, 1, 2, 2),(15, 685, 1, 1, 2),(15, 686, 1, 2, 2),(15, 687, 1, 1, 2),(15, 688, 1, 2, 2),(15, 689, 1, 1, 2),(15, 690, 1, 2, 2),(15, 691, 1, 1, 2),(15, 692, 1, 2, 2),(15, 693, 1, 1, 2),(15, 694, 1, 2, 2),(15, 695, 1, 1, 2),(15, 696, 1, 2, 2),(15, 697, 1, 1, 2),(15, 698, 1, 2, 2),(15, 699, 1, 1, 2),(15, 700, 1, 2, 2),(15, 701, 1, 1, 2),(15, 702, 1, 2, 2),(15, 703, 1, 1, 2),(15, 704, 1, 2, 2),(15, 705, 1, 1, 1),(15, 706, 1, 2, 1),(15, 707, 1, 1, 1),(15, 708, 1, 2, 1),(15, 709, 1, 1, 1),(15, 710, 1, 2, 1),(15, 711, 1, 1, 1),(15, 712, 1, 2, 1),(15, 713, 1, 1, 1),(15, 714, 1, 2, 1),(15, 715, 1, 1, 1),(15, 716, 1, 2, 1),(15, 717, 1, 1, 1),(15, 718, 1, 2, 1),(15, 719, 1, 1, 1),(15, 720, 1, 2, 1),(15, 721, 1, 1, 1),(15, 722, 1, 2, 1),(15, 723, 1, 1, 1),(15, 724, 1, 2, 1),(15, 725, 1, 1, 1),(15, 726, 1, 2, 1),(15, 727, 1, 1, 1),(15, 728, 1, 2, 1),(15, 729, 1, 1, 1),(15, 730, 1, 2, 1),(15, 731, 1, 1, 1),(15, 732, 1, 2, 1),(15, 733, 1, 1, 1),(15, 734, 1, 2, 1),(15, 735, 1, 1, 1),(15, 736, 1, 2, 1),(15, 737, 1, 1, 2),(15, 738, 1, 2, 2),(15, 739, 1, 1, 2),(15, 740, 1, 2, 2),(15, 741, 1, 1, 2),(15, 742, 1, 2, 2),(15, 743, 1, 1, 2),(15, 744, 1, 2, 2),(15, 745, 1, 1, 2),(15, 746, 1, 2, 2),(15, 747, 1, 1, 2),(15, 748, 1, 2, 2),(15, 749, 1, 1, 2),(15, 750, 1, 2, 2),(15, 751, 1, 1, 2),(15, 752, 1, 2, 2),(15, 753, 1, 1, 2),(15, 754, 1, 2, 2),(15, 755, 1, 1, 2),(15, 756, 1, 2, 2),(15, 757, 1, 1, 2),(15, 758, 1, 2, 2),(15, 759, 1, 1, 2),(15, 760, 1, 2, 2),(15, 761, 1, 1, 2),(15, 762, 1, 2, 2),(15, 763, 1, 1, 2),(15, 764, 1, 2, 2),(15, 765, 1, 1, 2),(15, 766, 1, 2, 2),(15, 767, 1, 1, 2),(15, 768, 1, 2, 2),(15, 769, 1, 1, 1),(15, 770, 1, 2, 1),(15, 771, 1, 1, 1),(15, 772, 1, 2, 1),(15, 773, 1, 1, 1),(15, 774, 1, 2, 1),(15, 775, 1, 1, 1),(15, 776, 1, 2, 1),(15, 777, 1, 1, 1),(15, 778, 1, 2, 1),(15, 779, 1, 1, 1),(15, 780, 1, 2, 1),(15, 781, 1, 1, 1),(15, 782, 1, 2, 1),(15, 783, 1, 1, 1),(15, 784, 1, 2, 1),(15, 785, 1, 1, 1),(15, 786, 1, 2, 1),(15, 787, 1, 1, 1),(15, 788, 1, 2, 1),(15, 789, 1, 1, 1),(15, 790, 1, 2, 1),(15, 791, 1, 1, 1),(15, 792, 1, 2, 1),(15, 793, 1, 1, 1),(15, 794, 1, 2, 1),(15, 795, 1, 1, 1),(15, 796, 1, 2, 1),(15, 797, 1, 1, 1),(15, 798, 1, 2, 1),(15, 799, 1, 1, 1),(15, 800, 1, 2, 1),(15, 801, 1, 1, 2),(15, 802, 1, 2, 2),(15, 803, 1, 1, 2),(15, 804, 1, 2, 2),(15, 805, 1, 1, 2),(15, 806, 1, 2, 2),(15, 807, 1, 1, 2),(15, 808, 1, 2, 2),(15, 809, 1, 1, 2),(15, 810, 1, 2, 2),(15, 811, 1, 1, 2),(15, 812, 1, 2, 2),(15, 813, 1, 1, 2),(15, 814, 1, 2, 2),(15, 815, 1, 1, 2),(15, 816, 1, 2, 2),(15, 817, 1, 1, 2),(15, 818, 1, 2, 2),(15, 819, 1, 1, 2),(15, 820, 1, 2, 2),(15, 821, 1, 1, 2),(15, 822, 1, 2, 2),(15, 823, 1, 1, 2),(15, 824, 1, 2, 2),(15, 825, 1, 1, 2),(15, 826, 1, 2, 2),(15, 827, 1, 1, 2),(15, 828, 1, 2, 2),(15, 829, 1, 1, 2),(15, 830, 1, 2, 2),(15, 831, 1, 1, 2),(15, 832, 1, 2, 2),(15, 833, 1, 1, 1),(15, 834, 1, 2, 1),(15, 835, 1, 1, 1),(15, 836, 1, 2, 1),(15, 837, 1, 1, 1),(15, 838, 1, 2, 1),(15, 839, 1, 1, 1),(15, 840, 1, 2, 1),(15, 841, 1, 1, 1),(15, 842, 1, 2, 1),(15, 843, 1, 1, 1),(15, 844, 1, 2, 1),(15, 845, 1, 1, 1),(15, 846, 1, 2, 1),(15, 847, 1, 1, 1),(15, 848, 1, 2, 1),(15, 849, 1, 1, 1),(15, 850, 1, 2, 1),(15, 851, 1, 1, 1),(15, 852, 1, 2, 1),(15, 853, 1, 1, 1),(15, 854, 1, 2, 1),(15, 855, 1, 1, 1),(15, 856, 1, 2, 1),(15, 857, 1, 1, 1),(15, 858, 1, 2, 1),(15, 859, 1, 1, 1),(15, 860, 1, 2, 1),(15, 861, 1, 1, 1),(15, 862, 1, 2, 1),(15, 863, 1, 1, 1),(15, 864, 1, 2, 1),(15, 865, 1, 1, 2),(15, 866, 1, 2, 2),(15, 867, 1, 1, 2),(15, 868, 1, 2, 2),(15, 869, 1, 1, 2),(15, 870, 1, 2, 2),(15, 871, 1, 1, 2),(15, 872, 1, 2, 2),(15, 873, 1, 1, 2),(15, 874, 1, 2, 2),(15, 875, 1, 1, 2),(15, 876, 1, 2, 2),(15, 877, 1, 1, 2),(15, 878, 1, 2, 2),(15, 879, 1, 1, 2),(15, 880, 1, 2, 2),(15, 881, 1, 1, 2),(15, 882, 1, 2, 2),(15, 883, 1, 1, 2),(15, 884, 1, 2, 2),(15, 885, 1, 1, 2),(15, 886, 1, 2, 2),(15, 887, 1, 1, 2),(15, 888, 1, 2, 2),(15, 889, 1, 1, 2),(15, 890, 1, 2, 2),(15, 891, 1, 1, 2),(15, 892, 1, 2, 2),(15, 893, 1, 1, 2),(15, 894, 1, 2, 2),(15, 895, 1, 1, 2),(15, 896, 1, 2, 2),(15, 897, 1, 1, 1),(15, 898, 1, 2, 1),(15, 899, 1, 1, 1),(15, 900, 1, 2, 1),(15, 901, 1, 1, 1),(15, 902, 1, 2, 1),(15, 903, 1, 1, 1),(15, 904, 1, 2, 1),(15, 905, 1, 1, 1),(15, 906, 1, 2, 1),(15, 907, 1, 1, 1),(15, 908, 1, 2, 1),(15, 909, 1, 1, 1),(15, 910, 1, 2, 1),(15, 911, 1, 1, 1),(15, 912, 1, 2, 1),(15, 913, 1, 1, 1),(15, 914, 1, 2, 1),(15, 915, 1, 1, 1),(15, 916, 1, 2, 1),(15, 917, 1, 1, 1),(15, 918, 1, 2, 1),(15, 919, 1, 1, 1),(15, 920, 1, 2, 1),(15, 921, 1, 1, 1),(15, 922, 1, 2, 1),(15, 923, 1, 1, 1),(15, 924, 1, 2, 1),(15, 925, 1, 1, 1),(15, 926, 1, 2, 1),(15, 927, 1, 1, 1),(15, 928, 1, 2, 1),(15, 929, 1, 1, 2),(15, 930, 1, 2, 2),(15, 931, 1, 1, 2),(15, 932, 1, 2, 2),(15, 933, 1, 1, 2),(15, 934, 1, 2, 2),(15, 935, 1, 1, 2),(15, 936, 1, 2, 2),(15, 937, 1, 1, 2),(15, 938, 1, 2, 2),(15, 939, 1, 1, 2),(15, 940, 1, 2, 2),(15, 941, 1, 1, 2),(15, 942, 1, 2, 2),(15, 943, 1, 1, 2),(15, 944, 1, 2, 2),(15, 945, 1, 1, 2),(15, 946, 1, 2, 2),(15, 947, 1, 1, 2),(15, 948, 1, 2, 2),(15, 949, 1, 1, 2),(15, 950, 1, 2, 2),(15, 951, 1, 1, 2),(15, 952, 1, 2, 2),(15, 953, 1, 1, 2),(15, 954, 1, 2, 2),(15, 955, 1, 1, 2),(15, 956, 1, 2, 2),(15, 957, 1, 1, 2),(15, 958, 1, 2, 2),(15, 959, 1, 1, 2),(15, 960, 1, 2, 2),(15, 961, 1, 1, 1),(15, 962, 1, 2, 1),(15, 963, 1, 1, 1),(15, 964, 1, 2, 1),(15, 965, 1, 1, 1),(15, 966, 1, 2, 1),(15, 967, 1, 1, 1),(15, 968, 1, 2, 1),(15, 969, 1, 1, 1),(15, 970, 1, 2, 1),(15, 971, 1, 1, 1),(15, 972, 1, 2, 1),(15, 973, 1, 1, 1),(15, 974, 1, 2, 1),(15, 975, 1, 1, 1),(15, 976, 1, 2, 1),(15, 977, 1, 1, 1),(15, 978, 1, 2, 1),(15, 979, 1, 1, 1),(15, 980, 1, 2, 1),(15, 981, 1, 1, 1),(15, 982, 1, 2, 1),(15, 983, 1, 1, 1),(15, 984, 1, 2, 1),(15, 985, 1, 1, 1),(15, 986, 1, 2, 1),(15, 987, 1, 1, 1),(15, 988, 1, 2, 1),(15, 989, 1, 1, 1),(15, 990, 1, 2, 1),(15, 991, 1, 1, 1),(15, 992, 1, 2, 1),(15, 993, 1, 1, 2),(15, 994, 1, 2, 2),(15, 995, 1, 1, 2),(15, 996, 1, 2, 2),(15, 997, 1, 1, 2),(15, 998, 1, 2, 2),(15, 999, 1, 1, 2),(15, 1000, 1, 2, 2),(15, 1001, 1, 1, 2),(15, 1002, 1, 2, 2),(15, 1003, 1, 1, 2),(15, 1004, 1, 2, 2),(15, 1005, 1, 1, 2),(15, 1006, 1, 2, 2),(15, 1007, 1, 1, 2),(15, 1008, 1, 2, 2),(15, 1009, 1, 1, 2),(15, 1010, 1, 2, 2),(15, 1011, 1, 1, 2),(15, 1012, 1, 2, 2),(15, 1013, 1, 1, 2),(15, 1014, 1, 2, 2),(15, 1015, 1, 1, 2),(15, 1016, 1, 2, 2),(15, 1017, 1, 1, 2),(15, 1018, 1, 2, 2),(15, 1019, 1, 1, 2),(15, 1020, 1, 2, 2),(15, 1021, 1, 1, 2),(15, 1022, 1, 2, 2),(15, 1023, 1, 1, 2),(15, 1024, 1, 2, 2),(15, 1025, 1, 1, 1),(15, 1026, 1, 2, 1),(15, 1027, 1, 1, 1),(15, 1028, 1, 2, 1),(15, 1029, 1, 1, 1),(15, 1030, 1, 2, 1),(15, 1031, 1, 1, 1),(15, 1032, 1, 2, 1),(15, 1033, 1, 1, 1),(15, 1034, 1, 2, 1),(15, 1035, 1, 1, 1),(15, 1036, 1, 2, 1),(15, 1037, 1, 1, 1),(15, 1038, 1, 2, 1),(15, 1039, 1, 1, 1),(15, 1040, 1, 2, 1),(15, 1041, 1, 1, 1),(15, 1042, 1, 2, 1),(15, 1043, 1, 1, 1),(15, 1044, 1, 2, 1),(15, 1045, 1, 1, 1),(15, 1046, 1, 2, 1),(15, 1047, 1, 1, 1),(15, 1048, 1, 2, 1),(15, 1049, 1, 1, 1),(15, 1050, 1, 2, 1),(15, 1051, 1, 1, 1),(15, 1052, 1, 2, 1),(15, 1053, 1, 1, 1),(15, 1054, 1, 2, 1),(15, 1055, 1, 1, 1),(15, 1056, 1, 2, 1),(15, 1057, 1, 1, 2),(15, 1058, 1, 2, 2),(15, 1059, 1, 1, 2),(15, 1060, 1, 2, 2),(15, 1061, 1, 1, 2),(15, 1062, 1, 2, 2),(15, 1063, 1, 1, 2),(15, 1064, 1, 2, 2),(15, 1065, 1, 1, 2),(15, 1066, 1, 2, 2),(15, 1067, 1, 1, 2),(15, 1068, 1, 2, 2),(15, 1069, 1, 1, 2),(15, 1070, 1, 2, 2),(15, 1071, 1, 1, 2),(15, 1072, 1, 2, 2),(15, 1073, 1, 1, 2),(15, 1074, 1, 2, 2),(15, 1075, 1, 1, 2),(15, 1076, 1, 2, 2),(15, 1077, 1, 1, 2),(15, 1078, 1, 2, 2),(15, 1079, 1, 1, 2),(15, 1080, 1, 2, 2),(15, 1081, 1, 1, 2),(15, 1082, 1, 2, 2),(15, 1083, 1, 1, 2),(15, 1084, 1, 2, 2),(15, 1085, 1, 1, 2),(15, 1086, 1, 2, 2),(15, 1087, 1, 1, 2),(15, 1088, 1, 2, 2),(15, 1089, 1, 1, 1),(15, 1090, 1, 2, 1),(15, 1091, 1, 1, 1),(15, 1092, 1, 2, 1),(15, 1093, 1, 1, 1),(15, 1094, 1, 2, 1),(15, 1095, 1, 1, 1),(15, 1096, 1, 2, 1),(15, 1097, 1, 1, 1),(15, 1098, 1, 2, 1),(15, 1099, 1, 1, 1),(15, 1100, 1, 2, 1),(15, 1101, 1, 1, 1),(15, 1102, 1, 2, 1),(15, 1103, 1, 1, 1),(15, 1104, 1, 2, 1),(15, 1105, 1, 1, 1),(15, 1106, 1, 2, 1),(15, 1107, 1, 1, 1),(15, 1108, 1, 2, 1),(15, 1109, 1, 1, 1),(15, 1110, 1, 2, 1),(15, 1111, 1, 1, 1),(15, 1112, 1, 2, 1),(15, 1113, 1, 1, 1),(15, 1114, 1, 2, 1),(15, 1115, 1, 1, 1),(15, 1116, 1, 2, 1),(15, 1117, 1, 1, 1),(15, 1118, 1, 2, 1),(15, 1119, 1, 1, 1),(15, 1120, 1, 2, 1),(15, 1121, 1, 1, 2),(15, 1122, 1, 2, 2),(15, 1123, 1, 1, 2),(15, 1124, 1, 2, 2),(15, 1125, 1, 1, 2),(15, 1126, 1, 2, 2),(15, 1127, 1, 1, 2),(15, 1128, 1, 2, 2),(15, 1129, 1, 1, 2),(15, 1130, 1, 2, 2),(15, 1131, 1, 1, 2),(15, 1132, 1, 2, 2),(15, 1133, 1, 1, 2),(15, 1134, 1, 2, 2),(15, 1135, 1, 1, 2),(15, 1136, 1, 2, 2),(15, 1137, 1, 1, 2),(15, 1138, 1, 2, 2),(15, 1139, 1, 1, 2),(15, 1140, 1, 2, 2),(15, 1141, 1, 1, 2),(15, 1142, 1, 2, 2),(15, 1143, 1, 1, 2),(15, 1144, 1, 2, 2),(15, 1145, 1, 1, 2),(15, 1146, 1, 2, 2),(15, 1147, 1, 1, 2),(15, 1148, 1, 2, 2),(15, 1149, 1, 1, 2),(15, 1150, 1, 2, 2),(15, 1151, 1, 1, 2),(15, 1152, 1, 2, 2),(15, 1153, 1, 1, 1),(15, 1154, 1, 2, 1),(15, 1155, 1, 1, 1),(15, 1156, 1, 2, 1),(15, 1157, 1, 1, 1),(15, 1158, 1, 2, 1),(15, 1159, 1, 1, 1),(15, 1160, 1, 2, 1),(15, 1161, 1, 1, 1),(15, 1162, 1, 2, 1),(15, 1163, 1, 1, 1),(15, 1164, 1, 2, 1),(15, 1165, 1, 1, 1),(15, 1166, 1, 2, 1),(15, 1167, 1, 1, 1),(15, 1168, 1, 2, 1),(15, 1169, 1, 1, 1),(15, 1170, 1, 2, 1),(15, 1171, 1, 1, 1),(15, 1172, 1, 2, 1),(15, 1173, 1, 1, 1),(15, 1174, 1, 2, 1),(15, 1175, 1, 1, 1),(15, 1176, 1, 2, 1),(15, 1177, 1, 1, 1),(15, 1178, 1, 2, 1),(15, 1179, 1, 1, 1),(15, 1180, 1, 2, 1),(15, 1181, 1, 1, 1),(15, 1182, 1, 2, 1),(15, 1183, 1, 1, 1),(15, 1184, 1, 2, 1),(15, 1185, 1, 1, 2),(15, 1186, 1, 2, 2),(15, 1187, 1, 1, 2),(15, 1188, 1, 2, 2),(15, 1189, 1, 1, 2),(15, 1190, 1, 2, 2),(15, 1191, 1, 1, 2),(15, 1192, 1, 2, 2),(15, 1193, 1, 1, 2),(15, 1194, 1, 2, 2),(15, 1195, 1, 1, 2),(15, 1196, 1, 2, 2),(15, 1197, 1, 1, 2),(15, 1198, 1, 2, 2),(15, 1199, 1, 1, 2),(15, 1200, 1, 2, 2),(15, 1201, 1, 1, 2),(15, 1202, 1, 2, 2),(15, 1203, 1, 1, 2),(15, 1204, 1, 2, 2),(15, 1205, 1, 1, 2),(15, 1206, 1, 2, 2),(15, 1207, 1, 1, 2),(15, 1208, 1, 2, 2),(15, 1209, 1, 1, 2),(15, 1210, 1, 2, 2),(15, 1211, 1, 1, 2),(15, 1212, 1, 2, 2),(15, 1213, 1, 1, 2),(15, 1214, 1, 2, 2),(15, 1215, 1, 1, 2),(15, 1216, 1, 2, 2),(15, 1217, 1, 1, 1),(15, 1218, 1, 2, 1),(15, 1219, 1, 1, 1),(15, 1220, 1, 2, 1),(15, 1221, 1, 1, 1),(15, 1222, 1, 2, 1),(15, 1223, 1, 1, 1),(15, 1224, 1, 2, 1),(15, 1225, 1, 1, 1),(15, 1226, 1, 2, 1),(15, 1227, 1, 1, 1),(15, 1228, 1, 2, 1),(15, 1229, 1, 1, 1),(15, 1230, 1, 2, 1),(15, 1231, 1, 1, 1),(15, 1232, 1, 2, 1),(15, 1233, 1, 1, 1),(15, 1234, 1, 2, 1),(15, 1235, 1, 1, 1),(15, 1236, 1, 2, 1),(15, 1237, 1, 1, 1),(15, 1238, 1, 2, 1),(15, 1239, 1, 1, 1),(15, 1240, 1, 2, 1),(15, 1241, 1, 1, 1),(15, 1242, 1, 2, 1),(15, 1243, 1, 1, 1),(15, 1244, 1, 2, 1),(15, 1245, 1, 1, 1),(15, 1246, 1, 2, 1),(15, 1247, 1, 1, 1),(15, 1248, 1, 2, 1),(15, 1249, 1, 1, 2),(15, 1250, 1, 2, 2),(15, 1251, 1, 1, 2),(15, 1252, 1, 2, 2),(15, 1253, 1, 1, 2),(15, 1254, 1, 2, 2),(15, 1255, 1, 1, 2),(15, 1256, 1, 2, 2),(15, 1257, 1, 1, 2),(15, 1258, 1, 2, 2),(15, 1259, 1, 1, 2),(15, 1260, 1, 2, 2),(15, 1261, 1, 1, 2),(15, 1262, 1, 2, 2),(15, 1263, 1, 1, 2),(15, 1264, 1, 2, 2),(15, 1265, 1, 1, 2),(15, 1266, 1, 2, 2),(15, 1267, 1, 1, 2),(15, 1268, 1, 2, 2),(15, 1269, 1, 1, 2),(15, 1270, 1, 2, 2),(15, 1271, 1, 1, 2),(15, 1272, 1, 2, 2),(15, 1273, 1, 1, 2),(15, 1274, 1, 2, 2),(15, 1275, 1, 1, 2),(15, 1276, 1, 2, 2),(15, 1277, 1, 1, 2),(15, 1278, 1, 2, 2),(15, 1279, 1, 1, 2),(15, 1280, 1, 2, 2),(15, 1281, 1, 1, 1),(15, 1282, 1, 2, 1),(15, 1283, 1, 1, 1),(15, 1284, 1, 2, 1),(15, 1285, 1, 1, 1),(15, 1286, 1, 2, 1),(15, 1287, 1, 1, 1),(15, 1288, 1, 2, 1),(15, 1289, 1, 1, 1),(15, 1290, 1, 2, 1),(15, 1291, 1, 1, 1),(15, 1292, 1, 2, 1),(15, 1293, 1, 1, 1),(15, 1294, 1, 2, 1),(15, 1295, 1, 1, 1),(15, 1296, 1, 2, 1),(15, 1297, 1, 1, 1),(15, 1298, 1, 2, 1),(15, 1299, 1, 1, 1),(15, 1300, 1, 2, 1),(15, 1301, 1, 1, 1),(15, 1302, 1, 2, 1),(15, 1303, 1, 1, 1),(15, 1304, 1, 2, 1),(15, 1305, 1, 1, 1),(15, 1306, 1, 2, 1),(15, 1307, 1, 1, 1),(15, 1308, 1, 2, 1),(15, 1309, 1, 1, 1),(15, 1310, 1, 2, 1),(15, 1311, 1, 1, 1),(15, 1312, 1, 2, 1),(15, 1313, 1, 1, 2),(15, 1314, 1, 2, 2),(15, 1315, 1, 1, 2),(15, 1316, 1, 2, 2),(15, 1317, 1, 1, 2),(15, 1318, 1, 2, 2),(15, 1319, 1, 1, 2),(15, 1320, 1, 2, 2),(15, 1321, 1, 1, 2),(15, 1322, 1, 2, 2),(15, 1323, 1, 1, 2),(15, 1324, 1, 2, 2),(15, 1325, 1, 1, 2),(15, 1326, 1, 2, 2),(15, 1327, 1, 1, 2),(15, 1328, 1, 2, 2),(15, 1329, 1, 1, 2),(15, 1330, 1, 2, 2),(15, 1331, 1, 1, 2),(15, 1332, 1, 2, 2),(15, 1333, 1, 1, 2),(15, 1334, 1, 2, 2),(15, 1335, 1, 1, 2),(15, 1336, 1, 2, 2),(15, 1337, 1, 1, 2),(15, 1338, 1, 2, 2),(15, 1339, 1, 1, 2),(15, 1340, 1, 2, 2),(15, 1341, 1, 1, 2),(15, 1342, 1, 2, 2),(15, 1343, 1, 1, 2),(15, 1344, 1, 2, 2),(15, 1345, 1, 1, 1),(15, 1346, 1, 2, 1),(15, 1347, 1, 1, 1),(15, 1348, 1, 2, 1),(15, 1349, 1, 1, 1),(15, 1350, 1, 2, 1),(15, 1351, 1, 1, 1),(15, 1352, 1, 2, 1),(15, 1353, 1, 1, 1),(15, 1354, 1, 2, 1),(15, 1355, 1, 1, 1),(15, 1356, 1, 2, 1),(15, 1357, 1, 1, 1),(15, 1358, 1, 2, 1),(15, 1359, 1, 1, 1),(15, 1360, 1, 2, 1),(15, 1361, 1, 1, 1),(15, 1362, 1, 2, 1),(15, 1363, 1, 1, 1),(15, 1364, 1, 2, 1),(15, 1365, 1, 1, 1),(15, 1366, 1, 2, 1),(15, 1367, 1, 1, 1),(15, 1368, 1, 2, 1),(15, 1369, 1, 1, 1),(15, 1370, 1, 2, 1),(15, 1371, 1, 1, 1),(15, 1372, 1, 2, 1),(15, 1373, 1, 1, 1),(15, 1374, 1, 2, 1),(15, 1375, 1, 1, 1),(15, 1376, 1, 2, 1),(15, 1377, 1, 1, 2),(15, 1378, 1, 2, 2),(15, 1379, 1, 1, 2),(15, 1380, 1, 2, 2),(15, 1381, 1, 1, 2),(15, 1382, 1, 2, 2),(15, 1383, 1, 1, 2),(15, 1384, 1, 2, 2),(15, 1385, 1, 1, 2),(15, 1386, 1, 2, 2),(15, 1387, 1, 1, 2),(15, 1388, 1, 2, 2),(15, 1389, 1, 1, 2),(15, 1390, 1, 2, 2),(15, 1391, 1, 1, 2),(15, 1392, 1, 2, 2),(15, 1393, 1, 1, 2),(15, 1394, 1, 2, 2),(15, 1395, 1, 1, 2),(15, 1396, 1, 2, 2),(15, 1397, 1, 1, 2),(15, 1398, 1, 2, 2),(15, 1399, 1, 1, 2),(15, 1400, 1, 2, 2),(15, 1401, 1, 1, 2),(15, 1402, 1, 2, 2),(15, 1403, 1, 1, 2),(15, 1404, 1, 2, 2),(15, 1405, 1, 1, 2),(15, 1406, 1, 2, 2),(15, 1407, 1, 1, 2),(15, 1408, 1, 2, 2),(15, 1409, 1, 1, 1),(15, 1410, 1, 2, 1),(15, 1411, 1, 1, 1),(15, 1412, 1, 2, 1),(15, 1413, 1, 1, 1),(15, 1414, 1, 2, 1),(15, 1415, 1, 1, 1),(15, 1416, 1, 2, 1),(15, 1417, 1, 1, 1),(15, 1418, 1, 2, 1),(15, 1419, 1, 1, 1),(15, 1420, 1, 2, 1),(15, 1421, 1, 1, 1),(15, 1422, 1, 2, 1),(15, 1423, 1, 1, 1),(15, 1424, 1, 2, 1),(15, 1425, 1, 1, 1),(15, 1426, 1, 2, 1),(15, 1427, 1, 1, 1),(15, 1428, 1, 2, 1),(15, 1429, 1, 1, 1),(15, 1430, 1, 2, 1),(15, 1431, 1, 1, 1),(15, 1432, 1, 2, 1),(15, 1433, 1, 1, 1),(15, 1434, 1, 2, 1),(15, 1435, 1, 1, 1),(15, 1436, 1, 2, 1),(15, 1437, 1, 1, 1),(15, 1438, 1, 2, 1),(15, 1439, 1, 1, 1),(15, 1440, 1, 2, 1),(15, 1441, 1, 1, 2),(15, 1442, 1, 2, 2),(15, 1443, 1, 1, 2),(15, 1444, 1, 2, 2),(15, 1445, 1, 1, 2),(15, 1446, 1, 2, 2),(15, 1447, 1, 1, 2),(15, 1448, 1, 2, 2),(15, 1449, 1, 1, 2),(15, 1450, 1, 2, 2),(15, 1451, 1, 1, 2),(15, 1452, 1, 2, 2),(15, 1453, 1, 1, 2),(15, 1454, 1, 2, 2),(15, 1455, 1, 1, 2),(15, 1456, 1, 2, 2),(15, 1457, 1, 1, 2),(15, 1458, 1, 2, 2),(15, 1459, 1, 1, 2),(15, 1460, 1, 2, 2),(15, 1461, 1, 1, 2),(15, 1462, 1, 2, 2),(15, 1463, 1, 1, 2),(15, 1464, 1, 2, 2),(15, 1465, 1, 1, 2),(15, 1466, 1, 2, 2),(15, 1467, 1, 1, 2),(15, 1468, 1, 2, 2),(15, 1469, 1, 1, 2),(15, 1470, 1, 2, 2),(15, 1471, 1, 1, 2),(15, 1472, 1, 2, 2),(15, 1473, 1, 1, 1),(15, 1474, 1, 2, 1),(15, 1475, 1, 1, 1),(15, 1476, 1, 2, 1),(15, 1477, 1, 1, 1),(15, 1478, 1, 2, 1),(15, 1479, 1, 1, 1),(15, 1480, 1, 2, 1),(15, 1481, 1, 1, 1),(15, 1482, 1, 2, 1),(15, 1483, 1, 1, 1),(15, 1484, 1, 2, 1),(15, 1485, 1, 1, 1),(15, 1486, 1, 2, 1),(15, 1487, 1, 1, 1),(15, 1488, 1, 2, 1),(15, 1489, 2, 1, 1),(15, 1490, 2, 2, 1),(15, 1491, 2, 1, 1),(15, 1492, 2, 2, 1),(15, 1493, 2, 1, 1),(15, 1494, 2, 2, 1),(15, 1495, 2, 1, 1),(15, 1496, 2, 2, 1),(15, 1497, 3, 1, 1),(15, 1498, 3, 2, 1),(15, 1499, 3, 1, 1),(15, 1500, 3, 2, 1),(15, 1501, 4, 1, 1),(15, 1502, 4, 2, 1),(15, 1503, 4, 1, 1),(15, 1504, 4, 2, 1),(15, 1505, 1, 1, 2),(15, 1506, 1, 2, 2),(15, 1507, 1, 1, 2),(15, 1508, 1, 2, 2),(15, 1509, 1, 1, 2),(15, 1510, 1, 2, 2),(15, 1511, 1, 1, 2),(15, 1512, 1, 2, 2),(15, 1513, 1, 1, 2),(15, 1514, 1, 2, 2),(15, 1515, 1, 1, 2),(15, 1516, 1, 2, 2),(15, 1517, 1, 1, 2),(15, 1518, 1, 2, 2),(15, 1519, 1, 1, 2),(15, 1520, 1, 2, 2),(15, 1521, 2, 1, 2),(15, 1522, 2, 2, 2),(15, 1523, 2, 1, 2),(15, 1524, 2, 2, 2),(15, 1525, 2, 1, 2),(15, 1526, 2, 2, 2),(15, 1527, 2, 1, 2),(15, 1528, 2, 2, 2),(15, 1529, 3, 1, 2),(15, 1530, 3, 2, 2),(15, 1531, 3, 1, 2),(15, 1532, 3, 2, 2),(15, 1533, 4, 1, 2),(15, 1534, 4, 2, 2),(15, 1535, 4, 1, 2),(15, 1536, 4, 2, 2),(16, 1, 1, 1, 1),(16, 2, 1, 2, 1),(16, 3, 1, 1, 1),(16, 4, 1, 2, 1),(16, 5, 1, 1, 1),(16, 6, 1, 2, 1),(16, 7, 1, 1, 1),(16, 8, 1, 2, 1),(16, 9, 1, 1, 1),(16, 10, 1, 2, 1),(16, 11, 1, 1, 1),(16, 12, 1, 2, 1),(16, 13, 1, 1, 1),(16, 14, 1, 2, 1),(16, 15, 1, 1, 1),(16, 16, 1, 2, 1),(16, 17, 1, 1, 1),(16, 18, 1, 2, 1),(16, 19, 1, 1, 1),(16, 20, 1, 2, 1),(16, 21, 1, 1, 1),(16, 22, 1, 2, 1),(16, 23, 1, 1, 1),(16, 24, 1, 2, 1),(16, 25, 1, 1, 1),(16, 26, 1, 2, 1),(16, 27, 1, 1, 1),(16, 28, 1, 2, 1),(16, 29, 1, 1, 1),(16, 30, 1, 2, 1),(16, 31, 1, 1, 1),(16, 32, 1, 2, 1),(16, 33, 1, 1, 1),(16, 34, 1, 2, 1),(16, 35, 1, 1, 1),(16, 36, 1, 2, 1),(16, 37, 1, 1, 1),(16, 38, 1, 2, 1),(16, 39, 1, 1, 1),(16, 40, 1, 2, 1),(16, 41, 1, 1, 1),(16, 42, 1, 2, 1),(16, 43, 1, 1, 1),(16, 44, 1, 2, 1),(16, 45, 1, 1, 1),(16, 46, 1, 2, 1),(16, 47, 1, 1, 1),(16, 48, 1, 2, 1),(16, 49, 1, 1, 1),(16, 50, 1, 2, 1),(16, 51, 1, 1, 1),(16, 52, 1, 2, 1),(16, 53, 1, 1, 1),(16, 54, 1, 2, 1),(16, 55, 1, 1, 1),(16, 56, 1, 2, 1),(16, 57, 1, 1, 1),(16, 58, 1, 2, 1),(16, 59, 1, 1, 1),(16, 60, 1, 2, 1),(16, 61, 1, 1, 1),(16, 62, 1, 2, 1),(16, 63, 1, 1, 1),(16, 64, 1, 2, 1),(16, 65, 1, 1, 1),(16, 66, 1, 2, 1),(16, 67, 1, 1, 1),(16, 68, 1, 2, 1),(16, 69, 1, 1, 1),(16, 70, 1, 2, 1),(16, 71, 1, 1, 1),(16, 72, 1, 2, 1),(16, 73, 1, 1, 1),(16, 74, 1, 2, 1),(16, 75, 1, 1, 1),(16, 76, 1, 2, 1),(16, 77, 1, 1, 1),(16, 78, 1, 2, 1),(16, 79, 1, 1, 1),(16, 80, 1, 2, 1),(16, 81, 1, 1, 1),(16, 82, 1, 2, 1),(16, 83, 1, 1, 1),(16, 84, 1, 2, 1),(16, 85, 1, 1, 1),(16, 86, 1, 2, 1),(16, 87, 1, 1, 1),(16, 88, 1, 2, 1),(16, 89, 1, 1, 1),(16, 90, 1, 2, 1),(16, 91, 1, 1, 1),(16, 92, 1, 2, 1),(16, 93, 1, 1, 1),(16, 94, 1, 2, 1),(16, 95, 1, 1, 1),(16, 96, 1, 2, 1),(16, 97, 1, 1, 1),(16, 98, 1, 2, 1),(16, 99, 1, 1, 1),(16, 100, 1, 2, 1),(16, 101, 1, 1, 1),(16, 102, 1, 2, 1),(16, 103, 1, 1, 1),(16, 104, 1, 2, 1),(16, 105, 1, 1, 1),(16, 106, 1, 2, 1),(16, 107, 1, 1, 1),(16, 108, 1, 2, 1),(16, 109, 1, 1, 1),(16, 110, 1, 2, 1),(16, 111, 1, 1, 1),(16, 112, 1, 2, 1),(16, 113, 1, 1, 1),(16, 114, 1, 2, 1),(16, 115, 1, 1, 1),(16, 116, 1, 2, 1),(16, 117, 1, 1, 1),(16, 118, 1, 2, 1),(16, 119, 1, 1, 1),(16, 120, 1, 2, 1),(16, 121, 1, 1, 1),(16, 122, 1, 2, 1),(16, 123, 1, 1, 1),(16, 124, 1, 2, 1),(16, 125, 1, 1, 1),(16, 126, 1, 2, 1),(16, 127, 1, 1, 1),(16, 128, 1, 2, 1),(16, 129, 1, 1, 1),(16, 130, 1, 2, 1),(16, 131, 1, 1, 1),(16, 132, 1, 2, 1),(16, 133, 1, 1, 1),(16, 134, 1, 2, 1),(16, 135, 1, 1, 1),(16, 136, 1, 2, 1),(16, 137, 1, 1, 1),(16, 138, 1, 2, 1),(16, 139, 1, 1, 1),(16, 140, 1, 2, 1),(16, 141, 1, 1, 1),(16, 142, 1, 2, 1),(16, 143, 1, 1, 1),(16, 144, 1, 2, 1),(16, 145, 1, 1, 1),(16, 146, 1, 2, 1),(16, 147, 1, 1, 1),(16, 148, 1, 2, 1),(16, 149, 1, 1, 1),(16, 150, 1, 2, 1),(16, 151, 1, 1, 1),(16, 152, 1, 2, 1),(16, 153, 1, 1, 1),(16, 154, 1, 2, 1),(16, 155, 1, 1, 1),(16, 156, 1, 2, 1),(16, 157, 1, 1, 1),(16, 158, 1, 2, 1),(16, 159, 1, 1, 1),(16, 160, 1, 2, 1),(16, 161, 1, 1, 1),(16, 162, 1, 2, 1),(16, 163, 1, 1, 1),(16, 164, 1, 2, 1),(16, 165, 1, 1, 1),(16, 166, 1, 2, 1),(16, 167, 1, 1, 1),(16, 168, 1, 2, 1),(16, 169, 1, 1, 1),(16, 170, 1, 2, 1),(16, 171, 1, 1, 1),(16, 172, 1, 2, 1),(16, 173, 1, 1, 1),(16, 174, 1, 2, 1),(16, 175, 1, 1, 1),(16, 176, 1, 2, 1),(16, 177, 1, 1, 1),(16, 178, 1, 2, 1),(16, 179, 1, 1, 1),(16, 180, 1, 2, 1),(16, 181, 1, 1, 1),(16, 182, 1, 2, 1),(16, 183, 1, 1, 1),(16, 184, 1, 2, 1),(16, 185, 1, 1, 1),(16, 186, 1, 2, 1),(16, 187, 1, 1, 1),(16, 188, 1, 2, 1),(16, 189, 1, 1, 1),(16, 190, 1, 2, 1),(16, 191, 1, 1, 1),(16, 192, 1, 2, 1),(16, 193, 1, 1, 1),(16, 194, 1, 2, 1),(16, 195, 1, 1, 1),(16, 196, 1, 2, 1),(16, 197, 1, 1, 1),(16, 198, 1, 2, 1),(16, 199, 1, 1, 1),(16, 200, 1, 2, 1),(16, 201, 1, 1, 1),(16, 202, 1, 2, 1),(16, 203, 1, 1, 1),(16, 204, 1, 2, 1),(16, 205, 1, 1, 1),(16, 206, 1, 2, 1),(16, 207, 1, 1, 1),(16, 208, 1, 2, 1),(16, 209, 1, 1, 1),(16, 210, 1, 2, 1),(16, 211, 1, 1, 1),(16, 212, 1, 2, 1),(16, 213, 1, 1, 1),(16, 214, 1, 2, 1),(16, 215, 1, 1, 1),(16, 216, 1, 2, 1),(16, 217, 1, 1, 1),(16, 218, 1, 2, 1),(16, 219, 1, 1, 1),(16, 220, 1, 2, 1),(16, 221, 1, 1, 1),(16, 222, 1, 2, 1),(16, 223, 1, 1, 1),(16, 224, 1, 2, 1),(16, 225, 1, 1, 1),(16, 226, 1, 2, 1),(16, 227, 1, 1, 1),(16, 228, 1, 2, 1),(16, 229, 1, 1, 1),(16, 230, 1, 2, 1),(16, 231, 1, 1, 1),(16, 232, 1, 2, 1),(16, 233, 1, 1, 1),(16, 234, 1, 2, 1),(16, 235, 1, 1, 1),(16, 236, 1, 2, 1),(16, 237, 1, 1, 1),(16, 238, 1, 2, 1),(16, 239, 1, 1, 1),(16, 240, 1, 2, 1),(16, 241, 1, 1, 1),(16, 242, 1, 2, 1),(16, 243, 1, 1, 1),(16, 244, 1, 2, 1),(16, 245, 1, 1, 1),(16, 246, 1, 2, 1),(16, 247, 1, 1, 1),(16, 248, 1, 2, 1),(16, 249, 1, 1, 1),(16, 250, 1, 2, 1),(16, 251, 1, 1, 1),(16, 252, 1, 2, 1),(16, 253, 1, 1, 1),(16, 254, 1, 2, 1),(16, 255, 1, 1, 1),(16, 256, 1, 2, 1),(16, 257, 1, 1, 1),(16, 258, 1, 2, 1),(16, 259, 1, 1, 1),(16, 260, 1, 2, 1),(16, 261, 1, 1, 1),(16, 262, 1, 2, 1),(16, 263, 1, 1, 1),(16, 264, 1, 2, 1),(16, 265, 1, 1, 1),(16, 266, 1, 2, 1),(16, 267, 1, 1, 1),(16, 268, 1, 2, 1),(16, 269, 1, 1, 1),(16, 270, 1, 2, 1),(16, 271, 1, 1, 1),(16, 272, 1, 2, 1),(16, 273, 1, 1, 1),(16, 274, 1, 2, 1),(16, 275, 1, 1, 1),(16, 276, 1, 2, 1),(16, 277, 1, 1, 1),(16, 278, 1, 2, 1),(16, 279, 1, 1, 1),(16, 280, 1, 2, 1),(16, 281, 1, 1, 1),(16, 282, 1, 2, 1),(16, 283, 1, 1, 1),(16, 284, 1, 2, 1),(16, 285, 1, 1, 1),(16, 286, 1, 2, 1),(16, 287, 1, 1, 1),(16, 288, 1, 2, 1),(16, 289, 1, 1, 1),(16, 290, 1, 2, 1),(16, 291, 1, 1, 1),(16, 292, 1, 2, 1),(16, 293, 1, 1, 1),(16, 294, 1, 2, 1),(16, 295, 1, 1, 1),(16, 296, 1, 2, 1),(16, 297, 1, 1, 1),(16, 298, 1, 2, 1),(16, 299, 1, 1, 1),(16, 300, 1, 2, 1),(16, 301, 1, 1, 1),(16, 302, 1, 2, 1),(16, 303, 1, 1, 1),(16, 304, 1, 2, 1),(16, 305, 1, 1, 1),(16, 306, 1, 2, 1),(16, 307, 1, 1, 1),(16, 308, 1, 2, 1),(16, 309, 1, 1, 1),(16, 310, 1, 2, 1),(16, 311, 1, 1, 1),(16, 312, 1, 2, 1),(16, 313, 1, 1, 1),(16, 314, 1, 2, 1),(16, 315, 1, 1, 1),(16, 316, 1, 2, 1),(16, 317, 1, 1, 1),(16, 318, 1, 2, 1),(16, 319, 1, 1, 1),(16, 320, 1, 2, 1),(16, 321, 1, 1, 1),(16, 322, 1, 2, 1),(16, 323, 1, 1, 1),(16, 324, 1, 2, 1),(16, 325, 1, 1, 1),(16, 326, 1, 2, 1),(16, 327, 1, 1, 1),(16, 328, 1, 2, 1),(16, 329, 1, 1, 1),(16, 330, 1, 2, 1),(16, 331, 1, 1, 1),(16, 332, 1, 2, 1),(16, 333, 1, 1, 1),(16, 334, 1, 2, 1),(16, 335, 1, 1, 1),(16, 336, 1, 2, 1),(16, 337, 1, 1, 1),(16, 338, 1, 2, 1),(16, 339, 1, 1, 1),(16, 340, 1, 2, 1),(16, 341, 1, 1, 1),(16, 342, 1, 2, 1),(16, 343, 1, 1, 1),(16, 344, 1, 2, 1),(16, 345, 1, 1, 1),(16, 346, 1, 2, 1),(16, 347, 1, 1, 1),(16, 348, 1, 2, 1),(16, 349, 1, 1, 1),(16, 350, 1, 2, 1),(16, 351, 1, 1, 1),(16, 352, 1, 2, 1),(16, 353, 1, 1, 1),(16, 354, 1, 2, 1),(16, 355, 1, 1, 1),(16, 356, 1, 2, 1),(16, 357, 1, 1, 1),(16, 358, 1, 2, 1),(16, 359, 1, 1, 1),(16, 360, 1, 2, 1),(16, 361, 1, 1, 1),(16, 362, 1, 2, 1),(16, 363, 1, 1, 1),(16, 364, 1, 2, 1),(16, 365, 1, 1, 1),(16, 366, 1, 2, 1),(16, 367, 1, 1, 1),(16, 368, 1, 2, 1),(16, 369, 1, 1, 1),(16, 370, 1, 2, 1),(16, 371, 1, 1, 1),(16, 372, 1, 2, 1),(16, 373, 1, 1, 1),(16, 374, 1, 2, 1),(16, 375, 1, 1, 1),(16, 376, 1, 2, 1),(16, 377, 1, 1, 1),(16, 378, 1, 2, 1),(16, 379, 1, 1, 1),(16, 380, 1, 2, 1),(16, 381, 1, 1, 1),(16, 382, 1, 2, 1),(16, 383, 1, 1, 1),(16, 384, 1, 2, 1),(16, 385, 1, 1, 1),(16, 386, 1, 2, 1),(16, 387, 1, 1, 1),(16, 388, 1, 2, 1),(16, 389, 1, 1, 1),(16, 390, 1, 2, 1),(16, 391, 1, 1, 1),(16, 392, 1, 2, 1),(16, 393, 1, 1, 1),(16, 394, 1, 2, 1),(16, 395, 1, 1, 1),(16, 396, 1, 2, 1),(16, 397, 1, 1, 1),(16, 398, 1, 2, 1),(16, 399, 1, 1, 1),(16, 400, 1, 2, 1),(16, 401, 1, 1, 1),(16, 402, 1, 2, 1),(16, 403, 1, 1, 1),(16, 404, 1, 2, 1),(16, 405, 1, 1, 1),(16, 406, 1, 2, 1),(16, 407, 1, 1, 1),(16, 408, 1, 2, 1),(16, 409, 1, 1, 1),(16, 410, 1, 2, 1),(16, 411, 1, 1, 1),(16, 412, 1, 2, 1),(16, 413, 1, 1, 1),(16, 414, 1, 2, 1),(16, 415, 1, 1, 1),(16, 416, 1, 2, 1),(16, 417, 1, 1, 1),(16, 418, 1, 2, 1),(16, 419, 1, 1, 1),(16, 420, 1, 2, 1),(16, 421, 1, 1, 1),(16, 422, 1, 2, 1),(16, 423, 1, 1, 1),(16, 424, 1, 2, 1),(16, 425, 1, 1, 1),(16, 426, 1, 2, 1),(16, 427, 1, 1, 1),(16, 428, 1, 2, 1),(16, 429, 1, 1, 1),(16, 430, 1, 2, 1),(16, 431, 1, 1, 1),(16, 432, 1, 2, 1),(16, 433, 1, 1, 1),(16, 434, 1, 2, 1),(16, 435, 1, 1, 1),(16, 436, 1, 2, 1),(16, 437, 1, 1, 1),(16, 438, 1, 2, 1),(16, 439, 1, 1, 1),(16, 440, 1, 2, 1),(16, 441, 1, 1, 1),(16, 442, 1, 2, 1),(16, 443, 1, 1, 1),(16, 444, 1, 2, 1),(16, 445, 1, 1, 1),(16, 446, 1, 2, 1),(16, 447, 1, 1, 1),(16, 448, 1, 2, 1),(16, 449, 1, 1, 1),(16, 450, 1, 2, 1),(16, 451, 1, 1, 1),(16, 452, 1, 2, 1),(16, 453, 1, 1, 1),(16, 454, 1, 2, 1),(16, 455, 1, 1, 1),(16, 456, 1, 2, 1),(16, 457, 1, 1, 1),(16, 458, 1, 2, 1),(16, 459, 1, 1, 1),(16, 460, 1, 2, 1),(16, 461, 1, 1, 1),(16, 462, 1, 2, 1),(16, 463, 1, 1, 1),(16, 464, 1, 2, 1),(16, 465, 1, 1, 1),(16, 466, 1, 2, 1),(16, 467, 1, 1, 1),(16, 468, 1, 2, 1),(16, 469, 1, 1, 1),(16, 470, 1, 2, 1),(16, 471, 1, 1, 1),(16, 472, 1, 2, 1),(16, 473, 1, 1, 1),(16, 474, 1, 2, 1),(16, 475, 1, 1, 1),(16, 476, 1, 2, 1),(16, 477, 1, 1, 1),(16, 478, 1, 2, 1),(16, 479, 1, 1, 1),(16, 480, 1, 2, 1),(16, 481, 1, 1, 1),(16, 482, 1, 2, 1),(16, 483, 1, 1, 1),(16, 484, 1, 2, 1),(16, 485, 1, 1, 1),(16, 486, 1, 2, 1),(16, 487, 1, 1, 1),(16, 488, 1, 2, 1),(16, 489, 1, 1, 1),(16, 490, 1, 2, 1),(16, 491, 1, 1, 1),(16, 492, 1, 2, 1),(16, 493, 1, 1, 1),(16, 494, 1, 2, 1),(16, 495, 1, 1, 1),(16, 496, 1, 2, 1),(16, 497, 1, 1, 1),(16, 498, 1, 2, 1),(16, 499, 1, 1, 1),(16, 500, 1, 2, 1),(16, 501, 1, 1, 1),(16, 502, 1, 2, 1),(16, 503, 1, 1, 1),(16, 504, 1, 2, 1),(16, 505, 1, 1, 1),(16, 506, 1, 2, 1),(16, 507, 1, 1, 1),(16, 508, 1, 2, 1),(16, 509, 1, 1, 1),(16, 510, 1, 2, 1),(16, 511, 1, 1, 1),(16, 512, 1, 2, 1),(16, 513, 1, 1, 1),(16, 514, 1, 2, 1),(16, 515, 1, 1, 1),(16, 516, 1, 2, 1),(16, 517, 1, 1, 1),(16, 518, 1, 2, 1),(16, 519, 1, 1, 1),(16, 520, 1, 2, 1),(16, 521, 1, 1, 1),(16, 522, 1, 2, 1),(16, 523, 1, 1, 1),(16, 524, 1, 2, 1),(16, 525, 1, 1, 1),(16, 526, 1, 2, 1),(16, 527, 1, 1, 1),(16, 528, 1, 2, 1),(16, 529, 1, 1, 1),(16, 530, 1, 2, 1),(16, 531, 1, 1, 1),(16, 532, 1, 2, 1),(16, 533, 1, 1, 1),(16, 534, 1, 2, 1),(16, 535, 1, 1, 1),(16, 536, 1, 2, 1),(16, 537, 1, 1, 1),(16, 538, 1, 2, 1),(16, 539, 1, 1, 1),(16, 540, 1, 2, 1),(16, 541, 1, 1, 1),(16, 542, 1, 2, 1),(16, 543, 1, 1, 1),(16, 544, 1, 2, 1),(16, 545, 1, 1, 1),(16, 546, 1, 2, 1),(16, 547, 1, 1, 1),(16, 548, 1, 2, 1),(16, 549, 1, 1, 1),(16, 550, 1, 2, 1),(16, 551, 1, 1, 1),(16, 552, 1, 2, 1),(16, 553, 1, 1, 1),(16, 554, 1, 2, 1),(16, 555, 1, 1, 1),(16, 556, 1, 2, 1),(16, 557, 1, 1, 1),(16, 558, 1, 2, 1),(16, 559, 1, 1, 1),(16, 560, 1, 2, 1),(16, 561, 1, 1, 1),(16, 562, 1, 2, 1),(16, 563, 1, 1, 1),(16, 564, 1, 2, 1),(16, 565, 1, 1, 1),(16, 566, 1, 2, 1),(16, 567, 1, 1, 1),(16, 568, 1, 2, 1),(16, 569, 1, 1, 1),(16, 570, 1, 2, 1),(16, 571, 1, 1, 1),(16, 572, 1, 2, 1),(16, 573, 1, 1, 1),(16, 574, 1, 2, 1),(16, 575, 1, 1, 1),(16, 576, 1, 2, 1),(16, 577, 1, 1, 1),(16, 578, 1, 2, 1),(16, 579, 1, 1, 1),(16, 580, 1, 2, 1),(16, 581, 1, 1, 1),(16, 582, 1, 2, 1),(16, 583, 1, 1, 1),(16, 584, 1, 2, 1),(16, 585, 1, 1, 1),(16, 586, 1, 2, 1),(16, 587, 1, 1, 1),(16, 588, 1, 2, 1),(16, 589, 1, 1, 1),(16, 590, 1, 2, 1),(16, 591, 1, 1, 1),(16, 592, 1, 2, 1),(16, 593, 1, 1, 1),(16, 594, 1, 2, 1),(16, 595, 1, 1, 1),(16, 596, 1, 2, 1),(16, 597, 1, 1, 1),(16, 598, 1, 2, 1),(16, 599, 1, 1, 1),(16, 600, 1, 2, 1),(16, 601, 1, 1, 1),(16, 602, 1, 2, 1),(16, 603, 1, 1, 1),(16, 604, 1, 2, 1),(16, 605, 1, 1, 1),(16, 606, 1, 2, 1),(16, 607, 1, 1, 1),(16, 608, 1, 2, 1),(16, 609, 1, 1, 1),(16, 610, 1, 2, 1),(16, 611, 1, 1, 1),(16, 612, 1, 2, 1),(16, 613, 1, 1, 1),(16, 614, 1, 2, 1),(16, 615, 1, 1, 1),(16, 616, 1, 2, 1),(16, 617, 1, 1, 1),(16, 618, 1, 2, 1),(16, 619, 1, 1, 1),(16, 620, 1, 2, 1),(16, 621, 1, 1, 1),(16, 622, 1, 2, 1),(16, 623, 1, 1, 1),(16, 624, 1, 2, 1),(16, 625, 1, 1, 1),(16, 626, 1, 2, 1),(16, 627, 1, 1, 1),(16, 628, 1, 2, 1),(16, 629, 1, 1, 1),(16, 630, 1, 2, 1),(16, 631, 1, 1, 1),(16, 632, 1, 2, 1),(16, 633, 1, 1, 1),(16, 634, 1, 2, 1),(16, 635, 1, 1, 1),(16, 636, 1, 2, 1),(16, 637, 1, 1, 1),(16, 638, 1, 2, 1),(16, 639, 1, 1, 1),(16, 640, 1, 2, 1),(16, 641, 1, 1, 1),(16, 642, 1, 2, 1),(16, 643, 1, 1, 1),(16, 644, 1, 2, 1),(16, 645, 1, 1, 1),(16, 646, 1, 2, 1),(16, 647, 1, 1, 1),(16, 648, 1, 2, 1),(16, 649, 1, 1, 1),(16, 650, 1, 2, 1),(16, 651, 1, 1, 1),(16, 652, 1, 2, 1),(16, 653, 1, 1, 1),(16, 654, 1, 2, 1),(16, 655, 1, 1, 1),(16, 656, 1, 2, 1),(16, 657, 1, 1, 1),(16, 658, 1, 2, 1),(16, 659, 1, 1, 1),(16, 660, 1, 2, 1),(16, 661, 1, 1, 1),(16, 662, 1, 2, 1),(16, 663, 1, 1, 1),(16, 664, 1, 2, 1),(16, 665, 1, 1, 1),(16, 666, 1, 2, 1),(16, 667, 1, 1, 1),(16, 668, 1, 2, 1),(16, 669, 1, 1, 1),(16, 670, 1, 2, 1),(16, 671, 1, 1, 1),(16, 672, 1, 2, 1),(16, 673, 1, 1, 1),(16, 674, 1, 2, 1),(16, 675, 1, 1, 1),(16, 676, 1, 2, 1),(16, 677, 1, 1, 1),(16, 678, 1, 2, 1),(16, 679, 1, 1, 1),(16, 680, 1, 2, 1),(16, 681, 1, 1, 1),(16, 682, 1, 2, 1),(16, 683, 1, 1, 1),(16, 684, 1, 2, 1),(16, 685, 1, 1, 1),(16, 686, 1, 2, 1),(16, 687, 1, 1, 1),(16, 688, 1, 2, 1),(16, 689, 1, 1, 1),(16, 690, 1, 2, 1),(16, 691, 1, 1, 1),(16, 692, 1, 2, 1),(16, 693, 1, 1, 1),(16, 694, 1, 2, 1),(16, 695, 1, 1, 1),(16, 696, 1, 2, 1),(16, 697, 1, 1, 1),(16, 698, 1, 2, 1),(16, 699, 1, 1, 1),(16, 700, 1, 2, 1),(16, 701, 1, 1, 1),(16, 702, 1, 2, 1),(16, 703, 1, 1, 1),(16, 704, 1, 2, 1),(16, 705, 1, 1, 1),(16, 706, 1, 2, 1),(16, 707, 1, 1, 1),(16, 708, 1, 2, 1),(16, 709, 1, 1, 1),(16, 710, 1, 2, 1),(16, 711, 1, 1, 1),(16, 712, 1, 2, 1),(16, 713, 1, 1, 1),(16, 714, 1, 2, 1),(16, 715, 1, 1, 1),(16, 716, 1, 2, 1),(16, 717, 1, 1, 1),(16, 718, 1, 2, 1),(16, 719, 1, 1, 1),(16, 720, 1, 2, 1),(16, 721, 1, 1, 1),(16, 722, 1, 2, 1),(16, 723, 1, 1, 1),(16, 724, 1, 2, 1),(16, 725, 1, 1, 1),(16, 726, 1, 2, 1),(16, 727, 1, 1, 1),(16, 728, 1, 2, 1),(16, 729, 1, 1, 1),(16, 730, 1, 2, 1),(16, 731, 1, 1, 1),(16, 732, 1, 2, 1),(16, 733, 1, 1, 1),(16, 734, 1, 2, 1),(16, 735, 1, 1, 1),(16, 736, 1, 2, 1),(16, 737, 1, 1, 1),(16, 738, 1, 2, 1),(16, 739, 1, 1, 1),(16, 740, 1, 2, 1),(16, 741, 1, 1, 1),(16, 742, 1, 2, 1),(16, 743, 1, 1, 1),(16, 744, 1, 2, 1),(16, 745, 1, 1, 1),(16, 746, 1, 2, 1),(16, 747, 1, 1, 1),(16, 748, 1, 2, 1),(16, 749, 1, 1, 1),(16, 750, 1, 2, 1),(16, 751, 1, 1, 1),(16, 752, 1, 2, 1),(16, 753, 1, 1, 1),(16, 754, 1, 2, 1),(16, 755, 1, 1, 1),(16, 756, 1, 2, 1),(16, 757, 1, 1, 1),(16, 758, 1, 2, 1),(16, 759, 1, 1, 1),(16, 760, 1, 2, 1),(16, 761, 1, 1, 1),(16, 762, 1, 2, 1),(16, 763, 1, 1, 1),(16, 764, 1, 2, 1),(16, 765, 1, 1, 1),(16, 766, 1, 2, 1),(16, 767, 1, 1, 1),(16, 768, 1, 2, 1),(16, 769, 1, 1, 1),(16, 770, 1, 2, 1),(16, 771, 1, 1, 1),(16, 772, 1, 2, 1),(16, 773, 1, 1, 1),(16, 774, 1, 2, 1),(16, 775, 1, 1, 1),(16, 776, 1, 2, 1),(16, 777, 1, 1, 1),(16, 778, 1, 2, 1),(16, 779, 1, 1, 1),(16, 780, 1, 2, 1),(16, 781, 1, 1, 1),(16, 782, 1, 2, 1),(16, 783, 1, 1, 1),(16, 784, 1, 2, 1),(16, 785, 1, 1, 1),(16, 786, 1, 2, 1),(16, 787, 1, 1, 1),(16, 788, 1, 2, 1),(16, 789, 1, 1, 1),(16, 790, 1, 2, 1),(16, 791, 1, 1, 1),(16, 792, 1, 2, 1),(16, 793, 1, 1, 1),(16, 794, 1, 2, 1),(16, 795, 1, 1, 1),(16, 796, 1, 2, 1),(16, 797, 1, 1, 1),(16, 798, 1, 2, 1),(16, 799, 1, 1, 1),(16, 800, 1, 2, 1),(16, 801, 1, 1, 1),(16, 802, 1, 2, 1),(16, 803, 1, 1, 1),(16, 804, 1, 2, 1),(16, 805, 1, 1, 1),(16, 806, 1, 2, 1),(16, 807, 1, 1, 1),(16, 808, 1, 2, 1),(16, 809, 1, 1, 1),(16, 810, 1, 2, 1),(16, 811, 1, 1, 1),(16, 812, 1, 2, 1),(16, 813, 1, 1, 1),(16, 814, 1, 2, 1),(16, 815, 1, 1, 1),(16, 816, 1, 2, 1),(16, 817, 1, 1, 1),(16, 818, 1, 2, 1),(16, 819, 1, 1, 1),(16, 820, 1, 2, 1),(16, 821, 1, 1, 1),(16, 822, 1, 2, 1),(16, 823, 1, 1, 1),(16, 824, 1, 2, 1),(16, 825, 1, 1, 1),(16, 826, 1, 2, 1),(16, 827, 1, 1, 1),(16, 828, 1, 2, 1),(16, 829, 1, 1, 1),(16, 830, 1, 2, 1),(16, 831, 1, 1, 1),(16, 832, 1, 2, 1),(16, 833, 1, 1, 1),(16, 834, 1, 2, 1),(16, 835, 1, 1, 1),(16, 836, 1, 2, 1),(16, 837, 1, 1, 1),(16, 838, 1, 2, 1),(16, 839, 1, 1, 1),(16, 840, 1, 2, 1),(16, 841, 1, 1, 1),(16, 842, 1, 2, 1),(16, 843, 1, 1, 1),(16, 844, 1, 2, 1),(16, 845, 1, 1, 1),(16, 846, 1, 2, 1),(16, 847, 1, 1, 1),(16, 848, 1, 2, 1),(16, 849, 1, 1, 1),(16, 850, 1, 2, 1),(16, 851, 1, 1, 1),(16, 852, 1, 2, 1),(16, 853, 1, 1, 1),(16, 854, 1, 2, 1),(16, 855, 1, 1, 1),(16, 856, 1, 2, 1),(16, 857, 1, 1, 1),(16, 858, 1, 2, 1),(16, 859, 1, 1, 1),(16, 860, 1, 2, 1),(16, 861, 1, 1, 1),(16, 862, 1, 2, 1),(16, 863, 1, 1, 1),(16, 864, 1, 2, 1),(16, 865, 1, 1, 1),(16, 866, 1, 2, 1),(16, 867, 1, 1, 1),(16, 868, 1, 2, 1),(16, 869, 1, 1, 1),(16, 870, 1, 2, 1),(16, 871, 1, 1, 1),(16, 872, 1, 2, 1),(16, 873, 1, 1, 1),(16, 874, 1, 2, 1),(16, 875, 1, 1, 1),(16, 876, 1, 2, 1),(16, 877, 1, 1, 1),(16, 878, 1, 2, 1),(16, 879, 1, 1, 1),(16, 880, 1, 2, 1),(16, 881, 1, 1, 1),(16, 882, 1, 2, 1),(16, 883, 1, 1, 1),(16, 884, 1, 2, 1),(16, 885, 1, 1, 1),(16, 886, 1, 2, 1),(16, 887, 1, 1, 1),(16, 888, 1, 2, 1),(16, 889, 1, 1, 1),(16, 890, 1, 2, 1),(16, 891, 1, 1, 1),(16, 892, 1, 2, 1),(16, 893, 1, 1, 1),(16, 894, 1, 2, 1),(16, 895, 1, 1, 1),(16, 896, 1, 2, 1),(16, 897, 1, 1, 1),(16, 898, 1, 2, 1),(16, 899, 1, 1, 1),(16, 900, 1, 2, 1),(16, 901, 1, 1, 1),(16, 902, 1, 2, 1),(16, 903, 1, 1, 1),(16, 904, 1, 2, 1),(16, 905, 1, 1, 1),(16, 906, 1, 2, 1),(16, 907, 1, 1, 1),(16, 908, 1, 2, 1),(16, 909, 1, 1, 1),(16, 910, 1, 2, 1),(16, 911, 1, 1, 1),(16, 912, 1, 2, 1),(16, 913, 1, 1, 1),(16, 914, 1, 2, 1),(16, 915, 1, 1, 1),(16, 916, 1, 2, 1),(16, 917, 1, 1, 1),(16, 918, 1, 2, 1),(16, 919, 1, 1, 1),(16, 920, 1, 2, 1),(16, 921, 1, 1, 1),(16, 922, 1, 2, 1),(16, 923, 1, 1, 1),(16, 924, 1, 2, 1),(16, 925, 1, 1, 1),(16, 926, 1, 2, 1),(16, 927, 1, 1, 1),(16, 928, 1, 2, 1),(16, 929, 1, 1, 1),(16, 930, 1, 2, 1),(16, 931, 1, 1, 1),(16, 932, 1, 2, 1),(16, 933, 1, 1, 1),(16, 934, 1, 2, 1),(16, 935, 1, 1, 1),(16, 936, 1, 2, 1),(16, 937, 1, 1, 1),(16, 938, 1, 2, 1),(16, 939, 1, 1, 1),(16, 940, 1, 2, 1),(16, 941, 1, 1, 1),(16, 942, 1, 2, 1),(16, 943, 1, 1, 1),(16, 944, 1, 2, 1),(16, 945, 1, 1, 1),(16, 946, 1, 2, 1),(16, 947, 1, 1, 1),(16, 948, 1, 2, 1),(16, 949, 1, 1, 1),(16, 950, 1, 2, 1),(16, 951, 1, 1, 1),(16, 952, 1, 2, 1),(16, 953, 1, 1, 1),(16, 954, 1, 2, 1),(16, 955, 1, 1, 1),(16, 956, 1, 2, 1),(16, 957, 1, 1, 1),(16, 958, 1, 2, 1),(16, 959, 1, 1, 1),(16, 960, 1, 2, 1),(16, 961, 1, 1, 1),(16, 962, 1, 2, 1),(16, 963, 1, 1, 1),(16, 964, 1, 2, 1),(16, 965, 1, 1, 1),(16, 966, 1, 2, 1),(16, 967, 1, 1, 1),(16, 968, 1, 2, 1),(16, 969, 1, 1, 1),(16, 970, 1, 2, 1),(16, 971, 1, 1, 1),(16, 972, 1, 2, 1),(16, 973, 1, 1, 1),(16, 974, 1, 2, 1),(16, 975, 1, 1, 1),(16, 976, 1, 2, 1),(16, 977, 1, 1, 1),(16, 978, 1, 2, 1),(16, 979, 1, 1, 1),(16, 980, 1, 2, 1),(16, 981, 1, 1, 1),(16, 982, 1, 2, 1),(16, 983, 1, 1, 1),(16, 984, 1, 2, 1),(16, 985, 1, 1, 1),(16, 986, 1, 2, 1),(16, 987, 1, 1, 1),(16, 988, 1, 2, 1),(16, 989, 1, 1, 1),(16, 990, 1, 2, 1),(16, 991, 1, 1, 1),(16, 992, 1, 2, 1),(16, 993, 1, 1, 1),(16, 994, 1, 2, 1),(16, 995, 1, 1, 1),(16, 996, 1, 2, 1),(16, 997, 1, 1, 1),(16, 998, 1, 2, 1),(16, 999, 1, 1, 1),(16, 1000, 1, 2, 1),(16, 1001, 1, 1, 1),(16, 1002, 1, 2, 1),(16, 1003, 1, 1, 1),(16, 1004, 1, 2, 1),(16, 1005, 1, 1, 1),(16, 1006, 1, 2, 1),(16, 1007, 1, 1, 1),(16, 1008, 1, 2, 1),(16, 1009, 1, 1, 1),(16, 1010, 1, 2, 1),(16, 1011, 1, 1, 1),(16, 1012, 1, 2, 1),(16, 1013, 1, 1, 1),(16, 1014, 1, 2, 1),(16, 1015, 1, 1, 1),(16, 1016, 1, 2, 1),(16, 1017, 1, 1, 1),(16, 1018, 1, 2, 1),(16, 1019, 1, 1, 1),(16, 1020, 1, 2, 1),(16, 1021, 1, 1, 1),(16, 1022, 1, 2, 1),(16, 1023, 1, 1, 1),(16, 1024, 1, 2, 1),(16, 1025, 1, 1, 1),(16, 1026, 1, 2, 1),(16, 1027, 1, 1, 1),(16, 1028, 1, 2, 1),(16, 1029, 1, 1, 1),(16, 1030, 1, 2, 1),(16, 1031, 1, 1, 1),(16, 1032, 1, 2, 1),(16, 1033, 1, 1, 1),(16, 1034, 1, 2, 1),(16, 1035, 1, 1, 1),(16, 1036, 1, 2, 1),(16, 1037, 1, 1, 1),(16, 1038, 1, 2, 1),(16, 1039, 1, 1, 1),(16, 1040, 1, 2, 1),(16, 1041, 1, 1, 1),(16, 1042, 1, 2, 1),(16, 1043, 1, 1, 1),(16, 1044, 1, 2, 1),(16, 1045, 1, 1, 1),(16, 1046, 1, 2, 1),(16, 1047, 1, 1, 1),(16, 1048, 1, 2, 1),(16, 1049, 1, 1, 1),(16, 1050, 1, 2, 1),(16, 1051, 1, 1, 1),(16, 1052, 1, 2, 1),(16, 1053, 1, 1, 1),(16, 1054, 1, 2, 1),(16, 1055, 1, 1, 1),(16, 1056, 1, 2, 1),(16, 1057, 1, 1, 1),(16, 1058, 1, 2, 1),(16, 1059, 1, 1, 1),(16, 1060, 1, 2, 1),(16, 1061, 1, 1, 1),(16, 1062, 1, 2, 1),(16, 1063, 1, 1, 1),(16, 1064, 1, 2, 1),(16, 1065, 1, 1, 1),(16, 1066, 1, 2, 1),(16, 1067, 1, 1, 1),(16, 1068, 1, 2, 1),(16, 1069, 1, 1, 1),(16, 1070, 1, 2, 1),(16, 1071, 1, 1, 1),(16, 1072, 1, 2, 1),(16, 1073, 1, 1, 1),(16, 1074, 1, 2, 1),(16, 1075, 1, 1, 1),(16, 1076, 1, 2, 1),(16, 1077, 1, 1, 1),(16, 1078, 1, 2, 1),(16, 1079, 1, 1, 1),(16, 1080, 1, 2, 1),(16, 1081, 1, 1, 1),(16, 1082, 1, 2, 1),(16, 1083, 1, 1, 1),(16, 1084, 1, 2, 1),(16, 1085, 1, 1, 1),(16, 1086, 1, 2, 1),(16, 1087, 1, 1, 1),(16, 1088, 1, 2, 1),(16, 1089, 1, 1, 1),(16, 1090, 1, 2, 1),(16, 1091, 1, 1, 1),(16, 1092, 1, 2, 1),(16, 1093, 1, 1, 1),(16, 1094, 1, 2, 1),(16, 1095, 1, 1, 1),(16, 1096, 1, 2, 1),(16, 1097, 1, 1, 1),(16, 1098, 1, 2, 1),(16, 1099, 1, 1, 1),(16, 1100, 1, 2, 1),(16, 1101, 1, 1, 1),(16, 1102, 1, 2, 1),(16, 1103, 1, 1, 1),(16, 1104, 1, 2, 1),(16, 1105, 1, 1, 1),(16, 1106, 1, 2, 1),(16, 1107, 1, 1, 1),(16, 1108, 1, 2, 1),(16, 1109, 1, 1, 1),(16, 1110, 1, 2, 1),(16, 1111, 1, 1, 1),(16, 1112, 1, 2, 1),(16, 1113, 1, 1, 1),(16, 1114, 1, 2, 1),(16, 1115, 1, 1, 1),(16, 1116, 1, 2, 1),(16, 1117, 1, 1, 1),(16, 1118, 1, 2, 1),(16, 1119, 1, 1, 1),(16, 1120, 1, 2, 1),(16, 1121, 1, 1, 1),(16, 1122, 1, 2, 1),(16, 1123, 1, 1, 1),(16, 1124, 1, 2, 1),(16, 1125, 1, 1, 1),(16, 1126, 1, 2, 1),(16, 1127, 1, 1, 1),(16, 1128, 1, 2, 1),(16, 1129, 1, 1, 1),(16, 1130, 1, 2, 1),(16, 1131, 1, 1, 1),(16, 1132, 1, 2, 1),(16, 1133, 1, 1, 1),(16, 1134, 1, 2, 1),(16, 1135, 1, 1, 1),(16, 1136, 1, 2, 1),(16, 1137, 1, 1, 1),(16, 1138, 1, 2, 1),(16, 1139, 1, 1, 1),(16, 1140, 1, 2, 1),(16, 1141, 1, 1, 1),(16, 1142, 1, 2, 1),(16, 1143, 1, 1, 1),(16, 1144, 1, 2, 1),(16, 1145, 1, 1, 1),(16, 1146, 1, 2, 1),(16, 1147, 1, 1, 1),(16, 1148, 1, 2, 1),(16, 1149, 1, 1, 1),(16, 1150, 1, 2, 1),(16, 1151, 1, 1, 1),(16, 1152, 1, 2, 1),(16, 1153, 1, 1, 1),(16, 1154, 1, 2, 1),(16, 1155, 1, 1, 1),(16, 1156, 1, 2, 1),(16, 1157, 1, 1, 1),(16, 1158, 1, 2, 1),(16, 1159, 1, 1, 1),(16, 1160, 1, 2, 1),(16, 1161, 1, 1, 1),(16, 1162, 1, 2, 1),(16, 1163, 1, 1, 1),(16, 1164, 1, 2, 1),(16, 1165, 1, 1, 1),(16, 1166, 1, 2, 1),(16, 1167, 1, 1, 1),(16, 1168, 1, 2, 1),(16, 1169, 1, 1, 1),(16, 1170, 1, 2, 1),(16, 1171, 1, 1, 1),(16, 1172, 1, 2, 1),(16, 1173, 1, 1, 1),(16, 1174, 1, 2, 1),(16, 1175, 1, 1, 1),(16, 1176, 1, 2, 1),(16, 1177, 1, 1, 1),(16, 1178, 1, 2, 1),(16, 1179, 1, 1, 1),(16, 1180, 1, 2, 1),(16, 1181, 1, 1, 1),(16, 1182, 1, 2, 1),(16, 1183, 1, 1, 1),(16, 1184, 1, 2, 1),(16, 1185, 1, 1, 1),(16, 1186, 1, 2, 1),(16, 1187, 1, 1, 1),(16, 1188, 1, 2, 1),(16, 1189, 1, 1, 1),(16, 1190, 1, 2, 1),(16, 1191, 1, 1, 1),(16, 1192, 1, 2, 1),(16, 1193, 1, 1, 1),(16, 1194, 1, 2, 1),(16, 1195, 1, 1, 1),(16, 1196, 1, 2, 1),(16, 1197, 1, 1, 1),(16, 1198, 1, 2, 1),(16, 1199, 1, 1, 1),(16, 1200, 1, 2, 1),(16, 1201, 1, 1, 1),(16, 1202, 1, 2, 1),(16, 1203, 1, 1, 1),(16, 1204, 1, 2, 1),(16, 1205, 1, 1, 1),(16, 1206, 1, 2, 1),(16, 1207, 1, 1, 1),(16, 1208, 1, 2, 1),(16, 1209, 1, 1, 1),(16, 1210, 1, 2, 1),(16, 1211, 1, 1, 1),(16, 1212, 1, 2, 1),(16, 1213, 1, 1, 1),(16, 1214, 1, 2, 1),(16, 1215, 1, 1, 1),(16, 1216, 1, 2, 1),(16, 1217, 1, 1, 1),(16, 1218, 1, 2, 1),(16, 1219, 1, 1, 1),(16, 1220, 1, 2, 1),(16, 1221, 1, 1, 1),(16, 1222, 1, 2, 1),(16, 1223, 1, 1, 1),(16, 1224, 1, 2, 1),(16, 1225, 1, 1, 1),(16, 1226, 1, 2, 1),(16, 1227, 1, 1, 1),(16, 1228, 1, 2, 1),(16, 1229, 1, 1, 1),(16, 1230, 1, 2, 1),(16, 1231, 1, 1, 1),(16, 1232, 1, 2, 1),(16, 1233, 1, 1, 1),(16, 1234, 1, 2, 1),(16, 1235, 1, 1, 1),(16, 1236, 1, 2, 1),(16, 1237, 1, 1, 1),(16, 1238, 1, 2, 1),(16, 1239, 1, 1, 1),(16, 1240, 1, 2, 1),(16, 1241, 1, 1, 1),(16, 1242, 1, 2, 1),(16, 1243, 1, 1, 1),(16, 1244, 1, 2, 1),(16, 1245, 1, 1, 1),(16, 1246, 1, 2, 1),(16, 1247, 1, 1, 1),(16, 1248, 1, 2, 1),(16, 1249, 1, 1, 1),(16, 1250, 1, 2, 1),(16, 1251, 1, 1, 1),(16, 1252, 1, 2, 1),(16, 1253, 1, 1, 1),(16, 1254, 1, 2, 1),(16, 1255, 1, 1, 1),(16, 1256, 1, 2, 1),(16, 1257, 1, 1, 1),(16, 1258, 1, 2, 1),(16, 1259, 1, 1, 1),(16, 1260, 1, 2, 1),(16, 1261, 1, 1, 1),(16, 1262, 1, 2, 1),(16, 1263, 1, 1, 1),(16, 1264, 1, 2, 1),(16, 1265, 1, 1, 1),(16, 1266, 1, 2, 1),(16, 1267, 1, 1, 1),(16, 1268, 1, 2, 1),(16, 1269, 1, 1, 1),(16, 1270, 1, 2, 1),(16, 1271, 1, 1, 1),(16, 1272, 1, 2, 1),(16, 1273, 1, 1, 1),(16, 1274, 1, 2, 1),(16, 1275, 1, 1, 1),(16, 1276, 1, 2, 1),(16, 1277, 1, 1, 1),(16, 1278, 1, 2, 1),(16, 1279, 1, 1, 1),(16, 1280, 1, 2, 1),(16, 1281, 1, 1, 1),(16, 1282, 1, 2, 1),(16, 1283, 1, 1, 1),(16, 1284, 1, 2, 1),(16, 1285, 1, 1, 1),(16, 1286, 1, 2, 1),(16, 1287, 1, 1, 1),(16, 1288, 1, 2, 1),(16, 1289, 1, 1, 1),(16, 1290, 1, 2, 1),(16, 1291, 1, 1, 1),(16, 1292, 1, 2, 1),(16, 1293, 1, 1, 1),(16, 1294, 1, 2, 1),(16, 1295, 1, 1, 1),(16, 1296, 1, 2, 1),(16, 1297, 1, 1, 1),(16, 1298, 1, 2, 1),(16, 1299, 1, 1, 1),(16, 1300, 1, 2, 1),(16, 1301, 1, 1, 1),(16, 1302, 1, 2, 1),(16, 1303, 1, 1, 1),(16, 1304, 1, 2, 1),(16, 1305, 1, 1, 1),(16, 1306, 1, 2, 1),(16, 1307, 1, 1, 1),(16, 1308, 1, 2, 1),(16, 1309, 1, 1, 1),(16, 1310, 1, 2, 1),(16, 1311, 1, 1, 1),(16, 1312, 1, 2, 1),(16, 1313, 1, 1, 1),(16, 1314, 1, 2, 1),(16, 1315, 1, 1, 1),(16, 1316, 1, 2, 1),(16, 1317, 1, 1, 1),(16, 1318, 1, 2, 1),(16, 1319, 1, 1, 1),(16, 1320, 1, 2, 1),(16, 1321, 1, 1, 1),(16, 1322, 1, 2, 1),(16, 1323, 1, 1, 1),(16, 1324, 1, 2, 1),(16, 1325, 1, 1, 1),(16, 1326, 1, 2, 1),(16, 1327, 1, 1, 1),(16, 1328, 1, 2, 1),(16, 1329, 1, 1, 1),(16, 1330, 1, 2, 1),(16, 1331, 1, 1, 1),(16, 1332, 1, 2, 1),(16, 1333, 1, 1, 1),(16, 1334, 1, 2, 1),(16, 1335, 1, 1, 1),(16, 1336, 1, 2, 1),(16, 1337, 1, 1, 1),(16, 1338, 1, 2, 1),(16, 1339, 1, 1, 1),(16, 1340, 1, 2, 1),(16, 1341, 1, 1, 1),(16, 1342, 1, 2, 1),(16, 1343, 1, 1, 1),(16, 1344, 1, 2, 1),(16, 1345, 1, 1, 1),(16, 1346, 1, 2, 1),(16, 1347, 1, 1, 1),(16, 1348, 1, 2, 1),(16, 1349, 1, 1, 1),(16, 1350, 1, 2, 1),(16, 1351, 1, 1, 1),(16, 1352, 1, 2, 1),(16, 1353, 1, 1, 1),(16, 1354, 1, 2, 1),(16, 1355, 1, 1, 1),(16, 1356, 1, 2, 1),(16, 1357, 1, 1, 1),(16, 1358, 1, 2, 1),(16, 1359, 1, 1, 1),(16, 1360, 1, 2, 1),(16, 1361, 1, 1, 1),(16, 1362, 1, 2, 1),(16, 1363, 1, 1, 1),(16, 1364, 1, 2, 1),(16, 1365, 1, 1, 1),(16, 1366, 1, 2, 1),(16, 1367, 1, 1, 1),(16, 1368, 1, 2, 1),(16, 1369, 1, 1, 1),(16, 1370, 1, 2, 1),(16, 1371, 1, 1, 1),(16, 1372, 1, 2, 1),(16, 1373, 1, 1, 1),(16, 1374, 1, 2, 1),(16, 1375, 1, 1, 1),(16, 1376, 1, 2, 1),(16, 1377, 1, 1, 1),(16, 1378, 1, 2, 1),(16, 1379, 1, 1, 1),(16, 1380, 1, 2, 1),(16, 1381, 1, 1, 1),(16, 1382, 1, 2, 1),(16, 1383, 1, 1, 1),(16, 1384, 1, 2, 1),(16, 1385, 1, 1, 1),(16, 1386, 1, 2, 1),(16, 1387, 1, 1, 1),(16, 1388, 1, 2, 1),(16, 1389, 1, 1, 1),(16, 1390, 1, 2, 1),(16, 1391, 1, 1, 1),(16, 1392, 1, 2, 1),(16, 1393, 1, 1, 1),(16, 1394, 1, 2, 1),(16, 1395, 1, 1, 1),(16, 1396, 1, 2, 1),(16, 1397, 1, 1, 1),(16, 1398, 1, 2, 1),(16, 1399, 1, 1, 1),(16, 1400, 1, 2, 1),(16, 1401, 1, 1, 1),(16, 1402, 1, 2, 1),(16, 1403, 1, 1, 1),(16, 1404, 1, 2, 1),(16, 1405, 1, 1, 1),(16, 1406, 1, 2, 1),(16, 1407, 1, 1, 1),(16, 1408, 1, 2, 1),(16, 1409, 1, 1, 1),(16, 1410, 1, 2, 1),(16, 1411, 1, 1, 1),(16, 1412, 1, 2, 1),(16, 1413, 1, 1, 1),(16, 1414, 1, 2, 1),(16, 1415, 1, 1, 1),(16, 1416, 1, 2, 1),(16, 1417, 1, 1, 1),(16, 1418, 1, 2, 1),(16, 1419, 1, 1, 1),(16, 1420, 1, 2, 1),(16, 1421, 1, 1, 1),(16, 1422, 1, 2, 1),(16, 1423, 1, 1, 1),(16, 1424, 1, 2, 1),(16, 1425, 1, 1, 1),(16, 1426, 1, 2, 1),(16, 1427, 1, 1, 1),(16, 1428, 1, 2, 1),(16, 1429, 1, 1, 1),(16, 1430, 1, 2, 1),(16, 1431, 1, 1, 1),(16, 1432, 1, 2, 1),(16, 1433, 1, 1, 1),(16, 1434, 1, 2, 1),(16, 1435, 1, 1, 1),(16, 1436, 1, 2, 1),(16, 1437, 1, 1, 1),(16, 1438, 1, 2, 1),(16, 1439, 1, 1, 1),(16, 1440, 1, 2, 1),(16, 1441, 1, 1, 1),(16, 1442, 1, 2, 1),(16, 1443, 1, 1, 1),(16, 1444, 1, 2, 1),(16, 1445, 1, 1, 1),(16, 1446, 1, 2, 1),(16, 1447, 1, 1, 1),(16, 1448, 1, 2, 1),(16, 1449, 1, 1, 1),(16, 1450, 1, 2, 1),(16, 1451, 1, 1, 1),(16, 1452, 1, 2, 1),(16, 1453, 1, 1, 1),(16, 1454, 1, 2, 1),(16, 1455, 1, 1, 1),(16, 1456, 1, 2, 1),(16, 1457, 1, 1, 1),(16, 1458, 1, 2, 1),(16, 1459, 1, 1, 1),(16, 1460, 1, 2, 1),(16, 1461, 1, 1, 1),(16, 1462, 1, 2, 1),(16, 1463, 1, 1, 1),(16, 1464, 1, 2, 1),(16, 1465, 1, 1, 1),(16, 1466, 1, 2, 1),(16, 1467, 1, 1, 1),(16, 1468, 1, 2, 1),(16, 1469, 1, 1, 1),(16, 1470, 1, 2, 1),(16, 1471, 1, 1, 1),(16, 1472, 1, 2, 1),(16, 1473, 1, 1, 1),(16, 1474, 1, 2, 1),(16, 1475, 1, 1, 1),(16, 1476, 1, 2, 1),(16, 1477, 1, 1, 1),(16, 1478, 1, 2, 1),(16, 1479, 1, 1, 1),(16, 1480, 1, 2, 1),(16, 1481, 1, 1, 1),(16, 1482, 1, 2, 1),(16, 1483, 1, 1, 1),(16, 1484, 1, 2, 1),(16, 1485, 1, 1, 1),(16, 1486, 1, 2, 1),(16, 1487, 1, 1, 1),(16, 1488, 1, 2, 1),(16, 1489, 2, 1, 1),(16, 1490, 2, 2, 1),(16, 1491, 2, 1, 1),(16, 1492, 2, 2, 1),(16, 1493, 2, 1, 1),(16, 1494, 2, 2, 1),(16, 1495, 2, 1, 1),(16, 1496, 2, 2, 1),(16, 1497, 3, 1, 1),(16, 1498, 3, 2, 1),(16, 1499, 3, 1, 1),(16, 1500, 3, 2, 1),(16, 1501, 4, 1, 1),(16, 1502, 4, 2, 1),(16, 1503, 4, 1, 1),(16, 1504, 4, 2, 1),(16, 1505, 1, 1, 1),(16, 1506, 1, 2, 1),(16, 1507, 1, 1, 1),(16, 1508, 1, 2, 1),(16, 1509, 1, 1, 1),(16, 1510, 1, 2, 1),(16, 1511, 1, 1, 1),(16, 1512, 1, 2, 1),(16, 1513, 1, 1, 1),(16, 1514, 1, 2, 1),(16, 1515, 1, 1, 1),(16, 1516, 1, 2, 1),(16, 1517, 1, 1, 1),(16, 1518, 1, 2, 1),(16, 1519, 1, 1, 1),(16, 1520, 1, 2, 1),(16, 1521, 2, 1, 1),(16, 1522, 2, 2, 1),(16, 1523, 2, 1, 1),(16, 1524, 2, 2, 1),(16, 1525, 2, 1, 1),(16, 1526, 2, 2, 1),(16, 1527, 2, 1, 1),(16, 1528, 2, 2, 1),(16, 1529, 3, 1, 1),(16, 1530, 3, 2, 1),(16, 1531, 3, 1, 1),(16, 1532, 3, 2, 1),(16, 1533, 4, 1, 1),(16, 1534, 4, 2, 1),(16, 1535, 4, 1, 1),(16, 1536, 4, 2, 1),(17, 1, 1, 1, 1),(17, 2, 1, 1, 2),(17, 3, 1, 1, 1),(17, 4, 1, 1, 2),(17, 5, 1, 1, 1),(17, 6, 1, 1, 2),(17, 7, 1, 1, 1),(17, 8, 1, 1, 2),(17, 9, 1, 1, 1),(17, 10, 1, 1, 2),(17, 11, 1, 1, 1),(17, 12, 1, 1, 2),(17, 13, 1, 1, 1),(17, 14, 1, 1, 2),(17, 15, 1, 1, 1),(17, 16, 1, 1, 2),(17, 17, 1, 1, 1),(17, 18, 1, 1, 2),(17, 19, 1, 1, 1),(17, 20, 1, 1, 2),(17, 21, 1, 1, 1),(17, 22, 1, 1, 2),(17, 23, 1, 1, 1),(17, 24, 1, 1, 2),(17, 25, 1, 1, 1),(17, 26, 1, 1, 2),(17, 27, 1, 1, 1),(17, 28, 1, 1, 2),(17, 29, 1, 1, 1),(17, 30, 1, 1, 2),(17, 31, 1, 1, 1),(17, 32, 1, 1, 2),(17, 33, 1, 1, 3),(17, 34, 1, 1, 4),(17, 35, 1, 1, 3),(17, 36, 1, 1, 4),(17, 37, 1, 1, 3),(17, 38, 1, 1, 4),(17, 39, 1, 1, 3),(17, 40, 1, 1, 4),(17, 41, 1, 1, 3),(17, 42, 1, 1, 4),(17, 43, 1, 1, 3),(17, 44, 1, 1, 4),(17, 45, 1, 1, 3),(17, 46, 1, 1, 4),(17, 47, 1, 1, 3),(17, 48, 1, 1, 4),(17, 49, 1, 1, 3),(17, 50, 1, 1, 4),(17, 51, 1, 1, 3),(17, 52, 1, 1, 4),(17, 53, 1, 1, 3),(17, 54, 1, 1, 4),(17, 55, 1, 1, 3),(17, 56, 1, 1, 4),(17, 57, 1, 1, 3),(17, 58, 1, 1, 4),(17, 59, 1, 1, 3),(17, 60, 1, 1, 4),(17, 61, 1, 1, 3),(17, 62, 1, 1, 4),(17, 63, 1, 1, 3),(17, 64, 1, 1, 4),(17, 65, 1, 1, 1),(17, 66, 1, 1, 2),(17, 67, 1, 1, 1),(17, 68, 1, 1, 2),(17, 69, 1, 1, 1),(17, 70, 1, 1, 2),(17, 71, 1, 1, 1),(17, 72, 1, 1, 2),(17, 73, 1, 1, 1),(17, 74, 1, 1, 2),(17, 75, 1, 1, 1),(17, 76, 1, 1, 2),(17, 77, 1, 1, 1),(17, 78, 1, 1, 2),(17, 79, 1, 1, 1),(17, 80, 1, 1, 2),(17, 81, 1, 1, 1),(17, 82, 1, 1, 2),(17, 83, 1, 1, 1),(17, 84, 1, 1, 2),(17, 85, 1, 1, 1),(17, 86, 1, 1, 2),(17, 87, 1, 1, 1),(17, 88, 1, 1, 2),(17, 89, 1, 1, 1),(17, 90, 1, 1, 2),(17, 91, 1, 1, 1),(17, 92, 1, 1, 2),(17, 93, 1, 1, 1),(17, 94, 1, 1, 2),(17, 95, 1, 1, 1),(17, 96, 1, 1, 2),(17, 97, 1, 1, 3),(17, 98, 1, 1, 4),(17, 99, 1, 1, 3),(17, 100, 1, 1, 4),(17, 101, 1, 1, 3),(17, 102, 1, 1, 4),(17, 103, 1, 1, 3),(17, 104, 1, 1, 4),(17, 105, 1, 1, 3),(17, 106, 1, 1, 4),(17, 107, 1, 1, 3),(17, 108, 1, 1, 4),(17, 109, 1, 1, 3),(17, 110, 1, 1, 4),(17, 111, 1, 1, 3),(17, 112, 1, 1, 4),(17, 113, 1, 1, 3),(17, 114, 1, 1, 4),(17, 115, 1, 1, 3),(17, 116, 1, 1, 4),(17, 117, 1, 1, 3),(17, 118, 1, 1, 4),(17, 119, 1, 1, 3),(17, 120, 1, 1, 4),(17, 121, 1, 1, 3),(17, 122, 1, 1, 4),(17, 123, 1, 1, 3),(17, 124, 1, 1, 4),(17, 125, 1, 1, 3),(17, 126, 1, 1, 4),(17, 127, 1, 1, 3),(17, 128, 1, 1, 4),(17, 129, 1, 1, 1),(17, 130, 1, 1, 2),(17, 131, 1, 1, 1),(17, 132, 1, 1, 2),(17, 133, 1, 1, 1),(17, 134, 1, 1, 2),(17, 135, 1, 1, 1),(17, 136, 1, 1, 2),(17, 137, 1, 1, 1),(17, 138, 1, 1, 2),(17, 139, 1, 1, 1),(17, 140, 1, 1, 2),(17, 141, 1, 1, 1),(17, 142, 1, 1, 2),(17, 143, 1, 1, 1),(17, 144, 1, 1, 2),(17, 145, 1, 1, 1),(17, 146, 1, 1, 2),(17, 147, 1, 1, 1),(17, 148, 1, 1, 2),(17, 149, 1, 1, 1),(17, 150, 1, 1, 2),(17, 151, 1, 1, 1),(17, 152, 1, 1, 2),(17, 153, 1, 1, 1),(17, 154, 1, 1, 2),(17, 155, 1, 1, 1),(17, 156, 1, 1, 2),(17, 157, 1, 1, 1),(17, 158, 1, 1, 2),(17, 159, 1, 1, 1),(17, 160, 1, 1, 2),(17, 161, 1, 1, 3),(17, 162, 1, 1, 4),(17, 163, 1, 1, 3),(17, 164, 1, 1, 4),(17, 165, 1, 1, 3),(17, 166, 1, 1, 4),(17, 167, 1, 1, 3),(17, 168, 1, 1, 4),(17, 169, 1, 1, 3),(17, 170, 1, 1, 4),(17, 171, 1, 1, 3),(17, 172, 1, 1, 4),(17, 173, 1, 1, 3),(17, 174, 1, 1, 4),(17, 175, 1, 1, 3),(17, 176, 1, 1, 4),(17, 177, 1, 1, 3),(17, 178, 1, 1, 4),(17, 179, 1, 1, 3),(17, 180, 1, 1, 4),(17, 181, 1, 1, 3),(17, 182, 1, 1, 4),(17, 183, 1, 1, 3),(17, 184, 1, 1, 4),(17, 185, 1, 1, 3),(17, 186, 1, 1, 4),(17, 187, 1, 1, 3),(17, 188, 1, 1, 4),(17, 189, 1, 1, 3),(17, 190, 1, 1, 4),(17, 191, 1, 1, 3),(17, 192, 1, 1, 4),(17, 193, 1, 1, 1),(17, 194, 1, 1, 2),(17, 195, 1, 1, 1),(17, 196, 1, 1, 2),(17, 197, 1, 1, 1),(17, 198, 1, 1, 2),(17, 199, 1, 1, 1),(17, 200, 1, 1, 2),(17, 201, 1, 1, 1),(17, 202, 1, 1, 2),(17, 203, 1, 1, 1),(17, 204, 1, 1, 2),(17, 205, 1, 1, 1),(17, 206, 1, 1, 2),(17, 207, 1, 1, 1),(17, 208, 1, 1, 2),(17, 209, 1, 1, 1),(17, 210, 1, 1, 2),(17, 211, 1, 1, 1),(17, 212, 1, 1, 2),(17, 213, 1, 1, 1),(17, 214, 1, 1, 2),(17, 215, 1, 1, 1),(17, 216, 1, 1, 2),(17, 217, 1, 1, 1),(17, 218, 1, 1, 2),(17, 219, 1, 1, 1),(17, 220, 1, 1, 2),(17, 221, 1, 1, 1),(17, 222, 1, 1, 2),(17, 223, 1, 1, 1),(17, 224, 1, 1, 2),(17, 225, 1, 1, 3),(17, 226, 1, 1, 4),(17, 227, 1, 1, 3),(17, 228, 1, 1, 4),(17, 229, 1, 1, 3),(17, 230, 1, 1, 4),(17, 231, 1, 1, 3),(17, 232, 1, 1, 4),(17, 233, 1, 1, 3),(17, 234, 1, 1, 4),(17, 235, 1, 1, 3),(17, 236, 1, 1, 4),(17, 237, 1, 1, 3),(17, 238, 1, 1, 4),(17, 239, 1, 1, 3),(17, 240, 1, 1, 4),(17, 241, 1, 1, 3),(17, 242, 1, 1, 4),(17, 243, 1, 1, 3),(17, 244, 1, 1, 4),(17, 245, 1, 1, 3),(17, 246, 1, 1, 4),(17, 247, 1, 1, 3),(17, 248, 1, 1, 4),(17, 249, 1, 1, 3),(17, 250, 1, 1, 4),(17, 251, 1, 1, 3),(17, 252, 1, 1, 4),(17, 253, 1, 1, 3),(17, 254, 1, 1, 4),(17, 255, 1, 1, 3),(17, 256, 1, 1, 4),(17, 257, 1, 1, 1),(17, 258, 1, 1, 2),(17, 259, 1, 1, 1),(17, 260, 1, 1, 2),(17, 261, 1, 1, 1),(17, 262, 1, 1, 2),(17, 263, 1, 1, 1),(17, 264, 1, 1, 2),(17, 265, 1, 1, 1),(17, 266, 1, 1, 2),(17, 267, 1, 1, 1),(17, 268, 1, 1, 2),(17, 269, 1, 1, 1),(17, 270, 1, 1, 2),(17, 271, 1, 1, 1),(17, 272, 1, 1, 2),(17, 273, 1, 1, 1),(17, 274, 1, 1, 2),(17, 275, 1, 1, 1),(17, 276, 1, 1, 2),(17, 277, 1, 1, 1),(17, 278, 1, 1, 2),(17, 279, 1, 1, 1),(17, 280, 1, 1, 2),(17, 281, 1, 1, 1),(17, 282, 1, 1, 2),(17, 283, 1, 1, 1),(17, 284, 1, 1, 2),(17, 285, 1, 1, 1),(17, 286, 1, 1, 2),(17, 287, 1, 1, 1),(17, 288, 1, 1, 2),(17, 289, 1, 1, 3),(17, 290, 1, 1, 4),(17, 291, 1, 1, 3),(17, 292, 1, 1, 4),(17, 293, 1, 1, 3),(17, 294, 1, 1, 4),(17, 295, 1, 1, 3),(17, 296, 1, 1, 4),(17, 297, 1, 1, 3),(17, 298, 1, 1, 4),(17, 299, 1, 1, 3),(17, 300, 1, 1, 4),(17, 301, 1, 1, 3),(17, 302, 1, 1, 4),(17, 303, 1, 1, 3),(17, 304, 1, 1, 4),(17, 305, 1, 1, 3),(17, 306, 1, 1, 4),(17, 307, 1, 1, 3),(17, 308, 1, 1, 4),(17, 309, 1, 1, 3),(17, 310, 1, 1, 4),(17, 311, 1, 1, 3),(17, 312, 1, 1, 4),(17, 313, 1, 1, 3),(17, 314, 1, 1, 4),(17, 315, 1, 1, 3),(17, 316, 1, 1, 4),(17, 317, 1, 1, 3),(17, 318, 1, 1, 4),(17, 319, 1, 1, 3),(17, 320, 1, 1, 4),(17, 321, 1, 1, 1),(17, 322, 1, 1, 2),(17, 323, 1, 1, 1),(17, 324, 1, 1, 2),(17, 325, 1, 1, 1),(17, 326, 1, 1, 2),(17, 327, 1, 1, 1),(17, 328, 1, 1, 2),(17, 329, 1, 1, 1),(17, 330, 1, 1, 2),(17, 331, 1, 1, 1),(17, 332, 1, 1, 2),(17, 333, 1, 1, 1),(17, 334, 1, 1, 2),(17, 335, 1, 1, 1),(17, 336, 1, 1, 2),(17, 337, 1, 1, 1),(17, 338, 1, 1, 2),(17, 339, 1, 1, 1),(17, 340, 1, 1, 2),(17, 341, 1, 1, 1),(17, 342, 1, 1, 2),(17, 343, 1, 1, 1),(17, 344, 1, 1, 2),(17, 345, 1, 1, 1),(17, 346, 1, 1, 2),(17, 347, 1, 1, 1),(17, 348, 1, 1, 2),(17, 349, 1, 1, 1),(17, 350, 1, 1, 2),(17, 351, 1, 1, 1),(17, 352, 1, 1, 2),(17, 353, 1, 1, 3),(17, 354, 1, 1, 4),(17, 355, 1, 1, 3),(17, 356, 1, 1, 4),(17, 357, 1, 1, 3),(17, 358, 1, 1, 4),(17, 359, 1, 1, 3),(17, 360, 1, 1, 4),(17, 361, 1, 1, 3),(17, 362, 1, 1, 4),(17, 363, 1, 1, 3),(17, 364, 1, 1, 4),(17, 365, 1, 1, 3),(17, 366, 1, 1, 4),(17, 367, 1, 1, 3),(17, 368, 1, 1, 4),(17, 369, 1, 1, 3),(17, 370, 1, 1, 4),(17, 371, 1, 1, 3),(17, 372, 1, 1, 4),(17, 373, 1, 1, 3),(17, 374, 1, 1, 4),(17, 375, 1, 1, 3),(17, 376, 1, 1, 4),(17, 377, 1, 1, 3),(17, 378, 1, 1, 4),(17, 379, 1, 1, 3),(17, 380, 1, 1, 4),(17, 381, 1, 1, 3),(17, 382, 1, 1, 4),(17, 383, 1, 1, 3),(17, 384, 1, 1, 4),(17, 385, 1, 1, 1),(17, 386, 1, 1, 2),(17, 387, 1, 1, 1),(17, 388, 1, 1, 2),(17, 389, 1, 1, 1),(17, 390, 1, 1, 2),(17, 391, 1, 1, 1),(17, 392, 1, 1, 2),(17, 393, 1, 1, 1),(17, 394, 1, 1, 2),(17, 395, 1, 1, 1),(17, 396, 1, 1, 2),(17, 397, 1, 1, 1),(17, 398, 1, 1, 2),(17, 399, 1, 1, 1),(17, 400, 1, 1, 2),(17, 401, 1, 1, 1),(17, 402, 1, 1, 2),(17, 403, 1, 1, 1),(17, 404, 1, 1, 2),(17, 405, 1, 1, 1),(17, 406, 1, 1, 2),(17, 407, 1, 1, 1),(17, 408, 1, 1, 2),(17, 409, 1, 1, 1),(17, 410, 1, 1, 2),(17, 411, 1, 1, 1),(17, 412, 1, 1, 2),(17, 413, 1, 1, 1),(17, 414, 1, 1, 2),(17, 415, 1, 1, 1),(17, 416, 1, 1, 2),(17, 417, 1, 1, 3),(17, 418, 1, 1, 4),(17, 419, 1, 1, 3),(17, 420, 1, 1, 4),(17, 421, 1, 1, 3),(17, 422, 1, 1, 4),(17, 423, 1, 1, 3),(17, 424, 1, 1, 4),(17, 425, 1, 1, 3),(17, 426, 1, 1, 4),(17, 427, 1, 1, 3),(17, 428, 1, 1, 4),(17, 429, 1, 1, 3),(17, 430, 1, 1, 4),(17, 431, 1, 1, 3),(17, 432, 1, 1, 4),(17, 433, 1, 1, 3),(17, 434, 1, 1, 4),(17, 435, 1, 1, 3),(17, 436, 1, 1, 4),(17, 437, 1, 1, 3),(17, 438, 1, 1, 4),(17, 439, 1, 1, 3),(17, 440, 1, 1, 4),(17, 441, 1, 1, 3),(17, 442, 1, 1, 4),(17, 443, 1, 1, 3),(17, 444, 1, 1, 4),(17, 445, 1, 1, 3),(17, 446, 1, 1, 4),(17, 447, 1, 1, 3),(17, 448, 1, 1, 4),(17, 449, 1, 1, 1),(17, 450, 1, 1, 2),(17, 451, 1, 1, 1),(17, 452, 1, 1, 2),(17, 453, 1, 1, 1),(17, 454, 1, 1, 2),(17, 455, 1, 1, 1),(17, 456, 1, 1, 2),(17, 457, 1, 1, 1),(17, 458, 1, 1, 2),(17, 459, 1, 1, 1),(17, 460, 1, 1, 2),(17, 461, 1, 1, 1),(17, 462, 1, 1, 2),(17, 463, 1, 1, 1),(17, 464, 1, 1, 2),(17, 465, 1, 1, 1),(17, 466, 1, 1, 2),(17, 467, 1, 1, 1),(17, 468, 1, 1, 2),(17, 469, 1, 1, 1),(17, 470, 1, 1, 2),(17, 471, 1, 1, 1),(17, 472, 1, 1, 2),(17, 473, 1, 1, 1),(17, 474, 1, 1, 2),(17, 475, 1, 1, 1),(17, 476, 1, 1, 2),(17, 477, 1, 1, 1),(17, 478, 1, 1, 2),(17, 479, 1, 1, 1),(17, 480, 1, 1, 2),(17, 481, 1, 1, 3),(17, 482, 1, 1, 4),(17, 483, 1, 1, 3),(17, 484, 1, 1, 4),(17, 485, 1, 1, 3),(17, 486, 1, 1, 4),(17, 487, 1, 1, 3),(17, 488, 1, 1, 4),(17, 489, 1, 1, 3),(17, 490, 1, 1, 4),(17, 491, 1, 1, 3),(17, 492, 1, 1, 4),(17, 493, 1, 1, 3),(17, 494, 1, 1, 4),(17, 495, 1, 1, 3),(17, 496, 1, 1, 4),(17, 497, 1, 1, 3),(17, 498, 1, 1, 4),(17, 499, 1, 1, 3),(17, 500, 1, 1, 4),(17, 501, 1, 1, 3),(17, 502, 1, 1, 4),(17, 503, 1, 1, 3),(17, 504, 1, 1, 4),(17, 505, 1, 1, 3),(17, 506, 1, 1, 4),(17, 507, 1, 1, 3),(17, 508, 1, 1, 4),(17, 509, 1, 1, 3),(17, 510, 1, 1, 4),(17, 511, 1, 1, 3),(17, 512, 1, 1, 4),(17, 513, 1, 1, 1),(17, 514, 1, 1, 2),(17, 515, 1, 1, 1),(17, 516, 1, 1, 2),(17, 517, 1, 1, 1),(17, 518, 1, 1, 2),(17, 519, 1, 1, 1),(17, 520, 1, 1, 2),(17, 521, 1, 1, 1),(17, 522, 1, 1, 2),(17, 523, 1, 1, 1),(17, 524, 1, 1, 2),(17, 525, 1, 1, 1),(17, 526, 1, 1, 2),(17, 527, 1, 1, 1),(17, 528, 1, 1, 2),(17, 529, 1, 1, 1),(17, 530, 1, 1, 2),(17, 531, 1, 1, 1),(17, 532, 1, 1, 2),(17, 533, 1, 1, 1),(17, 534, 1, 1, 2),(17, 535, 1, 1, 1),(17, 536, 1, 1, 2),(17, 537, 1, 1, 1),(17, 538, 1, 1, 2),(17, 539, 1, 1, 1),(17, 540, 1, 1, 2),(17, 541, 1, 1, 1),(17, 542, 1, 1, 2),(17, 543, 1, 1, 1),(17, 544, 1, 1, 2),(17, 545, 1, 1, 3),(17, 546, 1, 1, 4),(17, 547, 1, 1, 3),(17, 548, 1, 1, 4),(17, 549, 1, 1, 3),(17, 550, 1, 1, 4),(17, 551, 1, 1, 3),(17, 552, 1, 1, 4),(17, 553, 1, 1, 3),(17, 554, 1, 1, 4),(17, 555, 1, 1, 3),(17, 556, 1, 1, 4),(17, 557, 1, 1, 3),(17, 558, 1, 1, 4),(17, 559, 1, 1, 3),(17, 560, 1, 1, 4),(17, 561, 1, 1, 3),(17, 562, 1, 1, 4),(17, 563, 1, 1, 3),(17, 564, 1, 1, 4),(17, 565, 1, 1, 3),(17, 566, 1, 1, 4),(17, 567, 1, 1, 3),(17, 568, 1, 1, 4),(17, 569, 1, 1, 3),(17, 570, 1, 1, 4),(17, 571, 1, 1, 3),(17, 572, 1, 1, 4),(17, 573, 1, 1, 3),(17, 574, 1, 1, 4),(17, 575, 1, 1, 3),(17, 576, 1, 1, 4),(17, 577, 1, 1, 1),(17, 578, 1, 1, 2),(17, 579, 1, 1, 1),(17, 580, 1, 1, 2),(17, 581, 1, 1, 1),(17, 582, 1, 1, 2),(17, 583, 1, 1, 1),(17, 584, 1, 1, 2),(17, 585, 1, 1, 1),(17, 586, 1, 1, 2),(17, 587, 1, 1, 1),(17, 588, 1, 1, 2),(17, 589, 1, 1, 1),(17, 590, 1, 1, 2),(17, 591, 1, 1, 1),(17, 592, 1, 1, 2),(17, 593, 1, 1, 1),(17, 594, 1, 1, 2),(17, 595, 1, 1, 1),(17, 596, 1, 1, 2),(17, 597, 1, 1, 1),(17, 598, 1, 1, 2),(17, 599, 1, 1, 1),(17, 600, 1, 1, 2),(17, 601, 1, 1, 1),(17, 602, 1, 1, 2),(17, 603, 1, 1, 1),(17, 604, 1, 1, 2),(17, 605, 1, 1, 1),(17, 606, 1, 1, 2),(17, 607, 1, 1, 1),(17, 608, 1, 1, 2),(17, 609, 1, 1, 3),(17, 610, 1, 1, 4),(17, 611, 1, 1, 3),(17, 612, 1, 1, 4),(17, 613, 1, 1, 3),(17, 614, 1, 1, 4),(17, 615, 1, 1, 3),(17, 616, 1, 1, 4),(17, 617, 1, 1, 3),(17, 618, 1, 1, 4),(17, 619, 1, 1, 3),(17, 620, 1, 1, 4),(17, 621, 1, 1, 3),(17, 622, 1, 1, 4),(17, 623, 1, 1, 3),(17, 624, 1, 1, 4),(17, 625, 1, 1, 3),(17, 626, 1, 1, 4),(17, 627, 1, 1, 3),(17, 628, 1, 1, 4),(17, 629, 1, 1, 3),(17, 630, 1, 1, 4),(17, 631, 1, 1, 3),(17, 632, 1, 1, 4),(17, 633, 1, 1, 3),(17, 634, 1, 1, 4),(17, 635, 1, 1, 3),(17, 636, 1, 1, 4),(17, 637, 1, 1, 3),(17, 638, 1, 1, 4),(17, 639, 1, 1, 3),(17, 640, 1, 1, 4),(17, 641, 1, 1, 1),(17, 642, 1, 1, 2),(17, 643, 1, 1, 1),(17, 644, 1, 1, 2),(17, 645, 1, 1, 1),(17, 646, 1, 1, 2),(17, 647, 1, 1, 1),(17, 648, 1, 1, 2),(17, 649, 1, 1, 1),(17, 650, 1, 1, 2),(17, 651, 1, 1, 1),(17, 652, 1, 1, 2),(17, 653, 1, 1, 1),(17, 654, 1, 1, 2),(17, 655, 1, 1, 1),(17, 656, 1, 1, 2),(17, 657, 1, 1, 1),(17, 658, 1, 1, 2),(17, 659, 1, 1, 1),(17, 660, 1, 1, 2),(17, 661, 1, 1, 1),(17, 662, 1, 1, 2),(17, 663, 1, 1, 1),(17, 664, 1, 1, 2),(17, 665, 1, 1, 1),(17, 666, 1, 1, 2),(17, 667, 1, 1, 1),(17, 668, 1, 1, 2),(17, 669, 1, 1, 1),(17, 670, 1, 1, 2),(17, 671, 1, 1, 1),(17, 672, 1, 1, 2),(17, 673, 1, 1, 3),(17, 674, 1, 1, 4),(17, 675, 1, 1, 3),(17, 676, 1, 1, 4),(17, 677, 1, 1, 3),(17, 678, 1, 1, 4),(17, 679, 1, 1, 3),(17, 680, 1, 1, 4),(17, 681, 1, 1, 3),(17, 682, 1, 1, 4),(17, 683, 1, 1, 3),(17, 684, 1, 1, 4),(17, 685, 1, 1, 3),(17, 686, 1, 1, 4),(17, 687, 1, 1, 3),(17, 688, 1, 1, 4),(17, 689, 1, 1, 3),(17, 690, 1, 1, 4),(17, 691, 1, 1, 3),(17, 692, 1, 1, 4),(17, 693, 1, 1, 3),(17, 694, 1, 1, 4),(17, 695, 1, 1, 3),(17, 696, 1, 1, 4),(17, 697, 1, 1, 3),(17, 698, 1, 1, 4),(17, 699, 1, 1, 3),(17, 700, 1, 1, 4),(17, 701, 1, 1, 3),(17, 702, 1, 1, 4),(17, 703, 1, 1, 3),(17, 704, 1, 1, 4),(17, 705, 1, 1, 1),(17, 706, 1, 1, 2),(17, 707, 1, 1, 1),(17, 708, 1, 1, 2),(17, 709, 1, 1, 1),(17, 710, 1, 1, 2),(17, 711, 1, 1, 1),(17, 712, 1, 1, 2),(17, 713, 1, 1, 1),(17, 714, 1, 1, 2),(17, 715, 1, 1, 1),(17, 716, 1, 1, 2),(17, 717, 1, 1, 1),(17, 718, 1, 1, 2),(17, 719, 1, 1, 1),(17, 720, 1, 1, 2),(17, 721, 1, 1, 1),(17, 722, 1, 1, 2),(17, 723, 1, 1, 1),(17, 724, 1, 1, 2),(17, 725, 1, 1, 1),(17, 726, 1, 1, 2),(17, 727, 1, 1, 1),(17, 728, 1, 1, 2),(17, 729, 1, 1, 1),(17, 730, 1, 1, 2),(17, 731, 1, 1, 1),(17, 732, 1, 1, 2),(17, 733, 1, 1, 1),(17, 734, 1, 1, 2),(17, 735, 1, 1, 1),(17, 736, 1, 1, 2),(17, 737, 1, 1, 3),(17, 738, 1, 1, 4),(17, 739, 1, 1, 3),(17, 740, 1, 1, 4),(17, 741, 1, 1, 3),(17, 742, 1, 1, 4),(17, 743, 1, 1, 3),(17, 744, 1, 1, 4),(17, 745, 1, 1, 3),(17, 746, 1, 1, 4),(17, 747, 1, 1, 3),(17, 748, 1, 1, 4),(17, 749, 1, 1, 3),(17, 750, 1, 1, 4),(17, 751, 1, 1, 3),(17, 752, 1, 1, 4),(17, 753, 1, 1, 3),(17, 754, 1, 1, 4),(17, 755, 1, 1, 3),(17, 756, 1, 1, 4),(17, 757, 1, 1, 3),(17, 758, 1, 1, 4),(17, 759, 1, 1, 3),(17, 760, 1, 1, 4),(17, 761, 1, 1, 3),(17, 762, 1, 1, 4),(17, 763, 1, 1, 3),(17, 764, 1, 1, 4),(17, 765, 1, 1, 3),(17, 766, 1, 1, 4),(17, 767, 1, 1, 3),(17, 768, 1, 1, 4),(17, 769, 1, 1, 1),(17, 770, 1, 1, 2),(17, 771, 1, 1, 1),(17, 772, 1, 1, 2),(17, 773, 1, 1, 1),(17, 774, 1, 1, 2),(17, 775, 1, 1, 1),(17, 776, 1, 1, 2),(17, 777, 1, 1, 1),(17, 778, 1, 1, 2),(17, 779, 1, 1, 1),(17, 780, 1, 1, 2),(17, 781, 1, 1, 1),(17, 782, 1, 1, 2),(17, 783, 1, 1, 1),(17, 784, 1, 1, 2),(17, 785, 1, 1, 1),(17, 786, 1, 1, 2),(17, 787, 1, 1, 1),(17, 788, 1, 1, 2),(17, 789, 1, 1, 1),(17, 790, 1, 1, 2),(17, 791, 1, 1, 1),(17, 792, 1, 1, 2),(17, 793, 1, 1, 1),(17, 794, 1, 1, 2),(17, 795, 1, 1, 1),(17, 796, 1, 1, 2),(17, 797, 1, 1, 1),(17, 798, 1, 1, 2),(17, 799, 1, 1, 1),(17, 800, 1, 1, 2),(17, 801, 1, 1, 3),(17, 802, 1, 1, 4),(17, 803, 1, 1, 3),(17, 804, 1, 1, 4),(17, 805, 1, 1, 3),(17, 806, 1, 1, 4),(17, 807, 1, 1, 3),(17, 808, 1, 1, 4),(17, 809, 1, 1, 3),(17, 810, 1, 1, 4),(17, 811, 1, 1, 3),(17, 812, 1, 1, 4),(17, 813, 1, 1, 3),(17, 814, 1, 1, 4),(17, 815, 1, 1, 3),(17, 816, 1, 1, 4),(17, 817, 1, 1, 3),(17, 818, 1, 1, 4),(17, 819, 1, 1, 3),(17, 820, 1, 1, 4),(17, 821, 1, 1, 3),(17, 822, 1, 1, 4),(17, 823, 1, 1, 3),(17, 824, 1, 1, 4),(17, 825, 1, 1, 3),(17, 826, 1, 1, 4),(17, 827, 1, 1, 3),(17, 828, 1, 1, 4),(17, 829, 1, 1, 3),(17, 830, 1, 1, 4),(17, 831, 1, 1, 3),(17, 832, 1, 1, 4),(17, 833, 1, 1, 1),(17, 834, 1, 1, 2),(17, 835, 1, 1, 1),(17, 836, 1, 1, 2),(17, 837, 1, 1, 1),(17, 838, 1, 1, 2),(17, 839, 1, 1, 1),(17, 840, 1, 1, 2),(17, 841, 1, 1, 1),(17, 842, 1, 1, 2),(17, 843, 1, 1, 1),(17, 844, 1, 1, 2),(17, 845, 1, 1, 1),(17, 846, 1, 1, 2),(17, 847, 1, 1, 1),(17, 848, 1, 1, 2),(17, 849, 1, 1, 1),(17, 850, 1, 1, 2),(17, 851, 1, 1, 1),(17, 852, 1, 1, 2),(17, 853, 1, 1, 1),(17, 854, 1, 1, 2),(17, 855, 1, 1, 1),(17, 856, 1, 1, 2),(17, 857, 1, 1, 1),(17, 858, 1, 1, 2),(17, 859, 1, 1, 1),(17, 860, 1, 1, 2),(17, 861, 1, 1, 1),(17, 862, 1, 1, 2),(17, 863, 1, 1, 1),(17, 864, 1, 1, 2),(17, 865, 1, 1, 3),(17, 866, 1, 1, 4),(17, 867, 1, 1, 3),(17, 868, 1, 1, 4),(17, 869, 1, 1, 3),(17, 870, 1, 1, 4),(17, 871, 1, 1, 3),(17, 872, 1, 1, 4),(17, 873, 1, 1, 3),(17, 874, 1, 1, 4),(17, 875, 1, 1, 3),(17, 876, 1, 1, 4),(17, 877, 1, 1, 3),(17, 878, 1, 1, 4),(17, 879, 1, 1, 3),(17, 880, 1, 1, 4),(17, 881, 1, 1, 3),(17, 882, 1, 1, 4),(17, 883, 1, 1, 3),(17, 884, 1, 1, 4),(17, 885, 1, 1, 3),(17, 886, 1, 1, 4),(17, 887, 1, 1, 3),(17, 888, 1, 1, 4),(17, 889, 1, 1, 3),(17, 890, 1, 1, 4),(17, 891, 1, 1, 3),(17, 892, 1, 1, 4),(17, 893, 1, 1, 3),(17, 894, 1, 1, 4),(17, 895, 1, 1, 3),(17, 896, 1, 1, 4),(17, 897, 1, 1, 1),(17, 898, 1, 1, 2),(17, 899, 1, 1, 1),(17, 900, 1, 1, 2),(17, 901, 1, 1, 1),(17, 902, 1, 1, 2),(17, 903, 1, 1, 1),(17, 904, 1, 1, 2),(17, 905, 1, 1, 1),(17, 906, 1, 1, 2),(17, 907, 1, 1, 1),(17, 908, 1, 1, 2),(17, 909, 1, 1, 1),(17, 910, 1, 1, 2),(17, 911, 1, 1, 1),(17, 912, 1, 1, 2),(17, 913, 1, 1, 1),(17, 914, 1, 1, 2),(17, 915, 1, 1, 1),(17, 916, 1, 1, 2),(17, 917, 1, 1, 1),(17, 918, 1, 1, 2),(17, 919, 1, 1, 1),(17, 920, 1, 1, 2),(17, 921, 1, 1, 1),(17, 922, 1, 1, 2),(17, 923, 1, 1, 1),(17, 924, 1, 1, 2),(17, 925, 1, 1, 1),(17, 926, 1, 1, 2),(17, 927, 1, 1, 1),(17, 928, 1, 1, 2),(17, 929, 1, 1, 3),(17, 930, 1, 1, 4),(17, 931, 1, 1, 3),(17, 932, 1, 1, 4),(17, 933, 1, 1, 3),(17, 934, 1, 1, 4),(17, 935, 1, 1, 3),(17, 936, 1, 1, 4),(17, 937, 1, 1, 3),(17, 938, 1, 1, 4),(17, 939, 1, 1, 3),(17, 940, 1, 1, 4),(17, 941, 1, 1, 3),(17, 942, 1, 1, 4),(17, 943, 1, 1, 3),(17, 944, 1, 1, 4),(17, 945, 1, 1, 3),(17, 946, 1, 1, 4),(17, 947, 1, 1, 3),(17, 948, 1, 1, 4),(17, 949, 1, 1, 3),(17, 950, 1, 1, 4),(17, 951, 1, 1, 3),(17, 952, 1, 1, 4),(17, 953, 1, 1, 3),(17, 954, 1, 1, 4),(17, 955, 1, 1, 3),(17, 956, 1, 1, 4),(17, 957, 1, 1, 3),(17, 958, 1, 1, 4),(17, 959, 1, 1, 3),(17, 960, 1, 1, 4),(17, 961, 1, 1, 1),(17, 962, 1, 1, 2),(17, 963, 1, 1, 1),(17, 964, 1, 1, 2),(17, 965, 1, 1, 1),(17, 966, 1, 1, 2),(17, 967, 1, 1, 1),(17, 968, 1, 1, 2),(17, 969, 1, 1, 1),(17, 970, 1, 1, 2),(17, 971, 1, 1, 1),(17, 972, 1, 1, 2),(17, 973, 1, 1, 1),(17, 974, 1, 1, 2),(17, 975, 1, 1, 1),(17, 976, 1, 1, 2),(17, 977, 1, 1, 1),(17, 978, 1, 1, 2),(17, 979, 1, 1, 1),(17, 980, 1, 1, 2),(17, 981, 1, 1, 1),(17, 982, 1, 1, 2),(17, 983, 1, 1, 1),(17, 984, 1, 1, 2),(17, 985, 1, 1, 1),(17, 986, 1, 1, 2),(17, 987, 1, 1, 1),(17, 988, 1, 1, 2),(17, 989, 1, 1, 1),(17, 990, 1, 1, 2),(17, 991, 1, 1, 1),(17, 992, 1, 1, 2),(17, 993, 1, 1, 3),(17, 994, 1, 1, 4),(17, 995, 1, 1, 3),(17, 996, 1, 1, 4),(17, 997, 1, 1, 3),(17, 998, 1, 1, 4),(17, 999, 1, 1, 3),(17, 1000, 1, 1, 4),(17, 1001, 1, 1, 3),(17, 1002, 1, 1, 4),(17, 1003, 1, 1, 3),(17, 1004, 1, 1, 4),(17, 1005, 1, 1, 3),(17, 1006, 1, 1, 4),(17, 1007, 1, 1, 3),(17, 1008, 1, 1, 4),(17, 1009, 1, 1, 3),(17, 1010, 1, 1, 4),(17, 1011, 1, 1, 3),(17, 1012, 1, 1, 4),(17, 1013, 1, 1, 3),(17, 1014, 1, 1, 4),(17, 1015, 1, 1, 3),(17, 1016, 1, 1, 4),(17, 1017, 1, 1, 3),(17, 1018, 1, 1, 4),(17, 1019, 1, 1, 3),(17, 1020, 1, 1, 4),(17, 1021, 1, 1, 3),(17, 1022, 1, 1, 4),(17, 1023, 1, 1, 3),(17, 1024, 1, 1, 4),(17, 1025, 1, 1, 1),(17, 1026, 1, 1, 2),(17, 1027, 1, 1, 1),(17, 1028, 1, 1, 2),(17, 1029, 1, 1, 1),(17, 1030, 1, 1, 2),(17, 1031, 1, 1, 1),(17, 1032, 1, 1, 2),(17, 1033, 1, 1, 1),(17, 1034, 1, 1, 2),(17, 1035, 1, 1, 1),(17, 1036, 1, 1, 2),(17, 1037, 1, 1, 1),(17, 1038, 1, 1, 2),(17, 1039, 1, 1, 1),(17, 1040, 1, 1, 2),(17, 1041, 1, 1, 1),(17, 1042, 1, 1, 2),(17, 1043, 1, 1, 1),(17, 1044, 1, 1, 2),(17, 1045, 1, 1, 1),(17, 1046, 1, 1, 2),(17, 1047, 1, 1, 1),(17, 1048, 1, 1, 2),(17, 1049, 1, 1, 1),(17, 1050, 1, 1, 2),(17, 1051, 1, 1, 1),(17, 1052, 1, 1, 2),(17, 1053, 1, 1, 1),(17, 1054, 1, 1, 2),(17, 1055, 1, 1, 1),(17, 1056, 1, 1, 2),(17, 1057, 1, 1, 3),(17, 1058, 1, 1, 4),(17, 1059, 1, 1, 3),(17, 1060, 1, 1, 4),(17, 1061, 1, 1, 3),(17, 1062, 1, 1, 4),(17, 1063, 1, 1, 3),(17, 1064, 1, 1, 4),(17, 1065, 1, 1, 3),(17, 1066, 1, 1, 4),(17, 1067, 1, 1, 3),(17, 1068, 1, 1, 4),(17, 1069, 1, 1, 3),(17, 1070, 1, 1, 4),(17, 1071, 1, 1, 3),(17, 1072, 1, 1, 4),(17, 1073, 1, 1, 3),(17, 1074, 1, 1, 4),(17, 1075, 1, 1, 3),(17, 1076, 1, 1, 4),(17, 1077, 1, 1, 3),(17, 1078, 1, 1, 4),(17, 1079, 1, 1, 3),(17, 1080, 1, 1, 4),(17, 1081, 1, 1, 3),(17, 1082, 1, 1, 4),(17, 1083, 1, 1, 3),(17, 1084, 1, 1, 4),(17, 1085, 1, 1, 3),(17, 1086, 1, 1, 4),(17, 1087, 1, 1, 3),(17, 1088, 1, 1, 4),(17, 1089, 1, 1, 1),(17, 1090, 1, 1, 2),(17, 1091, 1, 1, 1),(17, 1092, 1, 1, 2),(17, 1093, 1, 1, 1),(17, 1094, 1, 1, 2),(17, 1095, 1, 1, 1),(17, 1096, 1, 1, 2),(17, 1097, 1, 1, 1),(17, 1098, 1, 1, 2),(17, 1099, 1, 1, 1),(17, 1100, 1, 1, 2),(17, 1101, 1, 1, 1),(17, 1102, 1, 1, 2),(17, 1103, 1, 1, 1),(17, 1104, 1, 1, 2),(17, 1105, 1, 1, 1),(17, 1106, 1, 1, 2),(17, 1107, 1, 1, 1),(17, 1108, 1, 1, 2),(17, 1109, 1, 1, 1),(17, 1110, 1, 1, 2),(17, 1111, 1, 1, 1),(17, 1112, 1, 1, 2),(17, 1113, 1, 1, 1),(17, 1114, 1, 1, 2),(17, 1115, 1, 1, 1),(17, 1116, 1, 1, 2),(17, 1117, 1, 1, 1),(17, 1118, 1, 1, 2),(17, 1119, 1, 1, 1),(17, 1120, 1, 1, 2),(17, 1121, 1, 1, 3),(17, 1122, 1, 1, 4),(17, 1123, 1, 1, 3),(17, 1124, 1, 1, 4),(17, 1125, 1, 1, 3),(17, 1126, 1, 1, 4),(17, 1127, 1, 1, 3),(17, 1128, 1, 1, 4),(17, 1129, 1, 1, 3),(17, 1130, 1, 1, 4),(17, 1131, 1, 1, 3),(17, 1132, 1, 1, 4),(17, 1133, 1, 1, 3),(17, 1134, 1, 1, 4),(17, 1135, 1, 1, 3),(17, 1136, 1, 1, 4),(17, 1137, 1, 1, 3),(17, 1138, 1, 1, 4),(17, 1139, 1, 1, 3),(17, 1140, 1, 1, 4),(17, 1141, 1, 1, 3),(17, 1142, 1, 1, 4),(17, 1143, 1, 1, 3),(17, 1144, 1, 1, 4),(17, 1145, 1, 1, 3),(17, 1146, 1, 1, 4),(17, 1147, 1, 1, 3),(17, 1148, 1, 1, 4),(17, 1149, 1, 1, 3),(17, 1150, 1, 1, 4),(17, 1151, 1, 1, 3),(17, 1152, 1, 1, 4),(17, 1153, 1, 1, 1),(17, 1154, 1, 1, 2),(17, 1155, 1, 1, 1),(17, 1156, 1, 1, 2),(17, 1157, 1, 1, 1),(17, 1158, 1, 1, 2),(17, 1159, 1, 1, 1),(17, 1160, 1, 1, 2),(17, 1161, 1, 1, 1),(17, 1162, 1, 1, 2),(17, 1163, 1, 1, 1),(17, 1164, 1, 1, 2),(17, 1165, 1, 1, 1),(17, 1166, 1, 1, 2),(17, 1167, 1, 1, 1),(17, 1168, 1, 1, 2),(17, 1169, 1, 1, 1),(17, 1170, 1, 1, 2),(17, 1171, 1, 1, 1),(17, 1172, 1, 1, 2),(17, 1173, 1, 1, 1),(17, 1174, 1, 1, 2),(17, 1175, 1, 1, 1),(17, 1176, 1, 1, 2),(17, 1177, 1, 1, 1),(17, 1178, 1, 1, 2),(17, 1179, 1, 1, 1),(17, 1180, 1, 1, 2),(17, 1181, 1, 1, 1),(17, 1182, 1, 1, 2),(17, 1183, 1, 1, 1),(17, 1184, 1, 1, 2),(17, 1185, 1, 1, 3),(17, 1186, 1, 1, 4),(17, 1187, 1, 1, 3),(17, 1188, 1, 1, 4),(17, 1189, 1, 1, 3),(17, 1190, 1, 1, 4),(17, 1191, 1, 1, 3),(17, 1192, 1, 1, 4),(17, 1193, 1, 1, 3),(17, 1194, 1, 1, 4),(17, 1195, 1, 1, 3),(17, 1196, 1, 1, 4),(17, 1197, 1, 1, 3),(17, 1198, 1, 1, 4),(17, 1199, 1, 1, 3),(17, 1200, 1, 1, 4),(17, 1201, 1, 1, 3),(17, 1202, 1, 1, 4),(17, 1203, 1, 1, 3),(17, 1204, 1, 1, 4),(17, 1205, 1, 1, 3),(17, 1206, 1, 1, 4),(17, 1207, 1, 1, 3),(17, 1208, 1, 1, 4),(17, 1209, 1, 1, 3),(17, 1210, 1, 1, 4),(17, 1211, 1, 1, 3),(17, 1212, 1, 1, 4),(17, 1213, 1, 1, 3),(17, 1214, 1, 1, 4),(17, 1215, 1, 1, 3),(17, 1216, 1, 1, 4),(17, 1217, 1, 1, 1),(17, 1218, 1, 1, 2),(17, 1219, 1, 1, 1),(17, 1220, 1, 1, 2),(17, 1221, 1, 1, 1),(17, 1222, 1, 1, 2),(17, 1223, 1, 1, 1),(17, 1224, 1, 1, 2),(17, 1225, 1, 1, 1),(17, 1226, 1, 1, 2),(17, 1227, 1, 1, 1),(17, 1228, 1, 1, 2),(17, 1229, 1, 1, 1),(17, 1230, 1, 1, 2),(17, 1231, 1, 1, 1),(17, 1232, 1, 1, 2),(17, 1233, 1, 1, 1),(17, 1234, 1, 1, 2),(17, 1235, 1, 1, 1),(17, 1236, 1, 1, 2),(17, 1237, 1, 1, 1),(17, 1238, 1, 1, 2),(17, 1239, 1, 1, 1),(17, 1240, 1, 1, 2),(17, 1241, 1, 1, 1),(17, 1242, 1, 1, 2),(17, 1243, 1, 1, 1),(17, 1244, 1, 1, 2),(17, 1245, 1, 1, 1),(17, 1246, 1, 1, 2),(17, 1247, 1, 1, 1),(17, 1248, 1, 1, 2),(17, 1249, 1, 1, 3),(17, 1250, 1, 1, 4),(17, 1251, 1, 1, 3),(17, 1252, 1, 1, 4),(17, 1253, 1, 1, 3),(17, 1254, 1, 1, 4),(17, 1255, 1, 1, 3),(17, 1256, 1, 1, 4),(17, 1257, 1, 1, 3),(17, 1258, 1, 1, 4),(17, 1259, 1, 1, 3),(17, 1260, 1, 1, 4),(17, 1261, 1, 1, 3),(17, 1262, 1, 1, 4),(17, 1263, 1, 1, 3),(17, 1264, 1, 1, 4),(17, 1265, 1, 1, 3),(17, 1266, 1, 1, 4),(17, 1267, 1, 1, 3),(17, 1268, 1, 1, 4),(17, 1269, 1, 1, 3),(17, 1270, 1, 1, 4),(17, 1271, 1, 1, 3),(17, 1272, 1, 1, 4),(17, 1273, 1, 1, 3),(17, 1274, 1, 1, 4),(17, 1275, 1, 1, 3),(17, 1276, 1, 1, 4),(17, 1277, 1, 1, 3),(17, 1278, 1, 1, 4),(17, 1279, 1, 1, 3),(17, 1280, 1, 1, 4),(17, 1281, 1, 1, 1),(17, 1282, 1, 1, 2),(17, 1283, 1, 1, 1),(17, 1284, 1, 1, 2),(17, 1285, 1, 1, 1),(17, 1286, 1, 1, 2),(17, 1287, 1, 1, 1),(17, 1288, 1, 1, 2),(17, 1289, 1, 1, 1),(17, 1290, 1, 1, 2),(17, 1291, 1, 1, 1),(17, 1292, 1, 1, 2),(17, 1293, 1, 1, 1),(17, 1294, 1, 1, 2),(17, 1295, 1, 1, 1),(17, 1296, 1, 1, 2),(17, 1297, 1, 1, 1),(17, 1298, 1, 1, 2),(17, 1299, 1, 1, 1),(17, 1300, 1, 1, 2),(17, 1301, 1, 1, 1),(17, 1302, 1, 1, 2),(17, 1303, 1, 1, 1),(17, 1304, 1, 1, 2),(17, 1305, 1, 1, 1),(17, 1306, 1, 1, 2),(17, 1307, 1, 1, 1),(17, 1308, 1, 1, 2),(17, 1309, 1, 1, 1),(17, 1310, 1, 1, 2),(17, 1311, 1, 1, 1),(17, 1312, 1, 1, 2),(17, 1313, 1, 1, 3),(17, 1314, 1, 1, 4),(17, 1315, 1, 1, 3),(17, 1316, 1, 1, 4),(17, 1317, 1, 1, 3),(17, 1318, 1, 1, 4),(17, 1319, 1, 1, 3),(17, 1320, 1, 1, 4),(17, 1321, 1, 1, 3),(17, 1322, 1, 1, 4),(17, 1323, 1, 1, 3),(17, 1324, 1, 1, 4),(17, 1325, 1, 1, 3),(17, 1326, 1, 1, 4),(17, 1327, 1, 1, 3),(17, 1328, 1, 1, 4),(17, 1329, 1, 1, 3),(17, 1330, 1, 1, 4),(17, 1331, 1, 1, 3),(17, 1332, 1, 1, 4),(17, 1333, 1, 1, 3),(17, 1334, 1, 1, 4),(17, 1335, 1, 1, 3),(17, 1336, 1, 1, 4),(17, 1337, 1, 1, 3),(17, 1338, 1, 1, 4),(17, 1339, 1, 1, 3),(17, 1340, 1, 1, 4),(17, 1341, 1, 1, 3),(17, 1342, 1, 1, 4),(17, 1343, 1, 1, 3),(17, 1344, 1, 1, 4),(17, 1345, 1, 1, 1),(17, 1346, 1, 1, 2),(17, 1347, 1, 1, 1),(17, 1348, 1, 1, 2),(17, 1349, 1, 1, 1),(17, 1350, 1, 1, 2),(17, 1351, 1, 1, 1),(17, 1352, 1, 1, 2),(17, 1353, 1, 1, 1),(17, 1354, 1, 1, 2),(17, 1355, 1, 1, 1),(17, 1356, 1, 1, 2),(17, 1357, 1, 1, 1),(17, 1358, 1, 1, 2),(17, 1359, 1, 1, 1),(17, 1360, 1, 1, 2),(17, 1361, 1, 1, 1),(17, 1362, 1, 1, 2),(17, 1363, 1, 1, 1),(17, 1364, 1, 1, 2),(17, 1365, 1, 1, 1),(17, 1366, 1, 1, 2),(17, 1367, 1, 1, 1),(17, 1368, 1, 1, 2),(17, 1369, 1, 1, 1),(17, 1370, 1, 1, 2),(17, 1371, 1, 1, 1),(17, 1372, 1, 1, 2),(17, 1373, 1, 1, 1),(17, 1374, 1, 1, 2),(17, 1375, 1, 1, 1),(17, 1376, 1, 1, 2),(17, 1377, 1, 1, 3),(17, 1378, 1, 1, 4),(17, 1379, 1, 1, 3),(17, 1380, 1, 1, 4),(17, 1381, 1, 1, 3),(17, 1382, 1, 1, 4),(17, 1383, 1, 1, 3),(17, 1384, 1, 1, 4),(17, 1385, 1, 1, 3),(17, 1386, 1, 1, 4),(17, 1387, 1, 1, 3),(17, 1388, 1, 1, 4),(17, 1389, 1, 1, 3),(17, 1390, 1, 1, 4),(17, 1391, 1, 1, 3),(17, 1392, 1, 1, 4),(17, 1393, 1, 1, 3),(17, 1394, 1, 1, 4),(17, 1395, 1, 1, 3),(17, 1396, 1, 1, 4),(17, 1397, 1, 1, 3),(17, 1398, 1, 1, 4),(17, 1399, 1, 1, 3),(17, 1400, 1, 1, 4),(17, 1401, 1, 1, 3),(17, 1402, 1, 1, 4),(17, 1403, 1, 1, 3),(17, 1404, 1, 1, 4),(17, 1405, 1, 1, 3),(17, 1406, 1, 1, 4),(17, 1407, 1, 1, 3),(17, 1408, 1, 1, 4),(17, 1409, 1, 1, 1),(17, 1410, 1, 1, 2),(17, 1411, 1, 1, 1),(17, 1412, 1, 1, 2),(17, 1413, 1, 1, 1),(17, 1414, 1, 1, 2),(17, 1415, 1, 1, 1),(17, 1416, 1, 1, 2),(17, 1417, 1, 1, 1),(17, 1418, 1, 1, 2),(17, 1419, 1, 1, 1),(17, 1420, 1, 1, 2),(17, 1421, 1, 1, 1),(17, 1422, 1, 1, 2),(17, 1423, 1, 1, 1),(17, 1424, 1, 1, 2),(17, 1425, 1, 1, 1),(17, 1426, 1, 1, 2),(17, 1427, 1, 1, 1),(17, 1428, 1, 1, 2),(17, 1429, 1, 1, 1),(17, 1430, 1, 1, 2),(17, 1431, 1, 1, 1),(17, 1432, 1, 1, 2),(17, 1433, 1, 1, 1),(17, 1434, 1, 1, 2),(17, 1435, 1, 1, 1),(17, 1436, 1, 1, 2),(17, 1437, 1, 1, 1),(17, 1438, 1, 1, 2),(17, 1439, 1, 1, 1),(17, 1440, 1, 1, 2),(17, 1441, 1, 1, 3),(17, 1442, 1, 1, 4),(17, 1443, 1, 1, 3),(17, 1444, 1, 1, 4),(17, 1445, 1, 1, 3),(17, 1446, 1, 1, 4),(17, 1447, 1, 1, 3),(17, 1448, 1, 1, 4),(17, 1449, 1, 1, 3),(17, 1450, 1, 1, 4),(17, 1451, 1, 1, 3),(17, 1452, 1, 1, 4),(17, 1453, 1, 1, 3),(17, 1454, 1, 1, 4),(17, 1455, 1, 1, 3),(17, 1456, 1, 1, 4),(17, 1457, 1, 1, 3),(17, 1458, 1, 1, 4),(17, 1459, 1, 1, 3),(17, 1460, 1, 1, 4),(17, 1461, 1, 1, 3),(17, 1462, 1, 1, 4),(17, 1463, 1, 1, 3),(17, 1464, 1, 1, 4),(17, 1465, 1, 1, 3),(17, 1466, 1, 1, 4),(17, 1467, 1, 1, 3),(17, 1468, 1, 1, 4),(17, 1469, 1, 1, 3),(17, 1470, 1, 1, 4),(17, 1471, 1, 1, 3),(17, 1472, 1, 1, 4),(17, 1473, 1, 1, 1),(17, 1474, 1, 1, 2),(17, 1475, 1, 1, 1),(17, 1476, 1, 1, 2),(17, 1477, 1, 1, 1),(17, 1478, 1, 1, 2),(17, 1479, 1, 1, 1),(17, 1480, 1, 1, 2),(17, 1481, 1, 1, 1),(17, 1482, 1, 1, 2),(17, 1483, 1, 1, 1),(17, 1484, 1, 1, 2),(17, 1485, 1, 1, 1),(17, 1486, 1, 1, 2),(17, 1487, 1, 1, 1),(17, 1488, 1, 1, 2),(17, 1489, 2, 1, 1),(17, 1490, 2, 1, 2),(17, 1491, 2, 1, 1),(17, 1492, 2, 1, 2),(17, 1493, 2, 1, 1),(17, 1494, 2, 1, 2),(17, 1495, 2, 1, 1),(17, 1496, 2, 1, 2),(17, 1497, 3, 1, 1),(17, 1498, 3, 1, 2),(17, 1499, 3, 1, 1),(17, 1500, 3, 1, 2),(17, 1501, 4, 1, 1),(17, 1502, 4, 1, 2),(17, 1503, 4, 1, 1),(17, 1504, 4, 1, 2),(17, 1505, 1, 1, 3),(17, 1506, 1, 1, 4),(17, 1507, 1, 1, 3),(17, 1508, 1, 1, 4),(17, 1509, 1, 1, 3),(17, 1510, 1, 1, 4),(17, 1511, 1, 1, 3),(17, 1512, 1, 1, 4),(17, 1513, 1, 1, 3),(17, 1514, 1, 1, 4),(17, 1515, 1, 1, 3),(17, 1516, 1, 1, 4),(17, 1517, 1, 1, 3),(17, 1518, 1, 1, 4),(17, 1519, 1, 1, 3),(17, 1520, 1, 1, 4),(17, 1521, 2, 1, 3),(17, 1522, 2, 1, 4),(17, 1523, 2, 1, 3),(17, 1524, 2, 1, 4),(17, 1525, 2, 1, 3),(17, 1526, 2, 1, 4),(17, 1527, 2, 1, 3),(17, 1528, 2, 1, 4),(17, 1529, 3, 1, 3),(17, 1530, 3, 1, 4),(17, 1531, 3, 1, 3),(17, 1532, 3, 1, 4),(17, 1533, 4, 1, 3),(17, 1534, 4, 1, 4),(17, 1535, 4, 1, 3),(17, 1536, 4, 1, 4),(18, 1, 1, 1, 1),(18, 2, 1, 1, 1),(18, 3, 1, 1, 1),(18, 4, 1, 1, 1),(18, 5, 1, 1, 1),(18, 6, 1, 1, 1),(18, 7, 1, 1, 1),(18, 8, 1, 1, 1),(18, 9, 1, 1, 1),(18, 10, 1, 1, 1),(18, 11, 1, 1, 1),(18, 12, 1, 1, 1),(18, 13, 1, 1, 1),(18, 14, 1, 1, 1),(18, 15, 1, 1, 1),(18, 16, 1, 1, 1),(18, 17, 1, 1, 1),(18, 18, 1, 1, 1),(18, 19, 1, 1, 1),(18, 20, 1, 1, 1),(18, 21, 1, 1, 1),(18, 22, 1, 1, 1),(18, 23, 1, 1, 1),(18, 24, 1, 1, 1),(18, 25, 1, 1, 1),(18, 26, 1, 1, 1),(18, 27, 1, 1, 1),(18, 28, 1, 1, 1),(18, 29, 1, 1, 1),(18, 30, 1, 1, 1),(18, 31, 1, 1, 1),(18, 32, 1, 1, 1),(18, 33, 1, 1, 2),(18, 34, 1, 1, 2),(18, 35, 1, 1, 2),(18, 36, 1, 1, 2),(18, 37, 1, 1, 2),(18, 38, 1, 1, 2),(18, 39, 1, 1, 2),(18, 40, 1, 1, 2),(18, 41, 1, 1, 2),(18, 42, 1, 1, 2),(18, 43, 1, 1, 2),(18, 44, 1, 1, 2),(18, 45, 1, 1, 2),(18, 46, 1, 1, 2),(18, 47, 1, 1, 2),(18, 48, 1, 1, 2),(18, 49, 1, 1, 2),(18, 50, 1, 1, 2),(18, 51, 1, 1, 2),(18, 52, 1, 1, 2),(18, 53, 1, 1, 2),(18, 54, 1, 1, 2),(18, 55, 1, 1, 2),(18, 56, 1, 1, 2),(18, 57, 1, 1, 2),(18, 58, 1, 1, 2),(18, 59, 1, 1, 2),(18, 60, 1, 1, 2),(18, 61, 1, 1, 2),(18, 62, 1, 1, 2),(18, 63, 1, 1, 2),(18, 64, 1, 1, 2),(18, 65, 1, 1, 1),(18, 66, 1, 1, 1),(18, 67, 1, 1, 1),(18, 68, 1, 1, 1),(18, 69, 1, 1, 1),(18, 70, 1, 1, 1),(18, 71, 1, 1, 1),(18, 72, 1, 1, 1),(18, 73, 1, 1, 1),(18, 74, 1, 1, 1),(18, 75, 1, 1, 1),(18, 76, 1, 1, 1),(18, 77, 1, 1, 1),(18, 78, 1, 1, 1),(18, 79, 1, 1, 1),(18, 80, 1, 1, 1),(18, 81, 1, 1, 1),(18, 82, 1, 1, 1),(18, 83, 1, 1, 1),(18, 84, 1, 1, 1),(18, 85, 1, 1, 1),(18, 86, 1, 1, 1),(18, 87, 1, 1, 1),(18, 88, 1, 1, 1),(18, 89, 1, 1, 1),(18, 90, 1, 1, 1),(18, 91, 1, 1, 1),(18, 92, 1, 1, 1),(18, 93, 1, 1, 1),(18, 94, 1, 1, 1),(18, 95, 1, 1, 1),(18, 96, 1, 1, 1),(18, 97, 1, 1, 2),(18, 98, 1, 1, 2),(18, 99, 1, 1, 2),(18, 100, 1, 1, 2),(18, 101, 1, 1, 2),(18, 102, 1, 1, 2),(18, 103, 1, 1, 2),(18, 104, 1, 1, 2),(18, 105, 1, 1, 2),(18, 106, 1, 1, 2),(18, 107, 1, 1, 2),(18, 108, 1, 1, 2),(18, 109, 1, 1, 2),(18, 110, 1, 1, 2),(18, 111, 1, 1, 2),(18, 112, 1, 1, 2),(18, 113, 1, 1, 2),(18, 114, 1, 1, 2),(18, 115, 1, 1, 2),(18, 116, 1, 1, 2),(18, 117, 1, 1, 2),(18, 118, 1, 1, 2),(18, 119, 1, 1, 2),(18, 120, 1, 1, 2),(18, 121, 1, 1, 2),(18, 122, 1, 1, 2),(18, 123, 1, 1, 2),(18, 124, 1, 1, 2),(18, 125, 1, 1, 2),(18, 126, 1, 1, 2),(18, 127, 1, 1, 2),(18, 128, 1, 1, 2),(18, 129, 1, 1, 1),(18, 130, 1, 1, 1),(18, 131, 1, 1, 1),(18, 132, 1, 1, 1),(18, 133, 1, 1, 1),(18, 134, 1, 1, 1),(18, 135, 1, 1, 1),(18, 136, 1, 1, 1),(18, 137, 1, 1, 1),(18, 138, 1, 1, 1),(18, 139, 1, 1, 1),(18, 140, 1, 1, 1),(18, 141, 1, 1, 1),(18, 142, 1, 1, 1),(18, 143, 1, 1, 1),(18, 144, 1, 1, 1),(18, 145, 1, 1, 1),(18, 146, 1, 1, 1),(18, 147, 1, 1, 1),(18, 148, 1, 1, 1),(18, 149, 1, 1, 1),(18, 150, 1, 1, 1),(18, 151, 1, 1, 1),(18, 152, 1, 1, 1),(18, 153, 1, 1, 1),(18, 154, 1, 1, 1),(18, 155, 1, 1, 1),(18, 156, 1, 1, 1),(18, 157, 1, 1, 1),(18, 158, 1, 1, 1),(18, 159, 1, 1, 1),(18, 160, 1, 1, 1),(18, 161, 1, 1, 2),(18, 162, 1, 1, 2),(18, 163, 1, 1, 2),(18, 164, 1, 1, 2),(18, 165, 1, 1, 2),(18, 166, 1, 1, 2),(18, 167, 1, 1, 2),(18, 168, 1, 1, 2),(18, 169, 1, 1, 2),(18, 170, 1, 1, 2),(18, 171, 1, 1, 2),(18, 172, 1, 1, 2),(18, 173, 1, 1, 2),(18, 174, 1, 1, 2),(18, 175, 1, 1, 2),(18, 176, 1, 1, 2),(18, 177, 1, 1, 2),(18, 178, 1, 1, 2),(18, 179, 1, 1, 2),(18, 180, 1, 1, 2),(18, 181, 1, 1, 2),(18, 182, 1, 1, 2),(18, 183, 1, 1, 2),(18, 184, 1, 1, 2),(18, 185, 1, 1, 2),(18, 186, 1, 1, 2),(18, 187, 1, 1, 2),(18, 188, 1, 1, 2),(18, 189, 1, 1, 2),(18, 190, 1, 1, 2),(18, 191, 1, 1, 2),(18, 192, 1, 1, 2),(18, 193, 1, 1, 1),(18, 194, 1, 1, 1),(18, 195, 1, 1, 1),(18, 196, 1, 1, 1),(18, 197, 1, 1, 1),(18, 198, 1, 1, 1),(18, 199, 1, 1, 1),(18, 200, 1, 1, 1),(18, 201, 1, 1, 1),(18, 202, 1, 1, 1),(18, 203, 1, 1, 1),(18, 204, 1, 1, 1),(18, 205, 1, 1, 1),(18, 206, 1, 1, 1),(18, 207, 1, 1, 1),(18, 208, 1, 1, 1),(18, 209, 1, 1, 1),(18, 210, 1, 1, 1),(18, 211, 1, 1, 1),(18, 212, 1, 1, 1),(18, 213, 1, 1, 1),(18, 214, 1, 1, 1),(18, 215, 1, 1, 1),(18, 216, 1, 1, 1),(18, 217, 1, 1, 1),(18, 218, 1, 1, 1),(18, 219, 1, 1, 1),(18, 220, 1, 1, 1),(18, 221, 1, 1, 1),(18, 222, 1, 1, 1),(18, 223, 1, 1, 1),(18, 224, 1, 1, 1),(18, 225, 1, 1, 2),(18, 226, 1, 1, 2),(18, 227, 1, 1, 2),(18, 228, 1, 1, 2),(18, 229, 1, 1, 2),(18, 230, 1, 1, 2),(18, 231, 1, 1, 2),(18, 232, 1, 1, 2),(18, 233, 1, 1, 2),(18, 234, 1, 1, 2),(18, 235, 1, 1, 2),(18, 236, 1, 1, 2),(18, 237, 1, 1, 2),(18, 238, 1, 1, 2),(18, 239, 1, 1, 2),(18, 240, 1, 1, 2),(18, 241, 1, 1, 2),(18, 242, 1, 1, 2),(18, 243, 1, 1, 2),(18, 244, 1, 1, 2),(18, 245, 1, 1, 2),(18, 246, 1, 1, 2),(18, 247, 1, 1, 2),(18, 248, 1, 1, 2),(18, 249, 1, 1, 2),(18, 250, 1, 1, 2),(18, 251, 1, 1, 2),(18, 252, 1, 1, 2),(18, 253, 1, 1, 2),(18, 254, 1, 1, 2),(18, 255, 1, 1, 2),(18, 256, 1, 1, 2),(18, 257, 1, 1, 1),(18, 258, 1, 1, 1),(18, 259, 1, 1, 1),(18, 260, 1, 1, 1),(18, 261, 1, 1, 1),(18, 262, 1, 1, 1),(18, 263, 1, 1, 1),(18, 264, 1, 1, 1),(18, 265, 1, 1, 1),(18, 266, 1, 1, 1),(18, 267, 1, 1, 1),(18, 268, 1, 1, 1),(18, 269, 1, 1, 1),(18, 270, 1, 1, 1),(18, 271, 1, 1, 1),(18, 272, 1, 1, 1),(18, 273, 1, 1, 1),(18, 274, 1, 1, 1),(18, 275, 1, 1, 1),(18, 276, 1, 1, 1),(18, 277, 1, 1, 1),(18, 278, 1, 1, 1),(18, 279, 1, 1, 1),(18, 280, 1, 1, 1),(18, 281, 1, 1, 1),(18, 282, 1, 1, 1),(18, 283, 1, 1, 1),(18, 284, 1, 1, 1),(18, 285, 1, 1, 1),(18, 286, 1, 1, 1),(18, 287, 1, 1, 1),(18, 288, 1, 1, 1),(18, 289, 1, 1, 2),(18, 290, 1, 1, 2),(18, 291, 1, 1, 2),(18, 292, 1, 1, 2),(18, 293, 1, 1, 2),(18, 294, 1, 1, 2),(18, 295, 1, 1, 2),(18, 296, 1, 1, 2),(18, 297, 1, 1, 2),(18, 298, 1, 1, 2),(18, 299, 1, 1, 2),(18, 300, 1, 1, 2),(18, 301, 1, 1, 2),(18, 302, 1, 1, 2),(18, 303, 1, 1, 2),(18, 304, 1, 1, 2),(18, 305, 1, 1, 2),(18, 306, 1, 1, 2),(18, 307, 1, 1, 2),(18, 308, 1, 1, 2),(18, 309, 1, 1, 2),(18, 310, 1, 1, 2),(18, 311, 1, 1, 2),(18, 312, 1, 1, 2),(18, 313, 1, 1, 2),(18, 314, 1, 1, 2),(18, 315, 1, 1, 2),(18, 316, 1, 1, 2),(18, 317, 1, 1, 2),(18, 318, 1, 1, 2),(18, 319, 1, 1, 2),(18, 320, 1, 1, 2),(18, 321, 1, 1, 1),(18, 322, 1, 1, 1),(18, 323, 1, 1, 1),(18, 324, 1, 1, 1),(18, 325, 1, 1, 1),(18, 326, 1, 1, 1),(18, 327, 1, 1, 1),(18, 328, 1, 1, 1),(18, 329, 1, 1, 1),(18, 330, 1, 1, 1),(18, 331, 1, 1, 1),(18, 332, 1, 1, 1),(18, 333, 1, 1, 1),(18, 334, 1, 1, 1),(18, 335, 1, 1, 1),(18, 336, 1, 1, 1),(18, 337, 1, 1, 1),(18, 338, 1, 1, 1),(18, 339, 1, 1, 1),(18, 340, 1, 1, 1),(18, 341, 1, 1, 1),(18, 342, 1, 1, 1),(18, 343, 1, 1, 1),(18, 344, 1, 1, 1),(18, 345, 1, 1, 1),(18, 346, 1, 1, 1),(18, 347, 1, 1, 1),(18, 348, 1, 1, 1),(18, 349, 1, 1, 1),(18, 350, 1, 1, 1),(18, 351, 1, 1, 1),(18, 352, 1, 1, 1),(18, 353, 1, 1, 2),(18, 354, 1, 1, 2),(18, 355, 1, 1, 2),(18, 356, 1, 1, 2),(18, 357, 1, 1, 2),(18, 358, 1, 1, 2),(18, 359, 1, 1, 2),(18, 360, 1, 1, 2),(18, 361, 1, 1, 2),(18, 362, 1, 1, 2),(18, 363, 1, 1, 2),(18, 364, 1, 1, 2),(18, 365, 1, 1, 2),(18, 366, 1, 1, 2),(18, 367, 1, 1, 2),(18, 368, 1, 1, 2),(18, 369, 1, 1, 2),(18, 370, 1, 1, 2),(18, 371, 1, 1, 2),(18, 372, 1, 1, 2),(18, 373, 1, 1, 2),(18, 374, 1, 1, 2),(18, 375, 1, 1, 2),(18, 376, 1, 1, 2),(18, 377, 1, 1, 2),(18, 378, 1, 1, 2),(18, 379, 1, 1, 2),(18, 380, 1, 1, 2),(18, 381, 1, 1, 2),(18, 382, 1, 1, 2),(18, 383, 1, 1, 2),(18, 384, 1, 1, 2),(18, 385, 1, 1, 1),(18, 386, 1, 1, 1),(18, 387, 1, 1, 1),(18, 388, 1, 1, 1),(18, 389, 1, 1, 1),(18, 390, 1, 1, 1),(18, 391, 1, 1, 1),(18, 392, 1, 1, 1),(18, 393, 1, 1, 1),(18, 394, 1, 1, 1),(18, 395, 1, 1, 1),(18, 396, 1, 1, 1),(18, 397, 1, 1, 1),(18, 398, 1, 1, 1),(18, 399, 1, 1, 1),(18, 400, 1, 1, 1),(18, 401, 1, 1, 1),(18, 402, 1, 1, 1),(18, 403, 1, 1, 1),(18, 404, 1, 1, 1),(18, 405, 1, 1, 1),(18, 406, 1, 1, 1),(18, 407, 1, 1, 1),(18, 408, 1, 1, 1),(18, 409, 1, 1, 1),(18, 410, 1, 1, 1),(18, 411, 1, 1, 1),(18, 412, 1, 1, 1),(18, 413, 1, 1, 1),(18, 414, 1, 1, 1),(18, 415, 1, 1, 1),(18, 416, 1, 1, 1),(18, 417, 1, 1, 2),(18, 418, 1, 1, 2),(18, 419, 1, 1, 2),(18, 420, 1, 1, 2),(18, 421, 1, 1, 2),(18, 422, 1, 1, 2),(18, 423, 1, 1, 2),(18, 424, 1, 1, 2),(18, 425, 1, 1, 2),(18, 426, 1, 1, 2),(18, 427, 1, 1, 2),(18, 428, 1, 1, 2),(18, 429, 1, 1, 2),(18, 430, 1, 1, 2),(18, 431, 1, 1, 2),(18, 432, 1, 1, 2),(18, 433, 1, 1, 2),(18, 434, 1, 1, 2),(18, 435, 1, 1, 2),(18, 436, 1, 1, 2),(18, 437, 1, 1, 2),(18, 438, 1, 1, 2),(18, 439, 1, 1, 2),(18, 440, 1, 1, 2),(18, 441, 1, 1, 2),(18, 442, 1, 1, 2),(18, 443, 1, 1, 2),(18, 444, 1, 1, 2),(18, 445, 1, 1, 2),(18, 446, 1, 1, 2),(18, 447, 1, 1, 2),(18, 448, 1, 1, 2),(18, 449, 1, 1, 1),(18, 450, 1, 1, 1),(18, 451, 1, 1, 1),(18, 452, 1, 1, 1),(18, 453, 1, 1, 1),(18, 454, 1, 1, 1),(18, 455, 1, 1, 1),(18, 456, 1, 1, 1),(18, 457, 1, 1, 1),(18, 458, 1, 1, 1),(18, 459, 1, 1, 1),(18, 460, 1, 1, 1),(18, 461, 1, 1, 1),(18, 462, 1, 1, 1),(18, 463, 1, 1, 1),(18, 464, 1, 1, 1),(18, 465, 1, 1, 1),(18, 466, 1, 1, 1),(18, 467, 1, 1, 1),(18, 468, 1, 1, 1),(18, 469, 1, 1, 1),(18, 470, 1, 1, 1),(18, 471, 1, 1, 1),(18, 472, 1, 1, 1),(18, 473, 1, 1, 1),(18, 474, 1, 1, 1),(18, 475, 1, 1, 1),(18, 476, 1, 1, 1),(18, 477, 1, 1, 1),(18, 478, 1, 1, 1),(18, 479, 1, 1, 1),(18, 480, 1, 1, 1),(18, 481, 1, 1, 2),(18, 482, 1, 1, 2),(18, 483, 1, 1, 2),(18, 484, 1, 1, 2),(18, 485, 1, 1, 2),(18, 486, 1, 1, 2),(18, 487, 1, 1, 2),(18, 488, 1, 1, 2),(18, 489, 1, 1, 2),(18, 490, 1, 1, 2),(18, 491, 1, 1, 2),(18, 492, 1, 1, 2),(18, 493, 1, 1, 2),(18, 494, 1, 1, 2),(18, 495, 1, 1, 2),(18, 496, 1, 1, 2),(18, 497, 1, 1, 2),(18, 498, 1, 1, 2),(18, 499, 1, 1, 2),(18, 500, 1, 1, 2),(18, 501, 1, 1, 2),(18, 502, 1, 1, 2),(18, 503, 1, 1, 2),(18, 504, 1, 1, 2),(18, 505, 1, 1, 2),(18, 506, 1, 1, 2),(18, 507, 1, 1, 2),(18, 508, 1, 1, 2),(18, 509, 1, 1, 2),(18, 510, 1, 1, 2),(18, 511, 1, 1, 2),(18, 512, 1, 1, 2),(18, 513, 1, 1, 1),(18, 514, 1, 1, 1),(18, 515, 1, 1, 1),(18, 516, 1, 1, 1),(18, 517, 1, 1, 1),(18, 518, 1, 1, 1),(18, 519, 1, 1, 1),(18, 520, 1, 1, 1),(18, 521, 1, 1, 1),(18, 522, 1, 1, 1),(18, 523, 1, 1, 1),(18, 524, 1, 1, 1),(18, 525, 1, 1, 1),(18, 526, 1, 1, 1),(18, 527, 1, 1, 1),(18, 528, 1, 1, 1),(18, 529, 1, 1, 1),(18, 530, 1, 1, 1),(18, 531, 1, 1, 1),(18, 532, 1, 1, 1),(18, 533, 1, 1, 1),(18, 534, 1, 1, 1),(18, 535, 1, 1, 1),(18, 536, 1, 1, 1),(18, 537, 1, 1, 1),(18, 538, 1, 1, 1),(18, 539, 1, 1, 1),(18, 540, 1, 1, 1),(18, 541, 1, 1, 1),(18, 542, 1, 1, 1),(18, 543, 1, 1, 1),(18, 544, 1, 1, 1),(18, 545, 1, 1, 2),(18, 546, 1, 1, 2),(18, 547, 1, 1, 2),(18, 548, 1, 1, 2),(18, 549, 1, 1, 2),(18, 550, 1, 1, 2),(18, 551, 1, 1, 2),(18, 552, 1, 1, 2),(18, 553, 1, 1, 2),(18, 554, 1, 1, 2),(18, 555, 1, 1, 2),(18, 556, 1, 1, 2),(18, 557, 1, 1, 2),(18, 558, 1, 1, 2),(18, 559, 1, 1, 2),(18, 560, 1, 1, 2),(18, 561, 1, 1, 2),(18, 562, 1, 1, 2),(18, 563, 1, 1, 2),(18, 564, 1, 1, 2),(18, 565, 1, 1, 2),(18, 566, 1, 1, 2),(18, 567, 1, 1, 2),(18, 568, 1, 1, 2),(18, 569, 1, 1, 2),(18, 570, 1, 1, 2),(18, 571, 1, 1, 2),(18, 572, 1, 1, 2),(18, 573, 1, 1, 2),(18, 574, 1, 1, 2),(18, 575, 1, 1, 2),(18, 576, 1, 1, 2),(18, 577, 1, 1, 1),(18, 578, 1, 1, 1),(18, 579, 1, 1, 1),(18, 580, 1, 1, 1),(18, 581, 1, 1, 1),(18, 582, 1, 1, 1),(18, 583, 1, 1, 1),(18, 584, 1, 1, 1),(18, 585, 1, 1, 1),(18, 586, 1, 1, 1),(18, 587, 1, 1, 1),(18, 588, 1, 1, 1),(18, 589, 1, 1, 1),(18, 590, 1, 1, 1),(18, 591, 1, 1, 1),(18, 592, 1, 1, 1),(18, 593, 1, 1, 1),(18, 594, 1, 1, 1),(18, 595, 1, 1, 1),(18, 596, 1, 1, 1),(18, 597, 1, 1, 1),(18, 598, 1, 1, 1),(18, 599, 1, 1, 1),(18, 600, 1, 1, 1),(18, 601, 1, 1, 1),(18, 602, 1, 1, 1),(18, 603, 1, 1, 1),(18, 604, 1, 1, 1),(18, 605, 1, 1, 1),(18, 606, 1, 1, 1),(18, 607, 1, 1, 1),(18, 608, 1, 1, 1),(18, 609, 1, 1, 2),(18, 610, 1, 1, 2),(18, 611, 1, 1, 2),(18, 612, 1, 1, 2),(18, 613, 1, 1, 2),(18, 614, 1, 1, 2),(18, 615, 1, 1, 2),(18, 616, 1, 1, 2),(18, 617, 1, 1, 2),(18, 618, 1, 1, 2),(18, 619, 1, 1, 2),(18, 620, 1, 1, 2),(18, 621, 1, 1, 2),(18, 622, 1, 1, 2),(18, 623, 1, 1, 2),(18, 624, 1, 1, 2),(18, 625, 1, 1, 2),(18, 626, 1, 1, 2),(18, 627, 1, 1, 2),(18, 628, 1, 1, 2),(18, 629, 1, 1, 2),(18, 630, 1, 1, 2),(18, 631, 1, 1, 2),(18, 632, 1, 1, 2),(18, 633, 1, 1, 2),(18, 634, 1, 1, 2),(18, 635, 1, 1, 2),(18, 636, 1, 1, 2),(18, 637, 1, 1, 2),(18, 638, 1, 1, 2),(18, 639, 1, 1, 2),(18, 640, 1, 1, 2),(18, 641, 1, 1, 1),(18, 642, 1, 1, 1),(18, 643, 1, 1, 1),(18, 644, 1, 1, 1),(18, 645, 1, 1, 1),(18, 646, 1, 1, 1),(18, 647, 1, 1, 1),(18, 648, 1, 1, 1),(18, 649, 1, 1, 1),(18, 650, 1, 1, 1),(18, 651, 1, 1, 1),(18, 652, 1, 1, 1),(18, 653, 1, 1, 1),(18, 654, 1, 1, 1),(18, 655, 1, 1, 1),(18, 656, 1, 1, 1),(18, 657, 1, 1, 1),(18, 658, 1, 1, 1),(18, 659, 1, 1, 1),(18, 660, 1, 1, 1),(18, 661, 1, 1, 1),(18, 662, 1, 1, 1),(18, 663, 1, 1, 1),(18, 664, 1, 1, 1),(18, 665, 1, 1, 1),(18, 666, 1, 1, 1),(18, 667, 1, 1, 1),(18, 668, 1, 1, 1),(18, 669, 1, 1, 1),(18, 670, 1, 1, 1),(18, 671, 1, 1, 1),(18, 672, 1, 1, 1),(18, 673, 1, 1, 2),(18, 674, 1, 1, 2),(18, 675, 1, 1, 2),(18, 676, 1, 1, 2),(18, 677, 1, 1, 2),(18, 678, 1, 1, 2),(18, 679, 1, 1, 2),(18, 680, 1, 1, 2),(18, 681, 1, 1, 2),(18, 682, 1, 1, 2),(18, 683, 1, 1, 2),(18, 684, 1, 1, 2),(18, 685, 1, 1, 2),(18, 686, 1, 1, 2),(18, 687, 1, 1, 2),(18, 688, 1, 1, 2),(18, 689, 1, 1, 2),(18, 690, 1, 1, 2),(18, 691, 1, 1, 2),(18, 692, 1, 1, 2),(18, 693, 1, 1, 2),(18, 694, 1, 1, 2),(18, 695, 1, 1, 2),(18, 696, 1, 1, 2),(18, 697, 1, 1, 2),(18, 698, 1, 1, 2),(18, 699, 1, 1, 2),(18, 700, 1, 1, 2),(18, 701, 1, 1, 2),(18, 702, 1, 1, 2),(18, 703, 1, 1, 2),(18, 704, 1, 1, 2),(18, 705, 1, 1, 1),(18, 706, 1, 1, 1),(18, 707, 1, 1, 1),(18, 708, 1, 1, 1),(18, 709, 1, 1, 1),(18, 710, 1, 1, 1),(18, 711, 1, 1, 1),(18, 712, 1, 1, 1),(18, 713, 1, 1, 1),(18, 714, 1, 1, 1),(18, 715, 1, 1, 1),(18, 716, 1, 1, 1),(18, 717, 1, 1, 1),(18, 718, 1, 1, 1),(18, 719, 1, 1, 1),(18, 720, 1, 1, 1),(18, 721, 1, 1, 1),(18, 722, 1, 1, 1),(18, 723, 1, 1, 1),(18, 724, 1, 1, 1),(18, 725, 1, 1, 1),(18, 726, 1, 1, 1),(18, 727, 1, 1, 1),(18, 728, 1, 1, 1),(18, 729, 1, 1, 1),(18, 730, 1, 1, 1),(18, 731, 1, 1, 1),(18, 732, 1, 1, 1),(18, 733, 1, 1, 1),(18, 734, 1, 1, 1),(18, 735, 1, 1, 1),(18, 736, 1, 1, 1),(18, 737, 1, 1, 2),(18, 738, 1, 1, 2),(18, 739, 1, 1, 2),(18, 740, 1, 1, 2),(18, 741, 1, 1, 2),(18, 742, 1, 1, 2),(18, 743, 1, 1, 2),(18, 744, 1, 1, 2),(18, 745, 1, 1, 2),(18, 746, 1, 1, 2),(18, 747, 1, 1, 2),(18, 748, 1, 1, 2),(18, 749, 1, 1, 2),(18, 750, 1, 1, 2),(18, 751, 1, 1, 2),(18, 752, 1, 1, 2),(18, 753, 1, 1, 2),(18, 754, 1, 1, 2),(18, 755, 1, 1, 2),(18, 756, 1, 1, 2),(18, 757, 1, 1, 2),(18, 758, 1, 1, 2),(18, 759, 1, 1, 2),(18, 760, 1, 1, 2),(18, 761, 1, 1, 2),(18, 762, 1, 1, 2),(18, 763, 1, 1, 2),(18, 764, 1, 1, 2),(18, 765, 1, 1, 2),(18, 766, 1, 1, 2),(18, 767, 1, 1, 2),(18, 768, 1, 1, 2),(18, 769, 1, 1, 1),(18, 770, 1, 1, 1),(18, 771, 1, 1, 1),(18, 772, 1, 1, 1),(18, 773, 1, 1, 1),(18, 774, 1, 1, 1),(18, 775, 1, 1, 1),(18, 776, 1, 1, 1),(18, 777, 1, 1, 1),(18, 778, 1, 1, 1),(18, 779, 1, 1, 1),(18, 780, 1, 1, 1),(18, 781, 1, 1, 1),(18, 782, 1, 1, 1),(18, 783, 1, 1, 1),(18, 784, 1, 1, 1),(18, 785, 1, 1, 1),(18, 786, 1, 1, 1),(18, 787, 1, 1, 1),(18, 788, 1, 1, 1),(18, 789, 1, 1, 1),(18, 790, 1, 1, 1),(18, 791, 1, 1, 1),(18, 792, 1, 1, 1),(18, 793, 1, 1, 1),(18, 794, 1, 1, 1),(18, 795, 1, 1, 1),(18, 796, 1, 1, 1),(18, 797, 1, 1, 1),(18, 798, 1, 1, 1),(18, 799, 1, 1, 1),(18, 800, 1, 1, 1),(18, 801, 1, 1, 2),(18, 802, 1, 1, 2),(18, 803, 1, 1, 2),(18, 804, 1, 1, 2),(18, 805, 1, 1, 2),(18, 806, 1, 1, 2),(18, 807, 1, 1, 2),(18, 808, 1, 1, 2),(18, 809, 1, 1, 2),(18, 810, 1, 1, 2),(18, 811, 1, 1, 2),(18, 812, 1, 1, 2),(18, 813, 1, 1, 2),(18, 814, 1, 1, 2),(18, 815, 1, 1, 2),(18, 816, 1, 1, 2),(18, 817, 1, 1, 2),(18, 818, 1, 1, 2),(18, 819, 1, 1, 2),(18, 820, 1, 1, 2),(18, 821, 1, 1, 2),(18, 822, 1, 1, 2),(18, 823, 1, 1, 2),(18, 824, 1, 1, 2),(18, 825, 1, 1, 2),(18, 826, 1, 1, 2),(18, 827, 1, 1, 2),(18, 828, 1, 1, 2),(18, 829, 1, 1, 2),(18, 830, 1, 1, 2),(18, 831, 1, 1, 2),(18, 832, 1, 1, 2),(18, 833, 1, 1, 1),(18, 834, 1, 1, 1),(18, 835, 1, 1, 1),(18, 836, 1, 1, 1),(18, 837, 1, 1, 1),(18, 838, 1, 1, 1),(18, 839, 1, 1, 1),(18, 840, 1, 1, 1),(18, 841, 1, 1, 1),(18, 842, 1, 1, 1),(18, 843, 1, 1, 1),(18, 844, 1, 1, 1),(18, 845, 1, 1, 1),(18, 846, 1, 1, 1),(18, 847, 1, 1, 1),(18, 848, 1, 1, 1),(18, 849, 1, 1, 1),(18, 850, 1, 1, 1),(18, 851, 1, 1, 1),(18, 852, 1, 1, 1),(18, 853, 1, 1, 1),(18, 854, 1, 1, 1),(18, 855, 1, 1, 1),(18, 856, 1, 1, 1),(18, 857, 1, 1, 1),(18, 858, 1, 1, 1),(18, 859, 1, 1, 1),(18, 860, 1, 1, 1),(18, 861, 1, 1, 1),(18, 862, 1, 1, 1),(18, 863, 1, 1, 1),(18, 864, 1, 1, 1),(18, 865, 1, 1, 2),(18, 866, 1, 1, 2),(18, 867, 1, 1, 2),(18, 868, 1, 1, 2),(18, 869, 1, 1, 2),(18, 870, 1, 1, 2),(18, 871, 1, 1, 2),(18, 872, 1, 1, 2),(18, 873, 1, 1, 2),(18, 874, 1, 1, 2),(18, 875, 1, 1, 2),(18, 876, 1, 1, 2),(18, 877, 1, 1, 2),(18, 878, 1, 1, 2),(18, 879, 1, 1, 2),(18, 880, 1, 1, 2),(18, 881, 1, 1, 2),(18, 882, 1, 1, 2),(18, 883, 1, 1, 2),(18, 884, 1, 1, 2),(18, 885, 1, 1, 2),(18, 886, 1, 1, 2),(18, 887, 1, 1, 2),(18, 888, 1, 1, 2),(18, 889, 1, 1, 2),(18, 890, 1, 1, 2),(18, 891, 1, 1, 2),(18, 892, 1, 1, 2),(18, 893, 1, 1, 2),(18, 894, 1, 1, 2),(18, 895, 1, 1, 2),(18, 896, 1, 1, 2),(18, 897, 1, 1, 1),(18, 898, 1, 1, 1),(18, 899, 1, 1, 1),(18, 900, 1, 1, 1),(18, 901, 1, 1, 1),(18, 902, 1, 1, 1),(18, 903, 1, 1, 1),(18, 904, 1, 1, 1),(18, 905, 1, 1, 1),(18, 906, 1, 1, 1),(18, 907, 1, 1, 1),(18, 908, 1, 1, 1),(18, 909, 1, 1, 1),(18, 910, 1, 1, 1),(18, 911, 1, 1, 1),(18, 912, 1, 1, 1),(18, 913, 1, 1, 1),(18, 914, 1, 1, 1),(18, 915, 1, 1, 1),(18, 916, 1, 1, 1),(18, 917, 1, 1, 1),(18, 918, 1, 1, 1),(18, 919, 1, 1, 1),(18, 920, 1, 1, 1),(18, 921, 1, 1, 1),(18, 922, 1, 1, 1),(18, 923, 1, 1, 1),(18, 924, 1, 1, 1),(18, 925, 1, 1, 1),(18, 926, 1, 1, 1),(18, 927, 1, 1, 1),(18, 928, 1, 1, 1),(18, 929, 1, 1, 2),(18, 930, 1, 1, 2),(18, 931, 1, 1, 2),(18, 932, 1, 1, 2),(18, 933, 1, 1, 2),(18, 934, 1, 1, 2),(18, 935, 1, 1, 2),(18, 936, 1, 1, 2),(18, 937, 1, 1, 2),(18, 938, 1, 1, 2),(18, 939, 1, 1, 2),(18, 940, 1, 1, 2),(18, 941, 1, 1, 2),(18, 942, 1, 1, 2),(18, 943, 1, 1, 2),(18, 944, 1, 1, 2),(18, 945, 1, 1, 2),(18, 946, 1, 1, 2),(18, 947, 1, 1, 2),(18, 948, 1, 1, 2),(18, 949, 1, 1, 2),(18, 950, 1, 1, 2),(18, 951, 1, 1, 2),(18, 952, 1, 1, 2),(18, 953, 1, 1, 2),(18, 954, 1, 1, 2),(18, 955, 1, 1, 2),(18, 956, 1, 1, 2),(18, 957, 1, 1, 2),(18, 958, 1, 1, 2),(18, 959, 1, 1, 2),(18, 960, 1, 1, 2),(18, 961, 1, 1, 1),(18, 962, 1, 1, 1),(18, 963, 1, 1, 1),(18, 964, 1, 1, 1),(18, 965, 1, 1, 1),(18, 966, 1, 1, 1),(18, 967, 1, 1, 1),(18, 968, 1, 1, 1),(18, 969, 1, 1, 1),(18, 970, 1, 1, 1),(18, 971, 1, 1, 1),(18, 972, 1, 1, 1),(18, 973, 1, 1, 1),(18, 974, 1, 1, 1),(18, 975, 1, 1, 1),(18, 976, 1, 1, 1),(18, 977, 1, 1, 1),(18, 978, 1, 1, 1),(18, 979, 1, 1, 1),(18, 980, 1, 1, 1),(18, 981, 1, 1, 1),(18, 982, 1, 1, 1),(18, 983, 1, 1, 1),(18, 984, 1, 1, 1),(18, 985, 1, 1, 1),(18, 986, 1, 1, 1),(18, 987, 1, 1, 1),(18, 988, 1, 1, 1),(18, 989, 1, 1, 1),(18, 990, 1, 1, 1),(18, 991, 1, 1, 1),(18, 992, 1, 1, 1),(18, 993, 1, 1, 2),(18, 994, 1, 1, 2),(18, 995, 1, 1, 2),(18, 996, 1, 1, 2),(18, 997, 1, 1, 2),(18, 998, 1, 1, 2),(18, 999, 1, 1, 2),(18, 1000, 1, 1, 2),(18, 1001, 1, 1, 2),(18, 1002, 1, 1, 2),(18, 1003, 1, 1, 2),(18, 1004, 1, 1, 2),(18, 1005, 1, 1, 2),(18, 1006, 1, 1, 2),(18, 1007, 1, 1, 2),(18, 1008, 1, 1, 2),(18, 1009, 1, 1, 2),(18, 1010, 1, 1, 2),(18, 1011, 1, 1, 2),(18, 1012, 1, 1, 2),(18, 1013, 1, 1, 2),(18, 1014, 1, 1, 2),(18, 1015, 1, 1, 2),(18, 1016, 1, 1, 2),(18, 1017, 1, 1, 2),(18, 1018, 1, 1, 2),(18, 1019, 1, 1, 2),(18, 1020, 1, 1, 2),(18, 1021, 1, 1, 2),(18, 1022, 1, 1, 2),(18, 1023, 1, 1, 2),(18, 1024, 1, 1, 2),(18, 1025, 1, 1, 1),(18, 1026, 1, 1, 1),(18, 1027, 1, 1, 1),(18, 1028, 1, 1, 1),(18, 1029, 1, 1, 1),(18, 1030, 1, 1, 1),(18, 1031, 1, 1, 1),(18, 1032, 1, 1, 1),(18, 1033, 1, 1, 1),(18, 1034, 1, 1, 1),(18, 1035, 1, 1, 1),(18, 1036, 1, 1, 1),(18, 1037, 1, 1, 1),(18, 1038, 1, 1, 1),(18, 1039, 1, 1, 1),(18, 1040, 1, 1, 1),(18, 1041, 1, 1, 1),(18, 1042, 1, 1, 1),(18, 1043, 1, 1, 1),(18, 1044, 1, 1, 1),(18, 1045, 1, 1, 1),(18, 1046, 1, 1, 1),(18, 1047, 1, 1, 1),(18, 1048, 1, 1, 1),(18, 1049, 1, 1, 1),(18, 1050, 1, 1, 1),(18, 1051, 1, 1, 1),(18, 1052, 1, 1, 1),(18, 1053, 1, 1, 1),(18, 1054, 1, 1, 1),(18, 1055, 1, 1, 1),(18, 1056, 1, 1, 1),(18, 1057, 1, 1, 2),(18, 1058, 1, 1, 2),(18, 1059, 1, 1, 2),(18, 1060, 1, 1, 2),(18, 1061, 1, 1, 2),(18, 1062, 1, 1, 2),(18, 1063, 1, 1, 2),(18, 1064, 1, 1, 2),(18, 1065, 1, 1, 2),(18, 1066, 1, 1, 2),(18, 1067, 1, 1, 2),(18, 1068, 1, 1, 2),(18, 1069, 1, 1, 2),(18, 1070, 1, 1, 2),(18, 1071, 1, 1, 2),(18, 1072, 1, 1, 2),(18, 1073, 1, 1, 2),(18, 1074, 1, 1, 2),(18, 1075, 1, 1, 2),(18, 1076, 1, 1, 2),(18, 1077, 1, 1, 2),(18, 1078, 1, 1, 2),(18, 1079, 1, 1, 2),(18, 1080, 1, 1, 2),(18, 1081, 1, 1, 2),(18, 1082, 1, 1, 2),(18, 1083, 1, 1, 2),(18, 1084, 1, 1, 2),(18, 1085, 1, 1, 2),(18, 1086, 1, 1, 2),(18, 1087, 1, 1, 2),(18, 1088, 1, 1, 2),(18, 1089, 1, 1, 1),(18, 1090, 1, 1, 1),(18, 1091, 1, 1, 1),(18, 1092, 1, 1, 1),(18, 1093, 1, 1, 1),(18, 1094, 1, 1, 1),(18, 1095, 1, 1, 1),(18, 1096, 1, 1, 1),(18, 1097, 1, 1, 1),(18, 1098, 1, 1, 1),(18, 1099, 1, 1, 1),(18, 1100, 1, 1, 1),(18, 1101, 1, 1, 1),(18, 1102, 1, 1, 1),(18, 1103, 1, 1, 1),(18, 1104, 1, 1, 1),(18, 1105, 1, 1, 1),(18, 1106, 1, 1, 1),(18, 1107, 1, 1, 1),(18, 1108, 1, 1, 1),(18, 1109, 1, 1, 1),(18, 1110, 1, 1, 1),(18, 1111, 1, 1, 1),(18, 1112, 1, 1, 1),(18, 1113, 1, 1, 1),(18, 1114, 1, 1, 1),(18, 1115, 1, 1, 1),(18, 1116, 1, 1, 1),(18, 1117, 1, 1, 1),(18, 1118, 1, 1, 1),(18, 1119, 1, 1, 1),(18, 1120, 1, 1, 1),(18, 1121, 1, 1, 2),(18, 1122, 1, 1, 2),(18, 1123, 1, 1, 2),(18, 1124, 1, 1, 2),(18, 1125, 1, 1, 2),(18, 1126, 1, 1, 2),(18, 1127, 1, 1, 2),(18, 1128, 1, 1, 2),(18, 1129, 1, 1, 2),(18, 1130, 1, 1, 2),(18, 1131, 1, 1, 2),(18, 1132, 1, 1, 2),(18, 1133, 1, 1, 2),(18, 1134, 1, 1, 2),(18, 1135, 1, 1, 2),(18, 1136, 1, 1, 2),(18, 1137, 1, 1, 2),(18, 1138, 1, 1, 2),(18, 1139, 1, 1, 2),(18, 1140, 1, 1, 2),(18, 1141, 1, 1, 2),(18, 1142, 1, 1, 2),(18, 1143, 1, 1, 2),(18, 1144, 1, 1, 2),(18, 1145, 1, 1, 2),(18, 1146, 1, 1, 2),(18, 1147, 1, 1, 2),(18, 1148, 1, 1, 2),(18, 1149, 1, 1, 2),(18, 1150, 1, 1, 2),(18, 1151, 1, 1, 2),(18, 1152, 1, 1, 2),(18, 1153, 1, 1, 1),(18, 1154, 1, 1, 1),(18, 1155, 1, 1, 1),(18, 1156, 1, 1, 1),(18, 1157, 1, 1, 1),(18, 1158, 1, 1, 1),(18, 1159, 1, 1, 1),(18, 1160, 1, 1, 1),(18, 1161, 1, 1, 1),(18, 1162, 1, 1, 1),(18, 1163, 1, 1, 1),(18, 1164, 1, 1, 1),(18, 1165, 1, 1, 1),(18, 1166, 1, 1, 1),(18, 1167, 1, 1, 1),(18, 1168, 1, 1, 1),(18, 1169, 1, 1, 1),(18, 1170, 1, 1, 1),(18, 1171, 1, 1, 1),(18, 1172, 1, 1, 1),(18, 1173, 1, 1, 1),(18, 1174, 1, 1, 1),(18, 1175, 1, 1, 1),(18, 1176, 1, 1, 1),(18, 1177, 1, 1, 1),(18, 1178, 1, 1, 1),(18, 1179, 1, 1, 1),(18, 1180, 1, 1, 1),(18, 1181, 1, 1, 1),(18, 1182, 1, 1, 1),(18, 1183, 1, 1, 1),(18, 1184, 1, 1, 1),(18, 1185, 1, 1, 2),(18, 1186, 1, 1, 2),(18, 1187, 1, 1, 2),(18, 1188, 1, 1, 2),(18, 1189, 1, 1, 2),(18, 1190, 1, 1, 2),(18, 1191, 1, 1, 2),(18, 1192, 1, 1, 2),(18, 1193, 1, 1, 2),(18, 1194, 1, 1, 2),(18, 1195, 1, 1, 2),(18, 1196, 1, 1, 2),(18, 1197, 1, 1, 2),(18, 1198, 1, 1, 2),(18, 1199, 1, 1, 2),(18, 1200, 1, 1, 2),(18, 1201, 1, 1, 2),(18, 1202, 1, 1, 2),(18, 1203, 1, 1, 2),(18, 1204, 1, 1, 2),(18, 1205, 1, 1, 2),(18, 1206, 1, 1, 2),(18, 1207, 1, 1, 2),(18, 1208, 1, 1, 2),(18, 1209, 1, 1, 2),(18, 1210, 1, 1, 2),(18, 1211, 1, 1, 2),(18, 1212, 1, 1, 2),(18, 1213, 1, 1, 2),(18, 1214, 1, 1, 2),(18, 1215, 1, 1, 2),(18, 1216, 1, 1, 2),(18, 1217, 1, 1, 1),(18, 1218, 1, 1, 1),(18, 1219, 1, 1, 1),(18, 1220, 1, 1, 1),(18, 1221, 1, 1, 1),(18, 1222, 1, 1, 1),(18, 1223, 1, 1, 1),(18, 1224, 1, 1, 1),(18, 1225, 1, 1, 1),(18, 1226, 1, 1, 1),(18, 1227, 1, 1, 1),(18, 1228, 1, 1, 1),(18, 1229, 1, 1, 1),(18, 1230, 1, 1, 1),(18, 1231, 1, 1, 1),(18, 1232, 1, 1, 1),(18, 1233, 1, 1, 1),(18, 1234, 1, 1, 1),(18, 1235, 1, 1, 1),(18, 1236, 1, 1, 1),(18, 1237, 1, 1, 1),(18, 1238, 1, 1, 1),(18, 1239, 1, 1, 1),(18, 1240, 1, 1, 1),(18, 1241, 1, 1, 1),(18, 1242, 1, 1, 1),(18, 1243, 1, 1, 1),(18, 1244, 1, 1, 1),(18, 1245, 1, 1, 1),(18, 1246, 1, 1, 1),(18, 1247, 1, 1, 1),(18, 1248, 1, 1, 1),(18, 1249, 1, 1, 2),(18, 1250, 1, 1, 2),(18, 1251, 1, 1, 2),(18, 1252, 1, 1, 2),(18, 1253, 1, 1, 2),(18, 1254, 1, 1, 2),(18, 1255, 1, 1, 2),(18, 1256, 1, 1, 2),(18, 1257, 1, 1, 2),(18, 1258, 1, 1, 2),(18, 1259, 1, 1, 2),(18, 1260, 1, 1, 2),(18, 1261, 1, 1, 2),(18, 1262, 1, 1, 2),(18, 1263, 1, 1, 2),(18, 1264, 1, 1, 2),(18, 1265, 1, 1, 2),(18, 1266, 1, 1, 2),(18, 1267, 1, 1, 2),(18, 1268, 1, 1, 2),(18, 1269, 1, 1, 2),(18, 1270, 1, 1, 2),(18, 1271, 1, 1, 2),(18, 1272, 1, 1, 2),(18, 1273, 1, 1, 2),(18, 1274, 1, 1, 2),(18, 1275, 1, 1, 2),(18, 1276, 1, 1, 2),(18, 1277, 1, 1, 2),(18, 1278, 1, 1, 2),(18, 1279, 1, 1, 2),(18, 1280, 1, 1, 2),(18, 1281, 1, 1, 1),(18, 1282, 1, 1, 1),(18, 1283, 1, 1, 1),(18, 1284, 1, 1, 1),(18, 1285, 1, 1, 1),(18, 1286, 1, 1, 1),(18, 1287, 1, 1, 1),(18, 1288, 1, 1, 1),(18, 1289, 1, 1, 1),(18, 1290, 1, 1, 1),(18, 1291, 1, 1, 1),(18, 1292, 1, 1, 1),(18, 1293, 1, 1, 1),(18, 1294, 1, 1, 1),(18, 1295, 1, 1, 1),(18, 1296, 1, 1, 1),(18, 1297, 1, 1, 1),(18, 1298, 1, 1, 1),(18, 1299, 1, 1, 1),(18, 1300, 1, 1, 1),(18, 1301, 1, 1, 1),(18, 1302, 1, 1, 1),(18, 1303, 1, 1, 1),(18, 1304, 1, 1, 1),(18, 1305, 1, 1, 1),(18, 1306, 1, 1, 1),(18, 1307, 1, 1, 1),(18, 1308, 1, 1, 1),(18, 1309, 1, 1, 1),(18, 1310, 1, 1, 1),(18, 1311, 1, 1, 1),(18, 1312, 1, 1, 1),(18, 1313, 1, 1, 2),(18, 1314, 1, 1, 2),(18, 1315, 1, 1, 2),(18, 1316, 1, 1, 2),(18, 1317, 1, 1, 2),(18, 1318, 1, 1, 2),(18, 1319, 1, 1, 2),(18, 1320, 1, 1, 2),(18, 1321, 1, 1, 2),(18, 1322, 1, 1, 2),(18, 1323, 1, 1, 2),(18, 1324, 1, 1, 2),(18, 1325, 1, 1, 2),(18, 1326, 1, 1, 2),(18, 1327, 1, 1, 2),(18, 1328, 1, 1, 2),(18, 1329, 1, 1, 2),(18, 1330, 1, 1, 2),(18, 1331, 1, 1, 2),(18, 1332, 1, 1, 2),(18, 1333, 1, 1, 2),(18, 1334, 1, 1, 2),(18, 1335, 1, 1, 2),(18, 1336, 1, 1, 2),(18, 1337, 1, 1, 2),(18, 1338, 1, 1, 2),(18, 1339, 1, 1, 2),(18, 1340, 1, 1, 2),(18, 1341, 1, 1, 2),(18, 1342, 1, 1, 2),(18, 1343, 1, 1, 2),(18, 1344, 1, 1, 2),(18, 1345, 1, 1, 1),(18, 1346, 1, 1, 1),(18, 1347, 1, 1, 1),(18, 1348, 1, 1, 1),(18, 1349, 1, 1, 1),(18, 1350, 1, 1, 1),(18, 1351, 1, 1, 1),(18, 1352, 1, 1, 1),(18, 1353, 1, 1, 1),(18, 1354, 1, 1, 1),(18, 1355, 1, 1, 1),(18, 1356, 1, 1, 1),(18, 1357, 1, 1, 1),(18, 1358, 1, 1, 1),(18, 1359, 1, 1, 1),(18, 1360, 1, 1, 1),(18, 1361, 1, 1, 1),(18, 1362, 1, 1, 1),(18, 1363, 1, 1, 1),(18, 1364, 1, 1, 1),(18, 1365, 1, 1, 1),(18, 1366, 1, 1, 1),(18, 1367, 1, 1, 1),(18, 1368, 1, 1, 1),(18, 1369, 1, 1, 1),(18, 1370, 1, 1, 1),(18, 1371, 1, 1, 1),(18, 1372, 1, 1, 1),(18, 1373, 1, 1, 1),(18, 1374, 1, 1, 1),(18, 1375, 1, 1, 1),(18, 1376, 1, 1, 1),(18, 1377, 1, 1, 2),(18, 1378, 1, 1, 2),(18, 1379, 1, 1, 2),(18, 1380, 1, 1, 2),(18, 1381, 1, 1, 2),(18, 1382, 1, 1, 2),(18, 1383, 1, 1, 2),(18, 1384, 1, 1, 2),(18, 1385, 1, 1, 2),(18, 1386, 1, 1, 2),(18, 1387, 1, 1, 2),(18, 1388, 1, 1, 2),(18, 1389, 1, 1, 2),(18, 1390, 1, 1, 2),(18, 1391, 1, 1, 2),(18, 1392, 1, 1, 2),(18, 1393, 1, 1, 2),(18, 1394, 1, 1, 2),(18, 1395, 1, 1, 2),(18, 1396, 1, 1, 2),(18, 1397, 1, 1, 2),(18, 1398, 1, 1, 2),(18, 1399, 1, 1, 2),(18, 1400, 1, 1, 2),(18, 1401, 1, 1, 2),(18, 1402, 1, 1, 2),(18, 1403, 1, 1, 2),(18, 1404, 1, 1, 2),(18, 1405, 1, 1, 2),(18, 1406, 1, 1, 2),(18, 1407, 1, 1, 2),(18, 1408, 1, 1, 2),(18, 1409, 1, 1, 1),(18, 1410, 1, 1, 1),(18, 1411, 1, 1, 1),(18, 1412, 1, 1, 1),(18, 1413, 1, 1, 1),(18, 1414, 1, 1, 1),(18, 1415, 1, 1, 1),(18, 1416, 1, 1, 1),(18, 1417, 1, 1, 1),(18, 1418, 1, 1, 1),(18, 1419, 1, 1, 1),(18, 1420, 1, 1, 1),(18, 1421, 1, 1, 1),(18, 1422, 1, 1, 1),(18, 1423, 1, 1, 1),(18, 1424, 1, 1, 1),(18, 1425, 1, 1, 1),(18, 1426, 1, 1, 1),(18, 1427, 1, 1, 1),(18, 1428, 1, 1, 1),(18, 1429, 1, 1, 1),(18, 1430, 1, 1, 1),(18, 1431, 1, 1, 1),(18, 1432, 1, 1, 1),(18, 1433, 1, 1, 1),(18, 1434, 1, 1, 1),(18, 1435, 1, 1, 1),(18, 1436, 1, 1, 1),(18, 1437, 1, 1, 1),(18, 1438, 1, 1, 1),(18, 1439, 1, 1, 1),(18, 1440, 1, 1, 1),(18, 1441, 1, 1, 2),(18, 1442, 1, 1, 2),(18, 1443, 1, 1, 2),(18, 1444, 1, 1, 2),(18, 1445, 1, 1, 2),(18, 1446, 1, 1, 2),(18, 1447, 1, 1, 2),(18, 1448, 1, 1, 2),(18, 1449, 1, 1, 2),(18, 1450, 1, 1, 2),(18, 1451, 1, 1, 2),(18, 1452, 1, 1, 2),(18, 1453, 1, 1, 2),(18, 1454, 1, 1, 2),(18, 1455, 1, 1, 2),(18, 1456, 1, 1, 2),(18, 1457, 1, 1, 2),(18, 1458, 1, 1, 2),(18, 1459, 1, 1, 2),(18, 1460, 1, 1, 2),(18, 1461, 1, 1, 2),(18, 1462, 1, 1, 2),(18, 1463, 1, 1, 2),(18, 1464, 1, 1, 2),(18, 1465, 1, 1, 2),(18, 1466, 1, 1, 2),(18, 1467, 1, 1, 2),(18, 1468, 1, 1, 2),(18, 1469, 1, 1, 2),(18, 1470, 1, 1, 2),(18, 1471, 1, 1, 2),(18, 1472, 1, 1, 2),(18, 1473, 1, 1, 1),(18, 1474, 1, 1, 1),(18, 1475, 1, 1, 1),(18, 1476, 1, 1, 1),(18, 1477, 1, 1, 1),(18, 1478, 1, 1, 1),(18, 1479, 1, 1, 1),(18, 1480, 1, 1, 1),(18, 1481, 1, 1, 1),(18, 1482, 1, 1, 1),(18, 1483, 1, 1, 1),(18, 1484, 1, 1, 1),(18, 1485, 1, 1, 1),(18, 1486, 1, 1, 1),(18, 1487, 1, 1, 1),(18, 1488, 1, 1, 1),(18, 1489, 2, 1, 1),(18, 1490, 2, 1, 1),(18, 1491, 2, 1, 1),(18, 1492, 2, 1, 1),(18, 1493, 2, 1, 1),(18, 1494, 2, 1, 1),(18, 1495, 2, 1, 1),(18, 1496, 2, 1, 1),(18, 1497, 3, 1, 1),(18, 1498, 3, 1, 1),(18, 1499, 3, 1, 1),(18, 1500, 3, 1, 1),(18, 1501, 4, 1, 1),(18, 1502, 4, 1, 1),(18, 1503, 4, 1, 1),(18, 1504, 4, 1, 1),(18, 1505, 1, 1, 2),(18, 1506, 1, 1, 2),(18, 1507, 1, 1, 2),(18, 1508, 1, 1, 2),(18, 1509, 1, 1, 2),(18, 1510, 1, 1, 2),(18, 1511, 1, 1, 2),(18, 1512, 1, 1, 2),(18, 1513, 1, 1, 2),(18, 1514, 1, 1, 2),(18, 1515, 1, 1, 2),(18, 1516, 1, 1, 2),(18, 1517, 1, 1, 2),(18, 1518, 1, 1, 2),(18, 1519, 1, 1, 2),(18, 1520, 1, 1, 2),(18, 1521, 2, 1, 2),(18, 1522, 2, 1, 2),(18, 1523, 2, 1, 2),(18, 1524, 2, 1, 2),(18, 1525, 2, 1, 2),(18, 1526, 2, 1, 2),(18, 1527, 2, 1, 2),(18, 1528, 2, 1, 2),(18, 1529, 3, 1, 2),(18, 1530, 3, 1, 2),(18, 1531, 3, 1, 2),(18, 1532, 3, 1, 2),(18, 1533, 4, 1, 2),(18, 1534, 4, 1, 2),(18, 1535, 4, 1, 2),(18, 1536, 4, 1, 2),(19, 1, 1, 1, 1),(19, 2, 1, 1, 1),(19, 3, 1, 1, 1),(19, 4, 1, 1, 1),(19, 5, 1, 1, 1),(19, 6, 1, 1, 1),(19, 7, 1, 1, 1),(19, 8, 1, 1, 1),(19, 9, 1, 1, 1),(19, 10, 1, 1, 1),(19, 11, 1, 1, 1),(19, 12, 1, 1, 1),(19, 13, 1, 1, 1),(19, 14, 1, 1, 1),(19, 15, 1, 1, 1),(19, 16, 1, 1, 1),(19, 17, 1, 1, 1),(19, 18, 1, 1, 1),(19, 19, 1, 1, 1),(19, 20, 1, 1, 1),(19, 21, 1, 1, 1),(19, 22, 1, 1, 1),(19, 23, 1, 1, 1),(19, 24, 1, 1, 1),(19, 25, 1, 1, 1),(19, 26, 1, 1, 1),(19, 27, 1, 1, 1),(19, 28, 1, 1, 1),(19, 29, 1, 1, 1),(19, 30, 1, 1, 1),(19, 31, 1, 1, 1),(19, 32, 1, 1, 1),(19, 33, 1, 1, 1),(19, 34, 1, 1, 1),(19, 35, 1, 1, 1),(19, 36, 1, 1, 1),(19, 37, 1, 1, 1),(19, 38, 1, 1, 1),(19, 39, 1, 1, 1),(19, 40, 1, 1, 1),(19, 41, 1, 1, 1),(19, 42, 1, 1, 1),(19, 43, 1, 1, 1),(19, 44, 1, 1, 1),(19, 45, 1, 1, 1),(19, 46, 1, 1, 1),(19, 47, 1, 1, 1),(19, 48, 1, 1, 1),(19, 49, 1, 1, 1),(19, 50, 1, 1, 1),(19, 51, 1, 1, 1),(19, 52, 1, 1, 1),(19, 53, 1, 1, 1),(19, 54, 1, 1, 1),(19, 55, 1, 1, 1),(19, 56, 1, 1, 1),(19, 57, 1, 1, 1),(19, 58, 1, 1, 1),(19, 59, 1, 1, 1),(19, 60, 1, 1, 1),(19, 61, 1, 1, 1),(19, 62, 1, 1, 1),(19, 63, 1, 1, 1),(19, 64, 1, 1, 1),(19, 65, 1, 1, 1),(19, 66, 1, 1, 1),(19, 67, 1, 1, 1),(19, 68, 1, 1, 1),(19, 69, 1, 1, 1),(19, 70, 1, 1, 1),(19, 71, 1, 1, 1),(19, 72, 1, 1, 1),(19, 73, 1, 1, 1),(19, 74, 1, 1, 1),(19, 75, 1, 1, 1),(19, 76, 1, 1, 1),(19, 77, 1, 1, 1),(19, 78, 1, 1, 1),(19, 79, 1, 1, 1),(19, 80, 1, 1, 1),(19, 81, 1, 1, 1),(19, 82, 1, 1, 1),(19, 83, 1, 1, 1),(19, 84, 1, 1, 1),(19, 85, 1, 1, 1),(19, 86, 1, 1, 1),(19, 87, 1, 1, 1),(19, 88, 1, 1, 1),(19, 89, 1, 1, 1),(19, 90, 1, 1, 1),(19, 91, 1, 1, 1),(19, 92, 1, 1, 1),(19, 93, 1, 1, 1),(19, 94, 1, 1, 1),(19, 95, 1, 1, 1),(19, 96, 1, 1, 1),(19, 97, 1, 1, 1),(19, 98, 1, 1, 1),(19, 99, 1, 1, 1),(19, 100, 1, 1, 1),(19, 101, 1, 1, 1),(19, 102, 1, 1, 1),(19, 103, 1, 1, 1),(19, 104, 1, 1, 1),(19, 105, 1, 1, 1),(19, 106, 1, 1, 1),(19, 107, 1, 1, 1),(19, 108, 1, 1, 1),(19, 109, 1, 1, 1),(19, 110, 1, 1, 1),(19, 111, 1, 1, 1),(19, 112, 1, 1, 1),(19, 113, 1, 1, 1),(19, 114, 1, 1, 1),(19, 115, 1, 1, 1),(19, 116, 1, 1, 1),(19, 117, 1, 1, 1),(19, 118, 1, 1, 1),(19, 119, 1, 1, 1),(19, 120, 1, 1, 1),(19, 121, 1, 1, 1),(19, 122, 1, 1, 1),(19, 123, 1, 1, 1),(19, 124, 1, 1, 1),(19, 125, 1, 1, 1),(19, 126, 1, 1, 1),(19, 127, 1, 1, 1),(19, 128, 1, 1, 1),(19, 129, 1, 1, 1),(19, 130, 1, 1, 1),(19, 131, 1, 1, 1),(19, 132, 1, 1, 1),(19, 133, 1, 1, 1),(19, 134, 1, 1, 1),(19, 135, 1, 1, 1),(19, 136, 1, 1, 1),(19, 137, 1, 1, 1),(19, 138, 1, 1, 1),(19, 139, 1, 1, 1),(19, 140, 1, 1, 1),(19, 141, 1, 1, 1),(19, 142, 1, 1, 1),(19, 143, 1, 1, 1),(19, 144, 1, 1, 1),(19, 145, 1, 1, 1),(19, 146, 1, 1, 1),(19, 147, 1, 1, 1),(19, 148, 1, 1, 1),(19, 149, 1, 1, 1),(19, 150, 1, 1, 1),(19, 151, 1, 1, 1),(19, 152, 1, 1, 1),(19, 153, 1, 1, 1),(19, 154, 1, 1, 1),(19, 155, 1, 1, 1),(19, 156, 1, 1, 1),(19, 157, 1, 1, 1),(19, 158, 1, 1, 1),(19, 159, 1, 1, 1),(19, 160, 1, 1, 1),(19, 161, 1, 1, 1),(19, 162, 1, 1, 1),(19, 163, 1, 1, 1),(19, 164, 1, 1, 1),(19, 165, 1, 1, 1),(19, 166, 1, 1, 1),(19, 167, 1, 1, 1),(19, 168, 1, 1, 1),(19, 169, 1, 1, 1),(19, 170, 1, 1, 1),(19, 171, 1, 1, 1),(19, 172, 1, 1, 1),(19, 173, 1, 1, 1),(19, 174, 1, 1, 1),(19, 175, 1, 1, 1),(19, 176, 1, 1, 1),(19, 177, 1, 1, 1),(19, 178, 1, 1, 1),(19, 179, 1, 1, 1),(19, 180, 1, 1, 1),(19, 181, 1, 1, 1),(19, 182, 1, 1, 1),(19, 183, 1, 1, 1),(19, 184, 1, 1, 1),(19, 185, 1, 1, 1),(19, 186, 1, 1, 1),(19, 187, 1, 1, 1),(19, 188, 1, 1, 1),(19, 189, 1, 1, 1),(19, 190, 1, 1, 1),(19, 191, 1, 1, 1),(19, 192, 1, 1, 1),(19, 193, 1, 1, 1),(19, 194, 1, 1, 1),(19, 195, 1, 1, 1),(19, 196, 1, 1, 1),(19, 197, 1, 1, 1),(19, 198, 1, 1, 1),(19, 199, 1, 1, 1),(19, 200, 1, 1, 1),(19, 201, 1, 1, 1),(19, 202, 1, 1, 1),(19, 203, 1, 1, 1),(19, 204, 1, 1, 1),(19, 205, 1, 1, 1),(19, 206, 1, 1, 1),(19, 207, 1, 1, 1),(19, 208, 1, 1, 1),(19, 209, 1, 1, 1),(19, 210, 1, 1, 1),(19, 211, 1, 1, 1),(19, 212, 1, 1, 1),(19, 213, 1, 1, 1),(19, 214, 1, 1, 1),(19, 215, 1, 1, 1),(19, 216, 1, 1, 1),(19, 217, 1, 1, 1),(19, 218, 1, 1, 1),(19, 219, 1, 1, 1),(19, 220, 1, 1, 1),(19, 221, 1, 1, 1),(19, 222, 1, 1, 1),(19, 223, 1, 1, 1),(19, 224, 1, 1, 1),(19, 225, 1, 1, 1),(19, 226, 1, 1, 1),(19, 227, 1, 1, 1),(19, 228, 1, 1, 1),(19, 229, 1, 1, 1),(19, 230, 1, 1, 1),(19, 231, 1, 1, 1),(19, 232, 1, 1, 1),(19, 233, 1, 1, 1),(19, 234, 1, 1, 1),(19, 235, 1, 1, 1),(19, 236, 1, 1, 1),(19, 237, 1, 1, 1),(19, 238, 1, 1, 1),(19, 239, 1, 1, 1),(19, 240, 1, 1, 1),(19, 241, 1, 1, 1),(19, 242, 1, 1, 1),(19, 243, 1, 1, 1),(19, 244, 1, 1, 1),(19, 245, 1, 1, 1),(19, 246, 1, 1, 1),(19, 247, 1, 1, 1),(19, 248, 1, 1, 1),(19, 249, 1, 1, 1),(19, 250, 1, 1, 1),(19, 251, 1, 1, 1),(19, 252, 1, 1, 1),(19, 253, 1, 1, 1),(19, 254, 1, 1, 1),(19, 255, 1, 1, 1),(19, 256, 1, 1, 1),(19, 257, 1, 1, 1),(19, 258, 1, 1, 1),(19, 259, 1, 1, 1),(19, 260, 1, 1, 1),(19, 261, 1, 1, 1),(19, 262, 1, 1, 1),(19, 263, 1, 1, 1),(19, 264, 1, 1, 1),(19, 265, 1, 1, 1),(19, 266, 1, 1, 1),(19, 267, 1, 1, 1),(19, 268, 1, 1, 1),(19, 269, 1, 1, 1),(19, 270, 1, 1, 1),(19, 271, 1, 1, 1),(19, 272, 1, 1, 1),(19, 273, 1, 1, 1),(19, 274, 1, 1, 1),(19, 275, 1, 1, 1),(19, 276, 1, 1, 1),(19, 277, 1, 1, 1),(19, 278, 1, 1, 1),(19, 279, 1, 1, 1),(19, 280, 1, 1, 1),(19, 281, 1, 1, 1),(19, 282, 1, 1, 1),(19, 283, 1, 1, 1),(19, 284, 1, 1, 1),(19, 285, 1, 1, 1),(19, 286, 1, 1, 1),(19, 287, 1, 1, 1),(19, 288, 1, 1, 1),(19, 289, 1, 1, 1),(19, 290, 1, 1, 1),(19, 291, 1, 1, 1),(19, 292, 1, 1, 1),(19, 293, 1, 1, 1),(19, 294, 1, 1, 1),(19, 295, 1, 1, 1),(19, 296, 1, 1, 1),(19, 297, 1, 1, 1),(19, 298, 1, 1, 1),(19, 299, 1, 1, 1),(19, 300, 1, 1, 1),(19, 301, 1, 1, 1),(19, 302, 1, 1, 1),(19, 303, 1, 1, 1),(19, 304, 1, 1, 1),(19, 305, 1, 1, 1),(19, 306, 1, 1, 1),(19, 307, 1, 1, 1),(19, 308, 1, 1, 1),(19, 309, 1, 1, 1),(19, 310, 1, 1, 1),(19, 311, 1, 1, 1),(19, 312, 1, 1, 1),(19, 313, 1, 1, 1),(19, 314, 1, 1, 1),(19, 315, 1, 1, 1),(19, 316, 1, 1, 1),(19, 317, 1, 1, 1),(19, 318, 1, 1, 1),(19, 319, 1, 1, 1),(19, 320, 1, 1, 1),(19, 321, 1, 1, 1),(19, 322, 1, 1, 1),(19, 323, 1, 1, 1),(19, 324, 1, 1, 1),(19, 325, 1, 1, 1),(19, 326, 1, 1, 1),(19, 327, 1, 1, 1),(19, 328, 1, 1, 1),(19, 329, 1, 1, 1),(19, 330, 1, 1, 1),(19, 331, 1, 1, 1),(19, 332, 1, 1, 1),(19, 333, 1, 1, 1),(19, 334, 1, 1, 1),(19, 335, 1, 1, 1),(19, 336, 1, 1, 1),(19, 337, 1, 1, 1),(19, 338, 1, 1, 1),(19, 339, 1, 1, 1),(19, 340, 1, 1, 1),(19, 341, 1, 1, 1),(19, 342, 1, 1, 1),(19, 343, 1, 1, 1),(19, 344, 1, 1, 1),(19, 345, 1, 1, 1),(19, 346, 1, 1, 1),(19, 347, 1, 1, 1),(19, 348, 1, 1, 1),(19, 349, 1, 1, 1),(19, 350, 1, 1, 1),(19, 351, 1, 1, 1),(19, 352, 1, 1, 1),(19, 353, 1, 1, 1),(19, 354, 1, 1, 1),(19, 355, 1, 1, 1),(19, 356, 1, 1, 1),(19, 357, 1, 1, 1),(19, 358, 1, 1, 1),(19, 359, 1, 1, 1),(19, 360, 1, 1, 1),(19, 361, 1, 1, 1),(19, 362, 1, 1, 1),(19, 363, 1, 1, 1),(19, 364, 1, 1, 1),(19, 365, 1, 1, 1),(19, 366, 1, 1, 1),(19, 367, 1, 1, 1),(19, 368, 1, 1, 1),(19, 369, 2, 1, 1),(19, 370, 2, 1, 1),(19, 371, 2, 1, 1),(19, 372, 2, 1, 1),(19, 373, 2, 1, 1),(19, 374, 2, 1, 1),(19, 375, 2, 1, 1),(19, 376, 2, 1, 1),(19, 377, 3, 1, 1),(19, 378, 3, 1, 1),(19, 379, 3, 1, 1),(19, 380, 3, 1, 1),(19, 381, 4, 1, 1),(19, 382, 4, 1, 1),(19, 383, 4, 1, 1),(19, 384, 4, 1, 1),(20, 1, 1, 1, 1),(20, 2, 1, 3, 1),(20, 3, 1, 1, 1),(20, 4, 1, 3, 1),(20, 5, 1, 1, 1),(20, 6, 1, 3, 1),(20, 7, 1, 1, 1),(20, 8, 1, 3, 1),(20, 9, 1, 1, 1),(20, 10, 1, 3, 1),(20, 11, 1, 1, 1),(20, 12, 1, 3, 1),(20, 13, 1, 1, 1),(20, 14, 1, 3, 1),(20, 15, 1, 1, 1),(20, 16, 1, 3, 1),(20, 17, 1, 1, 1),(20, 18, 1, 3, 1),(20, 19, 1, 1, 1),(20, 20, 1, 3, 1),(20, 21, 1, 1, 1),(20, 22, 1, 3, 1),(20, 23, 1, 1, 1),(20, 24, 1, 3, 1),(20, 25, 1, 1, 1),(20, 26, 1, 3, 1),(20, 27, 1, 1, 1),(20, 28, 1, 3, 1),(20, 29, 1, 1, 1),(20, 30, 1, 3, 1),(20, 31, 1, 1, 1),(20, 32, 1, 3, 1),(20, 33, 1, 2, 1),(20, 34, 1, 4, 1),(20, 35, 1, 2, 1),(20, 36, 1, 4, 1),(20, 37, 1, 2, 1),(20, 38, 1, 4, 1),(20, 39, 1, 2, 1),(20, 40, 1, 4, 1),(20, 41, 1, 2, 1),(20, 42, 1, 4, 1),(20, 43, 1, 2, 1),(20, 44, 1, 4, 1),(20, 45, 1, 2, 1),(20, 46, 1, 4, 1),(20, 47, 1, 2, 1),(20, 48, 1, 4, 1),(20, 49, 1, 2, 1),(20, 50, 1, 4, 1),(20, 51, 1, 2, 1),(20, 52, 1, 4, 1),(20, 53, 1, 2, 1),(20, 54, 1, 4, 1),(20, 55, 1, 2, 1),(20, 56, 1, 4, 1),(20, 57, 1, 2, 1),(20, 58, 1, 4, 1),(20, 59, 1, 2, 1),(20, 60, 1, 4, 1),(20, 61, 1, 2, 1),(20, 62, 1, 4, 1),(20, 63, 1, 2, 1),(20, 64, 1, 4, 1),(20, 65, 1, 1, 1),(20, 66, 1, 3, 1),(20, 67, 1, 1, 1),(20, 68, 1, 3, 1),(20, 69, 1, 1, 1),(20, 70, 1, 3, 1),(20, 71, 1, 1, 1),(20, 72, 1, 3, 1),(20, 73, 1, 1, 1),(20, 74, 1, 3, 1),(20, 75, 1, 1, 1),(20, 76, 1, 3, 1),(20, 77, 1, 1, 1),(20, 78, 1, 3, 1),(20, 79, 1, 1, 1),(20, 80, 1, 3, 1),(20, 81, 1, 1, 1),(20, 82, 1, 3, 1),(20, 83, 1, 1, 1),(20, 84, 1, 3, 1),(20, 85, 1, 1, 1),(20, 86, 1, 3, 1),(20, 87, 1, 1, 1),(20, 88, 1, 3, 1),(20, 89, 1, 1, 1),(20, 90, 1, 3, 1),(20, 91, 1, 1, 1),(20, 92, 1, 3, 1),(20, 93, 1, 1, 1),(20, 94, 1, 3, 1),(20, 95, 1, 1, 1),(20, 96, 1, 3, 1),(20, 97, 1, 2, 1),(20, 98, 1, 4, 1),(20, 99, 1, 2, 1),(20, 100, 1, 4, 1),(20, 101, 1, 2, 1),(20, 102, 1, 4, 1),(20, 103, 1, 2, 1),(20, 104, 1, 4, 1),(20, 105, 1, 2, 1),(20, 106, 1, 4, 1),(20, 107, 1, 2, 1),(20, 108, 1, 4, 1),(20, 109, 1, 2, 1),(20, 110, 1, 4, 1),(20, 111, 1, 2, 1),(20, 112, 1, 4, 1),(20, 113, 1, 2, 1),(20, 114, 1, 4, 1),(20, 115, 1, 2, 1),(20, 116, 1, 4, 1),(20, 117, 1, 2, 1),(20, 118, 1, 4, 1),(20, 119, 1, 2, 1),(20, 120, 1, 4, 1),(20, 121, 1, 2, 1),(20, 122, 1, 4, 1),(20, 123, 1, 2, 1),(20, 124, 1, 4, 1),(20, 125, 1, 2, 1),(20, 126, 1, 4, 1),(20, 127, 1, 2, 1),(20, 128, 1, 4, 1),(20, 129, 1, 1, 1),(20, 130, 1, 3, 1),(20, 131, 1, 1, 1),(20, 132, 1, 3, 1),(20, 133, 1, 1, 1),(20, 134, 1, 3, 1),(20, 135, 1, 1, 1),(20, 136, 1, 3, 1),(20, 137, 1, 1, 1),(20, 138, 1, 3, 1),(20, 139, 1, 1, 1),(20, 140, 1, 3, 1),(20, 141, 1, 1, 1),(20, 142, 1, 3, 1),(20, 143, 1, 1, 1),(20, 144, 1, 3, 1),(20, 145, 1, 1, 1),(20, 146, 1, 3, 1),(20, 147, 1, 1, 1),(20, 148, 1, 3, 1),(20, 149, 1, 1, 1),(20, 150, 1, 3, 1),(20, 151, 1, 1, 1),(20, 152, 1, 3, 1),(20, 153, 1, 1, 1),(20, 154, 1, 3, 1),(20, 155, 1, 1, 1),(20, 156, 1, 3, 1),(20, 157, 1, 1, 1),(20, 158, 1, 3, 1),(20, 159, 1, 1, 1),(20, 160, 1, 3, 1),(20, 161, 1, 2, 1),(20, 162, 1, 4, 1),(20, 163, 1, 2, 1),(20, 164, 1, 4, 1),(20, 165, 1, 2, 1),(20, 166, 1, 4, 1),(20, 167, 1, 2, 1),(20, 168, 1, 4, 1),(20, 169, 1, 2, 1),(20, 170, 1, 4, 1),(20, 171, 1, 2, 1),(20, 172, 1, 4, 1),(20, 173, 1, 2, 1),(20, 174, 1, 4, 1),(20, 175, 1, 2, 1),(20, 176, 1, 4, 1),(20, 177, 1, 2, 1),(20, 178, 1, 4, 1),(20, 179, 1, 2, 1),(20, 180, 1, 4, 1),(20, 181, 1, 2, 1),(20, 182, 1, 4, 1),(20, 183, 1, 2, 1),(20, 184, 1, 4, 1),(20, 185, 1, 2, 1),(20, 186, 1, 4, 1),(20, 187, 1, 2, 1),(20, 188, 1, 4, 1),(20, 189, 1, 2, 1),(20, 190, 1, 4, 1),(20, 191, 1, 2, 1),(20, 192, 1, 4, 1),(20, 193, 1, 1, 1),(20, 194, 1, 3, 1),(20, 195, 1, 1, 1),(20, 196, 1, 3, 1),(20, 197, 1, 1, 1),(20, 198, 1, 3, 1),(20, 199, 1, 1, 1),(20, 200, 1, 3, 1),(20, 201, 1, 1, 1),(20, 202, 1, 3, 1),(20, 203, 1, 1, 1),(20, 204, 1, 3, 1),(20, 205, 1, 1, 1),(20, 206, 1, 3, 1),(20, 207, 1, 1, 1),(20, 208, 1, 3, 1),(20, 209, 1, 1, 1),(20, 210, 1, 3, 1),(20, 211, 1, 1, 1),(20, 212, 1, 3, 1),(20, 213, 1, 1, 1),(20, 214, 1, 3, 1),(20, 215, 1, 1, 1),(20, 216, 1, 3, 1),(20, 217, 1, 1, 1),(20, 218, 1, 3, 1),(20, 219, 1, 1, 1),(20, 220, 1, 3, 1),(20, 221, 1, 1, 1),(20, 222, 1, 3, 1),(20, 223, 1, 1, 1),(20, 224, 1, 3, 1),(20, 225, 1, 2, 1),(20, 226, 1, 4, 1),(20, 227, 1, 2, 1),(20, 228, 1, 4, 1),(20, 229, 1, 2, 1),(20, 230, 1, 4, 1),(20, 231, 1, 2, 1),(20, 232, 1, 4, 1),(20, 233, 1, 2, 1),(20, 234, 1, 4, 1),(20, 235, 1, 2, 1),(20, 236, 1, 4, 1),(20, 237, 1, 2, 1),(20, 238, 1, 4, 1),(20, 239, 1, 2, 1),(20, 240, 1, 4, 1),(20, 241, 1, 2, 1),(20, 242, 1, 4, 1),(20, 243, 1, 2, 1),(20, 244, 1, 4, 1),(20, 245, 1, 2, 1),(20, 246, 1, 4, 1),(20, 247, 1, 2, 1),(20, 248, 1, 4, 1),(20, 249, 1, 2, 1),(20, 250, 1, 4, 1),(20, 251, 1, 2, 1),(20, 252, 1, 4, 1),(20, 253, 1, 2, 1),(20, 254, 1, 4, 1),(20, 255, 1, 2, 1),(20, 256, 1, 4, 1),(20, 257, 1, 1, 1),(20, 258, 1, 3, 1),(20, 259, 1, 1, 1),(20, 260, 1, 3, 1),(20, 261, 1, 1, 1),(20, 262, 1, 3, 1),(20, 263, 1, 1, 1),(20, 264, 1, 3, 1),(20, 265, 1, 1, 1),(20, 266, 1, 3, 1),(20, 267, 1, 1, 1),(20, 268, 1, 3, 1),(20, 269, 1, 1, 1),(20, 270, 1, 3, 1),(20, 271, 1, 1, 1),(20, 272, 1, 3, 1),(20, 273, 1, 1, 1),(20, 274, 1, 3, 1),(20, 275, 1, 1, 1),(20, 276, 1, 3, 1),(20, 277, 1, 1, 1),(20, 278, 1, 3, 1),(20, 279, 1, 1, 1),(20, 280, 1, 3, 1),(20, 281, 1, 1, 1),(20, 282, 1, 3, 1),(20, 283, 1, 1, 1),(20, 284, 1, 3, 1),(20, 285, 1, 1, 1),(20, 286, 1, 3, 1),(20, 287, 1, 1, 1),(20, 288, 1, 3, 1),(20, 289, 1, 2, 1),(20, 290, 1, 4, 1),(20, 291, 1, 2, 1),(20, 292, 1, 4, 1),(20, 293, 1, 2, 1),(20, 294, 1, 4, 1),(20, 295, 1, 2, 1),(20, 296, 1, 4, 1),(20, 297, 1, 2, 1),(20, 298, 1, 4, 1),(20, 299, 1, 2, 1),(20, 300, 1, 4, 1),(20, 301, 1, 2, 1),(20, 302, 1, 4, 1),(20, 303, 1, 2, 1),(20, 304, 1, 4, 1),(20, 305, 1, 2, 1),(20, 306, 1, 4, 1),(20, 307, 1, 2, 1),(20, 308, 1, 4, 1),(20, 309, 1, 2, 1),(20, 310, 1, 4, 1),(20, 311, 1, 2, 1),(20, 312, 1, 4, 1),(20, 313, 1, 2, 1),(20, 314, 1, 4, 1),(20, 315, 1, 2, 1),(20, 316, 1, 4, 1),(20, 317, 1, 2, 1),(20, 318, 1, 4, 1),(20, 319, 1, 2, 1),(20, 320, 1, 4, 1),(20, 321, 1, 1, 1),(20, 322, 1, 3, 1),(20, 323, 1, 1, 1),(20, 324, 1, 3, 1),(20, 325, 1, 1, 1),(20, 326, 1, 3, 1),(20, 327, 1, 1, 1),(20, 328, 1, 3, 1),(20, 329, 1, 1, 1),(20, 330, 1, 3, 1),(20, 331, 1, 1, 1),(20, 332, 1, 3, 1),(20, 333, 1, 1, 1),(20, 334, 1, 3, 1),(20, 335, 1, 1, 1),(20, 336, 1, 3, 1),(20, 337, 1, 1, 1),(20, 338, 1, 3, 1),(20, 339, 1, 1, 1),(20, 340, 1, 3, 1),(20, 341, 1, 1, 1),(20, 342, 1, 3, 1),(20, 343, 1, 1, 1),(20, 344, 1, 3, 1),(20, 345, 1, 1, 1),(20, 346, 1, 3, 1),(20, 347, 1, 1, 1),(20, 348, 1, 3, 1),(20, 349, 1, 1, 1),(20, 350, 1, 3, 1),(20, 351, 1, 1, 1),(20, 352, 1, 3, 1),(20, 353, 1, 2, 1),(20, 354, 1, 4, 1),(20, 355, 1, 2, 1),(20, 356, 1, 4, 1),(20, 357, 1, 2, 1),(20, 358, 1, 4, 1),(20, 359, 1, 2, 1),(20, 360, 1, 4, 1),(20, 361, 1, 2, 1),(20, 362, 1, 4, 1),(20, 363, 1, 2, 1),(20, 364, 1, 4, 1),(20, 365, 1, 2, 1),(20, 366, 1, 4, 1),(20, 367, 1, 2, 1),(20, 368, 1, 4, 1),(20, 369, 1, 2, 1),(20, 370, 1, 4, 1),(20, 371, 1, 2, 1),(20, 372, 1, 4, 1),(20, 373, 1, 2, 1),(20, 374, 1, 4, 1),(20, 375, 1, 2, 1),(20, 376, 1, 4, 1),(20, 377, 1, 2, 1),(20, 378, 1, 4, 1),(20, 379, 1, 2, 1),(20, 380, 1, 4, 1),(20, 381, 1, 2, 1),(20, 382, 1, 4, 1),(20, 383, 1, 2, 1),(20, 384, 1, 4, 1),(20, 385, 1, 1, 1),(20, 386, 1, 3, 1),(20, 387, 1, 1, 1),(20, 388, 1, 3, 1),(20, 389, 1, 1, 1),(20, 390, 1, 3, 1),(20, 391, 1, 1, 1),(20, 392, 1, 3, 1),(20, 393, 1, 1, 1),(20, 394, 1, 3, 1),(20, 395, 1, 1, 1),(20, 396, 1, 3, 1),(20, 397, 1, 1, 1),(20, 398, 1, 3, 1),(20, 399, 1, 1, 1),(20, 400, 1, 3, 1),(20, 401, 1, 1, 1),(20, 402, 1, 3, 1),(20, 403, 1, 1, 1),(20, 404, 1, 3, 1),(20, 405, 1, 1, 1),(20, 406, 1, 3, 1),(20, 407, 1, 1, 1),(20, 408, 1, 3, 1),(20, 409, 1, 1, 1),(20, 410, 1, 3, 1),(20, 411, 1, 1, 1),(20, 412, 1, 3, 1),(20, 413, 1, 1, 1),(20, 414, 1, 3, 1),(20, 415, 1, 1, 1),(20, 416, 1, 3, 1),(20, 417, 1, 2, 1),(20, 418, 1, 4, 1),(20, 419, 1, 2, 1),(20, 420, 1, 4, 1),(20, 421, 1, 2, 1),(20, 422, 1, 4, 1),(20, 423, 1, 2, 1),(20, 424, 1, 4, 1),(20, 425, 1, 2, 1),(20, 426, 1, 4, 1),(20, 427, 1, 2, 1),(20, 428, 1, 4, 1),(20, 429, 1, 2, 1),(20, 430, 1, 4, 1),(20, 431, 1, 2, 1),(20, 432, 1, 4, 1),(20, 433, 1, 2, 1),(20, 434, 1, 4, 1),(20, 435, 1, 2, 1),(20, 436, 1, 4, 1),(20, 437, 1, 2, 1),(20, 438, 1, 4, 1),(20, 439, 1, 2, 1),(20, 440, 1, 4, 1),(20, 441, 1, 2, 1),(20, 442, 1, 4, 1),(20, 443, 1, 2, 1),(20, 444, 1, 4, 1),(20, 445, 1, 2, 1),(20, 446, 1, 4, 1),(20, 447, 1, 2, 1),(20, 448, 1, 4, 1),(20, 449, 1, 1, 1),(20, 450, 1, 3, 1),(20, 451, 1, 1, 1),(20, 452, 1, 3, 1),(20, 453, 1, 1, 1),(20, 454, 1, 3, 1),(20, 455, 1, 1, 1),(20, 456, 1, 3, 1),(20, 457, 1, 1, 1),(20, 458, 1, 3, 1),(20, 459, 1, 1, 1),(20, 460, 1, 3, 1),(20, 461, 1, 1, 1),(20, 462, 1, 3, 1),(20, 463, 1, 1, 1),(20, 464, 1, 3, 1),(20, 465, 1, 1, 1),(20, 466, 1, 3, 1),(20, 467, 1, 1, 1),(20, 468, 1, 3, 1),(20, 469, 1, 1, 1),(20, 470, 1, 3, 1),(20, 471, 1, 1, 1),(20, 472, 1, 3, 1),(20, 473, 1, 1, 1),(20, 474, 1, 3, 1),(20, 475, 1, 1, 1),(20, 476, 1, 3, 1),(20, 477, 1, 1, 1),(20, 478, 1, 3, 1),(20, 479, 1, 1, 1),(20, 480, 1, 3, 1),(20, 481, 1, 2, 1),(20, 482, 1, 4, 1),(20, 483, 1, 2, 1),(20, 484, 1, 4, 1),(20, 485, 1, 2, 1),(20, 486, 1, 4, 1),(20, 487, 1, 2, 1),(20, 488, 1, 4, 1),(20, 489, 1, 2, 1),(20, 490, 1, 4, 1),(20, 491, 1, 2, 1),(20, 492, 1, 4, 1),(20, 493, 1, 2, 1),(20, 494, 1, 4, 1),(20, 495, 1, 2, 1),(20, 496, 1, 4, 1),(20, 497, 1, 2, 1),(20, 498, 1, 4, 1),(20, 499, 1, 2, 1),(20, 500, 1, 4, 1),(20, 501, 1, 2, 1),(20, 502, 1, 4, 1),(20, 503, 1, 2, 1),(20, 504, 1, 4, 1),(20, 505, 1, 2, 1),(20, 506, 1, 4, 1),(20, 507, 1, 2, 1),(20, 508, 1, 4, 1),(20, 509, 1, 2, 1),(20, 510, 1, 4, 1),(20, 511, 1, 2, 1),(20, 512, 1, 4, 1),(20, 513, 1, 1, 1),(20, 514, 1, 3, 1),(20, 515, 1, 1, 1),(20, 516, 1, 3, 1),(20, 517, 1, 1, 1),(20, 518, 1, 3, 1),(20, 519, 1, 1, 1),(20, 520, 1, 3, 1),(20, 521, 1, 1, 1),(20, 522, 1, 3, 1),(20, 523, 1, 1, 1),(20, 524, 1, 3, 1),(20, 525, 1, 1, 1),(20, 526, 1, 3, 1),(20, 527, 1, 1, 1),(20, 528, 1, 3, 1),(20, 529, 1, 1, 1),(20, 530, 1, 3, 1),(20, 531, 1, 1, 1),(20, 532, 1, 3, 1),(20, 533, 1, 1, 1),(20, 534, 1, 3, 1),(20, 535, 1, 1, 1),(20, 536, 1, 3, 1),(20, 537, 1, 1, 1),(20, 538, 1, 3, 1),(20, 539, 1, 1, 1),(20, 540, 1, 3, 1),(20, 541, 1, 1, 1),(20, 542, 1, 3, 1),(20, 543, 1, 1, 1),(20, 544, 1, 3, 1),(20, 545, 1, 2, 1),(20, 546, 1, 4, 1),(20, 547, 1, 2, 1),(20, 548, 1, 4, 1),(20, 549, 1, 2, 1),(20, 550, 1, 4, 1),(20, 551, 1, 2, 1),(20, 552, 1, 4, 1),(20, 553, 1, 2, 1),(20, 554, 1, 4, 1),(20, 555, 1, 2, 1),(20, 556, 1, 4, 1),(20, 557, 1, 2, 1),(20, 558, 1, 4, 1),(20, 559, 1, 2, 1),(20, 560, 1, 4, 1),(20, 561, 1, 2, 1),(20, 562, 1, 4, 1),(20, 563, 1, 2, 1),(20, 564, 1, 4, 1),(20, 565, 1, 2, 1),(20, 566, 1, 4, 1),(20, 567, 1, 2, 1),(20, 568, 1, 4, 1),(20, 569, 1, 2, 1),(20, 570, 1, 4, 1),(20, 571, 1, 2, 1),(20, 572, 1, 4, 1),(20, 573, 1, 2, 1),(20, 574, 1, 4, 1),(20, 575, 1, 2, 1),(20, 576, 1, 4, 1),(20, 577, 1, 1, 1),(20, 578, 1, 3, 1),(20, 579, 1, 1, 1),(20, 580, 1, 3, 1),(20, 581, 1, 1, 1),(20, 582, 1, 3, 1),(20, 583, 1, 1, 1),(20, 584, 1, 3, 1),(20, 585, 1, 1, 1),(20, 586, 1, 3, 1),(20, 587, 1, 1, 1),(20, 588, 1, 3, 1),(20, 589, 1, 1, 1),(20, 590, 1, 3, 1),(20, 591, 1, 1, 1),(20, 592, 1, 3, 1),(20, 593, 1, 1, 1),(20, 594, 1, 3, 1),(20, 595, 1, 1, 1),(20, 596, 1, 3, 1),(20, 597, 1, 1, 1),(20, 598, 1, 3, 1),(20, 599, 1, 1, 1),(20, 600, 1, 3, 1),(20, 601, 1, 1, 1),(20, 602, 1, 3, 1),(20, 603, 1, 1, 1),(20, 604, 1, 3, 1),(20, 605, 1, 1, 1),(20, 606, 1, 3, 1),(20, 607, 1, 1, 1),(20, 608, 1, 3, 1),(20, 609, 1, 2, 1),(20, 610, 1, 4, 1),(20, 611, 1, 2, 1),(20, 612, 1, 4, 1),(20, 613, 1, 2, 1),(20, 614, 1, 4, 1),(20, 615, 1, 2, 1),(20, 616, 1, 4, 1),(20, 617, 1, 2, 1),(20, 618, 1, 4, 1),(20, 619, 1, 2, 1),(20, 620, 1, 4, 1),(20, 621, 1, 2, 1),(20, 622, 1, 4, 1),(20, 623, 1, 2, 1),(20, 624, 1, 4, 1),(20, 625, 1, 2, 1),(20, 626, 1, 4, 1),(20, 627, 1, 2, 1),(20, 628, 1, 4, 1),(20, 629, 1, 2, 1),(20, 630, 1, 4, 1),(20, 631, 1, 2, 1),(20, 632, 1, 4, 1),(20, 633, 1, 2, 1),(20, 634, 1, 4, 1),(20, 635, 1, 2, 1),(20, 636, 1, 4, 1),(20, 637, 1, 2, 1),(20, 638, 1, 4, 1),(20, 639, 1, 2, 1),(20, 640, 1, 4, 1),(20, 641, 1, 1, 1),(20, 642, 1, 3, 1),(20, 643, 1, 1, 1),(20, 644, 1, 3, 1),(20, 645, 1, 1, 1),(20, 646, 1, 3, 1),(20, 647, 1, 1, 1),(20, 648, 1, 3, 1),(20, 649, 1, 1, 1),(20, 650, 1, 3, 1),(20, 651, 1, 1, 1),(20, 652, 1, 3, 1),(20, 653, 1, 1, 1),(20, 654, 1, 3, 1),(20, 655, 1, 1, 1),(20, 656, 1, 3, 1),(20, 657, 1, 1, 1),(20, 658, 1, 3, 1),(20, 659, 1, 1, 1),(20, 660, 1, 3, 1),(20, 661, 1, 1, 1),(20, 662, 1, 3, 1),(20, 663, 1, 1, 1),(20, 664, 1, 3, 1),(20, 665, 1, 1, 1),(20, 666, 1, 3, 1),(20, 667, 1, 1, 1),(20, 668, 1, 3, 1),(20, 669, 1, 1, 1),(20, 670, 1, 3, 1),(20, 671, 1, 1, 1),(20, 672, 1, 3, 1),(20, 673, 1, 2, 1),(20, 674, 1, 4, 1),(20, 675, 1, 2, 1),(20, 676, 1, 4, 1),(20, 677, 1, 2, 1),(20, 678, 1, 4, 1),(20, 679, 1, 2, 1),(20, 680, 1, 4, 1),(20, 681, 1, 2, 1),(20, 682, 1, 4, 1),(20, 683, 1, 2, 1),(20, 684, 1, 4, 1),(20, 685, 1, 2, 1),(20, 686, 1, 4, 1),(20, 687, 1, 2, 1),(20, 688, 1, 4, 1),(20, 689, 1, 2, 1),(20, 690, 1, 4, 1),(20, 691, 1, 2, 1),(20, 692, 1, 4, 1),(20, 693, 1, 2, 1),(20, 694, 1, 4, 1),(20, 695, 1, 2, 1),(20, 696, 1, 4, 1),(20, 697, 1, 2, 1),(20, 698, 1, 4, 1),(20, 699, 1, 2, 1),(20, 700, 1, 4, 1),(20, 701, 1, 2, 1),(20, 702, 1, 4, 1),(20, 703, 1, 2, 1),(20, 704, 1, 4, 1),(20, 705, 1, 1, 1),(20, 706, 1, 3, 1),(20, 707, 1, 1, 1),(20, 708, 1, 3, 1),(20, 709, 1, 1, 1),(20, 710, 1, 3, 1),(20, 711, 1, 1, 1),(20, 712, 1, 3, 1),(20, 713, 1, 1, 1),(20, 714, 1, 3, 1),(20, 715, 1, 1, 1),(20, 716, 1, 3, 1),(20, 717, 1, 1, 1),(20, 718, 1, 3, 1),(20, 719, 1, 1, 1),(20, 720, 1, 3, 1),(20, 721, 1, 1, 1),(20, 722, 1, 3, 1),(20, 723, 1, 1, 1),(20, 724, 1, 3, 1),(20, 725, 1, 1, 1),(20, 726, 1, 3, 1),(20, 727, 1, 1, 1),(20, 728, 1, 3, 1),(20, 729, 1, 1, 1),(20, 730, 1, 3, 1),(20, 731, 1, 1, 1),(20, 732, 1, 3, 1),(20, 733, 1, 1, 1),(20, 734, 1, 3, 1),(20, 735, 1, 1, 1),(20, 736, 1, 3, 1),(20, 737, 1, 2, 1),(20, 738, 1, 4, 1),(20, 739, 1, 2, 1),(20, 740, 1, 4, 1),(20, 741, 1, 2, 1),(20, 742, 1, 4, 1),(20, 743, 1, 2, 1),(20, 744, 1, 4, 1),(20, 745, 1, 2, 1),(20, 746, 1, 4, 1),(20, 747, 1, 2, 1),(20, 748, 1, 4, 1),(20, 749, 1, 2, 1),(20, 750, 1, 4, 1),(20, 751, 1, 2, 1),(20, 752, 1, 4, 1),(20, 753, 1, 2, 1),(20, 754, 1, 4, 1),(20, 755, 1, 2, 1),(20, 756, 1, 4, 1),(20, 757, 1, 2, 1),(20, 758, 1, 4, 1),(20, 759, 1, 2, 1),(20, 760, 1, 4, 1),(20, 761, 1, 2, 1),(20, 762, 1, 4, 1),(20, 763, 1, 2, 1),(20, 764, 1, 4, 1),(20, 765, 1, 2, 1),(20, 766, 1, 4, 1),(20, 767, 1, 2, 1),(20, 768, 1, 4, 1),(20, 769, 1, 1, 1),(20, 770, 1, 3, 1),(20, 771, 1, 1, 1),(20, 772, 1, 3, 1),(20, 773, 1, 1, 1),(20, 774, 1, 3, 1),(20, 775, 1, 1, 1),(20, 776, 1, 3, 1),(20, 777, 1, 1, 1),(20, 778, 1, 3, 1),(20, 779, 1, 1, 1),(20, 780, 1, 3, 1),(20, 781, 1, 1, 1),(20, 782, 1, 3, 1),(20, 783, 1, 1, 1),(20, 784, 1, 3, 1),(20, 785, 1, 1, 1),(20, 786, 1, 3, 1),(20, 787, 1, 1, 1),(20, 788, 1, 3, 1),(20, 789, 1, 1, 1),(20, 790, 1, 3, 1),(20, 791, 1, 1, 1),(20, 792, 1, 3, 1),(20, 793, 1, 1, 1),(20, 794, 1, 3, 1),(20, 795, 1, 1, 1),(20, 796, 1, 3, 1),(20, 797, 1, 1, 1),(20, 798, 1, 3, 1),(20, 799, 1, 1, 1),(20, 800, 1, 3, 1),(20, 801, 1, 2, 1),(20, 802, 1, 4, 1),(20, 803, 1, 2, 1),(20, 804, 1, 4, 1),(20, 805, 1, 2, 1),(20, 806, 1, 4, 1),(20, 807, 1, 2, 1),(20, 808, 1, 4, 1),(20, 809, 1, 2, 1),(20, 810, 1, 4, 1),(20, 811, 1, 2, 1),(20, 812, 1, 4, 1),(20, 813, 1, 2, 1),(20, 814, 1, 4, 1),(20, 815, 1, 2, 1),(20, 816, 1, 4, 1),(20, 817, 1, 2, 1),(20, 818, 1, 4, 1),(20, 819, 1, 2, 1),(20, 820, 1, 4, 1),(20, 821, 1, 2, 1),(20, 822, 1, 4, 1),(20, 823, 1, 2, 1),(20, 824, 1, 4, 1),(20, 825, 1, 2, 1),(20, 826, 1, 4, 1),(20, 827, 1, 2, 1),(20, 828, 1, 4, 1),(20, 829, 1, 2, 1),(20, 830, 1, 4, 1),(20, 831, 1, 2, 1),(20, 832, 1, 4, 1),(20, 833, 1, 1, 1),(20, 834, 1, 3, 1),(20, 835, 1, 1, 1),(20, 836, 1, 3, 1),(20, 837, 1, 1, 1),(20, 838, 1, 3, 1),(20, 839, 1, 1, 1),(20, 840, 1, 3, 1),(20, 841, 1, 1, 1),(20, 842, 1, 3, 1),(20, 843, 1, 1, 1),(20, 844, 1, 3, 1),(20, 845, 1, 1, 1),(20, 846, 1, 3, 1),(20, 847, 1, 1, 1),(20, 848, 1, 3, 1),(20, 849, 1, 1, 1),(20, 850, 1, 3, 1),(20, 851, 1, 1, 1),(20, 852, 1, 3, 1),(20, 853, 1, 1, 1),(20, 854, 1, 3, 1),(20, 855, 1, 1, 1),(20, 856, 1, 3, 1),(20, 857, 1, 1, 1),(20, 858, 1, 3, 1),(20, 859, 1, 1, 1),(20, 860, 1, 3, 1),(20, 861, 1, 1, 1),(20, 862, 1, 3, 1),(20, 863, 1, 1, 1),(20, 864, 1, 3, 1),(20, 865, 1, 2, 1),(20, 866, 1, 4, 1),(20, 867, 1, 2, 1),(20, 868, 1, 4, 1),(20, 869, 1, 2, 1),(20, 870, 1, 4, 1),(20, 871, 1, 2, 1),(20, 872, 1, 4, 1),(20, 873, 1, 2, 1),(20, 874, 1, 4, 1),(20, 875, 1, 2, 1),(20, 876, 1, 4, 1),(20, 877, 1, 2, 1),(20, 878, 1, 4, 1),(20, 879, 1, 2, 1),(20, 880, 1, 4, 1),(20, 881, 1, 2, 1),(20, 882, 1, 4, 1),(20, 883, 1, 2, 1),(20, 884, 1, 4, 1),(20, 885, 1, 2, 1),(20, 886, 1, 4, 1),(20, 887, 1, 2, 1),(20, 888, 1, 4, 1),(20, 889, 1, 2, 1),(20, 890, 1, 4, 1),(20, 891, 1, 2, 1),(20, 892, 1, 4, 1),(20, 893, 1, 2, 1),(20, 894, 1, 4, 1),(20, 895, 1, 2, 1),(20, 896, 1, 4, 1),(20, 897, 1, 1, 1),(20, 898, 1, 3, 1),(20, 899, 1, 1, 1),(20, 900, 1, 3, 1),(20, 901, 1, 1, 1),(20, 902, 1, 3, 1),(20, 903, 1, 1, 1),(20, 904, 1, 3, 1),(20, 905, 1, 1, 1),(20, 906, 1, 3, 1),(20, 907, 1, 1, 1),(20, 908, 1, 3, 1),(20, 909, 1, 1, 1),(20, 910, 1, 3, 1),(20, 911, 1, 1, 1),(20, 912, 1, 3, 1),(20, 913, 1, 1, 1),(20, 914, 1, 3, 1),(20, 915, 1, 1, 1),(20, 916, 1, 3, 1),(20, 917, 1, 1, 1),(20, 918, 1, 3, 1),(20, 919, 1, 1, 1),(20, 920, 1, 3, 1),(20, 921, 1, 1, 1),(20, 922, 1, 3, 1),(20, 923, 1, 1, 1),(20, 924, 1, 3, 1),(20, 925, 1, 1, 1),(20, 926, 1, 3, 1),(20, 927, 1, 1, 1),(20, 928, 1, 3, 1),(20, 929, 1, 2, 1),(20, 930, 1, 4, 1),(20, 931, 1, 2, 1),(20, 932, 1, 4, 1),(20, 933, 1, 2, 1),(20, 934, 1, 4, 1),(20, 935, 1, 2, 1),(20, 936, 1, 4, 1),(20, 937, 1, 2, 1),(20, 938, 1, 4, 1),(20, 939, 1, 2, 1),(20, 940, 1, 4, 1),(20, 941, 1, 2, 1),(20, 942, 1, 4, 1),(20, 943, 1, 2, 1),(20, 944, 1, 4, 1),(20, 945, 1, 2, 1),(20, 946, 1, 4, 1),(20, 947, 1, 2, 1),(20, 948, 1, 4, 1),(20, 949, 1, 2, 1),(20, 950, 1, 4, 1),(20, 951, 1, 2, 1),(20, 952, 1, 4, 1),(20, 953, 1, 2, 1),(20, 954, 1, 4, 1),(20, 955, 1, 2, 1),(20, 956, 1, 4, 1),(20, 957, 1, 2, 1),(20, 958, 1, 4, 1),(20, 959, 1, 2, 1),(20, 960, 1, 4, 1),(20, 961, 1, 1, 1),(20, 962, 1, 3, 1),(20, 963, 1, 1, 1),(20, 964, 1, 3, 1),(20, 965, 1, 1, 1),(20, 966, 1, 3, 1),(20, 967, 1, 1, 1),(20, 968, 1, 3, 1),(20, 969, 1, 1, 1),(20, 970, 1, 3, 1),(20, 971, 1, 1, 1),(20, 972, 1, 3, 1),(20, 973, 1, 1, 1),(20, 974, 1, 3, 1),(20, 975, 1, 1, 1),(20, 976, 1, 3, 1),(20, 977, 1, 1, 1),(20, 978, 1, 3, 1),(20, 979, 1, 1, 1),(20, 980, 1, 3, 1),(20, 981, 1, 1, 1),(20, 982, 1, 3, 1),(20, 983, 1, 1, 1),(20, 984, 1, 3, 1),(20, 985, 1, 1, 1),(20, 986, 1, 3, 1),(20, 987, 1, 1, 1),(20, 988, 1, 3, 1),(20, 989, 1, 1, 1),(20, 990, 1, 3, 1),(20, 991, 1, 1, 1),(20, 992, 1, 3, 1),(20, 993, 1, 2, 1),(20, 994, 1, 4, 1),(20, 995, 1, 2, 1),(20, 996, 1, 4, 1),(20, 997, 1, 2, 1),(20, 998, 1, 4, 1),(20, 999, 1, 2, 1),(20, 1000, 1, 4, 1),(20, 1001, 1, 2, 1),(20, 1002, 1, 4, 1),(20, 1003, 1, 2, 1),(20, 1004, 1, 4, 1),(20, 1005, 1, 2, 1),(20, 1006, 1, 4, 1),(20, 1007, 1, 2, 1),(20, 1008, 1, 4, 1),(20, 1009, 1, 2, 1),(20, 1010, 1, 4, 1),(20, 1011, 1, 2, 1),(20, 1012, 1, 4, 1),(20, 1013, 1, 2, 1),(20, 1014, 1, 4, 1),(20, 1015, 1, 2, 1),(20, 1016, 1, 4, 1),(20, 1017, 1, 2, 1),(20, 1018, 1, 4, 1),(20, 1019, 1, 2, 1),(20, 1020, 1, 4, 1),(20, 1021, 1, 2, 1),(20, 1022, 1, 4, 1),(20, 1023, 1, 2, 1),(20, 1024, 1, 4, 1),(20, 1025, 1, 1, 1),(20, 1026, 1, 3, 1),(20, 1027, 1, 1, 1),(20, 1028, 1, 3, 1),(20, 1029, 1, 1, 1),(20, 1030, 1, 3, 1),(20, 1031, 1, 1, 1),(20, 1032, 1, 3, 1),(20, 1033, 1, 1, 1),(20, 1034, 1, 3, 1),(20, 1035, 1, 1, 1),(20, 1036, 1, 3, 1),(20, 1037, 1, 1, 1),(20, 1038, 1, 3, 1),(20, 1039, 1, 1, 1),(20, 1040, 1, 3, 1),(20, 1041, 1, 1, 1),(20, 1042, 1, 3, 1),(20, 1043, 1, 1, 1),(20, 1044, 1, 3, 1),(20, 1045, 1, 1, 1),(20, 1046, 1, 3, 1),(20, 1047, 1, 1, 1),(20, 1048, 1, 3, 1),(20, 1049, 1, 1, 1),(20, 1050, 1, 3, 1),(20, 1051, 1, 1, 1),(20, 1052, 1, 3, 1),(20, 1053, 1, 1, 1),(20, 1054, 1, 3, 1),(20, 1055, 1, 1, 1),(20, 1056, 1, 3, 1),(20, 1057, 1, 2, 1),(20, 1058, 1, 4, 1),(20, 1059, 1, 2, 1),(20, 1060, 1, 4, 1),(20, 1061, 1, 2, 1),(20, 1062, 1, 4, 1),(20, 1063, 1, 2, 1),(20, 1064, 1, 4, 1),(20, 1065, 1, 2, 1),(20, 1066, 1, 4, 1),(20, 1067, 1, 2, 1),(20, 1068, 1, 4, 1),(20, 1069, 1, 2, 1),(20, 1070, 1, 4, 1),(20, 1071, 1, 2, 1),(20, 1072, 1, 4, 1),(20, 1073, 1, 2, 1),(20, 1074, 1, 4, 1),(20, 1075, 1, 2, 1),(20, 1076, 1, 4, 1),(20, 1077, 1, 2, 1),(20, 1078, 1, 4, 1),(20, 1079, 1, 2, 1),(20, 1080, 1, 4, 1),(20, 1081, 1, 2, 1),(20, 1082, 1, 4, 1),(20, 1083, 1, 2, 1),(20, 1084, 1, 4, 1),(20, 1085, 1, 2, 1),(20, 1086, 1, 4, 1),(20, 1087, 1, 2, 1),(20, 1088, 1, 4, 1),(20, 1089, 1, 1, 1),(20, 1090, 1, 3, 1),(20, 1091, 1, 1, 1),(20, 1092, 1, 3, 1),(20, 1093, 1, 1, 1),(20, 1094, 1, 3, 1),(20, 1095, 1, 1, 1),(20, 1096, 1, 3, 1),(20, 1097, 1, 1, 1),(20, 1098, 1, 3, 1),(20, 1099, 1, 1, 1),(20, 1100, 1, 3, 1),(20, 1101, 1, 1, 1),(20, 1102, 1, 3, 1),(20, 1103, 1, 1, 1),(20, 1104, 1, 3, 1),(20, 1105, 1, 1, 1),(20, 1106, 1, 3, 1),(20, 1107, 1, 1, 1),(20, 1108, 1, 3, 1),(20, 1109, 1, 1, 1),(20, 1110, 1, 3, 1),(20, 1111, 1, 1, 1),(20, 1112, 1, 3, 1),(20, 1113, 1, 1, 1),(20, 1114, 1, 3, 1),(20, 1115, 1, 1, 1),(20, 1116, 1, 3, 1),(20, 1117, 1, 1, 1),(20, 1118, 1, 3, 1),(20, 1119, 1, 1, 1),(20, 1120, 1, 3, 1),(20, 1121, 1, 2, 1),(20, 1122, 1, 4, 1),(20, 1123, 1, 2, 1),(20, 1124, 1, 4, 1),(20, 1125, 1, 2, 1),(20, 1126, 1, 4, 1),(20, 1127, 1, 2, 1),(20, 1128, 1, 4, 1),(20, 1129, 1, 2, 1),(20, 1130, 1, 4, 1),(20, 1131, 1, 2, 1),(20, 1132, 1, 4, 1),(20, 1133, 1, 2, 1),(20, 1134, 1, 4, 1),(20, 1135, 1, 2, 1),(20, 1136, 1, 4, 1),(20, 1137, 1, 2, 1),(20, 1138, 1, 4, 1),(20, 1139, 1, 2, 1),(20, 1140, 1, 4, 1),(20, 1141, 1, 2, 1),(20, 1142, 1, 4, 1),(20, 1143, 1, 2, 1),(20, 1144, 1, 4, 1),(20, 1145, 1, 2, 1),(20, 1146, 1, 4, 1),(20, 1147, 1, 2, 1),(20, 1148, 1, 4, 1),(20, 1149, 1, 2, 1),(20, 1150, 1, 4, 1),(20, 1151, 1, 2, 1),(20, 1152, 1, 4, 1),(20, 1153, 1, 1, 1),(20, 1154, 1, 3, 1),(20, 1155, 1, 1, 1),(20, 1156, 1, 3, 1),(20, 1157, 1, 1, 1),(20, 1158, 1, 3, 1),(20, 1159, 1, 1, 1),(20, 1160, 1, 3, 1),(20, 1161, 1, 1, 1),(20, 1162, 1, 3, 1),(20, 1163, 1, 1, 1),(20, 1164, 1, 3, 1),(20, 1165, 1, 1, 1),(20, 1166, 1, 3, 1),(20, 1167, 1, 1, 1),(20, 1168, 1, 3, 1),(20, 1169, 1, 1, 1),(20, 1170, 1, 3, 1),(20, 1171, 1, 1, 1),(20, 1172, 1, 3, 1),(20, 1173, 1, 1, 1),(20, 1174, 1, 3, 1),(20, 1175, 1, 1, 1),(20, 1176, 1, 3, 1),(20, 1177, 1, 1, 1),(20, 1178, 1, 3, 1),(20, 1179, 1, 1, 1),(20, 1180, 1, 3, 1),(20, 1181, 1, 1, 1),(20, 1182, 1, 3, 1),(20, 1183, 1, 1, 1),(20, 1184, 1, 3, 1),(20, 1185, 1, 2, 1),(20, 1186, 1, 4, 1),(20, 1187, 1, 2, 1),(20, 1188, 1, 4, 1),(20, 1189, 1, 2, 1),(20, 1190, 1, 4, 1),(20, 1191, 1, 2, 1),(20, 1192, 1, 4, 1),(20, 1193, 1, 2, 1),(20, 1194, 1, 4, 1),(20, 1195, 1, 2, 1),(20, 1196, 1, 4, 1),(20, 1197, 1, 2, 1),(20, 1198, 1, 4, 1),(20, 1199, 1, 2, 1),(20, 1200, 1, 4, 1),(20, 1201, 1, 2, 1),(20, 1202, 1, 4, 1),(20, 1203, 1, 2, 1),(20, 1204, 1, 4, 1),(20, 1205, 1, 2, 1),(20, 1206, 1, 4, 1),(20, 1207, 1, 2, 1),(20, 1208, 1, 4, 1),(20, 1209, 1, 2, 1),(20, 1210, 1, 4, 1),(20, 1211, 1, 2, 1),(20, 1212, 1, 4, 1),(20, 1213, 1, 2, 1),(20, 1214, 1, 4, 1),(20, 1215, 1, 2, 1),(20, 1216, 1, 4, 1),(20, 1217, 1, 1, 1),(20, 1218, 1, 3, 1),(20, 1219, 1, 1, 1),(20, 1220, 1, 3, 1),(20, 1221, 1, 1, 1),(20, 1222, 1, 3, 1),(20, 1223, 1, 1, 1),(20, 1224, 1, 3, 1),(20, 1225, 1, 1, 1),(20, 1226, 1, 3, 1),(20, 1227, 1, 1, 1),(20, 1228, 1, 3, 1),(20, 1229, 1, 1, 1),(20, 1230, 1, 3, 1),(20, 1231, 1, 1, 1),(20, 1232, 1, 3, 1),(20, 1233, 1, 1, 1),(20, 1234, 1, 3, 1),(20, 1235, 1, 1, 1),(20, 1236, 1, 3, 1),(20, 1237, 1, 1, 1),(20, 1238, 1, 3, 1),(20, 1239, 1, 1, 1),(20, 1240, 1, 3, 1),(20, 1241, 1, 1, 1),(20, 1242, 1, 3, 1),(20, 1243, 1, 1, 1),(20, 1244, 1, 3, 1),(20, 1245, 1, 1, 1),(20, 1246, 1, 3, 1),(20, 1247, 1, 1, 1),(20, 1248, 1, 3, 1),(20, 1249, 1, 2, 1),(20, 1250, 1, 4, 1),(20, 1251, 1, 2, 1),(20, 1252, 1, 4, 1),(20, 1253, 1, 2, 1),(20, 1254, 1, 4, 1),(20, 1255, 1, 2, 1),(20, 1256, 1, 4, 1),(20, 1257, 1, 2, 1),(20, 1258, 1, 4, 1),(20, 1259, 1, 2, 1),(20, 1260, 1, 4, 1),(20, 1261, 1, 2, 1),(20, 1262, 1, 4, 1),(20, 1263, 1, 2, 1),(20, 1264, 1, 4, 1),(20, 1265, 1, 2, 1),(20, 1266, 1, 4, 1),(20, 1267, 1, 2, 1),(20, 1268, 1, 4, 1),(20, 1269, 1, 2, 1),(20, 1270, 1, 4, 1),(20, 1271, 1, 2, 1),(20, 1272, 1, 4, 1),(20, 1273, 1, 2, 1),(20, 1274, 1, 4, 1),(20, 1275, 1, 2, 1),(20, 1276, 1, 4, 1),(20, 1277, 1, 2, 1),(20, 1278, 1, 4, 1),(20, 1279, 1, 2, 1),(20, 1280, 1, 4, 1),(20, 1281, 1, 1, 1),(20, 1282, 1, 3, 1),(20, 1283, 1, 1, 1),(20, 1284, 1, 3, 1),(20, 1285, 1, 1, 1),(20, 1286, 1, 3, 1),(20, 1287, 1, 1, 1),(20, 1288, 1, 3, 1),(20, 1289, 1, 1, 1),(20, 1290, 1, 3, 1),(20, 1291, 1, 1, 1),(20, 1292, 1, 3, 1),(20, 1293, 1, 1, 1),(20, 1294, 1, 3, 1),(20, 1295, 1, 1, 1),(20, 1296, 1, 3, 1),(20, 1297, 1, 1, 1),(20, 1298, 1, 3, 1),(20, 1299, 1, 1, 1),(20, 1300, 1, 3, 1),(20, 1301, 1, 1, 1),(20, 1302, 1, 3, 1),(20, 1303, 1, 1, 1),(20, 1304, 1, 3, 1),(20, 1305, 1, 1, 1),(20, 1306, 1, 3, 1),(20, 1307, 1, 1, 1),(20, 1308, 1, 3, 1),(20, 1309, 1, 1, 1),(20, 1310, 1, 3, 1),(20, 1311, 1, 1, 1),(20, 1312, 1, 3, 1),(20, 1313, 1, 2, 1),(20, 1314, 1, 4, 1),(20, 1315, 1, 2, 1),(20, 1316, 1, 4, 1),(20, 1317, 1, 2, 1),(20, 1318, 1, 4, 1),(20, 1319, 1, 2, 1),(20, 1320, 1, 4, 1),(20, 1321, 1, 2, 1),(20, 1322, 1, 4, 1),(20, 1323, 1, 2, 1),(20, 1324, 1, 4, 1),(20, 1325, 1, 2, 1),(20, 1326, 1, 4, 1),(20, 1327, 1, 2, 1),(20, 1328, 1, 4, 1),(20, 1329, 1, 2, 1),(20, 1330, 1, 4, 1),(20, 1331, 1, 2, 1),(20, 1332, 1, 4, 1),(20, 1333, 1, 2, 1),(20, 1334, 1, 4, 1),(20, 1335, 1, 2, 1),(20, 1336, 1, 4, 1),(20, 1337, 1, 2, 1),(20, 1338, 1, 4, 1),(20, 1339, 1, 2, 1),(20, 1340, 1, 4, 1),(20, 1341, 1, 2, 1),(20, 1342, 1, 4, 1),(20, 1343, 1, 2, 1),(20, 1344, 1, 4, 1),(20, 1345, 1, 1, 1),(20, 1346, 1, 3, 1),(20, 1347, 1, 1, 1),(20, 1348, 1, 3, 1),(20, 1349, 1, 1, 1),(20, 1350, 1, 3, 1),(20, 1351, 1, 1, 1),(20, 1352, 1, 3, 1),(20, 1353, 1, 1, 1),(20, 1354, 1, 3, 1),(20, 1355, 1, 1, 1),(20, 1356, 1, 3, 1),(20, 1357, 1, 1, 1),(20, 1358, 1, 3, 1),(20, 1359, 1, 1, 1),(20, 1360, 1, 3, 1),(20, 1361, 1, 1, 1),(20, 1362, 1, 3, 1),(20, 1363, 1, 1, 1),(20, 1364, 1, 3, 1),(20, 1365, 1, 1, 1),(20, 1366, 1, 3, 1),(20, 1367, 1, 1, 1),(20, 1368, 1, 3, 1),(20, 1369, 1, 1, 1),(20, 1370, 1, 3, 1),(20, 1371, 1, 1, 1),(20, 1372, 1, 3, 1),(20, 1373, 1, 1, 1),(20, 1374, 1, 3, 1),(20, 1375, 1, 1, 1),(20, 1376, 1, 3, 1),(20, 1377, 1, 2, 1),(20, 1378, 1, 4, 1),(20, 1379, 1, 2, 1),(20, 1380, 1, 4, 1),(20, 1381, 1, 2, 1),(20, 1382, 1, 4, 1),(20, 1383, 1, 2, 1),(20, 1384, 1, 4, 1),(20, 1385, 1, 2, 1),(20, 1386, 1, 4, 1),(20, 1387, 1, 2, 1),(20, 1388, 1, 4, 1),(20, 1389, 1, 2, 1),(20, 1390, 1, 4, 1),(20, 1391, 1, 2, 1),(20, 1392, 1, 4, 1),(20, 1393, 1, 2, 1),(20, 1394, 1, 4, 1),(20, 1395, 1, 2, 1),(20, 1396, 1, 4, 1),(20, 1397, 1, 2, 1),(20, 1398, 1, 4, 1),(20, 1399, 1, 2, 1),(20, 1400, 1, 4, 1),(20, 1401, 1, 2, 1),(20, 1402, 1, 4, 1),(20, 1403, 1, 2, 1),(20, 1404, 1, 4, 1),(20, 1405, 1, 2, 1),(20, 1406, 1, 4, 1),(20, 1407, 1, 2, 1),(20, 1408, 1, 4, 1),(20, 1409, 1, 1, 1),(20, 1410, 1, 3, 1),(20, 1411, 1, 1, 1),(20, 1412, 1, 3, 1),(20, 1413, 1, 1, 1),(20, 1414, 1, 3, 1),(20, 1415, 1, 1, 1),(20, 1416, 1, 3, 1),(20, 1417, 1, 1, 1),(20, 1418, 1, 3, 1),(20, 1419, 1, 1, 1),(20, 1420, 1, 3, 1),(20, 1421, 1, 1, 1),(20, 1422, 1, 3, 1),(20, 1423, 1, 1, 1),(20, 1424, 1, 3, 1),(20, 1425, 1, 1, 1),(20, 1426, 1, 3, 1),(20, 1427, 1, 1, 1),(20, 1428, 1, 3, 1),(20, 1429, 1, 1, 1),(20, 1430, 1, 3, 1),(20, 1431, 1, 1, 1),(20, 1432, 1, 3, 1),(20, 1433, 1, 1, 1),(20, 1434, 1, 3, 1),(20, 1435, 1, 1, 1),(20, 1436, 1, 3, 1),(20, 1437, 1, 1, 1),(20, 1438, 1, 3, 1),(20, 1439, 1, 1, 1),(20, 1440, 1, 3, 1),(20, 1441, 1, 2, 1),(20, 1442, 1, 4, 1),(20, 1443, 1, 2, 1),(20, 1444, 1, 4, 1),(20, 1445, 1, 2, 1),(20, 1446, 1, 4, 1),(20, 1447, 1, 2, 1),(20, 1448, 1, 4, 1),(20, 1449, 1, 2, 1),(20, 1450, 1, 4, 1),(20, 1451, 1, 2, 1),(20, 1452, 1, 4, 1),(20, 1453, 1, 2, 1),(20, 1454, 1, 4, 1),(20, 1455, 1, 2, 1),(20, 1456, 1, 4, 1),(20, 1457, 1, 2, 1),(20, 1458, 1, 4, 1),(20, 1459, 1, 2, 1),(20, 1460, 1, 4, 1),(20, 1461, 1, 2, 1),(20, 1462, 1, 4, 1),(20, 1463, 1, 2, 1),(20, 1464, 1, 4, 1),(20, 1465, 1, 2, 1),(20, 1466, 1, 4, 1),(20, 1467, 1, 2, 1),(20, 1468, 1, 4, 1),(20, 1469, 1, 2, 1),(20, 1470, 1, 4, 1),(20, 1471, 1, 2, 1),(20, 1472, 1, 4, 1),(20, 1473, 2, 1, 1),(20, 1474, 2, 3, 1),(20, 1475, 2, 1, 1),(20, 1476, 2, 3, 1),(20, 1477, 2, 1, 1),(20, 1478, 2, 3, 1),(20, 1479, 2, 1, 1),(20, 1480, 2, 3, 1),(20, 1481, 2, 1, 1),(20, 1482, 2, 3, 1),(20, 1483, 2, 1, 1),(20, 1484, 2, 3, 1),(20, 1485, 2, 1, 1),(20, 1486, 2, 3, 1),(20, 1487, 2, 1, 1),(20, 1488, 2, 3, 1),(20, 1489, 3, 1, 1),(20, 1490, 3, 3, 1),(20, 1491, 3, 1, 1),(20, 1492, 3, 3, 1),(20, 1493, 3, 1, 1),(20, 1494, 3, 3, 1),(20, 1495, 3, 1, 1),(20, 1496, 3, 3, 1),(20, 1497, 4, 1, 1),(20, 1498, 4, 3, 1),(20, 1499, 4, 1, 1),(20, 1500, 4, 3, 1),(20, 1501, 4, 1, 1),(20, 1502, 4, 3, 1),(20, 1503, 4, 1, 1),(20, 1504, 4, 3, 1),(20, 1505, 2, 2, 1),(20, 1506, 2, 4, 1),(20, 1507, 2, 2, 1),(20, 1508, 2, 4, 1),(20, 1509, 2, 2, 1),(20, 1510, 2, 4, 1),(20, 1511, 2, 2, 1),(20, 1512, 2, 4, 1),(20, 1513, 2, 2, 1),(20, 1514, 2, 4, 1),(20, 1515, 2, 2, 1),(20, 1516, 2, 4, 1),(20, 1517, 2, 2, 1),(20, 1518, 2, 4, 1),(20, 1519, 2, 2, 1),(20, 1520, 2, 4, 1),(20, 1521, 3, 2, 1),(20, 1522, 3, 4, 1),(20, 1523, 3, 2, 1),(20, 1524, 3, 4, 1),(20, 1525, 3, 2, 1),(20, 1526, 3, 4, 1),(20, 1527, 3, 2, 1),(20, 1528, 3, 4, 1),(20, 1529, 4, 2, 1),(20, 1530, 4, 4, 1),(20, 1531, 4, 2, 1),(20, 1532, 4, 4, 1),(20, 1533, 4, 2, 1),(20, 1534, 4, 4, 1),(20, 1535, 4, 2, 1),(20, 1536, 4, 4, 1),(21, 1, 1, 1, 1),(21, 2, 1, 2, 1),(21, 3, 1, 1, 1),(21, 4, 1, 2, 1),(21, 5, 1, 1, 1),(21, 6, 1, 2, 1),(21, 7, 1, 1, 1),(21, 8, 1, 2, 1),(21, 9, 1, 1, 1),(21, 10, 1, 2, 1),(21, 11, 1, 1, 1),(21, 12, 1, 2, 1),(21, 13, 1, 1, 1),(21, 14, 1, 2, 1),(21, 15, 1, 1, 1),(21, 16, 1, 2, 1),(21, 17, 1, 1, 1),(21, 18, 1, 2, 1),(21, 19, 1, 1, 1),(21, 20, 1, 2, 1),(21, 21, 1, 1, 1),(21, 22, 1, 2, 1),(21, 23, 1, 1, 1),(21, 24, 1, 2, 1),(21, 25, 1, 1, 1),(21, 26, 1, 2, 1),(21, 27, 1, 1, 1),(21, 28, 1, 2, 1),(21, 29, 1, 1, 1),(21, 30, 1, 2, 1),(21, 31, 1, 1, 1),(21, 32, 1, 2, 1),(21, 33, 1, 1, 2),(21, 34, 1, 2, 2),(21, 35, 1, 1, 2),(21, 36, 1, 2, 2),(21, 37, 1, 1, 2),(21, 38, 1, 2, 2),(21, 39, 1, 1, 2),(21, 40, 1, 2, 2),(21, 41, 1, 1, 2),(21, 42, 1, 2, 2),(21, 43, 1, 1, 2),(21, 44, 1, 2, 2),(21, 45, 1, 1, 2),(21, 46, 1, 2, 2),(21, 47, 1, 1, 2),(21, 48, 1, 2, 2),(21, 49, 1, 1, 2),(21, 50, 1, 2, 2),(21, 51, 1, 1, 2),(21, 52, 1, 2, 2),(21, 53, 1, 1, 2),(21, 54, 1, 2, 2),(21, 55, 1, 1, 2),(21, 56, 1, 2, 2),(21, 57, 1, 1, 2),(21, 58, 1, 2, 2),(21, 59, 1, 1, 2),(21, 60, 1, 2, 2),(21, 61, 1, 1, 2),(21, 62, 1, 2, 2),(21, 63, 1, 1, 2),(21, 64, 1, 2, 2),(21, 65, 1, 1, 1),(21, 66, 1, 2, 1),(21, 67, 1, 1, 1),(21, 68, 1, 2, 1),(21, 69, 1, 1, 1),(21, 70, 1, 2, 1),(21, 71, 1, 1, 1),(21, 72, 1, 2, 1),(21, 73, 1, 1, 1),(21, 74, 1, 2, 1),(21, 75, 1, 1, 1),(21, 76, 1, 2, 1),(21, 77, 1, 1, 1),(21, 78, 1, 2, 1),(21, 79, 1, 1, 1),(21, 80, 1, 2, 1),(21, 81, 1, 1, 1),(21, 82, 1, 2, 1),(21, 83, 1, 1, 1),(21, 84, 1, 2, 1),(21, 85, 1, 1, 1),(21, 86, 1, 2, 1),(21, 87, 1, 1, 1),(21, 88, 1, 2, 1),(21, 89, 1, 1, 1),(21, 90, 1, 2, 1),(21, 91, 1, 1, 1),(21, 92, 1, 2, 1),(21, 93, 1, 1, 1),(21, 94, 1, 2, 1),(21, 95, 1, 1, 1),(21, 96, 1, 2, 1),(21, 97, 1, 1, 2),(21, 98, 1, 2, 2),(21, 99, 1, 1, 2),(21, 100, 1, 2, 2),(21, 101, 1, 1, 2),(21, 102, 1, 2, 2),(21, 103, 1, 1, 2),(21, 104, 1, 2, 2),(21, 105, 1, 1, 2),(21, 106, 1, 2, 2),(21, 107, 1, 1, 2),(21, 108, 1, 2, 2),(21, 109, 1, 1, 2),(21, 110, 1, 2, 2),(21, 111, 1, 1, 2),(21, 112, 1, 2, 2),(21, 113, 1, 1, 2),(21, 114, 1, 2, 2),(21, 115, 1, 1, 2),(21, 116, 1, 2, 2),(21, 117, 1, 1, 2),(21, 118, 1, 2, 2),(21, 119, 1, 1, 2),(21, 120, 1, 2, 2),(21, 121, 1, 1, 2),(21, 122, 1, 2, 2),(21, 123, 1, 1, 2),(21, 124, 1, 2, 2),(21, 125, 1, 1, 2),(21, 126, 1, 2, 2),(21, 127, 1, 1, 2),(21, 128, 1, 2, 2),(21, 129, 1, 1, 1),(21, 130, 1, 2, 1),(21, 131, 1, 1, 1),(21, 132, 1, 2, 1),(21, 133, 1, 1, 1),(21, 134, 1, 2, 1),(21, 135, 1, 1, 1),(21, 136, 1, 2, 1),(21, 137, 1, 1, 1),(21, 138, 1, 2, 1),(21, 139, 1, 1, 1),(21, 140, 1, 2, 1),(21, 141, 1, 1, 1),(21, 142, 1, 2, 1),(21, 143, 1, 1, 1),(21, 144, 1, 2, 1),(21, 145, 1, 1, 1),(21, 146, 1, 2, 1),(21, 147, 1, 1, 1),(21, 148, 1, 2, 1),(21, 149, 1, 1, 1),(21, 150, 1, 2, 1),(21, 151, 1, 1, 1),(21, 152, 1, 2, 1),(21, 153, 1, 1, 1),(21, 154, 1, 2, 1),(21, 155, 1, 1, 1),(21, 156, 1, 2, 1),(21, 157, 1, 1, 1),(21, 158, 1, 2, 1),(21, 159, 1, 1, 1),(21, 160, 1, 2, 1),(21, 161, 1, 1, 2),(21, 162, 1, 2, 2),(21, 163, 1, 1, 2),(21, 164, 1, 2, 2),(21, 165, 1, 1, 2),(21, 166, 1, 2, 2),(21, 167, 1, 1, 2),(21, 168, 1, 2, 2),(21, 169, 1, 1, 2),(21, 170, 1, 2, 2),(21, 171, 1, 1, 2),(21, 172, 1, 2, 2),(21, 173, 1, 1, 2),(21, 174, 1, 2, 2),(21, 175, 1, 1, 2),(21, 176, 1, 2, 2),(21, 177, 1, 1, 2),(21, 178, 1, 2, 2),(21, 179, 1, 1, 2),(21, 180, 1, 2, 2),(21, 181, 1, 1, 2),(21, 182, 1, 2, 2),(21, 183, 1, 1, 2),(21, 184, 1, 2, 2),(21, 185, 1, 1, 2),(21, 186, 1, 2, 2),(21, 187, 1, 1, 2),(21, 188, 1, 2, 2),(21, 189, 1, 1, 2),(21, 190, 1, 2, 2),(21, 191, 1, 1, 2),(21, 192, 1, 2, 2),(21, 193, 1, 1, 1),(21, 194, 1, 2, 1),(21, 195, 1, 1, 1),(21, 196, 1, 2, 1),(21, 197, 1, 1, 1),(21, 198, 1, 2, 1),(21, 199, 1, 1, 1),(21, 200, 1, 2, 1),(21, 201, 1, 1, 1),(21, 202, 1, 2, 1),(21, 203, 1, 1, 1),(21, 204, 1, 2, 1),(21, 205, 1, 1, 1),(21, 206, 1, 2, 1),(21, 207, 1, 1, 1),(21, 208, 1, 2, 1),(21, 209, 1, 1, 1),(21, 210, 1, 2, 1),(21, 211, 1, 1, 1),(21, 212, 1, 2, 1),(21, 213, 1, 1, 1),(21, 214, 1, 2, 1),(21, 215, 1, 1, 1),(21, 216, 1, 2, 1),(21, 217, 1, 1, 1),(21, 218, 1, 2, 1),(21, 219, 1, 1, 1),(21, 220, 1, 2, 1),(21, 221, 1, 1, 1),(21, 222, 1, 2, 1),(21, 223, 1, 1, 1),(21, 224, 1, 2, 1),(21, 225, 1, 1, 2),(21, 226, 1, 2, 2),(21, 227, 1, 1, 2),(21, 228, 1, 2, 2),(21, 229, 1, 1, 2),(21, 230, 1, 2, 2),(21, 231, 1, 1, 2),(21, 232, 1, 2, 2),(21, 233, 1, 1, 2),(21, 234, 1, 2, 2),(21, 235, 1, 1, 2),(21, 236, 1, 2, 2),(21, 237, 1, 1, 2),(21, 238, 1, 2, 2),(21, 239, 1, 1, 2),(21, 240, 1, 2, 2),(21, 241, 1, 1, 2),(21, 242, 1, 2, 2),(21, 243, 1, 1, 2),(21, 244, 1, 2, 2),(21, 245, 1, 1, 2),(21, 246, 1, 2, 2),(21, 247, 1, 1, 2),(21, 248, 1, 2, 2),(21, 249, 1, 1, 2),(21, 250, 1, 2, 2),(21, 251, 1, 1, 2),(21, 252, 1, 2, 2),(21, 253, 1, 1, 2),(21, 254, 1, 2, 2),(21, 255, 1, 1, 2),(21, 256, 1, 2, 2),(21, 257, 1, 1, 1),(21, 258, 1, 2, 1),(21, 259, 1, 1, 1),(21, 260, 1, 2, 1),(21, 261, 1, 1, 1),(21, 262, 1, 2, 1),(21, 263, 1, 1, 1),(21, 264, 1, 2, 1),(21, 265, 1, 1, 1),(21, 266, 1, 2, 1),(21, 267, 1, 1, 1),(21, 268, 1, 2, 1),(21, 269, 1, 1, 1),(21, 270, 1, 2, 1),(21, 271, 1, 1, 1),(21, 272, 1, 2, 1),(21, 273, 1, 1, 1),(21, 274, 1, 2, 1),(21, 275, 1, 1, 1),(21, 276, 1, 2, 1),(21, 277, 1, 1, 1),(21, 278, 1, 2, 1),(21, 279, 1, 1, 1),(21, 280, 1, 2, 1),(21, 281, 1, 1, 1),(21, 282, 1, 2, 1),(21, 283, 1, 1, 1),(21, 284, 1, 2, 1),(21, 285, 1, 1, 1),(21, 286, 1, 2, 1),(21, 287, 1, 1, 1),(21, 288, 1, 2, 1),(21, 289, 1, 1, 2),(21, 290, 1, 2, 2),(21, 291, 1, 1, 2),(21, 292, 1, 2, 2),(21, 293, 1, 1, 2),(21, 294, 1, 2, 2),(21, 295, 1, 1, 2),(21, 296, 1, 2, 2),(21, 297, 1, 1, 2),(21, 298, 1, 2, 2),(21, 299, 1, 1, 2),(21, 300, 1, 2, 2),(21, 301, 1, 1, 2),(21, 302, 1, 2, 2),(21, 303, 1, 1, 2),(21, 304, 1, 2, 2),(21, 305, 1, 1, 2),(21, 306, 1, 2, 2),(21, 307, 1, 1, 2),(21, 308, 1, 2, 2),(21, 309, 1, 1, 2),(21, 310, 1, 2, 2),(21, 311, 1, 1, 2),(21, 312, 1, 2, 2),(21, 313, 1, 1, 2),(21, 314, 1, 2, 2),(21, 315, 1, 1, 2),(21, 316, 1, 2, 2),(21, 317, 1, 1, 2),(21, 318, 1, 2, 2),(21, 319, 1, 1, 2),(21, 320, 1, 2, 2),(21, 321, 1, 1, 1),(21, 322, 1, 2, 1),(21, 323, 1, 1, 1),(21, 324, 1, 2, 1),(21, 325, 1, 1, 1),(21, 326, 1, 2, 1),(21, 327, 1, 1, 1),(21, 328, 1, 2, 1),(21, 329, 1, 1, 1),(21, 330, 1, 2, 1),(21, 331, 1, 1, 1),(21, 332, 1, 2, 1),(21, 333, 1, 1, 1),(21, 334, 1, 2, 1),(21, 335, 1, 1, 1),(21, 336, 1, 2, 1),(21, 337, 1, 1, 1),(21, 338, 1, 2, 1),(21, 339, 1, 1, 1),(21, 340, 1, 2, 1),(21, 341, 1, 1, 1),(21, 342, 1, 2, 1),(21, 343, 1, 1, 1),(21, 344, 1, 2, 1),(21, 345, 1, 1, 1),(21, 346, 1, 2, 1),(21, 347, 1, 1, 1),(21, 348, 1, 2, 1),(21, 349, 1, 1, 1),(21, 350, 1, 2, 1),(21, 351, 1, 1, 1),(21, 352, 1, 2, 1),(21, 353, 1, 1, 2),(21, 354, 1, 2, 2),(21, 355, 1, 1, 2),(21, 356, 1, 2, 2),(21, 357, 1, 1, 2),(21, 358, 1, 2, 2),(21, 359, 1, 1, 2),(21, 360, 1, 2, 2),(21, 361, 1, 1, 2),(21, 362, 1, 2, 2),(21, 363, 1, 1, 2),(21, 364, 1, 2, 2),(21, 365, 1, 1, 2),(21, 366, 1, 2, 2),(21, 367, 1, 1, 2),(21, 368, 1, 2, 2),(21, 369, 1, 1, 2),(21, 370, 1, 2, 2),(21, 371, 1, 1, 2),(21, 372, 1, 2, 2),(21, 373, 1, 1, 2),(21, 374, 1, 2, 2),(21, 375, 1, 1, 2),(21, 376, 1, 2, 2),(21, 377, 1, 1, 2),(21, 378, 1, 2, 2),(21, 379, 1, 1, 2),(21, 380, 1, 2, 2),(21, 381, 1, 1, 2),(21, 382, 1, 2, 2),(21, 383, 1, 1, 2),(21, 384, 1, 2, 2),(21, 385, 1, 1, 1),(21, 386, 1, 2, 1),(21, 387, 1, 1, 1),(21, 388, 1, 2, 1),(21, 389, 1, 1, 1),(21, 390, 1, 2, 1),(21, 391, 1, 1, 1),(21, 392, 1, 2, 1),(21, 393, 1, 1, 1),(21, 394, 1, 2, 1),(21, 395, 1, 1, 1),(21, 396, 1, 2, 1),(21, 397, 1, 1, 1),(21, 398, 1, 2, 1),(21, 399, 1, 1, 1),(21, 400, 1, 2, 1),(21, 401, 1, 1, 1),(21, 402, 1, 2, 1),(21, 403, 1, 1, 1),(21, 404, 1, 2, 1),(21, 405, 1, 1, 1),(21, 406, 1, 2, 1),(21, 407, 1, 1, 1),(21, 408, 1, 2, 1),(21, 409, 1, 1, 1),(21, 410, 1, 2, 1),(21, 411, 1, 1, 1),(21, 412, 1, 2, 1),(21, 413, 1, 1, 1),(21, 414, 1, 2, 1),(21, 415, 1, 1, 1),(21, 416, 1, 2, 1),(21, 417, 1, 1, 2),(21, 418, 1, 2, 2),(21, 419, 1, 1, 2),(21, 420, 1, 2, 2),(21, 421, 1, 1, 2),(21, 422, 1, 2, 2),(21, 423, 1, 1, 2),(21, 424, 1, 2, 2),(21, 425, 1, 1, 2),(21, 426, 1, 2, 2),(21, 427, 1, 1, 2),(21, 428, 1, 2, 2),(21, 429, 1, 1, 2),(21, 430, 1, 2, 2),(21, 431, 1, 1, 2),(21, 432, 1, 2, 2),(21, 433, 1, 1, 2),(21, 434, 1, 2, 2),(21, 435, 1, 1, 2),(21, 436, 1, 2, 2),(21, 437, 1, 1, 2),(21, 438, 1, 2, 2),(21, 439, 1, 1, 2),(21, 440, 1, 2, 2),(21, 441, 1, 1, 2),(21, 442, 1, 2, 2),(21, 443, 1, 1, 2),(21, 444, 1, 2, 2),(21, 445, 1, 1, 2),(21, 446, 1, 2, 2),(21, 447, 1, 1, 2),(21, 448, 1, 2, 2),(21, 449, 1, 1, 1),(21, 450, 1, 2, 1),(21, 451, 1, 1, 1),(21, 452, 1, 2, 1),(21, 453, 1, 1, 1),(21, 454, 1, 2, 1),(21, 455, 1, 1, 1),(21, 456, 1, 2, 1),(21, 457, 1, 1, 1),(21, 458, 1, 2, 1),(21, 459, 1, 1, 1),(21, 460, 1, 2, 1),(21, 461, 1, 1, 1),(21, 462, 1, 2, 1),(21, 463, 1, 1, 1),(21, 464, 1, 2, 1),(21, 465, 1, 1, 1),(21, 466, 1, 2, 1),(21, 467, 1, 1, 1),(21, 468, 1, 2, 1),(21, 469, 1, 1, 1),(21, 470, 1, 2, 1),(21, 471, 1, 1, 1),(21, 472, 1, 2, 1),(21, 473, 1, 1, 1),(21, 474, 1, 2, 1),(21, 475, 1, 1, 1),(21, 476, 1, 2, 1),(21, 477, 1, 1, 1),(21, 478, 1, 2, 1),(21, 479, 1, 1, 1),(21, 480, 1, 2, 1),(21, 481, 1, 1, 2),(21, 482, 1, 2, 2),(21, 483, 1, 1, 2),(21, 484, 1, 2, 2),(21, 485, 1, 1, 2),(21, 486, 1, 2, 2),(21, 487, 1, 1, 2),(21, 488, 1, 2, 2),(21, 489, 1, 1, 2),(21, 490, 1, 2, 2),(21, 491, 1, 1, 2),(21, 492, 1, 2, 2),(21, 493, 1, 1, 2),(21, 494, 1, 2, 2),(21, 495, 1, 1, 2),(21, 496, 1, 2, 2),(21, 497, 1, 1, 2),(21, 498, 1, 2, 2),(21, 499, 1, 1, 2),(21, 500, 1, 2, 2),(21, 501, 1, 1, 2),(21, 502, 1, 2, 2),(21, 503, 1, 1, 2),(21, 504, 1, 2, 2),(21, 505, 1, 1, 2),(21, 506, 1, 2, 2),(21, 507, 1, 1, 2),(21, 508, 1, 2, 2),(21, 509, 1, 1, 2),(21, 510, 1, 2, 2),(21, 511, 1, 1, 2),(21, 512, 1, 2, 2),(21, 513, 1, 1, 1),(21, 514, 1, 2, 1),(21, 515, 1, 1, 1),(21, 516, 1, 2, 1),(21, 517, 1, 1, 1),(21, 518, 1, 2, 1),(21, 519, 1, 1, 1),(21, 520, 1, 2, 1),(21, 521, 1, 1, 1),(21, 522, 1, 2, 1),(21, 523, 1, 1, 1),(21, 524, 1, 2, 1),(21, 525, 1, 1, 1),(21, 526, 1, 2, 1),(21, 527, 1, 1, 1),(21, 528, 1, 2, 1),(21, 529, 1, 1, 1),(21, 530, 1, 2, 1),(21, 531, 1, 1, 1),(21, 532, 1, 2, 1),(21, 533, 1, 1, 1),(21, 534, 1, 2, 1),(21, 535, 1, 1, 1),(21, 536, 1, 2, 1),(21, 537, 1, 1, 1),(21, 538, 1, 2, 1),(21, 539, 1, 1, 1),(21, 540, 1, 2, 1),(21, 541, 1, 1, 1),(21, 542, 1, 2, 1),(21, 543, 1, 1, 1),(21, 544, 1, 2, 1),(21, 545, 1, 1, 2),(21, 546, 1, 2, 2),(21, 547, 1, 1, 2),(21, 548, 1, 2, 2),(21, 549, 1, 1, 2),(21, 550, 1, 2, 2),(21, 551, 1, 1, 2),(21, 552, 1, 2, 2),(21, 553, 1, 1, 2),(21, 554, 1, 2, 2),(21, 555, 1, 1, 2),(21, 556, 1, 2, 2),(21, 557, 1, 1, 2),(21, 558, 1, 2, 2),(21, 559, 1, 1, 2),(21, 560, 1, 2, 2),(21, 561, 1, 1, 2),(21, 562, 1, 2, 2),(21, 563, 1, 1, 2),(21, 564, 1, 2, 2),(21, 565, 1, 1, 2),(21, 566, 1, 2, 2),(21, 567, 1, 1, 2),(21, 568, 1, 2, 2),(21, 569, 1, 1, 2),(21, 570, 1, 2, 2),(21, 571, 1, 1, 2),(21, 572, 1, 2, 2),(21, 573, 1, 1, 2),(21, 574, 1, 2, 2),(21, 575, 1, 1, 2),(21, 576, 1, 2, 2),(21, 577, 1, 1, 1),(21, 578, 1, 2, 1),(21, 579, 1, 1, 1),(21, 580, 1, 2, 1),(21, 581, 1, 1, 1),(21, 582, 1, 2, 1),(21, 583, 1, 1, 1),(21, 584, 1, 2, 1),(21, 585, 1, 1, 1),(21, 586, 1, 2, 1),(21, 587, 1, 1, 1),(21, 588, 1, 2, 1),(21, 589, 1, 1, 1),(21, 590, 1, 2, 1),(21, 591, 1, 1, 1),(21, 592, 1, 2, 1),(21, 593, 1, 1, 1),(21, 594, 1, 2, 1),(21, 595, 1, 1, 1),(21, 596, 1, 2, 1),(21, 597, 1, 1, 1),(21, 598, 1, 2, 1),(21, 599, 1, 1, 1),(21, 600, 1, 2, 1),(21, 601, 1, 1, 1),(21, 602, 1, 2, 1),(21, 603, 1, 1, 1),(21, 604, 1, 2, 1),(21, 605, 1, 1, 1),(21, 606, 1, 2, 1),(21, 607, 1, 1, 1),(21, 608, 1, 2, 1),(21, 609, 1, 1, 2),(21, 610, 1, 2, 2),(21, 611, 1, 1, 2),(21, 612, 1, 2, 2),(21, 613, 1, 1, 2),(21, 614, 1, 2, 2),(21, 615, 1, 1, 2),(21, 616, 1, 2, 2),(21, 617, 1, 1, 2),(21, 618, 1, 2, 2),(21, 619, 1, 1, 2),(21, 620, 1, 2, 2),(21, 621, 1, 1, 2),(21, 622, 1, 2, 2),(21, 623, 1, 1, 2),(21, 624, 1, 2, 2),(21, 625, 1, 1, 2),(21, 626, 1, 2, 2),(21, 627, 1, 1, 2),(21, 628, 1, 2, 2),(21, 629, 1, 1, 2),(21, 630, 1, 2, 2),(21, 631, 1, 1, 2),(21, 632, 1, 2, 2),(21, 633, 1, 1, 2),(21, 634, 1, 2, 2),(21, 635, 1, 1, 2),(21, 636, 1, 2, 2),(21, 637, 1, 1, 2),(21, 638, 1, 2, 2),(21, 639, 1, 1, 2),(21, 640, 1, 2, 2),(21, 641, 1, 1, 1),(21, 642, 1, 2, 1),(21, 643, 1, 1, 1),(21, 644, 1, 2, 1),(21, 645, 1, 1, 1),(21, 646, 1, 2, 1),(21, 647, 1, 1, 1),(21, 648, 1, 2, 1),(21, 649, 1, 1, 1),(21, 650, 1, 2, 1),(21, 651, 1, 1, 1),(21, 652, 1, 2, 1),(21, 653, 1, 1, 1),(21, 654, 1, 2, 1),(21, 655, 1, 1, 1),(21, 656, 1, 2, 1),(21, 657, 1, 1, 1),(21, 658, 1, 2, 1),(21, 659, 1, 1, 1),(21, 660, 1, 2, 1),(21, 661, 1, 1, 1),(21, 662, 1, 2, 1),(21, 663, 1, 1, 1),(21, 664, 1, 2, 1),(21, 665, 1, 1, 1),(21, 666, 1, 2, 1),(21, 667, 1, 1, 1),(21, 668, 1, 2, 1),(21, 669, 1, 1, 1),(21, 670, 1, 2, 1),(21, 671, 1, 1, 1),(21, 672, 1, 2, 1),(21, 673, 1, 1, 2),(21, 674, 1, 2, 2),(21, 675, 1, 1, 2),(21, 676, 1, 2, 2),(21, 677, 1, 1, 2),(21, 678, 1, 2, 2),(21, 679, 1, 1, 2),(21, 680, 1, 2, 2),(21, 681, 1, 1, 2),(21, 682, 1, 2, 2),(21, 683, 1, 1, 2),(21, 684, 1, 2, 2),(21, 685, 1, 1, 2),(21, 686, 1, 2, 2),(21, 687, 1, 1, 2),(21, 688, 1, 2, 2),(21, 689, 1, 1, 2),(21, 690, 1, 2, 2),(21, 691, 1, 1, 2),(21, 692, 1, 2, 2),(21, 693, 1, 1, 2),(21, 694, 1, 2, 2),(21, 695, 1, 1, 2),(21, 696, 1, 2, 2),(21, 697, 1, 1, 2),(21, 698, 1, 2, 2),(21, 699, 1, 1, 2),(21, 700, 1, 2, 2),(21, 701, 1, 1, 2),(21, 702, 1, 2, 2),(21, 703, 1, 1, 2),(21, 704, 1, 2, 2),(21, 705, 1, 1, 1),(21, 706, 1, 2, 1),(21, 707, 1, 1, 1),(21, 708, 1, 2, 1),(21, 709, 1, 1, 1),(21, 710, 1, 2, 1),(21, 711, 1, 1, 1),(21, 712, 1, 2, 1),(21, 713, 1, 1, 1),(21, 714, 1, 2, 1),(21, 715, 1, 1, 1),(21, 716, 1, 2, 1),(21, 717, 1, 1, 1),(21, 718, 1, 2, 1),(21, 719, 1, 1, 1),(21, 720, 1, 2, 1),(21, 721, 1, 1, 1),(21, 722, 1, 2, 1),(21, 723, 1, 1, 1),(21, 724, 1, 2, 1),(21, 725, 1, 1, 1),(21, 726, 1, 2, 1),(21, 727, 1, 1, 1),(21, 728, 1, 2, 1),(21, 729, 1, 1, 1),(21, 730, 1, 2, 1),(21, 731, 1, 1, 1),(21, 732, 1, 2, 1),(21, 733, 1, 1, 1),(21, 734, 1, 2, 1),(21, 735, 1, 1, 1),(21, 736, 1, 2, 1),(21, 737, 1, 1, 2),(21, 738, 1, 2, 2),(21, 739, 1, 1, 2),(21, 740, 1, 2, 2),(21, 741, 1, 1, 2),(21, 742, 1, 2, 2),(21, 743, 1, 1, 2),(21, 744, 1, 2, 2),(21, 745, 1, 1, 2),(21, 746, 1, 2, 2),(21, 747, 1, 1, 2),(21, 748, 1, 2, 2),(21, 749, 1, 1, 2),(21, 750, 1, 2, 2),(21, 751, 1, 1, 2),(21, 752, 1, 2, 2),(21, 753, 1, 1, 2),(21, 754, 1, 2, 2),(21, 755, 1, 1, 2),(21, 756, 1, 2, 2),(21, 757, 1, 1, 2),(21, 758, 1, 2, 2),(21, 759, 1, 1, 2),(21, 760, 1, 2, 2),(21, 761, 1, 1, 2),(21, 762, 1, 2, 2),(21, 763, 1, 1, 2),(21, 764, 1, 2, 2),(21, 765, 1, 1, 2),(21, 766, 1, 2, 2),(21, 767, 1, 1, 2),(21, 768, 1, 2, 2),(21, 769, 1, 1, 1),(21, 770, 1, 2, 1),(21, 771, 1, 1, 1),(21, 772, 1, 2, 1),(21, 773, 1, 1, 1),(21, 774, 1, 2, 1),(21, 775, 1, 1, 1),(21, 776, 1, 2, 1),(21, 777, 1, 1, 1),(21, 778, 1, 2, 1),(21, 779, 1, 1, 1),(21, 780, 1, 2, 1),(21, 781, 1, 1, 1),(21, 782, 1, 2, 1),(21, 783, 1, 1, 1),(21, 784, 1, 2, 1),(21, 785, 1, 1, 1),(21, 786, 1, 2, 1),(21, 787, 1, 1, 1),(21, 788, 1, 2, 1),(21, 789, 1, 1, 1),(21, 790, 1, 2, 1),(21, 791, 1, 1, 1),(21, 792, 1, 2, 1),(21, 793, 1, 1, 1),(21, 794, 1, 2, 1),(21, 795, 1, 1, 1),(21, 796, 1, 2, 1),(21, 797, 1, 1, 1),(21, 798, 1, 2, 1),(21, 799, 1, 1, 1),(21, 800, 1, 2, 1),(21, 801, 1, 1, 2),(21, 802, 1, 2, 2),(21, 803, 1, 1, 2),(21, 804, 1, 2, 2),(21, 805, 1, 1, 2),(21, 806, 1, 2, 2),(21, 807, 1, 1, 2),(21, 808, 1, 2, 2),(21, 809, 1, 1, 2),(21, 810, 1, 2, 2),(21, 811, 1, 1, 2),(21, 812, 1, 2, 2),(21, 813, 1, 1, 2),(21, 814, 1, 2, 2),(21, 815, 1, 1, 2),(21, 816, 1, 2, 2),(21, 817, 1, 1, 2),(21, 818, 1, 2, 2),(21, 819, 1, 1, 2),(21, 820, 1, 2, 2),(21, 821, 1, 1, 2),(21, 822, 1, 2, 2),(21, 823, 1, 1, 2),(21, 824, 1, 2, 2),(21, 825, 1, 1, 2),(21, 826, 1, 2, 2),(21, 827, 1, 1, 2),(21, 828, 1, 2, 2),(21, 829, 1, 1, 2),(21, 830, 1, 2, 2),(21, 831, 1, 1, 2),(21, 832, 1, 2, 2),(21, 833, 1, 1, 1),(21, 834, 1, 2, 1),(21, 835, 1, 1, 1),(21, 836, 1, 2, 1),(21, 837, 1, 1, 1),(21, 838, 1, 2, 1),(21, 839, 1, 1, 1),(21, 840, 1, 2, 1),(21, 841, 1, 1, 1),(21, 842, 1, 2, 1),(21, 843, 1, 1, 1),(21, 844, 1, 2, 1),(21, 845, 1, 1, 1),(21, 846, 1, 2, 1),(21, 847, 1, 1, 1),(21, 848, 1, 2, 1),(21, 849, 1, 1, 1),(21, 850, 1, 2, 1),(21, 851, 1, 1, 1),(21, 852, 1, 2, 1),(21, 853, 1, 1, 1),(21, 854, 1, 2, 1),(21, 855, 1, 1, 1),(21, 856, 1, 2, 1),(21, 857, 1, 1, 1),(21, 858, 1, 2, 1),(21, 859, 1, 1, 1),(21, 860, 1, 2, 1),(21, 861, 1, 1, 1),(21, 862, 1, 2, 1),(21, 863, 1, 1, 1),(21, 864, 1, 2, 1),(21, 865, 1, 1, 2),(21, 866, 1, 2, 2),(21, 867, 1, 1, 2),(21, 868, 1, 2, 2),(21, 869, 1, 1, 2),(21, 870, 1, 2, 2),(21, 871, 1, 1, 2),(21, 872, 1, 2, 2),(21, 873, 1, 1, 2),(21, 874, 1, 2, 2),(21, 875, 1, 1, 2),(21, 876, 1, 2, 2),(21, 877, 1, 1, 2),(21, 878, 1, 2, 2),(21, 879, 1, 1, 2),(21, 880, 1, 2, 2),(21, 881, 1, 1, 2),(21, 882, 1, 2, 2),(21, 883, 1, 1, 2),(21, 884, 1, 2, 2),(21, 885, 1, 1, 2),(21, 886, 1, 2, 2),(21, 887, 1, 1, 2),(21, 888, 1, 2, 2),(21, 889, 1, 1, 2),(21, 890, 1, 2, 2),(21, 891, 1, 1, 2),(21, 892, 1, 2, 2),(21, 893, 1, 1, 2),(21, 894, 1, 2, 2),(21, 895, 1, 1, 2),(21, 896, 1, 2, 2),(21, 897, 1, 1, 1),(21, 898, 1, 2, 1),(21, 899, 1, 1, 1),(21, 900, 1, 2, 1),(21, 901, 1, 1, 1),(21, 902, 1, 2, 1),(21, 903, 1, 1, 1),(21, 904, 1, 2, 1),(21, 905, 1, 1, 1),(21, 906, 1, 2, 1),(21, 907, 1, 1, 1),(21, 908, 1, 2, 1),(21, 909, 1, 1, 1),(21, 910, 1, 2, 1),(21, 911, 1, 1, 1),(21, 912, 1, 2, 1),(21, 913, 1, 1, 1),(21, 914, 1, 2, 1),(21, 915, 1, 1, 1),(21, 916, 1, 2, 1),(21, 917, 1, 1, 1),(21, 918, 1, 2, 1),(21, 919, 1, 1, 1),(21, 920, 1, 2, 1),(21, 921, 1, 1, 1),(21, 922, 1, 2, 1),(21, 923, 1, 1, 1),(21, 924, 1, 2, 1),(21, 925, 1, 1, 1),(21, 926, 1, 2, 1),(21, 927, 1, 1, 1),(21, 928, 1, 2, 1),(21, 929, 1, 1, 2),(21, 930, 1, 2, 2),(21, 931, 1, 1, 2),(21, 932, 1, 2, 2),(21, 933, 1, 1, 2),(21, 934, 1, 2, 2),(21, 935, 1, 1, 2),(21, 936, 1, 2, 2),(21, 937, 1, 1, 2),(21, 938, 1, 2, 2),(21, 939, 1, 1, 2),(21, 940, 1, 2, 2),(21, 941, 1, 1, 2),(21, 942, 1, 2, 2),(21, 943, 1, 1, 2),(21, 944, 1, 2, 2),(21, 945, 1, 1, 2),(21, 946, 1, 2, 2),(21, 947, 1, 1, 2),(21, 948, 1, 2, 2),(21, 949, 1, 1, 2),(21, 950, 1, 2, 2),(21, 951, 1, 1, 2),(21, 952, 1, 2, 2),(21, 953, 1, 1, 2),(21, 954, 1, 2, 2),(21, 955, 1, 1, 2),(21, 956, 1, 2, 2),(21, 957, 1, 1, 2),(21, 958, 1, 2, 2),(21, 959, 1, 1, 2),(21, 960, 1, 2, 2),(21, 961, 1, 1, 1),(21, 962, 1, 2, 1),(21, 963, 1, 1, 1),(21, 964, 1, 2, 1),(21, 965, 1, 1, 1),(21, 966, 1, 2, 1),(21, 967, 1, 1, 1),(21, 968, 1, 2, 1),(21, 969, 1, 1, 1),(21, 970, 1, 2, 1),(21, 971, 1, 1, 1),(21, 972, 1, 2, 1),(21, 973, 1, 1, 1),(21, 974, 1, 2, 1),(21, 975, 1, 1, 1),(21, 976, 1, 2, 1),(21, 977, 1, 1, 1),(21, 978, 1, 2, 1),(21, 979, 1, 1, 1),(21, 980, 1, 2, 1),(21, 981, 1, 1, 1),(21, 982, 1, 2, 1),(21, 983, 1, 1, 1),(21, 984, 1, 2, 1),(21, 985, 1, 1, 1),(21, 986, 1, 2, 1),(21, 987, 1, 1, 1),(21, 988, 1, 2, 1),(21, 989, 1, 1, 1),(21, 990, 1, 2, 1),(21, 991, 1, 1, 1),(21, 992, 1, 2, 1),(21, 993, 1, 1, 2),(21, 994, 1, 2, 2),(21, 995, 1, 1, 2),(21, 996, 1, 2, 2),(21, 997, 1, 1, 2),(21, 998, 1, 2, 2),(21, 999, 1, 1, 2),(21, 1000, 1, 2, 2),(21, 1001, 1, 1, 2),(21, 1002, 1, 2, 2),(21, 1003, 1, 1, 2),(21, 1004, 1, 2, 2),(21, 1005, 1, 1, 2),(21, 1006, 1, 2, 2),(21, 1007, 1, 1, 2),(21, 1008, 1, 2, 2),(21, 1009, 1, 1, 2),(21, 1010, 1, 2, 2),(21, 1011, 1, 1, 2),(21, 1012, 1, 2, 2),(21, 1013, 1, 1, 2),(21, 1014, 1, 2, 2),(21, 1015, 1, 1, 2),(21, 1016, 1, 2, 2),(21, 1017, 1, 1, 2),(21, 1018, 1, 2, 2),(21, 1019, 1, 1, 2),(21, 1020, 1, 2, 2),(21, 1021, 1, 1, 2),(21, 1022, 1, 2, 2),(21, 1023, 1, 1, 2),(21, 1024, 1, 2, 2),(21, 1025, 1, 1, 1),(21, 1026, 1, 2, 1),(21, 1027, 1, 1, 1),(21, 1028, 1, 2, 1),(21, 1029, 1, 1, 1),(21, 1030, 1, 2, 1),(21, 1031, 1, 1, 1),(21, 1032, 1, 2, 1),(21, 1033, 1, 1, 1),(21, 1034, 1, 2, 1),(21, 1035, 1, 1, 1),(21, 1036, 1, 2, 1),(21, 1037, 1, 1, 1),(21, 1038, 1, 2, 1),(21, 1039, 1, 1, 1),(21, 1040, 1, 2, 1),(21, 1041, 1, 1, 1),(21, 1042, 1, 2, 1),(21, 1043, 1, 1, 1),(21, 1044, 1, 2, 1),(21, 1045, 1, 1, 1),(21, 1046, 1, 2, 1),(21, 1047, 1, 1, 1),(21, 1048, 1, 2, 1),(21, 1049, 1, 1, 1),(21, 1050, 1, 2, 1),(21, 1051, 1, 1, 1),(21, 1052, 1, 2, 1),(21, 1053, 1, 1, 1),(21, 1054, 1, 2, 1),(21, 1055, 1, 1, 1),(21, 1056, 1, 2, 1),(21, 1057, 1, 1, 2),(21, 1058, 1, 2, 2),(21, 1059, 1, 1, 2),(21, 1060, 1, 2, 2),(21, 1061, 1, 1, 2),(21, 1062, 1, 2, 2),(21, 1063, 1, 1, 2),(21, 1064, 1, 2, 2),(21, 1065, 1, 1, 2),(21, 1066, 1, 2, 2),(21, 1067, 1, 1, 2),(21, 1068, 1, 2, 2),(21, 1069, 1, 1, 2),(21, 1070, 1, 2, 2),(21, 1071, 1, 1, 2),(21, 1072, 1, 2, 2),(21, 1073, 1, 1, 2),(21, 1074, 1, 2, 2),(21, 1075, 1, 1, 2),(21, 1076, 1, 2, 2),(21, 1077, 1, 1, 2),(21, 1078, 1, 2, 2),(21, 1079, 1, 1, 2),(21, 1080, 1, 2, 2),(21, 1081, 1, 1, 2),(21, 1082, 1, 2, 2),(21, 1083, 1, 1, 2),(21, 1084, 1, 2, 2),(21, 1085, 1, 1, 2),(21, 1086, 1, 2, 2),(21, 1087, 1, 1, 2),(21, 1088, 1, 2, 2),(21, 1089, 1, 1, 1),(21, 1090, 1, 2, 1),(21, 1091, 1, 1, 1),(21, 1092, 1, 2, 1),(21, 1093, 1, 1, 1),(21, 1094, 1, 2, 1),(21, 1095, 1, 1, 1),(21, 1096, 1, 2, 1),(21, 1097, 1, 1, 1),(21, 1098, 1, 2, 1),(21, 1099, 1, 1, 1),(21, 1100, 1, 2, 1),(21, 1101, 1, 1, 1),(21, 1102, 1, 2, 1),(21, 1103, 1, 1, 1),(21, 1104, 1, 2, 1),(21, 1105, 1, 1, 1),(21, 1106, 1, 2, 1),(21, 1107, 1, 1, 1),(21, 1108, 1, 2, 1),(21, 1109, 1, 1, 1),(21, 1110, 1, 2, 1),(21, 1111, 1, 1, 1),(21, 1112, 1, 2, 1),(21, 1113, 1, 1, 1),(21, 1114, 1, 2, 1),(21, 1115, 1, 1, 1),(21, 1116, 1, 2, 1),(21, 1117, 1, 1, 1),(21, 1118, 1, 2, 1),(21, 1119, 1, 1, 1),(21, 1120, 1, 2, 1),(21, 1121, 1, 1, 2),(21, 1122, 1, 2, 2),(21, 1123, 1, 1, 2),(21, 1124, 1, 2, 2),(21, 1125, 1, 1, 2),(21, 1126, 1, 2, 2),(21, 1127, 1, 1, 2),(21, 1128, 1, 2, 2),(21, 1129, 1, 1, 2),(21, 1130, 1, 2, 2),(21, 1131, 1, 1, 2),(21, 1132, 1, 2, 2),(21, 1133, 1, 1, 2),(21, 1134, 1, 2, 2),(21, 1135, 1, 1, 2),(21, 1136, 1, 2, 2),(21, 1137, 1, 1, 2),(21, 1138, 1, 2, 2),(21, 1139, 1, 1, 2),(21, 1140, 1, 2, 2),(21, 1141, 1, 1, 2),(21, 1142, 1, 2, 2),(21, 1143, 1, 1, 2),(21, 1144, 1, 2, 2),(21, 1145, 1, 1, 2),(21, 1146, 1, 2, 2),(21, 1147, 1, 1, 2),(21, 1148, 1, 2, 2),(21, 1149, 1, 1, 2),(21, 1150, 1, 2, 2),(21, 1151, 1, 1, 2),(21, 1152, 1, 2, 2),(21, 1153, 1, 1, 1),(21, 1154, 1, 2, 1),(21, 1155, 1, 1, 1),(21, 1156, 1, 2, 1),(21, 1157, 1, 1, 1),(21, 1158, 1, 2, 1),(21, 1159, 1, 1, 1),(21, 1160, 1, 2, 1),(21, 1161, 1, 1, 1),(21, 1162, 1, 2, 1),(21, 1163, 1, 1, 1),(21, 1164, 1, 2, 1),(21, 1165, 1, 1, 1),(21, 1166, 1, 2, 1),(21, 1167, 1, 1, 1),(21, 1168, 1, 2, 1),(21, 1169, 1, 1, 1),(21, 1170, 1, 2, 1),(21, 1171, 1, 1, 1),(21, 1172, 1, 2, 1),(21, 1173, 1, 1, 1),(21, 1174, 1, 2, 1),(21, 1175, 1, 1, 1),(21, 1176, 1, 2, 1),(21, 1177, 1, 1, 1),(21, 1178, 1, 2, 1),(21, 1179, 1, 1, 1),(21, 1180, 1, 2, 1),(21, 1181, 1, 1, 1),(21, 1182, 1, 2, 1),(21, 1183, 1, 1, 1),(21, 1184, 1, 2, 1),(21, 1185, 1, 1, 2),(21, 1186, 1, 2, 2),(21, 1187, 1, 1, 2),(21, 1188, 1, 2, 2),(21, 1189, 1, 1, 2),(21, 1190, 1, 2, 2),(21, 1191, 1, 1, 2),(21, 1192, 1, 2, 2),(21, 1193, 1, 1, 2),(21, 1194, 1, 2, 2),(21, 1195, 1, 1, 2),(21, 1196, 1, 2, 2),(21, 1197, 1, 1, 2),(21, 1198, 1, 2, 2),(21, 1199, 1, 1, 2),(21, 1200, 1, 2, 2),(21, 1201, 1, 1, 2),(21, 1202, 1, 2, 2),(21, 1203, 1, 1, 2),(21, 1204, 1, 2, 2),(21, 1205, 1, 1, 2),(21, 1206, 1, 2, 2),(21, 1207, 1, 1, 2),(21, 1208, 1, 2, 2),(21, 1209, 1, 1, 2),(21, 1210, 1, 2, 2),(21, 1211, 1, 1, 2),(21, 1212, 1, 2, 2),(21, 1213, 1, 1, 2),(21, 1214, 1, 2, 2),(21, 1215, 1, 1, 2),(21, 1216, 1, 2, 2),(21, 1217, 1, 1, 1),(21, 1218, 1, 2, 1),(21, 1219, 1, 1, 1),(21, 1220, 1, 2, 1),(21, 1221, 1, 1, 1),(21, 1222, 1, 2, 1),(21, 1223, 1, 1, 1),(21, 1224, 1, 2, 1),(21, 1225, 1, 1, 1),(21, 1226, 1, 2, 1),(21, 1227, 1, 1, 1),(21, 1228, 1, 2, 1),(21, 1229, 1, 1, 1),(21, 1230, 1, 2, 1),(21, 1231, 1, 1, 1),(21, 1232, 1, 2, 1),(21, 1233, 1, 1, 1),(21, 1234, 1, 2, 1),(21, 1235, 1, 1, 1),(21, 1236, 1, 2, 1),(21, 1237, 1, 1, 1),(21, 1238, 1, 2, 1),(21, 1239, 1, 1, 1),(21, 1240, 1, 2, 1),(21, 1241, 1, 1, 1),(21, 1242, 1, 2, 1),(21, 1243, 1, 1, 1),(21, 1244, 1, 2, 1),(21, 1245, 1, 1, 1),(21, 1246, 1, 2, 1),(21, 1247, 1, 1, 1),(21, 1248, 1, 2, 1),(21, 1249, 1, 1, 2),(21, 1250, 1, 2, 2),(21, 1251, 1, 1, 2),(21, 1252, 1, 2, 2),(21, 1253, 1, 1, 2),(21, 1254, 1, 2, 2),(21, 1255, 1, 1, 2),(21, 1256, 1, 2, 2),(21, 1257, 1, 1, 2),(21, 1258, 1, 2, 2),(21, 1259, 1, 1, 2),(21, 1260, 1, 2, 2),(21, 1261, 1, 1, 2),(21, 1262, 1, 2, 2),(21, 1263, 1, 1, 2),(21, 1264, 1, 2, 2),(21, 1265, 1, 1, 2),(21, 1266, 1, 2, 2),(21, 1267, 1, 1, 2),(21, 1268, 1, 2, 2),(21, 1269, 1, 1, 2),(21, 1270, 1, 2, 2),(21, 1271, 1, 1, 2),(21, 1272, 1, 2, 2),(21, 1273, 1, 1, 2),(21, 1274, 1, 2, 2),(21, 1275, 1, 1, 2),(21, 1276, 1, 2, 2),(21, 1277, 1, 1, 2),(21, 1278, 1, 2, 2),(21, 1279, 1, 1, 2),(21, 1280, 1, 2, 2),(21, 1281, 1, 1, 1),(21, 1282, 1, 2, 1),(21, 1283, 1, 1, 1),(21, 1284, 1, 2, 1),(21, 1285, 1, 1, 1),(21, 1286, 1, 2, 1),(21, 1287, 1, 1, 1),(21, 1288, 1, 2, 1),(21, 1289, 1, 1, 1),(21, 1290, 1, 2, 1),(21, 1291, 1, 1, 1),(21, 1292, 1, 2, 1),(21, 1293, 1, 1, 1),(21, 1294, 1, 2, 1),(21, 1295, 1, 1, 1),(21, 1296, 1, 2, 1),(21, 1297, 1, 1, 1),(21, 1298, 1, 2, 1),(21, 1299, 1, 1, 1),(21, 1300, 1, 2, 1),(21, 1301, 1, 1, 1),(21, 1302, 1, 2, 1),(21, 1303, 1, 1, 1),(21, 1304, 1, 2, 1),(21, 1305, 1, 1, 1),(21, 1306, 1, 2, 1),(21, 1307, 1, 1, 1),(21, 1308, 1, 2, 1),(21, 1309, 1, 1, 1),(21, 1310, 1, 2, 1),(21, 1311, 1, 1, 1),(21, 1312, 1, 2, 1),(21, 1313, 1, 1, 2),(21, 1314, 1, 2, 2),(21, 1315, 1, 1, 2),(21, 1316, 1, 2, 2),(21, 1317, 1, 1, 2),(21, 1318, 1, 2, 2),(21, 1319, 1, 1, 2),(21, 1320, 1, 2, 2),(21, 1321, 1, 1, 2),(21, 1322, 1, 2, 2),(21, 1323, 1, 1, 2),(21, 1324, 1, 2, 2),(21, 1325, 1, 1, 2),(21, 1326, 1, 2, 2),(21, 1327, 1, 1, 2),(21, 1328, 1, 2, 2),(21, 1329, 1, 1, 2),(21, 1330, 1, 2, 2),(21, 1331, 1, 1, 2),(21, 1332, 1, 2, 2),(21, 1333, 1, 1, 2),(21, 1334, 1, 2, 2),(21, 1335, 1, 1, 2),(21, 1336, 1, 2, 2),(21, 1337, 1, 1, 2),(21, 1338, 1, 2, 2),(21, 1339, 1, 1, 2),(21, 1340, 1, 2, 2),(21, 1341, 1, 1, 2),(21, 1342, 1, 2, 2),(21, 1343, 1, 1, 2),(21, 1344, 1, 2, 2),(21, 1345, 1, 1, 1),(21, 1346, 1, 2, 1),(21, 1347, 1, 1, 1),(21, 1348, 1, 2, 1),(21, 1349, 1, 1, 1),(21, 1350, 1, 2, 1),(21, 1351, 1, 1, 1),(21, 1352, 1, 2, 1),(21, 1353, 1, 1, 1),(21, 1354, 1, 2, 1),(21, 1355, 1, 1, 1),(21, 1356, 1, 2, 1),(21, 1357, 1, 1, 1),(21, 1358, 1, 2, 1),(21, 1359, 1, 1, 1),(21, 1360, 1, 2, 1),(21, 1361, 1, 1, 1),(21, 1362, 1, 2, 1),(21, 1363, 1, 1, 1),(21, 1364, 1, 2, 1),(21, 1365, 1, 1, 1),(21, 1366, 1, 2, 1),(21, 1367, 1, 1, 1),(21, 1368, 1, 2, 1),(21, 1369, 1, 1, 1),(21, 1370, 1, 2, 1),(21, 1371, 1, 1, 1),(21, 1372, 1, 2, 1),(21, 1373, 1, 1, 1),(21, 1374, 1, 2, 1),(21, 1375, 1, 1, 1),(21, 1376, 1, 2, 1),(21, 1377, 1, 1, 2),(21, 1378, 1, 2, 2),(21, 1379, 1, 1, 2),(21, 1380, 1, 2, 2),(21, 1381, 1, 1, 2),(21, 1382, 1, 2, 2),(21, 1383, 1, 1, 2),(21, 1384, 1, 2, 2),(21, 1385, 1, 1, 2),(21, 1386, 1, 2, 2),(21, 1387, 1, 1, 2),(21, 1388, 1, 2, 2),(21, 1389, 1, 1, 2),(21, 1390, 1, 2, 2),(21, 1391, 1, 1, 2),(21, 1392, 1, 2, 2),(21, 1393, 1, 1, 2),(21, 1394, 1, 2, 2),(21, 1395, 1, 1, 2),(21, 1396, 1, 2, 2),(21, 1397, 1, 1, 2),(21, 1398, 1, 2, 2),(21, 1399, 1, 1, 2),(21, 1400, 1, 2, 2),(21, 1401, 1, 1, 2),(21, 1402, 1, 2, 2),(21, 1403, 1, 1, 2),(21, 1404, 1, 2, 2),(21, 1405, 1, 1, 2),(21, 1406, 1, 2, 2),(21, 1407, 1, 1, 2),(21, 1408, 1, 2, 2),(21, 1409, 1, 1, 1),(21, 1410, 1, 2, 1),(21, 1411, 1, 1, 1),(21, 1412, 1, 2, 1),(21, 1413, 1, 1, 1),(21, 1414, 1, 2, 1),(21, 1415, 1, 1, 1),(21, 1416, 1, 2, 1),(21, 1417, 1, 1, 1),(21, 1418, 1, 2, 1),(21, 1419, 1, 1, 1),(21, 1420, 1, 2, 1),(21, 1421, 1, 1, 1),(21, 1422, 1, 2, 1),(21, 1423, 1, 1, 1),(21, 1424, 1, 2, 1),(21, 1425, 1, 1, 1),(21, 1426, 1, 2, 1),(21, 1427, 1, 1, 1),(21, 1428, 1, 2, 1),(21, 1429, 1, 1, 1),(21, 1430, 1, 2, 1),(21, 1431, 1, 1, 1),(21, 1432, 1, 2, 1),(21, 1433, 1, 1, 1),(21, 1434, 1, 2, 1),(21, 1435, 1, 1, 1),(21, 1436, 1, 2, 1),(21, 1437, 1, 1, 1),(21, 1438, 1, 2, 1),(21, 1439, 1, 1, 1),(21, 1440, 1, 2, 1),(21, 1441, 1, 1, 2),(21, 1442, 1, 2, 2),(21, 1443, 1, 1, 2),(21, 1444, 1, 2, 2),(21, 1445, 1, 1, 2),(21, 1446, 1, 2, 2),(21, 1447, 1, 1, 2),(21, 1448, 1, 2, 2),(21, 1449, 1, 1, 2),(21, 1450, 1, 2, 2),(21, 1451, 1, 1, 2),(21, 1452, 1, 2, 2),(21, 1453, 1, 1, 2),(21, 1454, 1, 2, 2),(21, 1455, 1, 1, 2),(21, 1456, 1, 2, 2),(21, 1457, 1, 1, 2),(21, 1458, 1, 2, 2),(21, 1459, 1, 1, 2),(21, 1460, 1, 2, 2),(21, 1461, 1, 1, 2),(21, 1462, 1, 2, 2),(21, 1463, 1, 1, 2),(21, 1464, 1, 2, 2),(21, 1465, 1, 1, 2),(21, 1466, 1, 2, 2),(21, 1467, 1, 1, 2),(21, 1468, 1, 2, 2),(21, 1469, 1, 1, 2),(21, 1470, 1, 2, 2),(21, 1471, 1, 1, 2),(21, 1472, 1, 2, 2),(21, 1473, 2, 1, 1),(21, 1474, 2, 2, 1),(21, 1475, 2, 1, 1),(21, 1476, 2, 2, 1),(21, 1477, 2, 1, 1),(21, 1478, 2, 2, 1),(21, 1479, 2, 1, 1),(21, 1480, 2, 2, 1),(21, 1481, 2, 1, 1),(21, 1482, 2, 2, 1),(21, 1483, 2, 1, 1),(21, 1484, 2, 2, 1),(21, 1485, 2, 1, 1),(21, 1486, 2, 2, 1),(21, 1487, 2, 1, 1),(21, 1488, 2, 2, 1),(21, 1489, 3, 1, 1),(21, 1490, 3, 2, 1),(21, 1491, 3, 1, 1),(21, 1492, 3, 2, 1),(21, 1493, 3, 1, 1),(21, 1494, 3, 2, 1),(21, 1495, 3, 1, 1),(21, 1496, 3, 2, 1),(21, 1497, 4, 1, 1),(21, 1498, 4, 2, 1),(21, 1499, 4, 1, 1),(21, 1500, 4, 2, 1),(21, 1501, 4, 1, 1),(21, 1502, 4, 2, 1),(21, 1503, 4, 1, 1),(21, 1504, 4, 2, 1),(21, 1505, 2, 1, 2),(21, 1506, 2, 2, 2),(21, 1507, 2, 1, 2),(21, 1508, 2, 2, 2),(21, 1509, 2, 1, 2),(21, 1510, 2, 2, 2),(21, 1511, 2, 1, 2),(21, 1512, 2, 2, 2),(21, 1513, 2, 1, 2),(21, 1514, 2, 2, 2),(21, 1515, 2, 1, 2),(21, 1516, 2, 2, 2),(21, 1517, 2, 1, 2),(21, 1518, 2, 2, 2),(21, 1519, 2, 1, 2),(21, 1520, 2, 2, 2),(21, 1521, 3, 1, 2),(21, 1522, 3, 2, 2),(21, 1523, 3, 1, 2),(21, 1524, 3, 2, 2),(21, 1525, 3, 1, 2),(21, 1526, 3, 2, 2),(21, 1527, 3, 1, 2),(21, 1528, 3, 2, 2),(21, 1529, 4, 1, 2),(21, 1530, 4, 2, 2),(21, 1531, 4, 1, 2),(21, 1532, 4, 2, 2),(21, 1533, 4, 1, 2),(21, 1534, 4, 2, 2),(21, 1535, 4, 1, 2),(21, 1536, 4, 2, 2),(22, 1, 1, 1, 1),(22, 2, 1, 2, 1),(22, 3, 1, 1, 1),(22, 4, 1, 2, 1),(22, 5, 1, 1, 1),(22, 6, 1, 2, 1),(22, 7, 1, 1, 1),(22, 8, 1, 2, 1),(22, 9, 1, 1, 1),(22, 10, 1, 2, 1),(22, 11, 1, 1, 1),(22, 12, 1, 2, 1),(22, 13, 1, 1, 1),(22, 14, 1, 2, 1),(22, 15, 1, 1, 1),(22, 16, 1, 2, 1),(22, 17, 1, 1, 1),(22, 18, 1, 2, 1),(22, 19, 1, 1, 1),(22, 20, 1, 2, 1),(22, 21, 1, 1, 1),(22, 22, 1, 2, 1),(22, 23, 1, 1, 1),(22, 24, 1, 2, 1),(22, 25, 1, 1, 1),(22, 26, 1, 2, 1),(22, 27, 1, 1, 1),(22, 28, 1, 2, 1),(22, 29, 1, 1, 1),(22, 30, 1, 2, 1),(22, 31, 1, 1, 1),(22, 32, 1, 2, 1),(22, 33, 1, 1, 1),(22, 34, 1, 2, 1),(22, 35, 1, 1, 1),(22, 36, 1, 2, 1),(22, 37, 1, 1, 1),(22, 38, 1, 2, 1),(22, 39, 1, 1, 1),(22, 40, 1, 2, 1),(22, 41, 1, 1, 1),(22, 42, 1, 2, 1),(22, 43, 1, 1, 1),(22, 44, 1, 2, 1),(22, 45, 1, 1, 1),(22, 46, 1, 2, 1),(22, 47, 1, 1, 1),(22, 48, 1, 2, 1),(22, 49, 1, 1, 1),(22, 50, 1, 2, 1),(22, 51, 1, 1, 1),(22, 52, 1, 2, 1),(22, 53, 1, 1, 1),(22, 54, 1, 2, 1),(22, 55, 1, 1, 1),(22, 56, 1, 2, 1),(22, 57, 1, 1, 1),(22, 58, 1, 2, 1),(22, 59, 1, 1, 1),(22, 60, 1, 2, 1),(22, 61, 1, 1, 1),(22, 62, 1, 2, 1),(22, 63, 1, 1, 1),(22, 64, 1, 2, 1),(22, 65, 1, 1, 1),(22, 66, 1, 2, 1),(22, 67, 1, 1, 1),(22, 68, 1, 2, 1),(22, 69, 1, 1, 1),(22, 70, 1, 2, 1),(22, 71, 1, 1, 1),(22, 72, 1, 2, 1),(22, 73, 1, 1, 1),(22, 74, 1, 2, 1),(22, 75, 1, 1, 1),(22, 76, 1, 2, 1),(22, 77, 1, 1, 1),(22, 78, 1, 2, 1),(22, 79, 1, 1, 1),(22, 80, 1, 2, 1),(22, 81, 1, 1, 1),(22, 82, 1, 2, 1),(22, 83, 1, 1, 1),(22, 84, 1, 2, 1),(22, 85, 1, 1, 1),(22, 86, 1, 2, 1),(22, 87, 1, 1, 1),(22, 88, 1, 2, 1),(22, 89, 1, 1, 1),(22, 90, 1, 2, 1),(22, 91, 1, 1, 1),(22, 92, 1, 2, 1),(22, 93, 1, 1, 1),(22, 94, 1, 2, 1),(22, 95, 1, 1, 1),(22, 96, 1, 2, 1),(22, 97, 1, 1, 1),(22, 98, 1, 2, 1),(22, 99, 1, 1, 1),(22, 100, 1, 2, 1),(22, 101, 1, 1, 1),(22, 102, 1, 2, 1),(22, 103, 1, 1, 1),(22, 104, 1, 2, 1),(22, 105, 1, 1, 1),(22, 106, 1, 2, 1),(22, 107, 1, 1, 1),(22, 108, 1, 2, 1),(22, 109, 1, 1, 1),(22, 110, 1, 2, 1),(22, 111, 1, 1, 1),(22, 112, 1, 2, 1),(22, 113, 1, 1, 1),(22, 114, 1, 2, 1),(22, 115, 1, 1, 1),(22, 116, 1, 2, 1),(22, 117, 1, 1, 1),(22, 118, 1, 2, 1),(22, 119, 1, 1, 1),(22, 120, 1, 2, 1),(22, 121, 1, 1, 1),(22, 122, 1, 2, 1),(22, 123, 1, 1, 1),(22, 124, 1, 2, 1),(22, 125, 1, 1, 1),(22, 126, 1, 2, 1),(22, 127, 1, 1, 1),(22, 128, 1, 2, 1),(22, 129, 1, 1, 1),(22, 130, 1, 2, 1),(22, 131, 1, 1, 1),(22, 132, 1, 2, 1),(22, 133, 1, 1, 1),(22, 134, 1, 2, 1),(22, 135, 1, 1, 1),(22, 136, 1, 2, 1),(22, 137, 1, 1, 1),(22, 138, 1, 2, 1),(22, 139, 1, 1, 1),(22, 140, 1, 2, 1),(22, 141, 1, 1, 1),(22, 142, 1, 2, 1),(22, 143, 1, 1, 1),(22, 144, 1, 2, 1),(22, 145, 1, 1, 1),(22, 146, 1, 2, 1),(22, 147, 1, 1, 1),(22, 148, 1, 2, 1),(22, 149, 1, 1, 1),(22, 150, 1, 2, 1),(22, 151, 1, 1, 1),(22, 152, 1, 2, 1),(22, 153, 1, 1, 1),(22, 154, 1, 2, 1),(22, 155, 1, 1, 1),(22, 156, 1, 2, 1),(22, 157, 1, 1, 1),(22, 158, 1, 2, 1),(22, 159, 1, 1, 1),(22, 160, 1, 2, 1),(22, 161, 1, 1, 1),(22, 162, 1, 2, 1),(22, 163, 1, 1, 1),(22, 164, 1, 2, 1),(22, 165, 1, 1, 1),(22, 166, 1, 2, 1),(22, 167, 1, 1, 1),(22, 168, 1, 2, 1),(22, 169, 1, 1, 1),(22, 170, 1, 2, 1),(22, 171, 1, 1, 1),(22, 172, 1, 2, 1),(22, 173, 1, 1, 1),(22, 174, 1, 2, 1),(22, 175, 1, 1, 1),(22, 176, 1, 2, 1),(22, 177, 1, 1, 1),(22, 178, 1, 2, 1),(22, 179, 1, 1, 1),(22, 180, 1, 2, 1),(22, 181, 1, 1, 1),(22, 182, 1, 2, 1),(22, 183, 1, 1, 1),(22, 184, 1, 2, 1),(22, 185, 1, 1, 1),(22, 186, 1, 2, 1),(22, 187, 1, 1, 1),(22, 188, 1, 2, 1),(22, 189, 1, 1, 1),(22, 190, 1, 2, 1),(22, 191, 1, 1, 1),(22, 192, 1, 2, 1),(22, 193, 1, 1, 1),(22, 194, 1, 2, 1),(22, 195, 1, 1, 1),(22, 196, 1, 2, 1),(22, 197, 1, 1, 1),(22, 198, 1, 2, 1),(22, 199, 1, 1, 1),(22, 200, 1, 2, 1),(22, 201, 1, 1, 1),(22, 202, 1, 2, 1),(22, 203, 1, 1, 1),(22, 204, 1, 2, 1),(22, 205, 1, 1, 1),(22, 206, 1, 2, 1),(22, 207, 1, 1, 1),(22, 208, 1, 2, 1),(22, 209, 1, 1, 1),(22, 210, 1, 2, 1),(22, 211, 1, 1, 1),(22, 212, 1, 2, 1),(22, 213, 1, 1, 1),(22, 214, 1, 2, 1),(22, 215, 1, 1, 1),(22, 216, 1, 2, 1),(22, 217, 1, 1, 1),(22, 218, 1, 2, 1),(22, 219, 1, 1, 1),(22, 220, 1, 2, 1),(22, 221, 1, 1, 1),(22, 222, 1, 2, 1),(22, 223, 1, 1, 1),(22, 224, 1, 2, 1),(22, 225, 1, 1, 1),(22, 226, 1, 2, 1),(22, 227, 1, 1, 1),(22, 228, 1, 2, 1),(22, 229, 1, 1, 1),(22, 230, 1, 2, 1),(22, 231, 1, 1, 1),(22, 232, 1, 2, 1),(22, 233, 1, 1, 1),(22, 234, 1, 2, 1),(22, 235, 1, 1, 1),(22, 236, 1, 2, 1),(22, 237, 1, 1, 1),(22, 238, 1, 2, 1),(22, 239, 1, 1, 1),(22, 240, 1, 2, 1),(22, 241, 1, 1, 1),(22, 242, 1, 2, 1),(22, 243, 1, 1, 1),(22, 244, 1, 2, 1),(22, 245, 1, 1, 1),(22, 246, 1, 2, 1),(22, 247, 1, 1, 1),(22, 248, 1, 2, 1),(22, 249, 1, 1, 1),(22, 250, 1, 2, 1),(22, 251, 1, 1, 1),(22, 252, 1, 2, 1),(22, 253, 1, 1, 1),(22, 254, 1, 2, 1),(22, 255, 1, 1, 1),(22, 256, 1, 2, 1),(22, 257, 1, 1, 1),(22, 258, 1, 2, 1),(22, 259, 1, 1, 1),(22, 260, 1, 2, 1),(22, 261, 1, 1, 1),(22, 262, 1, 2, 1),(22, 263, 1, 1, 1),(22, 264, 1, 2, 1),(22, 265, 1, 1, 1),(22, 266, 1, 2, 1),(22, 267, 1, 1, 1),(22, 268, 1, 2, 1),(22, 269, 1, 1, 1),(22, 270, 1, 2, 1),(22, 271, 1, 1, 1),(22, 272, 1, 2, 1),(22, 273, 1, 1, 1),(22, 274, 1, 2, 1),(22, 275, 1, 1, 1),(22, 276, 1, 2, 1),(22, 277, 1, 1, 1),(22, 278, 1, 2, 1),(22, 279, 1, 1, 1),(22, 280, 1, 2, 1),(22, 281, 1, 1, 1),(22, 282, 1, 2, 1),(22, 283, 1, 1, 1),(22, 284, 1, 2, 1),(22, 285, 1, 1, 1),(22, 286, 1, 2, 1),(22, 287, 1, 1, 1),(22, 288, 1, 2, 1),(22, 289, 1, 1, 1),(22, 290, 1, 2, 1),(22, 291, 1, 1, 1),(22, 292, 1, 2, 1),(22, 293, 1, 1, 1),(22, 294, 1, 2, 1),(22, 295, 1, 1, 1),(22, 296, 1, 2, 1),(22, 297, 1, 1, 1),(22, 298, 1, 2, 1),(22, 299, 1, 1, 1),(22, 300, 1, 2, 1),(22, 301, 1, 1, 1),(22, 302, 1, 2, 1),(22, 303, 1, 1, 1),(22, 304, 1, 2, 1),(22, 305, 1, 1, 1),(22, 306, 1, 2, 1),(22, 307, 1, 1, 1),(22, 308, 1, 2, 1),(22, 309, 1, 1, 1),(22, 310, 1, 2, 1),(22, 311, 1, 1, 1),(22, 312, 1, 2, 1),(22, 313, 1, 1, 1),(22, 314, 1, 2, 1),(22, 315, 1, 1, 1),(22, 316, 1, 2, 1),(22, 317, 1, 1, 1),(22, 318, 1, 2, 1),(22, 319, 1, 1, 1),(22, 320, 1, 2, 1),(22, 321, 1, 1, 1),(22, 322, 1, 2, 1),(22, 323, 1, 1, 1),(22, 324, 1, 2, 1),(22, 325, 1, 1, 1),(22, 326, 1, 2, 1),(22, 327, 1, 1, 1),(22, 328, 1, 2, 1),(22, 329, 1, 1, 1),(22, 330, 1, 2, 1),(22, 331, 1, 1, 1),(22, 332, 1, 2, 1),(22, 333, 1, 1, 1),(22, 334, 1, 2, 1),(22, 335, 1, 1, 1),(22, 336, 1, 2, 1),(22, 337, 1, 1, 1),(22, 338, 1, 2, 1),(22, 339, 1, 1, 1),(22, 340, 1, 2, 1),(22, 341, 1, 1, 1),(22, 342, 1, 2, 1),(22, 343, 1, 1, 1),(22, 344, 1, 2, 1),(22, 345, 1, 1, 1),(22, 346, 1, 2, 1),(22, 347, 1, 1, 1),(22, 348, 1, 2, 1),(22, 349, 1, 1, 1),(22, 350, 1, 2, 1),(22, 351, 1, 1, 1),(22, 352, 1, 2, 1),(22, 353, 1, 1, 1),(22, 354, 1, 2, 1),(22, 355, 1, 1, 1),(22, 356, 1, 2, 1),(22, 357, 1, 1, 1),(22, 358, 1, 2, 1),(22, 359, 1, 1, 1),(22, 360, 1, 2, 1),(22, 361, 1, 1, 1),(22, 362, 1, 2, 1),(22, 363, 1, 1, 1),(22, 364, 1, 2, 1),(22, 365, 1, 1, 1),(22, 366, 1, 2, 1),(22, 367, 1, 1, 1),(22, 368, 1, 2, 1),(22, 369, 1, 1, 1),(22, 370, 1, 2, 1),(22, 371, 1, 1, 1),(22, 372, 1, 2, 1),(22, 373, 1, 1, 1),(22, 374, 1, 2, 1),(22, 375, 1, 1, 1),(22, 376, 1, 2, 1),(22, 377, 1, 1, 1),(22, 378, 1, 2, 1),(22, 379, 1, 1, 1),(22, 380, 1, 2, 1),(22, 381, 1, 1, 1),(22, 382, 1, 2, 1),(22, 383, 1, 1, 1),(22, 384, 1, 2, 1),(22, 385, 1, 1, 1),(22, 386, 1, 2, 1),(22, 387, 1, 1, 1),(22, 388, 1, 2, 1),(22, 389, 1, 1, 1),(22, 390, 1, 2, 1),(22, 391, 1, 1, 1),(22, 392, 1, 2, 1),(22, 393, 1, 1, 1),(22, 394, 1, 2, 1),(22, 395, 1, 1, 1),(22, 396, 1, 2, 1),(22, 397, 1, 1, 1),(22, 398, 1, 2, 1),(22, 399, 1, 1, 1),(22, 400, 1, 2, 1),(22, 401, 1, 1, 1),(22, 402, 1, 2, 1),(22, 403, 1, 1, 1),(22, 404, 1, 2, 1),(22, 405, 1, 1, 1),(22, 406, 1, 2, 1),(22, 407, 1, 1, 1),(22, 408, 1, 2, 1),(22, 409, 1, 1, 1),(22, 410, 1, 2, 1),(22, 411, 1, 1, 1),(22, 412, 1, 2, 1),(22, 413, 1, 1, 1),(22, 414, 1, 2, 1),(22, 415, 1, 1, 1),(22, 416, 1, 2, 1),(22, 417, 1, 1, 1),(22, 418, 1, 2, 1),(22, 419, 1, 1, 1),(22, 420, 1, 2, 1),(22, 421, 1, 1, 1),(22, 422, 1, 2, 1),(22, 423, 1, 1, 1),(22, 424, 1, 2, 1),(22, 425, 1, 1, 1),(22, 426, 1, 2, 1),(22, 427, 1, 1, 1),(22, 428, 1, 2, 1),(22, 429, 1, 1, 1),(22, 430, 1, 2, 1),(22, 431, 1, 1, 1),(22, 432, 1, 2, 1),(22, 433, 1, 1, 1),(22, 434, 1, 2, 1),(22, 435, 1, 1, 1),(22, 436, 1, 2, 1),(22, 437, 1, 1, 1),(22, 438, 1, 2, 1),(22, 439, 1, 1, 1),(22, 440, 1, 2, 1),(22, 441, 1, 1, 1),(22, 442, 1, 2, 1),(22, 443, 1, 1, 1),(22, 444, 1, 2, 1),(22, 445, 1, 1, 1),(22, 446, 1, 2, 1),(22, 447, 1, 1, 1),(22, 448, 1, 2, 1),(22, 449, 1, 1, 1),(22, 450, 1, 2, 1),(22, 451, 1, 1, 1),(22, 452, 1, 2, 1),(22, 453, 1, 1, 1),(22, 454, 1, 2, 1),(22, 455, 1, 1, 1),(22, 456, 1, 2, 1),(22, 457, 1, 1, 1),(22, 458, 1, 2, 1),(22, 459, 1, 1, 1),(22, 460, 1, 2, 1),(22, 461, 1, 1, 1),(22, 462, 1, 2, 1),(22, 463, 1, 1, 1),(22, 464, 1, 2, 1),(22, 465, 1, 1, 1),(22, 466, 1, 2, 1),(22, 467, 1, 1, 1),(22, 468, 1, 2, 1),(22, 469, 1, 1, 1),(22, 470, 1, 2, 1),(22, 471, 1, 1, 1),(22, 472, 1, 2, 1),(22, 473, 1, 1, 1),(22, 474, 1, 2, 1),(22, 475, 1, 1, 1),(22, 476, 1, 2, 1),(22, 477, 1, 1, 1),(22, 478, 1, 2, 1),(22, 479, 1, 1, 1),(22, 480, 1, 2, 1),(22, 481, 1, 1, 1),(22, 482, 1, 2, 1),(22, 483, 1, 1, 1),(22, 484, 1, 2, 1),(22, 485, 1, 1, 1),(22, 486, 1, 2, 1),(22, 487, 1, 1, 1),(22, 488, 1, 2, 1),(22, 489, 1, 1, 1),(22, 490, 1, 2, 1),(22, 491, 1, 1, 1),(22, 492, 1, 2, 1),(22, 493, 1, 1, 1),(22, 494, 1, 2, 1),(22, 495, 1, 1, 1),(22, 496, 1, 2, 1),(22, 497, 1, 1, 1),(22, 498, 1, 2, 1),(22, 499, 1, 1, 1),(22, 500, 1, 2, 1),(22, 501, 1, 1, 1),(22, 502, 1, 2, 1),(22, 503, 1, 1, 1),(22, 504, 1, 2, 1),(22, 505, 1, 1, 1),(22, 506, 1, 2, 1),(22, 507, 1, 1, 1),(22, 508, 1, 2, 1),(22, 509, 1, 1, 1),(22, 510, 1, 2, 1),(22, 511, 1, 1, 1),(22, 512, 1, 2, 1),(22, 513, 1, 1, 1),(22, 514, 1, 2, 1),(22, 515, 1, 1, 1),(22, 516, 1, 2, 1),(22, 517, 1, 1, 1),(22, 518, 1, 2, 1),(22, 519, 1, 1, 1),(22, 520, 1, 2, 1),(22, 521, 1, 1, 1),(22, 522, 1, 2, 1),(22, 523, 1, 1, 1),(22, 524, 1, 2, 1),(22, 525, 1, 1, 1),(22, 526, 1, 2, 1),(22, 527, 1, 1, 1),(22, 528, 1, 2, 1),(22, 529, 1, 1, 1),(22, 530, 1, 2, 1),(22, 531, 1, 1, 1),(22, 532, 1, 2, 1),(22, 533, 1, 1, 1),(22, 534, 1, 2, 1),(22, 535, 1, 1, 1),(22, 536, 1, 2, 1),(22, 537, 1, 1, 1),(22, 538, 1, 2, 1),(22, 539, 1, 1, 1),(22, 540, 1, 2, 1),(22, 541, 1, 1, 1),(22, 542, 1, 2, 1),(22, 543, 1, 1, 1),(22, 544, 1, 2, 1),(22, 545, 1, 1, 1),(22, 546, 1, 2, 1),(22, 547, 1, 1, 1),(22, 548, 1, 2, 1),(22, 549, 1, 1, 1),(22, 550, 1, 2, 1),(22, 551, 1, 1, 1),(22, 552, 1, 2, 1),(22, 553, 1, 1, 1),(22, 554, 1, 2, 1),(22, 555, 1, 1, 1),(22, 556, 1, 2, 1),(22, 557, 1, 1, 1),(22, 558, 1, 2, 1),(22, 559, 1, 1, 1),(22, 560, 1, 2, 1),(22, 561, 1, 1, 1),(22, 562, 1, 2, 1),(22, 563, 1, 1, 1),(22, 564, 1, 2, 1),(22, 565, 1, 1, 1),(22, 566, 1, 2, 1),(22, 567, 1, 1, 1),(22, 568, 1, 2, 1),(22, 569, 1, 1, 1),(22, 570, 1, 2, 1),(22, 571, 1, 1, 1),(22, 572, 1, 2, 1),(22, 573, 1, 1, 1),(22, 574, 1, 2, 1),(22, 575, 1, 1, 1),(22, 576, 1, 2, 1),(22, 577, 1, 1, 1),(22, 578, 1, 2, 1),(22, 579, 1, 1, 1),(22, 580, 1, 2, 1),(22, 581, 1, 1, 1),(22, 582, 1, 2, 1),(22, 583, 1, 1, 1),(22, 584, 1, 2, 1),(22, 585, 1, 1, 1),(22, 586, 1, 2, 1),(22, 587, 1, 1, 1),(22, 588, 1, 2, 1),(22, 589, 1, 1, 1),(22, 590, 1, 2, 1),(22, 591, 1, 1, 1),(22, 592, 1, 2, 1),(22, 593, 1, 1, 1),(22, 594, 1, 2, 1),(22, 595, 1, 1, 1),(22, 596, 1, 2, 1),(22, 597, 1, 1, 1),(22, 598, 1, 2, 1),(22, 599, 1, 1, 1),(22, 600, 1, 2, 1),(22, 601, 1, 1, 1),(22, 602, 1, 2, 1),(22, 603, 1, 1, 1),(22, 604, 1, 2, 1),(22, 605, 1, 1, 1),(22, 606, 1, 2, 1),(22, 607, 1, 1, 1),(22, 608, 1, 2, 1),(22, 609, 1, 1, 1),(22, 610, 1, 2, 1),(22, 611, 1, 1, 1),(22, 612, 1, 2, 1),(22, 613, 1, 1, 1),(22, 614, 1, 2, 1),(22, 615, 1, 1, 1),(22, 616, 1, 2, 1),(22, 617, 1, 1, 1),(22, 618, 1, 2, 1),(22, 619, 1, 1, 1),(22, 620, 1, 2, 1),(22, 621, 1, 1, 1),(22, 622, 1, 2, 1),(22, 623, 1, 1, 1),(22, 624, 1, 2, 1),(22, 625, 1, 1, 1),(22, 626, 1, 2, 1),(22, 627, 1, 1, 1),(22, 628, 1, 2, 1),(22, 629, 1, 1, 1),(22, 630, 1, 2, 1),(22, 631, 1, 1, 1),(22, 632, 1, 2, 1),(22, 633, 1, 1, 1),(22, 634, 1, 2, 1),(22, 635, 1, 1, 1),(22, 636, 1, 2, 1),(22, 637, 1, 1, 1),(22, 638, 1, 2, 1),(22, 639, 1, 1, 1),(22, 640, 1, 2, 1),(22, 641, 1, 1, 1),(22, 642, 1, 2, 1),(22, 643, 1, 1, 1),(22, 644, 1, 2, 1),(22, 645, 1, 1, 1),(22, 646, 1, 2, 1),(22, 647, 1, 1, 1),(22, 648, 1, 2, 1),(22, 649, 1, 1, 1),(22, 650, 1, 2, 1),(22, 651, 1, 1, 1),(22, 652, 1, 2, 1),(22, 653, 1, 1, 1),(22, 654, 1, 2, 1),(22, 655, 1, 1, 1),(22, 656, 1, 2, 1),(22, 657, 1, 1, 1),(22, 658, 1, 2, 1),(22, 659, 1, 1, 1),(22, 660, 1, 2, 1),(22, 661, 1, 1, 1),(22, 662, 1, 2, 1),(22, 663, 1, 1, 1),(22, 664, 1, 2, 1),(22, 665, 1, 1, 1),(22, 666, 1, 2, 1),(22, 667, 1, 1, 1),(22, 668, 1, 2, 1),(22, 669, 1, 1, 1),(22, 670, 1, 2, 1),(22, 671, 1, 1, 1),(22, 672, 1, 2, 1),(22, 673, 1, 1, 1),(22, 674, 1, 2, 1),(22, 675, 1, 1, 1),(22, 676, 1, 2, 1),(22, 677, 1, 1, 1),(22, 678, 1, 2, 1),(22, 679, 1, 1, 1),(22, 680, 1, 2, 1),(22, 681, 1, 1, 1),(22, 682, 1, 2, 1),(22, 683, 1, 1, 1),(22, 684, 1, 2, 1),(22, 685, 1, 1, 1),(22, 686, 1, 2, 1),(22, 687, 1, 1, 1),(22, 688, 1, 2, 1),(22, 689, 1, 1, 1),(22, 690, 1, 2, 1),(22, 691, 1, 1, 1),(22, 692, 1, 2, 1),(22, 693, 1, 1, 1),(22, 694, 1, 2, 1),(22, 695, 1, 1, 1),(22, 696, 1, 2, 1),(22, 697, 1, 1, 1),(22, 698, 1, 2, 1),(22, 699, 1, 1, 1),(22, 700, 1, 2, 1),(22, 701, 1, 1, 1),(22, 702, 1, 2, 1),(22, 703, 1, 1, 1),(22, 704, 1, 2, 1),(22, 705, 1, 1, 1),(22, 706, 1, 2, 1),(22, 707, 1, 1, 1),(22, 708, 1, 2, 1),(22, 709, 1, 1, 1),(22, 710, 1, 2, 1),(22, 711, 1, 1, 1),(22, 712, 1, 2, 1),(22, 713, 1, 1, 1),(22, 714, 1, 2, 1),(22, 715, 1, 1, 1),(22, 716, 1, 2, 1),(22, 717, 1, 1, 1),(22, 718, 1, 2, 1),(22, 719, 1, 1, 1),(22, 720, 1, 2, 1),(22, 721, 1, 1, 1),(22, 722, 1, 2, 1),(22, 723, 1, 1, 1),(22, 724, 1, 2, 1),(22, 725, 1, 1, 1),(22, 726, 1, 2, 1),(22, 727, 1, 1, 1),(22, 728, 1, 2, 1),(22, 729, 1, 1, 1),(22, 730, 1, 2, 1),(22, 731, 1, 1, 1),(22, 732, 1, 2, 1),(22, 733, 1, 1, 1),(22, 734, 1, 2, 1),(22, 735, 1, 1, 1),(22, 736, 1, 2, 1),(22, 737, 1, 1, 1),(22, 738, 1, 2, 1),(22, 739, 1, 1, 1),(22, 740, 1, 2, 1),(22, 741, 1, 1, 1),(22, 742, 1, 2, 1),(22, 743, 1, 1, 1),(22, 744, 1, 2, 1),(22, 745, 1, 1, 1),(22, 746, 1, 2, 1),(22, 747, 1, 1, 1),(22, 748, 1, 2, 1),(22, 749, 1, 1, 1),(22, 750, 1, 2, 1),(22, 751, 1, 1, 1),(22, 752, 1, 2, 1),(22, 753, 1, 1, 1),(22, 754, 1, 2, 1),(22, 755, 1, 1, 1),(22, 756, 1, 2, 1),(22, 757, 1, 1, 1),(22, 758, 1, 2, 1),(22, 759, 1, 1, 1),(22, 760, 1, 2, 1),(22, 761, 1, 1, 1),(22, 762, 1, 2, 1),(22, 763, 1, 1, 1),(22, 764, 1, 2, 1),(22, 765, 1, 1, 1),(22, 766, 1, 2, 1),(22, 767, 1, 1, 1),(22, 768, 1, 2, 1),(22, 769, 1, 1, 1),(22, 770, 1, 2, 1),(22, 771, 1, 1, 1),(22, 772, 1, 2, 1),(22, 773, 1, 1, 1),(22, 774, 1, 2, 1),(22, 775, 1, 1, 1),(22, 776, 1, 2, 1),(22, 777, 1, 1, 1),(22, 778, 1, 2, 1),(22, 779, 1, 1, 1),(22, 780, 1, 2, 1),(22, 781, 1, 1, 1),(22, 782, 1, 2, 1),(22, 783, 1, 1, 1),(22, 784, 1, 2, 1),(22, 785, 1, 1, 1),(22, 786, 1, 2, 1),(22, 787, 1, 1, 1),(22, 788, 1, 2, 1),(22, 789, 1, 1, 1),(22, 790, 1, 2, 1),(22, 791, 1, 1, 1),(22, 792, 1, 2, 1),(22, 793, 1, 1, 1),(22, 794, 1, 2, 1),(22, 795, 1, 1, 1),(22, 796, 1, 2, 1),(22, 797, 1, 1, 1),(22, 798, 1, 2, 1),(22, 799, 1, 1, 1),(22, 800, 1, 2, 1),(22, 801, 1, 1, 1),(22, 802, 1, 2, 1),(22, 803, 1, 1, 1),(22, 804, 1, 2, 1),(22, 805, 1, 1, 1),(22, 806, 1, 2, 1),(22, 807, 1, 1, 1),(22, 808, 1, 2, 1),(22, 809, 1, 1, 1),(22, 810, 1, 2, 1),(22, 811, 1, 1, 1),(22, 812, 1, 2, 1),(22, 813, 1, 1, 1),(22, 814, 1, 2, 1),(22, 815, 1, 1, 1),(22, 816, 1, 2, 1),(22, 817, 1, 1, 1),(22, 818, 1, 2, 1),(22, 819, 1, 1, 1),(22, 820, 1, 2, 1),(22, 821, 1, 1, 1),(22, 822, 1, 2, 1),(22, 823, 1, 1, 1),(22, 824, 1, 2, 1),(22, 825, 1, 1, 1),(22, 826, 1, 2, 1),(22, 827, 1, 1, 1),(22, 828, 1, 2, 1),(22, 829, 1, 1, 1),(22, 830, 1, 2, 1),(22, 831, 1, 1, 1),(22, 832, 1, 2, 1),(22, 833, 1, 1, 1),(22, 834, 1, 2, 1),(22, 835, 1, 1, 1),(22, 836, 1, 2, 1),(22, 837, 1, 1, 1),(22, 838, 1, 2, 1),(22, 839, 1, 1, 1),(22, 840, 1, 2, 1),(22, 841, 1, 1, 1),(22, 842, 1, 2, 1),(22, 843, 1, 1, 1),(22, 844, 1, 2, 1),(22, 845, 1, 1, 1),(22, 846, 1, 2, 1),(22, 847, 1, 1, 1),(22, 848, 1, 2, 1),(22, 849, 1, 1, 1),(22, 850, 1, 2, 1),(22, 851, 1, 1, 1),(22, 852, 1, 2, 1),(22, 853, 1, 1, 1),(22, 854, 1, 2, 1),(22, 855, 1, 1, 1),(22, 856, 1, 2, 1),(22, 857, 1, 1, 1),(22, 858, 1, 2, 1),(22, 859, 1, 1, 1),(22, 860, 1, 2, 1),(22, 861, 1, 1, 1),(22, 862, 1, 2, 1),(22, 863, 1, 1, 1),(22, 864, 1, 2, 1),(22, 865, 1, 1, 1),(22, 866, 1, 2, 1),(22, 867, 1, 1, 1),(22, 868, 1, 2, 1),(22, 869, 1, 1, 1),(22, 870, 1, 2, 1),(22, 871, 1, 1, 1),(22, 872, 1, 2, 1),(22, 873, 1, 1, 1),(22, 874, 1, 2, 1),(22, 875, 1, 1, 1),(22, 876, 1, 2, 1),(22, 877, 1, 1, 1),(22, 878, 1, 2, 1),(22, 879, 1, 1, 1),(22, 880, 1, 2, 1),(22, 881, 1, 1, 1),(22, 882, 1, 2, 1),(22, 883, 1, 1, 1),(22, 884, 1, 2, 1),(22, 885, 1, 1, 1),(22, 886, 1, 2, 1),(22, 887, 1, 1, 1),(22, 888, 1, 2, 1),(22, 889, 1, 1, 1),(22, 890, 1, 2, 1),(22, 891, 1, 1, 1),(22, 892, 1, 2, 1),(22, 893, 1, 1, 1),(22, 894, 1, 2, 1),(22, 895, 1, 1, 1),(22, 896, 1, 2, 1),(22, 897, 1, 1, 1),(22, 898, 1, 2, 1),(22, 899, 1, 1, 1),(22, 900, 1, 2, 1),(22, 901, 1, 1, 1),(22, 902, 1, 2, 1),(22, 903, 1, 1, 1),(22, 904, 1, 2, 1),(22, 905, 1, 1, 1),(22, 906, 1, 2, 1),(22, 907, 1, 1, 1),(22, 908, 1, 2, 1),(22, 909, 1, 1, 1),(22, 910, 1, 2, 1),(22, 911, 1, 1, 1),(22, 912, 1, 2, 1),(22, 913, 1, 1, 1),(22, 914, 1, 2, 1),(22, 915, 1, 1, 1),(22, 916, 1, 2, 1),(22, 917, 1, 1, 1),(22, 918, 1, 2, 1),(22, 919, 1, 1, 1),(22, 920, 1, 2, 1),(22, 921, 1, 1, 1),(22, 922, 1, 2, 1),(22, 923, 1, 1, 1),(22, 924, 1, 2, 1),(22, 925, 1, 1, 1),(22, 926, 1, 2, 1),(22, 927, 1, 1, 1),(22, 928, 1, 2, 1),(22, 929, 1, 1, 1),(22, 930, 1, 2, 1),(22, 931, 1, 1, 1),(22, 932, 1, 2, 1),(22, 933, 1, 1, 1),(22, 934, 1, 2, 1),(22, 935, 1, 1, 1),(22, 936, 1, 2, 1),(22, 937, 1, 1, 1),(22, 938, 1, 2, 1),(22, 939, 1, 1, 1),(22, 940, 1, 2, 1),(22, 941, 1, 1, 1),(22, 942, 1, 2, 1),(22, 943, 1, 1, 1),(22, 944, 1, 2, 1),(22, 945, 1, 1, 1),(22, 946, 1, 2, 1),(22, 947, 1, 1, 1),(22, 948, 1, 2, 1),(22, 949, 1, 1, 1),(22, 950, 1, 2, 1),(22, 951, 1, 1, 1),(22, 952, 1, 2, 1),(22, 953, 1, 1, 1),(22, 954, 1, 2, 1),(22, 955, 1, 1, 1),(22, 956, 1, 2, 1),(22, 957, 1, 1, 1),(22, 958, 1, 2, 1),(22, 959, 1, 1, 1),(22, 960, 1, 2, 1),(22, 961, 1, 1, 1),(22, 962, 1, 2, 1),(22, 963, 1, 1, 1),(22, 964, 1, 2, 1),(22, 965, 1, 1, 1),(22, 966, 1, 2, 1),(22, 967, 1, 1, 1),(22, 968, 1, 2, 1),(22, 969, 1, 1, 1),(22, 970, 1, 2, 1),(22, 971, 1, 1, 1),(22, 972, 1, 2, 1),(22, 973, 1, 1, 1),(22, 974, 1, 2, 1),(22, 975, 1, 1, 1),(22, 976, 1, 2, 1),(22, 977, 1, 1, 1),(22, 978, 1, 2, 1),(22, 979, 1, 1, 1),(22, 980, 1, 2, 1),(22, 981, 1, 1, 1),(22, 982, 1, 2, 1),(22, 983, 1, 1, 1),(22, 984, 1, 2, 1),(22, 985, 1, 1, 1),(22, 986, 1, 2, 1),(22, 987, 1, 1, 1),(22, 988, 1, 2, 1),(22, 989, 1, 1, 1),(22, 990, 1, 2, 1),(22, 991, 1, 1, 1),(22, 992, 1, 2, 1),(22, 993, 1, 1, 1),(22, 994, 1, 2, 1),(22, 995, 1, 1, 1),(22, 996, 1, 2, 1),(22, 997, 1, 1, 1),(22, 998, 1, 2, 1),(22, 999, 1, 1, 1),(22, 1000, 1, 2, 1),(22, 1001, 1, 1, 1),(22, 1002, 1, 2, 1),(22, 1003, 1, 1, 1),(22, 1004, 1, 2, 1),(22, 1005, 1, 1, 1),(22, 1006, 1, 2, 1),(22, 1007, 1, 1, 1),(22, 1008, 1, 2, 1),(22, 1009, 1, 1, 1),(22, 1010, 1, 2, 1),(22, 1011, 1, 1, 1),(22, 1012, 1, 2, 1),(22, 1013, 1, 1, 1),(22, 1014, 1, 2, 1),(22, 1015, 1, 1, 1),(22, 1016, 1, 2, 1),(22, 1017, 1, 1, 1),(22, 1018, 1, 2, 1),(22, 1019, 1, 1, 1),(22, 1020, 1, 2, 1),(22, 1021, 1, 1, 1),(22, 1022, 1, 2, 1),(22, 1023, 1, 1, 1),(22, 1024, 1, 2, 1),(22, 1025, 1, 1, 1),(22, 1026, 1, 2, 1),(22, 1027, 1, 1, 1),(22, 1028, 1, 2, 1),(22, 1029, 1, 1, 1),(22, 1030, 1, 2, 1),(22, 1031, 1, 1, 1),(22, 1032, 1, 2, 1),(22, 1033, 1, 1, 1),(22, 1034, 1, 2, 1),(22, 1035, 1, 1, 1),(22, 1036, 1, 2, 1),(22, 1037, 1, 1, 1),(22, 1038, 1, 2, 1),(22, 1039, 1, 1, 1),(22, 1040, 1, 2, 1),(22, 1041, 1, 1, 1),(22, 1042, 1, 2, 1),(22, 1043, 1, 1, 1),(22, 1044, 1, 2, 1),(22, 1045, 1, 1, 1),(22, 1046, 1, 2, 1),(22, 1047, 1, 1, 1),(22, 1048, 1, 2, 1),(22, 1049, 1, 1, 1),(22, 1050, 1, 2, 1),(22, 1051, 1, 1, 1),(22, 1052, 1, 2, 1),(22, 1053, 1, 1, 1),(22, 1054, 1, 2, 1),(22, 1055, 1, 1, 1),(22, 1056, 1, 2, 1),(22, 1057, 1, 1, 1),(22, 1058, 1, 2, 1),(22, 1059, 1, 1, 1),(22, 1060, 1, 2, 1),(22, 1061, 1, 1, 1),(22, 1062, 1, 2, 1),(22, 1063, 1, 1, 1),(22, 1064, 1, 2, 1),(22, 1065, 1, 1, 1),(22, 1066, 1, 2, 1),(22, 1067, 1, 1, 1),(22, 1068, 1, 2, 1),(22, 1069, 1, 1, 1),(22, 1070, 1, 2, 1),(22, 1071, 1, 1, 1),(22, 1072, 1, 2, 1),(22, 1073, 1, 1, 1),(22, 1074, 1, 2, 1),(22, 1075, 1, 1, 1),(22, 1076, 1, 2, 1),(22, 1077, 1, 1, 1),(22, 1078, 1, 2, 1),(22, 1079, 1, 1, 1),(22, 1080, 1, 2, 1),(22, 1081, 1, 1, 1),(22, 1082, 1, 2, 1),(22, 1083, 1, 1, 1),(22, 1084, 1, 2, 1),(22, 1085, 1, 1, 1),(22, 1086, 1, 2, 1),(22, 1087, 1, 1, 1),(22, 1088, 1, 2, 1),(22, 1089, 1, 1, 1),(22, 1090, 1, 2, 1),(22, 1091, 1, 1, 1),(22, 1092, 1, 2, 1),(22, 1093, 1, 1, 1),(22, 1094, 1, 2, 1),(22, 1095, 1, 1, 1),(22, 1096, 1, 2, 1),(22, 1097, 1, 1, 1),(22, 1098, 1, 2, 1),(22, 1099, 1, 1, 1),(22, 1100, 1, 2, 1),(22, 1101, 1, 1, 1),(22, 1102, 1, 2, 1),(22, 1103, 1, 1, 1),(22, 1104, 1, 2, 1),(22, 1105, 1, 1, 1),(22, 1106, 1, 2, 1),(22, 1107, 1, 1, 1),(22, 1108, 1, 2, 1),(22, 1109, 1, 1, 1),(22, 1110, 1, 2, 1),(22, 1111, 1, 1, 1),(22, 1112, 1, 2, 1),(22, 1113, 1, 1, 1),(22, 1114, 1, 2, 1),(22, 1115, 1, 1, 1),(22, 1116, 1, 2, 1),(22, 1117, 1, 1, 1),(22, 1118, 1, 2, 1),(22, 1119, 1, 1, 1),(22, 1120, 1, 2, 1),(22, 1121, 1, 1, 1),(22, 1122, 1, 2, 1),(22, 1123, 1, 1, 1),(22, 1124, 1, 2, 1),(22, 1125, 1, 1, 1),(22, 1126, 1, 2, 1),(22, 1127, 1, 1, 1),(22, 1128, 1, 2, 1),(22, 1129, 1, 1, 1),(22, 1130, 1, 2, 1),(22, 1131, 1, 1, 1),(22, 1132, 1, 2, 1),(22, 1133, 1, 1, 1),(22, 1134, 1, 2, 1),(22, 1135, 1, 1, 1),(22, 1136, 1, 2, 1),(22, 1137, 1, 1, 1),(22, 1138, 1, 2, 1),(22, 1139, 1, 1, 1),(22, 1140, 1, 2, 1),(22, 1141, 1, 1, 1),(22, 1142, 1, 2, 1),(22, 1143, 1, 1, 1),(22, 1144, 1, 2, 1),(22, 1145, 1, 1, 1),(22, 1146, 1, 2, 1),(22, 1147, 1, 1, 1),(22, 1148, 1, 2, 1),(22, 1149, 1, 1, 1),(22, 1150, 1, 2, 1),(22, 1151, 1, 1, 1),(22, 1152, 1, 2, 1),(22, 1153, 1, 1, 1),(22, 1154, 1, 2, 1),(22, 1155, 1, 1, 1),(22, 1156, 1, 2, 1),(22, 1157, 1, 1, 1),(22, 1158, 1, 2, 1),(22, 1159, 1, 1, 1),(22, 1160, 1, 2, 1),(22, 1161, 1, 1, 1),(22, 1162, 1, 2, 1),(22, 1163, 1, 1, 1),(22, 1164, 1, 2, 1),(22, 1165, 1, 1, 1),(22, 1166, 1, 2, 1),(22, 1167, 1, 1, 1),(22, 1168, 1, 2, 1),(22, 1169, 1, 1, 1),(22, 1170, 1, 2, 1),(22, 1171, 1, 1, 1),(22, 1172, 1, 2, 1),(22, 1173, 1, 1, 1),(22, 1174, 1, 2, 1),(22, 1175, 1, 1, 1),(22, 1176, 1, 2, 1),(22, 1177, 1, 1, 1),(22, 1178, 1, 2, 1),(22, 1179, 1, 1, 1),(22, 1180, 1, 2, 1),(22, 1181, 1, 1, 1),(22, 1182, 1, 2, 1),(22, 1183, 1, 1, 1),(22, 1184, 1, 2, 1),(22, 1185, 1, 1, 1),(22, 1186, 1, 2, 1),(22, 1187, 1, 1, 1),(22, 1188, 1, 2, 1),(22, 1189, 1, 1, 1),(22, 1190, 1, 2, 1),(22, 1191, 1, 1, 1),(22, 1192, 1, 2, 1),(22, 1193, 1, 1, 1),(22, 1194, 1, 2, 1),(22, 1195, 1, 1, 1),(22, 1196, 1, 2, 1),(22, 1197, 1, 1, 1),(22, 1198, 1, 2, 1),(22, 1199, 1, 1, 1),(22, 1200, 1, 2, 1),(22, 1201, 1, 1, 1),(22, 1202, 1, 2, 1),(22, 1203, 1, 1, 1),(22, 1204, 1, 2, 1),(22, 1205, 1, 1, 1),(22, 1206, 1, 2, 1),(22, 1207, 1, 1, 1),(22, 1208, 1, 2, 1),(22, 1209, 1, 1, 1),(22, 1210, 1, 2, 1),(22, 1211, 1, 1, 1),(22, 1212, 1, 2, 1),(22, 1213, 1, 1, 1),(22, 1214, 1, 2, 1),(22, 1215, 1, 1, 1),(22, 1216, 1, 2, 1),(22, 1217, 1, 1, 1),(22, 1218, 1, 2, 1),(22, 1219, 1, 1, 1),(22, 1220, 1, 2, 1),(22, 1221, 1, 1, 1),(22, 1222, 1, 2, 1),(22, 1223, 1, 1, 1),(22, 1224, 1, 2, 1),(22, 1225, 1, 1, 1),(22, 1226, 1, 2, 1),(22, 1227, 1, 1, 1),(22, 1228, 1, 2, 1),(22, 1229, 1, 1, 1),(22, 1230, 1, 2, 1),(22, 1231, 1, 1, 1),(22, 1232, 1, 2, 1),(22, 1233, 1, 1, 1),(22, 1234, 1, 2, 1),(22, 1235, 1, 1, 1),(22, 1236, 1, 2, 1),(22, 1237, 1, 1, 1),(22, 1238, 1, 2, 1),(22, 1239, 1, 1, 1),(22, 1240, 1, 2, 1),(22, 1241, 1, 1, 1),(22, 1242, 1, 2, 1),(22, 1243, 1, 1, 1),(22, 1244, 1, 2, 1),(22, 1245, 1, 1, 1),(22, 1246, 1, 2, 1),(22, 1247, 1, 1, 1),(22, 1248, 1, 2, 1),(22, 1249, 1, 1, 1),(22, 1250, 1, 2, 1),(22, 1251, 1, 1, 1),(22, 1252, 1, 2, 1),(22, 1253, 1, 1, 1),(22, 1254, 1, 2, 1),(22, 1255, 1, 1, 1),(22, 1256, 1, 2, 1),(22, 1257, 1, 1, 1),(22, 1258, 1, 2, 1),(22, 1259, 1, 1, 1),(22, 1260, 1, 2, 1),(22, 1261, 1, 1, 1),(22, 1262, 1, 2, 1),(22, 1263, 1, 1, 1),(22, 1264, 1, 2, 1),(22, 1265, 1, 1, 1),(22, 1266, 1, 2, 1),(22, 1267, 1, 1, 1),(22, 1268, 1, 2, 1),(22, 1269, 1, 1, 1),(22, 1270, 1, 2, 1),(22, 1271, 1, 1, 1),(22, 1272, 1, 2, 1),(22, 1273, 1, 1, 1),(22, 1274, 1, 2, 1),(22, 1275, 1, 1, 1),(22, 1276, 1, 2, 1),(22, 1277, 1, 1, 1),(22, 1278, 1, 2, 1),(22, 1279, 1, 1, 1),(22, 1280, 1, 2, 1),(22, 1281, 1, 1, 1),(22, 1282, 1, 2, 1),(22, 1283, 1, 1, 1),(22, 1284, 1, 2, 1),(22, 1285, 1, 1, 1),(22, 1286, 1, 2, 1),(22, 1287, 1, 1, 1),(22, 1288, 1, 2, 1),(22, 1289, 1, 1, 1),(22, 1290, 1, 2, 1),(22, 1291, 1, 1, 1),(22, 1292, 1, 2, 1),(22, 1293, 1, 1, 1),(22, 1294, 1, 2, 1),(22, 1295, 1, 1, 1),(22, 1296, 1, 2, 1),(22, 1297, 1, 1, 1),(22, 1298, 1, 2, 1),(22, 1299, 1, 1, 1),(22, 1300, 1, 2, 1),(22, 1301, 1, 1, 1),(22, 1302, 1, 2, 1),(22, 1303, 1, 1, 1),(22, 1304, 1, 2, 1),(22, 1305, 1, 1, 1),(22, 1306, 1, 2, 1),(22, 1307, 1, 1, 1),(22, 1308, 1, 2, 1),(22, 1309, 1, 1, 1),(22, 1310, 1, 2, 1),(22, 1311, 1, 1, 1),(22, 1312, 1, 2, 1),(22, 1313, 1, 1, 1),(22, 1314, 1, 2, 1),(22, 1315, 1, 1, 1),(22, 1316, 1, 2, 1),(22, 1317, 1, 1, 1),(22, 1318, 1, 2, 1),(22, 1319, 1, 1, 1),(22, 1320, 1, 2, 1),(22, 1321, 1, 1, 1),(22, 1322, 1, 2, 1),(22, 1323, 1, 1, 1),(22, 1324, 1, 2, 1),(22, 1325, 1, 1, 1),(22, 1326, 1, 2, 1),(22, 1327, 1, 1, 1),(22, 1328, 1, 2, 1),(22, 1329, 1, 1, 1),(22, 1330, 1, 2, 1),(22, 1331, 1, 1, 1),(22, 1332, 1, 2, 1),(22, 1333, 1, 1, 1),(22, 1334, 1, 2, 1),(22, 1335, 1, 1, 1),(22, 1336, 1, 2, 1),(22, 1337, 1, 1, 1),(22, 1338, 1, 2, 1),(22, 1339, 1, 1, 1),(22, 1340, 1, 2, 1),(22, 1341, 1, 1, 1),(22, 1342, 1, 2, 1),(22, 1343, 1, 1, 1),(22, 1344, 1, 2, 1),(22, 1345, 1, 1, 1),(22, 1346, 1, 2, 1),(22, 1347, 1, 1, 1),(22, 1348, 1, 2, 1),(22, 1349, 1, 1, 1),(22, 1350, 1, 2, 1),(22, 1351, 1, 1, 1),(22, 1352, 1, 2, 1),(22, 1353, 1, 1, 1),(22, 1354, 1, 2, 1),(22, 1355, 1, 1, 1),(22, 1356, 1, 2, 1),(22, 1357, 1, 1, 1),(22, 1358, 1, 2, 1),(22, 1359, 1, 1, 1),(22, 1360, 1, 2, 1),(22, 1361, 1, 1, 1),(22, 1362, 1, 2, 1),(22, 1363, 1, 1, 1),(22, 1364, 1, 2, 1),(22, 1365, 1, 1, 1),(22, 1366, 1, 2, 1),(22, 1367, 1, 1, 1),(22, 1368, 1, 2, 1),(22, 1369, 1, 1, 1),(22, 1370, 1, 2, 1),(22, 1371, 1, 1, 1),(22, 1372, 1, 2, 1),(22, 1373, 1, 1, 1),(22, 1374, 1, 2, 1),(22, 1375, 1, 1, 1),(22, 1376, 1, 2, 1),(22, 1377, 1, 1, 1),(22, 1378, 1, 2, 1),(22, 1379, 1, 1, 1),(22, 1380, 1, 2, 1),(22, 1381, 1, 1, 1),(22, 1382, 1, 2, 1),(22, 1383, 1, 1, 1),(22, 1384, 1, 2, 1),(22, 1385, 1, 1, 1),(22, 1386, 1, 2, 1),(22, 1387, 1, 1, 1),(22, 1388, 1, 2, 1),(22, 1389, 1, 1, 1),(22, 1390, 1, 2, 1),(22, 1391, 1, 1, 1),(22, 1392, 1, 2, 1),(22, 1393, 1, 1, 1),(22, 1394, 1, 2, 1),(22, 1395, 1, 1, 1),(22, 1396, 1, 2, 1),(22, 1397, 1, 1, 1),(22, 1398, 1, 2, 1),(22, 1399, 1, 1, 1),(22, 1400, 1, 2, 1),(22, 1401, 1, 1, 1),(22, 1402, 1, 2, 1),(22, 1403, 1, 1, 1),(22, 1404, 1, 2, 1),(22, 1405, 1, 1, 1),(22, 1406, 1, 2, 1),(22, 1407, 1, 1, 1),(22, 1408, 1, 2, 1),(22, 1409, 1, 1, 1),(22, 1410, 1, 2, 1),(22, 1411, 1, 1, 1),(22, 1412, 1, 2, 1),(22, 1413, 1, 1, 1),(22, 1414, 1, 2, 1),(22, 1415, 1, 1, 1),(22, 1416, 1, 2, 1),(22, 1417, 1, 1, 1),(22, 1418, 1, 2, 1),(22, 1419, 1, 1, 1),(22, 1420, 1, 2, 1),(22, 1421, 1, 1, 1),(22, 1422, 1, 2, 1),(22, 1423, 1, 1, 1),(22, 1424, 1, 2, 1),(22, 1425, 1, 1, 1),(22, 1426, 1, 2, 1),(22, 1427, 1, 1, 1),(22, 1428, 1, 2, 1),(22, 1429, 1, 1, 1),(22, 1430, 1, 2, 1),(22, 1431, 1, 1, 1),(22, 1432, 1, 2, 1),(22, 1433, 1, 1, 1),(22, 1434, 1, 2, 1),(22, 1435, 1, 1, 1),(22, 1436, 1, 2, 1),(22, 1437, 1, 1, 1),(22, 1438, 1, 2, 1),(22, 1439, 1, 1, 1),(22, 1440, 1, 2, 1),(22, 1441, 1, 1, 1),(22, 1442, 1, 2, 1),(22, 1443, 1, 1, 1),(22, 1444, 1, 2, 1),(22, 1445, 1, 1, 1),(22, 1446, 1, 2, 1),(22, 1447, 1, 1, 1),(22, 1448, 1, 2, 1),(22, 1449, 1, 1, 1),(22, 1450, 1, 2, 1),(22, 1451, 1, 1, 1),(22, 1452, 1, 2, 1),(22, 1453, 1, 1, 1),(22, 1454, 1, 2, 1),(22, 1455, 1, 1, 1),(22, 1456, 1, 2, 1),(22, 1457, 1, 1, 1),(22, 1458, 1, 2, 1),(22, 1459, 1, 1, 1),(22, 1460, 1, 2, 1),(22, 1461, 1, 1, 1),(22, 1462, 1, 2, 1),(22, 1463, 1, 1, 1),(22, 1464, 1, 2, 1),(22, 1465, 1, 1, 1),(22, 1466, 1, 2, 1),(22, 1467, 1, 1, 1),(22, 1468, 1, 2, 1),(22, 1469, 1, 1, 1),(22, 1470, 1, 2, 1),(22, 1471, 1, 1, 1),(22, 1472, 1, 2, 1),(22, 1473, 2, 1, 1),(22, 1474, 2, 2, 1),(22, 1475, 2, 1, 1),(22, 1476, 2, 2, 1),(22, 1477, 2, 1, 1),(22, 1478, 2, 2, 1),(22, 1479, 2, 1, 1),(22, 1480, 2, 2, 1),(22, 1481, 2, 1, 1),(22, 1482, 2, 2, 1),(22, 1483, 2, 1, 1),(22, 1484, 2, 2, 1),(22, 1485, 2, 1, 1),(22, 1486, 2, 2, 1),(22, 1487, 2, 1, 1),(22, 1488, 2, 2, 1),(22, 1489, 3, 1, 1),(22, 1490, 3, 2, 1),(22, 1491, 3, 1, 1),(22, 1492, 3, 2, 1),(22, 1493, 3, 1, 1),(22, 1494, 3, 2, 1),(22, 1495, 3, 1, 1),(22, 1496, 3, 2, 1),(22, 1497, 4, 1, 1),(22, 1498, 4, 2, 1),(22, 1499, 4, 1, 1),(22, 1500, 4, 2, 1),(22, 1501, 4, 1, 1),(22, 1502, 4, 2, 1),(22, 1503, 4, 1, 1),(22, 1504, 4, 2, 1),(22, 1505, 2, 1, 1),(22, 1506, 2, 2, 1),(22, 1507, 2, 1, 1),(22, 1508, 2, 2, 1),(22, 1509, 2, 1, 1),(22, 1510, 2, 2, 1),(22, 1511, 2, 1, 1),(22, 1512, 2, 2, 1),(22, 1513, 2, 1, 1),(22, 1514, 2, 2, 1),(22, 1515, 2, 1, 1),(22, 1516, 2, 2, 1),(22, 1517, 2, 1, 1),(22, 1518, 2, 2, 1),(22, 1519, 2, 1, 1),(22, 1520, 2, 2, 1),(22, 1521, 3, 1, 1),(22, 1522, 3, 2, 1),(22, 1523, 3, 1, 1),(22, 1524, 3, 2, 1),(22, 1525, 3, 1, 1),(22, 1526, 3, 2, 1),(22, 1527, 3, 1, 1),(22, 1528, 3, 2, 1),(22, 1529, 4, 1, 1),(22, 1530, 4, 2, 1),(22, 1531, 4, 1, 1),(22, 1532, 4, 2, 1),(22, 1533, 4, 1, 1),(22, 1534, 4, 2, 1),(22, 1535, 4, 1, 1),(22, 1536, 4, 2, 1),(23, 1, 1, 1, 1),(23, 2, 1, 1, 2),(23, 3, 1, 1, 1),(23, 4, 1, 1, 2),(23, 5, 1, 1, 1),(23, 6, 1, 1, 2),(23, 7, 1, 1, 1),(23, 8, 1, 1, 2),(23, 9, 1, 1, 1),(23, 10, 1, 1, 2),(23, 11, 1, 1, 1),(23, 12, 1, 1, 2),(23, 13, 1, 1, 1),(23, 14, 1, 1, 2),(23, 15, 1, 1, 1),(23, 16, 1, 1, 2),(23, 17, 1, 1, 1),(23, 18, 1, 1, 2),(23, 19, 1, 1, 1),(23, 20, 1, 1, 2),(23, 21, 1, 1, 1),(23, 22, 1, 1, 2),(23, 23, 1, 1, 1),(23, 24, 1, 1, 2),(23, 25, 1, 1, 1),(23, 26, 1, 1, 2),(23, 27, 1, 1, 1),(23, 28, 1, 1, 2),(23, 29, 1, 1, 1),(23, 30, 1, 1, 2),(23, 31, 1, 1, 1),(23, 32, 1, 1, 2),(23, 33, 1, 1, 3),(23, 34, 1, 1, 4),(23, 35, 1, 1, 3),(23, 36, 1, 1, 4),(23, 37, 1, 1, 3),(23, 38, 1, 1, 4),(23, 39, 1, 1, 3),(23, 40, 1, 1, 4),(23, 41, 1, 1, 3),(23, 42, 1, 1, 4),(23, 43, 1, 1, 3),(23, 44, 1, 1, 4),(23, 45, 1, 1, 3),(23, 46, 1, 1, 4),(23, 47, 1, 1, 3),(23, 48, 1, 1, 4),(23, 49, 1, 1, 3),(23, 50, 1, 1, 4),(23, 51, 1, 1, 3),(23, 52, 1, 1, 4),(23, 53, 1, 1, 3),(23, 54, 1, 1, 4),(23, 55, 1, 1, 3),(23, 56, 1, 1, 4),(23, 57, 1, 1, 3),(23, 58, 1, 1, 4),(23, 59, 1, 1, 3),(23, 60, 1, 1, 4),(23, 61, 1, 1, 3),(23, 62, 1, 1, 4),(23, 63, 1, 1, 3),(23, 64, 1, 1, 4),(23, 65, 1, 1, 1),(23, 66, 1, 1, 2),(23, 67, 1, 1, 1),(23, 68, 1, 1, 2),(23, 69, 1, 1, 1),(23, 70, 1, 1, 2),(23, 71, 1, 1, 1),(23, 72, 1, 1, 2),(23, 73, 1, 1, 1),(23, 74, 1, 1, 2),(23, 75, 1, 1, 1),(23, 76, 1, 1, 2),(23, 77, 1, 1, 1),(23, 78, 1, 1, 2),(23, 79, 1, 1, 1),(23, 80, 1, 1, 2),(23, 81, 1, 1, 1),(23, 82, 1, 1, 2),(23, 83, 1, 1, 1),(23, 84, 1, 1, 2),(23, 85, 1, 1, 1),(23, 86, 1, 1, 2),(23, 87, 1, 1, 1),(23, 88, 1, 1, 2),(23, 89, 1, 1, 1),(23, 90, 1, 1, 2),(23, 91, 1, 1, 1),(23, 92, 1, 1, 2),(23, 93, 1, 1, 1),(23, 94, 1, 1, 2),(23, 95, 1, 1, 1),(23, 96, 1, 1, 2),(23, 97, 1, 1, 3),(23, 98, 1, 1, 4),(23, 99, 1, 1, 3),(23, 100, 1, 1, 4),(23, 101, 1, 1, 3),(23, 102, 1, 1, 4),(23, 103, 1, 1, 3),(23, 104, 1, 1, 4),(23, 105, 1, 1, 3),(23, 106, 1, 1, 4),(23, 107, 1, 1, 3),(23, 108, 1, 1, 4),(23, 109, 1, 1, 3),(23, 110, 1, 1, 4),(23, 111, 1, 1, 3),(23, 112, 1, 1, 4),(23, 113, 1, 1, 3),(23, 114, 1, 1, 4),(23, 115, 1, 1, 3),(23, 116, 1, 1, 4),(23, 117, 1, 1, 3),(23, 118, 1, 1, 4),(23, 119, 1, 1, 3),(23, 120, 1, 1, 4),(23, 121, 1, 1, 3),(23, 122, 1, 1, 4),(23, 123, 1, 1, 3),(23, 124, 1, 1, 4),(23, 125, 1, 1, 3),(23, 126, 1, 1, 4),(23, 127, 1, 1, 3),(23, 128, 1, 1, 4),(23, 129, 1, 1, 1),(23, 130, 1, 1, 2),(23, 131, 1, 1, 1),(23, 132, 1, 1, 2),(23, 133, 1, 1, 1),(23, 134, 1, 1, 2),(23, 135, 1, 1, 1),(23, 136, 1, 1, 2),(23, 137, 1, 1, 1),(23, 138, 1, 1, 2),(23, 139, 1, 1, 1),(23, 140, 1, 1, 2),(23, 141, 1, 1, 1),(23, 142, 1, 1, 2),(23, 143, 1, 1, 1),(23, 144, 1, 1, 2),(23, 145, 1, 1, 1),(23, 146, 1, 1, 2),(23, 147, 1, 1, 1),(23, 148, 1, 1, 2),(23, 149, 1, 1, 1),(23, 150, 1, 1, 2),(23, 151, 1, 1, 1),(23, 152, 1, 1, 2),(23, 153, 1, 1, 1),(23, 154, 1, 1, 2),(23, 155, 1, 1, 1),(23, 156, 1, 1, 2),(23, 157, 1, 1, 1),(23, 158, 1, 1, 2),(23, 159, 1, 1, 1),(23, 160, 1, 1, 2),(23, 161, 1, 1, 3),(23, 162, 1, 1, 4),(23, 163, 1, 1, 3),(23, 164, 1, 1, 4),(23, 165, 1, 1, 3),(23, 166, 1, 1, 4),(23, 167, 1, 1, 3),(23, 168, 1, 1, 4),(23, 169, 1, 1, 3),(23, 170, 1, 1, 4),(23, 171, 1, 1, 3),(23, 172, 1, 1, 4),(23, 173, 1, 1, 3),(23, 174, 1, 1, 4),(23, 175, 1, 1, 3),(23, 176, 1, 1, 4),(23, 177, 1, 1, 3),(23, 178, 1, 1, 4),(23, 179, 1, 1, 3),(23, 180, 1, 1, 4),(23, 181, 1, 1, 3),(23, 182, 1, 1, 4),(23, 183, 1, 1, 3),(23, 184, 1, 1, 4),(23, 185, 1, 1, 3),(23, 186, 1, 1, 4),(23, 187, 1, 1, 3),(23, 188, 1, 1, 4),(23, 189, 1, 1, 3),(23, 190, 1, 1, 4),(23, 191, 1, 1, 3),(23, 192, 1, 1, 4),(23, 193, 1, 1, 1),(23, 194, 1, 1, 2),(23, 195, 1, 1, 1),(23, 196, 1, 1, 2),(23, 197, 1, 1, 1),(23, 198, 1, 1, 2),(23, 199, 1, 1, 1),(23, 200, 1, 1, 2),(23, 201, 1, 1, 1),(23, 202, 1, 1, 2),(23, 203, 1, 1, 1),(23, 204, 1, 1, 2),(23, 205, 1, 1, 1),(23, 206, 1, 1, 2),(23, 207, 1, 1, 1),(23, 208, 1, 1, 2),(23, 209, 1, 1, 1),(23, 210, 1, 1, 2),(23, 211, 1, 1, 1),(23, 212, 1, 1, 2),(23, 213, 1, 1, 1),(23, 214, 1, 1, 2),(23, 215, 1, 1, 1),(23, 216, 1, 1, 2),(23, 217, 1, 1, 1),(23, 218, 1, 1, 2),(23, 219, 1, 1, 1),(23, 220, 1, 1, 2),(23, 221, 1, 1, 1),(23, 222, 1, 1, 2),(23, 223, 1, 1, 1),(23, 224, 1, 1, 2),(23, 225, 1, 1, 3),(23, 226, 1, 1, 4),(23, 227, 1, 1, 3),(23, 228, 1, 1, 4),(23, 229, 1, 1, 3),(23, 230, 1, 1, 4),(23, 231, 1, 1, 3),(23, 232, 1, 1, 4),(23, 233, 1, 1, 3),(23, 234, 1, 1, 4),(23, 235, 1, 1, 3),(23, 236, 1, 1, 4),(23, 237, 1, 1, 3),(23, 238, 1, 1, 4),(23, 239, 1, 1, 3),(23, 240, 1, 1, 4),(23, 241, 1, 1, 3),(23, 242, 1, 1, 4),(23, 243, 1, 1, 3),(23, 244, 1, 1, 4),(23, 245, 1, 1, 3),(23, 246, 1, 1, 4),(23, 247, 1, 1, 3),(23, 248, 1, 1, 4),(23, 249, 1, 1, 3),(23, 250, 1, 1, 4),(23, 251, 1, 1, 3),(23, 252, 1, 1, 4),(23, 253, 1, 1, 3),(23, 254, 1, 1, 4),(23, 255, 1, 1, 3),(23, 256, 1, 1, 4),(23, 257, 1, 1, 1),(23, 258, 1, 1, 2),(23, 259, 1, 1, 1),(23, 260, 1, 1, 2),(23, 261, 1, 1, 1),(23, 262, 1, 1, 2),(23, 263, 1, 1, 1),(23, 264, 1, 1, 2),(23, 265, 1, 1, 1),(23, 266, 1, 1, 2),(23, 267, 1, 1, 1),(23, 268, 1, 1, 2),(23, 269, 1, 1, 1),(23, 270, 1, 1, 2),(23, 271, 1, 1, 1),(23, 272, 1, 1, 2),(23, 273, 1, 1, 1),(23, 274, 1, 1, 2),(23, 275, 1, 1, 1),(23, 276, 1, 1, 2),(23, 277, 1, 1, 1),(23, 278, 1, 1, 2),(23, 279, 1, 1, 1),(23, 280, 1, 1, 2),(23, 281, 1, 1, 1),(23, 282, 1, 1, 2),(23, 283, 1, 1, 1),(23, 284, 1, 1, 2),(23, 285, 1, 1, 1),(23, 286, 1, 1, 2),(23, 287, 1, 1, 1),(23, 288, 1, 1, 2),(23, 289, 1, 1, 3),(23, 290, 1, 1, 4),(23, 291, 1, 1, 3),(23, 292, 1, 1, 4),(23, 293, 1, 1, 3),(23, 294, 1, 1, 4),(23, 295, 1, 1, 3),(23, 296, 1, 1, 4),(23, 297, 1, 1, 3),(23, 298, 1, 1, 4),(23, 299, 1, 1, 3),(23, 300, 1, 1, 4),(23, 301, 1, 1, 3),(23, 302, 1, 1, 4),(23, 303, 1, 1, 3),(23, 304, 1, 1, 4),(23, 305, 1, 1, 3),(23, 306, 1, 1, 4),(23, 307, 1, 1, 3),(23, 308, 1, 1, 4),(23, 309, 1, 1, 3),(23, 310, 1, 1, 4),(23, 311, 1, 1, 3),(23, 312, 1, 1, 4),(23, 313, 1, 1, 3),(23, 314, 1, 1, 4),(23, 315, 1, 1, 3),(23, 316, 1, 1, 4),(23, 317, 1, 1, 3),(23, 318, 1, 1, 4),(23, 319, 1, 1, 3),(23, 320, 1, 1, 4),(23, 321, 1, 1, 1),(23, 322, 1, 1, 2),(23, 323, 1, 1, 1),(23, 324, 1, 1, 2),(23, 325, 1, 1, 1),(23, 326, 1, 1, 2),(23, 327, 1, 1, 1),(23, 328, 1, 1, 2),(23, 329, 1, 1, 1),(23, 330, 1, 1, 2),(23, 331, 1, 1, 1),(23, 332, 1, 1, 2),(23, 333, 1, 1, 1),(23, 334, 1, 1, 2),(23, 335, 1, 1, 1),(23, 336, 1, 1, 2),(23, 337, 1, 1, 1),(23, 338, 1, 1, 2),(23, 339, 1, 1, 1),(23, 340, 1, 1, 2),(23, 341, 1, 1, 1),(23, 342, 1, 1, 2),(23, 343, 1, 1, 1),(23, 344, 1, 1, 2),(23, 345, 1, 1, 1),(23, 346, 1, 1, 2),(23, 347, 1, 1, 1),(23, 348, 1, 1, 2),(23, 349, 1, 1, 1),(23, 350, 1, 1, 2),(23, 351, 1, 1, 1),(23, 352, 1, 1, 2),(23, 353, 1, 1, 3),(23, 354, 1, 1, 4),(23, 355, 1, 1, 3),(23, 356, 1, 1, 4),(23, 357, 1, 1, 3),(23, 358, 1, 1, 4),(23, 359, 1, 1, 3),(23, 360, 1, 1, 4),(23, 361, 1, 1, 3),(23, 362, 1, 1, 4),(23, 363, 1, 1, 3),(23, 364, 1, 1, 4),(23, 365, 1, 1, 3),(23, 366, 1, 1, 4),(23, 367, 1, 1, 3),(23, 368, 1, 1, 4),(23, 369, 1, 1, 3),(23, 370, 1, 1, 4),(23, 371, 1, 1, 3),(23, 372, 1, 1, 4),(23, 373, 1, 1, 3),(23, 374, 1, 1, 4),(23, 375, 1, 1, 3),(23, 376, 1, 1, 4),(23, 377, 1, 1, 3),(23, 378, 1, 1, 4),(23, 379, 1, 1, 3),(23, 380, 1, 1, 4),(23, 381, 1, 1, 3),(23, 382, 1, 1, 4),(23, 383, 1, 1, 3),(23, 384, 1, 1, 4),(23, 385, 1, 1, 1),(23, 386, 1, 1, 2),(23, 387, 1, 1, 1),(23, 388, 1, 1, 2),(23, 389, 1, 1, 1),(23, 390, 1, 1, 2),(23, 391, 1, 1, 1),(23, 392, 1, 1, 2),(23, 393, 1, 1, 1),(23, 394, 1, 1, 2),(23, 395, 1, 1, 1),(23, 396, 1, 1, 2),(23, 397, 1, 1, 1),(23, 398, 1, 1, 2),(23, 399, 1, 1, 1),(23, 400, 1, 1, 2),(23, 401, 1, 1, 1),(23, 402, 1, 1, 2),(23, 403, 1, 1, 1),(23, 404, 1, 1, 2),(23, 405, 1, 1, 1),(23, 406, 1, 1, 2),(23, 407, 1, 1, 1),(23, 408, 1, 1, 2),(23, 409, 1, 1, 1),(23, 410, 1, 1, 2),(23, 411, 1, 1, 1),(23, 412, 1, 1, 2),(23, 413, 1, 1, 1),(23, 414, 1, 1, 2),(23, 415, 1, 1, 1),(23, 416, 1, 1, 2),(23, 417, 1, 1, 3),(23, 418, 1, 1, 4),(23, 419, 1, 1, 3),(23, 420, 1, 1, 4),(23, 421, 1, 1, 3),(23, 422, 1, 1, 4),(23, 423, 1, 1, 3),(23, 424, 1, 1, 4),(23, 425, 1, 1, 3),(23, 426, 1, 1, 4),(23, 427, 1, 1, 3),(23, 428, 1, 1, 4),(23, 429, 1, 1, 3),(23, 430, 1, 1, 4),(23, 431, 1, 1, 3),(23, 432, 1, 1, 4),(23, 433, 1, 1, 3),(23, 434, 1, 1, 4),(23, 435, 1, 1, 3),(23, 436, 1, 1, 4),(23, 437, 1, 1, 3),(23, 438, 1, 1, 4),(23, 439, 1, 1, 3),(23, 440, 1, 1, 4),(23, 441, 1, 1, 3),(23, 442, 1, 1, 4),(23, 443, 1, 1, 3),(23, 444, 1, 1, 4),(23, 445, 1, 1, 3),(23, 446, 1, 1, 4),(23, 447, 1, 1, 3),(23, 448, 1, 1, 4),(23, 449, 1, 1, 1),(23, 450, 1, 1, 2),(23, 451, 1, 1, 1),(23, 452, 1, 1, 2),(23, 453, 1, 1, 1),(23, 454, 1, 1, 2),(23, 455, 1, 1, 1),(23, 456, 1, 1, 2),(23, 457, 1, 1, 1),(23, 458, 1, 1, 2),(23, 459, 1, 1, 1),(23, 460, 1, 1, 2),(23, 461, 1, 1, 1),(23, 462, 1, 1, 2),(23, 463, 1, 1, 1),(23, 464, 1, 1, 2),(23, 465, 1, 1, 1),(23, 466, 1, 1, 2),(23, 467, 1, 1, 1),(23, 468, 1, 1, 2),(23, 469, 1, 1, 1),(23, 470, 1, 1, 2),(23, 471, 1, 1, 1),(23, 472, 1, 1, 2),(23, 473, 1, 1, 1),(23, 474, 1, 1, 2),(23, 475, 1, 1, 1),(23, 476, 1, 1, 2),(23, 477, 1, 1, 1),(23, 478, 1, 1, 2),(23, 479, 1, 1, 1),(23, 480, 1, 1, 2),(23, 481, 1, 1, 3),(23, 482, 1, 1, 4),(23, 483, 1, 1, 3),(23, 484, 1, 1, 4),(23, 485, 1, 1, 3),(23, 486, 1, 1, 4),(23, 487, 1, 1, 3),(23, 488, 1, 1, 4),(23, 489, 1, 1, 3),(23, 490, 1, 1, 4),(23, 491, 1, 1, 3),(23, 492, 1, 1, 4),(23, 493, 1, 1, 3),(23, 494, 1, 1, 4),(23, 495, 1, 1, 3),(23, 496, 1, 1, 4),(23, 497, 1, 1, 3),(23, 498, 1, 1, 4),(23, 499, 1, 1, 3),(23, 500, 1, 1, 4),(23, 501, 1, 1, 3),(23, 502, 1, 1, 4),(23, 503, 1, 1, 3),(23, 504, 1, 1, 4),(23, 505, 1, 1, 3),(23, 506, 1, 1, 4),(23, 507, 1, 1, 3),(23, 508, 1, 1, 4),(23, 509, 1, 1, 3),(23, 510, 1, 1, 4),(23, 511, 1, 1, 3),(23, 512, 1, 1, 4),(23, 513, 1, 1, 1),(23, 514, 1, 1, 2),(23, 515, 1, 1, 1),(23, 516, 1, 1, 2),(23, 517, 1, 1, 1),(23, 518, 1, 1, 2),(23, 519, 1, 1, 1),(23, 520, 1, 1, 2),(23, 521, 1, 1, 1),(23, 522, 1, 1, 2),(23, 523, 1, 1, 1),(23, 524, 1, 1, 2),(23, 525, 1, 1, 1),(23, 526, 1, 1, 2),(23, 527, 1, 1, 1),(23, 528, 1, 1, 2),(23, 529, 1, 1, 1),(23, 530, 1, 1, 2),(23, 531, 1, 1, 1),(23, 532, 1, 1, 2),(23, 533, 1, 1, 1),(23, 534, 1, 1, 2),(23, 535, 1, 1, 1),(23, 536, 1, 1, 2),(23, 537, 1, 1, 1),(23, 538, 1, 1, 2),(23, 539, 1, 1, 1),(23, 540, 1, 1, 2),(23, 541, 1, 1, 1),(23, 542, 1, 1, 2),(23, 543, 1, 1, 1),(23, 544, 1, 1, 2),(23, 545, 1, 1, 3),(23, 546, 1, 1, 4),(23, 547, 1, 1, 3),(23, 548, 1, 1, 4),(23, 549, 1, 1, 3),(23, 550, 1, 1, 4),(23, 551, 1, 1, 3),(23, 552, 1, 1, 4),(23, 553, 1, 1, 3),(23, 554, 1, 1, 4),(23, 555, 1, 1, 3),(23, 556, 1, 1, 4),(23, 557, 1, 1, 3),(23, 558, 1, 1, 4),(23, 559, 1, 1, 3),(23, 560, 1, 1, 4),(23, 561, 1, 1, 3),(23, 562, 1, 1, 4),(23, 563, 1, 1, 3),(23, 564, 1, 1, 4),(23, 565, 1, 1, 3),(23, 566, 1, 1, 4),(23, 567, 1, 1, 3),(23, 568, 1, 1, 4),(23, 569, 1, 1, 3),(23, 570, 1, 1, 4),(23, 571, 1, 1, 3),(23, 572, 1, 1, 4),(23, 573, 1, 1, 3),(23, 574, 1, 1, 4),(23, 575, 1, 1, 3),(23, 576, 1, 1, 4),(23, 577, 1, 1, 1),(23, 578, 1, 1, 2),(23, 579, 1, 1, 1),(23, 580, 1, 1, 2),(23, 581, 1, 1, 1),(23, 582, 1, 1, 2),(23, 583, 1, 1, 1),(23, 584, 1, 1, 2),(23, 585, 1, 1, 1),(23, 586, 1, 1, 2),(23, 587, 1, 1, 1),(23, 588, 1, 1, 2),(23, 589, 1, 1, 1),(23, 590, 1, 1, 2),(23, 591, 1, 1, 1),(23, 592, 1, 1, 2),(23, 593, 1, 1, 1),(23, 594, 1, 1, 2),(23, 595, 1, 1, 1),(23, 596, 1, 1, 2),(23, 597, 1, 1, 1),(23, 598, 1, 1, 2),(23, 599, 1, 1, 1),(23, 600, 1, 1, 2),(23, 601, 1, 1, 1),(23, 602, 1, 1, 2),(23, 603, 1, 1, 1),(23, 604, 1, 1, 2),(23, 605, 1, 1, 1),(23, 606, 1, 1, 2),(23, 607, 1, 1, 1),(23, 608, 1, 1, 2),(23, 609, 1, 1, 3),(23, 610, 1, 1, 4),(23, 611, 1, 1, 3),(23, 612, 1, 1, 4),(23, 613, 1, 1, 3),(23, 614, 1, 1, 4),(23, 615, 1, 1, 3),(23, 616, 1, 1, 4),(23, 617, 1, 1, 3),(23, 618, 1, 1, 4),(23, 619, 1, 1, 3),(23, 620, 1, 1, 4),(23, 621, 1, 1, 3),(23, 622, 1, 1, 4),(23, 623, 1, 1, 3),(23, 624, 1, 1, 4),(23, 625, 1, 1, 3),(23, 626, 1, 1, 4),(23, 627, 1, 1, 3),(23, 628, 1, 1, 4),(23, 629, 1, 1, 3),(23, 630, 1, 1, 4),(23, 631, 1, 1, 3),(23, 632, 1, 1, 4),(23, 633, 1, 1, 3),(23, 634, 1, 1, 4),(23, 635, 1, 1, 3),(23, 636, 1, 1, 4),(23, 637, 1, 1, 3),(23, 638, 1, 1, 4),(23, 639, 1, 1, 3),(23, 640, 1, 1, 4),(23, 641, 1, 1, 1),(23, 642, 1, 1, 2),(23, 643, 1, 1, 1),(23, 644, 1, 1, 2),(23, 645, 1, 1, 1),(23, 646, 1, 1, 2),(23, 647, 1, 1, 1),(23, 648, 1, 1, 2),(23, 649, 1, 1, 1),(23, 650, 1, 1, 2),(23, 651, 1, 1, 1),(23, 652, 1, 1, 2),(23, 653, 1, 1, 1),(23, 654, 1, 1, 2),(23, 655, 1, 1, 1),(23, 656, 1, 1, 2),(23, 657, 1, 1, 1),(23, 658, 1, 1, 2),(23, 659, 1, 1, 1),(23, 660, 1, 1, 2),(23, 661, 1, 1, 1),(23, 662, 1, 1, 2),(23, 663, 1, 1, 1),(23, 664, 1, 1, 2),(23, 665, 1, 1, 1),(23, 666, 1, 1, 2),(23, 667, 1, 1, 1),(23, 668, 1, 1, 2),(23, 669, 1, 1, 1),(23, 670, 1, 1, 2),(23, 671, 1, 1, 1),(23, 672, 1, 1, 2),(23, 673, 1, 1, 3),(23, 674, 1, 1, 4),(23, 675, 1, 1, 3),(23, 676, 1, 1, 4),(23, 677, 1, 1, 3),(23, 678, 1, 1, 4),(23, 679, 1, 1, 3),(23, 680, 1, 1, 4),(23, 681, 1, 1, 3),(23, 682, 1, 1, 4),(23, 683, 1, 1, 3),(23, 684, 1, 1, 4),(23, 685, 1, 1, 3),(23, 686, 1, 1, 4),(23, 687, 1, 1, 3),(23, 688, 1, 1, 4),(23, 689, 1, 1, 3),(23, 690, 1, 1, 4),(23, 691, 1, 1, 3),(23, 692, 1, 1, 4),(23, 693, 1, 1, 3),(23, 694, 1, 1, 4),(23, 695, 1, 1, 3),(23, 696, 1, 1, 4),(23, 697, 1, 1, 3),(23, 698, 1, 1, 4),(23, 699, 1, 1, 3),(23, 700, 1, 1, 4),(23, 701, 1, 1, 3),(23, 702, 1, 1, 4),(23, 703, 1, 1, 3),(23, 704, 1, 1, 4),(23, 705, 1, 1, 1),(23, 706, 1, 1, 2),(23, 707, 1, 1, 1),(23, 708, 1, 1, 2),(23, 709, 1, 1, 1),(23, 710, 1, 1, 2),(23, 711, 1, 1, 1),(23, 712, 1, 1, 2),(23, 713, 1, 1, 1),(23, 714, 1, 1, 2),(23, 715, 1, 1, 1),(23, 716, 1, 1, 2),(23, 717, 1, 1, 1),(23, 718, 1, 1, 2),(23, 719, 1, 1, 1),(23, 720, 1, 1, 2),(23, 721, 1, 1, 1),(23, 722, 1, 1, 2),(23, 723, 1, 1, 1),(23, 724, 1, 1, 2),(23, 725, 1, 1, 1),(23, 726, 1, 1, 2),(23, 727, 1, 1, 1),(23, 728, 1, 1, 2),(23, 729, 1, 1, 1),(23, 730, 1, 1, 2),(23, 731, 1, 1, 1),(23, 732, 1, 1, 2),(23, 733, 1, 1, 1),(23, 734, 1, 1, 2),(23, 735, 1, 1, 1),(23, 736, 1, 1, 2),(23, 737, 1, 1, 3),(23, 738, 1, 1, 4),(23, 739, 1, 1, 3),(23, 740, 1, 1, 4),(23, 741, 1, 1, 3),(23, 742, 1, 1, 4),(23, 743, 1, 1, 3),(23, 744, 1, 1, 4),(23, 745, 1, 1, 3),(23, 746, 1, 1, 4),(23, 747, 1, 1, 3),(23, 748, 1, 1, 4),(23, 749, 1, 1, 3),(23, 750, 1, 1, 4),(23, 751, 1, 1, 3),(23, 752, 1, 1, 4),(23, 753, 1, 1, 3),(23, 754, 1, 1, 4),(23, 755, 1, 1, 3),(23, 756, 1, 1, 4),(23, 757, 1, 1, 3),(23, 758, 1, 1, 4),(23, 759, 1, 1, 3),(23, 760, 1, 1, 4),(23, 761, 1, 1, 3),(23, 762, 1, 1, 4),(23, 763, 1, 1, 3),(23, 764, 1, 1, 4),(23, 765, 1, 1, 3),(23, 766, 1, 1, 4),(23, 767, 1, 1, 3),(23, 768, 1, 1, 4),(23, 769, 1, 1, 1),(23, 770, 1, 1, 2),(23, 771, 1, 1, 1),(23, 772, 1, 1, 2),(23, 773, 1, 1, 1),(23, 774, 1, 1, 2),(23, 775, 1, 1, 1),(23, 776, 1, 1, 2),(23, 777, 1, 1, 1),(23, 778, 1, 1, 2),(23, 779, 1, 1, 1),(23, 780, 1, 1, 2),(23, 781, 1, 1, 1),(23, 782, 1, 1, 2),(23, 783, 1, 1, 1),(23, 784, 1, 1, 2),(23, 785, 1, 1, 1),(23, 786, 1, 1, 2),(23, 787, 1, 1, 1),(23, 788, 1, 1, 2),(23, 789, 1, 1, 1),(23, 790, 1, 1, 2),(23, 791, 1, 1, 1),(23, 792, 1, 1, 2),(23, 793, 1, 1, 1),(23, 794, 1, 1, 2),(23, 795, 1, 1, 1),(23, 796, 1, 1, 2),(23, 797, 1, 1, 1),(23, 798, 1, 1, 2),(23, 799, 1, 1, 1),(23, 800, 1, 1, 2),(23, 801, 1, 1, 3),(23, 802, 1, 1, 4),(23, 803, 1, 1, 3),(23, 804, 1, 1, 4),(23, 805, 1, 1, 3),(23, 806, 1, 1, 4),(23, 807, 1, 1, 3),(23, 808, 1, 1, 4),(23, 809, 1, 1, 3),(23, 810, 1, 1, 4),(23, 811, 1, 1, 3),(23, 812, 1, 1, 4),(23, 813, 1, 1, 3),(23, 814, 1, 1, 4),(23, 815, 1, 1, 3),(23, 816, 1, 1, 4),(23, 817, 1, 1, 3),(23, 818, 1, 1, 4),(23, 819, 1, 1, 3),(23, 820, 1, 1, 4),(23, 821, 1, 1, 3),(23, 822, 1, 1, 4),(23, 823, 1, 1, 3),(23, 824, 1, 1, 4),(23, 825, 1, 1, 3),(23, 826, 1, 1, 4),(23, 827, 1, 1, 3),(23, 828, 1, 1, 4),(23, 829, 1, 1, 3),(23, 830, 1, 1, 4),(23, 831, 1, 1, 3),(23, 832, 1, 1, 4),(23, 833, 1, 1, 1),(23, 834, 1, 1, 2),(23, 835, 1, 1, 1),(23, 836, 1, 1, 2),(23, 837, 1, 1, 1),(23, 838, 1, 1, 2),(23, 839, 1, 1, 1),(23, 840, 1, 1, 2),(23, 841, 1, 1, 1),(23, 842, 1, 1, 2),(23, 843, 1, 1, 1),(23, 844, 1, 1, 2),(23, 845, 1, 1, 1),(23, 846, 1, 1, 2),(23, 847, 1, 1, 1),(23, 848, 1, 1, 2),(23, 849, 1, 1, 1),(23, 850, 1, 1, 2),(23, 851, 1, 1, 1),(23, 852, 1, 1, 2),(23, 853, 1, 1, 1),(23, 854, 1, 1, 2),(23, 855, 1, 1, 1),(23, 856, 1, 1, 2),(23, 857, 1, 1, 1),(23, 858, 1, 1, 2),(23, 859, 1, 1, 1),(23, 860, 1, 1, 2),(23, 861, 1, 1, 1),(23, 862, 1, 1, 2),(23, 863, 1, 1, 1),(23, 864, 1, 1, 2),(23, 865, 1, 1, 3),(23, 866, 1, 1, 4),(23, 867, 1, 1, 3),(23, 868, 1, 1, 4),(23, 869, 1, 1, 3),(23, 870, 1, 1, 4),(23, 871, 1, 1, 3),(23, 872, 1, 1, 4),(23, 873, 1, 1, 3),(23, 874, 1, 1, 4),(23, 875, 1, 1, 3),(23, 876, 1, 1, 4),(23, 877, 1, 1, 3),(23, 878, 1, 1, 4),(23, 879, 1, 1, 3),(23, 880, 1, 1, 4),(23, 881, 1, 1, 3),(23, 882, 1, 1, 4),(23, 883, 1, 1, 3),(23, 884, 1, 1, 4),(23, 885, 1, 1, 3),(23, 886, 1, 1, 4),(23, 887, 1, 1, 3),(23, 888, 1, 1, 4),(23, 889, 1, 1, 3),(23, 890, 1, 1, 4),(23, 891, 1, 1, 3),(23, 892, 1, 1, 4),(23, 893, 1, 1, 3),(23, 894, 1, 1, 4),(23, 895, 1, 1, 3),(23, 896, 1, 1, 4),(23, 897, 1, 1, 1),(23, 898, 1, 1, 2),(23, 899, 1, 1, 1),(23, 900, 1, 1, 2),(23, 901, 1, 1, 1),(23, 902, 1, 1, 2),(23, 903, 1, 1, 1),(23, 904, 1, 1, 2),(23, 905, 1, 1, 1),(23, 906, 1, 1, 2),(23, 907, 1, 1, 1),(23, 908, 1, 1, 2),(23, 909, 1, 1, 1),(23, 910, 1, 1, 2),(23, 911, 1, 1, 1),(23, 912, 1, 1, 2),(23, 913, 1, 1, 1),(23, 914, 1, 1, 2),(23, 915, 1, 1, 1),(23, 916, 1, 1, 2),(23, 917, 1, 1, 1),(23, 918, 1, 1, 2),(23, 919, 1, 1, 1),(23, 920, 1, 1, 2),(23, 921, 1, 1, 1),(23, 922, 1, 1, 2),(23, 923, 1, 1, 1),(23, 924, 1, 1, 2),(23, 925, 1, 1, 1),(23, 926, 1, 1, 2),(23, 927, 1, 1, 1),(23, 928, 1, 1, 2),(23, 929, 1, 1, 3),(23, 930, 1, 1, 4),(23, 931, 1, 1, 3),(23, 932, 1, 1, 4),(23, 933, 1, 1, 3),(23, 934, 1, 1, 4),(23, 935, 1, 1, 3),(23, 936, 1, 1, 4),(23, 937, 1, 1, 3),(23, 938, 1, 1, 4),(23, 939, 1, 1, 3),(23, 940, 1, 1, 4),(23, 941, 1, 1, 3),(23, 942, 1, 1, 4),(23, 943, 1, 1, 3),(23, 944, 1, 1, 4),(23, 945, 1, 1, 3),(23, 946, 1, 1, 4),(23, 947, 1, 1, 3),(23, 948, 1, 1, 4),(23, 949, 1, 1, 3),(23, 950, 1, 1, 4),(23, 951, 1, 1, 3),(23, 952, 1, 1, 4),(23, 953, 1, 1, 3),(23, 954, 1, 1, 4),(23, 955, 1, 1, 3),(23, 956, 1, 1, 4),(23, 957, 1, 1, 3),(23, 958, 1, 1, 4),(23, 959, 1, 1, 3),(23, 960, 1, 1, 4),(23, 961, 1, 1, 1),(23, 962, 1, 1, 2),(23, 963, 1, 1, 1),(23, 964, 1, 1, 2),(23, 965, 1, 1, 1),(23, 966, 1, 1, 2),(23, 967, 1, 1, 1),(23, 968, 1, 1, 2),(23, 969, 1, 1, 1),(23, 970, 1, 1, 2),(23, 971, 1, 1, 1),(23, 972, 1, 1, 2),(23, 973, 1, 1, 1),(23, 974, 1, 1, 2),(23, 975, 1, 1, 1),(23, 976, 1, 1, 2),(23, 977, 1, 1, 1),(23, 978, 1, 1, 2),(23, 979, 1, 1, 1),(23, 980, 1, 1, 2),(23, 981, 1, 1, 1),(23, 982, 1, 1, 2),(23, 983, 1, 1, 1),(23, 984, 1, 1, 2),(23, 985, 1, 1, 1),(23, 986, 1, 1, 2),(23, 987, 1, 1, 1),(23, 988, 1, 1, 2),(23, 989, 1, 1, 1),(23, 990, 1, 1, 2),(23, 991, 1, 1, 1),(23, 992, 1, 1, 2),(23, 993, 1, 1, 3),(23, 994, 1, 1, 4),(23, 995, 1, 1, 3),(23, 996, 1, 1, 4),(23, 997, 1, 1, 3),(23, 998, 1, 1, 4),(23, 999, 1, 1, 3),(23, 1000, 1, 1, 4),(23, 1001, 1, 1, 3),(23, 1002, 1, 1, 4),(23, 1003, 1, 1, 3),(23, 1004, 1, 1, 4),(23, 1005, 1, 1, 3),(23, 1006, 1, 1, 4),(23, 1007, 1, 1, 3),(23, 1008, 1, 1, 4),(23, 1009, 1, 1, 3),(23, 1010, 1, 1, 4),(23, 1011, 1, 1, 3),(23, 1012, 1, 1, 4),(23, 1013, 1, 1, 3),(23, 1014, 1, 1, 4),(23, 1015, 1, 1, 3),(23, 1016, 1, 1, 4),(23, 1017, 1, 1, 3),(23, 1018, 1, 1, 4),(23, 1019, 1, 1, 3),(23, 1020, 1, 1, 4),(23, 1021, 1, 1, 3),(23, 1022, 1, 1, 4),(23, 1023, 1, 1, 3),(23, 1024, 1, 1, 4),(23, 1025, 1, 1, 1),(23, 1026, 1, 1, 2),(23, 1027, 1, 1, 1),(23, 1028, 1, 1, 2),(23, 1029, 1, 1, 1),(23, 1030, 1, 1, 2),(23, 1031, 1, 1, 1),(23, 1032, 1, 1, 2),(23, 1033, 1, 1, 1),(23, 1034, 1, 1, 2),(23, 1035, 1, 1, 1),(23, 1036, 1, 1, 2),(23, 1037, 1, 1, 1),(23, 1038, 1, 1, 2),(23, 1039, 1, 1, 1),(23, 1040, 1, 1, 2),(23, 1041, 1, 1, 1),(23, 1042, 1, 1, 2),(23, 1043, 1, 1, 1),(23, 1044, 1, 1, 2),(23, 1045, 1, 1, 1),(23, 1046, 1, 1, 2),(23, 1047, 1, 1, 1),(23, 1048, 1, 1, 2),(23, 1049, 1, 1, 1),(23, 1050, 1, 1, 2),(23, 1051, 1, 1, 1),(23, 1052, 1, 1, 2),(23, 1053, 1, 1, 1),(23, 1054, 1, 1, 2),(23, 1055, 1, 1, 1),(23, 1056, 1, 1, 2),(23, 1057, 1, 1, 3),(23, 1058, 1, 1, 4),(23, 1059, 1, 1, 3),(23, 1060, 1, 1, 4),(23, 1061, 1, 1, 3),(23, 1062, 1, 1, 4),(23, 1063, 1, 1, 3),(23, 1064, 1, 1, 4),(23, 1065, 1, 1, 3),(23, 1066, 1, 1, 4),(23, 1067, 1, 1, 3),(23, 1068, 1, 1, 4),(23, 1069, 1, 1, 3),(23, 1070, 1, 1, 4),(23, 1071, 1, 1, 3),(23, 1072, 1, 1, 4),(23, 1073, 1, 1, 3),(23, 1074, 1, 1, 4),(23, 1075, 1, 1, 3),(23, 1076, 1, 1, 4),(23, 1077, 1, 1, 3),(23, 1078, 1, 1, 4),(23, 1079, 1, 1, 3),(23, 1080, 1, 1, 4),(23, 1081, 1, 1, 3),(23, 1082, 1, 1, 4),(23, 1083, 1, 1, 3),(23, 1084, 1, 1, 4),(23, 1085, 1, 1, 3),(23, 1086, 1, 1, 4),(23, 1087, 1, 1, 3),(23, 1088, 1, 1, 4),(23, 1089, 1, 1, 1),(23, 1090, 1, 1, 2),(23, 1091, 1, 1, 1),(23, 1092, 1, 1, 2),(23, 1093, 1, 1, 1),(23, 1094, 1, 1, 2),(23, 1095, 1, 1, 1),(23, 1096, 1, 1, 2),(23, 1097, 1, 1, 1),(23, 1098, 1, 1, 2),(23, 1099, 1, 1, 1),(23, 1100, 1, 1, 2),(23, 1101, 1, 1, 1),(23, 1102, 1, 1, 2),(23, 1103, 1, 1, 1),(23, 1104, 1, 1, 2),(23, 1105, 1, 1, 1),(23, 1106, 1, 1, 2),(23, 1107, 1, 1, 1),(23, 1108, 1, 1, 2),(23, 1109, 1, 1, 1),(23, 1110, 1, 1, 2),(23, 1111, 1, 1, 1),(23, 1112, 1, 1, 2),(23, 1113, 1, 1, 1),(23, 1114, 1, 1, 2),(23, 1115, 1, 1, 1),(23, 1116, 1, 1, 2),(23, 1117, 1, 1, 1),(23, 1118, 1, 1, 2),(23, 1119, 1, 1, 1),(23, 1120, 1, 1, 2),(23, 1121, 1, 1, 3),(23, 1122, 1, 1, 4),(23, 1123, 1, 1, 3),(23, 1124, 1, 1, 4),(23, 1125, 1, 1, 3),(23, 1126, 1, 1, 4),(23, 1127, 1, 1, 3),(23, 1128, 1, 1, 4),(23, 1129, 1, 1, 3),(23, 1130, 1, 1, 4),(23, 1131, 1, 1, 3),(23, 1132, 1, 1, 4),(23, 1133, 1, 1, 3),(23, 1134, 1, 1, 4),(23, 1135, 1, 1, 3),(23, 1136, 1, 1, 4),(23, 1137, 1, 1, 3),(23, 1138, 1, 1, 4),(23, 1139, 1, 1, 3),(23, 1140, 1, 1, 4),(23, 1141, 1, 1, 3),(23, 1142, 1, 1, 4),(23, 1143, 1, 1, 3),(23, 1144, 1, 1, 4),(23, 1145, 1, 1, 3),(23, 1146, 1, 1, 4),(23, 1147, 1, 1, 3),(23, 1148, 1, 1, 4),(23, 1149, 1, 1, 3),(23, 1150, 1, 1, 4),(23, 1151, 1, 1, 3),(23, 1152, 1, 1, 4),(23, 1153, 1, 1, 1),(23, 1154, 1, 1, 2),(23, 1155, 1, 1, 1),(23, 1156, 1, 1, 2),(23, 1157, 1, 1, 1),(23, 1158, 1, 1, 2),(23, 1159, 1, 1, 1),(23, 1160, 1, 1, 2),(23, 1161, 1, 1, 1),(23, 1162, 1, 1, 2),(23, 1163, 1, 1, 1),(23, 1164, 1, 1, 2),(23, 1165, 1, 1, 1),(23, 1166, 1, 1, 2),(23, 1167, 1, 1, 1),(23, 1168, 1, 1, 2),(23, 1169, 1, 1, 1),(23, 1170, 1, 1, 2),(23, 1171, 1, 1, 1),(23, 1172, 1, 1, 2),(23, 1173, 1, 1, 1),(23, 1174, 1, 1, 2),(23, 1175, 1, 1, 1),(23, 1176, 1, 1, 2),(23, 1177, 1, 1, 1),(23, 1178, 1, 1, 2),(23, 1179, 1, 1, 1),(23, 1180, 1, 1, 2),(23, 1181, 1, 1, 1),(23, 1182, 1, 1, 2),(23, 1183, 1, 1, 1),(23, 1184, 1, 1, 2),(23, 1185, 1, 1, 3),(23, 1186, 1, 1, 4),(23, 1187, 1, 1, 3),(23, 1188, 1, 1, 4),(23, 1189, 1, 1, 3),(23, 1190, 1, 1, 4),(23, 1191, 1, 1, 3),(23, 1192, 1, 1, 4),(23, 1193, 1, 1, 3),(23, 1194, 1, 1, 4),(23, 1195, 1, 1, 3),(23, 1196, 1, 1, 4),(23, 1197, 1, 1, 3),(23, 1198, 1, 1, 4),(23, 1199, 1, 1, 3),(23, 1200, 1, 1, 4),(23, 1201, 1, 1, 3),(23, 1202, 1, 1, 4),(23, 1203, 1, 1, 3),(23, 1204, 1, 1, 4),(23, 1205, 1, 1, 3),(23, 1206, 1, 1, 4),(23, 1207, 1, 1, 3),(23, 1208, 1, 1, 4),(23, 1209, 1, 1, 3),(23, 1210, 1, 1, 4),(23, 1211, 1, 1, 3),(23, 1212, 1, 1, 4),(23, 1213, 1, 1, 3),(23, 1214, 1, 1, 4),(23, 1215, 1, 1, 3),(23, 1216, 1, 1, 4),(23, 1217, 1, 1, 1),(23, 1218, 1, 1, 2),(23, 1219, 1, 1, 1),(23, 1220, 1, 1, 2),(23, 1221, 1, 1, 1),(23, 1222, 1, 1, 2),(23, 1223, 1, 1, 1),(23, 1224, 1, 1, 2),(23, 1225, 1, 1, 1),(23, 1226, 1, 1, 2),(23, 1227, 1, 1, 1),(23, 1228, 1, 1, 2),(23, 1229, 1, 1, 1),(23, 1230, 1, 1, 2),(23, 1231, 1, 1, 1),(23, 1232, 1, 1, 2),(23, 1233, 1, 1, 1),(23, 1234, 1, 1, 2),(23, 1235, 1, 1, 1),(23, 1236, 1, 1, 2),(23, 1237, 1, 1, 1),(23, 1238, 1, 1, 2),(23, 1239, 1, 1, 1),(23, 1240, 1, 1, 2),(23, 1241, 1, 1, 1),(23, 1242, 1, 1, 2),(23, 1243, 1, 1, 1),(23, 1244, 1, 1, 2),(23, 1245, 1, 1, 1),(23, 1246, 1, 1, 2),(23, 1247, 1, 1, 1),(23, 1248, 1, 1, 2),(23, 1249, 1, 1, 3),(23, 1250, 1, 1, 4),(23, 1251, 1, 1, 3),(23, 1252, 1, 1, 4),(23, 1253, 1, 1, 3),(23, 1254, 1, 1, 4),(23, 1255, 1, 1, 3),(23, 1256, 1, 1, 4),(23, 1257, 1, 1, 3),(23, 1258, 1, 1, 4),(23, 1259, 1, 1, 3),(23, 1260, 1, 1, 4),(23, 1261, 1, 1, 3),(23, 1262, 1, 1, 4),(23, 1263, 1, 1, 3),(23, 1264, 1, 1, 4),(23, 1265, 1, 1, 3),(23, 1266, 1, 1, 4),(23, 1267, 1, 1, 3),(23, 1268, 1, 1, 4),(23, 1269, 1, 1, 3),(23, 1270, 1, 1, 4),(23, 1271, 1, 1, 3),(23, 1272, 1, 1, 4),(23, 1273, 1, 1, 3),(23, 1274, 1, 1, 4),(23, 1275, 1, 1, 3),(23, 1276, 1, 1, 4),(23, 1277, 1, 1, 3),(23, 1278, 1, 1, 4),(23, 1279, 1, 1, 3),(23, 1280, 1, 1, 4),(23, 1281, 1, 1, 1),(23, 1282, 1, 1, 2),(23, 1283, 1, 1, 1),(23, 1284, 1, 1, 2),(23, 1285, 1, 1, 1),(23, 1286, 1, 1, 2),(23, 1287, 1, 1, 1),(23, 1288, 1, 1, 2),(23, 1289, 1, 1, 1),(23, 1290, 1, 1, 2),(23, 1291, 1, 1, 1),(23, 1292, 1, 1, 2),(23, 1293, 1, 1, 1),(23, 1294, 1, 1, 2),(23, 1295, 1, 1, 1),(23, 1296, 1, 1, 2),(23, 1297, 1, 1, 1),(23, 1298, 1, 1, 2),(23, 1299, 1, 1, 1),(23, 1300, 1, 1, 2),(23, 1301, 1, 1, 1),(23, 1302, 1, 1, 2),(23, 1303, 1, 1, 1),(23, 1304, 1, 1, 2),(23, 1305, 1, 1, 1),(23, 1306, 1, 1, 2),(23, 1307, 1, 1, 1),(23, 1308, 1, 1, 2),(23, 1309, 1, 1, 1),(23, 1310, 1, 1, 2),(23, 1311, 1, 1, 1),(23, 1312, 1, 1, 2),(23, 1313, 1, 1, 3),(23, 1314, 1, 1, 4),(23, 1315, 1, 1, 3),(23, 1316, 1, 1, 4),(23, 1317, 1, 1, 3),(23, 1318, 1, 1, 4),(23, 1319, 1, 1, 3),(23, 1320, 1, 1, 4),(23, 1321, 1, 1, 3),(23, 1322, 1, 1, 4),(23, 1323, 1, 1, 3),(23, 1324, 1, 1, 4),(23, 1325, 1, 1, 3),(23, 1326, 1, 1, 4),(23, 1327, 1, 1, 3),(23, 1328, 1, 1, 4),(23, 1329, 1, 1, 3),(23, 1330, 1, 1, 4),(23, 1331, 1, 1, 3),(23, 1332, 1, 1, 4),(23, 1333, 1, 1, 3),(23, 1334, 1, 1, 4),(23, 1335, 1, 1, 3),(23, 1336, 1, 1, 4),(23, 1337, 1, 1, 3),(23, 1338, 1, 1, 4),(23, 1339, 1, 1, 3),(23, 1340, 1, 1, 4),(23, 1341, 1, 1, 3),(23, 1342, 1, 1, 4),(23, 1343, 1, 1, 3),(23, 1344, 1, 1, 4),(23, 1345, 1, 1, 1),(23, 1346, 1, 1, 2),(23, 1347, 1, 1, 1),(23, 1348, 1, 1, 2),(23, 1349, 1, 1, 1),(23, 1350, 1, 1, 2),(23, 1351, 1, 1, 1),(23, 1352, 1, 1, 2),(23, 1353, 1, 1, 1),(23, 1354, 1, 1, 2),(23, 1355, 1, 1, 1),(23, 1356, 1, 1, 2),(23, 1357, 1, 1, 1),(23, 1358, 1, 1, 2),(23, 1359, 1, 1, 1),(23, 1360, 1, 1, 2),(23, 1361, 1, 1, 1),(23, 1362, 1, 1, 2),(23, 1363, 1, 1, 1),(23, 1364, 1, 1, 2),(23, 1365, 1, 1, 1),(23, 1366, 1, 1, 2),(23, 1367, 1, 1, 1),(23, 1368, 1, 1, 2),(23, 1369, 1, 1, 1),(23, 1370, 1, 1, 2),(23, 1371, 1, 1, 1),(23, 1372, 1, 1, 2),(23, 1373, 1, 1, 1),(23, 1374, 1, 1, 2),(23, 1375, 1, 1, 1),(23, 1376, 1, 1, 2),(23, 1377, 1, 1, 3),(23, 1378, 1, 1, 4),(23, 1379, 1, 1, 3),(23, 1380, 1, 1, 4),(23, 1381, 1, 1, 3),(23, 1382, 1, 1, 4),(23, 1383, 1, 1, 3),(23, 1384, 1, 1, 4),(23, 1385, 1, 1, 3),(23, 1386, 1, 1, 4),(23, 1387, 1, 1, 3),(23, 1388, 1, 1, 4),(23, 1389, 1, 1, 3),(23, 1390, 1, 1, 4),(23, 1391, 1, 1, 3),(23, 1392, 1, 1, 4),(23, 1393, 1, 1, 3),(23, 1394, 1, 1, 4),(23, 1395, 1, 1, 3),(23, 1396, 1, 1, 4),(23, 1397, 1, 1, 3),(23, 1398, 1, 1, 4),(23, 1399, 1, 1, 3),(23, 1400, 1, 1, 4),(23, 1401, 1, 1, 3),(23, 1402, 1, 1, 4),(23, 1403, 1, 1, 3),(23, 1404, 1, 1, 4),(23, 1405, 1, 1, 3),(23, 1406, 1, 1, 4),(23, 1407, 1, 1, 3),(23, 1408, 1, 1, 4),(23, 1409, 1, 1, 1),(23, 1410, 1, 1, 2),(23, 1411, 1, 1, 1),(23, 1412, 1, 1, 2),(23, 1413, 1, 1, 1),(23, 1414, 1, 1, 2),(23, 1415, 1, 1, 1),(23, 1416, 1, 1, 2),(23, 1417, 1, 1, 1),(23, 1418, 1, 1, 2),(23, 1419, 1, 1, 1),(23, 1420, 1, 1, 2),(23, 1421, 1, 1, 1),(23, 1422, 1, 1, 2),(23, 1423, 1, 1, 1),(23, 1424, 1, 1, 2),(23, 1425, 1, 1, 1),(23, 1426, 1, 1, 2),(23, 1427, 1, 1, 1),(23, 1428, 1, 1, 2),(23, 1429, 1, 1, 1),(23, 1430, 1, 1, 2),(23, 1431, 1, 1, 1),(23, 1432, 1, 1, 2),(23, 1433, 1, 1, 1),(23, 1434, 1, 1, 2),(23, 1435, 1, 1, 1),(23, 1436, 1, 1, 2),(23, 1437, 1, 1, 1),(23, 1438, 1, 1, 2),(23, 1439, 1, 1, 1),(23, 1440, 1, 1, 2),(23, 1441, 1, 1, 3),(23, 1442, 1, 1, 4),(23, 1443, 1, 1, 3),(23, 1444, 1, 1, 4),(23, 1445, 1, 1, 3),(23, 1446, 1, 1, 4),(23, 1447, 1, 1, 3),(23, 1448, 1, 1, 4),(23, 1449, 1, 1, 3),(23, 1450, 1, 1, 4),(23, 1451, 1, 1, 3),(23, 1452, 1, 1, 4),(23, 1453, 1, 1, 3),(23, 1454, 1, 1, 4),(23, 1455, 1, 1, 3),(23, 1456, 1, 1, 4),(23, 1457, 1, 1, 3),(23, 1458, 1, 1, 4),(23, 1459, 1, 1, 3),(23, 1460, 1, 1, 4),(23, 1461, 1, 1, 3),(23, 1462, 1, 1, 4),(23, 1463, 1, 1, 3),(23, 1464, 1, 1, 4),(23, 1465, 1, 1, 3),(23, 1466, 1, 1, 4),(23, 1467, 1, 1, 3),(23, 1468, 1, 1, 4),(23, 1469, 1, 1, 3),(23, 1470, 1, 1, 4),(23, 1471, 1, 1, 3),(23, 1472, 1, 1, 4),(23, 1473, 2, 1, 1),(23, 1474, 2, 1, 2),(23, 1475, 2, 1, 1),(23, 1476, 2, 1, 2),(23, 1477, 2, 1, 1),(23, 1478, 2, 1, 2),(23, 1479, 2, 1, 1),(23, 1480, 2, 1, 2),(23, 1481, 2, 1, 1),(23, 1482, 2, 1, 2),(23, 1483, 2, 1, 1),(23, 1484, 2, 1, 2),(23, 1485, 2, 1, 1),(23, 1486, 2, 1, 2),(23, 1487, 2, 1, 1),(23, 1488, 2, 1, 2),(23, 1489, 3, 1, 1),(23, 1490, 3, 1, 2),(23, 1491, 3, 1, 1),(23, 1492, 3, 1, 2),(23, 1493, 3, 1, 1),(23, 1494, 3, 1, 2),(23, 1495, 3, 1, 1),(23, 1496, 3, 1, 2),(23, 1497, 4, 1, 1),(23, 1498, 4, 1, 2),(23, 1499, 4, 1, 1),(23, 1500, 4, 1, 2),(23, 1501, 4, 1, 1),(23, 1502, 4, 1, 2),(23, 1503, 4, 1, 1),(23, 1504, 4, 1, 2),(23, 1505, 2, 1, 3),(23, 1506, 2, 1, 4),(23, 1507, 2, 1, 3),(23, 1508, 2, 1, 4),(23, 1509, 2, 1, 3),(23, 1510, 2, 1, 4),(23, 1511, 2, 1, 3),(23, 1512, 2, 1, 4),(23, 1513, 2, 1, 3),(23, 1514, 2, 1, 4),(23, 1515, 2, 1, 3),(23, 1516, 2, 1, 4),(23, 1517, 2, 1, 3),(23, 1518, 2, 1, 4),(23, 1519, 2, 1, 3),(23, 1520, 2, 1, 4),(23, 1521, 3, 1, 3),(23, 1522, 3, 1, 4),(23, 1523, 3, 1, 3),(23, 1524, 3, 1, 4),(23, 1525, 3, 1, 3),(23, 1526, 3, 1, 4),(23, 1527, 3, 1, 3),(23, 1528, 3, 1, 4),(23, 1529, 4, 1, 3),(23, 1530, 4, 1, 4),(23, 1531, 4, 1, 3),(23, 1532, 4, 1, 4),(23, 1533, 4, 1, 3),(23, 1534, 4, 1, 4),(23, 1535, 4, 1, 3),(23, 1536, 4, 1, 4),(24, 1, 1, 1, 1),(24, 2, 1, 1, 1),(24, 3, 1, 1, 1),(24, 4, 1, 1, 1),(24, 5, 1, 1, 1),(24, 6, 1, 1, 1),(24, 7, 1, 1, 1),(24, 8, 1, 1, 1),(24, 9, 1, 1, 1),(24, 10, 1, 1, 1),(24, 11, 1, 1, 1),(24, 12, 1, 1, 1),(24, 13, 1, 1, 1),(24, 14, 1, 1, 1),(24, 15, 1, 1, 1),(24, 16, 1, 1, 1),(24, 17, 1, 1, 1),(24, 18, 1, 1, 1),(24, 19, 1, 1, 1),(24, 20, 1, 1, 1),(24, 21, 1, 1, 1),(24, 22, 1, 1, 1),(24, 23, 1, 1, 1),(24, 24, 1, 1, 1),(24, 25, 1, 1, 1),(24, 26, 1, 1, 1),(24, 27, 1, 1, 1),(24, 28, 1, 1, 1),(24, 29, 1, 1, 1),(24, 30, 1, 1, 1),(24, 31, 1, 1, 1),(24, 32, 1, 1, 1),(24, 33, 1, 1, 2),(24, 34, 1, 1, 2),(24, 35, 1, 1, 2),(24, 36, 1, 1, 2),(24, 37, 1, 1, 2),(24, 38, 1, 1, 2),(24, 39, 1, 1, 2),(24, 40, 1, 1, 2),(24, 41, 1, 1, 2),(24, 42, 1, 1, 2),(24, 43, 1, 1, 2),(24, 44, 1, 1, 2),(24, 45, 1, 1, 2),(24, 46, 1, 1, 2),(24, 47, 1, 1, 2),(24, 48, 1, 1, 2),(24, 49, 1, 1, 2),(24, 50, 1, 1, 2),(24, 51, 1, 1, 2),(24, 52, 1, 1, 2),(24, 53, 1, 1, 2),(24, 54, 1, 1, 2),(24, 55, 1, 1, 2),(24, 56, 1, 1, 2),(24, 57, 1, 1, 2),(24, 58, 1, 1, 2),(24, 59, 1, 1, 2),(24, 60, 1, 1, 2),(24, 61, 1, 1, 2),(24, 62, 1, 1, 2),(24, 63, 1, 1, 2),(24, 64, 1, 1, 2),(24, 65, 1, 1, 1),(24, 66, 1, 1, 1),(24, 67, 1, 1, 1),(24, 68, 1, 1, 1),(24, 69, 1, 1, 1),(24, 70, 1, 1, 1),(24, 71, 1, 1, 1),(24, 72, 1, 1, 1),(24, 73, 1, 1, 1),(24, 74, 1, 1, 1),(24, 75, 1, 1, 1),(24, 76, 1, 1, 1),(24, 77, 1, 1, 1),(24, 78, 1, 1, 1),(24, 79, 1, 1, 1),(24, 80, 1, 1, 1),(24, 81, 1, 1, 1),(24, 82, 1, 1, 1),(24, 83, 1, 1, 1),(24, 84, 1, 1, 1),(24, 85, 1, 1, 1),(24, 86, 1, 1, 1),(24, 87, 1, 1, 1),(24, 88, 1, 1, 1),(24, 89, 1, 1, 1),(24, 90, 1, 1, 1),(24, 91, 1, 1, 1),(24, 92, 1, 1, 1),(24, 93, 1, 1, 1),(24, 94, 1, 1, 1),(24, 95, 1, 1, 1),(24, 96, 1, 1, 1),(24, 97, 1, 1, 2),(24, 98, 1, 1, 2),(24, 99, 1, 1, 2),(24, 100, 1, 1, 2),(24, 101, 1, 1, 2),(24, 102, 1, 1, 2),(24, 103, 1, 1, 2),(24, 104, 1, 1, 2),(24, 105, 1, 1, 2),(24, 106, 1, 1, 2),(24, 107, 1, 1, 2),(24, 108, 1, 1, 2),(24, 109, 1, 1, 2),(24, 110, 1, 1, 2),(24, 111, 1, 1, 2),(24, 112, 1, 1, 2),(24, 113, 1, 1, 2),(24, 114, 1, 1, 2),(24, 115, 1, 1, 2),(24, 116, 1, 1, 2),(24, 117, 1, 1, 2),(24, 118, 1, 1, 2),(24, 119, 1, 1, 2),(24, 120, 1, 1, 2),(24, 121, 1, 1, 2),(24, 122, 1, 1, 2),(24, 123, 1, 1, 2),(24, 124, 1, 1, 2),(24, 125, 1, 1, 2),(24, 126, 1, 1, 2),(24, 127, 1, 1, 2),(24, 128, 1, 1, 2),(24, 129, 1, 1, 1),(24, 130, 1, 1, 1),(24, 131, 1, 1, 1),(24, 132, 1, 1, 1),(24, 133, 1, 1, 1),(24, 134, 1, 1, 1),(24, 135, 1, 1, 1),(24, 136, 1, 1, 1),(24, 137, 1, 1, 1),(24, 138, 1, 1, 1),(24, 139, 1, 1, 1),(24, 140, 1, 1, 1),(24, 141, 1, 1, 1),(24, 142, 1, 1, 1),(24, 143, 1, 1, 1),(24, 144, 1, 1, 1),(24, 145, 1, 1, 1),(24, 146, 1, 1, 1),(24, 147, 1, 1, 1),(24, 148, 1, 1, 1),(24, 149, 1, 1, 1),(24, 150, 1, 1, 1),(24, 151, 1, 1, 1),(24, 152, 1, 1, 1),(24, 153, 1, 1, 1),(24, 154, 1, 1, 1),(24, 155, 1, 1, 1),(24, 156, 1, 1, 1),(24, 157, 1, 1, 1),(24, 158, 1, 1, 1),(24, 159, 1, 1, 1),(24, 160, 1, 1, 1),(24, 161, 1, 1, 2),(24, 162, 1, 1, 2),(24, 163, 1, 1, 2),(24, 164, 1, 1, 2),(24, 165, 1, 1, 2),(24, 166, 1, 1, 2),(24, 167, 1, 1, 2),(24, 168, 1, 1, 2),(24, 169, 1, 1, 2),(24, 170, 1, 1, 2),(24, 171, 1, 1, 2),(24, 172, 1, 1, 2),(24, 173, 1, 1, 2),(24, 174, 1, 1, 2),(24, 175, 1, 1, 2),(24, 176, 1, 1, 2),(24, 177, 1, 1, 2),(24, 178, 1, 1, 2),(24, 179, 1, 1, 2),(24, 180, 1, 1, 2),(24, 181, 1, 1, 2),(24, 182, 1, 1, 2),(24, 183, 1, 1, 2),(24, 184, 1, 1, 2),(24, 185, 1, 1, 2),(24, 186, 1, 1, 2),(24, 187, 1, 1, 2),(24, 188, 1, 1, 2),(24, 189, 1, 1, 2),(24, 190, 1, 1, 2),(24, 191, 1, 1, 2),(24, 192, 1, 1, 2),(24, 193, 1, 1, 1),(24, 194, 1, 1, 1),(24, 195, 1, 1, 1),(24, 196, 1, 1, 1),(24, 197, 1, 1, 1),(24, 198, 1, 1, 1),(24, 199, 1, 1, 1),(24, 200, 1, 1, 1),(24, 201, 1, 1, 1),(24, 202, 1, 1, 1),(24, 203, 1, 1, 1),(24, 204, 1, 1, 1),(24, 205, 1, 1, 1),(24, 206, 1, 1, 1),(24, 207, 1, 1, 1),(24, 208, 1, 1, 1),(24, 209, 1, 1, 1),(24, 210, 1, 1, 1),(24, 211, 1, 1, 1),(24, 212, 1, 1, 1),(24, 213, 1, 1, 1),(24, 214, 1, 1, 1),(24, 215, 1, 1, 1),(24, 216, 1, 1, 1),(24, 217, 1, 1, 1),(24, 218, 1, 1, 1),(24, 219, 1, 1, 1),(24, 220, 1, 1, 1),(24, 221, 1, 1, 1),(24, 222, 1, 1, 1),(24, 223, 1, 1, 1),(24, 224, 1, 1, 1),(24, 225, 1, 1, 2),(24, 226, 1, 1, 2),(24, 227, 1, 1, 2),(24, 228, 1, 1, 2),(24, 229, 1, 1, 2),(24, 230, 1, 1, 2),(24, 231, 1, 1, 2),(24, 232, 1, 1, 2),(24, 233, 1, 1, 2),(24, 234, 1, 1, 2),(24, 235, 1, 1, 2),(24, 236, 1, 1, 2),(24, 237, 1, 1, 2),(24, 238, 1, 1, 2),(24, 239, 1, 1, 2),(24, 240, 1, 1, 2),(24, 241, 1, 1, 2),(24, 242, 1, 1, 2),(24, 243, 1, 1, 2),(24, 244, 1, 1, 2),(24, 245, 1, 1, 2),(24, 246, 1, 1, 2),(24, 247, 1, 1, 2),(24, 248, 1, 1, 2),(24, 249, 1, 1, 2),(24, 250, 1, 1, 2),(24, 251, 1, 1, 2),(24, 252, 1, 1, 2),(24, 253, 1, 1, 2),(24, 254, 1, 1, 2),(24, 255, 1, 1, 2),(24, 256, 1, 1, 2),(24, 257, 1, 1, 1),(24, 258, 1, 1, 1),(24, 259, 1, 1, 1),(24, 260, 1, 1, 1),(24, 261, 1, 1, 1),(24, 262, 1, 1, 1),(24, 263, 1, 1, 1),(24, 264, 1, 1, 1),(24, 265, 1, 1, 1),(24, 266, 1, 1, 1),(24, 267, 1, 1, 1),(24, 268, 1, 1, 1),(24, 269, 1, 1, 1),(24, 270, 1, 1, 1),(24, 271, 1, 1, 1),(24, 272, 1, 1, 1),(24, 273, 1, 1, 1),(24, 274, 1, 1, 1),(24, 275, 1, 1, 1),(24, 276, 1, 1, 1),(24, 277, 1, 1, 1),(24, 278, 1, 1, 1),(24, 279, 1, 1, 1),(24, 280, 1, 1, 1),(24, 281, 1, 1, 1),(24, 282, 1, 1, 1),(24, 283, 1, 1, 1),(24, 284, 1, 1, 1),(24, 285, 1, 1, 1),(24, 286, 1, 1, 1),(24, 287, 1, 1, 1),(24, 288, 1, 1, 1),(24, 289, 1, 1, 2),(24, 290, 1, 1, 2),(24, 291, 1, 1, 2),(24, 292, 1, 1, 2),(24, 293, 1, 1, 2),(24, 294, 1, 1, 2),(24, 295, 1, 1, 2),(24, 296, 1, 1, 2),(24, 297, 1, 1, 2),(24, 298, 1, 1, 2),(24, 299, 1, 1, 2),(24, 300, 1, 1, 2),(24, 301, 1, 1, 2),(24, 302, 1, 1, 2),(24, 303, 1, 1, 2),(24, 304, 1, 1, 2),(24, 305, 1, 1, 2),(24, 306, 1, 1, 2),(24, 307, 1, 1, 2),(24, 308, 1, 1, 2),(24, 309, 1, 1, 2),(24, 310, 1, 1, 2),(24, 311, 1, 1, 2),(24, 312, 1, 1, 2),(24, 313, 1, 1, 2),(24, 314, 1, 1, 2),(24, 315, 1, 1, 2),(24, 316, 1, 1, 2),(24, 317, 1, 1, 2),(24, 318, 1, 1, 2),(24, 319, 1, 1, 2),(24, 320, 1, 1, 2),(24, 321, 1, 1, 1),(24, 322, 1, 1, 1),(24, 323, 1, 1, 1),(24, 324, 1, 1, 1),(24, 325, 1, 1, 1),(24, 326, 1, 1, 1),(24, 327, 1, 1, 1),(24, 328, 1, 1, 1),(24, 329, 1, 1, 1),(24, 330, 1, 1, 1),(24, 331, 1, 1, 1),(24, 332, 1, 1, 1),(24, 333, 1, 1, 1),(24, 334, 1, 1, 1),(24, 335, 1, 1, 1),(24, 336, 1, 1, 1),(24, 337, 1, 1, 1),(24, 338, 1, 1, 1),(24, 339, 1, 1, 1),(24, 340, 1, 1, 1),(24, 341, 1, 1, 1),(24, 342, 1, 1, 1),(24, 343, 1, 1, 1),(24, 344, 1, 1, 1),(24, 345, 1, 1, 1),(24, 346, 1, 1, 1),(24, 347, 1, 1, 1),(24, 348, 1, 1, 1),(24, 349, 1, 1, 1),(24, 350, 1, 1, 1),(24, 351, 1, 1, 1),(24, 352, 1, 1, 1),(24, 353, 1, 1, 2),(24, 354, 1, 1, 2),(24, 355, 1, 1, 2),(24, 356, 1, 1, 2),(24, 357, 1, 1, 2),(24, 358, 1, 1, 2),(24, 359, 1, 1, 2),(24, 360, 1, 1, 2),(24, 361, 1, 1, 2),(24, 362, 1, 1, 2),(24, 363, 1, 1, 2),(24, 364, 1, 1, 2),(24, 365, 1, 1, 2),(24, 366, 1, 1, 2),(24, 367, 1, 1, 2),(24, 368, 1, 1, 2),(24, 369, 1, 1, 2),(24, 370, 1, 1, 2),(24, 371, 1, 1, 2),(24, 372, 1, 1, 2),(24, 373, 1, 1, 2),(24, 374, 1, 1, 2),(24, 375, 1, 1, 2),(24, 376, 1, 1, 2),(24, 377, 1, 1, 2),(24, 378, 1, 1, 2),(24, 379, 1, 1, 2),(24, 380, 1, 1, 2),(24, 381, 1, 1, 2),(24, 382, 1, 1, 2),(24, 383, 1, 1, 2),(24, 384, 1, 1, 2),(24, 385, 1, 1, 1),(24, 386, 1, 1, 1),(24, 387, 1, 1, 1),(24, 388, 1, 1, 1),(24, 389, 1, 1, 1),(24, 390, 1, 1, 1),(24, 391, 1, 1, 1),(24, 392, 1, 1, 1),(24, 393, 1, 1, 1),(24, 394, 1, 1, 1),(24, 395, 1, 1, 1),(24, 396, 1, 1, 1),(24, 397, 1, 1, 1),(24, 398, 1, 1, 1),(24, 399, 1, 1, 1),(24, 400, 1, 1, 1),(24, 401, 1, 1, 1),(24, 402, 1, 1, 1),(24, 403, 1, 1, 1),(24, 404, 1, 1, 1),(24, 405, 1, 1, 1),(24, 406, 1, 1, 1),(24, 407, 1, 1, 1),(24, 408, 1, 1, 1),(24, 409, 1, 1, 1),(24, 410, 1, 1, 1),(24, 411, 1, 1, 1),(24, 412, 1, 1, 1),(24, 413, 1, 1, 1),(24, 414, 1, 1, 1),(24, 415, 1, 1, 1),(24, 416, 1, 1, 1),(24, 417, 1, 1, 2),(24, 418, 1, 1, 2),(24, 419, 1, 1, 2),(24, 420, 1, 1, 2),(24, 421, 1, 1, 2),(24, 422, 1, 1, 2),(24, 423, 1, 1, 2),(24, 424, 1, 1, 2),(24, 425, 1, 1, 2),(24, 426, 1, 1, 2),(24, 427, 1, 1, 2),(24, 428, 1, 1, 2),(24, 429, 1, 1, 2),(24, 430, 1, 1, 2),(24, 431, 1, 1, 2),(24, 432, 1, 1, 2),(24, 433, 1, 1, 2),(24, 434, 1, 1, 2),(24, 435, 1, 1, 2),(24, 436, 1, 1, 2),(24, 437, 1, 1, 2),(24, 438, 1, 1, 2),(24, 439, 1, 1, 2),(24, 440, 1, 1, 2),(24, 441, 1, 1, 2),(24, 442, 1, 1, 2),(24, 443, 1, 1, 2),(24, 444, 1, 1, 2),(24, 445, 1, 1, 2),(24, 446, 1, 1, 2),(24, 447, 1, 1, 2),(24, 448, 1, 1, 2),(24, 449, 1, 1, 1),(24, 450, 1, 1, 1),(24, 451, 1, 1, 1),(24, 452, 1, 1, 1),(24, 453, 1, 1, 1),(24, 454, 1, 1, 1),(24, 455, 1, 1, 1),(24, 456, 1, 1, 1),(24, 457, 1, 1, 1),(24, 458, 1, 1, 1),(24, 459, 1, 1, 1),(24, 460, 1, 1, 1),(24, 461, 1, 1, 1),(24, 462, 1, 1, 1),(24, 463, 1, 1, 1),(24, 464, 1, 1, 1),(24, 465, 1, 1, 1),(24, 466, 1, 1, 1),(24, 467, 1, 1, 1),(24, 468, 1, 1, 1),(24, 469, 1, 1, 1),(24, 470, 1, 1, 1),(24, 471, 1, 1, 1),(24, 472, 1, 1, 1),(24, 473, 1, 1, 1),(24, 474, 1, 1, 1),(24, 475, 1, 1, 1),(24, 476, 1, 1, 1),(24, 477, 1, 1, 1),(24, 478, 1, 1, 1),(24, 479, 1, 1, 1),(24, 480, 1, 1, 1),(24, 481, 1, 1, 2),(24, 482, 1, 1, 2),(24, 483, 1, 1, 2),(24, 484, 1, 1, 2),(24, 485, 1, 1, 2),(24, 486, 1, 1, 2),(24, 487, 1, 1, 2),(24, 488, 1, 1, 2),(24, 489, 1, 1, 2),(24, 490, 1, 1, 2),(24, 491, 1, 1, 2),(24, 492, 1, 1, 2),(24, 493, 1, 1, 2),(24, 494, 1, 1, 2),(24, 495, 1, 1, 2),(24, 496, 1, 1, 2),(24, 497, 1, 1, 2),(24, 498, 1, 1, 2),(24, 499, 1, 1, 2),(24, 500, 1, 1, 2),(24, 501, 1, 1, 2),(24, 502, 1, 1, 2),(24, 503, 1, 1, 2),(24, 504, 1, 1, 2),(24, 505, 1, 1, 2),(24, 506, 1, 1, 2),(24, 507, 1, 1, 2),(24, 508, 1, 1, 2),(24, 509, 1, 1, 2),(24, 510, 1, 1, 2),(24, 511, 1, 1, 2),(24, 512, 1, 1, 2),(24, 513, 1, 1, 1),(24, 514, 1, 1, 1),(24, 515, 1, 1, 1),(24, 516, 1, 1, 1),(24, 517, 1, 1, 1),(24, 518, 1, 1, 1),(24, 519, 1, 1, 1),(24, 520, 1, 1, 1),(24, 521, 1, 1, 1),(24, 522, 1, 1, 1),(24, 523, 1, 1, 1),(24, 524, 1, 1, 1),(24, 525, 1, 1, 1),(24, 526, 1, 1, 1),(24, 527, 1, 1, 1),(24, 528, 1, 1, 1),(24, 529, 1, 1, 1),(24, 530, 1, 1, 1),(24, 531, 1, 1, 1),(24, 532, 1, 1, 1),(24, 533, 1, 1, 1),(24, 534, 1, 1, 1),(24, 535, 1, 1, 1),(24, 536, 1, 1, 1),(24, 537, 1, 1, 1),(24, 538, 1, 1, 1),(24, 539, 1, 1, 1),(24, 540, 1, 1, 1),(24, 541, 1, 1, 1),(24, 542, 1, 1, 1),(24, 543, 1, 1, 1),(24, 544, 1, 1, 1),(24, 545, 1, 1, 2),(24, 546, 1, 1, 2),(24, 547, 1, 1, 2),(24, 548, 1, 1, 2),(24, 549, 1, 1, 2),(24, 550, 1, 1, 2),(24, 551, 1, 1, 2),(24, 552, 1, 1, 2),(24, 553, 1, 1, 2),(24, 554, 1, 1, 2),(24, 555, 1, 1, 2),(24, 556, 1, 1, 2),(24, 557, 1, 1, 2),(24, 558, 1, 1, 2),(24, 559, 1, 1, 2),(24, 560, 1, 1, 2),(24, 561, 1, 1, 2),(24, 562, 1, 1, 2),(24, 563, 1, 1, 2),(24, 564, 1, 1, 2),(24, 565, 1, 1, 2),(24, 566, 1, 1, 2),(24, 567, 1, 1, 2),(24, 568, 1, 1, 2),(24, 569, 1, 1, 2),(24, 570, 1, 1, 2),(24, 571, 1, 1, 2),(24, 572, 1, 1, 2),(24, 573, 1, 1, 2),(24, 574, 1, 1, 2),(24, 575, 1, 1, 2),(24, 576, 1, 1, 2),(24, 577, 1, 1, 1),(24, 578, 1, 1, 1),(24, 579, 1, 1, 1),(24, 580, 1, 1, 1),(24, 581, 1, 1, 1),(24, 582, 1, 1, 1),(24, 583, 1, 1, 1),(24, 584, 1, 1, 1),(24, 585, 1, 1, 1),(24, 586, 1, 1, 1),(24, 587, 1, 1, 1),(24, 588, 1, 1, 1),(24, 589, 1, 1, 1),(24, 590, 1, 1, 1),(24, 591, 1, 1, 1),(24, 592, 1, 1, 1),(24, 593, 1, 1, 1),(24, 594, 1, 1, 1),(24, 595, 1, 1, 1),(24, 596, 1, 1, 1),(24, 597, 1, 1, 1),(24, 598, 1, 1, 1),(24, 599, 1, 1, 1),(24, 600, 1, 1, 1),(24, 601, 1, 1, 1),(24, 602, 1, 1, 1),(24, 603, 1, 1, 1),(24, 604, 1, 1, 1),(24, 605, 1, 1, 1),(24, 606, 1, 1, 1),(24, 607, 1, 1, 1),(24, 608, 1, 1, 1),(24, 609, 1, 1, 2),(24, 610, 1, 1, 2),(24, 611, 1, 1, 2),(24, 612, 1, 1, 2),(24, 613, 1, 1, 2),(24, 614, 1, 1, 2),(24, 615, 1, 1, 2),(24, 616, 1, 1, 2),(24, 617, 1, 1, 2),(24, 618, 1, 1, 2),(24, 619, 1, 1, 2),(24, 620, 1, 1, 2),(24, 621, 1, 1, 2),(24, 622, 1, 1, 2),(24, 623, 1, 1, 2),(24, 624, 1, 1, 2),(24, 625, 1, 1, 2),(24, 626, 1, 1, 2),(24, 627, 1, 1, 2),(24, 628, 1, 1, 2),(24, 629, 1, 1, 2),(24, 630, 1, 1, 2),(24, 631, 1, 1, 2),(24, 632, 1, 1, 2),(24, 633, 1, 1, 2),(24, 634, 1, 1, 2),(24, 635, 1, 1, 2),(24, 636, 1, 1, 2),(24, 637, 1, 1, 2),(24, 638, 1, 1, 2),(24, 639, 1, 1, 2),(24, 640, 1, 1, 2),(24, 641, 1, 1, 1),(24, 642, 1, 1, 1),(24, 643, 1, 1, 1),(24, 644, 1, 1, 1),(24, 645, 1, 1, 1),(24, 646, 1, 1, 1),(24, 647, 1, 1, 1),(24, 648, 1, 1, 1),(24, 649, 1, 1, 1),(24, 650, 1, 1, 1),(24, 651, 1, 1, 1),(24, 652, 1, 1, 1),(24, 653, 1, 1, 1),(24, 654, 1, 1, 1),(24, 655, 1, 1, 1),(24, 656, 1, 1, 1),(24, 657, 1, 1, 1),(24, 658, 1, 1, 1),(24, 659, 1, 1, 1),(24, 660, 1, 1, 1),(24, 661, 1, 1, 1),(24, 662, 1, 1, 1),(24, 663, 1, 1, 1),(24, 664, 1, 1, 1),(24, 665, 1, 1, 1),(24, 666, 1, 1, 1),(24, 667, 1, 1, 1),(24, 668, 1, 1, 1),(24, 669, 1, 1, 1),(24, 670, 1, 1, 1),(24, 671, 1, 1, 1),(24, 672, 1, 1, 1),(24, 673, 1, 1, 2),(24, 674, 1, 1, 2),(24, 675, 1, 1, 2),(24, 676, 1, 1, 2),(24, 677, 1, 1, 2),(24, 678, 1, 1, 2),(24, 679, 1, 1, 2),(24, 680, 1, 1, 2),(24, 681, 1, 1, 2),(24, 682, 1, 1, 2),(24, 683, 1, 1, 2),(24, 684, 1, 1, 2),(24, 685, 1, 1, 2),(24, 686, 1, 1, 2),(24, 687, 1, 1, 2),(24, 688, 1, 1, 2),(24, 689, 1, 1, 2),(24, 690, 1, 1, 2),(24, 691, 1, 1, 2),(24, 692, 1, 1, 2),(24, 693, 1, 1, 2),(24, 694, 1, 1, 2),(24, 695, 1, 1, 2),(24, 696, 1, 1, 2),(24, 697, 1, 1, 2),(24, 698, 1, 1, 2),(24, 699, 1, 1, 2),(24, 700, 1, 1, 2),(24, 701, 1, 1, 2),(24, 702, 1, 1, 2),(24, 703, 1, 1, 2),(24, 704, 1, 1, 2),(24, 705, 1, 1, 1),(24, 706, 1, 1, 1),(24, 707, 1, 1, 1),(24, 708, 1, 1, 1),(24, 709, 1, 1, 1),(24, 710, 1, 1, 1),(24, 711, 1, 1, 1),(24, 712, 1, 1, 1),(24, 713, 1, 1, 1),(24, 714, 1, 1, 1),(24, 715, 1, 1, 1),(24, 716, 1, 1, 1),(24, 717, 1, 1, 1),(24, 718, 1, 1, 1),(24, 719, 1, 1, 1),(24, 720, 1, 1, 1),(24, 721, 1, 1, 1),(24, 722, 1, 1, 1),(24, 723, 1, 1, 1),(24, 724, 1, 1, 1),(24, 725, 1, 1, 1),(24, 726, 1, 1, 1),(24, 727, 1, 1, 1),(24, 728, 1, 1, 1),(24, 729, 1, 1, 1),(24, 730, 1, 1, 1),(24, 731, 1, 1, 1),(24, 732, 1, 1, 1),(24, 733, 1, 1, 1),(24, 734, 1, 1, 1),(24, 735, 1, 1, 1),(24, 736, 1, 1, 1),(24, 737, 1, 1, 2),(24, 738, 1, 1, 2),(24, 739, 1, 1, 2),(24, 740, 1, 1, 2),(24, 741, 1, 1, 2),(24, 742, 1, 1, 2),(24, 743, 1, 1, 2),(24, 744, 1, 1, 2),(24, 745, 1, 1, 2),(24, 746, 1, 1, 2),(24, 747, 1, 1, 2),(24, 748, 1, 1, 2),(24, 749, 1, 1, 2),(24, 750, 1, 1, 2),(24, 751, 1, 1, 2),(24, 752, 1, 1, 2),(24, 753, 1, 1, 2),(24, 754, 1, 1, 2),(24, 755, 1, 1, 2),(24, 756, 1, 1, 2),(24, 757, 1, 1, 2),(24, 758, 1, 1, 2),(24, 759, 1, 1, 2),(24, 760, 1, 1, 2),(24, 761, 1, 1, 2),(24, 762, 1, 1, 2),(24, 763, 1, 1, 2),(24, 764, 1, 1, 2),(24, 765, 1, 1, 2),(24, 766, 1, 1, 2),(24, 767, 1, 1, 2),(24, 768, 1, 1, 2),(24, 769, 1, 1, 1),(24, 770, 1, 1, 1),(24, 771, 1, 1, 1),(24, 772, 1, 1, 1),(24, 773, 1, 1, 1),(24, 774, 1, 1, 1),(24, 775, 1, 1, 1),(24, 776, 1, 1, 1),(24, 777, 1, 1, 1),(24, 778, 1, 1, 1),(24, 779, 1, 1, 1),(24, 780, 1, 1, 1),(24, 781, 1, 1, 1),(24, 782, 1, 1, 1),(24, 783, 1, 1, 1),(24, 784, 1, 1, 1),(24, 785, 1, 1, 1),(24, 786, 1, 1, 1),(24, 787, 1, 1, 1),(24, 788, 1, 1, 1),(24, 789, 1, 1, 1),(24, 790, 1, 1, 1),(24, 791, 1, 1, 1),(24, 792, 1, 1, 1),(24, 793, 1, 1, 1),(24, 794, 1, 1, 1),(24, 795, 1, 1, 1),(24, 796, 1, 1, 1),(24, 797, 1, 1, 1),(24, 798, 1, 1, 1),(24, 799, 1, 1, 1),(24, 800, 1, 1, 1),(24, 801, 1, 1, 2),(24, 802, 1, 1, 2),(24, 803, 1, 1, 2),(24, 804, 1, 1, 2),(24, 805, 1, 1, 2),(24, 806, 1, 1, 2),(24, 807, 1, 1, 2),(24, 808, 1, 1, 2),(24, 809, 1, 1, 2),(24, 810, 1, 1, 2),(24, 811, 1, 1, 2),(24, 812, 1, 1, 2),(24, 813, 1, 1, 2),(24, 814, 1, 1, 2),(24, 815, 1, 1, 2),(24, 816, 1, 1, 2),(24, 817, 1, 1, 2),(24, 818, 1, 1, 2),(24, 819, 1, 1, 2),(24, 820, 1, 1, 2),(24, 821, 1, 1, 2),(24, 822, 1, 1, 2),(24, 823, 1, 1, 2),(24, 824, 1, 1, 2),(24, 825, 1, 1, 2),(24, 826, 1, 1, 2),(24, 827, 1, 1, 2),(24, 828, 1, 1, 2),(24, 829, 1, 1, 2),(24, 830, 1, 1, 2),(24, 831, 1, 1, 2),(24, 832, 1, 1, 2),(24, 833, 1, 1, 1),(24, 834, 1, 1, 1),(24, 835, 1, 1, 1),(24, 836, 1, 1, 1),(24, 837, 1, 1, 1),(24, 838, 1, 1, 1),(24, 839, 1, 1, 1),(24, 840, 1, 1, 1),(24, 841, 1, 1, 1),(24, 842, 1, 1, 1),(24, 843, 1, 1, 1),(24, 844, 1, 1, 1),(24, 845, 1, 1, 1),(24, 846, 1, 1, 1),(24, 847, 1, 1, 1),(24, 848, 1, 1, 1),(24, 849, 1, 1, 1),(24, 850, 1, 1, 1),(24, 851, 1, 1, 1),(24, 852, 1, 1, 1),(24, 853, 1, 1, 1),(24, 854, 1, 1, 1),(24, 855, 1, 1, 1),(24, 856, 1, 1, 1),(24, 857, 1, 1, 1),(24, 858, 1, 1, 1),(24, 859, 1, 1, 1),(24, 860, 1, 1, 1),(24, 861, 1, 1, 1),(24, 862, 1, 1, 1),(24, 863, 1, 1, 1),(24, 864, 1, 1, 1),(24, 865, 1, 1, 2),(24, 866, 1, 1, 2),(24, 867, 1, 1, 2),(24, 868, 1, 1, 2),(24, 869, 1, 1, 2),(24, 870, 1, 1, 2),(24, 871, 1, 1, 2),(24, 872, 1, 1, 2),(24, 873, 1, 1, 2),(24, 874, 1, 1, 2),(24, 875, 1, 1, 2),(24, 876, 1, 1, 2),(24, 877, 1, 1, 2),(24, 878, 1, 1, 2),(24, 879, 1, 1, 2),(24, 880, 1, 1, 2),(24, 881, 1, 1, 2),(24, 882, 1, 1, 2),(24, 883, 1, 1, 2),(24, 884, 1, 1, 2),(24, 885, 1, 1, 2),(24, 886, 1, 1, 2),(24, 887, 1, 1, 2),(24, 888, 1, 1, 2),(24, 889, 1, 1, 2),(24, 890, 1, 1, 2),(24, 891, 1, 1, 2),(24, 892, 1, 1, 2),(24, 893, 1, 1, 2),(24, 894, 1, 1, 2),(24, 895, 1, 1, 2),(24, 896, 1, 1, 2),(24, 897, 1, 1, 1),(24, 898, 1, 1, 1),(24, 899, 1, 1, 1),(24, 900, 1, 1, 1),(24, 901, 1, 1, 1),(24, 902, 1, 1, 1),(24, 903, 1, 1, 1),(24, 904, 1, 1, 1),(24, 905, 1, 1, 1),(24, 906, 1, 1, 1),(24, 907, 1, 1, 1),(24, 908, 1, 1, 1),(24, 909, 1, 1, 1),(24, 910, 1, 1, 1),(24, 911, 1, 1, 1),(24, 912, 1, 1, 1),(24, 913, 1, 1, 1),(24, 914, 1, 1, 1),(24, 915, 1, 1, 1),(24, 916, 1, 1, 1),(24, 917, 1, 1, 1),(24, 918, 1, 1, 1),(24, 919, 1, 1, 1),(24, 920, 1, 1, 1),(24, 921, 1, 1, 1),(24, 922, 1, 1, 1),(24, 923, 1, 1, 1),(24, 924, 1, 1, 1),(24, 925, 1, 1, 1),(24, 926, 1, 1, 1),(24, 927, 1, 1, 1),(24, 928, 1, 1, 1),(24, 929, 1, 1, 2),(24, 930, 1, 1, 2),(24, 931, 1, 1, 2),(24, 932, 1, 1, 2),(24, 933, 1, 1, 2),(24, 934, 1, 1, 2),(24, 935, 1, 1, 2),(24, 936, 1, 1, 2),(24, 937, 1, 1, 2),(24, 938, 1, 1, 2),(24, 939, 1, 1, 2),(24, 940, 1, 1, 2),(24, 941, 1, 1, 2),(24, 942, 1, 1, 2),(24, 943, 1, 1, 2),(24, 944, 1, 1, 2),(24, 945, 1, 1, 2),(24, 946, 1, 1, 2),(24, 947, 1, 1, 2),(24, 948, 1, 1, 2),(24, 949, 1, 1, 2),(24, 950, 1, 1, 2),(24, 951, 1, 1, 2),(24, 952, 1, 1, 2),(24, 953, 1, 1, 2),(24, 954, 1, 1, 2),(24, 955, 1, 1, 2),(24, 956, 1, 1, 2),(24, 957, 1, 1, 2),(24, 958, 1, 1, 2),(24, 959, 1, 1, 2),(24, 960, 1, 1, 2),(24, 961, 1, 1, 1),(24, 962, 1, 1, 1),(24, 963, 1, 1, 1),(24, 964, 1, 1, 1),(24, 965, 1, 1, 1),(24, 966, 1, 1, 1),(24, 967, 1, 1, 1),(24, 968, 1, 1, 1),(24, 969, 1, 1, 1),(24, 970, 1, 1, 1),(24, 971, 1, 1, 1),(24, 972, 1, 1, 1),(24, 973, 1, 1, 1),(24, 974, 1, 1, 1),(24, 975, 1, 1, 1),(24, 976, 1, 1, 1),(24, 977, 1, 1, 1),(24, 978, 1, 1, 1),(24, 979, 1, 1, 1),(24, 980, 1, 1, 1),(24, 981, 1, 1, 1),(24, 982, 1, 1, 1),(24, 983, 1, 1, 1),(24, 984, 1, 1, 1),(24, 985, 1, 1, 1),(24, 986, 1, 1, 1),(24, 987, 1, 1, 1),(24, 988, 1, 1, 1),(24, 989, 1, 1, 1),(24, 990, 1, 1, 1),(24, 991, 1, 1, 1),(24, 992, 1, 1, 1),(24, 993, 1, 1, 2),(24, 994, 1, 1, 2),(24, 995, 1, 1, 2),(24, 996, 1, 1, 2),(24, 997, 1, 1, 2),(24, 998, 1, 1, 2),(24, 999, 1, 1, 2),(24, 1000, 1, 1, 2),(24, 1001, 1, 1, 2),(24, 1002, 1, 1, 2),(24, 1003, 1, 1, 2),(24, 1004, 1, 1, 2),(24, 1005, 1, 1, 2),(24, 1006, 1, 1, 2),(24, 1007, 1, 1, 2),(24, 1008, 1, 1, 2),(24, 1009, 1, 1, 2),(24, 1010, 1, 1, 2),(24, 1011, 1, 1, 2),(24, 1012, 1, 1, 2),(24, 1013, 1, 1, 2),(24, 1014, 1, 1, 2),(24, 1015, 1, 1, 2),(24, 1016, 1, 1, 2),(24, 1017, 1, 1, 2),(24, 1018, 1, 1, 2),(24, 1019, 1, 1, 2),(24, 1020, 1, 1, 2),(24, 1021, 1, 1, 2),(24, 1022, 1, 1, 2),(24, 1023, 1, 1, 2),(24, 1024, 1, 1, 2),(24, 1025, 1, 1, 1),(24, 1026, 1, 1, 1),(24, 1027, 1, 1, 1),(24, 1028, 1, 1, 1),(24, 1029, 1, 1, 1),(24, 1030, 1, 1, 1),(24, 1031, 1, 1, 1),(24, 1032, 1, 1, 1),(24, 1033, 1, 1, 1),(24, 1034, 1, 1, 1),(24, 1035, 1, 1, 1),(24, 1036, 1, 1, 1),(24, 1037, 1, 1, 1),(24, 1038, 1, 1, 1),(24, 1039, 1, 1, 1),(24, 1040, 1, 1, 1),(24, 1041, 1, 1, 1),(24, 1042, 1, 1, 1),(24, 1043, 1, 1, 1),(24, 1044, 1, 1, 1),(24, 1045, 1, 1, 1),(24, 1046, 1, 1, 1),(24, 1047, 1, 1, 1),(24, 1048, 1, 1, 1),(24, 1049, 1, 1, 1),(24, 1050, 1, 1, 1),(24, 1051, 1, 1, 1),(24, 1052, 1, 1, 1),(24, 1053, 1, 1, 1),(24, 1054, 1, 1, 1),(24, 1055, 1, 1, 1),(24, 1056, 1, 1, 1),(24, 1057, 1, 1, 2),(24, 1058, 1, 1, 2),(24, 1059, 1, 1, 2),(24, 1060, 1, 1, 2),(24, 1061, 1, 1, 2),(24, 1062, 1, 1, 2),(24, 1063, 1, 1, 2),(24, 1064, 1, 1, 2),(24, 1065, 1, 1, 2),(24, 1066, 1, 1, 2),(24, 1067, 1, 1, 2),(24, 1068, 1, 1, 2),(24, 1069, 1, 1, 2),(24, 1070, 1, 1, 2),(24, 1071, 1, 1, 2),(24, 1072, 1, 1, 2),(24, 1073, 1, 1, 2),(24, 1074, 1, 1, 2),(24, 1075, 1, 1, 2),(24, 1076, 1, 1, 2),(24, 1077, 1, 1, 2),(24, 1078, 1, 1, 2),(24, 1079, 1, 1, 2),(24, 1080, 1, 1, 2),(24, 1081, 1, 1, 2),(24, 1082, 1, 1, 2),(24, 1083, 1, 1, 2),(24, 1084, 1, 1, 2),(24, 1085, 1, 1, 2),(24, 1086, 1, 1, 2),(24, 1087, 1, 1, 2),(24, 1088, 1, 1, 2),(24, 1089, 1, 1, 1),(24, 1090, 1, 1, 1),(24, 1091, 1, 1, 1),(24, 1092, 1, 1, 1),(24, 1093, 1, 1, 1),(24, 1094, 1, 1, 1),(24, 1095, 1, 1, 1),(24, 1096, 1, 1, 1),(24, 1097, 1, 1, 1),(24, 1098, 1, 1, 1),(24, 1099, 1, 1, 1),(24, 1100, 1, 1, 1),(24, 1101, 1, 1, 1),(24, 1102, 1, 1, 1),(24, 1103, 1, 1, 1),(24, 1104, 1, 1, 1),(24, 1105, 1, 1, 1),(24, 1106, 1, 1, 1),(24, 1107, 1, 1, 1),(24, 1108, 1, 1, 1),(24, 1109, 1, 1, 1),(24, 1110, 1, 1, 1),(24, 1111, 1, 1, 1),(24, 1112, 1, 1, 1),(24, 1113, 1, 1, 1),(24, 1114, 1, 1, 1),(24, 1115, 1, 1, 1),(24, 1116, 1, 1, 1),(24, 1117, 1, 1, 1),(24, 1118, 1, 1, 1),(24, 1119, 1, 1, 1),(24, 1120, 1, 1, 1),(24, 1121, 1, 1, 2),(24, 1122, 1, 1, 2),(24, 1123, 1, 1, 2),(24, 1124, 1, 1, 2),(24, 1125, 1, 1, 2),(24, 1126, 1, 1, 2),(24, 1127, 1, 1, 2),(24, 1128, 1, 1, 2),(24, 1129, 1, 1, 2),(24, 1130, 1, 1, 2),(24, 1131, 1, 1, 2),(24, 1132, 1, 1, 2),(24, 1133, 1, 1, 2),(24, 1134, 1, 1, 2),(24, 1135, 1, 1, 2),(24, 1136, 1, 1, 2),(24, 1137, 1, 1, 2),(24, 1138, 1, 1, 2),(24, 1139, 1, 1, 2),(24, 1140, 1, 1, 2),(24, 1141, 1, 1, 2),(24, 1142, 1, 1, 2),(24, 1143, 1, 1, 2),(24, 1144, 1, 1, 2),(24, 1145, 1, 1, 2),(24, 1146, 1, 1, 2),(24, 1147, 1, 1, 2),(24, 1148, 1, 1, 2),(24, 1149, 1, 1, 2),(24, 1150, 1, 1, 2),(24, 1151, 1, 1, 2),(24, 1152, 1, 1, 2),(24, 1153, 1, 1, 1),(24, 1154, 1, 1, 1),(24, 1155, 1, 1, 1),(24, 1156, 1, 1, 1),(24, 1157, 1, 1, 1),(24, 1158, 1, 1, 1),(24, 1159, 1, 1, 1),(24, 1160, 1, 1, 1),(24, 1161, 1, 1, 1),(24, 1162, 1, 1, 1),(24, 1163, 1, 1, 1),(24, 1164, 1, 1, 1),(24, 1165, 1, 1, 1),(24, 1166, 1, 1, 1),(24, 1167, 1, 1, 1),(24, 1168, 1, 1, 1),(24, 1169, 1, 1, 1),(24, 1170, 1, 1, 1),(24, 1171, 1, 1, 1),(24, 1172, 1, 1, 1),(24, 1173, 1, 1, 1),(24, 1174, 1, 1, 1),(24, 1175, 1, 1, 1),(24, 1176, 1, 1, 1),(24, 1177, 1, 1, 1),(24, 1178, 1, 1, 1),(24, 1179, 1, 1, 1),(24, 1180, 1, 1, 1),(24, 1181, 1, 1, 1),(24, 1182, 1, 1, 1),(24, 1183, 1, 1, 1),(24, 1184, 1, 1, 1),(24, 1185, 1, 1, 2),(24, 1186, 1, 1, 2),(24, 1187, 1, 1, 2),(24, 1188, 1, 1, 2),(24, 1189, 1, 1, 2),(24, 1190, 1, 1, 2),(24, 1191, 1, 1, 2),(24, 1192, 1, 1, 2),(24, 1193, 1, 1, 2),(24, 1194, 1, 1, 2),(24, 1195, 1, 1, 2),(24, 1196, 1, 1, 2),(24, 1197, 1, 1, 2),(24, 1198, 1, 1, 2),(24, 1199, 1, 1, 2),(24, 1200, 1, 1, 2),(24, 1201, 1, 1, 2),(24, 1202, 1, 1, 2),(24, 1203, 1, 1, 2),(24, 1204, 1, 1, 2),(24, 1205, 1, 1, 2),(24, 1206, 1, 1, 2),(24, 1207, 1, 1, 2),(24, 1208, 1, 1, 2),(24, 1209, 1, 1, 2),(24, 1210, 1, 1, 2),(24, 1211, 1, 1, 2),(24, 1212, 1, 1, 2),(24, 1213, 1, 1, 2),(24, 1214, 1, 1, 2),(24, 1215, 1, 1, 2),(24, 1216, 1, 1, 2),(24, 1217, 1, 1, 1),(24, 1218, 1, 1, 1),(24, 1219, 1, 1, 1),(24, 1220, 1, 1, 1),(24, 1221, 1, 1, 1),(24, 1222, 1, 1, 1),(24, 1223, 1, 1, 1),(24, 1224, 1, 1, 1),(24, 1225, 1, 1, 1),(24, 1226, 1, 1, 1),(24, 1227, 1, 1, 1),(24, 1228, 1, 1, 1),(24, 1229, 1, 1, 1),(24, 1230, 1, 1, 1),(24, 1231, 1, 1, 1),(24, 1232, 1, 1, 1),(24, 1233, 1, 1, 1),(24, 1234, 1, 1, 1),(24, 1235, 1, 1, 1),(24, 1236, 1, 1, 1),(24, 1237, 1, 1, 1),(24, 1238, 1, 1, 1),(24, 1239, 1, 1, 1),(24, 1240, 1, 1, 1),(24, 1241, 1, 1, 1),(24, 1242, 1, 1, 1),(24, 1243, 1, 1, 1),(24, 1244, 1, 1, 1),(24, 1245, 1, 1, 1),(24, 1246, 1, 1, 1),(24, 1247, 1, 1, 1),(24, 1248, 1, 1, 1),(24, 1249, 1, 1, 2),(24, 1250, 1, 1, 2),(24, 1251, 1, 1, 2),(24, 1252, 1, 1, 2),(24, 1253, 1, 1, 2),(24, 1254, 1, 1, 2),(24, 1255, 1, 1, 2),(24, 1256, 1, 1, 2),(24, 1257, 1, 1, 2),(24, 1258, 1, 1, 2),(24, 1259, 1, 1, 2),(24, 1260, 1, 1, 2),(24, 1261, 1, 1, 2),(24, 1262, 1, 1, 2),(24, 1263, 1, 1, 2),(24, 1264, 1, 1, 2),(24, 1265, 1, 1, 2),(24, 1266, 1, 1, 2),(24, 1267, 1, 1, 2),(24, 1268, 1, 1, 2),(24, 1269, 1, 1, 2),(24, 1270, 1, 1, 2),(24, 1271, 1, 1, 2),(24, 1272, 1, 1, 2),(24, 1273, 1, 1, 2),(24, 1274, 1, 1, 2),(24, 1275, 1, 1, 2),(24, 1276, 1, 1, 2),(24, 1277, 1, 1, 2),(24, 1278, 1, 1, 2),(24, 1279, 1, 1, 2),(24, 1280, 1, 1, 2),(24, 1281, 1, 1, 1),(24, 1282, 1, 1, 1),(24, 1283, 1, 1, 1),(24, 1284, 1, 1, 1),(24, 1285, 1, 1, 1),(24, 1286, 1, 1, 1),(24, 1287, 1, 1, 1),(24, 1288, 1, 1, 1),(24, 1289, 1, 1, 1),(24, 1290, 1, 1, 1),(24, 1291, 1, 1, 1),(24, 1292, 1, 1, 1),(24, 1293, 1, 1, 1),(24, 1294, 1, 1, 1),(24, 1295, 1, 1, 1),(24, 1296, 1, 1, 1),(24, 1297, 1, 1, 1),(24, 1298, 1, 1, 1),(24, 1299, 1, 1, 1),(24, 1300, 1, 1, 1),(24, 1301, 1, 1, 1),(24, 1302, 1, 1, 1),(24, 1303, 1, 1, 1),(24, 1304, 1, 1, 1),(24, 1305, 1, 1, 1),(24, 1306, 1, 1, 1),(24, 1307, 1, 1, 1),(24, 1308, 1, 1, 1),(24, 1309, 1, 1, 1),(24, 1310, 1, 1, 1),(24, 1311, 1, 1, 1),(24, 1312, 1, 1, 1),(24, 1313, 1, 1, 2),(24, 1314, 1, 1, 2),(24, 1315, 1, 1, 2),(24, 1316, 1, 1, 2),(24, 1317, 1, 1, 2),(24, 1318, 1, 1, 2),(24, 1319, 1, 1, 2),(24, 1320, 1, 1, 2),(24, 1321, 1, 1, 2),(24, 1322, 1, 1, 2),(24, 1323, 1, 1, 2),(24, 1324, 1, 1, 2),(24, 1325, 1, 1, 2),(24, 1326, 1, 1, 2),(24, 1327, 1, 1, 2),(24, 1328, 1, 1, 2),(24, 1329, 1, 1, 2),(24, 1330, 1, 1, 2),(24, 1331, 1, 1, 2),(24, 1332, 1, 1, 2),(24, 1333, 1, 1, 2),(24, 1334, 1, 1, 2),(24, 1335, 1, 1, 2),(24, 1336, 1, 1, 2),(24, 1337, 1, 1, 2),(24, 1338, 1, 1, 2),(24, 1339, 1, 1, 2),(24, 1340, 1, 1, 2),(24, 1341, 1, 1, 2),(24, 1342, 1, 1, 2),(24, 1343, 1, 1, 2),(24, 1344, 1, 1, 2),(24, 1345, 1, 1, 1),(24, 1346, 1, 1, 1),(24, 1347, 1, 1, 1),(24, 1348, 1, 1, 1),(24, 1349, 1, 1, 1),(24, 1350, 1, 1, 1),(24, 1351, 1, 1, 1),(24, 1352, 1, 1, 1),(24, 1353, 1, 1, 1),(24, 1354, 1, 1, 1),(24, 1355, 1, 1, 1),(24, 1356, 1, 1, 1),(24, 1357, 1, 1, 1),(24, 1358, 1, 1, 1),(24, 1359, 1, 1, 1),(24, 1360, 1, 1, 1),(24, 1361, 1, 1, 1),(24, 1362, 1, 1, 1),(24, 1363, 1, 1, 1),(24, 1364, 1, 1, 1),(24, 1365, 1, 1, 1),(24, 1366, 1, 1, 1),(24, 1367, 1, 1, 1),(24, 1368, 1, 1, 1),(24, 1369, 1, 1, 1),(24, 1370, 1, 1, 1),(24, 1371, 1, 1, 1),(24, 1372, 1, 1, 1),(24, 1373, 1, 1, 1),(24, 1374, 1, 1, 1),(24, 1375, 1, 1, 1),(24, 1376, 1, 1, 1),(24, 1377, 1, 1, 2),(24, 1378, 1, 1, 2),(24, 1379, 1, 1, 2),(24, 1380, 1, 1, 2),(24, 1381, 1, 1, 2),(24, 1382, 1, 1, 2),(24, 1383, 1, 1, 2),(24, 1384, 1, 1, 2),(24, 1385, 1, 1, 2),(24, 1386, 1, 1, 2),(24, 1387, 1, 1, 2),(24, 1388, 1, 1, 2),(24, 1389, 1, 1, 2),(24, 1390, 1, 1, 2),(24, 1391, 1, 1, 2),(24, 1392, 1, 1, 2),(24, 1393, 1, 1, 2),(24, 1394, 1, 1, 2),(24, 1395, 1, 1, 2),(24, 1396, 1, 1, 2),(24, 1397, 1, 1, 2),(24, 1398, 1, 1, 2),(24, 1399, 1, 1, 2),(24, 1400, 1, 1, 2),(24, 1401, 1, 1, 2),(24, 1402, 1, 1, 2),(24, 1403, 1, 1, 2),(24, 1404, 1, 1, 2),(24, 1405, 1, 1, 2),(24, 1406, 1, 1, 2),(24, 1407, 1, 1, 2),(24, 1408, 1, 1, 2),(24, 1409, 1, 1, 1),(24, 1410, 1, 1, 1),(24, 1411, 1, 1, 1),(24, 1412, 1, 1, 1),(24, 1413, 1, 1, 1),(24, 1414, 1, 1, 1),(24, 1415, 1, 1, 1),(24, 1416, 1, 1, 1),(24, 1417, 1, 1, 1),(24, 1418, 1, 1, 1),(24, 1419, 1, 1, 1),(24, 1420, 1, 1, 1),(24, 1421, 1, 1, 1),(24, 1422, 1, 1, 1),(24, 1423, 1, 1, 1),(24, 1424, 1, 1, 1),(24, 1425, 1, 1, 1),(24, 1426, 1, 1, 1),(24, 1427, 1, 1, 1),(24, 1428, 1, 1, 1),(24, 1429, 1, 1, 1),(24, 1430, 1, 1, 1),(24, 1431, 1, 1, 1),(24, 1432, 1, 1, 1),(24, 1433, 1, 1, 1),(24, 1434, 1, 1, 1),(24, 1435, 1, 1, 1),(24, 1436, 1, 1, 1),(24, 1437, 1, 1, 1),(24, 1438, 1, 1, 1),(24, 1439, 1, 1, 1),(24, 1440, 1, 1, 1),(24, 1441, 1, 1, 2),(24, 1442, 1, 1, 2),(24, 1443, 1, 1, 2),(24, 1444, 1, 1, 2),(24, 1445, 1, 1, 2),(24, 1446, 1, 1, 2),(24, 1447, 1, 1, 2),(24, 1448, 1, 1, 2),(24, 1449, 1, 1, 2),(24, 1450, 1, 1, 2),(24, 1451, 1, 1, 2),(24, 1452, 1, 1, 2),(24, 1453, 1, 1, 2),(24, 1454, 1, 1, 2),(24, 1455, 1, 1, 2),(24, 1456, 1, 1, 2),(24, 1457, 1, 1, 2),(24, 1458, 1, 1, 2),(24, 1459, 1, 1, 2),(24, 1460, 1, 1, 2),(24, 1461, 1, 1, 2),(24, 1462, 1, 1, 2),(24, 1463, 1, 1, 2),(24, 1464, 1, 1, 2),(24, 1465, 1, 1, 2),(24, 1466, 1, 1, 2),(24, 1467, 1, 1, 2),(24, 1468, 1, 1, 2),(24, 1469, 1, 1, 2),(24, 1470, 1, 1, 2),(24, 1471, 1, 1, 2),(24, 1472, 1, 1, 2),(24, 1473, 2, 1, 1),(24, 1474, 2, 1, 1),(24, 1475, 2, 1, 1),(24, 1476, 2, 1, 1),(24, 1477, 2, 1, 1),(24, 1478, 2, 1, 1),(24, 1479, 2, 1, 1),(24, 1480, 2, 1, 1),(24, 1481, 2, 1, 1),(24, 1482, 2, 1, 1),(24, 1483, 2, 1, 1),(24, 1484, 2, 1, 1),(24, 1485, 2, 1, 1),(24, 1486, 2, 1, 1),(24, 1487, 2, 1, 1),(24, 1488, 2, 1, 1),(24, 1489, 3, 1, 1),(24, 1490, 3, 1, 1),(24, 1491, 3, 1, 1),(24, 1492, 3, 1, 1),(24, 1493, 3, 1, 1),(24, 1494, 3, 1, 1),(24, 1495, 3, 1, 1),(24, 1496, 3, 1, 1),(24, 1497, 4, 1, 1),(24, 1498, 4, 1, 1),(24, 1499, 4, 1, 1),(24, 1500, 4, 1, 1),(24, 1501, 4, 1, 1),(24, 1502, 4, 1, 1),(24, 1503, 4, 1, 1),(24, 1504, 4, 1, 1),(24, 1505, 2, 1, 2),(24, 1506, 2, 1, 2),(24, 1507, 2, 1, 2),(24, 1508, 2, 1, 2),(24, 1509, 2, 1, 2),(24, 1510, 2, 1, 2),(24, 1511, 2, 1, 2),(24, 1512, 2, 1, 2),(24, 1513, 2, 1, 2),(24, 1514, 2, 1, 2),(24, 1515, 2, 1, 2),(24, 1516, 2, 1, 2),(24, 1517, 2, 1, 2),(24, 1518, 2, 1, 2),(24, 1519, 2, 1, 2),(24, 1520, 2, 1, 2),(24, 1521, 3, 1, 2),(24, 1522, 3, 1, 2),(24, 1523, 3, 1, 2),(24, 1524, 3, 1, 2),(24, 1525, 3, 1, 2),(24, 1526, 3, 1, 2),(24, 1527, 3, 1, 2),(24, 1528, 3, 1, 2),(24, 1529, 4, 1, 2),(24, 1530, 4, 1, 2),(24, 1531, 4, 1, 2),(24, 1532, 4, 1, 2),(24, 1533, 4, 1, 2),(24, 1534, 4, 1, 2),(24, 1535, 4, 1, 2),(24, 1536, 4, 1, 2),(25, 1, 5, 1, 1),(25, 2, 5, 1, 1),(25, 3, 5, 1, 1),(25, 4, 5, 1, 1),(25, 5, 5, 1, 1),(25, 6, 5, 1, 1),(25, 7, 5, 1, 1),(25, 8, 5, 1, 1),(25, 9, 5, 1, 1),(25, 10, 5, 1, 1),(25, 11, 5, 1, 1),(25, 12, 5, 1, 1),(25, 13, 5, 1, 1),(25, 14, 5, 1, 1),(25, 15, 5, 1, 1),(25, 16, 5, 1, 1),(25, 17, 5, 1, 1),(25, 18, 1, 1, 1),(25, 19, 1, 1, 1),(25, 20, 1, 1, 1),(25, 21, 1, 1, 1),(25, 22, 1, 1, 1),(25, 23, 1, 1, 1),(25, 24, 1, 1, 1),(25, 25, 1, 1, 1),(25, 26, 1, 1, 1),(25, 27, 1, 1, 1),(25, 28, 1, 1, 1),(25, 29, 1, 1, 1),(25, 30, 1, 1, 1),(25, 31, 1, 1, 1),(25, 32, 5, 1, 1),(25, 33, 5, 1, 1),(25, 34, 1, 1, 1),(25, 35, 1, 1, 1),(25, 36, 1, 1, 1),(25, 37, 1, 1, 1),(25, 38, 1, 1, 1),(25, 39, 1, 1, 1),(25, 40, 1, 1, 1),(25, 41, 1, 1, 1),(25, 42, 1, 1, 1),(25, 43, 1, 1, 1),(25, 44, 1, 1, 1),(25, 45, 1, 1, 1),(25, 46, 1, 1, 1),(25, 47, 1, 1, 1),(25, 48, 5, 1, 1),(25, 49, 5, 1, 1),(25, 50, 1, 1, 1),(25, 51, 1, 1, 1),(25, 52, 1, 1, 1),(25, 53, 1, 1, 1),(25, 54, 1, 1, 1),(25, 55, 1, 1, 1),(25, 56, 1, 1, 1),(25, 57, 1, 1, 1),(25, 58, 1, 1, 1),(25, 59, 1, 1, 1),(25, 60, 1, 1, 1),(25, 61, 1, 1, 1),(25, 62, 1, 1, 1),(25, 63, 1, 1, 1),(25, 64, 5, 1, 1),(25, 65, 5, 1, 1),(25, 66, 1, 1, 1),(25, 67, 1, 1, 1),(25, 68, 1, 1, 1),(25, 69, 1, 1, 1),(25, 70, 1, 1, 1),(25, 71, 1, 1, 1),(25, 72, 1, 1, 1),(25, 73, 1, 1, 1),(25, 74, 1, 1, 1),(25, 75, 1, 1, 1),(25, 76, 1, 1, 1),(25, 77, 1, 1, 1),(25, 78, 1, 1, 1),(25, 79, 1, 1, 1),(25, 80, 5, 1, 1),(25, 81, 5, 1, 1),(25, 82, 1, 1, 1),(25, 83, 1, 1, 1),(25, 84, 1, 1, 1),(25, 85, 1, 1, 1),(25, 86, 1, 1, 1),(25, 87, 1, 1, 1),(25, 88, 1, 1, 1),(25, 89, 1, 1, 1),(25, 90, 1, 1, 1),(25, 91, 1, 1, 1),(25, 92, 1, 1, 1),(25, 93, 1, 1, 1),(25, 94, 1, 1, 1),(25, 95, 1, 1, 1),(25, 96, 5, 1, 1),(25, 97, 5, 1, 1),(25, 98, 1, 1, 1),(25, 99, 1, 1, 1),(25, 100, 1, 1, 1),(25, 101, 1, 1, 1),(25, 102, 1, 1, 1),(25, 103, 1, 1, 1),(25, 104, 1, 1, 1),(25, 105, 1, 1, 1),(25, 106, 1, 1, 1),(25, 107, 1, 1, 1),(25, 108, 1, 1, 1),(25, 109, 1, 1, 1),(25, 110, 1, 1, 1),(25, 111, 1, 1, 1),(25, 112, 5, 1, 1),(25, 113, 5, 1, 1),(25, 114, 1, 1, 1),(25, 115, 1, 1, 1),(25, 116, 1, 1, 1),(25, 117, 1, 1, 1),(25, 118, 1, 1, 1),(25, 119, 1, 1, 1),(25, 120, 1, 1, 1),(25, 121, 1, 1, 1),(25, 122, 1, 1, 1),(25, 123, 1, 1, 1),(25, 124, 1, 1, 1),(25, 125, 1, 1, 1),(25, 126, 1, 1, 1),(25, 127, 1, 1, 1),(25, 128, 5, 1, 1),(25, 129, 5, 1, 1),(25, 130, 1, 1, 1),(25, 131, 1, 1, 1),(25, 132, 1, 1, 1),(25, 133, 1, 1, 1),(25, 134, 1, 1, 1),(25, 135, 1, 1, 1),(25, 136, 1, 1, 1),(25, 137, 1, 1, 1),(25, 138, 1, 1, 1),(25, 139, 1, 1, 1),(25, 140, 1, 1, 1),(25, 141, 1, 1, 1),(25, 142, 1, 1, 1),(25, 143, 1, 1, 1),(25, 144, 5, 1, 1),(25, 145, 5, 1, 1),(25, 146, 1, 1, 1),(25, 147, 1, 1, 1),(25, 148, 1, 1, 1),(25, 149, 1, 1, 1),(25, 150, 1, 1, 1),(25, 151, 1, 1, 1),(25, 152, 1, 1, 1),(25, 153, 1, 1, 1),(25, 154, 1, 1, 1),(25, 155, 1, 1, 1),(25, 156, 1, 1, 1),(25, 157, 1, 1, 1),(25, 158, 1, 1, 1),(25, 159, 1, 1, 1),(25, 160, 5, 1, 1),(25, 161, 5, 1, 1),(25, 162, 1, 1, 1),(25, 163, 1, 1, 1),(25, 164, 1, 1, 1),(25, 165, 1, 1, 1),(25, 166, 1, 1, 1),(25, 167, 1, 1, 1),(25, 168, 1, 1, 1),(25, 169, 1, 1, 1),(25, 170, 1, 1, 1),(25, 171, 1, 1, 1),(25, 172, 1, 1, 1),(25, 173, 1, 1, 1),(25, 174, 1, 1, 1),(25, 175, 1, 1, 1),(25, 176, 5, 1, 1),(25, 177, 5, 1, 1),(25, 178, 1, 1, 1),(25, 179, 1, 1, 1),(25, 180, 1, 1, 1),(25, 181, 1, 1, 1),(25, 182, 1, 1, 1),(25, 183, 1, 1, 1),(25, 184, 1, 1, 1),(25, 185, 1, 1, 1),(25, 186, 1, 1, 1),(25, 187, 1, 1, 1),(25, 188, 1, 1, 1),(25, 189, 1, 1, 1),(25, 190, 1, 1, 1),(25, 191, 1, 1, 1),(25, 192, 5, 1, 1),(25, 193, 5, 1, 1),(25, 194, 1, 1, 1),(25, 195, 1, 1, 1),(25, 196, 1, 1, 1),(25, 197, 1, 1, 1),(25, 198, 1, 1, 1),(25, 199, 1, 1, 1),(25, 200, 1, 1, 1),(25, 201, 1, 1, 1),(25, 202, 1, 1, 1),(25, 203, 1, 1, 1),(25, 204, 1, 1, 1),(25, 205, 1, 1, 1),(25, 206, 1, 1, 1),(25, 207, 1, 1, 1),(25, 208, 5, 1, 1),(25, 209, 5, 1, 1),(25, 210, 1, 1, 1),(25, 211, 1, 1, 1),(25, 212, 1, 1, 1),(25, 213, 1, 1, 1),(25, 214, 1, 1, 1),(25, 215, 1, 1, 1),(25, 216, 1, 1, 1),(25, 217, 1, 1, 1),(25, 218, 1, 1, 1),(25, 219, 1, 1, 1),(25, 220, 1, 1, 1),(25, 221, 1, 1, 1),(25, 222, 1, 1, 1),(25, 223, 1, 1, 1),(25, 224, 5, 1, 1),(25, 225, 5, 1, 1),(25, 226, 1, 1, 1),(25, 227, 1, 1, 1),(25, 228, 1, 1, 1),(25, 229, 1, 1, 1),(25, 230, 1, 1, 1),(25, 231, 1, 1, 1),(25, 232, 1, 1, 1),(25, 233, 1, 1, 1),(25, 234, 1, 1, 1),(25, 235, 1, 1, 1),(25, 236, 1, 1, 1),(25, 237, 1, 1, 1),(25, 238, 1, 1, 1),(25, 239, 1, 1, 1),(25, 240, 5, 1, 1),(25, 241, 5, 1, 1),(25, 242, 1, 1, 1),(25, 243, 1, 1, 1),(25, 244, 1, 1, 1),(25, 245, 1, 1, 1),(25, 246, 1, 1, 1),(25, 247, 1, 1, 1),(25, 248, 1, 1, 1),(25, 249, 1, 1, 1),(25, 250, 1, 1, 1),(25, 251, 1, 1, 1),(25, 252, 1, 1, 1),(25, 253, 1, 1, 1),(25, 254, 1, 1, 1),(25, 255, 1, 1, 1),(25, 256, 5, 1, 1),(25, 257, 5, 1, 1),(25, 258, 1, 1, 1),(25, 259, 1, 1, 1),(25, 260, 1, 1, 1),(25, 261, 1, 1, 1),(25, 262, 1, 1, 1),(25, 263, 1, 1, 1),(25, 264, 1, 1, 1),(25, 265, 1, 1, 1),(25, 266, 1, 1, 1),(25, 267, 1, 1, 1),(25, 268, 1, 1, 1),(25, 269, 1, 1, 1),(25, 270, 1, 1, 1),(25, 271, 1, 1, 1),(25, 272, 5, 1, 1),(25, 273, 5, 1, 1),(25, 274, 1, 1, 1),(25, 275, 1, 1, 1),(25, 276, 1, 1, 1),(25, 277, 1, 1, 1),(25, 278, 1, 1, 1),(25, 279, 1, 1, 1),(25, 280, 1, 1, 1),(25, 281, 1, 1, 1),(25, 282, 1, 1, 1),(25, 283, 1, 1, 1),(25, 284, 1, 1, 1),(25, 285, 1, 1, 1),(25, 286, 1, 1, 1),(25, 287, 1, 1, 1),(25, 288, 5, 1, 1),(25, 289, 5, 1, 1),(25, 290, 1, 1, 1),(25, 291, 1, 1, 1),(25, 292, 1, 1, 1),(25, 293, 1, 1, 1),(25, 294, 1, 1, 1),(25, 295, 1, 1, 1),(25, 296, 1, 1, 1),(25, 297, 1, 1, 1),(25, 298, 1, 1, 1),(25, 299, 1, 1, 1),(25, 300, 1, 1, 1),(25, 301, 1, 1, 1),(25, 302, 1, 1, 1),(25, 303, 1, 1, 1),(25, 304, 5, 1, 1),(25, 305, 5, 1, 1),(25, 306, 1, 1, 1),(25, 307, 1, 1, 1),(25, 308, 1, 1, 1),(25, 309, 1, 1, 1),(25, 310, 1, 1, 1),(25, 311, 1, 1, 1),(25, 312, 1, 1, 1),(25, 313, 1, 1, 1),(25, 314, 1, 1, 1),(25, 315, 1, 1, 1),(25, 316, 1, 1, 1),(25, 317, 1, 1, 1),(25, 318, 1, 1, 1),(25, 319, 1, 1, 1),(25, 320, 5, 1, 1),(25, 321, 5, 1, 1),(25, 322, 1, 1, 1),(25, 323, 1, 1, 1),(25, 324, 1, 1, 1),(25, 325, 1, 1, 1),(25, 326, 1, 1, 1),(25, 327, 1, 1, 1),(25, 328, 1, 1, 1),(25, 329, 1, 1, 1),(25, 330, 1, 1, 1),(25, 331, 1, 1, 1),(25, 332, 1, 1, 1),(25, 333, 1, 1, 1),(25, 334, 1, 1, 1),(25, 335, 1, 1, 1),(25, 336, 5, 1, 1),(25, 337, 5, 1, 1),(25, 338, 1, 1, 1),(25, 339, 1, 1, 1),(25, 340, 1, 1, 1),(25, 341, 1, 1, 1),(25, 342, 1, 1, 1),(25, 343, 1, 1, 1),(25, 344, 1, 1, 1),(25, 345, 1, 1, 1),(25, 346, 1, 1, 1),(25, 347, 1, 1, 1),(25, 348, 1, 1, 1),(25, 349, 1, 1, 1),(25, 350, 1, 1, 1),(25, 351, 1, 1, 1),(25, 352, 5, 1, 1),(25, 353, 5, 1, 1),(25, 354, 1, 1, 1),(25, 355, 1, 1, 1),(25, 356, 1, 1, 1),(25, 357, 1, 1, 1),(25, 358, 1, 1, 1),(25, 359, 1, 1, 1),(25, 360, 1, 1, 1),(25, 361, 2, 1, 1),(25, 362, 2, 1, 1),(25, 363, 2, 1, 1),(25, 364, 2, 1, 1),(25, 365, 3, 1, 1),(25, 366, 3, 1, 1),(25, 367, 4, 1, 1),(25, 368, 5, 1, 1),(25, 369, 5, 1, 1),(25, 370, 5, 1, 1),(25, 371, 5, 1, 1),(25, 372, 5, 1, 1),(25, 373, 5, 1, 1),(25, 374, 5, 1, 1),(25, 375, 5, 1, 1),(25, 376, 5, 1, 1),(25, 377, 5, 1, 1),(25, 378, 5, 1, 1),(25, 379, 5, 1, 1),(25, 380, 5, 1, 1),(25, 381, 5, 1, 1),(25, 382, 5, 1, 1),(25, 383, 5, 1, 1),(25, 384, 5, 1, 1),(26, 1, 5, 1, 1),(26, 2, 5, 3, 1),(26, 3, 5, 1, 1),(26, 4, 5, 3, 1),(26, 5, 5, 1, 1),(26, 6, 5, 3, 1),(26, 7, 5, 1, 1),(26, 8, 5, 3, 1),(26, 9, 5, 1, 1),(26, 10, 5, 3, 1),(26, 11, 5, 1, 1),(26, 12, 5, 3, 1),(26, 13, 5, 1, 1),(26, 14, 5, 3, 1),(26, 15, 5, 1, 1),(26, 16, 5, 3, 1),(26, 17, 5, 1, 1),(26, 18, 5, 3, 1),(26, 19, 5, 1, 1),(26, 20, 5, 3, 1),(26, 21, 5, 1, 1),(26, 22, 5, 3, 1),(26, 23, 5, 1, 1),(26, 24, 5, 3, 1),(26, 25, 5, 1, 1),(26, 26, 5, 3, 1),(26, 27, 5, 1, 1),(26, 28, 5, 3, 1),(26, 29, 5, 1, 1),(26, 30, 5, 3, 1),(26, 31, 5, 1, 1),(26, 32, 5, 3, 1),(26, 33, 5, 2, 1),(26, 34, 5, 4, 1),(26, 35, 5, 2, 1),(26, 36, 5, 4, 1),(26, 37, 5, 2, 1),(26, 38, 5, 4, 1),(26, 39, 5, 2, 1),(26, 40, 5, 4, 1),(26, 41, 5, 2, 1),(26, 42, 5, 4, 1),(26, 43, 5, 2, 1),(26, 44, 5, 4, 1),(26, 45, 5, 2, 1),(26, 46, 5, 4, 1),(26, 47, 5, 2, 1),(26, 48, 5, 4, 1),(26, 49, 5, 2, 1),(26, 50, 5, 4, 1),(26, 51, 5, 2, 1),(26, 52, 5, 4, 1),(26, 53, 5, 2, 1),(26, 54, 5, 4, 1),(26, 55, 5, 2, 1),(26, 56, 5, 4, 1),(26, 57, 5, 2, 1),(26, 58, 5, 4, 1),(26, 59, 5, 2, 1),(26, 60, 5, 4, 1),(26, 61, 5, 2, 1),(26, 62, 5, 4, 1),(26, 63, 5, 2, 1),(26, 64, 5, 4, 1),(26, 65, 5, 1, 1),(26, 66, 5, 3, 1),(26, 67, 1, 1, 1),(26, 68, 1, 3, 1),(26, 69, 1, 1, 1),(26, 70, 1, 3, 1),(26, 71, 1, 1, 1),(26, 72, 1, 3, 1),(26, 73, 1, 1, 1),(26, 74, 1, 3, 1),(26, 75, 1, 1, 1),(26, 76, 1, 3, 1),(26, 77, 1, 1, 1),(26, 78, 1, 3, 1),(26, 79, 1, 1, 1),(26, 80, 1, 3, 1),(26, 81, 1, 1, 1),(26, 82, 1, 3, 1),(26, 83, 1, 1, 1),(26, 84, 1, 3, 1),(26, 85, 1, 1, 1),(26, 86, 1, 3, 1),(26, 87, 1, 1, 1),(26, 88, 1, 3, 1),(26, 89, 1, 1, 1),(26, 90, 1, 3, 1),(26, 91, 1, 1, 1),(26, 92, 1, 3, 1),(26, 93, 1, 1, 1),(26, 94, 1, 3, 1),(26, 95, 5, 1, 1),(26, 96, 5, 3, 1),(26, 97, 5, 2, 1),(26, 98, 5, 4, 1),(26, 99, 1, 2, 1),(26, 100, 1, 4, 1),(26, 101, 1, 2, 1),(26, 102, 1, 4, 1),(26, 103, 1, 2, 1),(26, 104, 1, 4, 1),(26, 105, 1, 2, 1),(26, 106, 1, 4, 1),(26, 107, 1, 2, 1),(26, 108, 1, 4, 1),(26, 109, 1, 2, 1),(26, 110, 1, 4, 1),(26, 111, 1, 2, 1),(26, 112, 1, 4, 1),(26, 113, 1, 2, 1),(26, 114, 1, 4, 1),(26, 115, 1, 2, 1),(26, 116, 1, 4, 1),(26, 117, 1, 2, 1),(26, 118, 1, 4, 1),(26, 119, 1, 2, 1),(26, 120, 1, 4, 1),(26, 121, 1, 2, 1),(26, 122, 1, 4, 1),(26, 123, 1, 2, 1),(26, 124, 1, 4, 1),(26, 125, 1, 2, 1),(26, 126, 1, 4, 1),(26, 127, 5, 2, 1),(26, 128, 5, 4, 1),(26, 129, 5, 1, 1),(26, 130, 5, 3, 1),(26, 131, 1, 1, 1),(26, 132, 1, 3, 1),(26, 133, 1, 1, 1),(26, 134, 1, 3, 1),(26, 135, 1, 1, 1),(26, 136, 1, 3, 1),(26, 137, 1, 1, 1),(26, 138, 1, 3, 1),(26, 139, 1, 1, 1),(26, 140, 1, 3, 1),(26, 141, 1, 1, 1),(26, 142, 1, 3, 1),(26, 143, 1, 1, 1),(26, 144, 1, 3, 1),(26, 145, 1, 1, 1),(26, 146, 1, 3, 1),(26, 147, 1, 1, 1),(26, 148, 1, 3, 1),(26, 149, 1, 1, 1),(26, 150, 1, 3, 1),(26, 151, 1, 1, 1),(26, 152, 1, 3, 1),(26, 153, 1, 1, 1),(26, 154, 1, 3, 1),(26, 155, 1, 1, 1),(26, 156, 1, 3, 1),(26, 157, 1, 1, 1),(26, 158, 1, 3, 1),(26, 159, 5, 1, 1),(26, 160, 5, 3, 1),(26, 161, 5, 2, 1),(26, 162, 5, 4, 1),(26, 163, 1, 2, 1),(26, 164, 1, 4, 1),(26, 165, 1, 2, 1),(26, 166, 1, 4, 1),(26, 167, 1, 2, 1),(26, 168, 1, 4, 1),(26, 169, 1, 2, 1),(26, 170, 1, 4, 1),(26, 171, 1, 2, 1),(26, 172, 1, 4, 1),(26, 173, 1, 2, 1),(26, 174, 1, 4, 1),(26, 175, 1, 2, 1),(26, 176, 1, 4, 1),(26, 177, 1, 2, 1),(26, 178, 1, 4, 1),(26, 179, 1, 2, 1),(26, 180, 1, 4, 1),(26, 181, 1, 2, 1),(26, 182, 1, 4, 1),(26, 183, 1, 2, 1),(26, 184, 1, 4, 1),(26, 185, 1, 2, 1),(26, 186, 1, 4, 1),(26, 187, 1, 2, 1),(26, 188, 1, 4, 1),(26, 189, 1, 2, 1),(26, 190, 1, 4, 1),(26, 191, 5, 2, 1),(26, 192, 5, 4, 1),(26, 193, 5, 1, 1),(26, 194, 5, 3, 1),(26, 195, 1, 1, 1),(26, 196, 1, 3, 1),(26, 197, 1, 1, 1),(26, 198, 1, 3, 1),(26, 199, 1, 1, 1),(26, 200, 1, 3, 1),(26, 201, 1, 1, 1),(26, 202, 1, 3, 1),(26, 203, 1, 1, 1),(26, 204, 1, 3, 1),(26, 205, 1, 1, 1),(26, 206, 1, 3, 1),(26, 207, 1, 1, 1),(26, 208, 1, 3, 1),(26, 209, 1, 1, 1),(26, 210, 1, 3, 1),(26, 211, 1, 1, 1),(26, 212, 1, 3, 1),(26, 213, 1, 1, 1),(26, 214, 1, 3, 1),(26, 215, 1, 1, 1),(26, 216, 1, 3, 1),(26, 217, 1, 1, 1),(26, 218, 1, 3, 1),(26, 219, 1, 1, 1),(26, 220, 1, 3, 1),(26, 221, 1, 1, 1),(26, 222, 1, 3, 1),(26, 223, 5, 1, 1),(26, 224, 5, 3, 1),(26, 225, 5, 2, 1),(26, 226, 5, 4, 1),(26, 227, 1, 2, 1),(26, 228, 1, 4, 1),(26, 229, 1, 2, 1),(26, 230, 1, 4, 1),(26, 231, 1, 2, 1),(26, 232, 1, 4, 1),(26, 233, 1, 2, 1),(26, 234, 1, 4, 1),(26, 235, 1, 2, 1),(26, 236, 1, 4, 1),(26, 237, 1, 2, 1),(26, 238, 1, 4, 1),(26, 239, 1, 2, 1),(26, 240, 1, 4, 1),(26, 241, 1, 2, 1),(26, 242, 1, 4, 1),(26, 243, 1, 2, 1),(26, 244, 1, 4, 1),(26, 245, 1, 2, 1),(26, 246, 1, 4, 1),(26, 247, 1, 2, 1),(26, 248, 1, 4, 1),(26, 249, 1, 2, 1),(26, 250, 1, 4, 1),(26, 251, 1, 2, 1),(26, 252, 1, 4, 1),(26, 253, 1, 2, 1),(26, 254, 1, 4, 1),(26, 255, 5, 2, 1),(26, 256, 5, 4, 1),(26, 257, 5, 1, 1),(26, 258, 5, 3, 1),(26, 259, 1, 1, 1),(26, 260, 1, 3, 1),(26, 261, 1, 1, 1),(26, 262, 1, 3, 1),(26, 263, 1, 1, 1),(26, 264, 1, 3, 1),(26, 265, 1, 1, 1),(26, 266, 1, 3, 1),(26, 267, 1, 1, 1),(26, 268, 1, 3, 1),(26, 269, 1, 1, 1),(26, 270, 1, 3, 1),(26, 271, 1, 1, 1),(26, 272, 1, 3, 1),(26, 273, 1, 1, 1),(26, 274, 1, 3, 1),(26, 275, 1, 1, 1),(26, 276, 1, 3, 1),(26, 277, 1, 1, 1),(26, 278, 1, 3, 1),(26, 279, 1, 1, 1),(26, 280, 1, 3, 1),(26, 281, 1, 1, 1),(26, 282, 1, 3, 1),(26, 283, 1, 1, 1),(26, 284, 1, 3, 1),(26, 285, 1, 1, 1),(26, 286, 1, 3, 1),(26, 287, 5, 1, 1),(26, 288, 5, 3, 1),(26, 289, 5, 2, 1),(26, 290, 5, 4, 1),(26, 291, 1, 2, 1),(26, 292, 1, 4, 1),(26, 293, 1, 2, 1),(26, 294, 1, 4, 1),(26, 295, 1, 2, 1),(26, 296, 1, 4, 1),(26, 297, 1, 2, 1),(26, 298, 1, 4, 1),(26, 299, 1, 2, 1),(26, 300, 1, 4, 1),(26, 301, 1, 2, 1),(26, 302, 1, 4, 1),(26, 303, 1, 2, 1),(26, 304, 1, 4, 1),(26, 305, 1, 2, 1),(26, 306, 1, 4, 1),(26, 307, 1, 2, 1),(26, 308, 1, 4, 1),(26, 309, 1, 2, 1),(26, 310, 1, 4, 1),(26, 311, 1, 2, 1),(26, 312, 1, 4, 1),(26, 313, 1, 2, 1),(26, 314, 1, 4, 1),(26, 315, 1, 2, 1),(26, 316, 1, 4, 1),(26, 317, 1, 2, 1),(26, 318, 1, 4, 1),(26, 319, 5, 2, 1),(26, 320, 5, 4, 1),(26, 321, 5, 1, 1),(26, 322, 5, 3, 1),(26, 323, 1, 1, 1),(26, 324, 1, 3, 1),(26, 325, 1, 1, 1),(26, 326, 1, 3, 1),(26, 327, 1, 1, 1),(26, 328, 1, 3, 1),(26, 329, 1, 1, 1),(26, 330, 1, 3, 1),(26, 331, 1, 1, 1),(26, 332, 1, 3, 1),(26, 333, 1, 1, 1),(26, 334, 1, 3, 1),(26, 335, 1, 1, 1),(26, 336, 1, 3, 1),(26, 337, 1, 1, 1),(26, 338, 1, 3, 1),(26, 339, 1, 1, 1),(26, 340, 1, 3, 1),(26, 341, 1, 1, 1),(26, 342, 1, 3, 1),(26, 343, 1, 1, 1),(26, 344, 1, 3, 1),(26, 345, 1, 1, 1),(26, 346, 1, 3, 1),(26, 347, 1, 1, 1),(26, 348, 1, 3, 1),(26, 349, 1, 1, 1),(26, 350, 1, 3, 1),(26, 351, 5, 1, 1),(26, 352, 5, 3, 1),(26, 353, 5, 2, 1),(26, 354, 5, 4, 1),(26, 355, 1, 2, 1),(26, 356, 1, 4, 1),(26, 357, 1, 2, 1),(26, 358, 1, 4, 1),(26, 359, 1, 2, 1),(26, 360, 1, 4, 1),(26, 361, 1, 2, 1),(26, 362, 1, 4, 1),(26, 363, 1, 2, 1),(26, 364, 1, 4, 1),(26, 365, 1, 2, 1),(26, 366, 1, 4, 1),(26, 367, 1, 2, 1),(26, 368, 1, 4, 1),(26, 369, 1, 2, 1),(26, 370, 1, 4, 1),(26, 371, 1, 2, 1),(26, 372, 1, 4, 1),(26, 373, 1, 2, 1),(26, 374, 1, 4, 1),(26, 375, 1, 2, 1),(26, 376, 1, 4, 1),(26, 377, 1, 2, 1),(26, 378, 1, 4, 1),(26, 379, 1, 2, 1),(26, 380, 1, 4, 1),(26, 381, 1, 2, 1),(26, 382, 1, 4, 1),(26, 383, 5, 2, 1),(26, 384, 5, 4, 1),(26, 385, 5, 1, 1),(26, 386, 5, 3, 1),(26, 387, 1, 1, 1),(26, 388, 1, 3, 1),(26, 389, 1, 1, 1),(26, 390, 1, 3, 1),(26, 391, 1, 1, 1),(26, 392, 1, 3, 1),(26, 393, 1, 1, 1),(26, 394, 1, 3, 1),(26, 395, 1, 1, 1),(26, 396, 1, 3, 1),(26, 397, 1, 1, 1),(26, 398, 1, 3, 1),(26, 399, 1, 1, 1),(26, 400, 1, 3, 1),(26, 401, 1, 1, 1),(26, 402, 1, 3, 1),(26, 403, 1, 1, 1),(26, 404, 1, 3, 1),(26, 405, 1, 1, 1),(26, 406, 1, 3, 1),(26, 407, 1, 1, 1),(26, 408, 1, 3, 1),(26, 409, 1, 1, 1),(26, 410, 1, 3, 1),(26, 411, 1, 1, 1),(26, 412, 1, 3, 1),(26, 413, 1, 1, 1),(26, 414, 1, 3, 1),(26, 415, 5, 1, 1),(26, 416, 5, 3, 1),(26, 417, 5, 2, 1),(26, 418, 5, 4, 1),(26, 419, 1, 2, 1),(26, 420, 1, 4, 1),(26, 421, 1, 2, 1),(26, 422, 1, 4, 1),(26, 423, 1, 2, 1),(26, 424, 1, 4, 1),(26, 425, 1, 2, 1),(26, 426, 1, 4, 1),(26, 427, 1, 2, 1),(26, 428, 1, 4, 1),(26, 429, 1, 2, 1),(26, 430, 1, 4, 1),(26, 431, 1, 2, 1),(26, 432, 1, 4, 1),(26, 433, 1, 2, 1),(26, 434, 1, 4, 1),(26, 435, 1, 2, 1),(26, 436, 1, 4, 1),(26, 437, 1, 2, 1),(26, 438, 1, 4, 1),(26, 439, 1, 2, 1),(26, 440, 1, 4, 1),(26, 441, 1, 2, 1),(26, 442, 1, 4, 1),(26, 443, 1, 2, 1),(26, 444, 1, 4, 1),(26, 445, 1, 2, 1),(26, 446, 1, 4, 1),(26, 447, 5, 2, 1),(26, 448, 5, 4, 1),(26, 449, 5, 1, 1),(26, 450, 5, 3, 1),(26, 451, 1, 1, 1),(26, 452, 1, 3, 1),(26, 453, 1, 1, 1),(26, 454, 1, 3, 1),(26, 455, 1, 1, 1),(26, 456, 1, 3, 1),(26, 457, 1, 1, 1),(26, 458, 1, 3, 1),(26, 459, 1, 1, 1),(26, 460, 1, 3, 1),(26, 461, 1, 1, 1),(26, 462, 1, 3, 1),(26, 463, 1, 1, 1),(26, 464, 1, 3, 1),(26, 465, 1, 1, 1),(26, 466, 1, 3, 1),(26, 467, 1, 1, 1),(26, 468, 1, 3, 1),(26, 469, 1, 1, 1),(26, 470, 1, 3, 1),(26, 471, 1, 1, 1),(26, 472, 1, 3, 1),(26, 473, 1, 1, 1),(26, 474, 1, 3, 1),(26, 475, 1, 1, 1),(26, 476, 1, 3, 1),(26, 477, 1, 1, 1),(26, 478, 1, 3, 1),(26, 479, 5, 1, 1),(26, 480, 5, 3, 1),(26, 481, 5, 2, 1),(26, 482, 5, 4, 1),(26, 483, 1, 2, 1),(26, 484, 1, 4, 1),(26, 485, 1, 2, 1),(26, 486, 1, 4, 1),(26, 487, 1, 2, 1),(26, 488, 1, 4, 1),(26, 489, 1, 2, 1),(26, 490, 1, 4, 1),(26, 491, 1, 2, 1),(26, 492, 1, 4, 1),(26, 493, 1, 2, 1),(26, 494, 1, 4, 1),(26, 495, 1, 2, 1),(26, 496, 1, 4, 1),(26, 497, 1, 2, 1),(26, 498, 1, 4, 1),(26, 499, 1, 2, 1),(26, 500, 1, 4, 1),(26, 501, 1, 2, 1),(26, 502, 1, 4, 1),(26, 503, 1, 2, 1),(26, 504, 1, 4, 1),(26, 505, 1, 2, 1),(26, 506, 1, 4, 1),(26, 507, 1, 2, 1),(26, 508, 1, 4, 1),(26, 509, 1, 2, 1),(26, 510, 1, 4, 1),(26, 511, 5, 2, 1),(26, 512, 5, 4, 1),(26, 513, 5, 1, 1),(26, 514, 5, 3, 1),(26, 515, 1, 1, 1),(26, 516, 1, 3, 1),(26, 517, 1, 1, 1),(26, 518, 1, 3, 1),(26, 519, 1, 1, 1),(26, 520, 1, 3, 1),(26, 521, 1, 1, 1),(26, 522, 1, 3, 1),(26, 523, 1, 1, 1),(26, 524, 1, 3, 1),(26, 525, 1, 1, 1),(26, 526, 1, 3, 1),(26, 527, 1, 1, 1),(26, 528, 1, 3, 1),(26, 529, 1, 1, 1),(26, 530, 1, 3, 1),(26, 531, 1, 1, 1),(26, 532, 1, 3, 1),(26, 533, 1, 1, 1),(26, 534, 1, 3, 1),(26, 535, 1, 1, 1),(26, 536, 1, 3, 1),(26, 537, 1, 1, 1),(26, 538, 1, 3, 1),(26, 539, 1, 1, 1),(26, 540, 1, 3, 1),(26, 541, 1, 1, 1),(26, 542, 1, 3, 1),(26, 543, 5, 1, 1),(26, 544, 5, 3, 1),(26, 545, 5, 2, 1),(26, 546, 5, 4, 1),(26, 547, 1, 2, 1),(26, 548, 1, 4, 1),(26, 549, 1, 2, 1),(26, 550, 1, 4, 1),(26, 551, 1, 2, 1),(26, 552, 1, 4, 1),(26, 553, 1, 2, 1),(26, 554, 1, 4, 1),(26, 555, 1, 2, 1),(26, 556, 1, 4, 1),(26, 557, 1, 2, 1),(26, 558, 1, 4, 1),(26, 559, 1, 2, 1),(26, 560, 1, 4, 1),(26, 561, 1, 2, 1),(26, 562, 1, 4, 1),(26, 563, 1, 2, 1),(26, 564, 1, 4, 1),(26, 565, 1, 2, 1),(26, 566, 1, 4, 1),(26, 567, 1, 2, 1),(26, 568, 1, 4, 1),(26, 569, 1, 2, 1),(26, 570, 1, 4, 1),(26, 571, 1, 2, 1),(26, 572, 1, 4, 1),(26, 573, 1, 2, 1),(26, 574, 1, 4, 1),(26, 575, 5, 2, 1),(26, 576, 5, 4, 1),(26, 577, 5, 1, 1),(26, 578, 5, 3, 1),(26, 579, 1, 1, 1),(26, 580, 1, 3, 1),(26, 581, 1, 1, 1),(26, 582, 1, 3, 1),(26, 583, 1, 1, 1),(26, 584, 1, 3, 1),(26, 585, 1, 1, 1),(26, 586, 1, 3, 1),(26, 587, 1, 1, 1),(26, 588, 1, 3, 1),(26, 589, 1, 1, 1),(26, 590, 1, 3, 1),(26, 591, 1, 1, 1),(26, 592, 1, 3, 1),(26, 593, 1, 1, 1),(26, 594, 1, 3, 1),(26, 595, 1, 1, 1),(26, 596, 1, 3, 1),(26, 597, 1, 1, 1),(26, 598, 1, 3, 1),(26, 599, 1, 1, 1),(26, 600, 1, 3, 1),(26, 601, 1, 1, 1),(26, 602, 1, 3, 1),(26, 603, 1, 1, 1),(26, 604, 1, 3, 1),(26, 605, 1, 1, 1),(26, 606, 1, 3, 1),(26, 607, 5, 1, 1),(26, 608, 5, 3, 1),(26, 609, 5, 2, 1),(26, 610, 5, 4, 1),(26, 611, 1, 2, 1),(26, 612, 1, 4, 1),(26, 613, 1, 2, 1),(26, 614, 1, 4, 1),(26, 615, 1, 2, 1),(26, 616, 1, 4, 1),(26, 617, 1, 2, 1),(26, 618, 1, 4, 1),(26, 619, 1, 2, 1),(26, 620, 1, 4, 1),(26, 621, 1, 2, 1),(26, 622, 1, 4, 1),(26, 623, 1, 2, 1),(26, 624, 1, 4, 1),(26, 625, 1, 2, 1),(26, 626, 1, 4, 1),(26, 627, 1, 2, 1),(26, 628, 1, 4, 1),(26, 629, 1, 2, 1),(26, 630, 1, 4, 1),(26, 631, 1, 2, 1),(26, 632, 1, 4, 1),(26, 633, 1, 2, 1),(26, 634, 1, 4, 1),(26, 635, 1, 2, 1),(26, 636, 1, 4, 1),(26, 637, 1, 2, 1),(26, 638, 1, 4, 1),(26, 639, 5, 2, 1),(26, 640, 5, 4, 1),(26, 641, 5, 1, 1),(26, 642, 5, 3, 1),(26, 643, 1, 1, 1),(26, 644, 1, 3, 1),(26, 645, 1, 1, 1),(26, 646, 1, 3, 1),(26, 647, 1, 1, 1),(26, 648, 1, 3, 1),(26, 649, 1, 1, 1),(26, 650, 1, 3, 1),(26, 651, 1, 1, 1),(26, 652, 1, 3, 1),(26, 653, 1, 1, 1),(26, 654, 1, 3, 1),(26, 655, 1, 1, 1),(26, 656, 1, 3, 1),(26, 657, 1, 1, 1),(26, 658, 1, 3, 1),(26, 659, 1, 1, 1),(26, 660, 1, 3, 1),(26, 661, 1, 1, 1),(26, 662, 1, 3, 1),(26, 663, 1, 1, 1),(26, 664, 1, 3, 1),(26, 665, 1, 1, 1),(26, 666, 1, 3, 1),(26, 667, 1, 1, 1),(26, 668, 1, 3, 1),(26, 669, 1, 1, 1),(26, 670, 1, 3, 1),(26, 671, 5, 1, 1),(26, 672, 5, 3, 1),(26, 673, 5, 2, 1),(26, 674, 5, 4, 1),(26, 675, 1, 2, 1),(26, 676, 1, 4, 1),(26, 677, 1, 2, 1),(26, 678, 1, 4, 1),(26, 679, 1, 2, 1),(26, 680, 1, 4, 1),(26, 681, 1, 2, 1),(26, 682, 1, 4, 1),(26, 683, 1, 2, 1),(26, 684, 1, 4, 1),(26, 685, 1, 2, 1),(26, 686, 1, 4, 1),(26, 687, 1, 2, 1),(26, 688, 1, 4, 1),(26, 689, 1, 2, 1),(26, 690, 1, 4, 1),(26, 691, 1, 2, 1),(26, 692, 1, 4, 1),(26, 693, 1, 2, 1),(26, 694, 1, 4, 1),(26, 695, 1, 2, 1),(26, 696, 1, 4, 1),(26, 697, 1, 2, 1),(26, 698, 1, 4, 1),(26, 699, 1, 2, 1),(26, 700, 1, 4, 1),(26, 701, 1, 2, 1),(26, 702, 1, 4, 1),(26, 703, 5, 2, 1),(26, 704, 5, 4, 1),(26, 705, 5, 1, 1),(26, 706, 5, 3, 1),(26, 707, 1, 1, 1),(26, 708, 1, 3, 1),(26, 709, 1, 1, 1),(26, 710, 1, 3, 1),(26, 711, 1, 1, 1),(26, 712, 1, 3, 1),(26, 713, 1, 1, 1),(26, 714, 1, 3, 1),(26, 715, 1, 1, 1),(26, 716, 1, 3, 1),(26, 717, 1, 1, 1),(26, 718, 1, 3, 1),(26, 719, 1, 1, 1),(26, 720, 1, 3, 1),(26, 721, 1, 1, 1),(26, 722, 1, 3, 1),(26, 723, 1, 1, 1),(26, 724, 1, 3, 1),(26, 725, 1, 1, 1),(26, 726, 1, 3, 1),(26, 727, 1, 1, 1),(26, 728, 1, 3, 1),(26, 729, 1, 1, 1),(26, 730, 1, 3, 1),(26, 731, 1, 1, 1),(26, 732, 1, 3, 1),(26, 733, 1, 1, 1),(26, 734, 1, 3, 1),(26, 735, 5, 1, 1),(26, 736, 5, 3, 1),(26, 737, 5, 2, 1),(26, 738, 5, 4, 1),(26, 739, 1, 2, 1),(26, 740, 1, 4, 1),(26, 741, 1, 2, 1),(26, 742, 1, 4, 1),(26, 743, 1, 2, 1),(26, 744, 1, 4, 1),(26, 745, 1, 2, 1),(26, 746, 1, 4, 1),(26, 747, 1, 2, 1),(26, 748, 1, 4, 1),(26, 749, 1, 2, 1),(26, 750, 1, 4, 1),(26, 751, 1, 2, 1),(26, 752, 1, 4, 1),(26, 753, 1, 2, 1),(26, 754, 1, 4, 1),(26, 755, 1, 2, 1),(26, 756, 1, 4, 1),(26, 757, 1, 2, 1),(26, 758, 1, 4, 1),(26, 759, 1, 2, 1),(26, 760, 1, 4, 1),(26, 761, 1, 2, 1),(26, 762, 1, 4, 1),(26, 763, 1, 2, 1),(26, 764, 1, 4, 1),(26, 765, 1, 2, 1),(26, 766, 1, 4, 1),(26, 767, 5, 2, 1),(26, 768, 5, 4, 1),(26, 769, 5, 1, 1),(26, 770, 5, 3, 1),(26, 771, 1, 1, 1),(26, 772, 1, 3, 1),(26, 773, 1, 1, 1),(26, 774, 1, 3, 1),(26, 775, 1, 1, 1),(26, 776, 1, 3, 1),(26, 777, 1, 1, 1),(26, 778, 1, 3, 1),(26, 779, 1, 1, 1),(26, 780, 1, 3, 1),(26, 781, 1, 1, 1),(26, 782, 1, 3, 1),(26, 783, 1, 1, 1),(26, 784, 1, 3, 1),(26, 785, 1, 1, 1),(26, 786, 1, 3, 1),(26, 787, 1, 1, 1),(26, 788, 1, 3, 1),(26, 789, 1, 1, 1),(26, 790, 1, 3, 1),(26, 791, 1, 1, 1),(26, 792, 1, 3, 1),(26, 793, 1, 1, 1),(26, 794, 1, 3, 1),(26, 795, 1, 1, 1),(26, 796, 1, 3, 1),(26, 797, 1, 1, 1),(26, 798, 1, 3, 1),(26, 799, 5, 1, 1),(26, 800, 5, 3, 1),(26, 801, 5, 2, 1),(26, 802, 5, 4, 1),(26, 803, 1, 2, 1),(26, 804, 1, 4, 1),(26, 805, 1, 2, 1),(26, 806, 1, 4, 1),(26, 807, 1, 2, 1),(26, 808, 1, 4, 1),(26, 809, 1, 2, 1),(26, 810, 1, 4, 1),(26, 811, 1, 2, 1),(26, 812, 1, 4, 1),(26, 813, 1, 2, 1),(26, 814, 1, 4, 1),(26, 815, 1, 2, 1),(26, 816, 1, 4, 1),(26, 817, 1, 2, 1),(26, 818, 1, 4, 1),(26, 819, 1, 2, 1),(26, 820, 1, 4, 1),(26, 821, 1, 2, 1),(26, 822, 1, 4, 1),(26, 823, 1, 2, 1),(26, 824, 1, 4, 1),(26, 825, 1, 2, 1),(26, 826, 1, 4, 1),(26, 827, 1, 2, 1),(26, 828, 1, 4, 1),(26, 829, 1, 2, 1),(26, 830, 1, 4, 1),(26, 831, 5, 2, 1),(26, 832, 5, 4, 1),(26, 833, 5, 1, 1),(26, 834, 5, 3, 1),(26, 835, 1, 1, 1),(26, 836, 1, 3, 1),(26, 837, 1, 1, 1),(26, 838, 1, 3, 1),(26, 839, 1, 1, 1),(26, 840, 1, 3, 1),(26, 841, 1, 1, 1),(26, 842, 1, 3, 1),(26, 843, 1, 1, 1),(26, 844, 1, 3, 1),(26, 845, 1, 1, 1),(26, 846, 1, 3, 1),(26, 847, 1, 1, 1),(26, 848, 1, 3, 1),(26, 849, 1, 1, 1),(26, 850, 1, 3, 1),(26, 851, 1, 1, 1),(26, 852, 1, 3, 1),(26, 853, 1, 1, 1),(26, 854, 1, 3, 1),(26, 855, 1, 1, 1),(26, 856, 1, 3, 1),(26, 857, 1, 1, 1),(26, 858, 1, 3, 1),(26, 859, 1, 1, 1),(26, 860, 1, 3, 1),(26, 861, 1, 1, 1),(26, 862, 1, 3, 1),(26, 863, 5, 1, 1),(26, 864, 5, 3, 1),(26, 865, 5, 2, 1),(26, 866, 5, 4, 1),(26, 867, 1, 2, 1),(26, 868, 1, 4, 1),(26, 869, 1, 2, 1),(26, 870, 1, 4, 1),(26, 871, 1, 2, 1),(26, 872, 1, 4, 1),(26, 873, 1, 2, 1),(26, 874, 1, 4, 1),(26, 875, 1, 2, 1),(26, 876, 1, 4, 1),(26, 877, 1, 2, 1),(26, 878, 1, 4, 1),(26, 879, 1, 2, 1),(26, 880, 1, 4, 1),(26, 881, 1, 2, 1),(26, 882, 1, 4, 1),(26, 883, 1, 2, 1),(26, 884, 1, 4, 1),(26, 885, 1, 2, 1),(26, 886, 1, 4, 1),(26, 887, 1, 2, 1),(26, 888, 1, 4, 1),(26, 889, 1, 2, 1),(26, 890, 1, 4, 1),(26, 891, 1, 2, 1),(26, 892, 1, 4, 1),(26, 893, 1, 2, 1),(26, 894, 1, 4, 1),(26, 895, 5, 2, 1),(26, 896, 5, 4, 1),(26, 897, 5, 1, 1),(26, 898, 5, 3, 1),(26, 899, 1, 1, 1),(26, 900, 1, 3, 1),(26, 901, 1, 1, 1),(26, 902, 1, 3, 1),(26, 903, 1, 1, 1),(26, 904, 1, 3, 1),(26, 905, 1, 1, 1),(26, 906, 1, 3, 1),(26, 907, 1, 1, 1),(26, 908, 1, 3, 1),(26, 909, 1, 1, 1),(26, 910, 1, 3, 1),(26, 911, 1, 1, 1),(26, 912, 1, 3, 1),(26, 913, 1, 1, 1),(26, 914, 1, 3, 1),(26, 915, 1, 1, 1),(26, 916, 1, 3, 1),(26, 917, 1, 1, 1),(26, 918, 1, 3, 1),(26, 919, 1, 1, 1),(26, 920, 1, 3, 1),(26, 921, 1, 1, 1),(26, 922, 1, 3, 1),(26, 923, 1, 1, 1),(26, 924, 1, 3, 1),(26, 925, 1, 1, 1),(26, 926, 1, 3, 1),(26, 927, 5, 1, 1),(26, 928, 5, 3, 1),(26, 929, 5, 2, 1),(26, 930, 5, 4, 1),(26, 931, 1, 2, 1),(26, 932, 1, 4, 1),(26, 933, 1, 2, 1),(26, 934, 1, 4, 1),(26, 935, 1, 2, 1),(26, 936, 1, 4, 1),(26, 937, 1, 2, 1),(26, 938, 1, 4, 1),(26, 939, 1, 2, 1),(26, 940, 1, 4, 1),(26, 941, 1, 2, 1),(26, 942, 1, 4, 1),(26, 943, 1, 2, 1),(26, 944, 1, 4, 1),(26, 945, 1, 2, 1),(26, 946, 1, 4, 1),(26, 947, 1, 2, 1),(26, 948, 1, 4, 1),(26, 949, 1, 2, 1),(26, 950, 1, 4, 1),(26, 951, 1, 2, 1),(26, 952, 1, 4, 1),(26, 953, 1, 2, 1),(26, 954, 1, 4, 1),(26, 955, 1, 2, 1),(26, 956, 1, 4, 1),(26, 957, 1, 2, 1),(26, 958, 1, 4, 1),(26, 959, 5, 2, 1),(26, 960, 5, 4, 1),(26, 961, 5, 1, 1),(26, 962, 5, 3, 1),(26, 963, 1, 1, 1),(26, 964, 1, 3, 1),(26, 965, 1, 1, 1),(26, 966, 1, 3, 1),(26, 967, 1, 1, 1),(26, 968, 1, 3, 1),(26, 969, 1, 1, 1),(26, 970, 1, 3, 1),(26, 971, 1, 1, 1),(26, 972, 1, 3, 1),(26, 973, 1, 1, 1),(26, 974, 1, 3, 1),(26, 975, 1, 1, 1),(26, 976, 1, 3, 1),(26, 977, 1, 1, 1),(26, 978, 1, 3, 1),(26, 979, 1, 1, 1),(26, 980, 1, 3, 1),(26, 981, 1, 1, 1),(26, 982, 1, 3, 1),(26, 983, 1, 1, 1),(26, 984, 1, 3, 1),(26, 985, 1, 1, 1),(26, 986, 1, 3, 1),(26, 987, 1, 1, 1),(26, 988, 1, 3, 1),(26, 989, 1, 1, 1),(26, 990, 1, 3, 1),(26, 991, 5, 1, 1),(26, 992, 5, 3, 1),(26, 993, 5, 2, 1),(26, 994, 5, 4, 1),(26, 995, 1, 2, 1),(26, 996, 1, 4, 1),(26, 997, 1, 2, 1),(26, 998, 1, 4, 1),(26, 999, 1, 2, 1),(26, 1000, 1, 4, 1),(26, 1001, 1, 2, 1),(26, 1002, 1, 4, 1),(26, 1003, 1, 2, 1),(26, 1004, 1, 4, 1),(26, 1005, 1, 2, 1),(26, 1006, 1, 4, 1),(26, 1007, 1, 2, 1),(26, 1008, 1, 4, 1),(26, 1009, 1, 2, 1),(26, 1010, 1, 4, 1),(26, 1011, 1, 2, 1),(26, 1012, 1, 4, 1),(26, 1013, 1, 2, 1),(26, 1014, 1, 4, 1),(26, 1015, 1, 2, 1),(26, 1016, 1, 4, 1),(26, 1017, 1, 2, 1),(26, 1018, 1, 4, 1),(26, 1019, 1, 2, 1),(26, 1020, 1, 4, 1),(26, 1021, 1, 2, 1),(26, 1022, 1, 4, 1),(26, 1023, 5, 2, 1),(26, 1024, 5, 4, 1),(26, 1025, 5, 1, 1),(26, 1026, 5, 3, 1),(26, 1027, 1, 1, 1),(26, 1028, 1, 3, 1),(26, 1029, 1, 1, 1),(26, 1030, 1, 3, 1),(26, 1031, 1, 1, 1),(26, 1032, 1, 3, 1),(26, 1033, 1, 1, 1),(26, 1034, 1, 3, 1),(26, 1035, 1, 1, 1),(26, 1036, 1, 3, 1),(26, 1037, 1, 1, 1),(26, 1038, 1, 3, 1),(26, 1039, 1, 1, 1),(26, 1040, 1, 3, 1),(26, 1041, 1, 1, 1),(26, 1042, 1, 3, 1),(26, 1043, 1, 1, 1),(26, 1044, 1, 3, 1),(26, 1045, 1, 1, 1),(26, 1046, 1, 3, 1),(26, 1047, 1, 1, 1),(26, 1048, 1, 3, 1),(26, 1049, 1, 1, 1),(26, 1050, 1, 3, 1),(26, 1051, 1, 1, 1),(26, 1052, 1, 3, 1),(26, 1053, 1, 1, 1),(26, 1054, 1, 3, 1),(26, 1055, 5, 1, 1),(26, 1056, 5, 3, 1),(26, 1057, 5, 2, 1),(26, 1058, 5, 4, 1),(26, 1059, 1, 2, 1),(26, 1060, 1, 4, 1),(26, 1061, 1, 2, 1),(26, 1062, 1, 4, 1),(26, 1063, 1, 2, 1),(26, 1064, 1, 4, 1),(26, 1065, 1, 2, 1),(26, 1066, 1, 4, 1),(26, 1067, 1, 2, 1),(26, 1068, 1, 4, 1),(26, 1069, 1, 2, 1),(26, 1070, 1, 4, 1),(26, 1071, 1, 2, 1),(26, 1072, 1, 4, 1),(26, 1073, 1, 2, 1),(26, 1074, 1, 4, 1),(26, 1075, 1, 2, 1),(26, 1076, 1, 4, 1),(26, 1077, 1, 2, 1),(26, 1078, 1, 4, 1),(26, 1079, 1, 2, 1),(26, 1080, 1, 4, 1),(26, 1081, 1, 2, 1),(26, 1082, 1, 4, 1),(26, 1083, 1, 2, 1),(26, 1084, 1, 4, 1),(26, 1085, 1, 2, 1),(26, 1086, 1, 4, 1),(26, 1087, 5, 2, 1),(26, 1088, 5, 4, 1),(26, 1089, 5, 1, 1),(26, 1090, 5, 3, 1),(26, 1091, 1, 1, 1),(26, 1092, 1, 3, 1),(26, 1093, 1, 1, 1),(26, 1094, 1, 3, 1),(26, 1095, 1, 1, 1),(26, 1096, 1, 3, 1),(26, 1097, 1, 1, 1),(26, 1098, 1, 3, 1),(26, 1099, 1, 1, 1),(26, 1100, 1, 3, 1),(26, 1101, 1, 1, 1),(26, 1102, 1, 3, 1),(26, 1103, 1, 1, 1),(26, 1104, 1, 3, 1),(26, 1105, 1, 1, 1),(26, 1106, 1, 3, 1),(26, 1107, 1, 1, 1),(26, 1108, 1, 3, 1),(26, 1109, 1, 1, 1),(26, 1110, 1, 3, 1),(26, 1111, 1, 1, 1),(26, 1112, 1, 3, 1),(26, 1113, 1, 1, 1),(26, 1114, 1, 3, 1),(26, 1115, 1, 1, 1),(26, 1116, 1, 3, 1),(26, 1117, 1, 1, 1),(26, 1118, 1, 3, 1),(26, 1119, 5, 1, 1),(26, 1120, 5, 3, 1),(26, 1121, 5, 2, 1),(26, 1122, 5, 4, 1),(26, 1123, 1, 2, 1),(26, 1124, 1, 4, 1),(26, 1125, 1, 2, 1),(26, 1126, 1, 4, 1),(26, 1127, 1, 2, 1),(26, 1128, 1, 4, 1),(26, 1129, 1, 2, 1),(26, 1130, 1, 4, 1),(26, 1131, 1, 2, 1),(26, 1132, 1, 4, 1),(26, 1133, 1, 2, 1),(26, 1134, 1, 4, 1),(26, 1135, 1, 2, 1),(26, 1136, 1, 4, 1),(26, 1137, 1, 2, 1),(26, 1138, 1, 4, 1),(26, 1139, 1, 2, 1),(26, 1140, 1, 4, 1),(26, 1141, 1, 2, 1),(26, 1142, 1, 4, 1),(26, 1143, 1, 2, 1),(26, 1144, 1, 4, 1),(26, 1145, 1, 2, 1),(26, 1146, 1, 4, 1),(26, 1147, 1, 2, 1),(26, 1148, 1, 4, 1),(26, 1149, 1, 2, 1),(26, 1150, 1, 4, 1),(26, 1151, 5, 2, 1),(26, 1152, 5, 4, 1),(26, 1153, 5, 1, 1),(26, 1154, 5, 3, 1),(26, 1155, 1, 1, 1),(26, 1156, 1, 3, 1),(26, 1157, 1, 1, 1),(26, 1158, 1, 3, 1),(26, 1159, 1, 1, 1),(26, 1160, 1, 3, 1),(26, 1161, 1, 1, 1),(26, 1162, 1, 3, 1),(26, 1163, 1, 1, 1),(26, 1164, 1, 3, 1),(26, 1165, 1, 1, 1),(26, 1166, 1, 3, 1),(26, 1167, 1, 1, 1),(26, 1168, 1, 3, 1),(26, 1169, 1, 1, 1),(26, 1170, 1, 3, 1),(26, 1171, 1, 1, 1),(26, 1172, 1, 3, 1),(26, 1173, 1, 1, 1),(26, 1174, 1, 3, 1),(26, 1175, 1, 1, 1),(26, 1176, 1, 3, 1),(26, 1177, 1, 1, 1),(26, 1178, 1, 3, 1),(26, 1179, 1, 1, 1),(26, 1180, 1, 3, 1),(26, 1181, 1, 1, 1),(26, 1182, 1, 3, 1),(26, 1183, 5, 1, 1),(26, 1184, 5, 3, 1),(26, 1185, 5, 2, 1),(26, 1186, 5, 4, 1),(26, 1187, 1, 2, 1),(26, 1188, 1, 4, 1),(26, 1189, 1, 2, 1),(26, 1190, 1, 4, 1),(26, 1191, 1, 2, 1),(26, 1192, 1, 4, 1),(26, 1193, 1, 2, 1),(26, 1194, 1, 4, 1),(26, 1195, 1, 2, 1),(26, 1196, 1, 4, 1),(26, 1197, 1, 2, 1),(26, 1198, 1, 4, 1),(26, 1199, 1, 2, 1),(26, 1200, 1, 4, 1),(26, 1201, 1, 2, 1),(26, 1202, 1, 4, 1),(26, 1203, 1, 2, 1),(26, 1204, 1, 4, 1),(26, 1205, 1, 2, 1),(26, 1206, 1, 4, 1),(26, 1207, 1, 2, 1),(26, 1208, 1, 4, 1),(26, 1209, 1, 2, 1),(26, 1210, 1, 4, 1),(26, 1211, 1, 2, 1),(26, 1212, 1, 4, 1),(26, 1213, 1, 2, 1),(26, 1214, 1, 4, 1),(26, 1215, 5, 2, 1),(26, 1216, 5, 4, 1),(26, 1217, 5, 1, 1),(26, 1218, 5, 3, 1),(26, 1219, 1, 1, 1),(26, 1220, 1, 3, 1),(26, 1221, 1, 1, 1),(26, 1222, 1, 3, 1),(26, 1223, 1, 1, 1),(26, 1224, 1, 3, 1),(26, 1225, 1, 1, 1),(26, 1226, 1, 3, 1),(26, 1227, 1, 1, 1),(26, 1228, 1, 3, 1),(26, 1229, 1, 1, 1),(26, 1230, 1, 3, 1),(26, 1231, 1, 1, 1),(26, 1232, 1, 3, 1),(26, 1233, 1, 1, 1),(26, 1234, 1, 3, 1),(26, 1235, 1, 1, 1),(26, 1236, 1, 3, 1),(26, 1237, 1, 1, 1),(26, 1238, 1, 3, 1),(26, 1239, 1, 1, 1),(26, 1240, 1, 3, 1),(26, 1241, 1, 1, 1),(26, 1242, 1, 3, 1),(26, 1243, 1, 1, 1),(26, 1244, 1, 3, 1),(26, 1245, 1, 1, 1),(26, 1246, 1, 3, 1),(26, 1247, 5, 1, 1),(26, 1248, 5, 3, 1),(26, 1249, 5, 2, 1),(26, 1250, 5, 4, 1),(26, 1251, 1, 2, 1),(26, 1252, 1, 4, 1),(26, 1253, 1, 2, 1),(26, 1254, 1, 4, 1),(26, 1255, 1, 2, 1),(26, 1256, 1, 4, 1),(26, 1257, 1, 2, 1),(26, 1258, 1, 4, 1),(26, 1259, 1, 2, 1),(26, 1260, 1, 4, 1),(26, 1261, 1, 2, 1),(26, 1262, 1, 4, 1),(26, 1263, 1, 2, 1),(26, 1264, 1, 4, 1),(26, 1265, 1, 2, 1),(26, 1266, 1, 4, 1),(26, 1267, 1, 2, 1),(26, 1268, 1, 4, 1),(26, 1269, 1, 2, 1),(26, 1270, 1, 4, 1),(26, 1271, 1, 2, 1),(26, 1272, 1, 4, 1),(26, 1273, 1, 2, 1),(26, 1274, 1, 4, 1),(26, 1275, 1, 2, 1),(26, 1276, 1, 4, 1),(26, 1277, 1, 2, 1),(26, 1278, 1, 4, 1),(26, 1279, 5, 2, 1),(26, 1280, 5, 4, 1),(26, 1281, 5, 1, 1),(26, 1282, 5, 3, 1),(26, 1283, 1, 1, 1),(26, 1284, 1, 3, 1),(26, 1285, 1, 1, 1),(26, 1286, 1, 3, 1),(26, 1287, 1, 1, 1),(26, 1288, 1, 3, 1),(26, 1289, 1, 1, 1),(26, 1290, 1, 3, 1),(26, 1291, 1, 1, 1),(26, 1292, 1, 3, 1),(26, 1293, 1, 1, 1),(26, 1294, 1, 3, 1),(26, 1295, 1, 1, 1),(26, 1296, 1, 3, 1),(26, 1297, 1, 1, 1),(26, 1298, 1, 3, 1),(26, 1299, 1, 1, 1),(26, 1300, 1, 3, 1),(26, 1301, 1, 1, 1),(26, 1302, 1, 3, 1),(26, 1303, 1, 1, 1),(26, 1304, 1, 3, 1),(26, 1305, 1, 1, 1),(26, 1306, 1, 3, 1),(26, 1307, 1, 1, 1),(26, 1308, 1, 3, 1),(26, 1309, 1, 1, 1),(26, 1310, 1, 3, 1),(26, 1311, 5, 1, 1),(26, 1312, 5, 3, 1),(26, 1313, 5, 2, 1),(26, 1314, 5, 4, 1),(26, 1315, 1, 2, 1),(26, 1316, 1, 4, 1),(26, 1317, 1, 2, 1),(26, 1318, 1, 4, 1),(26, 1319, 1, 2, 1),(26, 1320, 1, 4, 1),(26, 1321, 1, 2, 1),(26, 1322, 1, 4, 1),(26, 1323, 1, 2, 1),(26, 1324, 1, 4, 1),(26, 1325, 1, 2, 1),(26, 1326, 1, 4, 1),(26, 1327, 1, 2, 1),(26, 1328, 1, 4, 1),(26, 1329, 1, 2, 1),(26, 1330, 1, 4, 1),(26, 1331, 1, 2, 1),(26, 1332, 1, 4, 1),(26, 1333, 1, 2, 1),(26, 1334, 1, 4, 1),(26, 1335, 1, 2, 1),(26, 1336, 1, 4, 1),(26, 1337, 1, 2, 1),(26, 1338, 1, 4, 1),(26, 1339, 1, 2, 1),(26, 1340, 1, 4, 1),(26, 1341, 1, 2, 1),(26, 1342, 1, 4, 1),(26, 1343, 5, 2, 1),(26, 1344, 5, 4, 1),(26, 1345, 5, 1, 1),(26, 1346, 5, 3, 1),(26, 1347, 1, 1, 1),(26, 1348, 1, 3, 1),(26, 1349, 1, 1, 1),(26, 1350, 1, 3, 1),(26, 1351, 1, 1, 1),(26, 1352, 1, 3, 1),(26, 1353, 1, 1, 1),(26, 1354, 1, 3, 1),(26, 1355, 1, 1, 1),(26, 1356, 1, 3, 1),(26, 1357, 1, 1, 1),(26, 1358, 1, 3, 1),(26, 1359, 1, 1, 1),(26, 1360, 1, 3, 1),(26, 1361, 1, 1, 1),(26, 1362, 1, 3, 1),(26, 1363, 1, 1, 1),(26, 1364, 1, 3, 1),(26, 1365, 1, 1, 1),(26, 1366, 1, 3, 1),(26, 1367, 1, 1, 1),(26, 1368, 1, 3, 1),(26, 1369, 1, 1, 1),(26, 1370, 1, 3, 1),(26, 1371, 1, 1, 1),(26, 1372, 1, 3, 1),(26, 1373, 1, 1, 1),(26, 1374, 1, 3, 1),(26, 1375, 5, 1, 1),(26, 1376, 5, 3, 1),(26, 1377, 5, 2, 1),(26, 1378, 5, 4, 1),(26, 1379, 1, 2, 1),(26, 1380, 1, 4, 1),(26, 1381, 1, 2, 1),(26, 1382, 1, 4, 1),(26, 1383, 1, 2, 1),(26, 1384, 1, 4, 1),(26, 1385, 1, 2, 1),(26, 1386, 1, 4, 1),(26, 1387, 1, 2, 1),(26, 1388, 1, 4, 1),(26, 1389, 1, 2, 1),(26, 1390, 1, 4, 1),(26, 1391, 1, 2, 1),(26, 1392, 1, 4, 1),(26, 1393, 1, 2, 1),(26, 1394, 1, 4, 1),(26, 1395, 1, 2, 1),(26, 1396, 1, 4, 1),(26, 1397, 1, 2, 1),(26, 1398, 1, 4, 1),(26, 1399, 1, 2, 1),(26, 1400, 1, 4, 1),(26, 1401, 1, 2, 1),(26, 1402, 1, 4, 1),(26, 1403, 1, 2, 1),(26, 1404, 1, 4, 1),(26, 1405, 1, 2, 1),(26, 1406, 1, 4, 1),(26, 1407, 5, 2, 1),(26, 1408, 5, 4, 1),(26, 1409, 5, 1, 1),(26, 1410, 5, 3, 1),(26, 1411, 1, 1, 1),(26, 1412, 1, 3, 1),(26, 1413, 1, 1, 1),(26, 1414, 1, 3, 1),(26, 1415, 1, 1, 1),(26, 1416, 1, 3, 1),(26, 1417, 1, 1, 1),(26, 1418, 1, 3, 1),(26, 1419, 1, 1, 1),(26, 1420, 1, 3, 1),(26, 1421, 1, 1, 1),(26, 1422, 1, 3, 1),(26, 1423, 1, 1, 1),(26, 1424, 1, 3, 1),(26, 1425, 2, 1, 1),(26, 1426, 2, 3, 1),(26, 1427, 2, 1, 1),(26, 1428, 2, 3, 1),(26, 1429, 2, 1, 1),(26, 1430, 2, 3, 1),(26, 1431, 2, 1, 1),(26, 1432, 2, 3, 1),(26, 1433, 3, 1, 1),(26, 1434, 3, 3, 1),(26, 1435, 3, 1, 1),(26, 1436, 3, 3, 1),(26, 1437, 4, 1, 1),(26, 1438, 4, 3, 1),(26, 1439, 5, 1, 1),(26, 1440, 5, 3, 1),(26, 1441, 5, 2, 1),(26, 1442, 5, 4, 1),(26, 1443, 1, 2, 1),(26, 1444, 1, 4, 1),(26, 1445, 1, 2, 1),(26, 1446, 1, 4, 1),(26, 1447, 1, 2, 1),(26, 1448, 1, 4, 1),(26, 1449, 1, 2, 1),(26, 1450, 1, 4, 1),(26, 1451, 1, 2, 1),(26, 1452, 1, 4, 1),(26, 1453, 1, 2, 1),(26, 1454, 1, 4, 1),(26, 1455, 1, 2, 1),(26, 1456, 1, 4, 1),(26, 1457, 2, 2, 1),(26, 1458, 2, 4, 1),(26, 1459, 2, 2, 1),(26, 1460, 2, 4, 1),(26, 1461, 2, 2, 1),(26, 1462, 2, 4, 1),(26, 1463, 2, 2, 1),(26, 1464, 2, 4, 1),(26, 1465, 3, 2, 1),(26, 1466, 3, 4, 1),(26, 1467, 3, 2, 1),(26, 1468, 3, 4, 1),(26, 1469, 4, 2, 1),(26, 1470, 4, 4, 1),(26, 1471, 5, 2, 1),(26, 1472, 5, 4, 1),(26, 1473, 5, 1, 1),(26, 1474, 5, 3, 1),(26, 1475, 5, 1, 1),(26, 1476, 5, 3, 1),(26, 1477, 5, 1, 1),(26, 1478, 5, 3, 1),(26, 1479, 5, 1, 1),(26, 1480, 5, 3, 1),(26, 1481, 5, 1, 1),(26, 1482, 5, 3, 1),(26, 1483, 5, 1, 1),(26, 1484, 5, 3, 1),(26, 1485, 5, 1, 1),(26, 1486, 5, 3, 1),(26, 1487, 5, 1, 1),(26, 1488, 5, 3, 1),(26, 1489, 5, 1, 1),(26, 1490, 5, 3, 1),(26, 1491, 5, 1, 1),(26, 1492, 5, 3, 1),(26, 1493, 5, 1, 1),(26, 1494, 5, 3, 1),(26, 1495, 5, 1, 1),(26, 1496, 5, 3, 1),(26, 1497, 5, 1, 1),(26, 1498, 5, 3, 1),(26, 1499, 5, 1, 1),(26, 1500, 5, 3, 1),(26, 1501, 5, 1, 1),(26, 1502, 5, 3, 1),(26, 1503, 5, 1, 1),(26, 1504, 5, 3, 1),(26, 1505, 5, 2, 1),(26, 1506, 5, 4, 1),(26, 1507, 5, 2, 1),(26, 1508, 5, 4, 1),(26, 1509, 5, 2, 1),(26, 1510, 5, 4, 1),(26, 1511, 5, 2, 1),(26, 1512, 5, 4, 1),(26, 1513, 5, 2, 1),(26, 1514, 5, 4, 1),(26, 1515, 5, 2, 1),(26, 1516, 5, 4, 1),(26, 1517, 5, 2, 1),(26, 1518, 5, 4, 1),(26, 1519, 5, 2, 1),(26, 1520, 5, 4, 1),(26, 1521, 5, 2, 1),(26, 1522, 5, 4, 1),(26, 1523, 5, 2, 1),(26, 1524, 5, 4, 1),(26, 1525, 5, 2, 1),(26, 1526, 5, 4, 1),(26, 1527, 5, 2, 1),(26, 1528, 5, 4, 1),(26, 1529, 5, 2, 1),(26, 1530, 5, 4, 1),(26, 1531, 5, 2, 1),(26, 1532, 5, 4, 1),(26, 1533, 5, 2, 1),(26, 1534, 5, 4, 1),(26, 1535, 5, 2, 1),(26, 1536, 5, 4, 1),(27, 1, 5, 1, 1),(27, 2, 5, 2, 1),(27, 3, 5, 1, 1),(27, 4, 5, 2, 1),(27, 5, 5, 1, 1),(27, 6, 5, 2, 1),(27, 7, 5, 1, 1),(27, 8, 5, 2, 1),(27, 9, 5, 1, 1),(27, 10, 5, 2, 1),(27, 11, 5, 1, 1),(27, 12, 5, 2, 1),(27, 13, 5, 1, 1),(27, 14, 5, 2, 1),(27, 15, 5, 1, 1),(27, 16, 5, 2, 1),(27, 17, 5, 1, 1),(27, 18, 5, 2, 1),(27, 19, 5, 1, 1),(27, 20, 5, 2, 1),(27, 21, 5, 1, 1),(27, 22, 5, 2, 1),(27, 23, 5, 1, 1),(27, 24, 5, 2, 1),(27, 25, 5, 1, 1),(27, 26, 5, 2, 1),(27, 27, 5, 1, 1),(27, 28, 5, 2, 1),(27, 29, 5, 1, 1),(27, 30, 5, 2, 1),(27, 31, 5, 1, 1),(27, 32, 5, 2, 1),(27, 33, 5, 1, 2),(27, 34, 5, 2, 2),(27, 35, 5, 1, 2),(27, 36, 5, 2, 2),(27, 37, 5, 1, 2),(27, 38, 5, 2, 2),(27, 39, 5, 1, 2),(27, 40, 5, 2, 2),(27, 41, 5, 1, 2),(27, 42, 5, 2, 2),(27, 43, 5, 1, 2),(27, 44, 5, 2, 2),(27, 45, 5, 1, 2),(27, 46, 5, 2, 2),(27, 47, 5, 1, 2),(27, 48, 5, 2, 2),(27, 49, 5, 1, 2),(27, 50, 5, 2, 2),(27, 51, 5, 1, 2),(27, 52, 5, 2, 2),(27, 53, 5, 1, 2),(27, 54, 5, 2, 2),(27, 55, 5, 1, 2),(27, 56, 5, 2, 2),(27, 57, 5, 1, 2),(27, 58, 5, 2, 2),(27, 59, 5, 1, 2),(27, 60, 5, 2, 2),(27, 61, 5, 1, 2),(27, 62, 5, 2, 2),(27, 63, 5, 1, 2),(27, 64, 5, 2, 2),(27, 65, 5, 1, 1),(27, 66, 5, 2, 1),(27, 67, 1, 1, 1),(27, 68, 1, 2, 1),(27, 69, 1, 1, 1),(27, 70, 1, 2, 1),(27, 71, 1, 1, 1),(27, 72, 1, 2, 1),(27, 73, 1, 1, 1),(27, 74, 1, 2, 1),(27, 75, 1, 1, 1),(27, 76, 1, 2, 1),(27, 77, 1, 1, 1),(27, 78, 1, 2, 1),(27, 79, 1, 1, 1),(27, 80, 1, 2, 1),(27, 81, 1, 1, 1),(27, 82, 1, 2, 1),(27, 83, 1, 1, 1),(27, 84, 1, 2, 1),(27, 85, 1, 1, 1),(27, 86, 1, 2, 1),(27, 87, 1, 1, 1),(27, 88, 1, 2, 1),(27, 89, 1, 1, 1),(27, 90, 1, 2, 1),(27, 91, 1, 1, 1),(27, 92, 1, 2, 1),(27, 93, 1, 1, 1),(27, 94, 1, 2, 1),(27, 95, 5, 1, 1),(27, 96, 5, 2, 1),(27, 97, 5, 1, 2),(27, 98, 5, 2, 2),(27, 99, 1, 1, 2),(27, 100, 1, 2, 2),(27, 101, 1, 1, 2),(27, 102, 1, 2, 2),(27, 103, 1, 1, 2),(27, 104, 1, 2, 2),(27, 105, 1, 1, 2),(27, 106, 1, 2, 2),(27, 107, 1, 1, 2),(27, 108, 1, 2, 2),(27, 109, 1, 1, 2),(27, 110, 1, 2, 2),(27, 111, 1, 1, 2),(27, 112, 1, 2, 2),(27, 113, 1, 1, 2),(27, 114, 1, 2, 2),(27, 115, 1, 1, 2),(27, 116, 1, 2, 2),(27, 117, 1, 1, 2),(27, 118, 1, 2, 2),(27, 119, 1, 1, 2),(27, 120, 1, 2, 2),(27, 121, 1, 1, 2),(27, 122, 1, 2, 2),(27, 123, 1, 1, 2),(27, 124, 1, 2, 2),(27, 125, 1, 1, 2),(27, 126, 1, 2, 2),(27, 127, 5, 1, 2),(27, 128, 5, 2, 2),(27, 129, 5, 1, 1),(27, 130, 5, 2, 1),(27, 131, 1, 1, 1),(27, 132, 1, 2, 1),(27, 133, 1, 1, 1),(27, 134, 1, 2, 1),(27, 135, 1, 1, 1),(27, 136, 1, 2, 1),(27, 137, 1, 1, 1),(27, 138, 1, 2, 1),(27, 139, 1, 1, 1),(27, 140, 1, 2, 1),(27, 141, 1, 1, 1),(27, 142, 1, 2, 1),(27, 143, 1, 1, 1),(27, 144, 1, 2, 1),(27, 145, 1, 1, 1),(27, 146, 1, 2, 1),(27, 147, 1, 1, 1),(27, 148, 1, 2, 1),(27, 149, 1, 1, 1),(27, 150, 1, 2, 1),(27, 151, 1, 1, 1),(27, 152, 1, 2, 1),(27, 153, 1, 1, 1),(27, 154, 1, 2, 1),(27, 155, 1, 1, 1),(27, 156, 1, 2, 1),(27, 157, 1, 1, 1),(27, 158, 1, 2, 1),(27, 159, 5, 1, 1),(27, 160, 5, 2, 1),(27, 161, 5, 1, 2),(27, 162, 5, 2, 2),(27, 163, 1, 1, 2),(27, 164, 1, 2, 2),(27, 165, 1, 1, 2),(27, 166, 1, 2, 2),(27, 167, 1, 1, 2),(27, 168, 1, 2, 2),(27, 169, 1, 1, 2),(27, 170, 1, 2, 2),(27, 171, 1, 1, 2),(27, 172, 1, 2, 2),(27, 173, 1, 1, 2),(27, 174, 1, 2, 2),(27, 175, 1, 1, 2),(27, 176, 1, 2, 2),(27, 177, 1, 1, 2),(27, 178, 1, 2, 2),(27, 179, 1, 1, 2),(27, 180, 1, 2, 2),(27, 181, 1, 1, 2),(27, 182, 1, 2, 2),(27, 183, 1, 1, 2),(27, 184, 1, 2, 2),(27, 185, 1, 1, 2),(27, 186, 1, 2, 2),(27, 187, 1, 1, 2),(27, 188, 1, 2, 2),(27, 189, 1, 1, 2),(27, 190, 1, 2, 2),(27, 191, 5, 1, 2),(27, 192, 5, 2, 2),(27, 193, 5, 1, 1),(27, 194, 5, 2, 1),(27, 195, 1, 1, 1),(27, 196, 1, 2, 1),(27, 197, 1, 1, 1),(27, 198, 1, 2, 1),(27, 199, 1, 1, 1),(27, 200, 1, 2, 1),(27, 201, 1, 1, 1),(27, 202, 1, 2, 1),(27, 203, 1, 1, 1),(27, 204, 1, 2, 1),(27, 205, 1, 1, 1),(27, 206, 1, 2, 1),(27, 207, 1, 1, 1),(27, 208, 1, 2, 1),(27, 209, 1, 1, 1),(27, 210, 1, 2, 1),(27, 211, 1, 1, 1),(27, 212, 1, 2, 1),(27, 213, 1, 1, 1),(27, 214, 1, 2, 1),(27, 215, 1, 1, 1),(27, 216, 1, 2, 1),(27, 217, 1, 1, 1),(27, 218, 1, 2, 1),(27, 219, 1, 1, 1),(27, 220, 1, 2, 1),(27, 221, 1, 1, 1),(27, 222, 1, 2, 1),(27, 223, 5, 1, 1),(27, 224, 5, 2, 1),(27, 225, 5, 1, 2),(27, 226, 5, 2, 2),(27, 227, 1, 1, 2),(27, 228, 1, 2, 2),(27, 229, 1, 1, 2),(27, 230, 1, 2, 2),(27, 231, 1, 1, 2),(27, 232, 1, 2, 2),(27, 233, 1, 1, 2),(27, 234, 1, 2, 2),(27, 235, 1, 1, 2),(27, 236, 1, 2, 2),(27, 237, 1, 1, 2),(27, 238, 1, 2, 2),(27, 239, 1, 1, 2),(27, 240, 1, 2, 2),(27, 241, 1, 1, 2),(27, 242, 1, 2, 2),(27, 243, 1, 1, 2),(27, 244, 1, 2, 2),(27, 245, 1, 1, 2),(27, 246, 1, 2, 2),(27, 247, 1, 1, 2),(27, 248, 1, 2, 2),(27, 249, 1, 1, 2),(27, 250, 1, 2, 2),(27, 251, 1, 1, 2),(27, 252, 1, 2, 2),(27, 253, 1, 1, 2),(27, 254, 1, 2, 2),(27, 255, 5, 1, 2),(27, 256, 5, 2, 2),(27, 257, 5, 1, 1),(27, 258, 5, 2, 1),(27, 259, 1, 1, 1),(27, 260, 1, 2, 1),(27, 261, 1, 1, 1),(27, 262, 1, 2, 1),(27, 263, 1, 1, 1),(27, 264, 1, 2, 1),(27, 265, 1, 1, 1),(27, 266, 1, 2, 1),(27, 267, 1, 1, 1),(27, 268, 1, 2, 1),(27, 269, 1, 1, 1),(27, 270, 1, 2, 1),(27, 271, 1, 1, 1),(27, 272, 1, 2, 1),(27, 273, 1, 1, 1),(27, 274, 1, 2, 1),(27, 275, 1, 1, 1),(27, 276, 1, 2, 1),(27, 277, 1, 1, 1),(27, 278, 1, 2, 1),(27, 279, 1, 1, 1),(27, 280, 1, 2, 1),(27, 281, 1, 1, 1),(27, 282, 1, 2, 1),(27, 283, 1, 1, 1),(27, 284, 1, 2, 1),(27, 285, 1, 1, 1),(27, 286, 1, 2, 1),(27, 287, 5, 1, 1),(27, 288, 5, 2, 1),(27, 289, 5, 1, 2),(27, 290, 5, 2, 2),(27, 291, 1, 1, 2),(27, 292, 1, 2, 2),(27, 293, 1, 1, 2),(27, 294, 1, 2, 2),(27, 295, 1, 1, 2),(27, 296, 1, 2, 2),(27, 297, 1, 1, 2),(27, 298, 1, 2, 2),(27, 299, 1, 1, 2),(27, 300, 1, 2, 2),(27, 301, 1, 1, 2),(27, 302, 1, 2, 2),(27, 303, 1, 1, 2),(27, 304, 1, 2, 2),(27, 305, 1, 1, 2),(27, 306, 1, 2, 2),(27, 307, 1, 1, 2),(27, 308, 1, 2, 2),(27, 309, 1, 1, 2),(27, 310, 1, 2, 2),(27, 311, 1, 1, 2),(27, 312, 1, 2, 2),(27, 313, 1, 1, 2),(27, 314, 1, 2, 2),(27, 315, 1, 1, 2),(27, 316, 1, 2, 2),(27, 317, 1, 1, 2),(27, 318, 1, 2, 2),(27, 319, 5, 1, 2),(27, 320, 5, 2, 2),(27, 321, 5, 1, 1),(27, 322, 5, 2, 1),(27, 323, 1, 1, 1),(27, 324, 1, 2, 1),(27, 325, 1, 1, 1),(27, 326, 1, 2, 1),(27, 327, 1, 1, 1),(27, 328, 1, 2, 1),(27, 329, 1, 1, 1),(27, 330, 1, 2, 1),(27, 331, 1, 1, 1),(27, 332, 1, 2, 1),(27, 333, 1, 1, 1),(27, 334, 1, 2, 1),(27, 335, 1, 1, 1),(27, 336, 1, 2, 1),(27, 337, 1, 1, 1),(27, 338, 1, 2, 1),(27, 339, 1, 1, 1),(27, 340, 1, 2, 1),(27, 341, 1, 1, 1),(27, 342, 1, 2, 1),(27, 343, 1, 1, 1),(27, 344, 1, 2, 1),(27, 345, 1, 1, 1),(27, 346, 1, 2, 1),(27, 347, 1, 1, 1),(27, 348, 1, 2, 1),(27, 349, 1, 1, 1),(27, 350, 1, 2, 1),(27, 351, 5, 1, 1),(27, 352, 5, 2, 1),(27, 353, 5, 1, 2),(27, 354, 5, 2, 2),(27, 355, 1, 1, 2),(27, 356, 1, 2, 2),(27, 357, 1, 1, 2),(27, 358, 1, 2, 2),(27, 359, 1, 1, 2),(27, 360, 1, 2, 2),(27, 361, 1, 1, 2),(27, 362, 1, 2, 2),(27, 363, 1, 1, 2),(27, 364, 1, 2, 2),(27, 365, 1, 1, 2),(27, 366, 1, 2, 2),(27, 367, 1, 1, 2),(27, 368, 1, 2, 2),(27, 369, 1, 1, 2),(27, 370, 1, 2, 2),(27, 371, 1, 1, 2),(27, 372, 1, 2, 2),(27, 373, 1, 1, 2),(27, 374, 1, 2, 2),(27, 375, 1, 1, 2),(27, 376, 1, 2, 2),(27, 377, 1, 1, 2),(27, 378, 1, 2, 2),(27, 379, 1, 1, 2),(27, 380, 1, 2, 2),(27, 381, 1, 1, 2),(27, 382, 1, 2, 2),(27, 383, 5, 1, 2),(27, 384, 5, 2, 2),(27, 385, 5, 1, 1),(27, 386, 5, 2, 1),(27, 387, 1, 1, 1),(27, 388, 1, 2, 1),(27, 389, 1, 1, 1),(27, 390, 1, 2, 1),(27, 391, 1, 1, 1),(27, 392, 1, 2, 1),(27, 393, 1, 1, 1),(27, 394, 1, 2, 1),(27, 395, 1, 1, 1),(27, 396, 1, 2, 1),(27, 397, 1, 1, 1),(27, 398, 1, 2, 1),(27, 399, 1, 1, 1),(27, 400, 1, 2, 1),(27, 401, 1, 1, 1),(27, 402, 1, 2, 1),(27, 403, 1, 1, 1),(27, 404, 1, 2, 1),(27, 405, 1, 1, 1),(27, 406, 1, 2, 1),(27, 407, 1, 1, 1),(27, 408, 1, 2, 1),(27, 409, 1, 1, 1),(27, 410, 1, 2, 1),(27, 411, 1, 1, 1),(27, 412, 1, 2, 1),(27, 413, 1, 1, 1),(27, 414, 1, 2, 1),(27, 415, 5, 1, 1),(27, 416, 5, 2, 1),(27, 417, 5, 1, 2),(27, 418, 5, 2, 2),(27, 419, 1, 1, 2),(27, 420, 1, 2, 2),(27, 421, 1, 1, 2),(27, 422, 1, 2, 2),(27, 423, 1, 1, 2),(27, 424, 1, 2, 2),(27, 425, 1, 1, 2),(27, 426, 1, 2, 2),(27, 427, 1, 1, 2),(27, 428, 1, 2, 2),(27, 429, 1, 1, 2),(27, 430, 1, 2, 2),(27, 431, 1, 1, 2),(27, 432, 1, 2, 2),(27, 433, 1, 1, 2),(27, 434, 1, 2, 2),(27, 435, 1, 1, 2),(27, 436, 1, 2, 2),(27, 437, 1, 1, 2),(27, 438, 1, 2, 2),(27, 439, 1, 1, 2),(27, 440, 1, 2, 2),(27, 441, 1, 1, 2),(27, 442, 1, 2, 2),(27, 443, 1, 1, 2),(27, 444, 1, 2, 2),(27, 445, 1, 1, 2),(27, 446, 1, 2, 2),(27, 447, 5, 1, 2),(27, 448, 5, 2, 2),(27, 449, 5, 1, 1),(27, 450, 5, 2, 1),(27, 451, 1, 1, 1),(27, 452, 1, 2, 1),(27, 453, 1, 1, 1),(27, 454, 1, 2, 1),(27, 455, 1, 1, 1),(27, 456, 1, 2, 1),(27, 457, 1, 1, 1),(27, 458, 1, 2, 1),(27, 459, 1, 1, 1),(27, 460, 1, 2, 1),(27, 461, 1, 1, 1),(27, 462, 1, 2, 1),(27, 463, 1, 1, 1),(27, 464, 1, 2, 1),(27, 465, 1, 1, 1),(27, 466, 1, 2, 1),(27, 467, 1, 1, 1),(27, 468, 1, 2, 1),(27, 469, 1, 1, 1),(27, 470, 1, 2, 1),(27, 471, 1, 1, 1),(27, 472, 1, 2, 1),(27, 473, 1, 1, 1),(27, 474, 1, 2, 1),(27, 475, 1, 1, 1),(27, 476, 1, 2, 1),(27, 477, 1, 1, 1),(27, 478, 1, 2, 1),(27, 479, 5, 1, 1),(27, 480, 5, 2, 1),(27, 481, 5, 1, 2),(27, 482, 5, 2, 2),(27, 483, 1, 1, 2),(27, 484, 1, 2, 2),(27, 485, 1, 1, 2),(27, 486, 1, 2, 2),(27, 487, 1, 1, 2),(27, 488, 1, 2, 2),(27, 489, 1, 1, 2),(27, 490, 1, 2, 2),(27, 491, 1, 1, 2),(27, 492, 1, 2, 2),(27, 493, 1, 1, 2),(27, 494, 1, 2, 2),(27, 495, 1, 1, 2),(27, 496, 1, 2, 2),(27, 497, 1, 1, 2),(27, 498, 1, 2, 2),(27, 499, 1, 1, 2),(27, 500, 1, 2, 2),(27, 501, 1, 1, 2),(27, 502, 1, 2, 2),(27, 503, 1, 1, 2),(27, 504, 1, 2, 2),(27, 505, 1, 1, 2),(27, 506, 1, 2, 2),(27, 507, 1, 1, 2),(27, 508, 1, 2, 2),(27, 509, 1, 1, 2),(27, 510, 1, 2, 2),(27, 511, 5, 1, 2),(27, 512, 5, 2, 2),(27, 513, 5, 1, 1),(27, 514, 5, 2, 1),(27, 515, 1, 1, 1),(27, 516, 1, 2, 1),(27, 517, 1, 1, 1),(27, 518, 1, 2, 1),(27, 519, 1, 1, 1),(27, 520, 1, 2, 1),(27, 521, 1, 1, 1),(27, 522, 1, 2, 1),(27, 523, 1, 1, 1),(27, 524, 1, 2, 1),(27, 525, 1, 1, 1),(27, 526, 1, 2, 1),(27, 527, 1, 1, 1),(27, 528, 1, 2, 1),(27, 529, 1, 1, 1),(27, 530, 1, 2, 1),(27, 531, 1, 1, 1),(27, 532, 1, 2, 1),(27, 533, 1, 1, 1),(27, 534, 1, 2, 1),(27, 535, 1, 1, 1),(27, 536, 1, 2, 1),(27, 537, 1, 1, 1),(27, 538, 1, 2, 1),(27, 539, 1, 1, 1),(27, 540, 1, 2, 1),(27, 541, 1, 1, 1),(27, 542, 1, 2, 1),(27, 543, 5, 1, 1),(27, 544, 5, 2, 1),(27, 545, 5, 1, 2),(27, 546, 5, 2, 2),(27, 547, 1, 1, 2),(27, 548, 1, 2, 2),(27, 549, 1, 1, 2),(27, 550, 1, 2, 2),(27, 551, 1, 1, 2),(27, 552, 1, 2, 2),(27, 553, 1, 1, 2),(27, 554, 1, 2, 2),(27, 555, 1, 1, 2),(27, 556, 1, 2, 2),(27, 557, 1, 1, 2),(27, 558, 1, 2, 2),(27, 559, 1, 1, 2),(27, 560, 1, 2, 2),(27, 561, 1, 1, 2),(27, 562, 1, 2, 2),(27, 563, 1, 1, 2),(27, 564, 1, 2, 2),(27, 565, 1, 1, 2),(27, 566, 1, 2, 2),(27, 567, 1, 1, 2),(27, 568, 1, 2, 2),(27, 569, 1, 1, 2),(27, 570, 1, 2, 2),(27, 571, 1, 1, 2),(27, 572, 1, 2, 2),(27, 573, 1, 1, 2),(27, 574, 1, 2, 2),(27, 575, 5, 1, 2),(27, 576, 5, 2, 2),(27, 577, 5, 1, 1),(27, 578, 5, 2, 1),(27, 579, 1, 1, 1),(27, 580, 1, 2, 1),(27, 581, 1, 1, 1),(27, 582, 1, 2, 1),(27, 583, 1, 1, 1),(27, 584, 1, 2, 1),(27, 585, 1, 1, 1),(27, 586, 1, 2, 1),(27, 587, 1, 1, 1),(27, 588, 1, 2, 1),(27, 589, 1, 1, 1),(27, 590, 1, 2, 1),(27, 591, 1, 1, 1),(27, 592, 1, 2, 1),(27, 593, 1, 1, 1),(27, 594, 1, 2, 1),(27, 595, 1, 1, 1),(27, 596, 1, 2, 1),(27, 597, 1, 1, 1),(27, 598, 1, 2, 1),(27, 599, 1, 1, 1),(27, 600, 1, 2, 1),(27, 601, 1, 1, 1),(27, 602, 1, 2, 1),(27, 603, 1, 1, 1),(27, 604, 1, 2, 1),(27, 605, 1, 1, 1),(27, 606, 1, 2, 1),(27, 607, 5, 1, 1),(27, 608, 5, 2, 1),(27, 609, 5, 1, 2),(27, 610, 5, 2, 2),(27, 611, 1, 1, 2),(27, 612, 1, 2, 2),(27, 613, 1, 1, 2),(27, 614, 1, 2, 2),(27, 615, 1, 1, 2),(27, 616, 1, 2, 2),(27, 617, 1, 1, 2),(27, 618, 1, 2, 2),(27, 619, 1, 1, 2),(27, 620, 1, 2, 2),(27, 621, 1, 1, 2),(27, 622, 1, 2, 2),(27, 623, 1, 1, 2),(27, 624, 1, 2, 2),(27, 625, 1, 1, 2),(27, 626, 1, 2, 2),(27, 627, 1, 1, 2),(27, 628, 1, 2, 2),(27, 629, 1, 1, 2),(27, 630, 1, 2, 2),(27, 631, 1, 1, 2),(27, 632, 1, 2, 2),(27, 633, 1, 1, 2),(27, 634, 1, 2, 2),(27, 635, 1, 1, 2),(27, 636, 1, 2, 2),(27, 637, 1, 1, 2),(27, 638, 1, 2, 2),(27, 639, 5, 1, 2),(27, 640, 5, 2, 2),(27, 641, 5, 1, 1),(27, 642, 5, 2, 1),(27, 643, 1, 1, 1),(27, 644, 1, 2, 1),(27, 645, 1, 1, 1),(27, 646, 1, 2, 1),(27, 647, 1, 1, 1),(27, 648, 1, 2, 1),(27, 649, 1, 1, 1),(27, 650, 1, 2, 1),(27, 651, 1, 1, 1),(27, 652, 1, 2, 1),(27, 653, 1, 1, 1),(27, 654, 1, 2, 1),(27, 655, 1, 1, 1),(27, 656, 1, 2, 1),(27, 657, 1, 1, 1),(27, 658, 1, 2, 1),(27, 659, 1, 1, 1),(27, 660, 1, 2, 1),(27, 661, 1, 1, 1),(27, 662, 1, 2, 1),(27, 663, 1, 1, 1),(27, 664, 1, 2, 1),(27, 665, 1, 1, 1),(27, 666, 1, 2, 1),(27, 667, 1, 1, 1),(27, 668, 1, 2, 1),(27, 669, 1, 1, 1),(27, 670, 1, 2, 1),(27, 671, 5, 1, 1),(27, 672, 5, 2, 1),(27, 673, 5, 1, 2),(27, 674, 5, 2, 2),(27, 675, 1, 1, 2),(27, 676, 1, 2, 2),(27, 677, 1, 1, 2),(27, 678, 1, 2, 2),(27, 679, 1, 1, 2),(27, 680, 1, 2, 2),(27, 681, 1, 1, 2),(27, 682, 1, 2, 2),(27, 683, 1, 1, 2),(27, 684, 1, 2, 2),(27, 685, 1, 1, 2),(27, 686, 1, 2, 2),(27, 687, 1, 1, 2),(27, 688, 1, 2, 2),(27, 689, 1, 1, 2),(27, 690, 1, 2, 2),(27, 691, 1, 1, 2),(27, 692, 1, 2, 2),(27, 693, 1, 1, 2),(27, 694, 1, 2, 2),(27, 695, 1, 1, 2),(27, 696, 1, 2, 2),(27, 697, 1, 1, 2),(27, 698, 1, 2, 2),(27, 699, 1, 1, 2),(27, 700, 1, 2, 2),(27, 701, 1, 1, 2),(27, 702, 1, 2, 2),(27, 703, 5, 1, 2),(27, 704, 5, 2, 2),(27, 705, 5, 1, 1),(27, 706, 5, 2, 1),(27, 707, 1, 1, 1),(27, 708, 1, 2, 1),(27, 709, 1, 1, 1),(27, 710, 1, 2, 1),(27, 711, 1, 1, 1),(27, 712, 1, 2, 1),(27, 713, 1, 1, 1),(27, 714, 1, 2, 1),(27, 715, 1, 1, 1),(27, 716, 1, 2, 1),(27, 717, 1, 1, 1),(27, 718, 1, 2, 1),(27, 719, 1, 1, 1),(27, 720, 1, 2, 1),(27, 721, 1, 1, 1),(27, 722, 1, 2, 1),(27, 723, 1, 1, 1),(27, 724, 1, 2, 1),(27, 725, 1, 1, 1),(27, 726, 1, 2, 1),(27, 727, 1, 1, 1),(27, 728, 1, 2, 1),(27, 729, 1, 1, 1),(27, 730, 1, 2, 1),(27, 731, 1, 1, 1),(27, 732, 1, 2, 1),(27, 733, 1, 1, 1),(27, 734, 1, 2, 1),(27, 735, 5, 1, 1),(27, 736, 5, 2, 1),(27, 737, 5, 1, 2),(27, 738, 5, 2, 2),(27, 739, 1, 1, 2),(27, 740, 1, 2, 2),(27, 741, 1, 1, 2),(27, 742, 1, 2, 2),(27, 743, 1, 1, 2),(27, 744, 1, 2, 2),(27, 745, 1, 1, 2),(27, 746, 1, 2, 2),(27, 747, 1, 1, 2),(27, 748, 1, 2, 2),(27, 749, 1, 1, 2),(27, 750, 1, 2, 2),(27, 751, 1, 1, 2),(27, 752, 1, 2, 2),(27, 753, 1, 1, 2),(27, 754, 1, 2, 2),(27, 755, 1, 1, 2),(27, 756, 1, 2, 2),(27, 757, 1, 1, 2),(27, 758, 1, 2, 2),(27, 759, 1, 1, 2),(27, 760, 1, 2, 2),(27, 761, 1, 1, 2),(27, 762, 1, 2, 2),(27, 763, 1, 1, 2),(27, 764, 1, 2, 2),(27, 765, 1, 1, 2),(27, 766, 1, 2, 2),(27, 767, 5, 1, 2),(27, 768, 5, 2, 2),(27, 769, 5, 1, 1),(27, 770, 5, 2, 1),(27, 771, 1, 1, 1),(27, 772, 1, 2, 1),(27, 773, 1, 1, 1),(27, 774, 1, 2, 1),(27, 775, 1, 1, 1),(27, 776, 1, 2, 1),(27, 777, 1, 1, 1),(27, 778, 1, 2, 1),(27, 779, 1, 1, 1),(27, 780, 1, 2, 1),(27, 781, 1, 1, 1),(27, 782, 1, 2, 1),(27, 783, 1, 1, 1),(27, 784, 1, 2, 1),(27, 785, 1, 1, 1),(27, 786, 1, 2, 1),(27, 787, 1, 1, 1),(27, 788, 1, 2, 1),(27, 789, 1, 1, 1),(27, 790, 1, 2, 1),(27, 791, 1, 1, 1),(27, 792, 1, 2, 1),(27, 793, 1, 1, 1),(27, 794, 1, 2, 1),(27, 795, 1, 1, 1),(27, 796, 1, 2, 1),(27, 797, 1, 1, 1),(27, 798, 1, 2, 1),(27, 799, 5, 1, 1),(27, 800, 5, 2, 1),(27, 801, 5, 1, 2),(27, 802, 5, 2, 2),(27, 803, 1, 1, 2),(27, 804, 1, 2, 2),(27, 805, 1, 1, 2),(27, 806, 1, 2, 2),(27, 807, 1, 1, 2),(27, 808, 1, 2, 2),(27, 809, 1, 1, 2),(27, 810, 1, 2, 2),(27, 811, 1, 1, 2),(27, 812, 1, 2, 2),(27, 813, 1, 1, 2),(27, 814, 1, 2, 2),(27, 815, 1, 1, 2),(27, 816, 1, 2, 2),(27, 817, 1, 1, 2),(27, 818, 1, 2, 2),(27, 819, 1, 1, 2),(27, 820, 1, 2, 2),(27, 821, 1, 1, 2),(27, 822, 1, 2, 2),(27, 823, 1, 1, 2),(27, 824, 1, 2, 2),(27, 825, 1, 1, 2),(27, 826, 1, 2, 2),(27, 827, 1, 1, 2),(27, 828, 1, 2, 2),(27, 829, 1, 1, 2),(27, 830, 1, 2, 2),(27, 831, 5, 1, 2),(27, 832, 5, 2, 2),(27, 833, 5, 1, 1),(27, 834, 5, 2, 1),(27, 835, 1, 1, 1),(27, 836, 1, 2, 1),(27, 837, 1, 1, 1),(27, 838, 1, 2, 1),(27, 839, 1, 1, 1),(27, 840, 1, 2, 1),(27, 841, 1, 1, 1),(27, 842, 1, 2, 1),(27, 843, 1, 1, 1),(27, 844, 1, 2, 1),(27, 845, 1, 1, 1),(27, 846, 1, 2, 1),(27, 847, 1, 1, 1),(27, 848, 1, 2, 1),(27, 849, 1, 1, 1),(27, 850, 1, 2, 1),(27, 851, 1, 1, 1),(27, 852, 1, 2, 1),(27, 853, 1, 1, 1),(27, 854, 1, 2, 1),(27, 855, 1, 1, 1),(27, 856, 1, 2, 1),(27, 857, 1, 1, 1),(27, 858, 1, 2, 1),(27, 859, 1, 1, 1),(27, 860, 1, 2, 1),(27, 861, 1, 1, 1),(27, 862, 1, 2, 1),(27, 863, 5, 1, 1),(27, 864, 5, 2, 1),(27, 865, 5, 1, 2),(27, 866, 5, 2, 2),(27, 867, 1, 1, 2),(27, 868, 1, 2, 2),(27, 869, 1, 1, 2),(27, 870, 1, 2, 2),(27, 871, 1, 1, 2),(27, 872, 1, 2, 2),(27, 873, 1, 1, 2),(27, 874, 1, 2, 2),(27, 875, 1, 1, 2),(27, 876, 1, 2, 2),(27, 877, 1, 1, 2),(27, 878, 1, 2, 2),(27, 879, 1, 1, 2),(27, 880, 1, 2, 2),(27, 881, 1, 1, 2),(27, 882, 1, 2, 2),(27, 883, 1, 1, 2),(27, 884, 1, 2, 2),(27, 885, 1, 1, 2),(27, 886, 1, 2, 2),(27, 887, 1, 1, 2),(27, 888, 1, 2, 2),(27, 889, 1, 1, 2),(27, 890, 1, 2, 2),(27, 891, 1, 1, 2),(27, 892, 1, 2, 2),(27, 893, 1, 1, 2),(27, 894, 1, 2, 2),(27, 895, 5, 1, 2),(27, 896, 5, 2, 2),(27, 897, 5, 1, 1),(27, 898, 5, 2, 1),(27, 899, 1, 1, 1),(27, 900, 1, 2, 1),(27, 901, 1, 1, 1),(27, 902, 1, 2, 1),(27, 903, 1, 1, 1),(27, 904, 1, 2, 1),(27, 905, 1, 1, 1),(27, 906, 1, 2, 1),(27, 907, 1, 1, 1),(27, 908, 1, 2, 1),(27, 909, 1, 1, 1),(27, 910, 1, 2, 1),(27, 911, 1, 1, 1),(27, 912, 1, 2, 1),(27, 913, 1, 1, 1),(27, 914, 1, 2, 1),(27, 915, 1, 1, 1),(27, 916, 1, 2, 1),(27, 917, 1, 1, 1),(27, 918, 1, 2, 1),(27, 919, 1, 1, 1),(27, 920, 1, 2, 1),(27, 921, 1, 1, 1),(27, 922, 1, 2, 1),(27, 923, 1, 1, 1),(27, 924, 1, 2, 1),(27, 925, 1, 1, 1),(27, 926, 1, 2, 1),(27, 927, 5, 1, 1),(27, 928, 5, 2, 1),(27, 929, 5, 1, 2),(27, 930, 5, 2, 2),(27, 931, 1, 1, 2),(27, 932, 1, 2, 2),(27, 933, 1, 1, 2),(27, 934, 1, 2, 2),(27, 935, 1, 1, 2),(27, 936, 1, 2, 2),(27, 937, 1, 1, 2),(27, 938, 1, 2, 2),(27, 939, 1, 1, 2),(27, 940, 1, 2, 2),(27, 941, 1, 1, 2),(27, 942, 1, 2, 2),(27, 943, 1, 1, 2),(27, 944, 1, 2, 2),(27, 945, 1, 1, 2),(27, 946, 1, 2, 2),(27, 947, 1, 1, 2),(27, 948, 1, 2, 2),(27, 949, 1, 1, 2),(27, 950, 1, 2, 2),(27, 951, 1, 1, 2),(27, 952, 1, 2, 2),(27, 953, 1, 1, 2),(27, 954, 1, 2, 2),(27, 955, 1, 1, 2),(27, 956, 1, 2, 2),(27, 957, 1, 1, 2),(27, 958, 1, 2, 2),(27, 959, 5, 1, 2),(27, 960, 5, 2, 2),(27, 961, 5, 1, 1),(27, 962, 5, 2, 1),(27, 963, 1, 1, 1),(27, 964, 1, 2, 1),(27, 965, 1, 1, 1),(27, 966, 1, 2, 1),(27, 967, 1, 1, 1),(27, 968, 1, 2, 1),(27, 969, 1, 1, 1),(27, 970, 1, 2, 1),(27, 971, 1, 1, 1),(27, 972, 1, 2, 1),(27, 973, 1, 1, 1),(27, 974, 1, 2, 1),(27, 975, 1, 1, 1),(27, 976, 1, 2, 1),(27, 977, 1, 1, 1),(27, 978, 1, 2, 1),(27, 979, 1, 1, 1),(27, 980, 1, 2, 1),(27, 981, 1, 1, 1),(27, 982, 1, 2, 1),(27, 983, 1, 1, 1),(27, 984, 1, 2, 1),(27, 985, 1, 1, 1),(27, 986, 1, 2, 1),(27, 987, 1, 1, 1),(27, 988, 1, 2, 1),(27, 989, 1, 1, 1),(27, 990, 1, 2, 1),(27, 991, 5, 1, 1),(27, 992, 5, 2, 1),(27, 993, 5, 1, 2),(27, 994, 5, 2, 2),(27, 995, 1, 1, 2),(27, 996, 1, 2, 2),(27, 997, 1, 1, 2),(27, 998, 1, 2, 2),(27, 999, 1, 1, 2),(27, 1000, 1, 2, 2),(27, 1001, 1, 1, 2),(27, 1002, 1, 2, 2),(27, 1003, 1, 1, 2),(27, 1004, 1, 2, 2),(27, 1005, 1, 1, 2),(27, 1006, 1, 2, 2),(27, 1007, 1, 1, 2),(27, 1008, 1, 2, 2),(27, 1009, 1, 1, 2),(27, 1010, 1, 2, 2),(27, 1011, 1, 1, 2),(27, 1012, 1, 2, 2),(27, 1013, 1, 1, 2),(27, 1014, 1, 2, 2),(27, 1015, 1, 1, 2),(27, 1016, 1, 2, 2),(27, 1017, 1, 1, 2),(27, 1018, 1, 2, 2),(27, 1019, 1, 1, 2),(27, 1020, 1, 2, 2),(27, 1021, 1, 1, 2),(27, 1022, 1, 2, 2),(27, 1023, 5, 1, 2),(27, 1024, 5, 2, 2),(27, 1025, 5, 1, 1),(27, 1026, 5, 2, 1),(27, 1027, 1, 1, 1),(27, 1028, 1, 2, 1),(27, 1029, 1, 1, 1),(27, 1030, 1, 2, 1),(27, 1031, 1, 1, 1),(27, 1032, 1, 2, 1),(27, 1033, 1, 1, 1),(27, 1034, 1, 2, 1),(27, 1035, 1, 1, 1),(27, 1036, 1, 2, 1),(27, 1037, 1, 1, 1),(27, 1038, 1, 2, 1),(27, 1039, 1, 1, 1),(27, 1040, 1, 2, 1),(27, 1041, 1, 1, 1),(27, 1042, 1, 2, 1),(27, 1043, 1, 1, 1),(27, 1044, 1, 2, 1),(27, 1045, 1, 1, 1),(27, 1046, 1, 2, 1),(27, 1047, 1, 1, 1),(27, 1048, 1, 2, 1),(27, 1049, 1, 1, 1),(27, 1050, 1, 2, 1),(27, 1051, 1, 1, 1),(27, 1052, 1, 2, 1),(27, 1053, 1, 1, 1),(27, 1054, 1, 2, 1),(27, 1055, 5, 1, 1),(27, 1056, 5, 2, 1),(27, 1057, 5, 1, 2),(27, 1058, 5, 2, 2),(27, 1059, 1, 1, 2),(27, 1060, 1, 2, 2),(27, 1061, 1, 1, 2),(27, 1062, 1, 2, 2),(27, 1063, 1, 1, 2),(27, 1064, 1, 2, 2),(27, 1065, 1, 1, 2),(27, 1066, 1, 2, 2),(27, 1067, 1, 1, 2),(27, 1068, 1, 2, 2),(27, 1069, 1, 1, 2),(27, 1070, 1, 2, 2),(27, 1071, 1, 1, 2),(27, 1072, 1, 2, 2),(27, 1073, 1, 1, 2),(27, 1074, 1, 2, 2),(27, 1075, 1, 1, 2),(27, 1076, 1, 2, 2),(27, 1077, 1, 1, 2),(27, 1078, 1, 2, 2),(27, 1079, 1, 1, 2),(27, 1080, 1, 2, 2),(27, 1081, 1, 1, 2),(27, 1082, 1, 2, 2),(27, 1083, 1, 1, 2),(27, 1084, 1, 2, 2),(27, 1085, 1, 1, 2),(27, 1086, 1, 2, 2),(27, 1087, 5, 1, 2),(27, 1088, 5, 2, 2),(27, 1089, 5, 1, 1),(27, 1090, 5, 2, 1),(27, 1091, 1, 1, 1),(27, 1092, 1, 2, 1),(27, 1093, 1, 1, 1),(27, 1094, 1, 2, 1),(27, 1095, 1, 1, 1),(27, 1096, 1, 2, 1),(27, 1097, 1, 1, 1),(27, 1098, 1, 2, 1),(27, 1099, 1, 1, 1),(27, 1100, 1, 2, 1),(27, 1101, 1, 1, 1),(27, 1102, 1, 2, 1),(27, 1103, 1, 1, 1),(27, 1104, 1, 2, 1),(27, 1105, 1, 1, 1),(27, 1106, 1, 2, 1),(27, 1107, 1, 1, 1),(27, 1108, 1, 2, 1),(27, 1109, 1, 1, 1),(27, 1110, 1, 2, 1),(27, 1111, 1, 1, 1),(27, 1112, 1, 2, 1),(27, 1113, 1, 1, 1),(27, 1114, 1, 2, 1),(27, 1115, 1, 1, 1),(27, 1116, 1, 2, 1),(27, 1117, 1, 1, 1),(27, 1118, 1, 2, 1),(27, 1119, 5, 1, 1),(27, 1120, 5, 2, 1),(27, 1121, 5, 1, 2),(27, 1122, 5, 2, 2),(27, 1123, 1, 1, 2),(27, 1124, 1, 2, 2),(27, 1125, 1, 1, 2),(27, 1126, 1, 2, 2),(27, 1127, 1, 1, 2),(27, 1128, 1, 2, 2),(27, 1129, 1, 1, 2),(27, 1130, 1, 2, 2),(27, 1131, 1, 1, 2),(27, 1132, 1, 2, 2),(27, 1133, 1, 1, 2),(27, 1134, 1, 2, 2),(27, 1135, 1, 1, 2),(27, 1136, 1, 2, 2),(27, 1137, 1, 1, 2),(27, 1138, 1, 2, 2),(27, 1139, 1, 1, 2),(27, 1140, 1, 2, 2),(27, 1141, 1, 1, 2),(27, 1142, 1, 2, 2),(27, 1143, 1, 1, 2),(27, 1144, 1, 2, 2),(27, 1145, 1, 1, 2),(27, 1146, 1, 2, 2),(27, 1147, 1, 1, 2),(27, 1148, 1, 2, 2),(27, 1149, 1, 1, 2),(27, 1150, 1, 2, 2),(27, 1151, 5, 1, 2),(27, 1152, 5, 2, 2),(27, 1153, 5, 1, 1),(27, 1154, 5, 2, 1),(27, 1155, 1, 1, 1),(27, 1156, 1, 2, 1),(27, 1157, 1, 1, 1),(27, 1158, 1, 2, 1),(27, 1159, 1, 1, 1),(27, 1160, 1, 2, 1),(27, 1161, 1, 1, 1),(27, 1162, 1, 2, 1),(27, 1163, 1, 1, 1),(27, 1164, 1, 2, 1),(27, 1165, 1, 1, 1),(27, 1166, 1, 2, 1),(27, 1167, 1, 1, 1),(27, 1168, 1, 2, 1),(27, 1169, 1, 1, 1),(27, 1170, 1, 2, 1),(27, 1171, 1, 1, 1),(27, 1172, 1, 2, 1),(27, 1173, 1, 1, 1),(27, 1174, 1, 2, 1),(27, 1175, 1, 1, 1),(27, 1176, 1, 2, 1),(27, 1177, 1, 1, 1),(27, 1178, 1, 2, 1),(27, 1179, 1, 1, 1),(27, 1180, 1, 2, 1),(27, 1181, 1, 1, 1),(27, 1182, 1, 2, 1),(27, 1183, 5, 1, 1),(27, 1184, 5, 2, 1),(27, 1185, 5, 1, 2),(27, 1186, 5, 2, 2),(27, 1187, 1, 1, 2),(27, 1188, 1, 2, 2),(27, 1189, 1, 1, 2),(27, 1190, 1, 2, 2),(27, 1191, 1, 1, 2),(27, 1192, 1, 2, 2),(27, 1193, 1, 1, 2),(27, 1194, 1, 2, 2),(27, 1195, 1, 1, 2),(27, 1196, 1, 2, 2),(27, 1197, 1, 1, 2),(27, 1198, 1, 2, 2),(27, 1199, 1, 1, 2),(27, 1200, 1, 2, 2),(27, 1201, 1, 1, 2),(27, 1202, 1, 2, 2),(27, 1203, 1, 1, 2),(27, 1204, 1, 2, 2),(27, 1205, 1, 1, 2),(27, 1206, 1, 2, 2),(27, 1207, 1, 1, 2),(27, 1208, 1, 2, 2),(27, 1209, 1, 1, 2),(27, 1210, 1, 2, 2),(27, 1211, 1, 1, 2),(27, 1212, 1, 2, 2),(27, 1213, 1, 1, 2),(27, 1214, 1, 2, 2),(27, 1215, 5, 1, 2),(27, 1216, 5, 2, 2),(27, 1217, 5, 1, 1),(27, 1218, 5, 2, 1),(27, 1219, 1, 1, 1),(27, 1220, 1, 2, 1),(27, 1221, 1, 1, 1),(27, 1222, 1, 2, 1),(27, 1223, 1, 1, 1),(27, 1224, 1, 2, 1),(27, 1225, 1, 1, 1),(27, 1226, 1, 2, 1),(27, 1227, 1, 1, 1),(27, 1228, 1, 2, 1),(27, 1229, 1, 1, 1),(27, 1230, 1, 2, 1),(27, 1231, 1, 1, 1),(27, 1232, 1, 2, 1),(27, 1233, 1, 1, 1),(27, 1234, 1, 2, 1),(27, 1235, 1, 1, 1),(27, 1236, 1, 2, 1),(27, 1237, 1, 1, 1),(27, 1238, 1, 2, 1),(27, 1239, 1, 1, 1),(27, 1240, 1, 2, 1),(27, 1241, 1, 1, 1),(27, 1242, 1, 2, 1),(27, 1243, 1, 1, 1),(27, 1244, 1, 2, 1),(27, 1245, 1, 1, 1),(27, 1246, 1, 2, 1),(27, 1247, 5, 1, 1),(27, 1248, 5, 2, 1),(27, 1249, 5, 1, 2),(27, 1250, 5, 2, 2),(27, 1251, 1, 1, 2),(27, 1252, 1, 2, 2),(27, 1253, 1, 1, 2),(27, 1254, 1, 2, 2),(27, 1255, 1, 1, 2),(27, 1256, 1, 2, 2),(27, 1257, 1, 1, 2),(27, 1258, 1, 2, 2),(27, 1259, 1, 1, 2),(27, 1260, 1, 2, 2),(27, 1261, 1, 1, 2),(27, 1262, 1, 2, 2),(27, 1263, 1, 1, 2),(27, 1264, 1, 2, 2),(27, 1265, 1, 1, 2),(27, 1266, 1, 2, 2),(27, 1267, 1, 1, 2),(27, 1268, 1, 2, 2),(27, 1269, 1, 1, 2),(27, 1270, 1, 2, 2),(27, 1271, 1, 1, 2),(27, 1272, 1, 2, 2),(27, 1273, 1, 1, 2),(27, 1274, 1, 2, 2),(27, 1275, 1, 1, 2),(27, 1276, 1, 2, 2),(27, 1277, 1, 1, 2),(27, 1278, 1, 2, 2),(27, 1279, 5, 1, 2),(27, 1280, 5, 2, 2),(27, 1281, 5, 1, 1),(27, 1282, 5, 2, 1),(27, 1283, 1, 1, 1),(27, 1284, 1, 2, 1),(27, 1285, 1, 1, 1),(27, 1286, 1, 2, 1),(27, 1287, 1, 1, 1),(27, 1288, 1, 2, 1),(27, 1289, 1, 1, 1),(27, 1290, 1, 2, 1),(27, 1291, 1, 1, 1),(27, 1292, 1, 2, 1),(27, 1293, 1, 1, 1),(27, 1294, 1, 2, 1),(27, 1295, 1, 1, 1),(27, 1296, 1, 2, 1),(27, 1297, 1, 1, 1),(27, 1298, 1, 2, 1),(27, 1299, 1, 1, 1),(27, 1300, 1, 2, 1),(27, 1301, 1, 1, 1),(27, 1302, 1, 2, 1),(27, 1303, 1, 1, 1),(27, 1304, 1, 2, 1),(27, 1305, 1, 1, 1),(27, 1306, 1, 2, 1),(27, 1307, 1, 1, 1),(27, 1308, 1, 2, 1),(27, 1309, 1, 1, 1),(27, 1310, 1, 2, 1),(27, 1311, 5, 1, 1),(27, 1312, 5, 2, 1),(27, 1313, 5, 1, 2),(27, 1314, 5, 2, 2),(27, 1315, 1, 1, 2),(27, 1316, 1, 2, 2),(27, 1317, 1, 1, 2),(27, 1318, 1, 2, 2),(27, 1319, 1, 1, 2),(27, 1320, 1, 2, 2),(27, 1321, 1, 1, 2),(27, 1322, 1, 2, 2),(27, 1323, 1, 1, 2),(27, 1324, 1, 2, 2),(27, 1325, 1, 1, 2),(27, 1326, 1, 2, 2),(27, 1327, 1, 1, 2),(27, 1328, 1, 2, 2),(27, 1329, 1, 1, 2),(27, 1330, 1, 2, 2),(27, 1331, 1, 1, 2),(27, 1332, 1, 2, 2),(27, 1333, 1, 1, 2),(27, 1334, 1, 2, 2),(27, 1335, 1, 1, 2),(27, 1336, 1, 2, 2),(27, 1337, 1, 1, 2),(27, 1338, 1, 2, 2),(27, 1339, 1, 1, 2),(27, 1340, 1, 2, 2),(27, 1341, 1, 1, 2),(27, 1342, 1, 2, 2),(27, 1343, 5, 1, 2),(27, 1344, 5, 2, 2),(27, 1345, 5, 1, 1),(27, 1346, 5, 2, 1),(27, 1347, 1, 1, 1),(27, 1348, 1, 2, 1),(27, 1349, 1, 1, 1),(27, 1350, 1, 2, 1),(27, 1351, 1, 1, 1),(27, 1352, 1, 2, 1),(27, 1353, 1, 1, 1),(27, 1354, 1, 2, 1),(27, 1355, 1, 1, 1),(27, 1356, 1, 2, 1),(27, 1357, 1, 1, 1),(27, 1358, 1, 2, 1),(27, 1359, 1, 1, 1),(27, 1360, 1, 2, 1),(27, 1361, 1, 1, 1),(27, 1362, 1, 2, 1),(27, 1363, 1, 1, 1),(27, 1364, 1, 2, 1),(27, 1365, 1, 1, 1),(27, 1366, 1, 2, 1),(27, 1367, 1, 1, 1),(27, 1368, 1, 2, 1),(27, 1369, 1, 1, 1),(27, 1370, 1, 2, 1),(27, 1371, 1, 1, 1),(27, 1372, 1, 2, 1),(27, 1373, 1, 1, 1),(27, 1374, 1, 2, 1),(27, 1375, 5, 1, 1),(27, 1376, 5, 2, 1),(27, 1377, 5, 1, 2),(27, 1378, 5, 2, 2),(27, 1379, 1, 1, 2),(27, 1380, 1, 2, 2),(27, 1381, 1, 1, 2),(27, 1382, 1, 2, 2),(27, 1383, 1, 1, 2),(27, 1384, 1, 2, 2),(27, 1385, 1, 1, 2),(27, 1386, 1, 2, 2),(27, 1387, 1, 1, 2),(27, 1388, 1, 2, 2),(27, 1389, 1, 1, 2),(27, 1390, 1, 2, 2),(27, 1391, 1, 1, 2),(27, 1392, 1, 2, 2),(27, 1393, 1, 1, 2),(27, 1394, 1, 2, 2),(27, 1395, 1, 1, 2),(27, 1396, 1, 2, 2),(27, 1397, 1, 1, 2),(27, 1398, 1, 2, 2),(27, 1399, 1, 1, 2),(27, 1400, 1, 2, 2),(27, 1401, 1, 1, 2),(27, 1402, 1, 2, 2),(27, 1403, 1, 1, 2),(27, 1404, 1, 2, 2),(27, 1405, 1, 1, 2),(27, 1406, 1, 2, 2),(27, 1407, 5, 1, 2),(27, 1408, 5, 2, 2),(27, 1409, 5, 1, 1),(27, 1410, 5, 2, 1),(27, 1411, 1, 1, 1),(27, 1412, 1, 2, 1),(27, 1413, 1, 1, 1),(27, 1414, 1, 2, 1),(27, 1415, 1, 1, 1),(27, 1416, 1, 2, 1),(27, 1417, 1, 1, 1),(27, 1418, 1, 2, 1),(27, 1419, 1, 1, 1),(27, 1420, 1, 2, 1),(27, 1421, 1, 1, 1),(27, 1422, 1, 2, 1),(27, 1423, 1, 1, 1),(27, 1424, 1, 2, 1),(27, 1425, 2, 1, 1),(27, 1426, 2, 2, 1),(27, 1427, 2, 1, 1),(27, 1428, 2, 2, 1),(27, 1429, 2, 1, 1),(27, 1430, 2, 2, 1),(27, 1431, 2, 1, 1),(27, 1432, 2, 2, 1),(27, 1433, 3, 1, 1),(27, 1434, 3, 2, 1),(27, 1435, 3, 1, 1),(27, 1436, 3, 2, 1),(27, 1437, 4, 1, 1),(27, 1438, 4, 2, 1),(27, 1439, 5, 1, 1),(27, 1440, 5, 2, 1),(27, 1441, 5, 1, 2),(27, 1442, 5, 2, 2),(27, 1443, 1, 1, 2),(27, 1444, 1, 2, 2),(27, 1445, 1, 1, 2),(27, 1446, 1, 2, 2),(27, 1447, 1, 1, 2),(27, 1448, 1, 2, 2),(27, 1449, 1, 1, 2),(27, 1450, 1, 2, 2),(27, 1451, 1, 1, 2),(27, 1452, 1, 2, 2),(27, 1453, 1, 1, 2),(27, 1454, 1, 2, 2),(27, 1455, 1, 1, 2),(27, 1456, 1, 2, 2),(27, 1457, 2, 1, 2),(27, 1458, 2, 2, 2),(27, 1459, 2, 1, 2),(27, 1460, 2, 2, 2),(27, 1461, 2, 1, 2),(27, 1462, 2, 2, 2),(27, 1463, 2, 1, 2),(27, 1464, 2, 2, 2),(27, 1465, 3, 1, 2),(27, 1466, 3, 2, 2),(27, 1467, 3, 1, 2),(27, 1468, 3, 2, 2),(27, 1469, 4, 1, 2),(27, 1470, 4, 2, 2),(27, 1471, 5, 1, 2),(27, 1472, 5, 2, 2),(27, 1473, 5, 1, 1),(27, 1474, 5, 2, 1),(27, 1475, 5, 1, 1),(27, 1476, 5, 2, 1),(27, 1477, 5, 1, 1),(27, 1478, 5, 2, 1),(27, 1479, 5, 1, 1),(27, 1480, 5, 2, 1),(27, 1481, 5, 1, 1),(27, 1482, 5, 2, 1),(27, 1483, 5, 1, 1),(27, 1484, 5, 2, 1),(27, 1485, 5, 1, 1),(27, 1486, 5, 2, 1),(27, 1487, 5, 1, 1),(27, 1488, 5, 2, 1),(27, 1489, 5, 1, 1),(27, 1490, 5, 2, 1),(27, 1491, 5, 1, 1),(27, 1492, 5, 2, 1),(27, 1493, 5, 1, 1),(27, 1494, 5, 2, 1),(27, 1495, 5, 1, 1),(27, 1496, 5, 2, 1),(27, 1497, 5, 1, 1),(27, 1498, 5, 2, 1),(27, 1499, 5, 1, 1),(27, 1500, 5, 2, 1),(27, 1501, 5, 1, 1),(27, 1502, 5, 2, 1),(27, 1503, 5, 1, 1),(27, 1504, 5, 2, 1),(27, 1505, 5, 1, 2),(27, 1506, 5, 2, 2),(27, 1507, 5, 1, 2),(27, 1508, 5, 2, 2),(27, 1509, 5, 1, 2),(27, 1510, 5, 2, 2),(27, 1511, 5, 1, 2),(27, 1512, 5, 2, 2),(27, 1513, 5, 1, 2),(27, 1514, 5, 2, 2),(27, 1515, 5, 1, 2),(27, 1516, 5, 2, 2),(27, 1517, 5, 1, 2),(27, 1518, 5, 2, 2),(27, 1519, 5, 1, 2),(27, 1520, 5, 2, 2),(27, 1521, 5, 1, 2),(27, 1522, 5, 2, 2),(27, 1523, 5, 1, 2),(27, 1524, 5, 2, 2),(27, 1525, 5, 1, 2),(27, 1526, 5, 2, 2),(27, 1527, 5, 1, 2),(27, 1528, 5, 2, 2),(27, 1529, 5, 1, 2),(27, 1530, 5, 2, 2),(27, 1531, 5, 1, 2),(27, 1532, 5, 2, 2),(27, 1533, 5, 1, 2),(27, 1534, 5, 2, 2),(27, 1535, 5, 1, 2),(27, 1536, 5, 2, 2),(28, 1, 5, 1, 1),(28, 2, 5, 2, 1),(28, 3, 5, 1, 1),(28, 4, 5, 2, 1),(28, 5, 5, 1, 1),(28, 6, 5, 2, 1),(28, 7, 5, 1, 1),(28, 8, 5, 2, 1),(28, 9, 5, 1, 1),(28, 10, 5, 2, 1),(28, 11, 5, 1, 1),(28, 12, 5, 2, 1),(28, 13, 5, 1, 1),(28, 14, 5, 2, 1),(28, 15, 5, 1, 1),(28, 16, 5, 2, 1),(28, 17, 5, 1, 1),(28, 18, 5, 2, 1),(28, 19, 5, 1, 1),(28, 20, 5, 2, 1),(28, 21, 5, 1, 1),(28, 22, 5, 2, 1),(28, 23, 5, 1, 1),(28, 24, 5, 2, 1),(28, 25, 5, 1, 1),(28, 26, 5, 2, 1),(28, 27, 5, 1, 1),(28, 28, 5, 2, 1),(28, 29, 5, 1, 1),(28, 30, 5, 2, 1),(28, 31, 5, 1, 1),(28, 32, 5, 2, 1),(28, 33, 5, 1, 1),(28, 34, 5, 2, 1),(28, 35, 5, 1, 1),(28, 36, 5, 2, 1),(28, 37, 5, 1, 1),(28, 38, 5, 2, 1),(28, 39, 5, 1, 1),(28, 40, 5, 2, 1),(28, 41, 5, 1, 1),(28, 42, 5, 2, 1),(28, 43, 5, 1, 1),(28, 44, 5, 2, 1),(28, 45, 5, 1, 1),(28, 46, 5, 2, 1),(28, 47, 5, 1, 1),(28, 48, 5, 2, 1),(28, 49, 5, 1, 1),(28, 50, 5, 2, 1),(28, 51, 5, 1, 1),(28, 52, 5, 2, 1),(28, 53, 5, 1, 1),(28, 54, 5, 2, 1),(28, 55, 5, 1, 1),(28, 56, 5, 2, 1),(28, 57, 5, 1, 1),(28, 58, 5, 2, 1),(28, 59, 5, 1, 1),(28, 60, 5, 2, 1),(28, 61, 5, 1, 1),(28, 62, 5, 2, 1),(28, 63, 5, 1, 1),(28, 64, 5, 2, 1),(28, 65, 5, 1, 1),(28, 66, 5, 2, 1),(28, 67, 1, 1, 1),(28, 68, 1, 2, 1),(28, 69, 1, 1, 1),(28, 70, 1, 2, 1),(28, 71, 1, 1, 1),(28, 72, 1, 2, 1),(28, 73, 1, 1, 1),(28, 74, 1, 2, 1),(28, 75, 1, 1, 1),(28, 76, 1, 2, 1),(28, 77, 1, 1, 1),(28, 78, 1, 2, 1),(28, 79, 1, 1, 1),(28, 80, 1, 2, 1),(28, 81, 1, 1, 1),(28, 82, 1, 2, 1),(28, 83, 1, 1, 1),(28, 84, 1, 2, 1),(28, 85, 1, 1, 1),(28, 86, 1, 2, 1),(28, 87, 1, 1, 1),(28, 88, 1, 2, 1),(28, 89, 1, 1, 1),(28, 90, 1, 2, 1),(28, 91, 1, 1, 1),(28, 92, 1, 2, 1),(28, 93, 1, 1, 1),(28, 94, 1, 2, 1),(28, 95, 5, 1, 1),(28, 96, 5, 2, 1),(28, 97, 5, 1, 1),(28, 98, 5, 2, 1),(28, 99, 1, 1, 1),(28, 100, 1, 2, 1),(28, 101, 1, 1, 1),(28, 102, 1, 2, 1),(28, 103, 1, 1, 1),(28, 104, 1, 2, 1),(28, 105, 1, 1, 1),(28, 106, 1, 2, 1),(28, 107, 1, 1, 1),(28, 108, 1, 2, 1),(28, 109, 1, 1, 1),(28, 110, 1, 2, 1),(28, 111, 1, 1, 1),(28, 112, 1, 2, 1),(28, 113, 1, 1, 1),(28, 114, 1, 2, 1),(28, 115, 1, 1, 1),(28, 116, 1, 2, 1),(28, 117, 1, 1, 1),(28, 118, 1, 2, 1),(28, 119, 1, 1, 1),(28, 120, 1, 2, 1),(28, 121, 1, 1, 1),(28, 122, 1, 2, 1),(28, 123, 1, 1, 1),(28, 124, 1, 2, 1),(28, 125, 1, 1, 1),(28, 126, 1, 2, 1),(28, 127, 5, 1, 1),(28, 128, 5, 2, 1),(28, 129, 5, 1, 1),(28, 130, 5, 2, 1),(28, 131, 1, 1, 1),(28, 132, 1, 2, 1),(28, 133, 1, 1, 1),(28, 134, 1, 2, 1),(28, 135, 1, 1, 1),(28, 136, 1, 2, 1),(28, 137, 1, 1, 1),(28, 138, 1, 2, 1),(28, 139, 1, 1, 1),(28, 140, 1, 2, 1),(28, 141, 1, 1, 1),(28, 142, 1, 2, 1),(28, 143, 1, 1, 1),(28, 144, 1, 2, 1),(28, 145, 1, 1, 1),(28, 146, 1, 2, 1),(28, 147, 1, 1, 1),(28, 148, 1, 2, 1),(28, 149, 1, 1, 1),(28, 150, 1, 2, 1),(28, 151, 1, 1, 1),(28, 152, 1, 2, 1),(28, 153, 1, 1, 1),(28, 154, 1, 2, 1),(28, 155, 1, 1, 1),(28, 156, 1, 2, 1),(28, 157, 1, 1, 1),(28, 158, 1, 2, 1),(28, 159, 5, 1, 1),(28, 160, 5, 2, 1),(28, 161, 5, 1, 1),(28, 162, 5, 2, 1),(28, 163, 1, 1, 1),(28, 164, 1, 2, 1),(28, 165, 1, 1, 1),(28, 166, 1, 2, 1),(28, 167, 1, 1, 1),(28, 168, 1, 2, 1),(28, 169, 1, 1, 1),(28, 170, 1, 2, 1),(28, 171, 1, 1, 1),(28, 172, 1, 2, 1),(28, 173, 1, 1, 1),(28, 174, 1, 2, 1),(28, 175, 1, 1, 1),(28, 176, 1, 2, 1),(28, 177, 1, 1, 1),(28, 178, 1, 2, 1),(28, 179, 1, 1, 1),(28, 180, 1, 2, 1),(28, 181, 1, 1, 1),(28, 182, 1, 2, 1),(28, 183, 1, 1, 1),(28, 184, 1, 2, 1),(28, 185, 1, 1, 1),(28, 186, 1, 2, 1),(28, 187, 1, 1, 1),(28, 188, 1, 2, 1),(28, 189, 1, 1, 1),(28, 190, 1, 2, 1),(28, 191, 5, 1, 1),(28, 192, 5, 2, 1),(28, 193, 5, 1, 1),(28, 194, 5, 2, 1),(28, 195, 1, 1, 1),(28, 196, 1, 2, 1),(28, 197, 1, 1, 1),(28, 198, 1, 2, 1),(28, 199, 1, 1, 1),(28, 200, 1, 2, 1),(28, 201, 1, 1, 1),(28, 202, 1, 2, 1),(28, 203, 1, 1, 1),(28, 204, 1, 2, 1),(28, 205, 1, 1, 1),(28, 206, 1, 2, 1),(28, 207, 1, 1, 1),(28, 208, 1, 2, 1),(28, 209, 1, 1, 1),(28, 210, 1, 2, 1),(28, 211, 1, 1, 1),(28, 212, 1, 2, 1),(28, 213, 1, 1, 1),(28, 214, 1, 2, 1),(28, 215, 1, 1, 1),(28, 216, 1, 2, 1),(28, 217, 1, 1, 1),(28, 218, 1, 2, 1),(28, 219, 1, 1, 1),(28, 220, 1, 2, 1),(28, 221, 1, 1, 1),(28, 222, 1, 2, 1),(28, 223, 5, 1, 1),(28, 224, 5, 2, 1),(28, 225, 5, 1, 1),(28, 226, 5, 2, 1),(28, 227, 1, 1, 1),(28, 228, 1, 2, 1),(28, 229, 1, 1, 1),(28, 230, 1, 2, 1),(28, 231, 1, 1, 1),(28, 232, 1, 2, 1),(28, 233, 1, 1, 1),(28, 234, 1, 2, 1),(28, 235, 1, 1, 1),(28, 236, 1, 2, 1),(28, 237, 1, 1, 1),(28, 238, 1, 2, 1),(28, 239, 1, 1, 1),(28, 240, 1, 2, 1),(28, 241, 1, 1, 1),(28, 242, 1, 2, 1),(28, 243, 1, 1, 1),(28, 244, 1, 2, 1),(28, 245, 1, 1, 1),(28, 246, 1, 2, 1),(28, 247, 1, 1, 1),(28, 248, 1, 2, 1),(28, 249, 1, 1, 1),(28, 250, 1, 2, 1),(28, 251, 1, 1, 1),(28, 252, 1, 2, 1),(28, 253, 1, 1, 1),(28, 254, 1, 2, 1),(28, 255, 5, 1, 1),(28, 256, 5, 2, 1),(28, 257, 5, 1, 1),(28, 258, 5, 2, 1),(28, 259, 1, 1, 1),(28, 260, 1, 2, 1),(28, 261, 1, 1, 1),(28, 262, 1, 2, 1),(28, 263, 1, 1, 1),(28, 264, 1, 2, 1),(28, 265, 1, 1, 1),(28, 266, 1, 2, 1),(28, 267, 1, 1, 1),(28, 268, 1, 2, 1),(28, 269, 1, 1, 1),(28, 270, 1, 2, 1),(28, 271, 1, 1, 1),(28, 272, 1, 2, 1),(28, 273, 1, 1, 1),(28, 274, 1, 2, 1),(28, 275, 1, 1, 1),(28, 276, 1, 2, 1),(28, 277, 1, 1, 1),(28, 278, 1, 2, 1),(28, 279, 1, 1, 1),(28, 280, 1, 2, 1),(28, 281, 1, 1, 1),(28, 282, 1, 2, 1),(28, 283, 1, 1, 1),(28, 284, 1, 2, 1),(28, 285, 1, 1, 1),(28, 286, 1, 2, 1),(28, 287, 5, 1, 1),(28, 288, 5, 2, 1),(28, 289, 5, 1, 1),(28, 290, 5, 2, 1),(28, 291, 1, 1, 1),(28, 292, 1, 2, 1),(28, 293, 1, 1, 1),(28, 294, 1, 2, 1),(28, 295, 1, 1, 1),(28, 296, 1, 2, 1),(28, 297, 1, 1, 1),(28, 298, 1, 2, 1),(28, 299, 1, 1, 1),(28, 300, 1, 2, 1),(28, 301, 1, 1, 1),(28, 302, 1, 2, 1),(28, 303, 1, 1, 1),(28, 304, 1, 2, 1),(28, 305, 1, 1, 1),(28, 306, 1, 2, 1),(28, 307, 1, 1, 1),(28, 308, 1, 2, 1),(28, 309, 1, 1, 1),(28, 310, 1, 2, 1),(28, 311, 1, 1, 1),(28, 312, 1, 2, 1),(28, 313, 1, 1, 1),(28, 314, 1, 2, 1),(28, 315, 1, 1, 1),(28, 316, 1, 2, 1),(28, 317, 1, 1, 1),(28, 318, 1, 2, 1),(28, 319, 5, 1, 1),(28, 320, 5, 2, 1),(28, 321, 5, 1, 1),(28, 322, 5, 2, 1),(28, 323, 1, 1, 1),(28, 324, 1, 2, 1),(28, 325, 1, 1, 1),(28, 326, 1, 2, 1),(28, 327, 1, 1, 1),(28, 328, 1, 2, 1),(28, 329, 1, 1, 1),(28, 330, 1, 2, 1),(28, 331, 1, 1, 1),(28, 332, 1, 2, 1),(28, 333, 1, 1, 1),(28, 334, 1, 2, 1),(28, 335, 1, 1, 1),(28, 336, 1, 2, 1),(28, 337, 1, 1, 1),(28, 338, 1, 2, 1),(28, 339, 1, 1, 1),(28, 340, 1, 2, 1),(28, 341, 1, 1, 1),(28, 342, 1, 2, 1),(28, 343, 1, 1, 1),(28, 344, 1, 2, 1),(28, 345, 1, 1, 1),(28, 346, 1, 2, 1),(28, 347, 1, 1, 1),(28, 348, 1, 2, 1),(28, 349, 1, 1, 1),(28, 350, 1, 2, 1),(28, 351, 5, 1, 1),(28, 352, 5, 2, 1),(28, 353, 5, 1, 1),(28, 354, 5, 2, 1),(28, 355, 1, 1, 1),(28, 356, 1, 2, 1),(28, 357, 1, 1, 1),(28, 358, 1, 2, 1),(28, 359, 1, 1, 1),(28, 360, 1, 2, 1),(28, 361, 1, 1, 1),(28, 362, 1, 2, 1),(28, 363, 1, 1, 1),(28, 364, 1, 2, 1),(28, 365, 1, 1, 1),(28, 366, 1, 2, 1),(28, 367, 1, 1, 1),(28, 368, 1, 2, 1),(28, 369, 1, 1, 1),(28, 370, 1, 2, 1),(28, 371, 1, 1, 1),(28, 372, 1, 2, 1),(28, 373, 1, 1, 1),(28, 374, 1, 2, 1),(28, 375, 1, 1, 1),(28, 376, 1, 2, 1),(28, 377, 1, 1, 1),(28, 378, 1, 2, 1),(28, 379, 1, 1, 1),(28, 380, 1, 2, 1),(28, 381, 1, 1, 1),(28, 382, 1, 2, 1),(28, 383, 5, 1, 1),(28, 384, 5, 2, 1),(28, 385, 5, 1, 1),(28, 386, 5, 2, 1),(28, 387, 1, 1, 1),(28, 388, 1, 2, 1),(28, 389, 1, 1, 1),(28, 390, 1, 2, 1),(28, 391, 1, 1, 1),(28, 392, 1, 2, 1),(28, 393, 1, 1, 1),(28, 394, 1, 2, 1),(28, 395, 1, 1, 1),(28, 396, 1, 2, 1),(28, 397, 1, 1, 1),(28, 398, 1, 2, 1),(28, 399, 1, 1, 1),(28, 400, 1, 2, 1),(28, 401, 1, 1, 1),(28, 402, 1, 2, 1),(28, 403, 1, 1, 1),(28, 404, 1, 2, 1),(28, 405, 1, 1, 1),(28, 406, 1, 2, 1),(28, 407, 1, 1, 1),(28, 408, 1, 2, 1),(28, 409, 1, 1, 1),(28, 410, 1, 2, 1),(28, 411, 1, 1, 1),(28, 412, 1, 2, 1),(28, 413, 1, 1, 1),(28, 414, 1, 2, 1),(28, 415, 5, 1, 1),(28, 416, 5, 2, 1),(28, 417, 5, 1, 1),(28, 418, 5, 2, 1),(28, 419, 1, 1, 1),(28, 420, 1, 2, 1),(28, 421, 1, 1, 1),(28, 422, 1, 2, 1),(28, 423, 1, 1, 1),(28, 424, 1, 2, 1),(28, 425, 1, 1, 1),(28, 426, 1, 2, 1),(28, 427, 1, 1, 1),(28, 428, 1, 2, 1),(28, 429, 1, 1, 1),(28, 430, 1, 2, 1),(28, 431, 1, 1, 1),(28, 432, 1, 2, 1),(28, 433, 1, 1, 1),(28, 434, 1, 2, 1),(28, 435, 1, 1, 1),(28, 436, 1, 2, 1),(28, 437, 1, 1, 1),(28, 438, 1, 2, 1),(28, 439, 1, 1, 1),(28, 440, 1, 2, 1),(28, 441, 1, 1, 1),(28, 442, 1, 2, 1),(28, 443, 1, 1, 1),(28, 444, 1, 2, 1),(28, 445, 1, 1, 1),(28, 446, 1, 2, 1),(28, 447, 5, 1, 1),(28, 448, 5, 2, 1),(28, 449, 5, 1, 1),(28, 450, 5, 2, 1),(28, 451, 1, 1, 1),(28, 452, 1, 2, 1),(28, 453, 1, 1, 1),(28, 454, 1, 2, 1),(28, 455, 1, 1, 1),(28, 456, 1, 2, 1),(28, 457, 1, 1, 1),(28, 458, 1, 2, 1),(28, 459, 1, 1, 1),(28, 460, 1, 2, 1),(28, 461, 1, 1, 1),(28, 462, 1, 2, 1),(28, 463, 1, 1, 1),(28, 464, 1, 2, 1),(28, 465, 1, 1, 1),(28, 466, 1, 2, 1),(28, 467, 1, 1, 1),(28, 468, 1, 2, 1),(28, 469, 1, 1, 1),(28, 470, 1, 2, 1),(28, 471, 1, 1, 1),(28, 472, 1, 2, 1),(28, 473, 1, 1, 1),(28, 474, 1, 2, 1),(28, 475, 1, 1, 1),(28, 476, 1, 2, 1),(28, 477, 1, 1, 1),(28, 478, 1, 2, 1),(28, 479, 5, 1, 1),(28, 480, 5, 2, 1),(28, 481, 5, 1, 1),(28, 482, 5, 2, 1),(28, 483, 1, 1, 1),(28, 484, 1, 2, 1),(28, 485, 1, 1, 1),(28, 486, 1, 2, 1),(28, 487, 1, 1, 1),(28, 488, 1, 2, 1),(28, 489, 1, 1, 1),(28, 490, 1, 2, 1),(28, 491, 1, 1, 1),(28, 492, 1, 2, 1),(28, 493, 1, 1, 1),(28, 494, 1, 2, 1),(28, 495, 1, 1, 1),(28, 496, 1, 2, 1),(28, 497, 1, 1, 1),(28, 498, 1, 2, 1),(28, 499, 1, 1, 1),(28, 500, 1, 2, 1),(28, 501, 1, 1, 1),(28, 502, 1, 2, 1),(28, 503, 1, 1, 1),(28, 504, 1, 2, 1),(28, 505, 1, 1, 1),(28, 506, 1, 2, 1),(28, 507, 1, 1, 1),(28, 508, 1, 2, 1),(28, 509, 1, 1, 1),(28, 510, 1, 2, 1),(28, 511, 5, 1, 1),(28, 512, 5, 2, 1),(28, 513, 5, 1, 1),(28, 514, 5, 2, 1),(28, 515, 1, 1, 1),(28, 516, 1, 2, 1),(28, 517, 1, 1, 1),(28, 518, 1, 2, 1),(28, 519, 1, 1, 1),(28, 520, 1, 2, 1),(28, 521, 1, 1, 1),(28, 522, 1, 2, 1),(28, 523, 1, 1, 1),(28, 524, 1, 2, 1),(28, 525, 1, 1, 1),(28, 526, 1, 2, 1),(28, 527, 1, 1, 1),(28, 528, 1, 2, 1),(28, 529, 1, 1, 1),(28, 530, 1, 2, 1),(28, 531, 1, 1, 1),(28, 532, 1, 2, 1),(28, 533, 1, 1, 1),(28, 534, 1, 2, 1),(28, 535, 1, 1, 1),(28, 536, 1, 2, 1),(28, 537, 1, 1, 1),(28, 538, 1, 2, 1),(28, 539, 1, 1, 1),(28, 540, 1, 2, 1),(28, 541, 1, 1, 1),(28, 542, 1, 2, 1),(28, 543, 5, 1, 1),(28, 544, 5, 2, 1),(28, 545, 5, 1, 1),(28, 546, 5, 2, 1),(28, 547, 1, 1, 1),(28, 548, 1, 2, 1),(28, 549, 1, 1, 1),(28, 550, 1, 2, 1),(28, 551, 1, 1, 1),(28, 552, 1, 2, 1),(28, 553, 1, 1, 1),(28, 554, 1, 2, 1),(28, 555, 1, 1, 1),(28, 556, 1, 2, 1),(28, 557, 1, 1, 1),(28, 558, 1, 2, 1),(28, 559, 1, 1, 1),(28, 560, 1, 2, 1),(28, 561, 1, 1, 1),(28, 562, 1, 2, 1),(28, 563, 1, 1, 1),(28, 564, 1, 2, 1),(28, 565, 1, 1, 1),(28, 566, 1, 2, 1),(28, 567, 1, 1, 1),(28, 568, 1, 2, 1),(28, 569, 1, 1, 1),(28, 570, 1, 2, 1),(28, 571, 1, 1, 1),(28, 572, 1, 2, 1),(28, 573, 1, 1, 1),(28, 574, 1, 2, 1),(28, 575, 5, 1, 1),(28, 576, 5, 2, 1),(28, 577, 5, 1, 1),(28, 578, 5, 2, 1),(28, 579, 1, 1, 1),(28, 580, 1, 2, 1),(28, 581, 1, 1, 1),(28, 582, 1, 2, 1),(28, 583, 1, 1, 1),(28, 584, 1, 2, 1),(28, 585, 1, 1, 1),(28, 586, 1, 2, 1),(28, 587, 1, 1, 1),(28, 588, 1, 2, 1),(28, 589, 1, 1, 1),(28, 590, 1, 2, 1),(28, 591, 1, 1, 1),(28, 592, 1, 2, 1),(28, 593, 1, 1, 1),(28, 594, 1, 2, 1),(28, 595, 1, 1, 1),(28, 596, 1, 2, 1),(28, 597, 1, 1, 1),(28, 598, 1, 2, 1),(28, 599, 1, 1, 1),(28, 600, 1, 2, 1),(28, 601, 1, 1, 1),(28, 602, 1, 2, 1),(28, 603, 1, 1, 1),(28, 604, 1, 2, 1),(28, 605, 1, 1, 1),(28, 606, 1, 2, 1),(28, 607, 5, 1, 1),(28, 608, 5, 2, 1),(28, 609, 5, 1, 1),(28, 610, 5, 2, 1),(28, 611, 1, 1, 1),(28, 612, 1, 2, 1),(28, 613, 1, 1, 1),(28, 614, 1, 2, 1),(28, 615, 1, 1, 1),(28, 616, 1, 2, 1),(28, 617, 1, 1, 1),(28, 618, 1, 2, 1),(28, 619, 1, 1, 1),(28, 620, 1, 2, 1),(28, 621, 1, 1, 1),(28, 622, 1, 2, 1),(28, 623, 1, 1, 1),(28, 624, 1, 2, 1),(28, 625, 1, 1, 1),(28, 626, 1, 2, 1),(28, 627, 1, 1, 1),(28, 628, 1, 2, 1),(28, 629, 1, 1, 1),(28, 630, 1, 2, 1),(28, 631, 1, 1, 1),(28, 632, 1, 2, 1),(28, 633, 1, 1, 1),(28, 634, 1, 2, 1),(28, 635, 1, 1, 1),(28, 636, 1, 2, 1),(28, 637, 1, 1, 1),(28, 638, 1, 2, 1),(28, 639, 5, 1, 1),(28, 640, 5, 2, 1),(28, 641, 5, 1, 1),(28, 642, 5, 2, 1),(28, 643, 1, 1, 1),(28, 644, 1, 2, 1),(28, 645, 1, 1, 1),(28, 646, 1, 2, 1),(28, 647, 1, 1, 1),(28, 648, 1, 2, 1),(28, 649, 1, 1, 1),(28, 650, 1, 2, 1),(28, 651, 1, 1, 1),(28, 652, 1, 2, 1),(28, 653, 1, 1, 1),(28, 654, 1, 2, 1),(28, 655, 1, 1, 1),(28, 656, 1, 2, 1),(28, 657, 1, 1, 1),(28, 658, 1, 2, 1),(28, 659, 1, 1, 1),(28, 660, 1, 2, 1),(28, 661, 1, 1, 1),(28, 662, 1, 2, 1),(28, 663, 1, 1, 1),(28, 664, 1, 2, 1),(28, 665, 1, 1, 1),(28, 666, 1, 2, 1),(28, 667, 1, 1, 1),(28, 668, 1, 2, 1),(28, 669, 1, 1, 1),(28, 670, 1, 2, 1),(28, 671, 5, 1, 1),(28, 672, 5, 2, 1),(28, 673, 5, 1, 1),(28, 674, 5, 2, 1),(28, 675, 1, 1, 1),(28, 676, 1, 2, 1),(28, 677, 1, 1, 1),(28, 678, 1, 2, 1),(28, 679, 1, 1, 1),(28, 680, 1, 2, 1),(28, 681, 1, 1, 1),(28, 682, 1, 2, 1),(28, 683, 1, 1, 1),(28, 684, 1, 2, 1),(28, 685, 1, 1, 1),(28, 686, 1, 2, 1),(28, 687, 1, 1, 1),(28, 688, 1, 2, 1),(28, 689, 1, 1, 1),(28, 690, 1, 2, 1),(28, 691, 1, 1, 1),(28, 692, 1, 2, 1),(28, 693, 1, 1, 1),(28, 694, 1, 2, 1),(28, 695, 1, 1, 1),(28, 696, 1, 2, 1),(28, 697, 1, 1, 1),(28, 698, 1, 2, 1),(28, 699, 1, 1, 1),(28, 700, 1, 2, 1),(28, 701, 1, 1, 1),(28, 702, 1, 2, 1),(28, 703, 5, 1, 1),(28, 704, 5, 2, 1),(28, 705, 5, 1, 1),(28, 706, 5, 2, 1),(28, 707, 1, 1, 1),(28, 708, 1, 2, 1),(28, 709, 1, 1, 1),(28, 710, 1, 2, 1),(28, 711, 1, 1, 1),(28, 712, 1, 2, 1),(28, 713, 1, 1, 1),(28, 714, 1, 2, 1),(28, 715, 1, 1, 1),(28, 716, 1, 2, 1),(28, 717, 1, 1, 1),(28, 718, 1, 2, 1),(28, 719, 1, 1, 1),(28, 720, 1, 2, 1),(28, 721, 1, 1, 1),(28, 722, 1, 2, 1),(28, 723, 1, 1, 1),(28, 724, 1, 2, 1),(28, 725, 1, 1, 1),(28, 726, 1, 2, 1),(28, 727, 1, 1, 1),(28, 728, 1, 2, 1),(28, 729, 1, 1, 1),(28, 730, 1, 2, 1),(28, 731, 1, 1, 1),(28, 732, 1, 2, 1),(28, 733, 1, 1, 1),(28, 734, 1, 2, 1),(28, 735, 5, 1, 1),(28, 736, 5, 2, 1),(28, 737, 5, 1, 1),(28, 738, 5, 2, 1),(28, 739, 1, 1, 1),(28, 740, 1, 2, 1),(28, 741, 1, 1, 1),(28, 742, 1, 2, 1),(28, 743, 1, 1, 1),(28, 744, 1, 2, 1),(28, 745, 1, 1, 1),(28, 746, 1, 2, 1),(28, 747, 1, 1, 1),(28, 748, 1, 2, 1),(28, 749, 1, 1, 1),(28, 750, 1, 2, 1),(28, 751, 1, 1, 1),(28, 752, 1, 2, 1),(28, 753, 1, 1, 1),(28, 754, 1, 2, 1),(28, 755, 1, 1, 1),(28, 756, 1, 2, 1),(28, 757, 1, 1, 1),(28, 758, 1, 2, 1),(28, 759, 1, 1, 1),(28, 760, 1, 2, 1),(28, 761, 1, 1, 1),(28, 762, 1, 2, 1),(28, 763, 1, 1, 1),(28, 764, 1, 2, 1),(28, 765, 1, 1, 1),(28, 766, 1, 2, 1),(28, 767, 5, 1, 1),(28, 768, 5, 2, 1),(28, 769, 5, 1, 1),(28, 770, 5, 2, 1),(28, 771, 1, 1, 1),(28, 772, 1, 2, 1),(28, 773, 1, 1, 1),(28, 774, 1, 2, 1),(28, 775, 1, 1, 1),(28, 776, 1, 2, 1),(28, 777, 1, 1, 1),(28, 778, 1, 2, 1),(28, 779, 1, 1, 1),(28, 780, 1, 2, 1),(28, 781, 1, 1, 1),(28, 782, 1, 2, 1),(28, 783, 1, 1, 1),(28, 784, 1, 2, 1),(28, 785, 1, 1, 1),(28, 786, 1, 2, 1),(28, 787, 1, 1, 1),(28, 788, 1, 2, 1),(28, 789, 1, 1, 1),(28, 790, 1, 2, 1),(28, 791, 1, 1, 1),(28, 792, 1, 2, 1),(28, 793, 1, 1, 1),(28, 794, 1, 2, 1),(28, 795, 1, 1, 1),(28, 796, 1, 2, 1),(28, 797, 1, 1, 1),(28, 798, 1, 2, 1),(28, 799, 5, 1, 1),(28, 800, 5, 2, 1),(28, 801, 5, 1, 1),(28, 802, 5, 2, 1),(28, 803, 1, 1, 1),(28, 804, 1, 2, 1),(28, 805, 1, 1, 1),(28, 806, 1, 2, 1),(28, 807, 1, 1, 1),(28, 808, 1, 2, 1),(28, 809, 1, 1, 1),(28, 810, 1, 2, 1),(28, 811, 1, 1, 1),(28, 812, 1, 2, 1),(28, 813, 1, 1, 1),(28, 814, 1, 2, 1),(28, 815, 1, 1, 1),(28, 816, 1, 2, 1),(28, 817, 1, 1, 1),(28, 818, 1, 2, 1),(28, 819, 1, 1, 1),(28, 820, 1, 2, 1),(28, 821, 1, 1, 1),(28, 822, 1, 2, 1),(28, 823, 1, 1, 1),(28, 824, 1, 2, 1),(28, 825, 1, 1, 1),(28, 826, 1, 2, 1),(28, 827, 1, 1, 1),(28, 828, 1, 2, 1),(28, 829, 1, 1, 1),(28, 830, 1, 2, 1),(28, 831, 5, 1, 1),(28, 832, 5, 2, 1),(28, 833, 5, 1, 1),(28, 834, 5, 2, 1),(28, 835, 1, 1, 1),(28, 836, 1, 2, 1),(28, 837, 1, 1, 1),(28, 838, 1, 2, 1),(28, 839, 1, 1, 1),(28, 840, 1, 2, 1),(28, 841, 1, 1, 1),(28, 842, 1, 2, 1),(28, 843, 1, 1, 1),(28, 844, 1, 2, 1),(28, 845, 1, 1, 1),(28, 846, 1, 2, 1),(28, 847, 1, 1, 1),(28, 848, 1, 2, 1),(28, 849, 1, 1, 1),(28, 850, 1, 2, 1),(28, 851, 1, 1, 1),(28, 852, 1, 2, 1),(28, 853, 1, 1, 1),(28, 854, 1, 2, 1),(28, 855, 1, 1, 1),(28, 856, 1, 2, 1),(28, 857, 1, 1, 1),(28, 858, 1, 2, 1),(28, 859, 1, 1, 1),(28, 860, 1, 2, 1),(28, 861, 1, 1, 1),(28, 862, 1, 2, 1),(28, 863, 5, 1, 1),(28, 864, 5, 2, 1),(28, 865, 5, 1, 1),(28, 866, 5, 2, 1),(28, 867, 1, 1, 1),(28, 868, 1, 2, 1),(28, 869, 1, 1, 1),(28, 870, 1, 2, 1),(28, 871, 1, 1, 1),(28, 872, 1, 2, 1),(28, 873, 1, 1, 1),(28, 874, 1, 2, 1),(28, 875, 1, 1, 1),(28, 876, 1, 2, 1),(28, 877, 1, 1, 1),(28, 878, 1, 2, 1),(28, 879, 1, 1, 1),(28, 880, 1, 2, 1),(28, 881, 1, 1, 1),(28, 882, 1, 2, 1),(28, 883, 1, 1, 1),(28, 884, 1, 2, 1),(28, 885, 1, 1, 1),(28, 886, 1, 2, 1),(28, 887, 1, 1, 1),(28, 888, 1, 2, 1),(28, 889, 1, 1, 1),(28, 890, 1, 2, 1),(28, 891, 1, 1, 1),(28, 892, 1, 2, 1),(28, 893, 1, 1, 1),(28, 894, 1, 2, 1),(28, 895, 5, 1, 1),(28, 896, 5, 2, 1),(28, 897, 5, 1, 1),(28, 898, 5, 2, 1),(28, 899, 1, 1, 1),(28, 900, 1, 2, 1),(28, 901, 1, 1, 1),(28, 902, 1, 2, 1),(28, 903, 1, 1, 1),(28, 904, 1, 2, 1),(28, 905, 1, 1, 1),(28, 906, 1, 2, 1),(28, 907, 1, 1, 1),(28, 908, 1, 2, 1),(28, 909, 1, 1, 1),(28, 910, 1, 2, 1),(28, 911, 1, 1, 1),(28, 912, 1, 2, 1),(28, 913, 1, 1, 1),(28, 914, 1, 2, 1),(28, 915, 1, 1, 1),(28, 916, 1, 2, 1),(28, 917, 1, 1, 1),(28, 918, 1, 2, 1),(28, 919, 1, 1, 1),(28, 920, 1, 2, 1),(28, 921, 1, 1, 1),(28, 922, 1, 2, 1),(28, 923, 1, 1, 1),(28, 924, 1, 2, 1),(28, 925, 1, 1, 1),(28, 926, 1, 2, 1),(28, 927, 5, 1, 1),(28, 928, 5, 2, 1),(28, 929, 5, 1, 1),(28, 930, 5, 2, 1),(28, 931, 1, 1, 1),(28, 932, 1, 2, 1),(28, 933, 1, 1, 1),(28, 934, 1, 2, 1),(28, 935, 1, 1, 1),(28, 936, 1, 2, 1),(28, 937, 1, 1, 1),(28, 938, 1, 2, 1),(28, 939, 1, 1, 1),(28, 940, 1, 2, 1),(28, 941, 1, 1, 1),(28, 942, 1, 2, 1),(28, 943, 1, 1, 1),(28, 944, 1, 2, 1),(28, 945, 1, 1, 1),(28, 946, 1, 2, 1),(28, 947, 1, 1, 1),(28, 948, 1, 2, 1),(28, 949, 1, 1, 1),(28, 950, 1, 2, 1),(28, 951, 1, 1, 1),(28, 952, 1, 2, 1),(28, 953, 1, 1, 1),(28, 954, 1, 2, 1),(28, 955, 1, 1, 1),(28, 956, 1, 2, 1),(28, 957, 1, 1, 1),(28, 958, 1, 2, 1),(28, 959, 5, 1, 1),(28, 960, 5, 2, 1),(28, 961, 5, 1, 1),(28, 962, 5, 2, 1),(28, 963, 1, 1, 1),(28, 964, 1, 2, 1),(28, 965, 1, 1, 1),(28, 966, 1, 2, 1),(28, 967, 1, 1, 1),(28, 968, 1, 2, 1),(28, 969, 1, 1, 1),(28, 970, 1, 2, 1),(28, 971, 1, 1, 1),(28, 972, 1, 2, 1),(28, 973, 1, 1, 1),(28, 974, 1, 2, 1),(28, 975, 1, 1, 1),(28, 976, 1, 2, 1),(28, 977, 1, 1, 1),(28, 978, 1, 2, 1),(28, 979, 1, 1, 1),(28, 980, 1, 2, 1),(28, 981, 1, 1, 1),(28, 982, 1, 2, 1),(28, 983, 1, 1, 1),(28, 984, 1, 2, 1),(28, 985, 1, 1, 1),(28, 986, 1, 2, 1),(28, 987, 1, 1, 1),(28, 988, 1, 2, 1),(28, 989, 1, 1, 1),(28, 990, 1, 2, 1),(28, 991, 5, 1, 1),(28, 992, 5, 2, 1),(28, 993, 5, 1, 1),(28, 994, 5, 2, 1),(28, 995, 1, 1, 1),(28, 996, 1, 2, 1),(28, 997, 1, 1, 1),(28, 998, 1, 2, 1),(28, 999, 1, 1, 1),(28, 1000, 1, 2, 1),(28, 1001, 1, 1, 1),(28, 1002, 1, 2, 1),(28, 1003, 1, 1, 1),(28, 1004, 1, 2, 1),(28, 1005, 1, 1, 1),(28, 1006, 1, 2, 1),(28, 1007, 1, 1, 1),(28, 1008, 1, 2, 1),(28, 1009, 1, 1, 1),(28, 1010, 1, 2, 1),(28, 1011, 1, 1, 1),(28, 1012, 1, 2, 1),(28, 1013, 1, 1, 1),(28, 1014, 1, 2, 1),(28, 1015, 1, 1, 1),(28, 1016, 1, 2, 1),(28, 1017, 1, 1, 1),(28, 1018, 1, 2, 1),(28, 1019, 1, 1, 1),(28, 1020, 1, 2, 1),(28, 1021, 1, 1, 1),(28, 1022, 1, 2, 1),(28, 1023, 5, 1, 1),(28, 1024, 5, 2, 1),(28, 1025, 5, 1, 1),(28, 1026, 5, 2, 1),(28, 1027, 1, 1, 1),(28, 1028, 1, 2, 1),(28, 1029, 1, 1, 1),(28, 1030, 1, 2, 1),(28, 1031, 1, 1, 1),(28, 1032, 1, 2, 1),(28, 1033, 1, 1, 1),(28, 1034, 1, 2, 1),(28, 1035, 1, 1, 1),(28, 1036, 1, 2, 1),(28, 1037, 1, 1, 1),(28, 1038, 1, 2, 1),(28, 1039, 1, 1, 1),(28, 1040, 1, 2, 1),(28, 1041, 1, 1, 1),(28, 1042, 1, 2, 1),(28, 1043, 1, 1, 1),(28, 1044, 1, 2, 1),(28, 1045, 1, 1, 1),(28, 1046, 1, 2, 1),(28, 1047, 1, 1, 1),(28, 1048, 1, 2, 1),(28, 1049, 1, 1, 1),(28, 1050, 1, 2, 1),(28, 1051, 1, 1, 1),(28, 1052, 1, 2, 1),(28, 1053, 1, 1, 1),(28, 1054, 1, 2, 1),(28, 1055, 5, 1, 1),(28, 1056, 5, 2, 1),(28, 1057, 5, 1, 1),(28, 1058, 5, 2, 1),(28, 1059, 1, 1, 1),(28, 1060, 1, 2, 1),(28, 1061, 1, 1, 1),(28, 1062, 1, 2, 1),(28, 1063, 1, 1, 1),(28, 1064, 1, 2, 1),(28, 1065, 1, 1, 1),(28, 1066, 1, 2, 1),(28, 1067, 1, 1, 1),(28, 1068, 1, 2, 1),(28, 1069, 1, 1, 1),(28, 1070, 1, 2, 1),(28, 1071, 1, 1, 1),(28, 1072, 1, 2, 1),(28, 1073, 1, 1, 1),(28, 1074, 1, 2, 1),(28, 1075, 1, 1, 1),(28, 1076, 1, 2, 1),(28, 1077, 1, 1, 1),(28, 1078, 1, 2, 1),(28, 1079, 1, 1, 1),(28, 1080, 1, 2, 1),(28, 1081, 1, 1, 1),(28, 1082, 1, 2, 1),(28, 1083, 1, 1, 1),(28, 1084, 1, 2, 1),(28, 1085, 1, 1, 1),(28, 1086, 1, 2, 1),(28, 1087, 5, 1, 1),(28, 1088, 5, 2, 1),(28, 1089, 5, 1, 1),(28, 1090, 5, 2, 1),(28, 1091, 1, 1, 1),(28, 1092, 1, 2, 1),(28, 1093, 1, 1, 1),(28, 1094, 1, 2, 1),(28, 1095, 1, 1, 1),(28, 1096, 1, 2, 1),(28, 1097, 1, 1, 1),(28, 1098, 1, 2, 1),(28, 1099, 1, 1, 1),(28, 1100, 1, 2, 1),(28, 1101, 1, 1, 1),(28, 1102, 1, 2, 1),(28, 1103, 1, 1, 1),(28, 1104, 1, 2, 1),(28, 1105, 1, 1, 1),(28, 1106, 1, 2, 1),(28, 1107, 1, 1, 1),(28, 1108, 1, 2, 1),(28, 1109, 1, 1, 1),(28, 1110, 1, 2, 1),(28, 1111, 1, 1, 1),(28, 1112, 1, 2, 1),(28, 1113, 1, 1, 1),(28, 1114, 1, 2, 1),(28, 1115, 1, 1, 1),(28, 1116, 1, 2, 1),(28, 1117, 1, 1, 1),(28, 1118, 1, 2, 1),(28, 1119, 5, 1, 1),(28, 1120, 5, 2, 1),(28, 1121, 5, 1, 1),(28, 1122, 5, 2, 1),(28, 1123, 1, 1, 1),(28, 1124, 1, 2, 1),(28, 1125, 1, 1, 1),(28, 1126, 1, 2, 1),(28, 1127, 1, 1, 1),(28, 1128, 1, 2, 1),(28, 1129, 1, 1, 1),(28, 1130, 1, 2, 1),(28, 1131, 1, 1, 1),(28, 1132, 1, 2, 1),(28, 1133, 1, 1, 1),(28, 1134, 1, 2, 1),(28, 1135, 1, 1, 1),(28, 1136, 1, 2, 1),(28, 1137, 1, 1, 1),(28, 1138, 1, 2, 1),(28, 1139, 1, 1, 1),(28, 1140, 1, 2, 1),(28, 1141, 1, 1, 1),(28, 1142, 1, 2, 1),(28, 1143, 1, 1, 1),(28, 1144, 1, 2, 1),(28, 1145, 1, 1, 1),(28, 1146, 1, 2, 1),(28, 1147, 1, 1, 1),(28, 1148, 1, 2, 1),(28, 1149, 1, 1, 1),(28, 1150, 1, 2, 1),(28, 1151, 5, 1, 1),(28, 1152, 5, 2, 1),(28, 1153, 5, 1, 1),(28, 1154, 5, 2, 1),(28, 1155, 1, 1, 1),(28, 1156, 1, 2, 1),(28, 1157, 1, 1, 1),(28, 1158, 1, 2, 1),(28, 1159, 1, 1, 1),(28, 1160, 1, 2, 1),(28, 1161, 1, 1, 1),(28, 1162, 1, 2, 1),(28, 1163, 1, 1, 1),(28, 1164, 1, 2, 1),(28, 1165, 1, 1, 1),(28, 1166, 1, 2, 1),(28, 1167, 1, 1, 1),(28, 1168, 1, 2, 1),(28, 1169, 1, 1, 1),(28, 1170, 1, 2, 1),(28, 1171, 1, 1, 1),(28, 1172, 1, 2, 1),(28, 1173, 1, 1, 1),(28, 1174, 1, 2, 1),(28, 1175, 1, 1, 1),(28, 1176, 1, 2, 1),(28, 1177, 1, 1, 1),(28, 1178, 1, 2, 1),(28, 1179, 1, 1, 1),(28, 1180, 1, 2, 1),(28, 1181, 1, 1, 1),(28, 1182, 1, 2, 1),(28, 1183, 5, 1, 1),(28, 1184, 5, 2, 1),(28, 1185, 5, 1, 1),(28, 1186, 5, 2, 1),(28, 1187, 1, 1, 1),(28, 1188, 1, 2, 1),(28, 1189, 1, 1, 1),(28, 1190, 1, 2, 1),(28, 1191, 1, 1, 1),(28, 1192, 1, 2, 1),(28, 1193, 1, 1, 1),(28, 1194, 1, 2, 1),(28, 1195, 1, 1, 1),(28, 1196, 1, 2, 1),(28, 1197, 1, 1, 1),(28, 1198, 1, 2, 1),(28, 1199, 1, 1, 1),(28, 1200, 1, 2, 1),(28, 1201, 1, 1, 1),(28, 1202, 1, 2, 1),(28, 1203, 1, 1, 1),(28, 1204, 1, 2, 1),(28, 1205, 1, 1, 1),(28, 1206, 1, 2, 1),(28, 1207, 1, 1, 1),(28, 1208, 1, 2, 1),(28, 1209, 1, 1, 1),(28, 1210, 1, 2, 1),(28, 1211, 1, 1, 1),(28, 1212, 1, 2, 1),(28, 1213, 1, 1, 1),(28, 1214, 1, 2, 1),(28, 1215, 5, 1, 1),(28, 1216, 5, 2, 1),(28, 1217, 5, 1, 1),(28, 1218, 5, 2, 1),(28, 1219, 1, 1, 1),(28, 1220, 1, 2, 1),(28, 1221, 1, 1, 1),(28, 1222, 1, 2, 1),(28, 1223, 1, 1, 1),(28, 1224, 1, 2, 1),(28, 1225, 1, 1, 1),(28, 1226, 1, 2, 1),(28, 1227, 1, 1, 1),(28, 1228, 1, 2, 1),(28, 1229, 1, 1, 1),(28, 1230, 1, 2, 1),(28, 1231, 1, 1, 1),(28, 1232, 1, 2, 1),(28, 1233, 1, 1, 1),(28, 1234, 1, 2, 1),(28, 1235, 1, 1, 1),(28, 1236, 1, 2, 1),(28, 1237, 1, 1, 1),(28, 1238, 1, 2, 1),(28, 1239, 1, 1, 1),(28, 1240, 1, 2, 1),(28, 1241, 1, 1, 1),(28, 1242, 1, 2, 1),(28, 1243, 1, 1, 1),(28, 1244, 1, 2, 1),(28, 1245, 1, 1, 1),(28, 1246, 1, 2, 1),(28, 1247, 5, 1, 1),(28, 1248, 5, 2, 1),(28, 1249, 5, 1, 1),(28, 1250, 5, 2, 1),(28, 1251, 1, 1, 1),(28, 1252, 1, 2, 1),(28, 1253, 1, 1, 1),(28, 1254, 1, 2, 1),(28, 1255, 1, 1, 1),(28, 1256, 1, 2, 1),(28, 1257, 1, 1, 1),(28, 1258, 1, 2, 1),(28, 1259, 1, 1, 1),(28, 1260, 1, 2, 1),(28, 1261, 1, 1, 1),(28, 1262, 1, 2, 1),(28, 1263, 1, 1, 1),(28, 1264, 1, 2, 1),(28, 1265, 1, 1, 1),(28, 1266, 1, 2, 1),(28, 1267, 1, 1, 1),(28, 1268, 1, 2, 1),(28, 1269, 1, 1, 1),(28, 1270, 1, 2, 1),(28, 1271, 1, 1, 1),(28, 1272, 1, 2, 1),(28, 1273, 1, 1, 1),(28, 1274, 1, 2, 1),(28, 1275, 1, 1, 1),(28, 1276, 1, 2, 1),(28, 1277, 1, 1, 1),(28, 1278, 1, 2, 1),(28, 1279, 5, 1, 1),(28, 1280, 5, 2, 1),(28, 1281, 5, 1, 1),(28, 1282, 5, 2, 1),(28, 1283, 1, 1, 1),(28, 1284, 1, 2, 1),(28, 1285, 1, 1, 1),(28, 1286, 1, 2, 1),(28, 1287, 1, 1, 1),(28, 1288, 1, 2, 1),(28, 1289, 1, 1, 1),(28, 1290, 1, 2, 1),(28, 1291, 1, 1, 1),(28, 1292, 1, 2, 1),(28, 1293, 1, 1, 1),(28, 1294, 1, 2, 1),(28, 1295, 1, 1, 1),(28, 1296, 1, 2, 1),(28, 1297, 1, 1, 1),(28, 1298, 1, 2, 1),(28, 1299, 1, 1, 1),(28, 1300, 1, 2, 1),(28, 1301, 1, 1, 1),(28, 1302, 1, 2, 1),(28, 1303, 1, 1, 1),(28, 1304, 1, 2, 1),(28, 1305, 1, 1, 1),(28, 1306, 1, 2, 1),(28, 1307, 1, 1, 1),(28, 1308, 1, 2, 1),(28, 1309, 1, 1, 1),(28, 1310, 1, 2, 1),(28, 1311, 5, 1, 1),(28, 1312, 5, 2, 1),(28, 1313, 5, 1, 1),(28, 1314, 5, 2, 1),(28, 1315, 1, 1, 1),(28, 1316, 1, 2, 1),(28, 1317, 1, 1, 1),(28, 1318, 1, 2, 1),(28, 1319, 1, 1, 1),(28, 1320, 1, 2, 1),(28, 1321, 1, 1, 1),(28, 1322, 1, 2, 1),(28, 1323, 1, 1, 1),(28, 1324, 1, 2, 1),(28, 1325, 1, 1, 1),(28, 1326, 1, 2, 1),(28, 1327, 1, 1, 1),(28, 1328, 1, 2, 1),(28, 1329, 1, 1, 1),(28, 1330, 1, 2, 1),(28, 1331, 1, 1, 1),(28, 1332, 1, 2, 1),(28, 1333, 1, 1, 1),(28, 1334, 1, 2, 1),(28, 1335, 1, 1, 1),(28, 1336, 1, 2, 1),(28, 1337, 1, 1, 1),(28, 1338, 1, 2, 1),(28, 1339, 1, 1, 1),(28, 1340, 1, 2, 1),(28, 1341, 1, 1, 1),(28, 1342, 1, 2, 1),(28, 1343, 5, 1, 1),(28, 1344, 5, 2, 1),(28, 1345, 5, 1, 1),(28, 1346, 5, 2, 1),(28, 1347, 1, 1, 1),(28, 1348, 1, 2, 1),(28, 1349, 1, 1, 1),(28, 1350, 1, 2, 1),(28, 1351, 1, 1, 1),(28, 1352, 1, 2, 1),(28, 1353, 1, 1, 1),(28, 1354, 1, 2, 1),(28, 1355, 1, 1, 1),(28, 1356, 1, 2, 1),(28, 1357, 1, 1, 1),(28, 1358, 1, 2, 1),(28, 1359, 1, 1, 1),(28, 1360, 1, 2, 1),(28, 1361, 1, 1, 1),(28, 1362, 1, 2, 1),(28, 1363, 1, 1, 1),(28, 1364, 1, 2, 1),(28, 1365, 1, 1, 1),(28, 1366, 1, 2, 1),(28, 1367, 1, 1, 1),(28, 1368, 1, 2, 1),(28, 1369, 1, 1, 1),(28, 1370, 1, 2, 1),(28, 1371, 1, 1, 1),(28, 1372, 1, 2, 1),(28, 1373, 1, 1, 1),(28, 1374, 1, 2, 1),(28, 1375, 5, 1, 1),(28, 1376, 5, 2, 1),(28, 1377, 5, 1, 1),(28, 1378, 5, 2, 1),(28, 1379, 1, 1, 1),(28, 1380, 1, 2, 1),(28, 1381, 1, 1, 1),(28, 1382, 1, 2, 1),(28, 1383, 1, 1, 1),(28, 1384, 1, 2, 1),(28, 1385, 1, 1, 1),(28, 1386, 1, 2, 1),(28, 1387, 1, 1, 1),(28, 1388, 1, 2, 1),(28, 1389, 1, 1, 1),(28, 1390, 1, 2, 1),(28, 1391, 1, 1, 1),(28, 1392, 1, 2, 1),(28, 1393, 1, 1, 1),(28, 1394, 1, 2, 1),(28, 1395, 1, 1, 1),(28, 1396, 1, 2, 1),(28, 1397, 1, 1, 1),(28, 1398, 1, 2, 1),(28, 1399, 1, 1, 1),(28, 1400, 1, 2, 1),(28, 1401, 1, 1, 1),(28, 1402, 1, 2, 1),(28, 1403, 1, 1, 1),(28, 1404, 1, 2, 1),(28, 1405, 1, 1, 1),(28, 1406, 1, 2, 1),(28, 1407, 5, 1, 1),(28, 1408, 5, 2, 1),(28, 1409, 5, 1, 1),(28, 1410, 5, 2, 1),(28, 1411, 1, 1, 1),(28, 1412, 1, 2, 1),(28, 1413, 1, 1, 1),(28, 1414, 1, 2, 1),(28, 1415, 1, 1, 1),(28, 1416, 1, 2, 1),(28, 1417, 1, 1, 1),(28, 1418, 1, 2, 1),(28, 1419, 1, 1, 1),(28, 1420, 1, 2, 1),(28, 1421, 1, 1, 1),(28, 1422, 1, 2, 1),(28, 1423, 1, 1, 1),(28, 1424, 1, 2, 1),(28, 1425, 2, 1, 1),(28, 1426, 2, 2, 1),(28, 1427, 2, 1, 1),(28, 1428, 2, 2, 1),(28, 1429, 2, 1, 1),(28, 1430, 2, 2, 1),(28, 1431, 2, 1, 1),(28, 1432, 2, 2, 1),(28, 1433, 3, 1, 1),(28, 1434, 3, 2, 1),(28, 1435, 3, 1, 1),(28, 1436, 3, 2, 1),(28, 1437, 4, 1, 1),(28, 1438, 4, 2, 1),(28, 1439, 5, 1, 1),(28, 1440, 5, 2, 1),(28, 1441, 5, 1, 1),(28, 1442, 5, 2, 1),(28, 1443, 1, 1, 1),(28, 1444, 1, 2, 1),(28, 1445, 1, 1, 1),(28, 1446, 1, 2, 1),(28, 1447, 1, 1, 1),(28, 1448, 1, 2, 1),(28, 1449, 1, 1, 1),(28, 1450, 1, 2, 1),(28, 1451, 1, 1, 1),(28, 1452, 1, 2, 1),(28, 1453, 1, 1, 1),(28, 1454, 1, 2, 1),(28, 1455, 1, 1, 1),(28, 1456, 1, 2, 1),(28, 1457, 2, 1, 1),(28, 1458, 2, 2, 1),(28, 1459, 2, 1, 1),(28, 1460, 2, 2, 1),(28, 1461, 2, 1, 1),(28, 1462, 2, 2, 1),(28, 1463, 2, 1, 1),(28, 1464, 2, 2, 1),(28, 1465, 3, 1, 1),(28, 1466, 3, 2, 1),(28, 1467, 3, 1, 1),(28, 1468, 3, 2, 1),(28, 1469, 4, 1, 1),(28, 1470, 4, 2, 1),(28, 1471, 5, 1, 1),(28, 1472, 5, 2, 1),(28, 1473, 5, 1, 1),(28, 1474, 5, 2, 1),(28, 1475, 5, 1, 1),(28, 1476, 5, 2, 1),(28, 1477, 5, 1, 1),(28, 1478, 5, 2, 1),(28, 1479, 5, 1, 1),(28, 1480, 5, 2, 1),(28, 1481, 5, 1, 1),(28, 1482, 5, 2, 1),(28, 1483, 5, 1, 1),(28, 1484, 5, 2, 1),(28, 1485, 5, 1, 1),(28, 1486, 5, 2, 1),(28, 1487, 5, 1, 1),(28, 1488, 5, 2, 1),(28, 1489, 5, 1, 1),(28, 1490, 5, 2, 1),(28, 1491, 5, 1, 1),(28, 1492, 5, 2, 1),(28, 1493, 5, 1, 1),(28, 1494, 5, 2, 1),(28, 1495, 5, 1, 1),(28, 1496, 5, 2, 1),(28, 1497, 5, 1, 1),(28, 1498, 5, 2, 1),(28, 1499, 5, 1, 1),(28, 1500, 5, 2, 1),(28, 1501, 5, 1, 1),(28, 1502, 5, 2, 1),(28, 1503, 5, 1, 1),(28, 1504, 5, 2, 1),(28, 1505, 5, 1, 1),(28, 1506, 5, 2, 1),(28, 1507, 5, 1, 1),(28, 1508, 5, 2, 1),(28, 1509, 5, 1, 1),(28, 1510, 5, 2, 1),(28, 1511, 5, 1, 1),(28, 1512, 5, 2, 1),(28, 1513, 5, 1, 1),(28, 1514, 5, 2, 1),(28, 1515, 5, 1, 1),(28, 1516, 5, 2, 1),(28, 1517, 5, 1, 1),(28, 1518, 5, 2, 1),(28, 1519, 5, 1, 1),(28, 1520, 5, 2, 1),(28, 1521, 5, 1, 1),(28, 1522, 5, 2, 1),(28, 1523, 5, 1, 1),(28, 1524, 5, 2, 1),(28, 1525, 5, 1, 1),(28, 1526, 5, 2, 1),(28, 1527, 5, 1, 1),(28, 1528, 5, 2, 1),(28, 1529, 5, 1, 1),(28, 1530, 5, 2, 1),(28, 1531, 5, 1, 1),(28, 1532, 5, 2, 1),(28, 1533, 5, 1, 1),(28, 1534, 5, 2, 1),(28, 1535, 5, 1, 1),(28, 1536, 5, 2, 1),(29, 1, 5, 1, 1),(29, 2, 5, 1, 2),(29, 3, 5, 1, 1),(29, 4, 5, 1, 2),(29, 5, 5, 1, 1),(29, 6, 5, 1, 2),(29, 7, 5, 1, 1),(29, 8, 5, 1, 2),(29, 9, 5, 1, 1),(29, 10, 5, 1, 2),(29, 11, 5, 1, 1),(29, 12, 5, 1, 2),(29, 13, 5, 1, 1),(29, 14, 5, 1, 2),(29, 15, 5, 1, 1),(29, 16, 5, 1, 2),(29, 17, 5, 1, 1),(29, 18, 5, 1, 2),(29, 19, 5, 1, 1),(29, 20, 5, 1, 2),(29, 21, 5, 1, 1),(29, 22, 5, 1, 2),(29, 23, 5, 1, 1),(29, 24, 5, 1, 2),(29, 25, 5, 1, 1),(29, 26, 5, 1, 2),(29, 27, 5, 1, 1),(29, 28, 5, 1, 2),(29, 29, 5, 1, 1),(29, 30, 5, 1, 2),(29, 31, 5, 1, 1),(29, 32, 5, 1, 2),(29, 33, 5, 1, 3),(29, 34, 5, 1, 4),(29, 35, 5, 1, 3),(29, 36, 5, 1, 4),(29, 37, 5, 1, 3),(29, 38, 5, 1, 4),(29, 39, 5, 1, 3),(29, 40, 5, 1, 4),(29, 41, 5, 1, 3),(29, 42, 5, 1, 4),(29, 43, 5, 1, 3),(29, 44, 5, 1, 4),(29, 45, 5, 1, 3),(29, 46, 5, 1, 4),(29, 47, 5, 1, 3),(29, 48, 5, 1, 4),(29, 49, 5, 1, 3),(29, 50, 5, 1, 4),(29, 51, 5, 1, 3),(29, 52, 5, 1, 4),(29, 53, 5, 1, 3),(29, 54, 5, 1, 4),(29, 55, 5, 1, 3),(29, 56, 5, 1, 4),(29, 57, 5, 1, 3),(29, 58, 5, 1, 4),(29, 59, 5, 1, 3),(29, 60, 5, 1, 4),(29, 61, 5, 1, 3),(29, 62, 5, 1, 4),(29, 63, 5, 1, 3),(29, 64, 5, 1, 4),(29, 65, 5, 1, 1),(29, 66, 5, 1, 2),(29, 67, 1, 1, 1),(29, 68, 1, 1, 2),(29, 69, 1, 1, 1),(29, 70, 1, 1, 2),(29, 71, 1, 1, 1),(29, 72, 1, 1, 2),(29, 73, 1, 1, 1),(29, 74, 1, 1, 2),(29, 75, 1, 1, 1),(29, 76, 1, 1, 2),(29, 77, 1, 1, 1),(29, 78, 1, 1, 2),(29, 79, 1, 1, 1),(29, 80, 1, 1, 2),(29, 81, 1, 1, 1),(29, 82, 1, 1, 2),(29, 83, 1, 1, 1),(29, 84, 1, 1, 2),(29, 85, 1, 1, 1),(29, 86, 1, 1, 2),(29, 87, 1, 1, 1),(29, 88, 1, 1, 2),(29, 89, 1, 1, 1),(29, 90, 1, 1, 2),(29, 91, 1, 1, 1),(29, 92, 1, 1, 2),(29, 93, 1, 1, 1),(29, 94, 1, 1, 2),(29, 95, 5, 1, 1),(29, 96, 5, 1, 2),(29, 97, 5, 1, 3),(29, 98, 5, 1, 4),(29, 99, 1, 1, 3),(29, 100, 1, 1, 4),(29, 101, 1, 1, 3),(29, 102, 1, 1, 4),(29, 103, 1, 1, 3),(29, 104, 1, 1, 4),(29, 105, 1, 1, 3),(29, 106, 1, 1, 4),(29, 107, 1, 1, 3),(29, 108, 1, 1, 4),(29, 109, 1, 1, 3),(29, 110, 1, 1, 4),(29, 111, 1, 1, 3),(29, 112, 1, 1, 4),(29, 113, 1, 1, 3),(29, 114, 1, 1, 4),(29, 115, 1, 1, 3),(29, 116, 1, 1, 4),(29, 117, 1, 1, 3),(29, 118, 1, 1, 4),(29, 119, 1, 1, 3),(29, 120, 1, 1, 4),(29, 121, 1, 1, 3),(29, 122, 1, 1, 4),(29, 123, 1, 1, 3),(29, 124, 1, 1, 4),(29, 125, 1, 1, 3),(29, 126, 1, 1, 4),(29, 127, 5, 1, 3),(29, 128, 5, 1, 4),(29, 129, 5, 1, 1),(29, 130, 5, 1, 2),(29, 131, 1, 1, 1),(29, 132, 1, 1, 2),(29, 133, 1, 1, 1),(29, 134, 1, 1, 2),(29, 135, 1, 1, 1),(29, 136, 1, 1, 2),(29, 137, 1, 1, 1),(29, 138, 1, 1, 2),(29, 139, 1, 1, 1),(29, 140, 1, 1, 2),(29, 141, 1, 1, 1),(29, 142, 1, 1, 2),(29, 143, 1, 1, 1),(29, 144, 1, 1, 2),(29, 145, 1, 1, 1),(29, 146, 1, 1, 2),(29, 147, 1, 1, 1),(29, 148, 1, 1, 2),(29, 149, 1, 1, 1),(29, 150, 1, 1, 2),(29, 151, 1, 1, 1),(29, 152, 1, 1, 2),(29, 153, 1, 1, 1),(29, 154, 1, 1, 2),(29, 155, 1, 1, 1),(29, 156, 1, 1, 2),(29, 157, 1, 1, 1),(29, 158, 1, 1, 2),(29, 159, 5, 1, 1),(29, 160, 5, 1, 2),(29, 161, 5, 1, 3),(29, 162, 5, 1, 4),(29, 163, 1, 1, 3),(29, 164, 1, 1, 4),(29, 165, 1, 1, 3),(29, 166, 1, 1, 4),(29, 167, 1, 1, 3),(29, 168, 1, 1, 4),(29, 169, 1, 1, 3),(29, 170, 1, 1, 4),(29, 171, 1, 1, 3),(29, 172, 1, 1, 4),(29, 173, 1, 1, 3),(29, 174, 1, 1, 4),(29, 175, 1, 1, 3),(29, 176, 1, 1, 4),(29, 177, 1, 1, 3),(29, 178, 1, 1, 4),(29, 179, 1, 1, 3),(29, 180, 1, 1, 4),(29, 181, 1, 1, 3),(29, 182, 1, 1, 4),(29, 183, 1, 1, 3),(29, 184, 1, 1, 4),(29, 185, 1, 1, 3),(29, 186, 1, 1, 4),(29, 187, 1, 1, 3),(29, 188, 1, 1, 4),(29, 189, 1, 1, 3),(29, 190, 1, 1, 4),(29, 191, 5, 1, 3),(29, 192, 5, 1, 4),(29, 193, 5, 1, 1),(29, 194, 5, 1, 2),(29, 195, 1, 1, 1),(29, 196, 1, 1, 2),(29, 197, 1, 1, 1),(29, 198, 1, 1, 2),(29, 199, 1, 1, 1),(29, 200, 1, 1, 2),(29, 201, 1, 1, 1),(29, 202, 1, 1, 2),(29, 203, 1, 1, 1),(29, 204, 1, 1, 2),(29, 205, 1, 1, 1),(29, 206, 1, 1, 2),(29, 207, 1, 1, 1),(29, 208, 1, 1, 2),(29, 209, 1, 1, 1),(29, 210, 1, 1, 2),(29, 211, 1, 1, 1),(29, 212, 1, 1, 2),(29, 213, 1, 1, 1),(29, 214, 1, 1, 2),(29, 215, 1, 1, 1),(29, 216, 1, 1, 2),(29, 217, 1, 1, 1),(29, 218, 1, 1, 2),(29, 219, 1, 1, 1),(29, 220, 1, 1, 2),(29, 221, 1, 1, 1),(29, 222, 1, 1, 2),(29, 223, 5, 1, 1),(29, 224, 5, 1, 2),(29, 225, 5, 1, 3),(29, 226, 5, 1, 4),(29, 227, 1, 1, 3),(29, 228, 1, 1, 4),(29, 229, 1, 1, 3),(29, 230, 1, 1, 4),(29, 231, 1, 1, 3),(29, 232, 1, 1, 4),(29, 233, 1, 1, 3),(29, 234, 1, 1, 4),(29, 235, 1, 1, 3),(29, 236, 1, 1, 4),(29, 237, 1, 1, 3),(29, 238, 1, 1, 4),(29, 239, 1, 1, 3),(29, 240, 1, 1, 4),(29, 241, 1, 1, 3),(29, 242, 1, 1, 4),(29, 243, 1, 1, 3),(29, 244, 1, 1, 4),(29, 245, 1, 1, 3),(29, 246, 1, 1, 4),(29, 247, 1, 1, 3),(29, 248, 1, 1, 4),(29, 249, 1, 1, 3),(29, 250, 1, 1, 4),(29, 251, 1, 1, 3),(29, 252, 1, 1, 4),(29, 253, 1, 1, 3),(29, 254, 1, 1, 4),(29, 255, 5, 1, 3),(29, 256, 5, 1, 4),(29, 257, 5, 1, 1),(29, 258, 5, 1, 2),(29, 259, 1, 1, 1),(29, 260, 1, 1, 2),(29, 261, 1, 1, 1),(29, 262, 1, 1, 2),(29, 263, 1, 1, 1),(29, 264, 1, 1, 2),(29, 265, 1, 1, 1),(29, 266, 1, 1, 2),(29, 267, 1, 1, 1),(29, 268, 1, 1, 2),(29, 269, 1, 1, 1),(29, 270, 1, 1, 2),(29, 271, 1, 1, 1),(29, 272, 1, 1, 2),(29, 273, 1, 1, 1),(29, 274, 1, 1, 2),(29, 275, 1, 1, 1),(29, 276, 1, 1, 2),(29, 277, 1, 1, 1),(29, 278, 1, 1, 2),(29, 279, 1, 1, 1),(29, 280, 1, 1, 2),(29, 281, 1, 1, 1),(29, 282, 1, 1, 2),(29, 283, 1, 1, 1),(29, 284, 1, 1, 2),(29, 285, 1, 1, 1),(29, 286, 1, 1, 2),(29, 287, 5, 1, 1),(29, 288, 5, 1, 2),(29, 289, 5, 1, 3),(29, 290, 5, 1, 4),(29, 291, 1, 1, 3),(29, 292, 1, 1, 4),(29, 293, 1, 1, 3),(29, 294, 1, 1, 4),(29, 295, 1, 1, 3),(29, 296, 1, 1, 4),(29, 297, 1, 1, 3),(29, 298, 1, 1, 4),(29, 299, 1, 1, 3),(29, 300, 1, 1, 4),(29, 301, 1, 1, 3),(29, 302, 1, 1, 4),(29, 303, 1, 1, 3),(29, 304, 1, 1, 4),(29, 305, 1, 1, 3),(29, 306, 1, 1, 4),(29, 307, 1, 1, 3),(29, 308, 1, 1, 4),(29, 309, 1, 1, 3),(29, 310, 1, 1, 4),(29, 311, 1, 1, 3),(29, 312, 1, 1, 4),(29, 313, 1, 1, 3),(29, 314, 1, 1, 4),(29, 315, 1, 1, 3),(29, 316, 1, 1, 4),(29, 317, 1, 1, 3),(29, 318, 1, 1, 4),(29, 319, 5, 1, 3),(29, 320, 5, 1, 4),(29, 321, 5, 1, 1),(29, 322, 5, 1, 2),(29, 323, 1, 1, 1),(29, 324, 1, 1, 2),(29, 325, 1, 1, 1),(29, 326, 1, 1, 2),(29, 327, 1, 1, 1),(29, 328, 1, 1, 2),(29, 329, 1, 1, 1),(29, 330, 1, 1, 2),(29, 331, 1, 1, 1),(29, 332, 1, 1, 2),(29, 333, 1, 1, 1),(29, 334, 1, 1, 2),(29, 335, 1, 1, 1),(29, 336, 1, 1, 2),(29, 337, 1, 1, 1),(29, 338, 1, 1, 2),(29, 339, 1, 1, 1),(29, 340, 1, 1, 2),(29, 341, 1, 1, 1),(29, 342, 1, 1, 2),(29, 343, 1, 1, 1),(29, 344, 1, 1, 2),(29, 345, 1, 1, 1),(29, 346, 1, 1, 2),(29, 347, 1, 1, 1),(29, 348, 1, 1, 2),(29, 349, 1, 1, 1),(29, 350, 1, 1, 2),(29, 351, 5, 1, 1),(29, 352, 5, 1, 2),(29, 353, 5, 1, 3),(29, 354, 5, 1, 4),(29, 355, 1, 1, 3),(29, 356, 1, 1, 4),(29, 357, 1, 1, 3),(29, 358, 1, 1, 4),(29, 359, 1, 1, 3),(29, 360, 1, 1, 4),(29, 361, 1, 1, 3),(29, 362, 1, 1, 4),(29, 363, 1, 1, 3),(29, 364, 1, 1, 4),(29, 365, 1, 1, 3),(29, 366, 1, 1, 4),(29, 367, 1, 1, 3),(29, 368, 1, 1, 4),(29, 369, 1, 1, 3),(29, 370, 1, 1, 4),(29, 371, 1, 1, 3),(29, 372, 1, 1, 4),(29, 373, 1, 1, 3),(29, 374, 1, 1, 4),(29, 375, 1, 1, 3),(29, 376, 1, 1, 4),(29, 377, 1, 1, 3),(29, 378, 1, 1, 4),(29, 379, 1, 1, 3),(29, 380, 1, 1, 4),(29, 381, 1, 1, 3),(29, 382, 1, 1, 4),(29, 383, 5, 1, 3),(29, 384, 5, 1, 4),(29, 385, 5, 1, 1),(29, 386, 5, 1, 2),(29, 387, 1, 1, 1),(29, 388, 1, 1, 2),(29, 389, 1, 1, 1),(29, 390, 1, 1, 2),(29, 391, 1, 1, 1),(29, 392, 1, 1, 2),(29, 393, 1, 1, 1),(29, 394, 1, 1, 2),(29, 395, 1, 1, 1),(29, 396, 1, 1, 2),(29, 397, 1, 1, 1),(29, 398, 1, 1, 2),(29, 399, 1, 1, 1),(29, 400, 1, 1, 2),(29, 401, 1, 1, 1),(29, 402, 1, 1, 2),(29, 403, 1, 1, 1),(29, 404, 1, 1, 2),(29, 405, 1, 1, 1),(29, 406, 1, 1, 2),(29, 407, 1, 1, 1),(29, 408, 1, 1, 2),(29, 409, 1, 1, 1),(29, 410, 1, 1, 2),(29, 411, 1, 1, 1),(29, 412, 1, 1, 2),(29, 413, 1, 1, 1),(29, 414, 1, 1, 2),(29, 415, 5, 1, 1),(29, 416, 5, 1, 2),(29, 417, 5, 1, 3),(29, 418, 5, 1, 4),(29, 419, 1, 1, 3),(29, 420, 1, 1, 4),(29, 421, 1, 1, 3),(29, 422, 1, 1, 4),(29, 423, 1, 1, 3),(29, 424, 1, 1, 4),(29, 425, 1, 1, 3),(29, 426, 1, 1, 4),(29, 427, 1, 1, 3),(29, 428, 1, 1, 4),(29, 429, 1, 1, 3),(29, 430, 1, 1, 4),(29, 431, 1, 1, 3),(29, 432, 1, 1, 4),(29, 433, 1, 1, 3),(29, 434, 1, 1, 4),(29, 435, 1, 1, 3),(29, 436, 1, 1, 4),(29, 437, 1, 1, 3),(29, 438, 1, 1, 4),(29, 439, 1, 1, 3),(29, 440, 1, 1, 4),(29, 441, 1, 1, 3),(29, 442, 1, 1, 4),(29, 443, 1, 1, 3),(29, 444, 1, 1, 4),(29, 445, 1, 1, 3),(29, 446, 1, 1, 4),(29, 447, 5, 1, 3),(29, 448, 5, 1, 4),(29, 449, 5, 1, 1),(29, 450, 5, 1, 2),(29, 451, 1, 1, 1),(29, 452, 1, 1, 2),(29, 453, 1, 1, 1),(29, 454, 1, 1, 2),(29, 455, 1, 1, 1),(29, 456, 1, 1, 2),(29, 457, 1, 1, 1),(29, 458, 1, 1, 2),(29, 459, 1, 1, 1),(29, 460, 1, 1, 2),(29, 461, 1, 1, 1),(29, 462, 1, 1, 2),(29, 463, 1, 1, 1),(29, 464, 1, 1, 2),(29, 465, 1, 1, 1),(29, 466, 1, 1, 2),(29, 467, 1, 1, 1),(29, 468, 1, 1, 2),(29, 469, 1, 1, 1),(29, 470, 1, 1, 2),(29, 471, 1, 1, 1),(29, 472, 1, 1, 2),(29, 473, 1, 1, 1),(29, 474, 1, 1, 2),(29, 475, 1, 1, 1),(29, 476, 1, 1, 2),(29, 477, 1, 1, 1),(29, 478, 1, 1, 2),(29, 479, 5, 1, 1),(29, 480, 5, 1, 2),(29, 481, 5, 1, 3),(29, 482, 5, 1, 4),(29, 483, 1, 1, 3),(29, 484, 1, 1, 4),(29, 485, 1, 1, 3),(29, 486, 1, 1, 4),(29, 487, 1, 1, 3),(29, 488, 1, 1, 4),(29, 489, 1, 1, 3),(29, 490, 1, 1, 4),(29, 491, 1, 1, 3),(29, 492, 1, 1, 4),(29, 493, 1, 1, 3),(29, 494, 1, 1, 4),(29, 495, 1, 1, 3),(29, 496, 1, 1, 4),(29, 497, 1, 1, 3),(29, 498, 1, 1, 4),(29, 499, 1, 1, 3),(29, 500, 1, 1, 4),(29, 501, 1, 1, 3),(29, 502, 1, 1, 4),(29, 503, 1, 1, 3),(29, 504, 1, 1, 4),(29, 505, 1, 1, 3),(29, 506, 1, 1, 4),(29, 507, 1, 1, 3),(29, 508, 1, 1, 4),(29, 509, 1, 1, 3),(29, 510, 1, 1, 4),(29, 511, 5, 1, 3),(29, 512, 5, 1, 4),(29, 513, 5, 1, 1),(29, 514, 5, 1, 2),(29, 515, 1, 1, 1),(29, 516, 1, 1, 2),(29, 517, 1, 1, 1),(29, 518, 1, 1, 2),(29, 519, 1, 1, 1),(29, 520, 1, 1, 2),(29, 521, 1, 1, 1),(29, 522, 1, 1, 2),(29, 523, 1, 1, 1),(29, 524, 1, 1, 2),(29, 525, 1, 1, 1),(29, 526, 1, 1, 2),(29, 527, 1, 1, 1),(29, 528, 1, 1, 2),(29, 529, 1, 1, 1),(29, 530, 1, 1, 2),(29, 531, 1, 1, 1),(29, 532, 1, 1, 2),(29, 533, 1, 1, 1),(29, 534, 1, 1, 2),(29, 535, 1, 1, 1),(29, 536, 1, 1, 2),(29, 537, 1, 1, 1),(29, 538, 1, 1, 2),(29, 539, 1, 1, 1),(29, 540, 1, 1, 2),(29, 541, 1, 1, 1),(29, 542, 1, 1, 2),(29, 543, 5, 1, 1),(29, 544, 5, 1, 2),(29, 545, 5, 1, 3),(29, 546, 5, 1, 4),(29, 547, 1, 1, 3),(29, 548, 1, 1, 4),(29, 549, 1, 1, 3),(29, 550, 1, 1, 4),(29, 551, 1, 1, 3),(29, 552, 1, 1, 4),(29, 553, 1, 1, 3),(29, 554, 1, 1, 4),(29, 555, 1, 1, 3),(29, 556, 1, 1, 4),(29, 557, 1, 1, 3),(29, 558, 1, 1, 4),(29, 559, 1, 1, 3),(29, 560, 1, 1, 4),(29, 561, 1, 1, 3),(29, 562, 1, 1, 4),(29, 563, 1, 1, 3),(29, 564, 1, 1, 4),(29, 565, 1, 1, 3),(29, 566, 1, 1, 4),(29, 567, 1, 1, 3),(29, 568, 1, 1, 4),(29, 569, 1, 1, 3),(29, 570, 1, 1, 4),(29, 571, 1, 1, 3),(29, 572, 1, 1, 4),(29, 573, 1, 1, 3),(29, 574, 1, 1, 4),(29, 575, 5, 1, 3),(29, 576, 5, 1, 4),(29, 577, 5, 1, 1),(29, 578, 5, 1, 2),(29, 579, 1, 1, 1),(29, 580, 1, 1, 2),(29, 581, 1, 1, 1),(29, 582, 1, 1, 2),(29, 583, 1, 1, 1),(29, 584, 1, 1, 2),(29, 585, 1, 1, 1),(29, 586, 1, 1, 2),(29, 587, 1, 1, 1),(29, 588, 1, 1, 2),(29, 589, 1, 1, 1),(29, 590, 1, 1, 2),(29, 591, 1, 1, 1),(29, 592, 1, 1, 2),(29, 593, 1, 1, 1),(29, 594, 1, 1, 2),(29, 595, 1, 1, 1),(29, 596, 1, 1, 2),(29, 597, 1, 1, 1),(29, 598, 1, 1, 2),(29, 599, 1, 1, 1),(29, 600, 1, 1, 2),(29, 601, 1, 1, 1),(29, 602, 1, 1, 2),(29, 603, 1, 1, 1),(29, 604, 1, 1, 2),(29, 605, 1, 1, 1),(29, 606, 1, 1, 2),(29, 607, 5, 1, 1),(29, 608, 5, 1, 2),(29, 609, 5, 1, 3),(29, 610, 5, 1, 4),(29, 611, 1, 1, 3),(29, 612, 1, 1, 4),(29, 613, 1, 1, 3),(29, 614, 1, 1, 4),(29, 615, 1, 1, 3),(29, 616, 1, 1, 4),(29, 617, 1, 1, 3),(29, 618, 1, 1, 4),(29, 619, 1, 1, 3),(29, 620, 1, 1, 4),(29, 621, 1, 1, 3),(29, 622, 1, 1, 4),(29, 623, 1, 1, 3),(29, 624, 1, 1, 4),(29, 625, 1, 1, 3),(29, 626, 1, 1, 4),(29, 627, 1, 1, 3),(29, 628, 1, 1, 4),(29, 629, 1, 1, 3),(29, 630, 1, 1, 4),(29, 631, 1, 1, 3),(29, 632, 1, 1, 4),(29, 633, 1, 1, 3),(29, 634, 1, 1, 4),(29, 635, 1, 1, 3),(29, 636, 1, 1, 4),(29, 637, 1, 1, 3),(29, 638, 1, 1, 4),(29, 639, 5, 1, 3),(29, 640, 5, 1, 4),(29, 641, 5, 1, 1),(29, 642, 5, 1, 2),(29, 643, 1, 1, 1),(29, 644, 1, 1, 2),(29, 645, 1, 1, 1),(29, 646, 1, 1, 2),(29, 647, 1, 1, 1),(29, 648, 1, 1, 2),(29, 649, 1, 1, 1),(29, 650, 1, 1, 2),(29, 651, 1, 1, 1),(29, 652, 1, 1, 2),(29, 653, 1, 1, 1),(29, 654, 1, 1, 2),(29, 655, 1, 1, 1),(29, 656, 1, 1, 2),(29, 657, 1, 1, 1),(29, 658, 1, 1, 2),(29, 659, 1, 1, 1),(29, 660, 1, 1, 2),(29, 661, 1, 1, 1),(29, 662, 1, 1, 2),(29, 663, 1, 1, 1),(29, 664, 1, 1, 2),(29, 665, 1, 1, 1),(29, 666, 1, 1, 2),(29, 667, 1, 1, 1),(29, 668, 1, 1, 2),(29, 669, 1, 1, 1),(29, 670, 1, 1, 2),(29, 671, 5, 1, 1),(29, 672, 5, 1, 2),(29, 673, 5, 1, 3),(29, 674, 5, 1, 4),(29, 675, 1, 1, 3),(29, 676, 1, 1, 4),(29, 677, 1, 1, 3),(29, 678, 1, 1, 4),(29, 679, 1, 1, 3),(29, 680, 1, 1, 4),(29, 681, 1, 1, 3),(29, 682, 1, 1, 4),(29, 683, 1, 1, 3),(29, 684, 1, 1, 4),(29, 685, 1, 1, 3),(29, 686, 1, 1, 4),(29, 687, 1, 1, 3),(29, 688, 1, 1, 4),(29, 689, 1, 1, 3),(29, 690, 1, 1, 4),(29, 691, 1, 1, 3),(29, 692, 1, 1, 4),(29, 693, 1, 1, 3),(29, 694, 1, 1, 4),(29, 695, 1, 1, 3),(29, 696, 1, 1, 4),(29, 697, 1, 1, 3),(29, 698, 1, 1, 4),(29, 699, 1, 1, 3),(29, 700, 1, 1, 4),(29, 701, 1, 1, 3),(29, 702, 1, 1, 4),(29, 703, 5, 1, 3),(29, 704, 5, 1, 4),(29, 705, 5, 1, 1),(29, 706, 5, 1, 2),(29, 707, 1, 1, 1),(29, 708, 1, 1, 2),(29, 709, 1, 1, 1),(29, 710, 1, 1, 2),(29, 711, 1, 1, 1),(29, 712, 1, 1, 2),(29, 713, 1, 1, 1),(29, 714, 1, 1, 2),(29, 715, 1, 1, 1),(29, 716, 1, 1, 2),(29, 717, 1, 1, 1),(29, 718, 1, 1, 2),(29, 719, 1, 1, 1),(29, 720, 1, 1, 2),(29, 721, 1, 1, 1),(29, 722, 1, 1, 2),(29, 723, 1, 1, 1),(29, 724, 1, 1, 2),(29, 725, 1, 1, 1),(29, 726, 1, 1, 2),(29, 727, 1, 1, 1),(29, 728, 1, 1, 2),(29, 729, 1, 1, 1),(29, 730, 1, 1, 2),(29, 731, 1, 1, 1),(29, 732, 1, 1, 2),(29, 733, 1, 1, 1),(29, 734, 1, 1, 2),(29, 735, 5, 1, 1),(29, 736, 5, 1, 2),(29, 737, 5, 1, 3),(29, 738, 5, 1, 4),(29, 739, 1, 1, 3),(29, 740, 1, 1, 4),(29, 741, 1, 1, 3),(29, 742, 1, 1, 4),(29, 743, 1, 1, 3),(29, 744, 1, 1, 4),(29, 745, 1, 1, 3),(29, 746, 1, 1, 4),(29, 747, 1, 1, 3),(29, 748, 1, 1, 4),(29, 749, 1, 1, 3),(29, 750, 1, 1, 4),(29, 751, 1, 1, 3),(29, 752, 1, 1, 4),(29, 753, 1, 1, 3),(29, 754, 1, 1, 4),(29, 755, 1, 1, 3),(29, 756, 1, 1, 4),(29, 757, 1, 1, 3),(29, 758, 1, 1, 4),(29, 759, 1, 1, 3),(29, 760, 1, 1, 4),(29, 761, 1, 1, 3),(29, 762, 1, 1, 4),(29, 763, 1, 1, 3),(29, 764, 1, 1, 4),(29, 765, 1, 1, 3),(29, 766, 1, 1, 4),(29, 767, 5, 1, 3),(29, 768, 5, 1, 4),(29, 769, 5, 1, 1),(29, 770, 5, 1, 2),(29, 771, 1, 1, 1),(29, 772, 1, 1, 2),(29, 773, 1, 1, 1),(29, 774, 1, 1, 2),(29, 775, 1, 1, 1),(29, 776, 1, 1, 2),(29, 777, 1, 1, 1),(29, 778, 1, 1, 2),(29, 779, 1, 1, 1),(29, 780, 1, 1, 2),(29, 781, 1, 1, 1),(29, 782, 1, 1, 2),(29, 783, 1, 1, 1),(29, 784, 1, 1, 2),(29, 785, 1, 1, 1),(29, 786, 1, 1, 2),(29, 787, 1, 1, 1),(29, 788, 1, 1, 2),(29, 789, 1, 1, 1),(29, 790, 1, 1, 2),(29, 791, 1, 1, 1),(29, 792, 1, 1, 2),(29, 793, 1, 1, 1),(29, 794, 1, 1, 2),(29, 795, 1, 1, 1),(29, 796, 1, 1, 2),(29, 797, 1, 1, 1),(29, 798, 1, 1, 2),(29, 799, 5, 1, 1),(29, 800, 5, 1, 2),(29, 801, 5, 1, 3),(29, 802, 5, 1, 4),(29, 803, 1, 1, 3),(29, 804, 1, 1, 4),(29, 805, 1, 1, 3),(29, 806, 1, 1, 4),(29, 807, 1, 1, 3),(29, 808, 1, 1, 4),(29, 809, 1, 1, 3),(29, 810, 1, 1, 4),(29, 811, 1, 1, 3),(29, 812, 1, 1, 4),(29, 813, 1, 1, 3),(29, 814, 1, 1, 4),(29, 815, 1, 1, 3),(29, 816, 1, 1, 4),(29, 817, 1, 1, 3),(29, 818, 1, 1, 4),(29, 819, 1, 1, 3),(29, 820, 1, 1, 4),(29, 821, 1, 1, 3),(29, 822, 1, 1, 4),(29, 823, 1, 1, 3),(29, 824, 1, 1, 4),(29, 825, 1, 1, 3),(29, 826, 1, 1, 4),(29, 827, 1, 1, 3),(29, 828, 1, 1, 4),(29, 829, 1, 1, 3),(29, 830, 1, 1, 4),(29, 831, 5, 1, 3),(29, 832, 5, 1, 4),(29, 833, 5, 1, 1),(29, 834, 5, 1, 2),(29, 835, 1, 1, 1),(29, 836, 1, 1, 2),(29, 837, 1, 1, 1),(29, 838, 1, 1, 2),(29, 839, 1, 1, 1),(29, 840, 1, 1, 2),(29, 841, 1, 1, 1),(29, 842, 1, 1, 2),(29, 843, 1, 1, 1),(29, 844, 1, 1, 2),(29, 845, 1, 1, 1),(29, 846, 1, 1, 2),(29, 847, 1, 1, 1),(29, 848, 1, 1, 2),(29, 849, 1, 1, 1),(29, 850, 1, 1, 2),(29, 851, 1, 1, 1),(29, 852, 1, 1, 2),(29, 853, 1, 1, 1),(29, 854, 1, 1, 2),(29, 855, 1, 1, 1),(29, 856, 1, 1, 2),(29, 857, 1, 1, 1),(29, 858, 1, 1, 2),(29, 859, 1, 1, 1),(29, 860, 1, 1, 2),(29, 861, 1, 1, 1),(29, 862, 1, 1, 2),(29, 863, 5, 1, 1),(29, 864, 5, 1, 2),(29, 865, 5, 1, 3),(29, 866, 5, 1, 4),(29, 867, 1, 1, 3),(29, 868, 1, 1, 4),(29, 869, 1, 1, 3),(29, 870, 1, 1, 4),(29, 871, 1, 1, 3),(29, 872, 1, 1, 4),(29, 873, 1, 1, 3),(29, 874, 1, 1, 4),(29, 875, 1, 1, 3),(29, 876, 1, 1, 4),(29, 877, 1, 1, 3),(29, 878, 1, 1, 4),(29, 879, 1, 1, 3),(29, 880, 1, 1, 4),(29, 881, 1, 1, 3),(29, 882, 1, 1, 4),(29, 883, 1, 1, 3),(29, 884, 1, 1, 4),(29, 885, 1, 1, 3),(29, 886, 1, 1, 4),(29, 887, 1, 1, 3),(29, 888, 1, 1, 4),(29, 889, 1, 1, 3),(29, 890, 1, 1, 4),(29, 891, 1, 1, 3),(29, 892, 1, 1, 4),(29, 893, 1, 1, 3),(29, 894, 1, 1, 4),(29, 895, 5, 1, 3),(29, 896, 5, 1, 4),(29, 897, 5, 1, 1),(29, 898, 5, 1, 2),(29, 899, 1, 1, 1),(29, 900, 1, 1, 2),(29, 901, 1, 1, 1),(29, 902, 1, 1, 2),(29, 903, 1, 1, 1),(29, 904, 1, 1, 2),(29, 905, 1, 1, 1),(29, 906, 1, 1, 2),(29, 907, 1, 1, 1),(29, 908, 1, 1, 2),(29, 909, 1, 1, 1),(29, 910, 1, 1, 2),(29, 911, 1, 1, 1),(29, 912, 1, 1, 2),(29, 913, 1, 1, 1),(29, 914, 1, 1, 2),(29, 915, 1, 1, 1),(29, 916, 1, 1, 2),(29, 917, 1, 1, 1),(29, 918, 1, 1, 2),(29, 919, 1, 1, 1),(29, 920, 1, 1, 2),(29, 921, 1, 1, 1),(29, 922, 1, 1, 2),(29, 923, 1, 1, 1),(29, 924, 1, 1, 2),(29, 925, 1, 1, 1),(29, 926, 1, 1, 2),(29, 927, 5, 1, 1),(29, 928, 5, 1, 2),(29, 929, 5, 1, 3),(29, 930, 5, 1, 4),(29, 931, 1, 1, 3),(29, 932, 1, 1, 4),(29, 933, 1, 1, 3),(29, 934, 1, 1, 4),(29, 935, 1, 1, 3),(29, 936, 1, 1, 4),(29, 937, 1, 1, 3),(29, 938, 1, 1, 4),(29, 939, 1, 1, 3),(29, 940, 1, 1, 4),(29, 941, 1, 1, 3),(29, 942, 1, 1, 4),(29, 943, 1, 1, 3),(29, 944, 1, 1, 4),(29, 945, 1, 1, 3),(29, 946, 1, 1, 4),(29, 947, 1, 1, 3),(29, 948, 1, 1, 4),(29, 949, 1, 1, 3),(29, 950, 1, 1, 4),(29, 951, 1, 1, 3),(29, 952, 1, 1, 4),(29, 953, 1, 1, 3),(29, 954, 1, 1, 4),(29, 955, 1, 1, 3),(29, 956, 1, 1, 4),(29, 957, 1, 1, 3),(29, 958, 1, 1, 4),(29, 959, 5, 1, 3),(29, 960, 5, 1, 4),(29, 961, 5, 1, 1),(29, 962, 5, 1, 2),(29, 963, 1, 1, 1),(29, 964, 1, 1, 2),(29, 965, 1, 1, 1),(29, 966, 1, 1, 2),(29, 967, 1, 1, 1),(29, 968, 1, 1, 2),(29, 969, 1, 1, 1),(29, 970, 1, 1, 2),(29, 971, 1, 1, 1),(29, 972, 1, 1, 2),(29, 973, 1, 1, 1),(29, 974, 1, 1, 2),(29, 975, 1, 1, 1),(29, 976, 1, 1, 2),(29, 977, 1, 1, 1),(29, 978, 1, 1, 2),(29, 979, 1, 1, 1),(29, 980, 1, 1, 2),(29, 981, 1, 1, 1),(29, 982, 1, 1, 2),(29, 983, 1, 1, 1),(29, 984, 1, 1, 2),(29, 985, 1, 1, 1),(29, 986, 1, 1, 2),(29, 987, 1, 1, 1),(29, 988, 1, 1, 2),(29, 989, 1, 1, 1),(29, 990, 1, 1, 2),(29, 991, 5, 1, 1),(29, 992, 5, 1, 2),(29, 993, 5, 1, 3),(29, 994, 5, 1, 4),(29, 995, 1, 1, 3),(29, 996, 1, 1, 4),(29, 997, 1, 1, 3),(29, 998, 1, 1, 4),(29, 999, 1, 1, 3),(29, 1000, 1, 1, 4),(29, 1001, 1, 1, 3),(29, 1002, 1, 1, 4),(29, 1003, 1, 1, 3),(29, 1004, 1, 1, 4),(29, 1005, 1, 1, 3),(29, 1006, 1, 1, 4),(29, 1007, 1, 1, 3),(29, 1008, 1, 1, 4),(29, 1009, 1, 1, 3),(29, 1010, 1, 1, 4),(29, 1011, 1, 1, 3),(29, 1012, 1, 1, 4),(29, 1013, 1, 1, 3),(29, 1014, 1, 1, 4),(29, 1015, 1, 1, 3),(29, 1016, 1, 1, 4),(29, 1017, 1, 1, 3),(29, 1018, 1, 1, 4),(29, 1019, 1, 1, 3),(29, 1020, 1, 1, 4),(29, 1021, 1, 1, 3),(29, 1022, 1, 1, 4),(29, 1023, 5, 1, 3),(29, 1024, 5, 1, 4),(29, 1025, 5, 1, 1),(29, 1026, 5, 1, 2),(29, 1027, 1, 1, 1),(29, 1028, 1, 1, 2),(29, 1029, 1, 1, 1),(29, 1030, 1, 1, 2),(29, 1031, 1, 1, 1),(29, 1032, 1, 1, 2),(29, 1033, 1, 1, 1),(29, 1034, 1, 1, 2),(29, 1035, 1, 1, 1),(29, 1036, 1, 1, 2),(29, 1037, 1, 1, 1),(29, 1038, 1, 1, 2),(29, 1039, 1, 1, 1),(29, 1040, 1, 1, 2),(29, 1041, 1, 1, 1),(29, 1042, 1, 1, 2),(29, 1043, 1, 1, 1),(29, 1044, 1, 1, 2),(29, 1045, 1, 1, 1),(29, 1046, 1, 1, 2),(29, 1047, 1, 1, 1),(29, 1048, 1, 1, 2),(29, 1049, 1, 1, 1),(29, 1050, 1, 1, 2),(29, 1051, 1, 1, 1),(29, 1052, 1, 1, 2),(29, 1053, 1, 1, 1),(29, 1054, 1, 1, 2),(29, 1055, 5, 1, 1),(29, 1056, 5, 1, 2),(29, 1057, 5, 1, 3),(29, 1058, 5, 1, 4),(29, 1059, 1, 1, 3),(29, 1060, 1, 1, 4),(29, 1061, 1, 1, 3),(29, 1062, 1, 1, 4),(29, 1063, 1, 1, 3),(29, 1064, 1, 1, 4),(29, 1065, 1, 1, 3),(29, 1066, 1, 1, 4),(29, 1067, 1, 1, 3),(29, 1068, 1, 1, 4),(29, 1069, 1, 1, 3),(29, 1070, 1, 1, 4),(29, 1071, 1, 1, 3),(29, 1072, 1, 1, 4),(29, 1073, 1, 1, 3),(29, 1074, 1, 1, 4),(29, 1075, 1, 1, 3),(29, 1076, 1, 1, 4),(29, 1077, 1, 1, 3),(29, 1078, 1, 1, 4),(29, 1079, 1, 1, 3),(29, 1080, 1, 1, 4),(29, 1081, 1, 1, 3),(29, 1082, 1, 1, 4),(29, 1083, 1, 1, 3),(29, 1084, 1, 1, 4),(29, 1085, 1, 1, 3),(29, 1086, 1, 1, 4),(29, 1087, 5, 1, 3),(29, 1088, 5, 1, 4),(29, 1089, 5, 1, 1),(29, 1090, 5, 1, 2),(29, 1091, 1, 1, 1),(29, 1092, 1, 1, 2),(29, 1093, 1, 1, 1),(29, 1094, 1, 1, 2),(29, 1095, 1, 1, 1),(29, 1096, 1, 1, 2),(29, 1097, 1, 1, 1),(29, 1098, 1, 1, 2),(29, 1099, 1, 1, 1),(29, 1100, 1, 1, 2),(29, 1101, 1, 1, 1),(29, 1102, 1, 1, 2),(29, 1103, 1, 1, 1),(29, 1104, 1, 1, 2),(29, 1105, 1, 1, 1),(29, 1106, 1, 1, 2),(29, 1107, 1, 1, 1),(29, 1108, 1, 1, 2),(29, 1109, 1, 1, 1),(29, 1110, 1, 1, 2),(29, 1111, 1, 1, 1),(29, 1112, 1, 1, 2),(29, 1113, 1, 1, 1),(29, 1114, 1, 1, 2),(29, 1115, 1, 1, 1),(29, 1116, 1, 1, 2),(29, 1117, 1, 1, 1),(29, 1118, 1, 1, 2),(29, 1119, 5, 1, 1),(29, 1120, 5, 1, 2),(29, 1121, 5, 1, 3),(29, 1122, 5, 1, 4),(29, 1123, 1, 1, 3),(29, 1124, 1, 1, 4),(29, 1125, 1, 1, 3),(29, 1126, 1, 1, 4),(29, 1127, 1, 1, 3),(29, 1128, 1, 1, 4),(29, 1129, 1, 1, 3),(29, 1130, 1, 1, 4),(29, 1131, 1, 1, 3),(29, 1132, 1, 1, 4),(29, 1133, 1, 1, 3),(29, 1134, 1, 1, 4),(29, 1135, 1, 1, 3),(29, 1136, 1, 1, 4),(29, 1137, 1, 1, 3),(29, 1138, 1, 1, 4),(29, 1139, 1, 1, 3),(29, 1140, 1, 1, 4),(29, 1141, 1, 1, 3),(29, 1142, 1, 1, 4),(29, 1143, 1, 1, 3),(29, 1144, 1, 1, 4),(29, 1145, 1, 1, 3),(29, 1146, 1, 1, 4),(29, 1147, 1, 1, 3),(29, 1148, 1, 1, 4),(29, 1149, 1, 1, 3),(29, 1150, 1, 1, 4),(29, 1151, 5, 1, 3),(29, 1152, 5, 1, 4),(29, 1153, 5, 1, 1),(29, 1154, 5, 1, 2),(29, 1155, 1, 1, 1),(29, 1156, 1, 1, 2),(29, 1157, 1, 1, 1),(29, 1158, 1, 1, 2),(29, 1159, 1, 1, 1),(29, 1160, 1, 1, 2),(29, 1161, 1, 1, 1),(29, 1162, 1, 1, 2),(29, 1163, 1, 1, 1),(29, 1164, 1, 1, 2),(29, 1165, 1, 1, 1),(29, 1166, 1, 1, 2),(29, 1167, 1, 1, 1),(29, 1168, 1, 1, 2),(29, 1169, 1, 1, 1),(29, 1170, 1, 1, 2),(29, 1171, 1, 1, 1),(29, 1172, 1, 1, 2),(29, 1173, 1, 1, 1),(29, 1174, 1, 1, 2),(29, 1175, 1, 1, 1),(29, 1176, 1, 1, 2),(29, 1177, 1, 1, 1),(29, 1178, 1, 1, 2),(29, 1179, 1, 1, 1),(29, 1180, 1, 1, 2),(29, 1181, 1, 1, 1),(29, 1182, 1, 1, 2),(29, 1183, 5, 1, 1),(29, 1184, 5, 1, 2),(29, 1185, 5, 1, 3),(29, 1186, 5, 1, 4),(29, 1187, 1, 1, 3),(29, 1188, 1, 1, 4),(29, 1189, 1, 1, 3),(29, 1190, 1, 1, 4),(29, 1191, 1, 1, 3),(29, 1192, 1, 1, 4),(29, 1193, 1, 1, 3),(29, 1194, 1, 1, 4),(29, 1195, 1, 1, 3),(29, 1196, 1, 1, 4),(29, 1197, 1, 1, 3),(29, 1198, 1, 1, 4),(29, 1199, 1, 1, 3),(29, 1200, 1, 1, 4),(29, 1201, 1, 1, 3),(29, 1202, 1, 1, 4),(29, 1203, 1, 1, 3),(29, 1204, 1, 1, 4),(29, 1205, 1, 1, 3),(29, 1206, 1, 1, 4),(29, 1207, 1, 1, 3),(29, 1208, 1, 1, 4),(29, 1209, 1, 1, 3),(29, 1210, 1, 1, 4),(29, 1211, 1, 1, 3),(29, 1212, 1, 1, 4),(29, 1213, 1, 1, 3),(29, 1214, 1, 1, 4),(29, 1215, 5, 1, 3),(29, 1216, 5, 1, 4),(29, 1217, 5, 1, 1),(29, 1218, 5, 1, 2),(29, 1219, 1, 1, 1),(29, 1220, 1, 1, 2),(29, 1221, 1, 1, 1),(29, 1222, 1, 1, 2),(29, 1223, 1, 1, 1),(29, 1224, 1, 1, 2),(29, 1225, 1, 1, 1),(29, 1226, 1, 1, 2),(29, 1227, 1, 1, 1),(29, 1228, 1, 1, 2),(29, 1229, 1, 1, 1),(29, 1230, 1, 1, 2),(29, 1231, 1, 1, 1),(29, 1232, 1, 1, 2),(29, 1233, 1, 1, 1),(29, 1234, 1, 1, 2),(29, 1235, 1, 1, 1),(29, 1236, 1, 1, 2),(29, 1237, 1, 1, 1),(29, 1238, 1, 1, 2),(29, 1239, 1, 1, 1),(29, 1240, 1, 1, 2),(29, 1241, 1, 1, 1),(29, 1242, 1, 1, 2),(29, 1243, 1, 1, 1),(29, 1244, 1, 1, 2),(29, 1245, 1, 1, 1),(29, 1246, 1, 1, 2),(29, 1247, 5, 1, 1),(29, 1248, 5, 1, 2),(29, 1249, 5, 1, 3),(29, 1250, 5, 1, 4),(29, 1251, 1, 1, 3),(29, 1252, 1, 1, 4),(29, 1253, 1, 1, 3),(29, 1254, 1, 1, 4),(29, 1255, 1, 1, 3),(29, 1256, 1, 1, 4),(29, 1257, 1, 1, 3),(29, 1258, 1, 1, 4),(29, 1259, 1, 1, 3),(29, 1260, 1, 1, 4),(29, 1261, 1, 1, 3),(29, 1262, 1, 1, 4),(29, 1263, 1, 1, 3),(29, 1264, 1, 1, 4),(29, 1265, 1, 1, 3),(29, 1266, 1, 1, 4),(29, 1267, 1, 1, 3),(29, 1268, 1, 1, 4),(29, 1269, 1, 1, 3),(29, 1270, 1, 1, 4),(29, 1271, 1, 1, 3),(29, 1272, 1, 1, 4),(29, 1273, 1, 1, 3),(29, 1274, 1, 1, 4),(29, 1275, 1, 1, 3),(29, 1276, 1, 1, 4),(29, 1277, 1, 1, 3),(29, 1278, 1, 1, 4),(29, 1279, 5, 1, 3),(29, 1280, 5, 1, 4),(29, 1281, 5, 1, 1),(29, 1282, 5, 1, 2),(29, 1283, 1, 1, 1),(29, 1284, 1, 1, 2),(29, 1285, 1, 1, 1),(29, 1286, 1, 1, 2),(29, 1287, 1, 1, 1),(29, 1288, 1, 1, 2),(29, 1289, 1, 1, 1),(29, 1290, 1, 1, 2),(29, 1291, 1, 1, 1),(29, 1292, 1, 1, 2),(29, 1293, 1, 1, 1),(29, 1294, 1, 1, 2),(29, 1295, 1, 1, 1),(29, 1296, 1, 1, 2),(29, 1297, 1, 1, 1),(29, 1298, 1, 1, 2),(29, 1299, 1, 1, 1),(29, 1300, 1, 1, 2),(29, 1301, 1, 1, 1),(29, 1302, 1, 1, 2),(29, 1303, 1, 1, 1),(29, 1304, 1, 1, 2),(29, 1305, 1, 1, 1),(29, 1306, 1, 1, 2),(29, 1307, 1, 1, 1),(29, 1308, 1, 1, 2),(29, 1309, 1, 1, 1),(29, 1310, 1, 1, 2),(29, 1311, 5, 1, 1),(29, 1312, 5, 1, 2),(29, 1313, 5, 1, 3),(29, 1314, 5, 1, 4),(29, 1315, 1, 1, 3),(29, 1316, 1, 1, 4),(29, 1317, 1, 1, 3),(29, 1318, 1, 1, 4),(29, 1319, 1, 1, 3),(29, 1320, 1, 1, 4),(29, 1321, 1, 1, 3),(29, 1322, 1, 1, 4),(29, 1323, 1, 1, 3),(29, 1324, 1, 1, 4),(29, 1325, 1, 1, 3),(29, 1326, 1, 1, 4),(29, 1327, 1, 1, 3),(29, 1328, 1, 1, 4),(29, 1329, 1, 1, 3),(29, 1330, 1, 1, 4),(29, 1331, 1, 1, 3),(29, 1332, 1, 1, 4),(29, 1333, 1, 1, 3),(29, 1334, 1, 1, 4),(29, 1335, 1, 1, 3),(29, 1336, 1, 1, 4),(29, 1337, 1, 1, 3),(29, 1338, 1, 1, 4),(29, 1339, 1, 1, 3),(29, 1340, 1, 1, 4),(29, 1341, 1, 1, 3),(29, 1342, 1, 1, 4),(29, 1343, 5, 1, 3),(29, 1344, 5, 1, 4),(29, 1345, 5, 1, 1),(29, 1346, 5, 1, 2),(29, 1347, 1, 1, 1),(29, 1348, 1, 1, 2),(29, 1349, 1, 1, 1),(29, 1350, 1, 1, 2),(29, 1351, 1, 1, 1),(29, 1352, 1, 1, 2),(29, 1353, 1, 1, 1),(29, 1354, 1, 1, 2),(29, 1355, 1, 1, 1),(29, 1356, 1, 1, 2),(29, 1357, 1, 1, 1),(29, 1358, 1, 1, 2),(29, 1359, 1, 1, 1),(29, 1360, 1, 1, 2),(29, 1361, 1, 1, 1),(29, 1362, 1, 1, 2),(29, 1363, 1, 1, 1),(29, 1364, 1, 1, 2),(29, 1365, 1, 1, 1),(29, 1366, 1, 1, 2),(29, 1367, 1, 1, 1),(29, 1368, 1, 1, 2),(29, 1369, 1, 1, 1),(29, 1370, 1, 1, 2),(29, 1371, 1, 1, 1),(29, 1372, 1, 1, 2),(29, 1373, 1, 1, 1),(29, 1374, 1, 1, 2),(29, 1375, 5, 1, 1),(29, 1376, 5, 1, 2),(29, 1377, 5, 1, 3),(29, 1378, 5, 1, 4),(29, 1379, 1, 1, 3),(29, 1380, 1, 1, 4),(29, 1381, 1, 1, 3),(29, 1382, 1, 1, 4),(29, 1383, 1, 1, 3),(29, 1384, 1, 1, 4),(29, 1385, 1, 1, 3),(29, 1386, 1, 1, 4),(29, 1387, 1, 1, 3),(29, 1388, 1, 1, 4),(29, 1389, 1, 1, 3),(29, 1390, 1, 1, 4),(29, 1391, 1, 1, 3),(29, 1392, 1, 1, 4),(29, 1393, 1, 1, 3),(29, 1394, 1, 1, 4),(29, 1395, 1, 1, 3),(29, 1396, 1, 1, 4),(29, 1397, 1, 1, 3),(29, 1398, 1, 1, 4),(29, 1399, 1, 1, 3),(29, 1400, 1, 1, 4),(29, 1401, 1, 1, 3),(29, 1402, 1, 1, 4),(29, 1403, 1, 1, 3),(29, 1404, 1, 1, 4),(29, 1405, 1, 1, 3),(29, 1406, 1, 1, 4),(29, 1407, 5, 1, 3),(29, 1408, 5, 1, 4),(29, 1409, 5, 1, 1),(29, 1410, 5, 1, 2),(29, 1411, 1, 1, 1),(29, 1412, 1, 1, 2),(29, 1413, 1, 1, 1),(29, 1414, 1, 1, 2),(29, 1415, 1, 1, 1),(29, 1416, 1, 1, 2),(29, 1417, 1, 1, 1),(29, 1418, 1, 1, 2),(29, 1419, 1, 1, 1),(29, 1420, 1, 1, 2),(29, 1421, 1, 1, 1),(29, 1422, 1, 1, 2),(29, 1423, 1, 1, 1),(29, 1424, 1, 1, 2),(29, 1425, 2, 1, 1),(29, 1426, 2, 1, 2),(29, 1427, 2, 1, 1),(29, 1428, 2, 1, 2),(29, 1429, 2, 1, 1),(29, 1430, 2, 1, 2),(29, 1431, 2, 1, 1),(29, 1432, 2, 1, 2),(29, 1433, 3, 1, 1),(29, 1434, 3, 1, 2),(29, 1435, 3, 1, 1),(29, 1436, 3, 1, 2),(29, 1437, 4, 1, 1),(29, 1438, 4, 1, 2),(29, 1439, 5, 1, 1),(29, 1440, 5, 1, 2),(29, 1441, 5, 1, 3),(29, 1442, 5, 1, 4),(29, 1443, 1, 1, 3),(29, 1444, 1, 1, 4),(29, 1445, 1, 1, 3),(29, 1446, 1, 1, 4),(29, 1447, 1, 1, 3),(29, 1448, 1, 1, 4),(29, 1449, 1, 1, 3),(29, 1450, 1, 1, 4),(29, 1451, 1, 1, 3),(29, 1452, 1, 1, 4),(29, 1453, 1, 1, 3),(29, 1454, 1, 1, 4),(29, 1455, 1, 1, 3),(29, 1456, 1, 1, 4),(29, 1457, 2, 1, 3),(29, 1458, 2, 1, 4),(29, 1459, 2, 1, 3),(29, 1460, 2, 1, 4),(29, 1461, 2, 1, 3),(29, 1462, 2, 1, 4),(29, 1463, 2, 1, 3),(29, 1464, 2, 1, 4),(29, 1465, 3, 1, 3),(29, 1466, 3, 1, 4),(29, 1467, 3, 1, 3),(29, 1468, 3, 1, 4),(29, 1469, 4, 1, 3),(29, 1470, 4, 1, 4),(29, 1471, 5, 1, 3),(29, 1472, 5, 1, 4),(29, 1473, 5, 1, 1),(29, 1474, 5, 1, 2),(29, 1475, 5, 1, 1),(29, 1476, 5, 1, 2),(29, 1477, 5, 1, 1),(29, 1478, 5, 1, 2),(29, 1479, 5, 1, 1),(29, 1480, 5, 1, 2),(29, 1481, 5, 1, 1),(29, 1482, 5, 1, 2),(29, 1483, 5, 1, 1),(29, 1484, 5, 1, 2),(29, 1485, 5, 1, 1),(29, 1486, 5, 1, 2),(29, 1487, 5, 1, 1),(29, 1488, 5, 1, 2),(29, 1489, 5, 1, 1),(29, 1490, 5, 1, 2),(29, 1491, 5, 1, 1),(29, 1492, 5, 1, 2),(29, 1493, 5, 1, 1),(29, 1494, 5, 1, 2),(29, 1495, 5, 1, 1),(29, 1496, 5, 1, 2),(29, 1497, 5, 1, 1),(29, 1498, 5, 1, 2),(29, 1499, 5, 1, 1),(29, 1500, 5, 1, 2),(29, 1501, 5, 1, 1),(29, 1502, 5, 1, 2),(29, 1503, 5, 1, 1),(29, 1504, 5, 1, 2),(29, 1505, 5, 1, 3),(29, 1506, 5, 1, 4),(29, 1507, 5, 1, 3),(29, 1508, 5, 1, 4),(29, 1509, 5, 1, 3),(29, 1510, 5, 1, 4),(29, 1511, 5, 1, 3),(29, 1512, 5, 1, 4),(29, 1513, 5, 1, 3),(29, 1514, 5, 1, 4),(29, 1515, 5, 1, 3),(29, 1516, 5, 1, 4),(29, 1517, 5, 1, 3),(29, 1518, 5, 1, 4),(29, 1519, 5, 1, 3),(29, 1520, 5, 1, 4),(29, 1521, 5, 1, 3),(29, 1522, 5, 1, 4),(29, 1523, 5, 1, 3),(29, 1524, 5, 1, 4),(29, 1525, 5, 1, 3),(29, 1526, 5, 1, 4),(29, 1527, 5, 1, 3),(29, 1528, 5, 1, 4),(29, 1529, 5, 1, 3),(29, 1530, 5, 1, 4),(29, 1531, 5, 1, 3),(29, 1532, 5, 1, 4),(29, 1533, 5, 1, 3),(29, 1534, 5, 1, 4),(29, 1535, 5, 1, 3),(29, 1536, 5, 1, 4),(30, 1, 5, 1, 1),(30, 2, 5, 1, 1),(30, 3, 5, 1, 1),(30, 4, 5, 1, 1),(30, 5, 5, 1, 1),(30, 6, 5, 1, 1),(30, 7, 5, 1, 1),(30, 8, 5, 1, 1),(30, 9, 5, 1, 1),(30, 10, 5, 1, 1),(30, 11, 5, 1, 1),(30, 12, 5, 1, 1),(30, 13, 5, 1, 1),(30, 14, 5, 1, 1),(30, 15, 5, 1, 1),(30, 16, 5, 1, 1),(30, 17, 5, 1, 1),(30, 18, 5, 1, 1),(30, 19, 5, 1, 1),(30, 20, 5, 1, 1),(30, 21, 5, 1, 1),(30, 22, 5, 1, 1),(30, 23, 5, 1, 1),(30, 24, 5, 1, 1),(30, 25, 5, 1, 1),(30, 26, 5, 1, 1),(30, 27, 5, 1, 1),(30, 28, 5, 1, 1),(30, 29, 5, 1, 1),(30, 30, 5, 1, 1),(30, 31, 5, 1, 1),(30, 32, 5, 1, 1),(30, 33, 5, 1, 2),(30, 34, 5, 1, 2),(30, 35, 5, 1, 2),(30, 36, 5, 1, 2),(30, 37, 5, 1, 2),(30, 38, 5, 1, 2),(30, 39, 5, 1, 2),(30, 40, 5, 1, 2),(30, 41, 5, 1, 2),(30, 42, 5, 1, 2),(30, 43, 5, 1, 2),(30, 44, 5, 1, 2),(30, 45, 5, 1, 2),(30, 46, 5, 1, 2),(30, 47, 5, 1, 2),(30, 48, 5, 1, 2),(30, 49, 5, 1, 2),(30, 50, 5, 1, 2),(30, 51, 5, 1, 2),(30, 52, 5, 1, 2),(30, 53, 5, 1, 2),(30, 54, 5, 1, 2),(30, 55, 5, 1, 2),(30, 56, 5, 1, 2),(30, 57, 5, 1, 2),(30, 58, 5, 1, 2),(30, 59, 5, 1, 2),(30, 60, 5, 1, 2),(30, 61, 5, 1, 2),(30, 62, 5, 1, 2),(30, 63, 5, 1, 2),(30, 64, 5, 1, 2),(30, 65, 5, 1, 1),(30, 66, 5, 1, 1),(30, 67, 1, 1, 1),(30, 68, 1, 1, 1),(30, 69, 1, 1, 1),(30, 70, 1, 1, 1),(30, 71, 1, 1, 1),(30, 72, 1, 1, 1),(30, 73, 1, 1, 1),(30, 74, 1, 1, 1),(30, 75, 1, 1, 1),(30, 76, 1, 1, 1),(30, 77, 1, 1, 1),(30, 78, 1, 1, 1),(30, 79, 1, 1, 1),(30, 80, 1, 1, 1),(30, 81, 1, 1, 1),(30, 82, 1, 1, 1),(30, 83, 1, 1, 1),(30, 84, 1, 1, 1),(30, 85, 1, 1, 1),(30, 86, 1, 1, 1),(30, 87, 1, 1, 1),(30, 88, 1, 1, 1),(30, 89, 1, 1, 1),(30, 90, 1, 1, 1),(30, 91, 1, 1, 1),(30, 92, 1, 1, 1),(30, 93, 1, 1, 1),(30, 94, 1, 1, 1),(30, 95, 5, 1, 1),(30, 96, 5, 1, 1),(30, 97, 5, 1, 2),(30, 98, 5, 1, 2),(30, 99, 1, 1, 2),(30, 100, 1, 1, 2),(30, 101, 1, 1, 2),(30, 102, 1, 1, 2),(30, 103, 1, 1, 2),(30, 104, 1, 1, 2),(30, 105, 1, 1, 2),(30, 106, 1, 1, 2),(30, 107, 1, 1, 2),(30, 108, 1, 1, 2),(30, 109, 1, 1, 2),(30, 110, 1, 1, 2),(30, 111, 1, 1, 2),(30, 112, 1, 1, 2),(30, 113, 1, 1, 2),(30, 114, 1, 1, 2),(30, 115, 1, 1, 2),(30, 116, 1, 1, 2),(30, 117, 1, 1, 2),(30, 118, 1, 1, 2),(30, 119, 1, 1, 2),(30, 120, 1, 1, 2),(30, 121, 1, 1, 2),(30, 122, 1, 1, 2),(30, 123, 1, 1, 2),(30, 124, 1, 1, 2),(30, 125, 1, 1, 2),(30, 126, 1, 1, 2),(30, 127, 5, 1, 2),(30, 128, 5, 1, 2),(30, 129, 5, 1, 1),(30, 130, 5, 1, 1),(30, 131, 1, 1, 1),(30, 132, 1, 1, 1),(30, 133, 1, 1, 1),(30, 134, 1, 1, 1),(30, 135, 1, 1, 1),(30, 136, 1, 1, 1),(30, 137, 1, 1, 1),(30, 138, 1, 1, 1),(30, 139, 1, 1, 1),(30, 140, 1, 1, 1),(30, 141, 1, 1, 1),(30, 142, 1, 1, 1),(30, 143, 1, 1, 1),(30, 144, 1, 1, 1),(30, 145, 1, 1, 1),(30, 146, 1, 1, 1),(30, 147, 1, 1, 1),(30, 148, 1, 1, 1),(30, 149, 1, 1, 1),(30, 150, 1, 1, 1),(30, 151, 1, 1, 1),(30, 152, 1, 1, 1),(30, 153, 1, 1, 1),(30, 154, 1, 1, 1),(30, 155, 1, 1, 1),(30, 156, 1, 1, 1),(30, 157, 1, 1, 1),(30, 158, 1, 1, 1),(30, 159, 5, 1, 1),(30, 160, 5, 1, 1),(30, 161, 5, 1, 2),(30, 162, 5, 1, 2),(30, 163, 1, 1, 2),(30, 164, 1, 1, 2),(30, 165, 1, 1, 2),(30, 166, 1, 1, 2),(30, 167, 1, 1, 2),(30, 168, 1, 1, 2),(30, 169, 1, 1, 2),(30, 170, 1, 1, 2),(30, 171, 1, 1, 2),(30, 172, 1, 1, 2),(30, 173, 1, 1, 2),(30, 174, 1, 1, 2),(30, 175, 1, 1, 2),(30, 176, 1, 1, 2),(30, 177, 1, 1, 2),(30, 178, 1, 1, 2),(30, 179, 1, 1, 2),(30, 180, 1, 1, 2),(30, 181, 1, 1, 2),(30, 182, 1, 1, 2),(30, 183, 1, 1, 2),(30, 184, 1, 1, 2),(30, 185, 1, 1, 2),(30, 186, 1, 1, 2),(30, 187, 1, 1, 2),(30, 188, 1, 1, 2),(30, 189, 1, 1, 2),(30, 190, 1, 1, 2),(30, 191, 5, 1, 2),(30, 192, 5, 1, 2),(30, 193, 5, 1, 1),(30, 194, 5, 1, 1),(30, 195, 1, 1, 1),(30, 196, 1, 1, 1),(30, 197, 1, 1, 1),(30, 198, 1, 1, 1),(30, 199, 1, 1, 1),(30, 200, 1, 1, 1),(30, 201, 1, 1, 1),(30, 202, 1, 1, 1),(30, 203, 1, 1, 1),(30, 204, 1, 1, 1),(30, 205, 1, 1, 1),(30, 206, 1, 1, 1),(30, 207, 1, 1, 1),(30, 208, 1, 1, 1),(30, 209, 1, 1, 1),(30, 210, 1, 1, 1),(30, 211, 1, 1, 1),(30, 212, 1, 1, 1),(30, 213, 1, 1, 1),(30, 214, 1, 1, 1),(30, 215, 1, 1, 1),(30, 216, 1, 1, 1),(30, 217, 1, 1, 1),(30, 218, 1, 1, 1),(30, 219, 1, 1, 1),(30, 220, 1, 1, 1),(30, 221, 1, 1, 1),(30, 222, 1, 1, 1),(30, 223, 5, 1, 1),(30, 224, 5, 1, 1),(30, 225, 5, 1, 2),(30, 226, 5, 1, 2),(30, 227, 1, 1, 2),(30, 228, 1, 1, 2),(30, 229, 1, 1, 2),(30, 230, 1, 1, 2),(30, 231, 1, 1, 2),(30, 232, 1, 1, 2),(30, 233, 1, 1, 2),(30, 234, 1, 1, 2),(30, 235, 1, 1, 2),(30, 236, 1, 1, 2),(30, 237, 1, 1, 2),(30, 238, 1, 1, 2),(30, 239, 1, 1, 2),(30, 240, 1, 1, 2),(30, 241, 1, 1, 2),(30, 242, 1, 1, 2),(30, 243, 1, 1, 2),(30, 244, 1, 1, 2),(30, 245, 1, 1, 2),(30, 246, 1, 1, 2),(30, 247, 1, 1, 2),(30, 248, 1, 1, 2),(30, 249, 1, 1, 2),(30, 250, 1, 1, 2),(30, 251, 1, 1, 2),(30, 252, 1, 1, 2),(30, 253, 1, 1, 2),(30, 254, 1, 1, 2),(30, 255, 5, 1, 2),(30, 256, 5, 1, 2),(30, 257, 5, 1, 1),(30, 258, 5, 1, 1),(30, 259, 1, 1, 1),(30, 260, 1, 1, 1),(30, 261, 1, 1, 1),(30, 262, 1, 1, 1),(30, 263, 1, 1, 1),(30, 264, 1, 1, 1),(30, 265, 1, 1, 1),(30, 266, 1, 1, 1),(30, 267, 1, 1, 1),(30, 268, 1, 1, 1),(30, 269, 1, 1, 1),(30, 270, 1, 1, 1),(30, 271, 1, 1, 1),(30, 272, 1, 1, 1),(30, 273, 1, 1, 1),(30, 274, 1, 1, 1),(30, 275, 1, 1, 1),(30, 276, 1, 1, 1),(30, 277, 1, 1, 1),(30, 278, 1, 1, 1),(30, 279, 1, 1, 1),(30, 280, 1, 1, 1),(30, 281, 1, 1, 1),(30, 282, 1, 1, 1),(30, 283, 1, 1, 1),(30, 284, 1, 1, 1),(30, 285, 1, 1, 1),(30, 286, 1, 1, 1),(30, 287, 5, 1, 1),(30, 288, 5, 1, 1),(30, 289, 5, 1, 2),(30, 290, 5, 1, 2),(30, 291, 1, 1, 2),(30, 292, 1, 1, 2),(30, 293, 1, 1, 2),(30, 294, 1, 1, 2),(30, 295, 1, 1, 2),(30, 296, 1, 1, 2),(30, 297, 1, 1, 2),(30, 298, 1, 1, 2),(30, 299, 1, 1, 2),(30, 300, 1, 1, 2),(30, 301, 1, 1, 2),(30, 302, 1, 1, 2),(30, 303, 1, 1, 2),(30, 304, 1, 1, 2),(30, 305, 1, 1, 2),(30, 306, 1, 1, 2),(30, 307, 1, 1, 2),(30, 308, 1, 1, 2),(30, 309, 1, 1, 2),(30, 310, 1, 1, 2),(30, 311, 1, 1, 2),(30, 312, 1, 1, 2),(30, 313, 1, 1, 2),(30, 314, 1, 1, 2),(30, 315, 1, 1, 2),(30, 316, 1, 1, 2),(30, 317, 1, 1, 2),(30, 318, 1, 1, 2),(30, 319, 5, 1, 2),(30, 320, 5, 1, 2),(30, 321, 5, 1, 1),(30, 322, 5, 1, 1),(30, 323, 1, 1, 1),(30, 324, 1, 1, 1),(30, 325, 1, 1, 1),(30, 326, 1, 1, 1),(30, 327, 1, 1, 1),(30, 328, 1, 1, 1),(30, 329, 1, 1, 1),(30, 330, 1, 1, 1),(30, 331, 1, 1, 1),(30, 332, 1, 1, 1),(30, 333, 1, 1, 1),(30, 334, 1, 1, 1),(30, 335, 1, 1, 1),(30, 336, 1, 1, 1),(30, 337, 1, 1, 1),(30, 338, 1, 1, 1),(30, 339, 1, 1, 1),(30, 340, 1, 1, 1),(30, 341, 1, 1, 1),(30, 342, 1, 1, 1),(30, 343, 1, 1, 1),(30, 344, 1, 1, 1),(30, 345, 1, 1, 1),(30, 346, 1, 1, 1),(30, 347, 1, 1, 1),(30, 348, 1, 1, 1),(30, 349, 1, 1, 1),(30, 350, 1, 1, 1),(30, 351, 5, 1, 1),(30, 352, 5, 1, 1),(30, 353, 5, 1, 2),(30, 354, 5, 1, 2),(30, 355, 1, 1, 2),(30, 356, 1, 1, 2),(30, 357, 1, 1, 2),(30, 358, 1, 1, 2),(30, 359, 1, 1, 2),(30, 360, 1, 1, 2),(30, 361, 1, 1, 2),(30, 362, 1, 1, 2),(30, 363, 1, 1, 2),(30, 364, 1, 1, 2),(30, 365, 1, 1, 2),(30, 366, 1, 1, 2),(30, 367, 1, 1, 2),(30, 368, 1, 1, 2),(30, 369, 1, 1, 2),(30, 370, 1, 1, 2),(30, 371, 1, 1, 2),(30, 372, 1, 1, 2),(30, 373, 1, 1, 2),(30, 374, 1, 1, 2),(30, 375, 1, 1, 2),(30, 376, 1, 1, 2),(30, 377, 1, 1, 2),(30, 378, 1, 1, 2),(30, 379, 1, 1, 2),(30, 380, 1, 1, 2),(30, 381, 1, 1, 2),(30, 382, 1, 1, 2),(30, 383, 5, 1, 2),(30, 384, 5, 1, 2),(30, 385, 5, 1, 1),(30, 386, 5, 1, 1),(30, 387, 1, 1, 1),(30, 388, 1, 1, 1),(30, 389, 1, 1, 1),(30, 390, 1, 1, 1),(30, 391, 1, 1, 1),(30, 392, 1, 1, 1),(30, 393, 1, 1, 1),(30, 394, 1, 1, 1),(30, 395, 1, 1, 1),(30, 396, 1, 1, 1),(30, 397, 1, 1, 1),(30, 398, 1, 1, 1),(30, 399, 1, 1, 1),(30, 400, 1, 1, 1),(30, 401, 1, 1, 1),(30, 402, 1, 1, 1),(30, 403, 1, 1, 1),(30, 404, 1, 1, 1),(30, 405, 1, 1, 1),(30, 406, 1, 1, 1),(30, 407, 1, 1, 1),(30, 408, 1, 1, 1),(30, 409, 1, 1, 1),(30, 410, 1, 1, 1),(30, 411, 1, 1, 1),(30, 412, 1, 1, 1),(30, 413, 1, 1, 1),(30, 414, 1, 1, 1),(30, 415, 5, 1, 1),(30, 416, 5, 1, 1),(30, 417, 5, 1, 2),(30, 418, 5, 1, 2),(30, 419, 1, 1, 2),(30, 420, 1, 1, 2),(30, 421, 1, 1, 2),(30, 422, 1, 1, 2),(30, 423, 1, 1, 2),(30, 424, 1, 1, 2),(30, 425, 1, 1, 2),(30, 426, 1, 1, 2),(30, 427, 1, 1, 2),(30, 428, 1, 1, 2),(30, 429, 1, 1, 2),(30, 430, 1, 1, 2),(30, 431, 1, 1, 2),(30, 432, 1, 1, 2),(30, 433, 1, 1, 2),(30, 434, 1, 1, 2),(30, 435, 1, 1, 2),(30, 436, 1, 1, 2),(30, 437, 1, 1, 2),(30, 438, 1, 1, 2),(30, 439, 1, 1, 2),(30, 440, 1, 1, 2),(30, 441, 1, 1, 2),(30, 442, 1, 1, 2),(30, 443, 1, 1, 2),(30, 444, 1, 1, 2),(30, 445, 1, 1, 2),(30, 446, 1, 1, 2),(30, 447, 5, 1, 2),(30, 448, 5, 1, 2),(30, 449, 5, 1, 1),(30, 450, 5, 1, 1),(30, 451, 1, 1, 1),(30, 452, 1, 1, 1),(30, 453, 1, 1, 1),(30, 454, 1, 1, 1),(30, 455, 1, 1, 1),(30, 456, 1, 1, 1),(30, 457, 1, 1, 1),(30, 458, 1, 1, 1),(30, 459, 1, 1, 1),(30, 460, 1, 1, 1),(30, 461, 1, 1, 1),(30, 462, 1, 1, 1),(30, 463, 1, 1, 1),(30, 464, 1, 1, 1),(30, 465, 1, 1, 1),(30, 466, 1, 1, 1),(30, 467, 1, 1, 1),(30, 468, 1, 1, 1),(30, 469, 1, 1, 1),(30, 470, 1, 1, 1),(30, 471, 1, 1, 1),(30, 472, 1, 1, 1),(30, 473, 1, 1, 1),(30, 474, 1, 1, 1),(30, 475, 1, 1, 1),(30, 476, 1, 1, 1),(30, 477, 1, 1, 1),(30, 478, 1, 1, 1),(30, 479, 5, 1, 1),(30, 480, 5, 1, 1),(30, 481, 5, 1, 2),(30, 482, 5, 1, 2),(30, 483, 1, 1, 2),(30, 484, 1, 1, 2),(30, 485, 1, 1, 2),(30, 486, 1, 1, 2),(30, 487, 1, 1, 2),(30, 488, 1, 1, 2),(30, 489, 1, 1, 2),(30, 490, 1, 1, 2),(30, 491, 1, 1, 2),(30, 492, 1, 1, 2),(30, 493, 1, 1, 2),(30, 494, 1, 1, 2),(30, 495, 1, 1, 2),(30, 496, 1, 1, 2),(30, 497, 1, 1, 2),(30, 498, 1, 1, 2),(30, 499, 1, 1, 2),(30, 500, 1, 1, 2),(30, 501, 1, 1, 2),(30, 502, 1, 1, 2),(30, 503, 1, 1, 2),(30, 504, 1, 1, 2),(30, 505, 1, 1, 2),(30, 506, 1, 1, 2),(30, 507, 1, 1, 2),(30, 508, 1, 1, 2),(30, 509, 1, 1, 2),(30, 510, 1, 1, 2),(30, 511, 5, 1, 2),(30, 512, 5, 1, 2),(30, 513, 5, 1, 1),(30, 514, 5, 1, 1),(30, 515, 1, 1, 1),(30, 516, 1, 1, 1),(30, 517, 1, 1, 1),(30, 518, 1, 1, 1),(30, 519, 1, 1, 1),(30, 520, 1, 1, 1),(30, 521, 1, 1, 1),(30, 522, 1, 1, 1),(30, 523, 1, 1, 1),(30, 524, 1, 1, 1),(30, 525, 1, 1, 1),(30, 526, 1, 1, 1),(30, 527, 1, 1, 1),(30, 528, 1, 1, 1),(30, 529, 1, 1, 1),(30, 530, 1, 1, 1),(30, 531, 1, 1, 1),(30, 532, 1, 1, 1),(30, 533, 1, 1, 1),(30, 534, 1, 1, 1),(30, 535, 1, 1, 1),(30, 536, 1, 1, 1),(30, 537, 1, 1, 1),(30, 538, 1, 1, 1),(30, 539, 1, 1, 1),(30, 540, 1, 1, 1),(30, 541, 1, 1, 1),(30, 542, 1, 1, 1),(30, 543, 5, 1, 1),(30, 544, 5, 1, 1),(30, 545, 5, 1, 2),(30, 546, 5, 1, 2),(30, 547, 1, 1, 2),(30, 548, 1, 1, 2),(30, 549, 1, 1, 2),(30, 550, 1, 1, 2),(30, 551, 1, 1, 2),(30, 552, 1, 1, 2),(30, 553, 1, 1, 2),(30, 554, 1, 1, 2),(30, 555, 1, 1, 2),(30, 556, 1, 1, 2),(30, 557, 1, 1, 2),(30, 558, 1, 1, 2),(30, 559, 1, 1, 2),(30, 560, 1, 1, 2),(30, 561, 1, 1, 2),(30, 562, 1, 1, 2),(30, 563, 1, 1, 2),(30, 564, 1, 1, 2),(30, 565, 1, 1, 2),(30, 566, 1, 1, 2),(30, 567, 1, 1, 2),(30, 568, 1, 1, 2),(30, 569, 1, 1, 2),(30, 570, 1, 1, 2),(30, 571, 1, 1, 2),(30, 572, 1, 1, 2),(30, 573, 1, 1, 2),(30, 574, 1, 1, 2),(30, 575, 5, 1, 2),(30, 576, 5, 1, 2),(30, 577, 5, 1, 1),(30, 578, 5, 1, 1),(30, 579, 1, 1, 1),(30, 580, 1, 1, 1),(30, 581, 1, 1, 1),(30, 582, 1, 1, 1),(30, 583, 1, 1, 1),(30, 584, 1, 1, 1),(30, 585, 1, 1, 1),(30, 586, 1, 1, 1),(30, 587, 1, 1, 1),(30, 588, 1, 1, 1),(30, 589, 1, 1, 1),(30, 590, 1, 1, 1),(30, 591, 1, 1, 1),(30, 592, 1, 1, 1),(30, 593, 1, 1, 1),(30, 594, 1, 1, 1),(30, 595, 1, 1, 1),(30, 596, 1, 1, 1),(30, 597, 1, 1, 1),(30, 598, 1, 1, 1),(30, 599, 1, 1, 1),(30, 600, 1, 1, 1),(30, 601, 1, 1, 1),(30, 602, 1, 1, 1),(30, 603, 1, 1, 1),(30, 604, 1, 1, 1),(30, 605, 1, 1, 1),(30, 606, 1, 1, 1),(30, 607, 5, 1, 1),(30, 608, 5, 1, 1),(30, 609, 5, 1, 2),(30, 610, 5, 1, 2),(30, 611, 1, 1, 2),(30, 612, 1, 1, 2),(30, 613, 1, 1, 2),(30, 614, 1, 1, 2),(30, 615, 1, 1, 2),(30, 616, 1, 1, 2),(30, 617, 1, 1, 2),(30, 618, 1, 1, 2),(30, 619, 1, 1, 2),(30, 620, 1, 1, 2),(30, 621, 1, 1, 2),(30, 622, 1, 1, 2),(30, 623, 1, 1, 2),(30, 624, 1, 1, 2),(30, 625, 1, 1, 2),(30, 626, 1, 1, 2),(30, 627, 1, 1, 2),(30, 628, 1, 1, 2),(30, 629, 1, 1, 2),(30, 630, 1, 1, 2),(30, 631, 1, 1, 2),(30, 632, 1, 1, 2),(30, 633, 1, 1, 2),(30, 634, 1, 1, 2),(30, 635, 1, 1, 2),(30, 636, 1, 1, 2),(30, 637, 1, 1, 2),(30, 638, 1, 1, 2),(30, 639, 5, 1, 2),(30, 640, 5, 1, 2),(30, 641, 5, 1, 1),(30, 642, 5, 1, 1),(30, 643, 1, 1, 1),(30, 644, 1, 1, 1),(30, 645, 1, 1, 1),(30, 646, 1, 1, 1),(30, 647, 1, 1, 1),(30, 648, 1, 1, 1),(30, 649, 1, 1, 1),(30, 650, 1, 1, 1),(30, 651, 1, 1, 1),(30, 652, 1, 1, 1),(30, 653, 1, 1, 1),(30, 654, 1, 1, 1),(30, 655, 1, 1, 1),(30, 656, 1, 1, 1),(30, 657, 1, 1, 1),(30, 658, 1, 1, 1),(30, 659, 1, 1, 1),(30, 660, 1, 1, 1),(30, 661, 1, 1, 1),(30, 662, 1, 1, 1),(30, 663, 1, 1, 1),(30, 664, 1, 1, 1),(30, 665, 1, 1, 1),(30, 666, 1, 1, 1),(30, 667, 1, 1, 1),(30, 668, 1, 1, 1),(30, 669, 1, 1, 1),(30, 670, 1, 1, 1),(30, 671, 5, 1, 1),(30, 672, 5, 1, 1),(30, 673, 5, 1, 2),(30, 674, 5, 1, 2),(30, 675, 1, 1, 2),(30, 676, 1, 1, 2),(30, 677, 1, 1, 2),(30, 678, 1, 1, 2),(30, 679, 1, 1, 2),(30, 680, 1, 1, 2),(30, 681, 1, 1, 2),(30, 682, 1, 1, 2),(30, 683, 1, 1, 2),(30, 684, 1, 1, 2),(30, 685, 1, 1, 2),(30, 686, 1, 1, 2),(30, 687, 1, 1, 2),(30, 688, 1, 1, 2),(30, 689, 1, 1, 2),(30, 690, 1, 1, 2),(30, 691, 1, 1, 2),(30, 692, 1, 1, 2),(30, 693, 1, 1, 2),(30, 694, 1, 1, 2),(30, 695, 1, 1, 2),(30, 696, 1, 1, 2),(30, 697, 1, 1, 2),(30, 698, 1, 1, 2),(30, 699, 1, 1, 2),(30, 700, 1, 1, 2),(30, 701, 1, 1, 2),(30, 702, 1, 1, 2),(30, 703, 5, 1, 2),(30, 704, 5, 1, 2),(30, 705, 5, 1, 1),(30, 706, 5, 1, 1),(30, 707, 1, 1, 1),(30, 708, 1, 1, 1),(30, 709, 1, 1, 1),(30, 710, 1, 1, 1),(30, 711, 1, 1, 1),(30, 712, 1, 1, 1),(30, 713, 1, 1, 1),(30, 714, 1, 1, 1),(30, 715, 1, 1, 1),(30, 716, 1, 1, 1),(30, 717, 1, 1, 1),(30, 718, 1, 1, 1),(30, 719, 1, 1, 1),(30, 720, 1, 1, 1),(30, 721, 1, 1, 1),(30, 722, 1, 1, 1),(30, 723, 1, 1, 1),(30, 724, 1, 1, 1),(30, 725, 1, 1, 1),(30, 726, 1, 1, 1),(30, 727, 1, 1, 1),(30, 728, 1, 1, 1),(30, 729, 1, 1, 1),(30, 730, 1, 1, 1),(30, 731, 1, 1, 1),(30, 732, 1, 1, 1),(30, 733, 1, 1, 1),(30, 734, 1, 1, 1),(30, 735, 5, 1, 1),(30, 736, 5, 1, 1),(30, 737, 5, 1, 2),(30, 738, 5, 1, 2),(30, 739, 1, 1, 2),(30, 740, 1, 1, 2),(30, 741, 1, 1, 2),(30, 742, 1, 1, 2),(30, 743, 1, 1, 2),(30, 744, 1, 1, 2),(30, 745, 1, 1, 2),(30, 746, 1, 1, 2),(30, 747, 1, 1, 2),(30, 748, 1, 1, 2),(30, 749, 1, 1, 2),(30, 750, 1, 1, 2),(30, 751, 1, 1, 2),(30, 752, 1, 1, 2),(30, 753, 1, 1, 2),(30, 754, 1, 1, 2),(30, 755, 1, 1, 2),(30, 756, 1, 1, 2),(30, 757, 1, 1, 2),(30, 758, 1, 1, 2),(30, 759, 1, 1, 2),(30, 760, 1, 1, 2),(30, 761, 1, 1, 2),(30, 762, 1, 1, 2),(30, 763, 1, 1, 2),(30, 764, 1, 1, 2),(30, 765, 1, 1, 2),(30, 766, 1, 1, 2),(30, 767, 5, 1, 2),(30, 768, 5, 1, 2),(30, 769, 5, 1, 1),(30, 770, 5, 1, 1),(30, 771, 1, 1, 1),(30, 772, 1, 1, 1),(30, 773, 1, 1, 1),(30, 774, 1, 1, 1),(30, 775, 1, 1, 1),(30, 776, 1, 1, 1),(30, 777, 1, 1, 1),(30, 778, 1, 1, 1),(30, 779, 1, 1, 1),(30, 780, 1, 1, 1),(30, 781, 1, 1, 1),(30, 782, 1, 1, 1),(30, 783, 1, 1, 1),(30, 784, 1, 1, 1),(30, 785, 1, 1, 1),(30, 786, 1, 1, 1),(30, 787, 1, 1, 1),(30, 788, 1, 1, 1),(30, 789, 1, 1, 1),(30, 790, 1, 1, 1),(30, 791, 1, 1, 1),(30, 792, 1, 1, 1),(30, 793, 1, 1, 1),(30, 794, 1, 1, 1),(30, 795, 1, 1, 1),(30, 796, 1, 1, 1),(30, 797, 1, 1, 1),(30, 798, 1, 1, 1),(30, 799, 5, 1, 1),(30, 800, 5, 1, 1),(30, 801, 5, 1, 2),(30, 802, 5, 1, 2),(30, 803, 1, 1, 2),(30, 804, 1, 1, 2),(30, 805, 1, 1, 2),(30, 806, 1, 1, 2),(30, 807, 1, 1, 2),(30, 808, 1, 1, 2),(30, 809, 1, 1, 2),(30, 810, 1, 1, 2),(30, 811, 1, 1, 2),(30, 812, 1, 1, 2),(30, 813, 1, 1, 2),(30, 814, 1, 1, 2),(30, 815, 1, 1, 2),(30, 816, 1, 1, 2),(30, 817, 1, 1, 2),(30, 818, 1, 1, 2),(30, 819, 1, 1, 2),(30, 820, 1, 1, 2),(30, 821, 1, 1, 2),(30, 822, 1, 1, 2),(30, 823, 1, 1, 2),(30, 824, 1, 1, 2),(30, 825, 1, 1, 2),(30, 826, 1, 1, 2),(30, 827, 1, 1, 2),(30, 828, 1, 1, 2),(30, 829, 1, 1, 2),(30, 830, 1, 1, 2),(30, 831, 5, 1, 2),(30, 832, 5, 1, 2),(30, 833, 5, 1, 1),(30, 834, 5, 1, 1),(30, 835, 1, 1, 1),(30, 836, 1, 1, 1),(30, 837, 1, 1, 1),(30, 838, 1, 1, 1),(30, 839, 1, 1, 1),(30, 840, 1, 1, 1),(30, 841, 1, 1, 1),(30, 842, 1, 1, 1),(30, 843, 1, 1, 1),(30, 844, 1, 1, 1),(30, 845, 1, 1, 1),(30, 846, 1, 1, 1),(30, 847, 1, 1, 1),(30, 848, 1, 1, 1),(30, 849, 1, 1, 1),(30, 850, 1, 1, 1),(30, 851, 1, 1, 1),(30, 852, 1, 1, 1),(30, 853, 1, 1, 1),(30, 854, 1, 1, 1),(30, 855, 1, 1, 1),(30, 856, 1, 1, 1),(30, 857, 1, 1, 1),(30, 858, 1, 1, 1),(30, 859, 1, 1, 1),(30, 860, 1, 1, 1),(30, 861, 1, 1, 1),(30, 862, 1, 1, 1),(30, 863, 5, 1, 1),(30, 864, 5, 1, 1),(30, 865, 5, 1, 2),(30, 866, 5, 1, 2),(30, 867, 1, 1, 2),(30, 868, 1, 1, 2),(30, 869, 1, 1, 2),(30, 870, 1, 1, 2),(30, 871, 1, 1, 2),(30, 872, 1, 1, 2),(30, 873, 1, 1, 2),(30, 874, 1, 1, 2),(30, 875, 1, 1, 2),(30, 876, 1, 1, 2),(30, 877, 1, 1, 2),(30, 878, 1, 1, 2),(30, 879, 1, 1, 2),(30, 880, 1, 1, 2),(30, 881, 1, 1, 2),(30, 882, 1, 1, 2),(30, 883, 1, 1, 2),(30, 884, 1, 1, 2),(30, 885, 1, 1, 2),(30, 886, 1, 1, 2),(30, 887, 1, 1, 2),(30, 888, 1, 1, 2),(30, 889, 1, 1, 2),(30, 890, 1, 1, 2),(30, 891, 1, 1, 2),(30, 892, 1, 1, 2),(30, 893, 1, 1, 2),(30, 894, 1, 1, 2),(30, 895, 5, 1, 2),(30, 896, 5, 1, 2),(30, 897, 5, 1, 1),(30, 898, 5, 1, 1),(30, 899, 1, 1, 1),(30, 900, 1, 1, 1),(30, 901, 1, 1, 1),(30, 902, 1, 1, 1),(30, 903, 1, 1, 1),(30, 904, 1, 1, 1),(30, 905, 1, 1, 1),(30, 906, 1, 1, 1),(30, 907, 1, 1, 1),(30, 908, 1, 1, 1),(30, 909, 1, 1, 1),(30, 910, 1, 1, 1),(30, 911, 1, 1, 1),(30, 912, 1, 1, 1),(30, 913, 1, 1, 1),(30, 914, 1, 1, 1),(30, 915, 1, 1, 1),(30, 916, 1, 1, 1),(30, 917, 1, 1, 1),(30, 918, 1, 1, 1),(30, 919, 1, 1, 1),(30, 920, 1, 1, 1),(30, 921, 1, 1, 1),(30, 922, 1, 1, 1),(30, 923, 1, 1, 1),(30, 924, 1, 1, 1),(30, 925, 1, 1, 1),(30, 926, 1, 1, 1),(30, 927, 5, 1, 1),(30, 928, 5, 1, 1),(30, 929, 5, 1, 2),(30, 930, 5, 1, 2),(30, 931, 1, 1, 2),(30, 932, 1, 1, 2),(30, 933, 1, 1, 2),(30, 934, 1, 1, 2),(30, 935, 1, 1, 2),(30, 936, 1, 1, 2),(30, 937, 1, 1, 2),(30, 938, 1, 1, 2),(30, 939, 1, 1, 2),(30, 940, 1, 1, 2),(30, 941, 1, 1, 2),(30, 942, 1, 1, 2),(30, 943, 1, 1, 2),(30, 944, 1, 1, 2),(30, 945, 1, 1, 2),(30, 946, 1, 1, 2),(30, 947, 1, 1, 2),(30, 948, 1, 1, 2),(30, 949, 1, 1, 2),(30, 950, 1, 1, 2),(30, 951, 1, 1, 2),(30, 952, 1, 1, 2),(30, 953, 1, 1, 2),(30, 954, 1, 1, 2),(30, 955, 1, 1, 2),(30, 956, 1, 1, 2),(30, 957, 1, 1, 2),(30, 958, 1, 1, 2),(30, 959, 5, 1, 2),(30, 960, 5, 1, 2),(30, 961, 5, 1, 1),(30, 962, 5, 1, 1),(30, 963, 1, 1, 1),(30, 964, 1, 1, 1),(30, 965, 1, 1, 1),(30, 966, 1, 1, 1),(30, 967, 1, 1, 1),(30, 968, 1, 1, 1),(30, 969, 1, 1, 1),(30, 970, 1, 1, 1),(30, 971, 1, 1, 1),(30, 972, 1, 1, 1),(30, 973, 1, 1, 1),(30, 974, 1, 1, 1),(30, 975, 1, 1, 1),(30, 976, 1, 1, 1),(30, 977, 1, 1, 1),(30, 978, 1, 1, 1),(30, 979, 1, 1, 1),(30, 980, 1, 1, 1),(30, 981, 1, 1, 1),(30, 982, 1, 1, 1),(30, 983, 1, 1, 1),(30, 984, 1, 1, 1),(30, 985, 1, 1, 1),(30, 986, 1, 1, 1),(30, 987, 1, 1, 1),(30, 988, 1, 1, 1),(30, 989, 1, 1, 1),(30, 990, 1, 1, 1),(30, 991, 5, 1, 1),(30, 992, 5, 1, 1),(30, 993, 5, 1, 2),(30, 994, 5, 1, 2),(30, 995, 1, 1, 2),(30, 996, 1, 1, 2),(30, 997, 1, 1, 2),(30, 998, 1, 1, 2),(30, 999, 1, 1, 2),(30, 1000, 1, 1, 2),(30, 1001, 1, 1, 2),(30, 1002, 1, 1, 2),(30, 1003, 1, 1, 2),(30, 1004, 1, 1, 2),(30, 1005, 1, 1, 2),(30, 1006, 1, 1, 2),(30, 1007, 1, 1, 2),(30, 1008, 1, 1, 2),(30, 1009, 1, 1, 2),(30, 1010, 1, 1, 2),(30, 1011, 1, 1, 2),(30, 1012, 1, 1, 2),(30, 1013, 1, 1, 2),(30, 1014, 1, 1, 2),(30, 1015, 1, 1, 2),(30, 1016, 1, 1, 2),(30, 1017, 1, 1, 2),(30, 1018, 1, 1, 2),(30, 1019, 1, 1, 2),(30, 1020, 1, 1, 2),(30, 1021, 1, 1, 2),(30, 1022, 1, 1, 2),(30, 1023, 5, 1, 2),(30, 1024, 5, 1, 2),(30, 1025, 5, 1, 1),(30, 1026, 5, 1, 1),(30, 1027, 1, 1, 1),(30, 1028, 1, 1, 1),(30, 1029, 1, 1, 1),(30, 1030, 1, 1, 1),(30, 1031, 1, 1, 1),(30, 1032, 1, 1, 1),(30, 1033, 1, 1, 1),(30, 1034, 1, 1, 1),(30, 1035, 1, 1, 1),(30, 1036, 1, 1, 1),(30, 1037, 1, 1, 1),(30, 1038, 1, 1, 1),(30, 1039, 1, 1, 1),(30, 1040, 1, 1, 1),(30, 1041, 1, 1, 1),(30, 1042, 1, 1, 1),(30, 1043, 1, 1, 1),(30, 1044, 1, 1, 1),(30, 1045, 1, 1, 1),(30, 1046, 1, 1, 1),(30, 1047, 1, 1, 1),(30, 1048, 1, 1, 1),(30, 1049, 1, 1, 1),(30, 1050, 1, 1, 1),(30, 1051, 1, 1, 1),(30, 1052, 1, 1, 1),(30, 1053, 1, 1, 1),(30, 1054, 1, 1, 1),(30, 1055, 5, 1, 1),(30, 1056, 5, 1, 1),(30, 1057, 5, 1, 2),(30, 1058, 5, 1, 2),(30, 1059, 1, 1, 2),(30, 1060, 1, 1, 2),(30, 1061, 1, 1, 2),(30, 1062, 1, 1, 2),(30, 1063, 1, 1, 2),(30, 1064, 1, 1, 2),(30, 1065, 1, 1, 2),(30, 1066, 1, 1, 2),(30, 1067, 1, 1, 2),(30, 1068, 1, 1, 2),(30, 1069, 1, 1, 2),(30, 1070, 1, 1, 2),(30, 1071, 1, 1, 2),(30, 1072, 1, 1, 2),(30, 1073, 1, 1, 2),(30, 1074, 1, 1, 2),(30, 1075, 1, 1, 2),(30, 1076, 1, 1, 2),(30, 1077, 1, 1, 2),(30, 1078, 1, 1, 2),(30, 1079, 1, 1, 2),(30, 1080, 1, 1, 2),(30, 1081, 1, 1, 2),(30, 1082, 1, 1, 2),(30, 1083, 1, 1, 2),(30, 1084, 1, 1, 2),(30, 1085, 1, 1, 2),(30, 1086, 1, 1, 2),(30, 1087, 5, 1, 2),(30, 1088, 5, 1, 2),(30, 1089, 5, 1, 1),(30, 1090, 5, 1, 1),(30, 1091, 1, 1, 1),(30, 1092, 1, 1, 1),(30, 1093, 1, 1, 1),(30, 1094, 1, 1, 1),(30, 1095, 1, 1, 1),(30, 1096, 1, 1, 1),(30, 1097, 1, 1, 1),(30, 1098, 1, 1, 1),(30, 1099, 1, 1, 1),(30, 1100, 1, 1, 1),(30, 1101, 1, 1, 1),(30, 1102, 1, 1, 1),(30, 1103, 1, 1, 1),(30, 1104, 1, 1, 1),(30, 1105, 1, 1, 1),(30, 1106, 1, 1, 1),(30, 1107, 1, 1, 1),(30, 1108, 1, 1, 1),(30, 1109, 1, 1, 1),(30, 1110, 1, 1, 1),(30, 1111, 1, 1, 1),(30, 1112, 1, 1, 1),(30, 1113, 1, 1, 1),(30, 1114, 1, 1, 1),(30, 1115, 1, 1, 1),(30, 1116, 1, 1, 1),(30, 1117, 1, 1, 1),(30, 1118, 1, 1, 1),(30, 1119, 5, 1, 1),(30, 1120, 5, 1, 1),(30, 1121, 5, 1, 2),(30, 1122, 5, 1, 2),(30, 1123, 1, 1, 2),(30, 1124, 1, 1, 2),(30, 1125, 1, 1, 2),(30, 1126, 1, 1, 2),(30, 1127, 1, 1, 2),(30, 1128, 1, 1, 2),(30, 1129, 1, 1, 2),(30, 1130, 1, 1, 2),(30, 1131, 1, 1, 2),(30, 1132, 1, 1, 2),(30, 1133, 1, 1, 2),(30, 1134, 1, 1, 2),(30, 1135, 1, 1, 2),(30, 1136, 1, 1, 2),(30, 1137, 1, 1, 2),(30, 1138, 1, 1, 2),(30, 1139, 1, 1, 2),(30, 1140, 1, 1, 2),(30, 1141, 1, 1, 2),(30, 1142, 1, 1, 2),(30, 1143, 1, 1, 2),(30, 1144, 1, 1, 2),(30, 1145, 1, 1, 2),(30, 1146, 1, 1, 2),(30, 1147, 1, 1, 2),(30, 1148, 1, 1, 2),(30, 1149, 1, 1, 2),(30, 1150, 1, 1, 2),(30, 1151, 5, 1, 2),(30, 1152, 5, 1, 2),(30, 1153, 5, 1, 1),(30, 1154, 5, 1, 1),(30, 1155, 1, 1, 1),(30, 1156, 1, 1, 1),(30, 1157, 1, 1, 1),(30, 1158, 1, 1, 1),(30, 1159, 1, 1, 1),(30, 1160, 1, 1, 1),(30, 1161, 1, 1, 1),(30, 1162, 1, 1, 1),(30, 1163, 1, 1, 1),(30, 1164, 1, 1, 1),(30, 1165, 1, 1, 1),(30, 1166, 1, 1, 1),(30, 1167, 1, 1, 1),(30, 1168, 1, 1, 1),(30, 1169, 1, 1, 1),(30, 1170, 1, 1, 1),(30, 1171, 1, 1, 1),(30, 1172, 1, 1, 1),(30, 1173, 1, 1, 1),(30, 1174, 1, 1, 1),(30, 1175, 1, 1, 1),(30, 1176, 1, 1, 1),(30, 1177, 1, 1, 1),(30, 1178, 1, 1, 1),(30, 1179, 1, 1, 1),(30, 1180, 1, 1, 1),(30, 1181, 1, 1, 1),(30, 1182, 1, 1, 1),(30, 1183, 5, 1, 1),(30, 1184, 5, 1, 1),(30, 1185, 5, 1, 2),(30, 1186, 5, 1, 2),(30, 1187, 1, 1, 2),(30, 1188, 1, 1, 2),(30, 1189, 1, 1, 2),(30, 1190, 1, 1, 2),(30, 1191, 1, 1, 2),(30, 1192, 1, 1, 2),(30, 1193, 1, 1, 2),(30, 1194, 1, 1, 2),(30, 1195, 1, 1, 2),(30, 1196, 1, 1, 2),(30, 1197, 1, 1, 2),(30, 1198, 1, 1, 2),(30, 1199, 1, 1, 2),(30, 1200, 1, 1, 2),(30, 1201, 1, 1, 2),(30, 1202, 1, 1, 2),(30, 1203, 1, 1, 2),(30, 1204, 1, 1, 2),(30, 1205, 1, 1, 2),(30, 1206, 1, 1, 2),(30, 1207, 1, 1, 2),(30, 1208, 1, 1, 2),(30, 1209, 1, 1, 2),(30, 1210, 1, 1, 2),(30, 1211, 1, 1, 2),(30, 1212, 1, 1, 2),(30, 1213, 1, 1, 2),(30, 1214, 1, 1, 2),(30, 1215, 5, 1, 2),(30, 1216, 5, 1, 2),(30, 1217, 5, 1, 1),(30, 1218, 5, 1, 1),(30, 1219, 1, 1, 1),(30, 1220, 1, 1, 1),(30, 1221, 1, 1, 1),(30, 1222, 1, 1, 1),(30, 1223, 1, 1, 1),(30, 1224, 1, 1, 1),(30, 1225, 1, 1, 1),(30, 1226, 1, 1, 1),(30, 1227, 1, 1, 1),(30, 1228, 1, 1, 1),(30, 1229, 1, 1, 1),(30, 1230, 1, 1, 1),(30, 1231, 1, 1, 1),(30, 1232, 1, 1, 1),(30, 1233, 1, 1, 1),(30, 1234, 1, 1, 1),(30, 1235, 1, 1, 1),(30, 1236, 1, 1, 1),(30, 1237, 1, 1, 1),(30, 1238, 1, 1, 1),(30, 1239, 1, 1, 1),(30, 1240, 1, 1, 1),(30, 1241, 1, 1, 1),(30, 1242, 1, 1, 1),(30, 1243, 1, 1, 1),(30, 1244, 1, 1, 1),(30, 1245, 1, 1, 1),(30, 1246, 1, 1, 1),(30, 1247, 5, 1, 1),(30, 1248, 5, 1, 1),(30, 1249, 5, 1, 2),(30, 1250, 5, 1, 2),(30, 1251, 1, 1, 2),(30, 1252, 1, 1, 2),(30, 1253, 1, 1, 2),(30, 1254, 1, 1, 2),(30, 1255, 1, 1, 2),(30, 1256, 1, 1, 2),(30, 1257, 1, 1, 2),(30, 1258, 1, 1, 2),(30, 1259, 1, 1, 2),(30, 1260, 1, 1, 2),(30, 1261, 1, 1, 2),(30, 1262, 1, 1, 2),(30, 1263, 1, 1, 2),(30, 1264, 1, 1, 2),(30, 1265, 1, 1, 2),(30, 1266, 1, 1, 2),(30, 1267, 1, 1, 2),(30, 1268, 1, 1, 2),(30, 1269, 1, 1, 2),(30, 1270, 1, 1, 2),(30, 1271, 1, 1, 2),(30, 1272, 1, 1, 2),(30, 1273, 1, 1, 2),(30, 1274, 1, 1, 2),(30, 1275, 1, 1, 2),(30, 1276, 1, 1, 2),(30, 1277, 1, 1, 2),(30, 1278, 1, 1, 2),(30, 1279, 5, 1, 2),(30, 1280, 5, 1, 2),(30, 1281, 5, 1, 1),(30, 1282, 5, 1, 1),(30, 1283, 1, 1, 1),(30, 1284, 1, 1, 1),(30, 1285, 1, 1, 1),(30, 1286, 1, 1, 1),(30, 1287, 1, 1, 1),(30, 1288, 1, 1, 1),(30, 1289, 1, 1, 1),(30, 1290, 1, 1, 1),(30, 1291, 1, 1, 1),(30, 1292, 1, 1, 1),(30, 1293, 1, 1, 1),(30, 1294, 1, 1, 1),(30, 1295, 1, 1, 1),(30, 1296, 1, 1, 1),(30, 1297, 1, 1, 1),(30, 1298, 1, 1, 1),(30, 1299, 1, 1, 1),(30, 1300, 1, 1, 1),(30, 1301, 1, 1, 1),(30, 1302, 1, 1, 1),(30, 1303, 1, 1, 1),(30, 1304, 1, 1, 1),(30, 1305, 1, 1, 1),(30, 1306, 1, 1, 1),(30, 1307, 1, 1, 1),(30, 1308, 1, 1, 1),(30, 1309, 1, 1, 1),(30, 1310, 1, 1, 1),(30, 1311, 5, 1, 1),(30, 1312, 5, 1, 1),(30, 1313, 5, 1, 2),(30, 1314, 5, 1, 2),(30, 1315, 1, 1, 2),(30, 1316, 1, 1, 2),(30, 1317, 1, 1, 2),(30, 1318, 1, 1, 2),(30, 1319, 1, 1, 2),(30, 1320, 1, 1, 2),(30, 1321, 1, 1, 2),(30, 1322, 1, 1, 2),(30, 1323, 1, 1, 2),(30, 1324, 1, 1, 2),(30, 1325, 1, 1, 2),(30, 1326, 1, 1, 2),(30, 1327, 1, 1, 2),(30, 1328, 1, 1, 2),(30, 1329, 1, 1, 2),(30, 1330, 1, 1, 2),(30, 1331, 1, 1, 2),(30, 1332, 1, 1, 2),(30, 1333, 1, 1, 2),(30, 1334, 1, 1, 2),(30, 1335, 1, 1, 2),(30, 1336, 1, 1, 2),(30, 1337, 1, 1, 2),(30, 1338, 1, 1, 2),(30, 1339, 1, 1, 2),(30, 1340, 1, 1, 2),(30, 1341, 1, 1, 2),(30, 1342, 1, 1, 2),(30, 1343, 5, 1, 2),(30, 1344, 5, 1, 2),(30, 1345, 5, 1, 1),(30, 1346, 5, 1, 1),(30, 1347, 1, 1, 1),(30, 1348, 1, 1, 1),(30, 1349, 1, 1, 1),(30, 1350, 1, 1, 1),(30, 1351, 1, 1, 1),(30, 1352, 1, 1, 1),(30, 1353, 1, 1, 1),(30, 1354, 1, 1, 1),(30, 1355, 1, 1, 1),(30, 1356, 1, 1, 1),(30, 1357, 1, 1, 1),(30, 1358, 1, 1, 1),(30, 1359, 1, 1, 1),(30, 1360, 1, 1, 1),(30, 1361, 1, 1, 1),(30, 1362, 1, 1, 1),(30, 1363, 1, 1, 1),(30, 1364, 1, 1, 1),(30, 1365, 1, 1, 1),(30, 1366, 1, 1, 1),(30, 1367, 1, 1, 1),(30, 1368, 1, 1, 1),(30, 1369, 1, 1, 1),(30, 1370, 1, 1, 1),(30, 1371, 1, 1, 1),(30, 1372, 1, 1, 1),(30, 1373, 1, 1, 1),(30, 1374, 1, 1, 1),(30, 1375, 5, 1, 1),(30, 1376, 5, 1, 1),(30, 1377, 5, 1, 2),(30, 1378, 5, 1, 2),(30, 1379, 1, 1, 2),(30, 1380, 1, 1, 2),(30, 1381, 1, 1, 2),(30, 1382, 1, 1, 2),(30, 1383, 1, 1, 2),(30, 1384, 1, 1, 2),(30, 1385, 1, 1, 2),(30, 1386, 1, 1, 2),(30, 1387, 1, 1, 2),(30, 1388, 1, 1, 2),(30, 1389, 1, 1, 2),(30, 1390, 1, 1, 2),(30, 1391, 1, 1, 2),(30, 1392, 1, 1, 2),(30, 1393, 1, 1, 2),(30, 1394, 1, 1, 2),(30, 1395, 1, 1, 2),(30, 1396, 1, 1, 2),(30, 1397, 1, 1, 2),(30, 1398, 1, 1, 2),(30, 1399, 1, 1, 2),(30, 1400, 1, 1, 2),(30, 1401, 1, 1, 2),(30, 1402, 1, 1, 2),(30, 1403, 1, 1, 2),(30, 1404, 1, 1, 2),(30, 1405, 1, 1, 2),(30, 1406, 1, 1, 2),(30, 1407, 5, 1, 2),(30, 1408, 5, 1, 2),(30, 1409, 5, 1, 1),(30, 1410, 5, 1, 1),(30, 1411, 1, 1, 1),(30, 1412, 1, 1, 1),(30, 1413, 1, 1, 1),(30, 1414, 1, 1, 1),(30, 1415, 1, 1, 1),(30, 1416, 1, 1, 1),(30, 1417, 1, 1, 1),(30, 1418, 1, 1, 1),(30, 1419, 1, 1, 1),(30, 1420, 1, 1, 1),(30, 1421, 1, 1, 1),(30, 1422, 1, 1, 1),(30, 1423, 1, 1, 1),(30, 1424, 1, 1, 1),(30, 1425, 2, 1, 1),(30, 1426, 2, 1, 1),(30, 1427, 2, 1, 1),(30, 1428, 2, 1, 1),(30, 1429, 2, 1, 1),(30, 1430, 2, 1, 1),(30, 1431, 2, 1, 1),(30, 1432, 2, 1, 1),(30, 1433, 3, 1, 1),(30, 1434, 3, 1, 1),(30, 1435, 3, 1, 1),(30, 1436, 3, 1, 1),(30, 1437, 4, 1, 1),(30, 1438, 4, 1, 1),(30, 1439, 5, 1, 1),(30, 1440, 5, 1, 1),(30, 1441, 5, 1, 2),(30, 1442, 5, 1, 2),(30, 1443, 1, 1, 2),(30, 1444, 1, 1, 2),(30, 1445, 1, 1, 2),(30, 1446, 1, 1, 2),(30, 1447, 1, 1, 2),(30, 1448, 1, 1, 2),(30, 1449, 1, 1, 2),(30, 1450, 1, 1, 2),(30, 1451, 1, 1, 2),(30, 1452, 1, 1, 2),(30, 1453, 1, 1, 2),(30, 1454, 1, 1, 2),(30, 1455, 1, 1, 2),(30, 1456, 1, 1, 2),(30, 1457, 2, 1, 2),(30, 1458, 2, 1, 2),(30, 1459, 2, 1, 2),(30, 1460, 2, 1, 2),(30, 1461, 2, 1, 2),(30, 1462, 2, 1, 2),(30, 1463, 2, 1, 2),(30, 1464, 2, 1, 2),(30, 1465, 3, 1, 2),(30, 1466, 3, 1, 2),(30, 1467, 3, 1, 2),(30, 1468, 3, 1, 2),(30, 1469, 4, 1, 2),(30, 1470, 4, 1, 2),(30, 1471, 5, 1, 2),(30, 1472, 5, 1, 2),(30, 1473, 5, 1, 1),(30, 1474, 5, 1, 1),(30, 1475, 5, 1, 1),(30, 1476, 5, 1, 1),(30, 1477, 5, 1, 1),(30, 1478, 5, 1, 1),(30, 1479, 5, 1, 1),(30, 1480, 5, 1, 1),(30, 1481, 5, 1, 1),(30, 1482, 5, 1, 1),(30, 1483, 5, 1, 1),(30, 1484, 5, 1, 1),(30, 1485, 5, 1, 1),(30, 1486, 5, 1, 1),(30, 1487, 5, 1, 1),(30, 1488, 5, 1, 1),(30, 1489, 5, 1, 1),(30, 1490, 5, 1, 1),(30, 1491, 5, 1, 1),(30, 1492, 5, 1, 1),(30, 1493, 5, 1, 1),(30, 1494, 5, 1, 1),(30, 1495, 5, 1, 1),(30, 1496, 5, 1, 1),(30, 1497, 5, 1, 1),(30, 1498, 5, 1, 1),(30, 1499, 5, 1, 1),(30, 1500, 5, 1, 1),(30, 1501, 5, 1, 1),(30, 1502, 5, 1, 1),(30, 1503, 5, 1, 1),(30, 1504, 5, 1, 1),(30, 1505, 5, 1, 2),(30, 1506, 5, 1, 2),(30, 1507, 5, 1, 2),(30, 1508, 5, 1, 2),(30, 1509, 5, 1, 2),(30, 1510, 5, 1, 2),(30, 1511, 5, 1, 2),(30, 1512, 5, 1, 2),(30, 1513, 5, 1, 2),(30, 1514, 5, 1, 2),(30, 1515, 5, 1, 2),(30, 1516, 5, 1, 2),(30, 1517, 5, 1, 2),(30, 1518, 5, 1, 2),(30, 1519, 5, 1, 2),(30, 1520, 5, 1, 2),(30, 1521, 5, 1, 2),(30, 1522, 5, 1, 2),(30, 1523, 5, 1, 2),(30, 1524, 5, 1, 2),(30, 1525, 5, 1, 2),(30, 1526, 5, 1, 2),(30, 1527, 5, 1, 2),(30, 1528, 5, 1, 2),(30, 1529, 5, 1, 2),(30, 1530, 5, 1, 2),(30, 1531, 5, 1, 2),(30, 1532, 5, 1, 2),(30, 1533, 5, 1, 2),(30, 1534, 5, 1, 2),(30, 1535, 5, 1, 2),(30, 1536, 5, 1, 2),(31, 1, 5, 1, 1),(31, 2, 5, 1, 1),(31, 3, 5, 1, 1),(31, 4, 5, 1, 1),(31, 5, 5, 1, 1),(31, 6, 5, 1, 1),(31, 7, 5, 1, 1),(31, 8, 5, 1, 1),(31, 9, 5, 1, 1),(31, 10, 5, 1, 1),(31, 11, 5, 1, 1),(31, 12, 5, 1, 1),(31, 13, 5, 1, 1),(31, 14, 5, 1, 1),(31, 15, 5, 1, 1),(31, 16, 5, 1, 1),(31, 17, 5, 1, 1),(31, 18, 1, 1, 1),(31, 19, 1, 1, 1),(31, 20, 1, 1, 1),(31, 21, 1, 1, 1),(31, 22, 1, 1, 1),(31, 23, 1, 1, 1),(31, 24, 1, 1, 1),(31, 25, 1, 1, 1),(31, 26, 1, 1, 1),(31, 27, 1, 1, 1),(31, 28, 1, 1, 1),(31, 29, 1, 1, 1),(31, 30, 1, 1, 1),(31, 31, 1, 1, 1),(31, 32, 5, 1, 1),(31, 33, 5, 1, 1),(31, 34, 1, 1, 1),(31, 35, 1, 1, 1),(31, 36, 1, 1, 1),(31, 37, 1, 1, 1),(31, 38, 1, 1, 1),(31, 39, 1, 1, 1),(31, 40, 1, 1, 1),(31, 41, 1, 1, 1),(31, 42, 1, 1, 1),(31, 43, 1, 1, 1),(31, 44, 1, 1, 1),(31, 45, 1, 1, 1),(31, 46, 1, 1, 1),(31, 47, 1, 1, 1),(31, 48, 5, 1, 1),(31, 49, 5, 1, 1),(31, 50, 1, 1, 1),(31, 51, 1, 1, 1),(31, 52, 1, 1, 1),(31, 53, 1, 1, 1),(31, 54, 1, 1, 1),(31, 55, 1, 1, 1),(31, 56, 1, 1, 1),(31, 57, 1, 1, 1),(31, 58, 1, 1, 1),(31, 59, 1, 1, 1),(31, 60, 1, 1, 1),(31, 61, 1, 1, 1),(31, 62, 1, 1, 1),(31, 63, 1, 1, 1),(31, 64, 5, 1, 1),(31, 65, 5, 1, 1),(31, 66, 1, 1, 1),(31, 67, 1, 1, 1),(31, 68, 1, 1, 1),(31, 69, 1, 1, 1),(31, 70, 1, 1, 1),(31, 71, 1, 1, 1),(31, 72, 1, 1, 1),(31, 73, 1, 1, 1),(31, 74, 1, 1, 1),(31, 75, 1, 1, 1),(31, 76, 1, 1, 1),(31, 77, 1, 1, 1),(31, 78, 1, 1, 1),(31, 79, 1, 1, 1),(31, 80, 5, 1, 1),(31, 81, 5, 1, 1),(31, 82, 1, 1, 1),(31, 83, 1, 1, 1),(31, 84, 1, 1, 1),(31, 85, 1, 1, 1),(31, 86, 1, 1, 1),(31, 87, 1, 1, 1),(31, 88, 1, 1, 1),(31, 89, 1, 1, 1),(31, 90, 1, 1, 1),(31, 91, 1, 1, 1),(31, 92, 1, 1, 1),(31, 93, 1, 1, 1),(31, 94, 1, 1, 1),(31, 95, 1, 1, 1),(31, 96, 5, 1, 1),(31, 97, 5, 1, 1),(31, 98, 1, 1, 1),(31, 99, 1, 1, 1),(31, 100, 1, 1, 1),(31, 101, 1, 1, 1),(31, 102, 1, 1, 1),(31, 103, 1, 1, 1),(31, 104, 1, 1, 1),(31, 105, 1, 1, 1),(31, 106, 1, 1, 1),(31, 107, 1, 1, 1),(31, 108, 1, 1, 1),(31, 109, 1, 1, 1),(31, 110, 1, 1, 1),(31, 111, 1, 1, 1),(31, 112, 5, 1, 1),(31, 113, 5, 1, 1),(31, 114, 1, 1, 1),(31, 115, 1, 1, 1),(31, 116, 1, 1, 1),(31, 117, 1, 1, 1),(31, 118, 1, 1, 1),(31, 119, 1, 1, 1),(31, 120, 1, 1, 1),(31, 121, 1, 1, 1),(31, 122, 1, 1, 1),(31, 123, 1, 1, 1),(31, 124, 1, 1, 1),(31, 125, 1, 1, 1),(31, 126, 1, 1, 1),(31, 127, 1, 1, 1),(31, 128, 5, 1, 1),(31, 129, 5, 1, 1),(31, 130, 1, 1, 1),(31, 131, 1, 1, 1),(31, 132, 1, 1, 1),(31, 133, 1, 1, 1),(31, 134, 1, 1, 1),(31, 135, 1, 1, 1),(31, 136, 1, 1, 1),(31, 137, 1, 1, 1),(31, 138, 1, 1, 1),(31, 139, 1, 1, 1),(31, 140, 1, 1, 1),(31, 141, 1, 1, 1),(31, 142, 1, 1, 1),(31, 143, 1, 1, 1),(31, 144, 5, 1, 1),(31, 145, 5, 1, 1),(31, 146, 1, 1, 1),(31, 147, 1, 1, 1),(31, 148, 1, 1, 1),(31, 149, 1, 1, 1),(31, 150, 1, 1, 1),(31, 151, 1, 1, 1),(31, 152, 1, 1, 1),(31, 153, 1, 1, 1),(31, 154, 1, 1, 1),(31, 155, 1, 1, 1),(31, 156, 1, 1, 1),(31, 157, 1, 1, 1),(31, 158, 1, 1, 1),(31, 159, 1, 1, 1),(31, 160, 5, 1, 1),(31, 161, 5, 1, 1),(31, 162, 1, 1, 1),(31, 163, 1, 1, 1),(31, 164, 1, 1, 1),(31, 165, 1, 1, 1),(31, 166, 1, 1, 1),(31, 167, 1, 1, 1),(31, 168, 1, 1, 1),(31, 169, 1, 1, 1),(31, 170, 1, 1, 1),(31, 171, 1, 1, 1),(31, 172, 1, 1, 1),(31, 173, 1, 1, 1),(31, 174, 1, 1, 1),(31, 175, 1, 1, 1),(31, 176, 5, 1, 1),(31, 177, 5, 1, 1),(31, 178, 1, 1, 1),(31, 179, 1, 1, 1),(31, 180, 1, 1, 1),(31, 181, 1, 1, 1),(31, 182, 1, 1, 1),(31, 183, 1, 1, 1),(31, 184, 1, 1, 1),(31, 185, 1, 1, 1),(31, 186, 1, 1, 1),(31, 187, 1, 1, 1),(31, 188, 1, 1, 1),(31, 189, 1, 1, 1),(31, 190, 1, 1, 1),(31, 191, 1, 1, 1),(31, 192, 5, 1, 1),(31, 193, 5, 1, 1),(31, 194, 1, 1, 1),(31, 195, 1, 1, 1),(31, 196, 1, 1, 1),(31, 197, 1, 1, 1),(31, 198, 1, 1, 1),(31, 199, 1, 1, 1),(31, 200, 1, 1, 1),(31, 201, 1, 1, 1),(31, 202, 1, 1, 1),(31, 203, 1, 1, 1),(31, 204, 1, 1, 1),(31, 205, 1, 1, 1),(31, 206, 1, 1, 1),(31, 207, 1, 1, 1),(31, 208, 5, 1, 1),(31, 209, 5, 1, 1),(31, 210, 1, 1, 1),(31, 211, 1, 1, 1),(31, 212, 1, 1, 1),(31, 213, 1, 1, 1),(31, 214, 1, 1, 1),(31, 215, 1, 1, 1),(31, 216, 1, 1, 1),(31, 217, 1, 1, 1),(31, 218, 1, 1, 1),(31, 219, 1, 1, 1),(31, 220, 1, 1, 1),(31, 221, 1, 1, 1),(31, 222, 1, 1, 1),(31, 223, 1, 1, 1),(31, 224, 5, 1, 1),(31, 225, 5, 1, 1),(31, 226, 1, 1, 1),(31, 227, 1, 1, 1),(31, 228, 1, 1, 1),(31, 229, 1, 1, 1),(31, 230, 1, 1, 1),(31, 231, 1, 1, 1),(31, 232, 1, 1, 1),(31, 233, 1, 1, 1),(31, 234, 1, 1, 1),(31, 235, 1, 1, 1),(31, 236, 1, 1, 1),(31, 237, 1, 1, 1),(31, 238, 1, 1, 1),(31, 239, 1, 1, 1),(31, 240, 5, 1, 1),(31, 241, 5, 1, 1),(31, 242, 1, 1, 1),(31, 243, 1, 1, 1),(31, 244, 1, 1, 1),(31, 245, 1, 1, 1),(31, 246, 1, 1, 1),(31, 247, 1, 1, 1),(31, 248, 1, 1, 1),(31, 249, 1, 1, 1),(31, 250, 1, 1, 1),(31, 251, 1, 1, 1),(31, 252, 1, 1, 1),(31, 253, 1, 1, 1),(31, 254, 1, 1, 1),(31, 255, 1, 1, 1),(31, 256, 5, 1, 1),(31, 257, 5, 1, 1),(31, 258, 1, 1, 1),(31, 259, 1, 1, 1),(31, 260, 1, 1, 1),(31, 261, 1, 1, 1),(31, 262, 1, 1, 1),(31, 263, 1, 1, 1),(31, 264, 1, 1, 1),(31, 265, 1, 1, 1),(31, 266, 1, 1, 1),(31, 267, 1, 1, 1),(31, 268, 1, 1, 1),(31, 269, 1, 1, 1),(31, 270, 1, 1, 1),(31, 271, 1, 1, 1),(31, 272, 5, 1, 1),(31, 273, 5, 1, 1),(31, 274, 1, 1, 1),(31, 275, 1, 1, 1),(31, 276, 1, 1, 1),(31, 277, 1, 1, 1),(31, 278, 1, 1, 1),(31, 279, 1, 1, 1),(31, 280, 1, 1, 1),(31, 281, 1, 1, 1),(31, 282, 1, 1, 1),(31, 283, 1, 1, 1),(31, 284, 1, 1, 1),(31, 285, 1, 1, 1),(31, 286, 1, 1, 1),(31, 287, 1, 1, 1),(31, 288, 5, 1, 1),(31, 289, 5, 1, 1),(31, 290, 1, 1, 1),(31, 291, 1, 1, 1),(31, 292, 1, 1, 1),(31, 293, 1, 1, 1),(31, 294, 1, 1, 1),(31, 295, 1, 1, 1),(31, 296, 1, 1, 1),(31, 297, 1, 1, 1),(31, 298, 1, 1, 1),(31, 299, 1, 1, 1),(31, 300, 1, 1, 1),(31, 301, 1, 1, 1),(31, 302, 1, 1, 1),(31, 303, 1, 1, 1),(31, 304, 5, 1, 1),(31, 305, 5, 1, 1),(31, 306, 1, 1, 1),(31, 307, 1, 1, 1),(31, 308, 1, 1, 1),(31, 309, 1, 1, 1),(31, 310, 1, 1, 1),(31, 311, 1, 1, 1),(31, 312, 1, 1, 1),(31, 313, 1, 1, 1),(31, 314, 1, 1, 1),(31, 315, 1, 1, 1),(31, 316, 1, 1, 1),(31, 317, 1, 1, 1),(31, 318, 1, 1, 1),(31, 319, 1, 1, 1),(31, 320, 5, 1, 1),(31, 321, 5, 1, 1),(31, 322, 1, 1, 1),(31, 323, 1, 1, 1),(31, 324, 1, 1, 1),(31, 325, 1, 1, 1),(31, 326, 1, 1, 1),(31, 327, 1, 1, 1),(31, 328, 1, 1, 1),(31, 329, 1, 1, 1),(31, 330, 1, 1, 1),(31, 331, 1, 1, 1),(31, 332, 1, 1, 1),(31, 333, 1, 1, 1),(31, 334, 1, 1, 1),(31, 335, 1, 1, 1),(31, 336, 5, 1, 1),(31, 337, 5, 1, 1),(31, 338, 1, 1, 1),(31, 339, 1, 1, 1),(31, 340, 1, 1, 1),(31, 341, 1, 1, 1),(31, 342, 1, 1, 1),(31, 343, 1, 1, 1),(31, 344, 1, 1, 1),(31, 345, 1, 1, 1),(31, 346, 1, 1, 1),(31, 347, 1, 1, 1),(31, 348, 1, 1, 1),(31, 349, 1, 1, 1),(31, 350, 1, 1, 1),(31, 351, 1, 1, 1),(31, 352, 5, 1, 1),(31, 353, 5, 1, 1),(31, 354, 2, 1, 1),(31, 355, 2, 1, 1),(31, 356, 2, 1, 1),(31, 357, 2, 1, 1),(31, 358, 2, 1, 1),(31, 359, 2, 1, 1),(31, 360, 2, 1, 1),(31, 361, 3, 1, 1),(31, 362, 3, 1, 1),(31, 363, 3, 1, 1),(31, 364, 3, 1, 1),(31, 365, 4, 1, 1),(31, 366, 4, 1, 1),(31, 367, 4, 1, 1),(31, 368, 5, 1, 1),(31, 369, 5, 1, 1),(31, 370, 5, 1, 1),(31, 371, 5, 1, 1),(31, 372, 5, 1, 1),(31, 373, 5, 1, 1),(31, 374, 5, 1, 1),(31, 375, 5, 1, 1),(31, 376, 5, 1, 1),(31, 377, 5, 1, 1),(31, 378, 5, 1, 1),(31, 379, 5, 1, 1),(31, 380, 5, 1, 1),(31, 381, 5, 1, 1),(31, 382, 5, 1, 1),(31, 383, 5, 1, 1),(31, 384, 5, 1, 1),(32, 1, 5, 1, 1),(32, 2, 5, 3, 1),(32, 3, 5, 1, 1),(32, 4, 5, 3, 1),(32, 5, 5, 1, 1),(32, 6, 5, 3, 1),(32, 7, 5, 1, 1),(32, 8, 5, 3, 1),(32, 9, 5, 1, 1),(32, 10, 5, 3, 1),(32, 11, 5, 1, 1),(32, 12, 5, 3, 1),(32, 13, 5, 1, 1),(32, 14, 5, 3, 1),(32, 15, 5, 1, 1),(32, 16, 5, 3, 1),(32, 17, 5, 1, 1),(32, 18, 5, 3, 1),(32, 19, 5, 1, 1),(32, 20, 5, 3, 1),(32, 21, 5, 1, 1),(32, 22, 5, 3, 1),(32, 23, 5, 1, 1),(32, 24, 5, 3, 1),(32, 25, 5, 1, 1),(32, 26, 5, 3, 1),(32, 27, 5, 1, 1),(32, 28, 5, 3, 1),(32, 29, 5, 1, 1),(32, 30, 5, 3, 1),(32, 31, 5, 1, 1),(32, 32, 5, 3, 1),(32, 33, 5, 2, 1),(32, 34, 5, 4, 1),(32, 35, 5, 2, 1),(32, 36, 5, 4, 1),(32, 37, 5, 2, 1),(32, 38, 5, 4, 1),(32, 39, 5, 2, 1),(32, 40, 5, 4, 1),(32, 41, 5, 2, 1),(32, 42, 5, 4, 1),(32, 43, 5, 2, 1),(32, 44, 5, 4, 1),(32, 45, 5, 2, 1),(32, 46, 5, 4, 1),(32, 47, 5, 2, 1),(32, 48, 5, 4, 1),(32, 49, 5, 2, 1),(32, 50, 5, 4, 1),(32, 51, 5, 2, 1),(32, 52, 5, 4, 1),(32, 53, 5, 2, 1),(32, 54, 5, 4, 1),(32, 55, 5, 2, 1),(32, 56, 5, 4, 1),(32, 57, 5, 2, 1),(32, 58, 5, 4, 1),(32, 59, 5, 2, 1),(32, 60, 5, 4, 1),(32, 61, 5, 2, 1),(32, 62, 5, 4, 1),(32, 63, 5, 2, 1),(32, 64, 5, 4, 1),(32, 65, 5, 1, 1),(32, 66, 5, 3, 1),(32, 67, 1, 1, 1),(32, 68, 1, 3, 1),(32, 69, 1, 1, 1),(32, 70, 1, 3, 1),(32, 71, 1, 1, 1),(32, 72, 1, 3, 1),(32, 73, 1, 1, 1),(32, 74, 1, 3, 1),(32, 75, 1, 1, 1),(32, 76, 1, 3, 1),(32, 77, 1, 1, 1),(32, 78, 1, 3, 1),(32, 79, 1, 1, 1),(32, 80, 1, 3, 1),(32, 81, 1, 1, 1),(32, 82, 1, 3, 1),(32, 83, 1, 1, 1),(32, 84, 1, 3, 1),(32, 85, 1, 1, 1),(32, 86, 1, 3, 1),(32, 87, 1, 1, 1),(32, 88, 1, 3, 1),(32, 89, 1, 1, 1),(32, 90, 1, 3, 1),(32, 91, 1, 1, 1),(32, 92, 1, 3, 1),(32, 93, 1, 1, 1),(32, 94, 1, 3, 1),(32, 95, 5, 1, 1),(32, 96, 5, 3, 1),(32, 97, 5, 2, 1),(32, 98, 5, 4, 1),(32, 99, 1, 2, 1),(32, 100, 1, 4, 1),(32, 101, 1, 2, 1),(32, 102, 1, 4, 1),(32, 103, 1, 2, 1),(32, 104, 1, 4, 1),(32, 105, 1, 2, 1),(32, 106, 1, 4, 1),(32, 107, 1, 2, 1),(32, 108, 1, 4, 1),(32, 109, 1, 2, 1),(32, 110, 1, 4, 1),(32, 111, 1, 2, 1),(32, 112, 1, 4, 1),(32, 113, 1, 2, 1),(32, 114, 1, 4, 1),(32, 115, 1, 2, 1),(32, 116, 1, 4, 1),(32, 117, 1, 2, 1),(32, 118, 1, 4, 1),(32, 119, 1, 2, 1),(32, 120, 1, 4, 1),(32, 121, 1, 2, 1),(32, 122, 1, 4, 1),(32, 123, 1, 2, 1),(32, 124, 1, 4, 1),(32, 125, 1, 2, 1),(32, 126, 1, 4, 1),(32, 127, 5, 2, 1),(32, 128, 5, 4, 1),(32, 129, 5, 1, 1),(32, 130, 5, 3, 1),(32, 131, 1, 1, 1),(32, 132, 1, 3, 1),(32, 133, 1, 1, 1),(32, 134, 1, 3, 1),(32, 135, 1, 1, 1),(32, 136, 1, 3, 1),(32, 137, 1, 1, 1),(32, 138, 1, 3, 1),(32, 139, 1, 1, 1),(32, 140, 1, 3, 1),(32, 141, 1, 1, 1),(32, 142, 1, 3, 1),(32, 143, 1, 1, 1),(32, 144, 1, 3, 1),(32, 145, 1, 1, 1),(32, 146, 1, 3, 1),(32, 147, 1, 1, 1),(32, 148, 1, 3, 1),(32, 149, 1, 1, 1),(32, 150, 1, 3, 1),(32, 151, 1, 1, 1),(32, 152, 1, 3, 1),(32, 153, 1, 1, 1),(32, 154, 1, 3, 1),(32, 155, 1, 1, 1),(32, 156, 1, 3, 1),(32, 157, 1, 1, 1),(32, 158, 1, 3, 1),(32, 159, 5, 1, 1),(32, 160, 5, 3, 1),(32, 161, 5, 2, 1),(32, 162, 5, 4, 1),(32, 163, 1, 2, 1),(32, 164, 1, 4, 1),(32, 165, 1, 2, 1),(32, 166, 1, 4, 1),(32, 167, 1, 2, 1),(32, 168, 1, 4, 1),(32, 169, 1, 2, 1),(32, 170, 1, 4, 1),(32, 171, 1, 2, 1),(32, 172, 1, 4, 1),(32, 173, 1, 2, 1),(32, 174, 1, 4, 1),(32, 175, 1, 2, 1),(32, 176, 1, 4, 1),(32, 177, 1, 2, 1),(32, 178, 1, 4, 1),(32, 179, 1, 2, 1),(32, 180, 1, 4, 1),(32, 181, 1, 2, 1),(32, 182, 1, 4, 1),(32, 183, 1, 2, 1),(32, 184, 1, 4, 1),(32, 185, 1, 2, 1),(32, 186, 1, 4, 1),(32, 187, 1, 2, 1),(32, 188, 1, 4, 1),(32, 189, 1, 2, 1),(32, 190, 1, 4, 1),(32, 191, 5, 2, 1),(32, 192, 5, 4, 1),(32, 193, 5, 1, 1),(32, 194, 5, 3, 1),(32, 195, 1, 1, 1),(32, 196, 1, 3, 1),(32, 197, 1, 1, 1),(32, 198, 1, 3, 1),(32, 199, 1, 1, 1),(32, 200, 1, 3, 1),(32, 201, 1, 1, 1),(32, 202, 1, 3, 1),(32, 203, 1, 1, 1),(32, 204, 1, 3, 1),(32, 205, 1, 1, 1),(32, 206, 1, 3, 1),(32, 207, 1, 1, 1),(32, 208, 1, 3, 1),(32, 209, 1, 1, 1),(32, 210, 1, 3, 1),(32, 211, 1, 1, 1),(32, 212, 1, 3, 1),(32, 213, 1, 1, 1),(32, 214, 1, 3, 1),(32, 215, 1, 1, 1),(32, 216, 1, 3, 1),(32, 217, 1, 1, 1),(32, 218, 1, 3, 1),(32, 219, 1, 1, 1),(32, 220, 1, 3, 1),(32, 221, 1, 1, 1),(32, 222, 1, 3, 1),(32, 223, 5, 1, 1),(32, 224, 5, 3, 1),(32, 225, 5, 2, 1),(32, 226, 5, 4, 1),(32, 227, 1, 2, 1),(32, 228, 1, 4, 1),(32, 229, 1, 2, 1),(32, 230, 1, 4, 1),(32, 231, 1, 2, 1),(32, 232, 1, 4, 1),(32, 233, 1, 2, 1),(32, 234, 1, 4, 1),(32, 235, 1, 2, 1),(32, 236, 1, 4, 1),(32, 237, 1, 2, 1),(32, 238, 1, 4, 1),(32, 239, 1, 2, 1),(32, 240, 1, 4, 1),(32, 241, 1, 2, 1),(32, 242, 1, 4, 1),(32, 243, 1, 2, 1),(32, 244, 1, 4, 1),(32, 245, 1, 2, 1),(32, 246, 1, 4, 1),(32, 247, 1, 2, 1),(32, 248, 1, 4, 1),(32, 249, 1, 2, 1),(32, 250, 1, 4, 1),(32, 251, 1, 2, 1),(32, 252, 1, 4, 1),(32, 253, 1, 2, 1),(32, 254, 1, 4, 1),(32, 255, 5, 2, 1),(32, 256, 5, 4, 1),(32, 257, 5, 1, 1),(32, 258, 5, 3, 1),(32, 259, 1, 1, 1),(32, 260, 1, 3, 1),(32, 261, 1, 1, 1),(32, 262, 1, 3, 1),(32, 263, 1, 1, 1),(32, 264, 1, 3, 1),(32, 265, 1, 1, 1),(32, 266, 1, 3, 1),(32, 267, 1, 1, 1),(32, 268, 1, 3, 1),(32, 269, 1, 1, 1),(32, 270, 1, 3, 1),(32, 271, 1, 1, 1),(32, 272, 1, 3, 1),(32, 273, 1, 1, 1),(32, 274, 1, 3, 1),(32, 275, 1, 1, 1),(32, 276, 1, 3, 1),(32, 277, 1, 1, 1),(32, 278, 1, 3, 1),(32, 279, 1, 1, 1),(32, 280, 1, 3, 1),(32, 281, 1, 1, 1),(32, 282, 1, 3, 1),(32, 283, 1, 1, 1),(32, 284, 1, 3, 1),(32, 285, 1, 1, 1),(32, 286, 1, 3, 1),(32, 287, 5, 1, 1),(32, 288, 5, 3, 1),(32, 289, 5, 2, 1),(32, 290, 5, 4, 1),(32, 291, 1, 2, 1),(32, 292, 1, 4, 1),(32, 293, 1, 2, 1),(32, 294, 1, 4, 1),(32, 295, 1, 2, 1),(32, 296, 1, 4, 1),(32, 297, 1, 2, 1),(32, 298, 1, 4, 1),(32, 299, 1, 2, 1),(32, 300, 1, 4, 1),(32, 301, 1, 2, 1),(32, 302, 1, 4, 1),(32, 303, 1, 2, 1),(32, 304, 1, 4, 1),(32, 305, 1, 2, 1),(32, 306, 1, 4, 1),(32, 307, 1, 2, 1),(32, 308, 1, 4, 1),(32, 309, 1, 2, 1),(32, 310, 1, 4, 1),(32, 311, 1, 2, 1),(32, 312, 1, 4, 1),(32, 313, 1, 2, 1),(32, 314, 1, 4, 1),(32, 315, 1, 2, 1),(32, 316, 1, 4, 1),(32, 317, 1, 2, 1),(32, 318, 1, 4, 1),(32, 319, 5, 2, 1),(32, 320, 5, 4, 1),(32, 321, 5, 1, 1),(32, 322, 5, 3, 1),(32, 323, 1, 1, 1),(32, 324, 1, 3, 1),(32, 325, 1, 1, 1),(32, 326, 1, 3, 1),(32, 327, 1, 1, 1),(32, 328, 1, 3, 1),(32, 329, 1, 1, 1),(32, 330, 1, 3, 1),(32, 331, 1, 1, 1),(32, 332, 1, 3, 1),(32, 333, 1, 1, 1),(32, 334, 1, 3, 1),(32, 335, 1, 1, 1),(32, 336, 1, 3, 1),(32, 337, 1, 1, 1),(32, 338, 1, 3, 1),(32, 339, 1, 1, 1),(32, 340, 1, 3, 1),(32, 341, 1, 1, 1),(32, 342, 1, 3, 1),(32, 343, 1, 1, 1),(32, 344, 1, 3, 1),(32, 345, 1, 1, 1),(32, 346, 1, 3, 1),(32, 347, 1, 1, 1),(32, 348, 1, 3, 1),(32, 349, 1, 1, 1),(32, 350, 1, 3, 1),(32, 351, 5, 1, 1),(32, 352, 5, 3, 1),(32, 353, 5, 2, 1),(32, 354, 5, 4, 1),(32, 355, 1, 2, 1),(32, 356, 1, 4, 1),(32, 357, 1, 2, 1),(32, 358, 1, 4, 1),(32, 359, 1, 2, 1),(32, 360, 1, 4, 1),(32, 361, 1, 2, 1),(32, 362, 1, 4, 1),(32, 363, 1, 2, 1),(32, 364, 1, 4, 1),(32, 365, 1, 2, 1),(32, 366, 1, 4, 1),(32, 367, 1, 2, 1),(32, 368, 1, 4, 1),(32, 369, 1, 2, 1),(32, 370, 1, 4, 1),(32, 371, 1, 2, 1),(32, 372, 1, 4, 1),(32, 373, 1, 2, 1),(32, 374, 1, 4, 1),(32, 375, 1, 2, 1),(32, 376, 1, 4, 1),(32, 377, 1, 2, 1),(32, 378, 1, 4, 1),(32, 379, 1, 2, 1),(32, 380, 1, 4, 1),(32, 381, 1, 2, 1),(32, 382, 1, 4, 1),(32, 383, 5, 2, 1),(32, 384, 5, 4, 1),(32, 385, 5, 1, 1),(32, 386, 5, 3, 1),(32, 387, 1, 1, 1),(32, 388, 1, 3, 1),(32, 389, 1, 1, 1),(32, 390, 1, 3, 1),(32, 391, 1, 1, 1),(32, 392, 1, 3, 1),(32, 393, 1, 1, 1),(32, 394, 1, 3, 1),(32, 395, 1, 1, 1),(32, 396, 1, 3, 1),(32, 397, 1, 1, 1),(32, 398, 1, 3, 1),(32, 399, 1, 1, 1),(32, 400, 1, 3, 1),(32, 401, 1, 1, 1),(32, 402, 1, 3, 1),(32, 403, 1, 1, 1),(32, 404, 1, 3, 1),(32, 405, 1, 1, 1),(32, 406, 1, 3, 1),(32, 407, 1, 1, 1),(32, 408, 1, 3, 1),(32, 409, 1, 1, 1),(32, 410, 1, 3, 1),(32, 411, 1, 1, 1),(32, 412, 1, 3, 1),(32, 413, 1, 1, 1),(32, 414, 1, 3, 1),(32, 415, 5, 1, 1),(32, 416, 5, 3, 1),(32, 417, 5, 2, 1),(32, 418, 5, 4, 1),(32, 419, 1, 2, 1),(32, 420, 1, 4, 1),(32, 421, 1, 2, 1),(32, 422, 1, 4, 1),(32, 423, 1, 2, 1),(32, 424, 1, 4, 1),(32, 425, 1, 2, 1),(32, 426, 1, 4, 1),(32, 427, 1, 2, 1),(32, 428, 1, 4, 1),(32, 429, 1, 2, 1),(32, 430, 1, 4, 1),(32, 431, 1, 2, 1),(32, 432, 1, 4, 1),(32, 433, 1, 2, 1),(32, 434, 1, 4, 1),(32, 435, 1, 2, 1),(32, 436, 1, 4, 1),(32, 437, 1, 2, 1),(32, 438, 1, 4, 1),(32, 439, 1, 2, 1),(32, 440, 1, 4, 1),(32, 441, 1, 2, 1),(32, 442, 1, 4, 1),(32, 443, 1, 2, 1),(32, 444, 1, 4, 1),(32, 445, 1, 2, 1),(32, 446, 1, 4, 1),(32, 447, 5, 2, 1),(32, 448, 5, 4, 1),(32, 449, 5, 1, 1),(32, 450, 5, 3, 1),(32, 451, 1, 1, 1),(32, 452, 1, 3, 1),(32, 453, 1, 1, 1),(32, 454, 1, 3, 1),(32, 455, 1, 1, 1),(32, 456, 1, 3, 1),(32, 457, 1, 1, 1),(32, 458, 1, 3, 1),(32, 459, 1, 1, 1),(32, 460, 1, 3, 1),(32, 461, 1, 1, 1),(32, 462, 1, 3, 1),(32, 463, 1, 1, 1),(32, 464, 1, 3, 1),(32, 465, 1, 1, 1),(32, 466, 1, 3, 1),(32, 467, 1, 1, 1),(32, 468, 1, 3, 1),(32, 469, 1, 1, 1),(32, 470, 1, 3, 1),(32, 471, 1, 1, 1),(32, 472, 1, 3, 1),(32, 473, 1, 1, 1),(32, 474, 1, 3, 1),(32, 475, 1, 1, 1),(32, 476, 1, 3, 1),(32, 477, 1, 1, 1),(32, 478, 1, 3, 1),(32, 479, 5, 1, 1),(32, 480, 5, 3, 1),(32, 481, 5, 2, 1),(32, 482, 5, 4, 1),(32, 483, 1, 2, 1),(32, 484, 1, 4, 1),(32, 485, 1, 2, 1),(32, 486, 1, 4, 1),(32, 487, 1, 2, 1),(32, 488, 1, 4, 1),(32, 489, 1, 2, 1),(32, 490, 1, 4, 1),(32, 491, 1, 2, 1),(32, 492, 1, 4, 1),(32, 493, 1, 2, 1),(32, 494, 1, 4, 1),(32, 495, 1, 2, 1),(32, 496, 1, 4, 1),(32, 497, 1, 2, 1),(32, 498, 1, 4, 1),(32, 499, 1, 2, 1),(32, 500, 1, 4, 1),(32, 501, 1, 2, 1),(32, 502, 1, 4, 1),(32, 503, 1, 2, 1),(32, 504, 1, 4, 1),(32, 505, 1, 2, 1),(32, 506, 1, 4, 1),(32, 507, 1, 2, 1),(32, 508, 1, 4, 1),(32, 509, 1, 2, 1),(32, 510, 1, 4, 1),(32, 511, 5, 2, 1),(32, 512, 5, 4, 1),(32, 513, 5, 1, 1),(32, 514, 5, 3, 1),(32, 515, 1, 1, 1),(32, 516, 1, 3, 1),(32, 517, 1, 1, 1),(32, 518, 1, 3, 1),(32, 519, 1, 1, 1),(32, 520, 1, 3, 1),(32, 521, 1, 1, 1),(32, 522, 1, 3, 1),(32, 523, 1, 1, 1),(32, 524, 1, 3, 1),(32, 525, 1, 1, 1),(32, 526, 1, 3, 1),(32, 527, 1, 1, 1),(32, 528, 1, 3, 1),(32, 529, 1, 1, 1),(32, 530, 1, 3, 1),(32, 531, 1, 1, 1),(32, 532, 1, 3, 1),(32, 533, 1, 1, 1),(32, 534, 1, 3, 1),(32, 535, 1, 1, 1),(32, 536, 1, 3, 1),(32, 537, 1, 1, 1),(32, 538, 1, 3, 1),(32, 539, 1, 1, 1),(32, 540, 1, 3, 1),(32, 541, 1, 1, 1),(32, 542, 1, 3, 1),(32, 543, 5, 1, 1),(32, 544, 5, 3, 1),(32, 545, 5, 2, 1),(32, 546, 5, 4, 1),(32, 547, 1, 2, 1),(32, 548, 1, 4, 1),(32, 549, 1, 2, 1),(32, 550, 1, 4, 1),(32, 551, 1, 2, 1),(32, 552, 1, 4, 1),(32, 553, 1, 2, 1),(32, 554, 1, 4, 1),(32, 555, 1, 2, 1),(32, 556, 1, 4, 1),(32, 557, 1, 2, 1),(32, 558, 1, 4, 1),(32, 559, 1, 2, 1),(32, 560, 1, 4, 1),(32, 561, 1, 2, 1),(32, 562, 1, 4, 1),(32, 563, 1, 2, 1),(32, 564, 1, 4, 1),(32, 565, 1, 2, 1),(32, 566, 1, 4, 1),(32, 567, 1, 2, 1),(32, 568, 1, 4, 1),(32, 569, 1, 2, 1),(32, 570, 1, 4, 1),(32, 571, 1, 2, 1),(32, 572, 1, 4, 1),(32, 573, 1, 2, 1),(32, 574, 1, 4, 1),(32, 575, 5, 2, 1),(32, 576, 5, 4, 1),(32, 577, 5, 1, 1),(32, 578, 5, 3, 1),(32, 579, 1, 1, 1),(32, 580, 1, 3, 1),(32, 581, 1, 1, 1),(32, 582, 1, 3, 1),(32, 583, 1, 1, 1),(32, 584, 1, 3, 1),(32, 585, 1, 1, 1),(32, 586, 1, 3, 1),(32, 587, 1, 1, 1),(32, 588, 1, 3, 1),(32, 589, 1, 1, 1),(32, 590, 1, 3, 1),(32, 591, 1, 1, 1),(32, 592, 1, 3, 1),(32, 593, 1, 1, 1),(32, 594, 1, 3, 1),(32, 595, 1, 1, 1),(32, 596, 1, 3, 1),(32, 597, 1, 1, 1),(32, 598, 1, 3, 1),(32, 599, 1, 1, 1),(32, 600, 1, 3, 1),(32, 601, 1, 1, 1),(32, 602, 1, 3, 1),(32, 603, 1, 1, 1),(32, 604, 1, 3, 1),(32, 605, 1, 1, 1),(32, 606, 1, 3, 1),(32, 607, 5, 1, 1),(32, 608, 5, 3, 1),(32, 609, 5, 2, 1),(32, 610, 5, 4, 1),(32, 611, 1, 2, 1),(32, 612, 1, 4, 1),(32, 613, 1, 2, 1),(32, 614, 1, 4, 1),(32, 615, 1, 2, 1),(32, 616, 1, 4, 1),(32, 617, 1, 2, 1),(32, 618, 1, 4, 1),(32, 619, 1, 2, 1),(32, 620, 1, 4, 1),(32, 621, 1, 2, 1),(32, 622, 1, 4, 1),(32, 623, 1, 2, 1),(32, 624, 1, 4, 1),(32, 625, 1, 2, 1),(32, 626, 1, 4, 1),(32, 627, 1, 2, 1),(32, 628, 1, 4, 1),(32, 629, 1, 2, 1),(32, 630, 1, 4, 1),(32, 631, 1, 2, 1),(32, 632, 1, 4, 1),(32, 633, 1, 2, 1),(32, 634, 1, 4, 1),(32, 635, 1, 2, 1),(32, 636, 1, 4, 1),(32, 637, 1, 2, 1),(32, 638, 1, 4, 1),(32, 639, 5, 2, 1),(32, 640, 5, 4, 1),(32, 641, 5, 1, 1),(32, 642, 5, 3, 1),(32, 643, 1, 1, 1),(32, 644, 1, 3, 1),(32, 645, 1, 1, 1),(32, 646, 1, 3, 1),(32, 647, 1, 1, 1),(32, 648, 1, 3, 1),(32, 649, 1, 1, 1),(32, 650, 1, 3, 1),(32, 651, 1, 1, 1),(32, 652, 1, 3, 1),(32, 653, 1, 1, 1),(32, 654, 1, 3, 1),(32, 655, 1, 1, 1),(32, 656, 1, 3, 1),(32, 657, 1, 1, 1),(32, 658, 1, 3, 1),(32, 659, 1, 1, 1),(32, 660, 1, 3, 1),(32, 661, 1, 1, 1),(32, 662, 1, 3, 1),(32, 663, 1, 1, 1),(32, 664, 1, 3, 1),(32, 665, 1, 1, 1),(32, 666, 1, 3, 1),(32, 667, 1, 1, 1),(32, 668, 1, 3, 1),(32, 669, 1, 1, 1),(32, 670, 1, 3, 1),(32, 671, 5, 1, 1),(32, 672, 5, 3, 1),(32, 673, 5, 2, 1),(32, 674, 5, 4, 1),(32, 675, 1, 2, 1),(32, 676, 1, 4, 1),(32, 677, 1, 2, 1),(32, 678, 1, 4, 1),(32, 679, 1, 2, 1),(32, 680, 1, 4, 1),(32, 681, 1, 2, 1),(32, 682, 1, 4, 1),(32, 683, 1, 2, 1),(32, 684, 1, 4, 1),(32, 685, 1, 2, 1),(32, 686, 1, 4, 1),(32, 687, 1, 2, 1),(32, 688, 1, 4, 1),(32, 689, 1, 2, 1),(32, 690, 1, 4, 1),(32, 691, 1, 2, 1),(32, 692, 1, 4, 1),(32, 693, 1, 2, 1),(32, 694, 1, 4, 1),(32, 695, 1, 2, 1),(32, 696, 1, 4, 1),(32, 697, 1, 2, 1),(32, 698, 1, 4, 1),(32, 699, 1, 2, 1),(32, 700, 1, 4, 1),(32, 701, 1, 2, 1),(32, 702, 1, 4, 1),(32, 703, 5, 2, 1),(32, 704, 5, 4, 1),(32, 705, 5, 1, 1),(32, 706, 5, 3, 1),(32, 707, 1, 1, 1),(32, 708, 1, 3, 1),(32, 709, 1, 1, 1),(32, 710, 1, 3, 1),(32, 711, 1, 1, 1),(32, 712, 1, 3, 1),(32, 713, 1, 1, 1),(32, 714, 1, 3, 1),(32, 715, 1, 1, 1),(32, 716, 1, 3, 1),(32, 717, 1, 1, 1),(32, 718, 1, 3, 1),(32, 719, 1, 1, 1),(32, 720, 1, 3, 1),(32, 721, 1, 1, 1),(32, 722, 1, 3, 1),(32, 723, 1, 1, 1),(32, 724, 1, 3, 1),(32, 725, 1, 1, 1),(32, 726, 1, 3, 1),(32, 727, 1, 1, 1),(32, 728, 1, 3, 1),(32, 729, 1, 1, 1),(32, 730, 1, 3, 1),(32, 731, 1, 1, 1),(32, 732, 1, 3, 1),(32, 733, 1, 1, 1),(32, 734, 1, 3, 1),(32, 735, 5, 1, 1),(32, 736, 5, 3, 1),(32, 737, 5, 2, 1),(32, 738, 5, 4, 1),(32, 739, 1, 2, 1),(32, 740, 1, 4, 1),(32, 741, 1, 2, 1),(32, 742, 1, 4, 1),(32, 743, 1, 2, 1),(32, 744, 1, 4, 1),(32, 745, 1, 2, 1),(32, 746, 1, 4, 1),(32, 747, 1, 2, 1),(32, 748, 1, 4, 1),(32, 749, 1, 2, 1),(32, 750, 1, 4, 1),(32, 751, 1, 2, 1),(32, 752, 1, 4, 1),(32, 753, 1, 2, 1),(32, 754, 1, 4, 1),(32, 755, 1, 2, 1),(32, 756, 1, 4, 1),(32, 757, 1, 2, 1),(32, 758, 1, 4, 1),(32, 759, 1, 2, 1),(32, 760, 1, 4, 1),(32, 761, 1, 2, 1),(32, 762, 1, 4, 1),(32, 763, 1, 2, 1),(32, 764, 1, 4, 1),(32, 765, 1, 2, 1),(32, 766, 1, 4, 1),(32, 767, 5, 2, 1),(32, 768, 5, 4, 1),(32, 769, 5, 1, 1),(32, 770, 5, 3, 1),(32, 771, 1, 1, 1),(32, 772, 1, 3, 1),(32, 773, 1, 1, 1),(32, 774, 1, 3, 1),(32, 775, 1, 1, 1),(32, 776, 1, 3, 1),(32, 777, 1, 1, 1),(32, 778, 1, 3, 1),(32, 779, 1, 1, 1),(32, 780, 1, 3, 1),(32, 781, 1, 1, 1),(32, 782, 1, 3, 1),(32, 783, 1, 1, 1),(32, 784, 1, 3, 1),(32, 785, 1, 1, 1),(32, 786, 1, 3, 1),(32, 787, 1, 1, 1),(32, 788, 1, 3, 1),(32, 789, 1, 1, 1),(32, 790, 1, 3, 1),(32, 791, 1, 1, 1),(32, 792, 1, 3, 1),(32, 793, 1, 1, 1),(32, 794, 1, 3, 1),(32, 795, 1, 1, 1),(32, 796, 1, 3, 1),(32, 797, 1, 1, 1),(32, 798, 1, 3, 1),(32, 799, 5, 1, 1),(32, 800, 5, 3, 1),(32, 801, 5, 2, 1),(32, 802, 5, 4, 1),(32, 803, 1, 2, 1),(32, 804, 1, 4, 1),(32, 805, 1, 2, 1),(32, 806, 1, 4, 1),(32, 807, 1, 2, 1),(32, 808, 1, 4, 1),(32, 809, 1, 2, 1),(32, 810, 1, 4, 1),(32, 811, 1, 2, 1),(32, 812, 1, 4, 1),(32, 813, 1, 2, 1),(32, 814, 1, 4, 1),(32, 815, 1, 2, 1),(32, 816, 1, 4, 1),(32, 817, 1, 2, 1),(32, 818, 1, 4, 1),(32, 819, 1, 2, 1),(32, 820, 1, 4, 1),(32, 821, 1, 2, 1),(32, 822, 1, 4, 1),(32, 823, 1, 2, 1),(32, 824, 1, 4, 1),(32, 825, 1, 2, 1),(32, 826, 1, 4, 1),(32, 827, 1, 2, 1),(32, 828, 1, 4, 1),(32, 829, 1, 2, 1),(32, 830, 1, 4, 1),(32, 831, 5, 2, 1),(32, 832, 5, 4, 1),(32, 833, 5, 1, 1),(32, 834, 5, 3, 1),(32, 835, 1, 1, 1),(32, 836, 1, 3, 1),(32, 837, 1, 1, 1),(32, 838, 1, 3, 1),(32, 839, 1, 1, 1),(32, 840, 1, 3, 1),(32, 841, 1, 1, 1),(32, 842, 1, 3, 1),(32, 843, 1, 1, 1),(32, 844, 1, 3, 1),(32, 845, 1, 1, 1),(32, 846, 1, 3, 1),(32, 847, 1, 1, 1),(32, 848, 1, 3, 1),(32, 849, 1, 1, 1),(32, 850, 1, 3, 1),(32, 851, 1, 1, 1),(32, 852, 1, 3, 1),(32, 853, 1, 1, 1),(32, 854, 1, 3, 1),(32, 855, 1, 1, 1),(32, 856, 1, 3, 1),(32, 857, 1, 1, 1),(32, 858, 1, 3, 1),(32, 859, 1, 1, 1),(32, 860, 1, 3, 1),(32, 861, 1, 1, 1),(32, 862, 1, 3, 1),(32, 863, 5, 1, 1),(32, 864, 5, 3, 1),(32, 865, 5, 2, 1),(32, 866, 5, 4, 1),(32, 867, 1, 2, 1),(32, 868, 1, 4, 1),(32, 869, 1, 2, 1),(32, 870, 1, 4, 1),(32, 871, 1, 2, 1),(32, 872, 1, 4, 1),(32, 873, 1, 2, 1),(32, 874, 1, 4, 1),(32, 875, 1, 2, 1),(32, 876, 1, 4, 1),(32, 877, 1, 2, 1),(32, 878, 1, 4, 1),(32, 879, 1, 2, 1),(32, 880, 1, 4, 1),(32, 881, 1, 2, 1),(32, 882, 1, 4, 1),(32, 883, 1, 2, 1),(32, 884, 1, 4, 1),(32, 885, 1, 2, 1),(32, 886, 1, 4, 1),(32, 887, 1, 2, 1),(32, 888, 1, 4, 1),(32, 889, 1, 2, 1),(32, 890, 1, 4, 1),(32, 891, 1, 2, 1),(32, 892, 1, 4, 1),(32, 893, 1, 2, 1),(32, 894, 1, 4, 1),(32, 895, 5, 2, 1),(32, 896, 5, 4, 1),(32, 897, 5, 1, 1),(32, 898, 5, 3, 1),(32, 899, 1, 1, 1),(32, 900, 1, 3, 1),(32, 901, 1, 1, 1),(32, 902, 1, 3, 1),(32, 903, 1, 1, 1),(32, 904, 1, 3, 1),(32, 905, 1, 1, 1),(32, 906, 1, 3, 1),(32, 907, 1, 1, 1),(32, 908, 1, 3, 1),(32, 909, 1, 1, 1),(32, 910, 1, 3, 1),(32, 911, 1, 1, 1),(32, 912, 1, 3, 1),(32, 913, 1, 1, 1),(32, 914, 1, 3, 1),(32, 915, 1, 1, 1),(32, 916, 1, 3, 1),(32, 917, 1, 1, 1),(32, 918, 1, 3, 1),(32, 919, 1, 1, 1),(32, 920, 1, 3, 1),(32, 921, 1, 1, 1),(32, 922, 1, 3, 1),(32, 923, 1, 1, 1),(32, 924, 1, 3, 1),(32, 925, 1, 1, 1),(32, 926, 1, 3, 1),(32, 927, 5, 1, 1),(32, 928, 5, 3, 1),(32, 929, 5, 2, 1),(32, 930, 5, 4, 1),(32, 931, 1, 2, 1),(32, 932, 1, 4, 1),(32, 933, 1, 2, 1),(32, 934, 1, 4, 1),(32, 935, 1, 2, 1),(32, 936, 1, 4, 1),(32, 937, 1, 2, 1),(32, 938, 1, 4, 1),(32, 939, 1, 2, 1),(32, 940, 1, 4, 1),(32, 941, 1, 2, 1),(32, 942, 1, 4, 1),(32, 943, 1, 2, 1),(32, 944, 1, 4, 1),(32, 945, 1, 2, 1),(32, 946, 1, 4, 1),(32, 947, 1, 2, 1),(32, 948, 1, 4, 1),(32, 949, 1, 2, 1),(32, 950, 1, 4, 1),(32, 951, 1, 2, 1),(32, 952, 1, 4, 1),(32, 953, 1, 2, 1),(32, 954, 1, 4, 1),(32, 955, 1, 2, 1),(32, 956, 1, 4, 1),(32, 957, 1, 2, 1),(32, 958, 1, 4, 1),(32, 959, 5, 2, 1),(32, 960, 5, 4, 1),(32, 961, 5, 1, 1),(32, 962, 5, 3, 1),(32, 963, 1, 1, 1),(32, 964, 1, 3, 1),(32, 965, 1, 1, 1),(32, 966, 1, 3, 1),(32, 967, 1, 1, 1),(32, 968, 1, 3, 1),(32, 969, 1, 1, 1),(32, 970, 1, 3, 1),(32, 971, 1, 1, 1),(32, 972, 1, 3, 1),(32, 973, 1, 1, 1),(32, 974, 1, 3, 1),(32, 975, 1, 1, 1),(32, 976, 1, 3, 1),(32, 977, 1, 1, 1),(32, 978, 1, 3, 1),(32, 979, 1, 1, 1),(32, 980, 1, 3, 1),(32, 981, 1, 1, 1),(32, 982, 1, 3, 1),(32, 983, 1, 1, 1),(32, 984, 1, 3, 1),(32, 985, 1, 1, 1),(32, 986, 1, 3, 1),(32, 987, 1, 1, 1),(32, 988, 1, 3, 1),(32, 989, 1, 1, 1),(32, 990, 1, 3, 1),(32, 991, 5, 1, 1),(32, 992, 5, 3, 1),(32, 993, 5, 2, 1),(32, 994, 5, 4, 1),(32, 995, 1, 2, 1),(32, 996, 1, 4, 1),(32, 997, 1, 2, 1),(32, 998, 1, 4, 1),(32, 999, 1, 2, 1),(32, 1000, 1, 4, 1),(32, 1001, 1, 2, 1),(32, 1002, 1, 4, 1),(32, 1003, 1, 2, 1),(32, 1004, 1, 4, 1),(32, 1005, 1, 2, 1),(32, 1006, 1, 4, 1),(32, 1007, 1, 2, 1),(32, 1008, 1, 4, 1),(32, 1009, 1, 2, 1),(32, 1010, 1, 4, 1),(32, 1011, 1, 2, 1),(32, 1012, 1, 4, 1),(32, 1013, 1, 2, 1),(32, 1014, 1, 4, 1),(32, 1015, 1, 2, 1),(32, 1016, 1, 4, 1),(32, 1017, 1, 2, 1),(32, 1018, 1, 4, 1),(32, 1019, 1, 2, 1),(32, 1020, 1, 4, 1),(32, 1021, 1, 2, 1),(32, 1022, 1, 4, 1),(32, 1023, 5, 2, 1),(32, 1024, 5, 4, 1),(32, 1025, 5, 1, 1),(32, 1026, 5, 3, 1),(32, 1027, 1, 1, 1),(32, 1028, 1, 3, 1),(32, 1029, 1, 1, 1),(32, 1030, 1, 3, 1),(32, 1031, 1, 1, 1),(32, 1032, 1, 3, 1),(32, 1033, 1, 1, 1),(32, 1034, 1, 3, 1),(32, 1035, 1, 1, 1),(32, 1036, 1, 3, 1),(32, 1037, 1, 1, 1),(32, 1038, 1, 3, 1),(32, 1039, 1, 1, 1),(32, 1040, 1, 3, 1),(32, 1041, 1, 1, 1),(32, 1042, 1, 3, 1),(32, 1043, 1, 1, 1),(32, 1044, 1, 3, 1),(32, 1045, 1, 1, 1),(32, 1046, 1, 3, 1),(32, 1047, 1, 1, 1),(32, 1048, 1, 3, 1),(32, 1049, 1, 1, 1),(32, 1050, 1, 3, 1),(32, 1051, 1, 1, 1),(32, 1052, 1, 3, 1),(32, 1053, 1, 1, 1),(32, 1054, 1, 3, 1),(32, 1055, 5, 1, 1),(32, 1056, 5, 3, 1),(32, 1057, 5, 2, 1),(32, 1058, 5, 4, 1),(32, 1059, 1, 2, 1),(32, 1060, 1, 4, 1),(32, 1061, 1, 2, 1),(32, 1062, 1, 4, 1),(32, 1063, 1, 2, 1),(32, 1064, 1, 4, 1),(32, 1065, 1, 2, 1),(32, 1066, 1, 4, 1),(32, 1067, 1, 2, 1),(32, 1068, 1, 4, 1),(32, 1069, 1, 2, 1),(32, 1070, 1, 4, 1),(32, 1071, 1, 2, 1),(32, 1072, 1, 4, 1),(32, 1073, 1, 2, 1),(32, 1074, 1, 4, 1),(32, 1075, 1, 2, 1),(32, 1076, 1, 4, 1),(32, 1077, 1, 2, 1),(32, 1078, 1, 4, 1),(32, 1079, 1, 2, 1),(32, 1080, 1, 4, 1),(32, 1081, 1, 2, 1),(32, 1082, 1, 4, 1),(32, 1083, 1, 2, 1),(32, 1084, 1, 4, 1),(32, 1085, 1, 2, 1),(32, 1086, 1, 4, 1),(32, 1087, 5, 2, 1),(32, 1088, 5, 4, 1),(32, 1089, 5, 1, 1),(32, 1090, 5, 3, 1),(32, 1091, 1, 1, 1),(32, 1092, 1, 3, 1),(32, 1093, 1, 1, 1),(32, 1094, 1, 3, 1),(32, 1095, 1, 1, 1),(32, 1096, 1, 3, 1),(32, 1097, 1, 1, 1),(32, 1098, 1, 3, 1),(32, 1099, 1, 1, 1),(32, 1100, 1, 3, 1),(32, 1101, 1, 1, 1),(32, 1102, 1, 3, 1),(32, 1103, 1, 1, 1),(32, 1104, 1, 3, 1),(32, 1105, 1, 1, 1),(32, 1106, 1, 3, 1),(32, 1107, 1, 1, 1),(32, 1108, 1, 3, 1),(32, 1109, 1, 1, 1),(32, 1110, 1, 3, 1),(32, 1111, 1, 1, 1),(32, 1112, 1, 3, 1),(32, 1113, 1, 1, 1),(32, 1114, 1, 3, 1),(32, 1115, 1, 1, 1),(32, 1116, 1, 3, 1),(32, 1117, 1, 1, 1),(32, 1118, 1, 3, 1),(32, 1119, 5, 1, 1),(32, 1120, 5, 3, 1),(32, 1121, 5, 2, 1),(32, 1122, 5, 4, 1),(32, 1123, 1, 2, 1),(32, 1124, 1, 4, 1),(32, 1125, 1, 2, 1),(32, 1126, 1, 4, 1),(32, 1127, 1, 2, 1),(32, 1128, 1, 4, 1),(32, 1129, 1, 2, 1),(32, 1130, 1, 4, 1),(32, 1131, 1, 2, 1),(32, 1132, 1, 4, 1),(32, 1133, 1, 2, 1),(32, 1134, 1, 4, 1),(32, 1135, 1, 2, 1),(32, 1136, 1, 4, 1),(32, 1137, 1, 2, 1),(32, 1138, 1, 4, 1),(32, 1139, 1, 2, 1),(32, 1140, 1, 4, 1),(32, 1141, 1, 2, 1),(32, 1142, 1, 4, 1),(32, 1143, 1, 2, 1),(32, 1144, 1, 4, 1),(32, 1145, 1, 2, 1),(32, 1146, 1, 4, 1),(32, 1147, 1, 2, 1),(32, 1148, 1, 4, 1),(32, 1149, 1, 2, 1),(32, 1150, 1, 4, 1),(32, 1151, 5, 2, 1),(32, 1152, 5, 4, 1),(32, 1153, 5, 1, 1),(32, 1154, 5, 3, 1),(32, 1155, 1, 1, 1),(32, 1156, 1, 3, 1),(32, 1157, 1, 1, 1),(32, 1158, 1, 3, 1),(32, 1159, 1, 1, 1),(32, 1160, 1, 3, 1),(32, 1161, 1, 1, 1),(32, 1162, 1, 3, 1),(32, 1163, 1, 1, 1),(32, 1164, 1, 3, 1),(32, 1165, 1, 1, 1),(32, 1166, 1, 3, 1),(32, 1167, 1, 1, 1),(32, 1168, 1, 3, 1),(32, 1169, 1, 1, 1),(32, 1170, 1, 3, 1),(32, 1171, 1, 1, 1),(32, 1172, 1, 3, 1),(32, 1173, 1, 1, 1),(32, 1174, 1, 3, 1),(32, 1175, 1, 1, 1),(32, 1176, 1, 3, 1),(32, 1177, 1, 1, 1),(32, 1178, 1, 3, 1),(32, 1179, 1, 1, 1),(32, 1180, 1, 3, 1),(32, 1181, 1, 1, 1),(32, 1182, 1, 3, 1),(32, 1183, 5, 1, 1),(32, 1184, 5, 3, 1),(32, 1185, 5, 2, 1),(32, 1186, 5, 4, 1),(32, 1187, 1, 2, 1),(32, 1188, 1, 4, 1),(32, 1189, 1, 2, 1),(32, 1190, 1, 4, 1),(32, 1191, 1, 2, 1),(32, 1192, 1, 4, 1),(32, 1193, 1, 2, 1),(32, 1194, 1, 4, 1),(32, 1195, 1, 2, 1),(32, 1196, 1, 4, 1),(32, 1197, 1, 2, 1),(32, 1198, 1, 4, 1),(32, 1199, 1, 2, 1),(32, 1200, 1, 4, 1),(32, 1201, 1, 2, 1),(32, 1202, 1, 4, 1),(32, 1203, 1, 2, 1),(32, 1204, 1, 4, 1),(32, 1205, 1, 2, 1),(32, 1206, 1, 4, 1),(32, 1207, 1, 2, 1),(32, 1208, 1, 4, 1),(32, 1209, 1, 2, 1),(32, 1210, 1, 4, 1),(32, 1211, 1, 2, 1),(32, 1212, 1, 4, 1),(32, 1213, 1, 2, 1),(32, 1214, 1, 4, 1),(32, 1215, 5, 2, 1),(32, 1216, 5, 4, 1),(32, 1217, 5, 1, 1),(32, 1218, 5, 3, 1),(32, 1219, 1, 1, 1),(32, 1220, 1, 3, 1),(32, 1221, 1, 1, 1),(32, 1222, 1, 3, 1),(32, 1223, 1, 1, 1),(32, 1224, 1, 3, 1),(32, 1225, 1, 1, 1),(32, 1226, 1, 3, 1),(32, 1227, 1, 1, 1),(32, 1228, 1, 3, 1),(32, 1229, 1, 1, 1),(32, 1230, 1, 3, 1),(32, 1231, 1, 1, 1),(32, 1232, 1, 3, 1),(32, 1233, 1, 1, 1),(32, 1234, 1, 3, 1),(32, 1235, 1, 1, 1),(32, 1236, 1, 3, 1),(32, 1237, 1, 1, 1),(32, 1238, 1, 3, 1),(32, 1239, 1, 1, 1),(32, 1240, 1, 3, 1),(32, 1241, 1, 1, 1),(32, 1242, 1, 3, 1),(32, 1243, 1, 1, 1),(32, 1244, 1, 3, 1),(32, 1245, 1, 1, 1),(32, 1246, 1, 3, 1),(32, 1247, 5, 1, 1),(32, 1248, 5, 3, 1),(32, 1249, 5, 2, 1),(32, 1250, 5, 4, 1),(32, 1251, 1, 2, 1),(32, 1252, 1, 4, 1),(32, 1253, 1, 2, 1),(32, 1254, 1, 4, 1),(32, 1255, 1, 2, 1),(32, 1256, 1, 4, 1),(32, 1257, 1, 2, 1),(32, 1258, 1, 4, 1),(32, 1259, 1, 2, 1),(32, 1260, 1, 4, 1),(32, 1261, 1, 2, 1),(32, 1262, 1, 4, 1),(32, 1263, 1, 2, 1),(32, 1264, 1, 4, 1),(32, 1265, 1, 2, 1),(32, 1266, 1, 4, 1),(32, 1267, 1, 2, 1),(32, 1268, 1, 4, 1),(32, 1269, 1, 2, 1),(32, 1270, 1, 4, 1),(32, 1271, 1, 2, 1),(32, 1272, 1, 4, 1),(32, 1273, 1, 2, 1),(32, 1274, 1, 4, 1),(32, 1275, 1, 2, 1),(32, 1276, 1, 4, 1),(32, 1277, 1, 2, 1),(32, 1278, 1, 4, 1),(32, 1279, 5, 2, 1),(32, 1280, 5, 4, 1),(32, 1281, 5, 1, 1),(32, 1282, 5, 3, 1),(32, 1283, 1, 1, 1),(32, 1284, 1, 3, 1),(32, 1285, 1, 1, 1),(32, 1286, 1, 3, 1),(32, 1287, 1, 1, 1),(32, 1288, 1, 3, 1),(32, 1289, 1, 1, 1),(32, 1290, 1, 3, 1),(32, 1291, 1, 1, 1),(32, 1292, 1, 3, 1),(32, 1293, 1, 1, 1),(32, 1294, 1, 3, 1),(32, 1295, 1, 1, 1),(32, 1296, 1, 3, 1),(32, 1297, 1, 1, 1),(32, 1298, 1, 3, 1),(32, 1299, 1, 1, 1),(32, 1300, 1, 3, 1),(32, 1301, 1, 1, 1),(32, 1302, 1, 3, 1),(32, 1303, 1, 1, 1),(32, 1304, 1, 3, 1),(32, 1305, 1, 1, 1),(32, 1306, 1, 3, 1),(32, 1307, 1, 1, 1),(32, 1308, 1, 3, 1),(32, 1309, 1, 1, 1),(32, 1310, 1, 3, 1),(32, 1311, 5, 1, 1),(32, 1312, 5, 3, 1),(32, 1313, 5, 2, 1),(32, 1314, 5, 4, 1),(32, 1315, 1, 2, 1),(32, 1316, 1, 4, 1),(32, 1317, 1, 2, 1),(32, 1318, 1, 4, 1),(32, 1319, 1, 2, 1),(32, 1320, 1, 4, 1),(32, 1321, 1, 2, 1),(32, 1322, 1, 4, 1),(32, 1323, 1, 2, 1),(32, 1324, 1, 4, 1),(32, 1325, 1, 2, 1),(32, 1326, 1, 4, 1),(32, 1327, 1, 2, 1),(32, 1328, 1, 4, 1),(32, 1329, 1, 2, 1),(32, 1330, 1, 4, 1),(32, 1331, 1, 2, 1),(32, 1332, 1, 4, 1),(32, 1333, 1, 2, 1),(32, 1334, 1, 4, 1),(32, 1335, 1, 2, 1),(32, 1336, 1, 4, 1),(32, 1337, 1, 2, 1),(32, 1338, 1, 4, 1),(32, 1339, 1, 2, 1),(32, 1340, 1, 4, 1),(32, 1341, 1, 2, 1),(32, 1342, 1, 4, 1),(32, 1343, 5, 2, 1),(32, 1344, 5, 4, 1),(32, 1345, 5, 1, 1),(32, 1346, 5, 3, 1),(32, 1347, 1, 1, 1),(32, 1348, 1, 3, 1),(32, 1349, 1, 1, 1),(32, 1350, 1, 3, 1),(32, 1351, 1, 1, 1),(32, 1352, 1, 3, 1),(32, 1353, 1, 1, 1),(32, 1354, 1, 3, 1),(32, 1355, 1, 1, 1),(32, 1356, 1, 3, 1),(32, 1357, 1, 1, 1),(32, 1358, 1, 3, 1),(32, 1359, 1, 1, 1),(32, 1360, 1, 3, 1),(32, 1361, 1, 1, 1),(32, 1362, 1, 3, 1),(32, 1363, 1, 1, 1),(32, 1364, 1, 3, 1),(32, 1365, 1, 1, 1),(32, 1366, 1, 3, 1),(32, 1367, 1, 1, 1),(32, 1368, 1, 3, 1),(32, 1369, 1, 1, 1),(32, 1370, 1, 3, 1),(32, 1371, 1, 1, 1),(32, 1372, 1, 3, 1),(32, 1373, 1, 1, 1),(32, 1374, 1, 3, 1),(32, 1375, 5, 1, 1),(32, 1376, 5, 3, 1),(32, 1377, 5, 2, 1),(32, 1378, 5, 4, 1),(32, 1379, 1, 2, 1),(32, 1380, 1, 4, 1),(32, 1381, 1, 2, 1),(32, 1382, 1, 4, 1),(32, 1383, 1, 2, 1),(32, 1384, 1, 4, 1),(32, 1385, 1, 2, 1),(32, 1386, 1, 4, 1),(32, 1387, 1, 2, 1),(32, 1388, 1, 4, 1),(32, 1389, 1, 2, 1),(32, 1390, 1, 4, 1),(32, 1391, 1, 2, 1),(32, 1392, 1, 4, 1),(32, 1393, 1, 2, 1),(32, 1394, 1, 4, 1),(32, 1395, 1, 2, 1),(32, 1396, 1, 4, 1),(32, 1397, 1, 2, 1),(32, 1398, 1, 4, 1),(32, 1399, 1, 2, 1),(32, 1400, 1, 4, 1),(32, 1401, 1, 2, 1),(32, 1402, 1, 4, 1),(32, 1403, 1, 2, 1),(32, 1404, 1, 4, 1),(32, 1405, 1, 2, 1),(32, 1406, 1, 4, 1),(32, 1407, 5, 2, 1),(32, 1408, 5, 4, 1),(32, 1409, 5, 1, 1),(32, 1410, 5, 3, 1),(32, 1411, 2, 1, 1),(32, 1412, 2, 3, 1),(32, 1413, 2, 1, 1),(32, 1414, 2, 3, 1),(32, 1415, 2, 1, 1),(32, 1416, 2, 3, 1),(32, 1417, 2, 1, 1),(32, 1418, 2, 3, 1),(32, 1419, 2, 1, 1),(32, 1420, 2, 3, 1),(32, 1421, 2, 1, 1),(32, 1422, 2, 3, 1),(32, 1423, 2, 1, 1),(32, 1424, 2, 3, 1),(32, 1425, 3, 1, 1),(32, 1426, 3, 3, 1),(32, 1427, 3, 1, 1),(32, 1428, 3, 3, 1),(32, 1429, 3, 1, 1),(32, 1430, 3, 3, 1),(32, 1431, 3, 1, 1),(32, 1432, 3, 3, 1),(32, 1433, 4, 1, 1),(32, 1434, 4, 3, 1),(32, 1435, 4, 1, 1),(32, 1436, 4, 3, 1),(32, 1437, 4, 1, 1),(32, 1438, 4, 3, 1),(32, 1439, 5, 1, 1),(32, 1440, 5, 3, 1),(32, 1441, 5, 2, 1),(32, 1442, 5, 4, 1),(32, 1443, 2, 2, 1),(32, 1444, 2, 4, 1),(32, 1445, 2, 2, 1),(32, 1446, 2, 4, 1),(32, 1447, 2, 2, 1),(32, 1448, 2, 4, 1),(32, 1449, 2, 2, 1),(32, 1450, 2, 4, 1),(32, 1451, 2, 2, 1),(32, 1452, 2, 4, 1),(32, 1453, 2, 2, 1),(32, 1454, 2, 4, 1),(32, 1455, 2, 2, 1),(32, 1456, 2, 4, 1),(32, 1457, 3, 2, 1),(32, 1458, 3, 4, 1),(32, 1459, 3, 2, 1),(32, 1460, 3, 4, 1),(32, 1461, 3, 2, 1),(32, 1462, 3, 4, 1),(32, 1463, 3, 2, 1),(32, 1464, 3, 4, 1),(32, 1465, 4, 2, 1),(32, 1466, 4, 4, 1),(32, 1467, 4, 2, 1),(32, 1468, 4, 4, 1),(32, 1469, 4, 2, 1),(32, 1470, 4, 4, 1),(32, 1471, 5, 2, 1),(32, 1472, 5, 4, 1),(32, 1473, 5, 1, 1),(32, 1474, 5, 3, 1),(32, 1475, 5, 1, 1),(32, 1476, 5, 3, 1),(32, 1477, 5, 1, 1),(32, 1478, 5, 3, 1),(32, 1479, 5, 1, 1),(32, 1480, 5, 3, 1),(32, 1481, 5, 1, 1),(32, 1482, 5, 3, 1),(32, 1483, 5, 1, 1),(32, 1484, 5, 3, 1),(32, 1485, 5, 1, 1),(32, 1486, 5, 3, 1),(32, 1487, 5, 1, 1),(32, 1488, 5, 3, 1),(32, 1489, 5, 1, 1),(32, 1490, 5, 3, 1),(32, 1491, 5, 1, 1),(32, 1492, 5, 3, 1),(32, 1493, 5, 1, 1),(32, 1494, 5, 3, 1),(32, 1495, 5, 1, 1),(32, 1496, 5, 3, 1),(32, 1497, 5, 1, 1),(32, 1498, 5, 3, 1),(32, 1499, 5, 1, 1),(32, 1500, 5, 3, 1),(32, 1501, 5, 1, 1),(32, 1502, 5, 3, 1),(32, 1503, 5, 1, 1),(32, 1504, 5, 3, 1),(32, 1505, 5, 2, 1),(32, 1506, 5, 4, 1),(32, 1507, 5, 2, 1),(32, 1508, 5, 4, 1),(32, 1509, 5, 2, 1),(32, 1510, 5, 4, 1),(32, 1511, 5, 2, 1),(32, 1512, 5, 4, 1),(32, 1513, 5, 2, 1),(32, 1514, 5, 4, 1),(32, 1515, 5, 2, 1),(32, 1516, 5, 4, 1),(32, 1517, 5, 2, 1),(32, 1518, 5, 4, 1),(32, 1519, 5, 2, 1),(32, 1520, 5, 4, 1),(32, 1521, 5, 2, 1),(32, 1522, 5, 4, 1),(32, 1523, 5, 2, 1),(32, 1524, 5, 4, 1),(32, 1525, 5, 2, 1),(32, 1526, 5, 4, 1),(32, 1527, 5, 2, 1),(32, 1528, 5, 4, 1),(32, 1529, 5, 2, 1),(32, 1530, 5, 4, 1),(32, 1531, 5, 2, 1),(32, 1532, 5, 4, 1),(32, 1533, 5, 2, 1),(32, 1534, 5, 4, 1),(32, 1535, 5, 2, 1),(32, 1536, 5, 4, 1),(33, 1, 5, 1, 1),(33, 2, 5, 2, 1),(33, 3, 5, 1, 1),(33, 4, 5, 2, 1),(33, 5, 5, 1, 1),(33, 6, 5, 2, 1),(33, 7, 5, 1, 1),(33, 8, 5, 2, 1),(33, 9, 5, 1, 1),(33, 10, 5, 2, 1),(33, 11, 5, 1, 1),(33, 12, 5, 2, 1),(33, 13, 5, 1, 1),(33, 14, 5, 2, 1),(33, 15, 5, 1, 1),(33, 16, 5, 2, 1),(33, 17, 5, 1, 1),(33, 18, 5, 2, 1),(33, 19, 5, 1, 1),(33, 20, 5, 2, 1),(33, 21, 5, 1, 1),(33, 22, 5, 2, 1),(33, 23, 5, 1, 1),(33, 24, 5, 2, 1),(33, 25, 5, 1, 1),(33, 26, 5, 2, 1),(33, 27, 5, 1, 1),(33, 28, 5, 2, 1),(33, 29, 5, 1, 1),(33, 30, 5, 2, 1),(33, 31, 5, 1, 1),(33, 32, 5, 2, 1),(33, 33, 5, 1, 2),(33, 34, 5, 2, 2),(33, 35, 5, 1, 2),(33, 36, 5, 2, 2),(33, 37, 5, 1, 2),(33, 38, 5, 2, 2),(33, 39, 5, 1, 2),(33, 40, 5, 2, 2),(33, 41, 5, 1, 2),(33, 42, 5, 2, 2),(33, 43, 5, 1, 2),(33, 44, 5, 2, 2),(33, 45, 5, 1, 2),(33, 46, 5, 2, 2),(33, 47, 5, 1, 2),(33, 48, 5, 2, 2),(33, 49, 5, 1, 2),(33, 50, 5, 2, 2),(33, 51, 5, 1, 2),(33, 52, 5, 2, 2),(33, 53, 5, 1, 2),(33, 54, 5, 2, 2),(33, 55, 5, 1, 2),(33, 56, 5, 2, 2),(33, 57, 5, 1, 2),(33, 58, 5, 2, 2),(33, 59, 5, 1, 2),(33, 60, 5, 2, 2),(33, 61, 5, 1, 2),(33, 62, 5, 2, 2),(33, 63, 5, 1, 2),(33, 64, 5, 2, 2),(33, 65, 5, 1, 1),(33, 66, 5, 2, 1),(33, 67, 1, 1, 1),(33, 68, 1, 2, 1),(33, 69, 1, 1, 1),(33, 70, 1, 2, 1),(33, 71, 1, 1, 1),(33, 72, 1, 2, 1),(33, 73, 1, 1, 1),(33, 74, 1, 2, 1),(33, 75, 1, 1, 1),(33, 76, 1, 2, 1),(33, 77, 1, 1, 1),(33, 78, 1, 2, 1),(33, 79, 1, 1, 1),(33, 80, 1, 2, 1),(33, 81, 1, 1, 1),(33, 82, 1, 2, 1),(33, 83, 1, 1, 1),(33, 84, 1, 2, 1),(33, 85, 1, 1, 1),(33, 86, 1, 2, 1),(33, 87, 1, 1, 1),(33, 88, 1, 2, 1),(33, 89, 1, 1, 1),(33, 90, 1, 2, 1),(33, 91, 1, 1, 1),(33, 92, 1, 2, 1),(33, 93, 1, 1, 1),(33, 94, 1, 2, 1),(33, 95, 5, 1, 1),(33, 96, 5, 2, 1),(33, 97, 5, 1, 2),(33, 98, 5, 2, 2),(33, 99, 1, 1, 2),(33, 100, 1, 2, 2),(33, 101, 1, 1, 2),(33, 102, 1, 2, 2),(33, 103, 1, 1, 2),(33, 104, 1, 2, 2),(33, 105, 1, 1, 2),(33, 106, 1, 2, 2),(33, 107, 1, 1, 2),(33, 108, 1, 2, 2),(33, 109, 1, 1, 2),(33, 110, 1, 2, 2),(33, 111, 1, 1, 2),(33, 112, 1, 2, 2),(33, 113, 1, 1, 2),(33, 114, 1, 2, 2),(33, 115, 1, 1, 2),(33, 116, 1, 2, 2),(33, 117, 1, 1, 2),(33, 118, 1, 2, 2),(33, 119, 1, 1, 2),(33, 120, 1, 2, 2),(33, 121, 1, 1, 2),(33, 122, 1, 2, 2),(33, 123, 1, 1, 2),(33, 124, 1, 2, 2),(33, 125, 1, 1, 2),(33, 126, 1, 2, 2),(33, 127, 5, 1, 2),(33, 128, 5, 2, 2),(33, 129, 5, 1, 1),(33, 130, 5, 2, 1),(33, 131, 1, 1, 1),(33, 132, 1, 2, 1),(33, 133, 1, 1, 1),(33, 134, 1, 2, 1),(33, 135, 1, 1, 1),(33, 136, 1, 2, 1),(33, 137, 1, 1, 1),(33, 138, 1, 2, 1),(33, 139, 1, 1, 1),(33, 140, 1, 2, 1),(33, 141, 1, 1, 1),(33, 142, 1, 2, 1),(33, 143, 1, 1, 1),(33, 144, 1, 2, 1),(33, 145, 1, 1, 1),(33, 146, 1, 2, 1),(33, 147, 1, 1, 1),(33, 148, 1, 2, 1),(33, 149, 1, 1, 1),(33, 150, 1, 2, 1),(33, 151, 1, 1, 1),(33, 152, 1, 2, 1),(33, 153, 1, 1, 1),(33, 154, 1, 2, 1),(33, 155, 1, 1, 1),(33, 156, 1, 2, 1),(33, 157, 1, 1, 1),(33, 158, 1, 2, 1),(33, 159, 5, 1, 1),(33, 160, 5, 2, 1),(33, 161, 5, 1, 2),(33, 162, 5, 2, 2),(33, 163, 1, 1, 2),(33, 164, 1, 2, 2),(33, 165, 1, 1, 2),(33, 166, 1, 2, 2),(33, 167, 1, 1, 2),(33, 168, 1, 2, 2),(33, 169, 1, 1, 2),(33, 170, 1, 2, 2),(33, 171, 1, 1, 2),(33, 172, 1, 2, 2),(33, 173, 1, 1, 2),(33, 174, 1, 2, 2),(33, 175, 1, 1, 2),(33, 176, 1, 2, 2),(33, 177, 1, 1, 2),(33, 178, 1, 2, 2),(33, 179, 1, 1, 2),(33, 180, 1, 2, 2),(33, 181, 1, 1, 2),(33, 182, 1, 2, 2),(33, 183, 1, 1, 2),(33, 184, 1, 2, 2),(33, 185, 1, 1, 2),(33, 186, 1, 2, 2),(33, 187, 1, 1, 2),(33, 188, 1, 2, 2),(33, 189, 1, 1, 2),(33, 190, 1, 2, 2),(33, 191, 5, 1, 2),(33, 192, 5, 2, 2),(33, 193, 5, 1, 1),(33, 194, 5, 2, 1),(33, 195, 1, 1, 1),(33, 196, 1, 2, 1),(33, 197, 1, 1, 1),(33, 198, 1, 2, 1),(33, 199, 1, 1, 1),(33, 200, 1, 2, 1),(33, 201, 1, 1, 1),(33, 202, 1, 2, 1),(33, 203, 1, 1, 1),(33, 204, 1, 2, 1),(33, 205, 1, 1, 1),(33, 206, 1, 2, 1),(33, 207, 1, 1, 1),(33, 208, 1, 2, 1),(33, 209, 1, 1, 1),(33, 210, 1, 2, 1),(33, 211, 1, 1, 1),(33, 212, 1, 2, 1),(33, 213, 1, 1, 1),(33, 214, 1, 2, 1),(33, 215, 1, 1, 1),(33, 216, 1, 2, 1),(33, 217, 1, 1, 1),(33, 218, 1, 2, 1),(33, 219, 1, 1, 1),(33, 220, 1, 2, 1),(33, 221, 1, 1, 1),(33, 222, 1, 2, 1),(33, 223, 5, 1, 1),(33, 224, 5, 2, 1),(33, 225, 5, 1, 2),(33, 226, 5, 2, 2),(33, 227, 1, 1, 2),(33, 228, 1, 2, 2),(33, 229, 1, 1, 2),(33, 230, 1, 2, 2),(33, 231, 1, 1, 2),(33, 232, 1, 2, 2),(33, 233, 1, 1, 2),(33, 234, 1, 2, 2),(33, 235, 1, 1, 2),(33, 236, 1, 2, 2),(33, 237, 1, 1, 2),(33, 238, 1, 2, 2),(33, 239, 1, 1, 2),(33, 240, 1, 2, 2),(33, 241, 1, 1, 2),(33, 242, 1, 2, 2),(33, 243, 1, 1, 2),(33, 244, 1, 2, 2),(33, 245, 1, 1, 2),(33, 246, 1, 2, 2),(33, 247, 1, 1, 2),(33, 248, 1, 2, 2),(33, 249, 1, 1, 2),(33, 250, 1, 2, 2),(33, 251, 1, 1, 2),(33, 252, 1, 2, 2),(33, 253, 1, 1, 2),(33, 254, 1, 2, 2),(33, 255, 5, 1, 2),(33, 256, 5, 2, 2),(33, 257, 5, 1, 1),(33, 258, 5, 2, 1),(33, 259, 1, 1, 1),(33, 260, 1, 2, 1),(33, 261, 1, 1, 1),(33, 262, 1, 2, 1),(33, 263, 1, 1, 1),(33, 264, 1, 2, 1),(33, 265, 1, 1, 1),(33, 266, 1, 2, 1),(33, 267, 1, 1, 1),(33, 268, 1, 2, 1),(33, 269, 1, 1, 1),(33, 270, 1, 2, 1),(33, 271, 1, 1, 1),(33, 272, 1, 2, 1),(33, 273, 1, 1, 1),(33, 274, 1, 2, 1),(33, 275, 1, 1, 1),(33, 276, 1, 2, 1),(33, 277, 1, 1, 1),(33, 278, 1, 2, 1),(33, 279, 1, 1, 1),(33, 280, 1, 2, 1),(33, 281, 1, 1, 1),(33, 282, 1, 2, 1),(33, 283, 1, 1, 1),(33, 284, 1, 2, 1),(33, 285, 1, 1, 1),(33, 286, 1, 2, 1),(33, 287, 5, 1, 1),(33, 288, 5, 2, 1),(33, 289, 5, 1, 2),(33, 290, 5, 2, 2),(33, 291, 1, 1, 2),(33, 292, 1, 2, 2),(33, 293, 1, 1, 2),(33, 294, 1, 2, 2),(33, 295, 1, 1, 2),(33, 296, 1, 2, 2),(33, 297, 1, 1, 2),(33, 298, 1, 2, 2),(33, 299, 1, 1, 2),(33, 300, 1, 2, 2),(33, 301, 1, 1, 2),(33, 302, 1, 2, 2),(33, 303, 1, 1, 2),(33, 304, 1, 2, 2),(33, 305, 1, 1, 2),(33, 306, 1, 2, 2),(33, 307, 1, 1, 2),(33, 308, 1, 2, 2),(33, 309, 1, 1, 2),(33, 310, 1, 2, 2),(33, 311, 1, 1, 2),(33, 312, 1, 2, 2),(33, 313, 1, 1, 2),(33, 314, 1, 2, 2),(33, 315, 1, 1, 2),(33, 316, 1, 2, 2),(33, 317, 1, 1, 2),(33, 318, 1, 2, 2),(33, 319, 5, 1, 2),(33, 320, 5, 2, 2),(33, 321, 5, 1, 1),(33, 322, 5, 2, 1),(33, 323, 1, 1, 1),(33, 324, 1, 2, 1),(33, 325, 1, 1, 1),(33, 326, 1, 2, 1),(33, 327, 1, 1, 1),(33, 328, 1, 2, 1),(33, 329, 1, 1, 1),(33, 330, 1, 2, 1),(33, 331, 1, 1, 1),(33, 332, 1, 2, 1),(33, 333, 1, 1, 1),(33, 334, 1, 2, 1),(33, 335, 1, 1, 1),(33, 336, 1, 2, 1),(33, 337, 1, 1, 1),(33, 338, 1, 2, 1),(33, 339, 1, 1, 1),(33, 340, 1, 2, 1),(33, 341, 1, 1, 1),(33, 342, 1, 2, 1),(33, 343, 1, 1, 1),(33, 344, 1, 2, 1),(33, 345, 1, 1, 1),(33, 346, 1, 2, 1),(33, 347, 1, 1, 1),(33, 348, 1, 2, 1),(33, 349, 1, 1, 1),(33, 350, 1, 2, 1),(33, 351, 5, 1, 1),(33, 352, 5, 2, 1),(33, 353, 5, 1, 2),(33, 354, 5, 2, 2),(33, 355, 1, 1, 2),(33, 356, 1, 2, 2),(33, 357, 1, 1, 2),(33, 358, 1, 2, 2),(33, 359, 1, 1, 2),(33, 360, 1, 2, 2),(33, 361, 1, 1, 2),(33, 362, 1, 2, 2),(33, 363, 1, 1, 2),(33, 364, 1, 2, 2),(33, 365, 1, 1, 2),(33, 366, 1, 2, 2),(33, 367, 1, 1, 2),(33, 368, 1, 2, 2),(33, 369, 1, 1, 2),(33, 370, 1, 2, 2),(33, 371, 1, 1, 2),(33, 372, 1, 2, 2),(33, 373, 1, 1, 2),(33, 374, 1, 2, 2),(33, 375, 1, 1, 2),(33, 376, 1, 2, 2),(33, 377, 1, 1, 2),(33, 378, 1, 2, 2),(33, 379, 1, 1, 2),(33, 380, 1, 2, 2),(33, 381, 1, 1, 2),(33, 382, 1, 2, 2),(33, 383, 5, 1, 2),(33, 384, 5, 2, 2),(33, 385, 5, 1, 1),(33, 386, 5, 2, 1),(33, 387, 1, 1, 1),(33, 388, 1, 2, 1),(33, 389, 1, 1, 1),(33, 390, 1, 2, 1),(33, 391, 1, 1, 1),(33, 392, 1, 2, 1),(33, 393, 1, 1, 1),(33, 394, 1, 2, 1),(33, 395, 1, 1, 1),(33, 396, 1, 2, 1),(33, 397, 1, 1, 1),(33, 398, 1, 2, 1),(33, 399, 1, 1, 1),(33, 400, 1, 2, 1),(33, 401, 1, 1, 1),(33, 402, 1, 2, 1),(33, 403, 1, 1, 1),(33, 404, 1, 2, 1),(33, 405, 1, 1, 1),(33, 406, 1, 2, 1),(33, 407, 1, 1, 1),(33, 408, 1, 2, 1),(33, 409, 1, 1, 1),(33, 410, 1, 2, 1),(33, 411, 1, 1, 1),(33, 412, 1, 2, 1),(33, 413, 1, 1, 1),(33, 414, 1, 2, 1),(33, 415, 5, 1, 1),(33, 416, 5, 2, 1),(33, 417, 5, 1, 2),(33, 418, 5, 2, 2),(33, 419, 1, 1, 2),(33, 420, 1, 2, 2),(33, 421, 1, 1, 2),(33, 422, 1, 2, 2),(33, 423, 1, 1, 2),(33, 424, 1, 2, 2),(33, 425, 1, 1, 2),(33, 426, 1, 2, 2),(33, 427, 1, 1, 2),(33, 428, 1, 2, 2),(33, 429, 1, 1, 2),(33, 430, 1, 2, 2),(33, 431, 1, 1, 2),(33, 432, 1, 2, 2),(33, 433, 1, 1, 2),(33, 434, 1, 2, 2),(33, 435, 1, 1, 2),(33, 436, 1, 2, 2),(33, 437, 1, 1, 2),(33, 438, 1, 2, 2),(33, 439, 1, 1, 2),(33, 440, 1, 2, 2),(33, 441, 1, 1, 2),(33, 442, 1, 2, 2),(33, 443, 1, 1, 2),(33, 444, 1, 2, 2),(33, 445, 1, 1, 2),(33, 446, 1, 2, 2),(33, 447, 5, 1, 2),(33, 448, 5, 2, 2),(33, 449, 5, 1, 1),(33, 450, 5, 2, 1),(33, 451, 1, 1, 1),(33, 452, 1, 2, 1),(33, 453, 1, 1, 1),(33, 454, 1, 2, 1),(33, 455, 1, 1, 1),(33, 456, 1, 2, 1),(33, 457, 1, 1, 1),(33, 458, 1, 2, 1),(33, 459, 1, 1, 1),(33, 460, 1, 2, 1),(33, 461, 1, 1, 1),(33, 462, 1, 2, 1),(33, 463, 1, 1, 1),(33, 464, 1, 2, 1),(33, 465, 1, 1, 1),(33, 466, 1, 2, 1),(33, 467, 1, 1, 1),(33, 468, 1, 2, 1),(33, 469, 1, 1, 1),(33, 470, 1, 2, 1),(33, 471, 1, 1, 1),(33, 472, 1, 2, 1),(33, 473, 1, 1, 1),(33, 474, 1, 2, 1),(33, 475, 1, 1, 1),(33, 476, 1, 2, 1),(33, 477, 1, 1, 1),(33, 478, 1, 2, 1),(33, 479, 5, 1, 1),(33, 480, 5, 2, 1),(33, 481, 5, 1, 2),(33, 482, 5, 2, 2),(33, 483, 1, 1, 2),(33, 484, 1, 2, 2),(33, 485, 1, 1, 2),(33, 486, 1, 2, 2),(33, 487, 1, 1, 2),(33, 488, 1, 2, 2),(33, 489, 1, 1, 2),(33, 490, 1, 2, 2),(33, 491, 1, 1, 2),(33, 492, 1, 2, 2),(33, 493, 1, 1, 2),(33, 494, 1, 2, 2),(33, 495, 1, 1, 2),(33, 496, 1, 2, 2),(33, 497, 1, 1, 2),(33, 498, 1, 2, 2),(33, 499, 1, 1, 2),(33, 500, 1, 2, 2),(33, 501, 1, 1, 2),(33, 502, 1, 2, 2),(33, 503, 1, 1, 2),(33, 504, 1, 2, 2),(33, 505, 1, 1, 2),(33, 506, 1, 2, 2),(33, 507, 1, 1, 2),(33, 508, 1, 2, 2),(33, 509, 1, 1, 2),(33, 510, 1, 2, 2),(33, 511, 5, 1, 2),(33, 512, 5, 2, 2),(33, 513, 5, 1, 1),(33, 514, 5, 2, 1),(33, 515, 1, 1, 1),(33, 516, 1, 2, 1),(33, 517, 1, 1, 1),(33, 518, 1, 2, 1),(33, 519, 1, 1, 1),(33, 520, 1, 2, 1),(33, 521, 1, 1, 1),(33, 522, 1, 2, 1),(33, 523, 1, 1, 1),(33, 524, 1, 2, 1),(33, 525, 1, 1, 1),(33, 526, 1, 2, 1),(33, 527, 1, 1, 1),(33, 528, 1, 2, 1),(33, 529, 1, 1, 1),(33, 530, 1, 2, 1),(33, 531, 1, 1, 1),(33, 532, 1, 2, 1),(33, 533, 1, 1, 1),(33, 534, 1, 2, 1),(33, 535, 1, 1, 1),(33, 536, 1, 2, 1),(33, 537, 1, 1, 1),(33, 538, 1, 2, 1),(33, 539, 1, 1, 1),(33, 540, 1, 2, 1),(33, 541, 1, 1, 1),(33, 542, 1, 2, 1),(33, 543, 5, 1, 1),(33, 544, 5, 2, 1),(33, 545, 5, 1, 2),(33, 546, 5, 2, 2),(33, 547, 1, 1, 2),(33, 548, 1, 2, 2),(33, 549, 1, 1, 2),(33, 550, 1, 2, 2),(33, 551, 1, 1, 2),(33, 552, 1, 2, 2),(33, 553, 1, 1, 2),(33, 554, 1, 2, 2),(33, 555, 1, 1, 2),(33, 556, 1, 2, 2),(33, 557, 1, 1, 2),(33, 558, 1, 2, 2),(33, 559, 1, 1, 2),(33, 560, 1, 2, 2),(33, 561, 1, 1, 2),(33, 562, 1, 2, 2),(33, 563, 1, 1, 2),(33, 564, 1, 2, 2),(33, 565, 1, 1, 2),(33, 566, 1, 2, 2),(33, 567, 1, 1, 2),(33, 568, 1, 2, 2),(33, 569, 1, 1, 2),(33, 570, 1, 2, 2),(33, 571, 1, 1, 2),(33, 572, 1, 2, 2),(33, 573, 1, 1, 2),(33, 574, 1, 2, 2),(33, 575, 5, 1, 2),(33, 576, 5, 2, 2),(33, 577, 5, 1, 1),(33, 578, 5, 2, 1),(33, 579, 1, 1, 1),(33, 580, 1, 2, 1),(33, 581, 1, 1, 1),(33, 582, 1, 2, 1),(33, 583, 1, 1, 1),(33, 584, 1, 2, 1),(33, 585, 1, 1, 1),(33, 586, 1, 2, 1),(33, 587, 1, 1, 1),(33, 588, 1, 2, 1),(33, 589, 1, 1, 1),(33, 590, 1, 2, 1),(33, 591, 1, 1, 1),(33, 592, 1, 2, 1),(33, 593, 1, 1, 1),(33, 594, 1, 2, 1),(33, 595, 1, 1, 1),(33, 596, 1, 2, 1),(33, 597, 1, 1, 1),(33, 598, 1, 2, 1),(33, 599, 1, 1, 1),(33, 600, 1, 2, 1),(33, 601, 1, 1, 1),(33, 602, 1, 2, 1),(33, 603, 1, 1, 1),(33, 604, 1, 2, 1),(33, 605, 1, 1, 1),(33, 606, 1, 2, 1),(33, 607, 5, 1, 1),(33, 608, 5, 2, 1),(33, 609, 5, 1, 2),(33, 610, 5, 2, 2),(33, 611, 1, 1, 2),(33, 612, 1, 2, 2),(33, 613, 1, 1, 2),(33, 614, 1, 2, 2),(33, 615, 1, 1, 2),(33, 616, 1, 2, 2),(33, 617, 1, 1, 2),(33, 618, 1, 2, 2),(33, 619, 1, 1, 2),(33, 620, 1, 2, 2),(33, 621, 1, 1, 2),(33, 622, 1, 2, 2),(33, 623, 1, 1, 2),(33, 624, 1, 2, 2),(33, 625, 1, 1, 2),(33, 626, 1, 2, 2),(33, 627, 1, 1, 2),(33, 628, 1, 2, 2),(33, 629, 1, 1, 2),(33, 630, 1, 2, 2),(33, 631, 1, 1, 2),(33, 632, 1, 2, 2),(33, 633, 1, 1, 2),(33, 634, 1, 2, 2),(33, 635, 1, 1, 2),(33, 636, 1, 2, 2),(33, 637, 1, 1, 2),(33, 638, 1, 2, 2),(33, 639, 5, 1, 2),(33, 640, 5, 2, 2),(33, 641, 5, 1, 1),(33, 642, 5, 2, 1),(33, 643, 1, 1, 1),(33, 644, 1, 2, 1),(33, 645, 1, 1, 1),(33, 646, 1, 2, 1),(33, 647, 1, 1, 1),(33, 648, 1, 2, 1),(33, 649, 1, 1, 1),(33, 650, 1, 2, 1),(33, 651, 1, 1, 1),(33, 652, 1, 2, 1),(33, 653, 1, 1, 1),(33, 654, 1, 2, 1),(33, 655, 1, 1, 1),(33, 656, 1, 2, 1),(33, 657, 1, 1, 1),(33, 658, 1, 2, 1),(33, 659, 1, 1, 1),(33, 660, 1, 2, 1),(33, 661, 1, 1, 1),(33, 662, 1, 2, 1),(33, 663, 1, 1, 1),(33, 664, 1, 2, 1),(33, 665, 1, 1, 1),(33, 666, 1, 2, 1),(33, 667, 1, 1, 1),(33, 668, 1, 2, 1),(33, 669, 1, 1, 1),(33, 670, 1, 2, 1),(33, 671, 5, 1, 1),(33, 672, 5, 2, 1),(33, 673, 5, 1, 2),(33, 674, 5, 2, 2),(33, 675, 1, 1, 2),(33, 676, 1, 2, 2),(33, 677, 1, 1, 2),(33, 678, 1, 2, 2),(33, 679, 1, 1, 2),(33, 680, 1, 2, 2),(33, 681, 1, 1, 2),(33, 682, 1, 2, 2),(33, 683, 1, 1, 2),(33, 684, 1, 2, 2),(33, 685, 1, 1, 2),(33, 686, 1, 2, 2),(33, 687, 1, 1, 2),(33, 688, 1, 2, 2),(33, 689, 1, 1, 2),(33, 690, 1, 2, 2),(33, 691, 1, 1, 2),(33, 692, 1, 2, 2),(33, 693, 1, 1, 2),(33, 694, 1, 2, 2),(33, 695, 1, 1, 2),(33, 696, 1, 2, 2),(33, 697, 1, 1, 2),(33, 698, 1, 2, 2),(33, 699, 1, 1, 2),(33, 700, 1, 2, 2),(33, 701, 1, 1, 2),(33, 702, 1, 2, 2),(33, 703, 5, 1, 2),(33, 704, 5, 2, 2),(33, 705, 5, 1, 1),(33, 706, 5, 2, 1),(33, 707, 1, 1, 1),(33, 708, 1, 2, 1),(33, 709, 1, 1, 1),(33, 710, 1, 2, 1),(33, 711, 1, 1, 1),(33, 712, 1, 2, 1),(33, 713, 1, 1, 1),(33, 714, 1, 2, 1),(33, 715, 1, 1, 1),(33, 716, 1, 2, 1),(33, 717, 1, 1, 1),(33, 718, 1, 2, 1),(33, 719, 1, 1, 1),(33, 720, 1, 2, 1),(33, 721, 1, 1, 1),(33, 722, 1, 2, 1),(33, 723, 1, 1, 1),(33, 724, 1, 2, 1),(33, 725, 1, 1, 1),(33, 726, 1, 2, 1),(33, 727, 1, 1, 1),(33, 728, 1, 2, 1),(33, 729, 1, 1, 1),(33, 730, 1, 2, 1),(33, 731, 1, 1, 1),(33, 732, 1, 2, 1),(33, 733, 1, 1, 1),(33, 734, 1, 2, 1),(33, 735, 5, 1, 1),(33, 736, 5, 2, 1),(33, 737, 5, 1, 2),(33, 738, 5, 2, 2),(33, 739, 1, 1, 2),(33, 740, 1, 2, 2),(33, 741, 1, 1, 2),(33, 742, 1, 2, 2),(33, 743, 1, 1, 2),(33, 744, 1, 2, 2),(33, 745, 1, 1, 2),(33, 746, 1, 2, 2),(33, 747, 1, 1, 2),(33, 748, 1, 2, 2),(33, 749, 1, 1, 2),(33, 750, 1, 2, 2),(33, 751, 1, 1, 2),(33, 752, 1, 2, 2),(33, 753, 1, 1, 2),(33, 754, 1, 2, 2),(33, 755, 1, 1, 2),(33, 756, 1, 2, 2),(33, 757, 1, 1, 2),(33, 758, 1, 2, 2),(33, 759, 1, 1, 2),(33, 760, 1, 2, 2),(33, 761, 1, 1, 2),(33, 762, 1, 2, 2),(33, 763, 1, 1, 2),(33, 764, 1, 2, 2),(33, 765, 1, 1, 2),(33, 766, 1, 2, 2),(33, 767, 5, 1, 2),(33, 768, 5, 2, 2),(33, 769, 5, 1, 1),(33, 770, 5, 2, 1),(33, 771, 1, 1, 1),(33, 772, 1, 2, 1),(33, 773, 1, 1, 1),(33, 774, 1, 2, 1),(33, 775, 1, 1, 1),(33, 776, 1, 2, 1),(33, 777, 1, 1, 1),(33, 778, 1, 2, 1),(33, 779, 1, 1, 1),(33, 780, 1, 2, 1),(33, 781, 1, 1, 1),(33, 782, 1, 2, 1),(33, 783, 1, 1, 1),(33, 784, 1, 2, 1),(33, 785, 1, 1, 1),(33, 786, 1, 2, 1),(33, 787, 1, 1, 1),(33, 788, 1, 2, 1),(33, 789, 1, 1, 1),(33, 790, 1, 2, 1),(33, 791, 1, 1, 1),(33, 792, 1, 2, 1),(33, 793, 1, 1, 1),(33, 794, 1, 2, 1),(33, 795, 1, 1, 1),(33, 796, 1, 2, 1),(33, 797, 1, 1, 1),(33, 798, 1, 2, 1),(33, 799, 5, 1, 1),(33, 800, 5, 2, 1),(33, 801, 5, 1, 2),(33, 802, 5, 2, 2),(33, 803, 1, 1, 2),(33, 804, 1, 2, 2),(33, 805, 1, 1, 2),(33, 806, 1, 2, 2),(33, 807, 1, 1, 2),(33, 808, 1, 2, 2),(33, 809, 1, 1, 2),(33, 810, 1, 2, 2),(33, 811, 1, 1, 2),(33, 812, 1, 2, 2),(33, 813, 1, 1, 2),(33, 814, 1, 2, 2),(33, 815, 1, 1, 2),(33, 816, 1, 2, 2),(33, 817, 1, 1, 2),(33, 818, 1, 2, 2),(33, 819, 1, 1, 2),(33, 820, 1, 2, 2),(33, 821, 1, 1, 2),(33, 822, 1, 2, 2),(33, 823, 1, 1, 2),(33, 824, 1, 2, 2),(33, 825, 1, 1, 2),(33, 826, 1, 2, 2),(33, 827, 1, 1, 2),(33, 828, 1, 2, 2),(33, 829, 1, 1, 2),(33, 830, 1, 2, 2),(33, 831, 5, 1, 2),(33, 832, 5, 2, 2),(33, 833, 5, 1, 1),(33, 834, 5, 2, 1),(33, 835, 1, 1, 1),(33, 836, 1, 2, 1),(33, 837, 1, 1, 1),(33, 838, 1, 2, 1),(33, 839, 1, 1, 1),(33, 840, 1, 2, 1),(33, 841, 1, 1, 1),(33, 842, 1, 2, 1),(33, 843, 1, 1, 1),(33, 844, 1, 2, 1),(33, 845, 1, 1, 1),(33, 846, 1, 2, 1),(33, 847, 1, 1, 1),(33, 848, 1, 2, 1),(33, 849, 1, 1, 1),(33, 850, 1, 2, 1),(33, 851, 1, 1, 1),(33, 852, 1, 2, 1),(33, 853, 1, 1, 1),(33, 854, 1, 2, 1),(33, 855, 1, 1, 1),(33, 856, 1, 2, 1),(33, 857, 1, 1, 1),(33, 858, 1, 2, 1),(33, 859, 1, 1, 1),(33, 860, 1, 2, 1),(33, 861, 1, 1, 1),(33, 862, 1, 2, 1),(33, 863, 5, 1, 1),(33, 864, 5, 2, 1),(33, 865, 5, 1, 2),(33, 866, 5, 2, 2),(33, 867, 1, 1, 2),(33, 868, 1, 2, 2),(33, 869, 1, 1, 2),(33, 870, 1, 2, 2),(33, 871, 1, 1, 2),(33, 872, 1, 2, 2),(33, 873, 1, 1, 2),(33, 874, 1, 2, 2),(33, 875, 1, 1, 2),(33, 876, 1, 2, 2),(33, 877, 1, 1, 2),(33, 878, 1, 2, 2),(33, 879, 1, 1, 2),(33, 880, 1, 2, 2),(33, 881, 1, 1, 2),(33, 882, 1, 2, 2),(33, 883, 1, 1, 2),(33, 884, 1, 2, 2),(33, 885, 1, 1, 2),(33, 886, 1, 2, 2),(33, 887, 1, 1, 2),(33, 888, 1, 2, 2),(33, 889, 1, 1, 2),(33, 890, 1, 2, 2),(33, 891, 1, 1, 2),(33, 892, 1, 2, 2),(33, 893, 1, 1, 2),(33, 894, 1, 2, 2),(33, 895, 5, 1, 2),(33, 896, 5, 2, 2),(33, 897, 5, 1, 1),(33, 898, 5, 2, 1),(33, 899, 1, 1, 1),(33, 900, 1, 2, 1),(33, 901, 1, 1, 1),(33, 902, 1, 2, 1),(33, 903, 1, 1, 1),(33, 904, 1, 2, 1),(33, 905, 1, 1, 1),(33, 906, 1, 2, 1),(33, 907, 1, 1, 1),(33, 908, 1, 2, 1),(33, 909, 1, 1, 1),(33, 910, 1, 2, 1),(33, 911, 1, 1, 1),(33, 912, 1, 2, 1),(33, 913, 1, 1, 1),(33, 914, 1, 2, 1),(33, 915, 1, 1, 1),(33, 916, 1, 2, 1),(33, 917, 1, 1, 1),(33, 918, 1, 2, 1),(33, 919, 1, 1, 1),(33, 920, 1, 2, 1),(33, 921, 1, 1, 1),(33, 922, 1, 2, 1),(33, 923, 1, 1, 1),(33, 924, 1, 2, 1),(33, 925, 1, 1, 1),(33, 926, 1, 2, 1),(33, 927, 5, 1, 1),(33, 928, 5, 2, 1),(33, 929, 5, 1, 2),(33, 930, 5, 2, 2),(33, 931, 1, 1, 2),(33, 932, 1, 2, 2),(33, 933, 1, 1, 2),(33, 934, 1, 2, 2),(33, 935, 1, 1, 2),(33, 936, 1, 2, 2),(33, 937, 1, 1, 2),(33, 938, 1, 2, 2),(33, 939, 1, 1, 2),(33, 940, 1, 2, 2),(33, 941, 1, 1, 2),(33, 942, 1, 2, 2),(33, 943, 1, 1, 2),(33, 944, 1, 2, 2),(33, 945, 1, 1, 2),(33, 946, 1, 2, 2),(33, 947, 1, 1, 2),(33, 948, 1, 2, 2),(33, 949, 1, 1, 2),(33, 950, 1, 2, 2),(33, 951, 1, 1, 2),(33, 952, 1, 2, 2),(33, 953, 1, 1, 2),(33, 954, 1, 2, 2),(33, 955, 1, 1, 2),(33, 956, 1, 2, 2),(33, 957, 1, 1, 2),(33, 958, 1, 2, 2),(33, 959, 5, 1, 2),(33, 960, 5, 2, 2),(33, 961, 5, 1, 1),(33, 962, 5, 2, 1),(33, 963, 1, 1, 1),(33, 964, 1, 2, 1),(33, 965, 1, 1, 1),(33, 966, 1, 2, 1),(33, 967, 1, 1, 1),(33, 968, 1, 2, 1),(33, 969, 1, 1, 1),(33, 970, 1, 2, 1),(33, 971, 1, 1, 1),(33, 972, 1, 2, 1),(33, 973, 1, 1, 1),(33, 974, 1, 2, 1),(33, 975, 1, 1, 1),(33, 976, 1, 2, 1),(33, 977, 1, 1, 1),(33, 978, 1, 2, 1),(33, 979, 1, 1, 1),(33, 980, 1, 2, 1),(33, 981, 1, 1, 1),(33, 982, 1, 2, 1),(33, 983, 1, 1, 1),(33, 984, 1, 2, 1),(33, 985, 1, 1, 1),(33, 986, 1, 2, 1),(33, 987, 1, 1, 1),(33, 988, 1, 2, 1),(33, 989, 1, 1, 1),(33, 990, 1, 2, 1),(33, 991, 5, 1, 1),(33, 992, 5, 2, 1),(33, 993, 5, 1, 2),(33, 994, 5, 2, 2),(33, 995, 1, 1, 2),(33, 996, 1, 2, 2),(33, 997, 1, 1, 2),(33, 998, 1, 2, 2),(33, 999, 1, 1, 2),(33, 1000, 1, 2, 2),(33, 1001, 1, 1, 2),(33, 1002, 1, 2, 2),(33, 1003, 1, 1, 2),(33, 1004, 1, 2, 2),(33, 1005, 1, 1, 2),(33, 1006, 1, 2, 2),(33, 1007, 1, 1, 2),(33, 1008, 1, 2, 2),(33, 1009, 1, 1, 2),(33, 1010, 1, 2, 2),(33, 1011, 1, 1, 2),(33, 1012, 1, 2, 2),(33, 1013, 1, 1, 2),(33, 1014, 1, 2, 2),(33, 1015, 1, 1, 2),(33, 1016, 1, 2, 2),(33, 1017, 1, 1, 2),(33, 1018, 1, 2, 2),(33, 1019, 1, 1, 2),(33, 1020, 1, 2, 2),(33, 1021, 1, 1, 2),(33, 1022, 1, 2, 2),(33, 1023, 5, 1, 2),(33, 1024, 5, 2, 2),(33, 1025, 5, 1, 1),(33, 1026, 5, 2, 1),(33, 1027, 1, 1, 1),(33, 1028, 1, 2, 1),(33, 1029, 1, 1, 1),(33, 1030, 1, 2, 1),(33, 1031, 1, 1, 1),(33, 1032, 1, 2, 1),(33, 1033, 1, 1, 1),(33, 1034, 1, 2, 1),(33, 1035, 1, 1, 1),(33, 1036, 1, 2, 1),(33, 1037, 1, 1, 1),(33, 1038, 1, 2, 1),(33, 1039, 1, 1, 1),(33, 1040, 1, 2, 1),(33, 1041, 1, 1, 1),(33, 1042, 1, 2, 1),(33, 1043, 1, 1, 1),(33, 1044, 1, 2, 1),(33, 1045, 1, 1, 1),(33, 1046, 1, 2, 1),(33, 1047, 1, 1, 1),(33, 1048, 1, 2, 1),(33, 1049, 1, 1, 1),(33, 1050, 1, 2, 1),(33, 1051, 1, 1, 1),(33, 1052, 1, 2, 1),(33, 1053, 1, 1, 1),(33, 1054, 1, 2, 1),(33, 1055, 5, 1, 1),(33, 1056, 5, 2, 1),(33, 1057, 5, 1, 2),(33, 1058, 5, 2, 2),(33, 1059, 1, 1, 2),(33, 1060, 1, 2, 2),(33, 1061, 1, 1, 2),(33, 1062, 1, 2, 2),(33, 1063, 1, 1, 2),(33, 1064, 1, 2, 2),(33, 1065, 1, 1, 2),(33, 1066, 1, 2, 2),(33, 1067, 1, 1, 2),(33, 1068, 1, 2, 2),(33, 1069, 1, 1, 2),(33, 1070, 1, 2, 2),(33, 1071, 1, 1, 2),(33, 1072, 1, 2, 2),(33, 1073, 1, 1, 2),(33, 1074, 1, 2, 2),(33, 1075, 1, 1, 2),(33, 1076, 1, 2, 2),(33, 1077, 1, 1, 2),(33, 1078, 1, 2, 2),(33, 1079, 1, 1, 2),(33, 1080, 1, 2, 2),(33, 1081, 1, 1, 2),(33, 1082, 1, 2, 2),(33, 1083, 1, 1, 2),(33, 1084, 1, 2, 2),(33, 1085, 1, 1, 2),(33, 1086, 1, 2, 2),(33, 1087, 5, 1, 2),(33, 1088, 5, 2, 2),(33, 1089, 5, 1, 1),(33, 1090, 5, 2, 1),(33, 1091, 1, 1, 1),(33, 1092, 1, 2, 1),(33, 1093, 1, 1, 1),(33, 1094, 1, 2, 1),(33, 1095, 1, 1, 1),(33, 1096, 1, 2, 1),(33, 1097, 1, 1, 1),(33, 1098, 1, 2, 1),(33, 1099, 1, 1, 1),(33, 1100, 1, 2, 1),(33, 1101, 1, 1, 1),(33, 1102, 1, 2, 1),(33, 1103, 1, 1, 1),(33, 1104, 1, 2, 1),(33, 1105, 1, 1, 1),(33, 1106, 1, 2, 1),(33, 1107, 1, 1, 1),(33, 1108, 1, 2, 1),(33, 1109, 1, 1, 1),(33, 1110, 1, 2, 1),(33, 1111, 1, 1, 1),(33, 1112, 1, 2, 1),(33, 1113, 1, 1, 1),(33, 1114, 1, 2, 1),(33, 1115, 1, 1, 1),(33, 1116, 1, 2, 1),(33, 1117, 1, 1, 1),(33, 1118, 1, 2, 1),(33, 1119, 5, 1, 1),(33, 1120, 5, 2, 1),(33, 1121, 5, 1, 2),(33, 1122, 5, 2, 2),(33, 1123, 1, 1, 2),(33, 1124, 1, 2, 2),(33, 1125, 1, 1, 2),(33, 1126, 1, 2, 2),(33, 1127, 1, 1, 2),(33, 1128, 1, 2, 2),(33, 1129, 1, 1, 2),(33, 1130, 1, 2, 2),(33, 1131, 1, 1, 2),(33, 1132, 1, 2, 2),(33, 1133, 1, 1, 2),(33, 1134, 1, 2, 2),(33, 1135, 1, 1, 2),(33, 1136, 1, 2, 2),(33, 1137, 1, 1, 2),(33, 1138, 1, 2, 2),(33, 1139, 1, 1, 2),(33, 1140, 1, 2, 2),(33, 1141, 1, 1, 2),(33, 1142, 1, 2, 2),(33, 1143, 1, 1, 2),(33, 1144, 1, 2, 2),(33, 1145, 1, 1, 2),(33, 1146, 1, 2, 2),(33, 1147, 1, 1, 2),(33, 1148, 1, 2, 2),(33, 1149, 1, 1, 2),(33, 1150, 1, 2, 2),(33, 1151, 5, 1, 2),(33, 1152, 5, 2, 2),(33, 1153, 5, 1, 1),(33, 1154, 5, 2, 1),(33, 1155, 1, 1, 1),(33, 1156, 1, 2, 1),(33, 1157, 1, 1, 1),(33, 1158, 1, 2, 1),(33, 1159, 1, 1, 1),(33, 1160, 1, 2, 1),(33, 1161, 1, 1, 1),(33, 1162, 1, 2, 1),(33, 1163, 1, 1, 1),(33, 1164, 1, 2, 1),(33, 1165, 1, 1, 1),(33, 1166, 1, 2, 1),(33, 1167, 1, 1, 1),(33, 1168, 1, 2, 1),(33, 1169, 1, 1, 1),(33, 1170, 1, 2, 1),(33, 1171, 1, 1, 1),(33, 1172, 1, 2, 1),(33, 1173, 1, 1, 1),(33, 1174, 1, 2, 1),(33, 1175, 1, 1, 1),(33, 1176, 1, 2, 1),(33, 1177, 1, 1, 1),(33, 1178, 1, 2, 1),(33, 1179, 1, 1, 1),(33, 1180, 1, 2, 1),(33, 1181, 1, 1, 1),(33, 1182, 1, 2, 1),(33, 1183, 5, 1, 1),(33, 1184, 5, 2, 1),(33, 1185, 5, 1, 2),(33, 1186, 5, 2, 2),(33, 1187, 1, 1, 2),(33, 1188, 1, 2, 2),(33, 1189, 1, 1, 2),(33, 1190, 1, 2, 2),(33, 1191, 1, 1, 2),(33, 1192, 1, 2, 2),(33, 1193, 1, 1, 2),(33, 1194, 1, 2, 2),(33, 1195, 1, 1, 2),(33, 1196, 1, 2, 2),(33, 1197, 1, 1, 2),(33, 1198, 1, 2, 2),(33, 1199, 1, 1, 2),(33, 1200, 1, 2, 2),(33, 1201, 1, 1, 2),(33, 1202, 1, 2, 2),(33, 1203, 1, 1, 2),(33, 1204, 1, 2, 2),(33, 1205, 1, 1, 2),(33, 1206, 1, 2, 2),(33, 1207, 1, 1, 2),(33, 1208, 1, 2, 2),(33, 1209, 1, 1, 2),(33, 1210, 1, 2, 2),(33, 1211, 1, 1, 2),(33, 1212, 1, 2, 2),(33, 1213, 1, 1, 2),(33, 1214, 1, 2, 2),(33, 1215, 5, 1, 2),(33, 1216, 5, 2, 2),(33, 1217, 5, 1, 1),(33, 1218, 5, 2, 1),(33, 1219, 1, 1, 1),(33, 1220, 1, 2, 1),(33, 1221, 1, 1, 1),(33, 1222, 1, 2, 1),(33, 1223, 1, 1, 1),(33, 1224, 1, 2, 1),(33, 1225, 1, 1, 1),(33, 1226, 1, 2, 1),(33, 1227, 1, 1, 1),(33, 1228, 1, 2, 1),(33, 1229, 1, 1, 1),(33, 1230, 1, 2, 1),(33, 1231, 1, 1, 1),(33, 1232, 1, 2, 1),(33, 1233, 1, 1, 1),(33, 1234, 1, 2, 1),(33, 1235, 1, 1, 1),(33, 1236, 1, 2, 1),(33, 1237, 1, 1, 1),(33, 1238, 1, 2, 1),(33, 1239, 1, 1, 1),(33, 1240, 1, 2, 1),(33, 1241, 1, 1, 1),(33, 1242, 1, 2, 1),(33, 1243, 1, 1, 1),(33, 1244, 1, 2, 1),(33, 1245, 1, 1, 1),(33, 1246, 1, 2, 1),(33, 1247, 5, 1, 1),(33, 1248, 5, 2, 1),(33, 1249, 5, 1, 2),(33, 1250, 5, 2, 2),(33, 1251, 1, 1, 2),(33, 1252, 1, 2, 2),(33, 1253, 1, 1, 2),(33, 1254, 1, 2, 2),(33, 1255, 1, 1, 2),(33, 1256, 1, 2, 2),(33, 1257, 1, 1, 2),(33, 1258, 1, 2, 2),(33, 1259, 1, 1, 2),(33, 1260, 1, 2, 2),(33, 1261, 1, 1, 2),(33, 1262, 1, 2, 2),(33, 1263, 1, 1, 2),(33, 1264, 1, 2, 2),(33, 1265, 1, 1, 2),(33, 1266, 1, 2, 2),(33, 1267, 1, 1, 2),(33, 1268, 1, 2, 2),(33, 1269, 1, 1, 2),(33, 1270, 1, 2, 2),(33, 1271, 1, 1, 2),(33, 1272, 1, 2, 2),(33, 1273, 1, 1, 2),(33, 1274, 1, 2, 2),(33, 1275, 1, 1, 2),(33, 1276, 1, 2, 2),(33, 1277, 1, 1, 2),(33, 1278, 1, 2, 2),(33, 1279, 5, 1, 2),(33, 1280, 5, 2, 2),(33, 1281, 5, 1, 1),(33, 1282, 5, 2, 1),(33, 1283, 1, 1, 1),(33, 1284, 1, 2, 1),(33, 1285, 1, 1, 1),(33, 1286, 1, 2, 1),(33, 1287, 1, 1, 1),(33, 1288, 1, 2, 1),(33, 1289, 1, 1, 1),(33, 1290, 1, 2, 1),(33, 1291, 1, 1, 1),(33, 1292, 1, 2, 1),(33, 1293, 1, 1, 1),(33, 1294, 1, 2, 1),(33, 1295, 1, 1, 1),(33, 1296, 1, 2, 1),(33, 1297, 1, 1, 1),(33, 1298, 1, 2, 1),(33, 1299, 1, 1, 1),(33, 1300, 1, 2, 1),(33, 1301, 1, 1, 1),(33, 1302, 1, 2, 1),(33, 1303, 1, 1, 1),(33, 1304, 1, 2, 1),(33, 1305, 1, 1, 1),(33, 1306, 1, 2, 1),(33, 1307, 1, 1, 1),(33, 1308, 1, 2, 1),(33, 1309, 1, 1, 1),(33, 1310, 1, 2, 1),(33, 1311, 5, 1, 1),(33, 1312, 5, 2, 1),(33, 1313, 5, 1, 2),(33, 1314, 5, 2, 2),(33, 1315, 1, 1, 2),(33, 1316, 1, 2, 2),(33, 1317, 1, 1, 2),(33, 1318, 1, 2, 2),(33, 1319, 1, 1, 2),(33, 1320, 1, 2, 2),(33, 1321, 1, 1, 2),(33, 1322, 1, 2, 2),(33, 1323, 1, 1, 2),(33, 1324, 1, 2, 2),(33, 1325, 1, 1, 2),(33, 1326, 1, 2, 2),(33, 1327, 1, 1, 2),(33, 1328, 1, 2, 2),(33, 1329, 1, 1, 2),(33, 1330, 1, 2, 2),(33, 1331, 1, 1, 2),(33, 1332, 1, 2, 2),(33, 1333, 1, 1, 2),(33, 1334, 1, 2, 2),(33, 1335, 1, 1, 2),(33, 1336, 1, 2, 2),(33, 1337, 1, 1, 2),(33, 1338, 1, 2, 2),(33, 1339, 1, 1, 2),(33, 1340, 1, 2, 2),(33, 1341, 1, 1, 2),(33, 1342, 1, 2, 2),(33, 1343, 5, 1, 2),(33, 1344, 5, 2, 2),(33, 1345, 5, 1, 1),(33, 1346, 5, 2, 1),(33, 1347, 1, 1, 1),(33, 1348, 1, 2, 1),(33, 1349, 1, 1, 1),(33, 1350, 1, 2, 1),(33, 1351, 1, 1, 1),(33, 1352, 1, 2, 1),(33, 1353, 1, 1, 1),(33, 1354, 1, 2, 1),(33, 1355, 1, 1, 1),(33, 1356, 1, 2, 1),(33, 1357, 1, 1, 1),(33, 1358, 1, 2, 1),(33, 1359, 1, 1, 1),(33, 1360, 1, 2, 1),(33, 1361, 1, 1, 1),(33, 1362, 1, 2, 1),(33, 1363, 1, 1, 1),(33, 1364, 1, 2, 1),(33, 1365, 1, 1, 1),(33, 1366, 1, 2, 1),(33, 1367, 1, 1, 1),(33, 1368, 1, 2, 1),(33, 1369, 1, 1, 1),(33, 1370, 1, 2, 1),(33, 1371, 1, 1, 1),(33, 1372, 1, 2, 1),(33, 1373, 1, 1, 1),(33, 1374, 1, 2, 1),(33, 1375, 5, 1, 1),(33, 1376, 5, 2, 1),(33, 1377, 5, 1, 2),(33, 1378, 5, 2, 2),(33, 1379, 1, 1, 2),(33, 1380, 1, 2, 2),(33, 1381, 1, 1, 2),(33, 1382, 1, 2, 2),(33, 1383, 1, 1, 2),(33, 1384, 1, 2, 2),(33, 1385, 1, 1, 2),(33, 1386, 1, 2, 2),(33, 1387, 1, 1, 2),(33, 1388, 1, 2, 2),(33, 1389, 1, 1, 2),(33, 1390, 1, 2, 2),(33, 1391, 1, 1, 2),(33, 1392, 1, 2, 2),(33, 1393, 1, 1, 2),(33, 1394, 1, 2, 2),(33, 1395, 1, 1, 2),(33, 1396, 1, 2, 2),(33, 1397, 1, 1, 2),(33, 1398, 1, 2, 2),(33, 1399, 1, 1, 2),(33, 1400, 1, 2, 2),(33, 1401, 1, 1, 2),(33, 1402, 1, 2, 2),(33, 1403, 1, 1, 2),(33, 1404, 1, 2, 2),(33, 1405, 1, 1, 2),(33, 1406, 1, 2, 2),(33, 1407, 5, 1, 2),(33, 1408, 5, 2, 2),(33, 1409, 5, 1, 1),(33, 1410, 5, 2, 1),(33, 1411, 2, 1, 1),(33, 1412, 2, 2, 1),(33, 1413, 2, 1, 1),(33, 1414, 2, 2, 1),(33, 1415, 2, 1, 1),(33, 1416, 2, 2, 1),(33, 1417, 2, 1, 1),(33, 1418, 2, 2, 1),(33, 1419, 2, 1, 1),(33, 1420, 2, 2, 1),(33, 1421, 2, 1, 1),(33, 1422, 2, 2, 1),(33, 1423, 2, 1, 1),(33, 1424, 2, 2, 1),(33, 1425, 3, 1, 1),(33, 1426, 3, 2, 1),(33, 1427, 3, 1, 1),(33, 1428, 3, 2, 1),(33, 1429, 3, 1, 1),(33, 1430, 3, 2, 1),(33, 1431, 3, 1, 1),(33, 1432, 3, 2, 1),(33, 1433, 4, 1, 1),(33, 1434, 4, 2, 1),(33, 1435, 4, 1, 1),(33, 1436, 4, 2, 1),(33, 1437, 4, 1, 1),(33, 1438, 4, 2, 1),(33, 1439, 5, 1, 1),(33, 1440, 5, 2, 1),(33, 1441, 5, 1, 2),(33, 1442, 5, 2, 2),(33, 1443, 2, 1, 2),(33, 1444, 2, 2, 2),(33, 1445, 2, 1, 2),(33, 1446, 2, 2, 2),(33, 1447, 2, 1, 2),(33, 1448, 2, 2, 2),(33, 1449, 2, 1, 2),(33, 1450, 2, 2, 2),(33, 1451, 2, 1, 2),(33, 1452, 2, 2, 2),(33, 1453, 2, 1, 2),(33, 1454, 2, 2, 2),(33, 1455, 2, 1, 2),(33, 1456, 2, 2, 2),(33, 1457, 3, 1, 2),(33, 1458, 3, 2, 2),(33, 1459, 3, 1, 2),(33, 1460, 3, 2, 2),(33, 1461, 3, 1, 2),(33, 1462, 3, 2, 2),(33, 1463, 3, 1, 2),(33, 1464, 3, 2, 2),(33, 1465, 4, 1, 2),(33, 1466, 4, 2, 2),(33, 1467, 4, 1, 2),(33, 1468, 4, 2, 2),(33, 1469, 4, 1, 2),(33, 1470, 4, 2, 2),(33, 1471, 5, 1, 2),(33, 1472, 5, 2, 2),(33, 1473, 5, 1, 1),(33, 1474, 5, 2, 1),(33, 1475, 5, 1, 1),(33, 1476, 5, 2, 1),(33, 1477, 5, 1, 1),(33, 1478, 5, 2, 1),(33, 1479, 5, 1, 1),(33, 1480, 5, 2, 1),(33, 1481, 5, 1, 1),(33, 1482, 5, 2, 1),(33, 1483, 5, 1, 1),(33, 1484, 5, 2, 1),(33, 1485, 5, 1, 1),(33, 1486, 5, 2, 1),(33, 1487, 5, 1, 1),(33, 1488, 5, 2, 1),(33, 1489, 5, 1, 1),(33, 1490, 5, 2, 1),(33, 1491, 5, 1, 1),(33, 1492, 5, 2, 1),(33, 1493, 5, 1, 1),(33, 1494, 5, 2, 1),(33, 1495, 5, 1, 1),(33, 1496, 5, 2, 1),(33, 1497, 5, 1, 1),(33, 1498, 5, 2, 1),(33, 1499, 5, 1, 1),(33, 1500, 5, 2, 1),(33, 1501, 5, 1, 1),(33, 1502, 5, 2, 1),(33, 1503, 5, 1, 1),(33, 1504, 5, 2, 1),(33, 1505, 5, 1, 2),(33, 1506, 5, 2, 2),(33, 1507, 5, 1, 2),(33, 1508, 5, 2, 2),(33, 1509, 5, 1, 2),(33, 1510, 5, 2, 2),(33, 1511, 5, 1, 2),(33, 1512, 5, 2, 2),(33, 1513, 5, 1, 2),(33, 1514, 5, 2, 2),(33, 1515, 5, 1, 2),(33, 1516, 5, 2, 2),(33, 1517, 5, 1, 2),(33, 1518, 5, 2, 2),(33, 1519, 5, 1, 2),(33, 1520, 5, 2, 2),(33, 1521, 5, 1, 2),(33, 1522, 5, 2, 2),(33, 1523, 5, 1, 2),(33, 1524, 5, 2, 2),(33, 1525, 5, 1, 2),(33, 1526, 5, 2, 2),(33, 1527, 5, 1, 2),(33, 1528, 5, 2, 2),(33, 1529, 5, 1, 2),(33, 1530, 5, 2, 2),(33, 1531, 5, 1, 2),(33, 1532, 5, 2, 2),(33, 1533, 5, 1, 2),(33, 1534, 5, 2, 2),(33, 1535, 5, 1, 2),(33, 1536, 5, 2, 2),(34, 1, 5, 1, 1),(34, 2, 5, 2, 1),(34, 3, 5, 1, 1),(34, 4, 5, 2, 1),(34, 5, 5, 1, 1),(34, 6, 5, 2, 1),(34, 7, 5, 1, 1),(34, 8, 5, 2, 1),(34, 9, 5, 1, 1),(34, 10, 5, 2, 1),(34, 11, 5, 1, 1),(34, 12, 5, 2, 1),(34, 13, 5, 1, 1),(34, 14, 5, 2, 1),(34, 15, 5, 1, 1),(34, 16, 5, 2, 1),(34, 17, 5, 1, 1),(34, 18, 5, 2, 1),(34, 19, 5, 1, 1),(34, 20, 5, 2, 1),(34, 21, 5, 1, 1),(34, 22, 5, 2, 1),(34, 23, 5, 1, 1),(34, 24, 5, 2, 1),(34, 25, 5, 1, 1),(34, 26, 5, 2, 1),(34, 27, 5, 1, 1),(34, 28, 5, 2, 1),(34, 29, 5, 1, 1),(34, 30, 5, 2, 1),(34, 31, 5, 1, 1),(34, 32, 5, 2, 1),(34, 33, 5, 1, 1),(34, 34, 5, 2, 1),(34, 35, 5, 1, 1),(34, 36, 5, 2, 1),(34, 37, 5, 1, 1),(34, 38, 5, 2, 1),(34, 39, 5, 1, 1),(34, 40, 5, 2, 1),(34, 41, 5, 1, 1),(34, 42, 5, 2, 1),(34, 43, 5, 1, 1),(34, 44, 5, 2, 1),(34, 45, 5, 1, 1),(34, 46, 5, 2, 1),(34, 47, 5, 1, 1),(34, 48, 5, 2, 1),(34, 49, 5, 1, 1),(34, 50, 5, 2, 1),(34, 51, 5, 1, 1),(34, 52, 5, 2, 1),(34, 53, 5, 1, 1),(34, 54, 5, 2, 1),(34, 55, 5, 1, 1),(34, 56, 5, 2, 1),(34, 57, 5, 1, 1),(34, 58, 5, 2, 1),(34, 59, 5, 1, 1),(34, 60, 5, 2, 1),(34, 61, 5, 1, 1),(34, 62, 5, 2, 1),(34, 63, 5, 1, 1),(34, 64, 5, 2, 1),(34, 65, 5, 1, 1),(34, 66, 5, 2, 1),(34, 67, 1, 1, 1),(34, 68, 1, 2, 1),(34, 69, 1, 1, 1),(34, 70, 1, 2, 1),(34, 71, 1, 1, 1),(34, 72, 1, 2, 1),(34, 73, 1, 1, 1),(34, 74, 1, 2, 1),(34, 75, 1, 1, 1),(34, 76, 1, 2, 1),(34, 77, 1, 1, 1),(34, 78, 1, 2, 1),(34, 79, 1, 1, 1),(34, 80, 1, 2, 1),(34, 81, 1, 1, 1),(34, 82, 1, 2, 1),(34, 83, 1, 1, 1),(34, 84, 1, 2, 1),(34, 85, 1, 1, 1),(34, 86, 1, 2, 1),(34, 87, 1, 1, 1),(34, 88, 1, 2, 1),(34, 89, 1, 1, 1),(34, 90, 1, 2, 1),(34, 91, 1, 1, 1),(34, 92, 1, 2, 1),(34, 93, 1, 1, 1),(34, 94, 1, 2, 1),(34, 95, 5, 1, 1),(34, 96, 5, 2, 1),(34, 97, 5, 1, 1),(34, 98, 5, 2, 1),(34, 99, 1, 1, 1),(34, 100, 1, 2, 1),(34, 101, 1, 1, 1),(34, 102, 1, 2, 1),(34, 103, 1, 1, 1),(34, 104, 1, 2, 1),(34, 105, 1, 1, 1),(34, 106, 1, 2, 1),(34, 107, 1, 1, 1),(34, 108, 1, 2, 1),(34, 109, 1, 1, 1),(34, 110, 1, 2, 1),(34, 111, 1, 1, 1),(34, 112, 1, 2, 1),(34, 113, 1, 1, 1),(34, 114, 1, 2, 1),(34, 115, 1, 1, 1),(34, 116, 1, 2, 1),(34, 117, 1, 1, 1),(34, 118, 1, 2, 1),(34, 119, 1, 1, 1),(34, 120, 1, 2, 1),(34, 121, 1, 1, 1),(34, 122, 1, 2, 1),(34, 123, 1, 1, 1),(34, 124, 1, 2, 1),(34, 125, 1, 1, 1),(34, 126, 1, 2, 1),(34, 127, 5, 1, 1),(34, 128, 5, 2, 1),(34, 129, 5, 1, 1),(34, 130, 5, 2, 1),(34, 131, 1, 1, 1),(34, 132, 1, 2, 1),(34, 133, 1, 1, 1),(34, 134, 1, 2, 1),(34, 135, 1, 1, 1),(34, 136, 1, 2, 1),(34, 137, 1, 1, 1),(34, 138, 1, 2, 1),(34, 139, 1, 1, 1),(34, 140, 1, 2, 1),(34, 141, 1, 1, 1),(34, 142, 1, 2, 1),(34, 143, 1, 1, 1),(34, 144, 1, 2, 1),(34, 145, 1, 1, 1),(34, 146, 1, 2, 1),(34, 147, 1, 1, 1),(34, 148, 1, 2, 1),(34, 149, 1, 1, 1),(34, 150, 1, 2, 1),(34, 151, 1, 1, 1),(34, 152, 1, 2, 1),(34, 153, 1, 1, 1),(34, 154, 1, 2, 1),(34, 155, 1, 1, 1),(34, 156, 1, 2, 1),(34, 157, 1, 1, 1),(34, 158, 1, 2, 1),(34, 159, 5, 1, 1),(34, 160, 5, 2, 1),(34, 161, 5, 1, 1),(34, 162, 5, 2, 1),(34, 163, 1, 1, 1),(34, 164, 1, 2, 1),(34, 165, 1, 1, 1),(34, 166, 1, 2, 1),(34, 167, 1, 1, 1),(34, 168, 1, 2, 1),(34, 169, 1, 1, 1),(34, 170, 1, 2, 1),(34, 171, 1, 1, 1),(34, 172, 1, 2, 1),(34, 173, 1, 1, 1),(34, 174, 1, 2, 1),(34, 175, 1, 1, 1),(34, 176, 1, 2, 1),(34, 177, 1, 1, 1),(34, 178, 1, 2, 1),(34, 179, 1, 1, 1),(34, 180, 1, 2, 1),(34, 181, 1, 1, 1),(34, 182, 1, 2, 1),(34, 183, 1, 1, 1),(34, 184, 1, 2, 1),(34, 185, 1, 1, 1),(34, 186, 1, 2, 1),(34, 187, 1, 1, 1),(34, 188, 1, 2, 1),(34, 189, 1, 1, 1),(34, 190, 1, 2, 1),(34, 191, 5, 1, 1),(34, 192, 5, 2, 1),(34, 193, 5, 1, 1),(34, 194, 5, 2, 1),(34, 195, 1, 1, 1),(34, 196, 1, 2, 1),(34, 197, 1, 1, 1),(34, 198, 1, 2, 1),(34, 199, 1, 1, 1),(34, 200, 1, 2, 1),(34, 201, 1, 1, 1),(34, 202, 1, 2, 1),(34, 203, 1, 1, 1),(34, 204, 1, 2, 1),(34, 205, 1, 1, 1),(34, 206, 1, 2, 1),(34, 207, 1, 1, 1),(34, 208, 1, 2, 1),(34, 209, 1, 1, 1),(34, 210, 1, 2, 1),(34, 211, 1, 1, 1),(34, 212, 1, 2, 1),(34, 213, 1, 1, 1),(34, 214, 1, 2, 1),(34, 215, 1, 1, 1),(34, 216, 1, 2, 1),(34, 217, 1, 1, 1),(34, 218, 1, 2, 1),(34, 219, 1, 1, 1),(34, 220, 1, 2, 1),(34, 221, 1, 1, 1),(34, 222, 1, 2, 1),(34, 223, 5, 1, 1),(34, 224, 5, 2, 1),(34, 225, 5, 1, 1),(34, 226, 5, 2, 1),(34, 227, 1, 1, 1),(34, 228, 1, 2, 1),(34, 229, 1, 1, 1),(34, 230, 1, 2, 1),(34, 231, 1, 1, 1),(34, 232, 1, 2, 1),(34, 233, 1, 1, 1),(34, 234, 1, 2, 1),(34, 235, 1, 1, 1),(34, 236, 1, 2, 1),(34, 237, 1, 1, 1),(34, 238, 1, 2, 1),(34, 239, 1, 1, 1),(34, 240, 1, 2, 1),(34, 241, 1, 1, 1),(34, 242, 1, 2, 1),(34, 243, 1, 1, 1),(34, 244, 1, 2, 1),(34, 245, 1, 1, 1),(34, 246, 1, 2, 1),(34, 247, 1, 1, 1),(34, 248, 1, 2, 1),(34, 249, 1, 1, 1),(34, 250, 1, 2, 1),(34, 251, 1, 1, 1),(34, 252, 1, 2, 1),(34, 253, 1, 1, 1),(34, 254, 1, 2, 1),(34, 255, 5, 1, 1),(34, 256, 5, 2, 1),(34, 257, 5, 1, 1),(34, 258, 5, 2, 1),(34, 259, 1, 1, 1),(34, 260, 1, 2, 1),(34, 261, 1, 1, 1),(34, 262, 1, 2, 1),(34, 263, 1, 1, 1),(34, 264, 1, 2, 1),(34, 265, 1, 1, 1),(34, 266, 1, 2, 1),(34, 267, 1, 1, 1),(34, 268, 1, 2, 1),(34, 269, 1, 1, 1),(34, 270, 1, 2, 1),(34, 271, 1, 1, 1),(34, 272, 1, 2, 1),(34, 273, 1, 1, 1),(34, 274, 1, 2, 1),(34, 275, 1, 1, 1),(34, 276, 1, 2, 1),(34, 277, 1, 1, 1),(34, 278, 1, 2, 1),(34, 279, 1, 1, 1),(34, 280, 1, 2, 1),(34, 281, 1, 1, 1),(34, 282, 1, 2, 1),(34, 283, 1, 1, 1),(34, 284, 1, 2, 1),(34, 285, 1, 1, 1),(34, 286, 1, 2, 1),(34, 287, 5, 1, 1),(34, 288, 5, 2, 1),(34, 289, 5, 1, 1),(34, 290, 5, 2, 1),(34, 291, 1, 1, 1),(34, 292, 1, 2, 1),(34, 293, 1, 1, 1),(34, 294, 1, 2, 1),(34, 295, 1, 1, 1),(34, 296, 1, 2, 1),(34, 297, 1, 1, 1),(34, 298, 1, 2, 1),(34, 299, 1, 1, 1),(34, 300, 1, 2, 1),(34, 301, 1, 1, 1),(34, 302, 1, 2, 1),(34, 303, 1, 1, 1),(34, 304, 1, 2, 1),(34, 305, 1, 1, 1),(34, 306, 1, 2, 1),(34, 307, 1, 1, 1),(34, 308, 1, 2, 1),(34, 309, 1, 1, 1),(34, 310, 1, 2, 1),(34, 311, 1, 1, 1),(34, 312, 1, 2, 1),(34, 313, 1, 1, 1),(34, 314, 1, 2, 1),(34, 315, 1, 1, 1),(34, 316, 1, 2, 1),(34, 317, 1, 1, 1),(34, 318, 1, 2, 1),(34, 319, 5, 1, 1),(34, 320, 5, 2, 1),(34, 321, 5, 1, 1),(34, 322, 5, 2, 1),(34, 323, 1, 1, 1),(34, 324, 1, 2, 1),(34, 325, 1, 1, 1),(34, 326, 1, 2, 1),(34, 327, 1, 1, 1),(34, 328, 1, 2, 1),(34, 329, 1, 1, 1),(34, 330, 1, 2, 1),(34, 331, 1, 1, 1),(34, 332, 1, 2, 1),(34, 333, 1, 1, 1),(34, 334, 1, 2, 1),(34, 335, 1, 1, 1),(34, 336, 1, 2, 1),(34, 337, 1, 1, 1),(34, 338, 1, 2, 1),(34, 339, 1, 1, 1),(34, 340, 1, 2, 1),(34, 341, 1, 1, 1),(34, 342, 1, 2, 1),(34, 343, 1, 1, 1),(34, 344, 1, 2, 1),(34, 345, 1, 1, 1),(34, 346, 1, 2, 1),(34, 347, 1, 1, 1),(34, 348, 1, 2, 1),(34, 349, 1, 1, 1),(34, 350, 1, 2, 1),(34, 351, 5, 1, 1),(34, 352, 5, 2, 1),(34, 353, 5, 1, 1),(34, 354, 5, 2, 1),(34, 355, 1, 1, 1),(34, 356, 1, 2, 1),(34, 357, 1, 1, 1),(34, 358, 1, 2, 1),(34, 359, 1, 1, 1),(34, 360, 1, 2, 1),(34, 361, 1, 1, 1),(34, 362, 1, 2, 1),(34, 363, 1, 1, 1),(34, 364, 1, 2, 1),(34, 365, 1, 1, 1),(34, 366, 1, 2, 1),(34, 367, 1, 1, 1),(34, 368, 1, 2, 1),(34, 369, 1, 1, 1),(34, 370, 1, 2, 1),(34, 371, 1, 1, 1),(34, 372, 1, 2, 1),(34, 373, 1, 1, 1),(34, 374, 1, 2, 1),(34, 375, 1, 1, 1),(34, 376, 1, 2, 1),(34, 377, 1, 1, 1),(34, 378, 1, 2, 1),(34, 379, 1, 1, 1),(34, 380, 1, 2, 1),(34, 381, 1, 1, 1),(34, 382, 1, 2, 1),(34, 383, 5, 1, 1),(34, 384, 5, 2, 1),(34, 385, 5, 1, 1),(34, 386, 5, 2, 1),(34, 387, 1, 1, 1),(34, 388, 1, 2, 1),(34, 389, 1, 1, 1),(34, 390, 1, 2, 1),(34, 391, 1, 1, 1),(34, 392, 1, 2, 1),(34, 393, 1, 1, 1),(34, 394, 1, 2, 1),(34, 395, 1, 1, 1),(34, 396, 1, 2, 1),(34, 397, 1, 1, 1),(34, 398, 1, 2, 1),(34, 399, 1, 1, 1),(34, 400, 1, 2, 1),(34, 401, 1, 1, 1),(34, 402, 1, 2, 1),(34, 403, 1, 1, 1),(34, 404, 1, 2, 1),(34, 405, 1, 1, 1),(34, 406, 1, 2, 1),(34, 407, 1, 1, 1),(34, 408, 1, 2, 1),(34, 409, 1, 1, 1),(34, 410, 1, 2, 1),(34, 411, 1, 1, 1),(34, 412, 1, 2, 1),(34, 413, 1, 1, 1),(34, 414, 1, 2, 1),(34, 415, 5, 1, 1),(34, 416, 5, 2, 1),(34, 417, 5, 1, 1),(34, 418, 5, 2, 1),(34, 419, 1, 1, 1),(34, 420, 1, 2, 1),(34, 421, 1, 1, 1),(34, 422, 1, 2, 1),(34, 423, 1, 1, 1),(34, 424, 1, 2, 1),(34, 425, 1, 1, 1),(34, 426, 1, 2, 1),(34, 427, 1, 1, 1),(34, 428, 1, 2, 1),(34, 429, 1, 1, 1),(34, 430, 1, 2, 1),(34, 431, 1, 1, 1),(34, 432, 1, 2, 1),(34, 433, 1, 1, 1),(34, 434, 1, 2, 1),(34, 435, 1, 1, 1),(34, 436, 1, 2, 1),(34, 437, 1, 1, 1),(34, 438, 1, 2, 1),(34, 439, 1, 1, 1),(34, 440, 1, 2, 1),(34, 441, 1, 1, 1),(34, 442, 1, 2, 1),(34, 443, 1, 1, 1),(34, 444, 1, 2, 1),(34, 445, 1, 1, 1),(34, 446, 1, 2, 1),(34, 447, 5, 1, 1),(34, 448, 5, 2, 1),(34, 449, 5, 1, 1),(34, 450, 5, 2, 1),(34, 451, 1, 1, 1),(34, 452, 1, 2, 1),(34, 453, 1, 1, 1),(34, 454, 1, 2, 1),(34, 455, 1, 1, 1),(34, 456, 1, 2, 1),(34, 457, 1, 1, 1),(34, 458, 1, 2, 1),(34, 459, 1, 1, 1),(34, 460, 1, 2, 1),(34, 461, 1, 1, 1),(34, 462, 1, 2, 1),(34, 463, 1, 1, 1),(34, 464, 1, 2, 1),(34, 465, 1, 1, 1),(34, 466, 1, 2, 1),(34, 467, 1, 1, 1),(34, 468, 1, 2, 1),(34, 469, 1, 1, 1),(34, 470, 1, 2, 1),(34, 471, 1, 1, 1),(34, 472, 1, 2, 1),(34, 473, 1, 1, 1),(34, 474, 1, 2, 1),(34, 475, 1, 1, 1),(34, 476, 1, 2, 1),(34, 477, 1, 1, 1),(34, 478, 1, 2, 1),(34, 479, 5, 1, 1),(34, 480, 5, 2, 1),(34, 481, 5, 1, 1),(34, 482, 5, 2, 1),(34, 483, 1, 1, 1),(34, 484, 1, 2, 1),(34, 485, 1, 1, 1),(34, 486, 1, 2, 1),(34, 487, 1, 1, 1),(34, 488, 1, 2, 1),(34, 489, 1, 1, 1),(34, 490, 1, 2, 1),(34, 491, 1, 1, 1),(34, 492, 1, 2, 1),(34, 493, 1, 1, 1),(34, 494, 1, 2, 1),(34, 495, 1, 1, 1),(34, 496, 1, 2, 1),(34, 497, 1, 1, 1),(34, 498, 1, 2, 1),(34, 499, 1, 1, 1),(34, 500, 1, 2, 1),(34, 501, 1, 1, 1),(34, 502, 1, 2, 1),(34, 503, 1, 1, 1),(34, 504, 1, 2, 1),(34, 505, 1, 1, 1),(34, 506, 1, 2, 1),(34, 507, 1, 1, 1),(34, 508, 1, 2, 1),(34, 509, 1, 1, 1),(34, 510, 1, 2, 1),(34, 511, 5, 1, 1),(34, 512, 5, 2, 1),(34, 513, 5, 1, 1),(34, 514, 5, 2, 1),(34, 515, 1, 1, 1),(34, 516, 1, 2, 1),(34, 517, 1, 1, 1),(34, 518, 1, 2, 1),(34, 519, 1, 1, 1),(34, 520, 1, 2, 1),(34, 521, 1, 1, 1),(34, 522, 1, 2, 1),(34, 523, 1, 1, 1),(34, 524, 1, 2, 1),(34, 525, 1, 1, 1),(34, 526, 1, 2, 1),(34, 527, 1, 1, 1),(34, 528, 1, 2, 1),(34, 529, 1, 1, 1),(34, 530, 1, 2, 1),(34, 531, 1, 1, 1),(34, 532, 1, 2, 1),(34, 533, 1, 1, 1),(34, 534, 1, 2, 1),(34, 535, 1, 1, 1),(34, 536, 1, 2, 1),(34, 537, 1, 1, 1),(34, 538, 1, 2, 1),(34, 539, 1, 1, 1),(34, 540, 1, 2, 1),(34, 541, 1, 1, 1),(34, 542, 1, 2, 1),(34, 543, 5, 1, 1),(34, 544, 5, 2, 1),(34, 545, 5, 1, 1),(34, 546, 5, 2, 1),(34, 547, 1, 1, 1),(34, 548, 1, 2, 1),(34, 549, 1, 1, 1),(34, 550, 1, 2, 1),(34, 551, 1, 1, 1),(34, 552, 1, 2, 1),(34, 553, 1, 1, 1),(34, 554, 1, 2, 1),(34, 555, 1, 1, 1),(34, 556, 1, 2, 1),(34, 557, 1, 1, 1),(34, 558, 1, 2, 1),(34, 559, 1, 1, 1),(34, 560, 1, 2, 1),(34, 561, 1, 1, 1),(34, 562, 1, 2, 1),(34, 563, 1, 1, 1),(34, 564, 1, 2, 1),(34, 565, 1, 1, 1),(34, 566, 1, 2, 1),(34, 567, 1, 1, 1),(34, 568, 1, 2, 1),(34, 569, 1, 1, 1),(34, 570, 1, 2, 1),(34, 571, 1, 1, 1),(34, 572, 1, 2, 1),(34, 573, 1, 1, 1),(34, 574, 1, 2, 1),(34, 575, 5, 1, 1),(34, 576, 5, 2, 1),(34, 577, 5, 1, 1),(34, 578, 5, 2, 1),(34, 579, 1, 1, 1),(34, 580, 1, 2, 1),(34, 581, 1, 1, 1),(34, 582, 1, 2, 1),(34, 583, 1, 1, 1),(34, 584, 1, 2, 1),(34, 585, 1, 1, 1),(34, 586, 1, 2, 1),(34, 587, 1, 1, 1),(34, 588, 1, 2, 1),(34, 589, 1, 1, 1),(34, 590, 1, 2, 1),(34, 591, 1, 1, 1),(34, 592, 1, 2, 1),(34, 593, 1, 1, 1),(34, 594, 1, 2, 1),(34, 595, 1, 1, 1),(34, 596, 1, 2, 1),(34, 597, 1, 1, 1),(34, 598, 1, 2, 1),(34, 599, 1, 1, 1),(34, 600, 1, 2, 1),(34, 601, 1, 1, 1),(34, 602, 1, 2, 1),(34, 603, 1, 1, 1),(34, 604, 1, 2, 1),(34, 605, 1, 1, 1),(34, 606, 1, 2, 1),(34, 607, 5, 1, 1),(34, 608, 5, 2, 1),(34, 609, 5, 1, 1),(34, 610, 5, 2, 1),(34, 611, 1, 1, 1),(34, 612, 1, 2, 1),(34, 613, 1, 1, 1),(34, 614, 1, 2, 1),(34, 615, 1, 1, 1),(34, 616, 1, 2, 1),(34, 617, 1, 1, 1),(34, 618, 1, 2, 1),(34, 619, 1, 1, 1),(34, 620, 1, 2, 1),(34, 621, 1, 1, 1),(34, 622, 1, 2, 1),(34, 623, 1, 1, 1),(34, 624, 1, 2, 1),(34, 625, 1, 1, 1),(34, 626, 1, 2, 1),(34, 627, 1, 1, 1),(34, 628, 1, 2, 1),(34, 629, 1, 1, 1),(34, 630, 1, 2, 1),(34, 631, 1, 1, 1),(34, 632, 1, 2, 1),(34, 633, 1, 1, 1),(34, 634, 1, 2, 1),(34, 635, 1, 1, 1),(34, 636, 1, 2, 1),(34, 637, 1, 1, 1),(34, 638, 1, 2, 1),(34, 639, 5, 1, 1),(34, 640, 5, 2, 1),(34, 641, 5, 1, 1),(34, 642, 5, 2, 1),(34, 643, 1, 1, 1),(34, 644, 1, 2, 1),(34, 645, 1, 1, 1),(34, 646, 1, 2, 1),(34, 647, 1, 1, 1),(34, 648, 1, 2, 1),(34, 649, 1, 1, 1),(34, 650, 1, 2, 1),(34, 651, 1, 1, 1),(34, 652, 1, 2, 1),(34, 653, 1, 1, 1),(34, 654, 1, 2, 1),(34, 655, 1, 1, 1),(34, 656, 1, 2, 1),(34, 657, 1, 1, 1),(34, 658, 1, 2, 1),(34, 659, 1, 1, 1),(34, 660, 1, 2, 1),(34, 661, 1, 1, 1),(34, 662, 1, 2, 1),(34, 663, 1, 1, 1),(34, 664, 1, 2, 1),(34, 665, 1, 1, 1),(34, 666, 1, 2, 1),(34, 667, 1, 1, 1),(34, 668, 1, 2, 1),(34, 669, 1, 1, 1),(34, 670, 1, 2, 1),(34, 671, 5, 1, 1),(34, 672, 5, 2, 1),(34, 673, 5, 1, 1),(34, 674, 5, 2, 1),(34, 675, 1, 1, 1),(34, 676, 1, 2, 1),(34, 677, 1, 1, 1),(34, 678, 1, 2, 1),(34, 679, 1, 1, 1),(34, 680, 1, 2, 1),(34, 681, 1, 1, 1),(34, 682, 1, 2, 1),(34, 683, 1, 1, 1),(34, 684, 1, 2, 1),(34, 685, 1, 1, 1),(34, 686, 1, 2, 1),(34, 687, 1, 1, 1),(34, 688, 1, 2, 1),(34, 689, 1, 1, 1),(34, 690, 1, 2, 1),(34, 691, 1, 1, 1),(34, 692, 1, 2, 1),(34, 693, 1, 1, 1),(34, 694, 1, 2, 1),(34, 695, 1, 1, 1),(34, 696, 1, 2, 1),(34, 697, 1, 1, 1),(34, 698, 1, 2, 1),(34, 699, 1, 1, 1),(34, 700, 1, 2, 1),(34, 701, 1, 1, 1),(34, 702, 1, 2, 1),(34, 703, 5, 1, 1),(34, 704, 5, 2, 1),(34, 705, 5, 1, 1),(34, 706, 5, 2, 1),(34, 707, 1, 1, 1),(34, 708, 1, 2, 1),(34, 709, 1, 1, 1),(34, 710, 1, 2, 1),(34, 711, 1, 1, 1),(34, 712, 1, 2, 1),(34, 713, 1, 1, 1),(34, 714, 1, 2, 1),(34, 715, 1, 1, 1),(34, 716, 1, 2, 1),(34, 717, 1, 1, 1),(34, 718, 1, 2, 1),(34, 719, 1, 1, 1),(34, 720, 1, 2, 1),(34, 721, 1, 1, 1),(34, 722, 1, 2, 1),(34, 723, 1, 1, 1),(34, 724, 1, 2, 1),(34, 725, 1, 1, 1),(34, 726, 1, 2, 1),(34, 727, 1, 1, 1),(34, 728, 1, 2, 1),(34, 729, 1, 1, 1),(34, 730, 1, 2, 1),(34, 731, 1, 1, 1),(34, 732, 1, 2, 1),(34, 733, 1, 1, 1),(34, 734, 1, 2, 1),(34, 735, 5, 1, 1),(34, 736, 5, 2, 1),(34, 737, 5, 1, 1),(34, 738, 5, 2, 1),(34, 739, 1, 1, 1),(34, 740, 1, 2, 1),(34, 741, 1, 1, 1),(34, 742, 1, 2, 1),(34, 743, 1, 1, 1),(34, 744, 1, 2, 1),(34, 745, 1, 1, 1),(34, 746, 1, 2, 1),(34, 747, 1, 1, 1),(34, 748, 1, 2, 1),(34, 749, 1, 1, 1),(34, 750, 1, 2, 1),(34, 751, 1, 1, 1),(34, 752, 1, 2, 1),(34, 753, 1, 1, 1),(34, 754, 1, 2, 1),(34, 755, 1, 1, 1),(34, 756, 1, 2, 1),(34, 757, 1, 1, 1),(34, 758, 1, 2, 1),(34, 759, 1, 1, 1),(34, 760, 1, 2, 1),(34, 761, 1, 1, 1),(34, 762, 1, 2, 1),(34, 763, 1, 1, 1),(34, 764, 1, 2, 1),(34, 765, 1, 1, 1),(34, 766, 1, 2, 1),(34, 767, 5, 1, 1),(34, 768, 5, 2, 1),(34, 769, 5, 1, 1),(34, 770, 5, 2, 1),(34, 771, 1, 1, 1),(34, 772, 1, 2, 1),(34, 773, 1, 1, 1),(34, 774, 1, 2, 1),(34, 775, 1, 1, 1),(34, 776, 1, 2, 1),(34, 777, 1, 1, 1),(34, 778, 1, 2, 1),(34, 779, 1, 1, 1),(34, 780, 1, 2, 1),(34, 781, 1, 1, 1),(34, 782, 1, 2, 1),(34, 783, 1, 1, 1),(34, 784, 1, 2, 1),(34, 785, 1, 1, 1),(34, 786, 1, 2, 1),(34, 787, 1, 1, 1),(34, 788, 1, 2, 1),(34, 789, 1, 1, 1),(34, 790, 1, 2, 1),(34, 791, 1, 1, 1),(34, 792, 1, 2, 1),(34, 793, 1, 1, 1),(34, 794, 1, 2, 1),(34, 795, 1, 1, 1),(34, 796, 1, 2, 1),(34, 797, 1, 1, 1),(34, 798, 1, 2, 1),(34, 799, 5, 1, 1),(34, 800, 5, 2, 1),(34, 801, 5, 1, 1),(34, 802, 5, 2, 1),(34, 803, 1, 1, 1),(34, 804, 1, 2, 1),(34, 805, 1, 1, 1),(34, 806, 1, 2, 1),(34, 807, 1, 1, 1),(34, 808, 1, 2, 1),(34, 809, 1, 1, 1),(34, 810, 1, 2, 1),(34, 811, 1, 1, 1),(34, 812, 1, 2, 1),(34, 813, 1, 1, 1),(34, 814, 1, 2, 1),(34, 815, 1, 1, 1),(34, 816, 1, 2, 1),(34, 817, 1, 1, 1),(34, 818, 1, 2, 1),(34, 819, 1, 1, 1),(34, 820, 1, 2, 1),(34, 821, 1, 1, 1),(34, 822, 1, 2, 1),(34, 823, 1, 1, 1),(34, 824, 1, 2, 1),(34, 825, 1, 1, 1),(34, 826, 1, 2, 1),(34, 827, 1, 1, 1),(34, 828, 1, 2, 1),(34, 829, 1, 1, 1),(34, 830, 1, 2, 1),(34, 831, 5, 1, 1),(34, 832, 5, 2, 1),(34, 833, 5, 1, 1),(34, 834, 5, 2, 1),(34, 835, 1, 1, 1),(34, 836, 1, 2, 1),(34, 837, 1, 1, 1),(34, 838, 1, 2, 1),(34, 839, 1, 1, 1),(34, 840, 1, 2, 1),(34, 841, 1, 1, 1),(34, 842, 1, 2, 1),(34, 843, 1, 1, 1),(34, 844, 1, 2, 1),(34, 845, 1, 1, 1),(34, 846, 1, 2, 1),(34, 847, 1, 1, 1),(34, 848, 1, 2, 1),(34, 849, 1, 1, 1),(34, 850, 1, 2, 1),(34, 851, 1, 1, 1),(34, 852, 1, 2, 1),(34, 853, 1, 1, 1),(34, 854, 1, 2, 1),(34, 855, 1, 1, 1),(34, 856, 1, 2, 1),(34, 857, 1, 1, 1),(34, 858, 1, 2, 1),(34, 859, 1, 1, 1),(34, 860, 1, 2, 1),(34, 861, 1, 1, 1),(34, 862, 1, 2, 1),(34, 863, 5, 1, 1),(34, 864, 5, 2, 1),(34, 865, 5, 1, 1),(34, 866, 5, 2, 1),(34, 867, 1, 1, 1),(34, 868, 1, 2, 1),(34, 869, 1, 1, 1),(34, 870, 1, 2, 1),(34, 871, 1, 1, 1),(34, 872, 1, 2, 1),(34, 873, 1, 1, 1),(34, 874, 1, 2, 1),(34, 875, 1, 1, 1),(34, 876, 1, 2, 1),(34, 877, 1, 1, 1),(34, 878, 1, 2, 1),(34, 879, 1, 1, 1),(34, 880, 1, 2, 1),(34, 881, 1, 1, 1),(34, 882, 1, 2, 1),(34, 883, 1, 1, 1),(34, 884, 1, 2, 1),(34, 885, 1, 1, 1),(34, 886, 1, 2, 1),(34, 887, 1, 1, 1),(34, 888, 1, 2, 1),(34, 889, 1, 1, 1),(34, 890, 1, 2, 1),(34, 891, 1, 1, 1),(34, 892, 1, 2, 1),(34, 893, 1, 1, 1),(34, 894, 1, 2, 1),(34, 895, 5, 1, 1),(34, 896, 5, 2, 1),(34, 897, 5, 1, 1),(34, 898, 5, 2, 1),(34, 899, 1, 1, 1),(34, 900, 1, 2, 1),(34, 901, 1, 1, 1),(34, 902, 1, 2, 1),(34, 903, 1, 1, 1),(34, 904, 1, 2, 1),(34, 905, 1, 1, 1),(34, 906, 1, 2, 1),(34, 907, 1, 1, 1),(34, 908, 1, 2, 1),(34, 909, 1, 1, 1),(34, 910, 1, 2, 1),(34, 911, 1, 1, 1),(34, 912, 1, 2, 1),(34, 913, 1, 1, 1),(34, 914, 1, 2, 1),(34, 915, 1, 1, 1),(34, 916, 1, 2, 1),(34, 917, 1, 1, 1),(34, 918, 1, 2, 1),(34, 919, 1, 1, 1),(34, 920, 1, 2, 1),(34, 921, 1, 1, 1),(34, 922, 1, 2, 1),(34, 923, 1, 1, 1),(34, 924, 1, 2, 1),(34, 925, 1, 1, 1),(34, 926, 1, 2, 1),(34, 927, 5, 1, 1),(34, 928, 5, 2, 1),(34, 929, 5, 1, 1),(34, 930, 5, 2, 1),(34, 931, 1, 1, 1),(34, 932, 1, 2, 1),(34, 933, 1, 1, 1),(34, 934, 1, 2, 1),(34, 935, 1, 1, 1),(34, 936, 1, 2, 1),(34, 937, 1, 1, 1),(34, 938, 1, 2, 1),(34, 939, 1, 1, 1),(34, 940, 1, 2, 1),(34, 941, 1, 1, 1),(34, 942, 1, 2, 1),(34, 943, 1, 1, 1),(34, 944, 1, 2, 1),(34, 945, 1, 1, 1),(34, 946, 1, 2, 1),(34, 947, 1, 1, 1),(34, 948, 1, 2, 1),(34, 949, 1, 1, 1),(34, 950, 1, 2, 1),(34, 951, 1, 1, 1),(34, 952, 1, 2, 1),(34, 953, 1, 1, 1),(34, 954, 1, 2, 1),(34, 955, 1, 1, 1),(34, 956, 1, 2, 1),(34, 957, 1, 1, 1),(34, 958, 1, 2, 1),(34, 959, 5, 1, 1),(34, 960, 5, 2, 1),(34, 961, 5, 1, 1),(34, 962, 5, 2, 1),(34, 963, 1, 1, 1),(34, 964, 1, 2, 1),(34, 965, 1, 1, 1),(34, 966, 1, 2, 1),(34, 967, 1, 1, 1),(34, 968, 1, 2, 1),(34, 969, 1, 1, 1),(34, 970, 1, 2, 1),(34, 971, 1, 1, 1),(34, 972, 1, 2, 1),(34, 973, 1, 1, 1),(34, 974, 1, 2, 1),(34, 975, 1, 1, 1),(34, 976, 1, 2, 1),(34, 977, 1, 1, 1),(34, 978, 1, 2, 1),(34, 979, 1, 1, 1),(34, 980, 1, 2, 1),(34, 981, 1, 1, 1),(34, 982, 1, 2, 1),(34, 983, 1, 1, 1),(34, 984, 1, 2, 1),(34, 985, 1, 1, 1),(34, 986, 1, 2, 1),(34, 987, 1, 1, 1),(34, 988, 1, 2, 1),(34, 989, 1, 1, 1),(34, 990, 1, 2, 1),(34, 991, 5, 1, 1),(34, 992, 5, 2, 1),(34, 993, 5, 1, 1),(34, 994, 5, 2, 1),(34, 995, 1, 1, 1),(34, 996, 1, 2, 1),(34, 997, 1, 1, 1),(34, 998, 1, 2, 1),(34, 999, 1, 1, 1),(34, 1000, 1, 2, 1),(34, 1001, 1, 1, 1),(34, 1002, 1, 2, 1),(34, 1003, 1, 1, 1),(34, 1004, 1, 2, 1),(34, 1005, 1, 1, 1),(34, 1006, 1, 2, 1),(34, 1007, 1, 1, 1),(34, 1008, 1, 2, 1),(34, 1009, 1, 1, 1),(34, 1010, 1, 2, 1),(34, 1011, 1, 1, 1),(34, 1012, 1, 2, 1),(34, 1013, 1, 1, 1),(34, 1014, 1, 2, 1),(34, 1015, 1, 1, 1),(34, 1016, 1, 2, 1),(34, 1017, 1, 1, 1),(34, 1018, 1, 2, 1),(34, 1019, 1, 1, 1),(34, 1020, 1, 2, 1),(34, 1021, 1, 1, 1),(34, 1022, 1, 2, 1),(34, 1023, 5, 1, 1),(34, 1024, 5, 2, 1),(34, 1025, 5, 1, 1),(34, 1026, 5, 2, 1),(34, 1027, 1, 1, 1),(34, 1028, 1, 2, 1),(34, 1029, 1, 1, 1),(34, 1030, 1, 2, 1),(34, 1031, 1, 1, 1),(34, 1032, 1, 2, 1),(34, 1033, 1, 1, 1),(34, 1034, 1, 2, 1),(34, 1035, 1, 1, 1),(34, 1036, 1, 2, 1),(34, 1037, 1, 1, 1),(34, 1038, 1, 2, 1),(34, 1039, 1, 1, 1),(34, 1040, 1, 2, 1),(34, 1041, 1, 1, 1),(34, 1042, 1, 2, 1),(34, 1043, 1, 1, 1),(34, 1044, 1, 2, 1),(34, 1045, 1, 1, 1),(34, 1046, 1, 2, 1),(34, 1047, 1, 1, 1),(34, 1048, 1, 2, 1),(34, 1049, 1, 1, 1),(34, 1050, 1, 2, 1),(34, 1051, 1, 1, 1),(34, 1052, 1, 2, 1),(34, 1053, 1, 1, 1),(34, 1054, 1, 2, 1),(34, 1055, 5, 1, 1),(34, 1056, 5, 2, 1),(34, 1057, 5, 1, 1),(34, 1058, 5, 2, 1),(34, 1059, 1, 1, 1),(34, 1060, 1, 2, 1),(34, 1061, 1, 1, 1),(34, 1062, 1, 2, 1),(34, 1063, 1, 1, 1),(34, 1064, 1, 2, 1),(34, 1065, 1, 1, 1),(34, 1066, 1, 2, 1),(34, 1067, 1, 1, 1),(34, 1068, 1, 2, 1),(34, 1069, 1, 1, 1),(34, 1070, 1, 2, 1),(34, 1071, 1, 1, 1),(34, 1072, 1, 2, 1),(34, 1073, 1, 1, 1),(34, 1074, 1, 2, 1),(34, 1075, 1, 1, 1),(34, 1076, 1, 2, 1),(34, 1077, 1, 1, 1),(34, 1078, 1, 2, 1),(34, 1079, 1, 1, 1),(34, 1080, 1, 2, 1),(34, 1081, 1, 1, 1),(34, 1082, 1, 2, 1),(34, 1083, 1, 1, 1),(34, 1084, 1, 2, 1),(34, 1085, 1, 1, 1),(34, 1086, 1, 2, 1),(34, 1087, 5, 1, 1),(34, 1088, 5, 2, 1),(34, 1089, 5, 1, 1),(34, 1090, 5, 2, 1),(34, 1091, 1, 1, 1),(34, 1092, 1, 2, 1),(34, 1093, 1, 1, 1),(34, 1094, 1, 2, 1),(34, 1095, 1, 1, 1),(34, 1096, 1, 2, 1),(34, 1097, 1, 1, 1),(34, 1098, 1, 2, 1),(34, 1099, 1, 1, 1),(34, 1100, 1, 2, 1),(34, 1101, 1, 1, 1),(34, 1102, 1, 2, 1),(34, 1103, 1, 1, 1),(34, 1104, 1, 2, 1),(34, 1105, 1, 1, 1),(34, 1106, 1, 2, 1),(34, 1107, 1, 1, 1),(34, 1108, 1, 2, 1),(34, 1109, 1, 1, 1),(34, 1110, 1, 2, 1),(34, 1111, 1, 1, 1),(34, 1112, 1, 2, 1),(34, 1113, 1, 1, 1),(34, 1114, 1, 2, 1),(34, 1115, 1, 1, 1),(34, 1116, 1, 2, 1),(34, 1117, 1, 1, 1),(34, 1118, 1, 2, 1),(34, 1119, 5, 1, 1),(34, 1120, 5, 2, 1),(34, 1121, 5, 1, 1),(34, 1122, 5, 2, 1),(34, 1123, 1, 1, 1),(34, 1124, 1, 2, 1),(34, 1125, 1, 1, 1),(34, 1126, 1, 2, 1),(34, 1127, 1, 1, 1),(34, 1128, 1, 2, 1),(34, 1129, 1, 1, 1),(34, 1130, 1, 2, 1),(34, 1131, 1, 1, 1),(34, 1132, 1, 2, 1),(34, 1133, 1, 1, 1),(34, 1134, 1, 2, 1),(34, 1135, 1, 1, 1),(34, 1136, 1, 2, 1),(34, 1137, 1, 1, 1),(34, 1138, 1, 2, 1),(34, 1139, 1, 1, 1),(34, 1140, 1, 2, 1),(34, 1141, 1, 1, 1),(34, 1142, 1, 2, 1),(34, 1143, 1, 1, 1),(34, 1144, 1, 2, 1),(34, 1145, 1, 1, 1),(34, 1146, 1, 2, 1),(34, 1147, 1, 1, 1),(34, 1148, 1, 2, 1),(34, 1149, 1, 1, 1),(34, 1150, 1, 2, 1),(34, 1151, 5, 1, 1),(34, 1152, 5, 2, 1),(34, 1153, 5, 1, 1),(34, 1154, 5, 2, 1),(34, 1155, 1, 1, 1),(34, 1156, 1, 2, 1),(34, 1157, 1, 1, 1),(34, 1158, 1, 2, 1),(34, 1159, 1, 1, 1),(34, 1160, 1, 2, 1),(34, 1161, 1, 1, 1),(34, 1162, 1, 2, 1),(34, 1163, 1, 1, 1),(34, 1164, 1, 2, 1),(34, 1165, 1, 1, 1),(34, 1166, 1, 2, 1),(34, 1167, 1, 1, 1),(34, 1168, 1, 2, 1),(34, 1169, 1, 1, 1),(34, 1170, 1, 2, 1),(34, 1171, 1, 1, 1),(34, 1172, 1, 2, 1),(34, 1173, 1, 1, 1),(34, 1174, 1, 2, 1),(34, 1175, 1, 1, 1),(34, 1176, 1, 2, 1),(34, 1177, 1, 1, 1),(34, 1178, 1, 2, 1),(34, 1179, 1, 1, 1),(34, 1180, 1, 2, 1),(34, 1181, 1, 1, 1),(34, 1182, 1, 2, 1),(34, 1183, 5, 1, 1),(34, 1184, 5, 2, 1),(34, 1185, 5, 1, 1),(34, 1186, 5, 2, 1),(34, 1187, 1, 1, 1),(34, 1188, 1, 2, 1),(34, 1189, 1, 1, 1),(34, 1190, 1, 2, 1),(34, 1191, 1, 1, 1),(34, 1192, 1, 2, 1),(34, 1193, 1, 1, 1),(34, 1194, 1, 2, 1),(34, 1195, 1, 1, 1),(34, 1196, 1, 2, 1),(34, 1197, 1, 1, 1),(34, 1198, 1, 2, 1),(34, 1199, 1, 1, 1),(34, 1200, 1, 2, 1),(34, 1201, 1, 1, 1),(34, 1202, 1, 2, 1),(34, 1203, 1, 1, 1),(34, 1204, 1, 2, 1),(34, 1205, 1, 1, 1),(34, 1206, 1, 2, 1),(34, 1207, 1, 1, 1),(34, 1208, 1, 2, 1),(34, 1209, 1, 1, 1),(34, 1210, 1, 2, 1),(34, 1211, 1, 1, 1),(34, 1212, 1, 2, 1),(34, 1213, 1, 1, 1),(34, 1214, 1, 2, 1),(34, 1215, 5, 1, 1),(34, 1216, 5, 2, 1),(34, 1217, 5, 1, 1),(34, 1218, 5, 2, 1),(34, 1219, 1, 1, 1),(34, 1220, 1, 2, 1),(34, 1221, 1, 1, 1),(34, 1222, 1, 2, 1),(34, 1223, 1, 1, 1),(34, 1224, 1, 2, 1),(34, 1225, 1, 1, 1),(34, 1226, 1, 2, 1),(34, 1227, 1, 1, 1),(34, 1228, 1, 2, 1),(34, 1229, 1, 1, 1),(34, 1230, 1, 2, 1),(34, 1231, 1, 1, 1),(34, 1232, 1, 2, 1),(34, 1233, 1, 1, 1),(34, 1234, 1, 2, 1),(34, 1235, 1, 1, 1),(34, 1236, 1, 2, 1),(34, 1237, 1, 1, 1),(34, 1238, 1, 2, 1),(34, 1239, 1, 1, 1),(34, 1240, 1, 2, 1),(34, 1241, 1, 1, 1),(34, 1242, 1, 2, 1),(34, 1243, 1, 1, 1),(34, 1244, 1, 2, 1),(34, 1245, 1, 1, 1),(34, 1246, 1, 2, 1),(34, 1247, 5, 1, 1),(34, 1248, 5, 2, 1),(34, 1249, 5, 1, 1),(34, 1250, 5, 2, 1),(34, 1251, 1, 1, 1),(34, 1252, 1, 2, 1),(34, 1253, 1, 1, 1),(34, 1254, 1, 2, 1),(34, 1255, 1, 1, 1),(34, 1256, 1, 2, 1),(34, 1257, 1, 1, 1),(34, 1258, 1, 2, 1),(34, 1259, 1, 1, 1),(34, 1260, 1, 2, 1),(34, 1261, 1, 1, 1),(34, 1262, 1, 2, 1),(34, 1263, 1, 1, 1),(34, 1264, 1, 2, 1),(34, 1265, 1, 1, 1),(34, 1266, 1, 2, 1),(34, 1267, 1, 1, 1),(34, 1268, 1, 2, 1),(34, 1269, 1, 1, 1),(34, 1270, 1, 2, 1),(34, 1271, 1, 1, 1),(34, 1272, 1, 2, 1),(34, 1273, 1, 1, 1),(34, 1274, 1, 2, 1),(34, 1275, 1, 1, 1),(34, 1276, 1, 2, 1),(34, 1277, 1, 1, 1),(34, 1278, 1, 2, 1),(34, 1279, 5, 1, 1),(34, 1280, 5, 2, 1),(34, 1281, 5, 1, 1),(34, 1282, 5, 2, 1),(34, 1283, 1, 1, 1),(34, 1284, 1, 2, 1),(34, 1285, 1, 1, 1),(34, 1286, 1, 2, 1),(34, 1287, 1, 1, 1),(34, 1288, 1, 2, 1),(34, 1289, 1, 1, 1),(34, 1290, 1, 2, 1),(34, 1291, 1, 1, 1),(34, 1292, 1, 2, 1),(34, 1293, 1, 1, 1),(34, 1294, 1, 2, 1),(34, 1295, 1, 1, 1),(34, 1296, 1, 2, 1),(34, 1297, 1, 1, 1),(34, 1298, 1, 2, 1),(34, 1299, 1, 1, 1),(34, 1300, 1, 2, 1),(34, 1301, 1, 1, 1),(34, 1302, 1, 2, 1),(34, 1303, 1, 1, 1),(34, 1304, 1, 2, 1),(34, 1305, 1, 1, 1),(34, 1306, 1, 2, 1),(34, 1307, 1, 1, 1),(34, 1308, 1, 2, 1),(34, 1309, 1, 1, 1),(34, 1310, 1, 2, 1),(34, 1311, 5, 1, 1),(34, 1312, 5, 2, 1),(34, 1313, 5, 1, 1),(34, 1314, 5, 2, 1),(34, 1315, 1, 1, 1),(34, 1316, 1, 2, 1),(34, 1317, 1, 1, 1),(34, 1318, 1, 2, 1),(34, 1319, 1, 1, 1),(34, 1320, 1, 2, 1),(34, 1321, 1, 1, 1),(34, 1322, 1, 2, 1),(34, 1323, 1, 1, 1),(34, 1324, 1, 2, 1),(34, 1325, 1, 1, 1),(34, 1326, 1, 2, 1),(34, 1327, 1, 1, 1),(34, 1328, 1, 2, 1),(34, 1329, 1, 1, 1),(34, 1330, 1, 2, 1),(34, 1331, 1, 1, 1),(34, 1332, 1, 2, 1),(34, 1333, 1, 1, 1),(34, 1334, 1, 2, 1),(34, 1335, 1, 1, 1),(34, 1336, 1, 2, 1),(34, 1337, 1, 1, 1),(34, 1338, 1, 2, 1),(34, 1339, 1, 1, 1),(34, 1340, 1, 2, 1),(34, 1341, 1, 1, 1),(34, 1342, 1, 2, 1),(34, 1343, 5, 1, 1),(34, 1344, 5, 2, 1),(34, 1345, 5, 1, 1),(34, 1346, 5, 2, 1),(34, 1347, 1, 1, 1),(34, 1348, 1, 2, 1),(34, 1349, 1, 1, 1),(34, 1350, 1, 2, 1),(34, 1351, 1, 1, 1),(34, 1352, 1, 2, 1),(34, 1353, 1, 1, 1),(34, 1354, 1, 2, 1),(34, 1355, 1, 1, 1),(34, 1356, 1, 2, 1),(34, 1357, 1, 1, 1),(34, 1358, 1, 2, 1),(34, 1359, 1, 1, 1),(34, 1360, 1, 2, 1),(34, 1361, 1, 1, 1),(34, 1362, 1, 2, 1),(34, 1363, 1, 1, 1),(34, 1364, 1, 2, 1),(34, 1365, 1, 1, 1),(34, 1366, 1, 2, 1),(34, 1367, 1, 1, 1),(34, 1368, 1, 2, 1),(34, 1369, 1, 1, 1),(34, 1370, 1, 2, 1),(34, 1371, 1, 1, 1),(34, 1372, 1, 2, 1),(34, 1373, 1, 1, 1),(34, 1374, 1, 2, 1),(34, 1375, 5, 1, 1),(34, 1376, 5, 2, 1),(34, 1377, 5, 1, 1),(34, 1378, 5, 2, 1),(34, 1379, 1, 1, 1),(34, 1380, 1, 2, 1),(34, 1381, 1, 1, 1),(34, 1382, 1, 2, 1),(34, 1383, 1, 1, 1),(34, 1384, 1, 2, 1),(34, 1385, 1, 1, 1),(34, 1386, 1, 2, 1),(34, 1387, 1, 1, 1),(34, 1388, 1, 2, 1),(34, 1389, 1, 1, 1),(34, 1390, 1, 2, 1),(34, 1391, 1, 1, 1),(34, 1392, 1, 2, 1),(34, 1393, 1, 1, 1),(34, 1394, 1, 2, 1),(34, 1395, 1, 1, 1),(34, 1396, 1, 2, 1),(34, 1397, 1, 1, 1),(34, 1398, 1, 2, 1),(34, 1399, 1, 1, 1),(34, 1400, 1, 2, 1),(34, 1401, 1, 1, 1),(34, 1402, 1, 2, 1),(34, 1403, 1, 1, 1),(34, 1404, 1, 2, 1),(34, 1405, 1, 1, 1),(34, 1406, 1, 2, 1),(34, 1407, 5, 1, 1),(34, 1408, 5, 2, 1),(34, 1409, 5, 1, 1),(34, 1410, 5, 2, 1),(34, 1411, 2, 1, 1),(34, 1412, 2, 2, 1),(34, 1413, 2, 1, 1),(34, 1414, 2, 2, 1),(34, 1415, 2, 1, 1),(34, 1416, 2, 2, 1),(34, 1417, 2, 1, 1),(34, 1418, 2, 2, 1),(34, 1419, 2, 1, 1),(34, 1420, 2, 2, 1),(34, 1421, 2, 1, 1),(34, 1422, 2, 2, 1),(34, 1423, 2, 1, 1),(34, 1424, 2, 2, 1),(34, 1425, 3, 1, 1),(34, 1426, 3, 2, 1),(34, 1427, 3, 1, 1),(34, 1428, 3, 2, 1),(34, 1429, 3, 1, 1),(34, 1430, 3, 2, 1),(34, 1431, 3, 1, 1),(34, 1432, 3, 2, 1),(34, 1433, 4, 1, 1),(34, 1434, 4, 2, 1),(34, 1435, 4, 1, 1),(34, 1436, 4, 2, 1),(34, 1437, 4, 1, 1),(34, 1438, 4, 2, 1),(34, 1439, 5, 1, 1),(34, 1440, 5, 2, 1),(34, 1441, 5, 1, 1),(34, 1442, 5, 2, 1),(34, 1443, 2, 1, 1),(34, 1444, 2, 2, 1),(34, 1445, 2, 1, 1),(34, 1446, 2, 2, 1),(34, 1447, 2, 1, 1),(34, 1448, 2, 2, 1),(34, 1449, 2, 1, 1),(34, 1450, 2, 2, 1),(34, 1451, 2, 1, 1),(34, 1452, 2, 2, 1),(34, 1453, 2, 1, 1),(34, 1454, 2, 2, 1),(34, 1455, 2, 1, 1),(34, 1456, 2, 2, 1),(34, 1457, 3, 1, 1),(34, 1458, 3, 2, 1),(34, 1459, 3, 1, 1),(34, 1460, 3, 2, 1),(34, 1461, 3, 1, 1),(34, 1462, 3, 2, 1),(34, 1463, 3, 1, 1),(34, 1464, 3, 2, 1),(34, 1465, 4, 1, 1),(34, 1466, 4, 2, 1),(34, 1467, 4, 1, 1),(34, 1468, 4, 2, 1),(34, 1469, 4, 1, 1),(34, 1470, 4, 2, 1),(34, 1471, 5, 1, 1),(34, 1472, 5, 2, 1),(34, 1473, 5, 1, 1),(34, 1474, 5, 2, 1),(34, 1475, 5, 1, 1),(34, 1476, 5, 2, 1),(34, 1477, 5, 1, 1),(34, 1478, 5, 2, 1),(34, 1479, 5, 1, 1),(34, 1480, 5, 2, 1),(34, 1481, 5, 1, 1),(34, 1482, 5, 2, 1),(34, 1483, 5, 1, 1),(34, 1484, 5, 2, 1),(34, 1485, 5, 1, 1),(34, 1486, 5, 2, 1),(34, 1487, 5, 1, 1),(34, 1488, 5, 2, 1),(34, 1489, 5, 1, 1),(34, 1490, 5, 2, 1),(34, 1491, 5, 1, 1),(34, 1492, 5, 2, 1),(34, 1493, 5, 1, 1),(34, 1494, 5, 2, 1),(34, 1495, 5, 1, 1),(34, 1496, 5, 2, 1),(34, 1497, 5, 1, 1),(34, 1498, 5, 2, 1),(34, 1499, 5, 1, 1),(34, 1500, 5, 2, 1),(34, 1501, 5, 1, 1),(34, 1502, 5, 2, 1),(34, 1503, 5, 1, 1),(34, 1504, 5, 2, 1),(34, 1505, 5, 1, 1),(34, 1506, 5, 2, 1),(34, 1507, 5, 1, 1),(34, 1508, 5, 2, 1),(34, 1509, 5, 1, 1),(34, 1510, 5, 2, 1),(34, 1511, 5, 1, 1),(34, 1512, 5, 2, 1),(34, 1513, 5, 1, 1),(34, 1514, 5, 2, 1),(34, 1515, 5, 1, 1),(34, 1516, 5, 2, 1),(34, 1517, 5, 1, 1),(34, 1518, 5, 2, 1),(34, 1519, 5, 1, 1),(34, 1520, 5, 2, 1),(34, 1521, 5, 1, 1),(34, 1522, 5, 2, 1),(34, 1523, 5, 1, 1),(34, 1524, 5, 2, 1),(34, 1525, 5, 1, 1),(34, 1526, 5, 2, 1),(34, 1527, 5, 1, 1),(34, 1528, 5, 2, 1),(34, 1529, 5, 1, 1),(34, 1530, 5, 2, 1),(34, 1531, 5, 1, 1),(34, 1532, 5, 2, 1),(34, 1533, 5, 1, 1),(34, 1534, 5, 2, 1),(34, 1535, 5, 1, 1),(34, 1536, 5, 2, 1),(35, 1, 5, 1, 1),(35, 2, 5, 1, 2),(35, 3, 5, 1, 1),(35, 4, 5, 1, 2),(35, 5, 5, 1, 1),(35, 6, 5, 1, 2),(35, 7, 5, 1, 1),(35, 8, 5, 1, 2),(35, 9, 5, 1, 1),(35, 10, 5, 1, 2),(35, 11, 5, 1, 1),(35, 12, 5, 1, 2),(35, 13, 5, 1, 1),(35, 14, 5, 1, 2),(35, 15, 5, 1, 1),(35, 16, 5, 1, 2),(35, 17, 5, 1, 1),(35, 18, 5, 1, 2),(35, 19, 5, 1, 1),(35, 20, 5, 1, 2),(35, 21, 5, 1, 1),(35, 22, 5, 1, 2),(35, 23, 5, 1, 1),(35, 24, 5, 1, 2),(35, 25, 5, 1, 1),(35, 26, 5, 1, 2),(35, 27, 5, 1, 1),(35, 28, 5, 1, 2),(35, 29, 5, 1, 1),(35, 30, 5, 1, 2),(35, 31, 5, 1, 1),(35, 32, 5, 1, 2),(35, 33, 5, 1, 3),(35, 34, 5, 1, 4),(35, 35, 5, 1, 3),(35, 36, 5, 1, 4),(35, 37, 5, 1, 3),(35, 38, 5, 1, 4),(35, 39, 5, 1, 3),(35, 40, 5, 1, 4),(35, 41, 5, 1, 3),(35, 42, 5, 1, 4),(35, 43, 5, 1, 3),(35, 44, 5, 1, 4),(35, 45, 5, 1, 3),(35, 46, 5, 1, 4),(35, 47, 5, 1, 3),(35, 48, 5, 1, 4),(35, 49, 5, 1, 3),(35, 50, 5, 1, 4),(35, 51, 5, 1, 3),(35, 52, 5, 1, 4),(35, 53, 5, 1, 3),(35, 54, 5, 1, 4),(35, 55, 5, 1, 3),(35, 56, 5, 1, 4),(35, 57, 5, 1, 3),(35, 58, 5, 1, 4),(35, 59, 5, 1, 3),(35, 60, 5, 1, 4),(35, 61, 5, 1, 3),(35, 62, 5, 1, 4),(35, 63, 5, 1, 3),(35, 64, 5, 1, 4),(35, 65, 5, 1, 1),(35, 66, 5, 1, 2),(35, 67, 1, 1, 1),(35, 68, 1, 1, 2),(35, 69, 1, 1, 1),(35, 70, 1, 1, 2),(35, 71, 1, 1, 1),(35, 72, 1, 1, 2),(35, 73, 1, 1, 1),(35, 74, 1, 1, 2),(35, 75, 1, 1, 1),(35, 76, 1, 1, 2),(35, 77, 1, 1, 1),(35, 78, 1, 1, 2),(35, 79, 1, 1, 1),(35, 80, 1, 1, 2),(35, 81, 1, 1, 1),(35, 82, 1, 1, 2),(35, 83, 1, 1, 1),(35, 84, 1, 1, 2),(35, 85, 1, 1, 1),(35, 86, 1, 1, 2),(35, 87, 1, 1, 1),(35, 88, 1, 1, 2),(35, 89, 1, 1, 1),(35, 90, 1, 1, 2),(35, 91, 1, 1, 1),(35, 92, 1, 1, 2),(35, 93, 1, 1, 1),(35, 94, 1, 1, 2),(35, 95, 5, 1, 1),(35, 96, 5, 1, 2),(35, 97, 5, 1, 3),(35, 98, 5, 1, 4),(35, 99, 1, 1, 3),(35, 100, 1, 1, 4),(35, 101, 1, 1, 3),(35, 102, 1, 1, 4),(35, 103, 1, 1, 3),(35, 104, 1, 1, 4),(35, 105, 1, 1, 3),(35, 106, 1, 1, 4),(35, 107, 1, 1, 3),(35, 108, 1, 1, 4),(35, 109, 1, 1, 3),(35, 110, 1, 1, 4),(35, 111, 1, 1, 3),(35, 112, 1, 1, 4),(35, 113, 1, 1, 3),(35, 114, 1, 1, 4),(35, 115, 1, 1, 3),(35, 116, 1, 1, 4),(35, 117, 1, 1, 3),(35, 118, 1, 1, 4),(35, 119, 1, 1, 3),(35, 120, 1, 1, 4),(35, 121, 1, 1, 3),(35, 122, 1, 1, 4),(35, 123, 1, 1, 3),(35, 124, 1, 1, 4),(35, 125, 1, 1, 3),(35, 126, 1, 1, 4),(35, 127, 5, 1, 3),(35, 128, 5, 1, 4),(35, 129, 5, 1, 1),(35, 130, 5, 1, 2),(35, 131, 1, 1, 1),(35, 132, 1, 1, 2),(35, 133, 1, 1, 1),(35, 134, 1, 1, 2),(35, 135, 1, 1, 1),(35, 136, 1, 1, 2),(35, 137, 1, 1, 1),(35, 138, 1, 1, 2),(35, 139, 1, 1, 1),(35, 140, 1, 1, 2),(35, 141, 1, 1, 1),(35, 142, 1, 1, 2),(35, 143, 1, 1, 1),(35, 144, 1, 1, 2),(35, 145, 1, 1, 1),(35, 146, 1, 1, 2),(35, 147, 1, 1, 1),(35, 148, 1, 1, 2),(35, 149, 1, 1, 1),(35, 150, 1, 1, 2),(35, 151, 1, 1, 1),(35, 152, 1, 1, 2),(35, 153, 1, 1, 1),(35, 154, 1, 1, 2),(35, 155, 1, 1, 1),(35, 156, 1, 1, 2),(35, 157, 1, 1, 1),(35, 158, 1, 1, 2),(35, 159, 5, 1, 1),(35, 160, 5, 1, 2),(35, 161, 5, 1, 3),(35, 162, 5, 1, 4),(35, 163, 1, 1, 3),(35, 164, 1, 1, 4),(35, 165, 1, 1, 3),(35, 166, 1, 1, 4),(35, 167, 1, 1, 3),(35, 168, 1, 1, 4),(35, 169, 1, 1, 3),(35, 170, 1, 1, 4),(35, 171, 1, 1, 3),(35, 172, 1, 1, 4),(35, 173, 1, 1, 3),(35, 174, 1, 1, 4),(35, 175, 1, 1, 3),(35, 176, 1, 1, 4),(35, 177, 1, 1, 3),(35, 178, 1, 1, 4),(35, 179, 1, 1, 3),(35, 180, 1, 1, 4),(35, 181, 1, 1, 3),(35, 182, 1, 1, 4),(35, 183, 1, 1, 3),(35, 184, 1, 1, 4),(35, 185, 1, 1, 3),(35, 186, 1, 1, 4),(35, 187, 1, 1, 3),(35, 188, 1, 1, 4),(35, 189, 1, 1, 3),(35, 190, 1, 1, 4),(35, 191, 5, 1, 3),(35, 192, 5, 1, 4),(35, 193, 5, 1, 1),(35, 194, 5, 1, 2),(35, 195, 1, 1, 1),(35, 196, 1, 1, 2),(35, 197, 1, 1, 1),(35, 198, 1, 1, 2),(35, 199, 1, 1, 1),(35, 200, 1, 1, 2),(35, 201, 1, 1, 1),(35, 202, 1, 1, 2),(35, 203, 1, 1, 1),(35, 204, 1, 1, 2),(35, 205, 1, 1, 1),(35, 206, 1, 1, 2),(35, 207, 1, 1, 1),(35, 208, 1, 1, 2),(35, 209, 1, 1, 1),(35, 210, 1, 1, 2),(35, 211, 1, 1, 1),(35, 212, 1, 1, 2),(35, 213, 1, 1, 1),(35, 214, 1, 1, 2),(35, 215, 1, 1, 1),(35, 216, 1, 1, 2),(35, 217, 1, 1, 1),(35, 218, 1, 1, 2),(35, 219, 1, 1, 1),(35, 220, 1, 1, 2),(35, 221, 1, 1, 1),(35, 222, 1, 1, 2),(35, 223, 5, 1, 1),(35, 224, 5, 1, 2),(35, 225, 5, 1, 3),(35, 226, 5, 1, 4),(35, 227, 1, 1, 3),(35, 228, 1, 1, 4),(35, 229, 1, 1, 3),(35, 230, 1, 1, 4),(35, 231, 1, 1, 3),(35, 232, 1, 1, 4),(35, 233, 1, 1, 3),(35, 234, 1, 1, 4),(35, 235, 1, 1, 3),(35, 236, 1, 1, 4),(35, 237, 1, 1, 3),(35, 238, 1, 1, 4),(35, 239, 1, 1, 3),(35, 240, 1, 1, 4),(35, 241, 1, 1, 3),(35, 242, 1, 1, 4),(35, 243, 1, 1, 3),(35, 244, 1, 1, 4),(35, 245, 1, 1, 3),(35, 246, 1, 1, 4),(35, 247, 1, 1, 3),(35, 248, 1, 1, 4),(35, 249, 1, 1, 3),(35, 250, 1, 1, 4),(35, 251, 1, 1, 3),(35, 252, 1, 1, 4),(35, 253, 1, 1, 3),(35, 254, 1, 1, 4),(35, 255, 5, 1, 3),(35, 256, 5, 1, 4),(35, 257, 5, 1, 1),(35, 258, 5, 1, 2),(35, 259, 1, 1, 1),(35, 260, 1, 1, 2),(35, 261, 1, 1, 1),(35, 262, 1, 1, 2),(35, 263, 1, 1, 1),(35, 264, 1, 1, 2),(35, 265, 1, 1, 1),(35, 266, 1, 1, 2),(35, 267, 1, 1, 1),(35, 268, 1, 1, 2),(35, 269, 1, 1, 1),(35, 270, 1, 1, 2),(35, 271, 1, 1, 1),(35, 272, 1, 1, 2),(35, 273, 1, 1, 1),(35, 274, 1, 1, 2),(35, 275, 1, 1, 1),(35, 276, 1, 1, 2),(35, 277, 1, 1, 1),(35, 278, 1, 1, 2),(35, 279, 1, 1, 1),(35, 280, 1, 1, 2),(35, 281, 1, 1, 1),(35, 282, 1, 1, 2),(35, 283, 1, 1, 1),(35, 284, 1, 1, 2),(35, 285, 1, 1, 1),(35, 286, 1, 1, 2),(35, 287, 5, 1, 1),(35, 288, 5, 1, 2),(35, 289, 5, 1, 3),(35, 290, 5, 1, 4),(35, 291, 1, 1, 3),(35, 292, 1, 1, 4),(35, 293, 1, 1, 3),(35, 294, 1, 1, 4),(35, 295, 1, 1, 3),(35, 296, 1, 1, 4),(35, 297, 1, 1, 3),(35, 298, 1, 1, 4),(35, 299, 1, 1, 3),(35, 300, 1, 1, 4),(35, 301, 1, 1, 3),(35, 302, 1, 1, 4),(35, 303, 1, 1, 3),(35, 304, 1, 1, 4),(35, 305, 1, 1, 3),(35, 306, 1, 1, 4),(35, 307, 1, 1, 3),(35, 308, 1, 1, 4),(35, 309, 1, 1, 3),(35, 310, 1, 1, 4),(35, 311, 1, 1, 3),(35, 312, 1, 1, 4),(35, 313, 1, 1, 3),(35, 314, 1, 1, 4),(35, 315, 1, 1, 3),(35, 316, 1, 1, 4),(35, 317, 1, 1, 3),(35, 318, 1, 1, 4),(35, 319, 5, 1, 3),(35, 320, 5, 1, 4),(35, 321, 5, 1, 1),(35, 322, 5, 1, 2),(35, 323, 1, 1, 1),(35, 324, 1, 1, 2),(35, 325, 1, 1, 1),(35, 326, 1, 1, 2),(35, 327, 1, 1, 1),(35, 328, 1, 1, 2),(35, 329, 1, 1, 1),(35, 330, 1, 1, 2),(35, 331, 1, 1, 1),(35, 332, 1, 1, 2),(35, 333, 1, 1, 1),(35, 334, 1, 1, 2),(35, 335, 1, 1, 1),(35, 336, 1, 1, 2),(35, 337, 1, 1, 1),(35, 338, 1, 1, 2),(35, 339, 1, 1, 1),(35, 340, 1, 1, 2),(35, 341, 1, 1, 1),(35, 342, 1, 1, 2),(35, 343, 1, 1, 1),(35, 344, 1, 1, 2),(35, 345, 1, 1, 1),(35, 346, 1, 1, 2),(35, 347, 1, 1, 1),(35, 348, 1, 1, 2),(35, 349, 1, 1, 1),(35, 350, 1, 1, 2),(35, 351, 5, 1, 1),(35, 352, 5, 1, 2),(35, 353, 5, 1, 3),(35, 354, 5, 1, 4),(35, 355, 1, 1, 3),(35, 356, 1, 1, 4),(35, 357, 1, 1, 3),(35, 358, 1, 1, 4),(35, 359, 1, 1, 3),(35, 360, 1, 1, 4),(35, 361, 1, 1, 3),(35, 362, 1, 1, 4),(35, 363, 1, 1, 3),(35, 364, 1, 1, 4),(35, 365, 1, 1, 3),(35, 366, 1, 1, 4),(35, 367, 1, 1, 3),(35, 368, 1, 1, 4),(35, 369, 1, 1, 3),(35, 370, 1, 1, 4),(35, 371, 1, 1, 3),(35, 372, 1, 1, 4),(35, 373, 1, 1, 3),(35, 374, 1, 1, 4),(35, 375, 1, 1, 3),(35, 376, 1, 1, 4),(35, 377, 1, 1, 3),(35, 378, 1, 1, 4),(35, 379, 1, 1, 3),(35, 380, 1, 1, 4),(35, 381, 1, 1, 3),(35, 382, 1, 1, 4),(35, 383, 5, 1, 3),(35, 384, 5, 1, 4),(35, 385, 5, 1, 1),(35, 386, 5, 1, 2),(35, 387, 1, 1, 1),(35, 388, 1, 1, 2),(35, 389, 1, 1, 1),(35, 390, 1, 1, 2),(35, 391, 1, 1, 1),(35, 392, 1, 1, 2),(35, 393, 1, 1, 1),(35, 394, 1, 1, 2),(35, 395, 1, 1, 1),(35, 396, 1, 1, 2),(35, 397, 1, 1, 1),(35, 398, 1, 1, 2),(35, 399, 1, 1, 1),(35, 400, 1, 1, 2),(35, 401, 1, 1, 1),(35, 402, 1, 1, 2),(35, 403, 1, 1, 1),(35, 404, 1, 1, 2),(35, 405, 1, 1, 1),(35, 406, 1, 1, 2),(35, 407, 1, 1, 1),(35, 408, 1, 1, 2),(35, 409, 1, 1, 1),(35, 410, 1, 1, 2),(35, 411, 1, 1, 1),(35, 412, 1, 1, 2),(35, 413, 1, 1, 1),(35, 414, 1, 1, 2),(35, 415, 5, 1, 1),(35, 416, 5, 1, 2),(35, 417, 5, 1, 3),(35, 418, 5, 1, 4),(35, 419, 1, 1, 3),(35, 420, 1, 1, 4),(35, 421, 1, 1, 3),(35, 422, 1, 1, 4),(35, 423, 1, 1, 3),(35, 424, 1, 1, 4),(35, 425, 1, 1, 3),(35, 426, 1, 1, 4),(35, 427, 1, 1, 3),(35, 428, 1, 1, 4),(35, 429, 1, 1, 3),(35, 430, 1, 1, 4),(35, 431, 1, 1, 3),(35, 432, 1, 1, 4),(35, 433, 1, 1, 3),(35, 434, 1, 1, 4),(35, 435, 1, 1, 3),(35, 436, 1, 1, 4),(35, 437, 1, 1, 3),(35, 438, 1, 1, 4),(35, 439, 1, 1, 3),(35, 440, 1, 1, 4),(35, 441, 1, 1, 3),(35, 442, 1, 1, 4),(35, 443, 1, 1, 3),(35, 444, 1, 1, 4),(35, 445, 1, 1, 3),(35, 446, 1, 1, 4),(35, 447, 5, 1, 3),(35, 448, 5, 1, 4),(35, 449, 5, 1, 1),(35, 450, 5, 1, 2),(35, 451, 1, 1, 1),(35, 452, 1, 1, 2),(35, 453, 1, 1, 1),(35, 454, 1, 1, 2),(35, 455, 1, 1, 1),(35, 456, 1, 1, 2),(35, 457, 1, 1, 1),(35, 458, 1, 1, 2),(35, 459, 1, 1, 1),(35, 460, 1, 1, 2),(35, 461, 1, 1, 1),(35, 462, 1, 1, 2),(35, 463, 1, 1, 1),(35, 464, 1, 1, 2),(35, 465, 1, 1, 1),(35, 466, 1, 1, 2),(35, 467, 1, 1, 1),(35, 468, 1, 1, 2),(35, 469, 1, 1, 1),(35, 470, 1, 1, 2),(35, 471, 1, 1, 1),(35, 472, 1, 1, 2),(35, 473, 1, 1, 1),(35, 474, 1, 1, 2),(35, 475, 1, 1, 1),(35, 476, 1, 1, 2),(35, 477, 1, 1, 1),(35, 478, 1, 1, 2),(35, 479, 5, 1, 1),(35, 480, 5, 1, 2),(35, 481, 5, 1, 3),(35, 482, 5, 1, 4),(35, 483, 1, 1, 3),(35, 484, 1, 1, 4),(35, 485, 1, 1, 3),(35, 486, 1, 1, 4),(35, 487, 1, 1, 3),(35, 488, 1, 1, 4),(35, 489, 1, 1, 3),(35, 490, 1, 1, 4),(35, 491, 1, 1, 3),(35, 492, 1, 1, 4),(35, 493, 1, 1, 3),(35, 494, 1, 1, 4),(35, 495, 1, 1, 3),(35, 496, 1, 1, 4),(35, 497, 1, 1, 3),(35, 498, 1, 1, 4),(35, 499, 1, 1, 3),(35, 500, 1, 1, 4),(35, 501, 1, 1, 3),(35, 502, 1, 1, 4),(35, 503, 1, 1, 3),(35, 504, 1, 1, 4),(35, 505, 1, 1, 3),(35, 506, 1, 1, 4),(35, 507, 1, 1, 3),(35, 508, 1, 1, 4),(35, 509, 1, 1, 3),(35, 510, 1, 1, 4),(35, 511, 5, 1, 3),(35, 512, 5, 1, 4),(35, 513, 5, 1, 1),(35, 514, 5, 1, 2),(35, 515, 1, 1, 1),(35, 516, 1, 1, 2),(35, 517, 1, 1, 1),(35, 518, 1, 1, 2),(35, 519, 1, 1, 1),(35, 520, 1, 1, 2),(35, 521, 1, 1, 1),(35, 522, 1, 1, 2),(35, 523, 1, 1, 1),(35, 524, 1, 1, 2),(35, 525, 1, 1, 1),(35, 526, 1, 1, 2),(35, 527, 1, 1, 1),(35, 528, 1, 1, 2),(35, 529, 1, 1, 1),(35, 530, 1, 1, 2),(35, 531, 1, 1, 1),(35, 532, 1, 1, 2),(35, 533, 1, 1, 1),(35, 534, 1, 1, 2),(35, 535, 1, 1, 1),(35, 536, 1, 1, 2),(35, 537, 1, 1, 1),(35, 538, 1, 1, 2),(35, 539, 1, 1, 1),(35, 540, 1, 1, 2),(35, 541, 1, 1, 1),(35, 542, 1, 1, 2),(35, 543, 5, 1, 1),(35, 544, 5, 1, 2),(35, 545, 5, 1, 3),(35, 546, 5, 1, 4),(35, 547, 1, 1, 3),(35, 548, 1, 1, 4),(35, 549, 1, 1, 3),(35, 550, 1, 1, 4),(35, 551, 1, 1, 3),(35, 552, 1, 1, 4),(35, 553, 1, 1, 3),(35, 554, 1, 1, 4),(35, 555, 1, 1, 3),(35, 556, 1, 1, 4),(35, 557, 1, 1, 3),(35, 558, 1, 1, 4),(35, 559, 1, 1, 3),(35, 560, 1, 1, 4),(35, 561, 1, 1, 3),(35, 562, 1, 1, 4),(35, 563, 1, 1, 3),(35, 564, 1, 1, 4),(35, 565, 1, 1, 3),(35, 566, 1, 1, 4),(35, 567, 1, 1, 3),(35, 568, 1, 1, 4),(35, 569, 1, 1, 3),(35, 570, 1, 1, 4),(35, 571, 1, 1, 3),(35, 572, 1, 1, 4),(35, 573, 1, 1, 3),(35, 574, 1, 1, 4),(35, 575, 5, 1, 3),(35, 576, 5, 1, 4),(35, 577, 5, 1, 1),(35, 578, 5, 1, 2),(35, 579, 1, 1, 1),(35, 580, 1, 1, 2),(35, 581, 1, 1, 1),(35, 582, 1, 1, 2),(35, 583, 1, 1, 1),(35, 584, 1, 1, 2),(35, 585, 1, 1, 1),(35, 586, 1, 1, 2),(35, 587, 1, 1, 1),(35, 588, 1, 1, 2),(35, 589, 1, 1, 1),(35, 590, 1, 1, 2),(35, 591, 1, 1, 1),(35, 592, 1, 1, 2),(35, 593, 1, 1, 1),(35, 594, 1, 1, 2),(35, 595, 1, 1, 1),(35, 596, 1, 1, 2),(35, 597, 1, 1, 1),(35, 598, 1, 1, 2),(35, 599, 1, 1, 1),(35, 600, 1, 1, 2),(35, 601, 1, 1, 1),(35, 602, 1, 1, 2),(35, 603, 1, 1, 1),(35, 604, 1, 1, 2),(35, 605, 1, 1, 1),(35, 606, 1, 1, 2),(35, 607, 5, 1, 1),(35, 608, 5, 1, 2),(35, 609, 5, 1, 3),(35, 610, 5, 1, 4),(35, 611, 1, 1, 3),(35, 612, 1, 1, 4),(35, 613, 1, 1, 3),(35, 614, 1, 1, 4),(35, 615, 1, 1, 3),(35, 616, 1, 1, 4),(35, 617, 1, 1, 3),(35, 618, 1, 1, 4),(35, 619, 1, 1, 3),(35, 620, 1, 1, 4),(35, 621, 1, 1, 3),(35, 622, 1, 1, 4),(35, 623, 1, 1, 3),(35, 624, 1, 1, 4),(35, 625, 1, 1, 3),(35, 626, 1, 1, 4),(35, 627, 1, 1, 3),(35, 628, 1, 1, 4),(35, 629, 1, 1, 3),(35, 630, 1, 1, 4),(35, 631, 1, 1, 3),(35, 632, 1, 1, 4),(35, 633, 1, 1, 3),(35, 634, 1, 1, 4),(35, 635, 1, 1, 3),(35, 636, 1, 1, 4),(35, 637, 1, 1, 3),(35, 638, 1, 1, 4),(35, 639, 5, 1, 3),(35, 640, 5, 1, 4),(35, 641, 5, 1, 1),(35, 642, 5, 1, 2),(35, 643, 1, 1, 1),(35, 644, 1, 1, 2),(35, 645, 1, 1, 1),(35, 646, 1, 1, 2),(35, 647, 1, 1, 1),(35, 648, 1, 1, 2),(35, 649, 1, 1, 1),(35, 650, 1, 1, 2),(35, 651, 1, 1, 1),(35, 652, 1, 1, 2),(35, 653, 1, 1, 1),(35, 654, 1, 1, 2),(35, 655, 1, 1, 1),(35, 656, 1, 1, 2),(35, 657, 1, 1, 1),(35, 658, 1, 1, 2),(35, 659, 1, 1, 1),(35, 660, 1, 1, 2),(35, 661, 1, 1, 1),(35, 662, 1, 1, 2),(35, 663, 1, 1, 1),(35, 664, 1, 1, 2),(35, 665, 1, 1, 1),(35, 666, 1, 1, 2),(35, 667, 1, 1, 1),(35, 668, 1, 1, 2),(35, 669, 1, 1, 1),(35, 670, 1, 1, 2),(35, 671, 5, 1, 1),(35, 672, 5, 1, 2),(35, 673, 5, 1, 3),(35, 674, 5, 1, 4),(35, 675, 1, 1, 3),(35, 676, 1, 1, 4),(35, 677, 1, 1, 3),(35, 678, 1, 1, 4),(35, 679, 1, 1, 3),(35, 680, 1, 1, 4),(35, 681, 1, 1, 3),(35, 682, 1, 1, 4),(35, 683, 1, 1, 3),(35, 684, 1, 1, 4),(35, 685, 1, 1, 3),(35, 686, 1, 1, 4),(35, 687, 1, 1, 3),(35, 688, 1, 1, 4),(35, 689, 1, 1, 3),(35, 690, 1, 1, 4),(35, 691, 1, 1, 3),(35, 692, 1, 1, 4),(35, 693, 1, 1, 3),(35, 694, 1, 1, 4),(35, 695, 1, 1, 3),(35, 696, 1, 1, 4),(35, 697, 1, 1, 3),(35, 698, 1, 1, 4),(35, 699, 1, 1, 3),(35, 700, 1, 1, 4),(35, 701, 1, 1, 3),(35, 702, 1, 1, 4),(35, 703, 5, 1, 3),(35, 704, 5, 1, 4),(35, 705, 5, 1, 1),(35, 706, 5, 1, 2),(35, 707, 1, 1, 1),(35, 708, 1, 1, 2),(35, 709, 1, 1, 1),(35, 710, 1, 1, 2),(35, 711, 1, 1, 1),(35, 712, 1, 1, 2),(35, 713, 1, 1, 1),(35, 714, 1, 1, 2),(35, 715, 1, 1, 1),(35, 716, 1, 1, 2),(35, 717, 1, 1, 1),(35, 718, 1, 1, 2),(35, 719, 1, 1, 1),(35, 720, 1, 1, 2),(35, 721, 1, 1, 1),(35, 722, 1, 1, 2),(35, 723, 1, 1, 1),(35, 724, 1, 1, 2),(35, 725, 1, 1, 1),(35, 726, 1, 1, 2),(35, 727, 1, 1, 1),(35, 728, 1, 1, 2),(35, 729, 1, 1, 1),(35, 730, 1, 1, 2),(35, 731, 1, 1, 1),(35, 732, 1, 1, 2),(35, 733, 1, 1, 1),(35, 734, 1, 1, 2),(35, 735, 5, 1, 1),(35, 736, 5, 1, 2),(35, 737, 5, 1, 3),(35, 738, 5, 1, 4),(35, 739, 1, 1, 3),(35, 740, 1, 1, 4),(35, 741, 1, 1, 3),(35, 742, 1, 1, 4),(35, 743, 1, 1, 3),(35, 744, 1, 1, 4),(35, 745, 1, 1, 3),(35, 746, 1, 1, 4),(35, 747, 1, 1, 3),(35, 748, 1, 1, 4),(35, 749, 1, 1, 3),(35, 750, 1, 1, 4),(35, 751, 1, 1, 3),(35, 752, 1, 1, 4),(35, 753, 1, 1, 3),(35, 754, 1, 1, 4),(35, 755, 1, 1, 3),(35, 756, 1, 1, 4),(35, 757, 1, 1, 3),(35, 758, 1, 1, 4),(35, 759, 1, 1, 3),(35, 760, 1, 1, 4),(35, 761, 1, 1, 3),(35, 762, 1, 1, 4),(35, 763, 1, 1, 3),(35, 764, 1, 1, 4),(35, 765, 1, 1, 3),(35, 766, 1, 1, 4),(35, 767, 5, 1, 3),(35, 768, 5, 1, 4),(35, 769, 5, 1, 1),(35, 770, 5, 1, 2),(35, 771, 1, 1, 1),(35, 772, 1, 1, 2),(35, 773, 1, 1, 1),(35, 774, 1, 1, 2),(35, 775, 1, 1, 1),(35, 776, 1, 1, 2),(35, 777, 1, 1, 1),(35, 778, 1, 1, 2),(35, 779, 1, 1, 1),(35, 780, 1, 1, 2),(35, 781, 1, 1, 1),(35, 782, 1, 1, 2),(35, 783, 1, 1, 1),(35, 784, 1, 1, 2),(35, 785, 1, 1, 1),(35, 786, 1, 1, 2),(35, 787, 1, 1, 1),(35, 788, 1, 1, 2),(35, 789, 1, 1, 1),(35, 790, 1, 1, 2),(35, 791, 1, 1, 1),(35, 792, 1, 1, 2),(35, 793, 1, 1, 1),(35, 794, 1, 1, 2),(35, 795, 1, 1, 1),(35, 796, 1, 1, 2),(35, 797, 1, 1, 1),(35, 798, 1, 1, 2),(35, 799, 5, 1, 1),(35, 800, 5, 1, 2),(35, 801, 5, 1, 3),(35, 802, 5, 1, 4),(35, 803, 1, 1, 3),(35, 804, 1, 1, 4),(35, 805, 1, 1, 3),(35, 806, 1, 1, 4),(35, 807, 1, 1, 3),(35, 808, 1, 1, 4),(35, 809, 1, 1, 3),(35, 810, 1, 1, 4),(35, 811, 1, 1, 3),(35, 812, 1, 1, 4),(35, 813, 1, 1, 3),(35, 814, 1, 1, 4),(35, 815, 1, 1, 3),(35, 816, 1, 1, 4),(35, 817, 1, 1, 3),(35, 818, 1, 1, 4),(35, 819, 1, 1, 3),(35, 820, 1, 1, 4),(35, 821, 1, 1, 3),(35, 822, 1, 1, 4),(35, 823, 1, 1, 3),(35, 824, 1, 1, 4),(35, 825, 1, 1, 3),(35, 826, 1, 1, 4),(35, 827, 1, 1, 3),(35, 828, 1, 1, 4),(35, 829, 1, 1, 3),(35, 830, 1, 1, 4),(35, 831, 5, 1, 3),(35, 832, 5, 1, 4),(35, 833, 5, 1, 1),(35, 834, 5, 1, 2),(35, 835, 1, 1, 1),(35, 836, 1, 1, 2),(35, 837, 1, 1, 1),(35, 838, 1, 1, 2),(35, 839, 1, 1, 1),(35, 840, 1, 1, 2),(35, 841, 1, 1, 1),(35, 842, 1, 1, 2),(35, 843, 1, 1, 1),(35, 844, 1, 1, 2),(35, 845, 1, 1, 1),(35, 846, 1, 1, 2),(35, 847, 1, 1, 1),(35, 848, 1, 1, 2),(35, 849, 1, 1, 1),(35, 850, 1, 1, 2),(35, 851, 1, 1, 1),(35, 852, 1, 1, 2),(35, 853, 1, 1, 1),(35, 854, 1, 1, 2),(35, 855, 1, 1, 1),(35, 856, 1, 1, 2),(35, 857, 1, 1, 1),(35, 858, 1, 1, 2),(35, 859, 1, 1, 1),(35, 860, 1, 1, 2),(35, 861, 1, 1, 1),(35, 862, 1, 1, 2),(35, 863, 5, 1, 1),(35, 864, 5, 1, 2),(35, 865, 5, 1, 3),(35, 866, 5, 1, 4),(35, 867, 1, 1, 3),(35, 868, 1, 1, 4),(35, 869, 1, 1, 3),(35, 870, 1, 1, 4),(35, 871, 1, 1, 3),(35, 872, 1, 1, 4),(35, 873, 1, 1, 3),(35, 874, 1, 1, 4),(35, 875, 1, 1, 3),(35, 876, 1, 1, 4),(35, 877, 1, 1, 3),(35, 878, 1, 1, 4),(35, 879, 1, 1, 3),(35, 880, 1, 1, 4),(35, 881, 1, 1, 3),(35, 882, 1, 1, 4),(35, 883, 1, 1, 3),(35, 884, 1, 1, 4),(35, 885, 1, 1, 3),(35, 886, 1, 1, 4),(35, 887, 1, 1, 3),(35, 888, 1, 1, 4),(35, 889, 1, 1, 3),(35, 890, 1, 1, 4),(35, 891, 1, 1, 3),(35, 892, 1, 1, 4),(35, 893, 1, 1, 3),(35, 894, 1, 1, 4),(35, 895, 5, 1, 3),(35, 896, 5, 1, 4),(35, 897, 5, 1, 1),(35, 898, 5, 1, 2),(35, 899, 1, 1, 1),(35, 900, 1, 1, 2),(35, 901, 1, 1, 1),(35, 902, 1, 1, 2),(35, 903, 1, 1, 1),(35, 904, 1, 1, 2),(35, 905, 1, 1, 1),(35, 906, 1, 1, 2),(35, 907, 1, 1, 1),(35, 908, 1, 1, 2),(35, 909, 1, 1, 1),(35, 910, 1, 1, 2),(35, 911, 1, 1, 1),(35, 912, 1, 1, 2),(35, 913, 1, 1, 1),(35, 914, 1, 1, 2),(35, 915, 1, 1, 1),(35, 916, 1, 1, 2),(35, 917, 1, 1, 1),(35, 918, 1, 1, 2),(35, 919, 1, 1, 1),(35, 920, 1, 1, 2),(35, 921, 1, 1, 1),(35, 922, 1, 1, 2),(35, 923, 1, 1, 1),(35, 924, 1, 1, 2),(35, 925, 1, 1, 1),(35, 926, 1, 1, 2),(35, 927, 5, 1, 1),(35, 928, 5, 1, 2),(35, 929, 5, 1, 3),(35, 930, 5, 1, 4),(35, 931, 1, 1, 3),(35, 932, 1, 1, 4),(35, 933, 1, 1, 3),(35, 934, 1, 1, 4),(35, 935, 1, 1, 3),(35, 936, 1, 1, 4),(35, 937, 1, 1, 3),(35, 938, 1, 1, 4),(35, 939, 1, 1, 3),(35, 940, 1, 1, 4),(35, 941, 1, 1, 3),(35, 942, 1, 1, 4),(35, 943, 1, 1, 3),(35, 944, 1, 1, 4),(35, 945, 1, 1, 3),(35, 946, 1, 1, 4),(35, 947, 1, 1, 3),(35, 948, 1, 1, 4),(35, 949, 1, 1, 3),(35, 950, 1, 1, 4),(35, 951, 1, 1, 3),(35, 952, 1, 1, 4),(35, 953, 1, 1, 3),(35, 954, 1, 1, 4),(35, 955, 1, 1, 3),(35, 956, 1, 1, 4),(35, 957, 1, 1, 3),(35, 958, 1, 1, 4),(35, 959, 5, 1, 3),(35, 960, 5, 1, 4),(35, 961, 5, 1, 1),(35, 962, 5, 1, 2),(35, 963, 1, 1, 1),(35, 964, 1, 1, 2),(35, 965, 1, 1, 1),(35, 966, 1, 1, 2),(35, 967, 1, 1, 1),(35, 968, 1, 1, 2),(35, 969, 1, 1, 1),(35, 970, 1, 1, 2),(35, 971, 1, 1, 1),(35, 972, 1, 1, 2),(35, 973, 1, 1, 1),(35, 974, 1, 1, 2),(35, 975, 1, 1, 1),(35, 976, 1, 1, 2),(35, 977, 1, 1, 1),(35, 978, 1, 1, 2),(35, 979, 1, 1, 1),(35, 980, 1, 1, 2),(35, 981, 1, 1, 1),(35, 982, 1, 1, 2),(35, 983, 1, 1, 1),(35, 984, 1, 1, 2),(35, 985, 1, 1, 1),(35, 986, 1, 1, 2),(35, 987, 1, 1, 1),(35, 988, 1, 1, 2),(35, 989, 1, 1, 1),(35, 990, 1, 1, 2),(35, 991, 5, 1, 1),(35, 992, 5, 1, 2),(35, 993, 5, 1, 3),(35, 994, 5, 1, 4),(35, 995, 1, 1, 3),(35, 996, 1, 1, 4),(35, 997, 1, 1, 3),(35, 998, 1, 1, 4),(35, 999, 1, 1, 3),(35, 1000, 1, 1, 4),(35, 1001, 1, 1, 3),(35, 1002, 1, 1, 4),(35, 1003, 1, 1, 3),(35, 1004, 1, 1, 4),(35, 1005, 1, 1, 3),(35, 1006, 1, 1, 4),(35, 1007, 1, 1, 3),(35, 1008, 1, 1, 4),(35, 1009, 1, 1, 3),(35, 1010, 1, 1, 4),(35, 1011, 1, 1, 3),(35, 1012, 1, 1, 4),(35, 1013, 1, 1, 3),(35, 1014, 1, 1, 4),(35, 1015, 1, 1, 3),(35, 1016, 1, 1, 4),(35, 1017, 1, 1, 3),(35, 1018, 1, 1, 4),(35, 1019, 1, 1, 3),(35, 1020, 1, 1, 4),(35, 1021, 1, 1, 3),(35, 1022, 1, 1, 4),(35, 1023, 5, 1, 3),(35, 1024, 5, 1, 4),(35, 1025, 5, 1, 1),(35, 1026, 5, 1, 2),(35, 1027, 1, 1, 1),(35, 1028, 1, 1, 2),(35, 1029, 1, 1, 1),(35, 1030, 1, 1, 2),(35, 1031, 1, 1, 1),(35, 1032, 1, 1, 2),(35, 1033, 1, 1, 1),(35, 1034, 1, 1, 2),(35, 1035, 1, 1, 1),(35, 1036, 1, 1, 2),(35, 1037, 1, 1, 1),(35, 1038, 1, 1, 2),(35, 1039, 1, 1, 1),(35, 1040, 1, 1, 2),(35, 1041, 1, 1, 1),(35, 1042, 1, 1, 2),(35, 1043, 1, 1, 1),(35, 1044, 1, 1, 2),(35, 1045, 1, 1, 1),(35, 1046, 1, 1, 2),(35, 1047, 1, 1, 1),(35, 1048, 1, 1, 2),(35, 1049, 1, 1, 1),(35, 1050, 1, 1, 2),(35, 1051, 1, 1, 1),(35, 1052, 1, 1, 2),(35, 1053, 1, 1, 1),(35, 1054, 1, 1, 2),(35, 1055, 5, 1, 1),(35, 1056, 5, 1, 2),(35, 1057, 5, 1, 3),(35, 1058, 5, 1, 4),(35, 1059, 1, 1, 3),(35, 1060, 1, 1, 4),(35, 1061, 1, 1, 3),(35, 1062, 1, 1, 4),(35, 1063, 1, 1, 3),(35, 1064, 1, 1, 4),(35, 1065, 1, 1, 3),(35, 1066, 1, 1, 4),(35, 1067, 1, 1, 3),(35, 1068, 1, 1, 4),(35, 1069, 1, 1, 3),(35, 1070, 1, 1, 4),(35, 1071, 1, 1, 3),(35, 1072, 1, 1, 4),(35, 1073, 1, 1, 3),(35, 1074, 1, 1, 4),(35, 1075, 1, 1, 3),(35, 1076, 1, 1, 4),(35, 1077, 1, 1, 3),(35, 1078, 1, 1, 4),(35, 1079, 1, 1, 3),(35, 1080, 1, 1, 4),(35, 1081, 1, 1, 3),(35, 1082, 1, 1, 4),(35, 1083, 1, 1, 3),(35, 1084, 1, 1, 4),(35, 1085, 1, 1, 3),(35, 1086, 1, 1, 4),(35, 1087, 5, 1, 3),(35, 1088, 5, 1, 4),(35, 1089, 5, 1, 1),(35, 1090, 5, 1, 2),(35, 1091, 1, 1, 1),(35, 1092, 1, 1, 2),(35, 1093, 1, 1, 1),(35, 1094, 1, 1, 2),(35, 1095, 1, 1, 1),(35, 1096, 1, 1, 2),(35, 1097, 1, 1, 1),(35, 1098, 1, 1, 2),(35, 1099, 1, 1, 1),(35, 1100, 1, 1, 2),(35, 1101, 1, 1, 1),(35, 1102, 1, 1, 2),(35, 1103, 1, 1, 1),(35, 1104, 1, 1, 2),(35, 1105, 1, 1, 1),(35, 1106, 1, 1, 2),(35, 1107, 1, 1, 1),(35, 1108, 1, 1, 2),(35, 1109, 1, 1, 1),(35, 1110, 1, 1, 2),(35, 1111, 1, 1, 1),(35, 1112, 1, 1, 2),(35, 1113, 1, 1, 1),(35, 1114, 1, 1, 2),(35, 1115, 1, 1, 1),(35, 1116, 1, 1, 2),(35, 1117, 1, 1, 1),(35, 1118, 1, 1, 2),(35, 1119, 5, 1, 1),(35, 1120, 5, 1, 2),(35, 1121, 5, 1, 3),(35, 1122, 5, 1, 4),(35, 1123, 1, 1, 3),(35, 1124, 1, 1, 4),(35, 1125, 1, 1, 3),(35, 1126, 1, 1, 4),(35, 1127, 1, 1, 3),(35, 1128, 1, 1, 4),(35, 1129, 1, 1, 3),(35, 1130, 1, 1, 4),(35, 1131, 1, 1, 3),(35, 1132, 1, 1, 4),(35, 1133, 1, 1, 3),(35, 1134, 1, 1, 4),(35, 1135, 1, 1, 3),(35, 1136, 1, 1, 4),(35, 1137, 1, 1, 3),(35, 1138, 1, 1, 4),(35, 1139, 1, 1, 3),(35, 1140, 1, 1, 4),(35, 1141, 1, 1, 3),(35, 1142, 1, 1, 4),(35, 1143, 1, 1, 3),(35, 1144, 1, 1, 4),(35, 1145, 1, 1, 3),(35, 1146, 1, 1, 4),(35, 1147, 1, 1, 3),(35, 1148, 1, 1, 4),(35, 1149, 1, 1, 3),(35, 1150, 1, 1, 4),(35, 1151, 5, 1, 3),(35, 1152, 5, 1, 4),(35, 1153, 5, 1, 1),(35, 1154, 5, 1, 2),(35, 1155, 1, 1, 1),(35, 1156, 1, 1, 2),(35, 1157, 1, 1, 1),(35, 1158, 1, 1, 2),(35, 1159, 1, 1, 1),(35, 1160, 1, 1, 2),(35, 1161, 1, 1, 1),(35, 1162, 1, 1, 2),(35, 1163, 1, 1, 1),(35, 1164, 1, 1, 2),(35, 1165, 1, 1, 1),(35, 1166, 1, 1, 2),(35, 1167, 1, 1, 1),(35, 1168, 1, 1, 2),(35, 1169, 1, 1, 1),(35, 1170, 1, 1, 2),(35, 1171, 1, 1, 1),(35, 1172, 1, 1, 2),(35, 1173, 1, 1, 1),(35, 1174, 1, 1, 2),(35, 1175, 1, 1, 1),(35, 1176, 1, 1, 2),(35, 1177, 1, 1, 1),(35, 1178, 1, 1, 2),(35, 1179, 1, 1, 1),(35, 1180, 1, 1, 2),(35, 1181, 1, 1, 1),(35, 1182, 1, 1, 2),(35, 1183, 5, 1, 1),(35, 1184, 5, 1, 2),(35, 1185, 5, 1, 3),(35, 1186, 5, 1, 4),(35, 1187, 1, 1, 3),(35, 1188, 1, 1, 4),(35, 1189, 1, 1, 3),(35, 1190, 1, 1, 4),(35, 1191, 1, 1, 3),(35, 1192, 1, 1, 4),(35, 1193, 1, 1, 3),(35, 1194, 1, 1, 4),(35, 1195, 1, 1, 3),(35, 1196, 1, 1, 4),(35, 1197, 1, 1, 3),(35, 1198, 1, 1, 4),(35, 1199, 1, 1, 3),(35, 1200, 1, 1, 4),(35, 1201, 1, 1, 3),(35, 1202, 1, 1, 4),(35, 1203, 1, 1, 3),(35, 1204, 1, 1, 4),(35, 1205, 1, 1, 3),(35, 1206, 1, 1, 4),(35, 1207, 1, 1, 3),(35, 1208, 1, 1, 4),(35, 1209, 1, 1, 3),(35, 1210, 1, 1, 4),(35, 1211, 1, 1, 3),(35, 1212, 1, 1, 4),(35, 1213, 1, 1, 3),(35, 1214, 1, 1, 4),(35, 1215, 5, 1, 3),(35, 1216, 5, 1, 4),(35, 1217, 5, 1, 1),(35, 1218, 5, 1, 2),(35, 1219, 1, 1, 1),(35, 1220, 1, 1, 2),(35, 1221, 1, 1, 1),(35, 1222, 1, 1, 2),(35, 1223, 1, 1, 1),(35, 1224, 1, 1, 2),(35, 1225, 1, 1, 1),(35, 1226, 1, 1, 2),(35, 1227, 1, 1, 1),(35, 1228, 1, 1, 2),(35, 1229, 1, 1, 1),(35, 1230, 1, 1, 2),(35, 1231, 1, 1, 1),(35, 1232, 1, 1, 2),(35, 1233, 1, 1, 1),(35, 1234, 1, 1, 2),(35, 1235, 1, 1, 1),(35, 1236, 1, 1, 2),(35, 1237, 1, 1, 1),(35, 1238, 1, 1, 2),(35, 1239, 1, 1, 1),(35, 1240, 1, 1, 2),(35, 1241, 1, 1, 1),(35, 1242, 1, 1, 2),(35, 1243, 1, 1, 1),(35, 1244, 1, 1, 2),(35, 1245, 1, 1, 1),(35, 1246, 1, 1, 2),(35, 1247, 5, 1, 1),(35, 1248, 5, 1, 2),(35, 1249, 5, 1, 3),(35, 1250, 5, 1, 4),(35, 1251, 1, 1, 3),(35, 1252, 1, 1, 4),(35, 1253, 1, 1, 3),(35, 1254, 1, 1, 4),(35, 1255, 1, 1, 3),(35, 1256, 1, 1, 4),(35, 1257, 1, 1, 3),(35, 1258, 1, 1, 4),(35, 1259, 1, 1, 3),(35, 1260, 1, 1, 4),(35, 1261, 1, 1, 3),(35, 1262, 1, 1, 4),(35, 1263, 1, 1, 3),(35, 1264, 1, 1, 4),(35, 1265, 1, 1, 3),(35, 1266, 1, 1, 4),(35, 1267, 1, 1, 3),(35, 1268, 1, 1, 4),(35, 1269, 1, 1, 3),(35, 1270, 1, 1, 4),(35, 1271, 1, 1, 3),(35, 1272, 1, 1, 4),(35, 1273, 1, 1, 3),(35, 1274, 1, 1, 4),(35, 1275, 1, 1, 3),(35, 1276, 1, 1, 4),(35, 1277, 1, 1, 3),(35, 1278, 1, 1, 4),(35, 1279, 5, 1, 3),(35, 1280, 5, 1, 4),(35, 1281, 5, 1, 1),(35, 1282, 5, 1, 2),(35, 1283, 1, 1, 1),(35, 1284, 1, 1, 2),(35, 1285, 1, 1, 1),(35, 1286, 1, 1, 2),(35, 1287, 1, 1, 1),(35, 1288, 1, 1, 2),(35, 1289, 1, 1, 1),(35, 1290, 1, 1, 2),(35, 1291, 1, 1, 1),(35, 1292, 1, 1, 2),(35, 1293, 1, 1, 1),(35, 1294, 1, 1, 2),(35, 1295, 1, 1, 1),(35, 1296, 1, 1, 2),(35, 1297, 1, 1, 1),(35, 1298, 1, 1, 2),(35, 1299, 1, 1, 1),(35, 1300, 1, 1, 2),(35, 1301, 1, 1, 1),(35, 1302, 1, 1, 2),(35, 1303, 1, 1, 1),(35, 1304, 1, 1, 2),(35, 1305, 1, 1, 1),(35, 1306, 1, 1, 2),(35, 1307, 1, 1, 1),(35, 1308, 1, 1, 2),(35, 1309, 1, 1, 1),(35, 1310, 1, 1, 2),(35, 1311, 5, 1, 1),(35, 1312, 5, 1, 2),(35, 1313, 5, 1, 3),(35, 1314, 5, 1, 4),(35, 1315, 1, 1, 3),(35, 1316, 1, 1, 4),(35, 1317, 1, 1, 3),(35, 1318, 1, 1, 4),(35, 1319, 1, 1, 3),(35, 1320, 1, 1, 4),(35, 1321, 1, 1, 3),(35, 1322, 1, 1, 4),(35, 1323, 1, 1, 3),(35, 1324, 1, 1, 4),(35, 1325, 1, 1, 3),(35, 1326, 1, 1, 4),(35, 1327, 1, 1, 3),(35, 1328, 1, 1, 4),(35, 1329, 1, 1, 3),(35, 1330, 1, 1, 4),(35, 1331, 1, 1, 3),(35, 1332, 1, 1, 4),(35, 1333, 1, 1, 3),(35, 1334, 1, 1, 4),(35, 1335, 1, 1, 3),(35, 1336, 1, 1, 4),(35, 1337, 1, 1, 3),(35, 1338, 1, 1, 4),(35, 1339, 1, 1, 3),(35, 1340, 1, 1, 4),(35, 1341, 1, 1, 3),(35, 1342, 1, 1, 4),(35, 1343, 5, 1, 3),(35, 1344, 5, 1, 4),(35, 1345, 5, 1, 1),(35, 1346, 5, 1, 2),(35, 1347, 1, 1, 1),(35, 1348, 1, 1, 2),(35, 1349, 1, 1, 1),(35, 1350, 1, 1, 2),(35, 1351, 1, 1, 1),(35, 1352, 1, 1, 2),(35, 1353, 1, 1, 1),(35, 1354, 1, 1, 2),(35, 1355, 1, 1, 1),(35, 1356, 1, 1, 2),(35, 1357, 1, 1, 1),(35, 1358, 1, 1, 2),(35, 1359, 1, 1, 1),(35, 1360, 1, 1, 2),(35, 1361, 1, 1, 1),(35, 1362, 1, 1, 2),(35, 1363, 1, 1, 1),(35, 1364, 1, 1, 2),(35, 1365, 1, 1, 1),(35, 1366, 1, 1, 2),(35, 1367, 1, 1, 1),(35, 1368, 1, 1, 2),(35, 1369, 1, 1, 1),(35, 1370, 1, 1, 2),(35, 1371, 1, 1, 1),(35, 1372, 1, 1, 2),(35, 1373, 1, 1, 1),(35, 1374, 1, 1, 2),(35, 1375, 5, 1, 1),(35, 1376, 5, 1, 2),(35, 1377, 5, 1, 3),(35, 1378, 5, 1, 4),(35, 1379, 1, 1, 3),(35, 1380, 1, 1, 4),(35, 1381, 1, 1, 3),(35, 1382, 1, 1, 4),(35, 1383, 1, 1, 3),(35, 1384, 1, 1, 4),(35, 1385, 1, 1, 3),(35, 1386, 1, 1, 4),(35, 1387, 1, 1, 3),(35, 1388, 1, 1, 4),(35, 1389, 1, 1, 3),(35, 1390, 1, 1, 4),(35, 1391, 1, 1, 3),(35, 1392, 1, 1, 4),(35, 1393, 1, 1, 3),(35, 1394, 1, 1, 4),(35, 1395, 1, 1, 3),(35, 1396, 1, 1, 4),(35, 1397, 1, 1, 3),(35, 1398, 1, 1, 4),(35, 1399, 1, 1, 3),(35, 1400, 1, 1, 4),(35, 1401, 1, 1, 3),(35, 1402, 1, 1, 4),(35, 1403, 1, 1, 3),(35, 1404, 1, 1, 4),(35, 1405, 1, 1, 3),(35, 1406, 1, 1, 4),(35, 1407, 5, 1, 3),(35, 1408, 5, 1, 4),(35, 1409, 5, 1, 1),(35, 1410, 5, 1, 2),(35, 1411, 2, 1, 1),(35, 1412, 2, 1, 2),(35, 1413, 2, 1, 1),(35, 1414, 2, 1, 2),(35, 1415, 2, 1, 1),(35, 1416, 2, 1, 2),(35, 1417, 2, 1, 1),(35, 1418, 2, 1, 2),(35, 1419, 2, 1, 1),(35, 1420, 2, 1, 2),(35, 1421, 2, 1, 1),(35, 1422, 2, 1, 2),(35, 1423, 2, 1, 1),(35, 1424, 2, 1, 2),(35, 1425, 3, 1, 1),(35, 1426, 3, 1, 2),(35, 1427, 3, 1, 1),(35, 1428, 3, 1, 2),(35, 1429, 3, 1, 1),(35, 1430, 3, 1, 2),(35, 1431, 3, 1, 1),(35, 1432, 3, 1, 2),(35, 1433, 4, 1, 1),(35, 1434, 4, 1, 2),(35, 1435, 4, 1, 1),(35, 1436, 4, 1, 2),(35, 1437, 4, 1, 1),(35, 1438, 4, 1, 2),(35, 1439, 5, 1, 1),(35, 1440, 5, 1, 2),(35, 1441, 5, 1, 3),(35, 1442, 5, 1, 4),(35, 1443, 2, 1, 3),(35, 1444, 2, 1, 4),(35, 1445, 2, 1, 3),(35, 1446, 2, 1, 4),(35, 1447, 2, 1, 3),(35, 1448, 2, 1, 4),(35, 1449, 2, 1, 3),(35, 1450, 2, 1, 4),(35, 1451, 2, 1, 3),(35, 1452, 2, 1, 4),(35, 1453, 2, 1, 3),(35, 1454, 2, 1, 4),(35, 1455, 2, 1, 3),(35, 1456, 2, 1, 4),(35, 1457, 3, 1, 3),(35, 1458, 3, 1, 4),(35, 1459, 3, 1, 3),(35, 1460, 3, 1, 4),(35, 1461, 3, 1, 3),(35, 1462, 3, 1, 4),(35, 1463, 3, 1, 3),(35, 1464, 3, 1, 4),(35, 1465, 4, 1, 3),(35, 1466, 4, 1, 4),(35, 1467, 4, 1, 3),(35, 1468, 4, 1, 4),(35, 1469, 4, 1, 3),(35, 1470, 4, 1, 4),(35, 1471, 5, 1, 3),(35, 1472, 5, 1, 4),(35, 1473, 5, 1, 1),(35, 1474, 5, 1, 2),(35, 1475, 5, 1, 1),(35, 1476, 5, 1, 2),(35, 1477, 5, 1, 1),(35, 1478, 5, 1, 2),(35, 1479, 5, 1, 1),(35, 1480, 5, 1, 2),(35, 1481, 5, 1, 1),(35, 1482, 5, 1, 2),(35, 1483, 5, 1, 1),(35, 1484, 5, 1, 2),(35, 1485, 5, 1, 1),(35, 1486, 5, 1, 2),(35, 1487, 5, 1, 1),(35, 1488, 5, 1, 2),(35, 1489, 5, 1, 1),(35, 1490, 5, 1, 2),(35, 1491, 5, 1, 1),(35, 1492, 5, 1, 2),(35, 1493, 5, 1, 1),(35, 1494, 5, 1, 2),(35, 1495, 5, 1, 1),(35, 1496, 5, 1, 2),(35, 1497, 5, 1, 1),(35, 1498, 5, 1, 2),(35, 1499, 5, 1, 1),(35, 1500, 5, 1, 2),(35, 1501, 5, 1, 1),(35, 1502, 5, 1, 2),(35, 1503, 5, 1, 1),(35, 1504, 5, 1, 2),(35, 1505, 5, 1, 3),(35, 1506, 5, 1, 4),(35, 1507, 5, 1, 3),(35, 1508, 5, 1, 4),(35, 1509, 5, 1, 3),(35, 1510, 5, 1, 4),(35, 1511, 5, 1, 3),(35, 1512, 5, 1, 4),(35, 1513, 5, 1, 3),(35, 1514, 5, 1, 4),(35, 1515, 5, 1, 3),(35, 1516, 5, 1, 4),(35, 1517, 5, 1, 3),(35, 1518, 5, 1, 4),(35, 1519, 5, 1, 3),(35, 1520, 5, 1, 4),(35, 1521, 5, 1, 3),(35, 1522, 5, 1, 4),(35, 1523, 5, 1, 3),(35, 1524, 5, 1, 4),(35, 1525, 5, 1, 3),(35, 1526, 5, 1, 4),(35, 1527, 5, 1, 3),(35, 1528, 5, 1, 4),(35, 1529, 5, 1, 3),(35, 1530, 5, 1, 4),(35, 1531, 5, 1, 3),(35, 1532, 5, 1, 4),(35, 1533, 5, 1, 3),(35, 1534, 5, 1, 4),(35, 1535, 5, 1, 3),(35, 1536, 5, 1, 4),(36, 1, 5, 1, 1),(36, 2, 5, 1, 1),(36, 3, 5, 1, 1),(36, 4, 5, 1, 1),(36, 5, 5, 1, 1),(36, 6, 5, 1, 1),(36, 7, 5, 1, 1),(36, 8, 5, 1, 1),(36, 9, 5, 1, 1),(36, 10, 5, 1, 1),(36, 11, 5, 1, 1),(36, 12, 5, 1, 1),(36, 13, 5, 1, 1),(36, 14, 5, 1, 1),(36, 15, 5, 1, 1),(36, 16, 5, 1, 1),(36, 17, 5, 1, 1),(36, 18, 5, 1, 1),(36, 19, 5, 1, 1),(36, 20, 5, 1, 1),(36, 21, 5, 1, 1),(36, 22, 5, 1, 1),(36, 23, 5, 1, 1),(36, 24, 5, 1, 1),(36, 25, 5, 1, 1),(36, 26, 5, 1, 1),(36, 27, 5, 1, 1),(36, 28, 5, 1, 1),(36, 29, 5, 1, 1),(36, 30, 5, 1, 1),(36, 31, 5, 1, 1),(36, 32, 5, 1, 1),(36, 33, 5, 1, 2),(36, 34, 5, 1, 2),(36, 35, 5, 1, 2),(36, 36, 5, 1, 2),(36, 37, 5, 1, 2),(36, 38, 5, 1, 2),(36, 39, 5, 1, 2),(36, 40, 5, 1, 2),(36, 41, 5, 1, 2),(36, 42, 5, 1, 2),(36, 43, 5, 1, 2),(36, 44, 5, 1, 2),(36, 45, 5, 1, 2),(36, 46, 5, 1, 2),(36, 47, 5, 1, 2),(36, 48, 5, 1, 2),(36, 49, 5, 1, 2),(36, 50, 5, 1, 2),(36, 51, 5, 1, 2),(36, 52, 5, 1, 2),(36, 53, 5, 1, 2),(36, 54, 5, 1, 2),(36, 55, 5, 1, 2),(36, 56, 5, 1, 2),(36, 57, 5, 1, 2),(36, 58, 5, 1, 2),(36, 59, 5, 1, 2),(36, 60, 5, 1, 2),(36, 61, 5, 1, 2),(36, 62, 5, 1, 2),(36, 63, 5, 1, 2),(36, 64, 5, 1, 2),(36, 65, 5, 1, 1),(36, 66, 5, 1, 1),(36, 67, 1, 1, 1),(36, 68, 1, 1, 1),(36, 69, 1, 1, 1),(36, 70, 1, 1, 1),(36, 71, 1, 1, 1),(36, 72, 1, 1, 1),(36, 73, 1, 1, 1),(36, 74, 1, 1, 1),(36, 75, 1, 1, 1),(36, 76, 1, 1, 1),(36, 77, 1, 1, 1),(36, 78, 1, 1, 1),(36, 79, 1, 1, 1),(36, 80, 1, 1, 1),(36, 81, 1, 1, 1),(36, 82, 1, 1, 1),(36, 83, 1, 1, 1),(36, 84, 1, 1, 1),(36, 85, 1, 1, 1),(36, 86, 1, 1, 1),(36, 87, 1, 1, 1),(36, 88, 1, 1, 1),(36, 89, 1, 1, 1),(36, 90, 1, 1, 1),(36, 91, 1, 1, 1),(36, 92, 1, 1, 1),(36, 93, 1, 1, 1),(36, 94, 1, 1, 1),(36, 95, 5, 1, 1),(36, 96, 5, 1, 1),(36, 97, 5, 1, 2),(36, 98, 5, 1, 2),(36, 99, 1, 1, 2),(36, 100, 1, 1, 2),(36, 101, 1, 1, 2),(36, 102, 1, 1, 2),(36, 103, 1, 1, 2),(36, 104, 1, 1, 2),(36, 105, 1, 1, 2),(36, 106, 1, 1, 2),(36, 107, 1, 1, 2),(36, 108, 1, 1, 2),(36, 109, 1, 1, 2),(36, 110, 1, 1, 2),(36, 111, 1, 1, 2),(36, 112, 1, 1, 2),(36, 113, 1, 1, 2),(36, 114, 1, 1, 2),(36, 115, 1, 1, 2),(36, 116, 1, 1, 2),(36, 117, 1, 1, 2),(36, 118, 1, 1, 2),(36, 119, 1, 1, 2),(36, 120, 1, 1, 2),(36, 121, 1, 1, 2),(36, 122, 1, 1, 2),(36, 123, 1, 1, 2),(36, 124, 1, 1, 2),(36, 125, 1, 1, 2),(36, 126, 1, 1, 2),(36, 127, 5, 1, 2),(36, 128, 5, 1, 2),(36, 129, 5, 1, 1),(36, 130, 5, 1, 1),(36, 131, 1, 1, 1),(36, 132, 1, 1, 1),(36, 133, 1, 1, 1),(36, 134, 1, 1, 1),(36, 135, 1, 1, 1),(36, 136, 1, 1, 1),(36, 137, 1, 1, 1),(36, 138, 1, 1, 1),(36, 139, 1, 1, 1),(36, 140, 1, 1, 1),(36, 141, 1, 1, 1),(36, 142, 1, 1, 1),(36, 143, 1, 1, 1),(36, 144, 1, 1, 1),(36, 145, 1, 1, 1),(36, 146, 1, 1, 1),(36, 147, 1, 1, 1),(36, 148, 1, 1, 1),(36, 149, 1, 1, 1),(36, 150, 1, 1, 1),(36, 151, 1, 1, 1),(36, 152, 1, 1, 1),(36, 153, 1, 1, 1),(36, 154, 1, 1, 1),(36, 155, 1, 1, 1),(36, 156, 1, 1, 1),(36, 157, 1, 1, 1),(36, 158, 1, 1, 1),(36, 159, 5, 1, 1),(36, 160, 5, 1, 1),(36, 161, 5, 1, 2),(36, 162, 5, 1, 2),(36, 163, 1, 1, 2),(36, 164, 1, 1, 2),(36, 165, 1, 1, 2),(36, 166, 1, 1, 2),(36, 167, 1, 1, 2),(36, 168, 1, 1, 2),(36, 169, 1, 1, 2),(36, 170, 1, 1, 2),(36, 171, 1, 1, 2),(36, 172, 1, 1, 2),(36, 173, 1, 1, 2),(36, 174, 1, 1, 2),(36, 175, 1, 1, 2),(36, 176, 1, 1, 2),(36, 177, 1, 1, 2),(36, 178, 1, 1, 2),(36, 179, 1, 1, 2),(36, 180, 1, 1, 2),(36, 181, 1, 1, 2),(36, 182, 1, 1, 2),(36, 183, 1, 1, 2),(36, 184, 1, 1, 2),(36, 185, 1, 1, 2),(36, 186, 1, 1, 2),(36, 187, 1, 1, 2),(36, 188, 1, 1, 2),(36, 189, 1, 1, 2),(36, 190, 1, 1, 2),(36, 191, 5, 1, 2),(36, 192, 5, 1, 2),(36, 193, 5, 1, 1),(36, 194, 5, 1, 1),(36, 195, 1, 1, 1),(36, 196, 1, 1, 1),(36, 197, 1, 1, 1),(36, 198, 1, 1, 1),(36, 199, 1, 1, 1),(36, 200, 1, 1, 1),(36, 201, 1, 1, 1),(36, 202, 1, 1, 1),(36, 203, 1, 1, 1),(36, 204, 1, 1, 1),(36, 205, 1, 1, 1),(36, 206, 1, 1, 1),(36, 207, 1, 1, 1),(36, 208, 1, 1, 1),(36, 209, 1, 1, 1),(36, 210, 1, 1, 1),(36, 211, 1, 1, 1),(36, 212, 1, 1, 1),(36, 213, 1, 1, 1),(36, 214, 1, 1, 1),(36, 215, 1, 1, 1),(36, 216, 1, 1, 1),(36, 217, 1, 1, 1),(36, 218, 1, 1, 1),(36, 219, 1, 1, 1),(36, 220, 1, 1, 1),(36, 221, 1, 1, 1),(36, 222, 1, 1, 1),(36, 223, 5, 1, 1),(36, 224, 5, 1, 1),(36, 225, 5, 1, 2),(36, 226, 5, 1, 2),(36, 227, 1, 1, 2),(36, 228, 1, 1, 2),(36, 229, 1, 1, 2),(36, 230, 1, 1, 2),(36, 231, 1, 1, 2),(36, 232, 1, 1, 2),(36, 233, 1, 1, 2),(36, 234, 1, 1, 2),(36, 235, 1, 1, 2),(36, 236, 1, 1, 2),(36, 237, 1, 1, 2),(36, 238, 1, 1, 2),(36, 239, 1, 1, 2),(36, 240, 1, 1, 2),(36, 241, 1, 1, 2),(36, 242, 1, 1, 2),(36, 243, 1, 1, 2),(36, 244, 1, 1, 2),(36, 245, 1, 1, 2),(36, 246, 1, 1, 2),(36, 247, 1, 1, 2),(36, 248, 1, 1, 2),(36, 249, 1, 1, 2),(36, 250, 1, 1, 2),(36, 251, 1, 1, 2),(36, 252, 1, 1, 2),(36, 253, 1, 1, 2),(36, 254, 1, 1, 2),(36, 255, 5, 1, 2),(36, 256, 5, 1, 2),(36, 257, 5, 1, 1),(36, 258, 5, 1, 1),(36, 259, 1, 1, 1),(36, 260, 1, 1, 1),(36, 261, 1, 1, 1),(36, 262, 1, 1, 1),(36, 263, 1, 1, 1),(36, 264, 1, 1, 1),(36, 265, 1, 1, 1),(36, 266, 1, 1, 1),(36, 267, 1, 1, 1),(36, 268, 1, 1, 1),(36, 269, 1, 1, 1),(36, 270, 1, 1, 1),(36, 271, 1, 1, 1),(36, 272, 1, 1, 1),(36, 273, 1, 1, 1),(36, 274, 1, 1, 1),(36, 275, 1, 1, 1),(36, 276, 1, 1, 1),(36, 277, 1, 1, 1),(36, 278, 1, 1, 1),(36, 279, 1, 1, 1),(36, 280, 1, 1, 1),(36, 281, 1, 1, 1),(36, 282, 1, 1, 1),(36, 283, 1, 1, 1),(36, 284, 1, 1, 1),(36, 285, 1, 1, 1),(36, 286, 1, 1, 1),(36, 287, 5, 1, 1),(36, 288, 5, 1, 1),(36, 289, 5, 1, 2),(36, 290, 5, 1, 2),(36, 291, 1, 1, 2),(36, 292, 1, 1, 2),(36, 293, 1, 1, 2),(36, 294, 1, 1, 2),(36, 295, 1, 1, 2),(36, 296, 1, 1, 2),(36, 297, 1, 1, 2),(36, 298, 1, 1, 2),(36, 299, 1, 1, 2),(36, 300, 1, 1, 2),(36, 301, 1, 1, 2),(36, 302, 1, 1, 2),(36, 303, 1, 1, 2),(36, 304, 1, 1, 2),(36, 305, 1, 1, 2),(36, 306, 1, 1, 2),(36, 307, 1, 1, 2),(36, 308, 1, 1, 2),(36, 309, 1, 1, 2),(36, 310, 1, 1, 2),(36, 311, 1, 1, 2),(36, 312, 1, 1, 2),(36, 313, 1, 1, 2),(36, 314, 1, 1, 2),(36, 315, 1, 1, 2),(36, 316, 1, 1, 2),(36, 317, 1, 1, 2),(36, 318, 1, 1, 2),(36, 319, 5, 1, 2),(36, 320, 5, 1, 2),(36, 321, 5, 1, 1),(36, 322, 5, 1, 1),(36, 323, 1, 1, 1),(36, 324, 1, 1, 1),(36, 325, 1, 1, 1),(36, 326, 1, 1, 1),(36, 327, 1, 1, 1),(36, 328, 1, 1, 1),(36, 329, 1, 1, 1),(36, 330, 1, 1, 1),(36, 331, 1, 1, 1),(36, 332, 1, 1, 1),(36, 333, 1, 1, 1),(36, 334, 1, 1, 1),(36, 335, 1, 1, 1),(36, 336, 1, 1, 1),(36, 337, 1, 1, 1),(36, 338, 1, 1, 1),(36, 339, 1, 1, 1),(36, 340, 1, 1, 1),(36, 341, 1, 1, 1),(36, 342, 1, 1, 1),(36, 343, 1, 1, 1),(36, 344, 1, 1, 1),(36, 345, 1, 1, 1),(36, 346, 1, 1, 1),(36, 347, 1, 1, 1),(36, 348, 1, 1, 1),(36, 349, 1, 1, 1),(36, 350, 1, 1, 1),(36, 351, 5, 1, 1),(36, 352, 5, 1, 1),(36, 353, 5, 1, 2),(36, 354, 5, 1, 2),(36, 355, 1, 1, 2),(36, 356, 1, 1, 2),(36, 357, 1, 1, 2),(36, 358, 1, 1, 2),(36, 359, 1, 1, 2),(36, 360, 1, 1, 2),(36, 361, 1, 1, 2),(36, 362, 1, 1, 2),(36, 363, 1, 1, 2),(36, 364, 1, 1, 2),(36, 365, 1, 1, 2),(36, 366, 1, 1, 2),(36, 367, 1, 1, 2),(36, 368, 1, 1, 2),(36, 369, 1, 1, 2),(36, 370, 1, 1, 2),(36, 371, 1, 1, 2),(36, 372, 1, 1, 2),(36, 373, 1, 1, 2),(36, 374, 1, 1, 2),(36, 375, 1, 1, 2),(36, 376, 1, 1, 2),(36, 377, 1, 1, 2),(36, 378, 1, 1, 2),(36, 379, 1, 1, 2),(36, 380, 1, 1, 2),(36, 381, 1, 1, 2),(36, 382, 1, 1, 2),(36, 383, 5, 1, 2),(36, 384, 5, 1, 2),(36, 385, 5, 1, 1),(36, 386, 5, 1, 1),(36, 387, 1, 1, 1),(36, 388, 1, 1, 1),(36, 389, 1, 1, 1),(36, 390, 1, 1, 1),(36, 391, 1, 1, 1),(36, 392, 1, 1, 1),(36, 393, 1, 1, 1),(36, 394, 1, 1, 1),(36, 395, 1, 1, 1),(36, 396, 1, 1, 1),(36, 397, 1, 1, 1),(36, 398, 1, 1, 1),(36, 399, 1, 1, 1),(36, 400, 1, 1, 1),(36, 401, 1, 1, 1),(36, 402, 1, 1, 1),(36, 403, 1, 1, 1),(36, 404, 1, 1, 1),(36, 405, 1, 1, 1),(36, 406, 1, 1, 1),(36, 407, 1, 1, 1),(36, 408, 1, 1, 1),(36, 409, 1, 1, 1),(36, 410, 1, 1, 1),(36, 411, 1, 1, 1),(36, 412, 1, 1, 1),(36, 413, 1, 1, 1),(36, 414, 1, 1, 1),(36, 415, 5, 1, 1),(36, 416, 5, 1, 1),(36, 417, 5, 1, 2),(36, 418, 5, 1, 2),(36, 419, 1, 1, 2),(36, 420, 1, 1, 2),(36, 421, 1, 1, 2),(36, 422, 1, 1, 2),(36, 423, 1, 1, 2),(36, 424, 1, 1, 2),(36, 425, 1, 1, 2),(36, 426, 1, 1, 2),(36, 427, 1, 1, 2),(36, 428, 1, 1, 2),(36, 429, 1, 1, 2),(36, 430, 1, 1, 2),(36, 431, 1, 1, 2),(36, 432, 1, 1, 2),(36, 433, 1, 1, 2),(36, 434, 1, 1, 2),(36, 435, 1, 1, 2),(36, 436, 1, 1, 2),(36, 437, 1, 1, 2),(36, 438, 1, 1, 2),(36, 439, 1, 1, 2),(36, 440, 1, 1, 2),(36, 441, 1, 1, 2),(36, 442, 1, 1, 2),(36, 443, 1, 1, 2),(36, 444, 1, 1, 2),(36, 445, 1, 1, 2),(36, 446, 1, 1, 2),(36, 447, 5, 1, 2),(36, 448, 5, 1, 2),(36, 449, 5, 1, 1),(36, 450, 5, 1, 1),(36, 451, 1, 1, 1),(36, 452, 1, 1, 1),(36, 453, 1, 1, 1),(36, 454, 1, 1, 1),(36, 455, 1, 1, 1),(36, 456, 1, 1, 1),(36, 457, 1, 1, 1),(36, 458, 1, 1, 1),(36, 459, 1, 1, 1),(36, 460, 1, 1, 1),(36, 461, 1, 1, 1),(36, 462, 1, 1, 1),(36, 463, 1, 1, 1),(36, 464, 1, 1, 1),(36, 465, 1, 1, 1),(36, 466, 1, 1, 1),(36, 467, 1, 1, 1),(36, 468, 1, 1, 1),(36, 469, 1, 1, 1),(36, 470, 1, 1, 1),(36, 471, 1, 1, 1),(36, 472, 1, 1, 1),(36, 473, 1, 1, 1),(36, 474, 1, 1, 1),(36, 475, 1, 1, 1),(36, 476, 1, 1, 1),(36, 477, 1, 1, 1),(36, 478, 1, 1, 1),(36, 479, 5, 1, 1),(36, 480, 5, 1, 1),(36, 481, 5, 1, 2),(36, 482, 5, 1, 2),(36, 483, 1, 1, 2),(36, 484, 1, 1, 2),(36, 485, 1, 1, 2),(36, 486, 1, 1, 2),(36, 487, 1, 1, 2),(36, 488, 1, 1, 2),(36, 489, 1, 1, 2),(36, 490, 1, 1, 2),(36, 491, 1, 1, 2),(36, 492, 1, 1, 2),(36, 493, 1, 1, 2),(36, 494, 1, 1, 2),(36, 495, 1, 1, 2),(36, 496, 1, 1, 2),(36, 497, 1, 1, 2),(36, 498, 1, 1, 2),(36, 499, 1, 1, 2),(36, 500, 1, 1, 2),(36, 501, 1, 1, 2),(36, 502, 1, 1, 2),(36, 503, 1, 1, 2),(36, 504, 1, 1, 2),(36, 505, 1, 1, 2),(36, 506, 1, 1, 2),(36, 507, 1, 1, 2),(36, 508, 1, 1, 2),(36, 509, 1, 1, 2),(36, 510, 1, 1, 2),(36, 511, 5, 1, 2),(36, 512, 5, 1, 2),(36, 513, 5, 1, 1),(36, 514, 5, 1, 1),(36, 515, 1, 1, 1),(36, 516, 1, 1, 1),(36, 517, 1, 1, 1),(36, 518, 1, 1, 1),(36, 519, 1, 1, 1),(36, 520, 1, 1, 1),(36, 521, 1, 1, 1),(36, 522, 1, 1, 1),(36, 523, 1, 1, 1),(36, 524, 1, 1, 1),(36, 525, 1, 1, 1),(36, 526, 1, 1, 1),(36, 527, 1, 1, 1),(36, 528, 1, 1, 1),(36, 529, 1, 1, 1),(36, 530, 1, 1, 1),(36, 531, 1, 1, 1),(36, 532, 1, 1, 1),(36, 533, 1, 1, 1),(36, 534, 1, 1, 1),(36, 535, 1, 1, 1),(36, 536, 1, 1, 1),(36, 537, 1, 1, 1),(36, 538, 1, 1, 1),(36, 539, 1, 1, 1),(36, 540, 1, 1, 1),(36, 541, 1, 1, 1),(36, 542, 1, 1, 1),(36, 543, 5, 1, 1),(36, 544, 5, 1, 1),(36, 545, 5, 1, 2),(36, 546, 5, 1, 2),(36, 547, 1, 1, 2),(36, 548, 1, 1, 2),(36, 549, 1, 1, 2),(36, 550, 1, 1, 2),(36, 551, 1, 1, 2),(36, 552, 1, 1, 2),(36, 553, 1, 1, 2),(36, 554, 1, 1, 2),(36, 555, 1, 1, 2),(36, 556, 1, 1, 2),(36, 557, 1, 1, 2),(36, 558, 1, 1, 2),(36, 559, 1, 1, 2),(36, 560, 1, 1, 2),(36, 561, 1, 1, 2),(36, 562, 1, 1, 2),(36, 563, 1, 1, 2),(36, 564, 1, 1, 2),(36, 565, 1, 1, 2),(36, 566, 1, 1, 2),(36, 567, 1, 1, 2),(36, 568, 1, 1, 2),(36, 569, 1, 1, 2),(36, 570, 1, 1, 2),(36, 571, 1, 1, 2),(36, 572, 1, 1, 2),(36, 573, 1, 1, 2),(36, 574, 1, 1, 2),(36, 575, 5, 1, 2),(36, 576, 5, 1, 2),(36, 577, 5, 1, 1),(36, 578, 5, 1, 1),(36, 579, 1, 1, 1),(36, 580, 1, 1, 1),(36, 581, 1, 1, 1),(36, 582, 1, 1, 1),(36, 583, 1, 1, 1),(36, 584, 1, 1, 1),(36, 585, 1, 1, 1),(36, 586, 1, 1, 1),(36, 587, 1, 1, 1),(36, 588, 1, 1, 1),(36, 589, 1, 1, 1),(36, 590, 1, 1, 1),(36, 591, 1, 1, 1),(36, 592, 1, 1, 1),(36, 593, 1, 1, 1),(36, 594, 1, 1, 1),(36, 595, 1, 1, 1),(36, 596, 1, 1, 1),(36, 597, 1, 1, 1),(36, 598, 1, 1, 1),(36, 599, 1, 1, 1),(36, 600, 1, 1, 1),(36, 601, 1, 1, 1),(36, 602, 1, 1, 1),(36, 603, 1, 1, 1),(36, 604, 1, 1, 1),(36, 605, 1, 1, 1),(36, 606, 1, 1, 1),(36, 607, 5, 1, 1),(36, 608, 5, 1, 1),(36, 609, 5, 1, 2),(36, 610, 5, 1, 2),(36, 611, 1, 1, 2),(36, 612, 1, 1, 2),(36, 613, 1, 1, 2),(36, 614, 1, 1, 2),(36, 615, 1, 1, 2),(36, 616, 1, 1, 2),(36, 617, 1, 1, 2),(36, 618, 1, 1, 2),(36, 619, 1, 1, 2),(36, 620, 1, 1, 2),(36, 621, 1, 1, 2),(36, 622, 1, 1, 2),(36, 623, 1, 1, 2),(36, 624, 1, 1, 2),(36, 625, 1, 1, 2),(36, 626, 1, 1, 2),(36, 627, 1, 1, 2),(36, 628, 1, 1, 2),(36, 629, 1, 1, 2),(36, 630, 1, 1, 2),(36, 631, 1, 1, 2),(36, 632, 1, 1, 2),(36, 633, 1, 1, 2),(36, 634, 1, 1, 2),(36, 635, 1, 1, 2),(36, 636, 1, 1, 2),(36, 637, 1, 1, 2),(36, 638, 1, 1, 2),(36, 639, 5, 1, 2),(36, 640, 5, 1, 2),(36, 641, 5, 1, 1),(36, 642, 5, 1, 1),(36, 643, 1, 1, 1),(36, 644, 1, 1, 1),(36, 645, 1, 1, 1),(36, 646, 1, 1, 1),(36, 647, 1, 1, 1),(36, 648, 1, 1, 1),(36, 649, 1, 1, 1),(36, 650, 1, 1, 1),(36, 651, 1, 1, 1),(36, 652, 1, 1, 1),(36, 653, 1, 1, 1),(36, 654, 1, 1, 1),(36, 655, 1, 1, 1),(36, 656, 1, 1, 1),(36, 657, 1, 1, 1),(36, 658, 1, 1, 1),(36, 659, 1, 1, 1),(36, 660, 1, 1, 1),(36, 661, 1, 1, 1),(36, 662, 1, 1, 1),(36, 663, 1, 1, 1),(36, 664, 1, 1, 1),(36, 665, 1, 1, 1),(36, 666, 1, 1, 1),(36, 667, 1, 1, 1),(36, 668, 1, 1, 1),(36, 669, 1, 1, 1),(36, 670, 1, 1, 1),(36, 671, 5, 1, 1),(36, 672, 5, 1, 1),(36, 673, 5, 1, 2),(36, 674, 5, 1, 2),(36, 675, 1, 1, 2),(36, 676, 1, 1, 2),(36, 677, 1, 1, 2),(36, 678, 1, 1, 2),(36, 679, 1, 1, 2),(36, 680, 1, 1, 2),(36, 681, 1, 1, 2),(36, 682, 1, 1, 2),(36, 683, 1, 1, 2),(36, 684, 1, 1, 2),(36, 685, 1, 1, 2),(36, 686, 1, 1, 2),(36, 687, 1, 1, 2),(36, 688, 1, 1, 2),(36, 689, 1, 1, 2),(36, 690, 1, 1, 2),(36, 691, 1, 1, 2),(36, 692, 1, 1, 2),(36, 693, 1, 1, 2),(36, 694, 1, 1, 2),(36, 695, 1, 1, 2),(36, 696, 1, 1, 2),(36, 697, 1, 1, 2),(36, 698, 1, 1, 2),(36, 699, 1, 1, 2),(36, 700, 1, 1, 2),(36, 701, 1, 1, 2),(36, 702, 1, 1, 2),(36, 703, 5, 1, 2),(36, 704, 5, 1, 2),(36, 705, 5, 1, 1),(36, 706, 5, 1, 1),(36, 707, 1, 1, 1),(36, 708, 1, 1, 1),(36, 709, 1, 1, 1),(36, 710, 1, 1, 1),(36, 711, 1, 1, 1),(36, 712, 1, 1, 1),(36, 713, 1, 1, 1),(36, 714, 1, 1, 1),(36, 715, 1, 1, 1),(36, 716, 1, 1, 1),(36, 717, 1, 1, 1),(36, 718, 1, 1, 1),(36, 719, 1, 1, 1),(36, 720, 1, 1, 1),(36, 721, 1, 1, 1),(36, 722, 1, 1, 1),(36, 723, 1, 1, 1),(36, 724, 1, 1, 1),(36, 725, 1, 1, 1),(36, 726, 1, 1, 1),(36, 727, 1, 1, 1),(36, 728, 1, 1, 1),(36, 729, 1, 1, 1),(36, 730, 1, 1, 1),(36, 731, 1, 1, 1),(36, 732, 1, 1, 1),(36, 733, 1, 1, 1),(36, 734, 1, 1, 1),(36, 735, 5, 1, 1),(36, 736, 5, 1, 1),(36, 737, 5, 1, 2),(36, 738, 5, 1, 2),(36, 739, 1, 1, 2),(36, 740, 1, 1, 2),(36, 741, 1, 1, 2),(36, 742, 1, 1, 2),(36, 743, 1, 1, 2),(36, 744, 1, 1, 2),(36, 745, 1, 1, 2),(36, 746, 1, 1, 2),(36, 747, 1, 1, 2),(36, 748, 1, 1, 2),(36, 749, 1, 1, 2),(36, 750, 1, 1, 2),(36, 751, 1, 1, 2),(36, 752, 1, 1, 2),(36, 753, 1, 1, 2),(36, 754, 1, 1, 2),(36, 755, 1, 1, 2),(36, 756, 1, 1, 2),(36, 757, 1, 1, 2),(36, 758, 1, 1, 2),(36, 759, 1, 1, 2),(36, 760, 1, 1, 2),(36, 761, 1, 1, 2),(36, 762, 1, 1, 2),(36, 763, 1, 1, 2),(36, 764, 1, 1, 2),(36, 765, 1, 1, 2),(36, 766, 1, 1, 2),(36, 767, 5, 1, 2),(36, 768, 5, 1, 2),(36, 769, 5, 1, 1),(36, 770, 5, 1, 1),(36, 771, 1, 1, 1),(36, 772, 1, 1, 1),(36, 773, 1, 1, 1),(36, 774, 1, 1, 1),(36, 775, 1, 1, 1),(36, 776, 1, 1, 1),(36, 777, 1, 1, 1),(36, 778, 1, 1, 1),(36, 779, 1, 1, 1),(36, 780, 1, 1, 1),(36, 781, 1, 1, 1),(36, 782, 1, 1, 1),(36, 783, 1, 1, 1),(36, 784, 1, 1, 1),(36, 785, 1, 1, 1),(36, 786, 1, 1, 1),(36, 787, 1, 1, 1),(36, 788, 1, 1, 1),(36, 789, 1, 1, 1),(36, 790, 1, 1, 1),(36, 791, 1, 1, 1),(36, 792, 1, 1, 1),(36, 793, 1, 1, 1),(36, 794, 1, 1, 1),(36, 795, 1, 1, 1),(36, 796, 1, 1, 1),(36, 797, 1, 1, 1),(36, 798, 1, 1, 1),(36, 799, 5, 1, 1),(36, 800, 5, 1, 1),(36, 801, 5, 1, 2),(36, 802, 5, 1, 2),(36, 803, 1, 1, 2),(36, 804, 1, 1, 2),(36, 805, 1, 1, 2),(36, 806, 1, 1, 2),(36, 807, 1, 1, 2),(36, 808, 1, 1, 2),(36, 809, 1, 1, 2),(36, 810, 1, 1, 2),(36, 811, 1, 1, 2),(36, 812, 1, 1, 2),(36, 813, 1, 1, 2),(36, 814, 1, 1, 2),(36, 815, 1, 1, 2),(36, 816, 1, 1, 2),(36, 817, 1, 1, 2),(36, 818, 1, 1, 2),(36, 819, 1, 1, 2),(36, 820, 1, 1, 2),(36, 821, 1, 1, 2),(36, 822, 1, 1, 2),(36, 823, 1, 1, 2),(36, 824, 1, 1, 2),(36, 825, 1, 1, 2),(36, 826, 1, 1, 2),(36, 827, 1, 1, 2),(36, 828, 1, 1, 2),(36, 829, 1, 1, 2),(36, 830, 1, 1, 2),(36, 831, 5, 1, 2),(36, 832, 5, 1, 2),(36, 833, 5, 1, 1),(36, 834, 5, 1, 1),(36, 835, 1, 1, 1),(36, 836, 1, 1, 1),(36, 837, 1, 1, 1),(36, 838, 1, 1, 1),(36, 839, 1, 1, 1),(36, 840, 1, 1, 1),(36, 841, 1, 1, 1),(36, 842, 1, 1, 1),(36, 843, 1, 1, 1),(36, 844, 1, 1, 1),(36, 845, 1, 1, 1),(36, 846, 1, 1, 1),(36, 847, 1, 1, 1),(36, 848, 1, 1, 1),(36, 849, 1, 1, 1),(36, 850, 1, 1, 1),(36, 851, 1, 1, 1),(36, 852, 1, 1, 1),(36, 853, 1, 1, 1),(36, 854, 1, 1, 1),(36, 855, 1, 1, 1),(36, 856, 1, 1, 1),(36, 857, 1, 1, 1),(36, 858, 1, 1, 1),(36, 859, 1, 1, 1),(36, 860, 1, 1, 1),(36, 861, 1, 1, 1),(36, 862, 1, 1, 1),(36, 863, 5, 1, 1),(36, 864, 5, 1, 1),(36, 865, 5, 1, 2),(36, 866, 5, 1, 2),(36, 867, 1, 1, 2),(36, 868, 1, 1, 2),(36, 869, 1, 1, 2),(36, 870, 1, 1, 2),(36, 871, 1, 1, 2),(36, 872, 1, 1, 2),(36, 873, 1, 1, 2),(36, 874, 1, 1, 2),(36, 875, 1, 1, 2),(36, 876, 1, 1, 2),(36, 877, 1, 1, 2),(36, 878, 1, 1, 2),(36, 879, 1, 1, 2),(36, 880, 1, 1, 2),(36, 881, 1, 1, 2),(36, 882, 1, 1, 2),(36, 883, 1, 1, 2),(36, 884, 1, 1, 2),(36, 885, 1, 1, 2),(36, 886, 1, 1, 2),(36, 887, 1, 1, 2),(36, 888, 1, 1, 2),(36, 889, 1, 1, 2),(36, 890, 1, 1, 2),(36, 891, 1, 1, 2),(36, 892, 1, 1, 2),(36, 893, 1, 1, 2),(36, 894, 1, 1, 2),(36, 895, 5, 1, 2),(36, 896, 5, 1, 2),(36, 897, 5, 1, 1),(36, 898, 5, 1, 1),(36, 899, 1, 1, 1),(36, 900, 1, 1, 1),(36, 901, 1, 1, 1),(36, 902, 1, 1, 1),(36, 903, 1, 1, 1),(36, 904, 1, 1, 1),(36, 905, 1, 1, 1),(36, 906, 1, 1, 1),(36, 907, 1, 1, 1),(36, 908, 1, 1, 1),(36, 909, 1, 1, 1),(36, 910, 1, 1, 1),(36, 911, 1, 1, 1),(36, 912, 1, 1, 1),(36, 913, 1, 1, 1),(36, 914, 1, 1, 1),(36, 915, 1, 1, 1),(36, 916, 1, 1, 1),(36, 917, 1, 1, 1),(36, 918, 1, 1, 1),(36, 919, 1, 1, 1),(36, 920, 1, 1, 1),(36, 921, 1, 1, 1),(36, 922, 1, 1, 1),(36, 923, 1, 1, 1),(36, 924, 1, 1, 1),(36, 925, 1, 1, 1),(36, 926, 1, 1, 1),(36, 927, 5, 1, 1),(36, 928, 5, 1, 1),(36, 929, 5, 1, 2),(36, 930, 5, 1, 2),(36, 931, 1, 1, 2),(36, 932, 1, 1, 2),(36, 933, 1, 1, 2),(36, 934, 1, 1, 2),(36, 935, 1, 1, 2),(36, 936, 1, 1, 2),(36, 937, 1, 1, 2),(36, 938, 1, 1, 2),(36, 939, 1, 1, 2),(36, 940, 1, 1, 2),(36, 941, 1, 1, 2),(36, 942, 1, 1, 2),(36, 943, 1, 1, 2),(36, 944, 1, 1, 2),(36, 945, 1, 1, 2),(36, 946, 1, 1, 2),(36, 947, 1, 1, 2),(36, 948, 1, 1, 2),(36, 949, 1, 1, 2),(36, 950, 1, 1, 2),(36, 951, 1, 1, 2),(36, 952, 1, 1, 2),(36, 953, 1, 1, 2),(36, 954, 1, 1, 2),(36, 955, 1, 1, 2),(36, 956, 1, 1, 2),(36, 957, 1, 1, 2),(36, 958, 1, 1, 2),(36, 959, 5, 1, 2),(36, 960, 5, 1, 2),(36, 961, 5, 1, 1),(36, 962, 5, 1, 1),(36, 963, 1, 1, 1),(36, 964, 1, 1, 1),(36, 965, 1, 1, 1),(36, 966, 1, 1, 1),(36, 967, 1, 1, 1),(36, 968, 1, 1, 1),(36, 969, 1, 1, 1),(36, 970, 1, 1, 1),(36, 971, 1, 1, 1),(36, 972, 1, 1, 1),(36, 973, 1, 1, 1),(36, 974, 1, 1, 1),(36, 975, 1, 1, 1),(36, 976, 1, 1, 1),(36, 977, 1, 1, 1),(36, 978, 1, 1, 1),(36, 979, 1, 1, 1),(36, 980, 1, 1, 1),(36, 981, 1, 1, 1),(36, 982, 1, 1, 1),(36, 983, 1, 1, 1),(36, 984, 1, 1, 1),(36, 985, 1, 1, 1),(36, 986, 1, 1, 1),(36, 987, 1, 1, 1),(36, 988, 1, 1, 1),(36, 989, 1, 1, 1),(36, 990, 1, 1, 1),(36, 991, 5, 1, 1),(36, 992, 5, 1, 1),(36, 993, 5, 1, 2),(36, 994, 5, 1, 2),(36, 995, 1, 1, 2),(36, 996, 1, 1, 2),(36, 997, 1, 1, 2),(36, 998, 1, 1, 2),(36, 999, 1, 1, 2),(36, 1000, 1, 1, 2),(36, 1001, 1, 1, 2),(36, 1002, 1, 1, 2),(36, 1003, 1, 1, 2),(36, 1004, 1, 1, 2),(36, 1005, 1, 1, 2),(36, 1006, 1, 1, 2),(36, 1007, 1, 1, 2),(36, 1008, 1, 1, 2),(36, 1009, 1, 1, 2),(36, 1010, 1, 1, 2),(36, 1011, 1, 1, 2),(36, 1012, 1, 1, 2),(36, 1013, 1, 1, 2),(36, 1014, 1, 1, 2),(36, 1015, 1, 1, 2),(36, 1016, 1, 1, 2),(36, 1017, 1, 1, 2),(36, 1018, 1, 1, 2),(36, 1019, 1, 1, 2),(36, 1020, 1, 1, 2),(36, 1021, 1, 1, 2),(36, 1022, 1, 1, 2),(36, 1023, 5, 1, 2),(36, 1024, 5, 1, 2),(36, 1025, 5, 1, 1),(36, 1026, 5, 1, 1),(36, 1027, 1, 1, 1),(36, 1028, 1, 1, 1),(36, 1029, 1, 1, 1),(36, 1030, 1, 1, 1),(36, 1031, 1, 1, 1),(36, 1032, 1, 1, 1),(36, 1033, 1, 1, 1),(36, 1034, 1, 1, 1),(36, 1035, 1, 1, 1),(36, 1036, 1, 1, 1),(36, 1037, 1, 1, 1),(36, 1038, 1, 1, 1),(36, 1039, 1, 1, 1),(36, 1040, 1, 1, 1),(36, 1041, 1, 1, 1),(36, 1042, 1, 1, 1),(36, 1043, 1, 1, 1),(36, 1044, 1, 1, 1),(36, 1045, 1, 1, 1),(36, 1046, 1, 1, 1),(36, 1047, 1, 1, 1),(36, 1048, 1, 1, 1),(36, 1049, 1, 1, 1),(36, 1050, 1, 1, 1),(36, 1051, 1, 1, 1),(36, 1052, 1, 1, 1),(36, 1053, 1, 1, 1),(36, 1054, 1, 1, 1),(36, 1055, 5, 1, 1),(36, 1056, 5, 1, 1),(36, 1057, 5, 1, 2),(36, 1058, 5, 1, 2),(36, 1059, 1, 1, 2),(36, 1060, 1, 1, 2),(36, 1061, 1, 1, 2),(36, 1062, 1, 1, 2),(36, 1063, 1, 1, 2),(36, 1064, 1, 1, 2),(36, 1065, 1, 1, 2),(36, 1066, 1, 1, 2),(36, 1067, 1, 1, 2),(36, 1068, 1, 1, 2),(36, 1069, 1, 1, 2),(36, 1070, 1, 1, 2),(36, 1071, 1, 1, 2),(36, 1072, 1, 1, 2),(36, 1073, 1, 1, 2),(36, 1074, 1, 1, 2),(36, 1075, 1, 1, 2),(36, 1076, 1, 1, 2),(36, 1077, 1, 1, 2),(36, 1078, 1, 1, 2),(36, 1079, 1, 1, 2),(36, 1080, 1, 1, 2),(36, 1081, 1, 1, 2),(36, 1082, 1, 1, 2),(36, 1083, 1, 1, 2),(36, 1084, 1, 1, 2),(36, 1085, 1, 1, 2),(36, 1086, 1, 1, 2),(36, 1087, 5, 1, 2),(36, 1088, 5, 1, 2),(36, 1089, 5, 1, 1),(36, 1090, 5, 1, 1),(36, 1091, 1, 1, 1),(36, 1092, 1, 1, 1),(36, 1093, 1, 1, 1),(36, 1094, 1, 1, 1),(36, 1095, 1, 1, 1),(36, 1096, 1, 1, 1),(36, 1097, 1, 1, 1),(36, 1098, 1, 1, 1),(36, 1099, 1, 1, 1),(36, 1100, 1, 1, 1),(36, 1101, 1, 1, 1),(36, 1102, 1, 1, 1),(36, 1103, 1, 1, 1),(36, 1104, 1, 1, 1),(36, 1105, 1, 1, 1),(36, 1106, 1, 1, 1),(36, 1107, 1, 1, 1),(36, 1108, 1, 1, 1),(36, 1109, 1, 1, 1),(36, 1110, 1, 1, 1),(36, 1111, 1, 1, 1),(36, 1112, 1, 1, 1),(36, 1113, 1, 1, 1),(36, 1114, 1, 1, 1),(36, 1115, 1, 1, 1),(36, 1116, 1, 1, 1),(36, 1117, 1, 1, 1),(36, 1118, 1, 1, 1),(36, 1119, 5, 1, 1),(36, 1120, 5, 1, 1),(36, 1121, 5, 1, 2),(36, 1122, 5, 1, 2),(36, 1123, 1, 1, 2),(36, 1124, 1, 1, 2),(36, 1125, 1, 1, 2),(36, 1126, 1, 1, 2),(36, 1127, 1, 1, 2),(36, 1128, 1, 1, 2),(36, 1129, 1, 1, 2),(36, 1130, 1, 1, 2),(36, 1131, 1, 1, 2),(36, 1132, 1, 1, 2),(36, 1133, 1, 1, 2),(36, 1134, 1, 1, 2),(36, 1135, 1, 1, 2),(36, 1136, 1, 1, 2),(36, 1137, 1, 1, 2),(36, 1138, 1, 1, 2),(36, 1139, 1, 1, 2),(36, 1140, 1, 1, 2),(36, 1141, 1, 1, 2),(36, 1142, 1, 1, 2),(36, 1143, 1, 1, 2),(36, 1144, 1, 1, 2),(36, 1145, 1, 1, 2),(36, 1146, 1, 1, 2),(36, 1147, 1, 1, 2),(36, 1148, 1, 1, 2),(36, 1149, 1, 1, 2),(36, 1150, 1, 1, 2),(36, 1151, 5, 1, 2),(36, 1152, 5, 1, 2),(36, 1153, 5, 1, 1),(36, 1154, 5, 1, 1),(36, 1155, 1, 1, 1),(36, 1156, 1, 1, 1),(36, 1157, 1, 1, 1),(36, 1158, 1, 1, 1),(36, 1159, 1, 1, 1),(36, 1160, 1, 1, 1),(36, 1161, 1, 1, 1),(36, 1162, 1, 1, 1),(36, 1163, 1, 1, 1),(36, 1164, 1, 1, 1),(36, 1165, 1, 1, 1),(36, 1166, 1, 1, 1),(36, 1167, 1, 1, 1),(36, 1168, 1, 1, 1),(36, 1169, 1, 1, 1),(36, 1170, 1, 1, 1),(36, 1171, 1, 1, 1),(36, 1172, 1, 1, 1),(36, 1173, 1, 1, 1),(36, 1174, 1, 1, 1),(36, 1175, 1, 1, 1),(36, 1176, 1, 1, 1),(36, 1177, 1, 1, 1),(36, 1178, 1, 1, 1),(36, 1179, 1, 1, 1),(36, 1180, 1, 1, 1),(36, 1181, 1, 1, 1),(36, 1182, 1, 1, 1),(36, 1183, 5, 1, 1),(36, 1184, 5, 1, 1),(36, 1185, 5, 1, 2),(36, 1186, 5, 1, 2),(36, 1187, 1, 1, 2),(36, 1188, 1, 1, 2),(36, 1189, 1, 1, 2),(36, 1190, 1, 1, 2),(36, 1191, 1, 1, 2),(36, 1192, 1, 1, 2),(36, 1193, 1, 1, 2),(36, 1194, 1, 1, 2),(36, 1195, 1, 1, 2),(36, 1196, 1, 1, 2),(36, 1197, 1, 1, 2),(36, 1198, 1, 1, 2),(36, 1199, 1, 1, 2),(36, 1200, 1, 1, 2),(36, 1201, 1, 1, 2),(36, 1202, 1, 1, 2),(36, 1203, 1, 1, 2),(36, 1204, 1, 1, 2),(36, 1205, 1, 1, 2),(36, 1206, 1, 1, 2),(36, 1207, 1, 1, 2),(36, 1208, 1, 1, 2),(36, 1209, 1, 1, 2),(36, 1210, 1, 1, 2),(36, 1211, 1, 1, 2),(36, 1212, 1, 1, 2),(36, 1213, 1, 1, 2),(36, 1214, 1, 1, 2),(36, 1215, 5, 1, 2),(36, 1216, 5, 1, 2),(36, 1217, 5, 1, 1),(36, 1218, 5, 1, 1),(36, 1219, 1, 1, 1),(36, 1220, 1, 1, 1),(36, 1221, 1, 1, 1),(36, 1222, 1, 1, 1),(36, 1223, 1, 1, 1),(36, 1224, 1, 1, 1),(36, 1225, 1, 1, 1),(36, 1226, 1, 1, 1),(36, 1227, 1, 1, 1),(36, 1228, 1, 1, 1),(36, 1229, 1, 1, 1),(36, 1230, 1, 1, 1),(36, 1231, 1, 1, 1),(36, 1232, 1, 1, 1),(36, 1233, 1, 1, 1),(36, 1234, 1, 1, 1),(36, 1235, 1, 1, 1),(36, 1236, 1, 1, 1),(36, 1237, 1, 1, 1),(36, 1238, 1, 1, 1),(36, 1239, 1, 1, 1),(36, 1240, 1, 1, 1),(36, 1241, 1, 1, 1),(36, 1242, 1, 1, 1),(36, 1243, 1, 1, 1),(36, 1244, 1, 1, 1),(36, 1245, 1, 1, 1),(36, 1246, 1, 1, 1),(36, 1247, 5, 1, 1),(36, 1248, 5, 1, 1),(36, 1249, 5, 1, 2),(36, 1250, 5, 1, 2),(36, 1251, 1, 1, 2),(36, 1252, 1, 1, 2),(36, 1253, 1, 1, 2),(36, 1254, 1, 1, 2),(36, 1255, 1, 1, 2),(36, 1256, 1, 1, 2),(36, 1257, 1, 1, 2),(36, 1258, 1, 1, 2),(36, 1259, 1, 1, 2),(36, 1260, 1, 1, 2),(36, 1261, 1, 1, 2),(36, 1262, 1, 1, 2),(36, 1263, 1, 1, 2),(36, 1264, 1, 1, 2),(36, 1265, 1, 1, 2),(36, 1266, 1, 1, 2),(36, 1267, 1, 1, 2),(36, 1268, 1, 1, 2),(36, 1269, 1, 1, 2),(36, 1270, 1, 1, 2),(36, 1271, 1, 1, 2),(36, 1272, 1, 1, 2),(36, 1273, 1, 1, 2),(36, 1274, 1, 1, 2),(36, 1275, 1, 1, 2),(36, 1276, 1, 1, 2),(36, 1277, 1, 1, 2),(36, 1278, 1, 1, 2),(36, 1279, 5, 1, 2),(36, 1280, 5, 1, 2),(36, 1281, 5, 1, 1),(36, 1282, 5, 1, 1),(36, 1283, 1, 1, 1),(36, 1284, 1, 1, 1),(36, 1285, 1, 1, 1),(36, 1286, 1, 1, 1),(36, 1287, 1, 1, 1),(36, 1288, 1, 1, 1),(36, 1289, 1, 1, 1),(36, 1290, 1, 1, 1),(36, 1291, 1, 1, 1),(36, 1292, 1, 1, 1),(36, 1293, 1, 1, 1),(36, 1294, 1, 1, 1),(36, 1295, 1, 1, 1),(36, 1296, 1, 1, 1),(36, 1297, 1, 1, 1),(36, 1298, 1, 1, 1),(36, 1299, 1, 1, 1),(36, 1300, 1, 1, 1),(36, 1301, 1, 1, 1),(36, 1302, 1, 1, 1),(36, 1303, 1, 1, 1),(36, 1304, 1, 1, 1),(36, 1305, 1, 1, 1),(36, 1306, 1, 1, 1),(36, 1307, 1, 1, 1),(36, 1308, 1, 1, 1),(36, 1309, 1, 1, 1),(36, 1310, 1, 1, 1),(36, 1311, 5, 1, 1),(36, 1312, 5, 1, 1),(36, 1313, 5, 1, 2),(36, 1314, 5, 1, 2),(36, 1315, 1, 1, 2),(36, 1316, 1, 1, 2),(36, 1317, 1, 1, 2),(36, 1318, 1, 1, 2),(36, 1319, 1, 1, 2),(36, 1320, 1, 1, 2),(36, 1321, 1, 1, 2),(36, 1322, 1, 1, 2),(36, 1323, 1, 1, 2),(36, 1324, 1, 1, 2),(36, 1325, 1, 1, 2),(36, 1326, 1, 1, 2),(36, 1327, 1, 1, 2),(36, 1328, 1, 1, 2),(36, 1329, 1, 1, 2),(36, 1330, 1, 1, 2),(36, 1331, 1, 1, 2),(36, 1332, 1, 1, 2),(36, 1333, 1, 1, 2),(36, 1334, 1, 1, 2),(36, 1335, 1, 1, 2),(36, 1336, 1, 1, 2),(36, 1337, 1, 1, 2),(36, 1338, 1, 1, 2),(36, 1339, 1, 1, 2),(36, 1340, 1, 1, 2),(36, 1341, 1, 1, 2),(36, 1342, 1, 1, 2),(36, 1343, 5, 1, 2),(36, 1344, 5, 1, 2),(36, 1345, 5, 1, 1),(36, 1346, 5, 1, 1),(36, 1347, 1, 1, 1),(36, 1348, 1, 1, 1),(36, 1349, 1, 1, 1),(36, 1350, 1, 1, 1),(36, 1351, 1, 1, 1),(36, 1352, 1, 1, 1),(36, 1353, 1, 1, 1),(36, 1354, 1, 1, 1),(36, 1355, 1, 1, 1),(36, 1356, 1, 1, 1),(36, 1357, 1, 1, 1),(36, 1358, 1, 1, 1),(36, 1359, 1, 1, 1),(36, 1360, 1, 1, 1),(36, 1361, 1, 1, 1),(36, 1362, 1, 1, 1),(36, 1363, 1, 1, 1),(36, 1364, 1, 1, 1),(36, 1365, 1, 1, 1),(36, 1366, 1, 1, 1),(36, 1367, 1, 1, 1),(36, 1368, 1, 1, 1),(36, 1369, 1, 1, 1),(36, 1370, 1, 1, 1),(36, 1371, 1, 1, 1),(36, 1372, 1, 1, 1),(36, 1373, 1, 1, 1),(36, 1374, 1, 1, 1),(36, 1375, 5, 1, 1),(36, 1376, 5, 1, 1),(36, 1377, 5, 1, 2),(36, 1378, 5, 1, 2),(36, 1379, 1, 1, 2),(36, 1380, 1, 1, 2),(36, 1381, 1, 1, 2),(36, 1382, 1, 1, 2),(36, 1383, 1, 1, 2),(36, 1384, 1, 1, 2),(36, 1385, 1, 1, 2),(36, 1386, 1, 1, 2),(36, 1387, 1, 1, 2),(36, 1388, 1, 1, 2),(36, 1389, 1, 1, 2),(36, 1390, 1, 1, 2),(36, 1391, 1, 1, 2),(36, 1392, 1, 1, 2),(36, 1393, 1, 1, 2),(36, 1394, 1, 1, 2),(36, 1395, 1, 1, 2),(36, 1396, 1, 1, 2),(36, 1397, 1, 1, 2),(36, 1398, 1, 1, 2),(36, 1399, 1, 1, 2),(36, 1400, 1, 1, 2),(36, 1401, 1, 1, 2),(36, 1402, 1, 1, 2),(36, 1403, 1, 1, 2),(36, 1404, 1, 1, 2),(36, 1405, 1, 1, 2),(36, 1406, 1, 1, 2),(36, 1407, 5, 1, 2),(36, 1408, 5, 1, 2),(36, 1409, 5, 1, 1),(36, 1410, 5, 1, 1),(36, 1411, 2, 1, 1),(36, 1412, 2, 1, 1),(36, 1413, 2, 1, 1),(36, 1414, 2, 1, 1),(36, 1415, 2, 1, 1),(36, 1416, 2, 1, 1),(36, 1417, 2, 1, 1),(36, 1418, 2, 1, 1),(36, 1419, 2, 1, 1),(36, 1420, 2, 1, 1),(36, 1421, 2, 1, 1),(36, 1422, 2, 1, 1),(36, 1423, 2, 1, 1),(36, 1424, 2, 1, 1),(36, 1425, 3, 1, 1),(36, 1426, 3, 1, 1),(36, 1427, 3, 1, 1),(36, 1428, 3, 1, 1),(36, 1429, 3, 1, 1),(36, 1430, 3, 1, 1),(36, 1431, 3, 1, 1),(36, 1432, 3, 1, 1),(36, 1433, 4, 1, 1),(36, 1434, 4, 1, 1),(36, 1435, 4, 1, 1),(36, 1436, 4, 1, 1),(36, 1437, 4, 1, 1),(36, 1438, 4, 1, 1),(36, 1439, 5, 1, 1),(36, 1440, 5, 1, 1),(36, 1441, 5, 1, 2),(36, 1442, 5, 1, 2),(36, 1443, 2, 1, 2),(36, 1444, 2, 1, 2),(36, 1445, 2, 1, 2),(36, 1446, 2, 1, 2),(36, 1447, 2, 1, 2),(36, 1448, 2, 1, 2),(36, 1449, 2, 1, 2),(36, 1450, 2, 1, 2),(36, 1451, 2, 1, 2),(36, 1452, 2, 1, 2),(36, 1453, 2, 1, 2),(36, 1454, 2, 1, 2),(36, 1455, 2, 1, 2),(36, 1456, 2, 1, 2),(36, 1457, 3, 1, 2),(36, 1458, 3, 1, 2),(36, 1459, 3, 1, 2),(36, 1460, 3, 1, 2),(36, 1461, 3, 1, 2),(36, 1462, 3, 1, 2),(36, 1463, 3, 1, 2),(36, 1464, 3, 1, 2),(36, 1465, 4, 1, 2),(36, 1466, 4, 1, 2),(36, 1467, 4, 1, 2),(36, 1468, 4, 1, 2),(36, 1469, 4, 1, 2),(36, 1470, 4, 1, 2),(36, 1471, 5, 1, 2),(36, 1472, 5, 1, 2),(36, 1473, 5, 1, 1),(36, 1474, 5, 1, 1),(36, 1475, 5, 1, 1),(36, 1476, 5, 1, 1),(36, 1477, 5, 1, 1),(36, 1478, 5, 1, 1),(36, 1479, 5, 1, 1),(36, 1480, 5, 1, 1),(36, 1481, 5, 1, 1),(36, 1482, 5, 1, 1),(36, 1483, 5, 1, 1),(36, 1484, 5, 1, 1),(36, 1485, 5, 1, 1),(36, 1486, 5, 1, 1),(36, 1487, 5, 1, 1),(36, 1488, 5, 1, 1),(36, 1489, 5, 1, 1),(36, 1490, 5, 1, 1),(36, 1491, 5, 1, 1),(36, 1492, 5, 1, 1),(36, 1493, 5, 1, 1),(36, 1494, 5, 1, 1),(36, 1495, 5, 1, 1),(36, 1496, 5, 1, 1),(36, 1497, 5, 1, 1),(36, 1498, 5, 1, 1),(36, 1499, 5, 1, 1),(36, 1500, 5, 1, 1),(36, 1501, 5, 1, 1),(36, 1502, 5, 1, 1),(36, 1503, 5, 1, 1),(36, 1504, 5, 1, 1),(36, 1505, 5, 1, 2),(36, 1506, 5, 1, 2),(36, 1507, 5, 1, 2),(36, 1508, 5, 1, 2),(36, 1509, 5, 1, 2),(36, 1510, 5, 1, 2),(36, 1511, 5, 1, 2),(36, 1512, 5, 1, 2),(36, 1513, 5, 1, 2),(36, 1514, 5, 1, 2),(36, 1515, 5, 1, 2),(36, 1516, 5, 1, 2),(36, 1517, 5, 1, 2),(36, 1518, 5, 1, 2),(36, 1519, 5, 1, 2),(36, 1520, 5, 1, 2),(36, 1521, 5, 1, 2),(36, 1522, 5, 1, 2),(36, 1523, 5, 1, 2),(36, 1524, 5, 1, 2),(36, 1525, 5, 1, 2),(36, 1526, 5, 1, 2),(36, 1527, 5, 1, 2),(36, 1528, 5, 1, 2),(36, 1529, 5, 1, 2),(36, 1530, 5, 1, 2),(36, 1531, 5, 1, 2),(36, 1532, 5, 1, 2),(36, 1533, 5, 1, 2),(36, 1534, 5, 1, 2),(36, 1535, 5, 1, 2),(36, 1536, 5, 1, 2),(37, 1, 1, 1, 1),(37, 2, 1, 1, 1),(37, 3, 1, 1, 1),(37, 4, 1, 1, 1),(37, 5, 1, 1, 1),(37, 6, 1, 1, 1),(37, 7, 1, 1, 1),(37, 8, 1, 1, 1),(37, 9, 1, 1, 1),(37, 10, 1, 1, 1),(37, 11, 1, 1, 1),(37, 12, 1, 1, 1),(37, 13, 1, 1, 1),(37, 14, 1, 1, 1),(37, 15, 1, 1, 1),(37, 16, 1, 1, 1),(37, 17, 1, 1, 1),(37, 18, 1, 1, 1),(37, 19, 1, 1, 1),(37, 20, 1, 1, 1),(37, 21, 1, 1, 1),(37, 22, 1, 1, 1),(37, 23, 1, 1, 1),(37, 24, 1, 1, 1),(37, 25, 1, 1, 1),(37, 26, 1, 1, 1),(37, 27, 1, 1, 1),(37, 28, 1, 1, 1),(37, 29, 1, 1, 1),(37, 30, 1, 1, 1),(37, 31, 1, 1, 1),(37, 32, 1, 1, 1),(37, 33, 1, 1, 1),(37, 34, 1, 1, 1),(37, 35, 1, 1, 1),(37, 36, 1, 1, 1),(37, 37, 1, 1, 1),(37, 38, 1, 1, 1),(37, 39, 1, 1, 1),(37, 40, 1, 1, 1),(37, 41, 1, 1, 1),(37, 42, 1, 1, 1),(37, 43, 1, 1, 1),(37, 44, 1, 1, 1),(37, 45, 1, 1, 1),(37, 46, 1, 1, 1),(37, 47, 1, 1, 1),(37, 48, 1, 1, 1),(37, 49, 1, 1, 1),(37, 50, 1, 1, 1),(37, 51, 1, 1, 1),(37, 52, 1, 1, 1),(37, 53, 1, 1, 1),(37, 54, 1, 1, 1),(37, 55, 1, 1, 1),(37, 56, 1, 1, 1),(37, 57, 1, 1, 1),(37, 58, 1, 1, 1),(37, 59, 1, 1, 1),(37, 60, 1, 1, 1),(37, 61, 1, 1, 1),(37, 62, 1, 1, 1),(37, 63, 1, 1, 1),(37, 64, 1, 1, 1),(37, 65, 1, 1, 1),(37, 66, 1, 1, 1),(37, 67, 1, 1, 1),(37, 68, 1, 1, 1),(37, 69, 1, 1, 1),(37, 70, 1, 1, 1),(37, 71, 1, 1, 1),(37, 72, 1, 1, 1),(37, 73, 1, 1, 1),(37, 74, 1, 1, 1),(37, 75, 1, 1, 1),(37, 76, 1, 1, 1),(37, 77, 1, 1, 1),(37, 78, 1, 1, 1),(37, 79, 1, 1, 1),(37, 80, 1, 1, 1),(37, 81, 1, 1, 1),(37, 82, 1, 1, 1),(37, 83, 1, 1, 1),(37, 84, 1, 1, 1),(37, 85, 1, 1, 1),(37, 86, 1, 1, 1),(37, 87, 1, 1, 1),(37, 88, 1, 1, 1),(37, 89, 1, 1, 1),(37, 90, 1, 1, 1),(37, 91, 1, 1, 1),(37, 92, 1, 1, 1),(37, 93, 1, 1, 1),(37, 94, 1, 1, 1),(37, 95, 1, 1, 1),(37, 96, 1, 1, 1),(37, 97, 1, 1, 1),(37, 98, 1, 1, 1),(37, 99, 1, 1, 1),(37, 100, 1, 1, 1),(37, 101, 1, 1, 1),(37, 102, 1, 1, 1),(37, 103, 1, 1, 1),(37, 104, 1, 1, 1),(37, 105, 1, 1, 1),(37, 106, 1, 1, 1),(37, 107, 1, 1, 1),(37, 108, 1, 1, 1),(37, 109, 1, 1, 1),(37, 110, 1, 1, 1),(37, 111, 1, 1, 1),(37, 112, 1, 1, 1),(37, 113, 1, 1, 1),(37, 114, 1, 1, 1),(37, 115, 1, 1, 1),(37, 116, 1, 1, 1),(37, 117, 1, 1, 1),(37, 118, 1, 1, 1),(37, 119, 1, 1, 1),(37, 120, 1, 1, 1),(37, 121, 1, 1, 1),(37, 122, 1, 1, 1),(37, 123, 1, 1, 1),(37, 124, 1, 1, 1),(37, 125, 1, 1, 1),(37, 126, 1, 1, 1),(37, 127, 1, 1, 1),(37, 128, 1, 1, 1),(37, 129, 1, 1, 1),(37, 130, 1, 1, 1),(37, 131, 1, 1, 1),(37, 132, 1, 1, 1),(37, 133, 1, 1, 1),(37, 134, 1, 1, 1),(37, 135, 1, 1, 1),(37, 136, 1, 1, 1),(37, 137, 1, 1, 1),(37, 138, 1, 1, 1),(37, 139, 1, 1, 1),(37, 140, 1, 1, 1),(37, 141, 1, 1, 1),(37, 142, 1, 1, 1),(37, 143, 1, 1, 1),(37, 144, 1, 1, 1),(37, 145, 1, 1, 1),(37, 146, 1, 1, 1),(37, 147, 1, 1, 1),(37, 148, 1, 1, 1),(37, 149, 1, 1, 1),(37, 150, 1, 1, 1),(37, 151, 1, 1, 1),(37, 152, 1, 1, 1),(37, 153, 1, 1, 1),(37, 154, 1, 1, 1),(37, 155, 1, 1, 1),(37, 156, 1, 1, 1),(37, 157, 1, 1, 1),(37, 158, 1, 1, 1),(37, 159, 1, 1, 1),(37, 160, 1, 1, 1),(37, 161, 1, 1, 1),(37, 162, 1, 1, 1),(37, 163, 1, 1, 1),(37, 164, 1, 1, 1),(37, 165, 1, 1, 1),(37, 166, 1, 1, 1),(37, 167, 1, 1, 1),(37, 168, 1, 1, 1),(37, 169, 1, 1, 1),(37, 170, 1, 1, 1),(37, 171, 1, 1, 1),(37, 172, 1, 1, 1),(37, 173, 1, 1, 1),(37, 174, 1, 1, 1),(37, 175, 1, 1, 1),(37, 176, 1, 1, 1),(37, 177, 1, 1, 1),(37, 178, 1, 1, 1),(37, 179, 1, 1, 1),(37, 180, 1, 1, 1),(37, 181, 1, 1, 1),(37, 182, 1, 1, 1),(37, 183, 1, 1, 1),(37, 184, 1, 1, 1),(37, 185, 1, 1, 1),(37, 186, 1, 1, 1),(37, 187, 1, 1, 1),(37, 188, 1, 1, 1),(37, 189, 1, 1, 1),(37, 190, 1, 1, 1),(37, 191, 1, 1, 1),(37, 192, 1, 1, 1),(37, 193, 1, 1, 1),(37, 194, 1, 1, 1),(37, 195, 1, 1, 1),(37, 196, 1, 1, 1),(37, 197, 1, 1, 1),(37, 198, 1, 1, 1),(37, 199, 1, 1, 1),(37, 200, 1, 1, 1),(37, 201, 1, 1, 1),(37, 202, 1, 1, 1),(37, 203, 1, 1, 1),(37, 204, 1, 1, 1),(37, 205, 1, 1, 1),(37, 206, 1, 1, 1),(37, 207, 1, 1, 1),(37, 208, 1, 1, 1),(37, 209, 1, 1, 1),(37, 210, 1, 1, 1),(37, 211, 1, 1, 1),(37, 212, 1, 1, 1),(37, 213, 1, 1, 1),(37, 214, 1, 1, 1),(37, 215, 1, 1, 1),(37, 216, 1, 1, 1),(37, 217, 1, 1, 1),(37, 218, 1, 1, 1),(37, 219, 1, 1, 1),(37, 220, 1, 1, 1),(37, 221, 1, 1, 1),(37, 222, 1, 1, 1),(37, 223, 1, 1, 1),(37, 224, 1, 1, 1),(37, 225, 1, 1, 1),(37, 226, 1, 1, 1),(37, 227, 1, 1, 1),(37, 228, 1, 1, 1),(37, 229, 1, 1, 1),(37, 230, 1, 1, 1),(37, 231, 1, 1, 1),(37, 232, 1, 1, 1),(37, 233, 1, 1, 1),(37, 234, 1, 1, 1),(37, 235, 1, 1, 1),(37, 236, 1, 1, 1),(37, 237, 1, 1, 1),(37, 238, 1, 1, 1),(37, 239, 1, 1, 1),(37, 240, 1, 1, 1),(37, 241, 1, 1, 1),(37, 242, 1, 1, 1),(37, 243, 1, 1, 1),(37, 244, 1, 1, 1),(37, 245, 1, 1, 1),(37, 246, 1, 1, 1),(37, 247, 1, 1, 1),(37, 248, 1, 1, 1),(37, 249, 1, 1, 1),(37, 250, 1, 1, 1),(37, 251, 1, 1, 1),(37, 252, 1, 1, 1),(37, 253, 1, 1, 1),(37, 254, 1, 1, 1),(37, 255, 1, 1, 1),(37, 256, 1, 1, 1),(37, 257, 1, 1, 1),(37, 258, 1, 1, 1),(37, 259, 1, 1, 1),(37, 260, 1, 1, 1),(37, 261, 1, 1, 1),(37, 262, 1, 1, 1),(37, 263, 1, 1, 1),(37, 264, 1, 1, 1),(37, 265, 1, 1, 1),(37, 266, 1, 1, 1),(37, 267, 1, 1, 1),(37, 268, 1, 1, 1),(37, 269, 1, 1, 1),(37, 270, 1, 1, 1),(37, 271, 1, 1, 1),(37, 272, 1, 1, 1),(37, 273, 1, 1, 1),(37, 274, 1, 1, 1),(37, 275, 1, 1, 1),(37, 276, 1, 1, 1),(37, 277, 1, 1, 1),(37, 278, 1, 1, 1),(37, 279, 1, 1, 1),(37, 280, 1, 1, 1),(37, 281, 1, 1, 1),(37, 282, 1, 1, 1),(37, 283, 1, 1, 1),(37, 284, 1, 1, 1),(37, 285, 1, 1, 1),(37, 286, 1, 1, 1),(37, 287, 1, 1, 1),(37, 288, 1, 1, 1),(37, 289, 1, 1, 1),(37, 290, 1, 1, 1),(37, 291, 1, 1, 1),(37, 292, 1, 1, 1),(37, 293, 1, 1, 1),(37, 294, 1, 1, 1),(37, 295, 1, 1, 1),(37, 296, 1, 1, 1),(37, 297, 1, 1, 1),(37, 298, 1, 1, 1),(37, 299, 1, 1, 1),(37, 300, 1, 1, 1),(37, 301, 1, 1, 1),(37, 302, 1, 1, 1),(37, 303, 1, 1, 1),(37, 304, 1, 1, 1),(37, 305, 1, 1, 1),(37, 306, 1, 1, 1),(37, 307, 1, 1, 1),(37, 308, 1, 1, 1),(37, 309, 1, 1, 1),(37, 310, 1, 1, 1),(37, 311, 1, 1, 1),(37, 312, 1, 1, 1),(37, 313, 1, 1, 1),(37, 314, 1, 1, 1),(37, 315, 1, 1, 1),(37, 316, 1, 1, 1),(37, 317, 1, 1, 1),(37, 318, 1, 1, 1),(37, 319, 1, 1, 1),(37, 320, 1, 1, 1),(37, 321, 1, 1, 1),(37, 322, 1, 1, 1),(37, 323, 1, 1, 1),(37, 324, 1, 1, 1),(37, 325, 1, 1, 1),(37, 326, 1, 1, 1),(37, 327, 1, 1, 1),(37, 328, 1, 1, 1),(37, 329, 1, 1, 1),(37, 330, 1, 1, 1),(37, 331, 1, 1, 1),(37, 332, 1, 1, 1),(37, 333, 1, 1, 1),(37, 334, 1, 1, 1),(37, 335, 1, 1, 1),(37, 336, 1, 1, 1),(37, 337, 1, 1, 1),(37, 338, 1, 1, 1),(37, 339, 1, 1, 1),(37, 340, 1, 1, 1),(37, 341, 1, 1, 1),(37, 342, 1, 1, 1),(37, 343, 1, 1, 1),(37, 344, 1, 1, 1),(37, 345, 1, 1, 1),(37, 346, 1, 1, 1),(37, 347, 1, 1, 1),(37, 348, 1, 1, 1),(37, 349, 1, 1, 1),(37, 350, 1, 1, 1),(37, 351, 1, 1, 1),(37, 352, 1, 1, 1),(37, 353, 1, 1, 1),(37, 354, 1, 1, 1),(37, 355, 1, 1, 1),(37, 356, 1, 1, 1),(37, 357, 1, 1, 1),(37, 358, 1, 1, 1),(37, 359, 1, 1, 1),(37, 360, 1, 1, 1),(37, 361, 1, 1, 1),(37, 362, 1, 1, 1),(37, 363, 1, 1, 1),(37, 364, 1, 1, 1),(37, 365, 1, 1, 1),(37, 366, 1, 1, 1),(37, 367, 1, 1, 1),(37, 368, 1, 1, 1),(37, 369, 1, 1, 1),(37, 370, 1, 1, 1),(37, 371, 1, 1, 1),(37, 372, 1, 1, 1),(37, 373, 1, 1, 1),(37, 374, 1, 1, 1),(37, 375, 1, 1, 1),(37, 376, 1, 1, 1),(37, 377, 1, 1, 1),(37, 378, 1, 1, 1),(37, 379, 1, 1, 1),(37, 380, 1, 1, 1),(37, 381, 1, 1, 1),(37, 382, 1, 1, 1),(37, 383, 1, 1, 1),(37, 384, 1, 1, 1),(37, 385, 1, 1, 1),(37, 386, 1, 1, 1),(37, 387, 1, 1, 1),(37, 388, 1, 1, 1),(37, 389, 1, 1, 1),(37, 390, 1, 1, 1),(37, 391, 1, 1, 1),(37, 392, 1, 1, 1),(37, 393, 1, 1, 1),(37, 394, 1, 1, 1),(37, 395, 1, 1, 1),(37, 396, 1, 1, 1),(37, 397, 1, 1, 1),(37, 398, 1, 1, 1),(37, 399, 1, 1, 1),(37, 400, 1, 1, 1),(37, 401, 1, 1, 1),(37, 402, 1, 1, 1),(37, 403, 1, 1, 1),(37, 404, 1, 1, 1),(37, 405, 1, 1, 1),(37, 406, 1, 1, 1),(37, 407, 1, 1, 1),(37, 408, 1, 1, 1),(37, 409, 1, 1, 1),(37, 410, 1, 1, 1),(37, 411, 1, 1, 1),(37, 412, 1, 1, 1),(37, 413, 1, 1, 1),(37, 414, 1, 1, 1),(37, 415, 1, 1, 1),(37, 416, 1, 1, 1),(37, 417, 1, 1, 1),(37, 418, 1, 1, 1),(37, 419, 1, 1, 1),(37, 420, 1, 1, 1),(37, 421, 1, 1, 1),(37, 422, 1, 1, 1),(37, 423, 1, 1, 1),(37, 424, 1, 1, 1),(37, 425, 1, 1, 1),(37, 426, 1, 1, 1),(37, 427, 1, 1, 1),(37, 428, 1, 1, 1),(37, 429, 1, 1, 1),(37, 430, 1, 1, 1),(37, 431, 1, 1, 1),(37, 432, 1, 1, 1),(37, 433, 1, 1, 1),(37, 434, 1, 1, 1),(37, 435, 1, 1, 1),(37, 436, 1, 1, 1),(37, 437, 1, 1, 1),(37, 438, 1, 1, 1),(37, 439, 1, 1, 1),(37, 440, 1, 1, 1),(37, 441, 1, 1, 1),(37, 442, 1, 1, 1),(37, 443, 1, 1, 1),(37, 444, 1, 1, 1),(37, 445, 1, 1, 1),(37, 446, 1, 1, 1),(37, 447, 1, 1, 1),(37, 448, 1, 1, 1),(37, 449, 1, 1, 1),(37, 450, 1, 1, 1),(37, 451, 1, 1, 1),(37, 452, 1, 1, 1),(37, 453, 1, 1, 1),(37, 454, 1, 1, 1),(37, 455, 1, 1, 1),(37, 456, 1, 1, 1),(37, 457, 1, 1, 1),(37, 458, 1, 1, 1),(37, 459, 1, 1, 1),(37, 460, 1, 1, 1),(37, 461, 1, 1, 1),(37, 462, 1, 1, 1),(37, 463, 1, 1, 1),(37, 464, 1, 1, 1),(37, 465, 1, 1, 1),(37, 466, 1, 1, 1),(37, 467, 1, 1, 1),(37, 468, 1, 1, 1),(37, 469, 1, 1, 1),(37, 470, 1, 1, 1),(37, 471, 1, 1, 1),(37, 472, 1, 1, 1),(37, 473, 1, 1, 1),(37, 474, 1, 1, 1),(37, 475, 1, 1, 1),(37, 476, 1, 1, 1),(37, 477, 1, 1, 1),(37, 478, 1, 1, 1),(37, 479, 1, 1, 1),(37, 480, 1, 1, 1),(37, 481, 1, 1, 1),(37, 482, 1, 1, 1),(37, 483, 1, 1, 1),(37, 484, 1, 1, 1),(37, 485, 1, 1, 1),(37, 486, 1, 1, 1),(37, 487, 1, 1, 1),(37, 488, 1, 1, 1),(37, 489, 1, 1, 1),(37, 490, 1, 1, 1),(37, 491, 1, 1, 1),(37, 492, 1, 1, 1),(37, 493, 1, 1, 1),(37, 494, 1, 1, 1),(37, 495, 1, 1, 1),(37, 496, 1, 1, 1),(37, 497, 1, 1, 1),(37, 498, 1, 1, 1),(37, 499, 1, 1, 1),(37, 500, 1, 1, 1),(37, 501, 1, 1, 1),(37, 502, 1, 1, 1),(37, 503, 1, 1, 1),(37, 504, 1, 1, 1),(37, 505, 1, 1, 1),(37, 506, 1, 1, 1),(37, 507, 1, 1, 1),(37, 508, 1, 1, 1),(37, 509, 1, 1, 1),(37, 510, 1, 1, 1),(37, 511, 1, 1, 1),(37, 512, 1, 1, 1),(37, 513, 1, 1, 1),(37, 514, 1, 1, 1),(37, 515, 1, 1, 1),(37, 516, 1, 1, 1),(37, 517, 1, 1, 1),(37, 518, 1, 1, 1),(37, 519, 1, 1, 1),(37, 520, 1, 1, 1),(37, 521, 1, 1, 1),(37, 522, 1, 1, 1),(37, 523, 1, 1, 1),(37, 524, 1, 1, 1),(37, 525, 1, 1, 1),(37, 526, 1, 1, 1),(37, 527, 1, 1, 1),(37, 528, 1, 1, 1),(37, 529, 1, 1, 1),(37, 530, 1, 1, 1),(37, 531, 1, 1, 1),(37, 532, 1, 1, 1),(37, 533, 1, 1, 1),(37, 534, 1, 1, 1),(37, 535, 1, 1, 1),(37, 536, 1, 1, 1),(37, 537, 1, 1, 1),(37, 538, 1, 1, 1),(37, 539, 1, 1, 1),(37, 540, 1, 1, 1),(37, 541, 1, 1, 1),(37, 542, 1, 1, 1),(37, 543, 1, 1, 1),(37, 544, 1, 1, 1),(37, 545, 1, 1, 1),(37, 546, 1, 1, 1),(37, 547, 1, 1, 1),(37, 548, 1, 1, 1),(37, 549, 1, 1, 1),(37, 550, 1, 1, 1),(37, 551, 1, 1, 1),(37, 552, 1, 1, 1),(37, 553, 1, 1, 1),(37, 554, 1, 1, 1),(37, 555, 1, 1, 1),(37, 556, 1, 1, 1),(37, 557, 1, 1, 1),(37, 558, 1, 1, 1),(37, 559, 1, 1, 1),(37, 560, 1, 1, 1),(37, 561, 1, 1, 1),(37, 562, 1, 1, 1),(37, 563, 1, 1, 1),(37, 564, 1, 1, 1),(37, 565, 1, 1, 1),(37, 566, 1, 1, 1),(37, 567, 1, 1, 1),(37, 568, 1, 1, 1),(37, 569, 1, 1, 1),(37, 570, 1, 1, 1),(37, 571, 1, 1, 1),(37, 572, 1, 1, 1),(37, 573, 1, 1, 1),(37, 574, 1, 1, 1),(37, 575, 1, 1, 1),(37, 576, 1, 1, 1),(37, 577, 1, 1, 1),(37, 578, 1, 1, 1),(37, 579, 1, 1, 1),(37, 580, 1, 1, 1),(37, 581, 1, 1, 1),(37, 582, 1, 1, 1),(37, 583, 1, 1, 1),(37, 584, 1, 1, 1),(37, 585, 1, 1, 1),(37, 586, 1, 1, 1),(37, 587, 1, 1, 1),(37, 588, 1, 1, 1),(37, 589, 1, 1, 1),(37, 590, 1, 1, 1),(37, 591, 1, 1, 1),(37, 592, 1, 1, 1),(37, 593, 1, 1, 1),(37, 594, 1, 1, 1),(37, 595, 1, 1, 1),(37, 596, 1, 1, 1),(37, 597, 1, 1, 1),(37, 598, 1, 1, 1),(37, 599, 1, 1, 1),(37, 600, 1, 1, 1),(37, 601, 1, 1, 1),(37, 602, 1, 1, 1),(37, 603, 1, 1, 1),(37, 604, 1, 1, 1),(37, 605, 1, 1, 1),(37, 606, 1, 1, 1),(37, 607, 1, 1, 1),(37, 608, 1, 1, 1),(37, 609, 1, 1, 1),(37, 610, 1, 1, 1),(37, 611, 1, 1, 1),(37, 612, 1, 1, 1),(37, 613, 1, 1, 1),(37, 614, 1, 1, 1),(37, 615, 1, 1, 1),(37, 616, 1, 1, 1),(37, 617, 1, 1, 1),(37, 618, 1, 1, 1),(37, 619, 1, 1, 1),(37, 620, 1, 1, 1),(37, 621, 1, 1, 1),(37, 622, 1, 1, 1),(37, 623, 1, 1, 1),(37, 624, 1, 1, 1),(37, 625, 1, 1, 1),(37, 626, 1, 1, 1),(37, 627, 1, 1, 1),(37, 628, 1, 1, 1),(37, 629, 1, 1, 1),(37, 630, 1, 1, 1),(37, 631, 1, 1, 1),(37, 632, 1, 1, 1),(37, 633, 1, 1, 1),(37, 634, 1, 1, 1),(37, 635, 1, 1, 1),(37, 636, 1, 1, 1),(37, 637, 1, 1, 1),(37, 638, 1, 1, 1),(37, 639, 1, 1, 1),(37, 640, 1, 1, 1),(37, 641, 1, 1, 1),(37, 642, 1, 1, 1),(37, 643, 1, 1, 1),(37, 644, 1, 1, 1),(37, 645, 1, 1, 1),(37, 646, 1, 1, 1),(37, 647, 1, 1, 1),(37, 648, 1, 1, 1),(37, 649, 1, 1, 1),(37, 650, 1, 1, 1),(37, 651, 1, 1, 1),(37, 652, 1, 1, 1),(37, 653, 1, 1, 1),(37, 654, 1, 1, 1),(37, 655, 1, 1, 1),(37, 656, 1, 1, 1),(37, 657, 1, 1, 1),(37, 658, 1, 1, 1),(37, 659, 1, 1, 1),(37, 660, 1, 1, 1),(37, 661, 1, 1, 1),(37, 662, 1, 1, 1),(37, 663, 1, 1, 1),(37, 664, 1, 1, 1),(37, 665, 1, 1, 1),(37, 666, 1, 1, 1),(37, 667, 1, 1, 1),(37, 668, 1, 1, 1),(37, 669, 1, 1, 1),(37, 670, 1, 1, 1),(37, 671, 1, 1, 1),(37, 672, 1, 1, 1),(37, 673, 1, 1, 1),(37, 674, 1, 1, 1),(37, 675, 1, 1, 1),(37, 676, 1, 1, 1),(37, 677, 1, 1, 1),(37, 678, 1, 1, 1),(37, 679, 1, 1, 1),(37, 680, 1, 1, 1),(37, 681, 1, 1, 1),(37, 682, 1, 1, 1),(37, 683, 1, 1, 1),(37, 684, 1, 1, 1),(37, 685, 1, 1, 1),(37, 686, 1, 1, 1),(37, 687, 1, 1, 1),(37, 688, 1, 1, 1),(37, 689, 1, 1, 1),(37, 690, 1, 1, 1),(37, 691, 1, 1, 1),(37, 692, 1, 1, 1),(37, 693, 1, 1, 1),(37, 694, 1, 1, 1),(37, 695, 1, 1, 1),(37, 696, 1, 1, 1),(37, 697, 1, 1, 1),(37, 698, 1, 1, 1),(37, 699, 1, 1, 1),(37, 700, 1, 1, 1),(37, 701, 1, 1, 1),(37, 702, 1, 1, 1),(37, 703, 1, 1, 1),(37, 704, 1, 1, 1),(37, 705, 1, 1, 1),(37, 706, 1, 1, 1),(37, 707, 1, 1, 1),(37, 708, 1, 1, 1),(37, 709, 1, 1, 1),(37, 710, 1, 1, 1),(37, 711, 1, 1, 1),(37, 712, 1, 1, 1),(37, 713, 1, 1, 1),(37, 714, 1, 1, 1),(37, 715, 1, 1, 1),(37, 716, 1, 1, 1),(37, 717, 1, 1, 1),(37, 718, 1, 1, 1),(37, 719, 1, 1, 1),(37, 720, 1, 1, 1),(37, 721, 1, 1, 1),(37, 722, 1, 1, 1),(37, 723, 1, 1, 1),(37, 724, 1, 1, 1),(37, 725, 1, 1, 1),(37, 726, 1, 1, 1),(37, 727, 1, 1, 1),(37, 728, 1, 1, 1),(37, 729, 1, 1, 1),(37, 730, 1, 1, 1),(37, 731, 1, 1, 1),(37, 732, 1, 1, 1),(37, 733, 1, 1, 1),(37, 734, 1, 1, 1),(37, 735, 1, 1, 1),(37, 736, 1, 1, 1),(37, 737, 1, 1, 1),(37, 738, 1, 1, 1),(37, 739, 1, 1, 1),(37, 740, 1, 1, 1),(37, 741, 1, 1, 1),(37, 742, 1, 1, 1),(37, 743, 1, 1, 1),(37, 744, 1, 1, 1),(37, 745, 1, 1, 1),(37, 746, 1, 1, 1),(37, 747, 1, 1, 1),(37, 748, 1, 1, 1),(37, 749, 1, 1, 1),(37, 750, 1, 1, 1),(37, 751, 1, 1, 1),(37, 752, 1, 1, 1),(37, 753, 1, 1, 1),(37, 754, 1, 1, 1),(37, 755, 1, 1, 1),(37, 756, 1, 1, 1),(37, 757, 1, 1, 1),(37, 758, 1, 1, 1),(37, 759, 1, 1, 1),(37, 760, 1, 1, 1),(37, 761, 1, 1, 1),(37, 762, 1, 1, 1),(37, 763, 1, 1, 1),(37, 764, 1, 1, 1),(37, 765, 1, 1, 1),(37, 766, 1, 1, 1),(37, 767, 1, 1, 1),(37, 768, 1, 1, 1),(37, 769, 1, 1, 1),(37, 770, 1, 1, 1),(37, 771, 1, 1, 1),(37, 772, 1, 1, 1),(37, 773, 1, 1, 1),(37, 774, 1, 1, 1),(37, 775, 1, 1, 1),(37, 776, 1, 1, 1),(37, 777, 1, 1, 1),(37, 778, 1, 1, 1),(37, 779, 1, 1, 1),(37, 780, 1, 1, 1),(37, 781, 1, 1, 1),(37, 782, 1, 1, 1),(37, 783, 1, 1, 1),(37, 784, 1, 1, 1),(37, 785, 1, 1, 1),(37, 786, 1, 1, 1),(37, 787, 1, 1, 1),(37, 788, 1, 1, 1),(37, 789, 1, 1, 1),(37, 790, 1, 1, 1),(37, 791, 1, 1, 1),(37, 792, 1, 1, 1),(37, 793, 1, 1, 1),(37, 794, 1, 1, 1),(37, 795, 1, 1, 1),(37, 796, 1, 1, 1),(37, 797, 1, 1, 1),(37, 798, 1, 1, 1),(37, 799, 1, 1, 1),(37, 800, 1, 1, 1),(37, 801, 1, 1, 1),(37, 802, 1, 1, 1),(37, 803, 1, 1, 1),(37, 804, 1, 1, 1),(37, 805, 1, 1, 1),(37, 806, 1, 1, 1),(37, 807, 1, 1, 1),(37, 808, 1, 1, 1),(37, 809, 1, 1, 1),(37, 810, 1, 1, 1),(37, 811, 1, 1, 1),(37, 812, 1, 1, 1),(37, 813, 1, 1, 1),(37, 814, 1, 1, 1),(37, 815, 1, 1, 1),(37, 816, 1, 1, 1),(37, 817, 1, 1, 1),(37, 818, 1, 1, 1),(37, 819, 1, 1, 1),(37, 820, 1, 1, 1),(37, 821, 1, 1, 1),(37, 822, 1, 1, 1),(37, 823, 1, 1, 1),(37, 824, 1, 1, 1),(37, 825, 1, 1, 1),(37, 826, 1, 1, 1),(37, 827, 1, 1, 1),(37, 828, 1, 1, 1),(37, 829, 1, 1, 1),(37, 830, 1, 1, 1),(37, 831, 1, 1, 1),(37, 832, 1, 1, 1),(37, 833, 1, 1, 1),(37, 834, 1, 1, 1),(37, 835, 1, 1, 1),(37, 836, 1, 1, 1),(37, 837, 1, 1, 1),(37, 838, 1, 1, 1),(37, 839, 1, 1, 1),(37, 840, 1, 1, 1),(37, 841, 1, 1, 1),(37, 842, 1, 1, 1),(37, 843, 1, 1, 1),(37, 844, 1, 1, 1),(37, 845, 1, 1, 1),(37, 846, 1, 1, 1),(37, 847, 1, 1, 1),(37, 848, 1, 1, 1),(37, 849, 1, 1, 1),(37, 850, 1, 1, 1),(37, 851, 1, 1, 1),(37, 852, 1, 1, 1),(37, 853, 1, 1, 1),(37, 854, 1, 1, 1),(37, 855, 1, 1, 1),(37, 856, 1, 1, 1),(37, 857, 1, 1, 1),(37, 858, 1, 1, 1),(37, 859, 1, 1, 1),(37, 860, 1, 1, 1),(37, 861, 1, 1, 1),(37, 862, 1, 1, 1),(37, 863, 1, 1, 1),(37, 864, 1, 1, 1),(37, 865, 1, 1, 1),(37, 866, 1, 1, 1),(37, 867, 1, 1, 1),(37, 868, 1, 1, 1),(37, 869, 1, 1, 1),(37, 870, 1, 1, 1),(37, 871, 1, 1, 1),(37, 872, 1, 1, 1),(37, 873, 1, 1, 1),(37, 874, 1, 1, 1),(37, 875, 1, 1, 1),(37, 876, 1, 1, 1),(37, 877, 1, 1, 1),(37, 878, 1, 1, 1),(37, 879, 1, 1, 1),(37, 880, 1, 1, 1),(37, 881, 1, 1, 1),(37, 882, 1, 1, 1),(37, 883, 1, 1, 1),(37, 884, 1, 1, 1),(37, 885, 1, 1, 1),(37, 886, 1, 1, 1),(37, 887, 1, 1, 1),(37, 888, 1, 1, 1),(37, 889, 1, 1, 1),(37, 890, 1, 1, 1),(37, 891, 1, 1, 1),(37, 892, 1, 1, 1),(37, 893, 1, 1, 1),(37, 894, 1, 1, 1),(37, 895, 1, 1, 1),(37, 896, 1, 1, 1),(37, 897, 1, 1, 1),(37, 898, 1, 1, 1),(37, 899, 1, 1, 1),(37, 900, 1, 1, 1),(37, 901, 1, 1, 1),(37, 902, 1, 1, 1),(37, 903, 1, 1, 1),(37, 904, 1, 1, 1),(37, 905, 1, 1, 1),(37, 906, 1, 1, 1),(37, 907, 1, 1, 1),(37, 908, 1, 1, 1),(37, 909, 1, 1, 1),(37, 910, 1, 1, 1),(37, 911, 1, 1, 1),(37, 912, 1, 1, 1),(37, 913, 1, 1, 1),(37, 914, 1, 1, 1),(37, 915, 1, 1, 1),(37, 916, 1, 1, 1),(37, 917, 1, 1, 1),(37, 918, 1, 1, 1),(37, 919, 1, 1, 1),(37, 920, 1, 1, 1),(37, 921, 1, 1, 1),(37, 922, 1, 1, 1),(37, 923, 1, 1, 1),(37, 924, 1, 1, 1),(37, 925, 1, 1, 1),(37, 926, 1, 1, 1),(37, 927, 1, 1, 1),(37, 928, 1, 1, 1),(37, 929, 1, 1, 1),(37, 930, 1, 1, 1),(37, 931, 1, 1, 1),(37, 932, 1, 1, 1),(37, 933, 1, 1, 1),(37, 934, 1, 1, 1),(37, 935, 1, 1, 1),(37, 936, 1, 1, 1),(37, 937, 1, 1, 1),(37, 938, 1, 1, 1),(37, 939, 1, 1, 1),(37, 940, 1, 1, 1),(37, 941, 1, 1, 1),(37, 942, 1, 1, 1),(37, 943, 1, 1, 1),(37, 944, 1, 1, 1),(37, 945, 1, 1, 1),(37, 946, 1, 1, 1),(37, 947, 1, 1, 1),(37, 948, 1, 1, 1),(37, 949, 1, 1, 1),(37, 950, 1, 1, 1),(37, 951, 1, 1, 1),(37, 952, 1, 1, 1),(37, 953, 1, 1, 1),(37, 954, 1, 1, 1),(37, 955, 1, 1, 1),(37, 956, 1, 1, 1),(37, 957, 1, 1, 1),(37, 958, 1, 1, 1),(37, 959, 1, 1, 1),(37, 960, 1, 1, 1),(37, 961, 1, 1, 1),(37, 962, 1, 1, 1),(37, 963, 1, 1, 1),(37, 964, 1, 1, 1),(37, 965, 1, 1, 1),(37, 966, 1, 1, 1),(37, 967, 1, 1, 1),(37, 968, 1, 1, 1),(37, 969, 1, 1, 1),(37, 970, 1, 1, 1),(37, 971, 1, 1, 1),(37, 972, 1, 1, 1),(37, 973, 1, 1, 1),(37, 974, 1, 1, 1),(37, 975, 1, 1, 1),(37, 976, 1, 1, 1),(37, 977, 1, 1, 1),(37, 978, 1, 1, 1),(37, 979, 1, 1, 1),(37, 980, 1, 1, 1),(37, 981, 1, 1, 1),(37, 982, 1, 1, 1),(37, 983, 1, 1, 1),(37, 984, 1, 1, 1),(37, 985, 1, 1, 1),(37, 986, 1, 1, 1),(37, 987, 1, 1, 1),(37, 988, 1, 1, 1),(37, 989, 1, 1, 1),(37, 990, 1, 1, 1),(37, 991, 1, 1, 1),(37, 992, 1, 1, 1),(37, 993, 1, 1, 1),(37, 994, 1, 1, 1),(37, 995, 1, 1, 1),(37, 996, 1, 1, 1),(37, 997, 1, 1, 1),(37, 998, 1, 1, 1),(37, 999, 1, 1, 1),(37, 1000, 1, 1, 1),(37, 1001, 1, 1, 1),(37, 1002, 1, 1, 1),(37, 1003, 1, 1, 1),(37, 1004, 1, 1, 1),(37, 1005, 1, 1, 1),(37, 1006, 1, 1, 1),(37, 1007, 1, 1, 1),(37, 1008, 1, 1, 1),(37, 1009, 1, 1, 1),(37, 1010, 1, 1, 1),(37, 1011, 1, 1, 1),(37, 1012, 1, 1, 1),(37, 1013, 1, 1, 1),(37, 1014, 1, 1, 1),(37, 1015, 1, 1, 1),(37, 1016, 1, 1, 1),(37, 1017, 1, 1, 1),(37, 1018, 1, 1, 1),(37, 1019, 1, 1, 1),(37, 1020, 1, 1, 1),(37, 1021, 1, 1, 1),(37, 1022, 1, 1, 1),(37, 1023, 1, 1, 1),(37, 1024, 1, 1, 1),(37, 1025, 1, 1, 1),(37, 1026, 1, 1, 1),(37, 1027, 1, 1, 1),(37, 1028, 1, 1, 1),(37, 1029, 1, 1, 1),(37, 1030, 1, 1, 1),(37, 1031, 1, 1, 1),(37, 1032, 1, 1, 1),(37, 1033, 1, 1, 1),(37, 1034, 1, 1, 1),(37, 1035, 1, 1, 1),(37, 1036, 1, 1, 1),(37, 1037, 1, 1, 1),(37, 1038, 1, 1, 1),(37, 1039, 1, 1, 1),(37, 1040, 1, 1, 1),(37, 1041, 1, 1, 1),(37, 1042, 1, 1, 1),(37, 1043, 1, 1, 1),(37, 1044, 1, 1, 1),(37, 1045, 1, 1, 1),(37, 1046, 1, 1, 1),(37, 1047, 1, 1, 1),(37, 1048, 1, 1, 1),(37, 1049, 1, 1, 1),(37, 1050, 1, 1, 1),(37, 1051, 1, 1, 1),(37, 1052, 1, 1, 1),(37, 1053, 1, 1, 1),(37, 1054, 1, 1, 1),(37, 1055, 1, 1, 1),(37, 1056, 1, 1, 1),(37, 1057, 1, 1, 1),(37, 1058, 1, 1, 1),(37, 1059, 1, 1, 1),(37, 1060, 1, 1, 1),(37, 1061, 1, 1, 1),(37, 1062, 1, 1, 1),(37, 1063, 1, 1, 1),(37, 1064, 1, 1, 1),(37, 1065, 1, 1, 1),(37, 1066, 1, 1, 1),(37, 1067, 1, 1, 1),(37, 1068, 1, 1, 1),(37, 1069, 1, 1, 1),(37, 1070, 1, 1, 1),(37, 1071, 1, 1, 1),(37, 1072, 1, 1, 1),(37, 1073, 1, 1, 1),(37, 1074, 1, 1, 1),(37, 1075, 1, 1, 1),(37, 1076, 1, 1, 1),(37, 1077, 1, 1, 1),(37, 1078, 1, 1, 1),(37, 1079, 1, 1, 1),(37, 1080, 1, 1, 1),(37, 1081, 1, 1, 1),(37, 1082, 1, 1, 1),(37, 1083, 1, 1, 1),(37, 1084, 1, 1, 1),(37, 1085, 1, 1, 1),(37, 1086, 1, 1, 1),(37, 1087, 1, 1, 1),(37, 1088, 1, 1, 1),(37, 1089, 1, 1, 1),(37, 1090, 1, 1, 1),(37, 1091, 1, 1, 1),(37, 1092, 1, 1, 1),(37, 1093, 1, 1, 1),(37, 1094, 1, 1, 1),(37, 1095, 1, 1, 1),(37, 1096, 1, 1, 1),(37, 1097, 1, 1, 1),(37, 1098, 1, 1, 1),(37, 1099, 1, 1, 1),(37, 1100, 1, 1, 1),(37, 1101, 1, 1, 1),(37, 1102, 1, 1, 1),(37, 1103, 1, 1, 1),(37, 1104, 1, 1, 1),(37, 1105, 1, 1, 1),(37, 1106, 1, 1, 1),(37, 1107, 1, 1, 1),(37, 1108, 1, 1, 1),(37, 1109, 1, 1, 1),(37, 1110, 1, 1, 1),(37, 1111, 1, 1, 1),(37, 1112, 1, 1, 1),(37, 1113, 1, 1, 1),(37, 1114, 1, 1, 1),(37, 1115, 1, 1, 1),(37, 1116, 1, 1, 1),(37, 1117, 1, 1, 1),(37, 1118, 1, 1, 1),(37, 1119, 1, 1, 1),(37, 1120, 1, 1, 1),(37, 1121, 1, 1, 1),(37, 1122, 1, 1, 1),(37, 1123, 1, 1, 1),(37, 1124, 1, 1, 1),(37, 1125, 1, 1, 1),(37, 1126, 1, 1, 1),(37, 1127, 1, 1, 1),(37, 1128, 1, 1, 1),(37, 1129, 1, 1, 1),(37, 1130, 1, 1, 1),(37, 1131, 1, 1, 1),(37, 1132, 1, 1, 1),(37, 1133, 1, 1, 1),(37, 1134, 1, 1, 1),(37, 1135, 1, 1, 1),(37, 1136, 1, 1, 1),(37, 1137, 1, 1, 1),(37, 1138, 1, 1, 1),(37, 1139, 1, 1, 1),(37, 1140, 1, 1, 1),(37, 1141, 1, 1, 1),(37, 1142, 1, 1, 1),(37, 1143, 1, 1, 1),(37, 1144, 1, 1, 1),(37, 1145, 1, 1, 1),(37, 1146, 1, 1, 1),(37, 1147, 1, 1, 1),(37, 1148, 1, 1, 1),(37, 1149, 1, 1, 1),(37, 1150, 1, 1, 1),(37, 1151, 1, 1, 1),(37, 1152, 1, 1, 1),(37, 1153, 1, 1, 1),(37, 1154, 1, 1, 1),(37, 1155, 1, 1, 1),(37, 1156, 1, 1, 1),(37, 1157, 1, 1, 1),(37, 1158, 1, 1, 1),(37, 1159, 1, 1, 1),(37, 1160, 1, 1, 1),(37, 1161, 1, 1, 1),(37, 1162, 1, 1, 1),(37, 1163, 1, 1, 1),(37, 1164, 1, 1, 1),(37, 1165, 1, 1, 1),(37, 1166, 1, 1, 1),(37, 1167, 1, 1, 1),(37, 1168, 1, 1, 1),(37, 1169, 1, 1, 1),(37, 1170, 1, 1, 1),(37, 1171, 1, 1, 1),(37, 1172, 1, 1, 1),(37, 1173, 1, 1, 1),(37, 1174, 1, 1, 1),(37, 1175, 1, 1, 1),(37, 1176, 1, 1, 1),(37, 1177, 1, 1, 1),(37, 1178, 1, 1, 1),(37, 1179, 1, 1, 1),(37, 1180, 1, 1, 1),(37, 1181, 1, 1, 1),(37, 1182, 1, 1, 1),(37, 1183, 1, 1, 1),(37, 1184, 1, 1, 1),(37, 1185, 1, 1, 1),(37, 1186, 1, 1, 1),(37, 1187, 1, 1, 1),(37, 1188, 1, 1, 1),(37, 1189, 1, 1, 1),(37, 1190, 1, 1, 1),(37, 1191, 1, 1, 1),(37, 1192, 1, 1, 1),(37, 1193, 1, 1, 1),(37, 1194, 1, 1, 1),(37, 1195, 1, 1, 1),(37, 1196, 1, 1, 1),(37, 1197, 1, 1, 1),(37, 1198, 1, 1, 1),(37, 1199, 1, 1, 1),(37, 1200, 1, 1, 1),(37, 1201, 1, 1, 1),(37, 1202, 1, 1, 1),(37, 1203, 1, 1, 1),(37, 1204, 1, 1, 1),(37, 1205, 1, 1, 1),(37, 1206, 1, 1, 1),(37, 1207, 1, 1, 1),(37, 1208, 1, 1, 1),(37, 1209, 1, 1, 1),(37, 1210, 1, 1, 1),(37, 1211, 1, 1, 1),(37, 1212, 1, 1, 1),(37, 1213, 1, 1, 1),(37, 1214, 1, 1, 1),(37, 1215, 1, 1, 1),(37, 1216, 1, 1, 1),(37, 1217, 1, 1, 1),(37, 1218, 1, 1, 1),(37, 1219, 1, 1, 1),(37, 1220, 1, 1, 1),(37, 1221, 1, 1, 1),(37, 1222, 1, 1, 1),(37, 1223, 1, 1, 1),(37, 1224, 1, 1, 1),(37, 1225, 1, 1, 1),(37, 1226, 1, 1, 1),(37, 1227, 1, 1, 1),(37, 1228, 1, 1, 1),(37, 1229, 1, 1, 1),(37, 1230, 1, 1, 1),(37, 1231, 1, 1, 1),(37, 1232, 1, 1, 1),(37, 1233, 1, 1, 1),(37, 1234, 1, 1, 1),(37, 1235, 1, 1, 1),(37, 1236, 1, 1, 1),(37, 1237, 1, 1, 1),(37, 1238, 1, 1, 1),(37, 1239, 1, 1, 1),(37, 1240, 1, 1, 1),(37, 1241, 1, 1, 1),(37, 1242, 1, 1, 1),(37, 1243, 1, 1, 1),(37, 1244, 1, 1, 1),(37, 1245, 1, 1, 1),(37, 1246, 1, 1, 1),(37, 1247, 1, 1, 1),(37, 1248, 1, 1, 1),(37, 1249, 1, 1, 1),(37, 1250, 1, 1, 1),(37, 1251, 1, 1, 1),(37, 1252, 1, 1, 1),(37, 1253, 1, 1, 1),(37, 1254, 1, 1, 1),(37, 1255, 1, 1, 1),(37, 1256, 1, 1, 1),(37, 1257, 1, 1, 1),(37, 1258, 1, 1, 1),(37, 1259, 1, 1, 1),(37, 1260, 1, 1, 1),(37, 1261, 1, 1, 1),(37, 1262, 1, 1, 1),(37, 1263, 1, 1, 1),(37, 1264, 1, 1, 1),(37, 1265, 1, 1, 1),(37, 1266, 1, 1, 1),(37, 1267, 1, 1, 1),(37, 1268, 1, 1, 1),(37, 1269, 1, 1, 1),(37, 1270, 1, 1, 1),(37, 1271, 1, 1, 1),(37, 1272, 1, 1, 1),(37, 1273, 1, 1, 1),(37, 1274, 1, 1, 1),(37, 1275, 1, 1, 1),(37, 1276, 1, 1, 1),(37, 1277, 1, 1, 1),(37, 1278, 1, 1, 1),(37, 1279, 1, 1, 1),(37, 1280, 1, 1, 1),(37, 1281, 1, 1, 1),(37, 1282, 1, 1, 1),(37, 1283, 1, 1, 1),(37, 1284, 1, 1, 1),(37, 1285, 1, 1, 1),(37, 1286, 1, 1, 1),(37, 1287, 1, 1, 1),(37, 1288, 1, 1, 1),(37, 1289, 1, 1, 1),(37, 1290, 1, 1, 1),(37, 1291, 1, 1, 1),(37, 1292, 1, 1, 1),(37, 1293, 1, 1, 1),(37, 1294, 1, 1, 1),(37, 1295, 1, 1, 1),(37, 1296, 1, 1, 1),(37, 1297, 1, 1, 1),(37, 1298, 1, 1, 1),(37, 1299, 1, 1, 1),(37, 1300, 1, 1, 1),(37, 1301, 1, 1, 1),(37, 1302, 1, 1, 1),(37, 1303, 1, 1, 1),(37, 1304, 1, 1, 1),(37, 1305, 1, 1, 1),(37, 1306, 1, 1, 1),(37, 1307, 1, 1, 1),(37, 1308, 1, 1, 1),(37, 1309, 1, 1, 1),(37, 1310, 1, 1, 1),(37, 1311, 1, 1, 1),(37, 1312, 1, 1, 1),(37, 1313, 1, 1, 1),(37, 1314, 1, 1, 1),(37, 1315, 1, 1, 1),(37, 1316, 1, 1, 1),(37, 1317, 1, 1, 1),(37, 1318, 1, 1, 1),(37, 1319, 1, 1, 1),(37, 1320, 1, 1, 1),(37, 1321, 1, 1, 1),(37, 1322, 1, 1, 1),(37, 1323, 1, 1, 1),(37, 1324, 1, 1, 1),(37, 1325, 1, 1, 1),(37, 1326, 1, 1, 1),(37, 1327, 1, 1, 1),(37, 1328, 1, 1, 1),(37, 1329, 1, 1, 1),(37, 1330, 1, 1, 1),(37, 1331, 1, 1, 1),(37, 1332, 1, 1, 1),(37, 1333, 1, 1, 1),(37, 1334, 1, 1, 1),(37, 1335, 1, 1, 1),(37, 1336, 1, 1, 1),(37, 1337, 1, 1, 1),(37, 1338, 1, 1, 1),(37, 1339, 1, 1, 1),(37, 1340, 1, 1, 1),(37, 1341, 1, 1, 1),(37, 1342, 1, 1, 1),(37, 1343, 1, 1, 1),(37, 1344, 1, 1, 1),(37, 1345, 1, 1, 1),(37, 1346, 1, 1, 1),(37, 1347, 1, 1, 1),(37, 1348, 1, 1, 1),(37, 1349, 1, 1, 1),(37, 1350, 1, 1, 1),(37, 1351, 1, 1, 1),(37, 1352, 1, 1, 1),(37, 1353, 1, 1, 1),(37, 1354, 1, 1, 1),(37, 1355, 1, 1, 1),(37, 1356, 1, 1, 1),(37, 1357, 1, 1, 1),(37, 1358, 1, 1, 1),(37, 1359, 1, 1, 1),(37, 1360, 1, 1, 1),(37, 1361, 1, 1, 1),(37, 1362, 1, 1, 1),(37, 1363, 1, 1, 1),(37, 1364, 1, 1, 1),(37, 1365, 1, 1, 1),(37, 1366, 1, 1, 1),(37, 1367, 1, 1, 1),(37, 1368, 1, 1, 1),(37, 1369, 1, 1, 1),(37, 1370, 1, 1, 1),(37, 1371, 1, 1, 1),(37, 1372, 1, 1, 1),(37, 1373, 1, 1, 1),(37, 1374, 1, 1, 1),(37, 1375, 1, 1, 1),(37, 1376, 1, 1, 1),(37, 1377, 1, 1, 1),(37, 1378, 1, 1, 1),(37, 1379, 1, 1, 1),(37, 1380, 1, 1, 1),(37, 1381, 1, 1, 1),(37, 1382, 1, 1, 1),(37, 1383, 1, 1, 1),(37, 1384, 1, 1, 1),(37, 1385, 1, 1, 1),(37, 1386, 1, 1, 1),(37, 1387, 1, 1, 1),(37, 1388, 1, 1, 1),(37, 1389, 1, 1, 1),(37, 1390, 1, 1, 1),(37, 1391, 1, 1, 1),(37, 1392, 1, 1, 1),(37, 1393, 1, 1, 1),(37, 1394, 1, 1, 1),(37, 1395, 1, 1, 1),(37, 1396, 1, 1, 1),(37, 1397, 1, 1, 1),(37, 1398, 1, 1, 1),(37, 1399, 1, 1, 1),(37, 1400, 1, 1, 1),(37, 1401, 1, 1, 1),(37, 1402, 1, 1, 1),(37, 1403, 1, 1, 1),(37, 1404, 1, 1, 1),(37, 1405, 1, 1, 1),(37, 1406, 1, 1, 1),(37, 1407, 1, 1, 1),(37, 1408, 1, 1, 1),(37, 1409, 1, 1, 1),(37, 1410, 1, 1, 1),(37, 1411, 1, 1, 1),(37, 1412, 1, 1, 1),(37, 1413, 1, 1, 1),(37, 1414, 1, 1, 1),(37, 1415, 1, 1, 1),(37, 1416, 1, 1, 1),(37, 1417, 1, 1, 1),(37, 1418, 1, 1, 1),(37, 1419, 1, 1, 1),(37, 1420, 1, 1, 1),(37, 1421, 1, 1, 1),(37, 1422, 1, 1, 1),(37, 1423, 1, 1, 1),(37, 1424, 1, 1, 1),(37, 1425, 1, 1, 1),(37, 1426, 1, 1, 1),(37, 1427, 1, 1, 1),(37, 1428, 1, 1, 1),(37, 1429, 1, 1, 1),(37, 1430, 1, 1, 1),(37, 1431, 1, 1, 1),(37, 1432, 1, 1, 1),(37, 1433, 1, 1, 1),(37, 1434, 1, 1, 1),(37, 1435, 1, 1, 1),(37, 1436, 1, 1, 1),(37, 1437, 1, 1, 1),(37, 1438, 1, 1, 1),(37, 1439, 1, 1, 1),(37, 1440, 1, 1, 1),(37, 1441, 1, 1, 1),(37, 1442, 1, 1, 1),(37, 1443, 1, 1, 1),(37, 1444, 1, 1, 1),(37, 1445, 1, 1, 1),(37, 1446, 1, 1, 1),(37, 1447, 1, 1, 1),(37, 1448, 1, 1, 1),(37, 1449, 1, 1, 1),(37, 1450, 1, 1, 1),(37, 1451, 1, 1, 1),(37, 1452, 1, 1, 1),(37, 1453, 1, 1, 1),(37, 1454, 1, 1, 1),(37, 1455, 1, 1, 1),(37, 1456, 1, 1, 1),(37, 1457, 1, 1, 1),(37, 1458, 1, 1, 1),(37, 1459, 1, 1, 1),(37, 1460, 1, 1, 1),(37, 1461, 1, 1, 1),(37, 1462, 1, 1, 1),(37, 1463, 1, 1, 1),(37, 1464, 1, 1, 1),(37, 1465, 1, 1, 1),(37, 1466, 1, 1, 1),(37, 1467, 1, 1, 1),(37, 1468, 1, 1, 1),(37, 1469, 1, 1, 1),(37, 1470, 1, 1, 1),(37, 1471, 1, 1, 1),(37, 1472, 1, 1, 1),(37, 1473, 1, 1, 1),(37, 1474, 1, 1, 1),(37, 1475, 1, 1, 1),(37, 1476, 1, 1, 1),(37, 1477, 1, 1, 1),(37, 1478, 1, 1, 1),(37, 1479, 1, 1, 1),(37, 1480, 1, 1, 1),(37, 1481, 1, 1, 1),(37, 1482, 1, 1, 1),(37, 1483, 1, 1, 1),(37, 1484, 1, 1, 1),(37, 1485, 1, 1, 1),(37, 1486, 1, 1, 1),(37, 1487, 1, 1, 1),(37, 1488, 1, 1, 1),(37, 1489, 2, 1, 1),(37, 1490, 2, 1, 1),(37, 1491, 2, 1, 1),(37, 1492, 2, 1, 1),(37, 1493, 2, 1, 1),(37, 1494, 2, 1, 1),(37, 1495, 2, 1, 1),(37, 1496, 2, 1, 1),(37, 1497, 3, 1, 1),(37, 1498, 3, 1, 1),(37, 1499, 3, 1, 1),(37, 1500, 3, 1, 1),(37, 1501, 4, 1, 1),(37, 1502, 4, 1, 1),(37, 1503, 4, 1, 1),(37, 1504, 4, 1, 1),(37, 1505, 1, 1, 1),(37, 1506, 1, 1, 1),(37, 1507, 1, 1, 1),(37, 1508, 1, 1, 1),(37, 1509, 1, 1, 1),(37, 1510, 1, 1, 1),(37, 1511, 1, 1, 1),(37, 1512, 1, 1, 1),(37, 1513, 1, 1, 1),(37, 1514, 1, 1, 1),(37, 1515, 1, 1, 1),(37, 1516, 1, 1, 1),(37, 1517, 1, 1, 1),(37, 1518, 1, 1, 1),(37, 1519, 1, 1, 1),(37, 1520, 1, 1, 1),(37, 1521, 2, 1, 1),(37, 1522, 2, 1, 1),(37, 1523, 2, 1, 1),(37, 1524, 2, 1, 1),(37, 1525, 2, 1, 1),(37, 1526, 2, 1, 1),(37, 1527, 2, 1, 1),(37, 1528, 2, 1, 1),(37, 1529, 3, 1, 1),(37, 1530, 3, 1, 1),(37, 1531, 3, 1, 1),(37, 1532, 3, 1, 1),(37, 1533, 4, 1, 1),(37, 1534, 4, 1, 1),(37, 1535, 4, 1, 1),(37, 1536, 4, 1, 1),(38, 1, 1, 1, 1),(38, 2, 1, 1, 1),(38, 3, 1, 1, 1),(38, 4, 1, 1, 1),(38, 5, 1, 1, 1),(38, 6, 1, 1, 1),(38, 7, 1, 1, 1),(38, 8, 1, 1, 1),(38, 9, 1, 1, 1),(38, 10, 1, 1, 1),(38, 11, 1, 1, 1),(38, 12, 1, 1, 1),(38, 13, 1, 1, 1),(38, 14, 1, 1, 1),(38, 15, 1, 1, 1),(38, 16, 1, 1, 1),(38, 17, 1, 1, 1),(38, 18, 1, 1, 1),(38, 19, 1, 1, 1),(38, 20, 1, 1, 1),(38, 21, 1, 1, 1),(38, 22, 1, 1, 1),(38, 23, 1, 1, 1),(38, 24, 1, 1, 1),(38, 25, 1, 1, 1),(38, 26, 1, 1, 1),(38, 27, 1, 1, 1),(38, 28, 1, 1, 1),(38, 29, 1, 1, 1),(38, 30, 1, 1, 1),(38, 31, 1, 1, 1),(38, 32, 1, 1, 1),(38, 33, 1, 1, 1),(38, 34, 1, 1, 1),(38, 35, 1, 1, 1),(38, 36, 1, 1, 1),(38, 37, 1, 1, 1),(38, 38, 1, 1, 1),(38, 39, 1, 1, 1),(38, 40, 1, 1, 1),(38, 41, 1, 1, 1),(38, 42, 1, 1, 1),(38, 43, 1, 1, 1),(38, 44, 1, 1, 1),(38, 45, 1, 1, 1),(38, 46, 1, 1, 1),(38, 47, 1, 1, 1),(38, 48, 1, 1, 1),(38, 49, 1, 1, 1),(38, 50, 1, 1, 1),(38, 51, 1, 1, 1),(38, 52, 1, 1, 1),(38, 53, 1, 1, 1),(38, 54, 1, 1, 1),(38, 55, 1, 1, 1),(38, 56, 1, 1, 1),(38, 57, 1, 1, 1),(38, 58, 1, 1, 1),(38, 59, 1, 1, 1),(38, 60, 1, 1, 1),(38, 61, 1, 1, 1),(38, 62, 1, 1, 1),(38, 63, 1, 1, 1),(38, 64, 1, 1, 1),(38, 65, 1, 1, 1),(38, 66, 1, 1, 1),(38, 67, 1, 1, 1),(38, 68, 1, 1, 1),(38, 69, 1, 1, 1),(38, 70, 1, 1, 1),(38, 71, 1, 1, 1),(38, 72, 1, 1, 1),(38, 73, 1, 1, 1),(38, 74, 1, 1, 1),(38, 75, 1, 1, 1),(38, 76, 1, 1, 1),(38, 77, 1, 1, 1),(38, 78, 1, 1, 1),(38, 79, 1, 1, 1),(38, 80, 1, 1, 1),(38, 81, 1, 1, 1),(38, 82, 1, 1, 1),(38, 83, 1, 1, 1),(38, 84, 1, 1, 1),(38, 85, 1, 1, 1),(38, 86, 1, 1, 1),(38, 87, 1, 1, 1),(38, 88, 1, 1, 1),(38, 89, 1, 1, 1),(38, 90, 1, 1, 1),(38, 91, 1, 1, 1),(38, 92, 1, 1, 1),(38, 93, 1, 1, 1),(38, 94, 1, 1, 1),(38, 95, 1, 1, 1),(38, 96, 1, 1, 1),(38, 97, 1, 1, 1),(38, 98, 1, 1, 1),(38, 99, 1, 1, 1),(38, 100, 1, 1, 1),(38, 101, 1, 1, 1),(38, 102, 1, 1, 1),(38, 103, 1, 1, 1),(38, 104, 1, 1, 1),(38, 105, 1, 1, 1),(38, 106, 1, 1, 1),(38, 107, 1, 1, 1),(38, 108, 1, 1, 1),(38, 109, 1, 1, 1),(38, 110, 1, 1, 1),(38, 111, 1, 1, 1),(38, 112, 1, 1, 1),(38, 113, 1, 1, 1),(38, 114, 1, 1, 1),(38, 115, 1, 1, 1),(38, 116, 1, 1, 1),(38, 117, 1, 1, 1),(38, 118, 1, 1, 1),(38, 119, 1, 1, 1),(38, 120, 1, 1, 1),(38, 121, 1, 1, 1),(38, 122, 1, 1, 1),(38, 123, 1, 1, 1),(38, 124, 1, 1, 1),(38, 125, 1, 1, 1),(38, 126, 1, 1, 1),(38, 127, 1, 1, 1),(38, 128, 1, 1, 1),(38, 129, 1, 1, 1),(38, 130, 1, 1, 1),(38, 131, 1, 1, 1),(38, 132, 1, 1, 1),(38, 133, 1, 1, 1),(38, 134, 1, 1, 1),(38, 135, 1, 1, 1),(38, 136, 1, 1, 1),(38, 137, 1, 1, 1),(38, 138, 1, 1, 1),(38, 139, 1, 1, 1),(38, 140, 1, 1, 1),(38, 141, 1, 1, 1),(38, 142, 1, 1, 1),(38, 143, 1, 1, 1),(38, 144, 1, 1, 1),(38, 145, 1, 1, 1),(38, 146, 1, 1, 1),(38, 147, 1, 1, 1),(38, 148, 1, 1, 1),(38, 149, 1, 1, 1),(38, 150, 1, 1, 1),(38, 151, 1, 1, 1),(38, 152, 1, 1, 1),(38, 153, 1, 1, 1),(38, 154, 1, 1, 1),(38, 155, 1, 1, 1),(38, 156, 1, 1, 1),(38, 157, 1, 1, 1),(38, 158, 1, 1, 1),(38, 159, 1, 1, 1),(38, 160, 1, 1, 1),(38, 161, 1, 1, 1),(38, 162, 1, 1, 1),(38, 163, 1, 1, 1),(38, 164, 1, 1, 1),(38, 165, 1, 1, 1),(38, 166, 1, 1, 1),(38, 167, 1, 1, 1),(38, 168, 1, 1, 1),(38, 169, 1, 1, 1),(38, 170, 1, 1, 1),(38, 171, 1, 1, 1),(38, 172, 1, 1, 1),(38, 173, 1, 1, 1),(38, 174, 1, 1, 1),(38, 175, 1, 1, 1),(38, 176, 1, 1, 1),(38, 177, 1, 1, 1),(38, 178, 1, 1, 1),(38, 179, 1, 1, 1),(38, 180, 1, 1, 1),(38, 181, 1, 1, 1),(38, 182, 1, 1, 1),(38, 183, 1, 1, 1),(38, 184, 1, 1, 1),(38, 185, 1, 1, 1),(38, 186, 1, 1, 1),(38, 187, 1, 1, 1),(38, 188, 1, 1, 1),(38, 189, 1, 1, 1),(38, 190, 1, 1, 1),(38, 191, 1, 1, 1),(38, 192, 1, 1, 1),(38, 193, 1, 1, 1),(38, 194, 1, 1, 1),(38, 195, 1, 1, 1),(38, 196, 1, 1, 1),(38, 197, 1, 1, 1),(38, 198, 1, 1, 1),(38, 199, 1, 1, 1),(38, 200, 1, 1, 1),(38, 201, 1, 1, 1),(38, 202, 1, 1, 1),(38, 203, 1, 1, 1),(38, 204, 1, 1, 1),(38, 205, 1, 1, 1),(38, 206, 1, 1, 1),(38, 207, 1, 1, 1),(38, 208, 1, 1, 1),(38, 209, 1, 1, 1),(38, 210, 1, 1, 1),(38, 211, 1, 1, 1),(38, 212, 1, 1, 1),(38, 213, 1, 1, 1),(38, 214, 1, 1, 1),(38, 215, 1, 1, 1),(38, 216, 1, 1, 1),(38, 217, 1, 1, 1),(38, 218, 1, 1, 1),(38, 219, 1, 1, 1),(38, 220, 1, 1, 1),(38, 221, 1, 1, 1),(38, 222, 1, 1, 1),(38, 223, 1, 1, 1),(38, 224, 1, 1, 1),(38, 225, 1, 1, 1),(38, 226, 1, 1, 1),(38, 227, 1, 1, 1),(38, 228, 1, 1, 1),(38, 229, 1, 1, 1),(38, 230, 1, 1, 1),(38, 231, 1, 1, 1),(38, 232, 1, 1, 1),(38, 233, 1, 1, 1),(38, 234, 1, 1, 1),(38, 235, 1, 1, 1),(38, 236, 1, 1, 1),(38, 237, 1, 1, 1),(38, 238, 1, 1, 1),(38, 239, 1, 1, 1),(38, 240, 1, 1, 1),(38, 241, 1, 1, 1),(38, 242, 1, 1, 1),(38, 243, 1, 1, 1),(38, 244, 1, 1, 1),(38, 245, 1, 1, 1),(38, 246, 1, 1, 1),(38, 247, 1, 1, 1),(38, 248, 1, 1, 1),(38, 249, 1, 1, 1),(38, 250, 1, 1, 1),(38, 251, 1, 1, 1),(38, 252, 1, 1, 1),(38, 253, 1, 1, 1),(38, 254, 1, 1, 1),(38, 255, 1, 1, 1),(38, 256, 1, 1, 1),(38, 257, 1, 1, 1),(38, 258, 1, 1, 1),(38, 259, 1, 1, 1),(38, 260, 1, 1, 1),(38, 261, 1, 1, 1),(38, 262, 1, 1, 1),(38, 263, 1, 1, 1),(38, 264, 1, 1, 1),(38, 265, 1, 1, 1),(38, 266, 1, 1, 1),(38, 267, 1, 1, 1),(38, 268, 1, 1, 1),(38, 269, 1, 1, 1),(38, 270, 1, 1, 1),(38, 271, 1, 1, 1),(38, 272, 1, 1, 1),(38, 273, 1, 1, 1),(38, 274, 1, 1, 1),(38, 275, 1, 1, 1),(38, 276, 1, 1, 1),(38, 277, 1, 1, 1),(38, 278, 1, 1, 1),(38, 279, 1, 1, 1),(38, 280, 1, 1, 1),(38, 281, 1, 1, 1),(38, 282, 1, 1, 1),(38, 283, 1, 1, 1),(38, 284, 1, 1, 1),(38, 285, 1, 1, 1),(38, 286, 1, 1, 1),(38, 287, 1, 1, 1),(38, 288, 1, 1, 1),(38, 289, 1, 1, 1),(38, 290, 1, 1, 1),(38, 291, 1, 1, 1),(38, 292, 1, 1, 1),(38, 293, 1, 1, 1),(38, 294, 1, 1, 1),(38, 295, 1, 1, 1),(38, 296, 1, 1, 1),(38, 297, 1, 1, 1),(38, 298, 1, 1, 1),(38, 299, 1, 1, 1),(38, 300, 1, 1, 1),(38, 301, 1, 1, 1),(38, 302, 1, 1, 1),(38, 303, 1, 1, 1),(38, 304, 1, 1, 1),(38, 305, 1, 1, 1),(38, 306, 1, 1, 1),(38, 307, 1, 1, 1),(38, 308, 1, 1, 1),(38, 309, 1, 1, 1),(38, 310, 1, 1, 1),(38, 311, 1, 1, 1),(38, 312, 1, 1, 1),(38, 313, 1, 1, 1),(38, 314, 1, 1, 1),(38, 315, 1, 1, 1),(38, 316, 1, 1, 1),(38, 317, 1, 1, 1),(38, 318, 1, 1, 1),(38, 319, 1, 1, 1),(38, 320, 1, 1, 1),(38, 321, 1, 1, 1),(38, 322, 1, 1, 1),(38, 323, 1, 1, 1),(38, 324, 1, 1, 1),(38, 325, 1, 1, 1),(38, 326, 1, 1, 1),(38, 327, 1, 1, 1),(38, 328, 1, 1, 1),(38, 329, 1, 1, 1),(38, 330, 1, 1, 1),(38, 331, 1, 1, 1),(38, 332, 1, 1, 1),(38, 333, 1, 1, 1),(38, 334, 1, 1, 1),(38, 335, 1, 1, 1),(38, 336, 1, 1, 1),(38, 337, 1, 1, 1),(38, 338, 1, 1, 1),(38, 339, 1, 1, 1),(38, 340, 1, 1, 1),(38, 341, 1, 1, 1),(38, 342, 1, 1, 1),(38, 343, 1, 1, 1),(38, 344, 1, 1, 1),(38, 345, 1, 1, 1),(38, 346, 1, 1, 1),(38, 347, 1, 1, 1),(38, 348, 1, 1, 1),(38, 349, 1, 1, 1),(38, 350, 1, 1, 1),(38, 351, 1, 1, 1),(38, 352, 1, 1, 1),(38, 353, 1, 1, 1),(38, 354, 1, 1, 1),(38, 355, 1, 1, 1),(38, 356, 1, 1, 1),(38, 357, 1, 1, 1),(38, 358, 1, 1, 1),(38, 359, 1, 1, 1),(38, 360, 1, 1, 1),(38, 361, 1, 1, 1),(38, 362, 1, 1, 1),(38, 363, 1, 1, 1),(38, 364, 1, 1, 1),(38, 365, 1, 1, 1),(38, 366, 1, 1, 1),(38, 367, 1, 1, 1),(38, 368, 1, 1, 1),(38, 369, 1, 1, 1),(38, 370, 1, 1, 1),(38, 371, 1, 1, 1),(38, 372, 1, 1, 1),(38, 373, 1, 1, 1),(38, 374, 1, 1, 1),(38, 375, 1, 1, 1),(38, 376, 1, 1, 1),(38, 377, 1, 1, 1),(38, 378, 1, 1, 1),(38, 379, 1, 1, 1),(38, 380, 1, 1, 1),(38, 381, 1, 1, 1),(38, 382, 1, 1, 1),(38, 383, 1, 1, 1),(38, 384, 1, 1, 1),(38, 385, 1, 1, 1),(38, 386, 1, 1, 1),(38, 387, 1, 1, 1),(38, 388, 1, 1, 1),(38, 389, 1, 1, 1),(38, 390, 1, 1, 1),(38, 391, 1, 1, 1),(38, 392, 1, 1, 1),(38, 393, 1, 1, 1),(38, 394, 1, 1, 1),(38, 395, 1, 1, 1),(38, 396, 1, 1, 1),(38, 397, 1, 1, 1),(38, 398, 1, 1, 1),(38, 399, 1, 1, 1),(38, 400, 1, 1, 1),(38, 401, 1, 1, 1),(38, 402, 1, 1, 1),(38, 403, 1, 1, 1),(38, 404, 1, 1, 1),(38, 405, 1, 1, 1),(38, 406, 1, 1, 1),(38, 407, 1, 1, 1),(38, 408, 1, 1, 1),(38, 409, 1, 1, 1),(38, 410, 1, 1, 1),(38, 411, 1, 1, 1),(38, 412, 1, 1, 1),(38, 413, 1, 1, 1),(38, 414, 1, 1, 1),(38, 415, 1, 1, 1),(38, 416, 1, 1, 1),(38, 417, 1, 1, 1),(38, 418, 1, 1, 1),(38, 419, 1, 1, 1),(38, 420, 1, 1, 1),(38, 421, 1, 1, 1),(38, 422, 1, 1, 1),(38, 423, 1, 1, 1),(38, 424, 1, 1, 1),(38, 425, 1, 1, 1),(38, 426, 1, 1, 1),(38, 427, 1, 1, 1),(38, 428, 1, 1, 1),(38, 429, 1, 1, 1),(38, 430, 1, 1, 1),(38, 431, 1, 1, 1),(38, 432, 1, 1, 1),(38, 433, 1, 1, 1),(38, 434, 1, 1, 1),(38, 435, 1, 1, 1),(38, 436, 1, 1, 1),(38, 437, 1, 1, 1),(38, 438, 1, 1, 1),(38, 439, 1, 1, 1),(38, 440, 1, 1, 1),(38, 441, 1, 1, 1),(38, 442, 1, 1, 1),(38, 443, 1, 1, 1),(38, 444, 1, 1, 1),(38, 445, 1, 1, 1),(38, 446, 1, 1, 1),(38, 447, 1, 1, 1),(38, 448, 1, 1, 1),(38, 449, 1, 1, 1),(38, 450, 1, 1, 1),(38, 451, 1, 1, 1),(38, 452, 1, 1, 1),(38, 453, 1, 1, 1),(38, 454, 1, 1, 1),(38, 455, 1, 1, 1),(38, 456, 1, 1, 1),(38, 457, 1, 1, 1),(38, 458, 1, 1, 1),(38, 459, 1, 1, 1),(38, 460, 1, 1, 1),(38, 461, 1, 1, 1),(38, 462, 1, 1, 1),(38, 463, 1, 1, 1),(38, 464, 1, 1, 1),(38, 465, 1, 1, 1),(38, 466, 1, 1, 1),(38, 467, 1, 1, 1),(38, 468, 1, 1, 1),(38, 469, 1, 1, 1),(38, 470, 1, 1, 1),(38, 471, 1, 1, 1),(38, 472, 1, 1, 1),(38, 473, 1, 1, 1),(38, 474, 1, 1, 1),(38, 475, 1, 1, 1),(38, 476, 1, 1, 1),(38, 477, 1, 1, 1),(38, 478, 1, 1, 1),(38, 479, 1, 1, 1),(38, 480, 1, 1, 1),(38, 481, 1, 1, 1),(38, 482, 1, 1, 1),(38, 483, 1, 1, 1),(38, 484, 1, 1, 1),(38, 485, 1, 1, 1),(38, 486, 1, 1, 1),(38, 487, 1, 1, 1),(38, 488, 1, 1, 1),(38, 489, 1, 1, 1),(38, 490, 1, 1, 1),(38, 491, 1, 1, 1),(38, 492, 1, 1, 1),(38, 493, 1, 1, 1),(38, 494, 1, 1, 1),(38, 495, 1, 1, 1),(38, 496, 1, 1, 1),(38, 497, 1, 1, 1),(38, 498, 1, 1, 1),(38, 499, 1, 1, 1),(38, 500, 1, 1, 1),(38, 501, 1, 1, 1),(38, 502, 1, 1, 1),(38, 503, 1, 1, 1),(38, 504, 1, 1, 1),(38, 505, 1, 1, 1),(38, 506, 1, 1, 1),(38, 507, 1, 1, 1),(38, 508, 1, 1, 1),(38, 509, 1, 1, 1),(38, 510, 1, 1, 1),(38, 511, 1, 1, 1),(38, 512, 1, 1, 1),(38, 513, 1, 1, 1),(38, 514, 1, 1, 1),(38, 515, 1, 1, 1),(38, 516, 1, 1, 1),(38, 517, 1, 1, 1),(38, 518, 1, 1, 1),(38, 519, 1, 1, 1),(38, 520, 1, 1, 1),(38, 521, 1, 1, 1),(38, 522, 1, 1, 1),(38, 523, 1, 1, 1),(38, 524, 1, 1, 1),(38, 525, 1, 1, 1),(38, 526, 1, 1, 1),(38, 527, 1, 1, 1),(38, 528, 1, 1, 1),(38, 529, 1, 1, 1),(38, 530, 1, 1, 1),(38, 531, 1, 1, 1),(38, 532, 1, 1, 1),(38, 533, 1, 1, 1),(38, 534, 1, 1, 1),(38, 535, 1, 1, 1),(38, 536, 1, 1, 1),(38, 537, 1, 1, 1),(38, 538, 1, 1, 1),(38, 539, 1, 1, 1),(38, 540, 1, 1, 1),(38, 541, 1, 1, 1),(38, 542, 1, 1, 1),(38, 543, 1, 1, 1),(38, 544, 1, 1, 1),(38, 545, 1, 1, 1),(38, 546, 1, 1, 1),(38, 547, 1, 1, 1),(38, 548, 1, 1, 1),(38, 549, 1, 1, 1),(38, 550, 1, 1, 1),(38, 551, 1, 1, 1),(38, 552, 1, 1, 1),(38, 553, 1, 1, 1),(38, 554, 1, 1, 1),(38, 555, 1, 1, 1),(38, 556, 1, 1, 1),(38, 557, 1, 1, 1),(38, 558, 1, 1, 1),(38, 559, 1, 1, 1),(38, 560, 1, 1, 1),(38, 561, 1, 1, 1),(38, 562, 1, 1, 1),(38, 563, 1, 1, 1),(38, 564, 1, 1, 1),(38, 565, 1, 1, 1),(38, 566, 1, 1, 1),(38, 567, 1, 1, 1),(38, 568, 1, 1, 1),(38, 569, 1, 1, 1),(38, 570, 1, 1, 1),(38, 571, 1, 1, 1),(38, 572, 1, 1, 1),(38, 573, 1, 1, 1),(38, 574, 1, 1, 1),(38, 575, 1, 1, 1),(38, 576, 1, 1, 1),(38, 577, 1, 1, 1),(38, 578, 1, 1, 1),(38, 579, 1, 1, 1),(38, 580, 1, 1, 1),(38, 581, 1, 1, 1),(38, 582, 1, 1, 1),(38, 583, 1, 1, 1),(38, 584, 1, 1, 1),(38, 585, 1, 1, 1),(38, 586, 1, 1, 1),(38, 587, 1, 1, 1),(38, 588, 1, 1, 1),(38, 589, 1, 1, 1),(38, 590, 1, 1, 1),(38, 591, 1, 1, 1),(38, 592, 1, 1, 1),(38, 593, 1, 1, 1),(38, 594, 1, 1, 1),(38, 595, 1, 1, 1),(38, 596, 1, 1, 1),(38, 597, 1, 1, 1),(38, 598, 1, 1, 1),(38, 599, 1, 1, 1),(38, 600, 1, 1, 1),(38, 601, 1, 1, 1),(38, 602, 1, 1, 1),(38, 603, 1, 1, 1),(38, 604, 1, 1, 1),(38, 605, 1, 1, 1),(38, 606, 1, 1, 1),(38, 607, 1, 1, 1),(38, 608, 1, 1, 1),(38, 609, 1, 1, 1),(38, 610, 1, 1, 1),(38, 611, 1, 1, 1),(38, 612, 1, 1, 1),(38, 613, 1, 1, 1),(38, 614, 1, 1, 1),(38, 615, 1, 1, 1),(38, 616, 1, 1, 1),(38, 617, 1, 1, 1),(38, 618, 1, 1, 1),(38, 619, 1, 1, 1),(38, 620, 1, 1, 1),(38, 621, 1, 1, 1),(38, 622, 1, 1, 1),(38, 623, 1, 1, 1),(38, 624, 1, 1, 1),(38, 625, 1, 1, 1),(38, 626, 1, 1, 1),(38, 627, 1, 1, 1),(38, 628, 1, 1, 1),(38, 629, 1, 1, 1),(38, 630, 1, 1, 1),(38, 631, 1, 1, 1),(38, 632, 1, 1, 1),(38, 633, 1, 1, 1),(38, 634, 1, 1, 1),(38, 635, 1, 1, 1),(38, 636, 1, 1, 1),(38, 637, 1, 1, 1),(38, 638, 1, 1, 1),(38, 639, 1, 1, 1),(38, 640, 1, 1, 1),(38, 641, 1, 1, 1),(38, 642, 1, 1, 1),(38, 643, 1, 1, 1),(38, 644, 1, 1, 1),(38, 645, 1, 1, 1),(38, 646, 1, 1, 1),(38, 647, 1, 1, 1),(38, 648, 1, 1, 1),(38, 649, 1, 1, 1),(38, 650, 1, 1, 1),(38, 651, 1, 1, 1),(38, 652, 1, 1, 1),(38, 653, 1, 1, 1),(38, 654, 1, 1, 1),(38, 655, 1, 1, 1),(38, 656, 1, 1, 1),(38, 657, 1, 1, 1),(38, 658, 1, 1, 1),(38, 659, 1, 1, 1),(38, 660, 1, 1, 1),(38, 661, 1, 1, 1),(38, 662, 1, 1, 1),(38, 663, 1, 1, 1),(38, 664, 1, 1, 1),(38, 665, 1, 1, 1),(38, 666, 1, 1, 1),(38, 667, 1, 1, 1),(38, 668, 1, 1, 1),(38, 669, 1, 1, 1),(38, 670, 1, 1, 1),(38, 671, 1, 1, 1),(38, 672, 1, 1, 1),(38, 673, 1, 1, 1),(38, 674, 1, 1, 1),(38, 675, 1, 1, 1),(38, 676, 1, 1, 1),(38, 677, 1, 1, 1),(38, 678, 1, 1, 1),(38, 679, 1, 1, 1),(38, 680, 1, 1, 1),(38, 681, 1, 1, 1),(38, 682, 1, 1, 1),(38, 683, 1, 1, 1),(38, 684, 1, 1, 1),(38, 685, 1, 1, 1),(38, 686, 1, 1, 1),(38, 687, 1, 1, 1),(38, 688, 1, 1, 1),(38, 689, 1, 1, 1),(38, 690, 1, 1, 1),(38, 691, 1, 1, 1),(38, 692, 1, 1, 1),(38, 693, 1, 1, 1),(38, 694, 1, 1, 1),(38, 695, 1, 1, 1),(38, 696, 1, 1, 1),(38, 697, 1, 1, 1),(38, 698, 1, 1, 1),(38, 699, 1, 1, 1),(38, 700, 1, 1, 1),(38, 701, 1, 1, 1),(38, 702, 1, 1, 1),(38, 703, 1, 1, 1),(38, 704, 1, 1, 1),(38, 705, 1, 1, 1),(38, 706, 1, 1, 1),(38, 707, 1, 1, 1),(38, 708, 1, 1, 1),(38, 709, 1, 1, 1),(38, 710, 1, 1, 1),(38, 711, 1, 1, 1),(38, 712, 1, 1, 1),(38, 713, 1, 1, 1),(38, 714, 1, 1, 1),(38, 715, 1, 1, 1),(38, 716, 1, 1, 1),(38, 717, 1, 1, 1),(38, 718, 1, 1, 1),(38, 719, 1, 1, 1),(38, 720, 1, 1, 1),(38, 721, 1, 1, 1),(38, 722, 1, 1, 1),(38, 723, 1, 1, 1),(38, 724, 1, 1, 1),(38, 725, 1, 1, 1),(38, 726, 1, 1, 1),(38, 727, 1, 1, 1),(38, 728, 1, 1, 1),(38, 729, 1, 1, 1),(38, 730, 1, 1, 1),(38, 731, 1, 1, 1),(38, 732, 1, 1, 1),(38, 733, 1, 1, 1),(38, 734, 1, 1, 1),(38, 735, 1, 1, 1),(38, 736, 1, 1, 1),(38, 737, 1, 1, 1),(38, 738, 1, 1, 1),(38, 739, 1, 1, 1),(38, 740, 1, 1, 1),(38, 741, 1, 1, 1),(38, 742, 1, 1, 1),(38, 743, 1, 1, 1),(38, 744, 1, 1, 1),(38, 745, 1, 1, 1),(38, 746, 1, 1, 1),(38, 747, 1, 1, 1),(38, 748, 1, 1, 1),(38, 749, 1, 1, 1),(38, 750, 1, 1, 1),(38, 751, 1, 1, 1),(38, 752, 1, 1, 1),(38, 753, 1, 1, 1),(38, 754, 1, 1, 1),(38, 755, 1, 1, 1),(38, 756, 1, 1, 1),(38, 757, 1, 1, 1),(38, 758, 1, 1, 1),(38, 759, 1, 1, 1),(38, 760, 1, 1, 1),(38, 761, 1, 1, 1),(38, 762, 1, 1, 1),(38, 763, 1, 1, 1),(38, 764, 1, 1, 1),(38, 765, 1, 1, 1),(38, 766, 1, 1, 1),(38, 767, 1, 1, 1),(38, 768, 1, 1, 1),(38, 769, 1, 1, 1),(38, 770, 1, 1, 1),(38, 771, 1, 1, 1),(38, 772, 1, 1, 1),(38, 773, 1, 1, 1),(38, 774, 1, 1, 1),(38, 775, 1, 1, 1),(38, 776, 1, 1, 1),(38, 777, 1, 1, 1),(38, 778, 1, 1, 1),(38, 779, 1, 1, 1),(38, 780, 1, 1, 1),(38, 781, 1, 1, 1),(38, 782, 1, 1, 1),(38, 783, 1, 1, 1),(38, 784, 1, 1, 1),(38, 785, 1, 1, 1),(38, 786, 1, 1, 1),(38, 787, 1, 1, 1),(38, 788, 1, 1, 1),(38, 789, 1, 1, 1),(38, 790, 1, 1, 1),(38, 791, 1, 1, 1),(38, 792, 1, 1, 1),(38, 793, 1, 1, 1),(38, 794, 1, 1, 1),(38, 795, 1, 1, 1),(38, 796, 1, 1, 1),(38, 797, 1, 1, 1),(38, 798, 1, 1, 1),(38, 799, 1, 1, 1),(38, 800, 1, 1, 1),(38, 801, 1, 1, 1),(38, 802, 1, 1, 1),(38, 803, 1, 1, 1),(38, 804, 1, 1, 1),(38, 805, 1, 1, 1),(38, 806, 1, 1, 1),(38, 807, 1, 1, 1),(38, 808, 1, 1, 1),(38, 809, 1, 1, 1),(38, 810, 1, 1, 1),(38, 811, 1, 1, 1),(38, 812, 1, 1, 1),(38, 813, 1, 1, 1),(38, 814, 1, 1, 1),(38, 815, 1, 1, 1),(38, 816, 1, 1, 1),(38, 817, 1, 1, 1),(38, 818, 1, 1, 1),(38, 819, 1, 1, 1),(38, 820, 1, 1, 1),(38, 821, 1, 1, 1),(38, 822, 1, 1, 1),(38, 823, 1, 1, 1),(38, 824, 1, 1, 1),(38, 825, 1, 1, 1),(38, 826, 1, 1, 1),(38, 827, 1, 1, 1),(38, 828, 1, 1, 1),(38, 829, 1, 1, 1),(38, 830, 1, 1, 1),(38, 831, 1, 1, 1),(38, 832, 1, 1, 1),(38, 833, 1, 1, 1),(38, 834, 1, 1, 1),(38, 835, 1, 1, 1),(38, 836, 1, 1, 1),(38, 837, 1, 1, 1),(38, 838, 1, 1, 1),(38, 839, 1, 1, 1),(38, 840, 1, 1, 1),(38, 841, 1, 1, 1),(38, 842, 1, 1, 1),(38, 843, 1, 1, 1),(38, 844, 1, 1, 1),(38, 845, 1, 1, 1),(38, 846, 1, 1, 1),(38, 847, 1, 1, 1),(38, 848, 1, 1, 1),(38, 849, 1, 1, 1),(38, 850, 1, 1, 1),(38, 851, 1, 1, 1),(38, 852, 1, 1, 1),(38, 853, 1, 1, 1),(38, 854, 1, 1, 1),(38, 855, 1, 1, 1),(38, 856, 1, 1, 1),(38, 857, 1, 1, 1),(38, 858, 1, 1, 1),(38, 859, 1, 1, 1),(38, 860, 1, 1, 1),(38, 861, 1, 1, 1),(38, 862, 1, 1, 1),(38, 863, 1, 1, 1),(38, 864, 1, 1, 1),(38, 865, 1, 1, 1),(38, 866, 1, 1, 1),(38, 867, 1, 1, 1),(38, 868, 1, 1, 1),(38, 869, 1, 1, 1),(38, 870, 1, 1, 1),(38, 871, 1, 1, 1),(38, 872, 1, 1, 1),(38, 873, 1, 1, 1),(38, 874, 1, 1, 1),(38, 875, 1, 1, 1),(38, 876, 1, 1, 1),(38, 877, 1, 1, 1),(38, 878, 1, 1, 1),(38, 879, 1, 1, 1),(38, 880, 1, 1, 1),(38, 881, 1, 1, 1),(38, 882, 1, 1, 1),(38, 883, 1, 1, 1),(38, 884, 1, 1, 1),(38, 885, 1, 1, 1),(38, 886, 1, 1, 1),(38, 887, 1, 1, 1),(38, 888, 1, 1, 1),(38, 889, 1, 1, 1),(38, 890, 1, 1, 1),(38, 891, 1, 1, 1),(38, 892, 1, 1, 1),(38, 893, 1, 1, 1),(38, 894, 1, 1, 1),(38, 895, 1, 1, 1),(38, 896, 1, 1, 1),(38, 897, 1, 1, 1),(38, 898, 1, 1, 1),(38, 899, 1, 1, 1),(38, 900, 1, 1, 1),(38, 901, 1, 1, 1),(38, 902, 1, 1, 1),(38, 903, 1, 1, 1),(38, 904, 1, 1, 1),(38, 905, 1, 1, 1),(38, 906, 1, 1, 1),(38, 907, 1, 1, 1),(38, 908, 1, 1, 1),(38, 909, 1, 1, 1),(38, 910, 1, 1, 1),(38, 911, 1, 1, 1),(38, 912, 1, 1, 1),(38, 913, 1, 1, 1),(38, 914, 1, 1, 1),(38, 915, 1, 1, 1),(38, 916, 1, 1, 1),(38, 917, 1, 1, 1),(38, 918, 1, 1, 1),(38, 919, 1, 1, 1),(38, 920, 1, 1, 1),(38, 921, 1, 1, 1),(38, 922, 1, 1, 1),(38, 923, 1, 1, 1),(38, 924, 1, 1, 1),(38, 925, 1, 1, 1),(38, 926, 1, 1, 1),(38, 927, 1, 1, 1),(38, 928, 1, 1, 1),(38, 929, 1, 1, 1),(38, 930, 1, 1, 1),(38, 931, 1, 1, 1),(38, 932, 1, 1, 1),(38, 933, 1, 1, 1),(38, 934, 1, 1, 1),(38, 935, 1, 1, 1),(38, 936, 1, 1, 1),(38, 937, 1, 1, 1),(38, 938, 1, 1, 1),(38, 939, 1, 1, 1),(38, 940, 1, 1, 1),(38, 941, 1, 1, 1),(38, 942, 1, 1, 1),(38, 943, 1, 1, 1),(38, 944, 1, 1, 1),(38, 945, 1, 1, 1),(38, 946, 1, 1, 1),(38, 947, 1, 1, 1),(38, 948, 1, 1, 1),(38, 949, 1, 1, 1),(38, 950, 1, 1, 1),(38, 951, 1, 1, 1),(38, 952, 1, 1, 1),(38, 953, 1, 1, 1),(38, 954, 1, 1, 1),(38, 955, 1, 1, 1),(38, 956, 1, 1, 1),(38, 957, 1, 1, 1),(38, 958, 1, 1, 1),(38, 959, 1, 1, 1),(38, 960, 1, 1, 1),(38, 961, 1, 1, 1),(38, 962, 1, 1, 1),(38, 963, 1, 1, 1),(38, 964, 1, 1, 1),(38, 965, 1, 1, 1),(38, 966, 1, 1, 1),(38, 967, 1, 1, 1),(38, 968, 1, 1, 1),(38, 969, 1, 1, 1),(38, 970, 1, 1, 1),(38, 971, 1, 1, 1),(38, 972, 1, 1, 1),(38, 973, 1, 1, 1),(38, 974, 1, 1, 1),(38, 975, 1, 1, 1),(38, 976, 1, 1, 1),(38, 977, 1, 1, 1),(38, 978, 1, 1, 1),(38, 979, 1, 1, 1),(38, 980, 1, 1, 1),(38, 981, 1, 1, 1),(38, 982, 1, 1, 1),(38, 983, 1, 1, 1),(38, 984, 1, 1, 1),(38, 985, 1, 1, 1),(38, 986, 1, 1, 1),(38, 987, 1, 1, 1),(38, 988, 1, 1, 1),(38, 989, 1, 1, 1),(38, 990, 1, 1, 1),(38, 991, 1, 1, 1),(38, 992, 1, 1, 1),(38, 993, 1, 1, 1),(38, 994, 1, 1, 1),(38, 995, 1, 1, 1),(38, 996, 1, 1, 1),(38, 997, 1, 1, 1),(38, 998, 1, 1, 1),(38, 999, 1, 1, 1),(38, 1000, 1, 1, 1),(38, 1001, 1, 1, 1),(38, 1002, 1, 1, 1),(38, 1003, 1, 1, 1),(38, 1004, 1, 1, 1),(38, 1005, 1, 1, 1),(38, 1006, 1, 1, 1),(38, 1007, 1, 1, 1),(38, 1008, 1, 1, 1),(38, 1009, 1, 1, 1),(38, 1010, 1, 1, 1),(38, 1011, 1, 1, 1),(38, 1012, 1, 1, 1),(38, 1013, 1, 1, 1),(38, 1014, 1, 1, 1),(38, 1015, 1, 1, 1),(38, 1016, 1, 1, 1),(38, 1017, 1, 1, 1),(38, 1018, 1, 1, 1),(38, 1019, 1, 1, 1),(38, 1020, 1, 1, 1),(38, 1021, 1, 1, 1),(38, 1022, 1, 1, 1),(38, 1023, 1, 1, 1),(38, 1024, 1, 1, 1),(38, 1025, 1, 1, 1),(38, 1026, 1, 1, 1),(38, 1027, 1, 1, 1),(38, 1028, 1, 1, 1),(38, 1029, 1, 1, 1),(38, 1030, 1, 1, 1),(38, 1031, 1, 1, 1),(38, 1032, 1, 1, 1),(38, 1033, 1, 1, 1),(38, 1034, 1, 1, 1),(38, 1035, 1, 1, 1),(38, 1036, 1, 1, 1),(38, 1037, 1, 1, 1),(38, 1038, 1, 1, 1),(38, 1039, 1, 1, 1),(38, 1040, 1, 1, 1),(38, 1041, 1, 1, 1),(38, 1042, 1, 1, 1),(38, 1043, 1, 1, 1),(38, 1044, 1, 1, 1),(38, 1045, 1, 1, 1),(38, 1046, 1, 1, 1),(38, 1047, 1, 1, 1),(38, 1048, 1, 1, 1),(38, 1049, 1, 1, 1),(38, 1050, 1, 1, 1),(38, 1051, 1, 1, 1),(38, 1052, 1, 1, 1),(38, 1053, 1, 1, 1),(38, 1054, 1, 1, 1),(38, 1055, 1, 1, 1),(38, 1056, 1, 1, 1),(38, 1057, 1, 1, 1),(38, 1058, 1, 1, 1),(38, 1059, 1, 1, 1),(38, 1060, 1, 1, 1),(38, 1061, 1, 1, 1),(38, 1062, 1, 1, 1),(38, 1063, 1, 1, 1),(38, 1064, 1, 1, 1),(38, 1065, 1, 1, 1),(38, 1066, 1, 1, 1),(38, 1067, 1, 1, 1),(38, 1068, 1, 1, 1),(38, 1069, 1, 1, 1),(38, 1070, 1, 1, 1),(38, 1071, 1, 1, 1),(38, 1072, 1, 1, 1),(38, 1073, 1, 1, 1),(38, 1074, 1, 1, 1),(38, 1075, 1, 1, 1),(38, 1076, 1, 1, 1),(38, 1077, 1, 1, 1),(38, 1078, 1, 1, 1),(38, 1079, 1, 1, 1),(38, 1080, 1, 1, 1),(38, 1081, 1, 1, 1),(38, 1082, 1, 1, 1),(38, 1083, 1, 1, 1),(38, 1084, 1, 1, 1),(38, 1085, 1, 1, 1),(38, 1086, 1, 1, 1),(38, 1087, 1, 1, 1),(38, 1088, 1, 1, 1),(38, 1089, 1, 1, 1),(38, 1090, 1, 1, 1),(38, 1091, 1, 1, 1),(38, 1092, 1, 1, 1),(38, 1093, 1, 1, 1),(38, 1094, 1, 1, 1),(38, 1095, 1, 1, 1),(38, 1096, 1, 1, 1),(38, 1097, 1, 1, 1),(38, 1098, 1, 1, 1),(38, 1099, 1, 1, 1),(38, 1100, 1, 1, 1),(38, 1101, 1, 1, 1),(38, 1102, 1, 1, 1),(38, 1103, 1, 1, 1),(38, 1104, 1, 1, 1),(38, 1105, 1, 1, 1),(38, 1106, 1, 1, 1),(38, 1107, 1, 1, 1),(38, 1108, 1, 1, 1),(38, 1109, 1, 1, 1),(38, 1110, 1, 1, 1),(38, 1111, 1, 1, 1),(38, 1112, 1, 1, 1),(38, 1113, 1, 1, 1),(38, 1114, 1, 1, 1),(38, 1115, 1, 1, 1),(38, 1116, 1, 1, 1),(38, 1117, 1, 1, 1),(38, 1118, 1, 1, 1),(38, 1119, 1, 1, 1),(38, 1120, 1, 1, 1),(38, 1121, 1, 1, 1),(38, 1122, 1, 1, 1),(38, 1123, 1, 1, 1),(38, 1124, 1, 1, 1),(38, 1125, 1, 1, 1),(38, 1126, 1, 1, 1),(38, 1127, 1, 1, 1),(38, 1128, 1, 1, 1),(38, 1129, 1, 1, 1),(38, 1130, 1, 1, 1),(38, 1131, 1, 1, 1),(38, 1132, 1, 1, 1),(38, 1133, 1, 1, 1),(38, 1134, 1, 1, 1),(38, 1135, 1, 1, 1),(38, 1136, 1, 1, 1),(38, 1137, 1, 1, 1),(38, 1138, 1, 1, 1),(38, 1139, 1, 1, 1),(38, 1140, 1, 1, 1),(38, 1141, 1, 1, 1),(38, 1142, 1, 1, 1),(38, 1143, 1, 1, 1),(38, 1144, 1, 1, 1),(38, 1145, 1, 1, 1),(38, 1146, 1, 1, 1),(38, 1147, 1, 1, 1),(38, 1148, 1, 1, 1),(38, 1149, 1, 1, 1),(38, 1150, 1, 1, 1),(38, 1151, 1, 1, 1),(38, 1152, 1, 1, 1),(38, 1153, 1, 1, 1),(38, 1154, 1, 1, 1),(38, 1155, 1, 1, 1),(38, 1156, 1, 1, 1),(38, 1157, 1, 1, 1),(38, 1158, 1, 1, 1),(38, 1159, 1, 1, 1),(38, 1160, 1, 1, 1),(38, 1161, 1, 1, 1),(38, 1162, 1, 1, 1),(38, 1163, 1, 1, 1),(38, 1164, 1, 1, 1),(38, 1165, 1, 1, 1),(38, 1166, 1, 1, 1),(38, 1167, 1, 1, 1),(38, 1168, 1, 1, 1),(38, 1169, 1, 1, 1),(38, 1170, 1, 1, 1),(38, 1171, 1, 1, 1),(38, 1172, 1, 1, 1),(38, 1173, 1, 1, 1),(38, 1174, 1, 1, 1),(38, 1175, 1, 1, 1),(38, 1176, 1, 1, 1),(38, 1177, 1, 1, 1),(38, 1178, 1, 1, 1),(38, 1179, 1, 1, 1),(38, 1180, 1, 1, 1),(38, 1181, 1, 1, 1),(38, 1182, 1, 1, 1),(38, 1183, 1, 1, 1),(38, 1184, 1, 1, 1),(38, 1185, 1, 1, 1),(38, 1186, 1, 1, 1),(38, 1187, 1, 1, 1),(38, 1188, 1, 1, 1),(38, 1189, 1, 1, 1),(38, 1190, 1, 1, 1),(38, 1191, 1, 1, 1),(38, 1192, 1, 1, 1),(38, 1193, 1, 1, 1),(38, 1194, 1, 1, 1),(38, 1195, 1, 1, 1),(38, 1196, 1, 1, 1),(38, 1197, 1, 1, 1),(38, 1198, 1, 1, 1),(38, 1199, 1, 1, 1),(38, 1200, 1, 1, 1),(38, 1201, 1, 1, 1),(38, 1202, 1, 1, 1),(38, 1203, 1, 1, 1),(38, 1204, 1, 1, 1),(38, 1205, 1, 1, 1),(38, 1206, 1, 1, 1),(38, 1207, 1, 1, 1),(38, 1208, 1, 1, 1),(38, 1209, 1, 1, 1),(38, 1210, 1, 1, 1),(38, 1211, 1, 1, 1),(38, 1212, 1, 1, 1),(38, 1213, 1, 1, 1),(38, 1214, 1, 1, 1),(38, 1215, 1, 1, 1),(38, 1216, 1, 1, 1),(38, 1217, 1, 1, 1),(38, 1218, 1, 1, 1),(38, 1219, 1, 1, 1),(38, 1220, 1, 1, 1),(38, 1221, 1, 1, 1),(38, 1222, 1, 1, 1),(38, 1223, 1, 1, 1),(38, 1224, 1, 1, 1),(38, 1225, 1, 1, 1),(38, 1226, 1, 1, 1),(38, 1227, 1, 1, 1),(38, 1228, 1, 1, 1),(38, 1229, 1, 1, 1),(38, 1230, 1, 1, 1),(38, 1231, 1, 1, 1),(38, 1232, 1, 1, 1),(38, 1233, 1, 1, 1),(38, 1234, 1, 1, 1),(38, 1235, 1, 1, 1),(38, 1236, 1, 1, 1),(38, 1237, 1, 1, 1),(38, 1238, 1, 1, 1),(38, 1239, 1, 1, 1),(38, 1240, 1, 1, 1),(38, 1241, 1, 1, 1),(38, 1242, 1, 1, 1),(38, 1243, 1, 1, 1),(38, 1244, 1, 1, 1),(38, 1245, 1, 1, 1),(38, 1246, 1, 1, 1),(38, 1247, 1, 1, 1),(38, 1248, 1, 1, 1),(38, 1249, 1, 1, 1),(38, 1250, 1, 1, 1),(38, 1251, 1, 1, 1),(38, 1252, 1, 1, 1),(38, 1253, 1, 1, 1),(38, 1254, 1, 1, 1),(38, 1255, 1, 1, 1),(38, 1256, 1, 1, 1),(38, 1257, 1, 1, 1),(38, 1258, 1, 1, 1),(38, 1259, 1, 1, 1),(38, 1260, 1, 1, 1),(38, 1261, 1, 1, 1),(38, 1262, 1, 1, 1),(38, 1263, 1, 1, 1),(38, 1264, 1, 1, 1),(38, 1265, 1, 1, 1),(38, 1266, 1, 1, 1),(38, 1267, 1, 1, 1),(38, 1268, 1, 1, 1),(38, 1269, 1, 1, 1),(38, 1270, 1, 1, 1),(38, 1271, 1, 1, 1),(38, 1272, 1, 1, 1),(38, 1273, 1, 1, 1),(38, 1274, 1, 1, 1),(38, 1275, 1, 1, 1),(38, 1276, 1, 1, 1),(38, 1277, 1, 1, 1),(38, 1278, 1, 1, 1),(38, 1279, 1, 1, 1),(38, 1280, 1, 1, 1),(38, 1281, 1, 1, 1),(38, 1282, 1, 1, 1),(38, 1283, 1, 1, 1),(38, 1284, 1, 1, 1),(38, 1285, 1, 1, 1),(38, 1286, 1, 1, 1),(38, 1287, 1, 1, 1),(38, 1288, 1, 1, 1),(38, 1289, 1, 1, 1),(38, 1290, 1, 1, 1),(38, 1291, 1, 1, 1),(38, 1292, 1, 1, 1),(38, 1293, 1, 1, 1),(38, 1294, 1, 1, 1),(38, 1295, 1, 1, 1),(38, 1296, 1, 1, 1),(38, 1297, 1, 1, 1),(38, 1298, 1, 1, 1),(38, 1299, 1, 1, 1),(38, 1300, 1, 1, 1),(38, 1301, 1, 1, 1),(38, 1302, 1, 1, 1),(38, 1303, 1, 1, 1),(38, 1304, 1, 1, 1),(38, 1305, 1, 1, 1),(38, 1306, 1, 1, 1),(38, 1307, 1, 1, 1),(38, 1308, 1, 1, 1),(38, 1309, 1, 1, 1),(38, 1310, 1, 1, 1),(38, 1311, 1, 1, 1),(38, 1312, 1, 1, 1),(38, 1313, 1, 1, 1),(38, 1314, 1, 1, 1),(38, 1315, 1, 1, 1),(38, 1316, 1, 1, 1),(38, 1317, 1, 1, 1),(38, 1318, 1, 1, 1),(38, 1319, 1, 1, 1),(38, 1320, 1, 1, 1),(38, 1321, 1, 1, 1),(38, 1322, 1, 1, 1),(38, 1323, 1, 1, 1),(38, 1324, 1, 1, 1),(38, 1325, 1, 1, 1),(38, 1326, 1, 1, 1),(38, 1327, 1, 1, 1),(38, 1328, 1, 1, 1),(38, 1329, 1, 1, 1),(38, 1330, 1, 1, 1),(38, 1331, 1, 1, 1),(38, 1332, 1, 1, 1),(38, 1333, 1, 1, 1),(38, 1334, 1, 1, 1),(38, 1335, 1, 1, 1),(38, 1336, 1, 1, 1),(38, 1337, 1, 1, 1),(38, 1338, 1, 1, 1),(38, 1339, 1, 1, 1),(38, 1340, 1, 1, 1),(38, 1341, 1, 1, 1),(38, 1342, 1, 1, 1),(38, 1343, 1, 1, 1),(38, 1344, 1, 1, 1),(38, 1345, 1, 1, 1),(38, 1346, 1, 1, 1),(38, 1347, 1, 1, 1),(38, 1348, 1, 1, 1),(38, 1349, 1, 1, 1),(38, 1350, 1, 1, 1),(38, 1351, 1, 1, 1),(38, 1352, 1, 1, 1),(38, 1353, 1, 1, 1),(38, 1354, 1, 1, 1),(38, 1355, 1, 1, 1),(38, 1356, 1, 1, 1),(38, 1357, 1, 1, 1),(38, 1358, 1, 1, 1),(38, 1359, 1, 1, 1),(38, 1360, 1, 1, 1),(38, 1361, 1, 1, 1),(38, 1362, 1, 1, 1),(38, 1363, 1, 1, 1),(38, 1364, 1, 1, 1),(38, 1365, 1, 1, 1),(38, 1366, 1, 1, 1),(38, 1367, 1, 1, 1),(38, 1368, 1, 1, 1),(38, 1369, 1, 1, 1),(38, 1370, 1, 1, 1),(38, 1371, 1, 1, 1),(38, 1372, 1, 1, 1),(38, 1373, 1, 1, 1),(38, 1374, 1, 1, 1),(38, 1375, 1, 1, 1),(38, 1376, 1, 1, 1),(38, 1377, 1, 1, 1),(38, 1378, 1, 1, 1),(38, 1379, 1, 1, 1),(38, 1380, 1, 1, 1),(38, 1381, 1, 1, 1),(38, 1382, 1, 1, 1),(38, 1383, 1, 1, 1),(38, 1384, 1, 1, 1),(38, 1385, 1, 1, 1),(38, 1386, 1, 1, 1),(38, 1387, 1, 1, 1),(38, 1388, 1, 1, 1),(38, 1389, 1, 1, 1),(38, 1390, 1, 1, 1),(38, 1391, 1, 1, 1),(38, 1392, 1, 1, 1),(38, 1393, 1, 1, 1),(38, 1394, 1, 1, 1),(38, 1395, 1, 1, 1),(38, 1396, 1, 1, 1),(38, 1397, 1, 1, 1),(38, 1398, 1, 1, 1),(38, 1399, 1, 1, 1),(38, 1400, 1, 1, 1),(38, 1401, 1, 1, 1),(38, 1402, 1, 1, 1),(38, 1403, 1, 1, 1),(38, 1404, 1, 1, 1),(38, 1405, 1, 1, 1),(38, 1406, 1, 1, 1),(38, 1407, 1, 1, 1),(38, 1408, 1, 1, 1),(38, 1409, 1, 1, 1),(38, 1410, 1, 1, 1),(38, 1411, 1, 1, 1),(38, 1412, 1, 1, 1),(38, 1413, 1, 1, 1),(38, 1414, 1, 1, 1),(38, 1415, 1, 1, 1),(38, 1416, 1, 1, 1),(38, 1417, 1, 1, 1),(38, 1418, 1, 1, 1),(38, 1419, 1, 1, 1),(38, 1420, 1, 1, 1),(38, 1421, 1, 1, 1),(38, 1422, 1, 1, 1),(38, 1423, 1, 1, 1),(38, 1424, 1, 1, 1),(38, 1425, 1, 1, 1),(38, 1426, 1, 1, 1),(38, 1427, 1, 1, 1),(38, 1428, 1, 1, 1),(38, 1429, 1, 1, 1),(38, 1430, 1, 1, 1),(38, 1431, 1, 1, 1),(38, 1432, 1, 1, 1),(38, 1433, 1, 1, 1),(38, 1434, 1, 1, 1),(38, 1435, 1, 1, 1),(38, 1436, 1, 1, 1),(38, 1437, 1, 1, 1),(38, 1438, 1, 1, 1),(38, 1439, 1, 1, 1),(38, 1440, 1, 1, 1),(38, 1441, 1, 1, 1),(38, 1442, 1, 1, 1),(38, 1443, 1, 1, 1),(38, 1444, 1, 1, 1),(38, 1445, 1, 1, 1),(38, 1446, 1, 1, 1),(38, 1447, 1, 1, 1),(38, 1448, 1, 1, 1),(38, 1449, 1, 1, 1),(38, 1450, 1, 1, 1),(38, 1451, 1, 1, 1),(38, 1452, 1, 1, 1),(38, 1453, 1, 1, 1),(38, 1454, 1, 1, 1),(38, 1455, 1, 1, 1),(38, 1456, 1, 1, 1),(38, 1457, 1, 1, 1),(38, 1458, 1, 1, 1),(38, 1459, 1, 1, 1),(38, 1460, 1, 1, 1),(38, 1461, 1, 1, 1),(38, 1462, 1, 1, 1),(38, 1463, 1, 1, 1),(38, 1464, 1, 1, 1),(38, 1465, 1, 1, 1),(38, 1466, 1, 1, 1),(38, 1467, 1, 1, 1),(38, 1468, 1, 1, 1),(38, 1469, 1, 1, 1),(38, 1470, 1, 1, 1),(38, 1471, 1, 1, 1),(38, 1472, 1, 1, 1),(38, 1473, 2, 1, 1),(38, 1474, 2, 1, 1),(38, 1475, 2, 1, 1),(38, 1476, 2, 1, 1),(38, 1477, 2, 1, 1),(38, 1478, 2, 1, 1),(38, 1479, 2, 1, 1),(38, 1480, 2, 1, 1),(38, 1481, 2, 1, 1),(38, 1482, 2, 1, 1),(38, 1483, 2, 1, 1),(38, 1484, 2, 1, 1),(38, 1485, 2, 1, 1),(38, 1486, 2, 1, 1),(38, 1487, 2, 1, 1),(38, 1488, 2, 1, 1),(38, 1489, 3, 1, 1),(38, 1490, 3, 1, 1),(38, 1491, 3, 1, 1),(38, 1492, 3, 1, 1),(38, 1493, 3, 1, 1),(38, 1494, 3, 1, 1),(38, 1495, 3, 1, 1),(38, 1496, 3, 1, 1),(38, 1497, 4, 1, 1),(38, 1498, 4, 1, 1),(38, 1499, 4, 1, 1),(38, 1500, 4, 1, 1),(38, 1501, 4, 1, 1),(38, 1502, 4, 1, 1),(38, 1503, 4, 1, 1),(38, 1504, 4, 1, 1),(38, 1505, 2, 1, 1),(38, 1506, 2, 1, 1),(38, 1507, 2, 1, 1),(38, 1508, 2, 1, 1),(38, 1509, 2, 1, 1),(38, 1510, 2, 1, 1),(38, 1511, 2, 1, 1),(38, 1512, 2, 1, 1),(38, 1513, 2, 1, 1),(38, 1514, 2, 1, 1),(38, 1515, 2, 1, 1),(38, 1516, 2, 1, 1),(38, 1517, 2, 1, 1),(38, 1518, 2, 1, 1),(38, 1519, 2, 1, 1),(38, 1520, 2, 1, 1),(38, 1521, 3, 1, 1),(38, 1522, 3, 1, 1),(38, 1523, 3, 1, 1),(38, 1524, 3, 1, 1),(38, 1525, 3, 1, 1),(38, 1526, 3, 1, 1),(38, 1527, 3, 1, 1),(38, 1528, 3, 1, 1),(38, 1529, 4, 1, 1),(38, 1530, 4, 1, 1),(38, 1531, 4, 1, 1),(38, 1532, 4, 1, 1),(38, 1533, 4, 1, 1),(38, 1534, 4, 1, 1),(38, 1535, 4, 1, 1),(38, 1536, 4, 1, 1),(39, 1, 5, 1, 1),(39, 2, 5, 1, 1),(39, 3, 5, 1, 1),(39, 4, 5, 1, 1),(39, 5, 5, 1, 1),(39, 6, 5, 1, 1),(39, 7, 5, 1, 1),(39, 8, 5, 1, 1),(39, 9, 5, 1, 1),(39, 10, 5, 1, 1),(39, 11, 5, 1, 1),(39, 12, 5, 1, 1),(39, 13, 5, 1, 1),(39, 14, 5, 1, 1),(39, 15, 5, 1, 1),(39, 16, 5, 1, 1),(39, 17, 5, 1, 1),(39, 18, 5, 1, 1),(39, 19, 5, 1, 1),(39, 20, 5, 1, 1),(39, 21, 5, 1, 1),(39, 22, 5, 1, 1),(39, 23, 5, 1, 1),(39, 24, 5, 1, 1),(39, 25, 5, 1, 1),(39, 26, 5, 1, 1),(39, 27, 5, 1, 1),(39, 28, 5, 1, 1),(39, 29, 5, 1, 1),(39, 30, 5, 1, 1),(39, 31, 5, 1, 1),(39, 32, 5, 1, 1),(39, 33, 5, 1, 1),(39, 34, 5, 1, 1),(39, 35, 5, 1, 1),(39, 36, 5, 1, 1),(39, 37, 5, 1, 1),(39, 38, 5, 1, 1),(39, 39, 5, 1, 1),(39, 40, 5, 1, 1),(39, 41, 5, 1, 1),(39, 42, 5, 1, 1),(39, 43, 5, 1, 1),(39, 44, 5, 1, 1),(39, 45, 5, 1, 1),(39, 46, 5, 1, 1),(39, 47, 5, 1, 1),(39, 48, 5, 1, 1),(39, 49, 5, 1, 1),(39, 50, 5, 1, 1),(39, 51, 5, 1, 1),(39, 52, 5, 1, 1),(39, 53, 5, 1, 1),(39, 54, 5, 1, 1),(39, 55, 5, 1, 1),(39, 56, 5, 1, 1),(39, 57, 5, 1, 1),(39, 58, 5, 1, 1),(39, 59, 5, 1, 1),(39, 60, 5, 1, 1),(39, 61, 5, 1, 1),(39, 62, 5, 1, 1),(39, 63, 5, 1, 1),(39, 64, 5, 1, 1),(39, 65, 5, 1, 1),(39, 66, 5, 1, 1),(39, 67, 1, 1, 1),(39, 68, 1, 1, 1),(39, 69, 1, 1, 1),(39, 70, 1, 1, 1),(39, 71, 1, 1, 1),(39, 72, 1, 1, 1),(39, 73, 1, 1, 1),(39, 74, 1, 1, 1),(39, 75, 1, 1, 1),(39, 76, 1, 1, 1),(39, 77, 1, 1, 1),(39, 78, 1, 1, 1),(39, 79, 1, 1, 1),(39, 80, 1, 1, 1),(39, 81, 1, 1, 1),(39, 82, 1, 1, 1),(39, 83, 1, 1, 1),(39, 84, 1, 1, 1),(39, 85, 1, 1, 1),(39, 86, 1, 1, 1),(39, 87, 1, 1, 1),(39, 88, 1, 1, 1),(39, 89, 1, 1, 1),(39, 90, 1, 1, 1),(39, 91, 1, 1, 1),(39, 92, 1, 1, 1),(39, 93, 1, 1, 1),(39, 94, 1, 1, 1),(39, 95, 5, 1, 1),(39, 96, 5, 1, 1),(39, 97, 5, 1, 1),(39, 98, 5, 1, 1),(39, 99, 1, 1, 1),(39, 100, 1, 1, 1),(39, 101, 1, 1, 1),(39, 102, 1, 1, 1),(39, 103, 1, 1, 1),(39, 104, 1, 1, 1),(39, 105, 1, 1, 1),(39, 106, 1, 1, 1),(39, 107, 1, 1, 1),(39, 108, 1, 1, 1),(39, 109, 1, 1, 1),(39, 110, 1, 1, 1),(39, 111, 1, 1, 1),(39, 112, 1, 1, 1),(39, 113, 1, 1, 1),(39, 114, 1, 1, 1),(39, 115, 1, 1, 1),(39, 116, 1, 1, 1),(39, 117, 1, 1, 1),(39, 118, 1, 1, 1),(39, 119, 1, 1, 1),(39, 120, 1, 1, 1),(39, 121, 1, 1, 1),(39, 122, 1, 1, 1),(39, 123, 1, 1, 1),(39, 124, 1, 1, 1),(39, 125, 1, 1, 1),(39, 126, 1, 1, 1),(39, 127, 5, 1, 1),(39, 128, 5, 1, 1),(39, 129, 5, 1, 1),(39, 130, 5, 1, 1),(39, 131, 1, 1, 1),(39, 132, 1, 1, 1),(39, 133, 1, 1, 1),(39, 134, 1, 1, 1),(39, 135, 1, 1, 1),(39, 136, 1, 1, 1),(39, 137, 1, 1, 1),(39, 138, 1, 1, 1),(39, 139, 1, 1, 1),(39, 140, 1, 1, 1),(39, 141, 1, 1, 1),(39, 142, 1, 1, 1),(39, 143, 1, 1, 1),(39, 144, 1, 1, 1),(39, 145, 1, 1, 1),(39, 146, 1, 1, 1),(39, 147, 1, 1, 1),(39, 148, 1, 1, 1),(39, 149, 1, 1, 1),(39, 150, 1, 1, 1),(39, 151, 1, 1, 1),(39, 152, 1, 1, 1),(39, 153, 1, 1, 1),(39, 154, 1, 1, 1),(39, 155, 1, 1, 1),(39, 156, 1, 1, 1),(39, 157, 1, 1, 1),(39, 158, 1, 1, 1),(39, 159, 5, 1, 1),(39, 160, 5, 1, 1),(39, 161, 5, 1, 1),(39, 162, 5, 1, 1),(39, 163, 1, 1, 1),(39, 164, 1, 1, 1),(39, 165, 1, 1, 1),(39, 166, 1, 1, 1),(39, 167, 1, 1, 1),(39, 168, 1, 1, 1),(39, 169, 1, 1, 1),(39, 170, 1, 1, 1),(39, 171, 1, 1, 1),(39, 172, 1, 1, 1),(39, 173, 1, 1, 1),(39, 174, 1, 1, 1),(39, 175, 1, 1, 1),(39, 176, 1, 1, 1),(39, 177, 1, 1, 1),(39, 178, 1, 1, 1),(39, 179, 1, 1, 1),(39, 180, 1, 1, 1),(39, 181, 1, 1, 1),(39, 182, 1, 1, 1),(39, 183, 1, 1, 1),(39, 184, 1, 1, 1),(39, 185, 1, 1, 1),(39, 186, 1, 1, 1),(39, 187, 1, 1, 1),(39, 188, 1, 1, 1),(39, 189, 1, 1, 1),(39, 190, 1, 1, 1),(39, 191, 5, 1, 1),(39, 192, 5, 1, 1),(39, 193, 5, 1, 1),(39, 194, 5, 1, 1),(39, 195, 1, 1, 1),(39, 196, 1, 1, 1),(39, 197, 1, 1, 1),(39, 198, 1, 1, 1),(39, 199, 1, 1, 1),(39, 200, 1, 1, 1),(39, 201, 1, 1, 1),(39, 202, 1, 1, 1),(39, 203, 1, 1, 1),(39, 204, 1, 1, 1),(39, 205, 1, 1, 1),(39, 206, 1, 1, 1),(39, 207, 1, 1, 1),(39, 208, 1, 1, 1),(39, 209, 1, 1, 1),(39, 210, 1, 1, 1),(39, 211, 1, 1, 1),(39, 212, 1, 1, 1),(39, 213, 1, 1, 1),(39, 214, 1, 1, 1),(39, 215, 1, 1, 1),(39, 216, 1, 1, 1),(39, 217, 1, 1, 1),(39, 218, 1, 1, 1),(39, 219, 1, 1, 1),(39, 220, 1, 1, 1),(39, 221, 1, 1, 1),(39, 222, 1, 1, 1),(39, 223, 5, 1, 1),(39, 224, 5, 1, 1),(39, 225, 5, 1, 1),(39, 226, 5, 1, 1),(39, 227, 1, 1, 1),(39, 228, 1, 1, 1),(39, 229, 1, 1, 1),(39, 230, 1, 1, 1),(39, 231, 1, 1, 1),(39, 232, 1, 1, 1),(39, 233, 1, 1, 1),(39, 234, 1, 1, 1),(39, 235, 1, 1, 1),(39, 236, 1, 1, 1),(39, 237, 1, 1, 1),(39, 238, 1, 1, 1),(39, 239, 1, 1, 1),(39, 240, 1, 1, 1),(39, 241, 1, 1, 1),(39, 242, 1, 1, 1),(39, 243, 1, 1, 1),(39, 244, 1, 1, 1),(39, 245, 1, 1, 1),(39, 246, 1, 1, 1),(39, 247, 1, 1, 1),(39, 248, 1, 1, 1),(39, 249, 1, 1, 1),(39, 250, 1, 1, 1),(39, 251, 1, 1, 1),(39, 252, 1, 1, 1),(39, 253, 1, 1, 1),(39, 254, 1, 1, 1),(39, 255, 5, 1, 1),(39, 256, 5, 1, 1),(39, 257, 5, 1, 1),(39, 258, 5, 1, 1),(39, 259, 1, 1, 1),(39, 260, 1, 1, 1),(39, 261, 1, 1, 1),(39, 262, 1, 1, 1),(39, 263, 1, 1, 1),(39, 264, 1, 1, 1),(39, 265, 1, 1, 1),(39, 266, 1, 1, 1),(39, 267, 1, 1, 1),(39, 268, 1, 1, 1),(39, 269, 1, 1, 1),(39, 270, 1, 1, 1),(39, 271, 1, 1, 1),(39, 272, 1, 1, 1),(39, 273, 1, 1, 1),(39, 274, 1, 1, 1),(39, 275, 1, 1, 1),(39, 276, 1, 1, 1),(39, 277, 1, 1, 1),(39, 278, 1, 1, 1),(39, 279, 1, 1, 1),(39, 280, 1, 1, 1),(39, 281, 1, 1, 1),(39, 282, 1, 1, 1),(39, 283, 1, 1, 1),(39, 284, 1, 1, 1),(39, 285, 1, 1, 1),(39, 286, 1, 1, 1),(39, 287, 5, 1, 1),(39, 288, 5, 1, 1),(39, 289, 5, 1, 1),(39, 290, 5, 1, 1),(39, 291, 1, 1, 1),(39, 292, 1, 1, 1),(39, 293, 1, 1, 1),(39, 294, 1, 1, 1),(39, 295, 1, 1, 1),(39, 296, 1, 1, 1),(39, 297, 1, 1, 1),(39, 298, 1, 1, 1),(39, 299, 1, 1, 1),(39, 300, 1, 1, 1),(39, 301, 1, 1, 1),(39, 302, 1, 1, 1),(39, 303, 1, 1, 1),(39, 304, 1, 1, 1),(39, 305, 1, 1, 1),(39, 306, 1, 1, 1),(39, 307, 1, 1, 1),(39, 308, 1, 1, 1),(39, 309, 1, 1, 1),(39, 310, 1, 1, 1),(39, 311, 1, 1, 1),(39, 312, 1, 1, 1),(39, 313, 1, 1, 1),(39, 314, 1, 1, 1),(39, 315, 1, 1, 1),(39, 316, 1, 1, 1),(39, 317, 1, 1, 1),(39, 318, 1, 1, 1),(39, 319, 5, 1, 1),(39, 320, 5, 1, 1),(39, 321, 5, 1, 1),(39, 322, 5, 1, 1),(39, 323, 1, 1, 1),(39, 324, 1, 1, 1),(39, 325, 1, 1, 1),(39, 326, 1, 1, 1),(39, 327, 1, 1, 1),(39, 328, 1, 1, 1),(39, 329, 1, 1, 1),(39, 330, 1, 1, 1),(39, 331, 1, 1, 1),(39, 332, 1, 1, 1),(39, 333, 1, 1, 1),(39, 334, 1, 1, 1),(39, 335, 1, 1, 1),(39, 336, 1, 1, 1),(39, 337, 1, 1, 1),(39, 338, 1, 1, 1),(39, 339, 1, 1, 1),(39, 340, 1, 1, 1),(39, 341, 1, 1, 1),(39, 342, 1, 1, 1),(39, 343, 1, 1, 1),(39, 344, 1, 1, 1),(39, 345, 1, 1, 1),(39, 346, 1, 1, 1),(39, 347, 1, 1, 1),(39, 348, 1, 1, 1),(39, 349, 1, 1, 1),(39, 350, 1, 1, 1),(39, 351, 5, 1, 1),(39, 352, 5, 1, 1),(39, 353, 5, 1, 1),(39, 354, 5, 1, 1),(39, 355, 1, 1, 1),(39, 356, 1, 1, 1),(39, 357, 1, 1, 1),(39, 358, 1, 1, 1),(39, 359, 1, 1, 1),(39, 360, 1, 1, 1),(39, 361, 1, 1, 1),(39, 362, 1, 1, 1),(39, 363, 1, 1, 1),(39, 364, 1, 1, 1),(39, 365, 1, 1, 1),(39, 366, 1, 1, 1),(39, 367, 1, 1, 1),(39, 368, 1, 1, 1),(39, 369, 1, 1, 1),(39, 370, 1, 1, 1),(39, 371, 1, 1, 1),(39, 372, 1, 1, 1),(39, 373, 1, 1, 1),(39, 374, 1, 1, 1),(39, 375, 1, 1, 1),(39, 376, 1, 1, 1),(39, 377, 1, 1, 1),(39, 378, 1, 1, 1),(39, 379, 1, 1, 1),(39, 380, 1, 1, 1),(39, 381, 1, 1, 1),(39, 382, 1, 1, 1),(39, 383, 5, 1, 1),(39, 384, 5, 1, 1),(39, 385, 5, 1, 1),(39, 386, 5, 1, 1),(39, 387, 1, 1, 1),(39, 388, 1, 1, 1),(39, 389, 1, 1, 1),(39, 390, 1, 1, 1),(39, 391, 1, 1, 1),(39, 392, 1, 1, 1),(39, 393, 1, 1, 1),(39, 394, 1, 1, 1),(39, 395, 1, 1, 1),(39, 396, 1, 1, 1),(39, 397, 1, 1, 1),(39, 398, 1, 1, 1),(39, 399, 1, 1, 1),(39, 400, 1, 1, 1),(39, 401, 1, 1, 1),(39, 402, 1, 1, 1),(39, 403, 1, 1, 1),(39, 404, 1, 1, 1),(39, 405, 1, 1, 1),(39, 406, 1, 1, 1),(39, 407, 1, 1, 1),(39, 408, 1, 1, 1),(39, 409, 1, 1, 1),(39, 410, 1, 1, 1),(39, 411, 1, 1, 1),(39, 412, 1, 1, 1),(39, 413, 1, 1, 1),(39, 414, 1, 1, 1),(39, 415, 5, 1, 1),(39, 416, 5, 1, 1),(39, 417, 5, 1, 1),(39, 418, 5, 1, 1),(39, 419, 1, 1, 1),(39, 420, 1, 1, 1),(39, 421, 1, 1, 1),(39, 422, 1, 1, 1),(39, 423, 1, 1, 1),(39, 424, 1, 1, 1),(39, 425, 1, 1, 1),(39, 426, 1, 1, 1),(39, 427, 1, 1, 1),(39, 428, 1, 1, 1),(39, 429, 1, 1, 1),(39, 430, 1, 1, 1),(39, 431, 1, 1, 1),(39, 432, 1, 1, 1),(39, 433, 1, 1, 1),(39, 434, 1, 1, 1),(39, 435, 1, 1, 1),(39, 436, 1, 1, 1),(39, 437, 1, 1, 1),(39, 438, 1, 1, 1),(39, 439, 1, 1, 1),(39, 440, 1, 1, 1),(39, 441, 1, 1, 1),(39, 442, 1, 1, 1),(39, 443, 1, 1, 1),(39, 444, 1, 1, 1),(39, 445, 1, 1, 1),(39, 446, 1, 1, 1),(39, 447, 5, 1, 1),(39, 448, 5, 1, 1),(39, 449, 5, 1, 1),(39, 450, 5, 1, 1),(39, 451, 1, 1, 1),(39, 452, 1, 1, 1),(39, 453, 1, 1, 1),(39, 454, 1, 1, 1),(39, 455, 1, 1, 1),(39, 456, 1, 1, 1),(39, 457, 1, 1, 1),(39, 458, 1, 1, 1),(39, 459, 1, 1, 1),(39, 460, 1, 1, 1),(39, 461, 1, 1, 1),(39, 462, 1, 1, 1),(39, 463, 1, 1, 1),(39, 464, 1, 1, 1),(39, 465, 1, 1, 1),(39, 466, 1, 1, 1),(39, 467, 1, 1, 1),(39, 468, 1, 1, 1),(39, 469, 1, 1, 1),(39, 470, 1, 1, 1),(39, 471, 1, 1, 1),(39, 472, 1, 1, 1),(39, 473, 1, 1, 1),(39, 474, 1, 1, 1),(39, 475, 1, 1, 1),(39, 476, 1, 1, 1),(39, 477, 1, 1, 1),(39, 478, 1, 1, 1),(39, 479, 5, 1, 1),(39, 480, 5, 1, 1),(39, 481, 5, 1, 1),(39, 482, 5, 1, 1),(39, 483, 1, 1, 1),(39, 484, 1, 1, 1),(39, 485, 1, 1, 1),(39, 486, 1, 1, 1),(39, 487, 1, 1, 1),(39, 488, 1, 1, 1),(39, 489, 1, 1, 1),(39, 490, 1, 1, 1),(39, 491, 1, 1, 1),(39, 492, 1, 1, 1),(39, 493, 1, 1, 1),(39, 494, 1, 1, 1),(39, 495, 1, 1, 1),(39, 496, 1, 1, 1),(39, 497, 1, 1, 1),(39, 498, 1, 1, 1),(39, 499, 1, 1, 1),(39, 500, 1, 1, 1),(39, 501, 1, 1, 1),(39, 502, 1, 1, 1),(39, 503, 1, 1, 1),(39, 504, 1, 1, 1),(39, 505, 1, 1, 1),(39, 506, 1, 1, 1),(39, 507, 1, 1, 1),(39, 508, 1, 1, 1),(39, 509, 1, 1, 1),(39, 510, 1, 1, 1),(39, 511, 5, 1, 1),(39, 512, 5, 1, 1),(39, 513, 5, 1, 1),(39, 514, 5, 1, 1),(39, 515, 1, 1, 1),(39, 516, 1, 1, 1),(39, 517, 1, 1, 1),(39, 518, 1, 1, 1),(39, 519, 1, 1, 1),(39, 520, 1, 1, 1),(39, 521, 1, 1, 1),(39, 522, 1, 1, 1),(39, 523, 1, 1, 1),(39, 524, 1, 1, 1),(39, 525, 1, 1, 1),(39, 526, 1, 1, 1),(39, 527, 1, 1, 1),(39, 528, 1, 1, 1),(39, 529, 1, 1, 1),(39, 530, 1, 1, 1),(39, 531, 1, 1, 1),(39, 532, 1, 1, 1),(39, 533, 1, 1, 1),(39, 534, 1, 1, 1),(39, 535, 1, 1, 1),(39, 536, 1, 1, 1),(39, 537, 1, 1, 1),(39, 538, 1, 1, 1),(39, 539, 1, 1, 1),(39, 540, 1, 1, 1),(39, 541, 1, 1, 1),(39, 542, 1, 1, 1),(39, 543, 5, 1, 1),(39, 544, 5, 1, 1),(39, 545, 5, 1, 1),(39, 546, 5, 1, 1),(39, 547, 1, 1, 1),(39, 548, 1, 1, 1),(39, 549, 1, 1, 1),(39, 550, 1, 1, 1),(39, 551, 1, 1, 1),(39, 552, 1, 1, 1),(39, 553, 1, 1, 1),(39, 554, 1, 1, 1),(39, 555, 1, 1, 1),(39, 556, 1, 1, 1),(39, 557, 1, 1, 1),(39, 558, 1, 1, 1),(39, 559, 1, 1, 1),(39, 560, 1, 1, 1),(39, 561, 1, 1, 1),(39, 562, 1, 1, 1),(39, 563, 1, 1, 1),(39, 564, 1, 1, 1),(39, 565, 1, 1, 1),(39, 566, 1, 1, 1),(39, 567, 1, 1, 1),(39, 568, 1, 1, 1),(39, 569, 1, 1, 1),(39, 570, 1, 1, 1),(39, 571, 1, 1, 1),(39, 572, 1, 1, 1),(39, 573, 1, 1, 1),(39, 574, 1, 1, 1),(39, 575, 5, 1, 1),(39, 576, 5, 1, 1),(39, 577, 5, 1, 1),(39, 578, 5, 1, 1),(39, 579, 1, 1, 1),(39, 580, 1, 1, 1),(39, 581, 1, 1, 1),(39, 582, 1, 1, 1),(39, 583, 1, 1, 1),(39, 584, 1, 1, 1),(39, 585, 1, 1, 1),(39, 586, 1, 1, 1),(39, 587, 1, 1, 1),(39, 588, 1, 1, 1),(39, 589, 1, 1, 1),(39, 590, 1, 1, 1),(39, 591, 1, 1, 1),(39, 592, 1, 1, 1),(39, 593, 1, 1, 1),(39, 594, 1, 1, 1),(39, 595, 1, 1, 1),(39, 596, 1, 1, 1),(39, 597, 1, 1, 1),(39, 598, 1, 1, 1),(39, 599, 1, 1, 1),(39, 600, 1, 1, 1),(39, 601, 1, 1, 1),(39, 602, 1, 1, 1),(39, 603, 1, 1, 1),(39, 604, 1, 1, 1),(39, 605, 1, 1, 1),(39, 606, 1, 1, 1),(39, 607, 5, 1, 1),(39, 608, 5, 1, 1),(39, 609, 5, 1, 1),(39, 610, 5, 1, 1),(39, 611, 1, 1, 1),(39, 612, 1, 1, 1),(39, 613, 1, 1, 1),(39, 614, 1, 1, 1),(39, 615, 1, 1, 1),(39, 616, 1, 1, 1),(39, 617, 1, 1, 1),(39, 618, 1, 1, 1),(39, 619, 1, 1, 1),(39, 620, 1, 1, 1),(39, 621, 1, 1, 1),(39, 622, 1, 1, 1),(39, 623, 1, 1, 1),(39, 624, 1, 1, 1),(39, 625, 1, 1, 1),(39, 626, 1, 1, 1),(39, 627, 1, 1, 1),(39, 628, 1, 1, 1),(39, 629, 1, 1, 1),(39, 630, 1, 1, 1),(39, 631, 1, 1, 1),(39, 632, 1, 1, 1),(39, 633, 1, 1, 1),(39, 634, 1, 1, 1),(39, 635, 1, 1, 1),(39, 636, 1, 1, 1),(39, 637, 1, 1, 1),(39, 638, 1, 1, 1),(39, 639, 5, 1, 1),(39, 640, 5, 1, 1),(39, 641, 5, 1, 1),(39, 642, 5, 1, 1),(39, 643, 1, 1, 1),(39, 644, 1, 1, 1),(39, 645, 1, 1, 1),(39, 646, 1, 1, 1),(39, 647, 1, 1, 1),(39, 648, 1, 1, 1),(39, 649, 1, 1, 1),(39, 650, 1, 1, 1),(39, 651, 1, 1, 1),(39, 652, 1, 1, 1),(39, 653, 1, 1, 1),(39, 654, 1, 1, 1),(39, 655, 1, 1, 1),(39, 656, 1, 1, 1),(39, 657, 1, 1, 1),(39, 658, 1, 1, 1),(39, 659, 1, 1, 1),(39, 660, 1, 1, 1),(39, 661, 1, 1, 1),(39, 662, 1, 1, 1),(39, 663, 1, 1, 1),(39, 664, 1, 1, 1),(39, 665, 1, 1, 1),(39, 666, 1, 1, 1),(39, 667, 1, 1, 1),(39, 668, 1, 1, 1),(39, 669, 1, 1, 1),(39, 670, 1, 1, 1),(39, 671, 5, 1, 1),(39, 672, 5, 1, 1),(39, 673, 5, 1, 1),(39, 674, 5, 1, 1),(39, 675, 1, 1, 1),(39, 676, 1, 1, 1),(39, 677, 1, 1, 1),(39, 678, 1, 1, 1),(39, 679, 1, 1, 1),(39, 680, 1, 1, 1),(39, 681, 1, 1, 1),(39, 682, 1, 1, 1),(39, 683, 1, 1, 1),(39, 684, 1, 1, 1),(39, 685, 1, 1, 1),(39, 686, 1, 1, 1),(39, 687, 1, 1, 1),(39, 688, 1, 1, 1),(39, 689, 1, 1, 1),(39, 690, 1, 1, 1),(39, 691, 1, 1, 1),(39, 692, 1, 1, 1),(39, 693, 1, 1, 1),(39, 694, 1, 1, 1),(39, 695, 1, 1, 1),(39, 696, 1, 1, 1),(39, 697, 1, 1, 1),(39, 698, 1, 1, 1),(39, 699, 1, 1, 1),(39, 700, 1, 1, 1),(39, 701, 1, 1, 1),(39, 702, 1, 1, 1),(39, 703, 5, 1, 1),(39, 704, 5, 1, 1),(39, 705, 5, 1, 1),(39, 706, 5, 1, 1),(39, 707, 1, 1, 1),(39, 708, 1, 1, 1),(39, 709, 1, 1, 1),(39, 710, 1, 1, 1),(39, 711, 1, 1, 1),(39, 712, 1, 1, 1),(39, 713, 1, 1, 1),(39, 714, 1, 1, 1),(39, 715, 1, 1, 1),(39, 716, 1, 1, 1),(39, 717, 1, 1, 1),(39, 718, 1, 1, 1),(39, 719, 1, 1, 1),(39, 720, 1, 1, 1),(39, 721, 1, 1, 1),(39, 722, 1, 1, 1),(39, 723, 1, 1, 1),(39, 724, 1, 1, 1),(39, 725, 1, 1, 1),(39, 726, 1, 1, 1),(39, 727, 1, 1, 1),(39, 728, 1, 1, 1),(39, 729, 1, 1, 1),(39, 730, 1, 1, 1),(39, 731, 1, 1, 1),(39, 732, 1, 1, 1),(39, 733, 1, 1, 1),(39, 734, 1, 1, 1),(39, 735, 5, 1, 1),(39, 736, 5, 1, 1),(39, 737, 5, 1, 1),(39, 738, 5, 1, 1),(39, 739, 1, 1, 1),(39, 740, 1, 1, 1),(39, 741, 1, 1, 1),(39, 742, 1, 1, 1),(39, 743, 1, 1, 1),(39, 744, 1, 1, 1),(39, 745, 1, 1, 1),(39, 746, 1, 1, 1),(39, 747, 1, 1, 1),(39, 748, 1, 1, 1),(39, 749, 1, 1, 1),(39, 750, 1, 1, 1),(39, 751, 1, 1, 1),(39, 752, 1, 1, 1),(39, 753, 1, 1, 1),(39, 754, 1, 1, 1),(39, 755, 1, 1, 1),(39, 756, 1, 1, 1),(39, 757, 1, 1, 1),(39, 758, 1, 1, 1),(39, 759, 1, 1, 1),(39, 760, 1, 1, 1),(39, 761, 1, 1, 1),(39, 762, 1, 1, 1),(39, 763, 1, 1, 1),(39, 764, 1, 1, 1),(39, 765, 1, 1, 1),(39, 766, 1, 1, 1),(39, 767, 5, 1, 1),(39, 768, 5, 1, 1),(39, 769, 5, 1, 1),(39, 770, 5, 1, 1),(39, 771, 1, 1, 1),(39, 772, 1, 1, 1),(39, 773, 1, 1, 1),(39, 774, 1, 1, 1),(39, 775, 1, 1, 1),(39, 776, 1, 1, 1),(39, 777, 1, 1, 1),(39, 778, 1, 1, 1),(39, 779, 1, 1, 1),(39, 780, 1, 1, 1),(39, 781, 1, 1, 1),(39, 782, 1, 1, 1),(39, 783, 1, 1, 1),(39, 784, 1, 1, 1),(39, 785, 1, 1, 1),(39, 786, 1, 1, 1),(39, 787, 1, 1, 1),(39, 788, 1, 1, 1),(39, 789, 1, 1, 1),(39, 790, 1, 1, 1),(39, 791, 1, 1, 1),(39, 792, 1, 1, 1),(39, 793, 1, 1, 1),(39, 794, 1, 1, 1),(39, 795, 1, 1, 1),(39, 796, 1, 1, 1),(39, 797, 1, 1, 1),(39, 798, 1, 1, 1),(39, 799, 5, 1, 1),(39, 800, 5, 1, 1),(39, 801, 5, 1, 1),(39, 802, 5, 1, 1),(39, 803, 1, 1, 1),(39, 804, 1, 1, 1),(39, 805, 1, 1, 1),(39, 806, 1, 1, 1),(39, 807, 1, 1, 1),(39, 808, 1, 1, 1),(39, 809, 1, 1, 1),(39, 810, 1, 1, 1),(39, 811, 1, 1, 1),(39, 812, 1, 1, 1),(39, 813, 1, 1, 1),(39, 814, 1, 1, 1),(39, 815, 1, 1, 1),(39, 816, 1, 1, 1),(39, 817, 1, 1, 1),(39, 818, 1, 1, 1),(39, 819, 1, 1, 1),(39, 820, 1, 1, 1),(39, 821, 1, 1, 1),(39, 822, 1, 1, 1),(39, 823, 1, 1, 1),(39, 824, 1, 1, 1),(39, 825, 1, 1, 1),(39, 826, 1, 1, 1),(39, 827, 1, 1, 1),(39, 828, 1, 1, 1),(39, 829, 1, 1, 1),(39, 830, 1, 1, 1),(39, 831, 5, 1, 1),(39, 832, 5, 1, 1),(39, 833, 5, 1, 1),(39, 834, 5, 1, 1),(39, 835, 1, 1, 1),(39, 836, 1, 1, 1),(39, 837, 1, 1, 1),(39, 838, 1, 1, 1),(39, 839, 1, 1, 1),(39, 840, 1, 1, 1),(39, 841, 1, 1, 1),(39, 842, 1, 1, 1),(39, 843, 1, 1, 1),(39, 844, 1, 1, 1),(39, 845, 1, 1, 1),(39, 846, 1, 1, 1),(39, 847, 1, 1, 1),(39, 848, 1, 1, 1),(39, 849, 1, 1, 1),(39, 850, 1, 1, 1),(39, 851, 1, 1, 1),(39, 852, 1, 1, 1),(39, 853, 1, 1, 1),(39, 854, 1, 1, 1),(39, 855, 1, 1, 1),(39, 856, 1, 1, 1),(39, 857, 1, 1, 1),(39, 858, 1, 1, 1),(39, 859, 1, 1, 1),(39, 860, 1, 1, 1),(39, 861, 1, 1, 1),(39, 862, 1, 1, 1),(39, 863, 5, 1, 1),(39, 864, 5, 1, 1),(39, 865, 5, 1, 1),(39, 866, 5, 1, 1),(39, 867, 1, 1, 1),(39, 868, 1, 1, 1),(39, 869, 1, 1, 1),(39, 870, 1, 1, 1),(39, 871, 1, 1, 1),(39, 872, 1, 1, 1),(39, 873, 1, 1, 1),(39, 874, 1, 1, 1),(39, 875, 1, 1, 1),(39, 876, 1, 1, 1),(39, 877, 1, 1, 1),(39, 878, 1, 1, 1),(39, 879, 1, 1, 1),(39, 880, 1, 1, 1),(39, 881, 1, 1, 1),(39, 882, 1, 1, 1),(39, 883, 1, 1, 1),(39, 884, 1, 1, 1),(39, 885, 1, 1, 1),(39, 886, 1, 1, 1),(39, 887, 1, 1, 1),(39, 888, 1, 1, 1),(39, 889, 1, 1, 1),(39, 890, 1, 1, 1),(39, 891, 1, 1, 1),(39, 892, 1, 1, 1),(39, 893, 1, 1, 1),(39, 894, 1, 1, 1),(39, 895, 5, 1, 1),(39, 896, 5, 1, 1),(39, 897, 5, 1, 1),(39, 898, 5, 1, 1),(39, 899, 1, 1, 1),(39, 900, 1, 1, 1),(39, 901, 1, 1, 1),(39, 902, 1, 1, 1),(39, 903, 1, 1, 1),(39, 904, 1, 1, 1),(39, 905, 1, 1, 1),(39, 906, 1, 1, 1),(39, 907, 1, 1, 1),(39, 908, 1, 1, 1),(39, 909, 1, 1, 1),(39, 910, 1, 1, 1),(39, 911, 1, 1, 1),(39, 912, 1, 1, 1),(39, 913, 1, 1, 1),(39, 914, 1, 1, 1),(39, 915, 1, 1, 1),(39, 916, 1, 1, 1),(39, 917, 1, 1, 1),(39, 918, 1, 1, 1),(39, 919, 1, 1, 1),(39, 920, 1, 1, 1),(39, 921, 1, 1, 1),(39, 922, 1, 1, 1),(39, 923, 1, 1, 1),(39, 924, 1, 1, 1),(39, 925, 1, 1, 1),(39, 926, 1, 1, 1),(39, 927, 5, 1, 1),(39, 928, 5, 1, 1),(39, 929, 5, 1, 1),(39, 930, 5, 1, 1),(39, 931, 1, 1, 1),(39, 932, 1, 1, 1),(39, 933, 1, 1, 1),(39, 934, 1, 1, 1),(39, 935, 1, 1, 1),(39, 936, 1, 1, 1),(39, 937, 1, 1, 1),(39, 938, 1, 1, 1),(39, 939, 1, 1, 1),(39, 940, 1, 1, 1),(39, 941, 1, 1, 1),(39, 942, 1, 1, 1),(39, 943, 1, 1, 1),(39, 944, 1, 1, 1),(39, 945, 1, 1, 1),(39, 946, 1, 1, 1),(39, 947, 1, 1, 1),(39, 948, 1, 1, 1),(39, 949, 1, 1, 1),(39, 950, 1, 1, 1),(39, 951, 1, 1, 1),(39, 952, 1, 1, 1),(39, 953, 1, 1, 1),(39, 954, 1, 1, 1),(39, 955, 1, 1, 1),(39, 956, 1, 1, 1),(39, 957, 1, 1, 1),(39, 958, 1, 1, 1),(39, 959, 5, 1, 1),(39, 960, 5, 1, 1),(39, 961, 5, 1, 1),(39, 962, 5, 1, 1),(39, 963, 1, 1, 1),(39, 964, 1, 1, 1),(39, 965, 1, 1, 1),(39, 966, 1, 1, 1),(39, 967, 1, 1, 1),(39, 968, 1, 1, 1),(39, 969, 1, 1, 1),(39, 970, 1, 1, 1),(39, 971, 1, 1, 1),(39, 972, 1, 1, 1),(39, 973, 1, 1, 1),(39, 974, 1, 1, 1),(39, 975, 1, 1, 1),(39, 976, 1, 1, 1),(39, 977, 1, 1, 1),(39, 978, 1, 1, 1),(39, 979, 1, 1, 1),(39, 980, 1, 1, 1),(39, 981, 1, 1, 1),(39, 982, 1, 1, 1),(39, 983, 1, 1, 1),(39, 984, 1, 1, 1),(39, 985, 1, 1, 1),(39, 986, 1, 1, 1),(39, 987, 1, 1, 1),(39, 988, 1, 1, 1),(39, 989, 1, 1, 1),(39, 990, 1, 1, 1),(39, 991, 5, 1, 1),(39, 992, 5, 1, 1),(39, 993, 5, 1, 1),(39, 994, 5, 1, 1),(39, 995, 1, 1, 1),(39, 996, 1, 1, 1),(39, 997, 1, 1, 1),(39, 998, 1, 1, 1),(39, 999, 1, 1, 1),(39, 1000, 1, 1, 1),(39, 1001, 1, 1, 1),(39, 1002, 1, 1, 1),(39, 1003, 1, 1, 1),(39, 1004, 1, 1, 1),(39, 1005, 1, 1, 1),(39, 1006, 1, 1, 1),(39, 1007, 1, 1, 1),(39, 1008, 1, 1, 1),(39, 1009, 1, 1, 1),(39, 1010, 1, 1, 1),(39, 1011, 1, 1, 1),(39, 1012, 1, 1, 1),(39, 1013, 1, 1, 1),(39, 1014, 1, 1, 1),(39, 1015, 1, 1, 1),(39, 1016, 1, 1, 1),(39, 1017, 1, 1, 1),(39, 1018, 1, 1, 1),(39, 1019, 1, 1, 1),(39, 1020, 1, 1, 1),(39, 1021, 1, 1, 1),(39, 1022, 1, 1, 1),(39, 1023, 5, 1, 1),(39, 1024, 5, 1, 1),(39, 1025, 5, 1, 1),(39, 1026, 5, 1, 1),(39, 1027, 1, 1, 1),(39, 1028, 1, 1, 1),(39, 1029, 1, 1, 1),(39, 1030, 1, 1, 1),(39, 1031, 1, 1, 1),(39, 1032, 1, 1, 1),(39, 1033, 1, 1, 1),(39, 1034, 1, 1, 1),(39, 1035, 1, 1, 1),(39, 1036, 1, 1, 1),(39, 1037, 1, 1, 1),(39, 1038, 1, 1, 1),(39, 1039, 1, 1, 1),(39, 1040, 1, 1, 1),(39, 1041, 1, 1, 1),(39, 1042, 1, 1, 1),(39, 1043, 1, 1, 1),(39, 1044, 1, 1, 1),(39, 1045, 1, 1, 1),(39, 1046, 1, 1, 1),(39, 1047, 1, 1, 1),(39, 1048, 1, 1, 1),(39, 1049, 1, 1, 1),(39, 1050, 1, 1, 1),(39, 1051, 1, 1, 1),(39, 1052, 1, 1, 1),(39, 1053, 1, 1, 1),(39, 1054, 1, 1, 1),(39, 1055, 5, 1, 1),(39, 1056, 5, 1, 1),(39, 1057, 5, 1, 1),(39, 1058, 5, 1, 1),(39, 1059, 1, 1, 1),(39, 1060, 1, 1, 1),(39, 1061, 1, 1, 1),(39, 1062, 1, 1, 1),(39, 1063, 1, 1, 1),(39, 1064, 1, 1, 1),(39, 1065, 1, 1, 1),(39, 1066, 1, 1, 1),(39, 1067, 1, 1, 1),(39, 1068, 1, 1, 1),(39, 1069, 1, 1, 1),(39, 1070, 1, 1, 1),(39, 1071, 1, 1, 1),(39, 1072, 1, 1, 1),(39, 1073, 1, 1, 1),(39, 1074, 1, 1, 1),(39, 1075, 1, 1, 1),(39, 1076, 1, 1, 1),(39, 1077, 1, 1, 1),(39, 1078, 1, 1, 1),(39, 1079, 1, 1, 1),(39, 1080, 1, 1, 1),(39, 1081, 1, 1, 1),(39, 1082, 1, 1, 1),(39, 1083, 1, 1, 1),(39, 1084, 1, 1, 1),(39, 1085, 1, 1, 1),(39, 1086, 1, 1, 1),(39, 1087, 5, 1, 1),(39, 1088, 5, 1, 1),(39, 1089, 5, 1, 1),(39, 1090, 5, 1, 1),(39, 1091, 1, 1, 1),(39, 1092, 1, 1, 1),(39, 1093, 1, 1, 1),(39, 1094, 1, 1, 1),(39, 1095, 1, 1, 1),(39, 1096, 1, 1, 1),(39, 1097, 1, 1, 1),(39, 1098, 1, 1, 1),(39, 1099, 1, 1, 1),(39, 1100, 1, 1, 1),(39, 1101, 1, 1, 1),(39, 1102, 1, 1, 1),(39, 1103, 1, 1, 1),(39, 1104, 1, 1, 1),(39, 1105, 1, 1, 1),(39, 1106, 1, 1, 1),(39, 1107, 1, 1, 1),(39, 1108, 1, 1, 1),(39, 1109, 1, 1, 1),(39, 1110, 1, 1, 1),(39, 1111, 1, 1, 1),(39, 1112, 1, 1, 1),(39, 1113, 1, 1, 1),(39, 1114, 1, 1, 1),(39, 1115, 1, 1, 1),(39, 1116, 1, 1, 1),(39, 1117, 1, 1, 1),(39, 1118, 1, 1, 1),(39, 1119, 5, 1, 1),(39, 1120, 5, 1, 1),(39, 1121, 5, 1, 1),(39, 1122, 5, 1, 1),(39, 1123, 1, 1, 1),(39, 1124, 1, 1, 1),(39, 1125, 1, 1, 1),(39, 1126, 1, 1, 1),(39, 1127, 1, 1, 1),(39, 1128, 1, 1, 1),(39, 1129, 1, 1, 1),(39, 1130, 1, 1, 1),(39, 1131, 1, 1, 1),(39, 1132, 1, 1, 1),(39, 1133, 1, 1, 1),(39, 1134, 1, 1, 1),(39, 1135, 1, 1, 1),(39, 1136, 1, 1, 1),(39, 1137, 1, 1, 1),(39, 1138, 1, 1, 1),(39, 1139, 1, 1, 1),(39, 1140, 1, 1, 1),(39, 1141, 1, 1, 1),(39, 1142, 1, 1, 1),(39, 1143, 1, 1, 1),(39, 1144, 1, 1, 1),(39, 1145, 1, 1, 1),(39, 1146, 1, 1, 1),(39, 1147, 1, 1, 1),(39, 1148, 1, 1, 1),(39, 1149, 1, 1, 1),(39, 1150, 1, 1, 1),(39, 1151, 5, 1, 1),(39, 1152, 5, 1, 1),(39, 1153, 5, 1, 1),(39, 1154, 5, 1, 1),(39, 1155, 1, 1, 1),(39, 1156, 1, 1, 1),(39, 1157, 1, 1, 1),(39, 1158, 1, 1, 1),(39, 1159, 1, 1, 1),(39, 1160, 1, 1, 1),(39, 1161, 1, 1, 1),(39, 1162, 1, 1, 1),(39, 1163, 1, 1, 1),(39, 1164, 1, 1, 1),(39, 1165, 1, 1, 1),(39, 1166, 1, 1, 1),(39, 1167, 1, 1, 1),(39, 1168, 1, 1, 1),(39, 1169, 1, 1, 1),(39, 1170, 1, 1, 1),(39, 1171, 1, 1, 1),(39, 1172, 1, 1, 1),(39, 1173, 1, 1, 1),(39, 1174, 1, 1, 1),(39, 1175, 1, 1, 1),(39, 1176, 1, 1, 1),(39, 1177, 1, 1, 1),(39, 1178, 1, 1, 1),(39, 1179, 1, 1, 1),(39, 1180, 1, 1, 1),(39, 1181, 1, 1, 1),(39, 1182, 1, 1, 1),(39, 1183, 5, 1, 1),(39, 1184, 5, 1, 1),(39, 1185, 5, 1, 1),(39, 1186, 5, 1, 1),(39, 1187, 1, 1, 1),(39, 1188, 1, 1, 1),(39, 1189, 1, 1, 1),(39, 1190, 1, 1, 1),(39, 1191, 1, 1, 1),(39, 1192, 1, 1, 1),(39, 1193, 1, 1, 1),(39, 1194, 1, 1, 1),(39, 1195, 1, 1, 1),(39, 1196, 1, 1, 1),(39, 1197, 1, 1, 1),(39, 1198, 1, 1, 1),(39, 1199, 1, 1, 1),(39, 1200, 1, 1, 1),(39, 1201, 1, 1, 1),(39, 1202, 1, 1, 1),(39, 1203, 1, 1, 1),(39, 1204, 1, 1, 1),(39, 1205, 1, 1, 1),(39, 1206, 1, 1, 1),(39, 1207, 1, 1, 1),(39, 1208, 1, 1, 1),(39, 1209, 1, 1, 1),(39, 1210, 1, 1, 1),(39, 1211, 1, 1, 1),(39, 1212, 1, 1, 1),(39, 1213, 1, 1, 1),(39, 1214, 1, 1, 1),(39, 1215, 5, 1, 1),(39, 1216, 5, 1, 1),(39, 1217, 5, 1, 1),(39, 1218, 5, 1, 1),(39, 1219, 1, 1, 1),(39, 1220, 1, 1, 1),(39, 1221, 1, 1, 1),(39, 1222, 1, 1, 1),(39, 1223, 1, 1, 1),(39, 1224, 1, 1, 1),(39, 1225, 1, 1, 1),(39, 1226, 1, 1, 1),(39, 1227, 1, 1, 1),(39, 1228, 1, 1, 1),(39, 1229, 1, 1, 1),(39, 1230, 1, 1, 1),(39, 1231, 1, 1, 1),(39, 1232, 1, 1, 1),(39, 1233, 1, 1, 1),(39, 1234, 1, 1, 1),(39, 1235, 1, 1, 1),(39, 1236, 1, 1, 1),(39, 1237, 1, 1, 1),(39, 1238, 1, 1, 1),(39, 1239, 1, 1, 1),(39, 1240, 1, 1, 1),(39, 1241, 1, 1, 1),(39, 1242, 1, 1, 1),(39, 1243, 1, 1, 1),(39, 1244, 1, 1, 1),(39, 1245, 1, 1, 1),(39, 1246, 1, 1, 1),(39, 1247, 5, 1, 1),(39, 1248, 5, 1, 1),(39, 1249, 5, 1, 1),(39, 1250, 5, 1, 1),(39, 1251, 1, 1, 1),(39, 1252, 1, 1, 1),(39, 1253, 1, 1, 1),(39, 1254, 1, 1, 1),(39, 1255, 1, 1, 1),(39, 1256, 1, 1, 1),(39, 1257, 1, 1, 1),(39, 1258, 1, 1, 1),(39, 1259, 1, 1, 1),(39, 1260, 1, 1, 1),(39, 1261, 1, 1, 1),(39, 1262, 1, 1, 1),(39, 1263, 1, 1, 1),(39, 1264, 1, 1, 1),(39, 1265, 1, 1, 1),(39, 1266, 1, 1, 1),(39, 1267, 1, 1, 1),(39, 1268, 1, 1, 1),(39, 1269, 1, 1, 1),(39, 1270, 1, 1, 1),(39, 1271, 1, 1, 1),(39, 1272, 1, 1, 1),(39, 1273, 1, 1, 1),(39, 1274, 1, 1, 1),(39, 1275, 1, 1, 1),(39, 1276, 1, 1, 1),(39, 1277, 1, 1, 1),(39, 1278, 1, 1, 1),(39, 1279, 5, 1, 1),(39, 1280, 5, 1, 1),(39, 1281, 5, 1, 1),(39, 1282, 5, 1, 1),(39, 1283, 1, 1, 1),(39, 1284, 1, 1, 1),(39, 1285, 1, 1, 1),(39, 1286, 1, 1, 1),(39, 1287, 1, 1, 1),(39, 1288, 1, 1, 1),(39, 1289, 1, 1, 1),(39, 1290, 1, 1, 1),(39, 1291, 1, 1, 1),(39, 1292, 1, 1, 1),(39, 1293, 1, 1, 1),(39, 1294, 1, 1, 1),(39, 1295, 1, 1, 1),(39, 1296, 1, 1, 1),(39, 1297, 1, 1, 1),(39, 1298, 1, 1, 1),(39, 1299, 1, 1, 1),(39, 1300, 1, 1, 1),(39, 1301, 1, 1, 1),(39, 1302, 1, 1, 1),(39, 1303, 1, 1, 1),(39, 1304, 1, 1, 1),(39, 1305, 1, 1, 1),(39, 1306, 1, 1, 1),(39, 1307, 1, 1, 1),(39, 1308, 1, 1, 1),(39, 1309, 1, 1, 1),(39, 1310, 1, 1, 1),(39, 1311, 5, 1, 1),(39, 1312, 5, 1, 1),(39, 1313, 5, 1, 1),(39, 1314, 5, 1, 1),(39, 1315, 1, 1, 1),(39, 1316, 1, 1, 1),(39, 1317, 1, 1, 1),(39, 1318, 1, 1, 1),(39, 1319, 1, 1, 1),(39, 1320, 1, 1, 1),(39, 1321, 1, 1, 1),(39, 1322, 1, 1, 1),(39, 1323, 1, 1, 1),(39, 1324, 1, 1, 1),(39, 1325, 1, 1, 1),(39, 1326, 1, 1, 1),(39, 1327, 1, 1, 1),(39, 1328, 1, 1, 1),(39, 1329, 1, 1, 1),(39, 1330, 1, 1, 1),(39, 1331, 1, 1, 1),(39, 1332, 1, 1, 1),(39, 1333, 1, 1, 1),(39, 1334, 1, 1, 1),(39, 1335, 1, 1, 1),(39, 1336, 1, 1, 1),(39, 1337, 1, 1, 1),(39, 1338, 1, 1, 1),(39, 1339, 1, 1, 1),(39, 1340, 1, 1, 1),(39, 1341, 1, 1, 1),(39, 1342, 1, 1, 1),(39, 1343, 5, 1, 1),(39, 1344, 5, 1, 1),(39, 1345, 5, 1, 1),(39, 1346, 5, 1, 1),(39, 1347, 1, 1, 1),(39, 1348, 1, 1, 1),(39, 1349, 1, 1, 1),(39, 1350, 1, 1, 1),(39, 1351, 1, 1, 1),(39, 1352, 1, 1, 1),(39, 1353, 1, 1, 1),(39, 1354, 1, 1, 1),(39, 1355, 1, 1, 1),(39, 1356, 1, 1, 1),(39, 1357, 1, 1, 1),(39, 1358, 1, 1, 1),(39, 1359, 1, 1, 1),(39, 1360, 1, 1, 1),(39, 1361, 1, 1, 1),(39, 1362, 1, 1, 1),(39, 1363, 1, 1, 1),(39, 1364, 1, 1, 1),(39, 1365, 1, 1, 1),(39, 1366, 1, 1, 1),(39, 1367, 1, 1, 1),(39, 1368, 1, 1, 1),(39, 1369, 1, 1, 1),(39, 1370, 1, 1, 1),(39, 1371, 1, 1, 1),(39, 1372, 1, 1, 1),(39, 1373, 1, 1, 1),(39, 1374, 1, 1, 1),(39, 1375, 5, 1, 1),(39, 1376, 5, 1, 1),(39, 1377, 5, 1, 1),(39, 1378, 5, 1, 1),(39, 1379, 1, 1, 1),(39, 1380, 1, 1, 1),(39, 1381, 1, 1, 1),(39, 1382, 1, 1, 1),(39, 1383, 1, 1, 1),(39, 1384, 1, 1, 1),(39, 1385, 1, 1, 1),(39, 1386, 1, 1, 1),(39, 1387, 1, 1, 1),(39, 1388, 1, 1, 1),(39, 1389, 1, 1, 1),(39, 1390, 1, 1, 1),(39, 1391, 1, 1, 1),(39, 1392, 1, 1, 1),(39, 1393, 1, 1, 1),(39, 1394, 1, 1, 1),(39, 1395, 1, 1, 1),(39, 1396, 1, 1, 1),(39, 1397, 1, 1, 1),(39, 1398, 1, 1, 1),(39, 1399, 1, 1, 1),(39, 1400, 1, 1, 1),(39, 1401, 1, 1, 1),(39, 1402, 1, 1, 1),(39, 1403, 1, 1, 1),(39, 1404, 1, 1, 1),(39, 1405, 1, 1, 1),(39, 1406, 1, 1, 1),(39, 1407, 5, 1, 1),(39, 1408, 5, 1, 1),(39, 1409, 5, 1, 1),(39, 1410, 5, 1, 1),(39, 1411, 1, 1, 1),(39, 1412, 1, 1, 1),(39, 1413, 1, 1, 1),(39, 1414, 1, 1, 1),(39, 1415, 1, 1, 1),(39, 1416, 1, 1, 1),(39, 1417, 1, 1, 1),(39, 1418, 1, 1, 1),(39, 1419, 1, 1, 1),(39, 1420, 1, 1, 1),(39, 1421, 1, 1, 1),(39, 1422, 1, 1, 1),(39, 1423, 1, 1, 1),(39, 1424, 1, 1, 1),(39, 1425, 2, 1, 1),(39, 1426, 2, 1, 1),(39, 1427, 2, 1, 1),(39, 1428, 2, 1, 1),(39, 1429, 2, 1, 1),(39, 1430, 2, 1, 1),(39, 1431, 2, 1, 1),(39, 1432, 2, 1, 1),(39, 1433, 3, 1, 1),(39, 1434, 3, 1, 1),(39, 1435, 3, 1, 1),(39, 1436, 3, 1, 1),(39, 1437, 4, 1, 1),(39, 1438, 4, 1, 1),(39, 1439, 5, 1, 1),(39, 1440, 5, 1, 1),(39, 1441, 5, 1, 1),(39, 1442, 5, 1, 1),(39, 1443, 1, 1, 1),(39, 1444, 1, 1, 1),(39, 1445, 1, 1, 1),(39, 1446, 1, 1, 1),(39, 1447, 1, 1, 1),(39, 1448, 1, 1, 1),(39, 1449, 1, 1, 1),(39, 1450, 1, 1, 1),(39, 1451, 1, 1, 1),(39, 1452, 1, 1, 1),(39, 1453, 1, 1, 1),(39, 1454, 1, 1, 1),(39, 1455, 1, 1, 1),(39, 1456, 1, 1, 1),(39, 1457, 2, 1, 1),(39, 1458, 2, 1, 1),(39, 1459, 2, 1, 1),(39, 1460, 2, 1, 1),(39, 1461, 2, 1, 1),(39, 1462, 2, 1, 1),(39, 1463, 2, 1, 1),(39, 1464, 2, 1, 1),(39, 1465, 3, 1, 1),(39, 1466, 3, 1, 1),(39, 1467, 3, 1, 1),(39, 1468, 3, 1, 1),(39, 1469, 4, 1, 1),(39, 1470, 4, 1, 1),(39, 1471, 5, 1, 1),(39, 1472, 5, 1, 1),(39, 1473, 5, 1, 1),(39, 1474, 5, 1, 1),(39, 1475, 5, 1, 1),(39, 1476, 5, 1, 1),(39, 1477, 5, 1, 1),(39, 1478, 5, 1, 1),(39, 1479, 5, 1, 1),(39, 1480, 5, 1, 1),(39, 1481, 5, 1, 1),(39, 1482, 5, 1, 1),(39, 1483, 5, 1, 1),(39, 1484, 5, 1, 1),(39, 1485, 5, 1, 1),(39, 1486, 5, 1, 1),(39, 1487, 5, 1, 1),(39, 1488, 5, 1, 1),(39, 1489, 5, 1, 1),(39, 1490, 5, 1, 1),(39, 1491, 5, 1, 1),(39, 1492, 5, 1, 1),(39, 1493, 5, 1, 1),(39, 1494, 5, 1, 1),(39, 1495, 5, 1, 1),(39, 1496, 5, 1, 1),(39, 1497, 5, 1, 1),(39, 1498, 5, 1, 1),(39, 1499, 5, 1, 1),(39, 1500, 5, 1, 1),(39, 1501, 5, 1, 1),(39, 1502, 5, 1, 1),(39, 1503, 5, 1, 1),(39, 1504, 5, 1, 1),(39, 1505, 5, 1, 1),(39, 1506, 5, 1, 1),(39, 1507, 5, 1, 1),(39, 1508, 5, 1, 1),(39, 1509, 5, 1, 1),(39, 1510, 5, 1, 1),(39, 1511, 5, 1, 1),(39, 1512, 5, 1, 1),(39, 1513, 5, 1, 1),(39, 1514, 5, 1, 1),(39, 1515, 5, 1, 1),(39, 1516, 5, 1, 1),(39, 1517, 5, 1, 1),(39, 1518, 5, 1, 1),(39, 1519, 5, 1, 1),(39, 1520, 5, 1, 1),(39, 1521, 5, 1, 1),(39, 1522, 5, 1, 1),(39, 1523, 5, 1, 1),(39, 1524, 5, 1, 1),(39, 1525, 5, 1, 1),(39, 1526, 5, 1, 1),(39, 1527, 5, 1, 1),(39, 1528, 5, 1, 1),(39, 1529, 5, 1, 1),(39, 1530, 5, 1, 1),(39, 1531, 5, 1, 1),(39, 1532, 5, 1, 1),(39, 1533, 5, 1, 1),(39, 1534, 5, 1, 1),(39, 1535, 5, 1, 1),(39, 1536, 5, 1, 1),(40, 1, 5, 1, 1),(40, 2, 5, 1, 1),(40, 3, 5, 1, 1),(40, 4, 5, 1, 1),(40, 5, 5, 1, 1),(40, 6, 5, 1, 1),(40, 7, 5, 1, 1),(40, 8, 5, 1, 1),(40, 9, 5, 1, 1),(40, 10, 5, 1, 1),(40, 11, 5, 1, 1),(40, 12, 5, 1, 1),(40, 13, 5, 1, 1),(40, 14, 5, 1, 1),(40, 15, 5, 1, 1),(40, 16, 5, 1, 1),(40, 17, 5, 1, 1),(40, 18, 5, 1, 1),(40, 19, 5, 1, 1),(40, 20, 5, 1, 1),(40, 21, 5, 1, 1),(40, 22, 5, 1, 1),(40, 23, 5, 1, 1),(40, 24, 5, 1, 1),(40, 25, 5, 1, 1),(40, 26, 5, 1, 1),(40, 27, 5, 1, 1),(40, 28, 5, 1, 1),(40, 29, 5, 1, 1),(40, 30, 5, 1, 1),(40, 31, 5, 1, 1),(40, 32, 5, 1, 1),(40, 33, 5, 1, 1),(40, 34, 5, 1, 1),(40, 35, 5, 1, 1),(40, 36, 5, 1, 1),(40, 37, 5, 1, 1),(40, 38, 5, 1, 1),(40, 39, 5, 1, 1),(40, 40, 5, 1, 1),(40, 41, 5, 1, 1),(40, 42, 5, 1, 1),(40, 43, 5, 1, 1),(40, 44, 5, 1, 1),(40, 45, 5, 1, 1),(40, 46, 5, 1, 1),(40, 47, 5, 1, 1),(40, 48, 5, 1, 1),(40, 49, 5, 1, 1),(40, 50, 5, 1, 1),(40, 51, 5, 1, 1),(40, 52, 5, 1, 1),(40, 53, 5, 1, 1),(40, 54, 5, 1, 1),(40, 55, 5, 1, 1),(40, 56, 5, 1, 1),(40, 57, 5, 1, 1),(40, 58, 5, 1, 1),(40, 59, 5, 1, 1),(40, 60, 5, 1, 1),(40, 61, 5, 1, 1),(40, 62, 5, 1, 1),(40, 63, 5, 1, 1),(40, 64, 5, 1, 1),(40, 65, 5, 1, 1),(40, 66, 5, 1, 1),(40, 67, 1, 1, 1),(40, 68, 1, 1, 1),(40, 69, 1, 1, 1),(40, 70, 1, 1, 1),(40, 71, 1, 1, 1),(40, 72, 1, 1, 1),(40, 73, 1, 1, 1),(40, 74, 1, 1, 1),(40, 75, 1, 1, 1),(40, 76, 1, 1, 1),(40, 77, 1, 1, 1),(40, 78, 1, 1, 1),(40, 79, 1, 1, 1),(40, 80, 1, 1, 1),(40, 81, 1, 1, 1),(40, 82, 1, 1, 1),(40, 83, 1, 1, 1),(40, 84, 1, 1, 1),(40, 85, 1, 1, 1),(40, 86, 1, 1, 1),(40, 87, 1, 1, 1),(40, 88, 1, 1, 1),(40, 89, 1, 1, 1),(40, 90, 1, 1, 1),(40, 91, 1, 1, 1),(40, 92, 1, 1, 1),(40, 93, 1, 1, 1),(40, 94, 1, 1, 1),(40, 95, 5, 1, 1),(40, 96, 5, 1, 1),(40, 97, 5, 1, 1),(40, 98, 5, 1, 1),(40, 99, 1, 1, 1),(40, 100, 1, 1, 1),(40, 101, 1, 1, 1),(40, 102, 1, 1, 1),(40, 103, 1, 1, 1),(40, 104, 1, 1, 1),(40, 105, 1, 1, 1),(40, 106, 1, 1, 1),(40, 107, 1, 1, 1),(40, 108, 1, 1, 1),(40, 109, 1, 1, 1),(40, 110, 1, 1, 1),(40, 111, 1, 1, 1),(40, 112, 1, 1, 1),(40, 113, 1, 1, 1),(40, 114, 1, 1, 1),(40, 115, 1, 1, 1),(40, 116, 1, 1, 1),(40, 117, 1, 1, 1),(40, 118, 1, 1, 1),(40, 119, 1, 1, 1),(40, 120, 1, 1, 1),(40, 121, 1, 1, 1),(40, 122, 1, 1, 1),(40, 123, 1, 1, 1),(40, 124, 1, 1, 1),(40, 125, 1, 1, 1),(40, 126, 1, 1, 1),(40, 127, 5, 1, 1),(40, 128, 5, 1, 1),(40, 129, 5, 1, 1),(40, 130, 5, 1, 1),(40, 131, 1, 1, 1),(40, 132, 1, 1, 1),(40, 133, 1, 1, 1),(40, 134, 1, 1, 1),(40, 135, 1, 1, 1),(40, 136, 1, 1, 1),(40, 137, 1, 1, 1),(40, 138, 1, 1, 1),(40, 139, 1, 1, 1),(40, 140, 1, 1, 1),(40, 141, 1, 1, 1),(40, 142, 1, 1, 1),(40, 143, 1, 1, 1),(40, 144, 1, 1, 1),(40, 145, 1, 1, 1),(40, 146, 1, 1, 1),(40, 147, 1, 1, 1),(40, 148, 1, 1, 1),(40, 149, 1, 1, 1),(40, 150, 1, 1, 1),(40, 151, 1, 1, 1),(40, 152, 1, 1, 1),(40, 153, 1, 1, 1),(40, 154, 1, 1, 1),(40, 155, 1, 1, 1),(40, 156, 1, 1, 1),(40, 157, 1, 1, 1),(40, 158, 1, 1, 1),(40, 159, 5, 1, 1),(40, 160, 5, 1, 1),(40, 161, 5, 1, 1),(40, 162, 5, 1, 1),(40, 163, 1, 1, 1),(40, 164, 1, 1, 1),(40, 165, 1, 1, 1),(40, 166, 1, 1, 1),(40, 167, 1, 1, 1),(40, 168, 1, 1, 1),(40, 169, 1, 1, 1),(40, 170, 1, 1, 1),(40, 171, 1, 1, 1),(40, 172, 1, 1, 1),(40, 173, 1, 1, 1),(40, 174, 1, 1, 1),(40, 175, 1, 1, 1),(40, 176, 1, 1, 1),(40, 177, 1, 1, 1),(40, 178, 1, 1, 1),(40, 179, 1, 1, 1),(40, 180, 1, 1, 1),(40, 181, 1, 1, 1),(40, 182, 1, 1, 1),(40, 183, 1, 1, 1),(40, 184, 1, 1, 1),(40, 185, 1, 1, 1),(40, 186, 1, 1, 1),(40, 187, 1, 1, 1),(40, 188, 1, 1, 1),(40, 189, 1, 1, 1),(40, 190, 1, 1, 1),(40, 191, 5, 1, 1),(40, 192, 5, 1, 1),(40, 193, 5, 1, 1),(40, 194, 5, 1, 1),(40, 195, 1, 1, 1),(40, 196, 1, 1, 1),(40, 197, 1, 1, 1),(40, 198, 1, 1, 1),(40, 199, 1, 1, 1),(40, 200, 1, 1, 1),(40, 201, 1, 1, 1),(40, 202, 1, 1, 1),(40, 203, 1, 1, 1),(40, 204, 1, 1, 1),(40, 205, 1, 1, 1),(40, 206, 1, 1, 1),(40, 207, 1, 1, 1),(40, 208, 1, 1, 1),(40, 209, 1, 1, 1),(40, 210, 1, 1, 1),(40, 211, 1, 1, 1),(40, 212, 1, 1, 1),(40, 213, 1, 1, 1),(40, 214, 1, 1, 1),(40, 215, 1, 1, 1),(40, 216, 1, 1, 1),(40, 217, 1, 1, 1),(40, 218, 1, 1, 1),(40, 219, 1, 1, 1),(40, 220, 1, 1, 1),(40, 221, 1, 1, 1),(40, 222, 1, 1, 1),(40, 223, 5, 1, 1),(40, 224, 5, 1, 1),(40, 225, 5, 1, 1),(40, 226, 5, 1, 1),(40, 227, 1, 1, 1),(40, 228, 1, 1, 1),(40, 229, 1, 1, 1),(40, 230, 1, 1, 1),(40, 231, 1, 1, 1),(40, 232, 1, 1, 1),(40, 233, 1, 1, 1),(40, 234, 1, 1, 1),(40, 235, 1, 1, 1),(40, 236, 1, 1, 1),(40, 237, 1, 1, 1),(40, 238, 1, 1, 1),(40, 239, 1, 1, 1),(40, 240, 1, 1, 1),(40, 241, 1, 1, 1),(40, 242, 1, 1, 1),(40, 243, 1, 1, 1),(40, 244, 1, 1, 1),(40, 245, 1, 1, 1),(40, 246, 1, 1, 1),(40, 247, 1, 1, 1),(40, 248, 1, 1, 1),(40, 249, 1, 1, 1),(40, 250, 1, 1, 1),(40, 251, 1, 1, 1),(40, 252, 1, 1, 1),(40, 253, 1, 1, 1),(40, 254, 1, 1, 1),(40, 255, 5, 1, 1),(40, 256, 5, 1, 1),(40, 257, 5, 1, 1),(40, 258, 5, 1, 1),(40, 259, 1, 1, 1),(40, 260, 1, 1, 1),(40, 261, 1, 1, 1),(40, 262, 1, 1, 1),(40, 263, 1, 1, 1),(40, 264, 1, 1, 1),(40, 265, 1, 1, 1),(40, 266, 1, 1, 1),(40, 267, 1, 1, 1),(40, 268, 1, 1, 1),(40, 269, 1, 1, 1),(40, 270, 1, 1, 1),(40, 271, 1, 1, 1),(40, 272, 1, 1, 1),(40, 273, 1, 1, 1),(40, 274, 1, 1, 1),(40, 275, 1, 1, 1),(40, 276, 1, 1, 1),(40, 277, 1, 1, 1),(40, 278, 1, 1, 1),(40, 279, 1, 1, 1),(40, 280, 1, 1, 1),(40, 281, 1, 1, 1),(40, 282, 1, 1, 1),(40, 283, 1, 1, 1),(40, 284, 1, 1, 1),(40, 285, 1, 1, 1),(40, 286, 1, 1, 1),(40, 287, 5, 1, 1),(40, 288, 5, 1, 1),(40, 289, 5, 1, 1),(40, 290, 5, 1, 1),(40, 291, 1, 1, 1),(40, 292, 1, 1, 1),(40, 293, 1, 1, 1),(40, 294, 1, 1, 1),(40, 295, 1, 1, 1),(40, 296, 1, 1, 1),(40, 297, 1, 1, 1),(40, 298, 1, 1, 1),(40, 299, 1, 1, 1),(40, 300, 1, 1, 1),(40, 301, 1, 1, 1),(40, 302, 1, 1, 1),(40, 303, 1, 1, 1),(40, 304, 1, 1, 1),(40, 305, 1, 1, 1),(40, 306, 1, 1, 1),(40, 307, 1, 1, 1),(40, 308, 1, 1, 1),(40, 309, 1, 1, 1),(40, 310, 1, 1, 1),(40, 311, 1, 1, 1),(40, 312, 1, 1, 1),(40, 313, 1, 1, 1),(40, 314, 1, 1, 1),(40, 315, 1, 1, 1),(40, 316, 1, 1, 1),(40, 317, 1, 1, 1),(40, 318, 1, 1, 1),(40, 319, 5, 1, 1),(40, 320, 5, 1, 1),(40, 321, 5, 1, 1),(40, 322, 5, 1, 1),(40, 323, 1, 1, 1),(40, 324, 1, 1, 1),(40, 325, 1, 1, 1),(40, 326, 1, 1, 1),(40, 327, 1, 1, 1),(40, 328, 1, 1, 1),(40, 329, 1, 1, 1),(40, 330, 1, 1, 1),(40, 331, 1, 1, 1),(40, 332, 1, 1, 1),(40, 333, 1, 1, 1),(40, 334, 1, 1, 1),(40, 335, 1, 1, 1),(40, 336, 1, 1, 1),(40, 337, 1, 1, 1),(40, 338, 1, 1, 1),(40, 339, 1, 1, 1),(40, 340, 1, 1, 1),(40, 341, 1, 1, 1),(40, 342, 1, 1, 1),(40, 343, 1, 1, 1),(40, 344, 1, 1, 1),(40, 345, 1, 1, 1),(40, 346, 1, 1, 1),(40, 347, 1, 1, 1),(40, 348, 1, 1, 1),(40, 349, 1, 1, 1),(40, 350, 1, 1, 1),(40, 351, 5, 1, 1),(40, 352, 5, 1, 1),(40, 353, 5, 1, 1),(40, 354, 5, 1, 1),(40, 355, 1, 1, 1),(40, 356, 1, 1, 1),(40, 357, 1, 1, 1),(40, 358, 1, 1, 1),(40, 359, 1, 1, 1),(40, 360, 1, 1, 1),(40, 361, 1, 1, 1),(40, 362, 1, 1, 1),(40, 363, 1, 1, 1),(40, 364, 1, 1, 1),(40, 365, 1, 1, 1),(40, 366, 1, 1, 1),(40, 367, 1, 1, 1),(40, 368, 1, 1, 1),(40, 369, 1, 1, 1),(40, 370, 1, 1, 1),(40, 371, 1, 1, 1),(40, 372, 1, 1, 1),(40, 373, 1, 1, 1),(40, 374, 1, 1, 1),(40, 375, 1, 1, 1),(40, 376, 1, 1, 1),(40, 377, 1, 1, 1),(40, 378, 1, 1, 1),(40, 379, 1, 1, 1),(40, 380, 1, 1, 1),(40, 381, 1, 1, 1),(40, 382, 1, 1, 1),(40, 383, 5, 1, 1),(40, 384, 5, 1, 1),(40, 385, 5, 1, 1),(40, 386, 5, 1, 1),(40, 387, 1, 1, 1),(40, 388, 1, 1, 1),(40, 389, 1, 1, 1),(40, 390, 1, 1, 1),(40, 391, 1, 1, 1),(40, 392, 1, 1, 1),(40, 393, 1, 1, 1),(40, 394, 1, 1, 1),(40, 395, 1, 1, 1),(40, 396, 1, 1, 1),(40, 397, 1, 1, 1),(40, 398, 1, 1, 1),(40, 399, 1, 1, 1),(40, 400, 1, 1, 1),(40, 401, 1, 1, 1),(40, 402, 1, 1, 1),(40, 403, 1, 1, 1),(40, 404, 1, 1, 1),(40, 405, 1, 1, 1),(40, 406, 1, 1, 1),(40, 407, 1, 1, 1),(40, 408, 1, 1, 1),(40, 409, 1, 1, 1),(40, 410, 1, 1, 1),(40, 411, 1, 1, 1),(40, 412, 1, 1, 1),(40, 413, 1, 1, 1),(40, 414, 1, 1, 1),(40, 415, 5, 1, 1),(40, 416, 5, 1, 1),(40, 417, 5, 1, 1),(40, 418, 5, 1, 1),(40, 419, 1, 1, 1),(40, 420, 1, 1, 1),(40, 421, 1, 1, 1),(40, 422, 1, 1, 1),(40, 423, 1, 1, 1),(40, 424, 1, 1, 1),(40, 425, 1, 1, 1),(40, 426, 1, 1, 1),(40, 427, 1, 1, 1),(40, 428, 1, 1, 1),(40, 429, 1, 1, 1),(40, 430, 1, 1, 1),(40, 431, 1, 1, 1),(40, 432, 1, 1, 1),(40, 433, 1, 1, 1),(40, 434, 1, 1, 1),(40, 435, 1, 1, 1),(40, 436, 1, 1, 1),(40, 437, 1, 1, 1),(40, 438, 1, 1, 1),(40, 439, 1, 1, 1),(40, 440, 1, 1, 1),(40, 441, 1, 1, 1),(40, 442, 1, 1, 1),(40, 443, 1, 1, 1),(40, 444, 1, 1, 1),(40, 445, 1, 1, 1),(40, 446, 1, 1, 1),(40, 447, 5, 1, 1),(40, 448, 5, 1, 1),(40, 449, 5, 1, 1),(40, 450, 5, 1, 1),(40, 451, 1, 1, 1),(40, 452, 1, 1, 1),(40, 453, 1, 1, 1),(40, 454, 1, 1, 1),(40, 455, 1, 1, 1),(40, 456, 1, 1, 1),(40, 457, 1, 1, 1),(40, 458, 1, 1, 1),(40, 459, 1, 1, 1),(40, 460, 1, 1, 1),(40, 461, 1, 1, 1),(40, 462, 1, 1, 1),(40, 463, 1, 1, 1),(40, 464, 1, 1, 1),(40, 465, 1, 1, 1),(40, 466, 1, 1, 1),(40, 467, 1, 1, 1),(40, 468, 1, 1, 1),(40, 469, 1, 1, 1),(40, 470, 1, 1, 1),(40, 471, 1, 1, 1),(40, 472, 1, 1, 1),(40, 473, 1, 1, 1),(40, 474, 1, 1, 1),(40, 475, 1, 1, 1),(40, 476, 1, 1, 1),(40, 477, 1, 1, 1),(40, 478, 1, 1, 1),(40, 479, 5, 1, 1),(40, 480, 5, 1, 1),(40, 481, 5, 1, 1),(40, 482, 5, 1, 1),(40, 483, 1, 1, 1),(40, 484, 1, 1, 1),(40, 485, 1, 1, 1),(40, 486, 1, 1, 1),(40, 487, 1, 1, 1),(40, 488, 1, 1, 1),(40, 489, 1, 1, 1),(40, 490, 1, 1, 1),(40, 491, 1, 1, 1),(40, 492, 1, 1, 1),(40, 493, 1, 1, 1),(40, 494, 1, 1, 1),(40, 495, 1, 1, 1),(40, 496, 1, 1, 1),(40, 497, 1, 1, 1),(40, 498, 1, 1, 1),(40, 499, 1, 1, 1),(40, 500, 1, 1, 1),(40, 501, 1, 1, 1),(40, 502, 1, 1, 1),(40, 503, 1, 1, 1),(40, 504, 1, 1, 1),(40, 505, 1, 1, 1),(40, 506, 1, 1, 1),(40, 507, 1, 1, 1),(40, 508, 1, 1, 1),(40, 509, 1, 1, 1),(40, 510, 1, 1, 1),(40, 511, 5, 1, 1),(40, 512, 5, 1, 1),(40, 513, 5, 1, 1),(40, 514, 5, 1, 1),(40, 515, 1, 1, 1),(40, 516, 1, 1, 1),(40, 517, 1, 1, 1),(40, 518, 1, 1, 1),(40, 519, 1, 1, 1),(40, 520, 1, 1, 1),(40, 521, 1, 1, 1),(40, 522, 1, 1, 1),(40, 523, 1, 1, 1),(40, 524, 1, 1, 1),(40, 525, 1, 1, 1),(40, 526, 1, 1, 1),(40, 527, 1, 1, 1),(40, 528, 1, 1, 1),(40, 529, 1, 1, 1),(40, 530, 1, 1, 1),(40, 531, 1, 1, 1),(40, 532, 1, 1, 1),(40, 533, 1, 1, 1),(40, 534, 1, 1, 1),(40, 535, 1, 1, 1),(40, 536, 1, 1, 1),(40, 537, 1, 1, 1),(40, 538, 1, 1, 1),(40, 539, 1, 1, 1),(40, 540, 1, 1, 1),(40, 541, 1, 1, 1),(40, 542, 1, 1, 1),(40, 543, 5, 1, 1),(40, 544, 5, 1, 1),(40, 545, 5, 1, 1),(40, 546, 5, 1, 1),(40, 547, 1, 1, 1),(40, 548, 1, 1, 1),(40, 549, 1, 1, 1),(40, 550, 1, 1, 1),(40, 551, 1, 1, 1),(40, 552, 1, 1, 1),(40, 553, 1, 1, 1),(40, 554, 1, 1, 1),(40, 555, 1, 1, 1),(40, 556, 1, 1, 1),(40, 557, 1, 1, 1),(40, 558, 1, 1, 1),(40, 559, 1, 1, 1),(40, 560, 1, 1, 1),(40, 561, 1, 1, 1),(40, 562, 1, 1, 1),(40, 563, 1, 1, 1),(40, 564, 1, 1, 1),(40, 565, 1, 1, 1),(40, 566, 1, 1, 1),(40, 567, 1, 1, 1),(40, 568, 1, 1, 1),(40, 569, 1, 1, 1),(40, 570, 1, 1, 1),(40, 571, 1, 1, 1),(40, 572, 1, 1, 1),(40, 573, 1, 1, 1),(40, 574, 1, 1, 1),(40, 575, 5, 1, 1),(40, 576, 5, 1, 1),(40, 577, 5, 1, 1),(40, 578, 5, 1, 1),(40, 579, 1, 1, 1),(40, 580, 1, 1, 1),(40, 581, 1, 1, 1),(40, 582, 1, 1, 1),(40, 583, 1, 1, 1),(40, 584, 1, 1, 1),(40, 585, 1, 1, 1),(40, 586, 1, 1, 1),(40, 587, 1, 1, 1),(40, 588, 1, 1, 1),(40, 589, 1, 1, 1),(40, 590, 1, 1, 1),(40, 591, 1, 1, 1),(40, 592, 1, 1, 1),(40, 593, 1, 1, 1),(40, 594, 1, 1, 1),(40, 595, 1, 1, 1),(40, 596, 1, 1, 1),(40, 597, 1, 1, 1),(40, 598, 1, 1, 1),(40, 599, 1, 1, 1),(40, 600, 1, 1, 1),(40, 601, 1, 1, 1),(40, 602, 1, 1, 1),(40, 603, 1, 1, 1),(40, 604, 1, 1, 1),(40, 605, 1, 1, 1),(40, 606, 1, 1, 1),(40, 607, 5, 1, 1),(40, 608, 5, 1, 1),(40, 609, 5, 1, 1),(40, 610, 5, 1, 1),(40, 611, 1, 1, 1),(40, 612, 1, 1, 1),(40, 613, 1, 1, 1),(40, 614, 1, 1, 1),(40, 615, 1, 1, 1),(40, 616, 1, 1, 1),(40, 617, 1, 1, 1),(40, 618, 1, 1, 1),(40, 619, 1, 1, 1),(40, 620, 1, 1, 1),(40, 621, 1, 1, 1),(40, 622, 1, 1, 1),(40, 623, 1, 1, 1),(40, 624, 1, 1, 1),(40, 625, 1, 1, 1),(40, 626, 1, 1, 1),(40, 627, 1, 1, 1),(40, 628, 1, 1, 1),(40, 629, 1, 1, 1),(40, 630, 1, 1, 1),(40, 631, 1, 1, 1),(40, 632, 1, 1, 1),(40, 633, 1, 1, 1),(40, 634, 1, 1, 1),(40, 635, 1, 1, 1),(40, 636, 1, 1, 1),(40, 637, 1, 1, 1),(40, 638, 1, 1, 1),(40, 639, 5, 1, 1),(40, 640, 5, 1, 1),(40, 641, 5, 1, 1),(40, 642, 5, 1, 1),(40, 643, 1, 1, 1),(40, 644, 1, 1, 1),(40, 645, 1, 1, 1),(40, 646, 1, 1, 1),(40, 647, 1, 1, 1),(40, 648, 1, 1, 1),(40, 649, 1, 1, 1),(40, 650, 1, 1, 1),(40, 651, 1, 1, 1),(40, 652, 1, 1, 1),(40, 653, 1, 1, 1),(40, 654, 1, 1, 1),(40, 655, 1, 1, 1),(40, 656, 1, 1, 1),(40, 657, 1, 1, 1),(40, 658, 1, 1, 1),(40, 659, 1, 1, 1),(40, 660, 1, 1, 1),(40, 661, 1, 1, 1),(40, 662, 1, 1, 1),(40, 663, 1, 1, 1),(40, 664, 1, 1, 1),(40, 665, 1, 1, 1),(40, 666, 1, 1, 1),(40, 667, 1, 1, 1),(40, 668, 1, 1, 1),(40, 669, 1, 1, 1),(40, 670, 1, 1, 1),(40, 671, 5, 1, 1),(40, 672, 5, 1, 1),(40, 673, 5, 1, 1),(40, 674, 5, 1, 1),(40, 675, 1, 1, 1),(40, 676, 1, 1, 1),(40, 677, 1, 1, 1),(40, 678, 1, 1, 1),(40, 679, 1, 1, 1),(40, 680, 1, 1, 1),(40, 681, 1, 1, 1),(40, 682, 1, 1, 1),(40, 683, 1, 1, 1),(40, 684, 1, 1, 1),(40, 685, 1, 1, 1),(40, 686, 1, 1, 1),(40, 687, 1, 1, 1),(40, 688, 1, 1, 1),(40, 689, 1, 1, 1),(40, 690, 1, 1, 1),(40, 691, 1, 1, 1),(40, 692, 1, 1, 1),(40, 693, 1, 1, 1),(40, 694, 1, 1, 1),(40, 695, 1, 1, 1),(40, 696, 1, 1, 1),(40, 697, 1, 1, 1),(40, 698, 1, 1, 1),(40, 699, 1, 1, 1),(40, 700, 1, 1, 1),(40, 701, 1, 1, 1),(40, 702, 1, 1, 1),(40, 703, 5, 1, 1),(40, 704, 5, 1, 1),(40, 705, 5, 1, 1),(40, 706, 5, 1, 1),(40, 707, 1, 1, 1),(40, 708, 1, 1, 1),(40, 709, 1, 1, 1),(40, 710, 1, 1, 1),(40, 711, 1, 1, 1),(40, 712, 1, 1, 1),(40, 713, 1, 1, 1),(40, 714, 1, 1, 1),(40, 715, 1, 1, 1),(40, 716, 1, 1, 1),(40, 717, 1, 1, 1),(40, 718, 1, 1, 1),(40, 719, 1, 1, 1),(40, 720, 1, 1, 1),(40, 721, 1, 1, 1),(40, 722, 1, 1, 1),(40, 723, 1, 1, 1),(40, 724, 1, 1, 1),(40, 725, 1, 1, 1),(40, 726, 1, 1, 1),(40, 727, 1, 1, 1),(40, 728, 1, 1, 1),(40, 729, 1, 1, 1),(40, 730, 1, 1, 1),(40, 731, 1, 1, 1),(40, 732, 1, 1, 1),(40, 733, 1, 1, 1),(40, 734, 1, 1, 1),(40, 735, 5, 1, 1),(40, 736, 5, 1, 1),(40, 737, 5, 1, 1),(40, 738, 5, 1, 1),(40, 739, 1, 1, 1),(40, 740, 1, 1, 1),(40, 741, 1, 1, 1),(40, 742, 1, 1, 1),(40, 743, 1, 1, 1),(40, 744, 1, 1, 1),(40, 745, 1, 1, 1),(40, 746, 1, 1, 1),(40, 747, 1, 1, 1),(40, 748, 1, 1, 1),(40, 749, 1, 1, 1),(40, 750, 1, 1, 1),(40, 751, 1, 1, 1),(40, 752, 1, 1, 1),(40, 753, 1, 1, 1),(40, 754, 1, 1, 1),(40, 755, 1, 1, 1),(40, 756, 1, 1, 1),(40, 757, 1, 1, 1),(40, 758, 1, 1, 1),(40, 759, 1, 1, 1),(40, 760, 1, 1, 1),(40, 761, 1, 1, 1),(40, 762, 1, 1, 1),(40, 763, 1, 1, 1),(40, 764, 1, 1, 1),(40, 765, 1, 1, 1),(40, 766, 1, 1, 1),(40, 767, 5, 1, 1),(40, 768, 5, 1, 1),(40, 769, 5, 1, 1),(40, 770, 5, 1, 1),(40, 771, 1, 1, 1),(40, 772, 1, 1, 1),(40, 773, 1, 1, 1),(40, 774, 1, 1, 1),(40, 775, 1, 1, 1),(40, 776, 1, 1, 1),(40, 777, 1, 1, 1),(40, 778, 1, 1, 1),(40, 779, 1, 1, 1),(40, 780, 1, 1, 1),(40, 781, 1, 1, 1),(40, 782, 1, 1, 1),(40, 783, 1, 1, 1),(40, 784, 1, 1, 1),(40, 785, 1, 1, 1),(40, 786, 1, 1, 1),(40, 787, 1, 1, 1),(40, 788, 1, 1, 1),(40, 789, 1, 1, 1),(40, 790, 1, 1, 1),(40, 791, 1, 1, 1),(40, 792, 1, 1, 1),(40, 793, 1, 1, 1),(40, 794, 1, 1, 1),(40, 795, 1, 1, 1),(40, 796, 1, 1, 1),(40, 797, 1, 1, 1),(40, 798, 1, 1, 1),(40, 799, 5, 1, 1),(40, 800, 5, 1, 1),(40, 801, 5, 1, 1),(40, 802, 5, 1, 1),(40, 803, 1, 1, 1),(40, 804, 1, 1, 1),(40, 805, 1, 1, 1),(40, 806, 1, 1, 1),(40, 807, 1, 1, 1),(40, 808, 1, 1, 1),(40, 809, 1, 1, 1),(40, 810, 1, 1, 1),(40, 811, 1, 1, 1),(40, 812, 1, 1, 1),(40, 813, 1, 1, 1),(40, 814, 1, 1, 1),(40, 815, 1, 1, 1),(40, 816, 1, 1, 1),(40, 817, 1, 1, 1),(40, 818, 1, 1, 1),(40, 819, 1, 1, 1),(40, 820, 1, 1, 1),(40, 821, 1, 1, 1),(40, 822, 1, 1, 1),(40, 823, 1, 1, 1),(40, 824, 1, 1, 1),(40, 825, 1, 1, 1),(40, 826, 1, 1, 1),(40, 827, 1, 1, 1),(40, 828, 1, 1, 1),(40, 829, 1, 1, 1),(40, 830, 1, 1, 1),(40, 831, 5, 1, 1),(40, 832, 5, 1, 1),(40, 833, 5, 1, 1),(40, 834, 5, 1, 1),(40, 835, 1, 1, 1),(40, 836, 1, 1, 1),(40, 837, 1, 1, 1),(40, 838, 1, 1, 1),(40, 839, 1, 1, 1),(40, 840, 1, 1, 1),(40, 841, 1, 1, 1),(40, 842, 1, 1, 1),(40, 843, 1, 1, 1),(40, 844, 1, 1, 1),(40, 845, 1, 1, 1),(40, 846, 1, 1, 1),(40, 847, 1, 1, 1),(40, 848, 1, 1, 1),(40, 849, 1, 1, 1),(40, 850, 1, 1, 1),(40, 851, 1, 1, 1),(40, 852, 1, 1, 1),(40, 853, 1, 1, 1),(40, 854, 1, 1, 1),(40, 855, 1, 1, 1),(40, 856, 1, 1, 1),(40, 857, 1, 1, 1),(40, 858, 1, 1, 1),(40, 859, 1, 1, 1),(40, 860, 1, 1, 1),(40, 861, 1, 1, 1),(40, 862, 1, 1, 1),(40, 863, 5, 1, 1),(40, 864, 5, 1, 1),(40, 865, 5, 1, 1),(40, 866, 5, 1, 1),(40, 867, 1, 1, 1),(40, 868, 1, 1, 1),(40, 869, 1, 1, 1),(40, 870, 1, 1, 1),(40, 871, 1, 1, 1),(40, 872, 1, 1, 1),(40, 873, 1, 1, 1),(40, 874, 1, 1, 1),(40, 875, 1, 1, 1),(40, 876, 1, 1, 1),(40, 877, 1, 1, 1),(40, 878, 1, 1, 1),(40, 879, 1, 1, 1),(40, 880, 1, 1, 1),(40, 881, 1, 1, 1),(40, 882, 1, 1, 1),(40, 883, 1, 1, 1),(40, 884, 1, 1, 1),(40, 885, 1, 1, 1),(40, 886, 1, 1, 1),(40, 887, 1, 1, 1),(40, 888, 1, 1, 1),(40, 889, 1, 1, 1),(40, 890, 1, 1, 1),(40, 891, 1, 1, 1),(40, 892, 1, 1, 1),(40, 893, 1, 1, 1),(40, 894, 1, 1, 1),(40, 895, 5, 1, 1),(40, 896, 5, 1, 1),(40, 897, 5, 1, 1),(40, 898, 5, 1, 1),(40, 899, 1, 1, 1),(40, 900, 1, 1, 1),(40, 901, 1, 1, 1),(40, 902, 1, 1, 1),(40, 903, 1, 1, 1),(40, 904, 1, 1, 1),(40, 905, 1, 1, 1),(40, 906, 1, 1, 1),(40, 907, 1, 1, 1),(40, 908, 1, 1, 1),(40, 909, 1, 1, 1),(40, 910, 1, 1, 1),(40, 911, 1, 1, 1),(40, 912, 1, 1, 1),(40, 913, 1, 1, 1),(40, 914, 1, 1, 1),(40, 915, 1, 1, 1),(40, 916, 1, 1, 1),(40, 917, 1, 1, 1),(40, 918, 1, 1, 1),(40, 919, 1, 1, 1),(40, 920, 1, 1, 1),(40, 921, 1, 1, 1),(40, 922, 1, 1, 1),(40, 923, 1, 1, 1),(40, 924, 1, 1, 1),(40, 925, 1, 1, 1),(40, 926, 1, 1, 1),(40, 927, 5, 1, 1),(40, 928, 5, 1, 1),(40, 929, 5, 1, 1),(40, 930, 5, 1, 1),(40, 931, 1, 1, 1),(40, 932, 1, 1, 1),(40, 933, 1, 1, 1),(40, 934, 1, 1, 1),(40, 935, 1, 1, 1),(40, 936, 1, 1, 1),(40, 937, 1, 1, 1),(40, 938, 1, 1, 1),(40, 939, 1, 1, 1),(40, 940, 1, 1, 1),(40, 941, 1, 1, 1),(40, 942, 1, 1, 1),(40, 943, 1, 1, 1),(40, 944, 1, 1, 1),(40, 945, 1, 1, 1),(40, 946, 1, 1, 1),(40, 947, 1, 1, 1),(40, 948, 1, 1, 1),(40, 949, 1, 1, 1),(40, 950, 1, 1, 1),(40, 951, 1, 1, 1),(40, 952, 1, 1, 1),(40, 953, 1, 1, 1),(40, 954, 1, 1, 1),(40, 955, 1, 1, 1),(40, 956, 1, 1, 1),(40, 957, 1, 1, 1),(40, 958, 1, 1, 1),(40, 959, 5, 1, 1),(40, 960, 5, 1, 1),(40, 961, 5, 1, 1),(40, 962, 5, 1, 1),(40, 963, 1, 1, 1),(40, 964, 1, 1, 1),(40, 965, 1, 1, 1),(40, 966, 1, 1, 1),(40, 967, 1, 1, 1),(40, 968, 1, 1, 1),(40, 969, 1, 1, 1),(40, 970, 1, 1, 1),(40, 971, 1, 1, 1),(40, 972, 1, 1, 1),(40, 973, 1, 1, 1),(40, 974, 1, 1, 1),(40, 975, 1, 1, 1),(40, 976, 1, 1, 1),(40, 977, 1, 1, 1),(40, 978, 1, 1, 1),(40, 979, 1, 1, 1),(40, 980, 1, 1, 1),(40, 981, 1, 1, 1),(40, 982, 1, 1, 1),(40, 983, 1, 1, 1),(40, 984, 1, 1, 1),(40, 985, 1, 1, 1),(40, 986, 1, 1, 1),(40, 987, 1, 1, 1),(40, 988, 1, 1, 1),(40, 989, 1, 1, 1),(40, 990, 1, 1, 1),(40, 991, 5, 1, 1),(40, 992, 5, 1, 1),(40, 993, 5, 1, 1),(40, 994, 5, 1, 1),(40, 995, 1, 1, 1),(40, 996, 1, 1, 1),(40, 997, 1, 1, 1),(40, 998, 1, 1, 1),(40, 999, 1, 1, 1),(40, 1000, 1, 1, 1),(40, 1001, 1, 1, 1),(40, 1002, 1, 1, 1),(40, 1003, 1, 1, 1),(40, 1004, 1, 1, 1),(40, 1005, 1, 1, 1),(40, 1006, 1, 1, 1),(40, 1007, 1, 1, 1),(40, 1008, 1, 1, 1),(40, 1009, 1, 1, 1),(40, 1010, 1, 1, 1),(40, 1011, 1, 1, 1),(40, 1012, 1, 1, 1),(40, 1013, 1, 1, 1),(40, 1014, 1, 1, 1),(40, 1015, 1, 1, 1),(40, 1016, 1, 1, 1),(40, 1017, 1, 1, 1),(40, 1018, 1, 1, 1),(40, 1019, 1, 1, 1),(40, 1020, 1, 1, 1),(40, 1021, 1, 1, 1),(40, 1022, 1, 1, 1),(40, 1023, 5, 1, 1),(40, 1024, 5, 1, 1),(40, 1025, 5, 1, 1),(40, 1026, 5, 1, 1),(40, 1027, 1, 1, 1),(40, 1028, 1, 1, 1),(40, 1029, 1, 1, 1),(40, 1030, 1, 1, 1),(40, 1031, 1, 1, 1),(40, 1032, 1, 1, 1),(40, 1033, 1, 1, 1),(40, 1034, 1, 1, 1),(40, 1035, 1, 1, 1),(40, 1036, 1, 1, 1),(40, 1037, 1, 1, 1),(40, 1038, 1, 1, 1),(40, 1039, 1, 1, 1),(40, 1040, 1, 1, 1),(40, 1041, 1, 1, 1),(40, 1042, 1, 1, 1),(40, 1043, 1, 1, 1),(40, 1044, 1, 1, 1),(40, 1045, 1, 1, 1),(40, 1046, 1, 1, 1),(40, 1047, 1, 1, 1),(40, 1048, 1, 1, 1),(40, 1049, 1, 1, 1),(40, 1050, 1, 1, 1),(40, 1051, 1, 1, 1),(40, 1052, 1, 1, 1),(40, 1053, 1, 1, 1),(40, 1054, 1, 1, 1),(40, 1055, 5, 1, 1),(40, 1056, 5, 1, 1),(40, 1057, 5, 1, 1),(40, 1058, 5, 1, 1),(40, 1059, 1, 1, 1),(40, 1060, 1, 1, 1),(40, 1061, 1, 1, 1),(40, 1062, 1, 1, 1),(40, 1063, 1, 1, 1),(40, 1064, 1, 1, 1),(40, 1065, 1, 1, 1),(40, 1066, 1, 1, 1),(40, 1067, 1, 1, 1),(40, 1068, 1, 1, 1),(40, 1069, 1, 1, 1),(40, 1070, 1, 1, 1),(40, 1071, 1, 1, 1),(40, 1072, 1, 1, 1),(40, 1073, 1, 1, 1),(40, 1074, 1, 1, 1),(40, 1075, 1, 1, 1),(40, 1076, 1, 1, 1),(40, 1077, 1, 1, 1),(40, 1078, 1, 1, 1),(40, 1079, 1, 1, 1),(40, 1080, 1, 1, 1),(40, 1081, 1, 1, 1),(40, 1082, 1, 1, 1),(40, 1083, 1, 1, 1),(40, 1084, 1, 1, 1),(40, 1085, 1, 1, 1),(40, 1086, 1, 1, 1),(40, 1087, 5, 1, 1),(40, 1088, 5, 1, 1),(40, 1089, 5, 1, 1),(40, 1090, 5, 1, 1),(40, 1091, 1, 1, 1),(40, 1092, 1, 1, 1),(40, 1093, 1, 1, 1),(40, 1094, 1, 1, 1),(40, 1095, 1, 1, 1),(40, 1096, 1, 1, 1),(40, 1097, 1, 1, 1),(40, 1098, 1, 1, 1),(40, 1099, 1, 1, 1),(40, 1100, 1, 1, 1),(40, 1101, 1, 1, 1),(40, 1102, 1, 1, 1),(40, 1103, 1, 1, 1),(40, 1104, 1, 1, 1),(40, 1105, 1, 1, 1),(40, 1106, 1, 1, 1),(40, 1107, 1, 1, 1),(40, 1108, 1, 1, 1),(40, 1109, 1, 1, 1),(40, 1110, 1, 1, 1),(40, 1111, 1, 1, 1),(40, 1112, 1, 1, 1),(40, 1113, 1, 1, 1),(40, 1114, 1, 1, 1),(40, 1115, 1, 1, 1),(40, 1116, 1, 1, 1),(40, 1117, 1, 1, 1),(40, 1118, 1, 1, 1),(40, 1119, 5, 1, 1),(40, 1120, 5, 1, 1),(40, 1121, 5, 1, 1),(40, 1122, 5, 1, 1),(40, 1123, 1, 1, 1),(40, 1124, 1, 1, 1),(40, 1125, 1, 1, 1),(40, 1126, 1, 1, 1),(40, 1127, 1, 1, 1),(40, 1128, 1, 1, 1),(40, 1129, 1, 1, 1),(40, 1130, 1, 1, 1),(40, 1131, 1, 1, 1),(40, 1132, 1, 1, 1),(40, 1133, 1, 1, 1),(40, 1134, 1, 1, 1),(40, 1135, 1, 1, 1),(40, 1136, 1, 1, 1),(40, 1137, 1, 1, 1),(40, 1138, 1, 1, 1),(40, 1139, 1, 1, 1),(40, 1140, 1, 1, 1),(40, 1141, 1, 1, 1),(40, 1142, 1, 1, 1),(40, 1143, 1, 1, 1),(40, 1144, 1, 1, 1),(40, 1145, 1, 1, 1),(40, 1146, 1, 1, 1),(40, 1147, 1, 1, 1),(40, 1148, 1, 1, 1),(40, 1149, 1, 1, 1),(40, 1150, 1, 1, 1),(40, 1151, 5, 1, 1),(40, 1152, 5, 1, 1),(40, 1153, 5, 1, 1),(40, 1154, 5, 1, 1),(40, 1155, 1, 1, 1),(40, 1156, 1, 1, 1),(40, 1157, 1, 1, 1),(40, 1158, 1, 1, 1),(40, 1159, 1, 1, 1),(40, 1160, 1, 1, 1),(40, 1161, 1, 1, 1),(40, 1162, 1, 1, 1),(40, 1163, 1, 1, 1),(40, 1164, 1, 1, 1),(40, 1165, 1, 1, 1),(40, 1166, 1, 1, 1),(40, 1167, 1, 1, 1),(40, 1168, 1, 1, 1),(40, 1169, 1, 1, 1),(40, 1170, 1, 1, 1),(40, 1171, 1, 1, 1),(40, 1172, 1, 1, 1),(40, 1173, 1, 1, 1),(40, 1174, 1, 1, 1),(40, 1175, 1, 1, 1),(40, 1176, 1, 1, 1),(40, 1177, 1, 1, 1),(40, 1178, 1, 1, 1),(40, 1179, 1, 1, 1),(40, 1180, 1, 1, 1),(40, 1181, 1, 1, 1),(40, 1182, 1, 1, 1),(40, 1183, 5, 1, 1),(40, 1184, 5, 1, 1),(40, 1185, 5, 1, 1),(40, 1186, 5, 1, 1),(40, 1187, 1, 1, 1),(40, 1188, 1, 1, 1),(40, 1189, 1, 1, 1),(40, 1190, 1, 1, 1),(40, 1191, 1, 1, 1),(40, 1192, 1, 1, 1),(40, 1193, 1, 1, 1),(40, 1194, 1, 1, 1),(40, 1195, 1, 1, 1),(40, 1196, 1, 1, 1),(40, 1197, 1, 1, 1),(40, 1198, 1, 1, 1),(40, 1199, 1, 1, 1),(40, 1200, 1, 1, 1),(40, 1201, 1, 1, 1),(40, 1202, 1, 1, 1),(40, 1203, 1, 1, 1),(40, 1204, 1, 1, 1),(40, 1205, 1, 1, 1),(40, 1206, 1, 1, 1),(40, 1207, 1, 1, 1),(40, 1208, 1, 1, 1),(40, 1209, 1, 1, 1),(40, 1210, 1, 1, 1),(40, 1211, 1, 1, 1),(40, 1212, 1, 1, 1),(40, 1213, 1, 1, 1),(40, 1214, 1, 1, 1),(40, 1215, 5, 1, 1),(40, 1216, 5, 1, 1),(40, 1217, 5, 1, 1),(40, 1218, 5, 1, 1),(40, 1219, 1, 1, 1),(40, 1220, 1, 1, 1),(40, 1221, 1, 1, 1),(40, 1222, 1, 1, 1),(40, 1223, 1, 1, 1),(40, 1224, 1, 1, 1),(40, 1225, 1, 1, 1),(40, 1226, 1, 1, 1),(40, 1227, 1, 1, 1),(40, 1228, 1, 1, 1),(40, 1229, 1, 1, 1),(40, 1230, 1, 1, 1),(40, 1231, 1, 1, 1),(40, 1232, 1, 1, 1),(40, 1233, 1, 1, 1),(40, 1234, 1, 1, 1),(40, 1235, 1, 1, 1),(40, 1236, 1, 1, 1),(40, 1237, 1, 1, 1),(40, 1238, 1, 1, 1),(40, 1239, 1, 1, 1),(40, 1240, 1, 1, 1),(40, 1241, 1, 1, 1),(40, 1242, 1, 1, 1),(40, 1243, 1, 1, 1),(40, 1244, 1, 1, 1),(40, 1245, 1, 1, 1),(40, 1246, 1, 1, 1),(40, 1247, 5, 1, 1),(40, 1248, 5, 1, 1),(40, 1249, 5, 1, 1),(40, 1250, 5, 1, 1),(40, 1251, 1, 1, 1),(40, 1252, 1, 1, 1),(40, 1253, 1, 1, 1),(40, 1254, 1, 1, 1),(40, 1255, 1, 1, 1),(40, 1256, 1, 1, 1),(40, 1257, 1, 1, 1),(40, 1258, 1, 1, 1),(40, 1259, 1, 1, 1),(40, 1260, 1, 1, 1),(40, 1261, 1, 1, 1),(40, 1262, 1, 1, 1),(40, 1263, 1, 1, 1),(40, 1264, 1, 1, 1),(40, 1265, 1, 1, 1),(40, 1266, 1, 1, 1),(40, 1267, 1, 1, 1),(40, 1268, 1, 1, 1),(40, 1269, 1, 1, 1),(40, 1270, 1, 1, 1),(40, 1271, 1, 1, 1),(40, 1272, 1, 1, 1),(40, 1273, 1, 1, 1),(40, 1274, 1, 1, 1),(40, 1275, 1, 1, 1),(40, 1276, 1, 1, 1),(40, 1277, 1, 1, 1),(40, 1278, 1, 1, 1),(40, 1279, 5, 1, 1),(40, 1280, 5, 1, 1),(40, 1281, 5, 1, 1),(40, 1282, 5, 1, 1),(40, 1283, 1, 1, 1),(40, 1284, 1, 1, 1),(40, 1285, 1, 1, 1),(40, 1286, 1, 1, 1),(40, 1287, 1, 1, 1),(40, 1288, 1, 1, 1),(40, 1289, 1, 1, 1),(40, 1290, 1, 1, 1),(40, 1291, 1, 1, 1),(40, 1292, 1, 1, 1),(40, 1293, 1, 1, 1),(40, 1294, 1, 1, 1),(40, 1295, 1, 1, 1),(40, 1296, 1, 1, 1),(40, 1297, 1, 1, 1),(40, 1298, 1, 1, 1),(40, 1299, 1, 1, 1),(40, 1300, 1, 1, 1),(40, 1301, 1, 1, 1),(40, 1302, 1, 1, 1),(40, 1303, 1, 1, 1),(40, 1304, 1, 1, 1),(40, 1305, 1, 1, 1),(40, 1306, 1, 1, 1),(40, 1307, 1, 1, 1),(40, 1308, 1, 1, 1),(40, 1309, 1, 1, 1),(40, 1310, 1, 1, 1),(40, 1311, 5, 1, 1),(40, 1312, 5, 1, 1),(40, 1313, 5, 1, 1),(40, 1314, 5, 1, 1),(40, 1315, 1, 1, 1),(40, 1316, 1, 1, 1),(40, 1317, 1, 1, 1),(40, 1318, 1, 1, 1),(40, 1319, 1, 1, 1),(40, 1320, 1, 1, 1),(40, 1321, 1, 1, 1),(40, 1322, 1, 1, 1),(40, 1323, 1, 1, 1),(40, 1324, 1, 1, 1),(40, 1325, 1, 1, 1),(40, 1326, 1, 1, 1),(40, 1327, 1, 1, 1),(40, 1328, 1, 1, 1),(40, 1329, 1, 1, 1),(40, 1330, 1, 1, 1),(40, 1331, 1, 1, 1),(40, 1332, 1, 1, 1),(40, 1333, 1, 1, 1),(40, 1334, 1, 1, 1),(40, 1335, 1, 1, 1),(40, 1336, 1, 1, 1),(40, 1337, 1, 1, 1),(40, 1338, 1, 1, 1),(40, 1339, 1, 1, 1),(40, 1340, 1, 1, 1),(40, 1341, 1, 1, 1),(40, 1342, 1, 1, 1),(40, 1343, 5, 1, 1),(40, 1344, 5, 1, 1),(40, 1345, 5, 1, 1),(40, 1346, 5, 1, 1),(40, 1347, 1, 1, 1),(40, 1348, 1, 1, 1),(40, 1349, 1, 1, 1),(40, 1350, 1, 1, 1),(40, 1351, 1, 1, 1),(40, 1352, 1, 1, 1),(40, 1353, 1, 1, 1),(40, 1354, 1, 1, 1),(40, 1355, 1, 1, 1),(40, 1356, 1, 1, 1),(40, 1357, 1, 1, 1),(40, 1358, 1, 1, 1),(40, 1359, 1, 1, 1),(40, 1360, 1, 1, 1),(40, 1361, 1, 1, 1),(40, 1362, 1, 1, 1),(40, 1363, 1, 1, 1),(40, 1364, 1, 1, 1),(40, 1365, 1, 1, 1),(40, 1366, 1, 1, 1),(40, 1367, 1, 1, 1),(40, 1368, 1, 1, 1),(40, 1369, 1, 1, 1),(40, 1370, 1, 1, 1),(40, 1371, 1, 1, 1),(40, 1372, 1, 1, 1),(40, 1373, 1, 1, 1),(40, 1374, 1, 1, 1),(40, 1375, 5, 1, 1),(40, 1376, 5, 1, 1),(40, 1377, 5, 1, 1),(40, 1378, 5, 1, 1),(40, 1379, 1, 1, 1),(40, 1380, 1, 1, 1),(40, 1381, 1, 1, 1),(40, 1382, 1, 1, 1),(40, 1383, 1, 1, 1),(40, 1384, 1, 1, 1),(40, 1385, 1, 1, 1),(40, 1386, 1, 1, 1),(40, 1387, 1, 1, 1),(40, 1388, 1, 1, 1),(40, 1389, 1, 1, 1),(40, 1390, 1, 1, 1),(40, 1391, 1, 1, 1),(40, 1392, 1, 1, 1),(40, 1393, 1, 1, 1),(40, 1394, 1, 1, 1),(40, 1395, 1, 1, 1),(40, 1396, 1, 1, 1),(40, 1397, 1, 1, 1),(40, 1398, 1, 1, 1),(40, 1399, 1, 1, 1),(40, 1400, 1, 1, 1),(40, 1401, 1, 1, 1),(40, 1402, 1, 1, 1),(40, 1403, 1, 1, 1),(40, 1404, 1, 1, 1),(40, 1405, 1, 1, 1),(40, 1406, 1, 1, 1),(40, 1407, 5, 1, 1),(40, 1408, 5, 1, 1),(40, 1409, 5, 1, 1),(40, 1410, 5, 1, 1),(40, 1411, 2, 1, 1),(40, 1412, 2, 1, 1),(40, 1413, 2, 1, 1),(40, 1414, 2, 1, 1),(40, 1415, 2, 1, 1),(40, 1416, 2, 1, 1),(40, 1417, 2, 1, 1),(40, 1418, 2, 1, 1),(40, 1419, 2, 1, 1),(40, 1420, 2, 1, 1),(40, 1421, 2, 1, 1),(40, 1422, 2, 1, 1),(40, 1423, 2, 1, 1),(40, 1424, 2, 1, 1),(40, 1425, 3, 1, 1),(40, 1426, 3, 1, 1),(40, 1427, 3, 1, 1),(40, 1428, 3, 1, 1),(40, 1429, 3, 1, 1),(40, 1430, 3, 1, 1),(40, 1431, 3, 1, 1),(40, 1432, 3, 1, 1),(40, 1433, 4, 1, 1),(40, 1434, 4, 1, 1),(40, 1435, 4, 1, 1),(40, 1436, 4, 1, 1),(40, 1437, 4, 1, 1),(40, 1438, 4, 1, 1),(40, 1439, 5, 1, 1),(40, 1440, 5, 1, 1),(40, 1441, 5, 1, 1),(40, 1442, 5, 1, 1),(40, 1443, 2, 1, 1),(40, 1444, 2, 1, 1),(40, 1445, 2, 1, 1),(40, 1446, 2, 1, 1),(40, 1447, 2, 1, 1),(40, 1448, 2, 1, 1),(40, 1449, 2, 1, 1),(40, 1450, 2, 1, 1),(40, 1451, 2, 1, 1),(40, 1452, 2, 1, 1),(40, 1453, 2, 1, 1),(40, 1454, 2, 1, 1),(40, 1455, 2, 1, 1),(40, 1456, 2, 1, 1),(40, 1457, 3, 1, 1),(40, 1458, 3, 1, 1),(40, 1459, 3, 1, 1),(40, 1460, 3, 1, 1),(40, 1461, 3, 1, 1),(40, 1462, 3, 1, 1),(40, 1463, 3, 1, 1),(40, 1464, 3, 1, 1),(40, 1465, 4, 1, 1),(40, 1466, 4, 1, 1),(40, 1467, 4, 1, 1),(40, 1468, 4, 1, 1),(40, 1469, 4, 1, 1),(40, 1470, 4, 1, 1),(40, 1471, 5, 1, 1),(40, 1472, 5, 1, 1),(40, 1473, 5, 1, 1),(40, 1474, 5, 1, 1),(40, 1475, 5, 1, 1),(40, 1476, 5, 1, 1),(40, 1477, 5, 1, 1),(40, 1478, 5, 1, 1),(40, 1479, 5, 1, 1),(40, 1480, 5, 1, 1),(40, 1481, 5, 1, 1),(40, 1482, 5, 1, 1),(40, 1483, 5, 1, 1),(40, 1484, 5, 1, 1),(40, 1485, 5, 1, 1),(40, 1486, 5, 1, 1),(40, 1487, 5, 1, 1),(40, 1488, 5, 1, 1),(40, 1489, 5, 1, 1),(40, 1490, 5, 1, 1),(40, 1491, 5, 1, 1),(40, 1492, 5, 1, 1),(40, 1493, 5, 1, 1),(40, 1494, 5, 1, 1),(40, 1495, 5, 1, 1),(40, 1496, 5, 1, 1),(40, 1497, 5, 1, 1),(40, 1498, 5, 1, 1),(40, 1499, 5, 1, 1),(40, 1500, 5, 1, 1),(40, 1501, 5, 1, 1),(40, 1502, 5, 1, 1),(40, 1503, 5, 1, 1),(40, 1504, 5, 1, 1),(40, 1505, 5, 1, 1),(40, 1506, 5, 1, 1),(40, 1507, 5, 1, 1),(40, 1508, 5, 1, 1),(40, 1509, 5, 1, 1),(40, 1510, 5, 1, 1),(40, 1511, 5, 1, 1),(40, 1512, 5, 1, 1),(40, 1513, 5, 1, 1),(40, 1514, 5, 1, 1),(40, 1515, 5, 1, 1),(40, 1516, 5, 1, 1),(40, 1517, 5, 1, 1),(40, 1518, 5, 1, 1),(40, 1519, 5, 1, 1),(40, 1520, 5, 1, 1),(40, 1521, 5, 1, 1),(40, 1522, 5, 1, 1),(40, 1523, 5, 1, 1),(40, 1524, 5, 1, 1),(40, 1525, 5, 1, 1),(40, 1526, 5, 1, 1),(40, 1527, 5, 1, 1),(40, 1528, 5, 1, 1),(40, 1529, 5, 1, 1),(40, 1530, 5, 1, 1),(40, 1531, 5, 1, 1),(40, 1532, 5, 1, 1),(40, 1533, 5, 1, 1),(40, 1534, 5, 1, 1),(40, 1535, 5, 1, 1),(40, 1536, 5, 1, 1),(41, 1, 4, 1, 1),(41, 2, 4, 1, 1),(41, 3, 4, 1, 1),(41, 4, 4, 1, 1),(41, 5, 4, 1, 1),(41, 6, 4, 1, 1),(41, 7, 4, 1, 1),(41, 8, 4, 1, 1),(41, 9, 4, 1, 1),(41, 10, 4, 1, 1),(41, 11, 4, 1, 1),(41, 12, 4, 1, 1),(41, 13, 4, 1, 1),(41, 14, 4, 1, 1),(41, 15, 4, 1, 1),(41, 16, 4, 1, 1),(41, 17, 4, 1, 1),(41, 18, 4, 1, 1),(41, 19, 4, 1, 1),(41, 20, 4, 1, 1),(41, 21, 4, 1, 1),(41, 22, 4, 1, 1),(41, 23, 4, 1, 1),(41, 24, 4, 1, 1),(41, 25, 4, 1, 1),(41, 26, 4, 1, 1),(41, 27, 4, 1, 1),(41, 28, 4, 1, 1),(41, 29, 4, 1, 1),(41, 30, 4, 1, 1),(41, 31, 4, 1, 1),(41, 32, 4, 1, 1),(41, 33, 4, 1, 1),(41, 34, 4, 1, 1),(41, 35, 4, 1, 1),(41, 36, 4, 1, 1),(41, 37, 4, 1, 1),(41, 38, 4, 1, 1),(41, 39, 4, 1, 1),(41, 40, 4, 1, 1),(41, 41, 4, 1, 1),(41, 42, 4, 1, 1),(41, 43, 4, 1, 1),(41, 44, 4, 1, 1),(41, 45, 4, 1, 1),(41, 46, 4, 1, 1),(41, 47, 4, 1, 1),(41, 48, 4, 1, 1),(41, 49, 4, 1, 1),(41, 50, 4, 1, 1),(41, 51, 4, 1, 1),(41, 52, 4, 1, 1),(41, 53, 4, 1, 1),(41, 54, 4, 1, 1),(41, 55, 4, 1, 1),(41, 56, 4, 1, 1),(41, 57, 4, 1, 1),(41, 58, 4, 1, 1),(41, 59, 4, 1, 1),(41, 60, 4, 1, 1),(41, 61, 4, 1, 1),(41, 62, 4, 1, 1),(41, 63, 4, 1, 1),(41, 64, 4, 1, 1),(41, 65, 4, 1, 1),(41, 66, 4, 1, 1),(41, 67, 4, 1, 1),(41, 68, 4, 1, 1),(41, 69, 4, 1, 1),(41, 70, 4, 1, 1),(41, 71, 4, 1, 1),(41, 72, 4, 1, 1),(41, 73, 4, 1, 1),(41, 74, 4, 1, 1),(41, 75, 4, 1, 1),(41, 76, 4, 1, 1),(41, 77, 4, 1, 1),(41, 78, 4, 1, 1),(41, 79, 4, 1, 1),(41, 80, 4, 1, 1),(41, 81, 4, 1, 1),(41, 82, 4, 1, 1),(41, 83, 4, 1, 1),(41, 84, 4, 1, 1),(41, 85, 4, 1, 1),(41, 86, 4, 1, 1),(41, 87, 4, 1, 1),(41, 88, 4, 1, 1),(41, 89, 4, 1, 1),(41, 90, 4, 1, 1),(41, 91, 4, 1, 1),(41, 92, 4, 1, 1),(41, 93, 4, 1, 1),(41, 94, 4, 1, 1),(41, 95, 4, 1, 1),(41, 96, 4, 1, 1),(41, 97, 4, 1, 1),(41, 98, 4, 1, 1),(41, 99, 4, 1, 1),(41, 100, 4, 1, 1),(41, 101, 4, 1, 1),(41, 102, 4, 1, 1),(41, 103, 4, 1, 1),(41, 104, 4, 1, 1),(41, 105, 4, 1, 1),(41, 106, 4, 1, 1),(41, 107, 4, 1, 1),(41, 108, 4, 1, 1),(41, 109, 4, 1, 1),(41, 110, 4, 1, 1),(41, 111, 4, 1, 1),(41, 112, 4, 1, 1),(41, 113, 4, 1, 1),(41, 114, 4, 1, 1),(41, 115, 4, 1, 1),(41, 116, 4, 1, 1),(41, 117, 4, 1, 1),(41, 118, 4, 1, 1),(41, 119, 4, 1, 1),(41, 120, 4, 1, 1),(41, 121, 4, 1, 1),(41, 122, 4, 1, 1),(41, 123, 4, 1, 1),(41, 124, 4, 1, 1),(41, 125, 4, 1, 1),(41, 126, 4, 1, 1),(41, 127, 4, 1, 1),(41, 128, 4, 1, 1),(41, 129, 4, 1, 1),(41, 130, 4, 1, 1),(41, 131, 4, 1, 1),(41, 132, 4, 1, 1),(41, 133, 4, 1, 1),(41, 134, 4, 1, 1),(41, 135, 4, 1, 1),(41, 136, 4, 1, 1),(41, 137, 4, 1, 1),(41, 138, 4, 1, 1),(41, 139, 4, 1, 1),(41, 140, 4, 1, 1),(41, 141, 4, 1, 1),(41, 142, 4, 1, 1),(41, 143, 4, 1, 1),(41, 144, 4, 1, 1),(41, 145, 4, 1, 1),(41, 146, 4, 1, 1),(41, 147, 4, 1, 1),(41, 148, 4, 1, 1),(41, 149, 4, 1, 1),(41, 150, 4, 1, 1),(41, 151, 4, 1, 1),(41, 152, 4, 1, 1),(41, 153, 4, 1, 1),(41, 154, 4, 1, 1),(41, 155, 4, 1, 1),(41, 156, 4, 1, 1),(41, 157, 4, 1, 1),(41, 158, 4, 1, 1),(41, 159, 4, 1, 1),(41, 160, 4, 1, 1),(41, 161, 4, 1, 1),(41, 162, 4, 1, 1),(41, 163, 4, 1, 1),(41, 164, 4, 1, 1),(41, 165, 4, 1, 1),(41, 166, 4, 1, 1),(41, 167, 4, 1, 1),(41, 168, 4, 1, 1),(41, 169, 4, 1, 1),(41, 170, 4, 1, 1),(41, 171, 4, 1, 1),(41, 172, 4, 1, 1),(41, 173, 4, 1, 1),(41, 174, 4, 1, 1),(41, 175, 4, 1, 1),(41, 176, 4, 1, 1),(41, 177, 4, 1, 1),(41, 178, 4, 1, 1),(41, 179, 4, 1, 1),(41, 180, 4, 1, 1),(41, 181, 4, 1, 1),(41, 182, 4, 1, 1),(41, 183, 4, 1, 1),(41, 184, 4, 1, 1),(41, 185, 4, 1, 1),(41, 186, 4, 1, 1),(41, 187, 4, 1, 1),(41, 188, 4, 1, 1),(41, 189, 4, 1, 1),(41, 190, 4, 1, 1),(41, 191, 4, 1, 1),(41, 192, 4, 1, 1),(41, 193, 4, 1, 1),(41, 194, 4, 1, 1),(41, 195, 4, 1, 1),(41, 196, 4, 1, 1),(41, 197, 4, 1, 1),(41, 198, 4, 1, 1),(41, 199, 4, 1, 1),(41, 200, 4, 1, 1),(41, 201, 4, 1, 1),(41, 202, 4, 1, 1),(41, 203, 4, 1, 1),(41, 204, 4, 1, 1),(41, 205, 4, 1, 1),(41, 206, 4, 1, 1),(41, 207, 4, 1, 1),(41, 208, 4, 1, 1),(41, 209, 4, 1, 1),(41, 210, 4, 1, 1),(41, 211, 4, 1, 1),(41, 212, 4, 1, 1),(41, 213, 4, 1, 1),(41, 214, 4, 1, 1),(41, 215, 4, 1, 1),(41, 216, 4, 1, 1),(41, 217, 4, 1, 1),(41, 218, 4, 1, 1),(41, 219, 4, 1, 1),(41, 220, 4, 1, 1),(41, 221, 4, 1, 1),(41, 222, 4, 1, 1),(41, 223, 4, 1, 1),(41, 224, 4, 1, 1),(41, 225, 4, 1, 1),(41, 226, 4, 1, 1),(41, 227, 4, 1, 1),(41, 228, 4, 1, 1),(41, 229, 4, 1, 1),(41, 230, 4, 1, 1),(41, 231, 4, 1, 1),(41, 232, 4, 1, 1),(41, 233, 4, 1, 1),(41, 234, 4, 1, 1),(41, 235, 4, 1, 1),(41, 236, 4, 1, 1),(41, 237, 4, 1, 1),(41, 238, 4, 1, 1),(41, 239, 4, 1, 1),(41, 240, 4, 1, 1),(41, 241, 4, 1, 1),(41, 242, 4, 1, 1),(41, 243, 4, 1, 1),(41, 244, 4, 1, 1),(41, 245, 4, 1, 1),(41, 246, 4, 1, 1),(41, 247, 4, 1, 1),(41, 248, 4, 1, 1),(41, 249, 4, 1, 1),(41, 250, 4, 1, 1),(41, 251, 4, 1, 1),(41, 252, 4, 1, 1),(41, 253, 4, 1, 1),(41, 254, 4, 1, 1),(41, 255, 4, 1, 1),(41, 256, 4, 1, 1),(41, 257, 4, 1, 1),(41, 258, 4, 1, 1),(41, 259, 4, 1, 1),(41, 260, 4, 1, 1),(41, 261, 4, 1, 1),(41, 262, 4, 1, 1),(41, 263, 4, 1, 1),(41, 264, 4, 1, 1),(41, 265, 4, 1, 1),(41, 266, 4, 1, 1),(41, 267, 4, 1, 1),(41, 268, 4, 1, 1),(41, 269, 4, 1, 1),(41, 270, 4, 1, 1),(41, 271, 4, 1, 1),(41, 272, 4, 1, 1),(41, 273, 4, 1, 1),(41, 274, 4, 1, 1),(41, 275, 4, 1, 1),(41, 276, 4, 1, 1),(41, 277, 4, 1, 1),(41, 278, 4, 1, 1),(41, 279, 4, 1, 1),(41, 280, 4, 1, 1),(41, 281, 4, 1, 1),(41, 282, 4, 1, 1),(41, 283, 4, 1, 1),(41, 284, 4, 1, 1),(41, 285, 4, 1, 1),(41, 286, 4, 1, 1),(41, 287, 4, 1, 1),(41, 288, 4, 1, 1),(41, 289, 4, 1, 1),(41, 290, 4, 1, 1),(41, 291, 4, 1, 1),(41, 292, 4, 1, 1),(41, 293, 4, 1, 1),(41, 294, 4, 1, 1),(41, 295, 4, 1, 1),(41, 296, 4, 1, 1),(41, 297, 4, 1, 1),(41, 298, 4, 1, 1),(41, 299, 4, 1, 1),(41, 300, 4, 1, 1),(41, 301, 4, 1, 1),(41, 302, 4, 1, 1),(41, 303, 4, 1, 1),(41, 304, 4, 1, 1),(41, 305, 4, 1, 1),(41, 306, 4, 1, 1),(41, 307, 4, 1, 1),(41, 308, 4, 1, 1),(41, 309, 4, 1, 1),(41, 310, 4, 1, 1),(41, 311, 4, 1, 1),(41, 312, 4, 1, 1),(41, 313, 4, 1, 1),(41, 314, 4, 1, 1),(41, 315, 4, 1, 1),(41, 316, 4, 1, 1),(41, 317, 4, 1, 1),(41, 318, 4, 1, 1),(41, 319, 4, 1, 1),(41, 320, 4, 1, 1),(41, 321, 4, 1, 1),(41, 322, 4, 1, 1),(41, 323, 4, 1, 1),(41, 324, 4, 1, 1),(41, 325, 4, 1, 1),(41, 326, 4, 1, 1),(41, 327, 4, 1, 1),(41, 328, 4, 1, 1),(41, 329, 4, 1, 1),(41, 330, 4, 1, 1),(41, 331, 4, 1, 1),(41, 332, 4, 1, 1),(41, 333, 4, 1, 1),(41, 334, 4, 1, 1),(41, 335, 4, 1, 1),(41, 336, 4, 1, 1),(41, 337, 4, 1, 1),(41, 338, 4, 1, 1),(41, 339, 4, 1, 1),(41, 340, 4, 1, 1),(41, 341, 4, 1, 1),(41, 342, 4, 1, 1),(41, 343, 4, 1, 1),(41, 344, 4, 1, 1),(41, 345, 4, 1, 1),(41, 346, 4, 1, 1),(41, 347, 4, 1, 1),(41, 348, 4, 1, 1),(41, 349, 4, 1, 1),(41, 350, 4, 1, 1),(41, 351, 4, 1, 1),(41, 352, 4, 1, 1),(41, 353, 4, 1, 1),(41, 354, 4, 1, 1),(41, 355, 4, 1, 1),(41, 356, 4, 1, 1),(41, 357, 4, 1, 1),(41, 358, 4, 1, 1),(41, 359, 4, 1, 1),(41, 360, 4, 1, 1),(41, 361, 4, 1, 1),(41, 362, 4, 1, 1),(41, 363, 4, 1, 1),(41, 364, 4, 1, 1),(41, 365, 4, 1, 1),(41, 366, 4, 1, 1),(41, 367, 4, 1, 1),(41, 368, 4, 1, 1),(41, 369, 4, 1, 1),(41, 370, 4, 1, 1),(41, 371, 4, 1, 1),(41, 372, 4, 1, 1),(41, 373, 4, 1, 1),(41, 374, 4, 1, 1),(41, 375, 4, 1, 1),(41, 376, 4, 1, 1),(41, 377, 4, 1, 1),(41, 378, 4, 1, 1),(41, 379, 4, 1, 1),(41, 380, 4, 1, 1),(41, 381, 4, 1, 1),(41, 382, 4, 1, 1),(41, 383, 4, 1, 1),(41, 384, 4, 1, 1),(41, 385, 4, 1, 1),(41, 386, 4, 1, 1),(41, 387, 4, 1, 1),(41, 388, 4, 1, 1),(41, 389, 4, 1, 1),(41, 390, 4, 1, 1),(41, 391, 4, 1, 1),(41, 392, 4, 1, 1),(41, 393, 4, 1, 1),(41, 394, 4, 1, 1),(41, 395, 4, 1, 1),(41, 396, 4, 1, 1),(41, 397, 4, 1, 1),(41, 398, 4, 1, 1),(41, 399, 4, 1, 1),(41, 400, 4, 1, 1),(41, 401, 4, 1, 1),(41, 402, 4, 1, 1),(41, 403, 4, 1, 1),(41, 404, 4, 1, 1),(41, 405, 4, 1, 1),(41, 406, 4, 1, 1),(41, 407, 4, 1, 1),(41, 408, 4, 1, 1),(41, 409, 4, 1, 1),(41, 410, 4, 1, 1),(41, 411, 4, 1, 1),(41, 412, 4, 1, 1),(41, 413, 4, 1, 1),(41, 414, 4, 1, 1),(41, 415, 4, 1, 1),(41, 416, 4, 1, 1),(41, 417, 4, 1, 1),(41, 418, 4, 1, 1),(41, 419, 4, 1, 1),(41, 420, 4, 1, 1),(41, 421, 4, 1, 1),(41, 422, 4, 1, 1),(41, 423, 4, 1, 1),(41, 424, 4, 1, 1),(41, 425, 4, 1, 1),(41, 426, 4, 1, 1),(41, 427, 4, 1, 1),(41, 428, 4, 1, 1),(41, 429, 4, 1, 1),(41, 430, 4, 1, 1),(41, 431, 4, 1, 1),(41, 432, 4, 1, 1),(41, 433, 4, 1, 1),(41, 434, 4, 1, 1),(41, 435, 4, 1, 1),(41, 436, 4, 1, 1),(41, 437, 4, 1, 1),(41, 438, 4, 1, 1),(41, 439, 4, 1, 1),(41, 440, 4, 1, 1),(41, 441, 4, 1, 1),(41, 442, 4, 1, 1),(41, 443, 4, 1, 1),(41, 444, 4, 1, 1),(41, 445, 4, 1, 1),(41, 446, 4, 1, 1),(41, 447, 4, 1, 1),(41, 448, 4, 1, 1),(41, 449, 4, 1, 1),(41, 450, 4, 1, 1),(41, 451, 4, 1, 1),(41, 452, 4, 1, 1),(41, 453, 4, 1, 1),(41, 454, 4, 1, 1),(41, 455, 4, 1, 1),(41, 456, 4, 1, 1),(41, 457, 4, 1, 1),(41, 458, 4, 1, 1),(41, 459, 4, 1, 1),(41, 460, 4, 1, 1),(41, 461, 4, 1, 1),(41, 462, 4, 1, 1),(41, 463, 4, 1, 1),(41, 464, 4, 1, 1),(41, 465, 4, 1, 1),(41, 466, 4, 1, 1),(41, 467, 4, 1, 1),(41, 468, 4, 1, 1),(41, 469, 4, 1, 1),(41, 470, 4, 1, 1),(41, 471, 4, 1, 1),(41, 472, 4, 1, 1),(41, 473, 4, 1, 1),(41, 474, 4, 1, 1),(41, 475, 4, 1, 1),(41, 476, 4, 1, 1),(41, 477, 4, 1, 1),(41, 478, 4, 1, 1),(41, 479, 4, 1, 1),(41, 480, 4, 1, 1),(41, 481, 4, 1, 1),(41, 482, 4, 1, 1),(41, 483, 4, 1, 1),(41, 484, 4, 1, 1),(41, 485, 4, 1, 1),(41, 486, 4, 1, 1),(41, 487, 4, 1, 1),(41, 488, 4, 1, 1),(41, 489, 4, 1, 1),(41, 490, 4, 1, 1),(41, 491, 4, 1, 1),(41, 492, 4, 1, 1),(41, 493, 4, 1, 1),(41, 494, 4, 1, 1),(41, 495, 4, 1, 1),(41, 496, 4, 1, 1),(41, 497, 4, 1, 1),(41, 498, 4, 1, 1),(41, 499, 4, 1, 1),(41, 500, 4, 1, 1),(41, 501, 4, 1, 1),(41, 502, 4, 1, 1),(41, 503, 4, 1, 1),(41, 504, 4, 1, 1),(41, 505, 4, 1, 1),(41, 506, 4, 1, 1),(41, 507, 4, 1, 1),(41, 508, 4, 1, 1),(41, 509, 4, 1, 1),(41, 510, 4, 1, 1),(41, 511, 4, 1, 1),(41, 512, 4, 1, 1),(41, 513, 4, 1, 1),(41, 514, 4, 1, 1),(41, 515, 4, 1, 1),(41, 516, 4, 1, 1),(41, 517, 4, 1, 1),(41, 518, 4, 1, 1),(41, 519, 4, 1, 1),(41, 520, 4, 1, 1),(41, 521, 4, 1, 1),(41, 522, 4, 1, 1),(41, 523, 4, 1, 1),(41, 524, 4, 1, 1),(41, 525, 4, 1, 1),(41, 526, 4, 1, 1),(41, 527, 4, 1, 1),(41, 528, 4, 1, 1),(41, 529, 4, 1, 1),(41, 530, 4, 1, 1),(41, 531, 4, 1, 1),(41, 532, 4, 1, 1),(41, 533, 4, 1, 1),(41, 534, 4, 1, 1),(41, 535, 4, 1, 1),(41, 536, 4, 1, 1),(41, 537, 4, 1, 1),(41, 538, 4, 1, 1),(41, 539, 4, 1, 1),(41, 540, 4, 1, 1),(41, 541, 4, 1, 1),(41, 542, 4, 1, 1),(41, 543, 4, 1, 1),(41, 544, 4, 1, 1),(41, 545, 4, 1, 1),(41, 546, 4, 1, 1),(41, 547, 4, 1, 1),(41, 548, 4, 1, 1),(41, 549, 4, 1, 1),(41, 550, 4, 1, 1),(41, 551, 4, 1, 1),(41, 552, 4, 1, 1),(41, 553, 4, 1, 1),(41, 554, 4, 1, 1),(41, 555, 4, 1, 1),(41, 556, 4, 1, 1),(41, 557, 4, 1, 1),(41, 558, 4, 1, 1),(41, 559, 4, 1, 1),(41, 560, 4, 1, 1),(41, 561, 4, 1, 1),(41, 562, 4, 1, 1),(41, 563, 4, 1, 1),(41, 564, 4, 1, 1),(41, 565, 4, 1, 1),(41, 566, 4, 1, 1),(41, 567, 4, 1, 1),(41, 568, 4, 1, 1),(41, 569, 4, 1, 1),(41, 570, 4, 1, 1),(41, 571, 4, 1, 1),(41, 572, 4, 1, 1),(41, 573, 4, 1, 1),(41, 574, 4, 1, 1),(41, 575, 4, 1, 1),(41, 576, 4, 1, 1),(41, 577, 4, 1, 1),(41, 578, 4, 1, 1),(41, 579, 4, 1, 1),(41, 580, 4, 1, 1),(41, 581, 4, 1, 1),(41, 582, 4, 1, 1),(41, 583, 4, 1, 1),(41, 584, 4, 1, 1),(41, 585, 4, 1, 1),(41, 586, 4, 1, 1),(41, 587, 4, 1, 1),(41, 588, 4, 1, 1),(41, 589, 4, 1, 1),(41, 590, 4, 1, 1),(41, 591, 4, 1, 1),(41, 592, 4, 1, 1),(41, 593, 4, 1, 1),(41, 594, 4, 1, 1),(41, 595, 4, 1, 1),(41, 596, 4, 1, 1),(41, 597, 4, 1, 1),(41, 598, 4, 1, 1),(41, 599, 4, 1, 1),(41, 600, 4, 1, 1),(41, 601, 4, 1, 1),(41, 602, 4, 1, 1),(41, 603, 4, 1, 1),(41, 604, 4, 1, 1),(41, 605, 4, 1, 1),(41, 606, 4, 1, 1),(41, 607, 4, 1, 1),(41, 608, 4, 1, 1),(41, 609, 4, 1, 1),(41, 610, 4, 1, 1),(41, 611, 4, 1, 1),(41, 612, 4, 1, 1),(41, 613, 4, 1, 1),(41, 614, 4, 1, 1),(41, 615, 4, 1, 1),(41, 616, 4, 1, 1),(41, 617, 4, 1, 1),(41, 618, 4, 1, 1),(41, 619, 4, 1, 1),(41, 620, 4, 1, 1),(41, 621, 4, 1, 1),(41, 622, 4, 1, 1),(41, 623, 4, 1, 1),(41, 624, 4, 1, 1),(41, 625, 4, 1, 1),(41, 626, 4, 1, 1),(41, 627, 4, 1, 1),(41, 628, 4, 1, 1),(41, 629, 4, 1, 1),(41, 630, 4, 1, 1),(41, 631, 4, 1, 1),(41, 632, 4, 1, 1),(41, 633, 4, 1, 1),(41, 634, 4, 1, 1),(41, 635, 4, 1, 1),(41, 636, 4, 1, 1),(41, 637, 4, 1, 1),(41, 638, 4, 1, 1),(41, 639, 4, 1, 1),(41, 640, 4, 1, 1),(41, 641, 4, 1, 1),(41, 642, 4, 1, 1),(41, 643, 4, 1, 1),(41, 644, 4, 1, 1),(41, 645, 4, 1, 1),(41, 646, 4, 1, 1),(41, 647, 4, 1, 1),(41, 648, 4, 1, 1),(41, 649, 4, 1, 1),(41, 650, 4, 1, 1),(41, 651, 4, 1, 1),(41, 652, 4, 1, 1),(41, 653, 4, 1, 1),(41, 654, 4, 1, 1),(41, 655, 4, 1, 1),(41, 656, 4, 1, 1),(41, 657, 4, 1, 1),(41, 658, 4, 1, 1),(41, 659, 4, 1, 1),(41, 660, 4, 1, 1),(41, 661, 4, 1, 1),(41, 662, 4, 1, 1),(41, 663, 4, 1, 1),(41, 664, 4, 1, 1),(41, 665, 4, 1, 1),(41, 666, 4, 1, 1),(41, 667, 4, 1, 1),(41, 668, 4, 1, 1),(41, 669, 4, 1, 1),(41, 670, 4, 1, 1),(41, 671, 4, 1, 1),(41, 672, 4, 1, 1),(41, 673, 4, 1, 1),(41, 674, 4, 1, 1),(41, 675, 4, 1, 1),(41, 676, 4, 1, 1),(41, 677, 4, 1, 1),(41, 678, 4, 1, 1),(41, 679, 4, 1, 1),(41, 680, 4, 1, 1),(41, 681, 4, 1, 1),(41, 682, 4, 1, 1),(41, 683, 4, 1, 1),(41, 684, 4, 1, 1),(41, 685, 4, 1, 1),(41, 686, 4, 1, 1),(41, 687, 4, 1, 1),(41, 688, 4, 1, 1),(41, 689, 4, 1, 1),(41, 690, 4, 1, 1),(41, 691, 4, 1, 1),(41, 692, 4, 1, 1),(41, 693, 4, 1, 1),(41, 694, 4, 1, 1),(41, 695, 4, 1, 1),(41, 696, 4, 1, 1),(41, 697, 4, 1, 1),(41, 698, 4, 1, 1),(41, 699, 4, 1, 1),(41, 700, 4, 1, 1),(41, 701, 4, 1, 1),(41, 702, 4, 1, 1),(41, 703, 4, 1, 1),(41, 704, 4, 1, 1),(41, 705, 4, 1, 1),(41, 706, 4, 1, 1),(41, 707, 4, 1, 1),(41, 708, 4, 1, 1),(41, 709, 4, 1, 1),(41, 710, 4, 1, 1),(41, 711, 4, 1, 1),(41, 712, 4, 1, 1),(41, 713, 4, 1, 1),(41, 714, 4, 1, 1),(41, 715, 4, 1, 1),(41, 716, 4, 1, 1),(41, 717, 4, 1, 1),(41, 718, 4, 1, 1),(41, 719, 4, 1, 1),(41, 720, 4, 1, 1),(41, 721, 4, 1, 1),(41, 722, 4, 1, 1),(41, 723, 4, 1, 1),(41, 724, 4, 1, 1),(41, 725, 4, 1, 1),(41, 726, 4, 1, 1),(41, 727, 4, 1, 1),(41, 728, 4, 1, 1),(41, 729, 4, 1, 1),(41, 730, 4, 1, 1),(41, 731, 4, 1, 1),(41, 732, 4, 1, 1),(41, 733, 4, 1, 1),(41, 734, 4, 1, 1),(41, 735, 4, 1, 1),(41, 736, 4, 1, 1),(41, 737, 4, 1, 1),(41, 738, 4, 1, 1),(41, 739, 4, 1, 1),(41, 740, 4, 1, 1),(41, 741, 4, 1, 1),(41, 742, 4, 1, 1),(41, 743, 4, 1, 1),(41, 744, 4, 1, 1),(41, 745, 4, 1, 1),(41, 746, 4, 1, 1),(41, 747, 4, 1, 1),(41, 748, 4, 1, 1),(41, 749, 4, 1, 1),(41, 750, 4, 1, 1),(41, 751, 4, 1, 1),(41, 752, 4, 1, 1),(41, 753, 4, 1, 1),(41, 754, 4, 1, 1),(41, 755, 4, 1, 1),(41, 756, 4, 1, 1),(41, 757, 4, 1, 1),(41, 758, 4, 1, 1),(41, 759, 4, 1, 1),(41, 760, 4, 1, 1),(41, 761, 4, 1, 1),(41, 762, 4, 1, 1),(41, 763, 4, 1, 1),(41, 764, 4, 1, 1),(41, 765, 4, 1, 1),(41, 766, 4, 1, 1),(41, 767, 4, 1, 1),(41, 768, 4, 1, 1),(41, 769, 4, 1, 1),(41, 770, 4, 1, 1),(41, 771, 4, 1, 1),(41, 772, 4, 1, 1),(41, 773, 4, 1, 1),(41, 774, 4, 1, 1),(41, 775, 4, 1, 1),(41, 776, 4, 1, 1),(41, 777, 4, 1, 1),(41, 778, 4, 1, 1),(41, 779, 4, 1, 1),(41, 780, 4, 1, 1),(41, 781, 4, 1, 1),(41, 782, 4, 1, 1),(41, 783, 4, 1, 1),(41, 784, 4, 1, 1),(41, 785, 4, 1, 1),(41, 786, 4, 1, 1),(41, 787, 4, 1, 1),(41, 788, 4, 1, 1),(41, 789, 4, 1, 1),(41, 790, 4, 1, 1),(41, 791, 4, 1, 1),(41, 792, 4, 1, 1),(41, 793, 4, 1, 1),(41, 794, 4, 1, 1),(41, 795, 4, 1, 1),(41, 796, 4, 1, 1),(41, 797, 4, 1, 1),(41, 798, 4, 1, 1),(41, 799, 4, 1, 1),(41, 800, 4, 1, 1),(41, 801, 4, 1, 1),(41, 802, 4, 1, 1),(41, 803, 4, 1, 1),(41, 804, 4, 1, 1),(41, 805, 4, 1, 1),(41, 806, 4, 1, 1),(41, 807, 4, 1, 1),(41, 808, 4, 1, 1),(41, 809, 4, 1, 1),(41, 810, 4, 1, 1),(41, 811, 4, 1, 1),(41, 812, 4, 1, 1),(41, 813, 4, 1, 1),(41, 814, 4, 1, 1),(41, 815, 4, 1, 1),(41, 816, 4, 1, 1),(41, 817, 4, 1, 1),(41, 818, 4, 1, 1),(41, 819, 4, 1, 1),(41, 820, 4, 1, 1),(41, 821, 4, 1, 1),(41, 822, 4, 1, 1),(41, 823, 4, 1, 1),(41, 824, 4, 1, 1),(41, 825, 4, 1, 1),(41, 826, 4, 1, 1),(41, 827, 4, 1, 1),(41, 828, 4, 1, 1),(41, 829, 4, 1, 1),(41, 830, 4, 1, 1),(41, 831, 4, 1, 1),(41, 832, 4, 1, 1),(41, 833, 4, 1, 1),(41, 834, 4, 1, 1),(41, 835, 4, 1, 1),(41, 836, 4, 1, 1),(41, 837, 4, 1, 1),(41, 838, 4, 1, 1),(41, 839, 4, 1, 1),(41, 840, 4, 1, 1),(41, 841, 4, 1, 1),(41, 842, 4, 1, 1),(41, 843, 4, 1, 1),(41, 844, 4, 1, 1),(41, 845, 4, 1, 1),(41, 846, 4, 1, 1),(41, 847, 4, 1, 1),(41, 848, 4, 1, 1),(41, 849, 4, 1, 1),(41, 850, 4, 1, 1),(41, 851, 4, 1, 1),(41, 852, 4, 1, 1),(41, 853, 4, 1, 1),(41, 854, 4, 1, 1),(41, 855, 4, 1, 1),(41, 856, 4, 1, 1),(41, 857, 4, 1, 1),(41, 858, 4, 1, 1),(41, 859, 4, 1, 1),(41, 860, 4, 1, 1),(41, 861, 4, 1, 1),(41, 862, 4, 1, 1),(41, 863, 4, 1, 1),(41, 864, 4, 1, 1),(41, 865, 4, 1, 1),(41, 866, 4, 1, 1),(41, 867, 4, 1, 1),(41, 868, 4, 1, 1),(41, 869, 4, 1, 1),(41, 870, 4, 1, 1),(41, 871, 4, 1, 1),(41, 872, 4, 1, 1),(41, 873, 4, 1, 1),(41, 874, 4, 1, 1),(41, 875, 4, 1, 1),(41, 876, 4, 1, 1),(41, 877, 4, 1, 1),(41, 878, 4, 1, 1),(41, 879, 4, 1, 1),(41, 880, 4, 1, 1),(41, 881, 4, 1, 1),(41, 882, 4, 1, 1),(41, 883, 4, 1, 1),(41, 884, 4, 1, 1),(41, 885, 4, 1, 1),(41, 886, 4, 1, 1),(41, 887, 4, 1, 1),(41, 888, 4, 1, 1),(41, 889, 4, 1, 1),(41, 890, 4, 1, 1),(41, 891, 4, 1, 1),(41, 892, 4, 1, 1),(41, 893, 4, 1, 1),(41, 894, 4, 1, 1),(41, 895, 4, 1, 1),(41, 896, 4, 1, 1),(41, 897, 4, 1, 1),(41, 898, 4, 1, 1),(41, 899, 4, 1, 1),(41, 900, 4, 1, 1),(41, 901, 4, 1, 1),(41, 902, 4, 1, 1),(41, 903, 4, 1, 1),(41, 904, 4, 1, 1),(41, 905, 4, 1, 1),(41, 906, 4, 1, 1),(41, 907, 4, 1, 1),(41, 908, 4, 1, 1),(41, 909, 4, 1, 1),(41, 910, 4, 1, 1),(41, 911, 4, 1, 1),(41, 912, 4, 1, 1),(41, 913, 4, 1, 1),(41, 914, 4, 1, 1),(41, 915, 4, 1, 1),(41, 916, 4, 1, 1),(41, 917, 4, 1, 1),(41, 918, 4, 1, 1),(41, 919, 4, 1, 1),(41, 920, 4, 1, 1),(41, 921, 4, 1, 1),(41, 922, 4, 1, 1),(41, 923, 4, 1, 1),(41, 924, 4, 1, 1),(41, 925, 4, 1, 1),(41, 926, 4, 1, 1),(41, 927, 4, 1, 1),(41, 928, 4, 1, 1),(41, 929, 4, 1, 1),(41, 930, 4, 1, 1),(41, 931, 4, 1, 1),(41, 932, 4, 1, 1),(41, 933, 4, 1, 1),(41, 934, 4, 1, 1),(41, 935, 4, 1, 1),(41, 936, 4, 1, 1),(41, 937, 4, 1, 1),(41, 938, 4, 1, 1),(41, 939, 4, 1, 1),(41, 940, 4, 1, 1),(41, 941, 4, 1, 1),(41, 942, 4, 1, 1),(41, 943, 4, 1, 1),(41, 944, 4, 1, 1),(41, 945, 4, 1, 1),(41, 946, 4, 1, 1),(41, 947, 4, 1, 1),(41, 948, 4, 1, 1),(41, 949, 4, 1, 1),(41, 950, 4, 1, 1),(41, 951, 4, 1, 1),(41, 952, 4, 1, 1),(41, 953, 4, 1, 1),(41, 954, 4, 1, 1),(41, 955, 4, 1, 1),(41, 956, 4, 1, 1),(41, 957, 4, 1, 1),(41, 958, 4, 1, 1),(41, 959, 4, 1, 1),(41, 960, 4, 1, 1),(41, 961, 4, 1, 1),(41, 962, 4, 1, 1),(41, 963, 4, 1, 1),(41, 964, 4, 1, 1),(41, 965, 4, 1, 1),(41, 966, 4, 1, 1),(41, 967, 4, 1, 1),(41, 968, 4, 1, 1),(41, 969, 4, 1, 1),(41, 970, 4, 1, 1),(41, 971, 4, 1, 1),(41, 972, 4, 1, 1),(41, 973, 4, 1, 1),(41, 974, 4, 1, 1),(41, 975, 4, 1, 1),(41, 976, 4, 1, 1),(41, 977, 4, 1, 1),(41, 978, 4, 1, 1),(41, 979, 4, 1, 1),(41, 980, 4, 1, 1),(41, 981, 4, 1, 1),(41, 982, 4, 1, 1),(41, 983, 4, 1, 1),(41, 984, 4, 1, 1),(41, 985, 4, 1, 1),(41, 986, 4, 1, 1),(41, 987, 4, 1, 1),(41, 988, 4, 1, 1),(41, 989, 4, 1, 1),(41, 990, 4, 1, 1),(41, 991, 4, 1, 1),(41, 992, 4, 1, 1),(41, 993, 4, 1, 1),(41, 994, 4, 1, 1),(41, 995, 4, 1, 1),(41, 996, 4, 1, 1),(41, 997, 4, 1, 1),(41, 998, 4, 1, 1),(41, 999, 4, 1, 1),(41, 1000, 4, 1, 1),(41, 1001, 4, 1, 1),(41, 1002, 4, 1, 1),(41, 1003, 4, 1, 1),(41, 1004, 4, 1, 1),(41, 1005, 4, 1, 1),(41, 1006, 4, 1, 1),(41, 1007, 4, 1, 1),(41, 1008, 4, 1, 1),(41, 1009, 4, 1, 1),(41, 1010, 4, 1, 1),(41, 1011, 4, 1, 1),(41, 1012, 4, 1, 1),(41, 1013, 4, 1, 1),(41, 1014, 4, 1, 1),(41, 1015, 4, 1, 1),(41, 1016, 4, 1, 1),(41, 1017, 4, 1, 1),(41, 1018, 4, 1, 1),(41, 1019, 4, 1, 1),(41, 1020, 4, 1, 1),(41, 1021, 4, 1, 1),(41, 1022, 4, 1, 1),(41, 1023, 4, 1, 1),(41, 1024, 4, 1, 1),(41, 1025, 4, 1, 1),(41, 1026, 4, 1, 1),(41, 1027, 4, 1, 1),(41, 1028, 4, 1, 1),(41, 1029, 4, 1, 1),(41, 1030, 4, 1, 1),(41, 1031, 4, 1, 1),(41, 1032, 4, 1, 1),(41, 1033, 4, 1, 1),(41, 1034, 4, 1, 1),(41, 1035, 4, 1, 1),(41, 1036, 4, 1, 1),(41, 1037, 4, 1, 1),(41, 1038, 4, 1, 1),(41, 1039, 4, 1, 1),(41, 1040, 4, 1, 1),(41, 1041, 4, 1, 1),(41, 1042, 4, 1, 1),(41, 1043, 4, 1, 1),(41, 1044, 4, 1, 1),(41, 1045, 4, 1, 1),(41, 1046, 4, 1, 1),(41, 1047, 4, 1, 1),(41, 1048, 4, 1, 1),(41, 1049, 4, 1, 1),(41, 1050, 4, 1, 1),(41, 1051, 4, 1, 1),(41, 1052, 4, 1, 1),(41, 1053, 4, 1, 1),(41, 1054, 4, 1, 1),(41, 1055, 4, 1, 1),(41, 1056, 4, 1, 1),(41, 1057, 4, 1, 1),(41, 1058, 4, 1, 1),(41, 1059, 4, 1, 1),(41, 1060, 4, 1, 1),(41, 1061, 4, 1, 1),(41, 1062, 4, 1, 1),(41, 1063, 4, 1, 1),(41, 1064, 4, 1, 1),(41, 1065, 4, 1, 1),(41, 1066, 4, 1, 1),(41, 1067, 4, 1, 1),(41, 1068, 4, 1, 1),(41, 1069, 4, 1, 1),(41, 1070, 4, 1, 1),(41, 1071, 4, 1, 1),(41, 1072, 4, 1, 1),(41, 1073, 4, 1, 1),(41, 1074, 4, 1, 1),(41, 1075, 4, 1, 1),(41, 1076, 4, 1, 1),(41, 1077, 4, 1, 1),(41, 1078, 4, 1, 1),(41, 1079, 4, 1, 1),(41, 1080, 4, 1, 1),(41, 1081, 4, 1, 1),(41, 1082, 4, 1, 1),(41, 1083, 4, 1, 1),(41, 1084, 4, 1, 1),(41, 1085, 4, 1, 1),(41, 1086, 4, 1, 1),(41, 1087, 4, 1, 1),(41, 1088, 4, 1, 1),(41, 1089, 4, 1, 1),(41, 1090, 4, 1, 1),(41, 1091, 4, 1, 1),(41, 1092, 4, 1, 1),(41, 1093, 4, 1, 1),(41, 1094, 4, 1, 1),(41, 1095, 4, 1, 1),(41, 1096, 4, 1, 1),(41, 1097, 4, 1, 1),(41, 1098, 4, 1, 1),(41, 1099, 4, 1, 1),(41, 1100, 4, 1, 1),(41, 1101, 4, 1, 1),(41, 1102, 4, 1, 1),(41, 1103, 4, 1, 1),(41, 1104, 4, 1, 1),(41, 1105, 4, 1, 1),(41, 1106, 4, 1, 1),(41, 1107, 4, 1, 1),(41, 1108, 4, 1, 1),(41, 1109, 4, 1, 1),(41, 1110, 4, 1, 1),(41, 1111, 4, 1, 1),(41, 1112, 4, 1, 1),(41, 1113, 4, 1, 1),(41, 1114, 4, 1, 1),(41, 1115, 4, 1, 1),(41, 1116, 4, 1, 1),(41, 1117, 4, 1, 1),(41, 1118, 4, 1, 1),(41, 1119, 4, 1, 1),(41, 1120, 4, 1, 1),(41, 1121, 4, 1, 1),(41, 1122, 4, 1, 1),(41, 1123, 4, 1, 1),(41, 1124, 4, 1, 1),(41, 1125, 4, 1, 1),(41, 1126, 4, 1, 1),(41, 1127, 4, 1, 1),(41, 1128, 4, 1, 1),(41, 1129, 4, 1, 1),(41, 1130, 4, 1, 1),(41, 1131, 4, 1, 1),(41, 1132, 4, 1, 1),(41, 1133, 4, 1, 1),(41, 1134, 4, 1, 1),(41, 1135, 4, 1, 1),(41, 1136, 4, 1, 1),(41, 1137, 4, 1, 1),(41, 1138, 4, 1, 1),(41, 1139, 4, 1, 1),(41, 1140, 4, 1, 1),(41, 1141, 4, 1, 1),(41, 1142, 4, 1, 1),(41, 1143, 4, 1, 1),(41, 1144, 4, 1, 1),(41, 1145, 4, 1, 1),(41, 1146, 4, 1, 1),(41, 1147, 4, 1, 1),(41, 1148, 4, 1, 1),(41, 1149, 4, 1, 1),(41, 1150, 4, 1, 1),(41, 1151, 4, 1, 1),(41, 1152, 4, 1, 1),(41, 1153, 4, 1, 1),(41, 1154, 4, 1, 1),(41, 1155, 4, 1, 1),(41, 1156, 4, 1, 1),(41, 1157, 4, 1, 1),(41, 1158, 4, 1, 1),(41, 1159, 4, 1, 1),(41, 1160, 4, 1, 1),(41, 1161, 4, 1, 1),(41, 1162, 4, 1, 1),(41, 1163, 4, 1, 1),(41, 1164, 4, 1, 1),(41, 1165, 4, 1, 1),(41, 1166, 4, 1, 1),(41, 1167, 4, 1, 1),(41, 1168, 4, 1, 1),(41, 1169, 4, 1, 1),(41, 1170, 4, 1, 1),(41, 1171, 4, 1, 1),(41, 1172, 4, 1, 1),(41, 1173, 4, 1, 1),(41, 1174, 4, 1, 1),(41, 1175, 4, 1, 1),(41, 1176, 4, 1, 1),(41, 1177, 4, 1, 1),(41, 1178, 4, 1, 1),(41, 1179, 4, 1, 1),(41, 1180, 4, 1, 1),(41, 1181, 4, 1, 1),(41, 1182, 4, 1, 1),(41, 1183, 4, 1, 1),(41, 1184, 4, 1, 1),(41, 1185, 4, 1, 1),(41, 1186, 4, 1, 1),(41, 1187, 4, 1, 1),(41, 1188, 4, 1, 1),(41, 1189, 4, 1, 1),(41, 1190, 4, 1, 1),(41, 1191, 4, 1, 1),(41, 1192, 4, 1, 1),(41, 1193, 4, 1, 1),(41, 1194, 4, 1, 1),(41, 1195, 4, 1, 1),(41, 1196, 4, 1, 1),(41, 1197, 4, 1, 1),(41, 1198, 4, 1, 1),(41, 1199, 4, 1, 1),(41, 1200, 4, 1, 1),(41, 1201, 4, 1, 1),(41, 1202, 4, 1, 1),(41, 1203, 4, 1, 1),(41, 1204, 4, 1, 1),(41, 1205, 4, 1, 1),(41, 1206, 4, 1, 1),(41, 1207, 4, 1, 1),(41, 1208, 4, 1, 1),(41, 1209, 4, 1, 1),(41, 1210, 4, 1, 1),(41, 1211, 4, 1, 1),(41, 1212, 4, 1, 1),(41, 1213, 4, 1, 1),(41, 1214, 4, 1, 1),(41, 1215, 4, 1, 1),(41, 1216, 4, 1, 1),(41, 1217, 4, 1, 1),(41, 1218, 4, 1, 1),(41, 1219, 4, 1, 1),(41, 1220, 4, 1, 1),(41, 1221, 4, 1, 1),(41, 1222, 4, 1, 1),(41, 1223, 4, 1, 1),(41, 1224, 4, 1, 1),(41, 1225, 4, 1, 1),(41, 1226, 4, 1, 1),(41, 1227, 4, 1, 1),(41, 1228, 4, 1, 1),(41, 1229, 4, 1, 1),(41, 1230, 4, 1, 1),(41, 1231, 4, 1, 1),(41, 1232, 4, 1, 1),(41, 1233, 4, 1, 1),(41, 1234, 4, 1, 1),(41, 1235, 4, 1, 1),(41, 1236, 4, 1, 1),(41, 1237, 4, 1, 1),(41, 1238, 4, 1, 1),(41, 1239, 4, 1, 1),(41, 1240, 4, 1, 1),(41, 1241, 4, 1, 1),(41, 1242, 4, 1, 1),(41, 1243, 4, 1, 1),(41, 1244, 4, 1, 1),(41, 1245, 4, 1, 1),(41, 1246, 4, 1, 1),(41, 1247, 4, 1, 1),(41, 1248, 4, 1, 1),(41, 1249, 4, 1, 1),(41, 1250, 4, 1, 1),(41, 1251, 4, 1, 1),(41, 1252, 4, 1, 1),(41, 1253, 4, 1, 1),(41, 1254, 4, 1, 1),(41, 1255, 4, 1, 1),(41, 1256, 4, 1, 1),(41, 1257, 4, 1, 1),(41, 1258, 4, 1, 1),(41, 1259, 4, 1, 1),(41, 1260, 4, 1, 1),(41, 1261, 4, 1, 1),(41, 1262, 4, 1, 1),(41, 1263, 4, 1, 1),(41, 1264, 4, 1, 1),(41, 1265, 4, 1, 1),(41, 1266, 4, 1, 1),(41, 1267, 4, 1, 1),(41, 1268, 4, 1, 1),(41, 1269, 4, 1, 1),(41, 1270, 4, 1, 1),(41, 1271, 4, 1, 1),(41, 1272, 4, 1, 1),(41, 1273, 4, 1, 1),(41, 1274, 4, 1, 1),(41, 1275, 4, 1, 1),(41, 1276, 4, 1, 1),(41, 1277, 4, 1, 1),(41, 1278, 4, 1, 1),(41, 1279, 4, 1, 1),(41, 1280, 4, 1, 1),(41, 1281, 4, 1, 1),(41, 1282, 4, 1, 1),(41, 1283, 4, 1, 1),(41, 1284, 4, 1, 1),(41, 1285, 4, 1, 1),(41, 1286, 4, 1, 1),(41, 1287, 4, 1, 1),(41, 1288, 4, 1, 1),(41, 1289, 4, 1, 1),(41, 1290, 4, 1, 1),(41, 1291, 4, 1, 1),(41, 1292, 4, 1, 1),(41, 1293, 4, 1, 1),(41, 1294, 4, 1, 1),(41, 1295, 4, 1, 1),(41, 1296, 4, 1, 1),(41, 1297, 4, 1, 1),(41, 1298, 4, 1, 1),(41, 1299, 4, 1, 1),(41, 1300, 4, 1, 1),(41, 1301, 4, 1, 1),(41, 1302, 4, 1, 1),(41, 1303, 4, 1, 1),(41, 1304, 4, 1, 1),(41, 1305, 4, 1, 1),(41, 1306, 4, 1, 1),(41, 1307, 4, 1, 1),(41, 1308, 4, 1, 1),(41, 1309, 4, 1, 1),(41, 1310, 4, 1, 1),(41, 1311, 4, 1, 1),(41, 1312, 4, 1, 1),(41, 1313, 4, 1, 1),(41, 1314, 4, 1, 1),(41, 1315, 4, 1, 1),(41, 1316, 4, 1, 1),(41, 1317, 4, 1, 1),(41, 1318, 4, 1, 1),(41, 1319, 4, 1, 1),(41, 1320, 4, 1, 1),(41, 1321, 4, 1, 1),(41, 1322, 4, 1, 1),(41, 1323, 4, 1, 1),(41, 1324, 4, 1, 1),(41, 1325, 4, 1, 1),(41, 1326, 4, 1, 1),(41, 1327, 4, 1, 1),(41, 1328, 4, 1, 1),(41, 1329, 4, 1, 1),(41, 1330, 4, 1, 1),(41, 1331, 4, 1, 1),(41, 1332, 4, 1, 1),(41, 1333, 4, 1, 1),(41, 1334, 4, 1, 1),(41, 1335, 4, 1, 1),(41, 1336, 4, 1, 1),(41, 1337, 4, 1, 1),(41, 1338, 4, 1, 1),(41, 1339, 4, 1, 1),(41, 1340, 4, 1, 1),(41, 1341, 4, 1, 1),(41, 1342, 4, 1, 1),(41, 1343, 4, 1, 1),(41, 1344, 4, 1, 1),(41, 1345, 4, 1, 1),(41, 1346, 4, 1, 1),(41, 1347, 4, 1, 1),(41, 1348, 4, 1, 1),(41, 1349, 4, 1, 1),(41, 1350, 4, 1, 1),(41, 1351, 4, 1, 1),(41, 1352, 4, 1, 1),(41, 1353, 4, 1, 1),(41, 1354, 4, 1, 1),(41, 1355, 4, 1, 1),(41, 1356, 4, 1, 1),(41, 1357, 4, 1, 1),(41, 1358, 4, 1, 1),(41, 1359, 4, 1, 1),(41, 1360, 4, 1, 1),(41, 1361, 4, 1, 1),(41, 1362, 4, 1, 1),(41, 1363, 4, 1, 1),(41, 1364, 4, 1, 1),(41, 1365, 4, 1, 1),(41, 1366, 4, 1, 1),(41, 1367, 4, 1, 1),(41, 1368, 4, 1, 1),(41, 1369, 4, 1, 1),(41, 1370, 4, 1, 1),(41, 1371, 4, 1, 1),(41, 1372, 4, 1, 1),(41, 1373, 4, 1, 1),(41, 1374, 4, 1, 1),(41, 1375, 4, 1, 1),(41, 1376, 4, 1, 1),(41, 1377, 4, 1, 1),(41, 1378, 4, 1, 1),(41, 1379, 4, 1, 1),(41, 1380, 4, 1, 1),(41, 1381, 4, 1, 1),(41, 1382, 4, 1, 1),(41, 1383, 4, 1, 1),(41, 1384, 4, 1, 1),(41, 1385, 4, 1, 1),(41, 1386, 4, 1, 1),(41, 1387, 4, 1, 1),(41, 1388, 4, 1, 1),(41, 1389, 4, 1, 1),(41, 1390, 4, 1, 1),(41, 1391, 4, 1, 1),(41, 1392, 4, 1, 1),(41, 1393, 4, 1, 1),(41, 1394, 4, 1, 1),(41, 1395, 4, 1, 1),(41, 1396, 4, 1, 1),(41, 1397, 4, 1, 1),(41, 1398, 4, 1, 1),(41, 1399, 4, 1, 1),(41, 1400, 4, 1, 1),(41, 1401, 4, 1, 1),(41, 1402, 4, 1, 1),(41, 1403, 4, 1, 1),(41, 1404, 4, 1, 1),(41, 1405, 4, 1, 1),(41, 1406, 4, 1, 1),(41, 1407, 4, 1, 1),(41, 1408, 4, 1, 1),(41, 1409, 4, 1, 1),(41, 1410, 4, 1, 1),(41, 1411, 4, 1, 1),(41, 1412, 4, 1, 1),(41, 1413, 4, 1, 1),(41, 1414, 4, 1, 1),(41, 1415, 4, 1, 1),(41, 1416, 4, 1, 1),(41, 1417, 4, 1, 1),(41, 1418, 4, 1, 1),(41, 1419, 4, 1, 1),(41, 1420, 4, 1, 1),(41, 1421, 4, 1, 1),(41, 1422, 4, 1, 1),(41, 1423, 4, 1, 1),(41, 1424, 4, 1, 1),(41, 1425, 4, 1, 1),(41, 1426, 4, 1, 1),(41, 1427, 4, 1, 1),(41, 1428, 4, 1, 1),(41, 1429, 4, 1, 1),(41, 1430, 4, 1, 1),(41, 1431, 4, 1, 1),(41, 1432, 4, 1, 1),(41, 1433, 4, 1, 1),(41, 1434, 4, 1, 1),(41, 1435, 4, 1, 1),(41, 1436, 4, 1, 1),(41, 1437, 4, 1, 1),(41, 1438, 4, 1, 1),(41, 1439, 4, 1, 1),(41, 1440, 4, 1, 1),(41, 1441, 4, 1, 1),(41, 1442, 4, 1, 1),(41, 1443, 4, 1, 1),(41, 1444, 4, 1, 1),(41, 1445, 4, 1, 1),(41, 1446, 4, 1, 1),(41, 1447, 4, 1, 1),(41, 1448, 4, 1, 1),(41, 1449, 4, 1, 1),(41, 1450, 4, 1, 1),(41, 1451, 4, 1, 1),(41, 1452, 4, 1, 1),(41, 1453, 4, 1, 1),(41, 1454, 4, 1, 1),(41, 1455, 4, 1, 1),(41, 1456, 4, 1, 1),(41, 1457, 4, 1, 1),(41, 1458, 4, 1, 1),(41, 1459, 4, 1, 1),(41, 1460, 4, 1, 1),(41, 1461, 4, 1, 1),(41, 1462, 4, 1, 1),(41, 1463, 4, 1, 1),(41, 1464, 4, 1, 1),(41, 1465, 4, 1, 1),(41, 1466, 4, 1, 1),(41, 1467, 4, 1, 1),(41, 1468, 4, 1, 1),(41, 1469, 4, 1, 1),(41, 1470, 4, 1, 1),(41, 1471, 4, 1, 1),(41, 1472, 4, 1, 1),(41, 1473, 4, 1, 1),(41, 1474, 4, 1, 1),(41, 1475, 4, 1, 1),(41, 1476, 4, 1, 1),(41, 1477, 4, 1, 1),(41, 1478, 4, 1, 1),(41, 1479, 4, 1, 1),(41, 1480, 4, 1, 1),(41, 1481, 4, 1, 1),(41, 1482, 4, 1, 1),(41, 1483, 4, 1, 1),(41, 1484, 4, 1, 1),(41, 1485, 4, 1, 1),(41, 1486, 4, 1, 1),(41, 1487, 4, 1, 1),(41, 1488, 4, 1, 1),(41, 1489, 4, 1, 1),(41, 1490, 4, 1, 1),(41, 1491, 4, 1, 1),(41, 1492, 4, 1, 1),(41, 1493, 4, 1, 1),(41, 1494, 4, 1, 1),(41, 1495, 4, 1, 1),(41, 1496, 4, 1, 1),(41, 1497, 4, 1, 1),(41, 1498, 4, 1, 1),(41, 1499, 4, 1, 1),(41, 1500, 4, 1, 1),(41, 1501, 4, 1, 1),(41, 1502, 4, 1, 1),(41, 1503, 4, 1, 1),(41, 1504, 4, 1, 1),(41, 1505, 4, 1, 1),(41, 1506, 4, 1, 1),(41, 1507, 4, 1, 1),(41, 1508, 4, 1, 1),(41, 1509, 4, 1, 1),(41, 1510, 4, 1, 1),(41, 1511, 4, 1, 1),(41, 1512, 4, 1, 1),(41, 1513, 4, 1, 1),(41, 1514, 4, 1, 1),(41, 1515, 4, 1, 1),(41, 1516, 4, 1, 1),(41, 1517, 4, 1, 1),(41, 1518, 4, 1, 1),(41, 1519, 4, 1, 1),(41, 1520, 4, 1, 1),(41, 1521, 4, 1, 1),(41, 1522, 4, 1, 1),(41, 1523, 4, 1, 1),(41, 1524, 4, 1, 1),(41, 1525, 4, 1, 1),(41, 1526, 4, 1, 1),(41, 1527, 4, 1, 1),(41, 1528, 4, 1, 1),(41, 1529, 4, 1, 1),(41, 1530, 4, 1, 1),(41, 1531, 4, 1, 1),(41, 1532, 4, 1, 1),(41, 1533, 4, 1, 1),(41, 1534, 4, 1, 1),(41, 1535, 4, 1, 1),(41, 1536, 4, 1, 1),(42, 1, 4, 1, 1),(42, 2, 4, 1, 1),(42, 3, 4, 1, 1),(42, 4, 4, 1, 1),(42, 5, 4, 1, 1),(42, 6, 4, 1, 1),(42, 7, 4, 1, 1),(42, 8, 4, 1, 1),(42, 9, 4, 1, 1),(42, 10, 4, 1, 1),(42, 11, 4, 1, 1),(42, 12, 4, 1, 1),(42, 13, 4, 1, 1),(42, 14, 4, 1, 1),(42, 15, 4, 1, 1),(42, 16, 4, 1, 1),(42, 17, 4, 1, 1),(42, 18, 4, 1, 1),(42, 19, 4, 1, 1),(42, 20, 4, 1, 1),(42, 21, 4, 1, 1),(42, 22, 4, 1, 1),(42, 23, 4, 1, 1),(42, 24, 4, 1, 1),(42, 25, 4, 1, 1),(42, 26, 4, 1, 1),(42, 27, 4, 1, 1),(42, 28, 4, 1, 1),(42, 29, 4, 1, 1),(42, 30, 4, 1, 1),(42, 31, 4, 1, 1),(42, 32, 4, 1, 1),(42, 33, 4, 1, 1),(42, 34, 4, 1, 1),(42, 35, 4, 1, 1),(42, 36, 4, 1, 1),(42, 37, 4, 1, 1),(42, 38, 4, 1, 1),(42, 39, 4, 1, 1),(42, 40, 4, 1, 1),(42, 41, 4, 1, 1),(42, 42, 4, 1, 1),(42, 43, 4, 1, 1),(42, 44, 4, 1, 1),(42, 45, 4, 1, 1),(42, 46, 4, 1, 1),(42, 47, 4, 1, 1),(42, 48, 4, 1, 1),(42, 49, 4, 1, 1),(42, 50, 4, 1, 1),(42, 51, 4, 1, 1),(42, 52, 4, 1, 1),(42, 53, 4, 1, 1),(42, 54, 4, 1, 1),(42, 55, 4, 1, 1),(42, 56, 4, 1, 1),(42, 57, 4, 1, 1),(42, 58, 4, 1, 1),(42, 59, 4, 1, 1),(42, 60, 4, 1, 1),(42, 61, 4, 1, 1),(42, 62, 4, 1, 1),(42, 63, 4, 1, 1),(42, 64, 4, 1, 1),(42, 65, 4, 1, 1),(42, 66, 4, 1, 1),(42, 67, 4, 1, 1),(42, 68, 4, 1, 1),(42, 69, 4, 1, 1),(42, 70, 4, 1, 1),(42, 71, 4, 1, 1),(42, 72, 4, 1, 1),(42, 73, 4, 1, 1),(42, 74, 4, 1, 1),(42, 75, 4, 1, 1),(42, 76, 4, 1, 1),(42, 77, 4, 1, 1),(42, 78, 4, 1, 1),(42, 79, 4, 1, 1),(42, 80, 4, 1, 1),(42, 81, 4, 1, 1),(42, 82, 4, 1, 1),(42, 83, 4, 1, 1),(42, 84, 4, 1, 1),(42, 85, 4, 1, 1),(42, 86, 4, 1, 1),(42, 87, 4, 1, 1),(42, 88, 4, 1, 1),(42, 89, 4, 1, 1),(42, 90, 4, 1, 1),(42, 91, 4, 1, 1),(42, 92, 4, 1, 1),(42, 93, 4, 1, 1),(42, 94, 4, 1, 1),(42, 95, 4, 1, 1),(42, 96, 4, 1, 1),(42, 97, 4, 1, 1),(42, 98, 4, 1, 1),(42, 99, 4, 1, 1),(42, 100, 4, 1, 1),(42, 101, 4, 1, 1),(42, 102, 4, 1, 1),(42, 103, 4, 1, 1),(42, 104, 4, 1, 1),(42, 105, 4, 1, 1),(42, 106, 4, 1, 1),(42, 107, 4, 1, 1),(42, 108, 4, 1, 1),(42, 109, 4, 1, 1),(42, 110, 4, 1, 1),(42, 111, 4, 1, 1),(42, 112, 4, 1, 1),(42, 113, 4, 1, 1),(42, 114, 4, 1, 1),(42, 115, 4, 1, 1),(42, 116, 4, 1, 1),(42, 117, 4, 1, 1),(42, 118, 4, 1, 1),(42, 119, 4, 1, 1),(42, 120, 4, 1, 1),(42, 121, 4, 1, 1),(42, 122, 4, 1, 1),(42, 123, 4, 1, 1),(42, 124, 4, 1, 1),(42, 125, 4, 1, 1),(42, 126, 4, 1, 1),(42, 127, 4, 1, 1),(42, 128, 4, 1, 1),(42, 129, 4, 1, 1),(42, 130, 4, 1, 1),(42, 131, 4, 1, 1),(42, 132, 4, 1, 1),(42, 133, 4, 1, 1),(42, 134, 4, 1, 1),(42, 135, 4, 1, 1),(42, 136, 4, 1, 1),(42, 137, 4, 1, 1),(42, 138, 4, 1, 1),(42, 139, 4, 1, 1),(42, 140, 4, 1, 1),(42, 141, 4, 1, 1),(42, 142, 4, 1, 1),(42, 143, 4, 1, 1),(42, 144, 4, 1, 1),(42, 145, 4, 1, 1),(42, 146, 4, 1, 1),(42, 147, 4, 1, 1),(42, 148, 4, 1, 1),(42, 149, 4, 1, 1),(42, 150, 4, 1, 1),(42, 151, 4, 1, 1),(42, 152, 4, 1, 1),(42, 153, 4, 1, 1),(42, 154, 4, 1, 1),(42, 155, 4, 1, 1),(42, 156, 4, 1, 1),(42, 157, 4, 1, 1),(42, 158, 4, 1, 1),(42, 159, 4, 1, 1),(42, 160, 4, 1, 1),(42, 161, 4, 1, 1),(42, 162, 4, 1, 1),(42, 163, 4, 1, 1),(42, 164, 4, 1, 1),(42, 165, 4, 1, 1),(42, 166, 4, 1, 1),(42, 167, 4, 1, 1),(42, 168, 4, 1, 1),(42, 169, 4, 1, 1),(42, 170, 4, 1, 1),(42, 171, 4, 1, 1),(42, 172, 4, 1, 1),(42, 173, 4, 1, 1),(42, 174, 4, 1, 1),(42, 175, 4, 1, 1),(42, 176, 4, 1, 1),(42, 177, 4, 1, 1),(42, 178, 4, 1, 1),(42, 179, 4, 1, 1),(42, 180, 4, 1, 1),(42, 181, 4, 1, 1),(42, 182, 4, 1, 1),(42, 183, 4, 1, 1),(42, 184, 4, 1, 1),(42, 185, 4, 1, 1),(42, 186, 4, 1, 1),(42, 187, 4, 1, 1),(42, 188, 4, 1, 1),(42, 189, 4, 1, 1),(42, 190, 4, 1, 1),(42, 191, 4, 1, 1),(42, 192, 4, 1, 1),(42, 193, 4, 1, 1),(42, 194, 4, 1, 1),(42, 195, 4, 1, 1),(42, 196, 4, 1, 1),(42, 197, 4, 1, 1),(42, 198, 4, 1, 1),(42, 199, 4, 1, 1),(42, 200, 4, 1, 1),(42, 201, 4, 1, 1),(42, 202, 4, 1, 1),(42, 203, 4, 1, 1),(42, 204, 4, 1, 1),(42, 205, 4, 1, 1),(42, 206, 4, 1, 1),(42, 207, 4, 1, 1),(42, 208, 4, 1, 1),(42, 209, 4, 1, 1),(42, 210, 4, 1, 1),(42, 211, 4, 1, 1),(42, 212, 4, 1, 1),(42, 213, 4, 1, 1),(42, 214, 4, 1, 1),(42, 215, 4, 1, 1),(42, 216, 4, 1, 1),(42, 217, 4, 1, 1),(42, 218, 4, 1, 1),(42, 219, 4, 1, 1),(42, 220, 4, 1, 1),(42, 221, 4, 1, 1),(42, 222, 4, 1, 1),(42, 223, 4, 1, 1),(42, 224, 4, 1, 1),(42, 225, 4, 1, 1),(42, 226, 4, 1, 1),(42, 227, 4, 1, 1),(42, 228, 4, 1, 1),(42, 229, 4, 1, 1),(42, 230, 4, 1, 1),(42, 231, 4, 1, 1),(42, 232, 4, 1, 1),(42, 233, 4, 1, 1),(42, 234, 4, 1, 1),(42, 235, 4, 1, 1),(42, 236, 4, 1, 1),(42, 237, 4, 1, 1),(42, 238, 4, 1, 1),(42, 239, 4, 1, 1),(42, 240, 4, 1, 1),(42, 241, 4, 1, 1),(42, 242, 4, 1, 1),(42, 243, 4, 1, 1),(42, 244, 4, 1, 1),(42, 245, 4, 1, 1),(42, 246, 4, 1, 1),(42, 247, 4, 1, 1),(42, 248, 4, 1, 1),(42, 249, 4, 1, 1),(42, 250, 4, 1, 1),(42, 251, 4, 1, 1),(42, 252, 4, 1, 1),(42, 253, 4, 1, 1),(42, 254, 4, 1, 1),(42, 255, 4, 1, 1),(42, 256, 4, 1, 1),(42, 257, 4, 1, 1),(42, 258, 4, 1, 1),(42, 259, 4, 1, 1),(42, 260, 4, 1, 1),(42, 261, 4, 1, 1),(42, 262, 4, 1, 1),(42, 263, 4, 1, 1),(42, 264, 4, 1, 1),(42, 265, 4, 1, 1),(42, 266, 4, 1, 1),(42, 267, 4, 1, 1),(42, 268, 4, 1, 1),(42, 269, 4, 1, 1),(42, 270, 4, 1, 1),(42, 271, 4, 1, 1),(42, 272, 4, 1, 1),(42, 273, 4, 1, 1),(42, 274, 4, 1, 1),(42, 275, 4, 1, 1),(42, 276, 4, 1, 1),(42, 277, 4, 1, 1),(42, 278, 4, 1, 1),(42, 279, 4, 1, 1),(42, 280, 4, 1, 1),(42, 281, 4, 1, 1),(42, 282, 4, 1, 1),(42, 283, 4, 1, 1),(42, 284, 4, 1, 1),(42, 285, 4, 1, 1),(42, 286, 4, 1, 1),(42, 287, 4, 1, 1),(42, 288, 4, 1, 1),(42, 289, 4, 1, 1),(42, 290, 4, 1, 1),(42, 291, 4, 1, 1),(42, 292, 4, 1, 1),(42, 293, 4, 1, 1),(42, 294, 4, 1, 1),(42, 295, 4, 1, 1),(42, 296, 4, 1, 1),(42, 297, 4, 1, 1),(42, 298, 4, 1, 1),(42, 299, 4, 1, 1),(42, 300, 4, 1, 1),(42, 301, 4, 1, 1),(42, 302, 4, 1, 1),(42, 303, 4, 1, 1),(42, 304, 4, 1, 1),(42, 305, 4, 1, 1),(42, 306, 4, 1, 1),(42, 307, 4, 1, 1),(42, 308, 4, 1, 1),(42, 309, 4, 1, 1),(42, 310, 4, 1, 1),(42, 311, 4, 1, 1),(42, 312, 4, 1, 1),(42, 313, 4, 1, 1),(42, 314, 4, 1, 1),(42, 315, 4, 1, 1),(42, 316, 4, 1, 1),(42, 317, 4, 1, 1),(42, 318, 4, 1, 1),(42, 319, 4, 1, 1),(42, 320, 4, 1, 1),(42, 321, 4, 1, 1),(42, 322, 4, 1, 1),(42, 323, 4, 1, 1),(42, 324, 4, 1, 1),(42, 325, 4, 1, 1),(42, 326, 4, 1, 1),(42, 327, 4, 1, 1),(42, 328, 4, 1, 1),(42, 329, 4, 1, 1),(42, 330, 4, 1, 1),(42, 331, 4, 1, 1),(42, 332, 4, 1, 1),(42, 333, 4, 1, 1),(42, 334, 4, 1, 1),(42, 335, 4, 1, 1),(42, 336, 4, 1, 1),(42, 337, 4, 1, 1),(42, 338, 4, 1, 1),(42, 339, 4, 1, 1),(42, 340, 4, 1, 1),(42, 341, 4, 1, 1),(42, 342, 4, 1, 1),(42, 343, 4, 1, 1),(42, 344, 4, 1, 1),(42, 345, 4, 1, 1),(42, 346, 4, 1, 1),(42, 347, 4, 1, 1),(42, 348, 4, 1, 1),(42, 349, 4, 1, 1),(42, 350, 4, 1, 1),(42, 351, 4, 1, 1),(42, 352, 4, 1, 1),(42, 353, 4, 1, 1),(42, 354, 4, 1, 1),(42, 355, 4, 1, 1),(42, 356, 4, 1, 1),(42, 357, 4, 1, 1),(42, 358, 4, 1, 1),(42, 359, 4, 1, 1),(42, 360, 4, 1, 1),(42, 361, 4, 1, 1),(42, 362, 4, 1, 1),(42, 363, 4, 1, 1),(42, 364, 4, 1, 1),(42, 365, 4, 1, 1),(42, 366, 4, 1, 1),(42, 367, 4, 1, 1),(42, 368, 4, 1, 1),(42, 369, 4, 1, 1),(42, 370, 4, 1, 1),(42, 371, 4, 1, 1),(42, 372, 4, 1, 1),(42, 373, 4, 1, 1),(42, 374, 4, 1, 1),(42, 375, 4, 1, 1),(42, 376, 4, 1, 1),(42, 377, 4, 1, 1),(42, 378, 4, 1, 1),(42, 379, 4, 1, 1),(42, 380, 4, 1, 1),(42, 381, 4, 1, 1),(42, 382, 4, 1, 1),(42, 383, 4, 1, 1),(42, 384, 4, 1, 1),(42, 385, 4, 1, 1),(42, 386, 4, 1, 1),(42, 387, 4, 1, 1),(42, 388, 4, 1, 1),(42, 389, 4, 1, 1),(42, 390, 4, 1, 1),(42, 391, 4, 1, 1),(42, 392, 4, 1, 1),(42, 393, 4, 1, 1),(42, 394, 4, 1, 1),(42, 395, 4, 1, 1),(42, 396, 4, 1, 1),(42, 397, 4, 1, 1),(42, 398, 4, 1, 1),(42, 399, 4, 1, 1),(42, 400, 4, 1, 1),(42, 401, 4, 1, 1),(42, 402, 4, 1, 1),(42, 403, 4, 1, 1),(42, 404, 4, 1, 1),(42, 405, 4, 1, 1),(42, 406, 4, 1, 1),(42, 407, 4, 1, 1),(42, 408, 4, 1, 1),(42, 409, 4, 1, 1),(42, 410, 4, 1, 1),(42, 411, 4, 1, 1),(42, 412, 4, 1, 1),(42, 413, 4, 1, 1),(42, 414, 4, 1, 1),(42, 415, 4, 1, 1),(42, 416, 4, 1, 1),(42, 417, 4, 1, 1),(42, 418, 4, 1, 1),(42, 419, 4, 1, 1),(42, 420, 4, 1, 1),(42, 421, 4, 1, 1),(42, 422, 4, 1, 1),(42, 423, 4, 1, 1),(42, 424, 4, 1, 1),(42, 425, 4, 1, 1),(42, 426, 4, 1, 1),(42, 427, 4, 1, 1),(42, 428, 4, 1, 1),(42, 429, 4, 1, 1),(42, 430, 4, 1, 1),(42, 431, 4, 1, 1),(42, 432, 4, 1, 1),(42, 433, 4, 1, 1),(42, 434, 4, 1, 1),(42, 435, 4, 1, 1),(42, 436, 4, 1, 1),(42, 437, 4, 1, 1),(42, 438, 4, 1, 1),(42, 439, 4, 1, 1),(42, 440, 4, 1, 1),(42, 441, 4, 1, 1),(42, 442, 4, 1, 1),(42, 443, 4, 1, 1),(42, 444, 4, 1, 1),(42, 445, 4, 1, 1),(42, 446, 4, 1, 1),(42, 447, 4, 1, 1),(42, 448, 4, 1, 1),(42, 449, 4, 1, 1),(42, 450, 4, 1, 1),(42, 451, 4, 1, 1),(42, 452, 4, 1, 1),(42, 453, 4, 1, 1),(42, 454, 4, 1, 1),(42, 455, 4, 1, 1),(42, 456, 4, 1, 1),(42, 457, 4, 1, 1),(42, 458, 4, 1, 1),(42, 459, 4, 1, 1),(42, 460, 4, 1, 1),(42, 461, 4, 1, 1),(42, 462, 4, 1, 1),(42, 463, 4, 1, 1),(42, 464, 4, 1, 1),(42, 465, 4, 1, 1),(42, 466, 4, 1, 1),(42, 467, 4, 1, 1),(42, 468, 4, 1, 1),(42, 469, 4, 1, 1),(42, 470, 4, 1, 1),(42, 471, 4, 1, 1),(42, 472, 4, 1, 1),(42, 473, 4, 1, 1),(42, 474, 4, 1, 1),(42, 475, 4, 1, 1),(42, 476, 4, 1, 1),(42, 477, 4, 1, 1),(42, 478, 4, 1, 1),(42, 479, 4, 1, 1),(42, 480, 4, 1, 1),(42, 481, 4, 1, 1),(42, 482, 4, 1, 1),(42, 483, 4, 1, 1),(42, 484, 4, 1, 1),(42, 485, 4, 1, 1),(42, 486, 4, 1, 1),(42, 487, 4, 1, 1),(42, 488, 4, 1, 1),(42, 489, 4, 1, 1),(42, 490, 4, 1, 1),(42, 491, 4, 1, 1),(42, 492, 4, 1, 1),(42, 493, 4, 1, 1),(42, 494, 4, 1, 1),(42, 495, 4, 1, 1),(42, 496, 4, 1, 1),(42, 497, 4, 1, 1),(42, 498, 4, 1, 1),(42, 499, 4, 1, 1),(42, 500, 4, 1, 1),(42, 501, 4, 1, 1),(42, 502, 4, 1, 1),(42, 503, 4, 1, 1),(42, 504, 4, 1, 1),(42, 505, 4, 1, 1),(42, 506, 4, 1, 1),(42, 507, 4, 1, 1),(42, 508, 4, 1, 1),(42, 509, 4, 1, 1),(42, 510, 4, 1, 1),(42, 511, 4, 1, 1),(42, 512, 4, 1, 1),(42, 513, 4, 1, 1),(42, 514, 4, 1, 1),(42, 515, 4, 1, 1),(42, 516, 4, 1, 1),(42, 517, 4, 1, 1),(42, 518, 4, 1, 1),(42, 519, 4, 1, 1),(42, 520, 4, 1, 1),(42, 521, 4, 1, 1),(42, 522, 4, 1, 1),(42, 523, 4, 1, 1),(42, 524, 4, 1, 1),(42, 525, 4, 1, 1),(42, 526, 4, 1, 1),(42, 527, 4, 1, 1),(42, 528, 4, 1, 1),(42, 529, 4, 1, 1),(42, 530, 4, 1, 1),(42, 531, 4, 1, 1),(42, 532, 4, 1, 1),(42, 533, 4, 1, 1),(42, 534, 4, 1, 1),(42, 535, 4, 1, 1),(42, 536, 4, 1, 1),(42, 537, 4, 1, 1),(42, 538, 4, 1, 1),(42, 539, 4, 1, 1),(42, 540, 4, 1, 1),(42, 541, 4, 1, 1),(42, 542, 4, 1, 1),(42, 543, 4, 1, 1),(42, 544, 4, 1, 1),(42, 545, 4, 1, 1),(42, 546, 4, 1, 1),(42, 547, 4, 1, 1),(42, 548, 4, 1, 1),(42, 549, 4, 1, 1),(42, 550, 4, 1, 1),(42, 551, 4, 1, 1),(42, 552, 4, 1, 1),(42, 553, 4, 1, 1),(42, 554, 4, 1, 1),(42, 555, 4, 1, 1),(42, 556, 4, 1, 1),(42, 557, 4, 1, 1),(42, 558, 4, 1, 1),(42, 559, 4, 1, 1),(42, 560, 4, 1, 1),(42, 561, 4, 1, 1),(42, 562, 4, 1, 1),(42, 563, 4, 1, 1),(42, 564, 4, 1, 1),(42, 565, 4, 1, 1),(42, 566, 4, 1, 1),(42, 567, 4, 1, 1),(42, 568, 4, 1, 1),(42, 569, 4, 1, 1),(42, 570, 4, 1, 1),(42, 571, 4, 1, 1),(42, 572, 4, 1, 1),(42, 573, 4, 1, 1),(42, 574, 4, 1, 1),(42, 575, 4, 1, 1),(42, 576, 4, 1, 1),(42, 577, 4, 1, 1),(42, 578, 4, 1, 1),(42, 579, 4, 1, 1),(42, 580, 4, 1, 1),(42, 581, 4, 1, 1),(42, 582, 4, 1, 1),(42, 583, 4, 1, 1),(42, 584, 4, 1, 1),(42, 585, 4, 1, 1),(42, 586, 4, 1, 1),(42, 587, 4, 1, 1),(42, 588, 4, 1, 1),(42, 589, 4, 1, 1),(42, 590, 4, 1, 1),(42, 591, 4, 1, 1),(42, 592, 4, 1, 1),(42, 593, 4, 1, 1),(42, 594, 4, 1, 1),(42, 595, 4, 1, 1),(42, 596, 4, 1, 1),(42, 597, 4, 1, 1),(42, 598, 4, 1, 1),(42, 599, 4, 1, 1),(42, 600, 4, 1, 1),(42, 601, 4, 1, 1),(42, 602, 4, 1, 1),(42, 603, 4, 1, 1),(42, 604, 4, 1, 1),(42, 605, 4, 1, 1),(42, 606, 4, 1, 1),(42, 607, 4, 1, 1),(42, 608, 4, 1, 1),(42, 609, 4, 1, 1),(42, 610, 4, 1, 1),(42, 611, 4, 1, 1),(42, 612, 4, 1, 1),(42, 613, 4, 1, 1),(42, 614, 4, 1, 1),(42, 615, 4, 1, 1),(42, 616, 4, 1, 1),(42, 617, 4, 1, 1),(42, 618, 4, 1, 1),(42, 619, 4, 1, 1),(42, 620, 4, 1, 1),(42, 621, 4, 1, 1),(42, 622, 4, 1, 1),(42, 623, 4, 1, 1),(42, 624, 4, 1, 1),(42, 625, 4, 1, 1),(42, 626, 4, 1, 1),(42, 627, 4, 1, 1),(42, 628, 4, 1, 1),(42, 629, 4, 1, 1),(42, 630, 4, 1, 1),(42, 631, 4, 1, 1),(42, 632, 4, 1, 1),(42, 633, 4, 1, 1),(42, 634, 4, 1, 1),(42, 635, 4, 1, 1),(42, 636, 4, 1, 1),(42, 637, 4, 1, 1),(42, 638, 4, 1, 1),(42, 639, 4, 1, 1),(42, 640, 4, 1, 1),(42, 641, 4, 1, 1),(42, 642, 4, 1, 1),(42, 643, 4, 1, 1),(42, 644, 4, 1, 1),(42, 645, 4, 1, 1),(42, 646, 4, 1, 1),(42, 647, 4, 1, 1),(42, 648, 4, 1, 1),(42, 649, 4, 1, 1),(42, 650, 4, 1, 1),(42, 651, 4, 1, 1),(42, 652, 4, 1, 1),(42, 653, 4, 1, 1),(42, 654, 4, 1, 1),(42, 655, 4, 1, 1),(42, 656, 4, 1, 1),(42, 657, 4, 1, 1),(42, 658, 4, 1, 1),(42, 659, 4, 1, 1),(42, 660, 4, 1, 1),(42, 661, 4, 1, 1),(42, 662, 4, 1, 1),(42, 663, 4, 1, 1),(42, 664, 4, 1, 1),(42, 665, 4, 1, 1),(42, 666, 4, 1, 1),(42, 667, 4, 1, 1),(42, 668, 4, 1, 1),(42, 669, 4, 1, 1),(42, 670, 4, 1, 1),(42, 671, 4, 1, 1),(42, 672, 4, 1, 1),(42, 673, 4, 1, 1),(42, 674, 4, 1, 1),(42, 675, 4, 1, 1),(42, 676, 4, 1, 1),(42, 677, 4, 1, 1),(42, 678, 4, 1, 1),(42, 679, 4, 1, 1),(42, 680, 4, 1, 1),(42, 681, 4, 1, 1),(42, 682, 4, 1, 1),(42, 683, 4, 1, 1),(42, 684, 4, 1, 1),(42, 685, 4, 1, 1),(42, 686, 4, 1, 1),(42, 687, 4, 1, 1),(42, 688, 4, 1, 1),(42, 689, 4, 1, 1),(42, 690, 4, 1, 1),(42, 691, 4, 1, 1),(42, 692, 4, 1, 1),(42, 693, 4, 1, 1),(42, 694, 4, 1, 1),(42, 695, 4, 1, 1),(42, 696, 4, 1, 1),(42, 697, 4, 1, 1),(42, 698, 4, 1, 1),(42, 699, 4, 1, 1),(42, 700, 4, 1, 1),(42, 701, 4, 1, 1),(42, 702, 4, 1, 1),(42, 703, 4, 1, 1),(42, 704, 4, 1, 1),(42, 705, 4, 1, 1),(42, 706, 4, 1, 1),(42, 707, 4, 1, 1),(42, 708, 4, 1, 1),(42, 709, 4, 1, 1),(42, 710, 4, 1, 1),(42, 711, 4, 1, 1),(42, 712, 4, 1, 1),(42, 713, 4, 1, 1),(42, 714, 4, 1, 1),(42, 715, 4, 1, 1),(42, 716, 4, 1, 1),(42, 717, 4, 1, 1),(42, 718, 4, 1, 1),(42, 719, 4, 1, 1),(42, 720, 4, 1, 1),(42, 721, 4, 1, 1),(42, 722, 4, 1, 1),(42, 723, 4, 1, 1),(42, 724, 4, 1, 1),(42, 725, 4, 1, 1),(42, 726, 4, 1, 1),(42, 727, 4, 1, 1),(42, 728, 4, 1, 1),(42, 729, 4, 1, 1),(42, 730, 4, 1, 1),(42, 731, 4, 1, 1),(42, 732, 4, 1, 1),(42, 733, 4, 1, 1),(42, 734, 4, 1, 1),(42, 735, 4, 1, 1),(42, 736, 4, 1, 1),(42, 737, 4, 1, 1),(42, 738, 4, 1, 1),(42, 739, 4, 1, 1),(42, 740, 4, 1, 1),(42, 741, 4, 1, 1),(42, 742, 4, 1, 1),(42, 743, 4, 1, 1),(42, 744, 4, 1, 1),(42, 745, 4, 1, 1),(42, 746, 4, 1, 1),(42, 747, 4, 1, 1),(42, 748, 4, 1, 1),(42, 749, 4, 1, 1),(42, 750, 4, 1, 1),(42, 751, 4, 1, 1),(42, 752, 4, 1, 1),(42, 753, 4, 1, 1),(42, 754, 4, 1, 1),(42, 755, 4, 1, 1),(42, 756, 4, 1, 1),(42, 757, 4, 1, 1),(42, 758, 4, 1, 1),(42, 759, 4, 1, 1),(42, 760, 4, 1, 1),(42, 761, 4, 1, 1),(42, 762, 4, 1, 1),(42, 763, 4, 1, 1),(42, 764, 4, 1, 1),(42, 765, 4, 1, 1),(42, 766, 4, 1, 1),(42, 767, 4, 1, 1),(42, 768, 4, 1, 1),(42, 769, 4, 1, 1),(42, 770, 4, 1, 1),(42, 771, 4, 1, 1),(42, 772, 4, 1, 1),(42, 773, 4, 1, 1),(42, 774, 4, 1, 1),(42, 775, 4, 1, 1),(42, 776, 4, 1, 1),(42, 777, 4, 1, 1),(42, 778, 4, 1, 1),(42, 779, 4, 1, 1),(42, 780, 4, 1, 1),(42, 781, 4, 1, 1),(42, 782, 4, 1, 1),(42, 783, 4, 1, 1),(42, 784, 4, 1, 1),(42, 785, 4, 1, 1),(42, 786, 4, 1, 1),(42, 787, 4, 1, 1),(42, 788, 4, 1, 1),(42, 789, 4, 1, 1),(42, 790, 4, 1, 1),(42, 791, 4, 1, 1),(42, 792, 4, 1, 1),(42, 793, 4, 1, 1),(42, 794, 4, 1, 1),(42, 795, 4, 1, 1),(42, 796, 4, 1, 1),(42, 797, 4, 1, 1),(42, 798, 4, 1, 1),(42, 799, 4, 1, 1),(42, 800, 4, 1, 1),(42, 801, 4, 1, 1),(42, 802, 4, 1, 1),(42, 803, 4, 1, 1),(42, 804, 4, 1, 1),(42, 805, 4, 1, 1),(42, 806, 4, 1, 1),(42, 807, 4, 1, 1),(42, 808, 4, 1, 1),(42, 809, 4, 1, 1),(42, 810, 4, 1, 1),(42, 811, 4, 1, 1),(42, 812, 4, 1, 1),(42, 813, 4, 1, 1),(42, 814, 4, 1, 1),(42, 815, 4, 1, 1),(42, 816, 4, 1, 1),(42, 817, 4, 1, 1),(42, 818, 4, 1, 1),(42, 819, 4, 1, 1),(42, 820, 4, 1, 1),(42, 821, 4, 1, 1),(42, 822, 4, 1, 1),(42, 823, 4, 1, 1),(42, 824, 4, 1, 1),(42, 825, 4, 1, 1),(42, 826, 4, 1, 1),(42, 827, 4, 1, 1),(42, 828, 4, 1, 1),(42, 829, 4, 1, 1),(42, 830, 4, 1, 1),(42, 831, 4, 1, 1),(42, 832, 4, 1, 1),(42, 833, 4, 1, 1),(42, 834, 4, 1, 1),(42, 835, 4, 1, 1),(42, 836, 4, 1, 1),(42, 837, 4, 1, 1),(42, 838, 4, 1, 1),(42, 839, 4, 1, 1),(42, 840, 4, 1, 1),(42, 841, 4, 1, 1),(42, 842, 4, 1, 1),(42, 843, 4, 1, 1),(42, 844, 4, 1, 1),(42, 845, 4, 1, 1),(42, 846, 4, 1, 1),(42, 847, 4, 1, 1),(42, 848, 4, 1, 1),(42, 849, 4, 1, 1),(42, 850, 4, 1, 1),(42, 851, 4, 1, 1),(42, 852, 4, 1, 1),(42, 853, 4, 1, 1),(42, 854, 4, 1, 1),(42, 855, 4, 1, 1),(42, 856, 4, 1, 1),(42, 857, 4, 1, 1),(42, 858, 4, 1, 1),(42, 859, 4, 1, 1),(42, 860, 4, 1, 1),(42, 861, 4, 1, 1),(42, 862, 4, 1, 1),(42, 863, 4, 1, 1),(42, 864, 4, 1, 1),(42, 865, 4, 1, 1),(42, 866, 4, 1, 1),(42, 867, 4, 1, 1),(42, 868, 4, 1, 1),(42, 869, 4, 1, 1),(42, 870, 4, 1, 1),(42, 871, 4, 1, 1),(42, 872, 4, 1, 1),(42, 873, 4, 1, 1),(42, 874, 4, 1, 1),(42, 875, 4, 1, 1),(42, 876, 4, 1, 1),(42, 877, 4, 1, 1),(42, 878, 4, 1, 1),(42, 879, 4, 1, 1),(42, 880, 4, 1, 1),(42, 881, 4, 1, 1),(42, 882, 4, 1, 1),(42, 883, 4, 1, 1),(42, 884, 4, 1, 1),(42, 885, 4, 1, 1),(42, 886, 4, 1, 1),(42, 887, 4, 1, 1),(42, 888, 4, 1, 1),(42, 889, 4, 1, 1),(42, 890, 4, 1, 1),(42, 891, 4, 1, 1),(42, 892, 4, 1, 1),(42, 893, 4, 1, 1),(42, 894, 4, 1, 1),(42, 895, 4, 1, 1),(42, 896, 4, 1, 1),(42, 897, 4, 1, 1),(42, 898, 4, 1, 1),(42, 899, 4, 1, 1),(42, 900, 4, 1, 1),(42, 901, 4, 1, 1),(42, 902, 4, 1, 1),(42, 903, 4, 1, 1),(42, 904, 4, 1, 1),(42, 905, 4, 1, 1),(42, 906, 4, 1, 1),(42, 907, 4, 1, 1),(42, 908, 4, 1, 1),(42, 909, 4, 1, 1),(42, 910, 4, 1, 1),(42, 911, 4, 1, 1),(42, 912, 4, 1, 1),(42, 913, 4, 1, 1),(42, 914, 4, 1, 1),(42, 915, 4, 1, 1),(42, 916, 4, 1, 1),(42, 917, 4, 1, 1),(42, 918, 4, 1, 1),(42, 919, 4, 1, 1),(42, 920, 4, 1, 1),(42, 921, 4, 1, 1),(42, 922, 4, 1, 1),(42, 923, 4, 1, 1),(42, 924, 4, 1, 1),(42, 925, 4, 1, 1),(42, 926, 4, 1, 1),(42, 927, 4, 1, 1),(42, 928, 4, 1, 1),(42, 929, 4, 1, 1),(42, 930, 4, 1, 1),(42, 931, 4, 1, 1),(42, 932, 4, 1, 1),(42, 933, 4, 1, 1),(42, 934, 4, 1, 1),(42, 935, 4, 1, 1),(42, 936, 4, 1, 1),(42, 937, 4, 1, 1),(42, 938, 4, 1, 1),(42, 939, 4, 1, 1),(42, 940, 4, 1, 1),(42, 941, 4, 1, 1),(42, 942, 4, 1, 1),(42, 943, 4, 1, 1),(42, 944, 4, 1, 1),(42, 945, 4, 1, 1),(42, 946, 4, 1, 1),(42, 947, 4, 1, 1),(42, 948, 4, 1, 1),(42, 949, 4, 1, 1),(42, 950, 4, 1, 1),(42, 951, 4, 1, 1),(42, 952, 4, 1, 1),(42, 953, 4, 1, 1),(42, 954, 4, 1, 1),(42, 955, 4, 1, 1),(42, 956, 4, 1, 1),(42, 957, 4, 1, 1),(42, 958, 4, 1, 1),(42, 959, 4, 1, 1),(42, 960, 4, 1, 1),(42, 961, 4, 1, 1),(42, 962, 4, 1, 1),(42, 963, 4, 1, 1),(42, 964, 4, 1, 1),(42, 965, 4, 1, 1),(42, 966, 4, 1, 1),(42, 967, 4, 1, 1),(42, 968, 4, 1, 1),(42, 969, 4, 1, 1),(42, 970, 4, 1, 1),(42, 971, 4, 1, 1),(42, 972, 4, 1, 1),(42, 973, 4, 1, 1),(42, 974, 4, 1, 1),(42, 975, 4, 1, 1),(42, 976, 4, 1, 1),(42, 977, 4, 1, 1),(42, 978, 4, 1, 1),(42, 979, 4, 1, 1),(42, 980, 4, 1, 1),(42, 981, 4, 1, 1),(42, 982, 4, 1, 1),(42, 983, 4, 1, 1),(42, 984, 4, 1, 1),(42, 985, 4, 1, 1),(42, 986, 4, 1, 1),(42, 987, 4, 1, 1),(42, 988, 4, 1, 1),(42, 989, 4, 1, 1),(42, 990, 4, 1, 1),(42, 991, 4, 1, 1),(42, 992, 4, 1, 1),(42, 993, 4, 1, 1),(42, 994, 4, 1, 1),(42, 995, 4, 1, 1),(42, 996, 4, 1, 1),(42, 997, 4, 1, 1),(42, 998, 4, 1, 1),(42, 999, 4, 1, 1),(42, 1000, 4, 1, 1),(42, 1001, 4, 1, 1),(42, 1002, 4, 1, 1),(42, 1003, 4, 1, 1),(42, 1004, 4, 1, 1),(42, 1005, 4, 1, 1),(42, 1006, 4, 1, 1),(42, 1007, 4, 1, 1),(42, 1008, 4, 1, 1),(42, 1009, 4, 1, 1),(42, 1010, 4, 1, 1),(42, 1011, 4, 1, 1),(42, 1012, 4, 1, 1),(42, 1013, 4, 1, 1),(42, 1014, 4, 1, 1),(42, 1015, 4, 1, 1),(42, 1016, 4, 1, 1),(42, 1017, 4, 1, 1),(42, 1018, 4, 1, 1),(42, 1019, 4, 1, 1),(42, 1020, 4, 1, 1),(42, 1021, 4, 1, 1),(42, 1022, 4, 1, 1),(42, 1023, 4, 1, 1),(42, 1024, 4, 1, 1),(42, 1025, 4, 1, 1),(42, 1026, 4, 1, 1),(42, 1027, 4, 1, 1),(42, 1028, 4, 1, 1),(42, 1029, 4, 1, 1),(42, 1030, 4, 1, 1),(42, 1031, 4, 1, 1),(42, 1032, 4, 1, 1),(42, 1033, 4, 1, 1),(42, 1034, 4, 1, 1),(42, 1035, 4, 1, 1),(42, 1036, 4, 1, 1),(42, 1037, 4, 1, 1),(42, 1038, 4, 1, 1),(42, 1039, 4, 1, 1),(42, 1040, 4, 1, 1),(42, 1041, 4, 1, 1),(42, 1042, 4, 1, 1),(42, 1043, 4, 1, 1),(42, 1044, 4, 1, 1),(42, 1045, 4, 1, 1),(42, 1046, 4, 1, 1),(42, 1047, 4, 1, 1),(42, 1048, 4, 1, 1),(42, 1049, 4, 1, 1),(42, 1050, 4, 1, 1),(42, 1051, 4, 1, 1),(42, 1052, 4, 1, 1),(42, 1053, 4, 1, 1),(42, 1054, 4, 1, 1),(42, 1055, 4, 1, 1),(42, 1056, 4, 1, 1),(42, 1057, 4, 1, 1),(42, 1058, 4, 1, 1),(42, 1059, 4, 1, 1),(42, 1060, 4, 1, 1),(42, 1061, 4, 1, 1),(42, 1062, 4, 1, 1),(42, 1063, 4, 1, 1),(42, 1064, 4, 1, 1),(42, 1065, 4, 1, 1),(42, 1066, 4, 1, 1),(42, 1067, 4, 1, 1),(42, 1068, 4, 1, 1),(42, 1069, 4, 1, 1),(42, 1070, 4, 1, 1),(42, 1071, 4, 1, 1),(42, 1072, 4, 1, 1),(42, 1073, 4, 1, 1),(42, 1074, 4, 1, 1),(42, 1075, 4, 1, 1),(42, 1076, 4, 1, 1),(42, 1077, 4, 1, 1),(42, 1078, 4, 1, 1),(42, 1079, 4, 1, 1),(42, 1080, 4, 1, 1),(42, 1081, 4, 1, 1),(42, 1082, 4, 1, 1),(42, 1083, 4, 1, 1),(42, 1084, 4, 1, 1),(42, 1085, 4, 1, 1),(42, 1086, 4, 1, 1),(42, 1087, 4, 1, 1),(42, 1088, 4, 1, 1),(42, 1089, 4, 1, 1),(42, 1090, 4, 1, 1),(42, 1091, 4, 1, 1),(42, 1092, 4, 1, 1),(42, 1093, 4, 1, 1),(42, 1094, 4, 1, 1),(42, 1095, 4, 1, 1),(42, 1096, 4, 1, 1),(42, 1097, 4, 1, 1),(42, 1098, 4, 1, 1),(42, 1099, 4, 1, 1),(42, 1100, 4, 1, 1),(42, 1101, 4, 1, 1),(42, 1102, 4, 1, 1),(42, 1103, 4, 1, 1),(42, 1104, 4, 1, 1),(42, 1105, 4, 1, 1),(42, 1106, 4, 1, 1),(42, 1107, 4, 1, 1),(42, 1108, 4, 1, 1),(42, 1109, 4, 1, 1),(42, 1110, 4, 1, 1),(42, 1111, 4, 1, 1),(42, 1112, 4, 1, 1),(42, 1113, 4, 1, 1),(42, 1114, 4, 1, 1),(42, 1115, 4, 1, 1),(42, 1116, 4, 1, 1),(42, 1117, 4, 1, 1),(42, 1118, 4, 1, 1),(42, 1119, 4, 1, 1),(42, 1120, 4, 1, 1),(42, 1121, 4, 1, 1),(42, 1122, 4, 1, 1),(42, 1123, 4, 1, 1),(42, 1124, 4, 1, 1),(42, 1125, 4, 1, 1),(42, 1126, 4, 1, 1),(42, 1127, 4, 1, 1),(42, 1128, 4, 1, 1),(42, 1129, 4, 1, 1),(42, 1130, 4, 1, 1),(42, 1131, 4, 1, 1),(42, 1132, 4, 1, 1),(42, 1133, 4, 1, 1),(42, 1134, 4, 1, 1),(42, 1135, 4, 1, 1),(42, 1136, 4, 1, 1),(42, 1137, 4, 1, 1),(42, 1138, 4, 1, 1),(42, 1139, 4, 1, 1),(42, 1140, 4, 1, 1),(42, 1141, 4, 1, 1),(42, 1142, 4, 1, 1),(42, 1143, 4, 1, 1),(42, 1144, 4, 1, 1),(42, 1145, 4, 1, 1),(42, 1146, 4, 1, 1),(42, 1147, 4, 1, 1),(42, 1148, 4, 1, 1),(42, 1149, 4, 1, 1),(42, 1150, 4, 1, 1),(42, 1151, 4, 1, 1),(42, 1152, 4, 1, 1),(42, 1153, 4, 1, 1),(42, 1154, 4, 1, 1),(42, 1155, 4, 1, 1),(42, 1156, 4, 1, 1),(42, 1157, 4, 1, 1),(42, 1158, 4, 1, 1),(42, 1159, 4, 1, 1),(42, 1160, 4, 1, 1),(42, 1161, 4, 1, 1),(42, 1162, 4, 1, 1),(42, 1163, 4, 1, 1),(42, 1164, 4, 1, 1),(42, 1165, 4, 1, 1),(42, 1166, 4, 1, 1),(42, 1167, 4, 1, 1),(42, 1168, 4, 1, 1),(42, 1169, 4, 1, 1),(42, 1170, 4, 1, 1),(42, 1171, 4, 1, 1),(42, 1172, 4, 1, 1),(42, 1173, 4, 1, 1),(42, 1174, 4, 1, 1),(42, 1175, 4, 1, 1),(42, 1176, 4, 1, 1),(42, 1177, 4, 1, 1),(42, 1178, 4, 1, 1),(42, 1179, 4, 1, 1),(42, 1180, 4, 1, 1),(42, 1181, 4, 1, 1),(42, 1182, 4, 1, 1),(42, 1183, 4, 1, 1),(42, 1184, 4, 1, 1),(42, 1185, 4, 1, 1),(42, 1186, 4, 1, 1),(42, 1187, 4, 1, 1),(42, 1188, 4, 1, 1),(42, 1189, 4, 1, 1),(42, 1190, 4, 1, 1),(42, 1191, 4, 1, 1),(42, 1192, 4, 1, 1),(42, 1193, 4, 1, 1),(42, 1194, 4, 1, 1),(42, 1195, 4, 1, 1),(42, 1196, 4, 1, 1),(42, 1197, 4, 1, 1),(42, 1198, 4, 1, 1),(42, 1199, 4, 1, 1),(42, 1200, 4, 1, 1),(42, 1201, 4, 1, 1),(42, 1202, 4, 1, 1),(42, 1203, 4, 1, 1),(42, 1204, 4, 1, 1),(42, 1205, 4, 1, 1),(42, 1206, 4, 1, 1),(42, 1207, 4, 1, 1),(42, 1208, 4, 1, 1),(42, 1209, 4, 1, 1),(42, 1210, 4, 1, 1),(42, 1211, 4, 1, 1),(42, 1212, 4, 1, 1),(42, 1213, 4, 1, 1),(42, 1214, 4, 1, 1),(42, 1215, 4, 1, 1),(42, 1216, 4, 1, 1),(42, 1217, 4, 1, 1),(42, 1218, 4, 1, 1),(42, 1219, 4, 1, 1),(42, 1220, 4, 1, 1),(42, 1221, 4, 1, 1),(42, 1222, 4, 1, 1),(42, 1223, 4, 1, 1),(42, 1224, 4, 1, 1),(42, 1225, 4, 1, 1),(42, 1226, 4, 1, 1),(42, 1227, 4, 1, 1),(42, 1228, 4, 1, 1),(42, 1229, 4, 1, 1),(42, 1230, 4, 1, 1),(42, 1231, 4, 1, 1),(42, 1232, 4, 1, 1),(42, 1233, 4, 1, 1),(42, 1234, 4, 1, 1),(42, 1235, 4, 1, 1),(42, 1236, 4, 1, 1),(42, 1237, 4, 1, 1),(42, 1238, 4, 1, 1),(42, 1239, 4, 1, 1),(42, 1240, 4, 1, 1),(42, 1241, 4, 1, 1),(42, 1242, 4, 1, 1),(42, 1243, 4, 1, 1),(42, 1244, 4, 1, 1),(42, 1245, 4, 1, 1),(42, 1246, 4, 1, 1),(42, 1247, 4, 1, 1),(42, 1248, 4, 1, 1),(42, 1249, 4, 1, 1),(42, 1250, 4, 1, 1),(42, 1251, 4, 1, 1),(42, 1252, 4, 1, 1),(42, 1253, 4, 1, 1),(42, 1254, 4, 1, 1),(42, 1255, 4, 1, 1),(42, 1256, 4, 1, 1),(42, 1257, 4, 1, 1),(42, 1258, 4, 1, 1),(42, 1259, 4, 1, 1),(42, 1260, 4, 1, 1),(42, 1261, 4, 1, 1),(42, 1262, 4, 1, 1),(42, 1263, 4, 1, 1),(42, 1264, 4, 1, 1),(42, 1265, 4, 1, 1),(42, 1266, 4, 1, 1),(42, 1267, 4, 1, 1),(42, 1268, 4, 1, 1),(42, 1269, 4, 1, 1),(42, 1270, 4, 1, 1),(42, 1271, 4, 1, 1),(42, 1272, 4, 1, 1),(42, 1273, 4, 1, 1),(42, 1274, 4, 1, 1),(42, 1275, 4, 1, 1),(42, 1276, 4, 1, 1),(42, 1277, 4, 1, 1),(42, 1278, 4, 1, 1),(42, 1279, 4, 1, 1),(42, 1280, 4, 1, 1),(42, 1281, 4, 1, 1),(42, 1282, 4, 1, 1),(42, 1283, 4, 1, 1),(42, 1284, 4, 1, 1),(42, 1285, 4, 1, 1),(42, 1286, 4, 1, 1),(42, 1287, 4, 1, 1),(42, 1288, 4, 1, 1),(42, 1289, 4, 1, 1),(42, 1290, 4, 1, 1),(42, 1291, 4, 1, 1),(42, 1292, 4, 1, 1),(42, 1293, 4, 1, 1),(42, 1294, 4, 1, 1),(42, 1295, 4, 1, 1),(42, 1296, 4, 1, 1),(42, 1297, 4, 1, 1),(42, 1298, 4, 1, 1),(42, 1299, 4, 1, 1),(42, 1300, 4, 1, 1),(42, 1301, 4, 1, 1),(42, 1302, 4, 1, 1),(42, 1303, 4, 1, 1),(42, 1304, 4, 1, 1),(42, 1305, 4, 1, 1),(42, 1306, 4, 1, 1),(42, 1307, 4, 1, 1),(42, 1308, 4, 1, 1),(42, 1309, 4, 1, 1),(42, 1310, 4, 1, 1),(42, 1311, 4, 1, 1),(42, 1312, 4, 1, 1),(42, 1313, 4, 1, 1),(42, 1314, 4, 1, 1),(42, 1315, 4, 1, 1),(42, 1316, 4, 1, 1),(42, 1317, 4, 1, 1),(42, 1318, 4, 1, 1),(42, 1319, 4, 1, 1),(42, 1320, 4, 1, 1),(42, 1321, 4, 1, 1),(42, 1322, 4, 1, 1),(42, 1323, 4, 1, 1),(42, 1324, 4, 1, 1),(42, 1325, 4, 1, 1),(42, 1326, 4, 1, 1),(42, 1327, 4, 1, 1),(42, 1328, 4, 1, 1),(42, 1329, 4, 1, 1),(42, 1330, 4, 1, 1),(42, 1331, 4, 1, 1),(42, 1332, 4, 1, 1),(42, 1333, 4, 1, 1),(42, 1334, 4, 1, 1),(42, 1335, 4, 1, 1),(42, 1336, 4, 1, 1),(42, 1337, 4, 1, 1),(42, 1338, 4, 1, 1),(42, 1339, 4, 1, 1),(42, 1340, 4, 1, 1),(42, 1341, 4, 1, 1),(42, 1342, 4, 1, 1),(42, 1343, 4, 1, 1),(42, 1344, 4, 1, 1),(42, 1345, 4, 1, 1),(42, 1346, 4, 1, 1),(42, 1347, 4, 1, 1),(42, 1348, 4, 1, 1),(42, 1349, 4, 1, 1),(42, 1350, 4, 1, 1),(42, 1351, 4, 1, 1),(42, 1352, 4, 1, 1),(42, 1353, 4, 1, 1),(42, 1354, 4, 1, 1),(42, 1355, 4, 1, 1),(42, 1356, 4, 1, 1),(42, 1357, 4, 1, 1),(42, 1358, 4, 1, 1),(42, 1359, 4, 1, 1),(42, 1360, 4, 1, 1),(42, 1361, 4, 1, 1),(42, 1362, 4, 1, 1),(42, 1363, 4, 1, 1),(42, 1364, 4, 1, 1),(42, 1365, 4, 1, 1),(42, 1366, 4, 1, 1),(42, 1367, 4, 1, 1),(42, 1368, 4, 1, 1),(42, 1369, 4, 1, 1),(42, 1370, 4, 1, 1),(42, 1371, 4, 1, 1),(42, 1372, 4, 1, 1),(42, 1373, 4, 1, 1),(42, 1374, 4, 1, 1),(42, 1375, 4, 1, 1),(42, 1376, 4, 1, 1),(42, 1377, 4, 1, 1),(42, 1378, 4, 1, 1),(42, 1379, 4, 1, 1),(42, 1380, 4, 1, 1),(42, 1381, 4, 1, 1),(42, 1382, 4, 1, 1),(42, 1383, 4, 1, 1),(42, 1384, 4, 1, 1),(42, 1385, 4, 1, 1),(42, 1386, 4, 1, 1),(42, 1387, 4, 1, 1),(42, 1388, 4, 1, 1),(42, 1389, 4, 1, 1),(42, 1390, 4, 1, 1),(42, 1391, 4, 1, 1),(42, 1392, 4, 1, 1),(42, 1393, 4, 1, 1),(42, 1394, 4, 1, 1),(42, 1395, 4, 1, 1),(42, 1396, 4, 1, 1),(42, 1397, 4, 1, 1),(42, 1398, 4, 1, 1),(42, 1399, 4, 1, 1),(42, 1400, 4, 1, 1),(42, 1401, 4, 1, 1),(42, 1402, 4, 1, 1),(42, 1403, 4, 1, 1),(42, 1404, 4, 1, 1),(42, 1405, 4, 1, 1),(42, 1406, 4, 1, 1),(42, 1407, 4, 1, 1),(42, 1408, 4, 1, 1),(42, 1409, 4, 1, 1),(42, 1410, 4, 1, 1),(42, 1411, 4, 1, 1),(42, 1412, 4, 1, 1),(42, 1413, 4, 1, 1),(42, 1414, 4, 1, 1),(42, 1415, 4, 1, 1),(42, 1416, 4, 1, 1),(42, 1417, 4, 1, 1),(42, 1418, 4, 1, 1),(42, 1419, 4, 1, 1),(42, 1420, 4, 1, 1),(42, 1421, 4, 1, 1),(42, 1422, 4, 1, 1),(42, 1423, 4, 1, 1),(42, 1424, 4, 1, 1),(42, 1425, 4, 1, 1),(42, 1426, 4, 1, 1),(42, 1427, 4, 1, 1),(42, 1428, 4, 1, 1),(42, 1429, 4, 1, 1),(42, 1430, 4, 1, 1),(42, 1431, 4, 1, 1),(42, 1432, 4, 1, 1),(42, 1433, 4, 1, 1),(42, 1434, 4, 1, 1),(42, 1435, 4, 1, 1),(42, 1436, 4, 1, 1),(42, 1437, 4, 1, 1),(42, 1438, 4, 1, 1),(42, 1439, 4, 1, 1),(42, 1440, 4, 1, 1),(42, 1441, 4, 1, 1),(42, 1442, 4, 1, 1),(42, 1443, 4, 1, 1),(42, 1444, 4, 1, 1),(42, 1445, 4, 1, 1),(42, 1446, 4, 1, 1),(42, 1447, 4, 1, 1),(42, 1448, 4, 1, 1),(42, 1449, 4, 1, 1),(42, 1450, 4, 1, 1),(42, 1451, 4, 1, 1),(42, 1452, 4, 1, 1),(42, 1453, 4, 1, 1),(42, 1454, 4, 1, 1),(42, 1455, 4, 1, 1),(42, 1456, 4, 1, 1),(42, 1457, 4, 1, 1),(42, 1458, 4, 1, 1),(42, 1459, 4, 1, 1),(42, 1460, 4, 1, 1),(42, 1461, 4, 1, 1),(42, 1462, 4, 1, 1),(42, 1463, 4, 1, 1),(42, 1464, 4, 1, 1),(42, 1465, 4, 1, 1),(42, 1466, 4, 1, 1),(42, 1467, 4, 1, 1),(42, 1468, 4, 1, 1),(42, 1469, 4, 1, 1),(42, 1470, 4, 1, 1),(42, 1471, 4, 1, 1),(42, 1472, 4, 1, 1),(42, 1473, 4, 1, 1),(42, 1474, 4, 1, 1),(42, 1475, 4, 1, 1),(42, 1476, 4, 1, 1),(42, 1477, 4, 1, 1),(42, 1478, 4, 1, 1),(42, 1479, 4, 1, 1),(42, 1480, 4, 1, 1),(42, 1481, 4, 1, 1),(42, 1482, 4, 1, 1),(42, 1483, 4, 1, 1),(42, 1484, 4, 1, 1),(42, 1485, 4, 1, 1),(42, 1486, 4, 1, 1),(42, 1487, 4, 1, 1),(42, 1488, 4, 1, 1),(42, 1489, 4, 1, 1),(42, 1490, 4, 1, 1),(42, 1491, 4, 1, 1),(42, 1492, 4, 1, 1),(42, 1493, 4, 1, 1),(42, 1494, 4, 1, 1),(42, 1495, 4, 1, 1),(42, 1496, 4, 1, 1),(42, 1497, 4, 1, 1),(42, 1498, 4, 1, 1),(42, 1499, 4, 1, 1),(42, 1500, 4, 1, 1),(42, 1501, 4, 1, 1),(42, 1502, 4, 1, 1),(42, 1503, 4, 1, 1),(42, 1504, 4, 1, 1),(42, 1505, 4, 1, 1),(42, 1506, 4, 1, 1),(42, 1507, 4, 1, 1),(42, 1508, 4, 1, 1),(42, 1509, 4, 1, 1),(42, 1510, 4, 1, 1),(42, 1511, 4, 1, 1),(42, 1512, 4, 1, 1),(42, 1513, 4, 1, 1),(42, 1514, 4, 1, 1),(42, 1515, 4, 1, 1),(42, 1516, 4, 1, 1),(42, 1517, 4, 1, 1),(42, 1518, 4, 1, 1),(42, 1519, 4, 1, 1),(42, 1520, 4, 1, 1),(42, 1521, 4, 1, 1),(42, 1522, 4, 1, 1),(42, 1523, 4, 1, 1),(42, 1524, 4, 1, 1),(42, 1525, 4, 1, 1),(42, 1526, 4, 1, 1),(42, 1527, 4, 1, 1),(42, 1528, 4, 1, 1),(42, 1529, 4, 1, 1),(42, 1530, 4, 1, 1),(42, 1531, 4, 1, 1),(42, 1532, 4, 1, 1),(42, 1533, 4, 1, 1),(42, 1534, 4, 1, 1),(42, 1535, 4, 1, 1),(42, 1536, 4, 1, 1),(43, 1, 4, 1, 1),(43, 2, 4, 1, 1),(43, 3, 4, 1, 1),(43, 4, 4, 1, 1),(43, 5, 4, 1, 1),(43, 6, 4, 1, 1),(43, 7, 4, 1, 1),(43, 8, 4, 1, 1),(43, 9, 4, 1, 1),(43, 10, 4, 1, 1),(43, 11, 4, 1, 1),(43, 12, 4, 1, 1),(43, 13, 4, 1, 1),(43, 14, 4, 1, 1),(43, 15, 4, 1, 1),(43, 16, 4, 1, 1),(43, 17, 4, 1, 1),(43, 18, 4, 1, 1),(43, 19, 4, 1, 1),(43, 20, 4, 1, 1),(43, 21, 4, 1, 1),(43, 22, 4, 1, 1),(43, 23, 4, 1, 1),(43, 24, 4, 1, 1),(43, 25, 4, 1, 1),(43, 26, 4, 1, 1),(43, 27, 4, 1, 1),(43, 28, 4, 1, 1),(43, 29, 4, 1, 1),(43, 30, 4, 1, 1),(43, 31, 4, 1, 1),(43, 32, 4, 1, 1),(43, 33, 4, 1, 1),(43, 34, 4, 1, 1),(43, 35, 4, 1, 1),(43, 36, 4, 1, 1),(43, 37, 4, 1, 1),(43, 38, 4, 1, 1),(43, 39, 4, 1, 1),(43, 40, 4, 1, 1),(43, 41, 4, 1, 1),(43, 42, 4, 1, 1),(43, 43, 4, 1, 1),(43, 44, 4, 1, 1),(43, 45, 4, 1, 1),(43, 46, 4, 1, 1),(43, 47, 4, 1, 1),(43, 48, 4, 1, 1),(43, 49, 4, 1, 1),(43, 50, 4, 1, 1),(43, 51, 4, 1, 1),(43, 52, 4, 1, 1),(43, 53, 4, 1, 1),(43, 54, 4, 1, 1),(43, 55, 4, 1, 1),(43, 56, 4, 1, 1),(43, 57, 4, 1, 1),(43, 58, 4, 1, 1),(43, 59, 4, 1, 1),(43, 60, 4, 1, 1),(43, 61, 4, 1, 1),(43, 62, 4, 1, 1),(43, 63, 4, 1, 1),(43, 64, 4, 1, 1),(43, 65, 4, 1, 1),(43, 66, 4, 1, 1),(43, 67, 4, 1, 1),(43, 68, 4, 1, 1),(43, 69, 4, 1, 1),(43, 70, 4, 1, 1),(43, 71, 4, 1, 1),(43, 72, 4, 1, 1),(43, 73, 4, 1, 1),(43, 74, 4, 1, 1),(43, 75, 4, 1, 1),(43, 76, 4, 1, 1),(43, 77, 4, 1, 1),(43, 78, 4, 1, 1),(43, 79, 4, 1, 1),(43, 80, 4, 1, 1),(43, 81, 4, 1, 1),(43, 82, 4, 1, 1),(43, 83, 4, 1, 1),(43, 84, 4, 1, 1),(43, 85, 4, 1, 1),(43, 86, 4, 1, 1),(43, 87, 4, 1, 1),(43, 88, 4, 1, 1),(43, 89, 4, 1, 1),(43, 90, 4, 1, 1),(43, 91, 4, 1, 1),(43, 92, 4, 1, 1),(43, 93, 4, 1, 1),(43, 94, 4, 1, 1),(43, 95, 4, 1, 1),(43, 96, 4, 1, 1),(43, 97, 4, 1, 1),(43, 98, 4, 1, 1),(43, 99, 4, 1, 1),(43, 100, 4, 1, 1),(43, 101, 4, 1, 1),(43, 102, 4, 1, 1),(43, 103, 4, 1, 1),(43, 104, 4, 1, 1),(43, 105, 4, 1, 1),(43, 106, 4, 1, 1),(43, 107, 4, 1, 1),(43, 108, 4, 1, 1),(43, 109, 4, 1, 1),(43, 110, 4, 1, 1),(43, 111, 4, 1, 1),(43, 112, 4, 1, 1),(43, 113, 4, 1, 1),(43, 114, 4, 1, 1),(43, 115, 4, 1, 1),(43, 116, 4, 1, 1),(43, 117, 4, 1, 1),(43, 118, 4, 1, 1),(43, 119, 4, 1, 1),(43, 120, 4, 1, 1),(43, 121, 4, 1, 1),(43, 122, 4, 1, 1),(43, 123, 4, 1, 1),(43, 124, 4, 1, 1),(43, 125, 4, 1, 1),(43, 126, 4, 1, 1),(43, 127, 4, 1, 1),(43, 128, 4, 1, 1),(43, 129, 4, 1, 1),(43, 130, 4, 1, 1),(43, 131, 4, 1, 1),(43, 132, 4, 1, 1),(43, 133, 4, 1, 1),(43, 134, 4, 1, 1),(43, 135, 4, 1, 1),(43, 136, 4, 1, 1),(43, 137, 4, 1, 1),(43, 138, 4, 1, 1),(43, 139, 4, 1, 1),(43, 140, 4, 1, 1),(43, 141, 4, 1, 1),(43, 142, 4, 1, 1),(43, 143, 4, 1, 1),(43, 144, 4, 1, 1),(43, 145, 4, 1, 1),(43, 146, 4, 1, 1),(43, 147, 4, 1, 1),(43, 148, 4, 1, 1),(43, 149, 4, 1, 1),(43, 150, 4, 1, 1),(43, 151, 4, 1, 1),(43, 152, 4, 1, 1),(43, 153, 4, 1, 1),(43, 154, 4, 1, 1),(43, 155, 4, 1, 1),(43, 156, 4, 1, 1),(43, 157, 4, 1, 1),(43, 158, 4, 1, 1),(43, 159, 4, 1, 1),(43, 160, 4, 1, 1),(43, 161, 4, 1, 1),(43, 162, 4, 1, 1),(43, 163, 4, 1, 1),(43, 164, 4, 1, 1),(43, 165, 4, 1, 1),(43, 166, 4, 1, 1),(43, 167, 4, 1, 1),(43, 168, 4, 1, 1),(43, 169, 4, 1, 1),(43, 170, 4, 1, 1),(43, 171, 4, 1, 1),(43, 172, 4, 1, 1),(43, 173, 4, 1, 1),(43, 174, 4, 1, 1),(43, 175, 4, 1, 1),(43, 176, 4, 1, 1),(43, 177, 4, 1, 1),(43, 178, 4, 1, 1),(43, 179, 4, 1, 1),(43, 180, 4, 1, 1),(43, 181, 4, 1, 1),(43, 182, 4, 1, 1),(43, 183, 4, 1, 1),(43, 184, 4, 1, 1),(43, 185, 4, 1, 1),(43, 186, 4, 1, 1),(43, 187, 4, 1, 1),(43, 188, 4, 1, 1),(43, 189, 4, 1, 1),(43, 190, 4, 1, 1),(43, 191, 4, 1, 1),(43, 192, 4, 1, 1),(43, 193, 4, 1, 1),(43, 194, 4, 1, 1),(43, 195, 4, 1, 1),(43, 196, 4, 1, 1),(43, 197, 4, 1, 1),(43, 198, 4, 1, 1),(43, 199, 4, 1, 1),(43, 200, 4, 1, 1),(43, 201, 4, 1, 1),(43, 202, 4, 1, 1),(43, 203, 4, 1, 1),(43, 204, 4, 1, 1),(43, 205, 4, 1, 1),(43, 206, 4, 1, 1),(43, 207, 4, 1, 1),(43, 208, 4, 1, 1),(43, 209, 4, 1, 1),(43, 210, 4, 1, 1),(43, 211, 4, 1, 1),(43, 212, 4, 1, 1),(43, 213, 4, 1, 1),(43, 214, 4, 1, 1),(43, 215, 4, 1, 1),(43, 216, 4, 1, 1),(43, 217, 4, 1, 1),(43, 218, 4, 1, 1),(43, 219, 4, 1, 1),(43, 220, 4, 1, 1),(43, 221, 4, 1, 1),(43, 222, 4, 1, 1),(43, 223, 4, 1, 1),(43, 224, 4, 1, 1),(43, 225, 4, 1, 1),(43, 226, 4, 1, 1),(43, 227, 4, 1, 1),(43, 228, 4, 1, 1),(43, 229, 4, 1, 1),(43, 230, 4, 1, 1),(43, 231, 4, 1, 1),(43, 232, 4, 1, 1),(43, 233, 4, 1, 1),(43, 234, 4, 1, 1),(43, 235, 4, 1, 1),(43, 236, 4, 1, 1),(43, 237, 4, 1, 1),(43, 238, 4, 1, 1),(43, 239, 4, 1, 1),(43, 240, 4, 1, 1),(43, 241, 4, 1, 1),(43, 242, 4, 1, 1),(43, 243, 4, 1, 1),(43, 244, 4, 1, 1),(43, 245, 4, 1, 1),(43, 246, 4, 1, 1),(43, 247, 4, 1, 1),(43, 248, 4, 1, 1),(43, 249, 4, 1, 1),(43, 250, 4, 1, 1),(43, 251, 4, 1, 1),(43, 252, 4, 1, 1),(43, 253, 4, 1, 1),(43, 254, 4, 1, 1),(43, 255, 4, 1, 1),(43, 256, 4, 1, 1),(43, 257, 4, 1, 1),(43, 258, 4, 1, 1),(43, 259, 4, 1, 1),(43, 260, 4, 1, 1),(43, 261, 4, 1, 1),(43, 262, 4, 1, 1),(43, 263, 4, 1, 1),(43, 264, 4, 1, 1),(43, 265, 4, 1, 1),(43, 266, 4, 1, 1),(43, 267, 4, 1, 1),(43, 268, 4, 1, 1),(43, 269, 4, 1, 1),(43, 270, 4, 1, 1),(43, 271, 4, 1, 1),(43, 272, 4, 1, 1),(43, 273, 4, 1, 1),(43, 274, 4, 1, 1),(43, 275, 4, 1, 1),(43, 276, 4, 1, 1),(43, 277, 4, 1, 1),(43, 278, 4, 1, 1),(43, 279, 4, 1, 1),(43, 280, 4, 1, 1),(43, 281, 4, 1, 1),(43, 282, 4, 1, 1),(43, 283, 4, 1, 1),(43, 284, 4, 1, 1),(43, 285, 4, 1, 1),(43, 286, 4, 1, 1),(43, 287, 4, 1, 1),(43, 288, 4, 1, 1),(43, 289, 4, 1, 1),(43, 290, 4, 1, 1),(43, 291, 4, 1, 1),(43, 292, 4, 1, 1),(43, 293, 4, 1, 1),(43, 294, 4, 1, 1),(43, 295, 4, 1, 1),(43, 296, 4, 1, 1),(43, 297, 4, 1, 1),(43, 298, 4, 1, 1),(43, 299, 4, 1, 1),(43, 300, 4, 1, 1),(43, 301, 4, 1, 1),(43, 302, 4, 1, 1),(43, 303, 4, 1, 1),(43, 304, 4, 1, 1),(43, 305, 4, 1, 1),(43, 306, 4, 1, 1),(43, 307, 4, 1, 1),(43, 308, 4, 1, 1),(43, 309, 4, 1, 1),(43, 310, 4, 1, 1),(43, 311, 4, 1, 1),(43, 312, 4, 1, 1),(43, 313, 4, 1, 1),(43, 314, 4, 1, 1),(43, 315, 4, 1, 1),(43, 316, 4, 1, 1),(43, 317, 4, 1, 1),(43, 318, 4, 1, 1),(43, 319, 4, 1, 1),(43, 320, 4, 1, 1),(43, 321, 4, 1, 1),(43, 322, 4, 1, 1),(43, 323, 4, 1, 1),(43, 324, 4, 1, 1),(43, 325, 4, 1, 1),(43, 326, 4, 1, 1),(43, 327, 4, 1, 1),(43, 328, 4, 1, 1),(43, 329, 4, 1, 1),(43, 330, 4, 1, 1),(43, 331, 4, 1, 1),(43, 332, 4, 1, 1),(43, 333, 4, 1, 1),(43, 334, 4, 1, 1),(43, 335, 4, 1, 1),(43, 336, 4, 1, 1),(43, 337, 4, 1, 1),(43, 338, 4, 1, 1),(43, 339, 4, 1, 1),(43, 340, 4, 1, 1),(43, 341, 4, 1, 1),(43, 342, 4, 1, 1),(43, 343, 4, 1, 1),(43, 344, 4, 1, 1),(43, 345, 4, 1, 1),(43, 346, 4, 1, 1),(43, 347, 4, 1, 1),(43, 348, 4, 1, 1),(43, 349, 4, 1, 1),(43, 350, 4, 1, 1),(43, 351, 4, 1, 1),(43, 352, 4, 1, 1),(43, 353, 4, 1, 1),(43, 354, 4, 1, 1),(43, 355, 4, 1, 1),(43, 356, 4, 1, 1),(43, 357, 4, 1, 1),(43, 358, 4, 1, 1),(43, 359, 4, 1, 1),(43, 360, 4, 1, 1),(43, 361, 4, 1, 1),(43, 362, 4, 1, 1),(43, 363, 4, 1, 1),(43, 364, 4, 1, 1),(43, 365, 4, 1, 1),(43, 366, 4, 1, 1),(43, 367, 4, 1, 1),(43, 368, 4, 1, 1),(43, 369, 4, 1, 1),(43, 370, 4, 1, 1),(43, 371, 4, 1, 1),(43, 372, 4, 1, 1),(43, 373, 4, 1, 1),(43, 374, 4, 1, 1),(43, 375, 4, 1, 1),(43, 376, 4, 1, 1),(43, 377, 4, 1, 1),(43, 378, 4, 1, 1),(43, 379, 4, 1, 1),(43, 380, 4, 1, 1),(43, 381, 4, 1, 1),(43, 382, 4, 1, 1),(43, 383, 4, 1, 1),(43, 384, 4, 1, 1),(43, 385, 4, 1, 1),(43, 386, 4, 1, 1),(43, 387, 4, 1, 1),(43, 388, 4, 1, 1),(43, 389, 4, 1, 1),(43, 390, 4, 1, 1),(43, 391, 4, 1, 1),(43, 392, 4, 1, 1),(43, 393, 4, 1, 1),(43, 394, 4, 1, 1),(43, 395, 4, 1, 1),(43, 396, 4, 1, 1),(43, 397, 4, 1, 1),(43, 398, 4, 1, 1),(43, 399, 4, 1, 1),(43, 400, 4, 1, 1),(43, 401, 4, 1, 1),(43, 402, 4, 1, 1),(43, 403, 4, 1, 1),(43, 404, 4, 1, 1),(43, 405, 4, 1, 1),(43, 406, 4, 1, 1),(43, 407, 4, 1, 1),(43, 408, 4, 1, 1),(43, 409, 4, 1, 1),(43, 410, 4, 1, 1),(43, 411, 4, 1, 1),(43, 412, 4, 1, 1),(43, 413, 4, 1, 1),(43, 414, 4, 1, 1),(43, 415, 4, 1, 1),(43, 416, 4, 1, 1),(43, 417, 4, 1, 1),(43, 418, 4, 1, 1),(43, 419, 4, 1, 1),(43, 420, 4, 1, 1),(43, 421, 4, 1, 1),(43, 422, 4, 1, 1),(43, 423, 4, 1, 1),(43, 424, 4, 1, 1),(43, 425, 4, 1, 1),(43, 426, 4, 1, 1),(43, 427, 4, 1, 1),(43, 428, 4, 1, 1),(43, 429, 4, 1, 1),(43, 430, 4, 1, 1),(43, 431, 4, 1, 1),(43, 432, 4, 1, 1),(43, 433, 4, 1, 1),(43, 434, 4, 1, 1),(43, 435, 4, 1, 1),(43, 436, 4, 1, 1),(43, 437, 4, 1, 1),(43, 438, 4, 1, 1),(43, 439, 4, 1, 1),(43, 440, 4, 1, 1),(43, 441, 4, 1, 1),(43, 442, 4, 1, 1),(43, 443, 4, 1, 1),(43, 444, 4, 1, 1),(43, 445, 4, 1, 1),(43, 446, 4, 1, 1),(43, 447, 4, 1, 1),(43, 448, 4, 1, 1),(43, 449, 4, 1, 1),(43, 450, 4, 1, 1),(43, 451, 4, 1, 1),(43, 452, 4, 1, 1),(43, 453, 4, 1, 1),(43, 454, 4, 1, 1),(43, 455, 4, 1, 1),(43, 456, 4, 1, 1),(43, 457, 4, 1, 1),(43, 458, 4, 1, 1),(43, 459, 4, 1, 1),(43, 460, 4, 1, 1),(43, 461, 4, 1, 1),(43, 462, 4, 1, 1),(43, 463, 4, 1, 1),(43, 464, 4, 1, 1),(43, 465, 4, 1, 1),(43, 466, 4, 1, 1),(43, 467, 4, 1, 1),(43, 468, 4, 1, 1),(43, 469, 4, 1, 1),(43, 470, 4, 1, 1),(43, 471, 4, 1, 1),(43, 472, 4, 1, 1),(43, 473, 4, 1, 1),(43, 474, 4, 1, 1),(43, 475, 4, 1, 1),(43, 476, 4, 1, 1),(43, 477, 4, 1, 1),(43, 478, 4, 1, 1),(43, 479, 4, 1, 1),(43, 480, 4, 1, 1),(43, 481, 4, 1, 1),(43, 482, 4, 1, 1),(43, 483, 4, 1, 1),(43, 484, 4, 1, 1),(43, 485, 4, 1, 1),(43, 486, 4, 1, 1),(43, 487, 4, 1, 1),(43, 488, 4, 1, 1),(43, 489, 4, 1, 1),(43, 490, 4, 1, 1),(43, 491, 4, 1, 1),(43, 492, 4, 1, 1),(43, 493, 4, 1, 1),(43, 494, 4, 1, 1),(43, 495, 4, 1, 1),(43, 496, 4, 1, 1),(43, 497, 4, 1, 1),(43, 498, 4, 1, 1),(43, 499, 4, 1, 1),(43, 500, 4, 1, 1),(43, 501, 4, 1, 1),(43, 502, 4, 1, 1),(43, 503, 4, 1, 1),(43, 504, 4, 1, 1),(43, 505, 4, 1, 1),(43, 506, 4, 1, 1),(43, 507, 4, 1, 1),(43, 508, 4, 1, 1),(43, 509, 4, 1, 1),(43, 510, 4, 1, 1),(43, 511, 4, 1, 1),(43, 512, 4, 1, 1),(43, 513, 4, 1, 1),(43, 514, 4, 1, 1),(43, 515, 4, 1, 1),(43, 516, 4, 1, 1),(43, 517, 4, 1, 1),(43, 518, 4, 1, 1),(43, 519, 4, 1, 1),(43, 520, 4, 1, 1),(43, 521, 4, 1, 1),(43, 522, 4, 1, 1),(43, 523, 4, 1, 1),(43, 524, 4, 1, 1),(43, 525, 4, 1, 1),(43, 526, 4, 1, 1),(43, 527, 4, 1, 1),(43, 528, 4, 1, 1),(43, 529, 4, 1, 1),(43, 530, 4, 1, 1),(43, 531, 4, 1, 1),(43, 532, 4, 1, 1),(43, 533, 4, 1, 1),(43, 534, 4, 1, 1),(43, 535, 4, 1, 1),(43, 536, 4, 1, 1),(43, 537, 4, 1, 1),(43, 538, 4, 1, 1),(43, 539, 4, 1, 1),(43, 540, 4, 1, 1),(43, 541, 4, 1, 1),(43, 542, 4, 1, 1),(43, 543, 4, 1, 1),(43, 544, 4, 1, 1),(43, 545, 4, 1, 1),(43, 546, 4, 1, 1),(43, 547, 4, 1, 1),(43, 548, 4, 1, 1),(43, 549, 4, 1, 1),(43, 550, 4, 1, 1),(43, 551, 4, 1, 1),(43, 552, 4, 1, 1),(43, 553, 4, 1, 1),(43, 554, 4, 1, 1),(43, 555, 4, 1, 1),(43, 556, 4, 1, 1),(43, 557, 4, 1, 1),(43, 558, 4, 1, 1),(43, 559, 4, 1, 1),(43, 560, 4, 1, 1),(43, 561, 4, 1, 1),(43, 562, 4, 1, 1),(43, 563, 4, 1, 1),(43, 564, 4, 1, 1),(43, 565, 4, 1, 1),(43, 566, 4, 1, 1),(43, 567, 4, 1, 1),(43, 568, 4, 1, 1),(43, 569, 4, 1, 1),(43, 570, 4, 1, 1),(43, 571, 4, 1, 1),(43, 572, 4, 1, 1),(43, 573, 4, 1, 1),(43, 574, 4, 1, 1),(43, 575, 4, 1, 1),(43, 576, 4, 1, 1),(43, 577, 4, 1, 1),(43, 578, 4, 1, 1),(43, 579, 4, 1, 1),(43, 580, 4, 1, 1),(43, 581, 4, 1, 1),(43, 582, 4, 1, 1),(43, 583, 4, 1, 1),(43, 584, 4, 1, 1),(43, 585, 4, 1, 1),(43, 586, 4, 1, 1),(43, 587, 4, 1, 1),(43, 588, 4, 1, 1),(43, 589, 4, 1, 1),(43, 590, 4, 1, 1),(43, 591, 4, 1, 1),(43, 592, 4, 1, 1),(43, 593, 4, 1, 1),(43, 594, 4, 1, 1),(43, 595, 4, 1, 1),(43, 596, 4, 1, 1),(43, 597, 4, 1, 1),(43, 598, 4, 1, 1),(43, 599, 4, 1, 1),(43, 600, 4, 1, 1),(43, 601, 4, 1, 1),(43, 602, 4, 1, 1),(43, 603, 4, 1, 1),(43, 604, 4, 1, 1),(43, 605, 4, 1, 1),(43, 606, 4, 1, 1),(43, 607, 4, 1, 1),(43, 608, 4, 1, 1),(43, 609, 4, 1, 1),(43, 610, 4, 1, 1),(43, 611, 4, 1, 1),(43, 612, 4, 1, 1),(43, 613, 4, 1, 1),(43, 614, 4, 1, 1),(43, 615, 4, 1, 1),(43, 616, 4, 1, 1),(43, 617, 4, 1, 1),(43, 618, 4, 1, 1),(43, 619, 4, 1, 1),(43, 620, 4, 1, 1),(43, 621, 4, 1, 1),(43, 622, 4, 1, 1),(43, 623, 4, 1, 1),(43, 624, 4, 1, 1),(43, 625, 4, 1, 1),(43, 626, 4, 1, 1),(43, 627, 4, 1, 1),(43, 628, 4, 1, 1),(43, 629, 4, 1, 1),(43, 630, 4, 1, 1),(43, 631, 4, 1, 1),(43, 632, 4, 1, 1),(43, 633, 4, 1, 1),(43, 634, 4, 1, 1),(43, 635, 4, 1, 1),(43, 636, 4, 1, 1),(43, 637, 4, 1, 1),(43, 638, 4, 1, 1),(43, 639, 4, 1, 1),(43, 640, 4, 1, 1),(43, 641, 4, 1, 1),(43, 642, 4, 1, 1),(43, 643, 4, 1, 1),(43, 644, 4, 1, 1),(43, 645, 4, 1, 1),(43, 646, 4, 1, 1),(43, 647, 4, 1, 1),(43, 648, 4, 1, 1),(43, 649, 4, 1, 1),(43, 650, 4, 1, 1),(43, 651, 4, 1, 1),(43, 652, 4, 1, 1),(43, 653, 4, 1, 1),(43, 654, 4, 1, 1),(43, 655, 4, 1, 1),(43, 656, 4, 1, 1),(43, 657, 4, 1, 1),(43, 658, 4, 1, 1),(43, 659, 4, 1, 1),(43, 660, 4, 1, 1),(43, 661, 4, 1, 1),(43, 662, 4, 1, 1),(43, 663, 4, 1, 1),(43, 664, 4, 1, 1),(43, 665, 4, 1, 1),(43, 666, 4, 1, 1),(43, 667, 4, 1, 1),(43, 668, 4, 1, 1),(43, 669, 4, 1, 1),(43, 670, 4, 1, 1),(43, 671, 4, 1, 1),(43, 672, 4, 1, 1),(43, 673, 4, 1, 1),(43, 674, 4, 1, 1),(43, 675, 4, 1, 1),(43, 676, 4, 1, 1),(43, 677, 4, 1, 1),(43, 678, 4, 1, 1),(43, 679, 4, 1, 1),(43, 680, 4, 1, 1),(43, 681, 4, 1, 1),(43, 682, 4, 1, 1),(43, 683, 4, 1, 1),(43, 684, 4, 1, 1),(43, 685, 4, 1, 1),(43, 686, 4, 1, 1),(43, 687, 4, 1, 1),(43, 688, 4, 1, 1),(43, 689, 4, 1, 1),(43, 690, 4, 1, 1),(43, 691, 4, 1, 1),(43, 692, 4, 1, 1),(43, 693, 4, 1, 1),(43, 694, 4, 1, 1),(43, 695, 4, 1, 1),(43, 696, 4, 1, 1),(43, 697, 4, 1, 1),(43, 698, 4, 1, 1),(43, 699, 4, 1, 1),(43, 700, 4, 1, 1),(43, 701, 4, 1, 1),(43, 702, 4, 1, 1),(43, 703, 4, 1, 1),(43, 704, 4, 1, 1),(43, 705, 4, 1, 1),(43, 706, 4, 1, 1),(43, 707, 4, 1, 1),(43, 708, 4, 1, 1),(43, 709, 4, 1, 1),(43, 710, 4, 1, 1),(43, 711, 4, 1, 1),(43, 712, 4, 1, 1),(43, 713, 4, 1, 1),(43, 714, 4, 1, 1),(43, 715, 4, 1, 1),(43, 716, 4, 1, 1),(43, 717, 4, 1, 1),(43, 718, 4, 1, 1),(43, 719, 4, 1, 1),(43, 720, 4, 1, 1),(43, 721, 4, 1, 1),(43, 722, 4, 1, 1),(43, 723, 4, 1, 1),(43, 724, 4, 1, 1),(43, 725, 4, 1, 1),(43, 726, 4, 1, 1),(43, 727, 4, 1, 1),(43, 728, 4, 1, 1),(43, 729, 4, 1, 1),(43, 730, 4, 1, 1),(43, 731, 4, 1, 1),(43, 732, 4, 1, 1),(43, 733, 4, 1, 1),(43, 734, 4, 1, 1),(43, 735, 4, 1, 1),(43, 736, 4, 1, 1),(43, 737, 4, 1, 1),(43, 738, 4, 1, 1),(43, 739, 4, 1, 1),(43, 740, 4, 1, 1),(43, 741, 4, 1, 1),(43, 742, 4, 1, 1),(43, 743, 4, 1, 1),(43, 744, 4, 1, 1),(43, 745, 4, 1, 1),(43, 746, 4, 1, 1),(43, 747, 4, 1, 1),(43, 748, 4, 1, 1),(43, 749, 4, 1, 1),(43, 750, 4, 1, 1),(43, 751, 4, 1, 1),(43, 752, 4, 1, 1),(43, 753, 4, 1, 1),(43, 754, 4, 1, 1),(43, 755, 4, 1, 1),(43, 756, 4, 1, 1),(43, 757, 4, 1, 1),(43, 758, 4, 1, 1),(43, 759, 4, 1, 1),(43, 760, 4, 1, 1),(43, 761, 4, 1, 1),(43, 762, 4, 1, 1),(43, 763, 4, 1, 1),(43, 764, 4, 1, 1),(43, 765, 4, 1, 1),(43, 766, 4, 1, 1),(43, 767, 4, 1, 1),(43, 768, 4, 1, 1),(43, 769, 4, 1, 1),(43, 770, 4, 1, 1),(43, 771, 4, 1, 1),(43, 772, 4, 1, 1),(43, 773, 4, 1, 1),(43, 774, 4, 1, 1),(43, 775, 4, 1, 1),(43, 776, 4, 1, 1),(43, 777, 4, 1, 1),(43, 778, 4, 1, 1),(43, 779, 4, 1, 1),(43, 780, 4, 1, 1),(43, 781, 4, 1, 1),(43, 782, 4, 1, 1),(43, 783, 4, 1, 1),(43, 784, 4, 1, 1),(43, 785, 4, 1, 1),(43, 786, 4, 1, 1),(43, 787, 4, 1, 1),(43, 788, 4, 1, 1),(43, 789, 4, 1, 1),(43, 790, 4, 1, 1),(43, 791, 4, 1, 1),(43, 792, 4, 1, 1),(43, 793, 4, 1, 1),(43, 794, 4, 1, 1),(43, 795, 4, 1, 1),(43, 796, 4, 1, 1),(43, 797, 4, 1, 1),(43, 798, 4, 1, 1),(43, 799, 4, 1, 1),(43, 800, 4, 1, 1),(43, 801, 4, 1, 1),(43, 802, 4, 1, 1),(43, 803, 4, 1, 1),(43, 804, 4, 1, 1),(43, 805, 4, 1, 1),(43, 806, 4, 1, 1),(43, 807, 4, 1, 1),(43, 808, 4, 1, 1),(43, 809, 4, 1, 1),(43, 810, 4, 1, 1),(43, 811, 4, 1, 1),(43, 812, 4, 1, 1),(43, 813, 4, 1, 1),(43, 814, 4, 1, 1),(43, 815, 4, 1, 1),(43, 816, 4, 1, 1),(43, 817, 4, 1, 1),(43, 818, 4, 1, 1),(43, 819, 4, 1, 1),(43, 820, 4, 1, 1),(43, 821, 4, 1, 1),(43, 822, 4, 1, 1),(43, 823, 4, 1, 1),(43, 824, 4, 1, 1),(43, 825, 4, 1, 1),(43, 826, 4, 1, 1),(43, 827, 4, 1, 1),(43, 828, 4, 1, 1),(43, 829, 4, 1, 1),(43, 830, 4, 1, 1),(43, 831, 4, 1, 1),(43, 832, 4, 1, 1),(43, 833, 4, 1, 1),(43, 834, 4, 1, 1),(43, 835, 4, 1, 1),(43, 836, 4, 1, 1),(43, 837, 4, 1, 1),(43, 838, 4, 1, 1),(43, 839, 4, 1, 1),(43, 840, 4, 1, 1),(43, 841, 4, 1, 1),(43, 842, 4, 1, 1),(43, 843, 4, 1, 1),(43, 844, 4, 1, 1),(43, 845, 4, 1, 1),(43, 846, 4, 1, 1),(43, 847, 4, 1, 1),(43, 848, 4, 1, 1),(43, 849, 4, 1, 1),(43, 850, 4, 1, 1),(43, 851, 4, 1, 1),(43, 852, 4, 1, 1),(43, 853, 4, 1, 1),(43, 854, 4, 1, 1),(43, 855, 4, 1, 1),(43, 856, 4, 1, 1),(43, 857, 4, 1, 1),(43, 858, 4, 1, 1),(43, 859, 4, 1, 1),(43, 860, 4, 1, 1),(43, 861, 4, 1, 1),(43, 862, 4, 1, 1),(43, 863, 4, 1, 1),(43, 864, 4, 1, 1),(43, 865, 4, 1, 1),(43, 866, 4, 1, 1),(43, 867, 4, 1, 1),(43, 868, 4, 1, 1),(43, 869, 4, 1, 1),(43, 870, 4, 1, 1),(43, 871, 4, 1, 1),(43, 872, 4, 1, 1),(43, 873, 4, 1, 1),(43, 874, 4, 1, 1),(43, 875, 4, 1, 1),(43, 876, 4, 1, 1),(43, 877, 4, 1, 1),(43, 878, 4, 1, 1),(43, 879, 4, 1, 1),(43, 880, 4, 1, 1),(43, 881, 4, 1, 1),(43, 882, 4, 1, 1),(43, 883, 4, 1, 1),(43, 884, 4, 1, 1),(43, 885, 4, 1, 1),(43, 886, 4, 1, 1),(43, 887, 4, 1, 1),(43, 888, 4, 1, 1),(43, 889, 4, 1, 1),(43, 890, 4, 1, 1),(43, 891, 4, 1, 1),(43, 892, 4, 1, 1),(43, 893, 4, 1, 1),(43, 894, 4, 1, 1),(43, 895, 4, 1, 1),(43, 896, 4, 1, 1),(43, 897, 4, 1, 1),(43, 898, 4, 1, 1),(43, 899, 4, 1, 1),(43, 900, 4, 1, 1),(43, 901, 4, 1, 1),(43, 902, 4, 1, 1),(43, 903, 4, 1, 1),(43, 904, 4, 1, 1),(43, 905, 4, 1, 1),(43, 906, 4, 1, 1),(43, 907, 4, 1, 1),(43, 908, 4, 1, 1),(43, 909, 4, 1, 1),(43, 910, 4, 1, 1),(43, 911, 4, 1, 1),(43, 912, 4, 1, 1),(43, 913, 4, 1, 1),(43, 914, 4, 1, 1),(43, 915, 4, 1, 1),(43, 916, 4, 1, 1),(43, 917, 4, 1, 1),(43, 918, 4, 1, 1),(43, 919, 4, 1, 1),(43, 920, 4, 1, 1),(43, 921, 4, 1, 1),(43, 922, 4, 1, 1),(43, 923, 4, 1, 1),(43, 924, 4, 1, 1),(43, 925, 4, 1, 1),(43, 926, 4, 1, 1),(43, 927, 4, 1, 1),(43, 928, 4, 1, 1),(43, 929, 4, 1, 1),(43, 930, 4, 1, 1),(43, 931, 4, 1, 1),(43, 932, 4, 1, 1),(43, 933, 4, 1, 1),(43, 934, 4, 1, 1),(43, 935, 4, 1, 1),(43, 936, 4, 1, 1),(43, 937, 4, 1, 1),(43, 938, 4, 1, 1),(43, 939, 4, 1, 1),(43, 940, 4, 1, 1),(43, 941, 4, 1, 1),(43, 942, 4, 1, 1),(43, 943, 4, 1, 1),(43, 944, 4, 1, 1),(43, 945, 4, 1, 1),(43, 946, 4, 1, 1),(43, 947, 4, 1, 1),(43, 948, 4, 1, 1),(43, 949, 4, 1, 1),(43, 950, 4, 1, 1),(43, 951, 4, 1, 1),(43, 952, 4, 1, 1),(43, 953, 4, 1, 1),(43, 954, 4, 1, 1),(43, 955, 4, 1, 1),(43, 956, 4, 1, 1),(43, 957, 4, 1, 1),(43, 958, 4, 1, 1),(43, 959, 4, 1, 1),(43, 960, 4, 1, 1),(43, 961, 4, 1, 1),(43, 962, 4, 1, 1),(43, 963, 4, 1, 1),(43, 964, 4, 1, 1),(43, 965, 4, 1, 1),(43, 966, 4, 1, 1),(43, 967, 4, 1, 1),(43, 968, 4, 1, 1),(43, 969, 4, 1, 1),(43, 970, 4, 1, 1),(43, 971, 4, 1, 1),(43, 972, 4, 1, 1),(43, 973, 4, 1, 1),(43, 974, 4, 1, 1),(43, 975, 4, 1, 1),(43, 976, 4, 1, 1),(43, 977, 4, 1, 1),(43, 978, 4, 1, 1),(43, 979, 4, 1, 1),(43, 980, 4, 1, 1),(43, 981, 4, 1, 1),(43, 982, 4, 1, 1),(43, 983, 4, 1, 1),(43, 984, 4, 1, 1),(43, 985, 4, 1, 1),(43, 986, 4, 1, 1),(43, 987, 4, 1, 1),(43, 988, 4, 1, 1),(43, 989, 4, 1, 1),(43, 990, 4, 1, 1),(43, 991, 4, 1, 1),(43, 992, 4, 1, 1),(43, 993, 4, 1, 1),(43, 994, 4, 1, 1),(43, 995, 4, 1, 1),(43, 996, 4, 1, 1),(43, 997, 4, 1, 1),(43, 998, 4, 1, 1),(43, 999, 4, 1, 1),(43, 1000, 4, 1, 1),(43, 1001, 4, 1, 1),(43, 1002, 4, 1, 1),(43, 1003, 4, 1, 1),(43, 1004, 4, 1, 1),(43, 1005, 4, 1, 1),(43, 1006, 4, 1, 1),(43, 1007, 4, 1, 1),(43, 1008, 4, 1, 1),(43, 1009, 4, 1, 1),(43, 1010, 4, 1, 1),(43, 1011, 4, 1, 1),(43, 1012, 4, 1, 1),(43, 1013, 4, 1, 1),(43, 1014, 4, 1, 1),(43, 1015, 4, 1, 1),(43, 1016, 4, 1, 1),(43, 1017, 4, 1, 1),(43, 1018, 4, 1, 1),(43, 1019, 4, 1, 1),(43, 1020, 4, 1, 1),(43, 1021, 4, 1, 1),(43, 1022, 4, 1, 1),(43, 1023, 4, 1, 1),(43, 1024, 4, 1, 1),(43, 1025, 4, 1, 1),(43, 1026, 4, 1, 1),(43, 1027, 4, 1, 1),(43, 1028, 4, 1, 1),(43, 1029, 4, 1, 1),(43, 1030, 4, 1, 1),(43, 1031, 4, 1, 1),(43, 1032, 4, 1, 1),(43, 1033, 4, 1, 1),(43, 1034, 4, 1, 1),(43, 1035, 4, 1, 1),(43, 1036, 4, 1, 1),(43, 1037, 4, 1, 1),(43, 1038, 4, 1, 1),(43, 1039, 4, 1, 1),(43, 1040, 4, 1, 1),(43, 1041, 4, 1, 1),(43, 1042, 4, 1, 1),(43, 1043, 4, 1, 1),(43, 1044, 4, 1, 1),(43, 1045, 4, 1, 1),(43, 1046, 4, 1, 1),(43, 1047, 4, 1, 1),(43, 1048, 4, 1, 1),(43, 1049, 4, 1, 1),(43, 1050, 4, 1, 1),(43, 1051, 4, 1, 1),(43, 1052, 4, 1, 1),(43, 1053, 4, 1, 1),(43, 1054, 4, 1, 1),(43, 1055, 4, 1, 1),(43, 1056, 4, 1, 1),(43, 1057, 4, 1, 1),(43, 1058, 4, 1, 1),(43, 1059, 4, 1, 1),(43, 1060, 4, 1, 1),(43, 1061, 4, 1, 1),(43, 1062, 4, 1, 1),(43, 1063, 4, 1, 1),(43, 1064, 4, 1, 1),(43, 1065, 4, 1, 1),(43, 1066, 4, 1, 1),(43, 1067, 4, 1, 1),(43, 1068, 4, 1, 1),(43, 1069, 4, 1, 1),(43, 1070, 4, 1, 1),(43, 1071, 4, 1, 1),(43, 1072, 4, 1, 1),(43, 1073, 4, 1, 1),(43, 1074, 4, 1, 1),(43, 1075, 4, 1, 1),(43, 1076, 4, 1, 1),(43, 1077, 4, 1, 1),(43, 1078, 4, 1, 1),(43, 1079, 4, 1, 1),(43, 1080, 4, 1, 1),(43, 1081, 4, 1, 1),(43, 1082, 4, 1, 1),(43, 1083, 4, 1, 1),(43, 1084, 4, 1, 1),(43, 1085, 4, 1, 1),(43, 1086, 4, 1, 1),(43, 1087, 4, 1, 1),(43, 1088, 4, 1, 1),(43, 1089, 4, 1, 1),(43, 1090, 4, 1, 1),(43, 1091, 4, 1, 1),(43, 1092, 4, 1, 1),(43, 1093, 4, 1, 1),(43, 1094, 4, 1, 1),(43, 1095, 4, 1, 1),(43, 1096, 4, 1, 1),(43, 1097, 4, 1, 1),(43, 1098, 4, 1, 1),(43, 1099, 4, 1, 1),(43, 1100, 4, 1, 1),(43, 1101, 4, 1, 1),(43, 1102, 4, 1, 1),(43, 1103, 4, 1, 1),(43, 1104, 4, 1, 1),(43, 1105, 4, 1, 1),(43, 1106, 4, 1, 1),(43, 1107, 4, 1, 1),(43, 1108, 4, 1, 1),(43, 1109, 4, 1, 1),(43, 1110, 4, 1, 1),(43, 1111, 4, 1, 1),(43, 1112, 4, 1, 1),(43, 1113, 4, 1, 1),(43, 1114, 4, 1, 1),(43, 1115, 4, 1, 1),(43, 1116, 4, 1, 1),(43, 1117, 4, 1, 1),(43, 1118, 4, 1, 1),(43, 1119, 4, 1, 1),(43, 1120, 4, 1, 1),(43, 1121, 4, 1, 1),(43, 1122, 4, 1, 1),(43, 1123, 4, 1, 1),(43, 1124, 4, 1, 1),(43, 1125, 4, 1, 1),(43, 1126, 4, 1, 1),(43, 1127, 4, 1, 1),(43, 1128, 4, 1, 1),(43, 1129, 4, 1, 1),(43, 1130, 4, 1, 1),(43, 1131, 4, 1, 1),(43, 1132, 4, 1, 1),(43, 1133, 4, 1, 1),(43, 1134, 4, 1, 1),(43, 1135, 4, 1, 1),(43, 1136, 4, 1, 1),(43, 1137, 4, 1, 1),(43, 1138, 4, 1, 1),(43, 1139, 4, 1, 1),(43, 1140, 4, 1, 1),(43, 1141, 4, 1, 1),(43, 1142, 4, 1, 1),(43, 1143, 4, 1, 1),(43, 1144, 4, 1, 1),(43, 1145, 4, 1, 1),(43, 1146, 4, 1, 1),(43, 1147, 4, 1, 1),(43, 1148, 4, 1, 1),(43, 1149, 4, 1, 1),(43, 1150, 4, 1, 1),(43, 1151, 4, 1, 1),(43, 1152, 4, 1, 1),(43, 1153, 4, 1, 1),(43, 1154, 4, 1, 1),(43, 1155, 4, 1, 1),(43, 1156, 4, 1, 1),(43, 1157, 4, 1, 1),(43, 1158, 4, 1, 1),(43, 1159, 4, 1, 1),(43, 1160, 4, 1, 1),(43, 1161, 4, 1, 1),(43, 1162, 4, 1, 1),(43, 1163, 4, 1, 1),(43, 1164, 4, 1, 1),(43, 1165, 4, 1, 1),(43, 1166, 4, 1, 1),(43, 1167, 4, 1, 1),(43, 1168, 4, 1, 1),(43, 1169, 4, 1, 1),(43, 1170, 4, 1, 1),(43, 1171, 4, 1, 1),(43, 1172, 4, 1, 1),(43, 1173, 4, 1, 1),(43, 1174, 4, 1, 1),(43, 1175, 4, 1, 1),(43, 1176, 4, 1, 1),(43, 1177, 4, 1, 1),(43, 1178, 4, 1, 1),(43, 1179, 4, 1, 1),(43, 1180, 4, 1, 1),(43, 1181, 4, 1, 1),(43, 1182, 4, 1, 1),(43, 1183, 4, 1, 1),(43, 1184, 4, 1, 1),(43, 1185, 4, 1, 1),(43, 1186, 4, 1, 1),(43, 1187, 4, 1, 1),(43, 1188, 4, 1, 1),(43, 1189, 4, 1, 1),(43, 1190, 4, 1, 1),(43, 1191, 4, 1, 1),(43, 1192, 4, 1, 1),(43, 1193, 4, 1, 1),(43, 1194, 4, 1, 1),(43, 1195, 4, 1, 1),(43, 1196, 4, 1, 1),(43, 1197, 4, 1, 1),(43, 1198, 4, 1, 1),(43, 1199, 4, 1, 1),(43, 1200, 4, 1, 1),(43, 1201, 4, 1, 1),(43, 1202, 4, 1, 1),(43, 1203, 4, 1, 1),(43, 1204, 4, 1, 1),(43, 1205, 4, 1, 1),(43, 1206, 4, 1, 1),(43, 1207, 4, 1, 1),(43, 1208, 4, 1, 1),(43, 1209, 4, 1, 1),(43, 1210, 4, 1, 1),(43, 1211, 4, 1, 1),(43, 1212, 4, 1, 1),(43, 1213, 4, 1, 1),(43, 1214, 4, 1, 1),(43, 1215, 4, 1, 1),(43, 1216, 4, 1, 1),(43, 1217, 4, 1, 1),(43, 1218, 4, 1, 1),(43, 1219, 4, 1, 1),(43, 1220, 4, 1, 1),(43, 1221, 4, 1, 1),(43, 1222, 4, 1, 1),(43, 1223, 4, 1, 1),(43, 1224, 4, 1, 1),(43, 1225, 4, 1, 1),(43, 1226, 4, 1, 1),(43, 1227, 4, 1, 1),(43, 1228, 4, 1, 1),(43, 1229, 4, 1, 1),(43, 1230, 4, 1, 1),(43, 1231, 4, 1, 1),(43, 1232, 4, 1, 1),(43, 1233, 4, 1, 1),(43, 1234, 4, 1, 1),(43, 1235, 4, 1, 1),(43, 1236, 4, 1, 1),(43, 1237, 4, 1, 1),(43, 1238, 4, 1, 1),(43, 1239, 4, 1, 1),(43, 1240, 4, 1, 1),(43, 1241, 4, 1, 1),(43, 1242, 4, 1, 1),(43, 1243, 4, 1, 1),(43, 1244, 4, 1, 1),(43, 1245, 4, 1, 1),(43, 1246, 4, 1, 1),(43, 1247, 4, 1, 1),(43, 1248, 4, 1, 1),(43, 1249, 4, 1, 1),(43, 1250, 4, 1, 1),(43, 1251, 4, 1, 1),(43, 1252, 4, 1, 1),(43, 1253, 4, 1, 1),(43, 1254, 4, 1, 1),(43, 1255, 4, 1, 1),(43, 1256, 4, 1, 1),(43, 1257, 4, 1, 1),(43, 1258, 4, 1, 1),(43, 1259, 4, 1, 1),(43, 1260, 4, 1, 1),(43, 1261, 4, 1, 1),(43, 1262, 4, 1, 1),(43, 1263, 4, 1, 1),(43, 1264, 4, 1, 1),(43, 1265, 4, 1, 1),(43, 1266, 4, 1, 1),(43, 1267, 4, 1, 1),(43, 1268, 4, 1, 1),(43, 1269, 4, 1, 1),(43, 1270, 4, 1, 1),(43, 1271, 4, 1, 1),(43, 1272, 4, 1, 1),(43, 1273, 4, 1, 1),(43, 1274, 4, 1, 1),(43, 1275, 4, 1, 1),(43, 1276, 4, 1, 1),(43, 1277, 4, 1, 1),(43, 1278, 4, 1, 1),(43, 1279, 4, 1, 1),(43, 1280, 4, 1, 1),(43, 1281, 4, 1, 1),(43, 1282, 4, 1, 1),(43, 1283, 4, 1, 1),(43, 1284, 4, 1, 1),(43, 1285, 4, 1, 1),(43, 1286, 4, 1, 1),(43, 1287, 4, 1, 1),(43, 1288, 4, 1, 1),(43, 1289, 4, 1, 1),(43, 1290, 4, 1, 1),(43, 1291, 4, 1, 1),(43, 1292, 4, 1, 1),(43, 1293, 4, 1, 1),(43, 1294, 4, 1, 1),(43, 1295, 4, 1, 1),(43, 1296, 4, 1, 1),(43, 1297, 4, 1, 1),(43, 1298, 4, 1, 1),(43, 1299, 4, 1, 1),(43, 1300, 4, 1, 1),(43, 1301, 4, 1, 1),(43, 1302, 4, 1, 1),(43, 1303, 4, 1, 1),(43, 1304, 4, 1, 1),(43, 1305, 4, 1, 1),(43, 1306, 4, 1, 1),(43, 1307, 4, 1, 1),(43, 1308, 4, 1, 1),(43, 1309, 4, 1, 1),(43, 1310, 4, 1, 1),(43, 1311, 4, 1, 1),(43, 1312, 4, 1, 1),(43, 1313, 4, 1, 1),(43, 1314, 4, 1, 1),(43, 1315, 4, 1, 1),(43, 1316, 4, 1, 1),(43, 1317, 4, 1, 1),(43, 1318, 4, 1, 1),(43, 1319, 4, 1, 1),(43, 1320, 4, 1, 1),(43, 1321, 4, 1, 1),(43, 1322, 4, 1, 1),(43, 1323, 4, 1, 1),(43, 1324, 4, 1, 1),(43, 1325, 4, 1, 1),(43, 1326, 4, 1, 1),(43, 1327, 4, 1, 1),(43, 1328, 4, 1, 1),(43, 1329, 4, 1, 1),(43, 1330, 4, 1, 1),(43, 1331, 4, 1, 1),(43, 1332, 4, 1, 1),(43, 1333, 4, 1, 1),(43, 1334, 4, 1, 1),(43, 1335, 4, 1, 1),(43, 1336, 4, 1, 1),(43, 1337, 4, 1, 1),(43, 1338, 4, 1, 1),(43, 1339, 4, 1, 1),(43, 1340, 4, 1, 1),(43, 1341, 4, 1, 1),(43, 1342, 4, 1, 1),(43, 1343, 4, 1, 1),(43, 1344, 4, 1, 1),(43, 1345, 4, 1, 1),(43, 1346, 4, 1, 1),(43, 1347, 4, 1, 1),(43, 1348, 4, 1, 1),(43, 1349, 4, 1, 1),(43, 1350, 4, 1, 1),(43, 1351, 4, 1, 1),(43, 1352, 4, 1, 1),(43, 1353, 4, 1, 1),(43, 1354, 4, 1, 1),(43, 1355, 4, 1, 1),(43, 1356, 4, 1, 1),(43, 1357, 4, 1, 1),(43, 1358, 4, 1, 1),(43, 1359, 4, 1, 1),(43, 1360, 4, 1, 1),(43, 1361, 4, 1, 1),(43, 1362, 4, 1, 1),(43, 1363, 4, 1, 1),(43, 1364, 4, 1, 1),(43, 1365, 4, 1, 1),(43, 1366, 4, 1, 1),(43, 1367, 4, 1, 1),(43, 1368, 4, 1, 1),(43, 1369, 4, 1, 1),(43, 1370, 4, 1, 1),(43, 1371, 4, 1, 1),(43, 1372, 4, 1, 1),(43, 1373, 4, 1, 1),(43, 1374, 4, 1, 1),(43, 1375, 4, 1, 1),(43, 1376, 4, 1, 1),(43, 1377, 4, 1, 1),(43, 1378, 4, 1, 1),(43, 1379, 4, 1, 1),(43, 1380, 4, 1, 1),(43, 1381, 4, 1, 1),(43, 1382, 4, 1, 1),(43, 1383, 4, 1, 1),(43, 1384, 4, 1, 1),(43, 1385, 4, 1, 1),(43, 1386, 4, 1, 1),(43, 1387, 4, 1, 1),(43, 1388, 4, 1, 1),(43, 1389, 4, 1, 1),(43, 1390, 4, 1, 1),(43, 1391, 4, 1, 1),(43, 1392, 4, 1, 1),(43, 1393, 4, 1, 1),(43, 1394, 4, 1, 1),(43, 1395, 4, 1, 1),(43, 1396, 4, 1, 1),(43, 1397, 4, 1, 1),(43, 1398, 4, 1, 1),(43, 1399, 4, 1, 1),(43, 1400, 4, 1, 1),(43, 1401, 4, 1, 1),(43, 1402, 4, 1, 1),(43, 1403, 4, 1, 1),(43, 1404, 4, 1, 1),(43, 1405, 4, 1, 1),(43, 1406, 4, 1, 1),(43, 1407, 4, 1, 1),(43, 1408, 4, 1, 1),(43, 1409, 4, 1, 1),(43, 1410, 4, 1, 1),(43, 1411, 4, 1, 1),(43, 1412, 4, 1, 1),(43, 1413, 4, 1, 1),(43, 1414, 4, 1, 1),(43, 1415, 4, 1, 1),(43, 1416, 4, 1, 1),(43, 1417, 4, 1, 1),(43, 1418, 4, 1, 1),(43, 1419, 4, 1, 1),(43, 1420, 4, 1, 1),(43, 1421, 4, 1, 1),(43, 1422, 4, 1, 1),(43, 1423, 4, 1, 1),(43, 1424, 4, 1, 1),(43, 1425, 4, 1, 1),(43, 1426, 4, 1, 1),(43, 1427, 4, 1, 1),(43, 1428, 4, 1, 1),(43, 1429, 4, 1, 1),(43, 1430, 4, 1, 1),(43, 1431, 4, 1, 1),(43, 1432, 4, 1, 1),(43, 1433, 4, 1, 1),(43, 1434, 4, 1, 1),(43, 1435, 4, 1, 1),(43, 1436, 4, 1, 1),(43, 1437, 4, 1, 1),(43, 1438, 4, 1, 1),(43, 1439, 4, 1, 1),(43, 1440, 4, 1, 1),(43, 1441, 4, 1, 1),(43, 1442, 4, 1, 1),(43, 1443, 4, 1, 1),(43, 1444, 4, 1, 1),(43, 1445, 4, 1, 1),(43, 1446, 4, 1, 1),(43, 1447, 4, 1, 1),(43, 1448, 4, 1, 1),(43, 1449, 4, 1, 1),(43, 1450, 4, 1, 1),(43, 1451, 4, 1, 1),(43, 1452, 4, 1, 1),(43, 1453, 4, 1, 1),(43, 1454, 4, 1, 1),(43, 1455, 4, 1, 1),(43, 1456, 4, 1, 1),(43, 1457, 4, 1, 1),(43, 1458, 4, 1, 1),(43, 1459, 4, 1, 1),(43, 1460, 4, 1, 1),(43, 1461, 4, 1, 1),(43, 1462, 4, 1, 1),(43, 1463, 4, 1, 1),(43, 1464, 4, 1, 1),(43, 1465, 4, 1, 1),(43, 1466, 4, 1, 1),(43, 1467, 4, 1, 1),(43, 1468, 4, 1, 1),(43, 1469, 4, 1, 1),(43, 1470, 4, 1, 1),(43, 1471, 4, 1, 1),(43, 1472, 4, 1, 1),(43, 1473, 4, 1, 1),(43, 1474, 4, 1, 1),(43, 1475, 4, 1, 1),(43, 1476, 4, 1, 1),(43, 1477, 4, 1, 1),(43, 1478, 4, 1, 1),(43, 1479, 4, 1, 1),(43, 1480, 4, 1, 1),(43, 1481, 4, 1, 1),(43, 1482, 4, 1, 1),(43, 1483, 4, 1, 1),(43, 1484, 4, 1, 1),(43, 1485, 4, 1, 1),(43, 1486, 4, 1, 1),(43, 1487, 4, 1, 1),(43, 1488, 4, 1, 1),(43, 1489, 4, 1, 1),(43, 1490, 4, 1, 1),(43, 1491, 4, 1, 1),(43, 1492, 4, 1, 1),(43, 1493, 4, 1, 1),(43, 1494, 4, 1, 1),(43, 1495, 4, 1, 1),(43, 1496, 4, 1, 1),(43, 1497, 4, 1, 1),(43, 1498, 4, 1, 1),(43, 1499, 4, 1, 1),(43, 1500, 4, 1, 1),(43, 1501, 4, 1, 1),(43, 1502, 4, 1, 1),(43, 1503, 4, 1, 1),(43, 1504, 4, 1, 1),(43, 1505, 4, 1, 1),(43, 1506, 4, 1, 1),(43, 1507, 4, 1, 1),(43, 1508, 4, 1, 1),(43, 1509, 4, 1, 1),(43, 1510, 4, 1, 1),(43, 1511, 4, 1, 1),(43, 1512, 4, 1, 1),(43, 1513, 4, 1, 1),(43, 1514, 4, 1, 1),(43, 1515, 4, 1, 1),(43, 1516, 4, 1, 1),(43, 1517, 4, 1, 1),(43, 1518, 4, 1, 1),(43, 1519, 4, 1, 1),(43, 1520, 4, 1, 1),(43, 1521, 4, 1, 1),(43, 1522, 4, 1, 1),(43, 1523, 4, 1, 1),(43, 1524, 4, 1, 1),(43, 1525, 4, 1, 1),(43, 1526, 4, 1, 1),(43, 1527, 4, 1, 1),(43, 1528, 4, 1, 1),(43, 1529, 4, 1, 1),(43, 1530, 4, 1, 1),(43, 1531, 4, 1, 1),(43, 1532, 4, 1, 1),(43, 1533, 4, 1, 1),(43, 1534, 4, 1, 1),(43, 1535, 4, 1, 1),(43, 1536, 4, 1, 1),(44, 1, 4, 1, 1),(44, 2, 4, 1, 1),(44, 3, 4, 1, 1),(44, 4, 4, 1, 1),(44, 5, 4, 1, 1),(44, 6, 4, 1, 1),(44, 7, 4, 1, 1),(44, 8, 4, 1, 1),(44, 9, 4, 1, 1),(44, 10, 4, 1, 1),(44, 11, 4, 1, 1),(44, 12, 4, 1, 1),(44, 13, 4, 1, 1),(44, 14, 4, 1, 1),(44, 15, 4, 1, 1),(44, 16, 4, 1, 1),(44, 17, 4, 1, 1),(44, 18, 4, 1, 1),(44, 19, 4, 1, 1),(44, 20, 4, 1, 1),(44, 21, 4, 1, 1),(44, 22, 4, 1, 1),(44, 23, 4, 1, 1),(44, 24, 4, 1, 1),(44, 25, 4, 1, 1),(44, 26, 4, 1, 1),(44, 27, 4, 1, 1),(44, 28, 4, 1, 1),(44, 29, 4, 1, 1),(44, 30, 4, 1, 1),(44, 31, 4, 1, 1),(44, 32, 4, 1, 1),(44, 33, 4, 1, 1),(44, 34, 4, 1, 1),(44, 35, 4, 1, 1),(44, 36, 4, 1, 1),(44, 37, 4, 1, 1),(44, 38, 4, 1, 1),(44, 39, 4, 1, 1),(44, 40, 4, 1, 1),(44, 41, 4, 1, 1),(44, 42, 4, 1, 1),(44, 43, 4, 1, 1),(44, 44, 4, 1, 1),(44, 45, 4, 1, 1),(44, 46, 4, 1, 1),(44, 47, 4, 1, 1),(44, 48, 4, 1, 1),(44, 49, 4, 1, 1),(44, 50, 4, 1, 1),(44, 51, 4, 1, 1),(44, 52, 4, 1, 1),(44, 53, 4, 1, 1),(44, 54, 4, 1, 1),(44, 55, 4, 1, 1),(44, 56, 4, 1, 1),(44, 57, 4, 1, 1),(44, 58, 4, 1, 1),(44, 59, 4, 1, 1),(44, 60, 4, 1, 1),(44, 61, 4, 1, 1),(44, 62, 4, 1, 1),(44, 63, 4, 1, 1),(44, 64, 4, 1, 1),(44, 65, 4, 1, 1),(44, 66, 4, 1, 1),(44, 67, 4, 1, 1),(44, 68, 4, 1, 1),(44, 69, 4, 1, 1),(44, 70, 4, 1, 1),(44, 71, 4, 1, 1),(44, 72, 4, 1, 1),(44, 73, 4, 1, 1),(44, 74, 4, 1, 1),(44, 75, 4, 1, 1),(44, 76, 4, 1, 1),(44, 77, 4, 1, 1),(44, 78, 4, 1, 1),(44, 79, 4, 1, 1),(44, 80, 4, 1, 1),(44, 81, 4, 1, 1),(44, 82, 4, 1, 1),(44, 83, 4, 1, 1),(44, 84, 4, 1, 1),(44, 85, 4, 1, 1),(44, 86, 4, 1, 1),(44, 87, 4, 1, 1),(44, 88, 4, 1, 1),(44, 89, 4, 1, 1),(44, 90, 4, 1, 1),(44, 91, 4, 1, 1),(44, 92, 4, 1, 1),(44, 93, 4, 1, 1),(44, 94, 4, 1, 1),(44, 95, 4, 1, 1),(44, 96, 4, 1, 1),(44, 97, 4, 1, 1),(44, 98, 4, 1, 1),(44, 99, 4, 1, 1),(44, 100, 4, 1, 1),(44, 101, 4, 1, 1),(44, 102, 4, 1, 1),(44, 103, 4, 1, 1),(44, 104, 4, 1, 1),(44, 105, 4, 1, 1),(44, 106, 4, 1, 1),(44, 107, 4, 1, 1),(44, 108, 4, 1, 1),(44, 109, 4, 1, 1),(44, 110, 4, 1, 1),(44, 111, 4, 1, 1),(44, 112, 4, 1, 1),(44, 113, 4, 1, 1),(44, 114, 4, 1, 1),(44, 115, 4, 1, 1),(44, 116, 4, 1, 1),(44, 117, 4, 1, 1),(44, 118, 4, 1, 1),(44, 119, 4, 1, 1),(44, 120, 4, 1, 1),(44, 121, 4, 1, 1),(44, 122, 4, 1, 1),(44, 123, 4, 1, 1),(44, 124, 4, 1, 1),(44, 125, 4, 1, 1),(44, 126, 4, 1, 1),(44, 127, 4, 1, 1),(44, 128, 4, 1, 1),(44, 129, 4, 1, 1),(44, 130, 4, 1, 1),(44, 131, 4, 1, 1),(44, 132, 4, 1, 1),(44, 133, 4, 1, 1),(44, 134, 4, 1, 1),(44, 135, 4, 1, 1),(44, 136, 4, 1, 1),(44, 137, 4, 1, 1),(44, 138, 4, 1, 1),(44, 139, 4, 1, 1),(44, 140, 4, 1, 1),(44, 141, 4, 1, 1),(44, 142, 4, 1, 1),(44, 143, 4, 1, 1),(44, 144, 4, 1, 1),(44, 145, 4, 1, 1),(44, 146, 4, 1, 1),(44, 147, 4, 1, 1),(44, 148, 4, 1, 1),(44, 149, 4, 1, 1),(44, 150, 4, 1, 1),(44, 151, 4, 1, 1),(44, 152, 4, 1, 1),(44, 153, 4, 1, 1),(44, 154, 4, 1, 1),(44, 155, 4, 1, 1),(44, 156, 4, 1, 1),(44, 157, 4, 1, 1),(44, 158, 4, 1, 1),(44, 159, 4, 1, 1),(44, 160, 4, 1, 1),(44, 161, 4, 1, 1),(44, 162, 4, 1, 1),(44, 163, 4, 1, 1),(44, 164, 4, 1, 1),(44, 165, 4, 1, 1),(44, 166, 4, 1, 1),(44, 167, 4, 1, 1),(44, 168, 4, 1, 1),(44, 169, 4, 1, 1),(44, 170, 4, 1, 1),(44, 171, 4, 1, 1),(44, 172, 4, 1, 1),(44, 173, 4, 1, 1),(44, 174, 4, 1, 1),(44, 175, 4, 1, 1),(44, 176, 4, 1, 1),(44, 177, 4, 1, 1),(44, 178, 4, 1, 1),(44, 179, 4, 1, 1),(44, 180, 4, 1, 1),(44, 181, 4, 1, 1),(44, 182, 4, 1, 1),(44, 183, 4, 1, 1),(44, 184, 4, 1, 1),(44, 185, 4, 1, 1),(44, 186, 4, 1, 1),(44, 187, 4, 1, 1),(44, 188, 4, 1, 1),(44, 189, 4, 1, 1),(44, 190, 4, 1, 1),(44, 191, 4, 1, 1),(44, 192, 4, 1, 1),(44, 193, 4, 1, 1),(44, 194, 4, 1, 1),(44, 195, 4, 1, 1),(44, 196, 4, 1, 1),(44, 197, 4, 1, 1),(44, 198, 4, 1, 1),(44, 199, 4, 1, 1),(44, 200, 4, 1, 1),(44, 201, 4, 1, 1),(44, 202, 4, 1, 1),(44, 203, 4, 1, 1),(44, 204, 4, 1, 1),(44, 205, 4, 1, 1),(44, 206, 4, 1, 1),(44, 207, 4, 1, 1),(44, 208, 4, 1, 1),(44, 209, 4, 1, 1),(44, 210, 4, 1, 1),(44, 211, 4, 1, 1),(44, 212, 4, 1, 1),(44, 213, 4, 1, 1),(44, 214, 4, 1, 1),(44, 215, 4, 1, 1),(44, 216, 4, 1, 1),(44, 217, 4, 1, 1),(44, 218, 4, 1, 1),(44, 219, 4, 1, 1),(44, 220, 4, 1, 1),(44, 221, 4, 1, 1),(44, 222, 4, 1, 1),(44, 223, 4, 1, 1),(44, 224, 4, 1, 1),(44, 225, 4, 1, 1),(44, 226, 4, 1, 1),(44, 227, 4, 1, 1),(44, 228, 4, 1, 1),(44, 229, 4, 1, 1),(44, 230, 4, 1, 1),(44, 231, 4, 1, 1),(44, 232, 4, 1, 1),(44, 233, 4, 1, 1),(44, 234, 4, 1, 1),(44, 235, 4, 1, 1),(44, 236, 4, 1, 1),(44, 237, 4, 1, 1),(44, 238, 4, 1, 1),(44, 239, 4, 1, 1),(44, 240, 4, 1, 1),(44, 241, 4, 1, 1),(44, 242, 4, 1, 1),(44, 243, 4, 1, 1),(44, 244, 4, 1, 1),(44, 245, 4, 1, 1),(44, 246, 4, 1, 1),(44, 247, 4, 1, 1),(44, 248, 4, 1, 1),(44, 249, 4, 1, 1),(44, 250, 4, 1, 1),(44, 251, 4, 1, 1),(44, 252, 4, 1, 1),(44, 253, 4, 1, 1),(44, 254, 4, 1, 1),(44, 255, 4, 1, 1),(44, 256, 4, 1, 1),(44, 257, 4, 1, 1),(44, 258, 4, 1, 1),(44, 259, 4, 1, 1),(44, 260, 4, 1, 1),(44, 261, 4, 1, 1),(44, 262, 4, 1, 1),(44, 263, 4, 1, 1),(44, 264, 4, 1, 1),(44, 265, 4, 1, 1),(44, 266, 4, 1, 1),(44, 267, 4, 1, 1),(44, 268, 4, 1, 1),(44, 269, 4, 1, 1),(44, 270, 4, 1, 1),(44, 271, 4, 1, 1),(44, 272, 4, 1, 1),(44, 273, 4, 1, 1),(44, 274, 4, 1, 1),(44, 275, 4, 1, 1),(44, 276, 4, 1, 1),(44, 277, 4, 1, 1),(44, 278, 4, 1, 1),(44, 279, 4, 1, 1),(44, 280, 4, 1, 1),(44, 281, 4, 1, 1),(44, 282, 4, 1, 1),(44, 283, 4, 1, 1),(44, 284, 4, 1, 1),(44, 285, 4, 1, 1),(44, 286, 4, 1, 1),(44, 287, 4, 1, 1),(44, 288, 4, 1, 1),(44, 289, 4, 1, 1),(44, 290, 4, 1, 1),(44, 291, 4, 1, 1),(44, 292, 4, 1, 1),(44, 293, 4, 1, 1),(44, 294, 4, 1, 1),(44, 295, 4, 1, 1),(44, 296, 4, 1, 1),(44, 297, 4, 1, 1),(44, 298, 4, 1, 1),(44, 299, 4, 1, 1),(44, 300, 4, 1, 1),(44, 301, 4, 1, 1),(44, 302, 4, 1, 1),(44, 303, 4, 1, 1),(44, 304, 4, 1, 1),(44, 305, 4, 1, 1),(44, 306, 4, 1, 1),(44, 307, 4, 1, 1),(44, 308, 4, 1, 1),(44, 309, 4, 1, 1),(44, 310, 4, 1, 1),(44, 311, 4, 1, 1),(44, 312, 4, 1, 1),(44, 313, 4, 1, 1),(44, 314, 4, 1, 1),(44, 315, 4, 1, 1),(44, 316, 4, 1, 1),(44, 317, 4, 1, 1),(44, 318, 4, 1, 1),(44, 319, 4, 1, 1),(44, 320, 4, 1, 1),(44, 321, 4, 1, 1),(44, 322, 4, 1, 1),(44, 323, 4, 1, 1),(44, 324, 4, 1, 1),(44, 325, 4, 1, 1),(44, 326, 4, 1, 1),(44, 327, 4, 1, 1),(44, 328, 4, 1, 1),(44, 329, 4, 1, 1),(44, 330, 4, 1, 1),(44, 331, 4, 1, 1),(44, 332, 4, 1, 1),(44, 333, 4, 1, 1),(44, 334, 4, 1, 1),(44, 335, 4, 1, 1),(44, 336, 4, 1, 1),(44, 337, 4, 1, 1),(44, 338, 4, 1, 1),(44, 339, 4, 1, 1),(44, 340, 4, 1, 1),(44, 341, 4, 1, 1),(44, 342, 4, 1, 1),(44, 343, 4, 1, 1),(44, 344, 4, 1, 1),(44, 345, 4, 1, 1),(44, 346, 4, 1, 1),(44, 347, 4, 1, 1),(44, 348, 4, 1, 1),(44, 349, 4, 1, 1),(44, 350, 4, 1, 1),(44, 351, 4, 1, 1),(44, 352, 4, 1, 1),(44, 353, 4, 1, 1),(44, 354, 4, 1, 1),(44, 355, 4, 1, 1),(44, 356, 4, 1, 1),(44, 357, 4, 1, 1),(44, 358, 4, 1, 1),(44, 359, 4, 1, 1),(44, 360, 4, 1, 1),(44, 361, 4, 1, 1),(44, 362, 4, 1, 1),(44, 363, 4, 1, 1),(44, 364, 4, 1, 1),(44, 365, 4, 1, 1),(44, 366, 4, 1, 1),(44, 367, 4, 1, 1),(44, 368, 4, 1, 1),(44, 369, 4, 1, 1),(44, 370, 4, 1, 1),(44, 371, 4, 1, 1),(44, 372, 4, 1, 1),(44, 373, 4, 1, 1),(44, 374, 4, 1, 1),(44, 375, 4, 1, 1),(44, 376, 4, 1, 1),(44, 377, 4, 1, 1),(44, 378, 4, 1, 1),(44, 379, 4, 1, 1),(44, 380, 4, 1, 1),(44, 381, 4, 1, 1),(44, 382, 4, 1, 1),(44, 383, 4, 1, 1),(44, 384, 4, 1, 1),(44, 385, 4, 1, 1),(44, 386, 4, 1, 1),(44, 387, 4, 1, 1),(44, 388, 4, 1, 1),(44, 389, 4, 1, 1),(44, 390, 4, 1, 1),(44, 391, 4, 1, 1),(44, 392, 4, 1, 1),(44, 393, 4, 1, 1),(44, 394, 4, 1, 1),(44, 395, 4, 1, 1),(44, 396, 4, 1, 1),(44, 397, 4, 1, 1),(44, 398, 4, 1, 1),(44, 399, 4, 1, 1),(44, 400, 4, 1, 1),(44, 401, 4, 1, 1),(44, 402, 4, 1, 1),(44, 403, 4, 1, 1),(44, 404, 4, 1, 1),(44, 405, 4, 1, 1),(44, 406, 4, 1, 1),(44, 407, 4, 1, 1),(44, 408, 4, 1, 1),(44, 409, 4, 1, 1),(44, 410, 4, 1, 1),(44, 411, 4, 1, 1),(44, 412, 4, 1, 1),(44, 413, 4, 1, 1),(44, 414, 4, 1, 1),(44, 415, 4, 1, 1),(44, 416, 4, 1, 1),(44, 417, 4, 1, 1),(44, 418, 4, 1, 1),(44, 419, 4, 1, 1),(44, 420, 4, 1, 1),(44, 421, 4, 1, 1),(44, 422, 4, 1, 1),(44, 423, 4, 1, 1),(44, 424, 4, 1, 1),(44, 425, 4, 1, 1),(44, 426, 4, 1, 1),(44, 427, 4, 1, 1),(44, 428, 4, 1, 1),(44, 429, 4, 1, 1),(44, 430, 4, 1, 1),(44, 431, 4, 1, 1),(44, 432, 4, 1, 1),(44, 433, 4, 1, 1),(44, 434, 4, 1, 1),(44, 435, 4, 1, 1),(44, 436, 4, 1, 1),(44, 437, 4, 1, 1),(44, 438, 4, 1, 1),(44, 439, 4, 1, 1),(44, 440, 4, 1, 1),(44, 441, 4, 1, 1),(44, 442, 4, 1, 1),(44, 443, 4, 1, 1),(44, 444, 4, 1, 1),(44, 445, 4, 1, 1),(44, 446, 4, 1, 1),(44, 447, 4, 1, 1),(44, 448, 4, 1, 1),(44, 449, 4, 1, 1),(44, 450, 4, 1, 1),(44, 451, 4, 1, 1),(44, 452, 4, 1, 1),(44, 453, 4, 1, 1),(44, 454, 4, 1, 1),(44, 455, 4, 1, 1),(44, 456, 4, 1, 1),(44, 457, 4, 1, 1),(44, 458, 4, 1, 1),(44, 459, 4, 1, 1),(44, 460, 4, 1, 1),(44, 461, 4, 1, 1),(44, 462, 4, 1, 1),(44, 463, 4, 1, 1),(44, 464, 4, 1, 1),(44, 465, 4, 1, 1),(44, 466, 4, 1, 1),(44, 467, 4, 1, 1),(44, 468, 4, 1, 1),(44, 469, 4, 1, 1),(44, 470, 4, 1, 1),(44, 471, 4, 1, 1),(44, 472, 4, 1, 1),(44, 473, 4, 1, 1),(44, 474, 4, 1, 1),(44, 475, 4, 1, 1),(44, 476, 4, 1, 1),(44, 477, 4, 1, 1),(44, 478, 4, 1, 1),(44, 479, 4, 1, 1),(44, 480, 4, 1, 1),(44, 481, 4, 1, 1),(44, 482, 4, 1, 1),(44, 483, 4, 1, 1),(44, 484, 4, 1, 1),(44, 485, 4, 1, 1),(44, 486, 4, 1, 1),(44, 487, 4, 1, 1),(44, 488, 4, 1, 1),(44, 489, 4, 1, 1),(44, 490, 4, 1, 1),(44, 491, 4, 1, 1),(44, 492, 4, 1, 1),(44, 493, 4, 1, 1),(44, 494, 4, 1, 1),(44, 495, 4, 1, 1),(44, 496, 4, 1, 1),(44, 497, 4, 1, 1),(44, 498, 4, 1, 1),(44, 499, 4, 1, 1),(44, 500, 4, 1, 1),(44, 501, 4, 1, 1),(44, 502, 4, 1, 1),(44, 503, 4, 1, 1),(44, 504, 4, 1, 1),(44, 505, 4, 1, 1),(44, 506, 4, 1, 1),(44, 507, 4, 1, 1),(44, 508, 4, 1, 1),(44, 509, 4, 1, 1),(44, 510, 4, 1, 1),(44, 511, 4, 1, 1),(44, 512, 4, 1, 1),(44, 513, 4, 1, 1),(44, 514, 4, 1, 1),(44, 515, 4, 1, 1),(44, 516, 4, 1, 1),(44, 517, 4, 1, 1),(44, 518, 4, 1, 1),(44, 519, 4, 1, 1),(44, 520, 4, 1, 1),(44, 521, 4, 1, 1),(44, 522, 4, 1, 1),(44, 523, 4, 1, 1),(44, 524, 4, 1, 1),(44, 525, 4, 1, 1),(44, 526, 4, 1, 1),(44, 527, 4, 1, 1),(44, 528, 4, 1, 1),(44, 529, 4, 1, 1),(44, 530, 4, 1, 1),(44, 531, 4, 1, 1),(44, 532, 4, 1, 1),(44, 533, 4, 1, 1),(44, 534, 4, 1, 1),(44, 535, 4, 1, 1),(44, 536, 4, 1, 1),(44, 537, 4, 1, 1),(44, 538, 4, 1, 1),(44, 539, 4, 1, 1),(44, 540, 4, 1, 1),(44, 541, 4, 1, 1),(44, 542, 4, 1, 1),(44, 543, 4, 1, 1),(44, 544, 4, 1, 1),(44, 545, 4, 1, 1),(44, 546, 4, 1, 1),(44, 547, 4, 1, 1),(44, 548, 4, 1, 1),(44, 549, 4, 1, 1),(44, 550, 4, 1, 1),(44, 551, 4, 1, 1),(44, 552, 4, 1, 1),(44, 553, 4, 1, 1),(44, 554, 4, 1, 1),(44, 555, 4, 1, 1),(44, 556, 4, 1, 1),(44, 557, 4, 1, 1),(44, 558, 4, 1, 1),(44, 559, 4, 1, 1),(44, 560, 4, 1, 1),(44, 561, 4, 1, 1),(44, 562, 4, 1, 1),(44, 563, 4, 1, 1),(44, 564, 4, 1, 1),(44, 565, 4, 1, 1),(44, 566, 4, 1, 1),(44, 567, 4, 1, 1),(44, 568, 4, 1, 1),(44, 569, 4, 1, 1),(44, 570, 4, 1, 1),(44, 571, 4, 1, 1),(44, 572, 4, 1, 1),(44, 573, 4, 1, 1),(44, 574, 4, 1, 1),(44, 575, 4, 1, 1),(44, 576, 4, 1, 1),(44, 577, 4, 1, 1),(44, 578, 4, 1, 1),(44, 579, 4, 1, 1),(44, 580, 4, 1, 1),(44, 581, 4, 1, 1),(44, 582, 4, 1, 1),(44, 583, 4, 1, 1),(44, 584, 4, 1, 1),(44, 585, 4, 1, 1),(44, 586, 4, 1, 1),(44, 587, 4, 1, 1),(44, 588, 4, 1, 1),(44, 589, 4, 1, 1),(44, 590, 4, 1, 1),(44, 591, 4, 1, 1),(44, 592, 4, 1, 1),(44, 593, 4, 1, 1),(44, 594, 4, 1, 1),(44, 595, 4, 1, 1),(44, 596, 4, 1, 1),(44, 597, 4, 1, 1),(44, 598, 4, 1, 1),(44, 599, 4, 1, 1),(44, 600, 4, 1, 1),(44, 601, 4, 1, 1),(44, 602, 4, 1, 1),(44, 603, 4, 1, 1),(44, 604, 4, 1, 1),(44, 605, 4, 1, 1),(44, 606, 4, 1, 1),(44, 607, 4, 1, 1),(44, 608, 4, 1, 1),(44, 609, 4, 1, 1),(44, 610, 4, 1, 1),(44, 611, 4, 1, 1),(44, 612, 4, 1, 1),(44, 613, 4, 1, 1),(44, 614, 4, 1, 1),(44, 615, 4, 1, 1),(44, 616, 4, 1, 1),(44, 617, 4, 1, 1),(44, 618, 4, 1, 1),(44, 619, 4, 1, 1),(44, 620, 4, 1, 1),(44, 621, 4, 1, 1),(44, 622, 4, 1, 1),(44, 623, 4, 1, 1),(44, 624, 4, 1, 1),(44, 625, 4, 1, 1),(44, 626, 4, 1, 1),(44, 627, 4, 1, 1),(44, 628, 4, 1, 1),(44, 629, 4, 1, 1),(44, 630, 4, 1, 1),(44, 631, 4, 1, 1),(44, 632, 4, 1, 1),(44, 633, 4, 1, 1),(44, 634, 4, 1, 1),(44, 635, 4, 1, 1),(44, 636, 4, 1, 1),(44, 637, 4, 1, 1),(44, 638, 4, 1, 1),(44, 639, 4, 1, 1),(44, 640, 4, 1, 1),(44, 641, 4, 1, 1),(44, 642, 4, 1, 1),(44, 643, 4, 1, 1),(44, 644, 4, 1, 1),(44, 645, 4, 1, 1),(44, 646, 4, 1, 1),(44, 647, 4, 1, 1),(44, 648, 4, 1, 1),(44, 649, 4, 1, 1),(44, 650, 4, 1, 1),(44, 651, 4, 1, 1),(44, 652, 4, 1, 1),(44, 653, 4, 1, 1),(44, 654, 4, 1, 1),(44, 655, 4, 1, 1),(44, 656, 4, 1, 1),(44, 657, 4, 1, 1),(44, 658, 4, 1, 1),(44, 659, 4, 1, 1),(44, 660, 4, 1, 1),(44, 661, 4, 1, 1),(44, 662, 4, 1, 1),(44, 663, 4, 1, 1),(44, 664, 4, 1, 1),(44, 665, 4, 1, 1),(44, 666, 4, 1, 1),(44, 667, 4, 1, 1),(44, 668, 4, 1, 1),(44, 669, 4, 1, 1),(44, 670, 4, 1, 1),(44, 671, 4, 1, 1),(44, 672, 4, 1, 1),(44, 673, 4, 1, 1),(44, 674, 4, 1, 1),(44, 675, 4, 1, 1),(44, 676, 4, 1, 1),(44, 677, 4, 1, 1),(44, 678, 4, 1, 1),(44, 679, 4, 1, 1),(44, 680, 4, 1, 1),(44, 681, 4, 1, 1),(44, 682, 4, 1, 1),(44, 683, 4, 1, 1),(44, 684, 4, 1, 1),(44, 685, 4, 1, 1),(44, 686, 4, 1, 1),(44, 687, 4, 1, 1),(44, 688, 4, 1, 1),(44, 689, 4, 1, 1),(44, 690, 4, 1, 1),(44, 691, 4, 1, 1),(44, 692, 4, 1, 1),(44, 693, 4, 1, 1),(44, 694, 4, 1, 1),(44, 695, 4, 1, 1),(44, 696, 4, 1, 1),(44, 697, 4, 1, 1),(44, 698, 4, 1, 1),(44, 699, 4, 1, 1),(44, 700, 4, 1, 1),(44, 701, 4, 1, 1),(44, 702, 4, 1, 1),(44, 703, 4, 1, 1),(44, 704, 4, 1, 1),(44, 705, 4, 1, 1),(44, 706, 4, 1, 1),(44, 707, 4, 1, 1),(44, 708, 4, 1, 1),(44, 709, 4, 1, 1),(44, 710, 4, 1, 1),(44, 711, 4, 1, 1),(44, 712, 4, 1, 1),(44, 713, 4, 1, 1),(44, 714, 4, 1, 1),(44, 715, 4, 1, 1),(44, 716, 4, 1, 1),(44, 717, 4, 1, 1),(44, 718, 4, 1, 1),(44, 719, 4, 1, 1),(44, 720, 4, 1, 1),(44, 721, 4, 1, 1),(44, 722, 4, 1, 1),(44, 723, 4, 1, 1),(44, 724, 4, 1, 1),(44, 725, 4, 1, 1),(44, 726, 4, 1, 1),(44, 727, 4, 1, 1),(44, 728, 4, 1, 1),(44, 729, 4, 1, 1),(44, 730, 4, 1, 1),(44, 731, 4, 1, 1),(44, 732, 4, 1, 1),(44, 733, 4, 1, 1),(44, 734, 4, 1, 1),(44, 735, 4, 1, 1),(44, 736, 4, 1, 1),(44, 737, 4, 1, 1),(44, 738, 4, 1, 1),(44, 739, 4, 1, 1),(44, 740, 4, 1, 1),(44, 741, 4, 1, 1),(44, 742, 4, 1, 1),(44, 743, 4, 1, 1),(44, 744, 4, 1, 1),(44, 745, 4, 1, 1),(44, 746, 4, 1, 1),(44, 747, 4, 1, 1),(44, 748, 4, 1, 1),(44, 749, 4, 1, 1),(44, 750, 4, 1, 1),(44, 751, 4, 1, 1),(44, 752, 4, 1, 1),(44, 753, 4, 1, 1),(44, 754, 4, 1, 1),(44, 755, 4, 1, 1),(44, 756, 4, 1, 1),(44, 757, 4, 1, 1),(44, 758, 4, 1, 1),(44, 759, 4, 1, 1),(44, 760, 4, 1, 1),(44, 761, 4, 1, 1),(44, 762, 4, 1, 1),(44, 763, 4, 1, 1),(44, 764, 4, 1, 1),(44, 765, 4, 1, 1),(44, 766, 4, 1, 1),(44, 767, 4, 1, 1),(44, 768, 4, 1, 1),(44, 769, 4, 1, 1),(44, 770, 4, 1, 1),(44, 771, 4, 1, 1),(44, 772, 4, 1, 1),(44, 773, 4, 1, 1),(44, 774, 4, 1, 1),(44, 775, 4, 1, 1),(44, 776, 4, 1, 1),(44, 777, 4, 1, 1),(44, 778, 4, 1, 1),(44, 779, 4, 1, 1),(44, 780, 4, 1, 1),(44, 781, 4, 1, 1),(44, 782, 4, 1, 1),(44, 783, 4, 1, 1),(44, 784, 4, 1, 1),(44, 785, 4, 1, 1),(44, 786, 4, 1, 1),(44, 787, 4, 1, 1),(44, 788, 4, 1, 1),(44, 789, 4, 1, 1),(44, 790, 4, 1, 1),(44, 791, 4, 1, 1),(44, 792, 4, 1, 1),(44, 793, 4, 1, 1),(44, 794, 4, 1, 1),(44, 795, 4, 1, 1),(44, 796, 4, 1, 1),(44, 797, 4, 1, 1),(44, 798, 4, 1, 1),(44, 799, 4, 1, 1),(44, 800, 4, 1, 1),(44, 801, 4, 1, 1),(44, 802, 4, 1, 1),(44, 803, 4, 1, 1),(44, 804, 4, 1, 1),(44, 805, 4, 1, 1),(44, 806, 4, 1, 1),(44, 807, 4, 1, 1),(44, 808, 4, 1, 1),(44, 809, 4, 1, 1),(44, 810, 4, 1, 1),(44, 811, 4, 1, 1),(44, 812, 4, 1, 1),(44, 813, 4, 1, 1),(44, 814, 4, 1, 1),(44, 815, 4, 1, 1),(44, 816, 4, 1, 1),(44, 817, 4, 1, 1),(44, 818, 4, 1, 1),(44, 819, 4, 1, 1),(44, 820, 4, 1, 1),(44, 821, 4, 1, 1),(44, 822, 4, 1, 1),(44, 823, 4, 1, 1),(44, 824, 4, 1, 1),(44, 825, 4, 1, 1),(44, 826, 4, 1, 1),(44, 827, 4, 1, 1),(44, 828, 4, 1, 1),(44, 829, 4, 1, 1),(44, 830, 4, 1, 1),(44, 831, 4, 1, 1),(44, 832, 4, 1, 1),(44, 833, 4, 1, 1),(44, 834, 4, 1, 1),(44, 835, 4, 1, 1),(44, 836, 4, 1, 1),(44, 837, 4, 1, 1),(44, 838, 4, 1, 1),(44, 839, 4, 1, 1),(44, 840, 4, 1, 1),(44, 841, 4, 1, 1),(44, 842, 4, 1, 1),(44, 843, 4, 1, 1),(44, 844, 4, 1, 1),(44, 845, 4, 1, 1),(44, 846, 4, 1, 1),(44, 847, 4, 1, 1),(44, 848, 4, 1, 1),(44, 849, 4, 1, 1),(44, 850, 4, 1, 1),(44, 851, 4, 1, 1),(44, 852, 4, 1, 1),(44, 853, 4, 1, 1),(44, 854, 4, 1, 1),(44, 855, 4, 1, 1),(44, 856, 4, 1, 1),(44, 857, 4, 1, 1),(44, 858, 4, 1, 1),(44, 859, 4, 1, 1),(44, 860, 4, 1, 1),(44, 861, 4, 1, 1),(44, 862, 4, 1, 1),(44, 863, 4, 1, 1),(44, 864, 4, 1, 1),(44, 865, 4, 1, 1),(44, 866, 4, 1, 1),(44, 867, 4, 1, 1),(44, 868, 4, 1, 1),(44, 869, 4, 1, 1),(44, 870, 4, 1, 1),(44, 871, 4, 1, 1),(44, 872, 4, 1, 1),(44, 873, 4, 1, 1),(44, 874, 4, 1, 1),(44, 875, 4, 1, 1),(44, 876, 4, 1, 1),(44, 877, 4, 1, 1),(44, 878, 4, 1, 1),(44, 879, 4, 1, 1),(44, 880, 4, 1, 1),(44, 881, 4, 1, 1),(44, 882, 4, 1, 1),(44, 883, 4, 1, 1),(44, 884, 4, 1, 1),(44, 885, 4, 1, 1),(44, 886, 4, 1, 1),(44, 887, 4, 1, 1),(44, 888, 4, 1, 1),(44, 889, 4, 1, 1),(44, 890, 4, 1, 1),(44, 891, 4, 1, 1),(44, 892, 4, 1, 1),(44, 893, 4, 1, 1),(44, 894, 4, 1, 1),(44, 895, 4, 1, 1),(44, 896, 4, 1, 1),(44, 897, 4, 1, 1),(44, 898, 4, 1, 1),(44, 899, 4, 1, 1),(44, 900, 4, 1, 1),(44, 901, 4, 1, 1),(44, 902, 4, 1, 1),(44, 903, 4, 1, 1),(44, 904, 4, 1, 1),(44, 905, 4, 1, 1),(44, 906, 4, 1, 1),(44, 907, 4, 1, 1),(44, 908, 4, 1, 1),(44, 909, 4, 1, 1),(44, 910, 4, 1, 1),(44, 911, 4, 1, 1),(44, 912, 4, 1, 1),(44, 913, 4, 1, 1),(44, 914, 4, 1, 1),(44, 915, 4, 1, 1),(44, 916, 4, 1, 1),(44, 917, 4, 1, 1),(44, 918, 4, 1, 1),(44, 919, 4, 1, 1),(44, 920, 4, 1, 1),(44, 921, 4, 1, 1),(44, 922, 4, 1, 1),(44, 923, 4, 1, 1),(44, 924, 4, 1, 1),(44, 925, 4, 1, 1),(44, 926, 4, 1, 1),(44, 927, 4, 1, 1),(44, 928, 4, 1, 1),(44, 929, 4, 1, 1),(44, 930, 4, 1, 1),(44, 931, 4, 1, 1),(44, 932, 4, 1, 1),(44, 933, 4, 1, 1),(44, 934, 4, 1, 1),(44, 935, 4, 1, 1),(44, 936, 4, 1, 1),(44, 937, 4, 1, 1),(44, 938, 4, 1, 1),(44, 939, 4, 1, 1),(44, 940, 4, 1, 1),(44, 941, 4, 1, 1),(44, 942, 4, 1, 1),(44, 943, 4, 1, 1),(44, 944, 4, 1, 1),(44, 945, 4, 1, 1),(44, 946, 4, 1, 1),(44, 947, 4, 1, 1),(44, 948, 4, 1, 1),(44, 949, 4, 1, 1),(44, 950, 4, 1, 1),(44, 951, 4, 1, 1),(44, 952, 4, 1, 1),(44, 953, 4, 1, 1),(44, 954, 4, 1, 1),(44, 955, 4, 1, 1),(44, 956, 4, 1, 1),(44, 957, 4, 1, 1),(44, 958, 4, 1, 1),(44, 959, 4, 1, 1),(44, 960, 4, 1, 1),(44, 961, 4, 1, 1),(44, 962, 4, 1, 1),(44, 963, 4, 1, 1),(44, 964, 4, 1, 1),(44, 965, 4, 1, 1),(44, 966, 4, 1, 1),(44, 967, 4, 1, 1),(44, 968, 4, 1, 1),(44, 969, 4, 1, 1),(44, 970, 4, 1, 1),(44, 971, 4, 1, 1),(44, 972, 4, 1, 1),(44, 973, 4, 1, 1),(44, 974, 4, 1, 1),(44, 975, 4, 1, 1),(44, 976, 4, 1, 1),(44, 977, 4, 1, 1),(44, 978, 4, 1, 1),(44, 979, 4, 1, 1),(44, 980, 4, 1, 1),(44, 981, 4, 1, 1),(44, 982, 4, 1, 1),(44, 983, 4, 1, 1),(44, 984, 4, 1, 1),(44, 985, 4, 1, 1),(44, 986, 4, 1, 1),(44, 987, 4, 1, 1),(44, 988, 4, 1, 1),(44, 989, 4, 1, 1),(44, 990, 4, 1, 1),(44, 991, 4, 1, 1),(44, 992, 4, 1, 1),(44, 993, 4, 1, 1),(44, 994, 4, 1, 1),(44, 995, 4, 1, 1),(44, 996, 4, 1, 1),(44, 997, 4, 1, 1),(44, 998, 4, 1, 1),(44, 999, 4, 1, 1),(44, 1000, 4, 1, 1),(44, 1001, 4, 1, 1),(44, 1002, 4, 1, 1),(44, 1003, 4, 1, 1),(44, 1004, 4, 1, 1),(44, 1005, 4, 1, 1),(44, 1006, 4, 1, 1),(44, 1007, 4, 1, 1),(44, 1008, 4, 1, 1),(44, 1009, 4, 1, 1),(44, 1010, 4, 1, 1),(44, 1011, 4, 1, 1),(44, 1012, 4, 1, 1),(44, 1013, 4, 1, 1),(44, 1014, 4, 1, 1),(44, 1015, 4, 1, 1),(44, 1016, 4, 1, 1),(44, 1017, 4, 1, 1),(44, 1018, 4, 1, 1),(44, 1019, 4, 1, 1),(44, 1020, 4, 1, 1),(44, 1021, 4, 1, 1),(44, 1022, 4, 1, 1),(44, 1023, 4, 1, 1),(44, 1024, 4, 1, 1),(44, 1025, 4, 1, 1),(44, 1026, 4, 1, 1),(44, 1027, 4, 1, 1),(44, 1028, 4, 1, 1),(44, 1029, 4, 1, 1),(44, 1030, 4, 1, 1),(44, 1031, 4, 1, 1),(44, 1032, 4, 1, 1),(44, 1033, 4, 1, 1),(44, 1034, 4, 1, 1),(44, 1035, 4, 1, 1),(44, 1036, 4, 1, 1),(44, 1037, 4, 1, 1),(44, 1038, 4, 1, 1),(44, 1039, 4, 1, 1),(44, 1040, 4, 1, 1),(44, 1041, 4, 1, 1),(44, 1042, 4, 1, 1),(44, 1043, 4, 1, 1),(44, 1044, 4, 1, 1),(44, 1045, 4, 1, 1),(44, 1046, 4, 1, 1),(44, 1047, 4, 1, 1),(44, 1048, 4, 1, 1),(44, 1049, 4, 1, 1),(44, 1050, 4, 1, 1),(44, 1051, 4, 1, 1),(44, 1052, 4, 1, 1),(44, 1053, 4, 1, 1),(44, 1054, 4, 1, 1),(44, 1055, 4, 1, 1),(44, 1056, 4, 1, 1),(44, 1057, 4, 1, 1),(44, 1058, 4, 1, 1),(44, 1059, 4, 1, 1),(44, 1060, 4, 1, 1),(44, 1061, 4, 1, 1),(44, 1062, 4, 1, 1),(44, 1063, 4, 1, 1),(44, 1064, 4, 1, 1),(44, 1065, 4, 1, 1),(44, 1066, 4, 1, 1),(44, 1067, 4, 1, 1),(44, 1068, 4, 1, 1),(44, 1069, 4, 1, 1),(44, 1070, 4, 1, 1),(44, 1071, 4, 1, 1),(44, 1072, 4, 1, 1),(44, 1073, 4, 1, 1),(44, 1074, 4, 1, 1),(44, 1075, 4, 1, 1),(44, 1076, 4, 1, 1),(44, 1077, 4, 1, 1),(44, 1078, 4, 1, 1),(44, 1079, 4, 1, 1),(44, 1080, 4, 1, 1),(44, 1081, 4, 1, 1),(44, 1082, 4, 1, 1),(44, 1083, 4, 1, 1),(44, 1084, 4, 1, 1),(44, 1085, 4, 1, 1),(44, 1086, 4, 1, 1),(44, 1087, 4, 1, 1),(44, 1088, 4, 1, 1),(44, 1089, 4, 1, 1),(44, 1090, 4, 1, 1),(44, 1091, 4, 1, 1),(44, 1092, 4, 1, 1),(44, 1093, 4, 1, 1),(44, 1094, 4, 1, 1),(44, 1095, 4, 1, 1),(44, 1096, 4, 1, 1),(44, 1097, 4, 1, 1),(44, 1098, 4, 1, 1),(44, 1099, 4, 1, 1),(44, 1100, 4, 1, 1),(44, 1101, 4, 1, 1),(44, 1102, 4, 1, 1),(44, 1103, 4, 1, 1),(44, 1104, 4, 1, 1),(44, 1105, 4, 1, 1),(44, 1106, 4, 1, 1),(44, 1107, 4, 1, 1),(44, 1108, 4, 1, 1),(44, 1109, 4, 1, 1),(44, 1110, 4, 1, 1),(44, 1111, 4, 1, 1),(44, 1112, 4, 1, 1),(44, 1113, 4, 1, 1),(44, 1114, 4, 1, 1),(44, 1115, 4, 1, 1),(44, 1116, 4, 1, 1),(44, 1117, 4, 1, 1),(44, 1118, 4, 1, 1),(44, 1119, 4, 1, 1),(44, 1120, 4, 1, 1),(44, 1121, 4, 1, 1),(44, 1122, 4, 1, 1),(44, 1123, 4, 1, 1),(44, 1124, 4, 1, 1),(44, 1125, 4, 1, 1),(44, 1126, 4, 1, 1),(44, 1127, 4, 1, 1),(44, 1128, 4, 1, 1),(44, 1129, 4, 1, 1),(44, 1130, 4, 1, 1),(44, 1131, 4, 1, 1),(44, 1132, 4, 1, 1),(44, 1133, 4, 1, 1),(44, 1134, 4, 1, 1),(44, 1135, 4, 1, 1),(44, 1136, 4, 1, 1),(44, 1137, 4, 1, 1),(44, 1138, 4, 1, 1),(44, 1139, 4, 1, 1),(44, 1140, 4, 1, 1),(44, 1141, 4, 1, 1),(44, 1142, 4, 1, 1),(44, 1143, 4, 1, 1),(44, 1144, 4, 1, 1),(44, 1145, 4, 1, 1),(44, 1146, 4, 1, 1),(44, 1147, 4, 1, 1),(44, 1148, 4, 1, 1),(44, 1149, 4, 1, 1),(44, 1150, 4, 1, 1),(44, 1151, 4, 1, 1),(44, 1152, 4, 1, 1),(44, 1153, 4, 1, 1),(44, 1154, 4, 1, 1),(44, 1155, 4, 1, 1),(44, 1156, 4, 1, 1),(44, 1157, 4, 1, 1),(44, 1158, 4, 1, 1),(44, 1159, 4, 1, 1),(44, 1160, 4, 1, 1),(44, 1161, 4, 1, 1),(44, 1162, 4, 1, 1),(44, 1163, 4, 1, 1),(44, 1164, 4, 1, 1),(44, 1165, 4, 1, 1),(44, 1166, 4, 1, 1),(44, 1167, 4, 1, 1),(44, 1168, 4, 1, 1),(44, 1169, 4, 1, 1),(44, 1170, 4, 1, 1),(44, 1171, 4, 1, 1),(44, 1172, 4, 1, 1),(44, 1173, 4, 1, 1),(44, 1174, 4, 1, 1),(44, 1175, 4, 1, 1),(44, 1176, 4, 1, 1),(44, 1177, 4, 1, 1),(44, 1178, 4, 1, 1),(44, 1179, 4, 1, 1),(44, 1180, 4, 1, 1),(44, 1181, 4, 1, 1),(44, 1182, 4, 1, 1),(44, 1183, 4, 1, 1),(44, 1184, 4, 1, 1),(44, 1185, 4, 1, 1),(44, 1186, 4, 1, 1),(44, 1187, 4, 1, 1),(44, 1188, 4, 1, 1),(44, 1189, 4, 1, 1),(44, 1190, 4, 1, 1),(44, 1191, 4, 1, 1),(44, 1192, 4, 1, 1),(44, 1193, 4, 1, 1),(44, 1194, 4, 1, 1),(44, 1195, 4, 1, 1),(44, 1196, 4, 1, 1),(44, 1197, 4, 1, 1),(44, 1198, 4, 1, 1),(44, 1199, 4, 1, 1),(44, 1200, 4, 1, 1),(44, 1201, 4, 1, 1),(44, 1202, 4, 1, 1),(44, 1203, 4, 1, 1),(44, 1204, 4, 1, 1),(44, 1205, 4, 1, 1),(44, 1206, 4, 1, 1),(44, 1207, 4, 1, 1),(44, 1208, 4, 1, 1),(44, 1209, 4, 1, 1),(44, 1210, 4, 1, 1),(44, 1211, 4, 1, 1),(44, 1212, 4, 1, 1),(44, 1213, 4, 1, 1),(44, 1214, 4, 1, 1),(44, 1215, 4, 1, 1),(44, 1216, 4, 1, 1),(44, 1217, 4, 1, 1),(44, 1218, 4, 1, 1),(44, 1219, 4, 1, 1),(44, 1220, 4, 1, 1),(44, 1221, 4, 1, 1),(44, 1222, 4, 1, 1),(44, 1223, 4, 1, 1),(44, 1224, 4, 1, 1),(44, 1225, 4, 1, 1),(44, 1226, 4, 1, 1),(44, 1227, 4, 1, 1),(44, 1228, 4, 1, 1),(44, 1229, 4, 1, 1),(44, 1230, 4, 1, 1),(44, 1231, 4, 1, 1),(44, 1232, 4, 1, 1),(44, 1233, 4, 1, 1),(44, 1234, 4, 1, 1),(44, 1235, 4, 1, 1),(44, 1236, 4, 1, 1),(44, 1237, 4, 1, 1),(44, 1238, 4, 1, 1),(44, 1239, 4, 1, 1),(44, 1240, 4, 1, 1),(44, 1241, 4, 1, 1),(44, 1242, 4, 1, 1),(44, 1243, 4, 1, 1),(44, 1244, 4, 1, 1),(44, 1245, 4, 1, 1),(44, 1246, 4, 1, 1),(44, 1247, 4, 1, 1),(44, 1248, 4, 1, 1),(44, 1249, 4, 1, 1),(44, 1250, 4, 1, 1),(44, 1251, 4, 1, 1),(44, 1252, 4, 1, 1),(44, 1253, 4, 1, 1),(44, 1254, 4, 1, 1),(44, 1255, 4, 1, 1),(44, 1256, 4, 1, 1),(44, 1257, 4, 1, 1),(44, 1258, 4, 1, 1),(44, 1259, 4, 1, 1),(44, 1260, 4, 1, 1),(44, 1261, 4, 1, 1),(44, 1262, 4, 1, 1),(44, 1263, 4, 1, 1),(44, 1264, 4, 1, 1),(44, 1265, 4, 1, 1),(44, 1266, 4, 1, 1),(44, 1267, 4, 1, 1),(44, 1268, 4, 1, 1),(44, 1269, 4, 1, 1),(44, 1270, 4, 1, 1),(44, 1271, 4, 1, 1),(44, 1272, 4, 1, 1),(44, 1273, 4, 1, 1),(44, 1274, 4, 1, 1),(44, 1275, 4, 1, 1),(44, 1276, 4, 1, 1),(44, 1277, 4, 1, 1),(44, 1278, 4, 1, 1),(44, 1279, 4, 1, 1),(44, 1280, 4, 1, 1),(44, 1281, 4, 1, 1),(44, 1282, 4, 1, 1),(44, 1283, 4, 1, 1),(44, 1284, 4, 1, 1),(44, 1285, 4, 1, 1),(44, 1286, 4, 1, 1),(44, 1287, 4, 1, 1),(44, 1288, 4, 1, 1),(44, 1289, 4, 1, 1),(44, 1290, 4, 1, 1),(44, 1291, 4, 1, 1),(44, 1292, 4, 1, 1),(44, 1293, 4, 1, 1),(44, 1294, 4, 1, 1),(44, 1295, 4, 1, 1),(44, 1296, 4, 1, 1),(44, 1297, 4, 1, 1),(44, 1298, 4, 1, 1),(44, 1299, 4, 1, 1),(44, 1300, 4, 1, 1),(44, 1301, 4, 1, 1),(44, 1302, 4, 1, 1),(44, 1303, 4, 1, 1),(44, 1304, 4, 1, 1),(44, 1305, 4, 1, 1),(44, 1306, 4, 1, 1),(44, 1307, 4, 1, 1),(44, 1308, 4, 1, 1),(44, 1309, 4, 1, 1),(44, 1310, 4, 1, 1),(44, 1311, 4, 1, 1),(44, 1312, 4, 1, 1),(44, 1313, 4, 1, 1),(44, 1314, 4, 1, 1),(44, 1315, 4, 1, 1),(44, 1316, 4, 1, 1),(44, 1317, 4, 1, 1),(44, 1318, 4, 1, 1),(44, 1319, 4, 1, 1),(44, 1320, 4, 1, 1),(44, 1321, 4, 1, 1),(44, 1322, 4, 1, 1),(44, 1323, 4, 1, 1),(44, 1324, 4, 1, 1),(44, 1325, 4, 1, 1),(44, 1326, 4, 1, 1),(44, 1327, 4, 1, 1),(44, 1328, 4, 1, 1),(44, 1329, 4, 1, 1),(44, 1330, 4, 1, 1),(44, 1331, 4, 1, 1),(44, 1332, 4, 1, 1),(44, 1333, 4, 1, 1),(44, 1334, 4, 1, 1),(44, 1335, 4, 1, 1),(44, 1336, 4, 1, 1),(44, 1337, 4, 1, 1),(44, 1338, 4, 1, 1),(44, 1339, 4, 1, 1),(44, 1340, 4, 1, 1),(44, 1341, 4, 1, 1),(44, 1342, 4, 1, 1),(44, 1343, 4, 1, 1),(44, 1344, 4, 1, 1),(44, 1345, 4, 1, 1),(44, 1346, 4, 1, 1),(44, 1347, 4, 1, 1),(44, 1348, 4, 1, 1),(44, 1349, 4, 1, 1),(44, 1350, 4, 1, 1),(44, 1351, 4, 1, 1),(44, 1352, 4, 1, 1),(44, 1353, 4, 1, 1),(44, 1354, 4, 1, 1),(44, 1355, 4, 1, 1),(44, 1356, 4, 1, 1),(44, 1357, 4, 1, 1),(44, 1358, 4, 1, 1),(44, 1359, 4, 1, 1),(44, 1360, 4, 1, 1),(44, 1361, 4, 1, 1),(44, 1362, 4, 1, 1),(44, 1363, 4, 1, 1),(44, 1364, 4, 1, 1),(44, 1365, 4, 1, 1),(44, 1366, 4, 1, 1),(44, 1367, 4, 1, 1),(44, 1368, 4, 1, 1),(44, 1369, 4, 1, 1),(44, 1370, 4, 1, 1),(44, 1371, 4, 1, 1),(44, 1372, 4, 1, 1),(44, 1373, 4, 1, 1),(44, 1374, 4, 1, 1),(44, 1375, 4, 1, 1),(44, 1376, 4, 1, 1),(44, 1377, 4, 1, 1),(44, 1378, 4, 1, 1),(44, 1379, 4, 1, 1),(44, 1380, 4, 1, 1),(44, 1381, 4, 1, 1),(44, 1382, 4, 1, 1),(44, 1383, 4, 1, 1),(44, 1384, 4, 1, 1),(44, 1385, 4, 1, 1),(44, 1386, 4, 1, 1),(44, 1387, 4, 1, 1),(44, 1388, 4, 1, 1),(44, 1389, 4, 1, 1),(44, 1390, 4, 1, 1),(44, 1391, 4, 1, 1),(44, 1392, 4, 1, 1),(44, 1393, 4, 1, 1),(44, 1394, 4, 1, 1),(44, 1395, 4, 1, 1),(44, 1396, 4, 1, 1),(44, 1397, 4, 1, 1),(44, 1398, 4, 1, 1),(44, 1399, 4, 1, 1),(44, 1400, 4, 1, 1),(44, 1401, 4, 1, 1),(44, 1402, 4, 1, 1),(44, 1403, 4, 1, 1),(44, 1404, 4, 1, 1),(44, 1405, 4, 1, 1),(44, 1406, 4, 1, 1),(44, 1407, 4, 1, 1),(44, 1408, 4, 1, 1),(44, 1409, 4, 1, 1),(44, 1410, 4, 1, 1),(44, 1411, 4, 1, 1),(44, 1412, 4, 1, 1),(44, 1413, 4, 1, 1),(44, 1414, 4, 1, 1),(44, 1415, 4, 1, 1),(44, 1416, 4, 1, 1),(44, 1417, 4, 1, 1),(44, 1418, 4, 1, 1),(44, 1419, 4, 1, 1),(44, 1420, 4, 1, 1),(44, 1421, 4, 1, 1),(44, 1422, 4, 1, 1),(44, 1423, 4, 1, 1),(44, 1424, 4, 1, 1),(44, 1425, 4, 1, 1),(44, 1426, 4, 1, 1),(44, 1427, 4, 1, 1),(44, 1428, 4, 1, 1),(44, 1429, 4, 1, 1),(44, 1430, 4, 1, 1),(44, 1431, 4, 1, 1),(44, 1432, 4, 1, 1),(44, 1433, 4, 1, 1),(44, 1434, 4, 1, 1),(44, 1435, 4, 1, 1),(44, 1436, 4, 1, 1),(44, 1437, 4, 1, 1),(44, 1438, 4, 1, 1),(44, 1439, 4, 1, 1),(44, 1440, 4, 1, 1),(44, 1441, 4, 1, 1),(44, 1442, 4, 1, 1),(44, 1443, 4, 1, 1),(44, 1444, 4, 1, 1),(44, 1445, 4, 1, 1),(44, 1446, 4, 1, 1),(44, 1447, 4, 1, 1),(44, 1448, 4, 1, 1),(44, 1449, 4, 1, 1),(44, 1450, 4, 1, 1),(44, 1451, 4, 1, 1),(44, 1452, 4, 1, 1),(44, 1453, 4, 1, 1),(44, 1454, 4, 1, 1),(44, 1455, 4, 1, 1),(44, 1456, 4, 1, 1),(44, 1457, 4, 1, 1),(44, 1458, 4, 1, 1),(44, 1459, 4, 1, 1),(44, 1460, 4, 1, 1),(44, 1461, 4, 1, 1),(44, 1462, 4, 1, 1),(44, 1463, 4, 1, 1),(44, 1464, 4, 1, 1),(44, 1465, 4, 1, 1),(44, 1466, 4, 1, 1),(44, 1467, 4, 1, 1),(44, 1468, 4, 1, 1),(44, 1469, 4, 1, 1),(44, 1470, 4, 1, 1),(44, 1471, 4, 1, 1),(44, 1472, 4, 1, 1),(44, 1473, 4, 1, 1),(44, 1474, 4, 1, 1),(44, 1475, 4, 1, 1),(44, 1476, 4, 1, 1),(44, 1477, 4, 1, 1),(44, 1478, 4, 1, 1),(44, 1479, 4, 1, 1),(44, 1480, 4, 1, 1),(44, 1481, 4, 1, 1),(44, 1482, 4, 1, 1),(44, 1483, 4, 1, 1),(44, 1484, 4, 1, 1),(44, 1485, 4, 1, 1),(44, 1486, 4, 1, 1),(44, 1487, 4, 1, 1),(44, 1488, 4, 1, 1),(44, 1489, 4, 1, 1),(44, 1490, 4, 1, 1),(44, 1491, 4, 1, 1),(44, 1492, 4, 1, 1),(44, 1493, 4, 1, 1),(44, 1494, 4, 1, 1),(44, 1495, 4, 1, 1),(44, 1496, 4, 1, 1),(44, 1497, 4, 1, 1),(44, 1498, 4, 1, 1),(44, 1499, 4, 1, 1),(44, 1500, 4, 1, 1),(44, 1501, 4, 1, 1),(44, 1502, 4, 1, 1),(44, 1503, 4, 1, 1),(44, 1504, 4, 1, 1),(44, 1505, 4, 1, 1),(44, 1506, 4, 1, 1),(44, 1507, 4, 1, 1),(44, 1508, 4, 1, 1),(44, 1509, 4, 1, 1),(44, 1510, 4, 1, 1),(44, 1511, 4, 1, 1),(44, 1512, 4, 1, 1),(44, 1513, 4, 1, 1),(44, 1514, 4, 1, 1),(44, 1515, 4, 1, 1),(44, 1516, 4, 1, 1),(44, 1517, 4, 1, 1),(44, 1518, 4, 1, 1),(44, 1519, 4, 1, 1),(44, 1520, 4, 1, 1),(44, 1521, 4, 1, 1),(44, 1522, 4, 1, 1),(44, 1523, 4, 1, 1),(44, 1524, 4, 1, 1),(44, 1525, 4, 1, 1),(44, 1526, 4, 1, 1),(44, 1527, 4, 1, 1),(44, 1528, 4, 1, 1),(44, 1529, 4, 1, 1),(44, 1530, 4, 1, 1),(44, 1531, 4, 1, 1),(44, 1532, 4, 1, 1),(44, 1533, 4, 1, 1),(44, 1534, 4, 1, 1),(44, 1535, 4, 1, 1),(44, 1536, 4, 1, 1);



INSERT INTO well_numbers (plate_format, well_name, row, row_num, col, total_col_count, by_row, by_col, quad, parent_well) VALUES (96, 'A01', 'A', 1, 1, 12, 1, 1, 1, 1),(96, 'B01', 'B', 2, 1, 12, 13, 2, 1, 2),(96, 'C01', 'C', 3, 1, 12, 25, 3, 1, 3),(96, 'D01', 'D', 4, 1, 12, 37, 4, 1, 4),(96, 'E01', 'E', 5, 1, 12, 49, 5, 1, 5),(96, 'F01', 'F', 6, 1, 12, 61, 6, 1, 6),(96, 'G01', 'G', 7, 1, 12, 73, 7, 1, 7),(96, 'H01', 'H', 8, 1, 12, 85, 8, 1, 8),(96, 'A02', 'A', 1, 2, 12, 2, 9, 1, 9),(96, 'B02', 'B', 2, 2, 12, 14, 10, 1, 10),(96, 'C02', 'C', 3, 2, 12, 26, 11, 1, 11),(96, 'D02', 'D', 4, 2, 12, 38, 12, 1, 12),(96, 'E02', 'E', 5, 2, 12, 50, 13, 1, 13),(96, 'F02', 'F', 6, 2, 12, 62, 14, 1, 14),(96, 'G02', 'G', 7, 2, 12, 74, 15, 1, 15),(96, 'H02', 'H', 8, 2, 12, 86, 16, 1, 16),(96, 'A03', 'A', 1, 3, 12, 3, 17, 1, 17),(96, 'B03', 'B', 2, 3, 12, 15, 18, 1, 18),(96, 'C03', 'C', 3, 3, 12, 27, 19, 1, 19),(96, 'D03', 'D', 4, 3, 12, 39, 20, 1, 20),(96, 'E03', 'E', 5, 3, 12, 51, 21, 1, 21),(96, 'F03', 'F', 6, 3, 12, 63, 22, 1, 22),(96, 'G03', 'G', 7, 3, 12, 75, 23, 1, 23),(96, 'H03', 'H', 8, 3, 12, 87, 24, 1, 24),(96, 'A04', 'A', 1, 4, 12, 4, 25, 1, 25),(96, 'B04', 'B', 2, 4, 12, 16, 26, 1, 26),(96, 'C04', 'C', 3, 4, 12, 28, 27, 1, 27),(96, 'D04', 'D', 4, 4, 12, 40, 28, 1, 28),(96, 'E04', 'E', 5, 4, 12, 52, 29, 1, 29),(96, 'F04', 'F', 6, 4, 12, 64, 30, 1, 30),(96, 'G04', 'G', 7, 4, 12, 76, 31, 1, 31),(96, 'H04', 'H', 8, 4, 12, 88, 32, 1, 32),(96, 'A05', 'A', 1, 5, 12, 5, 33, 1, 33),(96, 'B05', 'B', 2, 5, 12, 17, 34, 1, 34),(96, 'C05', 'C', 3, 5, 12, 29, 35, 1, 35),(96, 'D05', 'D', 4, 5, 12, 41, 36, 1, 36),(96, 'E05', 'E', 5, 5, 12, 53, 37, 1, 37),(96, 'F05', 'F', 6, 5, 12, 65, 38, 1, 38),(96, 'G05', 'G', 7, 5, 12, 77, 39, 1, 39),(96, 'H05', 'H', 8, 5, 12, 89, 40, 1, 40),(96, 'A06', 'A', 1, 6, 12, 6, 41, 1, 41),(96, 'B06', 'B', 2, 6, 12, 18, 42, 1, 42),(96, 'C06', 'C', 3, 6, 12, 30, 43, 1, 43),(96, 'D06', 'D', 4, 6, 12, 42, 44, 1, 44),(96, 'E06', 'E', 5, 6, 12, 54, 45, 1, 45),(96, 'F06', 'F', 6, 6, 12, 66, 46, 1, 46),(96, 'G06', 'G', 7, 6, 12, 78, 47, 1, 47),(96, 'H06', 'H', 8, 6, 12, 90, 48, 1, 48),(96, 'A07', 'A', 1, 7, 12, 7, 49, 1, 49),(96, 'B07', 'B', 2, 7, 12, 19, 50, 1, 50),(96, 'C07', 'C', 3, 7, 12, 31, 51, 1, 51),(96, 'D07', 'D', 4, 7, 12, 43, 52, 1, 52),(96, 'E07', 'E', 5, 7, 12, 55, 53, 1, 53),(96, 'F07', 'F', 6, 7, 12, 67, 54, 1, 54),(96, 'G07', 'G', 7, 7, 12, 79, 55, 1, 55),(96, 'H07', 'H', 8, 7, 12, 91, 56, 1, 56),(96, 'A08', 'A', 1, 8, 12, 8, 57, 1, 57),(96, 'B08', 'B', 2, 8, 12, 20, 58, 1, 58),(96, 'C08', 'C', 3, 8, 12, 32, 59, 1, 59),(96, 'D08', 'D', 4, 8, 12, 44, 60, 1, 60),(96, 'E08', 'E', 5, 8, 12, 56, 61, 1, 61),(96, 'F08', 'F', 6, 8, 12, 68, 62, 1, 62),(96, 'G08', 'G', 7, 8, 12, 80, 63, 1, 63),(96, 'H08', 'H', 8, 8, 12, 92, 64, 1, 64),(96, 'A09', 'A', 1, 9, 12, 9, 65, 1, 65),(96, 'B09', 'B', 2, 9, 12, 21, 66, 1, 66),(96, 'C09', 'C', 3, 9, 12, 33, 67, 1, 67),(96, 'D09', 'D', 4, 9, 12, 45, 68, 1, 68),(96, 'E09', 'E', 5, 9, 12, 57, 69, 1, 69),(96, 'F09', 'F', 6, 9, 12, 69, 70, 1, 70),(96, 'G09', 'G', 7, 9, 12, 81, 71, 1, 71),(96, 'H09', 'H', 8, 9, 12, 93, 72, 1, 72),(96, 'A10', 'A', 1, 10, 12, 10, 73, 1, 73),(96, 'B10', 'B', 2, 10, 12, 22, 74, 1, 74),(96, 'C10', 'C', 3, 10, 12, 34, 75, 1, 75),(96, 'D10', 'D', 4, 10, 12, 46, 76, 1, 76),(96, 'E10', 'E', 5, 10, 12, 58, 77, 1, 77),(96, 'F10', 'F', 6, 10, 12, 70, 78, 1, 78),(96, 'G10', 'G', 7, 10, 12, 82, 79, 1, 79),(96, 'H10', 'H', 8, 10, 12, 94, 80, 1, 80),(96, 'A11', 'A', 1, 11, 12, 11, 81, 1, 81),(96, 'B11', 'B', 2, 11, 12, 23, 82, 1, 82),(96, 'C11', 'C', 3, 11, 12, 35, 83, 1, 83),(96, 'D11', 'D', 4, 11, 12, 47, 84, 1, 84),(96, 'E11', 'E', 5, 11, 12, 59, 85, 1, 85),(96, 'F11', 'F', 6, 11, 12, 71, 86, 1, 86),(96, 'G11', 'G', 7, 11, 12, 83, 87, 1, 87),(96, 'H11', 'H', 8, 11, 12, 95, 88, 1, 88),(96, 'A12', 'A', 1, 12, 12, 12, 89, 1, 89),(96, 'B12', 'B', 2, 12, 12, 24, 90, 1, 90),(96, 'C12', 'C', 3, 12, 12, 36, 91, 1, 91),(96, 'D12', 'D', 4, 12, 12, 48, 92, 1, 92),(96, 'E12', 'E', 5, 12, 12, 60, 93, 1, 93),(96, 'F12', 'F', 6, 12, 12, 72, 94, 1, 94),(96, 'G12', 'G', 7, 12, 12, 84, 95, 1, 95),(96, 'H12', 'H', 8, 12, 12, 96, 96, 1, 96),(384, 'A01', 'A', 1, 1, 24, 1, 1, 1, 1),(384, 'B01', 'B', 2, 1, 24, 25, 2, 3, 1),(384, 'C01', 'C', 3, 1, 24, 49, 3, 1, 2),(384, 'D01', 'D', 4, 1, 24, 73, 4, 3, 2),(384, 'E01', 'E', 5, 1, 24, 97, 5, 1, 3),(384, 'F01', 'F', 6, 1, 24, 121, 6, 3, 3),(384, 'G01', 'G', 7, 1, 24, 145, 7, 1, 4),(384, 'H01', 'H', 8, 1, 24, 169, 8, 3, 4),(384, 'I01', 'I', 9, 1, 24, 193, 9, 1, 5),(384, 'J01', 'J', 10, 1, 24, 217, 10, 3, 5),(384, 'K01', 'K', 11, 1, 24, 241, 11, 1, 6),(384, 'L01', 'L', 12, 1, 24, 265, 12, 3, 6),(384, 'M01', 'M', 13, 1, 24, 289, 13, 1, 7),(384, 'N01', 'N', 14, 1, 24, 313, 14, 3, 7),(384, 'O01', 'O', 15, 1, 24, 337, 15, 1, 8),(384, 'P01', 'P', 16, 1, 24, 361, 16, 3, 8),(384, 'A02', 'A', 1, 2, 24, 2, 17, 2, 1),(384, 'B02', 'B', 2, 2, 24, 26, 18, 4, 1),(384, 'C02', 'C', 3, 2, 24, 50, 19, 2, 2),(384, 'D02', 'D', 4, 2, 24, 74, 20, 4, 2),(384, 'E02', 'E', 5, 2, 24, 98, 21, 2, 3),(384, 'F02', 'F', 6, 2, 24, 122, 22, 4, 3),(384, 'G02', 'G', 7, 2, 24, 146, 23, 2, 4),(384, 'H02', 'H', 8, 2, 24, 170, 24, 4, 4),(384, 'I02', 'I', 9, 2, 24, 194, 25, 2, 5),(384, 'J02', 'J', 10, 2, 24, 218, 26, 4, 5),(384, 'K02', 'K', 11, 2, 24, 242, 27, 2, 6),(384, 'L02', 'L', 12, 2, 24, 266, 28, 4, 6),(384, 'M02', 'M', 13, 2, 24, 290, 29, 2, 7),(384, 'N02', 'N', 14, 2, 24, 314, 30, 4, 7),(384, 'O02', 'O', 15, 2, 24, 338, 31, 2, 8),(384, 'P02', 'P', 16, 2, 24, 362, 32, 4, 8),(384, 'A03', 'A', 1, 3, 24, 3, 33, 1, 9),(384, 'B03', 'B', 2, 3, 24, 27, 34, 3, 9),(384, 'C03', 'C', 3, 3, 24, 51, 35, 1, 10),(384, 'D03', 'D', 4, 3, 24, 75, 36, 3, 10),(384, 'E03', 'E', 5, 3, 24, 99, 37, 1, 11),(384, 'F03', 'F', 6, 3, 24, 123, 38, 3, 11),(384, 'G03', 'G', 7, 3, 24, 147, 39, 1, 12),(384, 'H03', 'H', 8, 3, 24, 171, 40, 3, 12),(384, 'I03', 'I', 9, 3, 24, 195, 41, 1, 13),(384, 'J03', 'J', 10, 3, 24, 219, 42, 3, 13),(384, 'K03', 'K', 11, 3, 24, 243, 43, 1, 14),(384, 'L03', 'L', 12, 3, 24, 267, 44, 3, 14),(384, 'M03', 'M', 13, 3, 24, 291, 45, 1, 15),(384, 'N03', 'N', 14, 3, 24, 315, 46, 3, 15),(384, 'O03', 'O', 15, 3, 24, 339, 47, 1, 16),(384, 'P03', 'P', 16, 3, 24, 363, 48, 3, 16),(384, 'A04', 'A', 1, 4, 24, 4, 49, 2, 9),(384, 'B04', 'B', 2, 4, 24, 28, 50, 4, 9),(384, 'C04', 'C', 3, 4, 24, 52, 51, 2, 10),(384, 'D04', 'D', 4, 4, 24, 76, 52, 4, 10),(384, 'E04', 'E', 5, 4, 24, 100, 53, 2, 11),(384, 'F04', 'F', 6, 4, 24, 124, 54, 4, 11),(384, 'G04', 'G', 7, 4, 24, 148, 55, 2, 12),(384, 'H04', 'H', 8, 4, 24, 172, 56, 4, 12),(384, 'I04', 'I', 9, 4, 24, 196, 57, 2, 13),(384, 'J04', 'J', 10, 4, 24, 220, 58, 4, 13),(384, 'K04', 'K', 11, 4, 24, 244, 59, 2, 14),(384, 'L04', 'L', 12, 4, 24, 268, 60, 4, 14),(384, 'M04', 'M', 13, 4, 24, 292, 61, 2, 15),(384, 'N04', 'N', 14, 4, 24, 316, 62, 4, 15),(384, 'O04', 'O', 15, 4, 24, 340, 63, 2, 16),(384, 'P04', 'P', 16, 4, 24, 364, 64, 4, 16),(384, 'A05', 'A', 1, 5, 24, 5, 65, 1, 17),(384, 'B05', 'B', 2, 5, 24, 29, 66, 3, 17),(384, 'C05', 'C', 3, 5, 24, 53, 67, 1, 18),(384, 'D05', 'D', 4, 5, 24, 77, 68, 3, 18),(384, 'E05', 'E', 5, 5, 24, 101, 69, 1, 19),(384, 'F05', 'F', 6, 5, 24, 125, 70, 3, 19),(384, 'G05', 'G', 7, 5, 24, 149, 71, 1, 20),(384, 'H05', 'H', 8, 5, 24, 173, 72, 3, 20),(384, 'I05', 'I', 9, 5, 24, 197, 73, 1, 21),(384, 'J05', 'J', 10, 5, 24, 221, 74, 3, 21),(384, 'K05', 'K', 11, 5, 24, 245, 75, 1, 22),(384, 'L05', 'L', 12, 5, 24, 269, 76, 3, 22),(384, 'M05', 'M', 13, 5, 24, 293, 77, 1, 23),(384, 'N05', 'N', 14, 5, 24, 317, 78, 3, 23),(384, 'O05', 'O', 15, 5, 24, 341, 79, 1, 24),(384, 'P05', 'P', 16, 5, 24, 365, 80, 3, 24),(384, 'A06', 'A', 1, 6, 24, 6, 81, 2, 17),(384, 'B06', 'B', 2, 6, 24, 30, 82, 4, 17),(384, 'C06', 'C', 3, 6, 24, 54, 83, 2, 18),(384, 'D06', 'D', 4, 6, 24, 78, 84, 4, 18),(384, 'E06', 'E', 5, 6, 24, 102, 85, 2, 19),(384, 'F06', 'F', 6, 6, 24, 126, 86, 4, 19),(384, 'G06', 'G', 7, 6, 24, 150, 87, 2, 20),(384, 'H06', 'H', 8, 6, 24, 174, 88, 4, 20),(384, 'I06', 'I', 9, 6, 24, 198, 89, 2, 21),(384, 'J06', 'J', 10, 6, 24, 222, 90, 4, 21),(384, 'K06', 'K', 11, 6, 24, 246, 91, 2, 22),(384, 'L06', 'L', 12, 6, 24, 270, 92, 4, 22),(384, 'M06', 'M', 13, 6, 24, 294, 93, 2, 23),(384, 'N06', 'N', 14, 6, 24, 318, 94, 4, 23),(384, 'O06', 'O', 15, 6, 24, 342, 95, 2, 24),(384, 'P06', 'P', 16, 6, 24, 366, 96, 4, 24),(384, 'A07', 'A', 1, 7, 24, 7, 97, 1, 25),(384, 'B07', 'B', 2, 7, 24, 31, 98, 3, 25),(384, 'C07', 'C', 3, 7, 24, 55, 99, 1, 26),(384, 'D07', 'D', 4, 7, 24, 79, 100, 3, 26),(384, 'E07', 'E', 5, 7, 24, 103, 101, 1, 27),(384, 'F07', 'F', 6, 7, 24, 127, 102, 3, 27),(384, 'G07', 'G', 7, 7, 24, 151, 103, 1, 28),(384, 'H07', 'H', 8, 7, 24, 175, 104, 3, 28),(384, 'I07', 'I', 9, 7, 24, 199, 105, 1, 29),(384, 'J07', 'J', 10, 7, 24, 223, 106, 3, 29),(384, 'K07', 'K', 11, 7, 24, 247, 107, 1, 30),(384, 'L07', 'L', 12, 7, 24, 271, 108, 3, 30),(384, 'M07', 'M', 13, 7, 24, 295, 109, 1, 31),(384, 'N07', 'N', 14, 7, 24, 319, 110, 3, 31),(384, 'O07', 'O', 15, 7, 24, 343, 111, 1, 32),(384, 'P07', 'P', 16, 7, 24, 367, 112, 3, 32),(384, 'A08', 'A', 1, 8, 24, 8, 113, 2, 25),(384, 'B08', 'B', 2, 8, 24, 32, 114, 4, 25),(384, 'C08', 'C', 3, 8, 24, 56, 115, 2, 26),(384, 'D08', 'D', 4, 8, 24, 80, 116, 4, 26),(384, 'E08', 'E', 5, 8, 24, 104, 117, 2, 27),(384, 'F08', 'F', 6, 8, 24, 128, 118, 4, 27),(384, 'G08', 'G', 7, 8, 24, 152, 119, 2, 28),(384, 'H08', 'H', 8, 8, 24, 176, 120, 4, 28),(384, 'I08', 'I', 9, 8, 24, 200, 121, 2, 29),(384, 'J08', 'J', 10, 8, 24, 224, 122, 4, 29),(384, 'K08', 'K', 11, 8, 24, 248, 123, 2, 30),(384, 'L08', 'L', 12, 8, 24, 272, 124, 4, 30),(384, 'M08', 'M', 13, 8, 24, 296, 125, 2, 31),(384, 'N08', 'N', 14, 8, 24, 320, 126, 4, 31),(384, 'O08', 'O', 15, 8, 24, 344, 127, 2, 32),(384, 'P08', 'P', 16, 8, 24, 368, 128, 4, 32),(384, 'A09', 'A', 1, 9, 24, 9, 129, 1, 33),(384, 'B09', 'B', 2, 9, 24, 33, 130, 3, 33),(384, 'C09', 'C', 3, 9, 24, 57, 131, 1, 34),(384, 'D09', 'D', 4, 9, 24, 81, 132, 3, 34),(384, 'E09', 'E', 5, 9, 24, 105, 133, 1, 35),(384, 'F09', 'F', 6, 9, 24, 129, 134, 3, 35),(384, 'G09', 'G', 7, 9, 24, 153, 135, 1, 36),(384, 'H09', 'H', 8, 9, 24, 177, 136, 3, 36),(384, 'I09', 'I', 9, 9, 24, 201, 137, 1, 37),(384, 'J09', 'J', 10, 9, 24, 225, 138, 3, 37),(384, 'K09', 'K', 11, 9, 24, 249, 139, 1, 38),(384, 'L09', 'L', 12, 9, 24, 273, 140, 3, 38),(384, 'M09', 'M', 13, 9, 24, 297, 141, 1, 39),(384, 'N09', 'N', 14, 9, 24, 321, 142, 3, 39),(384, 'O09', 'O', 15, 9, 24, 345, 143, 1, 40),(384, 'P09', 'P', 16, 9, 24, 369, 144, 3, 40),(384, 'A10', 'A', 1, 10, 24, 10, 145, 2, 33),(384, 'B10', 'B', 2, 10, 24, 34, 146, 4, 33),(384, 'C10', 'C', 3, 10, 24, 58, 147, 2, 34),(384, 'D10', 'D', 4, 10, 24, 82, 148, 4, 34),(384, 'E10', 'E', 5, 10, 24, 106, 149, 2, 35),(384, 'F10', 'F', 6, 10, 24, 130, 150, 4, 35),(384, 'G10', 'G', 7, 10, 24, 154, 151, 2, 36),(384, 'H10', 'H', 8, 10, 24, 178, 152, 4, 36),(384, 'I10', 'I', 9, 10, 24, 202, 153, 2, 37),(384, 'J10', 'J', 10, 10, 24, 226, 154, 4, 37),(384, 'K10', 'K', 11, 10, 24, 250, 155, 2, 38),(384, 'L10', 'L', 12, 10, 24, 274, 156, 4, 38),(384, 'M10', 'M', 13, 10, 24, 298, 157, 2, 39),(384, 'N10', 'N', 14, 10, 24, 322, 158, 4, 39),(384, 'O10', 'O', 15, 10, 24, 346, 159, 2, 40),(384, 'P10', 'P', 16, 10, 24, 370, 160, 4, 40),(384, 'A11', 'A', 1, 11, 24, 11, 161, 1, 41),(384, 'B11', 'B', 2, 11, 24, 35, 162, 3, 41),(384, 'C11', 'C', 3, 11, 24, 59, 163, 1, 42),(384, 'D11', 'D', 4, 11, 24, 83, 164, 3, 42),(384, 'E11', 'E', 5, 11, 24, 107, 165, 1, 43),(384, 'F11', 'F', 6, 11, 24, 131, 166, 3, 43),(384, 'G11', 'G', 7, 11, 24, 155, 167, 1, 44),(384, 'H11', 'H', 8, 11, 24, 179, 168, 3, 44),(384, 'I11', 'I', 9, 11, 24, 203, 169, 1, 45),(384, 'J11', 'J', 10, 11, 24, 227, 170, 3, 45),(384, 'K11', 'K', 11, 11, 24, 251, 171, 1, 46),(384, 'L11', 'L', 12, 11, 24, 275, 172, 3, 46),(384, 'M11', 'M', 13, 11, 24, 299, 173, 1, 47),(384, 'N11', 'N', 14, 11, 24, 323, 174, 3, 47),(384, 'O11', 'O', 15, 11, 24, 347, 175, 1, 48),(384, 'P11', 'P', 16, 11, 24, 371, 176, 3, 48),(384, 'A12', 'A', 1, 12, 24, 12, 177, 2, 41),(384, 'B12', 'B', 2, 12, 24, 36, 178, 4, 41),(384, 'C12', 'C', 3, 12, 24, 60, 179, 2, 42),(384, 'D12', 'D', 4, 12, 24, 84, 180, 4, 42),(384, 'E12', 'E', 5, 12, 24, 108, 181, 2, 43),(384, 'F12', 'F', 6, 12, 24, 132, 182, 4, 43),(384, 'G12', 'G', 7, 12, 24, 156, 183, 2, 44),(384, 'H12', 'H', 8, 12, 24, 180, 184, 4, 44),(384, 'I12', 'I', 9, 12, 24, 204, 185, 2, 45),(384, 'J12', 'J', 10, 12, 24, 228, 186, 4, 45),(384, 'K12', 'K', 11, 12, 24, 252, 187, 2, 46),(384, 'L12', 'L', 12, 12, 24, 276, 188, 4, 46),(384, 'M12', 'M', 13, 12, 24, 300, 189, 2, 47),(384, 'N12', 'N', 14, 12, 24, 324, 190, 4, 47),(384, 'O12', 'O', 15, 12, 24, 348, 191, 2, 48),(384, 'P12', 'P', 16, 12, 24, 372, 192, 4, 48),(384, 'A13', 'A', 1, 13, 24, 13, 193, 1, 49),(384, 'B13', 'B', 2, 13, 24, 37, 194, 3, 49),(384, 'C13', 'C', 3, 13, 24, 61, 195, 1, 50),(384, 'D13', 'D', 4, 13, 24, 85, 196, 3, 50),(384, 'E13', 'E', 5, 13, 24, 109, 197, 1, 51),(384, 'F13', 'F', 6, 13, 24, 133, 198, 3, 51),(384, 'G13', 'G', 7, 13, 24, 157, 199, 1, 52),(384, 'H13', 'H', 8, 13, 24, 181, 200, 3, 52),(384, 'I13', 'I', 9, 13, 24, 205, 201, 1, 53),(384, 'J13', 'J', 10, 13, 24, 229, 202, 3, 53),(384, 'K13', 'K', 11, 13, 24, 253, 203, 1, 54),(384, 'L13', 'L', 12, 13, 24, 277, 204, 3, 54),(384, 'M13', 'M', 13, 13, 24, 301, 205, 1, 55),(384, 'N13', 'N', 14, 13, 24, 325, 206, 3, 55),(384, 'O13', 'O', 15, 13, 24, 349, 207, 1, 56),(384, 'P13', 'P', 16, 13, 24, 373, 208, 3, 56),(384, 'A14', 'A', 1, 14, 24, 14, 209, 2, 49),(384, 'B14', 'B', 2, 14, 24, 38, 210, 4, 49),(384, 'C14', 'C', 3, 14, 24, 62, 211, 2, 50),(384, 'D14', 'D', 4, 14, 24, 86, 212, 4, 50),(384, 'E14', 'E', 5, 14, 24, 110, 213, 2, 51),(384, 'F14', 'F', 6, 14, 24, 134, 214, 4, 51),(384, 'G14', 'G', 7, 14, 24, 158, 215, 2, 52),(384, 'H14', 'H', 8, 14, 24, 182, 216, 4, 52),(384, 'I14', 'I', 9, 14, 24, 206, 217, 2, 53),(384, 'J14', 'J', 10, 14, 24, 230, 218, 4, 53),(384, 'K14', 'K', 11, 14, 24, 254, 219, 2, 54),(384, 'L14', 'L', 12, 14, 24, 278, 220, 4, 54),(384, 'M14', 'M', 13, 14, 24, 302, 221, 2, 55),(384, 'N14', 'N', 14, 14, 24, 326, 222, 4, 55),(384, 'O14', 'O', 15, 14, 24, 350, 223, 2, 56),(384, 'P14', 'P', 16, 14, 24, 374, 224, 4, 56),(384, 'A15', 'A', 1, 15, 24, 15, 225, 1, 57),(384, 'B15', 'B', 2, 15, 24, 39, 226, 3, 57),(384, 'C15', 'C', 3, 15, 24, 63, 227, 1, 58),(384, 'D15', 'D', 4, 15, 24, 87, 228, 3, 58),(384, 'E15', 'E', 5, 15, 24, 111, 229, 1, 59),(384, 'F15', 'F', 6, 15, 24, 135, 230, 3, 59),(384, 'G15', 'G', 7, 15, 24, 159, 231, 1, 60),(384, 'H15', 'H', 8, 15, 24, 183, 232, 3, 60),(384, 'I15', 'I', 9, 15, 24, 207, 233, 1, 61),(384, 'J15', 'J', 10, 15, 24, 231, 234, 3, 61),(384, 'K15', 'K', 11, 15, 24, 255, 235, 1, 62),(384, 'L15', 'L', 12, 15, 24, 279, 236, 3, 62),(384, 'M15', 'M', 13, 15, 24, 303, 237, 1, 63),(384, 'N15', 'N', 14, 15, 24, 327, 238, 3, 63),(384, 'O15', 'O', 15, 15, 24, 351, 239, 1, 64),(384, 'P15', 'P', 16, 15, 24, 375, 240, 3, 64),(384, 'A16', 'A', 1, 16, 24, 16, 241, 2, 57),(384, 'B16', 'B', 2, 16, 24, 40, 242, 4, 57),(384, 'C16', 'C', 3, 16, 24, 64, 243, 2, 58),(384, 'D16', 'D', 4, 16, 24, 88, 244, 4, 58),(384, 'E16', 'E', 5, 16, 24, 112, 245, 2, 59),(384, 'F16', 'F', 6, 16, 24, 136, 246, 4, 59),(384, 'G16', 'G', 7, 16, 24, 160, 247, 2, 60),(384, 'H16', 'H', 8, 16, 24, 184, 248, 4, 60),(384, 'I16', 'I', 9, 16, 24, 208, 249, 2, 61),(384, 'J16', 'J', 10, 16, 24, 232, 250, 4, 61),(384, 'K16', 'K', 11, 16, 24, 256, 251, 2, 62),(384, 'L16', 'L', 12, 16, 24, 280, 252, 4, 62),(384, 'M16', 'M', 13, 16, 24, 304, 253, 2, 63),(384, 'N16', 'N', 14, 16, 24, 328, 254, 4, 63),(384, 'O16', 'O', 15, 16, 24, 352, 255, 2, 64),(384, 'P16', 'P', 16, 16, 24, 376, 256, 4, 64),(384, 'A17', 'A', 1, 17, 24, 17, 257, 1, 65),(384, 'B17', 'B', 2, 17, 24, 41, 258, 3, 65),(384, 'C17', 'C', 3, 17, 24, 65, 259, 1, 66),(384, 'D17', 'D', 4, 17, 24, 89, 260, 3, 66),(384, 'E17', 'E', 5, 17, 24, 113, 261, 1, 67),(384, 'F17', 'F', 6, 17, 24, 137, 262, 3, 67),(384, 'G17', 'G', 7, 17, 24, 161, 263, 1, 68),(384, 'H17', 'H', 8, 17, 24, 185, 264, 3, 68),(384, 'I17', 'I', 9, 17, 24, 209, 265, 1, 69),(384, 'J17', 'J', 10, 17, 24, 233, 266, 3, 69),(384, 'K17', 'K', 11, 17, 24, 257, 267, 1, 70),(384, 'L17', 'L', 12, 17, 24, 281, 268, 3, 70),(384, 'M17', 'M', 13, 17, 24, 305, 269, 1, 71),(384, 'N17', 'N', 14, 17, 24, 329, 270, 3, 71),(384, 'O17', 'O', 15, 17, 24, 353, 271, 1, 72),(384, 'P17', 'P', 16, 17, 24, 377, 272, 3, 72),(384, 'A18', 'A', 1, 18, 24, 18, 273, 2, 65),(384, 'B18', 'B', 2, 18, 24, 42, 274, 4, 65),(384, 'C18', 'C', 3, 18, 24, 66, 275, 2, 66),(384, 'D18', 'D', 4, 18, 24, 90, 276, 4, 66),(384, 'E18', 'E', 5, 18, 24, 114, 277, 2, 67),(384, 'F18', 'F', 6, 18, 24, 138, 278, 4, 67),(384, 'G18', 'G', 7, 18, 24, 162, 279, 2, 68),(384, 'H18', 'H', 8, 18, 24, 186, 280, 4, 68),(384, 'I18', 'I', 9, 18, 24, 210, 281, 2, 69),(384, 'J18', 'J', 10, 18, 24, 234, 282, 4, 69),(384, 'K18', 'K', 11, 18, 24, 258, 283, 2, 70),(384, 'L18', 'L', 12, 18, 24, 282, 284, 4, 70),(384, 'M18', 'M', 13, 18, 24, 306, 285, 2, 71),(384, 'N18', 'N', 14, 18, 24, 330, 286, 4, 71),(384, 'O18', 'O', 15, 18, 24, 354, 287, 2, 72),(384, 'P18', 'P', 16, 18, 24, 378, 288, 4, 72),(384, 'A19', 'A', 1, 19, 24, 19, 289, 1, 73),(384, 'B19', 'B', 2, 19, 24, 43, 290, 3, 73),(384, 'C19', 'C', 3, 19, 24, 67, 291, 1, 74),(384, 'D19', 'D', 4, 19, 24, 91, 292, 3, 74),(384, 'E19', 'E', 5, 19, 24, 115, 293, 1, 75),(384, 'F19', 'F', 6, 19, 24, 139, 294, 3, 75),(384, 'G19', 'G', 7, 19, 24, 163, 295, 1, 76),(384, 'H19', 'H', 8, 19, 24, 187, 296, 3, 76),(384, 'I19', 'I', 9, 19, 24, 211, 297, 1, 77),(384, 'J19', 'J', 10, 19, 24, 235, 298, 3, 77),(384, 'K19', 'K', 11, 19, 24, 259, 299, 1, 78),(384, 'L19', 'L', 12, 19, 24, 283, 300, 3, 78),(384, 'M19', 'M', 13, 19, 24, 307, 301, 1, 79),(384, 'N19', 'N', 14, 19, 24, 331, 302, 3, 79),(384, 'O19', 'O', 15, 19, 24, 355, 303, 1, 80),(384, 'P19', 'P', 16, 19, 24, 379, 304, 3, 80),(384, 'A20', 'A', 1, 20, 24, 20, 305, 2, 73),(384, 'B20', 'B', 2, 20, 24, 44, 306, 4, 73),(384, 'C20', 'C', 3, 20, 24, 68, 307, 2, 74),(384, 'D20', 'D', 4, 20, 24, 92, 308, 4, 74),(384, 'E20', 'E', 5, 20, 24, 116, 309, 2, 75),(384, 'F20', 'F', 6, 20, 24, 140, 310, 4, 75),(384, 'G20', 'G', 7, 20, 24, 164, 311, 2, 76),(384, 'H20', 'H', 8, 20, 24, 188, 312, 4, 76),(384, 'I20', 'I', 9, 20, 24, 212, 313, 2, 77),(384, 'J20', 'J', 10, 20, 24, 236, 314, 4, 77),(384, 'K20', 'K', 11, 20, 24, 260, 315, 2, 78),(384, 'L20', 'L', 12, 20, 24, 284, 316, 4, 78),(384, 'M20', 'M', 13, 20, 24, 308, 317, 2, 79),(384, 'N20', 'N', 14, 20, 24, 332, 318, 4, 79),(384, 'O20', 'O', 15, 20, 24, 356, 319, 2, 80),(384, 'P20', 'P', 16, 20, 24, 380, 320, 4, 80),(384, 'A21', 'A', 1, 21, 24, 21, 321, 1, 81),(384, 'B21', 'B', 2, 21, 24, 45, 322, 3, 81),(384, 'C21', 'C', 3, 21, 24, 69, 323, 1, 82),(384, 'D21', 'D', 4, 21, 24, 93, 324, 3, 82),(384, 'E21', 'E', 5, 21, 24, 117, 325, 1, 83),(384, 'F21', 'F', 6, 21, 24, 141, 326, 3, 83),(384, 'G21', 'G', 7, 21, 24, 165, 327, 1, 84),(384, 'H21', 'H', 8, 21, 24, 189, 328, 3, 84),(384, 'I21', 'I', 9, 21, 24, 213, 329, 1, 85),(384, 'J21', 'J', 10, 21, 24, 237, 330, 3, 85),(384, 'K21', 'K', 11, 21, 24, 261, 331, 1, 86),(384, 'L21', 'L', 12, 21, 24, 285, 332, 3, 86),(384, 'M21', 'M', 13, 21, 24, 309, 333, 1, 87),(384, 'N21', 'N', 14, 21, 24, 333, 334, 3, 87),(384, 'O21', 'O', 15, 21, 24, 357, 335, 1, 88),(384, 'P21', 'P', 16, 21, 24, 381, 336, 3, 88),(384, 'A22', 'A', 1, 22, 24, 22, 337, 2, 81),(384, 'B22', 'B', 2, 22, 24, 46, 338, 4, 81),(384, 'C22', 'C', 3, 22, 24, 70, 339, 2, 82),(384, 'D22', 'D', 4, 22, 24, 94, 340, 4, 82),(384, 'E22', 'E', 5, 22, 24, 118, 341, 2, 83),(384, 'F22', 'F', 6, 22, 24, 142, 342, 4, 83),(384, 'G22', 'G', 7, 22, 24, 166, 343, 2, 84),(384, 'H22', 'H', 8, 22, 24, 190, 344, 4, 84),(384, 'I22', 'I', 9, 22, 24, 214, 345, 2, 85),(384, 'J22', 'J', 10, 22, 24, 238, 346, 4, 85),(384, 'K22', 'K', 11, 22, 24, 262, 347, 2, 86),(384, 'L22', 'L', 12, 22, 24, 286, 348, 4, 86),(384, 'M22', 'M', 13, 22, 24, 310, 349, 2, 87),(384, 'N22', 'N', 14, 22, 24, 334, 350, 4, 87),(384, 'O22', 'O', 15, 22, 24, 358, 351, 2, 88),(384, 'P22', 'P', 16, 22, 24, 382, 352, 4, 88),(384, 'A23', 'A', 1, 23, 24, 23, 353, 1, 89),(384, 'B23', 'B', 2, 23, 24, 47, 354, 3, 89),(384, 'C23', 'C', 3, 23, 24, 71, 355, 1, 90),(384, 'D23', 'D', 4, 23, 24, 95, 356, 3, 90),(384, 'E23', 'E', 5, 23, 24, 119, 357, 1, 91),(384, 'F23', 'F', 6, 23, 24, 143, 358, 3, 91),(384, 'G23', 'G', 7, 23, 24, 167, 359, 1, 92),(384, 'H23', 'H', 8, 23, 24, 191, 360, 3, 92),(384, 'I23', 'I', 9, 23, 24, 215, 361, 1, 93),(384, 'J23', 'J', 10, 23, 24, 239, 362, 3, 93),(384, 'K23', 'K', 11, 23, 24, 263, 363, 1, 94),(384, 'L23', 'L', 12, 23, 24, 287, 364, 3, 94),(384, 'M23', 'M', 13, 23, 24, 311, 365, 1, 95),(384, 'N23', 'N', 14, 23, 24, 335, 366, 3, 95),(384, 'O23', 'O', 15, 23, 24, 359, 367, 1, 96),(384, 'P23', 'P', 16, 23, 24, 383, 368, 3, 96),(384, 'A24', 'A', 1, 24, 24, 24, 369, 2, 89),(384, 'B24', 'B', 2, 24, 24, 48, 370, 4, 89),(384, 'C24', 'C', 3, 24, 24, 72, 371, 2, 90),(384, 'D24', 'D', 4, 24, 24, 96, 372, 4, 90),(384, 'E24', 'E', 5, 24, 24, 120, 373, 2, 91),(384, 'F24', 'F', 6, 24, 24, 144, 374, 4, 91),(384, 'G24', 'G', 7, 24, 24, 168, 375, 2, 92),(384, 'H24', 'H', 8, 24, 24, 192, 376, 4, 92),(384, 'I24', 'I', 9, 24, 24, 216, 377, 2, 93),(384, 'J24', 'J', 10, 24, 24, 240, 378, 4, 93),(384, 'K24', 'K', 11, 24, 24, 264, 379, 2, 94),(384, 'L24', 'L', 12, 24, 24, 288, 380, 4, 94),(384, 'M24', 'M', 13, 24, 24, 312, 381, 2, 95),(384, 'N24', 'N', 14, 24, 24, 336, 382, 4, 95),(384, 'O24', 'O', 15, 24, 24, 360, 383, 2, 96),(384, 'P24', 'P', 16, 24, 24, 384, 384, 4, 96),(1536, 'A01', 'A', 1, 1, 48, 1, 1, 1, 1),(1536, 'C01', 'C', 3, 1, 48, 97, 3, 1, 2),(1536, 'E01', 'E', 5, 1, 48, 193, 5, 1, 3),(1536, 'G01', 'G', 7, 1, 48, 289, 7, 1, 4),(1536, 'I01', 'I', 9, 1, 48, 385, 9, 1, 5),(1536, 'K01', 'K', 11, 1, 48, 481, 11, 1, 6),(1536, 'M01', 'M', 13, 1, 48, 577, 13, 1, 7),(1536, 'O01', 'O', 15, 1, 48, 673, 15, 1, 8),(1536, 'Q01', 'Q', 17, 1, 48, 769, 17, 1, 9),(1536, 'S01', 'S', 19, 1, 48, 865, 19, 1, 10),(1536, 'U01', 'U', 21, 1, 48, 961, 21, 1, 11),(1536, 'W01', 'W', 23, 1, 48, 1057, 23, 1, 12),(1536, 'Y01', 'Y', 25, 1, 48, 1153, 25, 1, 13),(1536, 'AA01', 'AA', 27, 1, 48, 1249, 27, 1, 14),(1536, 'AC01', 'AC', 29, 1, 48, 1345, 29, 1, 15),(1536, 'AE01', 'AE', 31, 1, 48, 1441, 31, 1, 16),(1536, 'A03', 'A', 1, 3, 48, 3, 65, 1, 17),(1536, 'C03', 'C', 3, 3, 48, 99, 67, 1, 18),(1536, 'E03', 'E', 5, 3, 48, 195, 69, 1, 19),(1536, 'G03', 'G', 7, 3, 48, 291, 71, 1, 20),(1536, 'I03', 'I', 9, 3, 48, 387, 73, 1, 21),(1536, 'K03', 'K', 11, 3, 48, 483, 75, 1, 22),(1536, 'M03', 'M', 13, 3, 48, 579, 77, 1, 23),(1536, 'O03', 'O', 15, 3, 48, 675, 79, 1, 24),(1536, 'Q03', 'Q', 17, 3, 48, 771, 81, 1, 25),(1536, 'S03', 'S', 19, 3, 48, 867, 83, 1, 26),(1536, 'U03', 'U', 21, 3, 48, 963, 85, 1, 27),(1536, 'W03', 'W', 23, 3, 48, 1059, 87, 1, 28),(1536, 'Y03', 'Y', 25, 3, 48, 1155, 89, 1, 29),(1536, 'AA03', 'AA', 27, 3, 48, 1251, 91, 1, 30),(1536, 'AC03', 'AC', 29, 3, 48, 1347, 93, 1, 31),(1536, 'AE03', 'AE', 31, 3, 48, 1443, 95, 1, 32),(1536, 'A05', 'A', 1, 5, 48, 5, 129, 1, 33),(1536, 'C05', 'C', 3, 5, 48, 101, 131, 1, 34),(1536, 'E05', 'E', 5, 5, 48, 197, 133, 1, 35),(1536, 'G05', 'G', 7, 5, 48, 293, 135, 1, 36),(1536, 'I05', 'I', 9, 5, 48, 389, 137, 1, 37),(1536, 'K05', 'K', 11, 5, 48, 485, 139, 1, 38),(1536, 'M05', 'M', 13, 5, 48, 581, 141, 1, 39),(1536, 'O05', 'O', 15, 5, 48, 677, 143, 1, 40),(1536, 'Q05', 'Q', 17, 5, 48, 773, 145, 1, 41),(1536, 'S05', 'S', 19, 5, 48, 869, 147, 1, 42),(1536, 'U05', 'U', 21, 5, 48, 965, 149, 1, 43),(1536, 'W05', 'W', 23, 5, 48, 1061, 151, 1, 44),(1536, 'Y05', 'Y', 25, 5, 48, 1157, 153, 1, 45),(1536, 'AA05', 'AA', 27, 5, 48, 1253, 155, 1, 46),(1536, 'AC05', 'AC', 29, 5, 48, 1349, 157, 1, 47),(1536, 'AE05', 'AE', 31, 5, 48, 1445, 159, 1, 48),(1536, 'A07', 'A', 1, 7, 48, 7, 193, 1, 49),(1536, 'C07', 'C', 3, 7, 48, 103, 195, 1, 50),(1536, 'E07', 'E', 5, 7, 48, 199, 197, 1, 51),(1536, 'G07', 'G', 7, 7, 48, 295, 199, 1, 52),(1536, 'I07', 'I', 9, 7, 48, 391, 201, 1, 53),(1536, 'K07', 'K', 11, 7, 48, 487, 203, 1, 54),(1536, 'M07', 'M', 13, 7, 48, 583, 205, 1, 55),(1536, 'O07', 'O', 15, 7, 48, 679, 207, 1, 56),(1536, 'Q07', 'Q', 17, 7, 48, 775, 209, 1, 57),(1536, 'S07', 'S', 19, 7, 48, 871, 211, 1, 58),(1536, 'U07', 'U', 21, 7, 48, 967, 213, 1, 59),(1536, 'W07', 'W', 23, 7, 48, 1063, 215, 1, 60),(1536, 'Y07', 'Y', 25, 7, 48, 1159, 217, 1, 61),(1536, 'AA07', 'AA', 27, 7, 48, 1255, 219, 1, 62),(1536, 'AC07', 'AC', 29, 7, 48, 1351, 221, 1, 63),(1536, 'AE07', 'AE', 31, 7, 48, 1447, 223, 1, 64),(1536, 'A09', 'A', 1, 9, 48, 9, 257, 1, 65),(1536, 'C09', 'C', 3, 9, 48, 105, 259, 1, 66),(1536, 'E09', 'E', 5, 9, 48, 201, 261, 1, 67),(1536, 'G09', 'G', 7, 9, 48, 297, 263, 1, 68),(1536, 'I09', 'I', 9, 9, 48, 393, 265, 1, 69),(1536, 'K09', 'K', 11, 9, 48, 489, 267, 1, 70),(1536, 'M09', 'M', 13, 9, 48, 585, 269, 1, 71),(1536, 'O09', 'O', 15, 9, 48, 681, 271, 1, 72),(1536, 'Q09', 'Q', 17, 9, 48, 777, 273, 1, 73),(1536, 'S09', 'S', 19, 9, 48, 873, 275, 1, 74),(1536, 'U09', 'U', 21, 9, 48, 969, 277, 1, 75),(1536, 'W09', 'W', 23, 9, 48, 1065, 279, 1, 76),(1536, 'Y09', 'Y', 25, 9, 48, 1161, 281, 1, 77),(1536, 'AA09', 'AA', 27, 9, 48, 1257, 283, 1, 78),(1536, 'AC09', 'AC', 29, 9, 48, 1353, 285, 1, 79),(1536, 'AE09', 'AE', 31, 9, 48, 1449, 287, 1, 80),(1536, 'A11', 'A', 1, 11, 48, 11, 321, 1, 81),(1536, 'C11', 'C', 3, 11, 48, 107, 323, 1, 82),(1536, 'E11', 'E', 5, 11, 48, 203, 325, 1, 83),(1536, 'G11', 'G', 7, 11, 48, 299, 327, 1, 84),(1536, 'I11', 'I', 9, 11, 48, 395, 329, 1, 85),(1536, 'K11', 'K', 11, 11, 48, 491, 331, 1, 86),(1536, 'M11', 'M', 13, 11, 48, 587, 333, 1, 87),(1536, 'O11', 'O', 15, 11, 48, 683, 335, 1, 88),(1536, 'Q11', 'Q', 17, 11, 48, 779, 337, 1, 89),(1536, 'S11', 'S', 19, 11, 48, 875, 339, 1, 90),(1536, 'U11', 'U', 21, 11, 48, 971, 341, 1, 91),(1536, 'W11', 'W', 23, 11, 48, 1067, 343, 1, 92),(1536, 'Y11', 'Y', 25, 11, 48, 1163, 345, 1, 93),(1536, 'AA11', 'AA', 27, 11, 48, 1259, 347, 1, 94),(1536, 'AC11', 'AC', 29, 11, 48, 1355, 349, 1, 95),(1536, 'AE11', 'AE', 31, 11, 48, 1451, 351, 1, 96),(1536, 'A13', 'A', 1, 13, 48, 13, 385, 1, 97),(1536, 'C13', 'C', 3, 13, 48, 109, 387, 1, 98),(1536, 'E13', 'E', 5, 13, 48, 205, 389, 1, 99),(1536, 'G13', 'G', 7, 13, 48, 301, 391, 1, 100),(1536, 'I13', 'I', 9, 13, 48, 397, 393, 1, 101),(1536, 'K13', 'K', 11, 13, 48, 493, 395, 1, 102),(1536, 'M13', 'M', 13, 13, 48, 589, 397, 1, 103),(1536, 'O13', 'O', 15, 13, 48, 685, 399, 1, 104),(1536, 'Q13', 'Q', 17, 13, 48, 781, 401, 1, 105),(1536, 'S13', 'S', 19, 13, 48, 877, 403, 1, 106),(1536, 'U13', 'U', 21, 13, 48, 973, 405, 1, 107),(1536, 'W13', 'W', 23, 13, 48, 1069, 407, 1, 108),(1536, 'Y13', 'Y', 25, 13, 48, 1165, 409, 1, 109),(1536, 'AA13', 'AA', 27, 13, 48, 1261, 411, 1, 110),(1536, 'AC13', 'AC', 29, 13, 48, 1357, 413, 1, 111),(1536, 'AE13', 'AE', 31, 13, 48, 1453, 415, 1, 112),(1536, 'A15', 'A', 1, 15, 48, 15, 449, 1, 113),(1536, 'C15', 'C', 3, 15, 48, 111, 451, 1, 114),(1536, 'E15', 'E', 5, 15, 48, 207, 453, 1, 115),(1536, 'G15', 'G', 7, 15, 48, 303, 455, 1, 116),(1536, 'I15', 'I', 9, 15, 48, 399, 457, 1, 117),(1536, 'K15', 'K', 11, 15, 48, 495, 459, 1, 118),(1536, 'M15', 'M', 13, 15, 48, 591, 461, 1, 119),(1536, 'O15', 'O', 15, 15, 48, 687, 463, 1, 120),(1536, 'Q15', 'Q', 17, 15, 48, 783, 465, 1, 121),(1536, 'S15', 'S', 19, 15, 48, 879, 467, 1, 122),(1536, 'U15', 'U', 21, 15, 48, 975, 469, 1, 123),(1536, 'W15', 'W', 23, 15, 48, 1071, 471, 1, 124),(1536, 'Y15', 'Y', 25, 15, 48, 1167, 473, 1, 125),(1536, 'AA15', 'AA', 27, 15, 48, 1263, 475, 1, 126),(1536, 'AC15', 'AC', 29, 15, 48, 1359, 477, 1, 127),(1536, 'AE15', 'AE', 31, 15, 48, 1455, 479, 1, 128),(1536, 'A17', 'A', 1, 17, 48, 17, 513, 1, 129),(1536, 'C17', 'C', 3, 17, 48, 113, 515, 1, 130),(1536, 'E17', 'E', 5, 17, 48, 209, 517, 1, 131),(1536, 'G17', 'G', 7, 17, 48, 305, 519, 1, 132),(1536, 'I17', 'I', 9, 17, 48, 401, 521, 1, 133),(1536, 'K17', 'K', 11, 17, 48, 497, 523, 1, 134),(1536, 'M17', 'M', 13, 17, 48, 593, 525, 1, 135),(1536, 'O17', 'O', 15, 17, 48, 689, 527, 1, 136),(1536, 'Q17', 'Q', 17, 17, 48, 785, 529, 1, 137),(1536, 'S17', 'S', 19, 17, 48, 881, 531, 1, 138),(1536, 'U17', 'U', 21, 17, 48, 977, 533, 1, 139),(1536, 'W17', 'W', 23, 17, 48, 1073, 535, 1, 140),(1536, 'Y17', 'Y', 25, 17, 48, 1169, 537, 1, 141),(1536, 'AA17', 'AA', 27, 17, 48, 1265, 539, 1, 142),(1536, 'AC17', 'AC', 29, 17, 48, 1361, 541, 1, 143),(1536, 'AE17', 'AE', 31, 17, 48, 1457, 543, 1, 144),(1536, 'A19', 'A', 1, 19, 48, 19, 577, 1, 145),(1536, 'C19', 'C', 3, 19, 48, 115, 579, 1, 146),(1536, 'E19', 'E', 5, 19, 48, 211, 581, 1, 147),(1536, 'G19', 'G', 7, 19, 48, 307, 583, 1, 148),(1536, 'I19', 'I', 9, 19, 48, 403, 585, 1, 149),(1536, 'K19', 'K', 11, 19, 48, 499, 587, 1, 150),(1536, 'M19', 'M', 13, 19, 48, 595, 589, 1, 151),(1536, 'O19', 'O', 15, 19, 48, 691, 591, 1, 152),(1536, 'Q19', 'Q', 17, 19, 48, 787, 593, 1, 153),(1536, 'S19', 'S', 19, 19, 48, 883, 595, 1, 154),(1536, 'U19', 'U', 21, 19, 48, 979, 597, 1, 155),(1536, 'W19', 'W', 23, 19, 48, 1075, 599, 1, 156),(1536, 'Y19', 'Y', 25, 19, 48, 1171, 601, 1, 157),(1536, 'AA19', 'AA', 27, 19, 48, 1267, 603, 1, 158),(1536, 'AC19', 'AC', 29, 19, 48, 1363, 605, 1, 159),(1536, 'AE19', 'AE', 31, 19, 48, 1459, 607, 1, 160),(1536, 'A21', 'A', 1, 21, 48, 21, 641, 1, 161),(1536, 'C21', 'C', 3, 21, 48, 117, 643, 1, 162),(1536, 'E21', 'E', 5, 21, 48, 213, 645, 1, 163),(1536, 'G21', 'G', 7, 21, 48, 309, 647, 1, 164),(1536, 'I21', 'I', 9, 21, 48, 405, 649, 1, 165),(1536, 'K21', 'K', 11, 21, 48, 501, 651, 1, 166),(1536, 'M21', 'M', 13, 21, 48, 597, 653, 1, 167),(1536, 'O21', 'O', 15, 21, 48, 693, 655, 1, 168),(1536, 'Q21', 'Q', 17, 21, 48, 789, 657, 1, 169),(1536, 'S21', 'S', 19, 21, 48, 885, 659, 1, 170),(1536, 'U21', 'U', 21, 21, 48, 981, 661, 1, 171),(1536, 'W21', 'W', 23, 21, 48, 1077, 663, 1, 172),(1536, 'Y21', 'Y', 25, 21, 48, 1173, 665, 1, 173),(1536, 'AA21', 'AA', 27, 21, 48, 1269, 667, 1, 174),(1536, 'AC21', 'AC', 29, 21, 48, 1365, 669, 1, 175),(1536, 'AE21', 'AE', 31, 21, 48, 1461, 671, 1, 176),(1536, 'A23', 'A', 1, 23, 48, 23, 705, 1, 177),(1536, 'C23', 'C', 3, 23, 48, 119, 707, 1, 178),(1536, 'E23', 'E', 5, 23, 48, 215, 709, 1, 179),(1536, 'G23', 'G', 7, 23, 48, 311, 711, 1, 180),(1536, 'I23', 'I', 9, 23, 48, 407, 713, 1, 181),(1536, 'K23', 'K', 11, 23, 48, 503, 715, 1, 182),(1536, 'M23', 'M', 13, 23, 48, 599, 717, 1, 183),(1536, 'O23', 'O', 15, 23, 48, 695, 719, 1, 184),(1536, 'Q23', 'Q', 17, 23, 48, 791, 721, 1, 185),(1536, 'S23', 'S', 19, 23, 48, 887, 723, 1, 186),(1536, 'U23', 'U', 21, 23, 48, 983, 725, 1, 187),(1536, 'W23', 'W', 23, 23, 48, 1079, 727, 1, 188),(1536, 'Y23', 'Y', 25, 23, 48, 1175, 729, 1, 189),(1536, 'AA23', 'AA', 27, 23, 48, 1271, 731, 1, 190),(1536, 'AC23', 'AC', 29, 23, 48, 1367, 733, 1, 191),(1536, 'AE23', 'AE', 31, 23, 48, 1463, 735, 1, 192),(1536, 'A25', 'A', 1, 25, 48, 25, 769, 1, 193),(1536, 'C25', 'C', 3, 25, 48, 121, 771, 1, 194),(1536, 'E25', 'E', 5, 25, 48, 217, 773, 1, 195),(1536, 'G25', 'G', 7, 25, 48, 313, 775, 1, 196),(1536, 'I25', 'I', 9, 25, 48, 409, 777, 1, 197),(1536, 'K25', 'K', 11, 25, 48, 505, 779, 1, 198),(1536, 'M25', 'M', 13, 25, 48, 601, 781, 1, 199),(1536, 'O25', 'O', 15, 25, 48, 697, 783, 1, 200),(1536, 'Q25', 'Q', 17, 25, 48, 793, 785, 1, 201),(1536, 'S25', 'S', 19, 25, 48, 889, 787, 1, 202),(1536, 'U25', 'U', 21, 25, 48, 985, 789, 1, 203),(1536, 'W25', 'W', 23, 25, 48, 1081, 791, 1, 204),(1536, 'Y25', 'Y', 25, 25, 48, 1177, 793, 1, 205),(1536, 'AA25', 'AA', 27, 25, 48, 1273, 795, 1, 206),(1536, 'AC25', 'AC', 29, 25, 48, 1369, 797, 1, 207),(1536, 'AE25', 'AE', 31, 25, 48, 1465, 799, 1, 208),(1536, 'A27', 'A', 1, 27, 48, 27, 833, 1, 209),(1536, 'C27', 'C', 3, 27, 48, 123, 835, 1, 210),(1536, 'E27', 'E', 5, 27, 48, 219, 837, 1, 211),(1536, 'G27', 'G', 7, 27, 48, 315, 839, 1, 212),(1536, 'I27', 'I', 9, 27, 48, 411, 841, 1, 213),(1536, 'K27', 'K', 11, 27, 48, 507, 843, 1, 214),(1536, 'M27', 'M', 13, 27, 48, 603, 845, 1, 215),(1536, 'O27', 'O', 15, 27, 48, 699, 847, 1, 216),(1536, 'Q27', 'Q', 17, 27, 48, 795, 849, 1, 217),(1536, 'S27', 'S', 19, 27, 48, 891, 851, 1, 218),(1536, 'U27', 'U', 21, 27, 48, 987, 853, 1, 219),(1536, 'W27', 'W', 23, 27, 48, 1083, 855, 1, 220),(1536, 'Y27', 'Y', 25, 27, 48, 1179, 857, 1, 221),(1536, 'AA27', 'AA', 27, 27, 48, 1275, 859, 1, 222),(1536, 'AC27', 'AC', 29, 27, 48, 1371, 861, 1, 223),(1536, 'AE27', 'AE', 31, 27, 48, 1467, 863, 1, 224),(1536, 'A29', 'A', 1, 29, 48, 29, 897, 1, 225),(1536, 'C29', 'C', 3, 29, 48, 125, 899, 1, 226),(1536, 'E29', 'E', 5, 29, 48, 221, 901, 1, 227),(1536, 'G29', 'G', 7, 29, 48, 317, 903, 1, 228),(1536, 'I29', 'I', 9, 29, 48, 413, 905, 1, 229),(1536, 'K29', 'K', 11, 29, 48, 509, 907, 1, 230),(1536, 'M29', 'M', 13, 29, 48, 605, 909, 1, 231),(1536, 'O29', 'O', 15, 29, 48, 701, 911, 1, 232),(1536, 'Q29', 'Q', 17, 29, 48, 797, 913, 1, 233),(1536, 'S29', 'S', 19, 29, 48, 893, 915, 1, 234),(1536, 'U29', 'U', 21, 29, 48, 989, 917, 1, 235),(1536, 'W29', 'W', 23, 29, 48, 1085, 919, 1, 236),(1536, 'Y29', 'Y', 25, 29, 48, 1181, 921, 1, 237),(1536, 'AA29', 'AA', 27, 29, 48, 1277, 923, 1, 238),(1536, 'AC29', 'AC', 29, 29, 48, 1373, 925, 1, 239),(1536, 'AE29', 'AE', 31, 29, 48, 1469, 927, 1, 240),(1536, 'A31', 'A', 1, 31, 48, 31, 961, 1, 241),(1536, 'C31', 'C', 3, 31, 48, 127, 963, 1, 242),(1536, 'E31', 'E', 5, 31, 48, 223, 965, 1, 243),(1536, 'G31', 'G', 7, 31, 48, 319, 967, 1, 244),(1536, 'I31', 'I', 9, 31, 48, 415, 969, 1, 245),(1536, 'K31', 'K', 11, 31, 48, 511, 971, 1, 246),(1536, 'M31', 'M', 13, 31, 48, 607, 973, 1, 247),(1536, 'O31', 'O', 15, 31, 48, 703, 975, 1, 248),(1536, 'Q31', 'Q', 17, 31, 48, 799, 977, 1, 249),(1536, 'S31', 'S', 19, 31, 48, 895, 979, 1, 250),(1536, 'U31', 'U', 21, 31, 48, 991, 981, 1, 251),(1536, 'W31', 'W', 23, 31, 48, 1087, 983, 1, 252),(1536, 'Y31', 'Y', 25, 31, 48, 1183, 985, 1, 253),(1536, 'AA31', 'AA', 27, 31, 48, 1279, 987, 1, 254),(1536, 'AC31', 'AC', 29, 31, 48, 1375, 989, 1, 255),(1536, 'AE31', 'AE', 31, 31, 48, 1471, 991, 1, 256),(1536, 'A33', 'A', 1, 33, 48, 33, 1025, 1, 257),(1536, 'C33', 'C', 3, 33, 48, 129, 1027, 1, 258),(1536, 'E33', 'E', 5, 33, 48, 225, 1029, 1, 259),(1536, 'G33', 'G', 7, 33, 48, 321, 1031, 1, 260),(1536, 'I33', 'I', 9, 33, 48, 417, 1033, 1, 261),(1536, 'K33', 'K', 11, 33, 48, 513, 1035, 1, 262),(1536, 'M33', 'M', 13, 33, 48, 609, 1037, 1, 263),(1536, 'O33', 'O', 15, 33, 48, 705, 1039, 1, 264),(1536, 'Q33', 'Q', 17, 33, 48, 801, 1041, 1, 265),(1536, 'S33', 'S', 19, 33, 48, 897, 1043, 1, 266),(1536, 'U33', 'U', 21, 33, 48, 993, 1045, 1, 267),(1536, 'W33', 'W', 23, 33, 48, 1089, 1047, 1, 268),(1536, 'Y33', 'Y', 25, 33, 48, 1185, 1049, 1, 269),(1536, 'AA33', 'AA', 27, 33, 48, 1281, 1051, 1, 270),(1536, 'AC33', 'AC', 29, 33, 48, 1377, 1053, 1, 271),(1536, 'AE33', 'AE', 31, 33, 48, 1473, 1055, 1, 272),(1536, 'A35', 'A', 1, 35, 48, 35, 1089, 1, 273),(1536, 'C35', 'C', 3, 35, 48, 131, 1091, 1, 274),(1536, 'E35', 'E', 5, 35, 48, 227, 1093, 1, 275),(1536, 'G35', 'G', 7, 35, 48, 323, 1095, 1, 276),(1536, 'I35', 'I', 9, 35, 48, 419, 1097, 1, 277),(1536, 'K35', 'K', 11, 35, 48, 515, 1099, 1, 278),(1536, 'M35', 'M', 13, 35, 48, 611, 1101, 1, 279),(1536, 'O35', 'O', 15, 35, 48, 707, 1103, 1, 280),(1536, 'Q35', 'Q', 17, 35, 48, 803, 1105, 1, 281),(1536, 'S35', 'S', 19, 35, 48, 899, 1107, 1, 282),(1536, 'U35', 'U', 21, 35, 48, 995, 1109, 1, 283),(1536, 'W35', 'W', 23, 35, 48, 1091, 1111, 1, 284),(1536, 'Y35', 'Y', 25, 35, 48, 1187, 1113, 1, 285),(1536, 'AA35', 'AA', 27, 35, 48, 1283, 1115, 1, 286),(1536, 'AC35', 'AC', 29, 35, 48, 1379, 1117, 1, 287),(1536, 'AE35', 'AE', 31, 35, 48, 1475, 1119, 1, 288),(1536, 'A37', 'A', 1, 37, 48, 37, 1153, 1, 289),(1536, 'C37', 'C', 3, 37, 48, 133, 1155, 1, 290),(1536, 'E37', 'E', 5, 37, 48, 229, 1157, 1, 291),(1536, 'G37', 'G', 7, 37, 48, 325, 1159, 1, 292),(1536, 'I37', 'I', 9, 37, 48, 421, 1161, 1, 293),(1536, 'K37', 'K', 11, 37, 48, 517, 1163, 1, 294),(1536, 'M37', 'M', 13, 37, 48, 613, 1165, 1, 295),(1536, 'O37', 'O', 15, 37, 48, 709, 1167, 1, 296),(1536, 'Q37', 'Q', 17, 37, 48, 805, 1169, 1, 297),(1536, 'S37', 'S', 19, 37, 48, 901, 1171, 1, 298),(1536, 'U37', 'U', 21, 37, 48, 997, 1173, 1, 299),(1536, 'W37', 'W', 23, 37, 48, 1093, 1175, 1, 300),(1536, 'Y37', 'Y', 25, 37, 48, 1189, 1177, 1, 301),(1536, 'AA37', 'AA', 27, 37, 48, 1285, 1179, 1, 302),(1536, 'AC37', 'AC', 29, 37, 48, 1381, 1181, 1, 303),(1536, 'AE37', 'AE', 31, 37, 48, 1477, 1183, 1, 304),(1536, 'A39', 'A', 1, 39, 48, 39, 1217, 1, 305),(1536, 'C39', 'C', 3, 39, 48, 135, 1219, 1, 306),(1536, 'E39', 'E', 5, 39, 48, 231, 1221, 1, 307),(1536, 'G39', 'G', 7, 39, 48, 327, 1223, 1, 308),(1536, 'I39', 'I', 9, 39, 48, 423, 1225, 1, 309),(1536, 'K39', 'K', 11, 39, 48, 519, 1227, 1, 310),(1536, 'M39', 'M', 13, 39, 48, 615, 1229, 1, 311),(1536, 'O39', 'O', 15, 39, 48, 711, 1231, 1, 312),(1536, 'Q39', 'Q', 17, 39, 48, 807, 1233, 1, 313),(1536, 'S39', 'S', 19, 39, 48, 903, 1235, 1, 314),(1536, 'U39', 'U', 21, 39, 48, 999, 1237, 1, 315),(1536, 'W39', 'W', 23, 39, 48, 1095, 1239, 1, 316),(1536, 'Y39', 'Y', 25, 39, 48, 1191, 1241, 1, 317),(1536, 'AA39', 'AA', 27, 39, 48, 1287, 1243, 1, 318),(1536, 'AC39', 'AC', 29, 39, 48, 1383, 1245, 1, 319),(1536, 'AE39', 'AE', 31, 39, 48, 1479, 1247, 1, 320),(1536, 'A41', 'A', 1, 41, 48, 41, 1281, 1, 321),(1536, 'C41', 'C', 3, 41, 48, 137, 1283, 1, 322),(1536, 'E41', 'E', 5, 41, 48, 233, 1285, 1, 323),(1536, 'G41', 'G', 7, 41, 48, 329, 1287, 1, 324),(1536, 'I41', 'I', 9, 41, 48, 425, 1289, 1, 325),(1536, 'K41', 'K', 11, 41, 48, 521, 1291, 1, 326),(1536, 'M41', 'M', 13, 41, 48, 617, 1293, 1, 327),(1536, 'O41', 'O', 15, 41, 48, 713, 1295, 1, 328),(1536, 'Q41', 'Q', 17, 41, 48, 809, 1297, 1, 329),(1536, 'S41', 'S', 19, 41, 48, 905, 1299, 1, 330),(1536, 'U41', 'U', 21, 41, 48, 1001, 1301, 1, 331),(1536, 'W41', 'W', 23, 41, 48, 1097, 1303, 1, 332),(1536, 'Y41', 'Y', 25, 41, 48, 1193, 1305, 1, 333),(1536, 'AA41', 'AA', 27, 41, 48, 1289, 1307, 1, 334),(1536, 'AC41', 'AC', 29, 41, 48, 1385, 1309, 1, 335),(1536, 'AE41', 'AE', 31, 41, 48, 1481, 1311, 1, 336),(1536, 'A43', 'A', 1, 43, 48, 43, 1345, 1, 337),(1536, 'C43', 'C', 3, 43, 48, 139, 1347, 1, 338),(1536, 'E43', 'E', 5, 43, 48, 235, 1349, 1, 339),(1536, 'G43', 'G', 7, 43, 48, 331, 1351, 1, 340),(1536, 'I43', 'I', 9, 43, 48, 427, 1353, 1, 341),(1536, 'K43', 'K', 11, 43, 48, 523, 1355, 1, 342),(1536, 'M43', 'M', 13, 43, 48, 619, 1357, 1, 343),(1536, 'O43', 'O', 15, 43, 48, 715, 1359, 1, 344),(1536, 'Q43', 'Q', 17, 43, 48, 811, 1361, 1, 345),(1536, 'S43', 'S', 19, 43, 48, 907, 1363, 1, 346),(1536, 'U43', 'U', 21, 43, 48, 1003, 1365, 1, 347),(1536, 'W43', 'W', 23, 43, 48, 1099, 1367, 1, 348),(1536, 'Y43', 'Y', 25, 43, 48, 1195, 1369, 1, 349),(1536, 'AA43', 'AA', 27, 43, 48, 1291, 1371, 1, 350),(1536, 'AC43', 'AC', 29, 43, 48, 1387, 1373, 1, 351),(1536, 'AE43', 'AE', 31, 43, 48, 1483, 1375, 1, 352),(1536, 'A45', 'A', 1, 45, 48, 45, 1409, 1, 353),(1536, 'C45', 'C', 3, 45, 48, 141, 1411, 1, 354),(1536, 'E45', 'E', 5, 45, 48, 237, 1413, 1, 355),(1536, 'G45', 'G', 7, 45, 48, 333, 1415, 1, 356),(1536, 'I45', 'I', 9, 45, 48, 429, 1417, 1, 357),(1536, 'K45', 'K', 11, 45, 48, 525, 1419, 1, 358),(1536, 'M45', 'M', 13, 45, 48, 621, 1421, 1, 359),(1536, 'O45', 'O', 15, 45, 48, 717, 1423, 1, 360),(1536, 'Q45', 'Q', 17, 45, 48, 813, 1425, 1, 361),(1536, 'S45', 'S', 19, 45, 48, 909, 1427, 1, 362),(1536, 'U45', 'U', 21, 45, 48, 1005, 1429, 1, 363),(1536, 'W45', 'W', 23, 45, 48, 1101, 1431, 1, 364),(1536, 'Y45', 'Y', 25, 45, 48, 1197, 1433, 1, 365),(1536, 'AA45', 'AA', 27, 45, 48, 1293, 1435, 1, 366),(1536, 'AC45', 'AC', 29, 45, 48, 1389, 1437, 1, 367),(1536, 'AE45', 'AE', 31, 45, 48, 1485, 1439, 1, 368),(1536, 'A47', 'A', 1, 47, 48, 47, 1473, 1, 369),(1536, 'C47', 'C', 3, 47, 48, 143, 1475, 1, 370),(1536, 'E47', 'E', 5, 47, 48, 239, 1477, 1, 371),(1536, 'G47', 'G', 7, 47, 48, 335, 1479, 1, 372),(1536, 'I47', 'I', 9, 47, 48, 431, 1481, 1, 373),(1536, 'K47', 'K', 11, 47, 48, 527, 1483, 1, 374),(1536, 'M47', 'M', 13, 47, 48, 623, 1485, 1, 375),(1536, 'O47', 'O', 15, 47, 48, 719, 1487, 1, 376),(1536, 'Q47', 'Q', 17, 47, 48, 815, 1489, 1, 377),(1536, 'S47', 'S', 19, 47, 48, 911, 1491, 1, 378),(1536, 'U47', 'U', 21, 47, 48, 1007, 1493, 1, 379),(1536, 'W47', 'W', 23, 47, 48, 1103, 1495, 1, 380),(1536, 'Y47', 'Y', 25, 47, 48, 1199, 1497, 1, 381),(1536, 'AA47', 'AA', 27, 47, 48, 1295, 1499, 1, 382),(1536, 'AC47', 'AC', 29, 47, 48, 1391, 1501, 1, 383),(1536, 'AE47', 'AE', 31, 47, 48, 1487, 1503, 1, 384),(1536, 'A02', 'A', 1, 2, 48, 2, 33, 2, 1),(1536, 'C02', 'C', 3, 2, 48, 98, 35, 2, 2),(1536, 'E02', 'E', 5, 2, 48, 194, 37, 2, 3),(1536, 'G02', 'G', 7, 2, 48, 290, 39, 2, 4),(1536, 'I02', 'I', 9, 2, 48, 386, 41, 2, 5),(1536, 'K02', 'K', 11, 2, 48, 482, 43, 2, 6),(1536, 'M02', 'M', 13, 2, 48, 578, 45, 2, 7),(1536, 'O02', 'O', 15, 2, 48, 674, 47, 2, 8),(1536, 'Q02', 'Q', 17, 2, 48, 770, 49, 2, 9),(1536, 'S02', 'S', 19, 2, 48, 866, 51, 2, 10),(1536, 'U02', 'U', 21, 2, 48, 962, 53, 2, 11),(1536, 'W02', 'W', 23, 2, 48, 1058, 55, 2, 12),(1536, 'Y02', 'Y', 25, 2, 48, 1154, 57, 2, 13),(1536, 'AA02', 'AA', 27, 2, 48, 1250, 59, 2, 14),(1536, 'AC02', 'AC', 29, 2, 48, 1346, 61, 2, 15),(1536, 'AE02', 'AE', 31, 2, 48, 1442, 63, 2, 16),(1536, 'A04', 'A', 1, 4, 48, 4, 97, 2, 17),(1536, 'C04', 'C', 3, 4, 48, 100, 99, 2, 18),(1536, 'E04', 'E', 5, 4, 48, 196, 101, 2, 19),(1536, 'G04', 'G', 7, 4, 48, 292, 103, 2, 20),(1536, 'I04', 'I', 9, 4, 48, 388, 105, 2, 21),(1536, 'K04', 'K', 11, 4, 48, 484, 107, 2, 22),(1536, 'M04', 'M', 13, 4, 48, 580, 109, 2, 23),(1536, 'O04', 'O', 15, 4, 48, 676, 111, 2, 24),(1536, 'Q04', 'Q', 17, 4, 48, 772, 113, 2, 25),(1536, 'S04', 'S', 19, 4, 48, 868, 115, 2, 26),(1536, 'U04', 'U', 21, 4, 48, 964, 117, 2, 27),(1536, 'W04', 'W', 23, 4, 48, 1060, 119, 2, 28),(1536, 'Y04', 'Y', 25, 4, 48, 1156, 121, 2, 29),(1536, 'AA04', 'AA', 27, 4, 48, 1252, 123, 2, 30),(1536, 'AC04', 'AC', 29, 4, 48, 1348, 125, 2, 31),(1536, 'AE04', 'AE', 31, 4, 48, 1444, 127, 2, 32),(1536, 'A06', 'A', 1, 6, 48, 6, 161, 2, 33),(1536, 'C06', 'C', 3, 6, 48, 102, 163, 2, 34),(1536, 'E06', 'E', 5, 6, 48, 198, 165, 2, 35),(1536, 'G06', 'G', 7, 6, 48, 294, 167, 2, 36),(1536, 'I06', 'I', 9, 6, 48, 390, 169, 2, 37),(1536, 'K06', 'K', 11, 6, 48, 486, 171, 2, 38),(1536, 'M06', 'M', 13, 6, 48, 582, 173, 2, 39),(1536, 'O06', 'O', 15, 6, 48, 678, 175, 2, 40),(1536, 'Q06', 'Q', 17, 6, 48, 774, 177, 2, 41),(1536, 'S06', 'S', 19, 6, 48, 870, 179, 2, 42),(1536, 'U06', 'U', 21, 6, 48, 966, 181, 2, 43),(1536, 'W06', 'W', 23, 6, 48, 1062, 183, 2, 44),(1536, 'Y06', 'Y', 25, 6, 48, 1158, 185, 2, 45),(1536, 'AA06', 'AA', 27, 6, 48, 1254, 187, 2, 46),(1536, 'AC06', 'AC', 29, 6, 48, 1350, 189, 2, 47),(1536, 'AE06', 'AE', 31, 6, 48, 1446, 191, 2, 48),(1536, 'A08', 'A', 1, 8, 48, 8, 225, 2, 49),(1536, 'C08', 'C', 3, 8, 48, 104, 227, 2, 50),(1536, 'E08', 'E', 5, 8, 48, 200, 229, 2, 51),(1536, 'G08', 'G', 7, 8, 48, 296, 231, 2, 52),(1536, 'I08', 'I', 9, 8, 48, 392, 233, 2, 53),(1536, 'K08', 'K', 11, 8, 48, 488, 235, 2, 54),(1536, 'M08', 'M', 13, 8, 48, 584, 237, 2, 55),(1536, 'O08', 'O', 15, 8, 48, 680, 239, 2, 56),(1536, 'Q08', 'Q', 17, 8, 48, 776, 241, 2, 57),(1536, 'S08', 'S', 19, 8, 48, 872, 243, 2, 58),(1536, 'U08', 'U', 21, 8, 48, 968, 245, 2, 59),(1536, 'W08', 'W', 23, 8, 48, 1064, 247, 2, 60),(1536, 'Y08', 'Y', 25, 8, 48, 1160, 249, 2, 61),(1536, 'AA08', 'AA', 27, 8, 48, 1256, 251, 2, 62),(1536, 'AC08', 'AC', 29, 8, 48, 1352, 253, 2, 63),(1536, 'AE08', 'AE', 31, 8, 48, 1448, 255, 2, 64),(1536, 'A10', 'A', 1, 10, 48, 10, 289, 2, 65),(1536, 'C10', 'C', 3, 10, 48, 106, 291, 2, 66),(1536, 'E10', 'E', 5, 10, 48, 202, 293, 2, 67),(1536, 'G10', 'G', 7, 10, 48, 298, 295, 2, 68),(1536, 'I10', 'I', 9, 10, 48, 394, 297, 2, 69),(1536, 'K10', 'K', 11, 10, 48, 490, 299, 2, 70),(1536, 'M10', 'M', 13, 10, 48, 586, 301, 2, 71),(1536, 'O10', 'O', 15, 10, 48, 682, 303, 2, 72),(1536, 'Q10', 'Q', 17, 10, 48, 778, 305, 2, 73),(1536, 'S10', 'S', 19, 10, 48, 874, 307, 2, 74),(1536, 'U10', 'U', 21, 10, 48, 970, 309, 2, 75),(1536, 'W10', 'W', 23, 10, 48, 1066, 311, 2, 76),(1536, 'Y10', 'Y', 25, 10, 48, 1162, 313, 2, 77),(1536, 'AA10', 'AA', 27, 10, 48, 1258, 315, 2, 78),(1536, 'AC10', 'AC', 29, 10, 48, 1354, 317, 2, 79),(1536, 'AE10', 'AE', 31, 10, 48, 1450, 319, 2, 80),(1536, 'A12', 'A', 1, 12, 48, 12, 353, 2, 81),(1536, 'C12', 'C', 3, 12, 48, 108, 355, 2, 82),(1536, 'E12', 'E', 5, 12, 48, 204, 357, 2, 83),(1536, 'G12', 'G', 7, 12, 48, 300, 359, 2, 84),(1536, 'I12', 'I', 9, 12, 48, 396, 361, 2, 85),(1536, 'K12', 'K', 11, 12, 48, 492, 363, 2, 86),(1536, 'M12', 'M', 13, 12, 48, 588, 365, 2, 87),(1536, 'O12', 'O', 15, 12, 48, 684, 367, 2, 88),(1536, 'Q12', 'Q', 17, 12, 48, 780, 369, 2, 89),(1536, 'S12', 'S', 19, 12, 48, 876, 371, 2, 90),(1536, 'U12', 'U', 21, 12, 48, 972, 373, 2, 91),(1536, 'W12', 'W', 23, 12, 48, 1068, 375, 2, 92),(1536, 'Y12', 'Y', 25, 12, 48, 1164, 377, 2, 93),(1536, 'AA12', 'AA', 27, 12, 48, 1260, 379, 2, 94),(1536, 'AC12', 'AC', 29, 12, 48, 1356, 381, 2, 95),(1536, 'AE12', 'AE', 31, 12, 48, 1452, 383, 2, 96),(1536, 'A14', 'A', 1, 14, 48, 14, 417, 2, 97),(1536, 'C14', 'C', 3, 14, 48, 110, 419, 2, 98),(1536, 'E14', 'E', 5, 14, 48, 206, 421, 2, 99),(1536, 'G14', 'G', 7, 14, 48, 302, 423, 2, 100),(1536, 'I14', 'I', 9, 14, 48, 398, 425, 2, 101),(1536, 'K14', 'K', 11, 14, 48, 494, 427, 2, 102),(1536, 'M14', 'M', 13, 14, 48, 590, 429, 2, 103),(1536, 'O14', 'O', 15, 14, 48, 686, 431, 2, 104),(1536, 'Q14', 'Q', 17, 14, 48, 782, 433, 2, 105),(1536, 'S14', 'S', 19, 14, 48, 878, 435, 2, 106),(1536, 'U14', 'U', 21, 14, 48, 974, 437, 2, 107),(1536, 'W14', 'W', 23, 14, 48, 1070, 439, 2, 108),(1536, 'Y14', 'Y', 25, 14, 48, 1166, 441, 2, 109),(1536, 'AA14', 'AA', 27, 14, 48, 1262, 443, 2, 110),(1536, 'AC14', 'AC', 29, 14, 48, 1358, 445, 2, 111),(1536, 'AE14', 'AE', 31, 14, 48, 1454, 447, 2, 112),(1536, 'A16', 'A', 1, 16, 48, 16, 481, 2, 113),(1536, 'C16', 'C', 3, 16, 48, 112, 483, 2, 114),(1536, 'E16', 'E', 5, 16, 48, 208, 485, 2, 115),(1536, 'G16', 'G', 7, 16, 48, 304, 487, 2, 116),(1536, 'I16', 'I', 9, 16, 48, 400, 489, 2, 117),(1536, 'K16', 'K', 11, 16, 48, 496, 491, 2, 118),(1536, 'M16', 'M', 13, 16, 48, 592, 493, 2, 119),(1536, 'O16', 'O', 15, 16, 48, 688, 495, 2, 120),(1536, 'Q16', 'Q', 17, 16, 48, 784, 497, 2, 121),(1536, 'S16', 'S', 19, 16, 48, 880, 499, 2, 122),(1536, 'U16', 'U', 21, 16, 48, 976, 501, 2, 123),(1536, 'W16', 'W', 23, 16, 48, 1072, 503, 2, 124),(1536, 'Y16', 'Y', 25, 16, 48, 1168, 505, 2, 125),(1536, 'AA16', 'AA', 27, 16, 48, 1264, 507, 2, 126),(1536, 'AC16', 'AC', 29, 16, 48, 1360, 509, 2, 127),(1536, 'AE16', 'AE', 31, 16, 48, 1456, 511, 2, 128),(1536, 'A18', 'A', 1, 18, 48, 18, 545, 2, 129),(1536, 'C18', 'C', 3, 18, 48, 114, 547, 2, 130),(1536, 'E18', 'E', 5, 18, 48, 210, 549, 2, 131),(1536, 'G18', 'G', 7, 18, 48, 306, 551, 2, 132),(1536, 'I18', 'I', 9, 18, 48, 402, 553, 2, 133),(1536, 'K18', 'K', 11, 18, 48, 498, 555, 2, 134),(1536, 'M18', 'M', 13, 18, 48, 594, 557, 2, 135),(1536, 'O18', 'O', 15, 18, 48, 690, 559, 2, 136),(1536, 'Q18', 'Q', 17, 18, 48, 786, 561, 2, 137),(1536, 'S18', 'S', 19, 18, 48, 882, 563, 2, 138),(1536, 'U18', 'U', 21, 18, 48, 978, 565, 2, 139),(1536, 'W18', 'W', 23, 18, 48, 1074, 567, 2, 140),(1536, 'Y18', 'Y', 25, 18, 48, 1170, 569, 2, 141),(1536, 'AA18', 'AA', 27, 18, 48, 1266, 571, 2, 142),(1536, 'AC18', 'AC', 29, 18, 48, 1362, 573, 2, 143),(1536, 'AE18', 'AE', 31, 18, 48, 1458, 575, 2, 144),(1536, 'A20', 'A', 1, 20, 48, 20, 609, 2, 145),(1536, 'C20', 'C', 3, 20, 48, 116, 611, 2, 146),(1536, 'E20', 'E', 5, 20, 48, 212, 613, 2, 147),(1536, 'G20', 'G', 7, 20, 48, 308, 615, 2, 148),(1536, 'I20', 'I', 9, 20, 48, 404, 617, 2, 149),(1536, 'K20', 'K', 11, 20, 48, 500, 619, 2, 150),(1536, 'M20', 'M', 13, 20, 48, 596, 621, 2, 151),(1536, 'O20', 'O', 15, 20, 48, 692, 623, 2, 152),(1536, 'Q20', 'Q', 17, 20, 48, 788, 625, 2, 153),(1536, 'S20', 'S', 19, 20, 48, 884, 627, 2, 154),(1536, 'U20', 'U', 21, 20, 48, 980, 629, 2, 155),(1536, 'W20', 'W', 23, 20, 48, 1076, 631, 2, 156),(1536, 'Y20', 'Y', 25, 20, 48, 1172, 633, 2, 157),(1536, 'AA20', 'AA', 27, 20, 48, 1268, 635, 2, 158),(1536, 'AC20', 'AC', 29, 20, 48, 1364, 637, 2, 159),(1536, 'AE20', 'AE', 31, 20, 48, 1460, 639, 2, 160),(1536, 'A22', 'A', 1, 22, 48, 22, 673, 2, 161),(1536, 'C22', 'C', 3, 22, 48, 118, 675, 2, 162),(1536, 'E22', 'E', 5, 22, 48, 214, 677, 2, 163),(1536, 'G22', 'G', 7, 22, 48, 310, 679, 2, 164),(1536, 'I22', 'I', 9, 22, 48, 406, 681, 2, 165),(1536, 'K22', 'K', 11, 22, 48, 502, 683, 2, 166),(1536, 'M22', 'M', 13, 22, 48, 598, 685, 2, 167),(1536, 'O22', 'O', 15, 22, 48, 694, 687, 2, 168),(1536, 'Q22', 'Q', 17, 22, 48, 790, 689, 2, 169),(1536, 'S22', 'S', 19, 22, 48, 886, 691, 2, 170),(1536, 'U22', 'U', 21, 22, 48, 982, 693, 2, 171),(1536, 'W22', 'W', 23, 22, 48, 1078, 695, 2, 172),(1536, 'Y22', 'Y', 25, 22, 48, 1174, 697, 2, 173),(1536, 'AA22', 'AA', 27, 22, 48, 1270, 699, 2, 174),(1536, 'AC22', 'AC', 29, 22, 48, 1366, 701, 2, 175),(1536, 'AE22', 'AE', 31, 22, 48, 1462, 703, 2, 176),(1536, 'A24', 'A', 1, 24, 48, 24, 737, 2, 177),(1536, 'C24', 'C', 3, 24, 48, 120, 739, 2, 178),(1536, 'E24', 'E', 5, 24, 48, 216, 741, 2, 179),(1536, 'G24', 'G', 7, 24, 48, 312, 743, 2, 180),(1536, 'I24', 'I', 9, 24, 48, 408, 745, 2, 181),(1536, 'K24', 'K', 11, 24, 48, 504, 747, 2, 182),(1536, 'M24', 'M', 13, 24, 48, 600, 749, 2, 183),(1536, 'O24', 'O', 15, 24, 48, 696, 751, 2, 184),(1536, 'Q24', 'Q', 17, 24, 48, 792, 753, 2, 185),(1536, 'S24', 'S', 19, 24, 48, 888, 755, 2, 186),(1536, 'U24', 'U', 21, 24, 48, 984, 757, 2, 187),(1536, 'W24', 'W', 23, 24, 48, 1080, 759, 2, 188),(1536, 'Y24', 'Y', 25, 24, 48, 1176, 761, 2, 189),(1536, 'AA24', 'AA', 27, 24, 48, 1272, 763, 2, 190),(1536, 'AC24', 'AC', 29, 24, 48, 1368, 765, 2, 191),(1536, 'AE24', 'AE', 31, 24, 48, 1464, 767, 2, 192),(1536, 'A26', 'A', 1, 26, 48, 26, 801, 2, 193),(1536, 'C26', 'C', 3, 26, 48, 122, 803, 2, 194),(1536, 'E26', 'E', 5, 26, 48, 218, 805, 2, 195),(1536, 'G26', 'G', 7, 26, 48, 314, 807, 2, 196),(1536, 'I26', 'I', 9, 26, 48, 410, 809, 2, 197),(1536, 'K26', 'K', 11, 26, 48, 506, 811, 2, 198),(1536, 'M26', 'M', 13, 26, 48, 602, 813, 2, 199),(1536, 'O26', 'O', 15, 26, 48, 698, 815, 2, 200),(1536, 'Q26', 'Q', 17, 26, 48, 794, 817, 2, 201),(1536, 'S26', 'S', 19, 26, 48, 890, 819, 2, 202),(1536, 'U26', 'U', 21, 26, 48, 986, 821, 2, 203),(1536, 'W26', 'W', 23, 26, 48, 1082, 823, 2, 204),(1536, 'Y26', 'Y', 25, 26, 48, 1178, 825, 2, 205),(1536, 'AA26', 'AA', 27, 26, 48, 1274, 827, 2, 206),(1536, 'AC26', 'AC', 29, 26, 48, 1370, 829, 2, 207),(1536, 'AE26', 'AE', 31, 26, 48, 1466, 831, 2, 208),(1536, 'A28', 'A', 1, 28, 48, 28, 865, 2, 209),(1536, 'C28', 'C', 3, 28, 48, 124, 867, 2, 210),(1536, 'E28', 'E', 5, 28, 48, 220, 869, 2, 211),(1536, 'G28', 'G', 7, 28, 48, 316, 871, 2, 212),(1536, 'I28', 'I', 9, 28, 48, 412, 873, 2, 213),(1536, 'K28', 'K', 11, 28, 48, 508, 875, 2, 214),(1536, 'M28', 'M', 13, 28, 48, 604, 877, 2, 215),(1536, 'O28', 'O', 15, 28, 48, 700, 879, 2, 216),(1536, 'Q28', 'Q', 17, 28, 48, 796, 881, 2, 217),(1536, 'S28', 'S', 19, 28, 48, 892, 883, 2, 218),(1536, 'U28', 'U', 21, 28, 48, 988, 885, 2, 219),(1536, 'W28', 'W', 23, 28, 48, 1084, 887, 2, 220),(1536, 'Y28', 'Y', 25, 28, 48, 1180, 889, 2, 221),(1536, 'AA28', 'AA', 27, 28, 48, 1276, 891, 2, 222),(1536, 'AC28', 'AC', 29, 28, 48, 1372, 893, 2, 223),(1536, 'AE28', 'AE', 31, 28, 48, 1468, 895, 2, 224),(1536, 'A30', 'A', 1, 30, 48, 30, 929, 2, 225),(1536, 'C30', 'C', 3, 30, 48, 126, 931, 2, 226),(1536, 'E30', 'E', 5, 30, 48, 222, 933, 2, 227),(1536, 'G30', 'G', 7, 30, 48, 318, 935, 2, 228),(1536, 'I30', 'I', 9, 30, 48, 414, 937, 2, 229),(1536, 'K30', 'K', 11, 30, 48, 510, 939, 2, 230),(1536, 'M30', 'M', 13, 30, 48, 606, 941, 2, 231),(1536, 'O30', 'O', 15, 30, 48, 702, 943, 2, 232),(1536, 'Q30', 'Q', 17, 30, 48, 798, 945, 2, 233),(1536, 'S30', 'S', 19, 30, 48, 894, 947, 2, 234),(1536, 'U30', 'U', 21, 30, 48, 990, 949, 2, 235),(1536, 'W30', 'W', 23, 30, 48, 1086, 951, 2, 236),(1536, 'Y30', 'Y', 25, 30, 48, 1182, 953, 2, 237),(1536, 'AA30', 'AA', 27, 30, 48, 1278, 955, 2, 238),(1536, 'AC30', 'AC', 29, 30, 48, 1374, 957, 2, 239),(1536, 'AE30', 'AE', 31, 30, 48, 1470, 959, 2, 240),(1536, 'A32', 'A', 1, 32, 48, 32, 993, 2, 241),(1536, 'C32', 'C', 3, 32, 48, 128, 995, 2, 242),(1536, 'E32', 'E', 5, 32, 48, 224, 997, 2, 243),(1536, 'G32', 'G', 7, 32, 48, 320, 999, 2, 244),(1536, 'I32', 'I', 9, 32, 48, 416, 1001, 2, 245),(1536, 'K32', 'K', 11, 32, 48, 512, 1003, 2, 246),(1536, 'M32', 'M', 13, 32, 48, 608, 1005, 2, 247),(1536, 'O32', 'O', 15, 32, 48, 704, 1007, 2, 248),(1536, 'Q32', 'Q', 17, 32, 48, 800, 1009, 2, 249),(1536, 'S32', 'S', 19, 32, 48, 896, 1011, 2, 250),(1536, 'U32', 'U', 21, 32, 48, 992, 1013, 2, 251),(1536, 'W32', 'W', 23, 32, 48, 1088, 1015, 2, 252),(1536, 'Y32', 'Y', 25, 32, 48, 1184, 1017, 2, 253),(1536, 'AA32', 'AA', 27, 32, 48, 1280, 1019, 2, 254),(1536, 'AC32', 'AC', 29, 32, 48, 1376, 1021, 2, 255),(1536, 'AE32', 'AE', 31, 32, 48, 1472, 1023, 2, 256),(1536, 'A34', 'A', 1, 34, 48, 34, 1057, 2, 257),(1536, 'C34', 'C', 3, 34, 48, 130, 1059, 2, 258),(1536, 'E34', 'E', 5, 34, 48, 226, 1061, 2, 259),(1536, 'G34', 'G', 7, 34, 48, 322, 1063, 2, 260),(1536, 'I34', 'I', 9, 34, 48, 418, 1065, 2, 261),(1536, 'K34', 'K', 11, 34, 48, 514, 1067, 2, 262),(1536, 'M34', 'M', 13, 34, 48, 610, 1069, 2, 263),(1536, 'O34', 'O', 15, 34, 48, 706, 1071, 2, 264),(1536, 'Q34', 'Q', 17, 34, 48, 802, 1073, 2, 265),(1536, 'S34', 'S', 19, 34, 48, 898, 1075, 2, 266),(1536, 'U34', 'U', 21, 34, 48, 994, 1077, 2, 267),(1536, 'W34', 'W', 23, 34, 48, 1090, 1079, 2, 268),(1536, 'Y34', 'Y', 25, 34, 48, 1186, 1081, 2, 269),(1536, 'AA34', 'AA', 27, 34, 48, 1282, 1083, 2, 270),(1536, 'AC34', 'AC', 29, 34, 48, 1378, 1085, 2, 271),(1536, 'AE34', 'AE', 31, 34, 48, 1474, 1087, 2, 272),(1536, 'A36', 'A', 1, 36, 48, 36, 1121, 2, 273),(1536, 'C36', 'C', 3, 36, 48, 132, 1123, 2, 274),(1536, 'E36', 'E', 5, 36, 48, 228, 1125, 2, 275),(1536, 'G36', 'G', 7, 36, 48, 324, 1127, 2, 276),(1536, 'I36', 'I', 9, 36, 48, 420, 1129, 2, 277),(1536, 'K36', 'K', 11, 36, 48, 516, 1131, 2, 278),(1536, 'M36', 'M', 13, 36, 48, 612, 1133, 2, 279),(1536, 'O36', 'O', 15, 36, 48, 708, 1135, 2, 280),(1536, 'Q36', 'Q', 17, 36, 48, 804, 1137, 2, 281),(1536, 'S36', 'S', 19, 36, 48, 900, 1139, 2, 282),(1536, 'U36', 'U', 21, 36, 48, 996, 1141, 2, 283),(1536, 'W36', 'W', 23, 36, 48, 1092, 1143, 2, 284),(1536, 'Y36', 'Y', 25, 36, 48, 1188, 1145, 2, 285),(1536, 'AA36', 'AA', 27, 36, 48, 1284, 1147, 2, 286),(1536, 'AC36', 'AC', 29, 36, 48, 1380, 1149, 2, 287),(1536, 'AE36', 'AE', 31, 36, 48, 1476, 1151, 2, 288),(1536, 'A38', 'A', 1, 38, 48, 38, 1185, 2, 289),(1536, 'C38', 'C', 3, 38, 48, 134, 1187, 2, 290),(1536, 'E38', 'E', 5, 38, 48, 230, 1189, 2, 291),(1536, 'G38', 'G', 7, 38, 48, 326, 1191, 2, 292),(1536, 'I38', 'I', 9, 38, 48, 422, 1193, 2, 293),(1536, 'K38', 'K', 11, 38, 48, 518, 1195, 2, 294),(1536, 'M38', 'M', 13, 38, 48, 614, 1197, 2, 295),(1536, 'O38', 'O', 15, 38, 48, 710, 1199, 2, 296),(1536, 'Q38', 'Q', 17, 38, 48, 806, 1201, 2, 297),(1536, 'S38', 'S', 19, 38, 48, 902, 1203, 2, 298),(1536, 'U38', 'U', 21, 38, 48, 998, 1205, 2, 299),(1536, 'W38', 'W', 23, 38, 48, 1094, 1207, 2, 300),(1536, 'Y38', 'Y', 25, 38, 48, 1190, 1209, 2, 301),(1536, 'AA38', 'AA', 27, 38, 48, 1286, 1211, 2, 302),(1536, 'AC38', 'AC', 29, 38, 48, 1382, 1213, 2, 303),(1536, 'AE38', 'AE', 31, 38, 48, 1478, 1215, 2, 304),(1536, 'A40', 'A', 1, 40, 48, 40, 1249, 2, 305),(1536, 'C40', 'C', 3, 40, 48, 136, 1251, 2, 306),(1536, 'E40', 'E', 5, 40, 48, 232, 1253, 2, 307),(1536, 'G40', 'G', 7, 40, 48, 328, 1255, 2, 308),(1536, 'I40', 'I', 9, 40, 48, 424, 1257, 2, 309),(1536, 'K40', 'K', 11, 40, 48, 520, 1259, 2, 310),(1536, 'M40', 'M', 13, 40, 48, 616, 1261, 2, 311),(1536, 'O40', 'O', 15, 40, 48, 712, 1263, 2, 312),(1536, 'Q40', 'Q', 17, 40, 48, 808, 1265, 2, 313),(1536, 'S40', 'S', 19, 40, 48, 904, 1267, 2, 314),(1536, 'U40', 'U', 21, 40, 48, 1000, 1269, 2, 315),(1536, 'W40', 'W', 23, 40, 48, 1096, 1271, 2, 316),(1536, 'Y40', 'Y', 25, 40, 48, 1192, 1273, 2, 317),(1536, 'AA40', 'AA', 27, 40, 48, 1288, 1275, 2, 318),(1536, 'AC40', 'AC', 29, 40, 48, 1384, 1277, 2, 319),(1536, 'AE40', 'AE', 31, 40, 48, 1480, 1279, 2, 320),(1536, 'A42', 'A', 1, 42, 48, 42, 1313, 2, 321),(1536, 'C42', 'C', 3, 42, 48, 138, 1315, 2, 322),(1536, 'E42', 'E', 5, 42, 48, 234, 1317, 2, 323),(1536, 'G42', 'G', 7, 42, 48, 330, 1319, 2, 324),(1536, 'I42', 'I', 9, 42, 48, 426, 1321, 2, 325),(1536, 'K42', 'K', 11, 42, 48, 522, 1323, 2, 326),(1536, 'M42', 'M', 13, 42, 48, 618, 1325, 2, 327),(1536, 'O42', 'O', 15, 42, 48, 714, 1327, 2, 328),(1536, 'Q42', 'Q', 17, 42, 48, 810, 1329, 2, 329),(1536, 'S42', 'S', 19, 42, 48, 906, 1331, 2, 330),(1536, 'U42', 'U', 21, 42, 48, 1002, 1333, 2, 331),(1536, 'W42', 'W', 23, 42, 48, 1098, 1335, 2, 332),(1536, 'Y42', 'Y', 25, 42, 48, 1194, 1337, 2, 333),(1536, 'AA42', 'AA', 27, 42, 48, 1290, 1339, 2, 334),(1536, 'AC42', 'AC', 29, 42, 48, 1386, 1341, 2, 335),(1536, 'AE42', 'AE', 31, 42, 48, 1482, 1343, 2, 336),(1536, 'A44', 'A', 1, 44, 48, 44, 1377, 2, 337),(1536, 'C44', 'C', 3, 44, 48, 140, 1379, 2, 338),(1536, 'E44', 'E', 5, 44, 48, 236, 1381, 2, 339),(1536, 'G44', 'G', 7, 44, 48, 332, 1383, 2, 340),(1536, 'I44', 'I', 9, 44, 48, 428, 1385, 2, 341),(1536, 'K44', 'K', 11, 44, 48, 524, 1387, 2, 342),(1536, 'M44', 'M', 13, 44, 48, 620, 1389, 2, 343),(1536, 'O44', 'O', 15, 44, 48, 716, 1391, 2, 344),(1536, 'Q44', 'Q', 17, 44, 48, 812, 1393, 2, 345),(1536, 'S44', 'S', 19, 44, 48, 908, 1395, 2, 346),(1536, 'U44', 'U', 21, 44, 48, 1004, 1397, 2, 347),(1536, 'W44', 'W', 23, 44, 48, 1100, 1399, 2, 348),(1536, 'Y44', 'Y', 25, 44, 48, 1196, 1401, 2, 349),(1536, 'AA44', 'AA', 27, 44, 48, 1292, 1403, 2, 350),(1536, 'AC44', 'AC', 29, 44, 48, 1388, 1405, 2, 351),(1536, 'AE44', 'AE', 31, 44, 48, 1484, 1407, 2, 352),(1536, 'A46', 'A', 1, 46, 48, 46, 1441, 2, 353),(1536, 'C46', 'C', 3, 46, 48, 142, 1443, 2, 354),(1536, 'E46', 'E', 5, 46, 48, 238, 1445, 2, 355),(1536, 'G46', 'G', 7, 46, 48, 334, 1447, 2, 356),(1536, 'I46', 'I', 9, 46, 48, 430, 1449, 2, 357),(1536, 'K46', 'K', 11, 46, 48, 526, 1451, 2, 358),(1536, 'M46', 'M', 13, 46, 48, 622, 1453, 2, 359),(1536, 'O46', 'O', 15, 46, 48, 718, 1455, 2, 360),(1536, 'Q46', 'Q', 17, 46, 48, 814, 1457, 2, 361),(1536, 'S46', 'S', 19, 46, 48, 910, 1459, 2, 362),(1536, 'U46', 'U', 21, 46, 48, 1006, 1461, 2, 363),(1536, 'W46', 'W', 23, 46, 48, 1102, 1463, 2, 364),(1536, 'Y46', 'Y', 25, 46, 48, 1198, 1465, 2, 365),(1536, 'AA46', 'AA', 27, 46, 48, 1294, 1467, 2, 366),(1536, 'AC46', 'AC', 29, 46, 48, 1390, 1469, 2, 367),(1536, 'AE46', 'AE', 31, 46, 48, 1486, 1471, 2, 368),(1536, 'A48', 'A', 1, 48, 48, 48, 1505, 2, 369),(1536, 'C48', 'C', 3, 48, 48, 144, 1507, 2, 370),(1536, 'E48', 'E', 5, 48, 48, 240, 1509, 2, 371),(1536, 'G48', 'G', 7, 48, 48, 336, 1511, 2, 372),(1536, 'I48', 'I', 9, 48, 48, 432, 1513, 2, 373),(1536, 'K48', 'K', 11, 48, 48, 528, 1515, 2, 374),(1536, 'M48', 'M', 13, 48, 48, 624, 1517, 2, 375),(1536, 'O48', 'O', 15, 48, 48, 720, 1519, 2, 376),(1536, 'Q48', 'Q', 17, 48, 48, 816, 1521, 2, 377),(1536, 'S48', 'S', 19, 48, 48, 912, 1523, 2, 378),(1536, 'U48', 'U', 21, 48, 48, 1008, 1525, 2, 379),(1536, 'W48', 'W', 23, 48, 48, 1104, 1527, 2, 380),(1536, 'Y48', 'Y', 25, 48, 48, 1200, 1529, 2, 381),(1536, 'AA48', 'AA', 27, 48, 48, 1296, 1531, 2, 382),(1536, 'AC48', 'AC', 29, 48, 48, 1392, 1533, 2, 383),(1536, 'AE48', 'AE', 31, 48, 48, 1488, 1535, 2, 384),(1536, 'B01', 'B', 2, 1, 48, 49, 2, 3, 1),(1536, 'D01', 'D', 4, 1, 48, 145, 4, 3, 2),(1536, 'F01', 'F', 6, 1, 48, 241, 6, 3, 3),(1536, 'H01', 'H', 8, 1, 48, 337, 8, 3, 4),(1536, 'J01', 'J', 10, 1, 48, 433, 10, 3, 5),(1536, 'L01', 'L', 12, 1, 48, 529, 12, 3, 6),(1536, 'N01', 'N', 14, 1, 48, 625, 14, 3, 7),(1536, 'P01', 'P', 16, 1, 48, 721, 16, 3, 8),(1536, 'R01', 'R', 18, 1, 48, 817, 18, 3, 9),(1536, 'T01', 'T', 20, 1, 48, 913, 20, 3, 10),(1536, 'V01', 'V', 22, 1, 48, 1009, 22, 3, 11),(1536, 'X01', 'X', 24, 1, 48, 1105, 24, 3, 12),(1536, 'Z01', 'Z', 26, 1, 48, 1201, 26, 3, 13),(1536, 'AB01', 'AB', 28, 1, 48, 1297, 28, 3, 14),(1536, 'AD01', 'AD', 30, 1, 48, 1393, 30, 3, 15),(1536, 'AF01', 'AF', 32, 1, 48, 1489, 32, 3, 16),(1536, 'B03', 'B', 2, 3, 48, 51, 66, 3, 17),(1536, 'D03', 'D', 4, 3, 48, 147, 68, 3, 18),(1536, 'F03', 'F', 6, 3, 48, 243, 70, 3, 19),(1536, 'H03', 'H', 8, 3, 48, 339, 72, 3, 20),(1536, 'J03', 'J', 10, 3, 48, 435, 74, 3, 21),(1536, 'L03', 'L', 12, 3, 48, 531, 76, 3, 22),(1536, 'N03', 'N', 14, 3, 48, 627, 78, 3, 23),(1536, 'P03', 'P', 16, 3, 48, 723, 80, 3, 24),(1536, 'R03', 'R', 18, 3, 48, 819, 82, 3, 25),(1536, 'T03', 'T', 20, 3, 48, 915, 84, 3, 26),(1536, 'V03', 'V', 22, 3, 48, 1011, 86, 3, 27),(1536, 'X03', 'X', 24, 3, 48, 1107, 88, 3, 28),(1536, 'Z03', 'Z', 26, 3, 48, 1203, 90, 3, 29),(1536, 'AB03', 'AB', 28, 3, 48, 1299, 92, 3, 30),(1536, 'AD03', 'AD', 30, 3, 48, 1395, 94, 3, 31),(1536, 'AF03', 'AF', 32, 3, 48, 1491, 96, 3, 32),(1536, 'B05', 'B', 2, 5, 48, 53, 130, 3, 33),(1536, 'D05', 'D', 4, 5, 48, 149, 132, 3, 34),(1536, 'F05', 'F', 6, 5, 48, 245, 134, 3, 35),(1536, 'H05', 'H', 8, 5, 48, 341, 136, 3, 36),(1536, 'J05', 'J', 10, 5, 48, 437, 138, 3, 37),(1536, 'L05', 'L', 12, 5, 48, 533, 140, 3, 38),(1536, 'N05', 'N', 14, 5, 48, 629, 142, 3, 39),(1536, 'P05', 'P', 16, 5, 48, 725, 144, 3, 40),(1536, 'R05', 'R', 18, 5, 48, 821, 146, 3, 41),(1536, 'T05', 'T', 20, 5, 48, 917, 148, 3, 42),(1536, 'V05', 'V', 22, 5, 48, 1013, 150, 3, 43),(1536, 'X05', 'X', 24, 5, 48, 1109, 152, 3, 44),(1536, 'Z05', 'Z', 26, 5, 48, 1205, 154, 3, 45),(1536, 'AB05', 'AB', 28, 5, 48, 1301, 156, 3, 46),(1536, 'AD05', 'AD', 30, 5, 48, 1397, 158, 3, 47),(1536, 'AF05', 'AF', 32, 5, 48, 1493, 160, 3, 48),(1536, 'B07', 'B', 2, 7, 48, 55, 194, 3, 49),(1536, 'D07', 'D', 4, 7, 48, 151, 196, 3, 50),(1536, 'F07', 'F', 6, 7, 48, 247, 198, 3, 51),(1536, 'H07', 'H', 8, 7, 48, 343, 200, 3, 52),(1536, 'J07', 'J', 10, 7, 48, 439, 202, 3, 53),(1536, 'L07', 'L', 12, 7, 48, 535, 204, 3, 54),(1536, 'N07', 'N', 14, 7, 48, 631, 206, 3, 55),(1536, 'P07', 'P', 16, 7, 48, 727, 208, 3, 56),(1536, 'R07', 'R', 18, 7, 48, 823, 210, 3, 57),(1536, 'T07', 'T', 20, 7, 48, 919, 212, 3, 58),(1536, 'V07', 'V', 22, 7, 48, 1015, 214, 3, 59),(1536, 'X07', 'X', 24, 7, 48, 1111, 216, 3, 60),(1536, 'Z07', 'Z', 26, 7, 48, 1207, 218, 3, 61),(1536, 'AB07', 'AB', 28, 7, 48, 1303, 220, 3, 62),(1536, 'AD07', 'AD', 30, 7, 48, 1399, 222, 3, 63),(1536, 'AF07', 'AF', 32, 7, 48, 1495, 224, 3, 64),(1536, 'B09', 'B', 2, 9, 48, 57, 258, 3, 65),(1536, 'D09', 'D', 4, 9, 48, 153, 260, 3, 66),(1536, 'F09', 'F', 6, 9, 48, 249, 262, 3, 67),(1536, 'H09', 'H', 8, 9, 48, 345, 264, 3, 68),(1536, 'J09', 'J', 10, 9, 48, 441, 266, 3, 69),(1536, 'L09', 'L', 12, 9, 48, 537, 268, 3, 70),(1536, 'N09', 'N', 14, 9, 48, 633, 270, 3, 71),(1536, 'P09', 'P', 16, 9, 48, 729, 272, 3, 72),(1536, 'R09', 'R', 18, 9, 48, 825, 274, 3, 73),(1536, 'T09', 'T', 20, 9, 48, 921, 276, 3, 74),(1536, 'V09', 'V', 22, 9, 48, 1017, 278, 3, 75),(1536, 'X09', 'X', 24, 9, 48, 1113, 280, 3, 76),(1536, 'Z09', 'Z', 26, 9, 48, 1209, 282, 3, 77),(1536, 'AB09', 'AB', 28, 9, 48, 1305, 284, 3, 78),(1536, 'AD09', 'AD', 30, 9, 48, 1401, 286, 3, 79),(1536, 'AF09', 'AF', 32, 9, 48, 1497, 288, 3, 80),(1536, 'B11', 'B', 2, 11, 48, 59, 322, 3, 81),(1536, 'D11', 'D', 4, 11, 48, 155, 324, 3, 82),(1536, 'F11', 'F', 6, 11, 48, 251, 326, 3, 83),(1536, 'H11', 'H', 8, 11, 48, 347, 328, 3, 84),(1536, 'J11', 'J', 10, 11, 48, 443, 330, 3, 85),(1536, 'L11', 'L', 12, 11, 48, 539, 332, 3, 86),(1536, 'N11', 'N', 14, 11, 48, 635, 334, 3, 87),(1536, 'P11', 'P', 16, 11, 48, 731, 336, 3, 88),(1536, 'R11', 'R', 18, 11, 48, 827, 338, 3, 89),(1536, 'T11', 'T', 20, 11, 48, 923, 340, 3, 90),(1536, 'V11', 'V', 22, 11, 48, 1019, 342, 3, 91),(1536, 'X11', 'X', 24, 11, 48, 1115, 344, 3, 92),(1536, 'Z11', 'Z', 26, 11, 48, 1211, 346, 3, 93),(1536, 'AB11', 'AB', 28, 11, 48, 1307, 348, 3, 94),(1536, 'AD11', 'AD', 30, 11, 48, 1403, 350, 3, 95),(1536, 'AF11', 'AF', 32, 11, 48, 1499, 352, 3, 96),(1536, 'B13', 'B', 2, 13, 48, 61, 386, 3, 97),(1536, 'D13', 'D', 4, 13, 48, 157, 388, 3, 98),(1536, 'F13', 'F', 6, 13, 48, 253, 390, 3, 99),(1536, 'H13', 'H', 8, 13, 48, 349, 392, 3, 100),(1536, 'J13', 'J', 10, 13, 48, 445, 394, 3, 101),(1536, 'L13', 'L', 12, 13, 48, 541, 396, 3, 102),(1536, 'N13', 'N', 14, 13, 48, 637, 398, 3, 103),(1536, 'P13', 'P', 16, 13, 48, 733, 400, 3, 104),(1536, 'R13', 'R', 18, 13, 48, 829, 402, 3, 105),(1536, 'T13', 'T', 20, 13, 48, 925, 404, 3, 106),(1536, 'V13', 'V', 22, 13, 48, 1021, 406, 3, 107),(1536, 'X13', 'X', 24, 13, 48, 1117, 408, 3, 108),(1536, 'Z13', 'Z', 26, 13, 48, 1213, 410, 3, 109),(1536, 'AB13', 'AB', 28, 13, 48, 1309, 412, 3, 110),(1536, 'AD13', 'AD', 30, 13, 48, 1405, 414, 3, 111),(1536, 'AF13', 'AF', 32, 13, 48, 1501, 416, 3, 112),(1536, 'B15', 'B', 2, 15, 48, 63, 450, 3, 113),(1536, 'D15', 'D', 4, 15, 48, 159, 452, 3, 114),(1536, 'F15', 'F', 6, 15, 48, 255, 454, 3, 115),(1536, 'H15', 'H', 8, 15, 48, 351, 456, 3, 116),(1536, 'J15', 'J', 10, 15, 48, 447, 458, 3, 117),(1536, 'L15', 'L', 12, 15, 48, 543, 460, 3, 118),(1536, 'N15', 'N', 14, 15, 48, 639, 462, 3, 119),(1536, 'P15', 'P', 16, 15, 48, 735, 464, 3, 120),(1536, 'R15', 'R', 18, 15, 48, 831, 466, 3, 121),(1536, 'T15', 'T', 20, 15, 48, 927, 468, 3, 122),(1536, 'V15', 'V', 22, 15, 48, 1023, 470, 3, 123),(1536, 'X15', 'X', 24, 15, 48, 1119, 472, 3, 124),(1536, 'Z15', 'Z', 26, 15, 48, 1215, 474, 3, 125),(1536, 'AB15', 'AB', 28, 15, 48, 1311, 476, 3, 126),(1536, 'AD15', 'AD', 30, 15, 48, 1407, 478, 3, 127),(1536, 'AF15', 'AF', 32, 15, 48, 1503, 480, 3, 128),(1536, 'B17', 'B', 2, 17, 48, 65, 514, 3, 129),(1536, 'D17', 'D', 4, 17, 48, 161, 516, 3, 130),(1536, 'F17', 'F', 6, 17, 48, 257, 518, 3, 131),(1536, 'H17', 'H', 8, 17, 48, 353, 520, 3, 132),(1536, 'J17', 'J', 10, 17, 48, 449, 522, 3, 133),(1536, 'L17', 'L', 12, 17, 48, 545, 524, 3, 134),(1536, 'N17', 'N', 14, 17, 48, 641, 526, 3, 135),(1536, 'P17', 'P', 16, 17, 48, 737, 528, 3, 136),(1536, 'R17', 'R', 18, 17, 48, 833, 530, 3, 137),(1536, 'T17', 'T', 20, 17, 48, 929, 532, 3, 138),(1536, 'V17', 'V', 22, 17, 48, 1025, 534, 3, 139),(1536, 'X17', 'X', 24, 17, 48, 1121, 536, 3, 140),(1536, 'Z17', 'Z', 26, 17, 48, 1217, 538, 3, 141),(1536, 'AB17', 'AB', 28, 17, 48, 1313, 540, 3, 142),(1536, 'AD17', 'AD', 30, 17, 48, 1409, 542, 3, 143),(1536, 'AF17', 'AF', 32, 17, 48, 1505, 544, 3, 144),(1536, 'B19', 'B', 2, 19, 48, 67, 578, 3, 145),(1536, 'D19', 'D', 4, 19, 48, 163, 580, 3, 146),(1536, 'F19', 'F', 6, 19, 48, 259, 582, 3, 147),(1536, 'H19', 'H', 8, 19, 48, 355, 584, 3, 148),(1536, 'J19', 'J', 10, 19, 48, 451, 586, 3, 149),(1536, 'L19', 'L', 12, 19, 48, 547, 588, 3, 150),(1536, 'N19', 'N', 14, 19, 48, 643, 590, 3, 151),(1536, 'P19', 'P', 16, 19, 48, 739, 592, 3, 152),(1536, 'R19', 'R', 18, 19, 48, 835, 594, 3, 153),(1536, 'T19', 'T', 20, 19, 48, 931, 596, 3, 154),(1536, 'V19', 'V', 22, 19, 48, 1027, 598, 3, 155),(1536, 'X19', 'X', 24, 19, 48, 1123, 600, 3, 156),(1536, 'Z19', 'Z', 26, 19, 48, 1219, 602, 3, 157),(1536, 'AB19', 'AB', 28, 19, 48, 1315, 604, 3, 158),(1536, 'AD19', 'AD', 30, 19, 48, 1411, 606, 3, 159),(1536, 'AF19', 'AF', 32, 19, 48, 1507, 608, 3, 160),(1536, 'B21', 'B', 2, 21, 48, 69, 642, 3, 161),(1536, 'D21', 'D', 4, 21, 48, 165, 644, 3, 162),(1536, 'F21', 'F', 6, 21, 48, 261, 646, 3, 163),(1536, 'H21', 'H', 8, 21, 48, 357, 648, 3, 164),(1536, 'J21', 'J', 10, 21, 48, 453, 650, 3, 165),(1536, 'L21', 'L', 12, 21, 48, 549, 652, 3, 166),(1536, 'N21', 'N', 14, 21, 48, 645, 654, 3, 167),(1536, 'P21', 'P', 16, 21, 48, 741, 656, 3, 168),(1536, 'R21', 'R', 18, 21, 48, 837, 658, 3, 169),(1536, 'T21', 'T', 20, 21, 48, 933, 660, 3, 170),(1536, 'V21', 'V', 22, 21, 48, 1029, 662, 3, 171),(1536, 'X21', 'X', 24, 21, 48, 1125, 664, 3, 172),(1536, 'Z21', 'Z', 26, 21, 48, 1221, 666, 3, 173),(1536, 'AB21', 'AB', 28, 21, 48, 1317, 668, 3, 174),(1536, 'AD21', 'AD', 30, 21, 48, 1413, 670, 3, 175),(1536, 'AF21', 'AF', 32, 21, 48, 1509, 672, 3, 176),(1536, 'B23', 'B', 2, 23, 48, 71, 706, 3, 177),(1536, 'D23', 'D', 4, 23, 48, 167, 708, 3, 178),(1536, 'F23', 'F', 6, 23, 48, 263, 710, 3, 179),(1536, 'H23', 'H', 8, 23, 48, 359, 712, 3, 180),(1536, 'J23', 'J', 10, 23, 48, 455, 714, 3, 181),(1536, 'L23', 'L', 12, 23, 48, 551, 716, 3, 182),(1536, 'N23', 'N', 14, 23, 48, 647, 718, 3, 183),(1536, 'P23', 'P', 16, 23, 48, 743, 720, 3, 184),(1536, 'R23', 'R', 18, 23, 48, 839, 722, 3, 185),(1536, 'T23', 'T', 20, 23, 48, 935, 724, 3, 186),(1536, 'V23', 'V', 22, 23, 48, 1031, 726, 3, 187),(1536, 'X23', 'X', 24, 23, 48, 1127, 728, 3, 188),(1536, 'Z23', 'Z', 26, 23, 48, 1223, 730, 3, 189),(1536, 'AB23', 'AB', 28, 23, 48, 1319, 732, 3, 190),(1536, 'AD23', 'AD', 30, 23, 48, 1415, 734, 3, 191),(1536, 'AF23', 'AF', 32, 23, 48, 1511, 736, 3, 192),(1536, 'B25', 'B', 2, 25, 48, 73, 770, 3, 193),(1536, 'D25', 'D', 4, 25, 48, 169, 772, 3, 194),(1536, 'F25', 'F', 6, 25, 48, 265, 774, 3, 195),(1536, 'H25', 'H', 8, 25, 48, 361, 776, 3, 196),(1536, 'J25', 'J', 10, 25, 48, 457, 778, 3, 197),(1536, 'L25', 'L', 12, 25, 48, 553, 780, 3, 198),(1536, 'N25', 'N', 14, 25, 48, 649, 782, 3, 199),(1536, 'P25', 'P', 16, 25, 48, 745, 784, 3, 200),(1536, 'R25', 'R', 18, 25, 48, 841, 786, 3, 201),(1536, 'T25', 'T', 20, 25, 48, 937, 788, 3, 202),(1536, 'V25', 'V', 22, 25, 48, 1033, 790, 3, 203),(1536, 'X25', 'X', 24, 25, 48, 1129, 792, 3, 204),(1536, 'Z25', 'Z', 26, 25, 48, 1225, 794, 3, 205),(1536, 'AB25', 'AB', 28, 25, 48, 1321, 796, 3, 206),(1536, 'AD25', 'AD', 30, 25, 48, 1417, 798, 3, 207),(1536, 'AF25', 'AF', 32, 25, 48, 1513, 800, 3, 208),(1536, 'B27', 'B', 2, 27, 48, 75, 834, 3, 209),(1536, 'D27', 'D', 4, 27, 48, 171, 836, 3, 210),(1536, 'F27', 'F', 6, 27, 48, 267, 838, 3, 211),(1536, 'H27', 'H', 8, 27, 48, 363, 840, 3, 212),(1536, 'J27', 'J', 10, 27, 48, 459, 842, 3, 213),(1536, 'L27', 'L', 12, 27, 48, 555, 844, 3, 214),(1536, 'N27', 'N', 14, 27, 48, 651, 846, 3, 215),(1536, 'P27', 'P', 16, 27, 48, 747, 848, 3, 216),(1536, 'R27', 'R', 18, 27, 48, 843, 850, 3, 217),(1536, 'T27', 'T', 20, 27, 48, 939, 852, 3, 218),(1536, 'V27', 'V', 22, 27, 48, 1035, 854, 3, 219),(1536, 'X27', 'X', 24, 27, 48, 1131, 856, 3, 220),(1536, 'Z27', 'Z', 26, 27, 48, 1227, 858, 3, 221),(1536, 'AB27', 'AB', 28, 27, 48, 1323, 860, 3, 222),(1536, 'AD27', 'AD', 30, 27, 48, 1419, 862, 3, 223),(1536, 'AF27', 'AF', 32, 27, 48, 1515, 864, 3, 224),(1536, 'B29', 'B', 2, 29, 48, 77, 898, 3, 225),(1536, 'D29', 'D', 4, 29, 48, 173, 900, 3, 226),(1536, 'F29', 'F', 6, 29, 48, 269, 902, 3, 227),(1536, 'H29', 'H', 8, 29, 48, 365, 904, 3, 228),(1536, 'J29', 'J', 10, 29, 48, 461, 906, 3, 229),(1536, 'L29', 'L', 12, 29, 48, 557, 908, 3, 230),(1536, 'N29', 'N', 14, 29, 48, 653, 910, 3, 231),(1536, 'P29', 'P', 16, 29, 48, 749, 912, 3, 232),(1536, 'R29', 'R', 18, 29, 48, 845, 914, 3, 233),(1536, 'T29', 'T', 20, 29, 48, 941, 916, 3, 234),(1536, 'V29', 'V', 22, 29, 48, 1037, 918, 3, 235),(1536, 'X29', 'X', 24, 29, 48, 1133, 920, 3, 236),(1536, 'Z29', 'Z', 26, 29, 48, 1229, 922, 3, 237),(1536, 'AB29', 'AB', 28, 29, 48, 1325, 924, 3, 238),(1536, 'AD29', 'AD', 30, 29, 48, 1421, 926, 3, 239),(1536, 'AF29', 'AF', 32, 29, 48, 1517, 928, 3, 240),(1536, 'B31', 'B', 2, 31, 48, 79, 962, 3, 241),(1536, 'D31', 'D', 4, 31, 48, 175, 964, 3, 242),(1536, 'F31', 'F', 6, 31, 48, 271, 966, 3, 243),(1536, 'H31', 'H', 8, 31, 48, 367, 968, 3, 244),(1536, 'J31', 'J', 10, 31, 48, 463, 970, 3, 245),(1536, 'L31', 'L', 12, 31, 48, 559, 972, 3, 246),(1536, 'N31', 'N', 14, 31, 48, 655, 974, 3, 247),(1536, 'P31', 'P', 16, 31, 48, 751, 976, 3, 248),(1536, 'R31', 'R', 18, 31, 48, 847, 978, 3, 249),(1536, 'T31', 'T', 20, 31, 48, 943, 980, 3, 250),(1536, 'V31', 'V', 22, 31, 48, 1039, 982, 3, 251),(1536, 'X31', 'X', 24, 31, 48, 1135, 984, 3, 252),(1536, 'Z31', 'Z', 26, 31, 48, 1231, 986, 3, 253),(1536, 'AB31', 'AB', 28, 31, 48, 1327, 988, 3, 254),(1536, 'AD31', 'AD', 30, 31, 48, 1423, 990, 3, 255),(1536, 'AF31', 'AF', 32, 31, 48, 1519, 992, 3, 256),(1536, 'B33', 'B', 2, 33, 48, 81, 1026, 3, 257),(1536, 'D33', 'D', 4, 33, 48, 177, 1028, 3, 258),(1536, 'F33', 'F', 6, 33, 48, 273, 1030, 3, 259),(1536, 'H33', 'H', 8, 33, 48, 369, 1032, 3, 260),(1536, 'J33', 'J', 10, 33, 48, 465, 1034, 3, 261),(1536, 'L33', 'L', 12, 33, 48, 561, 1036, 3, 262),(1536, 'N33', 'N', 14, 33, 48, 657, 1038, 3, 263),(1536, 'P33', 'P', 16, 33, 48, 753, 1040, 3, 264),(1536, 'R33', 'R', 18, 33, 48, 849, 1042, 3, 265),(1536, 'T33', 'T', 20, 33, 48, 945, 1044, 3, 266),(1536, 'V33', 'V', 22, 33, 48, 1041, 1046, 3, 267),(1536, 'X33', 'X', 24, 33, 48, 1137, 1048, 3, 268),(1536, 'Z33', 'Z', 26, 33, 48, 1233, 1050, 3, 269),(1536, 'AB33', 'AB', 28, 33, 48, 1329, 1052, 3, 270),(1536, 'AD33', 'AD', 30, 33, 48, 1425, 1054, 3, 271),(1536, 'AF33', 'AF', 32, 33, 48, 1521, 1056, 3, 272),(1536, 'B35', 'B', 2, 35, 48, 83, 1090, 3, 273),(1536, 'D35', 'D', 4, 35, 48, 179, 1092, 3, 274),(1536, 'F35', 'F', 6, 35, 48, 275, 1094, 3, 275),(1536, 'H35', 'H', 8, 35, 48, 371, 1096, 3, 276),(1536, 'J35', 'J', 10, 35, 48, 467, 1098, 3, 277),(1536, 'L35', 'L', 12, 35, 48, 563, 1100, 3, 278),(1536, 'N35', 'N', 14, 35, 48, 659, 1102, 3, 279),(1536, 'P35', 'P', 16, 35, 48, 755, 1104, 3, 280),(1536, 'R35', 'R', 18, 35, 48, 851, 1106, 3, 281),(1536, 'T35', 'T', 20, 35, 48, 947, 1108, 3, 282),(1536, 'V35', 'V', 22, 35, 48, 1043, 1110, 3, 283),(1536, 'X35', 'X', 24, 35, 48, 1139, 1112, 3, 284),(1536, 'Z35', 'Z', 26, 35, 48, 1235, 1114, 3, 285),(1536, 'AB35', 'AB', 28, 35, 48, 1331, 1116, 3, 286),(1536, 'AD35', 'AD', 30, 35, 48, 1427, 1118, 3, 287),(1536, 'AF35', 'AF', 32, 35, 48, 1523, 1120, 3, 288),(1536, 'B37', 'B', 2, 37, 48, 85, 1154, 3, 289),(1536, 'D37', 'D', 4, 37, 48, 181, 1156, 3, 290),(1536, 'F37', 'F', 6, 37, 48, 277, 1158, 3, 291),(1536, 'H37', 'H', 8, 37, 48, 373, 1160, 3, 292),(1536, 'J37', 'J', 10, 37, 48, 469, 1162, 3, 293),(1536, 'L37', 'L', 12, 37, 48, 565, 1164, 3, 294),(1536, 'N37', 'N', 14, 37, 48, 661, 1166, 3, 295),(1536, 'P37', 'P', 16, 37, 48, 757, 1168, 3, 296),(1536, 'R37', 'R', 18, 37, 48, 853, 1170, 3, 297),(1536, 'T37', 'T', 20, 37, 48, 949, 1172, 3, 298),(1536, 'V37', 'V', 22, 37, 48, 1045, 1174, 3, 299),(1536, 'X37', 'X', 24, 37, 48, 1141, 1176, 3, 300),(1536, 'Z37', 'Z', 26, 37, 48, 1237, 1178, 3, 301),(1536, 'AB37', 'AB', 28, 37, 48, 1333, 1180, 3, 302),(1536, 'AD37', 'AD', 30, 37, 48, 1429, 1182, 3, 303),(1536, 'AF37', 'AF', 32, 37, 48, 1525, 1184, 3, 304),(1536, 'B39', 'B', 2, 39, 48, 87, 1218, 3, 305),(1536, 'D39', 'D', 4, 39, 48, 183, 1220, 3, 306),(1536, 'F39', 'F', 6, 39, 48, 279, 1222, 3, 307),(1536, 'H39', 'H', 8, 39, 48, 375, 1224, 3, 308),(1536, 'J39', 'J', 10, 39, 48, 471, 1226, 3, 309),(1536, 'L39', 'L', 12, 39, 48, 567, 1228, 3, 310),(1536, 'N39', 'N', 14, 39, 48, 663, 1230, 3, 311),(1536, 'P39', 'P', 16, 39, 48, 759, 1232, 3, 312),(1536, 'R39', 'R', 18, 39, 48, 855, 1234, 3, 313),(1536, 'T39', 'T', 20, 39, 48, 951, 1236, 3, 314),(1536, 'V39', 'V', 22, 39, 48, 1047, 1238, 3, 315),(1536, 'X39', 'X', 24, 39, 48, 1143, 1240, 3, 316),(1536, 'Z39', 'Z', 26, 39, 48, 1239, 1242, 3, 317),(1536, 'AB39', 'AB', 28, 39, 48, 1335, 1244, 3, 318),(1536, 'AD39', 'AD', 30, 39, 48, 1431, 1246, 3, 319),(1536, 'AF39', 'AF', 32, 39, 48, 1527, 1248, 3, 320),(1536, 'B41', 'B', 2, 41, 48, 89, 1282, 3, 321),(1536, 'D41', 'D', 4, 41, 48, 185, 1284, 3, 322),(1536, 'F41', 'F', 6, 41, 48, 281, 1286, 3, 323),(1536, 'H41', 'H', 8, 41, 48, 377, 1288, 3, 324),(1536, 'J41', 'J', 10, 41, 48, 473, 1290, 3, 325),(1536, 'L41', 'L', 12, 41, 48, 569, 1292, 3, 326),(1536, 'N41', 'N', 14, 41, 48, 665, 1294, 3, 327),(1536, 'P41', 'P', 16, 41, 48, 761, 1296, 3, 328),(1536, 'R41', 'R', 18, 41, 48, 857, 1298, 3, 329),(1536, 'T41', 'T', 20, 41, 48, 953, 1300, 3, 330),(1536, 'V41', 'V', 22, 41, 48, 1049, 1302, 3, 331),(1536, 'X41', 'X', 24, 41, 48, 1145, 1304, 3, 332),(1536, 'Z41', 'Z', 26, 41, 48, 1241, 1306, 3, 333),(1536, 'AB41', 'AB', 28, 41, 48, 1337, 1308, 3, 334),(1536, 'AD41', 'AD', 30, 41, 48, 1433, 1310, 3, 335),(1536, 'AF41', 'AF', 32, 41, 48, 1529, 1312, 3, 336),(1536, 'B43', 'B', 2, 43, 48, 91, 1346, 3, 337),(1536, 'D43', 'D', 4, 43, 48, 187, 1348, 3, 338),(1536, 'F43', 'F', 6, 43, 48, 283, 1350, 3, 339),(1536, 'H43', 'H', 8, 43, 48, 379, 1352, 3, 340),(1536, 'J43', 'J', 10, 43, 48, 475, 1354, 3, 341),(1536, 'L43', 'L', 12, 43, 48, 571, 1356, 3, 342),(1536, 'N43', 'N', 14, 43, 48, 667, 1358, 3, 343),(1536, 'P43', 'P', 16, 43, 48, 763, 1360, 3, 344),(1536, 'R43', 'R', 18, 43, 48, 859, 1362, 3, 345),(1536, 'T43', 'T', 20, 43, 48, 955, 1364, 3, 346),(1536, 'V43', 'V', 22, 43, 48, 1051, 1366, 3, 347),(1536, 'X43', 'X', 24, 43, 48, 1147, 1368, 3, 348),(1536, 'Z43', 'Z', 26, 43, 48, 1243, 1370, 3, 349),(1536, 'AB43', 'AB', 28, 43, 48, 1339, 1372, 3, 350),(1536, 'AD43', 'AD', 30, 43, 48, 1435, 1374, 3, 351),(1536, 'AF43', 'AF', 32, 43, 48, 1531, 1376, 3, 352),(1536, 'B45', 'B', 2, 45, 48, 93, 1410, 3, 353),(1536, 'D45', 'D', 4, 45, 48, 189, 1412, 3, 354),(1536, 'F45', 'F', 6, 45, 48, 285, 1414, 3, 355),(1536, 'H45', 'H', 8, 45, 48, 381, 1416, 3, 356),(1536, 'J45', 'J', 10, 45, 48, 477, 1418, 3, 357),(1536, 'L45', 'L', 12, 45, 48, 573, 1420, 3, 358),(1536, 'N45', 'N', 14, 45, 48, 669, 1422, 3, 359),(1536, 'P45', 'P', 16, 45, 48, 765, 1424, 3, 360),(1536, 'R45', 'R', 18, 45, 48, 861, 1426, 3, 361),(1536, 'T45', 'T', 20, 45, 48, 957, 1428, 3, 362),(1536, 'V45', 'V', 22, 45, 48, 1053, 1430, 3, 363),(1536, 'X45', 'X', 24, 45, 48, 1149, 1432, 3, 364),(1536, 'Z45', 'Z', 26, 45, 48, 1245, 1434, 3, 365),(1536, 'AB45', 'AB', 28, 45, 48, 1341, 1436, 3, 366),(1536, 'AD45', 'AD', 30, 45, 48, 1437, 1438, 3, 367),(1536, 'AF45', 'AF', 32, 45, 48, 1533, 1440, 3, 368),(1536, 'B47', 'B', 2, 47, 48, 95, 1474, 3, 369),(1536, 'D47', 'D', 4, 47, 48, 191, 1476, 3, 370),(1536, 'F47', 'F', 6, 47, 48, 287, 1478, 3, 371),(1536, 'H47', 'H', 8, 47, 48, 383, 1480, 3, 372),(1536, 'J47', 'J', 10, 47, 48, 479, 1482, 3, 373),(1536, 'L47', 'L', 12, 47, 48, 575, 1484, 3, 374),(1536, 'N47', 'N', 14, 47, 48, 671, 1486, 3, 375),(1536, 'P47', 'P', 16, 47, 48, 767, 1488, 3, 376),(1536, 'R47', 'R', 18, 47, 48, 863, 1490, 3, 377),(1536, 'T47', 'T', 20, 47, 48, 959, 1492, 3, 378),(1536, 'V47', 'V', 22, 47, 48, 1055, 1494, 3, 379),(1536, 'X47', 'X', 24, 47, 48, 1151, 1496, 3, 380),(1536, 'Z47', 'Z', 26, 47, 48, 1247, 1498, 3, 381),(1536, 'AB47', 'AB', 28, 47, 48, 1343, 1500, 3, 382),(1536, 'AD47', 'AD', 30, 47, 48, 1439, 1502, 3, 383),(1536, 'AF47', 'AF', 32, 47, 48, 1535, 1504, 3, 384),(1536, 'B02', 'B', 2, 2, 48, 50, 34, 4, 1),(1536, 'D02', 'D', 4, 2, 48, 146, 36, 4, 2),(1536, 'F02', 'F', 6, 2, 48, 242, 38, 4, 3),(1536, 'H02', 'H', 8, 2, 48, 338, 40, 4, 4),(1536, 'J02', 'J', 10, 2, 48, 434, 42, 4, 5),(1536, 'L02', 'L', 12, 2, 48, 530, 44, 4, 6),(1536, 'N02', 'N', 14, 2, 48, 626, 46, 4, 7),(1536, 'P02', 'P', 16, 2, 48, 722, 48, 4, 8),(1536, 'R02', 'R', 18, 2, 48, 818, 50, 4, 9),(1536, 'T02', 'T', 20, 2, 48, 914, 52, 4, 10),(1536, 'V02', 'V', 22, 2, 48, 1010, 54, 4, 11),(1536, 'X02', 'X', 24, 2, 48, 1106, 56, 4, 12),(1536, 'Z02', 'Z', 26, 2, 48, 1202, 58, 4, 13),(1536, 'AB02', 'AB', 28, 2, 48, 1298, 60, 4, 14),(1536, 'AD02', 'AD', 30, 2, 48, 1394, 62, 4, 15),(1536, 'AF02', 'AF', 32, 2, 48, 1490, 64, 4, 16),(1536, 'B04', 'B', 2, 4, 48, 52, 98, 4, 17),(1536, 'D04', 'D', 4, 4, 48, 148, 100, 4, 18),(1536, 'F04', 'F', 6, 4, 48, 244, 102, 4, 19),(1536, 'H04', 'H', 8, 4, 48, 340, 104, 4, 20),(1536, 'J04', 'J', 10, 4, 48, 436, 106, 4, 21),(1536, 'L04', 'L', 12, 4, 48, 532, 108, 4, 22),(1536, 'N04', 'N', 14, 4, 48, 628, 110, 4, 23),(1536, 'P04', 'P', 16, 4, 48, 724, 112, 4, 24),(1536, 'R04', 'R', 18, 4, 48, 820, 114, 4, 25),(1536, 'T04', 'T', 20, 4, 48, 916, 116, 4, 26),(1536, 'V04', 'V', 22, 4, 48, 1012, 118, 4, 27),(1536, 'X04', 'X', 24, 4, 48, 1108, 120, 4, 28),(1536, 'Z04', 'Z', 26, 4, 48, 1204, 122, 4, 29),(1536, 'AB04', 'AB', 28, 4, 48, 1300, 124, 4, 30),(1536, 'AD04', 'AD', 30, 4, 48, 1396, 126, 4, 31),(1536, 'AF04', 'AF', 32, 4, 48, 1492, 128, 4, 32),(1536, 'B06', 'B', 2, 6, 48, 54, 162, 4, 33),(1536, 'D06', 'D', 4, 6, 48, 150, 164, 4, 34),(1536, 'F06', 'F', 6, 6, 48, 246, 166, 4, 35),(1536, 'H06', 'H', 8, 6, 48, 342, 168, 4, 36),(1536, 'J06', 'J', 10, 6, 48, 438, 170, 4, 37),(1536, 'L06', 'L', 12, 6, 48, 534, 172, 4, 38),(1536, 'N06', 'N', 14, 6, 48, 630, 174, 4, 39),(1536, 'P06', 'P', 16, 6, 48, 726, 176, 4, 40),(1536, 'R06', 'R', 18, 6, 48, 822, 178, 4, 41),(1536, 'T06', 'T', 20, 6, 48, 918, 180, 4, 42),(1536, 'V06', 'V', 22, 6, 48, 1014, 182, 4, 43),(1536, 'X06', 'X', 24, 6, 48, 1110, 184, 4, 44),(1536, 'Z06', 'Z', 26, 6, 48, 1206, 186, 4, 45),(1536, 'AB06', 'AB', 28, 6, 48, 1302, 188, 4, 46),(1536, 'AD06', 'AD', 30, 6, 48, 1398, 190, 4, 47),(1536, 'AF06', 'AF', 32, 6, 48, 1494, 192, 4, 48),(1536, 'B08', 'B', 2, 8, 48, 56, 226, 4, 49),(1536, 'D08', 'D', 4, 8, 48, 152, 228, 4, 50),(1536, 'F08', 'F', 6, 8, 48, 248, 230, 4, 51),(1536, 'H08', 'H', 8, 8, 48, 344, 232, 4, 52),(1536, 'J08', 'J', 10, 8, 48, 440, 234, 4, 53),(1536, 'L08', 'L', 12, 8, 48, 536, 236, 4, 54),(1536, 'N08', 'N', 14, 8, 48, 632, 238, 4, 55),(1536, 'P08', 'P', 16, 8, 48, 728, 240, 4, 56),(1536, 'R08', 'R', 18, 8, 48, 824, 242, 4, 57),(1536, 'T08', 'T', 20, 8, 48, 920, 244, 4, 58),(1536, 'V08', 'V', 22, 8, 48, 1016, 246, 4, 59),(1536, 'X08', 'X', 24, 8, 48, 1112, 248, 4, 60),(1536, 'Z08', 'Z', 26, 8, 48, 1208, 250, 4, 61),(1536, 'AB08', 'AB', 28, 8, 48, 1304, 252, 4, 62),(1536, 'AD08', 'AD', 30, 8, 48, 1400, 254, 4, 63),(1536, 'AF08', 'AF', 32, 8, 48, 1496, 256, 4, 64),(1536, 'B10', 'B', 2, 10, 48, 58, 290, 4, 65),(1536, 'D10', 'D', 4, 10, 48, 154, 292, 4, 66),(1536, 'F10', 'F', 6, 10, 48, 250, 294, 4, 67),(1536, 'H10', 'H', 8, 10, 48, 346, 296, 4, 68),(1536, 'J10', 'J', 10, 10, 48, 442, 298, 4, 69),(1536, 'L10', 'L', 12, 10, 48, 538, 300, 4, 70),(1536, 'N10', 'N', 14, 10, 48, 634, 302, 4, 71),(1536, 'P10', 'P', 16, 10, 48, 730, 304, 4, 72),(1536, 'R10', 'R', 18, 10, 48, 826, 306, 4, 73),(1536, 'T10', 'T', 20, 10, 48, 922, 308, 4, 74),(1536, 'V10', 'V', 22, 10, 48, 1018, 310, 4, 75),(1536, 'X10', 'X', 24, 10, 48, 1114, 312, 4, 76),(1536, 'Z10', 'Z', 26, 10, 48, 1210, 314, 4, 77),(1536, 'AB10', 'AB', 28, 10, 48, 1306, 316, 4, 78),(1536, 'AD10', 'AD', 30, 10, 48, 1402, 318, 4, 79),(1536, 'AF10', 'AF', 32, 10, 48, 1498, 320, 4, 80),(1536, 'B12', 'B', 2, 12, 48, 60, 354, 4, 81),(1536, 'D12', 'D', 4, 12, 48, 156, 356, 4, 82),(1536, 'F12', 'F', 6, 12, 48, 252, 358, 4, 83),(1536, 'H12', 'H', 8, 12, 48, 348, 360, 4, 84),(1536, 'J12', 'J', 10, 12, 48, 444, 362, 4, 85),(1536, 'L12', 'L', 12, 12, 48, 540, 364, 4, 86),(1536, 'N12', 'N', 14, 12, 48, 636, 366, 4, 87),(1536, 'P12', 'P', 16, 12, 48, 732, 368, 4, 88),(1536, 'R12', 'R', 18, 12, 48, 828, 370, 4, 89),(1536, 'T12', 'T', 20, 12, 48, 924, 372, 4, 90),(1536, 'V12', 'V', 22, 12, 48, 1020, 374, 4, 91),(1536, 'X12', 'X', 24, 12, 48, 1116, 376, 4, 92),(1536, 'Z12', 'Z', 26, 12, 48, 1212, 378, 4, 93),(1536, 'AB12', 'AB', 28, 12, 48, 1308, 380, 4, 94),(1536, 'AD12', 'AD', 30, 12, 48, 1404, 382, 4, 95),(1536, 'AF12', 'AF', 32, 12, 48, 1500, 384, 4, 96),(1536, 'B14', 'B', 2, 14, 48, 62, 418, 4, 97),(1536, 'D14', 'D', 4, 14, 48, 158, 420, 4, 98),(1536, 'F14', 'F', 6, 14, 48, 254, 422, 4, 99),(1536, 'H14', 'H', 8, 14, 48, 350, 424, 4, 100),(1536, 'J14', 'J', 10, 14, 48, 446, 426, 4, 101),(1536, 'L14', 'L', 12, 14, 48, 542, 428, 4, 102),(1536, 'N14', 'N', 14, 14, 48, 638, 430, 4, 103),(1536, 'P14', 'P', 16, 14, 48, 734, 432, 4, 104),(1536, 'R14', 'R', 18, 14, 48, 830, 434, 4, 105),(1536, 'T14', 'T', 20, 14, 48, 926, 436, 4, 106),(1536, 'V14', 'V', 22, 14, 48, 1022, 438, 4, 107),(1536, 'X14', 'X', 24, 14, 48, 1118, 440, 4, 108),(1536, 'Z14', 'Z', 26, 14, 48, 1214, 442, 4, 109),(1536, 'AB14', 'AB', 28, 14, 48, 1310, 444, 4, 110),(1536, 'AD14', 'AD', 30, 14, 48, 1406, 446, 4, 111),(1536, 'AF14', 'AF', 32, 14, 48, 1502, 448, 4, 112),(1536, 'B16', 'B', 2, 16, 48, 64, 482, 4, 113),(1536, 'D16', 'D', 4, 16, 48, 160, 484, 4, 114),(1536, 'F16', 'F', 6, 16, 48, 256, 486, 4, 115),(1536, 'H16', 'H', 8, 16, 48, 352, 488, 4, 116),(1536, 'J16', 'J', 10, 16, 48, 448, 490, 4, 117),(1536, 'L16', 'L', 12, 16, 48, 544, 492, 4, 118),(1536, 'N16', 'N', 14, 16, 48, 640, 494, 4, 119),(1536, 'P16', 'P', 16, 16, 48, 736, 496, 4, 120),(1536, 'R16', 'R', 18, 16, 48, 832, 498, 4, 121),(1536, 'T16', 'T', 20, 16, 48, 928, 500, 4, 122),(1536, 'V16', 'V', 22, 16, 48, 1024, 502, 4, 123),(1536, 'X16', 'X', 24, 16, 48, 1120, 504, 4, 124),(1536, 'Z16', 'Z', 26, 16, 48, 1216, 506, 4, 125),(1536, 'AB16', 'AB', 28, 16, 48, 1312, 508, 4, 126),(1536, 'AD16', 'AD', 30, 16, 48, 1408, 510, 4, 127),(1536, 'AF16', 'AF', 32, 16, 48, 1504, 512, 4, 128),(1536, 'B18', 'B', 2, 18, 48, 66, 546, 4, 129),(1536, 'D18', 'D', 4, 18, 48, 162, 548, 4, 130),(1536, 'F18', 'F', 6, 18, 48, 258, 550, 4, 131),(1536, 'H18', 'H', 8, 18, 48, 354, 552, 4, 132),(1536, 'J18', 'J', 10, 18, 48, 450, 554, 4, 133),(1536, 'L18', 'L', 12, 18, 48, 546, 556, 4, 134),(1536, 'N18', 'N', 14, 18, 48, 642, 558, 4, 135),(1536, 'P18', 'P', 16, 18, 48, 738, 560, 4, 136),(1536, 'R18', 'R', 18, 18, 48, 834, 562, 4, 137),(1536, 'T18', 'T', 20, 18, 48, 930, 564, 4, 138),(1536, 'V18', 'V', 22, 18, 48, 1026, 566, 4, 139),(1536, 'X18', 'X', 24, 18, 48, 1122, 568, 4, 140),(1536, 'Z18', 'Z', 26, 18, 48, 1218, 570, 4, 141),(1536, 'AB18', 'AB', 28, 18, 48, 1314, 572, 4, 142),(1536, 'AD18', 'AD', 30, 18, 48, 1410, 574, 4, 143),(1536, 'AF18', 'AF', 32, 18, 48, 1506, 576, 4, 144),(1536, 'B20', 'B', 2, 20, 48, 68, 610, 4, 145),(1536, 'D20', 'D', 4, 20, 48, 164, 612, 4, 146),(1536, 'F20', 'F', 6, 20, 48, 260, 614, 4, 147),(1536, 'H20', 'H', 8, 20, 48, 356, 616, 4, 148),(1536, 'J20', 'J', 10, 20, 48, 452, 618, 4, 149),(1536, 'L20', 'L', 12, 20, 48, 548, 620, 4, 150),(1536, 'N20', 'N', 14, 20, 48, 644, 622, 4, 151),(1536, 'P20', 'P', 16, 20, 48, 740, 624, 4, 152),(1536, 'R20', 'R', 18, 20, 48, 836, 626, 4, 153),(1536, 'T20', 'T', 20, 20, 48, 932, 628, 4, 154),(1536, 'V20', 'V', 22, 20, 48, 1028, 630, 4, 155),(1536, 'X20', 'X', 24, 20, 48, 1124, 632, 4, 156),(1536, 'Z20', 'Z', 26, 20, 48, 1220, 634, 4, 157),(1536, 'AB20', 'AB', 28, 20, 48, 1316, 636, 4, 158),(1536, 'AD20', 'AD', 30, 20, 48, 1412, 638, 4, 159),(1536, 'AF20', 'AF', 32, 20, 48, 1508, 640, 4, 160),(1536, 'B22', 'B', 2, 22, 48, 70, 674, 4, 161),(1536, 'D22', 'D', 4, 22, 48, 166, 676, 4, 162),(1536, 'F22', 'F', 6, 22, 48, 262, 678, 4, 163),(1536, 'H22', 'H', 8, 22, 48, 358, 680, 4, 164),(1536, 'J22', 'J', 10, 22, 48, 454, 682, 4, 165),(1536, 'L22', 'L', 12, 22, 48, 550, 684, 4, 166),(1536, 'N22', 'N', 14, 22, 48, 646, 686, 4, 167),(1536, 'P22', 'P', 16, 22, 48, 742, 688, 4, 168),(1536, 'R22', 'R', 18, 22, 48, 838, 690, 4, 169),(1536, 'T22', 'T', 20, 22, 48, 934, 692, 4, 170),(1536, 'V22', 'V', 22, 22, 48, 1030, 694, 4, 171),(1536, 'X22', 'X', 24, 22, 48, 1126, 696, 4, 172),(1536, 'Z22', 'Z', 26, 22, 48, 1222, 698, 4, 173),(1536, 'AB22', 'AB', 28, 22, 48, 1318, 700, 4, 174),(1536, 'AD22', 'AD', 30, 22, 48, 1414, 702, 4, 175),(1536, 'AF22', 'AF', 32, 22, 48, 1510, 704, 4, 176),(1536, 'B24', 'B', 2, 24, 48, 72, 738, 4, 177),(1536, 'D24', 'D', 4, 24, 48, 168, 740, 4, 178),(1536, 'F24', 'F', 6, 24, 48, 264, 742, 4, 179),(1536, 'H24', 'H', 8, 24, 48, 360, 744, 4, 180),(1536, 'J24', 'J', 10, 24, 48, 456, 746, 4, 181),(1536, 'L24', 'L', 12, 24, 48, 552, 748, 4, 182),(1536, 'N24', 'N', 14, 24, 48, 648, 750, 4, 183),(1536, 'P24', 'P', 16, 24, 48, 744, 752, 4, 184),(1536, 'R24', 'R', 18, 24, 48, 840, 754, 4, 185),(1536, 'T24', 'T', 20, 24, 48, 936, 756, 4, 186),(1536, 'V24', 'V', 22, 24, 48, 1032, 758, 4, 187),(1536, 'X24', 'X', 24, 24, 48, 1128, 760, 4, 188),(1536, 'Z24', 'Z', 26, 24, 48, 1224, 762, 4, 189),(1536, 'AB24', 'AB', 28, 24, 48, 1320, 764, 4, 190),(1536, 'AD24', 'AD', 30, 24, 48, 1416, 766, 4, 191),(1536, 'AF24', 'AF', 32, 24, 48, 1512, 768, 4, 192),(1536, 'B26', 'B', 2, 26, 48, 74, 802, 4, 193),(1536, 'D26', 'D', 4, 26, 48, 170, 804, 4, 194),(1536, 'F26', 'F', 6, 26, 48, 266, 806, 4, 195),(1536, 'H26', 'H', 8, 26, 48, 362, 808, 4, 196),(1536, 'J26', 'J', 10, 26, 48, 458, 810, 4, 197),(1536, 'L26', 'L', 12, 26, 48, 554, 812, 4, 198),(1536, 'N26', 'N', 14, 26, 48, 650, 814, 4, 199),(1536, 'P26', 'P', 16, 26, 48, 746, 816, 4, 200),(1536, 'R26', 'R', 18, 26, 48, 842, 818, 4, 201),(1536, 'T26', 'T', 20, 26, 48, 938, 820, 4, 202),(1536, 'V26', 'V', 22, 26, 48, 1034, 822, 4, 203),(1536, 'X26', 'X', 24, 26, 48, 1130, 824, 4, 204),(1536, 'Z26', 'Z', 26, 26, 48, 1226, 826, 4, 205),(1536, 'AB26', 'AB', 28, 26, 48, 1322, 828, 4, 206),(1536, 'AD26', 'AD', 30, 26, 48, 1418, 830, 4, 207),(1536, 'AF26', 'AF', 32, 26, 48, 1514, 832, 4, 208),(1536, 'B28', 'B', 2, 28, 48, 76, 866, 4, 209),(1536, 'D28', 'D', 4, 28, 48, 172, 868, 4, 210),(1536, 'F28', 'F', 6, 28, 48, 268, 870, 4, 211),(1536, 'H28', 'H', 8, 28, 48, 364, 872, 4, 212),(1536, 'J28', 'J', 10, 28, 48, 460, 874, 4, 213),(1536, 'L28', 'L', 12, 28, 48, 556, 876, 4, 214),(1536, 'N28', 'N', 14, 28, 48, 652, 878, 4, 215),(1536, 'P28', 'P', 16, 28, 48, 748, 880, 4, 216),(1536, 'R28', 'R', 18, 28, 48, 844, 882, 4, 217),(1536, 'T28', 'T', 20, 28, 48, 940, 884, 4, 218),(1536, 'V28', 'V', 22, 28, 48, 1036, 886, 4, 219),(1536, 'X28', 'X', 24, 28, 48, 1132, 888, 4, 220),(1536, 'Z28', 'Z', 26, 28, 48, 1228, 890, 4, 221),(1536, 'AB28', 'AB', 28, 28, 48, 1324, 892, 4, 222),(1536, 'AD28', 'AD', 30, 28, 48, 1420, 894, 4, 223),(1536, 'AF28', 'AF', 32, 28, 48, 1516, 896, 4, 224),(1536, 'B30', 'B', 2, 30, 48, 78, 930, 4, 225),(1536, 'D30', 'D', 4, 30, 48, 174, 932, 4, 226),(1536, 'F30', 'F', 6, 30, 48, 270, 934, 4, 227),(1536, 'H30', 'H', 8, 30, 48, 366, 936, 4, 228),(1536, 'J30', 'J', 10, 30, 48, 462, 938, 4, 229),(1536, 'L30', 'L', 12, 30, 48, 558, 940, 4, 230),(1536, 'N30', 'N', 14, 30, 48, 654, 942, 4, 231),(1536, 'P30', 'P', 16, 30, 48, 750, 944, 4, 232),(1536, 'R30', 'R', 18, 30, 48, 846, 946, 4, 233),(1536, 'T30', 'T', 20, 30, 48, 942, 948, 4, 234),(1536, 'V30', 'V', 22, 30, 48, 1038, 950, 4, 235),(1536, 'X30', 'X', 24, 30, 48, 1134, 952, 4, 236),(1536, 'Z30', 'Z', 26, 30, 48, 1230, 954, 4, 237),(1536, 'AB30', 'AB', 28, 30, 48, 1326, 956, 4, 238),(1536, 'AD30', 'AD', 30, 30, 48, 1422, 958, 4, 239),(1536, 'AF30', 'AF', 32, 30, 48, 1518, 960, 4, 240),(1536, 'B32', 'B', 2, 32, 48, 80, 994, 4, 241),(1536, 'D32', 'D', 4, 32, 48, 176, 996, 4, 242),(1536, 'F32', 'F', 6, 32, 48, 272, 998, 4, 243),(1536, 'H32', 'H', 8, 32, 48, 368, 1000, 4, 244),(1536, 'J32', 'J', 10, 32, 48, 464, 1002, 4, 245),(1536, 'L32', 'L', 12, 32, 48, 560, 1004, 4, 246),(1536, 'N32', 'N', 14, 32, 48, 656, 1006, 4, 247),(1536, 'P32', 'P', 16, 32, 48, 752, 1008, 4, 248),(1536, 'R32', 'R', 18, 32, 48, 848, 1010, 4, 249),(1536, 'T32', 'T', 20, 32, 48, 944, 1012, 4, 250),(1536, 'V32', 'V', 22, 32, 48, 1040, 1014, 4, 251),(1536, 'X32', 'X', 24, 32, 48, 1136, 1016, 4, 252),(1536, 'Z32', 'Z', 26, 32, 48, 1232, 1018, 4, 253),(1536, 'AB32', 'AB', 28, 32, 48, 1328, 1020, 4, 254),(1536, 'AD32', 'AD', 30, 32, 48, 1424, 1022, 4, 255),(1536, 'AF32', 'AF', 32, 32, 48, 1520, 1024, 4, 256),(1536, 'B34', 'B', 2, 34, 48, 82, 1058, 4, 257),(1536, 'D34', 'D', 4, 34, 48, 178, 1060, 4, 258),(1536, 'F34', 'F', 6, 34, 48, 274, 1062, 4, 259),(1536, 'H34', 'H', 8, 34, 48, 370, 1064, 4, 260),(1536, 'J34', 'J', 10, 34, 48, 466, 1066, 4, 261),(1536, 'L34', 'L', 12, 34, 48, 562, 1068, 4, 262),(1536, 'N34', 'N', 14, 34, 48, 658, 1070, 4, 263),(1536, 'P34', 'P', 16, 34, 48, 754, 1072, 4, 264),(1536, 'R34', 'R', 18, 34, 48, 850, 1074, 4, 265),(1536, 'T34', 'T', 20, 34, 48, 946, 1076, 4, 266),(1536, 'V34', 'V', 22, 34, 48, 1042, 1078, 4, 267),(1536, 'X34', 'X', 24, 34, 48, 1138, 1080, 4, 268),(1536, 'Z34', 'Z', 26, 34, 48, 1234, 1082, 4, 269),(1536, 'AB34', 'AB', 28, 34, 48, 1330, 1084, 4, 270),(1536, 'AD34', 'AD', 30, 34, 48, 1426, 1086, 4, 271),(1536, 'AF34', 'AF', 32, 34, 48, 1522, 1088, 4, 272),(1536, 'B36', 'B', 2, 36, 48, 84, 1122, 4, 273),(1536, 'D36', 'D', 4, 36, 48, 180, 1124, 4, 274),(1536, 'F36', 'F', 6, 36, 48, 276, 1126, 4, 275),(1536, 'H36', 'H', 8, 36, 48, 372, 1128, 4, 276),(1536, 'J36', 'J', 10, 36, 48, 468, 1130, 4, 277),(1536, 'L36', 'L', 12, 36, 48, 564, 1132, 4, 278),(1536, 'N36', 'N', 14, 36, 48, 660, 1134, 4, 279),(1536, 'P36', 'P', 16, 36, 48, 756, 1136, 4, 280),(1536, 'R36', 'R', 18, 36, 48, 852, 1138, 4, 281),(1536, 'T36', 'T', 20, 36, 48, 948, 1140, 4, 282),(1536, 'V36', 'V', 22, 36, 48, 1044, 1142, 4, 283),(1536, 'X36', 'X', 24, 36, 48, 1140, 1144, 4, 284),(1536, 'Z36', 'Z', 26, 36, 48, 1236, 1146, 4, 285),(1536, 'AB36', 'AB', 28, 36, 48, 1332, 1148, 4, 286),(1536, 'AD36', 'AD', 30, 36, 48, 1428, 1150, 4, 287),(1536, 'AF36', 'AF', 32, 36, 48, 1524, 1152, 4, 288),(1536, 'B38', 'B', 2, 38, 48, 86, 1186, 4, 289),(1536, 'D38', 'D', 4, 38, 48, 182, 1188, 4, 290),(1536, 'F38', 'F', 6, 38, 48, 278, 1190, 4, 291),(1536, 'H38', 'H', 8, 38, 48, 374, 1192, 4, 292),(1536, 'J38', 'J', 10, 38, 48, 470, 1194, 4, 293),(1536, 'L38', 'L', 12, 38, 48, 566, 1196, 4, 294),(1536, 'N38', 'N', 14, 38, 48, 662, 1198, 4, 295),(1536, 'P38', 'P', 16, 38, 48, 758, 1200, 4, 296),(1536, 'R38', 'R', 18, 38, 48, 854, 1202, 4, 297),(1536, 'T38', 'T', 20, 38, 48, 950, 1204, 4, 298),(1536, 'V38', 'V', 22, 38, 48, 1046, 1206, 4, 299),(1536, 'X38', 'X', 24, 38, 48, 1142, 1208, 4, 300),(1536, 'Z38', 'Z', 26, 38, 48, 1238, 1210, 4, 301),(1536, 'AB38', 'AB', 28, 38, 48, 1334, 1212, 4, 302),(1536, 'AD38', 'AD', 30, 38, 48, 1430, 1214, 4, 303),(1536, 'AF38', 'AF', 32, 38, 48, 1526, 1216, 4, 304),(1536, 'B40', 'B', 2, 40, 48, 88, 1250, 4, 305),(1536, 'D40', 'D', 4, 40, 48, 184, 1252, 4, 306),(1536, 'F40', 'F', 6, 40, 48, 280, 1254, 4, 307),(1536, 'H40', 'H', 8, 40, 48, 376, 1256, 4, 308),(1536, 'J40', 'J', 10, 40, 48, 472, 1258, 4, 309),(1536, 'L40', 'L', 12, 40, 48, 568, 1260, 4, 310),(1536, 'N40', 'N', 14, 40, 48, 664, 1262, 4, 311),(1536, 'P40', 'P', 16, 40, 48, 760, 1264, 4, 312),(1536, 'R40', 'R', 18, 40, 48, 856, 1266, 4, 313),(1536, 'T40', 'T', 20, 40, 48, 952, 1268, 4, 314),(1536, 'V40', 'V', 22, 40, 48, 1048, 1270, 4, 315),(1536, 'X40', 'X', 24, 40, 48, 1144, 1272, 4, 316),(1536, 'Z40', 'Z', 26, 40, 48, 1240, 1274, 4, 317),(1536, 'AB40', 'AB', 28, 40, 48, 1336, 1276, 4, 318),(1536, 'AD40', 'AD', 30, 40, 48, 1432, 1278, 4, 319),(1536, 'AF40', 'AF', 32, 40, 48, 1528, 1280, 4, 320),(1536, 'B42', 'B', 2, 42, 48, 90, 1314, 4, 321),(1536, 'D42', 'D', 4, 42, 48, 186, 1316, 4, 322),(1536, 'F42', 'F', 6, 42, 48, 282, 1318, 4, 323),(1536, 'H42', 'H', 8, 42, 48, 378, 1320, 4, 324),(1536, 'J42', 'J', 10, 42, 48, 474, 1322, 4, 325),(1536, 'L42', 'L', 12, 42, 48, 570, 1324, 4, 326),(1536, 'N42', 'N', 14, 42, 48, 666, 1326, 4, 327),(1536, 'P42', 'P', 16, 42, 48, 762, 1328, 4, 328),(1536, 'R42', 'R', 18, 42, 48, 858, 1330, 4, 329),(1536, 'T42', 'T', 20, 42, 48, 954, 1332, 4, 330),(1536, 'V42', 'V', 22, 42, 48, 1050, 1334, 4, 331),(1536, 'X42', 'X', 24, 42, 48, 1146, 1336, 4, 332),(1536, 'Z42', 'Z', 26, 42, 48, 1242, 1338, 4, 333),(1536, 'AB42', 'AB', 28, 42, 48, 1338, 1340, 4, 334),(1536, 'AD42', 'AD', 30, 42, 48, 1434, 1342, 4, 335),(1536, 'AF42', 'AF', 32, 42, 48, 1530, 1344, 4, 336),(1536, 'B44', 'B', 2, 44, 48, 92, 1378, 4, 337),(1536, 'D44', 'D', 4, 44, 48, 188, 1380, 4, 338),(1536, 'F44', 'F', 6, 44, 48, 284, 1382, 4, 339),(1536, 'H44', 'H', 8, 44, 48, 380, 1384, 4, 340),(1536, 'J44', 'J', 10, 44, 48, 476, 1386, 4, 341),(1536, 'L44', 'L', 12, 44, 48, 572, 1388, 4, 342),(1536, 'N44', 'N', 14, 44, 48, 668, 1390, 4, 343),(1536, 'P44', 'P', 16, 44, 48, 764, 1392, 4, 344),(1536, 'R44', 'R', 18, 44, 48, 860, 1394, 4, 345),(1536, 'T44', 'T', 20, 44, 48, 956, 1396, 4, 346),(1536, 'V44', 'V', 22, 44, 48, 1052, 1398, 4, 347),(1536, 'X44', 'X', 24, 44, 48, 1148, 1400, 4, 348),(1536, 'Z44', 'Z', 26, 44, 48, 1244, 1402, 4, 349),(1536, 'AB44', 'AB', 28, 44, 48, 1340, 1404, 4, 350),(1536, 'AD44', 'AD', 30, 44, 48, 1436, 1406, 4, 351),(1536, 'AF44', 'AF', 32, 44, 48, 1532, 1408, 4, 352),(1536, 'B46', 'B', 2, 46, 48, 94, 1442, 4, 353),(1536, 'D46', 'D', 4, 46, 48, 190, 1444, 4, 354),(1536, 'F46', 'F', 6, 46, 48, 286, 1446, 4, 355),(1536, 'H46', 'H', 8, 46, 48, 382, 1448, 4, 356),(1536, 'J46', 'J', 10, 46, 48, 478, 1450, 4, 357),(1536, 'L46', 'L', 12, 46, 48, 574, 1452, 4, 358),(1536, 'N46', 'N', 14, 46, 48, 670, 1454, 4, 359),(1536, 'P46', 'P', 16, 46, 48, 766, 1456, 4, 360),(1536, 'R46', 'R', 18, 46, 48, 862, 1458, 4, 361),(1536, 'T46', 'T', 20, 46, 48, 958, 1460, 4, 362),(1536, 'V46', 'V', 22, 46, 48, 1054, 1462, 4, 363),(1536, 'X46', 'X', 24, 46, 48, 1150, 1464, 4, 364),(1536, 'Z46', 'Z', 26, 46, 48, 1246, 1466, 4, 365),(1536, 'AB46', 'AB', 28, 46, 48, 1342, 1468, 4, 366),(1536, 'AD46', 'AD', 30, 46, 48, 1438, 1470, 4, 367),(1536, 'AF46', 'AF', 32, 46, 48, 1534, 1472, 4, 368),(1536, 'B48', 'B', 2, 48, 48, 96, 1506, 4, 369),(1536, 'D48', 'D', 4, 48, 48, 192, 1508, 4, 370),(1536, 'F48', 'F', 6, 48, 48, 288, 1510, 4, 371),(1536, 'H48', 'H', 8, 48, 48, 384, 1512, 4, 372),(1536, 'J48', 'J', 10, 48, 48, 480, 1514, 4, 373),(1536, 'L48', 'L', 12, 48, 48, 576, 1516, 4, 374),(1536, 'N48', 'N', 14, 48, 48, 672, 1518, 4, 375),(1536, 'P48', 'P', 16, 48, 48, 768, 1520, 4, 376),(1536, 'R48', 'R', 18, 48, 48, 864, 1522, 4, 377),(1536, 'T48', 'T', 20, 48, 48, 960, 1524, 4, 378),(1536, 'V48', 'V', 22, 48, 48, 1056, 1526, 4, 379),(1536, 'X48', 'X', 24, 48, 48, 1152, 1528, 4, 380),(1536, 'Z48', 'Z', 26, 48, 48, 1248, 1530, 4, 381),(1536, 'AB48', 'AB', 28, 48, 48, 1344, 1532, 4, 382),(1536, 'AD48', 'AD', 30, 48, 48, 1440, 1534, 4, 383),(1536, 'AF48', 'AF', 32, 48, 48, 1536, 1536, 4, 384);


DROP FUNCTION IF EXISTS new_user(_name character varying, _password character VARYING, _salt CHARACTER VARYING, _email CHARACTER VARYING, _group  CHARACTER VARYING);

CREATE OR REPLACE FUNCTION new_user(_name character VARYING,  _password character VARYING, _salt CHARACTER VARYING, _email  CHARACTER VARYING, _group  CHARACTER VARYING)
  RETURNS void AS
$BODY$
BEGIN
   INSERT INTO person(lnuser, passwd, salt, email, usergroup)
   VALUES ( _name, _password, _salt, _email, _group);
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF EXISTS new_project(_descr character varying, _project_name character VARYING, _sessions_id VARCHAR(32));

CREATE OR REPLACE FUNCTION new_project(_descr character varying, _project_name character VARYING, _sessions_id VARCHAR(32))
  RETURNS void AS
$BODY$
DECLARE
   v_id integer;
BEGIN
   INSERT INTO project(descr, project_name, sessions_id)
   VALUES (_descr, _project_name, _sessions_id)
   RETURNING id INTO v_id;
   UPDATE project SET project_sys_name = 'PRJ-'||v_id WHERE id=v_id;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF exists new_plate_set(_descr VARCHAR(30), _plate_set_name VARCHAR(30), _num_plates INTEGER, _plate_format_id INTEGER,  _plate_type_id INTEGER, _project_id INTEGER, _plate_layout_name_id INTEGER, _sessions_id VARCHAR(32),  _with_samples boolean, _target_layout_name_id INTEGER);


CREATE OR REPLACE FUNCTION new_plate_set(_descr VARCHAR(30),_plate_set_name VARCHAR(30), _num_plates INTEGER, _plate_format_id INTEGER, _plate_type_id INTEGER, _project_id INTEGER, _plate_layout_name_id INTEGER, _sessions_id VARCHAR(32), _with_samples boolean, _target_layout_name_id INTEGER)
  RETURNS integer AS
$BODY$
DECLARE
   ps_id INTEGER;
   n_plates INTEGER;
   p_type INTEGER;
   p_form INTEGER;
   prj_id INTEGER;
   plt_id INTEGER;
   play_n_id INTEGER;
   w_spls BOOLEAN := _with_samples;
   trg_lyt_name_id INTEGER := _target_layout_name_id;
BEGIN
   
   INSERT INTO plate_set(descr, plate_set_name, num_plates, plate_format_id, plate_type_id, project_id, plate_layout_name_id, sessions_id, target_layout_name_id)
   VALUES (_descr, _plate_set_name, _num_plates, _plate_format_id, _plate_type_id, _project_id, _plate_layout_name_id, _sessions_id, trg_lyt_name_id )
   RETURNING ID, plate_format_id, num_plates, project_id, plate_type_id, plate_layout_name_id INTO ps_id, p_form, n_plates, prj_id, p_type, play_n_id;
   UPDATE plate_set SET plate_set_sys_name = 'PS-'||ps_id WHERE id=ps_id;

FOR i IN 1..n_plates loop
	     -- _plate_type_id INTEGER, _plate_set_id INTEGER, _project_id INTEGER, _plate_format_id INTEGER, include_sample BOOLEAN
	    SELECT new_plate(p_type, ps_id, p_form, play_n_id, w_spls) INTO plt_id;
	    UPDATE plate_plate_set SET plate_order = i WHERE plate_set_id = ps_id AND plate_id = plt_id;

END LOOP;

RETURN ps_id;

END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF exists new_plate_set_from_group(_descr VARCHAR(30), _plate_set_name VARCHAR(30), _num_plates INTEGER, _plate_format_id INTEGER,  _plate_type_id INTEGER, _project_id INTEGER, _plate_layout_name_id INTEGER, _sessions_id VARCHAR(32));


CREATE OR REPLACE FUNCTION new_plate_set_from_group(_descr VARCHAR(30),_plate_set_name VARCHAR(30), _num_plates INTEGER, _plate_format_id INTEGER, _plate_type_id INTEGER, _project_id INTEGER, _plate_layout_name_id INTEGER, _sessions_id VARCHAR(32))
  RETURNS integer AS
$BODY$
DECLARE
   ps_id INTEGER; 

BEGIN
  

   INSERT INTO plate_set(descr, plate_set_name, num_plates, plate_format_id, plate_type_id, project_id, plate_layout_name_id, sessions_id)
   VALUES (_descr, _plate_set_name, _num_plates, _plate_format_id, _plate_type_id, _project_id, _plate_layout_name_id, _sessions_id )
   RETURNING id INTO ps_id;
   UPDATE plate_set SET plate_set_sys_name = 'PS-'||ps_id WHERE id=ps_id;


RETURN ps_id;


END;
$BODY$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF exists get_num_samples_for_plate_set( _plate_set_id INTEGER);

CREATE OR REPLACE FUNCTION get_num_samples_for_plate_set(_plate_set_id INTEGER)
  RETURNS INTEGER AS
$BODY$
DECLARE
   psid int := _plate_set_id;
   
   counter INTEGER;
   sql_statement VARCHAR;
all_sample_ids INTEGER[];
num_samples INTEGER;
   
BEGIN
sql_statement := 'SELECT ARRAY(SELECT sample.id FROM plate, plate_plate_set, well, sample, well_sample WHERE plate_plate_set.plate_set_id = ' || psid || ' AND plate_plate_set.plate_id = plate.id AND well.plate_id = plate.id AND well_sample.well_id = well.id AND well_sample.sample_id = sample.id ORDER BY plate_plate_set.plate_id, plate_plate_set.plate_order, well.id)';

--    RAISE notice 'sql_statement: (%)', sql_statement;

     EXECUTE sql_statement INTO all_sample_ids;
     num_samples := array_length(all_sample_ids ,1); 
 -- RAISE notice 'ids: (%)', all_sample_ids;
 -- RAISE notice 'num: (%)', num_samples;

RETURN num_samples;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF exists assoc_plate_ids_with_plate_set_id( _plate_ids INTEGER[], _plate_set_id INTEGER);

CREATE OR REPLACE FUNCTION assoc_plate_ids_with_plate_set_id(_plate_ids int[], _plate_set_id int)
  RETURNS void AS
$BODY$
DECLARE
   pid int;
   plate_ids int[];
   counter INTEGER;
   sql_statement VARCHAR;
   
BEGIN
counter := 1;
SELECT sort(_plate_ids) INTO plate_ids;
sql_statement := 'INSERT INTO plate_plate_set (plate_set_id, plate_id, plate_order) VALUES ';

  FOREACH pid IN ARRAY plate_ids
     LOOP
     sql_statement := sql_statement || '(' || _plate_set_id || ', '  ||  pid || ', ' || counter || '),';
     counter = counter + 1;
    END LOOP;

     sql_statement := SUBSTRING(sql_statement, 1, CHAR_LENGTH(sql_statement)-1) || ';';
     --RAISE notice 'sqlstatement: (%)', sql_statement;
     EXECUTE sql_statement;

END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF EXISTS new_plate(INTEGER, INTEGER,INTEGER,INTEGER, BOOLEAN);

CREATE OR REPLACE FUNCTION new_plate(_plate_type_id INTEGER, _plate_set_id INTEGER, _plate_format_id INTEGER, _plate_layout_name_id INTEGER,  _include_sample BOOLEAN)
  RETURNS integer AS
$BODY$
DECLARE
   plt_id INTEGER;
   ps_id INTEGER = _plate_set_id;
   pf_id INTEGER;
   w_id INTEGER;
   s_id INTEGER;
   spl_include BOOLEAN := _include_sample;
   w integer;	

BEGIN

   INSERT INTO plate(plate_type_id,   plate_format_id, plate_layout_name_id)
   VALUES (_plate_type_id,  _plate_format_id, _plate_layout_name_id)
   RETURNING id  INTO plt_id;

    UPDATE plate SET plate_sys_name = 'PLT-'||plt_id WHERE id=plt_id;


FOR w IN 1.._plate_format_id LOOP

  --RAISE notice 'w: (%)', w;
       INSERT INTO well(by_col, plate_id) VALUES(w, plt_id)
       RETURNING id INTO w_id;
       
       IF spl_include THEN  --check if it is an \"unknown\" well i.e. not a control
       IF w IN (SELECT well_by_col  FROM plate_layout, plate_layout_name  WHERE plate_layout.plate_layout_name_id = plate_layout_name.id AND plate_layout.well_type_id = 1 AND plate_layout.plate_layout_name_id = _plate_layout_name_id) THEN
       INSERT INTO sample (sample_sys_name) VALUES (null)
       RETURNING id INTO s_id;
       UPDATE sample SET sample_sys_name = 'SPL-'||s_id WHERE id=s_id;

       INSERT INTO well_sample(well_id, sample_id)VALUES(w_id, s_id);
      END IF;
       END IF;
   END LOOP;

   INSERT INTO plate_plate_set(plate_set_id, plate_id)
   VALUES (ps_id, plt_id );

RETURN plt_id;

END;
$BODY$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF EXISTS new_sample(INTEGER,INTEGER,INTEGER);

CREATE OR REPLACE FUNCTION new_sample(_project_id INTEGER, _plate_id INTEGER,  _accs_id INTEGER)
  RETURNS void AS
$BODY$
DECLARE
   v_id integer;
BEGIN
   
   INSERT INTO sample(project_id, plate_id, accs_id)
   VALUES (_project_id, _plate_id,   _accs_id)
   RETURNING id INTO v_id;

    UPDATE sample SET sample_sys_name = 'SPL-'||v_id WHERE id=v_id RETURNING id;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF EXISTS new_target(INTEGER,VARCHAR,VARCHAR,VARCHAR);

CREATE OR REPLACE FUNCTION new_target(_project_id INTEGER, _trg_name varchar(30), _descr varchar(250), _accs_id varchar(30))
  RETURNS integer AS
$BODY$
DECLARE
   v_id integer;
BEGIN
   
   INSERT INTO target(project_id, target_name, descr, accs_id)
   VALUES (_project_id, _trg_name, _descr,   _accs_id)
   RETURNING id INTO v_id;

    UPDATE target SET target_sys_name = 'TRG-'||v_id WHERE id=v_id;

RETURN v_id;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF EXISTS new_target_layout_name(INTEGER,VARCHAR,VARCHAR,INTEGER,INTEGER,INTEGER,INTEGER,INTEGER);

CREATE OR REPLACE FUNCTION new_target_layout_name(_project_id INTEGER,  _trg_lyt_name varchar(30), _descr varchar(250), _reps INTEGER, q1_id INTEGER, q2_id INTEGER, q3_id INTEGER, q4_id INTEGER)
  RETURNS void AS
$BODY$
DECLARE
   v_id integer;
BEGIN  
   INSERT INTO target_layout_name(project_id,  target_layout_name_name, target_layout_name_desc, reps)
   VALUES (_project_id,  _trg_lyt_name, _descr, _reps)
   RETURNING id INTO v_id;

    UPDATE target_layout_name SET target_layout_name_sys_name = 'TLY-'||v_id WHERE id=v_id;

    INSERT INTO target_layout(target_layout_name_id, target_id, quad) VALUES (v_id, q1_id, 1),
    (v_id, q2_id, 2),(v_id, q3_id, 3),(v_id, q4_id, 4);

END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF EXISTS bulk_target_upload( _fields text[]);

CREATE OR REPLACE FUNCTION bulk_target_upload( _fields text[])
   RETURNS void AS
$func$
DECLARE
   m text[];
BEGIN
   FOREACH m SLICE 1 IN ARRAY _fields
   LOOP
         PERFORM new_target( CAST(m[1] AS INTEGER), m[2], m[3], m[4]);
--      RAISE NOTICE '% EXECUTING fieldname: %, stats: %', now()::text, m[1], m[2];
   END LOOP;
END
$func$  LANGUAGE plpgsql;

DROP FUNCTION IF EXISTS new_assay_run(  VARCHAR(30), VARCHAR(30), INTEGER,  INTEGER, INTEGER);

CREATE OR REPLACE FUNCTION new_assay_run( _assay_run_name VARCHAR(30), _descr VARCHAR(30), _assay_type_id INTEGER, _plate_set_id INTEGER, _plate_layout_name_id INTEGER, _sessions_id VARCHAR(32) )
  RETURNS integer AS
$BODY$
DECLARE
   v_id integer;
BEGIN
   
   INSERT INTO assay_run(assay_run_name , descr, assay_type_id, plate_set_id, plate_layout_name_id, sessions_id)
   VALUES (_assay_run_name, _descr, _assay_type_id, _plate_set_id, _plate_layout_name_id, _sessions_id)
   RETURNING id INTO v_id;

    UPDATE assay_run SET assay_run_sys_name = 'AR-'||v_id WHERE id=v_id;

RETURN v_id;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF EXISTS get_ids_for_sys_names( VARCHAR[], VARCHAR(30), VARCHAR(30));

CREATE OR REPLACE FUNCTION get_ids_for_sys_names( _sys_names VARCHAR[], _table VARCHAR(30), _sys_name VARCHAR(30))
  RETURNS integer[] AS
$BODY$
DECLARE
   sn varchar(20);
   an_int integer;
   sys_ids INTEGER[];
   sql_statement VARCHAR;
   sql_statement2 VARCHAR;
   
   temp INTEGER;

BEGIN

 sql_statement := 'SELECT id FROM ' || _table || ' WHERE ' || _sys_name   || ' = ';

  FOREACH sn IN ARRAY _sys_names
     LOOP
     sql_statement2 := sql_statement || quote_literal(sn);
     EXECUTE sql_statement2 INTO temp;
     sys_ids := array_append(sys_ids, temp );
    END LOOP;

RETURN sys_ids;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE PARALLEL UNSAFE; 

DROP FUNCTION IF EXISTS get_number_samples_for_psid( _psid INTEGER );

CREATE OR REPLACE FUNCTION get_number_samples_for_psid( _psid INTEGER) 
  RETURNS integer AS
$BODY$
DECLARE
   num_samples INTEGER;
   sql_statement VARCHAR;
  --plate_layout_name_id INTEGER;

BEGIN

     --sql_statement := 'SELECT plate_layout_name_id FROM plate_set WHERE id = ' || _psid;
     --EXECUTE sql_statement INTO plate_layout_name_id;

      sql_statement := 'SELECT count(sample_id) FROM well_sample WHERE well_sample.well_id IN (SELECT well.id FROM well WHERE well.plate_id  IN (SELECT plate_id FROM plate_plate_set WHERE plate_plate_set.plate_set_id = ' || _psid || '))'; 
      EXECUTE sql_statement INTO num_samples;

RETURN num_samples;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE PARALLEL UNSAFE;

DROP FUNCTION IF EXISTS new_plate_layout(  VARCHAR(30), VARCHAR(30), INTEGER,  VARCHAR[][]);

CREATE OR REPLACE FUNCTION new_plate_layout( _plate_layout_name VARCHAR(30), _descr VARCHAR(30), _plate_format_id INTEGER, _data VARCHAR[][])
  RETURNS integer AS
$BODY$
DECLARE
   src_id integer;
   dest_id INTEGER;
   dest_name VARCHAR(30);
BEGIN


   INSERT INTO plate_layout_name(name, descr, plate_format_id)
   VALUES (_plate_layout_name, _descr, _plate_format_id)
   RETURNING id INTO src_id;

dest_name := _plate_layout_name || '-dest';

   INSERT INTO plate_layout_name(name, descr, plate_format_id)
   VALUES (_plate_layout_name, _descr, _plate_format_id)
   RETURNING id INTO dest_id;

INSERT INTO layout_source_dest(src, dest) VALUES (src_id, dest_id);


 
RETURN plname_id;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF exists reformat_plate_set(source_plate_set_id INTEGER, source_num_plates INTEGER, n_reps_source INTEGER, dest_descr VARCHAR(30), dest_plate_set_name VARCHAR(30), dest_num_plates INTEGER, dest_plate_format_id INTEGER, dest_plate_type_id INTEGER, project_id INTEGER, dest_plate_layout_name_id INTEGER, sessions_id VARCHAR(32), target_layout_name_id INTEGER );

CREATE OR REPLACE FUNCTION reformat_plate_set(source_plate_set_id INTEGER, source_num_plates INTEGER, n_reps_source INTEGER, dest_descr VARCHAR(30), dest_plate_set_name VARCHAR(30), dest_num_plates INTEGER, dest_plate_format_id INTEGER, dest_plate_type_id INTEGER, project_id INTEGER, dest_plate_layout_name_id INTEGER, sessions_id VARCHAR(32), target_layout_name_id INTEGER)
RETURNS integer AS
$BODY$
DECLARE

dest_plate_set_id INTEGER;
all_source_well_ids INTEGER[];
all_dest_well_ids INTEGER[];
w INTEGER;
holder INTEGER;

BEGIN
--here I am creating the destination plate set, no samples included
SELECT new_plate_set(dest_descr ,dest_plate_set_name, dest_num_plates, dest_plate_format_id, dest_plate_type_id, project_id, dest_plate_layout_name_id, sessions_id, false, target_layout_name_id) INTO dest_plate_set_id;

--RAISE notice 'dest_plate_set_id: (%)', dest_plate_set_id;

CREATE TEMP TABLE temp1(counter INT, plate_id INT, plate_order INT, well_by_col INT, well_id INT);

FOR i IN 1..n_reps_source LOOP
INSERT INTO temp1 select i, well.plate_id, plate_plate_set.plate_order, well.by_col, well.id AS well_id FROM plate_plate_set, well  WHERE plate_plate_set.plate_set_id = source_plate_set_id AND plate_plate_set.plate_id = well.plate_id   ORDER BY well.plate_id, well.ID;
END LOOP;

SELECT ARRAY (SELECT well_id FROM temp1 ORDER BY plate_id, counter, well_id) INTO all_source_well_ids;


SELECT ARRAY (SELECT  dest.id  FROM ( SELECT plate_plate_set.plate_ID, well.by_col,  well.id  FROM well, plate_plate_set  WHERE plate_plate_set.plate_set_id = dest_plate_set_id  AND plate_plate_set.plate_id = well.plate_id) AS dest JOIN (SELECT well_numbers.well_name, well_numbers.by_col, well_numbers.quad FROM well_numbers WHERE well_numbers.plate_format=dest_plate_format_id)  AS foo ON (dest.by_col=foo.by_col) ORDER BY plate_id, quad, dest.by_col) INTO all_dest_well_ids;


FOR w IN 1..array_length(all_source_well_ids,1)  LOOP
SELECT sample.id FROM sample, well, well_sample WHERE well_sample.well_id=well.id AND well_sample.sample_id=sample.id AND well.id= all_source_well_ids[w] INTO holder;
INSERT INTO well_sample (well_id, sample_id) VALUES (all_dest_well_ids[w], holder );


--RAISE notice  'w: (%)', w;
--RAISE notice  'all_source_well_ids[w]: (%)', all_source_well_ids[w];
--RAISE notice  'all_dest_well_ids[w]: (%)', all_dest_well_ids[w];

END LOOP;

--RAISE notice  'all_source_well_ids: (%)', all_source_well_ids;
--RAISE notice  'all_dest_well_ids: (%)', all_dest_well_ids;


DROP TABLE temp1;

RETURN dest_plate_set_id;
END;
$BODY$
LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF exists process_assay_run_data(_assay_run_id integer);

CREATE OR REPLACE FUNCTION process_assay_run_data(_assay_run_id integer)
  RETURNS void AS
$BODY$
DECLARE
   plates INTEGER[]; 
   wells INTEGER[];  
   background decimal;
   positives decimal;
   negatives DECIMAL;
   unk_max DECIMAL;
   norm_factor DECIMAL;
--   format INTEGER;
BEGIN


CREATE TABLE data_set AS
SELECT max(assay_result_pre.assay_run_id) as assay_run_id, assay_result_pre.plate_order, max(assay_result_pre.well) as well, avg( assay_result_pre.response) as response, 0.0 AS bkgrnd_sub, 0.0 AS norm, 0.0 AS norm_pos,0.0 AS p_enhance,  max(plate_layout.well_by_col) AS well_by_col, max(plate_layout.well_type_id) AS well_type_id, plate_layout.replicates, plate_layout.target, max(assay_run.plate_layout_name_id) AS plate_layout_name_id, well_numbers.parent_well
FROM assay_result_pre, assay_run, plate_layout, plate_layout_name, well_numbers
WHERE  assay_result_pre.well = plate_layout.well_by_col AND 
       assay_result_pre.assay_run_id = assay_run.id AND  
       well_numbers.by_col = plate_layout.well_by_col AND
       well_numbers.plate_format=plate_layout_name.plate_format_id AND
       assay_run.plate_layout_name_id=plate_layout_name.id AND
       plate_layout.plate_layout_name_id = assay_run.plate_layout_name_id  AND 
       assay_run.ID = _assay_run_id::INTEGER
GROUP BY well_numbers.parent_well, plate_layout.replicates, plate_layout.target, assay_result_pre.plate_order
ORDER BY plate_order, parent_well;

-- background subtract

SELECT ARRAY (SELECT distinct plate_order FROM data_set WHERE data_set.assay_run_id = _assay_run_id  ORDER BY plate_order) INTO plates;

FOR plate_var IN 1..array_length(plates,1) LOOP
  SELECT AVG(data_set.response) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=4 INTO background;
  SELECT ARRAY (SELECT distinct well FROM data_set WHERE plate_order=plate_var ORDER BY well) INTO wells;

  FOR well_var IN 1..array_length(wells,1) LOOP

          UPDATE data_set SET bkgrnd_sub  = GREATEST( (data_set.response-background), 0) WHERE assay_run_id = _assay_run_id AND plate_order=plate_var AND well = wells[well_var];
-- raise notice 'well: %; plate %', wells[well_var], plate_var;

   END LOOP;

END LOOP;

-- use background subtracted values

FOR plate_var IN 1..array_length(plates,1) LOOP

SELECT AVG(data_set.bkgrnd_sub) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=2 INTO positives;
SELECT AVG(data_set.bkgrnd_sub) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=3 INTO negatives;
SELECT MAX(data_set.bkgrnd_sub) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=1 INTO unk_max;
-- raise notice 'plate %; unk_max: %', plate_var, unk_max;

SELECT ARRAY (SELECT distinct well FROM data_set WHERE plate_order=plate_var ORDER BY well) INTO wells;

       FOR well_var IN 1..array_length(wells,1) LOOP

          UPDATE data_set SET  norm = (data_set.bkgrnd_sub/unk_max), norm_pos = (data_set.bkgrnd_sub/positives), p_enhance = 100*(((data_set.bkgrnd_sub-negatives)/(positives-negatives))-1) WHERE assay_run_id = _assay_run_id AND plate_order=plate_var AND well = wells[well_var];
   END LOOP;

END LOOP;


INSERT INTO assay_result SELECT assay_run_id, plate_order, well, response , bkgrnd_sub::REAL, norm::REAL, norm_pos::REAL, p_enhance::REAL from data_set;
 DROP TABLE IF EXISTS data_set;
 TRUNCATE TABLE assay_result_pre;

PERFORM populate_assay_run_stats(_assay_run_id);


END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

-- CREATE OR REPLACE FUNCTION process_assay_run_data(_assay_run_id integer)
--   RETURNS void AS
-- $BODY$
-- DECLARE
--    plates INTEGER[];   
--    background decimal;
--    positives decimal;
--    negatives DECIMAL;
--    unk_max DECIMAL;
--    norm_factor DECIMAL;
--    format INTEGER;
-- BEGIN

-- CREATE TEMP TABLE data_set  ON COMMIT DROP AS SELECT assay_result.assay_run_id, assay_result.plate_order, assay_result.well, assay_result.response, assay_result.bkgrnd_sub, assay_result.norm, assay_result.norm_pos, plate_layout.well_by_col, plate_layout.well_type_id, plate_layout.replicates, plate_layout.target FROM assay_result JOIN plate_layout  ON (assay_result.well = plate_layout.well_by_col)  WHERE assay_result.assay_run_id = _assay_run_id AND  plate_layout.plate_layout_name_id = (SELECT plate_layout_name_id FROM assay_run WHERE assay_run.ID = _assay_run_id);

-- SELECT ARRAY (SELECT distinct plate_order FROM data_set WHERE data_set.assay_run_id = _assay_run_id  ORDER BY plate_order) INTO plates;

-- FOR plate_var IN 1..array_length(plates,1) LOOP

-- SELECT AVG(data_set.response) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=2 INTO positives;
-- SELECT AVG(data_set.response) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=3 INTO negatives;
-- SELECT AVG(data_set.response) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=4 INTO background;
-- SELECT MAX(data_set.response) FROM data_set WHERE data_set.plate_order = plate_var AND data_set.well_type_id=1 INTO unk_max;

-- SELECT plate_layout_name.plate_format_id FROM plate_layout_name, assay_run WHERE assay_run.plate_layout_name_id=plate_layout_name.ID AND assay_run.id=_assay_run_id INTO format;

--        FOR well_var IN 1..format LOOP

--           UPDATE assay_result SET bkgrnd_sub  = (assay_result.response-background), norm = ((assay_result.response-background)/unk_max), norm_pos = ((response-background)/positives), p_enhance = 100*(((assay_result.response-negatives)/(positives-negatives))-1) WHERE assay_result.assay_run_id=_assay_run_id AND assay_result.plate_order=plate_var AND assay_result.well = well_var;

--    END LOOP;

-- END LOOP;
-- DROP TABLE data_set;

-- END;
-- $BODY$
--   LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF exists get_scatter_plot_data( integer);

-- need the join to preserve the controls which do not have sample IDs
CREATE OR REPLACE FUNCTION get_scatter_plot_data(_assay_run_id INTEGER)
RETURNS TABLE(arid INTEGER,  plate INTEGER, well INTEGER, response REAL, bkgrnd_sub REAL,   norm REAL,   norm_pos REAL, p_enhance REAL,  well_type_id INTEGER,  replicates integer, target integer, sample_id integer ) AS
$BODY$
begin

CREATE TEMPORARY TABLE temp1 AS (SELECT _assay_run_id, assay_result.plate_order,assay_result.well, assay_result.response, assay_result.bkgrnd_sub, assay_result.norm, assay_result.norm_pos, assay_result.p_enhance, assay_run.plate_set_id, assay_run.plate_layout_name_id, plate_layout.well_type_id, plate_layout.replicates, plate_layout.target FROM assay_run, assay_result JOIN plate_layout ON ( assay_result.well = plate_layout.well_by_col) WHERE assay_result.assay_run_id = assay_run.id  AND assay_run.ID = _assay_run_id AND plate_layout.plate_layout_name_id = assay_run.plate_layout_name_id);


CREATE TEMPORARY TABLE temp2 AS (SELECT plate_plate_set.plate_order, well.by_col, well_sample.sample_id FROM  plate_plate_set, plate_set, plate,  well,  well_sample, assay_run, sample WHERE plate_plate_set.plate_set_id = plate_set.ID AND plate_plate_set.plate_id = plate.ID AND well.plate_id = plate.id  and well_sample.well_id=well.ID AND well_sample.sample_id=sample.id AND plate_plate_set.plate_set_id = assay_run.plate_set_id AND assay_run.ID = _assay_run_id);


RETURN query
  SELECT temp1._assay_run_id, temp1.plate_order,temp1.well, temp1.response, temp1.bkgrnd_sub, temp1.norm, temp1.norm_pos, temp1.p_enhance, temp1.well_type_id, temp1.replicates, temp1.target, temp2.sample_id FROM temp1 LEFT OUTER JOIN temp2 on (temp1.plate_order=temp2.plate_order AND temp1.well= temp2.by_col);

DROP TABLE temp1;
DROP TABLE temp2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF EXISTS new_hit_list(_name VARCHAR(250), _descr VARCHAR(250), _num_hits INTEGER, _assay_run_id INTEGER, _sessions_id VARCHAR(32), hit_list integer[]);

CREATE OR REPLACE FUNCTION new_hit_list(_name VARCHAR(250), _descr VARCHAR(250), _num_hits INTEGER, _assay_run_id INTEGER, _sessions_id VARCHAR(32), hit_list integer[])
  RETURNS void AS
$BODY$
DECLARE
 hl_id INTEGER;
 hl_sys_name VARCHAR(10);
 s_id INTEGER;
BEGIN


  INSERT INTO hit_list(hitlist_name, descr, n, assay_run_id, sessions_id)
   VALUES (_name, _descr, _num_hits, _assay_run_id, _sessions_id)
   RETURNING id INTO hl_id;

    UPDATE hit_list SET hitlist_sys_name = 'HL-'|| hl_id WHERE id=hl_id;
    
FOR i IN 1.._num_hits loop
 INSERT INTO hit_sample(hitlist_id, sample_id)VALUES(hl_id, hit_list[i]);
END LOOP;

END;
$BODY$
  LANGUAGE plpgsql VOLATILE;



DROP FUNCTION IF EXISTS process_access_ids( INTEGER);

CREATE OR REPLACE FUNCTION process_access_ids(ps_id INTEGER)
 RETURNS SETOF temp_accs_id AS
$BODY$
DECLARE
  r temp_accs_id%rowtype;
BEGIN

-- TRUNCATE temp_accs_id RESTART IDENTITY CASCADE;

-- note that I was previously passing the sql to populate temp but artanis truncates the sql statement
-- execute sql_statement;


   FOR r IN
      SELECT * FROM temp_accs_id
   loop

UPDATE sample SET accs_id = r.accs_id WHERE sample.ID IN ( SELECT sample.id FROM plate_set, plate_plate_set, plate, well, well_sample, sample WHERE plate_plate_set.plate_set_id=ps_id AND plate_plate_set.plate_id=plate.id AND well.plate_id=plate.ID AND well_sample.well_id=well.ID AND well_sample.sample_id=sample.ID AND plate_plate_set.plate_order=r.plate_order AND well.by_col=r.by_col);


       RETURN NEXT r;
   END LOOP;

TRUNCATE temp_accs_id RESTART IDENTITY CASCADE;

END;

$BODY$
  LANGUAGE plpgsql VOLATILE;
  

DROP FUNCTION IF EXISTS create_layout_records(VARCHAR, VARCHAR, VARCHAR, INTEGER, INTEGER, INTEGER, integer );

CREATE OR REPLACE FUNCTION create_layout_records(source_name VARCHAR, source_description VARCHAR, control_location VARCHAR, n_controls INTEGER, n_unknowns INTEGER, format INTEGER, n_edge integer)
 RETURNS void AS
$BODY$
DECLARE
   source_id INTEGER;
   dest_id INTEGER;
   edge INTEGER;
dest_layout_ids INTEGER[];
-- dest_layout_descr VARCHAR[] := '{\"1S4T\",\"2S2T\",\"2S4T\",\"4S1T\",\"4S2T\"}';
dest_layout_descr VARCHAR[] := '{1S4T,2S2T,2S4T,4S1T,4S2T}';
dest_format INTEGER;
i INTEGER;

BEGIN

IF n_edge >0 THEN edge = 0; ELSE edge = 1; END IF;

IF format = 96 THEN
dest_layout_ids := '{2,3,4,5,6}';
dest_format := 384;
END IF;

IF format = 384 THEN
dest_layout_ids := '{14,15,16,17,18}';
dest_format := 1536;
END IF;

INSERT INTO plate_layout_name (NAME, descr, plate_format_id, replicates, targets, use_edge, num_controls, unknown_n, control_loc, source_dest) VALUES (source_name, source_description, format, 1, 1, edge, n_controls, n_unknowns, control_location, 'source') RETURNING ID INTO source_id;

    UPDATE plate_layout_name SET sys_name = 'LYT-'|| source_id WHERE id=source_id;

--insert source
INSERT INTO plate_layout (SELECT source_id AS "plate_layout_name_id", well_by_col, well_type_id, replicates, target FROM import_plate_layout); 


--insert destinations
FOR i IN 1..5 loop

INSERT INTO plate_layout_name (name, descr, plate_format_id, replicates, targets, use_edge, num_controls, unknown_n, control_loc, source_dest) VALUES ( source_name, dest_layout_descr[i], dest_format, 1, 1, edge, n_controls, n_unknowns, control_location, 'dest') RETURNING ID INTO dest_id;
 UPDATE plate_layout_name SET sys_name = 'LYT-'|| dest_id WHERE id=dest_id;


INSERT INTO plate_layout (SELECT dest_id AS "plate_layout_name_id", well_numbers.by_col AS "well_by_col", import_plate_layout.well_type_id, plate_layout.replicates, plate_layout.target FROM well_numbers, import_plate_layout, plate_layout WHERE well_numbers.plate_format = dest_format AND import_plate_layout.well_by_col=well_numbers.parent_well AND plate_layout.plate_layout_name_id=dest_layout_ids[i] AND plate_layout.well_by_col=well_numbers.by_col);


INSERT INTO layout_source_dest (src, dest) VALUES (source_id, dest_id);
END LOOP;
--


TRUNCATE TABLE import_plate_layout;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

   

DROP FUNCTION IF EXISTS get_all_data_for_assay_run(_assay_run_ids INTEGER );

CREATE OR REPLACE FUNCTION get_all_data_for_assay_run(_assay_run_id INTEGER )
RETURNS TABLE(assay_run_sys_name VARCHAR,  plate_set_sys_name VARCHAR(32),  plate_sys_name VARCHAR(32), plate_order INT, well_name VARCHAR, type_well VARCHAR,  by_col INTEGER, response REAL, bkgrnd_sub REAL, norm REAL, norm_pos REAL, p_enhance REAL, sample_sys_name VARCHAR(32), accs_id VARCHAR, target_name VARCHAR, target_accs VARCHAR)  AS
$BODY$
DECLARE

v_assay_run_id INTEGER := _assay_run_id;
v_plate_set_id INTEGER;
v_plate_format INTEGER;
v_layout_id INTEGER;

BEGIN

SELECT assay_run.plate_set_id FROM assay_run WHERE assay_run.ID =v_assay_run_id INTO v_plate_set_id;
SELECT plate_layout_name.plate_format_id FROM plate_layout_name, assay_run WHERE plate_layout_name.ID= assay_run.plate_layout_name_id AND assay_run.ID =v_assay_run_id INTO v_plate_format;
SELECT assay_run.plate_layout_name_id FROM assay_run WHERE assay_run.ID =v_assay_run_id INTO v_layout_id;

--get the plate set
CREATE TEMP TABLE plate_set_data(assay_run_sys_name VARCHAR, plate_set_sys_name VARCHAR, plate_sys_name VARCHAR, plate_order INT, well_name VARCHAR, type_well VARCHAR, by_col INT, well_id INT, response REAL, bkgrnd_sub REAL, norm REAL, norm_pos REAL, p_enhance REAL, target_name varchar, target_accs VARCHAR );

INSERT INTO plate_set_data SELECT assay_run.assay_run_sys_name, plate_set.plate_set_sys_name , plate.plate_sys_name, plate_plate_set.plate_order, well_numbers.well_name, well_type.name, well.by_col, well.ID AS "well_id", assay_result.response, assay_result.bkgrnd_sub, assay_result.norm, assay_result.norm_pos, assay_result.p_enhance,  target.target_name, target.accs_id  FROM  plate_set, plate_plate_set, plate, well, assay_result, assay_run, well_numbers, plate_layout, well_type, target, target_layout_name, target_layout WHERE plate_plate_set.plate_set_id=plate_set.id AND plate_plate_set.plate_id=plate.ID and plate.id=well.plate_id  AND plate_set.ID = v_plate_set_id AND assay_result.assay_run_id= v_assay_run_id AND assay_result.plate_order=plate_plate_set.plate_order AND assay_result.well=well.by_col AND assay_run.ID = v_assay_run_id AND well_numbers.plate_format= v_plate_format AND well_numbers.by_col=well.by_col AND plate_layout.plate_layout_name_id=v_layout_id AND plate_layout.well_type_id=well_type.ID AND plate_layout.well_by_col=well.by_col AND well_numbers.quad=target_layout.quad and plate_set.target_layout_name_id=target_layout.target_layout_name_id and target_layout.target_id = target.id AND target_layout_name.id=target_layout.target_layout_name_id ;

CREATE TEMP TABLE sample_names(well_id INT, sample_sys_name VARCHAR, accs_id VARCHAR);

INSERT INTO sample_names SELECT well.ID AS "well_id", sample.sample_sys_name, sample.accs_id  FROM well, well_sample, sample WHERE well_sample.sample_id=sample.ID AND well_sample.well_id=well.ID AND well.ID IN (SELECT well.ID FROM  plate_plate_set, plate, well WHERE plate_plate_set.plate_id = plate.ID AND well.plate_id = plate.ID AND plate_plate_set.plate_set_id = v_plate_set_id);

RETURN query
  SELECT  plate_set_data.assay_run_sys_name,  plate_set_data.plate_set_sys_name, plate_set_data.plate_sys_name, plate_set_data.plate_order, plate_set_data.well_name, plate_set_data.type_well ,  plate_set_data.by_col, plate_set_data.response, plate_set_data.bkgrnd_sub, plate_set_data.norm, plate_set_data.norm_pos, plate_set_data.p_enhance, sample_names.sample_sys_name, sample_names.accs_id, plate_set_data.target_name, plate_set_data.target_accs FROM plate_set_data LEFT JOIN sample_names on (plate_set_data.well_id=sample_names.well_id) ORDER BY plate_set_data.plate_order desc, plate_set_data.by_col DESC;

DROP TABLE plate_set_data;
DROP TABLE sample_names;

END;
$BODY$
LANGUAGE plpgsql VOLATILE;



DROP FUNCTION IF EXISTS rearray_transfer_samples(integer, INTEGER, integer);


CREATE OR REPLACE FUNCTION rearray_transfer_samples(source_plate_set_id INTEGER, dest_plate_set_id INTEGER, hit_list_id integer)
 RETURNS void AS
$BODY$
DECLARE
   i INTEGER;
all_hit_sample_ids INTEGER[];
dest_wells INTEGER[];
num_hits INTEGER;
rp_id INTEGER;


BEGIN
--select get in plate, well order, not necessarily sample order 
SELECT ARRAY (SELECT  sample.id FROM plate_set, plate_plate_set, plate, well, well_sample, sample WHERE plate_plate_set.plate_set_id=plate_set.ID AND plate_plate_set.plate_id=plate.id AND well.plate_id=plate.ID AND well_sample.well_id=well.ID AND well_sample.sample_id=sample.ID and plate_set.id=source_plate_set_id AND sample.ID  IN  (SELECT hit_sample.sample_id FROM hit_sample WHERE hit_sample.hitlist_id = hit_list_id) ORDER BY plate.ID, well.ID) INTO all_hit_sample_ids;

num_hits := array_length(all_hit_sample_ids, 1);
--raise NOTice 'num_hits: (%)', num_hits;

SELECT ARRAY (SELECT well.ID FROM plate_set, plate_plate_set, plate, well, plate_layout WHERE plate_plate_set.plate_set_id=plate_set.ID AND plate_plate_set.plate_id=plate.id AND well.plate_id=plate.ID AND plate_set.plate_layout_name_id=plate_layout.plate_layout_name_id AND plate_layout.well_by_col= well.by_col AND plate_set.id=dest_plate_set_id AND plate_layout.well_type_id=1 ORDER BY well.ID) INTO dest_wells;


  for i IN 1..num_hits
  loop
  INSERT INTO well_sample (well_id, sample_id) VALUES ( dest_wells[i], all_hit_sample_ids[i]);   
raise NOTice 'dest_well: (%)', dest_wells[i];
raise NOTice 'sample: (%)', all_hit_sample_ids[i];


END LOOP;

INSERT INTO rearray_pairs (src, dest) VALUES (source_plate_set_id, dest_plate_set_id)  returning id INTO rp_id;

CREATE TEMP TABLE temp1 (plate_sys_name VARCHAR(10), by_col INTEGER, sample_id INTEGER);

INSERT INTO temp1 SELECT  plate.plate_sys_name, well.by_col, sample.ID AS "sample_id"  FROM plate_set, plate_plate_set, plate, well, well_sample, sample  WHERE plate_plate_set.plate_set_id=plate_set.ID AND plate_plate_set.plate_id=plate.id AND well.plate_id=plate.ID AND well_sample.well_id=well.ID AND well_sample.sample_id=sample.ID and plate_set.id=source_plate_set_id  AND sample.ID IN  (SELECT hit_sample.sample_id FROM hit_sample WHERE hit_sample.hitlist_id = hit_list_id ORDER BY sample.ID);

CREATE TEMP TABLE temp2 (plate_sys_name VARCHAR(10), by_col INTEGER, sample_id INTEGER);

INSERT INTO temp2 SELECT  plate.plate_sys_name, well.by_col, sample.ID AS "sample_id" FROM plate_set, plate_plate_set, plate, well, well_sample, sample  WHERE plate_plate_set.plate_set_id=plate_set.ID AND plate_plate_set.plate_id=plate.id AND well.plate_id=plate.ID AND well_sample.well_id=well.ID AND well_sample.sample_id=sample.ID and plate_set.id=dest_plate_set_id  ORDER BY sample.ID;

INSERT INTO worklists ( rearray_pairs_id, sample_id, source_plate, source_well, dest_plate, dest_well) SELECT rp_id, temp1.sample_id, temp1.plate_sys_name, temp1.by_col, temp2.plate_sys_name, temp2.by_col FROM temp1, temp2 WHERE temp1.sample_id = temp2.sample_id;

DROP TABLE temp1, temp2;

END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP FUNCTION IF EXISTS global_search(_term character varying);


CREATE OR REPLACE FUNCTION global_search(_term character varying)
  RETURNS TABLE ("Project" CHARACTER VARYING 
                  ,"PlateSet" CHARACTER VARYING
		  ,"Entity" TEXT 
		  ,"SysName" CHARACTER VARYING  
		  ,"Name" CHARACTER VARYING
		  ,"Description" CHARACTER VARYING
		  ) AS
$func$
BEGIN
CREATE TEMP VIEW gsearch AS SELECT project_sys_name , '' AS "plate_set_sys_name",  'Project' AS "entity", project_sys_name AS "entity_sys_name" , project_name AS  entity_name , descr  FROM project
UNION
SELECT project.project_sys_name , plate_set.plate_set_sys_name , 'PlateSet' AS "entity",plate_set_sys_name AS "entity_sys_name" , plate_set_name AS "entity_name" , plate_set.descr FROM plate_set, project WHERE plate_set.project_id=project.ID      
UNION
SELECT project.project_sys_name , plate_set.plate_set_sys_name , 'Plate' AS "entity", plate_sys_name AS "entity_sys_name" , '' AS "entity_name" , plate.barcode AS descr FROM plate_set, project, plate, plate_plate_set WHERE plate_set.project_id=project.ID AND plate_plate_set.plate_set_id=plate_set.ID AND plate_plate_set.plate_id=plate.id       
UNION
SELECT project.project_sys_name , plate_set.plate_set_sys_name , 'Sample' AS "entity", sample_sys_name AS "entity_sys_name" , '' AS "entity_name" , sample.accs_id AS descr FROM plate_set, project, plate, plate_plate_set, well, well_sample, sample WHERE plate_set.project_id=project.ID AND plate_plate_set.plate_set_id=plate_set.ID AND plate_plate_set.plate_id=plate.ID AND well.plate_id=plate.ID AND well_sample.well_id=well.ID AND well_sample.sample_id=sample.id      
UNION
SELECT project.project_sys_name , plate_set.plate_set_sys_name , 'AssayRun' AS "entity", assay_run_sys_name AS "entity_sys_name" , assay_run_name AS "entity_name" ,  assay_run.descr AS descr FROM plate_set, project, assay_run WHERE plate_set.project_id=project.ID AND assay_run.plate_set_id=plate_set.ID      
UNION
SELECT project.project_sys_name , plate_set.plate_set_sys_name , 'HitList' AS "entity", hitlist_sys_name AS "entity_sys_name" , hitlist_name AS "entity_name" ,  hit_list.descr AS descr FROM plate_set, project, assay_run, hit_list WHERE plate_set.project_id=project.ID AND assay_run.plate_set_id=plate_set.ID AND hit_list.assay_run_id=assay_run.id;      


RETURN query
SELECT * FROM gsearch WHERE project_sys_name LIKE '%'|| _term || '%'
UNION
SELECT * FROM gsearch WHERE plate_set_sys_name LIKE '%'|| _term || '%'
UNION
SELECT * FROM gsearch WHERE entity LIKE '%'|| _term || '%'
UNION
SELECT * FROM gsearch WHERE entity_sys_name LIKE '%'|| _term || '%'
UNION
SELECT * FROM gsearch WHERE entity_name LIKE '%'|| _term || '%'
UNION
SELECT * FROM gsearch WHERE descr LIKE '%'|| _term || '%' ORDER BY project_sys_name, plate_set_sys_name, entity;

DROP VIEW gsearch;

END;
$func$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF EXISTS delete_neg_response() CASCADE;

CREATE OR REPLACE FUNCTION delete_neg_response()
  RETURNS trigger AS
$BODY$
BEGIN

NEW.response= GREATEST(NEW.response,0);

 RETURN NEW;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;

DROP TRIGGER IF EXISTS delete_neg_value ON assay_result_pre;

CREATE TRIGGER delete_neg_value BEFORE INSERT ON assay_result_pre
                              FOR EACH ROW EXECUTE PROCEDURE delete_neg_response();       



DROP FUNCTION IF EXISTS get_layout_id_for_plate_set_sys_name(VARCHAR);
CREATE OR REPLACE FUNCTION get_layout_id_for_plate_set_sys_name( _plate_set_sys_name varchar(8))
  RETURNS integer AS
$BODY$
DECLARE
   v_id integer;
BEGIN
 SELECT plate_layout_name_id FROM plate_set WHERE plate_set_sys_name = _plate_set_sys_name into v_id;
RETURN v_id;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF EXISTS get_layout_name_descr_for_layout_id(INTEGER);
CREATE OR REPLACE FUNCTION get_layout_name_descr_for_layout_id( _plate_layout_id integer)
  RETURNS VARCHAR AS
$BODY$
DECLARE
    r record;
   result VARCHAR(250);
BEGIN
SELECT plate_layout_name.name, plate_layout_name.descr FROM  plate_layout_name WHERE plate_layout_name.id = _plate_layout_id into r;
result := r.name || ';' || r.descr;
RETURN result;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;


DROP FUNCTION IF EXISTS process_barcode_ids( INTEGER);

CREATE OR REPLACE FUNCTION process_barcode_ids(ps_id INTEGER )
 RETURNS SETOF temp_barcode_id AS
$BODY$
DECLARE
  r temp_barcode_id%rowtype;
BEGIN

-- TRUNCATE temp_barcode_id RESTART IDENTITY CASCADE;
--raise NOTice 'sql: (%)', sql_statement;
-- execute sql_statement;
--raise NOTice 'post execute: (%)', 2;
   FOR r IN
      SELECT * FROM temp_barcode_id
   loop

UPDATE plate SET barcode = r.barcode_id WHERE plate.ID IN ( SELECT plate.id FROM plate_set, plate_plate_set, plate  WHERE plate_plate_set.plate_set_id=ps_id AND plate_plate_set.plate_id=plate.id  AND plate_plate_set.plate_order=r.plate_order);

       RETURN NEXT r;
   END LOOP;

TRUNCATE temp_barcode_id RESTART IDENTITY CASCADE;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;
  
DROP FUNCTION IF exists populate_assay_run_stats(_assay_run_id integer);

CREATE OR REPLACE FUNCTION populate_assay_run_stats(_assay_run_id integer)
  RETURNS void AS
$BODY$
DECLARE

format_id INTEGER; 
max_response DECIMAL;
min_response DECIMAL;
mean_bkgrnd DECIMAL;
std_dev_bkgrnd DECIMAL;
mean_pos DECIMAL;
stdev_pos DECIMAL;
mean_neg DECIMAL;
stdev_neg DECIMAL;
mean_neg_3_sd DECIMAL;
mean_neg_2_sd DECIMAL;
mean_pos_3_sd DECIMAL;
mean_pos_2_sd DECIMAL;
   


BEGIN
select plate_format_id from plate_layout_name where plate_layout_name.id = (select plate_layout_name_id from assay_run where assay_run.id = _assay_run_id) INTO format_id;

DROP TABLE IF EXISTS data;
CREATE TEMPORARY TABLE data AS (select * from get_scatter_plot_data( _assay_run_id )); 

DROP TABLE IF EXISTS assay_run_processed;
CREATE TEMPORARY TABLE assay_run_processed AS select MAX(plate) AS "plate", MAX(well) AS "well", avg(response) AS "response" , avg(bkgrnd_sub) AS "bkgrnd_sub" , avg(norm) AS "norm" , avg(norm_pos) AS "norm_pos" , avg(p_enhance) AS "p_enhance" , max(well_type_id) AS "well_type_id" , max(replicates) AS "replicates" , max(target) AS "target" , max(sample_id) AS "sample_id" , max(parent_well) AS "parent_well"  FROM data LEFT JOIN well_numbers ON (data.well = well_numbers.by_col) where well_numbers.plate_format = format_id GROUP BY parent_well,replicates, target, plate;

DROP TABLE IF EXISTS with_samples;
CREATE TEMPORARY TABLE with_samples AS (select * from assay_run_processed where well_type_id = 1 AND sample_id is not null ) ;

DROP TABLE IF EXISTS positives;
CREATE TEMPORARY TABLE positives AS (select * from assay_run_processed where well_type_id = 2 );

DROP TABLE IF EXISTS negatives;
CREATE TEMPORARY TABLE negatives AS (select * from assay_run_processed where well_type_id = 3 );

DROP TABLE IF EXISTS backgrounds;
CREATE TEMPORARY TABLE backgrounds AS (select * from assay_run_processed where well_type_id = 4 );


-- background subtracted

select max(bkgrnd_sub) from with_samples INTO max_response;
select min(bkgrnd_sub) from with_samples INTO min_response;
select avg(bkgrnd_sub) from with_samples INTO mean_bkgrnd;
select stddev_samp(bkgrnd_sub) from with_samples INTO std_dev_bkgrnd;
select avg(bkgrnd_sub) from positives INTO mean_pos;
select stddev_samp(bkgrnd_sub) from positives INTO stdev_pos;
select avg(bkgrnd_sub) from negatives INTO mean_neg;
select stddev_samp(bkgrnd_sub) from negatives INTO stdev_neg;
mean_neg_3_sd := mean_neg + 3*stdev_neg;
mean_neg_2_sd := mean_neg + 2*stdev_neg;
mean_pos_3_sd := mean_pos + 3*stdev_pos;
mean_pos_2_sd := mean_pos + 2*stdev_pos;

-- public static final int RAW = 0;
-- public static final int NORM = 1;
-- public static final int NORM_POS = 2;
-- public static final int P_ENHANCE = 3;
 

INSERT INTO assay_run_stats ( assay_run_id, response_type, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos, mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd ) VALUES ( _assay_run_id, 0, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos,mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd );

-- norm

select max(norm) from with_samples INTO max_response;
select min(norm) from with_samples INTO min_response;
select avg(norm) from with_samples INTO mean_bkgrnd;
select stddev_samp(norm) from with_samples INTO std_dev_bkgrnd;
select avg(norm) from positives INTO mean_pos;
select stddev_samp(norm) from positives INTO stdev_pos;
select avg(norm) from negatives INTO mean_neg;
select stddev_samp(norm) from negatives INTO stdev_neg;
mean_neg_3_sd := mean_neg + 3*stdev_neg;
mean_neg_2_sd := mean_neg + 2*stdev_neg;
mean_pos_3_sd := mean_pos + 3*stdev_pos;
mean_pos_2_sd := mean_pos + 2*stdev_pos;

INSERT INTO assay_run_stats ( assay_run_id, response_type, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos, mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd ) VALUES ( _assay_run_id, 1, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos,mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd );


-- norm_pos

select max(norm_pos) from with_samples INTO max_response;
select min(norm_pos) from with_samples INTO min_response;
select avg(norm_pos) from with_samples INTO mean_bkgrnd;
select stddev_samp(norm_pos) from with_samples INTO std_dev_bkgrnd;
select avg(norm_pos) from positives INTO mean_pos;
select stddev_samp(norm_pos) from positives INTO stdev_pos;
select avg(norm_pos) from negatives INTO mean_neg;
select stddev_samp(norm_pos) from negatives INTO stdev_neg;
mean_neg_3_sd := mean_neg + 3*stdev_neg;
mean_neg_2_sd := mean_neg + 2*stdev_neg;
mean_pos_3_sd := mean_pos + 3*stdev_pos;
mean_pos_2_sd := mean_pos + 2*stdev_pos;

INSERT INTO assay_run_stats ( assay_run_id, response_type, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos, mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd ) VALUES ( _assay_run_id, 2, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos,mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd );

-- p_enhance

select max(p_enhance) from with_samples INTO max_response;
select min(p_enhance) from with_samples INTO min_response;
select avg(p_enhance) from with_samples INTO mean_bkgrnd;
select stddev_samp(p_enhance) from with_samples INTO std_dev_bkgrnd;
select avg(p_enhance) from positives INTO mean_pos;
select stddev_samp(p_enhance) from positives INTO stdev_pos;
select avg(p_enhance) from negatives INTO mean_neg;
select stddev_samp(p_enhance) from negatives INTO stdev_neg;
mean_neg_3_sd := mean_neg + 3*stdev_neg;
mean_neg_2_sd := mean_neg + 2*stdev_neg;
mean_pos_3_sd := mean_pos + 3*stdev_pos;
mean_pos_2_sd := mean_pos + 2*stdev_pos;

INSERT INTO assay_run_stats ( assay_run_id, response_type, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos, mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd ) VALUES ( _assay_run_id, 3, max_response, min_response, mean_bkgrnd, std_dev_bkgrnd, mean_pos, stdev_pos,mean_neg_3_sd, mean_neg_2_sd, mean_pos_3_sd, mean_pos_2_sd );


DROP TABLE IF EXISTS data;
DROP TABLE IF EXISTS assay_run_processed;

DROP TABLE IF EXISTS with_samples;
DROP TABLE IF EXISTS positives;
DROP TABLE IF EXISTS negatives;
DROP TABLE IF EXISTS backgrounds;

END;
$BODY$
  LANGUAGE plpgsql VOLATILE;



-- public static final int RAW = 0;
-- public static final int NORM = 1;
-- public static final int NORM_POS = 2;
-- public static final int P_ENHANCE = 3;

DROP FUNCTION IF EXISTS response_wrangler( _desired_response INTEGER,  _assay_run_id INTEGER, _unknowns_only BOOLEAN );
   

CREATE OR REPLACE FUNCTION response_wrangler( _desired_response INTEGER,  _assay_run_id INTEGER, _unknowns_only BOOLEAN )
 RETURNS TABLE( sorted_response REAL, well INTEGER, well_type INTEGER, sample_id INTEGER   ) AS
 $BODY$
DECLARE
   i INT DEFAULT 1;
   j INT DEFAULT 0;
   num_rows INTEGER;
BEGIN

CREATE TEMPORARY TABLE data_table AS SELECT * FROM get_scatter_plot_data( _assay_run_id);

-- in Java I need   double[][]  sorted_response [response] [well] [type_id] [sample_id]

DROP TABLE IF EXISTS sorted_response_table;
DROP TABLE IF EXISTS sorted_response_unk_only_table;

-- des_resp is the desired response

CASE _desired_response
   WHEN 0 THEN
    CREATE TABLE sorted_response_table AS (SELECT  bkgrnd_sub AS des_resp, data_table.well, well_type_id, data_table.sample_id FROM data_table ORDER BY des_resp DESC); 
WHEN 1 THEN
    CREATE TABLE sorted_response_table AS (SELECT  norm AS des_resp, data_table.well, well_type_id, data_table.sample_id FROM data_table ORDER BY des_resp DESC);
WHEN 2 THEN 
    CREATE TABLE sorted_response_table AS (SELECT  norm_pos AS des_resp, data_table.well, well_type_id, data_table.sample_id FROM data_table ORDER BY des_resp DESC);
WHEN 3 THEN 
    CREATE TABLE sorted_response_table AS (SELECT  p_enhance AS des_resp, data_table.well, well_type_id, data_table.sample_id FROM data_table ORDER BY des_resp DESC);
END CASE;

 IF _unknowns_only = TRUE THEN
 CREATE  TABLE results_table AS (SELECT * FROM sorted_response_table WHERE well_type_id =1);
 ELSE
 CREATE  TABLE results_table AS (SELECT * FROM sorted_response_table);
 END IF;

RETURN query 
SELECT * FROM results_table;

DROP TABLE IF EXISTS data_table;
DROP TABLE IF EXISTS sorted_response_table;
DROP TABLE IF EXISTS results_table;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE;




